#! /bin/ksh
# option -f to avoid running .cshrc and override PATH set with setmod
# if one would use the tsch, and run this script in background the output 
# would be suspended !!!!
#******************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: ccdMidasBgStop.sh,v 4.11 2005/06/22 10:58:14 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# alongino  07/11/96  created
#

#************************************************************************
#   NAME
#   ccdMidasBgStop.sh - stop a Midas background session
# 
#   SYNOPSIS
#   ccdMidasBgStop.sh [<unit ID>]
# 
#   DESCRIPTION
#   This shell script stops a Midas session running in background mode.
#   <unit ID> is the Midas unit (00 to 99) to be stopped. Default : 50
# 
#   FILES
#
#   ENVIRONMENT
#   HOST    name of host computer
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#   > ccdMidasBgStop.sh
#         Stop Background Midas session default unit 50.
#
#   > ccdMidasBgStopt.sh 51
#         Stop Background Midas session unit 51.
#
#
#   SEE ALSO
#   ccdMidasBgStart.sh
#
#   BUGS
#   Currently there are problems with resource releasing when one tries
#   to terminate a Midas background session (SPR 960690).
#   This script just brings back the background MIdas session to
#   foreground.
#------------------------------------------------------------------------
midasId=50
if [ $# -ge 1 ]
then
    midasId=$1
fi
echo ""
echo "Terminate Midas session $midasId on $HOST ... \c"
msgSend $RTAPENV pco FORWMSG "-protocol MIDAS -procID $midasId -hostName $HOST -message bye"
if [ $? != 0 ]
then
    echo "FAILED"
else
    echo "done"
fi
#
ps -aef | grep inmidas | grep -v grep | grep -v ccsScheduler | awk '{print "kill -9",$2}' | sh
exit 0
#
# ___oOo___
#
