#!/bin/sh
if [ "`uname`" = "Linux" ]; then enable -n echo; fi
#
# E.S.O. - VLT project - 1993
#
# "@(#) $Id: dblScanFilter.awk,v 1.30 2004/12/06 17:17:35 vltsccm Exp $" 
#
# dblScanFilter.awk
#
# HISTORY
#
# who       when      what
# --------  --------  ----------------------------------------------
# gchiozzi  17/07/95  Added quotes in output strings
# mcomin    17/05/95  First version
#
############################################################################
#
#   NAME
#
#   dblScanFilter.awk -  This awk script filters scan configuration files
#
#   SYNOPSIS
#
#   dblScanFilter.awk  <list-of-parameters>  inputFile > outputFile
# 
#   DESCRIPTION
#
#   Scans the file identified by the name 'inputFile' and filters the
#   file according to the following parameters :
#
#
#    Parameters                |  Keyword
#   ____________________________________________
#
#   - envName                  | Name of the environment, beginning with '@'
#
#   It the outputFile is not specified, the output is displayed on the screen.
#
#   Parameters are specified  with the syntax : <parameter-name>=<value>
#   
# 
#   EXAMPLES
#
#   dblScanFilter.awk  envName=@wte13 lcu1.scan > myOutput
#
#   CAUTION
#
############################################################################

awk '

#
# Process command line arguments
#
BEGIN {
  envName = "" 
}

#
# Main : Check scan mode and produce the corresponding output line
#
# A text line in a file is formed by a sequence of strings separated by blanks.
# A string is referenced by variable '$n', where <n> identifies its position in the line.
# 

{
  if ($3 == "POLL") 
     {
     printf ("scanConfig \"%s\" \"%s%s\" POLL %d \n",$1,envName,$2,$4)
     }
  else if ($3 == "SRBX") 
     {
     printf ("scanConfig \"%s\" \"%s%s\" SRBX %d %d \n",$1,envName,$2,$5,$6)
     }
}

' $*
