#! /bin/sh
if [ "`uname`" = "Linux" ]; then enable -n echo; fi
#*******************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: errchCheckFile.sh,v 1.5 1998/03/02 17:48:31 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# mgajardo  07/11/97  created
#
#************************************************************************
#   NAME
#   errchCheckFile
#
#   SYNOPSIS
#   errchCheckFile <mod>
#
#   DESCRIPTION
#   Checks if <mod>_ERRORS file is in :
#      ../ERRORS   
#      $INTROOT/ERRORS
#      $VLTROOT/ERRORS
#
#   FILES
#   errchCheckFile.sh 
#
#   RETURN VALUES
#      if  <mod>_ERRORS  is in ../ERRORS         RETURN 0
#      if  <mod>_ERRORS  is in $INTROOT/ERRORS   RETURN 1
#      if  <mod>_ERRORS  is in $VLTROOT/ERRORS   RETURN 2
#      if  can not found <mod>_ERRORS>           RETURN 3
#
#
#   EXAMPLES
#   errchCheckFile  tims
#
#   SEE ALSO
#   errchCheck
#
#
#------------------------------------------------------------------------
#

if [ -e ../ERRORS/$1_ERRORS ]
then
#   echo  "file found on ../ERRORS" |tee
   exit 0
fi
if [ -e $INTROOT/ERRORS/$1_ERRORS ]
then
#   echo  "file found on "$INTROOT"/ERRORS" |tee
   exit 1
fi
if [ -e $VLTROOT/ERRORS/$1_ERRORS ]
then
#   echo  "file found on "$VLTROOT"/ERRORS" |tee
   exit 2
fi
echo " Can not found "$1"_ERRORS"
exit 3



# ___oOo___
