#!/bin/sh
if [ "`uname`" = "Linux" ]; then enable -n echo; fi
#************************************************************************
#
# E.S.O. - VLT project
#
# "@(#) $Id: errchGetFile.awk,v 1.5 1998/03/02 17:48:30 vltsccm Exp $" 
#
# CCSerrGetFile.awk"
# 
# who      when     what
#-------- -------- ------------------
# mgajardo 06/05/97 created for cmm
#************************************************************************
#   NAME
#   errchGetFile.awk
#
#   SYNOPSIS
#   errchGetFile.awk <list-of-parameters> ../object/*.cpp
#
#   DESCRIPTION
#   get the name of the error files that the modules is including.
#
#    Parameters                 |  Keyword
#   ____________________________________________
#    CCS                        | ccs
#    verbose                    | on
#
#
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#
#   SEE ALSO
#
#   BUGS
#
#------------------------------------------------------------------------
gawk '

BEGIN {
 ccs = ""
 verbose=0
 for (i=1; i<ARGC ; i++ ) {
       if ( ARGV[i] ~ /ccs=/ )     { ccs       = substr(ARGV[i],5) }
       if ( ARGV[i] ~ /verbose=/ )     { verbose = substr(ARGV[i],9) }
 }

}

/Errors.h/{
   array[getFileName($0)]=2 
}

END{
  name="errchCheck.awk ccs="ccs" "
  if ( verbose )
    name=name"verbose=on "                  


   
 for (i in array)
 {
  status = system(" errchCheckFile.sh " i)

  if (status == 0)
      name=name"../ERRORS/"i"_ERRORS "
  else if  (status == 1)  { 
     name=name"$INTROOT/ERRORS/"i"_ERRORS "
     }
  else if  (status == 2) {
     name=name"$VLTROOT/ERRORS/"i"_ERRORS "
     }
  else {
     print  "Fatal ERROR " 
     exit 1
     }
 }
 name=name" ../object/*.cpp"
 print name

}

# getFileName extract de name of the .h file from the path
function getFileName(s)
{ n=split(s,a,"/")
  i=index(a[n],"Errors.h")
  name=substr(a[n],0,i-1)
  return name 
}



' $*
