#!/bin/sh 
if [ "`uname`" = "Linux" ]; then enable -n echo; fi
#*******************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: fcdDcsCheckEnv.sh,v 2.130 2005/09/08 12:50:21 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# rdonalds  06/09/96  created
# rdonalds  08/02/98  Removed the check of bitPixel from SLCU database
#		      this values is loaded by SlcuStartupCamera
# ccumani   24/11/98  checking of INTROOT deleted
#

#************************************************************************
#   NAME
# 
#   SYNOPSIS
# 
#   DESCRIPTION
#      Script which ensures that the correct environmental variables are set
#
#   FILES
#
#   ENVIRONMENT
#
#        CCDNAME, INS_ROOT, INS_HOST
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#       fcdSlcuCheckEnv 
#           
#   SEE ALSO
#
#   BUGS     
#
#------------------------------------------------------------------------
#

# signal trap (if any)

#
# Commands to be executed
#
# avoid pop-up windows
NO_ERR_DISPLAY=1;export NO_ERR_DISPLAY;

# Use UCB echo because we can then use the -n switch
if test -x /usr/ucb/echo; then
    ECHO=/usr/ucb/echo;
else
    ECHO=echo;
fi

# Check that the enronment
check_env () {
    if [ "$CCDNAME" = "" ]
    then
        $ECHO "FATAL ERROR CCDNAME not set"
        return 1
    fi

#    if [ "$INTROOT" = "" ]
#    then
#        $ECHO "FATAL ERROR INTROOT not set"
#        return 1
#    fi

    if [ "$INS_ROOT" = "" ]
    then
        $ECHO "FATAL ERROR INS_ROOT not set"
        return 1
    fi

    if [ "$INS_HOST" = "" ]
    then
        $ECHO "FATAL ERROR INS_HOST not set"
        return 1
    fi

    # Read a database value to ensure that the database is active
    dbbitsPixel=`dbRead "<alias>$CCDNAME:readout.bitsPixel"`
    if [ $? != 0 ]
    then
	$ECHO "FATAL ERROR Database is not active for $CCDNAME"
	return 1
    fi

    # Ensure that this value has a value which we know should be there.
    bitsPixel=`echo $dbbitsPixel | awk '{print $4}'`
    if [ "$bitsPixel" != 16 ]
    then
	$ECHO "FATAL ERROR readout.bitsPixel value $bitsPixel for $CCDNAME is invalid"
	$ECHO "            perhapse the database values have not been loaded"
	return 1
    fi

    return 0
}


#
# main()
#
main () {
    check_env
    stat=$?

    if [ $stat = 0 ]
    then
	:
    else
	$ECHO "fcdDcsCheckEnv FAILED"
    fi

    exit $stat
}
main $*
