#!/bin/sh
if [ "`uname`" = "Linux" ]; then enable -n echo; fi
#******************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: fcdDemo.sh,v 2.27 2005/05/17 17:13:59 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# abalestr  05/06/97  created (ported from CCD software)
# ccumani   19/05/98  Header for manpage modified
# abalestr  12/06/03  Ported to Bourne shell from csh
#

#************************************************************************
#   NAME
#   fcdDemo.sh - start the FIERA stand-alone sw
# 
#   SYNOPSIS
#   fcdDemo.sh [<camera>] [<WS env.>] [<SLCU env.>] [<INS root>]
# 
#   DESCRIPTION
#   This shell script pops up the panels used to control a CCD camera in
#   stand-alone. Actions are simulated within the panels. No FIERA program need
#   to run.
#
#   <camera>     camera name, also root point in DB (default env. var. CCDNAME)
#   <WS env.>    name of workstation environment (default env. var. RTAPENV)
#   <SLCU env.>   name of SLCU environment (default env. var. CCDLENV)
#   <INS root>   INS_ROOT environment variable
# 
#   FILES
#
#   ENVIRONMENT
#   CCDNAME  default for camera name (e.g. myccd)
#   RTAPENV  default for WS local environment (e.g. myws)
#   CCDLENV  default for SLCU environment (e.g myfiera) 
#   INS_ROOT default root directory for instrument data 
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#   fcdDemo.sh myccd myws myfiera $INS_ROOT
#   Start FIERA sw for camera "myccd", WS environment "myws",
#   SLCU environment "myfiera". Panels run in simulation.
#
#   SEE ALSO
#   fcdStart.sh
#
#   BUGS
#------------------------------------------------------------------------
#
# set environment variables (if not yet done)
#
if [ $# -ge 1 ] 
then
  CCDNAME=$1
fi
if [ $# -ge 2 ] 
then
  RTAPENV=$2
fi
if [ $# -ge 3 ] 
then
  CCDLENV=$3
fi
if [ $# -ge 4 ] 
then
  INS_ROOT=$4
fi

fcdStart.sh $CCDNAME $RTAPENV $CCDLENV $INS_ROOT 1








