#!/bin/sh
# Define which version of the sequencer to use \
  exec seqWish "$0"  ${1+"$@"}
#
#*************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: inducer.pan,v 1.65 2003/12/17 19:26:25 vltsccm Exp $" 
#
# inducer.pan
#
# This file has been produced by the panel editor
#   version: panel.tcl,v 3.11
#   date   : Tue Sep  9 13:01:42 MESZ 1997
#
#      !!!!!!!!!!  DO NOT MANUALLY EDIT THIS FILE  !!!!!!!!! 
#
#--------------------------------------------------------------
#
global par gvar cv bcv actAreaHeight shArea panClassLib 
global geoCmdReply panClassLib panUsrProcs panUsrLib
global argv0 env panWidget panWidgetHlp panDbData cwp
global menu menuBar menuHelp ckMenuBar ckActBut ckShHelp ckCCS
# 
#  Get directory root of VLT, integration, current module. 
global VLTROOT INTROOT HOME

if {[catch {set VLTROOT $env(VLTROOT)}]} {set VLTROOT dummy}
if {[catch {set INTROOT $env(INTROOT)}]} {set INTROOT dummy}
if {[catch {set HOME    $env(HOME)}   ]} {set HOME    dummy}
# 
# Set auto_path 
# 

if { [file exist ../lib/libpanPublic.tcl] } { 
   lappend auto_path ../lib/libpanPublic.tcl
} elseif { [file exist $INTROOT/lib/libpanPublic.tcl ] } { 
   lappend auto_path $INTROOT/lib/libpanPublic.tcl
} elseif { [file exist $VLTROOT/lib/libpanPublic.tcl ] } { 
   lappend auto_path $VLTROOT/lib/libpanPublic.tcl 
} else {
   puts stderr "panel EXITS : Tcl library libpanPublic.tcl not found " 
   exit 1
}

#
# Link panel to user libraries 
#
set panUsrLib   libvcc.tcl  
set panClassLib {}

panSetAutoPath  $panUsrLib $panClassLib 

if {[info exists EDITING]} { 
   set panRoot .inducer 
   set panUsrProcs {}
   set argc 0 ; set argv {}
   set par(PANELX) 30
   set par(PANELY) 19
} else {
   set par(MY_NAME) [file tail $argv0] 
   set EDITING 0
   set tk_strictMotif 0
   setPublicVar
   set panRoot . 
}

#
#-----------------------------------------------
#            Widget Definition  
#-----------------------------------------------
# 

set ckShHelp      1; # Set Short Help
set ckActBut      9; # Set Action Button Area
set ckMenuBar     1; # Setup Menu Bar
set ckCCS         1; # Initialize CCS
set ckCmdReply    0;  # Display Cmd. Reply
set cwp           ""
set actAreaHeight 32; # Set height of action area 

panReadOption winter
panCreateFrame inducer 30 19;  # Create empty frame
panGetCvNames  inducer cv bcv;   # Get Canvas Names
panInit        $argc $argv;  # Initialization



UifActionButton    $bcv.wBeginMacro -canvasAnchor nw \
                   -command inducerEvhBeginMacro -initialState normal \
                   -label {Begin Macro} -stateVar gvar(inducer-wdg10Var) \
                   -width 12
VccSelector        $cv.wDev -background Grey90 -canvasAnchor nw \
                   -command inducerEvhSelectDev -completionIgnore {""} \
                   -completionMode {enabled ignorecase leading trailing} \
                   -entryState normal -entryWidth 10 \
                   -evtComplete {<Escape> <Tab>} -evtInvoke <Return> \
                   -font -Adobe-helvetica-medium-r-normal--14* \
                   -foreground Black -labelText Device: -labelWidth 0 \
                   -menuMaxLen 25 -menuType radiobutton -state normal \
                   -userMenuEnable 0 -variable inducer(vDev)
UifActionButton    $bcv.wEndMacro -canvasAnchor nw \
                   -command inducerEvhEndMacro -initialState normal \
                   -label End -stateVar gvar(inducer-wdg11Var) -width 6
VccSelectorEnv     $cv.wEnv -background Grey90 -canvasAnchor nw \
                   -command inducerEvhSelectEnv -completionIgnore {""} \
                   -completionMode {enabled ignorecase leading trailing} \
                   -entryState normal -entryWidth 8 \
                   -evtComplete {<Tab> <Escape>} -evtInvoke <Return> \
                   -font -Adobe-helvetica-medium-r-normal--14* \
                   -foreground Black -labelText Environment: -labelWidth 0 \
                   -menuFilter l* -menuMaxLen 25 -menuType radiobutton \
                   -queryModes {fromaccdb fromfiles dynamic} -state normal \
                   -userMenuEnable 1 -validate 0 -variable inducer(vEnv) \
                   -vccInfoObj ::vccInfo
UifActionButton    $bcv.wExecMacro -canvasAnchor nw \
                   -command inducerEvhExecMacro -initialState normal \
                   -label Exec -stateVar gvar(inducer-wdg12Var) -width 6
UifActionButton    $bcv.wLoadLccConfig -canvasAnchor nw \
                   -command inducerEvhLoadLccConfig -initialState normal \
                   -label {Load LCC} -stateVar gvar(inducer-wdg17Var) \
                   -width 12
UifActionButton    $bcv.wLoadMacro -canvasAnchor nw \
                   -command inducerEvhLoadMacro -initialState normal \
                   -label Load... -stateVar gvar(inducer-wdg14Var) -width 6
UifActionButton    $bcv.wLoadPanel -canvasAnchor nw \
                   -command inducerEvhLoadPanel -initialState normal \
                   -label Load... -stateVar gvar(inducer-wdg16Var) -width 6
UifActionButton    $bcv.wNotes -canvasAnchor nw \
                   -command inducerEvhPersonalNotes -initialState normal \
                   -label Notes... -stateVar gvar(inducer-wdg18Var) \
                   -width 10
UifActionButton    $bcv.wSaveMacro -canvasAnchor nw \
                   -command inducerEvhSaveMacro -initialState normal \
                   -label Save... -stateVar gvar(inducer-wdg13Var) -width 6
UifActionButton    $bcv.wSavePanel -canvasAnchor nw \
                   -command inducerEvhSavePanel -initialState normal \
                   -label {Save Panel...} -stateVar gvar(inducer-wdg15Var) \
                   -width 12
UifOutput          $cv.www11 -anchor center -canvasAnchor nw -color Black \
                   -dbMode dbPoll -evtFilter w -font "-Adobe-courier-medium-r-normal--12*" -frame 1 \
                   -variable gvar(vDeviceId) -width 13
UifButton          $cv.www12 -canvasAnchor nw -command inducerEvhResetDevice \
                   -initialState normal -label {Reset Device} -popup 0 \
                   -stateVar gvar(dummy_www12) -width 12
UifRadioButton     $cv.www13 -anchor nw -canvasAnchor nw -label On-Line \
                   -onVal 0 -variable gvar(fOnline) -width 8
UifRadioButton     $cv.www14 -anchor nw -canvasAnchor nw -label Off-Line \
                   -onVal 0 -variable gvar(fOnline) -width 8
UifOutput          $cv.www16 -anchor center -canvasAnchor nw -color Black \
                   -dbMode dbPoll -evtFilter w \
                   -font -Adobe-courier-medium-r-normal--14* -frame 1 \
                   -variable gvar(vTicksPerSec) -width 10
UifOptionButton    $cv.www17 -canvasAnchor nw \
                   -itemList {TEST EXCLUSIVE SHARED READONLY} -length 8 \
                   -selectMode label -variable gvar(vMode)
UifOutput          $cv.www9 -anchor center -canvasAnchor nw -color Black \
                   -dbMode dbPoll -evtFilter {"w"} -font "-Adobe-courier-medium-r-normal--12*" -frame 1 \
                   -variable gvar(vMessage) -width 46

#
#  Canvas Items
#

$cv create text 548 16 -tags "text inducer-item1" -anchor w \
          -text "Device-ID:" \
          -fill black -font -Adobe-helvetica-medium-r-normal--14* 

$cv create text 552 40 -tags "text inducer-item2" -anchor w \
          -text "Ticks/sec:" \
          -fill black -font -Adobe-helvetica-medium-r-normal--14* 


#
# Set Widget Configuration
#
set panWidget(wBeginMacro)  {UifActionButton 316 1 1 0 0 0 0 inducer-wdg10Var 0 {}}
set panWidget(wDev)  {PubClass 180 3 1 0 libvcc.tcl nw 0 0 0}
set panWidget(wEndMacro)  {UifActionButton 420 1 0 0 0 0 0 inducer-wdg11Var 0 {}}
set panWidget(wEnv)  {PubClass 4 3 1 0 libvcc.tcl nw 0 0 0}
set panWidget(wExecMacro)  {UifActionButton 476 1 0 0 0 0 0 inducer-wdg12Var 0 {}}
set panWidget(wLoadLccConfig)  {UifActionButton 192 1 1 0 0 0 0 inducer-wdg17Var 0 {}}
set panWidget(wLoadMacro)  {UifActionButton 588 1 1 0 0 0 0 inducer-wdg14Var 0 {}}
set panWidget(wLoadPanel)  {UifActionButton 108 1 1 0 0 0 0 inducer-wdg16Var 0 {}}
set panWidget(wNotes)  {UifActionButton 692.0 1.0 1 0 0 0 0 inducer-wdg18Var 0 {}}
set panWidget(wSaveMacro)  {UifActionButton 532 1 0 0 0 0 0 inducer-wdg13Var 0 {}}
set panWidget(wSavePanel)  {UifActionButton 4 1 1 0 0 0 0 inducer-wdg15Var 0 {}}
set panWidget(www11)  {UifOutput 624.0 4.0 1 0 0 0 0 {} 0 {} {}}
set panWidget(www12)  {UifButton 344.0 28.0 1 0 0 0 0 {} 0 {}}
set panWidget(www13)  {UifRadioButton 452.0 28.0 1 0 0 0 0 {} 0 0 0 0 0 0}
set panWidget(www14)  {UifRadioButton 452.0 4.0 1 0 0 0 0 {} 0 0 0 0 0 0}
set panWidget(www16)  {UifOutput 624.0 28.0 1 0 0 0 0 vTicksPerSec 0 {} {}}
set panWidget(www17)  {UifOptionButton 340.0 0.0 1 0 READONLY 0 0 vMode 0 {}}
set panWidget(www9)  {UifOutput 8.0 32.0 1 0 0 0 0 vMessage 0 {} {}}

#
# Set Database Configuration
#

#
# Set Short Help for each widget
#
set panWidgetHlp(wBeginMacro)  {Start recording all device interactions (current macro will be lost)}
set panWidgetHlp(wDev)  {Device Selector. Select one to connect the device to the panel.}
set panWidgetHlp(wEndMacro)  {Stop macro recording and close the current macro}
set panWidgetHlp(wEnv)  {LCU Environment Selector. Input or select one to query the available devices.}
set panWidgetHlp(wExecMacro)  {Redo the current macro}
set panWidgetHlp(wLoadLccConfig)  {Download the LCC signal configuration from the LCU (if available)}
set panWidgetHlp(wLoadMacro)  {Load the current macro from a selectable file}
set panWidgetHlp(wLoadPanel)  {Load device-specific panel contents from a selectable file}
set panWidgetHlp(wNotes)  {Open the Personal Notes editor}
set panWidgetHlp(wSaveMacro)  {Save the current macro into a selectable file}
set panWidgetHlp(wSavePanel)  {Save device-specific panel contents to a selectable file}
set panWidgetHlp(www11)  {Displays the Device-ID after connection (if available).}
set panWidgetHlp(www12)  {Resets the connected device.}
set panWidgetHlp(www13)  {Updates the device from the panel and resumes connection.}
set panWidgetHlp(www14)  {Disconnects the panel from the device, but keeps the channel open.}
set panWidgetHlp(www16)  {Displays the LCU system-clock-rate in ticks per second.}
set panWidgetHlp(www17)  {Open-Mode for the device-channel. Select from the menu to re-open the device with alternative access privileges.}
set panWidgetHlp(www9)  {Information about panel status}

#
#-----------------------------------------------
#           Menu Bar Definition  
#-----------------------------------------------
# 

set menu(0) {File 0 file {}}
set menu(1) {Options 0 options {}}
set menu(2) {VxWorks 0 vxworks {}}
set menu(3) {Driver 0 driver {}}
set menu(4) {Help 0 help {}}


# Add MenuButton <File> 

set mb [addMenuButton $menuBar file "File" 0 left]

# Menu  

addMenuCmd $mb "Load Panel..." 1 {inducerEvhLoadPanel}
addMenuCmd $mb "Save Panel..." 1 {inducerEvhSavePanel}
$mb add separator
addMenuCmd $mb "Begin Macro" 1 {inducerEvhBeginMacro}
addMenuCmd $mb "End Macro" 1 {inducerEvhEndMacro}
addMenuCmd $mb "Exec Macro" 6 {inducerEvhExecMacro}
addMenuCmd $mb "Save Macro..." 0 {inducerEvhSaveMacro}
addMenuCmd $mb "Load Macro..." 0 {inducerEvhLoadMacro}
$mb add separator
addMenuCmd $mb "Quit" 1 {inducerEvhQuit}

# Add MenuButton <Options> 

set mb [addMenuButton $menuBar options "Options" 0 left]

# Menu  

addMenuCmd $mb "Load LCC Config" 1 {inducerEvhLoadLccConfig}
$mb add separator
addMenuCk $mb "Macro with delay" 0 {inducerEvhMacroWithDelay} inducer(fMacroWithDelay)
$mb add separator
addMenuCk $mb "Enable Debug" 0 {inducerEvhEnableDebug} inducer(fDebug)

# Add MenuButton <VxWorks> 

set mb [addMenuButton $menuBar vxworks "VxWorks" 0 left]

# Menu  

set mb01 [addCascadeMenu $mb i/o_system "I/O System" -1]
set mb02 [addCascadeMenu $mb network "Network" -1]
addMenuCmd $mb "Show Devices" 0 {inducerEvhVxWorks devs}
addMenuCmd $mb "Show Memory" 0 {inducerEvhVxWorks memShow}
addMenuCmd $mb "Show Modules" 0 {inducerEvhVxWorks moduleShow}
addMenuCmd $mb "Show Stacks" 0 {inducerEvhVxWorks checkStack}
addMenuCmd $mb "Task Info" 0 {inducerEvhVxWorks i}
addMenuCmd $mb "Version" 0 {inducerEvhVxWorks version}

# Menu I/O System 

addMenuCmd $mb01 "Show Drivers" 0 {inducerEvhVxWorks iosDrvShow}
addMenuCmd $mb01 "Show Devices" 0 {inducerEvhVxWorks iosDevShow}
addMenuCmd $mb01 "Show File-Descriptors" 0 {inducerEvhVxWorks iosFdShow}

# Menu Network 

addMenuCmd $mb02 "ARP Entries" 0 {inducerEvhVxWorks arptabShow}
addMenuCmd $mb02 "ARP Table" 0 {inducerEvhVxWorks arpShow}
addMenuCmd $mb02 "Host Table" 0 {inducerEvhVxWorks hostShow}
addMenuCmd $mb02 "ICMP Statistics" 0 {inducerEvhVxWorks icmpstatShow}
addMenuCmd $mb02 "IP Sockets" 0 {inducerEvhVxWorks inetstatShow}
addMenuCmd $mb02 "IP Statistics" 0 {inducerEvhVxWorks ipstatShow}
addMenuCmd $mb02 "MBUF Statistics" 0 {inducerEvhVxWorks mbufShow}
addMenuCmd $mb02 "Routing Table" 0 {inducerEvhVxWorks routeShow}
addMenuCmd $mb02 "Routing Statistics" 0 {inducerEvhVxWorks routestatShow}
addMenuCmd $mb02 "TCP Statistics" 0 {inducerEvhVxWorks tcpstatShow}
addMenuCmd $mb02 "UDP Statistics" 0 {inducerEvhVxWorks udpstatShow}

# Add MenuButton <Driver> 

set mb [addMenuButton $menuBar driver "Driver" 0 left]

# Menu  


# Add MenuButton <Help> 

set mb [addMenuButton $menuBar help "Help" 0 right]

# Menu  

addMenuCmd $mb "Info..." 1 {inducerEvhInfo}
addMenuCmd $mb "On Device..." 4 {inducerEvhHelpOnDevice}
addMenuCmd $mb "Personal Notes" 1 {inducerEvhPersonalNotes}
addMenuCmd $mb "Extended Help..." 1 {inducerEvhExtendedHelp}

#
#-----------------------------------------------
#           Menu Help Definition  
#-----------------------------------------------
# 


#
#-----------------------------------------------
#            Create the Panel  
#-----------------------------------------------
#

wm geometry  $panRoot 784x158
wm title     $panRoot "inducer"
set par(TITLE) "inducer" 

panMainStart  inducer $argc $argv

#--------------------    End of Main   --------------------

