#!/bin/sh
if [ "`uname`" = "Linux" ]; then enable -n echo; fi
#
# This scripts takes the logFile and filters out all fits logs
#  (cloned form logFilterFile.awk)

# Need to specify complete path because it is used in a cron script
gawk '

BEGIN {

   # Execure shell command and assign value to a variable 
   "uname -s" | getline osType
   "uname -r" | getline osRelease
   "uname -n" | getline nodeName

   yday  = ARGV[1];
   today = ARGV[2];

   # Reset first two arguments to avoid that awk
   # take them as filename
 
   ARGV[1] = ""
   ARGV[2] = ""
}

{
   # Extract all FITS logs and remove pre-ample

   if (osType == "SunOS" && osRelease >= 5.8) {
          fitsTime    = $10
          oldFitsTime = $9
          idxDate     = 9
   } else {
          fitsTime    = $7
          oldFitsTime = $6
          idxDate     = 6
   }

   if (oldFitsTime ~ /([0-9]+):([0-9]+):([0-9]+)>/ ) {

       if ($2 == yday || $2 == today) {

          tmp = $2 " " nodeName " "
          for (i=idxDate ; i<=NF ; i++)
              {
              tmp = tmp $i " "
              }
          print tmp
       }

   } else if (fitsTime ~ /([0-9]+):([0-9]+):([0-9]+)>/ ) {

       if ($2 == yday || $2 == today) {

          tmp = $2 " " 
          for (i=idxDate ; i<=NF ; i++)
              {
              tmp = tmp $i " "
              }
          print tmp
       }
   }
}
' $*






