#!/bin/sh
if [ "`uname`" = "Linux" ]; then enable -n echo; fi
#
# This scripts takes the logFile and filters out all fits logs
#  (cloned form logFilterFile.awk)

# Need to specify complete path because it is used in a cron script
gawk '

BEGIN {

   nativeLog = 0

   envName[0] = envName[1] = envName[2] = envName[3] = ""
   envName[4] = envName[5] = envName[6] = envName[7] = ""

   maxIdx = 8
   envIdx = 0

   for (i=1; i<ARGC ; i++ )  {
      if ( ARGV[i] ~ /nativeLog=/ )   { nativeLog = 1}
   }
}

END {

  envList = envName[0]

  for (i=1 ; i<=envIdx ; i++)
      {
      if (i < envIdx) {
        envList = envList " "
      }

      envList = envList envName[i] 

      }

  print envList 

}

{

   if (nativeLog) {

      if (osType == "SunOS" && osRelease >= 5.8) {
          fitsTime     = $10
          logEnv       = $9
      } else {
          fitsTime     = $7
          logEnv       = $6
      }

      # Check if this is a FITS log
      if (fitsTime ~ /([0-9]+):([0-9]+):([0-9]+)>/ ) {
         fitsEnvName = logEnv
      } else {
         fitsEnvName = ""
      }

   } else {

      fitsEnvName = $2
   }

#   print $5 " " $6 " " $7 " " $8 " fitsTime = " fitsTime "  fitsEnvName =" fitsEnvName

   if (fitsEnvName != "" ) {

       fidx = -1

       for (i=0 ; i<=envIdx ; i++)
           {
           if (fitsEnvName == envName[i]) {
              fidx = i 
           }
       }

       if (fidx < 0) {
          envName[envIdx] = fitsEnvName
          envIdx ++
       }

       if (fidx > envIdx) {
          envName[envIdx] = fitsEnvName
          envIdx ++
       } else {
          envName[fidx]   = fitsEnvName
       }

#       print "envIdx = " envIdx "fidx = " fidx " " envName[envIdx] " fitsEnvName = !" fitsEnvName "!"

       if (envIdx >= maxIdx) {
          envIdx = maxIdx
       }
    }
}

' $*
