!******************************************************************************
! E.S.O. - VLT project
!
! "@(#) $Id: ccdDisplayMidasObj.prg,v 4.11 2005/06/22 10:58:20 vltsccm Exp $"
!
! who       when      what
! --------  --------  ----------------------------------------------
! alongino  07/11/96  created
!

!************************************************************************
!   NAME
!   ccdDisplayMidasObj.prg - Midas procedure used by ccdTestMidasObj.sh
! 
!   SYNOPSIS
!   ccdDisplayMidasObj.prg [<fits_file>] [<threshold>]
! 
!   DESCRIPTION
!   This Midas procedure is used by the script ccdTestMidasObj.sh to
!   display the results of star detection computations
!   The <threshold> value should be passed as expected by the Midas command
!   SEARCH/ROMAFIT, namely:
!   C,val: the threshold will be constant with value val;
!   R,val: the threshold will be set at val times the sky standard deviation.
!   Default: R,3
! 
!   FILES
!   midasObj0001.bdf    image in bdf format for Midas
!   midasObj0001SKY.tbl table containing intermediate sky parameters
!   midasObj0001CAT.tbl table containing final object parameters
!
!   ENVIRONMENT
!
!   RETURN VALUES
!
!   CAUTIONS
!
!   EXAMPLES
!   > @@ ccdDisplayMidasObj myImage.fits R,3
!         Analyse image FITS file myImage.fits in the local directory 
!         with threshold 3 times sky standard deviation.
!
!   SEE ALSO
!   Midas ROMAFIT package (Midas Manual Volume B)
!   ccdMidasObj.prg
!
!   BUGS
!------------------------------------------------------------------------
!
! Default values
!
define/par p1 "ccdDisplayMidasObj.fits" C
define/par p2 "R,3" C
!
! Show the results of starts detection in image
!
crea/disp
load/lut heat
clea/chan overlay
load/ima midasObj0001
name/column midasObj0001CAT.tbl :x :x_coord 
name/column midasObj0001CAT.tbl :y :y_coord
compu/tab midasObj0001CAT.tbl radius1 = 10
draw/circle midasObj0001CAT.tbl F
!
! The End
!
!inmidas 50 -p -j "set/back socket"
!
!Midas 002> connect/back te67:50 nowait z sockets
!Midas 005> z,clea/back 5
!Midas 006> disco/back 50
!Midas 010> z,bye
!Midas 001> set/context romafot
!Midas 005> inta/fits 1 midasObj antonio.fits
!Midas 006> sky/roma midasObj0001
!Midas 016> search/roma midasObj0001 ? ? ? ? R,3 4000
!Midas 017> read/tab midasObj0001CAT.tbl
!Midas 009> compu/tab midasObj0001CAT.tbl x_coord = :x
!Midas 010> compu/tab midasObj0001CAT.tbl y_coord = :y
!Midas 011> compu/tab midasObj0001CAT.tbl radius1 = 10
!Midas 002> crea/disp
!Midas 003> load/lut heat
!Midas 008> load/ima midasObj0001
!Midas 014> draw/circle midasObj0001CAT.tbl F
!
!Midas 015> clea/chan overlay
!bye
!
