#ifndef JNICCS_H
#define JNICCS_H
/*******************************************************************************
* E.S.O. - VLT project
#
# "@(#) $Id: Ccs.h,v 1.41 2004/12/06 12:25:18 vltsccm Exp $" 
*
* Ccs.h
*
* who       when        what
* --------  ----------  ----------------------------------------------
* eallaert  1998-10-23  created
*/

/************************************************************************
*  This is the public interface file for the CCS JNI library
*
*  Remark that if you use it, the following compilation flags should be set:
*  - CCS_FULL if the compilation is with full CCS
*  - CCS_LIGHT if the compilation is with CCS-light
*
*----------------------------------------------------------------------
*/
/*
 * Other header files 
 */
#if defined(CCS_FULL) || defined(CCS_LIGHT)
#include "CcsErrors.h"		 /* error interface file */
#else
I need to have either CCS_FULL or CCS_LIGHT
#endif

#include <ccs.h>		/* declares the vlt* and ccs* datatypes */
/*
 * Definition of constants
 */
#define CcsVERSION "$Revision: 1.41 $"/* string containing revision code */

#define CcsNAME "Ccs"	/* default name for ccsInit */

#if defined(CCS_FULL)
#define CcsLONGNAME "The CCS Java Native Interface with full CCS"
#define CcsCCSTYPE "full"
#elif defined(CCS_LIGHT)
#define CcsLONGNAME "The CCS Java Native Interface with CCS-light"
#define CcsCCSTYPE "light"
#endif

#define CcsDEFAULTID "Ccs"		/* default module Id - cf errAdd() */
					/* package name is derived from this */
					/* (1st character is upshifted) */
#define CcsDEFAULTCHECK "NO_CHECK"	/* def check - cf msgSendCommand() */

/*
 * Global variables-  see also seqInit.c, seqMsgDispatch
 */
extern char	*numericVersion;	/* string containing version */

extern ccsERROR		lastError;	/* CCS error at last errCloseStack */

extern ccsENVNAME	myEnvName;	/* local environment name */
extern ccsPROCNUM	myProcNum;	/* Sequencer process number */
extern ccsPROCNAME	myProcName;	/* the CCS name of this process */

extern vltLOGICAL	cmdsAllowed;	/* reflects whether Sequencer event */
					/* loop will allow incoming cmds */
/*
 * Data types
 */

/*
 * Function prototypes
 */
/* EXTERN ccsCOMPL_STAT saveAndCloseStack (ccsERROR   *error);	*/

#endif	/*!JNICCS_H*/


