#ifndef agws_H
#define agws_H
/******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: agws.h,v 1.198 2005/08/26 15:24:43 vltsccm Exp $"
*
* who       when      what
* --------  --------  -------------------------------------------------------
* gchiozzi  02/10/97  Removed function agwsMswListPoint(). Not used any more.
* awalland  22/11/96  Changed path to catalog library (for NOV96)
* nfiebig   23/08/96  skycat lib includes added
* nfiebig   30/05/96  service function prototypes added 
* gchiozzi  29/02/96  created
*/

/************************************************************************
 *
 *   General include file for the "agws" module.
 *   It contains common definitions used in every component of the module
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

/*
 * cat lib includes (keep before any evh includes, otherwise conflict!)
 */
#include <cat/TcsCatalog.h>

#include "eccsTestTools.h"
#include "eccsDB_ATTR.h"
#include "evhCALLBACK.h"

/* 
 * Includes with error messages 
 */
#include "agwsErrors.h"

/* 
 *  Defines for the target telescope.
 *  The default target is VLT
 *  Up to now only VLT and NTT
 *  All other common defines used both in C/C++ code and dbLoader definitions
 */

#include "tcs.h"
#include "agwsDefines.h"

/*
 *  Value/Name conversion tables:
 *  The defines for both values and names are in agwsDefines.h
 *  Other applications sending or receiving these values/string
 *  can include this file and link the file agws.C with the code
 *  for the mapping functions.
 *  We have to think if there is a better place where to put these
 *  common things.
 */

#include "fndNAME_MAP.h"

extern fndNAME_MAP agwsStateNameMap;

#include "oslx.h"
#include "agwsTARGET_LIST.h"

/*
 * define the eccs log level
 */
#ifdef eccsLOG_LEVEL
#undef eccsLOG_LEVEL
#endif
#define eccsLOG_LEVEL 0

/*
 * global variables 
 */
extern dbSYMADDRESS     agwsDbRoot;  // module database root point
extern agwsTARGET_LIST *agwsTargets; // list of sub-command targets

/*
 * service function prototypes
 */
char                   *agwsGetProcName(const msgPROCESSID &orgId);
char                   *agwsDestTarget(msgMESSAGE &msg);
ccsCOMPL_STAT           agwsSendReply(msgMESSAGE &user, const char *format, ...) __attribute__ ((format (printf, 2, 3)));
ccsCOMPL_STAT           agwsSendErrorReply(msgMESSAGE &user, const ccsERROR &errMsg);
ccsCOMPL_STAT           agwsGetTimeout(char *cmdName, ccsTIMEVAL &timeout);
 
/*
 * macro to delete a dynamic object and invalidate its pointer
 */
#define DELETE(objPtr)       \
    if (objPtr != NULL)      \
        {                    \
        delete objPtr;       \
        objPtr = NULL;       \
        }

#endif // !agws_H
