#ifndef agwsCON_ADAPTER_NTT_H
#define agwsCON_ADAPTER_NTT_H
/******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: agwsCON_ADAPTER_NTT.h,v 1.198 2005/08/26 15:24:48 vltsccm Exp $"
*
* who       when      what
* --------  --------  --------------------------------------------------------
* gchiozzi 2000-07-27 Added agwsCON_SERVER to constructors and as member.
* gchiozzi  03/02/98  Overloaded ProbeStopCB implementation.
* tphan     14/01/98  removed GetRefPos()
* gchiozzi  28/11/97  Replaced pointer to gsCatalogue with reference.
* gchiozzi   19/10/97  Removed private data member agwsConServer. Not used
* gchiozzi  17/10/97  Removed GetRotAngleDb() method. Using tif.
* tphan     17/10/96  add NTT probe (thanks to rabuter)
* nfiebig   26/08/96  created
*/

/******************************************************************************
 * Declaration of the agwsCON_ADAPTER_NTT class. Overloads the NTT specific
 * features of the basic agwsCON_ADAPTER class.
 *-----------------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

#include "agwsCON_SERVER.h"
#include "agwsCON_ADAPTER.h"

class agwsCON_ADAPTER_NTT : public agwsCON_ADAPTER
{
  public:
    agwsCON_ADAPTER_NTT(const dbSYMADDRESS dbPoint, agwsCON_CAT &gsCatt, agwsCON_SERVER &agServer);

    virtual evhCB_COMPL_STAT ProbeAbsCB(msgMESSAGE &msg, agwsCMD_HANDLER &handler);
    virtual evhCB_COMPL_STAT ProbeCenterCB(msgMESSAGE &msg, agwsCMD_HANDLER &handler);
    virtual evhCB_COMPL_STAT ProbeParkCB(msgMESSAGE &msg, agwsCMD_HANDLER &handler);
    virtual evhCB_COMPL_STAT ProbeStopCB(msgMESSAGE &msg, agwsCMD_HANDLER &handler);
    virtual evhCB_COMPL_STAT OffsetAdCB(msgMESSAGE &msg, agwsCMD_HANDLER &handler);
    virtual evhCB_COMPL_STAT OffsetXyCB(msgMESSAGE &msg, agwsCMD_HANDLER &handler);

    virtual vltLOGICAL       CheckProbePos(vltDOUBLE  alpha,
					   vltDOUBLE  delta,
					   vltLOGICAL usedMargin,
					   vltDOUBLE  rotAngle   );

  protected:

    ccsCOMPL_STAT GetProbePosDB(vltDOUBLE *probeX,
    				vltDOUBLE *probeY); 

    ccsCOMPL_STAT GetProbeNameDB(char * probeName);

    ccsCOMPL_STAT GetProbeCenterDB(char      *probeName,
				   vltDOUBLE *centerX,
				   vltDOUBLE *centerY);

    ccsCOMPL_STAT GetProbeVignetDB(char      *probeName,
				   vltDOUBLE *minX,
				   vltDOUBLE *maxX,
				   vltDOUBLE *minY,
				   vltDOUBLE *maxY);

    ccsCOMPL_STAT DiffRefPosAndGs(vltDOUBLE  gsRaInRad, 
				  vltDOUBLE  gsDecInRad,
				  vltDOUBLE *diffRaInMm,
				  vltDOUBLE *diffDecInMm);
						
    ccsCOMPL_STAT ComputeProbePos(char       *probe,
   				  vltDOUBLE   diffRaInMm,
				  vltDOUBLE   diffDecInMm,
				  vltLOGICAL  marginUsed,
				  vltDOUBLE   rotAngle,
				  vltDOUBLE   centerX,
				  vltDOUBLE   centerY,
				  vltDOUBLE  *probeX,
				  vltDOUBLE  *probeY,
				  vltLOGICAL *legalPos
				  );
				  
    ccsCOMPL_STAT ConvertProbePos(vltDOUBLE   alpha,
				  vltDOUBLE   delta,
				  vltLOGICAL  marginUsed,
				  vltDOUBLE   rotAngle,
				  vltDOUBLE  *probeX,
				  vltDOUBLE  *probeY,
				  vltLOGICAL *legalPos
				  );

    ccsCOMPL_STAT GetRotOffsetDB(vltDOUBLE *rotOffset);

    ccsCOMPL_STAT OffsAdParamShuffle  (char *buffer, vltLOGICAL *legalPos);
    ccsCOMPL_STAT OffsXyParamShuffle  (char *buffer, vltLOGICAL *legalPos);
    ccsCOMPL_STAT ProbeAbsParamShuffle(char *buffer, vltLOGICAL *legalPos);
    
  private:
};

#endif // !agwsCON_ADAPTER_NTT_H

// __oOo__
