#ifndef agwsCON_ADAPTER_VLT_H
#define agwsCON_ADAPTER_VLT_H
/******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: agwsCON_ADAPTER_VLT.h,v 1.198 2005/08/26 15:24:48 vltsccm Exp $"
*
* who       when      what
* --------  --------  --------------------------------------------------------
* gchiozzi 2000-07-27 Added agwsCON_SERVER to constructors and as member.
* gchiozzi 2000-07-27 Remover adrotRotTrkLimitEvent

* mkiekebu  11/08/99  AdapterEventCB & AdapterEventStopAgOkCB added
* mkiekebu  30/07/99  new constructor added
* gchiozzi  28/11/97  Replaced pointer to gsCatalogue with reference.
* nfiebig   26/08/96  created
*/

/******************************************************************************
 * Declaration of the agwsCON_ADAPTER_VLT class. Overloads the VLT specific
 * features of the basic agwsCON_ADAPTER class.
 *-----------------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

#include "agwsCON_ADAPTER.h"

class agwsCON_ADAPTER_VLT : public agwsCON_ADAPTER
{
  public:
    agwsCON_ADAPTER_VLT(const dbSYMADDRESS dbPoint, agwsCON_CAT &gsCat, agwsCON_SERVER &agServer);
    agwsCON_ADAPTER_VLT(const dbSYMADDRESS dbPoint, agwsCON_CAT &gsCat, agwsCON_SERVER &agServer,
			agwsCON_SETUP *gsSetup);

    ccsCOMPL_STAT Init();
    virtual evhCB_COMPL_STAT ProbeAltCB(msgMESSAGE &msg, agwsCMD_HANDLER &handler);
    virtual evhCB_COMPL_STAT ProbeGsCB(msgMESSAGE &msg, agwsCMD_HANDLER &handler);

    virtual ccsCOMPL_STAT EnableAdRotEvents();
    virtual ccsCOMPL_STAT DisableAdRotEvents();
    virtual vltLOGICAL    CheckProbePos(vltDOUBLE  alpha,
					vltDOUBLE  delta,
					vltLOGICAL usedMargin,
					vltDOUBLE  rotAngle);
    virtual ccsCOMPL_STAT Reset();
    virtual ccsCOMPL_STAT UpdateVignettingLimits();

  protected:
    virtual evhCB_COMPL_STAT AdrotEventCB(evtEVENT_MSG &, void *);
    virtual evhCB_COMPL_STAT AdapterEventCB(evtEVENT_MSG &, void *);
    virtual evhCB_COMPL_STAT SetVignOkCB(msgMESSAGE &, void *);
    virtual evhCB_COMPL_STAT SetVignErrorCB(msgMESSAGE &, void *);
    virtual evhCB_COMPL_STAT InsDataChangedCB(msgMESSAGE &, void *);
    virtual evhCB_COMPL_STAT CheckGsOkCB(msgMESSAGE &msg, agwsCMD_HANDLER &handler);
//  virtual evhCB_COMPL_STAT CheckGsErrorCB(msgMESSAGE &msg, agwsCMD_HANDLER &handler);
    virtual evhCB_COMPL_STAT AdrotEventStopAgOkCB(msgMESSAGE &, void *);
    virtual evhCB_COMPL_STAT AdapterEventStopAgOkCB(msgMESSAGE &, void *);

    virtual ccsCOMPL_STAT    CheckGs(agwsGUIDE_STAR &star,
				     agwsCMD_HANDLER &handler);
    virtual evhCB_COMPL_STAT CheckGsAltCB(msgMESSAGE &msg, agwsCMD_HANDLER &handler);
    virtual evhCB_COMPL_STAT CheckGsAltErrorCB(msgMESSAGE &msg, agwsCMD_HANDLER &handler);

    agwsGUIDE_STAR   &ValidStar();
    agwsTRANSFER     probePrchkCmd;

  private:
    agwsCMD_HANDLER  prAltCmdHandler;   // PRALT command handler
    ccsTIMEVAL       prAltTimeout;      // PRALT transfer command timeout
    evtEVENT         adrotGsOutOfFieldEvent;
    evtEVENT         adrotAdTrkLimitEvent;
    agwsTRANSFER     probeSetVignCmd;
    agwsGUIDE_STAR   validStar;
};

/*
 * inline definition of adapter class
 */
#include "agwsCON_ADAPTER_VLT.icc"

#endif // !agwsCON_ADAPTER_VLT_H

// __oOo__

