#ifndef agwsCON_CHECK_H
#define agwsCON_CHECK_H
/******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: agwsCON_CHECK.h,v 1.198 2005/08/26 15:24:44 vltsccm Exp $"
*
* who       when      what
* --------  --------  --------------------------------------------------------
* rkarban 2001-12-06 remove functions for setting timer getting CB
* rkarban 2001-12-06 make method to access interval
* rkarban 2001-11-27 make all public methods virtual
* gchiozzi  23/09/97  Added handling of check loop time on db.
* gchiozzi  29/02/96  created
*/
/******************************************************************************
 *
 *-----------------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

/*
 * module includes
 */
#include "agws.h"
#include "evhDB_TASK.h"
#include "evhTIMER.h"

/*
 * periodic check interval in seconds
 */
class agwsCON_CHECK : public evhDB_TASK
{
  public:
    agwsCON_CHECK(const dbSYMADDRESS  dbPoint);
    virtual ~agwsCON_CHECK();

    virtual ccsCOMPL_STAT Init();
    virtual ccsCOMPL_STAT CheckStart();
    virtual ccsCOMPL_STAT CheckGuiding();

    virtual ccsCOMPL_STAT StartPeriodicCheck(evhCALLBACK &userCB);
    virtual ccsCOMPL_STAT StopPeriodicCheck();

    virtual evhCB_COMPL_STAT PeriodicCheckCB(msgMESSAGE &, void *);

  protected:
    vltINT32 Interval() {return interval;};

  private:
    vltINT32      interval; // time bettween two checks
    evhTIMER     *timer;    // timer to trigger periodic checks
    evhCALLBACK  *stopCB;   // call-back for requesting stop of auto-guiding
};

#endif /*!agwsCON_CHECK_H*/
