#ifndef agwsCON_SETUP_H
#define agwsCON_SETUP_H
/*****************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: agwsCON_SETUP.h,v 1.198 2005/08/26 15:24:44 vltsccm Exp $"
*
* who       when      what
* --------  --------  -------------------------------------------------------
* gchiozzi  21/09/98  Added CheckBox() and CheckWin()
* gchiozzi  23/07/98  Added private method LoadDefaultRefXY()
* rkarban  21/07/98  replace GetDefaultWin with GetDefaultRefXY
* gchiozzi  28/11/97  Replaced pointer to gsCatalogue with reference.
* gchiozzi  17/11/97  Added save method.
* gchiozzi  07/11/97  Added Reload() method to load again the current setup file
* gchiozzi  09/10/97  Removed SETROW command
* gchiozzi  29/02/96  created
*/

/*****************************************************************************
 * Definition of class agwsCON_SETUP
 *----------------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

#include "math.h"
extern "C" {
#include "tcsVcc.h"
#include "slalib.h"
#include "slamac.h"
}
#include "agws.h"
#include "agwsCON_CAT.h"

#include "evhDB_TASK.h"
#include "evhCOMMAND.h"
#include "oslx.h"

/*
 *  Enum to identify in what do we want to set the
 *  user function
 */

enum agwsUFMODE
{
    agwsUFMODE_GUIDE_LOOP,
    agwsUFMODE_SINGLE_EXP,
    agwsUFMODE_NONE
};

struct agwsAG_BOX
{
    vltDOUBLE refx; 
    vltDOUBLE refy;
    vltINT32  width;
};

struct agwsAG_XY
{
    vltDOUBLE x; 
    vltDOUBLE y;
};

struct agwsAG_WIN
{
    vltINT32  strx;
    vltINT32  stry;
    vltINT32  nx;
    vltINT32  ny;
    vltDOUBLE refx; 
    vltDOUBLE refy;
};

class agwsCON_SETUP : public evhDB_TASK
{
  public:
    agwsCON_SETUP(const dbSYMADDRESS dbPoint, agwsCON_CAT &gsCat);
    virtual ~agwsCON_SETUP();

    virtual ccsCOMPL_STAT Init();
    
    virtual evhCB_COMPL_STAT SetupCB(msgMESSAGE &msg, void *);

    virtual ccsCOMPL_STAT    HandleSetupCmd(const char  *setupBuf);
    virtual ccsCOMPL_STAT    GetBox(agwsAG_BOX *box);
    virtual ccsCOMPL_STAT    SetBox(agwsAG_BOX &box);

    virtual ccsCOMPL_STAT    GetDefaultRefXY(agwsAG_XY *refxy);

    virtual ccsCOMPL_STAT    GetWin(agwsAG_WIN *win);
    virtual ccsCOMPL_STAT    SetWin(agwsAG_WIN &win);

    virtual ccsCOMPL_STAT    GetIntTime(vltDOUBLE *val);
    virtual ccsCOMPL_STAT    SetIntTime(vltDOUBLE  val);

    virtual ccsCOMPL_STAT    GetNREP(vltINT32 *val);
    virtual ccsCOMPL_STAT    SetNREP(vltINT32  val);

    virtual ccsCOMPL_STAT    GetIPFUNC(char *val);
    virtual ccsCOMPL_STAT    SetIPFUNC(char *val);

    virtual ccsCOMPL_STAT    GetCENTROID(char *val);
    virtual ccsCOMPL_STAT    SetCENTROID(char *val);
    
    virtual ccsCOMPL_STAT    SetUfMode(agwsUFMODE mode);

    virtual ccsCOMPL_STAT    Save();
    virtual ccsCOMPL_STAT    Reload();

    virtual oslxSETUP       &SetupFile();

  protected:
    virtual ccsCOMPL_STAT    CheckBox(agwsAG_BOX *box);
    virtual ccsCOMPL_STAT    CheckWin(agwsAG_WIN *win);
    virtual ccsCOMPL_STAT LoadDefaultRefXY(agwsAG_XY *refxy);

    virtual ccsCOMPL_STAT ProcessSearchSetup();
    virtual ccsCOMPL_STAT ProcessCatSetup();
    virtual ccsCOMPL_STAT ProcessProbeSetup();
    virtual ccsCOMPL_STAT ProcessTargetSetup();
    virtual ccsCOMPL_STAT ProcessTccdSetup();

    virtual ccsCOMPL_STAT CheckSetup(char      **report, 
			     vltUINT16  *numErrors);



    agwsCON_CAT   &gsCatalogue;  // pointer to internal guide-star catalogue
    oslxSETUP      setupFile;    // TCS & TCCD setup file
    oslxDICTIONARY dictionary;   // TCS & TCCD dictionary
    slxFILENAME    tccdFilename; // TCCD setup file name

    agwsAG_XY      defRefxy;     // the default reference pixel of the chip
                                 // where the dichroic patch is
  private:
};

#endif /*!agwsCON_SETUP_H*/
