#ifndef agwsDEFINES_H
#define agwsDEFINES_H
/******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: agwsDefines.h,v 1.198 2005/08/26 15:24:45 vltsccm Exp $"
*
* who       when      what
* --------  --------  --------------------------------------------------------
* rkarban 2002-08-21 handle ATS_TCS
* rkarban 2002-08-21 remove ATS_TCS dependency
* rkarban 2002-01-30 share tif definitions for agws states
* rkarban 2001-07-02 add wavelength definition
* rkarban 2000-10-31 add ATS_TCS target
* gchiozzi 2000-08-31 Added full keyword name (TEL.AG.xxx) to some keyword, to avoid aliases
* gchiozzi 2000-08-30 Added min/max search radious setup file defines
* gchiozzi 2000-07-27 Moved handling of pix size here from fswsServer.
* gchiozzi 2000-02-01 Removed defines for agwsDB_TRK_XXX attributes: not used 
* mkiekebu  2000-01-11 Definitions for new OFFSGP cmd added  
* gchiozzi  15/11/99  Removed FINDGS command
* mkiekebu  01/07/99  command OFFSGP and agwsDB_TARGET_IMAGESCALE added
* gchiozzi  21/09/98  Removed defines fot TCCD WIN1 keywords
* gchiozzi  24/08/98  Added definitions for single exposure time handling.
* gchiozzi  14/08/98  Changed defines for STARTAG command to TCCD. Removed duplicates.
* gchiozzi  23/07/98  Replaced agwsINS_TCCD class with table.
* tcsmgr    21/07/98  set default of DEFERR to 0.5
* gchiozzi  20/07/98  Added OFFSADG command handling
* rkarban   18/07/98  change CNTGS to PR2STAR and STAR2PR
* tphan     25/05/98  Added cmd CNTGS
* gchiozzi  13/05/98  Added agUF_NONE
* gchiozzi  09/05/98  Removed agwsSERVER_SETUP
* gchiozzi  22/04/98  Added defines for centroiding function selection modes.
* gchiozzi  31/03/98  Added define for guiding active attribute in agServer image.
* gchiozzi  10/02/98  PRABS command accepts now AD instead of RaDecl
* gchiozzi  03/02/98  Patched agwsCOORD_STR_AD
* gchiozzi  08/01/98  Added define for TCCD Auto Restart flag.
* gchiozzi  15/12/97  Removed definition for GETRA command. Not used any more.
* gchiozzi  28/11/97  Removed takeActPos atribute.
* gchiozzi  18/11/97  Added agwsBOX2GS_DEFERR define
* gchiozzi  12/11/97  Replaced agwsGS_TRY_STATE enum with typedef and defines.
* gchiozzi  07/11/97  Added defines for STRTCCD and STOPCCD commands
* gchiozzi  07/11/97  Added define for TCCD keyword DET.WIN1.ST
* gchiozzi  23/10/97  Removed probe and rotator target. Only adatper is used.
* gchiozzi  10/10/97  Cleaned up TARGET_TCS cpp sections and move here some constants
* gchiozzi  09/10/97  Remover oslxServer
* gchiozzi  06/10/97  Renamed BOX2STAR as BOX2GS
* gchiozzi  03/10/97  Added agwsDB_TARGET_OSLXSERV define for tccd oslxServer
* gchiozzi  23/09/97  Added handling of check loop time on db.
* gchiozzi  22/07/97  Patch: TCCS keywords not aliases
* tphan     22/06/97  added agwsDB_BOX2STAR
* tphan     21/06/97  changed agwsPROBE_MARGIN from 20 to 10 mm (added vignetting check))
* rkarban   23/03/97  add define DB_ROTANGLE
* tphan     09/12/96  Updated keyworks for alias file TCS.alias
* tphan     07/12/96  Added RTD_FILENAME for test of rtd based gui's
* nttmgr    05/12/96  Added defines for handling of rotator adapter
* nfiebig   26/09/96  removed some unused defines
* nfiebig   23/08/96  circular search radii added
* nfiebig   06/05/96  updated command literals
* gchiozzi  29/02/96  created
*/

/******************************************************************************
 *
 * This file contains common defines used both by C/C++ files and 
 * dbLoader files
 *-----------------------------------------------------------------------------
 */

/* 
 *  Defines for the target telescope.
 *  The default target is VLT
 *  Up to now only VLT and NTT
 */

#include "tcsDefines.h"
#include "tifDefines.h"


/* Module name */
#define agwsMOD "agws"

/*
 ***************************************************************************
 * Defines for states values and names
 ***************************************************************************
 */
/*
 * These enum and string vector are used in the whole module
 * to identify states and substates.
 * The values must be coordinated with the standard states defined in 
 * evhStates.h
 */

#include "evhStates.h"

/* Local remapping of some standard states (just for convenience) */
#define agwsSTATE_UNK            evhSTATE_UNK
#define agwsSTATE_OFF            evhSTATE_OFF
#define agwsSTATE_LOADED         evhSTATE_LOADED
#define agwsSTATE_STANDBY        evhSTATE_STANDBY
#define agwsSTATE_ONLINE         evhSTATE_ONLINE
#define agwsSTATE_ERROR          evhSTATE_ERROR
#define agwsSTATE_IDLE           evhSTATE_IDLE

/* New states. I start from 121 to be sure not to clash */
#define agwsSTATE_OPERATING      tifAG_STATE_OPERATING
#define agwsSTATE_GUIDING        tifAG_STATE_GUIDING
#define agwsSTATE_MANUAL         tifAG_STATE_MANUAL

/* Defines for name states */
#define agwsSTATE_STR_UNK        evhSTATE_STR_UNK
#define agwsSTATE_STR_OFF        evhSTATE_STR_OFF 
#define agwsSTATE_STR_LOADED     evhSTATE_STR_LOADED 
#define agwsSTATE_STR_STANDBY    evhSTATE_STR_STANDBY 
#define agwsSTATE_STR_ONLINE     evhSTATE_STR_ONLINE 
#define agwsSTATE_STR_ERROR      evhSTATE_STR_ERROR 
#define agwsSTATE_STR_IDLE       evhSTATE_STR_IDLE
#define agwsSTATE_STR_OPERATING  "OPERATING"
#define agwsSTATE_STR_GUIDING    "GUIDING"
#define agwsSTATE_STR_MANUAL     "MANUAL"


#define agwsMODE_STR_AUTOGUIDE  "AG"
#define agwsMODE_STR_MAX_LEN    2

/*
 *    Standard OK reply
 *    Othere replies to commands
 */

#define agwsOK_REPLY             "OK"
#define agwsABORT_REPLY          "aborted"

#define agwsGS_NOT_TRIED    0
#define agwsGS_TRYING       1
#define agwsGS_DISCARDED    2
#define agwsGS_UNUSED       3

/*
 ***************************************************************************
 * Defines for database points and attributes
 ***************************************************************************
 */

#define agwsMAX_NO_OF_FOCI  5

// sub-points and attributes of <agwsRoot>:control
#define agwsDB_GUIDESTAR       "guideStar"
#define agwsDB_GUIDESTAR_TABLE "guideStarTable"
#define agwsDB_SERVER_CMDS     "cmdTimeouts"
#define agwsDB_SERVER_SETUP    "serverSetup"
#define agwsDB_TCCDSETUP       "ccdSetup"
#define agwsDB_PROBESETUP      "probeSetup"
#define agwsDB_SEARCHCRITERIA  "searchCriteria"
#define agwsDB_FOCUSDATA       "focusData"
#define agwsDB_MSW_LIST        "targetsAddr"
#define agwsDB_CHECK_LOOP_TIME "checkLoopTime"
#define agwsDB_BOX2GS          "box2gs"

// attributes in guideStar
#define agwsDB_ALPHA           ".alpha"
#define agwsDB_DELTA           ".delta"
#define agwsDB_MAGNITUDE       ".magnitude"
#define agwsDB_WAVELENGTH      ".wavelength"
#define agwsDB_OFFSET_ALPHA    ".offsetAlpha"
#define agwsDB_OFFSET_DELTA    ".offsetDelta"
#define agwsDB_FWHM            ".FWHM"
#define agwsDB_BACKGROUND      ".background"
#define agwsDB_FWHM_1          ".FWHM_1"
#define agwsDB_BACKGROUND_1    ".background_1"
#define agwsDB_FWHM_3          ".FWHM_3"
#define agwsDB_BACKGROUND_3    ".background_3"
#define agwsDB_FWHM_10         ".FWHM_10"
#define agwsDB_BACKGROUND_10   ".background_10"

#define agwsDB_GUIDESTAR_TABLE_ATTR ".tbl"

// attributes in ccdSetup
#define agwsDB_SETUPFILE            ".defaultSetup"
#define agwsDB_TCCD_AUTO_RESTART    ".autoRestart"
#define agwsDB_UFMODE_GUIDE_LOOP    ".ufModeGuideLoop"
#define agwsDB_UFMODE_SINGLE_EXP    ".ufModeSingleExp"
#define agwsDB_UF_DEFAULT_FUNC      ".ufDefaultFunc"

#define agwsDB_SINGLE_EXP_TIME      ".singleExpTime"

// attributes in probeSetup
#define agwsDB_MAXMOVE              ".maxMove"
#define agwsDB_PROBEPATH            ".probePath"

// attributes in targetSetup (temporarily in probeSetup)
#define agwsDB_TARG_ALPHA           ".alpha"
#define agwsDB_TARG_DELTA           ".delta"

// attribute for guide probe offset 
#define agwsDB_OFFSBUF_ALPHA        ".offsBufAlpha"
#define agwsDB_OFFSBUF_DELTA        ".offsBufDelta"
#define agwsDB_OFFSSET_DELTA        ".offsSetDelta"
#define agwsDB_OFFSSET_ALPHA        ".offsSetAlpha"


// attributes in searchCriteria
#define agwsDB_CATNAME              ".catalogName"
#define agwsDB_MINMAG               ".minMag"
#define agwsDB_MAXMAG               ".maxMag"
#define agwsDB_MINRAD               ".minRadius"
#define agwsDB_MAXRAD               ".maxRadius"
#define agwsDB_VIGLIM               ".vigLim"
#define agwsDB_ROTANGLE             ".rotAngle"

// sub-points in focusData
#define agwsDB_LOAD_ON_INIT         "loadOnInit"
#define agwsDB_TARGET_ADAPTER       "adapter"
#define agwsDB_TARGET_SERVER        "agServer"
#define agwsDB_TARGET_TCCD          "agTccd"
#define agwsDB_TARGET_TRK           "trkws"

// attributes in each focusData sub-point

#define agwsDB_TARGET_NAME          ".modName"
#define agwsDB_TARGET_DEST          ".destination"
#define agwsDB_TARGET_POINT         ".modSymbAddr"

// focus data table attribute
#define agwsDB_FOCUS_DATA           ".data"

// attributes in box2gs sub-point
#define agwsDB_BOX2GS_OFFSETX       ".xOffset"
#define agwsDB_BOX2GS_OFFSETY       ".yOffset"

#define agwsDB_AD_X_POINT           ":gp1x.posUser"
#define agwsDB_AD_Y_POINT           ":gp1y.posUser"

#define agwsDB_ROT_ADAPTER          ":intCoord.adapt"
#define agwsDB_ROT_POSITION         ".position"
#define agwsDB_ROT_OFFSET           ".rotatorOffset"
#define agwsDB_PROBE_NAME           ".probeName"
#define agwsDB_PROBE_CENTER_X       ".centerX"
#define agwsDB_PROBE_CENTER_Y       ".centerY"
#define agwsDB_PROBE_MIN_VIGNET_X   ".minVignetX"
#define agwsDB_PROBE_MAX_VIGNET_X   ".maxVignetX"
#define agwsDB_PROBE_MIN_VIGNET_Y   ".minVignetY"
#define agwsDB_PROBE_MAX_VIGNET_Y   ".maxVignetY"

#define agwsDB_AGSERV_GUIDING       ".guidingActive"

/*
 ***************************************************************************
 * Defines for command names
 ***************************************************************************
 */

/* New commands accepted by agwsControl process */

#define agwsBOX2GS_CMD    "BOX2GS"
#define agwsSTARTAG_CMD   "STARTAG"
#define agwsSTOPAG_CMD    "STOPAG"
#define agwsPRTOGS_CMD    "PRTOGS"
#define agwsDETGS_CMD     "DETGS"
#define agwsCNTOBJ_CMD    "CNTOBJ"
#define agwsPR2STAR_CMD   "PR2STAR"
#define agwsSTAR2PR_CMD   "STAR2PR"
#define agwsTEL2OBJ_CMD   "TEL2OBJ"

#define agwsPRABS_CMD     "PRABS"
#define agwsPRALT_CMD     "PRALT"
#define agwsPRCHK_CMD     "PRCHK"
#define agwsPRCNT_CMD     "PRCNT"
#define agwsPRDOBJ_CMD    "PRDOBJ"
#define agwsPRGS_CMD      "PRGS"
#define agwsPRPARK_CMD    "PRPARK"
#define agwsPRSTOP_CMD    "PRSTOP"
#define agwsOFFSAD_CMD    "OFFSAD"
#define agwsOFFSGP_CMD    "OFFSGP"
#define agwsOFFSADG_CMD   "OFFSADG"
#define agwsOFFSXY_CMD    "OFFSXY"
#define agwsSTARTMC_CMD   "STRTMC"
#define agwsSTOPMC_CMD    "STOPMC"

#define agwsCANDGS_CMD    "CANDGS"
#define agwsGETGS_CMD     "GETGS"
#define agwsGETGSS_CMD    "GETGSS"
#define agwsSELGS_CMD     "SELGS"
#define agwsSRCGS_CMD     "SRCGS"

#define agwsSETUP_CMD     "SETUP"

#define agwsSTRTCCD_CMD   "STRTCCD"
#define agwsSTOPCCD_CMD   "STOPCCD"

#if TARGET_TCS == VLT_TCS || TARGET_TCS == ATS_TCS
#define agwsSEND_PRABS_CMD     "PRABS"
#define agwsSEND_PRALT_CMD     "PRALT"
#define agwsSEND_PRCHK_CMD     "PRCHK"
#define agwsSEND_PRCNT_CMD     "PRCNT"
#define agwsSEND_PRDOBJ_CMD    "PRDOBJ"
#define agwsSEND_PRGS_CMD      "PRGS"
#define agwsSEND_PRPARK_CMD    "PRPARK"
#define agwsSEND_PRSTOP_CMD    "PRSTOP"
#define agwsSEND_OFFSAD_CMD    "OFFSAD"
#define agwsSEND_OFFSXY_CMD    "OFFSXY"
#define agwsSEND_STARTMC_CMD   "STRTMC"
#define agwsSEND_STOPMC_CMD    "STOPMC"
#define agwsSEND_GPINPOS_CMD   "GPINPOS"
#define agwsSEND_SETVIGN_CMD   "SETVIGN"

#elif TARGET_TCS == NTT_TCS
#define agwsSEND_PRABS_CMD     "MOVGP"
#define agwsSEND_PRALT_CMD     "PRALT"
#define agwsSEND_PRCHK_CMD     "PRCHK"
#define agwsSEND_PRCNT_CMD     "MOVGPCN"
#define agwsSEND_PRDOBJ_CMD    "PRDOBJ"
#define agwsSEND_PRGS_CMD      "PRGS"
#define agwsSEND_PRPARK_CMD    "PARK"
#define agwsSEND_PRSTOP_CMD    "PRSTOP"
#define agwsSEND_OFFSAD_CMD    "OFFSAD"
#define agwsSEND_OFFSXY_CMD    "OFFSXY"
#define agwsSEND_STARTMC_CMD   "STRTMC"
#define agwsSEND_STOPMC_CMD    "STOPMC"
#else
    #error Defined value for TARGET_TCS not supported
#endif

/* Commands sent to other modules     */
/* (interface must be defined better) */

/* To adapter module */
// ... and all the probe commands PRxxx, defined already above

/* To trkws module */
#define agwsTRK_OFFSAD_CMD    "OFFSAD"

/* To TCCD and agServer modules */
#define agwsTCCD_STARTAG_CMD     "START"
#define agwsTCCD_SETUP_CMD       "SETUP"
#define agwsTCCD_START_EXP_CMD   "START"
#define agwsTCCD_WAIT_EXP_CMD    "WAIT"
#define agwsTCCD_STPWAIT_EXP_CMD "STPWAIT"

#define agwsAG_STARTAG_CMD       "STARTAG"
#define agwsAG_STOPAG_CMD        "STOPAG"
#define agwsAG_OFFSAG_CMD        "OFFSAG"
#define agwsAG_OFFSAG2_CMD       "OFFSAG2"
#define agwsAG_CONFIG_CMD        "CONFIG"
#define agwsAG_XY2AD_CMD         "XY2AD"
#define agwsAG_PIXSIZE_CMD       "PIXSIZE"


/*
 ***************************************************************************
 *  Various Type Defines
 ***************************************************************************
 */

/*
 *  Coordinate types
 */
 
#define agwsCOORD_STR_AD        "AD"

#define agwsCOORD_STR_AA        "AA"
#define agwsCOORD_STR_XY        "XY"

/*
 *  Target types
 */
#define agwsTARG_NONE        0
#define agwsTARG_ALAZ        1
#define agwsTARG_COOR        2
#define agwsTARG_MOBJ        3
#define agwsTARG_NAME        4
#define agwsTARG_OBJ         5

#define agwsTARG_STR_NONE        "NO_TARGET"
#define agwsTARG_STR_ALAZ        "ALT_AZ"
#define agwsTARG_STR_COOR        "COORDINATE"
#define agwsTARG_STR_MOBJ        "MOVING_OBJ"
#define agwsTARG_STR_NAME        "NAMED_POS"
#define agwsTARG_STR_OBJ         "CATALOG_OBJ"

/*
 *  Preset types
 */
#define agwsAG_ERR         0
#define agwsAG_ASTRO       1
#define agwsAG_ENG         2

#define agwsAG_STR_ERR     "ERROR"
#define agwsAG_STR_ASTRO   "ASTRONOMICAL"
#define agwsAG_STR_ENG     "ENGINEERING"

/*
 *   Auto guide type
 */
#define agwsAG_NONE              0
#define agwsAG_AUTO_GUIDE        1
#define agwsAG_FIELD_STAB        2

#define agwsAG_STR_NONE              "NONE"
#define agwsAG_STR_AUTO_GUIDE        "AUTO_GUIDE"
#define agwsAG_STR_FIELD_STAB        "FIELD_STAB"

/*
 *   Auto guide centroiding function selection modes
 */
#define agwsUF_AUTO     0
#define agwsUF_CENTROID 1
#define agwsUF_IPFUNC   2
#define agwsUF_BOTH     3
#define agwsUF_NONE     4

/*
 *   Guide-star sources
 */
//#define agwsAG_STR_NONE       "NONE"
#define agwsAG_STR_CATALOGUE    "CATALOGUE"
#define agwsAG_STR_SETUPFILE    "SETUPFILE"

/*
 * vignetting criteria
 */
#define agwsAG_VIGLIM_NONE_STR   "NONE"
#define agwsAG_VIGLIM_INS_STR    "INSTRUMENT"
/*
 ***************************************************************************
 *  Defines for numerical constants
 *  Most should be moved in the database
 ***************************************************************************
 */

/*
 * number of entries in internal guide-star catalogue
 */
#define agwsGS_CAT_SIZE      5

/*
 * OFFSGP command default box reduction for range checking (0..1)
 */
#define agwsOFFSGP_BOX_REDUCTION	0.7

/*
 * BOX2GS command default max error and
 *                max loop
 */
#define agwsBOX2GS_DEFERR   0.5
#define agwsBOX2GS_LOOPMAX  20

/*
 * Technical CCD dimensions
 */
#define agwsTCCD_SIZE_X  400
#define agwsTCCD_SIZE_Y  290

#if TARGET_TCS == VLT_TCS || TARGET_TCS == ATS_TCS
#elif TARGET_TCS == NTT_TCS

#define agwsIMAGE_SCALE		0.3	/* arcsec per pixel for ntt. See ag db */
#define agwsPLATE_SCALE		5.35905	/* arcsec per mm for ntt adapter */

#define agwsPROBE_MARGIN	10	/* in mm */

#define agwsPROBE_X_MAX		175	/* ntt probe max X in mm */
#define agwsPROBE_Y_MAX		325	/* ntt probe max Y in mm */


#else
#error Defined value for TARGET_TCS not supported
#endif


/*
 ***************************************************************************
 *  Defines for setup file keywords and aliases
 ***************************************************************************
 */

/* Default and current setup file name */
#define agwsDEFAULT_SETUP   "agwsDefaultSetup.targ"
#define agwsCURRENT_SETUP   "agwsCurrentSetup.ref"

/* Setup file category */
#define agwsSK_CATEGORY     "TEL"

/* Setup file subsystems */
#define agwsSK_SUBS_AG      "AG"
#define agwsSK_SUBS_TARG    "TARG"
#define agwsSK_SUBS_ROT     "ROT"
#define agwsSK_SUBS_FS      "FS"
#define agwsSK_SUBS_M2      "M2"
#define agwsSK_SUBS_ADC     "ADC"
#define agwsSK_SUBS_AO      "AO"

/* Setup file keywords */
#define agwsSK_TYPE           "TYPE"
#define agwsSK_TARG_TYPE      "TEL.TARG.TYPE"
#define agwsSK_ALPHA          "ALPHA"
#define agwsSK_DELTA          "DELTA"
#define agwsSK_EPOCHSYSTEM    "EPOCHSYSTEM"
#define agwsSK_EPOCH          "EPOCH"
#define agwsSK_EQUINOX        "EQUINOX"
#define agwsSK_PMA            "PMA"
#define agwsSK_PMD            "PMD"
#define agwsSK_RADVEL         "RADVEL"
#define agwsSK_PARALLAX       "PARALLAX"
#define agwsSK_COORDTYPE      "COORDTYPE"
#define agwsSK_ALT            "ALT"
#define agwsSK_AZ             "AZ"
#define agwsSK_NAME           "NAME"
#define agwsSK_OBJCAT         "CAT"
#define agwsSK_OBJID          "OBJID"
#define agwsSK_WLENGTH        "WLENGTH"
#define agwsSK_OFFSETALPHA    "OFFSETALPHA"
#define agwsSK_OFFSETDELTA    "OFFSETDELTA"
#define agwsSK_AGCRIT         "AGCRIT"
#define agwsSK_OFFANGLE       "OFFANGLE"
#define agwsSK_ENABLED        "ENABLED"
#define agwsSK_ALTAZTRACK     "ALTAZTRACK"
#define agwsSK_AGTYPE         "TYPE"
#define agwsSK_START          "START"
#define agwsSK_OBJCNT         "OBJCNT"
#define agwsSK_RESET          "RESET"
#define agwsSK_ZENITH         "ZENITH"
#define agwsSK_ABSPOS         "ABSPOS"
#define agwsSK_DTIME          "DTIME"

#define agwsSK_GUIDESTAR      "GUIDESTAR"
#define agwsSK_MINMAG         "TEL.AG.MINMAG"
#define agwsSK_MAXMAG         "TEL.AG.MAXMAG"
#define agwsSK_MINRAD         "TEL.AG.MINRAD"
#define agwsSK_MAXRAD         "TEL.AG.MAXRAD"
#define agwsSK_VIGLIM         "VIGLIM"
#define agwsSK_MAXMOVE        "MAXMOVE_AG"
#define agwsSK_PROBEPATH      "PROBEPATH_AG"
#define agwsSK_COUNT          "COUNT_AG"
#define agwsSK_CYCLETIME      "CYCLETIME_AG"
#define agwsSK_INTTIME        "INTTIME_AG"

/*
 * TCCD keyword aliases
 */
#define agwsSK_TCCD_COUNT     "DET.EXP.NREP"
#define agwsSK_TCCD_CYCLETIME "DET.EXP.TIMEREP"
#define agwsSK_TCCD_INTTIME   "DET.WIN1.UIT1"

#endif /*!agwsDEFINES_H*/
