#ifndef agwsTRANSFER_H
#define agwsTRANSFER_H
/******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: agwsTRANSFER.h,v 1.198 2005/08/26 15:24:47 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* nfiebig   29/05/96  created
*/

/************************************************************************
 * Definition of the agwsTRANSFER service class
 *----------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

#include "agws.h"
#include "agwsSTATE.h"
#include "evhOBJ_CALLBACK.h"
#include "evhCOMMAND.h"

class agwsTRANSFER : public evhCOMMAND
{
  public:
    agwsTRANSFER(const dbSYMADDRESS dbPoint, 
                 const dbATTRIBUTE targetName = NULL);
    ccsCOMPL_STAT Target(const dbATTRIBUTE targetName);
    ccsCOMPL_STAT Send(const msgCMD cmd, const char *buffer, 
                       vltINT32 startState, vltINT32 endState);

    virtual ccsCOMPL_STAT Reset();
    const char *GetTarget() const;

  protected:
    int _ReplyCB(msgMESSAGE &msg, void *udata);
    int _ErrReplyCB(msgMESSAGE &msg, void *udata);
    int _TimeoutCB(msgMESSAGE &msg, void *udata);

  private:
    agwsSTATE state;           // state handling object
    char      targetName[32];  // attribute name of target specification
    vltINT32  endState;        // state to switch to on command completion
    static vltINT32 numOfCmdsActive;
};

#endif // !agwsTRANSFER_H

// __oOo__
