/**************************************************************************
* E.S.O. - VLT project
#
# "@(#) $Id: alrmCCS.h,v 1.115 2005/09/05 09:04:19 vltsccm Exp $" 
*
* <alrm.h>  -  CCS/Alarm Interface File
*
* who        when      what
* ---------  --------  ----------------------------------------------
* B.Gilli    16/11/95  Created
* rabuter    17/11/95  Include alrm module private  definitions
* B.Gilli    09/04/96  modified to take local copy of newAlarm.h
* bgilli     15/05/96  removed previous modif not necessary for HP-UX10
* rabuter    20/01/97  on SUN still requires local copy of newAlarm.h
* mcomin     23/03/97  Use rtap/newAlarm.h for both HP and SUN 
* bgilli     14/07/98  Excluded rtap include files in CCS_Lite case.
* mcomin     20/07/98  Change ifdef RTAPROOT to ifndef CCS_LIGHT
************************************************************************
*/
#ifndef ALRMCCS_H
#define ALRMCCS_H
/*
 * Include Error Definitions
 */
#include "alrmErrors.h"

/*
 *  Header Files
 */
#include <stdio.h>
#include <stdlib.h>

#ifndef CCS_LIGHT
#  include <rtap/errno.h>
#  include <rtap/newAlarm.h>
#endif

#include "db.h"
#include "CCS.h"
#include "msg.h"

#include "alrmPrivate.h"


/*Public Interface of the CCS/Alarm System API*/

typedef struct alrmCon_ alrmCONN;
/*Prototype*/
ccsCOMPL_STAT alrmAttach( alrmCONN *con, ccsERROR * error );
ccsCOMPL_STAT alrmDetach( alrmCONN *con, ccsERROR * error );


typedef struct alrmMsg_ alrmALARM;
/*Prototype*/
ccsCOMPL_STAT alrmParseMsg( msgHEADER *msg, alrmALARM *alarm, vltUINT16 *next,  ccsERROR * error );


#endif /*!ALRMCCS_H*/
