#ifndef ALRMLITE_H
#define ALRMLITE_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: alrmLite.h,v 1.115 2005/09/05 09:04:20 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* tebert    21/07/98  created
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */
#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>
#include <unistd.h>

#include "CCS.h"

#define ALRMSERVER                  "alrmServer"
#define alrmCCS_ALARM_ALIAS         "alrmccs_alarm"
#define rtAS_OPEN_HISTORICAL        0x1
#define rtAS_OPEN_CURRENT           0x2
#define rtAS_OPEN_FUTURE            0x0

#define rtAS_FUTURE_ALARMS          rtAS_OPEN_FUTURE
#define rtAS_CURRENT_FUTURE_ALARMS  (rtAS_OPEN_CURRENT | rtAS_OPEN_FUTURE)

#define rtAS_CONN_CLOSED            0
#define rtAS_CONN_OPEN              1
#define rtAS_CONN_SHUTDOWN          2
#define rtAS_CONN_NOREQ             3

#define rtAS_CONN_STATUS_CHG        3
#define rtAS_MAX_CONN_ID            1023

#define rtAS_ALL_CONNS              (~0L)

#define rtAS_FLAGS_INSTANCE_CHANGED 0x01

#define rtALARM_CONN_MGMT           msgTYPE_ALARM_CONN
#define rtALARM_NOTIFICATION        msgTYPE_ALARM

#define rtExtConnBit(ptr,conn) ((ptr)[(conn)/8] &   (1<<(conn)%8))
#define rtSetConnBit(ptr,conn) ((ptr)[(conn)/8] |=  (1<<(conn)%8))
#define rtClrConnBit(ptr,conn) ((ptr)[(conn)/8] &= ~(1<<(conn)%8))

/*
 * error codes
 */
#define rtE_NA_NO_ALARM_SYS            0x03C00000
#define rtE_NA_INVLD_CONN_TYPE         0x03C20000
#define rtE_NA_INV_CONN                0x03C60000
#define rtE_NA_BAD_NOTIF               0x03C60002
#define rtE_NA_NOT_NOTIF_MSG           0x03C2000C

/*
 * typedefs
 */
typedef rtInt rtASConnection_T;
 
typedef struct rtASConnInfo
    {
    rtUInt32      connType;
    rtDbAddress   alarmBranch;
    rtChar       *filterExpr;
    } rtASConnInfo_T;

typedef struct
    {
    rtUInt32    sequence;
    rtUInt16    index;
    rtLogical   acknowledged;
    rtUInt8     reserved;
    rtTime      time;
    } rtASState_T; 

typedef struct rtASSource
    {
    rtProcessEnv       env;
    rtUInt32           categories;
    rtPlin             plin;
    rtAin              ain;
    rtUInt8            flags;  
    rtASState_T        state; 
    } rtASSource_T;

typedef struct
    {
    rtUInt8  connBits[1];
    rtUInt8  matchBits[1];
    } rtASConnMatch_T;

typedef struct
    {
    rtChar   msg[1];
    } rtASMessage_T;

typedef struct rtAlarmInfo
    {
    rtASSource_T            alarmSource;
    rtASConnMatch_T        *connMatch;
    rtInt                   connMatchLen;
    rtASMessage_T          *alarmMsg;
    rtInt                   alarmMsgLen;
    } rtAlarmInfo_T;

typedef struct rtASConnMgmt
    {
    rtUInt32   connAction;
    rtUInt32   appConnId;
    } rtASConnMgmt_T;

typedef struct rtASConnStatusChg
    {
    rtUInt32  reqStatus;
    rtUInt32  newStatus;
    rtError   rtErrno;
    } rtASConnStatusChg_T;

typedef struct
    {
    rtUInt32   ack;
    rtUInt32   acked_sequence;
    rtTime     acked_time;
    rtUInt32   acked_uid;
    rtUInt32   type;
    rtLogical  enabled;
    rtLogical  notify;
    rtUInt8    history;
    rtUInt8    flags;
    } rtASInstance_T;

/* functions */
rtASConnection_T rtCreateAlarmConnection  (rtChar *env, rtASConnInfo_T *connInfo);
rtInt            rtDestroyAlarmConnection (rtASConnection_T connInfo);
rtInt            rtNextAlarm              (rtMsgHeader *msgHeader, rtAlarmInfo_T *alarmInfo,
                                           rtInt *lastAlarm);

#endif /*!ALRMLITE_H*/
