/**************************************************************************
* E.S.O. - VLT project
#
# "@(#) $Id: alrmPrivate.h,v 1.115 2005/09/05 09:04:20 vltsccm Exp $" 
*
* <alrmPrivate.h>  -  CCS/Alarm system all private headers
*
* who        when      what
* ---------  --------  ----------------------------------------------
* rabuter    16/11/95  Created
* mcomin     20/07/98  rtFALSE/rtTRUE replaced with CCS types.
* fdelgado   15/09/98  definitions for symbols alrmSCOPE_LOCAL and
*                      alrmSCOPE_GLOBAL added
*
************************************************************************
*/
#ifndef alrmPrivate_H
#define alrmPrivate_H


#include "alrmErrors.h"
#include "alrmClassdef.h"

/*alrmMsg */
#define ALRMMSG_ATTRIBUTE             128

#define alrmMSG_CONN_CLOSE            rtAS_CONN_CLOSED
#define alrmMSG_CONN_OPEN             rtAS_CONN_OPEN
#define alrmMSG_CONN_SHUTDOWN         rtAS_CONN_SHUTDOWN

#define ALRMMSG_MESSAGELEN            1024

#define alrmMSG_MORE                  ccsTRUE
#define alrmMSG_NOMORE                ccsFALSE

#define alrmMSG_STATE_ACKOK           8

/*public*/
Class *alrmMsgConstruct();
ccsCOMPL_STAT  alrmMsgDestruct(Class *);

/*private*/
void  alrmMsgActivate(Class *);


#define  alrmMsg_Env_I			        1
#define  alrmMsg_Point_I			2
#define  alrmMsg_Attribute_I			3
#define  alrmMsg_AttrPlin_I			4
#define  alrmMsg_AttrAin_I			5
#define  alrmMsg_AttrValue_I			6
#define  alrmMsg_Severity_I			7
#define  alrmMsg_Scope_I			8
#define  alrmMsg_Timeout_I			9
#define  alrmMsg_SourceConnId_I			10
#define  alrmMsg_ConnAction_I			11
#define  alrmMsg_IsAck_I			12
#define  alrmMsg_Parse_I			13
#define  alrmMsg_AttrSize_I			14
#define  alrmMsg_AttrType_I			15
#define  alrmMsg_Message_I			16
#define  alrmMsg_Subpoint_I			17

#define  alrmMsg_SIZE			        18

struct  alrmMsg_{
	unsigned char * alrmMsg_Env;
	unsigned char * alrmMsg_Point;
	unsigned char * alrmMsg_Subpoint;
	unsigned char * alrmMsg_Attribute;
	unsigned char * alrmMsg_AttrValue;
	short alrmMsg_AttrPlin;
	short alrmMsg_AttrAin;
        long alrmMsg_AttrSize;
        vltUINT8  alrmMsg_AttrType;
	vltUINT16 alrmMsg_Severity;
	vltUINT8  alrmMsg_Scope;
	vltUINT32 alrmMsg_Timeout;
	short alrmMsg_SourceConnId;
	vltUINT8 alrmMsg_ConnAction;
        unsigned short alrmMsg_IsAck;
	unsigned char * alrmMsg_Message;

};
typedef Class  alrmMsg;

/*Public Class alrmMsg  Data Members*/
/*Dato..*/
#define alrmMsgEnv(tab)		        (*((Class*)tab)[alrmMsg_Env_I].puc)
/*Dato..*/
#define alrmMsgPoint(tab)		(*((Class*)tab)[alrmMsg_Point_I].puc)
/*Dato..*/
#define alrmMsgSubpoint(tab)		(*((Class*)tab)[alrmMsg_Subpoint_I].puc)
/*Dato..*/
#define alrmMsgAttribute(tab)		(*((Class*)tab)[alrmMsg_Attribute_I].puc)
/*Dato..*/
#define alrmMsgAttrPlin(tab)		(*((Class*)tab)[alrmMsg_AttrPlin_I].l)
/*Dato..*/
#define alrmMsgAttrAin(tab)		(*((Class*)tab)[alrmMsg_AttrAin_I].l)
/*Dato..*/
#define alrmMsgAttrValue(tab)		(*((Class*)tab)[alrmMsg_AttrValue_I].puc)
/*Dato..*/
#define alrmMsgAttrSize(tab)		(*((Class*)tab)[alrmMsg_AttrSize_I].l)
/*Dato..*/
#define alrmMsgAttrType(tab)		(*((Class*)tab)[alrmMsg_AttrType_I].vui8)
/*Dato..*/
#define alrmMsgSeverity(tab)		(*((Class*)tab)[alrmMsg_Severity_I].vui16)
/*Dato..*/
#define alrmMsgScope(tab)		(*((Class*)tab)[alrmMsg_Scope_I].vui8)
/*Dato..*/
#define alrmMsgTimeout(tab)		(*((Class*)tab)[alrmMsg_Timeout_I].vui32)
/*Dato..*/
#define alrmMsgSourceConnId(tab)	(*((Class*)tab)[alrmMsg_SourceConnId_I].s)
/*Dato..*/
#define alrmMsgConnAction(tab)	        (*((Class*)tab)[alrmMsg_ConnAction_I].vui8)
/*Dato..*/
#define alrmMsgIsAck(tab)	        (*((Class*)tab)[alrmMsg_IsAck_I].us)
/*Dato..*/
#define alrmMsgMessage(tab)		(*((Class*)tab)[alrmMsg_Message_I].puc)

/*Public Class alrmMsg Function Members*/
/*Funcion..*/
#define alrmMsgParse(tab,m,o,e)	        (*((Class*)tab)[alrmMsg_Parse_I].ccs)(tab,m,o,e)


/*alrmCon*/

/*Scopes*/
#define alrmCON_SCOPE_LOCAL         1
#define alrmCON_SCOPE_GLOBAL        2

/*Severity States*/
#define   alrmCON_ERROR             4
#define   alrmCON_NORMAL            8
#define   alrmCON_WARNING           16
#define   alrmCON_SERIOUS           32
#define   alrmCON_FATAL             64
#define   alrmCON_WARNING_ACK       128
#define   alrmCON_SERIOUS_ACK       256
#define   alrmCON_FATAL_ACK         512
#define   alrmCON_WARNING_ACKED     1024
#define   alrmCON_SERIOUS_ACKED     2048
#define   alrmCON_FATAL_ACKED       4096

/*Scopes of Alarms*/
#define   alrmSCOPE_LOCAL         0
#define   alrmSCOPE_GLOBAL        1

/*Severity States*/
#define   alrmERROR             0
#define   alrmNORMAL            1
#define   alrmWARNING           2
#define   alrmSERIOUS           3
#define   alrmFATAL             4
#define   alrmWARNING_ACK       5
#define   alrmSERIOUS_ACK       6
#define   alrmFATAL_ACK         7
#define   alrmWARNING_ACKED     8
#define   alrmSERIOUS_ACKED     9
#define   alrmFATAL_ACKED       10

/*public*/
Class *alrmConConstruct();
ccsCOMPL_STAT alrmConDestruct(Class *);
/*private*/
void  alrmConActivate(Class *);


#define  alrmCon_Env_I			        1
#define  alrmCon_Branch_I			2
#define  alrmCon_Filter_I			3
#define  alrmCon_Id_I			        4
#define  alrmCon_Connect_I			5
#define  alrmCon_Disconnect_I			6

#define  alrmCon_SIZE			        7

struct  alrmCon_{
	unsigned char * alrmCon_Env;
	unsigned char * alrmCon_Branch;
	unsigned short alrmCon_Filter;
	short alrmCon_Id;
};
typedef Class  alrmCon;

/*Public Class alrmCon  Data Members*/
/*Dato..*/
#define alrmConEnv(tab)		        (*((Class*)tab)[alrmCon_Env_I].puc)
/*Dato..*/
#define alrmConBranch(tab)		(*((Class*)tab)[alrmCon_Branch_I].puc)
/*Dato..*/
#define alrmConFilter(tab)		(*((Class*)tab)[alrmCon_Filter_I].us)
/*Dato..*/
#define alrmConId(tab)		        (*((Class*)tab)[alrmCon_Id_I].s)

/*Public Class alrmCon Function Members*/
/*Funcion..*/
#define alrmConConnect(tab,e)	        (*((Class*)tab)[alrmCon_Connect_I].ccs)(tab,e)
/*Funcion..*/
#define alrmConDisconnect(tab,e)	(*((Class*)tab)[alrmCon_Disconnect_I].ccs)(tab,e)


#endif
