#ifndef bossARF_MGR_H
#define bossARF_MGR_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: bossARF_MGR.h,v 1.153 2005/08/23 16:46:36 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* epozna   17/11/00   created
* epozna   24/07/01   added AddChangeCatTag 
* epozna   16/10/02   VLTSW20020431:AddKw_INSTRUME,AddKw_PICOI,AddKw_OBSERVER
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

#include "ixacARF_MGR.h"
#include "ixacTIMER_LOGS.h"
#include "ixacErr.h"
#include "oslxFITS_EXT.h" 

class bossARF_MGR : public ixacARF_MGR
{
public:
  
    bossARF_MGR( oslxDICTIONARY *dictionary=NULL);
    ~bossARF_MGR();
  
    ccsCOMPL_STAT AddChangeCatTag(const slxFILENAME targetFile,
				  ...);
    ccsCOMPL_STAT AddAppendExtTag(const slxFILENAME targetFile,
				  ...);
    ccsCOMPL_STAT AddCreateNewTag(const slxFILENAME targetFile,
				  ...);
    ccsCOMPL_STAT AddAppendBinTag(const slxFILENAME file1,
				  ...);
    ccsCOMPL_STAT AddMergeTag(const slxFILENAME  targetFile,
			      ...);
    ccsCOMPL_STAT AddAppendTag(const slxFILENAME targetFile,
			       ...);

    ccsCOMPL_STAT LoadArf(const slxFILENAME arf);
    ccsCOMPL_STAT HandleArf(const slxFILENAME arf, 
			    const char *volacNewDataFileNameDbAttr=NULL,
			    const char *osNewDataDbAttr=NULL  );
  
    vltLOGICAL    HasArcMember();
    ccsCOMPL_STAT LoadDictionaries(char * dictionaries);
    vltLOGICAL    IsDictOnList(char * dict);
    ccsCOMPL_STAT ActivateTimer(vltLOGICAL isact);

 protected: 
    /*support function for adding dependent kws to the hdr*/
    ccsCOMPL_STAT AddKw_OBJECT(oslxFITS_EXT * fitsextPtr);
    ccsCOMPL_STAT AddKw_PICOI(oslxFITS_EXT * fitsextPtr);
    ccsCOMPL_STAT AddKw_OBSERVER(oslxFITS_EXT * fitsextPtr);
    ccsCOMPL_STAT AddKwsCompolsary(oslxFITS_EXT * fitsextPtr);

    vltLOGICAL        hasArcMember_;
    dbSYMADDRESS      dbAddrOsNewData_;
    vltBYTES128       dictnames_;

 private:
    ixacTIMER_LOGS    timerLog;
    ixacTIMER_LOGS    timerLogMain;
    vltINT32          logLevel;
};
#endif /*!bossARF_MGR_H*/
