#ifndef bossCtrlMain_H
#define bossCtrlMain_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: bossCtrlMain.h,v 1.153 2005/08/23 16:46:37 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* epozna    05/07/00  adopted and fitted to boss (after ic0/icb)
* epozna    09/09/03  APR2004 comp: removed function Exit(err) 
*/

/************************************************************************
 * This file contains definitions used by class bossCtrlMain.C
 *----------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

/* 
 * VLT Headers
 */


/* 
 * boss Headers
 */
#include "boss.h"
#include "bossSERVER.h"


class bossCtrlMain : public eccsERROR_CLASS
{
  public:
     
      //constructor,destructor
      bossCtrlMain(char *prefix,const char* version);             
      virtual ~bossCtrlMain();     
                      
      // Init method
      ccsCOMPL_STAT Init(int argc, char *argv[]); 

      // Exit method
      virtual void Exit(vltINT32 status, 
                        vltLOGICAL dereg = ccsTRUE); 

      // public functions
      virtual ccsCOMPL_STAT CreateServer(bossSERVER *newServer);
      virtual ccsCOMPL_STAT DeclareProcessName(int argc, char *argv[]);

  protected:

      ccsPROCNAME  procName;              // name of this process
      char         dictionary[256];       // dictionary name
      char         alias[256];            // alias table name
      char         osId[20];              // OS Id
      char         osPrefix[20];          // OS prefix
      char         osVersion[256];         // OS version 

    /*
      void Exit(vltLOGICAL dereg, ccsMODULEID moduleId, 
                vltINT16 errorNumber,...);
    */
  private:
      bossSERVER   * bossServer;
      virtual ccsCOMPL_STAT DeleteServer();      // delete server instance
 //   virtual void Usage() = 0;                  // on-line help method

};


#endif /*!bossCtrlMain_H*/
