#ifndef bossEXPOSTATE_HANDLE_H
#define bossEXPOSTATE_HANDLE_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: bossEXPOSTATE_HANDLE.h,v 1.153 2005/08/23 16:46:43 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* zins      05/10/98  created
* epozna              updated to BOSS
* epozna    10/05/00  added new function 'SetOsState' 
*                     for new databasepoint (OS:status.osstate)
* epozna   15/01/02    VLTSW20010724 added  SetSubStateUI
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

#include "evhTASK.h"
#include "fndNAME_MAP.h"
#include "eccsDB_ATTR.h"

#include "ixacTASK.h"
#include "bossStates.h"

class bossEXPOSTATE_HANDLE :  public eccsERROR_CLASS  //public fndOBJECT, : public ixacTASK
{
public:
    bossEXPOSTATE_HANDLE();
    virtual ~bossEXPOSTATE_HANDLE();

    virtual ccsCOMPL_STAT Init(const dbSYMADDRESS dbPoint);

    virtual ccsCOMPL_STAT GetState(vltINT32 *state);
    virtual ccsCOMPL_STAT GetStateName(const char **stateName);

    virtual ccsCOMPL_STAT GetSubState(vltINT32 *subState);
    virtual ccsCOMPL_STAT GetSubStateUI(vltUINT32 *subState);
    virtual ccsCOMPL_STAT GetSubStateName(const char **subStateName);

    virtual ccsCOMPL_STAT SetState(vltINT32 state);
    virtual ccsCOMPL_STAT SetSubState(vltINT32 subState);
    virtual ccsCOMPL_STAT SetSubStateUI(vltUINT32 subState);
    virtual ccsCOMPL_STAT UpdateSubState(vltUINT32 obsStatus);

    virtual ccsCOMPL_STAT SetOsState(vltINT32 subState);
    virtual ccsCOMPL_STAT SetStates(vltINT32 state, vltINT32 subState);

    virtual ccsCOMPL_STAT StateNo2Str(const vltINT32 state,
                                      const char **stateName);
    virtual ccsCOMPL_STAT StateStr2No(const char *stateName,
                                      vltINT32 *state);
    virtual ccsCOMPL_STAT SubStateNo2Str(const vltINT32 subState,
                                         const char **subStateName);
    virtual ccsCOMPL_STAT SubStateStr2No(const char *subStateName,
                                         vltINT32 *subState);

    virtual ccsCOMPL_STAT SetStateNamesTable(fndNAME_AND_INDEX *table,
                                             vltUINT32 nbElem);
    virtual ccsCOMPL_STAT SetSubStateNamesTable(fndNAME_AND_INDEX *table,
                                                vltUINT32 nbElem);
protected:
    virtual vltLOGICAL    DbWriteEnabled() const;

private:
    bossEXPOSTATE_HANDLE& operator=(const bossEXPOSTATE_HANDLE&);
    bossEXPOSTATE_HANDLE (const bossEXPOSTATE_HANDLE&);

    dbSYMADDRESS dbRef;

    vltLOGICAL   dbWriteEnabled;
    
    fndNAME_MAP  *stateNames;
    fndNAME_MAP  *subStateNames;
 
    static fndNAME_AND_INDEX stateNamesTable[];
    static fndNAME_AND_INDEX subStateNamesTable[];
};


#endif /*!bossEXPOSTATE_HANDLE_H*/
