#ifndef  bossEXPOTBL_HANDLE_H
#define  bossEXPOTBL_HANDLE_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: bossEXPOTBL_HANDLE.h,v 1.153 2005/08/23 16:46:42 vltsccm Exp $"
*
* who       when        what
* --------  ----------  ----------------------------------------------
* epozna  2003-11-17  created
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

#include "eccsErr.h"
#include "evhHANDLER.h"
#include "ixacErr.h"
#include "inscExpStates.h"  
#include "bossExpoStatus.h"
#include "bossEXPOSURE_TABLE_ENTRY.h"

class bossEXPOTBL_HANDLE : public eccsERROR_CLASS 
{
  public: 
    //constructor/destructor
    bossEXPOTBL_HANDLE(const dbSYMADDRESS dbPoint);
    
    // warning : default constructor in eccsERROR_CLASS (not virtual)
    virtual ~bossEXPOTBL_HANDLE();

    //expoId
    virtual ccsCOMPL_STAT CheckExpoId(vltINT32 expoId); //( can be removed)
    
    //Check if entry exist
    virtual vltLOGICAL    IsDefined (int expoId);
    virtual vltLOGICAL    IsDefined (char* expoId);
    
    //Add entry
    ccsCOMPL_STAT AddExposure (int expoId,       char *mode,
			       char *subsystems, char *inspath, 
			       char *detector,   char * filename, 
			       char *state,      char *expstrt);
    virtual vltINT32      GetFirstEmptyLine();  
    virtual vltINT32      GetLine(int expoId);
    virtual vltINT32      GetLine(char* expoId); 
    virtual int           GetExpoIdFromStr(char* tblElem);

    //remove entry
    virtual ccsCOMPL_STAT DeleteExposure (int expoId);
    virtual ccsCOMPL_STAT DeleteExposure (char* expoIdString);
    
    //modify existing exposure
    virtual ccsCOMPL_STAT ModifyExposure (int expoId,    char *parameter, 
					  char *value);
    
    //get entry
    virtual ccsCOMPL_STAT GetExposure(int  expoId,      char *mode,
				      char *subsystems, char *inspath, 
				      char *detector,   char *filename, 
				      char *state,      char *expstrt); 
    
    // Image data file    
    virtual char          *GetFileName(vltINT32 expoId);
    virtual ccsCOMPL_STAT GetFileName(vltINT32 expoId,char* filename);
    
    //subsystems
    virtual char         *GetSubsystems(vltINT32 expoId);
    virtual ccsCOMPL_STAT GetSubsystems(vltINT32 expoId,char *subsystems);

    //getinsmode
    virtual char         *GetInsMode(vltINT32 expoId);
    virtual ccsCOMPL_STAT GetInsMode(vltINT32 expoId,char * insmode );

    //getdetector
    virtual char         *GetDetector(vltINT32 expoId);
    virtual ccsCOMPL_STAT GetDetector(vltINT32 expoId,char* detector);
    virtual vltINT32      GetNumberOfDetectors(vltINT32 expoId);
    //getinspath
    virtual char         *GetInsPath(vltINT32 expoId);
    virtual ccsCOMPL_STAT GetInsPath(vltINT32 expoId,char* path);

    //getexpstart flag
    virtual char         *GetExpstartFlag(vltINT32 expoId);
    virtual ccsCOMPL_STAT GetExpstartFlag(vltINT32 expoId,char *expstrt);
    
    //get exposure status
    virtual char         *GetExposureStatus(vltINT32 expoId);
    virtual ccsCOMPL_STAT GetExposureStatus(vltINT32 expoId,char *status );
    
  protected: 
    // Root database point
    dbSYMADDRESS dbRef_; 
    
    // stores the currently running exposures in a db table
    eccsDB_TABLE<bossEXPOSURE_TABLE_ENTRY> * exposureTbl; 

  private:
    // Declaration of copy constructor and assignment operator as private
    // methods, in order to hide them from the users.
    bossEXPOTBL_HANDLE& operator=(const bossEXPOTBL_HANDLE&);
    bossEXPOTBL_HANDLE (const bossEXPOTBL_HANDLE&);

  
};
#endif /*! bossEXPOTBL_HANDLE_H*/
    
