#ifndef bossExpoStatus_H
#define bossExpoStatus_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: bossExpoStatus.h,v 1.153 2005/08/23 16:46:37 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* epozna  31/05/01  created
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif


// Observation status ( 4096 8192 16384)
#define bossEXP_RUNNING    1024   
#define bossEXP_MERGING    2048
#define bossEXP_FINISHED   8192
#define bossEXP_CANCELLED  4096

/*  additional CCD expostatus values
 *  exposure status as declared in 'ccd.h'
 *  boss using  :ccdEXP_LOOP_FINITE ccdEXP_LOOP_INFINITE	
 */
#define ccdEXP_NONE             0
#define ccdEXP_INACTIVE         1
#define ccdEXP_PENDING          2
#define ccdEXP_INTEGRATING      4
#define ccdEXP_PAUSED           8
#define ccdEXP_READING         16
#define ccdEXP_PROCESSING      32
#define ccdEXP_TRANSFERING     64
#define ccdEXP_COMPLETED      128
#define ccdEXP_FAILED         256
#define ccdEXP_ABORTED        512
#define ccdEXP_LOOP_FINITE   1024
#define ccdEXP_LOOP_INFINITE 2048

#define ccdEXP_DONE \
       (ccdEXP_COMPLETED | ccdEXP_FAILED | ccdEXP_ABORTED)
#define ccdEXP_RUNNING \
       (ccdEXP_PENDING | ccdEXP_INTEGRATING | ccdEXP_PAUSED | \
	ccdEXP_READING | ccdEXP_PROCESSING | ccdEXP_TRANSFERING )
#define ccdEXP_LOOP \
       (ccdEXP_LOOP_FINITE | ccdEXP_LOOP_INFINITE)


#endif /*!bossExpoStatus_H*/
