#ifndef bossFITS_HEADER_H
#define bossFITS_HEADER_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: bossFITS_HEADER.h,v 1.153 2005/08/23 16:46:37 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* marteau  27/04/99  created
* epozna   01/08/00  restructured (no more expomode and arrays)
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

#include "fndOBJECT.h"
#include "eccsErr.h"
#include "oslx.h"
#include "ixacKEY_DB_MAP.h"
//#include "bossEXPOSURE.h"

class bossFITS_HEADER : public fndOBJECT, public eccsERROR_CLASS
{
public:
    bossFITS_HEADER(oslxDICTIONARY *dictionary,
                    ixacKEY_DB_MAP *keyDbMap);
    
    virtual ~bossFITS_HEADER();

    virtual ccsCOMPL_STAT SetRefList(const char **refList); // d
    virtual ccsCOMPL_STAT SetTemplateFile (slxFILENAME templateFile);
    virtual ccsCOMPL_STAT LoadHeader(const slxFILENAME  fileName);
    virtual ccsCOMPL_STAT CreateStoreFits (oslxKEYWORD &keyword);

    virtual ccsCOMPL_STAT AddComment (const slxKEYW_LINE comment);
    virtual ccsCOMPL_STAT ClearCommentList();

    virtual void          ClearKeywFilter();
    virtual ccsCOMPL_STAT AddKeywFilter(const slxKEYW_LINE keywFilter);
    virtual ccsCOMPL_STAT SpecifyFilters();

    virtual ccsCOMPL_STAT SetFileName(slxFILENAME name);
    virtual char          *GetFileName();
    virtual ccsCOMPL_STAT DeleteFile(slxFILENAME name);

    virtual ccsCOMPL_STAT FillHeader(oslxKEYW_FILTER *filter = NULL,
                                     vltLOGICAL clear = TRUE);
    virtual ccsCOMPL_STAT ClearInstance();
    
    // Extract keywords from SETUP command
    virtual ccsCOMPL_STAT ExtractKeywords(oslxSETUP &setup);

    virtual ccsCOMPL_STAT SetExtendedDbAttr(char *dbAttr);
    virtual ccsCOMPL_STAT SetExtended(vltLOGICAL extended);
    virtual vltLOGICAL IsExtended();

    ccsCOMPL_STAT DumpKeywords();
    // assignment operator is overloaded
    // bossFITS_HEADER& operator=(const bossFITS_HEADER& hdr);
     bossFITS_HEADER& operator=( bossFITS_HEADER& hdr);
protected:

private:
    
    bossFITS_HEADER (const bossFITS_HEADER&);

    // Locate and load the template FITS file
    ccsCOMPL_STAT LoadTemplateFile(char *templateFile, 
                                   oslxSHORT_FITS *shortFits);

    // Check if keyword belongs to header or maint-header class and if is
    // defined in the key-db map.
    ccsCOMPL_STAT CheckKeyword(oslxKEYWORD keyword, vltLOGICAL *isHeaderClass);

    ixacKEY_DB_MAP  *keyDbMap_;

    dbSYMADDRESS    extendedDbAttr_; // Db attr. where extended flag stored
    vltLOGICAL      extended_;

    oslxDICTIONARY  *dictionary_;


// ===============
    // Name of the complete FITS header
    slxFILENAME     headerFileName_;
    // Template file name
    slxFILENAME     tplFileName_;
    // Filter to extract SETUP keyword to be placed in the FITS header
    oslxKEYW_FILTER keywFilter_;
    // List of keyword to be placed in header
    ixacHASH        refList_;
    // oslxFITS instance to handle 
    oslxFITS        fitsHeader_;



};

#endif /*! bossFITS_HEADER_H */
