#ifndef bossINTERFACE_H
#define bossINTERFACE_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: bossINTERFACE.h,v 1.153 2005/08/23 16:46:38 vltsccm Exp $"
*
* who        when      what
* --------  --------  ----------------------------------------------
* zins       05/06/98  created
* epozna     27/03/00  change according to bossDIC
*                      add functions, and private variables 
* epozna     22/05/00  private --> protected
* epozna     05/06/00  added defined value: #define bossEXPOID_UNDEFINED -9999 
*                      add empty functions to be overloaded by CCD intf.:
*                       subsMsgModify(),subsMsgProcess()
* epozna     23/06/00  added :SetupError
* epozna     01/08/00  modify args of Expend()/Expstart()/GetStatusFits()
* epozna     23/07/01  added functions: Set/GetNewCategory(),Set/GetCategoryName  
* epozna     06/02/02  update to ctooCONFIG
*  epozna    24/10/02  VLTSW20020280/1 functions to support wipe/stop
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */
#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif
/* 
 * System Headers 
 */

//#include "bossPrivate.h"
#include "evhDB_CMD_SEND.h"
#include "evhDB_SYNC.h"
#include "oslxDYN_BUF.h"
#include "oslxSHORT_FITS.h"
#include "ixacKEYW_CMD_PARAM.h"
#include "bossStates.h"
#include "oslxSETUP.h"
#include "ctooCONFIG.h"


#define bossNB_SYNC_OBJ 5


// Lis of standard sub-system categories
#define bossICS_SUBSYS  0x1   // ICS sub-system
#define bossDCS_SUBSYS  0x2   // DCS sub-system
#define bossTCS_SUBSYS  0x4   // TCS sub-system
#define bossOS_SUBSYS   0x8   // OS server
//#define bossRTD_SUBSYS  0x16  // this value is reserved for RTD (see module bossrtd)

#define bossALL_SUBSYS 0xFFFFFFFF

// db point where the type opf the instrument is used
#define bossINSTYPE_DB_POINT "<alias>insType.type"


// Possible access modes to sub-system
typedef enum 
{
    bossACC_NORMAL = 0,
    bossACC_SIMUL,
    bossACC_IGNORE,
    bossACC_NOT_AVAIL   // FORBIDDEN    
} bossACCESS_TYPE;


class bossINTERFACE : public evhDB_CMD_SEND
{
public:
    bossINTERFACE(const dbSYMADDRESS dbPoint, vltINT32 srvId); 
    bossINTERFACE(const dbSYMADDRESS dbPoint, char* srvId);
    virtual ~bossINTERFACE();

    // Return root database point
    virtual dbSYMADDRESS *GetDbPoint();
    
    // Return Server Id 
    virtual vltINT32    GetISrvId(); // deprecated
    virtual char*       GetSrvId();
    
    // return the type of interface
    virtual char*          GetInterfaceType();
    virtual ccsCOMPL_STAT  SetInterfaceType(char * type);

    // Generic INTERFACE configuration
    virtual ccsCOMPL_STAT Configure(ctooCONFIG *appConfig,oslxDICTIONARY *dictionaryPtr);
    virtual ccsCOMPL_STAT ConfigureKeyword(oslxKEYWORD &keyword);
    virtual ccsCOMPL_STAT ConfigureIfPreProc(ctooCONFIG *appConfig, 
					      oslxCONFIG *cfgSubstPtr);
    virtual ccsCOMPL_STAT ConfigureIfSpecKeywords(char* param, char *value);
    virtual ccsCOMPL_STAT ConfigureIfSpecPostProc(ctooCONFIG *appConfig);


    // INTERFACE public data access
    virtual char              *GetName();
    virtual ccsCOMPL_STAT     SetName(char *newName);
    virtual char              *GetEnvName();
    virtual ccsCOMPL_STAT     SetEnvName(char *newEnvName);
    virtual char              *GetProcName();
    virtual ccsCOMPL_STAT     SetProcName(char *newProcName);
    virtual char              *GetServerName();
    virtual ccsCOMPL_STAT     SetServerName(char *newServerName);
    virtual ccsCOMPL_STAT     SetServerName();
    virtual char              *GetSimulatorName();
    virtual ccsCOMPL_STAT     SetSimulatorName(char *newSimulatorName);
    virtual ccsCOMPL_STAT     AddDictionaryName(char *newDictionaryName);
    virtual char              *GetDictNames();
    virtual ccsCOMPL_STAT     SetAliasTableName(char *newAliasTableName); 
    virtual char              *GetAliasTableName();
    virtual ccsCOMPL_STAT     SetNewCategory(char *newCategory);
    virtual char              *GetNewCategory();
    virtual ccsCOMPL_STAT     SetCategoryName(char *category);
    virtual char              *GetDbRoot();
    virtual ccsCOMPL_STAT     SetDbRoot(char *dbRoot);
    virtual ccsCOMPL_STAT     SetDbIfRoot(char *dbIfRoot);
    virtual char              *GetCategoryName();
    virtual const char        *GetStateDbAttr();
    virtual ccsCOMPL_STAT     SetStateDbAttr(char *newStateDbAttr);
    virtual ccsCOMPL_STAT     SetStateDbAttr(); // set default db address
    virtual vltINT32          GetTimeout();
    virtual ccsCOMPL_STAT     SetTimeout(vltINT32 newTimeout);
    virtual ccsCOMPL_STAT     SetKeywFilter(char * newkeywfilt);
    virtual ccsCOMPL_STAT     SetAccess(char *newAccessMode);
    virtual vltLOGICAL        IsSimulated();
    virtual vltLOGICAL        IsAvailable();
    virtual vltLOGICAL        IsIgnored();
    virtual char              *GetDestProc();
    virtual char              *GetDestEnv();

    virtual ccsCOMPL_STAT     SetDefaults();
    virtual ccsCOMPL_STAT     SetDefaultDbRoot(); 
    virtual ccsCOMPL_STAT     SetDefaultKeywordFilter();
    virtual ccsCOMPL_STAT     SetDefaultDbRef();
    virtual ccsCOMPL_STAT     SetValuesInDb();
    virtual ccsCOMPL_STAT     LoadDic(oslxDICTIONARY &dictionary);

    // Get pointer to the keyword filters associated to the interface
    virtual oslxKEYW_FILTER   *GetKeywFilter();

    // Set and test the sub-system categories.
    virtual ccsCOMPL_STAT     SetCategory(const vltINT32 category);
    virtual vltLOGICAL        IsInCategory(const vltINT32 category);

    // Get the current value of the state or sub-state of the sub-system
    virtual vltINT32          GetSubSystemState();
    
    // Send synchronous command to interface process
    virtual ccsCOMPL_STAT Send (msgMESSAGE   &msg,
                                vltLOGICAL   timeoutFlag=ccsTRUE,
				vltLOGICAL   paramCheck=ccsTRUE);
    virtual ccsCOMPL_STAT Send(const msgCMD  command,
                               const char   *parameters,
                               msgLENGTH     parametersLen=0,
                               vltLOGICAL    timeoutFlag=ccsTRUE,
			       vltLOGICAL    paramCheck=ccsTRUE);

    // Send async. command to interface process
    virtual ccsCOMPL_STAT Forward(msgMESSAGE &msg,
                                  vltLOGICAL timeoutFlag=ccsTRUE,
				  vltLOGICAL checkstop =ccsFALSE);
    virtual ccsCOMPL_STAT Forward(const msgCMD command,
                                  const char *parameters,
                                  msgLENGTH parametersLen=0,
                                  vltLOGICAL timeoutFlag=ccsTRUE);


    // Set and get calling process
    virtual ccsCOMPL_STAT SetRequestor(msgMESSAGE &msg);
    virtual msgMESSAGE &GetRequestor();
    
    // Check if a reply from sub-system is waited
    virtual vltLOGICAL    IsWaitingReply();
 
    // Synchronization on reply from sub-system
    virtual ccsCOMPL_STAT SyncReply();
    virtual ccsCOMPL_STAT SyncReply(evhOBJ_CALLBACK callBack);

    // Default callback to be executed when sub-system reply is received
    virtual evhCB_COMPL_STAT SyncReplyCB(msgMESSAGE &msg, void* userData);

    // Attach callback to command completion
    virtual ccsCOMPL_STAT NotifyCmdCompletion(evhOBJ_CALLBACK callBack);
  
    // Reset command reply synchronization
    virtual ccsCOMPL_STAT SyncReset();

    // Reset communication
    virtual ccsCOMPL_STAT Reset();
   
    // Error handling
    virtual ccsCOMPL_STAT GetErrStatus();   // Return the error status for the
                                            // last execution of the command
    virtual ccsERROR      *GetErrMsg();     // Return the error message
    virtual ccsCOMPL_STAT ClearErr();       // Clear the error (msg and status)

    // Message reply buffer
    virtual oslxDYN_BUF   *Buffer();

    // *** Specific functions for the exposure control
    // Functions call at the start and at end of the exposure.
    virtual ccsCOMPL_STAT ExpStart(vltINT32 expoId,const char *filename, char *);
    virtual ccsCOMPL_STAT ExpEnd(vltINT32 expoId,
				 const char *detId,
				 const char *filename, 
				 const char *path);

    // Set/Get a expoId
    virtual ccsCOMPL_STAT SetExpoId(vltINT32 expoId);
    virtual vltINT32 GetExpoId();

    // Get the status FITS file produced by sub-system (if any)
    virtual char          *GetStatusFits(vltINT32 expoId,const char *detId,
					 const char *filename);  
    
     // allow the subsystem interface to modify the the msg send by OS
     // need to couple the expoId of OS and the local expoId of TCCD 
     virtual  ccsCOMPL_STAT subsMsgModify (const msgCMD command,
					 msgMESSAGE &msg ) ; 
     virtual ccsCOMPL_STAT  subsMsgModify (const msgCMD command,
					 char *parameters ) ;

    // allow the subsystem interface to processing  the reply
    // of the msg (needed fpr expoId coupling START)
    virtual void  subsMsgProcess (const msgCMD command);      
   
    // to be called in case of SETUP error reply
    ccsCOMPL_STAT SetupError (msgMESSAGE &msg);

    // instrument type
    virtual char *           InsType();

    //forward cmd support function 
    virtual ccsCOMPL_STAT    UpdateInsType();
    virtual ccsCOMPL_STAT    SendForwardCmd(msgMESSAGE &msg,
					    char *command, char* commandParams);
    virtual ccsCOMPL_STAT    ReplyForwardCmd(const char *newBuffer, 
					     msgLENGTH   newBuflen=0,
					     vltLOGICAL  lastReply=ccsTRUE);
    virtual ccsCOMPL_STAT    ReplyForwardCmd(const ccsERROR &errmsg);
    virtual void             ForwardEvhCmdReset();
    virtual evhCB_COMPL_STAT ForwardReplyCB (msgMESSAGE &msg, void *  );
    virtual evhCB_COMPL_STAT ForwardTimeOutCB (msgMESSAGE &msg, void *  );
    virtual evhCB_COMPL_STAT ForwardErrReplyCB (msgMESSAGE &msg, void *  );
    virtual ccsCOMPL_STAT    CheckCfgKeywords();
  
	
protected:

    // Hook functions on completion of the command
    virtual evhCB_COMPL_STAT CompletedCB(msgMESSAGE &msg, void *userData);
    virtual evhCB_COMPL_STAT ErrorCB(msgMESSAGE &msg, void *userData);
    virtual evhCB_COMPL_STAT TimeoutCB(msgMESSAGE &msg, void *userData);
    // workaround removed after OCT99
    // virtual evhCB_COMPL_STAT EventErrorCB(msgMESSAGE &msg, void *userData);

    // Notify that command execution is finished
    virtual ccsCOMPL_STAT    Notify(); 

    // Handle the destination process name
    virtual char             *GetDestTarget();
    virtual ccsCOMPL_STAT    SetDestTarget(char *newDestProcess);

    // Clear message buffer
    void ClearMsgBuffer (msgMESSAGE &msg);

    // instrument id
    vltBYTES32      insConId_;


    vltINT32        isrvId_;
    vltBYTES32      srvId_;

    // Configuration parameters
    vltBYTES64      interfaceType_;   // The type of the interface (name of the class).
    vltBYTES32      name_;            // Sub-system name.
    vltBYTES32      accessMode_;      // Access mode to interface.
    vltINT32        accessType_;      // integer representation of acces mode
    vltBYTES32      dictTbl_[20];     // List of the dictionaries.
    vltINT32        nbDict_;          // Number of the dictionaries.
    vltLOGICAL      isdic_;           // Flag to denote if DICTi kw given in cfg 
    vltLOGICAL      isKeywFilt_;      // Flag to denote if KEYWFILT cfg kw is declared 
    vltBYTES256     aliasTableName_;  // Name of the alias table.
    vltBYTES32      envName_;         // Name of the environment.
    vltBYTES32      procName_;        // Name of the process.
    vltBYTES32      serverName_;      // Server process name (envname+procname)
    vltBYTES32      simulatorName_;   // Simulation process name.
    vltINT32        timeout_;         // Timeout for the interface.
    oslxKEYW_FILTER keywFilter_;      // Filter to extract sub-system Keywords
    vltBYTES16      origCategory_;    // category of subsyst (saved header keyword)
    vltBYTES16      newCategory_;     // user specified category (e.g. 'INS1')
    //vltBYTES128     dictnames_;     // name of the dictionaries as comma sep list
    dbSYMADDRESS    dbRoot_;          // the database root of subsystem
    dbSYMADDRESS    stateDbAttr_;     // Db attr. where sub-system state stored
    dbSYMADDRESS    stateDbAttrDefault_;     // Db attr. where sub-system state stored


    // Root database point of the interface itself (boss logs various data under this)
    dbSYMADDRESS    dbRef_;
 

    // Current destination process (Server process or Simulation process)
    vltBYTES32      destTarget_;
    vltBYTES32      destProc_;
    vltBYTES32      destEnv_;

    // List of categories to which the sub-systems belongs.
    vltINT32        category_;
    
    // Communication handling parameters 
    vltLOGICAL      waitingReply_;   // True if waiting reply from sub-system
    ccsCOMPL_STAT   errStatus_;      // True if an error is returned by
                                     // sub-system.
    ccsERROR        errMsg_;         // Error message (when error occured).
    msgMESSAGE      requestor_;      // Request message 
    oslxDYN_BUF     buffer_;         // Internal message buffer to store reply.

    // Objects to synchronize sub-system reply
    evhDB_SYNC      syncReply_[bossNB_SYNC_OBJ];

    // Database events handling
    evtEVENT        cmdCompletionEvt_;// Command completion event

    // Exposure ID attached to the sub-system. In principle, this is only
    // relevant for OS or DCS sub-system.
    vltINT32        expoId_;
    
    msgMESSAGE *forwardMsg;
    evhCOMMAND forwardEvhCmd_;
    vltLOGICAL isCondSet_;

    vltBYTES32 lastCommand_;    //Last Command  sent or forwarded to subsystem

  private:
    // Declaration of copy constructor and assignment operator as private
    // methods, in order to hide them to users.
    bossINTERFACE& operator=(const bossINTERFACE&);
    bossINTERFACE(const bossINTERFACE&);
    
 
};

#endif /*!bossINTERFACE_H*/
