#ifndef bossINTERFACE_ARCH_H
#define bossINTERFACE_ARCH_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: bossINTERFACE_ARCH.h,v 1.153 2005/08/23 16:46:38 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* gzins     04/12/99  created
* epozna    30/03/00  update to bossDic (new constructor function)
* epozna    02/07/00  added Configure
* epozna    08/12/00  added isArchive argument to Archive() 
* - - - - - - - - - - -APR2003 - - - - - - - - - - - - - - - - - - - - - - - - -
* epozna    07/09/03  Archive -- VLTSW20030312 added expoId arg to Archive()
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

#include "bossINTERFACE.h" 
#include "bossEXPOSURE.h"
#include "bossWaitCmdHandler.h"
#include "bossARF_MGR.h"
#include "bossArchErrHndl.h"

class bossINTERFACE_ARCH : public bossINTERFACE
{
public:
    bossINTERFACE_ARCH(const dbSYMADDRESS dbPoint, vltINT32 srvId);  
    bossINTERFACE_ARCH(const dbSYMADDRESS dbPoint, char * srvId);
    virtual ~bossINTERFACE_ARCH();

    virtual  ccsCOMPL_STAT   SetArchData(vltLOGICAL archStatus); 
    virtual  ccsCOMPL_STAT   Init(bossEXPOSURE        *expotbl,
				  bossWaitCmdHandler  *waitCmdHandlPtr,
				  bossArchErrHndl     *archerr); 
    virtual  ccsCOMPL_STAT   Configure(ctooCONFIG     *appConfig,
				       oslxDICTIONARY *dictionaryPtr);
    virtual  vltLOGICAL      ArchDataDisabled();

    //VLTSW20040387
    virtual  ccsCOMPL_STAT   CheckArchiverProc();
    virtual  ccsCOMPL_STAT   CheckArchiverProcId();

    //Msg handling actions
    virtual  ccsCOMPL_STAT   Archive(vltINT32 expoId,const char *arfFileName);
    virtual  ccsCOMPL_STAT   ArchiveReplyAction(vltLOGICAL isok);
    virtual  ccsCOMPL_STAT   ArchiveErrorReplyAction();
    virtual  ccsCOMPL_STAT   SendNextCmd();
   
    // Check If ARchiver is busy processing a command
    virtual  vltLOGICAL      IsQueue();
protected:
    evhCB_COMPL_STAT CompletedCB(msgMESSAGE &msg, void *);
    evhCB_COMPL_STAT ErrorCB(msgMESSAGE &msg, void *);
    evhCB_COMPL_STAT TimeoutCB(msgMESSAGE &msg, void *);
   
private:
    
    //Archive command queue handling
    ccsCOMPL_STAT RemoveArchCmd(char *key);
    ccsCOMPL_STAT GetNextArchCmd(vltINT32 *expoId,char* command,char* buffer ,char *key);
    ccsCOMPL_STAT AddArchCmd(vltINT32 expoId,const char * command,const char *buffer);
    

    // Declaration of copy constructor and assignment operator as private
    // methods, in order to hide them from the users.
    bossINTERFACE_ARCH& operator=(const bossINTERFACE_ARCH&);
    bossINTERFACE_ARCH (const bossINTERFACE_ARCH&);

    vltLOGICAL            archStatus_;
    bossArchErrHndl     * archErrHandl_;
    bossEXPOSURE        * expoTablePtr_;
    bossWaitCmdHandler  * waitCmdHandlerPtr_;
};

#endif /*!bossINTERFACE_ARCH_H*/
