#ifndef bossINTERFACE_CCD_H
#define bossINTERFACE_CCD_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: bossINTERFACE_CCD.h,v 1.153 2005/08/23 16:46:38 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* epozna     21/05/00 created
* epozna     31/05/01 overloaded  GetExpoStatus() to avoid collision 
*                     with boss status when CCD is looping
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

#include "bossINTERFACE_DCS.h"
//#define bossEXPOID_UNDEFINED -9999  // defined in bossINTERFACE.h 
#define ADD_PARAM_LENGTH   100

class bossINTERFACE_CCD : public bossINTERFACE_DCS
{
public:
    bossINTERFACE_CCD(const dbSYMADDRESS dbPoint, char * srvId);
    virtual ~bossINTERFACE_CCD();



    virtual ccsCOMPL_STAT Forward(const msgCMD command,
				  const char *parameters,
				  msgLENGTH parametersLen,
				  vltLOGICAL timeoutFlag);

    //Reset i.e. cancel the next exposure 
    virtual    void  Reset (vltINT32 expoId);
    // total reset of the interface. Called when SOS starts up.
    ccsCOMPL_STAT Clear();

    // configure ccdName 
    virtual ccsCOMPL_STAT ConfigureIfSpecKeywords(char* param,char* value); 
    
    // get/set ccdName from configuration
    virtual   char * GetCcdName();
    virtual   ccsCOMPL_STAT SetCcdName(char *ccdname);



protected:      
     
    virtual vltUINT32 GetExpoStatus();

    virtual  ccsCOMPL_STAT subsMsgModify (const msgCMD command,
					  msgMESSAGE &msg); 

    virtual ccsCOMPL_STAT  subsMsgModify (const msgCMD command,
					 char *parameters ) ;

    //  modify the expoId ; for SETUP  -1 or 0
    //                      for WAIT, ABORT  : local expoId
    ccsCOMPL_STAT  modifyExpoId (const msgCMD command,  msgMESSAGE &msg );  

    // Check if expoId is correct --> delete expoId 
    // ( current for  PAUSE, CONT; next for START ) 
    ccsCOMPL_STAT deleteExpoId (const msgCMD command,  msgMESSAGE &msg );  

    // delete msg buffer 
    ccsCOMPL_STAT NoParameter (const msgCMD command,  msgMESSAGE &msg);

    // Check given expoId, logs various errors
    ccsCOMPL_STAT checkExpoIdMismatch(const msgCMD command,vltINT32 expoId);   

    ccsCOMPL_STAT  expoIdForSetup(vltINT32 origExpoId, vltINT32 &refId );
    ccsCOMPL_STAT  expoIdCoupling(vltINT32 origExpoId, vltINT32 &refId );
    
    //should be called when error reply received for the SETUP command
    ccsCOMPL_STAT SetupError (msgMESSAGE &msg);
    
    // process reply of START command
    void virtual  subsMsgProcess (const msgCMD command); 
    

    vltINT32   origExpoId_next   ;    
    vltINT32   origExpoId_current; 
    vltINT32   localExpoId_current;
    vltINT32   countSetup_next;
    vltBYTES64 ccdName_;

   

private:
    // Declaration of copy constructor and assignment operator as private
    // methods, in order to hide them from the users.
    bossINTERFACE_CCD& operator=(const bossINTERFACE_CCD&);
    bossINTERFACE_CCD (const bossINTERFACE_CCD&);   
   
};

#endif /*!bossINTERFACE_CCD_H*/
