#ifndef bossINTERFACE_ICS_H
#define bossINTERFACE_ICS_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: bossINTERFACE_ICS.h,v 1.153 2005/08/23 16:46:39 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* gzins     04/12/99  created
* epozna    01/08/00  modify args of Expend()/Expstart()/GetStatusFits()
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

#include "bossINTERFACE.h"

class bossINTERFACE_ICS : public bossINTERFACE
{
public:
    bossINTERFACE_ICS(const dbSYMADDRESS dbPoint, vltINT32 srvId);   
    bossINTERFACE_ICS(const dbSYMADDRESS dbPoint, char* srvId);
    virtual ~bossINTERFACE_ICS();

    // set default cfg values
    virtual ccsCOMPL_STAT ConfigureIfPreProc(ctooCONFIG *appConfig, 
				      oslxCONFIG *cfgSubstPtr);
    // Method calls at the start and at end of the exposure.
    virtual ccsCOMPL_STAT ExpStart(vltINT32 expoId,const char *filename, char * path);
    virtual ccsCOMPL_STAT ExpEnd(vltINT32 expoId,const char *detId,
				 const char *filename, const char * path);
    virtual ccsCOMPL_STAT SendExpEndCmd(const char *path);
    virtual ccsCOMPL_STAT CreateStatusFits(vltINT32 expoId,const char *filename);

    // Get the status FITS file produced by sub-system (if any)
    virtual char          *GetStatusFits(vltINT32 expoId,
					 const char *detId,
					 const char *filename);

    //VLTSW20020714 Check if ICS is busy (substate) when internal cmds are handled
    virtual ccsCOMPL_STAT  ConfigureIfSpecKeywords(char* param,char* value);
    virtual ccsCOMPL_STAT  ConfigureIfSpecPostProc(ctooCONFIG *appConfig);
    virtual ccsCOMPL_STAT  SetDbAddressSubstate(char* dbAddress);
    virtual ccsCOMPL_STAT  SetDbAddressSubstate();
    virtual ccsCOMPL_STAT  GetSubstate(vltINT32 *substate );
    virtual ccsCOMPL_STAT  WaitTillFree( );
    virtual ccsCOMPL_STAT  IsBusy(vltLOGICAL *isbusy );  
    virtual ccsCOMPL_STAT  Forward(const msgCMD command,
				   const char *parameters,
				   msgLENGTH parametersLen=0,
				   vltLOGICAL timeoutFlag=ccsTRUE);
    virtual ccsCOMPL_STAT   Forward(msgMESSAGE &msg,
				    vltLOGICAL timeoutFlag=ccsTRUE,
				    vltLOGICAL checkstop =ccsFALSE);
protected:
    dbSYMADDRESS    substateDbAttrDefault_; 
    dbSYMADDRESS    dbAddressSubstate_;
private:
    // Declaration of copy constructor and assignment operator as private
    // methods, in order to hide them from the users.
    bossINTERFACE_ICS& operator=(const bossINTERFACE_ICS&);
    bossINTERFACE_ICS (const bossINTERFACE_ICS&);
    
};

#endif /*!bossINTERFACE_ICS_H*/
