#ifndef bossINTERFACE_OS_H
#define bossINTERFACE_OS_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: bossINTERFACE_OS.h,v 1.153 2005/08/23 16:46:39 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* gzins     04/12/99  created
* epozna    30/03/00  update to bossDic (new constructor function)
* epozna    15/03/01  GetOsPrefix, SetOsPrefix
*                     SOS added lots of functions ...
*                         added msg modifying fuinctions 
* epozna    24/04/01  added functions Cancel()
* epozna    06/08/01  overloaded  CompletedCB
* - - - - - - - - - - - - - - -MAR2002 - - - - - - - - - - - - - - 
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

//#include "bossINTERFACE.h"
#include "bossINTERFACE_DCS.h"

class bossINTERFACE_OS : public bossINTERFACE_DCS
{
public:
    bossINTERFACE_OS(const dbSYMADDRESS dbPoint, vltINT32 srvId);  
    bossINTERFACE_OS(const dbSYMADDRESS dbPoint, char * srvId);
    virtual ~bossINTERFACE_OS();
  
    //functions to modify the incoming command before sending to the subsystems
    virtual ccsCOMPL_STAT subsMsgModify (const msgCMD command,
				 msgMESSAGE &msg);
    
    virtual ccsCOMPL_STAT ModifySetupCommand (const msgCMD command,
				      msgMESSAGE &msg) ;

    ccsCOMPL_STAT ModifyFunctionParameter (vltINT32 parnum,
				       char ** setupBuf,vltINT32 expoId );

    virtual ccsCOMPL_STAT ModifyDetId(const msgCMD command,
				       msgMESSAGE &msg);

    // virtual ccsCOMPL_STAT SetDbAddressOsNewData(char* dbAddressOsNewData);
    //virtual char *        GetDbAddressOsNewData();
   

    virtual ccsCOMPL_STAT SetOsId(char *osId);
    virtual ccsCOMPL_STAT SetImageFileName(const char *filename,
					   vltINT32 expoId);
    virtual ccsCOMPL_STAT  Init(oslxDICTIONARY     *dictionaryPtr, 
				bossWaitCmdHandler *waitCmdHandlPtr,
				ixacKEY_DB_MAP     *keyDbMapPtr);
    
    virtual ccsCOMPL_STAT SetDefaultDbRoot();
    virtual ccsCOMPL_STAT ConfigureIfSpecKeywords(char* param,char* value);
    // SOS functions
    virtual void           SetOsPrefix(char * prefix);
    virtual ccsCOMPL_STAT  SetDefaultPrefix();
    virtual char *         GetOsPrefix();

    //virtual ccsCOMPL_STAT ExpStart(const char *sExpoId, char *);
    virtual ccsCOMPL_STAT ExpStart(vltINT32 expoId,const char *filename, char * path);
    virtual ccsCOMPL_STAT ExpEnd(vltINT32,const char*,
				 const char *filename,const char *);
    virtual char *        GetHdrFileName (char* filename);
    virtual char *        GetBtblFileName(char* filename);
    virtual ccsCOMPL_STAT GetFileName(vltINT32 expoId, char *imageFileName);
    virtual ccsCOMPL_STAT GetHeader(vltINT32 expoId, char* osname, char *filename);

    //overloaded DCS func
    virtual ccsCOMPL_STAT Cancel(vltINT32 expoId);

    virtual evhCB_COMPL_STAT WaitReplyCB (msgMESSAGE &msg, void *  ) ;

    virtual void             RemoveFromImageList(vltINT32 expoId);
    virtual void             AddToImageList(vltINT32 expoId);
    virtual vltLOGICAL       IsOnImageList(vltINT32 expoId);

    
protected:
   virtual evhCB_COMPL_STAT CompletedCB(msgMESSAGE &msg, void *);


    //dbSYMADDRESS   dbAddressOsNewData_;
    //dbSYMADDRESS   dbAddressOsNewDataDefault_; 
   vltBYTES32     osId_;            // Name of the OS (e.g. xxo)
   vltBYTES256    imageList_;       // list of exposures that are creating images
   

private:
    // Declaration of copy constructor and assignment operator as private
    // methods, in order to hide them from the users.
    bossINTERFACE_OS& operator=(const bossINTERFACE_OS&);
    bossINTERFACE_OS (const bossINTERFACE_OS&);
    vltBYTES16 prefix_;
};

#endif /*!bossINTERFACE_OS_H*/
