#ifndef bossINTERFACE_TCS_H
#define bossINTERFACE_TCS_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: bossINTERFACE_TCS.h,v 1.153 2005/08/23 16:46:40 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* gzins    03/12/99  createde
* pozna    01/08/00  modify args of Expend()/Expstart()/GetStatusFits()
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

#include "bossINTERFACE_TCS_BASE.h"

// Attributes of the TCS public database class
#define bossDB_TCS_RA_ATTR           "<alias>tifPublic:coord.ra"
#define bossDB_TCS_DEC_ATTR          "<alias>tifPublic:coord.dec"
#define bossDB_TCS_ROT_ANGLE_ATTR    "<alias>tifPublic:track.rotAngle"
#define bossDB_TCS_FOCU_VALUE_ATTR   "<alias>tifPublic:m2.focuValue"
#define bossDB_TCS_ADA_POSANGLE_ATTR "<alias>tifPublic:track.adaPosAngle"

class bossINTERFACE_TCS : public bossINTERFACE_TCS_BASE
{
public:
    bossINTERFACE_TCS(const dbSYMADDRESS dbPoint, char *   srvId);

    virtual ~bossINTERFACE_TCS();

    virtual ccsCOMPL_STAT ConfigureIfSpecKeywords(char* param,char* value);
    virtual ccsCOMPL_STAT ConvertXY(vltDOUBLE offsetX, vltDOUBLE offsetY, 
                                    vltDOUBLE scale, vltDOUBLE *offsetAlpha,
                                    vltDOUBLE *offsetDelta);
    // Start/Stop auto guiding.
    virtual ccsCOMPL_STAT StartAg();
    virtual ccsCOMPL_STAT StopAg();

    // Start/Stop chopping.
    virtual ccsCOMPL_STAT StartChop(const vltDOUBLE chopFreq);
    virtual ccsCOMPL_STAT StopChop();

    // Prepare command and parameters to issue offset with TCS
    virtual ccsCOMPL_STAT GetCmdAdOffset(msgCMD command, char *params,
                                         vltDOUBLE  offsetAlpha,
                                         vltDOUBLE  offsetDelta,
                                         vltLOGICAL nonCombinedAg);
    virtual ccsCOMPL_STAT GetCmdFocOffset(msgCMD command, char *params,
                                          vltDOUBLE  offsetFocus);
    virtual ccsCOMPL_STAT GetCmdRotOffset(msgCMD command, char *params,
                                          vltDOUBLE  offsetRot);
     
    // Method calls at the start and at end of the exposure.
    virtual ccsCOMPL_STAT ExpStart(vltINT32 expoId,const char *filename, char *);
    virtual ccsCOMPL_STAT ExpEnd(vltINT32 expoId,const char *detId,
				 const char *filename,const char * );

    // Get the status FITS file produced by sub-system (if any)
    virtual char          *GetStatusFits(vltINT32 expoId,const char * detId,
					 const char *filename);
  
    // TCS is used  
    virtual char * InsType();

    virtual  ccsCOMPL_STAT CheckTelescopValue(char *telId);

    // tmp
    virtual  ccsCOMPL_STAT GetBtblFiles(vltINT32        expoId,
					char            *filename,
					vltINT32        *noOfbtblFiles,
					slxSTRING_LIST  *btblFileList  );

  
    virtual ccsCOMPL_STAT ConfigureIfPreProc(ctooCONFIG *appConfig, 
					     oslxCONFIG *cfgSubstPtr);
protected:
    virtual ccsCOMPL_STAT GetByName(char *nameIndex, vltDOUBLE *value);
    

private:
    // Declaration of copy constructor and assignment operator as private
    // methods, in order to hide them from the users.
    bossINTERFACE_TCS& operator=(const bossINTERFACE_TCS&);
    bossINTERFACE_TCS (const bossINTERFACE_TCS&);
    
};


#endif /*!bossINTERFACE_TCS_H*/
