#ifndef bossINTERFACE_TCS_BASE_H
#define bossINTERFACE_TCS_BASE_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: bossINTERFACE_TCS_BASE.h,v 1.153 2005/08/23 16:46:40 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* epozna  21/09/01  created
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

#include "bossINTERFACE.h"
class bossINTERFACE_TCS_BASE : public bossINTERFACE
{
public:
    //constructor/destructor
    bossINTERFACE_TCS_BASE(const dbSYMADDRESS dbPoint, char *   srvId);
    virtual ~bossINTERFACE_TCS_BASE();

    virtual  char              *GetTelId();

    virtual  ccsCOMPL_STAT     GetBtblFiles(vltINT32        expoId,
					    char            *filename,
					    vltINT32        *noOfbtblFiles,
					    slxSTRING_LIST  *btblFileList  );
    virtual  ccsCOMPL_STAT     SetTelId(char *telId);
    virtual  ccsCOMPL_STAT     CheckTelescopValue(char *telId)=0;
    virtual  ccsCOMPL_STAT     ConfigureIfSpecKeywords(char* param,char* value);
    virtual  ccsCOMPL_STAT     ConfigureIfSpecPostProc(ctooCONFIG *appConfig);

protected:
    vltBYTES32      telId_;           // value for the TELESCOP keyword in the fitshdr
    


private:
    // Declaration of copy constructor and assignment operator as private
    // methods, in order to hide them from the users.
    bossINTERFACE_TCS_BASE& operator=(const bossINTERFACE_TCS_BASE&);
    bossINTERFACE_TCS_BASE (const bossINTERFACE_TCS_BASE&);
    

};
#endif /*! bossINTERFACE_TCS_BASE_H*/
