#ifndef bossINTERFACE_VLTI_H
#define bossINTERFACE_VLTI_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: bossINTERFACE_VLTI.h,v 1.6 2003/07/22 11:50:39 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* pozna     03/12/99  created
* epozna    08/01/02  VLTSW20010691 - vlti binary table handling
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

#include "bossINTERFACE_TCS_BASE.h"


class bossINTERFACE_VLTI : public bossINTERFACE_TCS_BASE
{
public:
    // constructor/destructor
    bossINTERFACE_VLTI(const dbSYMADDRESS dbPoint, char *   srvId);
    virtual ~bossINTERFACE_VLTI();
        
    // Method calls at the start and at end of the exposure.

    virtual ccsCOMPL_STAT ExpStart(vltINT32 expoId,const char *filename,
				   char *); 
    virtual ccsCOMPL_STAT ExpEnd  (vltINT32 expoId,const char *detId,
				   const char *filename,const char *);

    // Get the status FITS file produced by sub-system (if any)
    virtual char          *GetStatusFits(vltINT32   expoId,
					 const char *detId,
					 const char *filename);
    virtual char *         InsType();

    virtual ccsCOMPL_STAT GetBtblFiles(vltINT32         expoId, 
				       char            *detId,
				       vltINT32        *noOfBtblFiles,
				       slxSTRING_LIST  *btblFileList  ) ;

    // overload abstract function
    virtual  ccsCOMPL_STAT     CheckTelescopValue(char *telId);
protected:
   

private:
    // Declaration of copy constructor and assignment operator as private
    // methods, in order to hide them from the users.
    bossINTERFACE_VLTI& operator=(const bossINTERFACE_VLTI&);
    bossINTERFACE_VLTI (const bossINTERFACE_VLTI&);
    
};


#endif /*!bossINTERFACE_VLTI_H*/
