#ifndef bossSERVER_H
#define bossSERVER_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: bossSERVER.h,v 1.153 2005/08/23 16:46:42 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* gzins     09/10/98  created
* epozna    04/04/00  updated to BOSS
* epozna    14/06/00  added function : CheckDiskPlace()
* epozna    14/06/00  added functions: InsModeCB()
*                                      SetCurrExpoMode()
* epozna    26/06/00  added functions: GetParameterDetId()
*                                      VersionCB()
*                                      Set/GetOsName
*                     removed: ExpEndCB(), ExpStartCB(), ExpEndPreProc(),
*                              ExpStartPreProc(), ExpStartPostProc(), 
*                              ExpEndPostProc()
* epozna     06/07/00  added prot var : insConId_                      
*                      added function : ParseAppOptions (from xxo)
*                                       functions to set/get version and modul 
*                                       tcsExpStart() , icsExpStart(),
*                                       SetNewDataFileDb
* epozna   23/04/01    added functions : Standby-,Online-,OffPostProc()
*                                        StartPreProcMain(),StartPreProcSpecial()
* epozna   29/05/01    added Exposure Cancel functions 
* - - - - -- - - - - - - - Mar2002 - - - - - - - - - - - - - - - - -
* epozna   25/03/02    VLTSW20020180: added SetupPostProc 
* - - - - -- - - - - - - - Apr2002 - - - - - - - - - - - - - - - - -
* epozna   25/03/02    VLTSW20020505 Standard naming
* epozna   7/Jan/04    VLTSW20030388 added ApplImageHandleProc
* - - - - - - - - - - - -  APR2004 - - - - - - - - - - - - - - - - - 
* epozna   1/07/04     VLTSW20040155 CheckTcsOnLine 
*/


/************************************************************************
 *
 *----------------------------------------------------------------------
 */



#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif
/*
 * VLT Software
 */
#include "evhHANDLER.h"
#include "oslx.h"
/*
 * Local Headers 
 */
//#include "ixacAPP_CONFIG.h"

#include "ctooCONFIG.h"
#include "bossINS_MODES.h"
#include "bossINTERFACE_LIST.h"
#include "bossINTERFACE_DCS.h"
#include "bossINTERFACE_ARCH.h"
#include "bossEXPOSURE.h"
#include "bossEXPOSTATE_HANDLE.h"
#include "bossArchErrHndl.h"

//#include "bossFITS_HEADER.h"
#include "ixacTIMER_LOGS.h"
#include "ixacCMD_PARAM.h"
#include "ixacKEY_DB_MAP.h"
#include "ixacKEYW_HANDLER.h"
#include "bossWaitCmdHandler.h"
#include "bossARF_MGR.h"
#include "bossINTERFACE.h"


class bossSERVER : public ixacTASK 
{
public:

    // constructors
    bossSERVER(const dbSYMADDRESS dbPoint,  char * insId,
	       char * dict=NULL,            char * alias =NULL, 
	       char * keydbmap =NULL );
    bossSERVER::bossSERVER(ctooCONFIG *cfg);
    bossSERVER::bossSERVER(char* insConId);
       
    // destructor
    virtual ~bossSERVER();
    
    // Initialisation
    virtual ccsCOMPL_STAT PrimarySetting();
    virtual ccsCOMPL_STAT Init();  
    virtual ccsCOMPL_STAT LoadDictionaries(char *dictionary, char *alias, 
					   char *instrumentId, char *keyDbMap);
    virtual ccsCOMPL_STAT LoadXDictAndXAli();
    
    virtual ccsCOMPL_STAT InitMain();
    virtual ccsCOMPL_STAT InitLogLevel();

    //interface handling functions
    virtual ccsCOMPL_STAT SubsystemInterfaces();
    virtual ccsCOMPL_STAT SubsystemInterfacesCheck();
    virtual ccsCOMPL_STAT CreateInterface(int i,char* subsname,char* category, 
					  char* substype,char* ifdbroot);
    // optional function to be overloaded
    virtual ccsCOMPL_STAT InitPostProc();
    
    
    
    // Server configuration
    virtual ccsCOMPL_STAT Configure(char *instrumentId=NULL);
    virtual ccsCOMPL_STAT AppConfigure(ctooCONFIG *appConfig);
    
    virtual ccsCOMPL_STAT SetMaintenanceMode(vltLOGICAL newValue);
    virtual vltLOGICAL    IsMaintenanceModeActivated();
    
    virtual ccsCOMPL_STAT SetAlignState(vltLOGICAL newValue);
    virtual vltLOGICAL    IsAlignedState();
    virtual ccsCOMPL_STAT SetDataBaseEvtCB(evtEVENT * eventPtr,
					   evhOBJ_CALLBACK &callback);
    
    // Checks if execution of command is allowed 
    virtual ccsCOMPL_STAT CheckStates (const char *command);


    // Handle exposure Id
    virtual ccsCOMPL_STAT NewExpoId(vltINT32 *expoId);
    virtual ccsCOMPL_STAT GetCurrExpoId(vltINT32 *expoId);
    virtual ccsCOMPL_STAT CheckExpoId(msgMESSAGE &msg, vltINT32 *expoId);
    
    // Check exposure status
    virtual ccsCOMPL_STAT CheckExpoStatus(const char *command, 
					  vltINT32 expoId,char * detId=NULL);
    static ccsCOMPL_STAT  CheckExpoStatus(const char *command, 
					  vltUINT32 expoStatus);
    
    
    
    // Handle observation status
    virtual ccsCOMPL_STAT UpdateObsStatus();
    virtual vltUINT32     GetObsStatus();
   
    
    // Retreives status of the functions
    virtual ccsCOMPL_STAT GetStatus(ixacKEYW_CMD_PARAM &statusCmd,
				    vltLOGICAL allFunctions);
    
    // Callbacks for commands
    virtual evhCB_COMPL_STAT AbortCB   (msgMESSAGE &msg, void *userData);
    virtual evhCB_COMPL_STAT AddFitsCB (msgMESSAGE &msg, void *userData);
    virtual evhCB_COMPL_STAT CommentCB (msgMESSAGE &msg, void *userData);
    virtual evhCB_COMPL_STAT ContCB    (msgMESSAGE &msg, void *userData);
    virtual evhCB_COMPL_STAT EndCB     (msgMESSAGE &msg, void *userData);
    virtual evhCB_COMPL_STAT ExitCB    (msgMESSAGE &msg, void *userData);
    //virtual evhCB_COMPL_STAT ExpEndCB  (msgMESSAGE &msg, void *userData);
    //virtual evhCB_COMPL_STAT ExpStartCB(msgMESSAGE &msg, void *userData);
    virtual evhCB_COMPL_STAT ForwardCB (msgMESSAGE &msg, void *userData);
    virtual evhCB_COMPL_STAT OffCB     (msgMESSAGE &msg, void *userData);
    virtual evhCB_COMPL_STAT OnlineCB  (msgMESSAGE &msg, void *userData);
    virtual evhCB_COMPL_STAT PauseCB   (msgMESSAGE &msg, void *userData);
    virtual evhCB_COMPL_STAT SelftstCB (msgMESSAGE &msg, void *userData);
    virtual evhCB_COMPL_STAT SetModeCB (msgMESSAGE &msg, void *userData);
    virtual evhCB_COMPL_STAT SetupCB   (msgMESSAGE &msg, void *userData);
    virtual evhCB_COMPL_STAT StandbyCB (msgMESSAGE &msg, void *userData);
    virtual evhCB_COMPL_STAT StartCB   (msgMESSAGE &msg, void *userData);
    virtual evhCB_COMPL_STAT StateCB   (msgMESSAGE &msg, void *userData);
    virtual evhCB_COMPL_STAT StatusCB  (msgMESSAGE &msg, void *userData);
    virtual evhCB_COMPL_STAT StopCB    (msgMESSAGE &msg, void *userData);
    virtual evhCB_COMPL_STAT TestCB    (msgMESSAGE &msg, void *userData);
    virtual evhCB_COMPL_STAT WaitCB    (msgMESSAGE &msg, void *userData);
    
    virtual ccsCOMPL_STAT    RepeatExposure (msgMESSAGE &msg,vltINT32 expoId, void *userData);
    
    // callback for internal commands
    virtual evhCB_COMPL_STAT GetHdrCB  (msgMESSAGE &msg, void *userData);
    virtual evhCB_COMPL_STAT CleanCB   (msgMESSAGE &msg, void *userData);
    virtual evhCB_COMPL_STAT ExpendCB  (msgMESSAGE &msg, void*userData);
    virtual evhCB_COMPL_STAT ExpStartCB(msgMESSAGE &msg, void*userData);
    
    static ccsCOMPL_STAT     ResetDetSubsystem(vltINT32 expoId, char *detId,void * info,
					       bossINTERFACE_DCS* subsystem, ccsERROR *error);
    static ccsCOMPL_STAT     CheckStatusOfDetector(vltINT32 expoId, char *detId,void *command,
						   bossINTERFACE_DCS* subsystem, ccsERROR *error);
    ccsCOMPL_STAT RunFunctionOnDetectors(char * detectors, vltINT32 expoId,void * info,
					 ccsCOMPL_STAT (* func)(vltINT32,char*,void*,
								bossINTERFACE_DCS*,ccsERROR* ));
    
    // functions for cancelling exposure(s) with END cmd 
    ccsCOMPL_STAT Cancel(msgMESSAGE &msg,vltINT32 expoId); 
    ccsCOMPL_STAT EndAllExposures(vltINT32 expoId);
    ccsCOMPL_STAT CancelAllExposures();
    static ccsCOMPL_STAT EndDetSubsystem(bossINTERFACE* subSystemPtr, vltINT32 expoId,
					 void *,void *, void *, ccsERROR *error);
    static ccsCOMPL_STAT CancelDetSubsystem(bossINTERFACE* subSystemPtr, vltINT32 expoId,
					    void *,void *, void *, ccsERROR *error);

    // Pre-processing functions for commands    
    virtual ccsCOMPL_STAT SetupPreProc    (msgMESSAGE &msg, vltINT32 expoId,
					   void *userData);
    virtual ccsCOMPL_STAT ContPreProc    (msgMESSAGE &msg, vltINT32 expoId,
					  void *userData);
    virtual ccsCOMPL_STAT EndPreProc     (msgMESSAGE &msg, vltINT32 expoId,
					  void *userData);
    virtual ccsCOMPL_STAT OffPreProc     (msgMESSAGE &msg, void *userData);
    virtual ccsCOMPL_STAT OnlinePreProc  (msgMESSAGE &msg, void *userData);
    virtual ccsCOMPL_STAT PausePreProc   (msgMESSAGE &msg, vltINT32 expoId,
					  void *userData);
    virtual ccsCOMPL_STAT SelftstPreProc (msgMESSAGE &msg, void *userData);
    virtual ccsCOMPL_STAT StandbyPreProc (msgMESSAGE &msg, void *userData);
    virtual ccsCOMPL_STAT TestPreProc    (msgMESSAGE &msg, void *userData);
    
    //pre-processing functions for command START
    virtual ccsCOMPL_STAT StartPreProcMain    (msgMESSAGE &msg, vltINT32 expoId,
					       void *userData); 
    virtual ccsCOMPL_STAT StartPreProc        (msgMESSAGE &msg, vltINT32 expoId,
					       void *userData);
    virtual ccsCOMPL_STAT StartPreProcSpecial (msgMESSAGE &msg, vltINT32 expoId,
					       void *userData);
    
    
    // Post-processing functions for commands  
    virtual ccsCOMPL_STAT SetupPostProc    (msgMESSAGE &msg, vltINT32 expoId,
					    void *userData);
    virtual ccsCOMPL_STAT AbortPostProc    (msgMESSAGE &msg, vltINT32 expoId,
					    void *userData);
    virtual ccsCOMPL_STAT ContPostProc     (msgMESSAGE &msg, vltINT32 expoId,
					    void *userData);
    virtual ccsCOMPL_STAT EndPostProc      (msgMESSAGE &msg, vltINT32 expoId,
					    void *userData);
    virtual ccsCOMPL_STAT PausePostProc    (msgMESSAGE &msg, vltINT32 expoId,
					    void *userData);
    virtual ccsCOMPL_STAT StartPostProc    (msgMESSAGE &msg, vltINT32 expoId,
					    void *userData);
    virtual ccsCOMPL_STAT StateCmdPostProc (msgMESSAGE &msg, void *userData);
    virtual ccsCOMPL_STAT OnlinePostProc   (msgMESSAGE &msg);
    virtual ccsCOMPL_STAT StandbyPostProc  (msgMESSAGE &msg);
    virtual ccsCOMPL_STAT OffPostProc      (msgMESSAGE &msg);
    
    // Functions to process command
    virtual ccsCOMPL_STAT ExpoCtrlCmdProc  (msgMESSAGE &msg, vltINT32 expoId,
					    void *userData);
    virtual void ExpoCmdErrorProc(msgMESSAGE &msg, vltLOGICAL resetSubState );
    virtual ccsCOMPL_STAT StateCtrlCmdProc (msgMESSAGE &msg, void *userData);
    virtual ccsCOMPL_STAT TestCtrlCmdProc  (msgMESSAGE &msg, void *userData);
    
    // Functions to handle the start/end of exposure
    virtual ccsCOMPL_STAT ExpStart(char* filename, vltINT32 expoId);
    virtual ccsCOMPL_STAT ExpEnd(vltINT32 expoId,char* detId);
    virtual ccsCOMPL_STAT ExpEnd  (char* filename, vltINT32 expoId,char* detId);
    
    // Functions to manipulate <subSystem> parameter
    virtual vltLOGICAL    HasDestSubSystem(ixacCMD_PARAM &cmd);
    virtual ccsCOMPL_STAT GetDestSubSystem(ixacCMD_PARAM &cmd, 
					   bossINTERFACE **subSystemPtr,
					   vltLOGICAL    *lastDestProc);
    
    // Callbacks for command replies
    virtual evhCB_COMPL_STAT SetupSyncReplyCB (msgMESSAGE &msg, void *userData);
    virtual ccsCOMPL_STAT SetupResetSubsyst(msgMESSAGE &msg, vltINT32 expoId);
    virtual evhCB_COMPL_STAT StateCtrlSyncReplyCB (msgMESSAGE &msg,
						   void *userData);
    virtual evhCB_COMPL_STAT TestCtrlSyncReplyCB (msgMESSAGE &msg,
						  void *userData);
    

    // Callbacks for keyword events
    virtual evhCB_COMPL_STAT SetLogLevelCB
    (const msgCMD command, const oslxKEYW_FILTER &keywordFilter,
     oslxSHORT_FITS &keywordList, void *);
    
    virtual evhCB_COMPL_STAT SetVerboseLevelCB
    (const msgCMD command, const oslxKEYW_FILTER &keywordFilter,
     oslxSHORT_FITS &keywordList, void *);
    
    virtual evhCB_COMPL_STAT SetActionLevelCB
    (const msgCMD command, const oslxKEYW_FILTER &keywordFilter,
     oslxSHORT_FITS &keywordList, void *);
    
    virtual evhCB_COMPL_STAT SetTimerLevelCB
    (const msgCMD command, const oslxKEYW_FILTER &keywordFilter,
     oslxSHORT_FITS &keywordList, void *);
    
    // Callbacks for database events
    virtual evhCB_COMPL_STAT ExpoStatusEvtCB(evtEVENT_MSG &msg, void *);
    virtual evhCB_COMPL_STAT NewDataFileEvtCB(evtEVENT_MSG &msg, void *);
    virtual evhCB_COMPL_STAT StateEvtCB(evtEVENT_MSG &msg, void *);
    virtual evhCB_COMPL_STAT OsNewDataEvtCB(evtEVENT_MSG &msg, 
					    void *userData);
    virtual evhCB_COMPL_STAT OsExpoStatusEvtAction(vltINT32   expoId,
						   char      *detId ,
						   vltUINT32  newExpoStatus);
    virtual evhCB_COMPL_STAT InvalidExpEvtCB(evtEVENT_MSG &msg,
					     void *userData);
    
    virtual evhCB_COMPL_STAT ArchiverEvtCB(evtEVENT_MSG &msg,
					   void *userData);
    //
    static ccsCOMPL_STAT IsBusy(bossINTERFACE* subSystemPtr,
				vltINT32 expoId,void * iswait,
				void *, void * , ccsERROR *error);
    
    // Sends stop cmd when exposure is aborted
    static ccsCOMPL_STAT SendStop(bossINTERFACE* subSystemPtr,
				  vltINT32 expoId,void * ,
				  void *, void * , ccsERROR *error);

    // Pre-processing functions for DB events
    virtual ccsCOMPL_STAT ExpoStatusEvtPreProc(evtEVENT_MSG &msg, 
					       vltINT32 expoId,
					       void *userData);
    virtual ccsCOMPL_STAT NewDataFileEvtPreProc(evtEVENT_MSG &msg, 
						vltINT32 expoId,
						void *userData);
    virtual ccsCOMPL_STAT OsNewDataEvtPreProc(evtEVENT_MSG &msg, 
					      vltINT32  expoId, 
					      char *    osName ,
					      char *    osNewDataFileName, 
					      void *    userData) ;
    
    // Prepare arf file  for archiver process
    virtual ccsCOMPL_STAT ArchiveImage(vltINT32 expoId);
    virtual ccsCOMPL_STAT ApplImageHandleProc(vltINT32 expoId, 
					      char * filename, 
					      bossARF_MGR* arfMgr);
    virtual ccsCOMPL_STAT CheckArchiverProcess();
    virtual ccsCOMPL_STAT MergePrimHeader(bossINTERFACE_DCS *detSubsystem,
					  bossARF_MGR* arfMgr, 
					  vltINT32 expoId,char* detId);
    virtual ccsCOMPL_STAT GetMosaicMainFile(bossINTERFACE_DCS *detSubsystem,
					    vltINT32 expoId, vltINT32 *fileNum );
    virtual ccsCOMPL_STAT MergeMosaicFiles(bossINTERFACE_DCS *detSubsystem,
					   bossARF_MGR* arfMgr,vltINT32 expoId);
    virtual ccsCOMPL_STAT MergeMosaicFileNum(vltINT32 fileNum,
					     bossINTERFACE_DCS *detSubsystem,
					     bossARF_MGR* arfMgr);

    // Add sub-system to the list of 'slave' sub-systems
    virtual ccsCOMPL_STAT AddSubSystem (bossINTERFACE *subSystemPtr);
    
    // Get pointer to the list of 'slave' sub-systems
    virtual bossINTERFACE_LIST *GetSubSystemList();
    
    virtual ccsCOMPL_STAT CheckDiskPlace(vltINT32 expoMode,
					 vltINT32 *nbOfBlocks);
  
    //  virtual evhCB_COMPL_STAT InsModeCB (const msgCMD, const oslxKEYW_FILTER &, 
    //                      oslxSHORT_FITS &keywordList, void *);
  
    virtual ccsCOMPL_STAT  GetAndDeleteParameterDetId(msgMESSAGE &msg, 
						      char * detId );
    virtual ccsCOMPL_STAT  GetDetIdParameter(msgMESSAGE &msg, char * detId); 
    virtual ccsCOMPL_STAT  GetDetIdParameter(msgMESSAGE &msg, 
					     char * detId,int *expoId ); 
    virtual ccsCOMPL_STAT  GetExpoIdParameter(msgMESSAGE &msg, 
					      int * expoId );
    virtual ccsCOMPL_STAT  DeclareWaitCmdParam(msgMESSAGE &msg, 
					       char* detId,
					       vltINT32 *expoId,
					       char* cond);
    virtual evhCB_COMPL_STAT VersionCB(msgMESSAGE &msg,void *);

    //Functions for command ACCESS 
    virtual evhCB_COMPL_STAT AccessCB(msgMESSAGE &msg,void *);
    ccsCOMPL_STAT            AccessResetStateSubstate();
    evhCB_COMPL_STAT         AccessError(msgMESSAGE &msg);

    // Functions to set/get the name and version of the specific OS application 
    virtual void        SetModulVersion(char * appPrefix, char * appVersion);
    virtual void        SetOsName(char*);
    virtual void        SetOsNameFromVersion(char* version);
    virtual char *      GetOsName();    
    virtual char *      GetOsVersion();
    
    // Handling application command-line options
    virtual ccsCOMPL_STAT ParseAppOptions(vltINT32 argc, vltINT8 *argv[],
					  vltINT32 *optind);
    
    
    //Prepare for exposure during command START
    virtual ccsCOMPL_STAT StartPrepareExposure(msgMESSAGE &msg,vltINT32 expoId, char * detId );
    virtual ccsCOMPL_STAT PrepareExposure(vltINT32 expoId, char * detId);
    virtual ccsCOMPL_STAT SetNewFileName(vltINT32 expoId, char * detId );
    
    // Setup supplementary functions to handle parameter 'noExposure'
    ccsCOMPL_STAT CheckNoExposure(msgMESSAGE &msg,vltLOGICAL &noexposure);
    ccsCOMPL_STAT NoExposureAction(msgMESSAGE &msg,void * userdata);
    
    //setup supplememtary functions to handle errors
    evhCB_COMPL_STAT SetupErrorNoDelete(vltUINT32 subState,msgMESSAGE &msg);
    evhCB_COMPL_STAT SetupReturnError(vltINT32 expoId,  char* status,vltUINT32 subState,
				      msgMESSAGE &msg);
    evhCB_COMPL_STAT SetupReturnErrorSimple();
   

    // tcs and ics expstart function
    virtual ccsCOMPL_STAT tcsExpStart(vltINT32 expoId,char *osId=NULL);
    virtual ccsCOMPL_STAT icsExpStart(vltINT32 expoId);
    virtual ccsCOMPL_STAT osExpStart(vltINT32 expoId);
    
    virtual ccsCOMPL_STAT AddExpstartFlag(vltINT32 expoId,char * flag);
    virtual ccsCOMPL_STAT DeleteExpstartFlag(vltINT32 expoId,char * flag);
    virtual ccsCOMPL_STAT AuxImageDataPrepared(vltINT32 expoId);
   

    virtual ccsCOMPL_STAT IsImageRequired(vltINT32 expoId, char* detId,
					  vltLOGICAL &isImage);
    
    virtual ccsCOMPL_STAT Synchronise(vltINT32 expoId, 
				      ExpAction action,ExpActionState state);
    // function for merging files created during an exposure
    virtual ccsCOMPL_STAT MergeHeaderImage(vltINT32 expoId,char * detId);
    virtual ccsCOMPL_STAT MergeHeaderFiles(char* filename, vltINT32 expoId);
    virtual ccsCOMPL_STAT CheckCompletition(vltINT32 expoId); 
    virtual ccsCOMPL_STAT CreateBtblFile(vltINT32 expoId,char* btblFileName);
    
    // declare obligatory kw in the configfile 
    virtual void  CompulsoryKeywords(char**);
    
    // db point read write
    virtual ccsCOMPL_STAT SetNewDataFileDb(const char *newFileName);
    
    // trigger function to be executed when certain  kw found in setup 
    virtual evhCB_COMPL_STAT HandleSetupKeywords(const msgCMD,  
						 const oslxKEYW_FILTER &, 
						 oslxSHORT_FITS &keywordList, 
						 void *expoId);
    virtual ccsCOMPL_STAT SetupImageName(vltINT32 expoId,char * keyword, char* fname); 
    virtual ccsCOMPL_STAT SetupImageTypeAllDet(int type,char *value);
    virtual ccsCOMPL_STAT SetupImageTypeDet(int type,char * servId, char* type);

    virtual ccsCOMPL_STAT SetupImageNaming(bossINTERFACE * subsystem,char *naming);
    virtual ccsCOMPL_STAT SetupImageExt(bossINTERFACE * subsystem,char *naming);
    virtual ccsCOMPL_STAT SetupArchMode(char * servId, char* arcMode);

    // add to header the TPL OBS DPR OCS keywords
    virtual ccsCOMPL_STAT AddExtractedSetupKeywordsToFitsHeader(vltINT32 expoId);
    
    //
    virtual ccsCOMPL_STAT CheckDetId(vltINT32 expoId,char *detId);
    virtual ccsCOMPL_STAT CheckSubsystemList(vltINT32 expoId);
    
    // wait 
    static ccsCOMPL_STAT   WaitProcess(bossINTERFACE* subSystemPtr,
				       vltINT32 expoId,void * detectors,
				       void *msg, void *cmd, 
				       ccsERROR *error);
    
    
    // exposure handling
    virtual void  SetExposureDeleteFlag (vltLOGICAL expDelFlag );
    virtual void  DeleteExposure (vltINT32 expoId );
    virtual void  DeleteResetExposure (msgMESSAGE &msg,vltINT32 expoId );
    
    // SOS functions 
    ccsCOMPL_STAT SetOSPrefixes();
    virtual ccsCOMPL_STAT GetOsHeaders(char * filename, vltINT32 expoId, 
				       char *osname );
    virtual ccsCOMPL_STAT MergeOsFiles(char * filename, vltINT32 expoId,char * osname);
    static  vltLOGICAL    IsExist(slxFILENAME filename);
    virtual ccsCOMPL_STAT CopyInsFile(char *origFileName ,char *newFileName);
    virtual ccsCOMPL_STAT CopyFile(char *origFileName ,char *newFileName);
    
    ccsCOMPL_STAT  RunFunctionOnOSes(vltINT32 expoId,void *info1,void *info2,void *info3,
				     ccsCOMPL_STAT (* func)
				     (bossINTERFACE*,vltINT32,void*,void *,void *,
				      ccsERROR*));
    
    ccsCOMPL_STAT  RunFunctionOnSubsystems(vltUINT32 category,vltINT32 expoId,
					   void *info1,void *info2,void *info3,
					   ccsCOMPL_STAT (* func)
					   (bossINTERFACE*, vltINT32,
					    void*, void *,void * ,ccsERROR*));
    ccsCOMPL_STAT  RunFunctionOnICSes(vltINT32 expoId,
				      void *info1,void *info2,void *info3,
				      ccsCOMPL_STAT (* func)
				      (bossINTERFACE*, vltINT32,
				       void*, void *,void * ,ccsERROR*));
    ccsCOMPL_STAT  RunFunctionOnTCS(vltINT32 expoId,
				    void *info1,void *info2,void *info3,
				    ccsCOMPL_STAT (* func)
				    (bossINTERFACE*, vltINT32,
				     void*, void *,void * ,ccsERROR*));
    ccsCOMPL_STAT  RunFunctionOnDCSes(vltINT32 expoId,
				      void *info1,void *info2,void *info3,
				      ccsCOMPL_STAT (* func)
				      (bossINTERFACE*, vltINT32,
				       void*, void *,void * ,ccsERROR*));
    
    virtual ccsCOMPL_STAT RemoveUserFiles(char* filename,bossARF_MGR * arfMgr);
    virtual ccsCOMPL_STAT AddUserFiles   (char* filename,bossARF_MGR * arfMgr);
    virtual void          GetSosUserFiles(char* filename, char** userfiles);
    virtual void          GetListOfOsCreatingHdr(vltINT32 expoId, char* osList);
    static  vltLOGICAL    IsSubystOnList( char *subsyst,char* subsystList);
    
    
    // static functions called to run on more subsystems
    static ccsCOMPL_STAT ArfAddHdrs(  bossINTERFACE* subSystemPtr,vltINT32 expoId,
				      void * arfMgr,void * filename,void *osname,
				      ccsERROR *error);
    
    static ccsCOMPL_STAT ArfRemoveHdrs(bossINTERFACE* subSystemPtr,vltINT32 expoId,
				       void * arfMgr,void *filename,void *osname,
				       ccsERROR *error);
    
    static ccsCOMPL_STAT SosExposureEndProcess(bossINTERFACE* subSystemPtr,
					       vltINT32 expoId,void * filename,
					       void *osname, void * osList, ccsERROR *error);
    
    static ccsCOMPL_STAT ExposureEndProcess(bossINTERFACE* subSystemPtr,
					    vltINT32 expoId,void * filename,
					    void *path, void * , ccsERROR *error);
    
/*
  static ccsCOMPL_STAT MergeSubsystHeaders(bossINTERFACE* subSystemPtr,
  vltINT32 expoId,void *detSubsystem ,
  void * filename, void * , ccsERROR *error);
  
*/

    static ccsCOMPL_STAT MergeSubsystemHeaders(bossINTERFACE* subSystemPtr,
					       vltINT32 expoId,void *detName ,
					       void *filename , void *arfMgr , 
					       ccsERROR *error);
    
    
    static ccsCOMPL_STAT MergeTCSBtbl(bossINTERFACE* subSystemPtr,
				      vltINT32 expoId,void *detName ,
				      void *filename , void *arfMgr , 
				      ccsERROR *error);
    
    static ccsCOMPL_STAT RemoveSubsystemHeaders(bossINTERFACE* subSystemPtr,
						vltINT32 expoId,void *detName ,
						void *filename , void *arfMgr , 
						ccsERROR *error);
    
    static ccsCOMPL_STAT ExposureStartProcess(bossINTERFACE* subSystemPtr,
					      vltINT32 expoId,void * hdrFileName,
					      void *path, void * ,
					      ccsERROR *error);
    
    static ccsCOMPL_STAT LoadTcsHeader(bossINTERFACE* subSystemPtr,vltINT32 expoId,
				       void * filename,void * hdr,void * , 
				       ccsERROR *error);  
    
    static ccsCOMPL_STAT LoadIcsHeader(bossINTERFACE* subSystemPtr,vltINT32 expoId,
				       void * filename,void * hdr,void * , 
				       ccsERROR *error);
    
    static ccsCOMPL_STAT DeleteStatusFitsFile(bossINTERFACE* subSystemPtr,
					      vltINT32 ,void * filename,void *, 
					      void *, ccsERROR *error);
    
    static ccsCOMPL_STAT InitDetectors(bossINTERFACE* subSystemPtr,vltINT32 ,
				       void *dictionaryPtr ,
				       void *waitCmdHandlerPtr, 
				       void *keyDbMap, ccsERROR *error);
    
    static ccsCOMPL_STAT Clean(bossINTERFACE* subSystemPtr,
			       vltINT32 expoId,void *, void *,void *,
			       ccsERROR *error);
    
    
    static ccsCOMPL_STAT GetFileName(bossINTERFACE* subSystemPtr,
				     vltINT32 expoId,void * filenames,
				     void *, void * , ccsERROR *error);
    
    
    static ccsCOMPL_STAT SendCommand(bossINTERFACE* subSystemPtr,
				     vltINT32 expoId,void * command,
				     void *parameters, void * ,
				     ccsERROR *error);

    static ccsCOMPL_STAT CheckSubSystState(bossINTERFACE* subSystemPtr,
					   vltINT32 expoId,void* reqState,
					   void *, void * ,ccsERROR *error);

    // support function to add TELESCOP keyword
    virtual ccsCOMPL_STAT AddTelescopKwToFitsHdr(vltINT32 expoId,
						 bossINTERFACE_DCS * dcsSubSystemPtr);
    
    // VLTSW20040155 support function to check  TCS state
    virtual ccsCOMPL_STAT CheckTcsOnLine();

    // Check SOS
    ccsCOMPL_STAT CheckSOS();
    virtual       vltLOGICAL isSOS();
    vltLOGICAL    IsMsgSenderOS(msgMESSAGE &msg);
    
    // Inform VOLAC
    void Archive(vltLOGICAL isArchive);
    vltLOGICAL isArchive();
    
    // general func
    static ccsCOMPL_STAT  GetCompleteFileName(char *filename, 
					      slxFILENAME *completeName, ccsERROR *error);
    
    //Check if instrument is a VLTI ins
    static vltLOGICAL isVLTI();
    
    // restrict or allow execution of setups
    void AllowSetupWhileExpRunning(vltLOGICAL isAllowed);

    //Delegated functions (for back compatibility)
    virtual ccsCOMPL_STAT GetState(vltINT32 *state);
    virtual ccsCOMPL_STAT GetStateName(const char **stateName);

    virtual ccsCOMPL_STAT GetSubState(vltINT32 *subState);
    virtual ccsCOMPL_STAT GetSubStateUI(vltUINT32 *subState);
    virtual ccsCOMPL_STAT GetSubStateName(const char **subStateName);

    virtual ccsCOMPL_STAT SetState(vltINT32 state);
    virtual ccsCOMPL_STAT SetSubState(vltINT32 subState);
    virtual ccsCOMPL_STAT SetSubStateUI(vltUINT32 subState);
    virtual ccsCOMPL_STAT UpdateSubState(vltUINT32 obsStatus);

    virtual ccsCOMPL_STAT SetOsState     (vltINT32 subState);
    virtual ccsCOMPL_STAT SetStates      (vltINT32 state, 
					  vltINT32 subState);
    virtual ccsCOMPL_STAT StateNo2Str    (const vltINT32 state,
					  const char **stateName);
    virtual ccsCOMPL_STAT StateStr2No    (const char *stateName,
					  vltINT32 *state);
    virtual ccsCOMPL_STAT SubStateNo2Str (const vltINT32 subState,
					  const char **subStateName);
    virtual ccsCOMPL_STAT SosInfo        (char * filename, 
					  vltINT32 expoId, 
					  char*info );
    
protected:
    ccsCOMPL_STAT AddStaticKeywordsToFitsHeader(bossFITS_HEADER *hdrptr);
    ccsCOMPL_STAT SendReply(msgMESSAGE &msg, 
			    vltLOGICAL lastReply = ccsTRUE);
    //support functions
    
    ccsCOMPL_STAT RetrieveFitsDataFromCfg();
    void          ExposureFailedAction(vltINT32 expoId,
				       vltLOGICAL display,ccsLOC_ID locId);
    
    // data
    oslxALIAS          *aliasPtr;
    oslxDICTIONARY     *dictionaryPtr;
    ctooCONFIG         *appConfigPtr;     // vltSW20010007 ixacAPP_CONFIG
    bossINS_MODES      *insModesPtr;
    
    //bossFITS_HEADER    *fitsStatusPtr;
    bossEXPOSURE       *exposurePtr; 

    bossWaitCmdHandler  *waitCmdHandlerPtr;
    
    oslxSETUP          *setupPtr;
    
    ixacTIMER_LOGS     timerLog;
    
    ixacKEY_DB_MAP     keyDbMap;
    
    ixacKEYW_HANDLER   *keywHandlerPtr;  /* Keyword trigger handler */
    
    // List of sub-systems which are under control of Instrument Server
    bossINTERFACE_LIST subSystemList;
    
    // Interface with the archiver process
    bossINTERFACE_ARCH *archivePtr_;
    
    // Application configuration data
    vltBYTES64         insConId_;     
    vltBYTES64         keyDbMap_; 
    vltBYTES64         alias_; 
    vltBYTES64         dictionary_;
  
    // Application specific OS name and version
    vltBYTES32         osName_; 
    vltBYTES256        osVersion_;    
    
    // Instrument info (as specified in cfg)
    slxKEYW_LINE      release_; 
    slxKEYW_LINE      origin_; 

    // control flags
    vltLOGICAL         exposureDeleteFlag_;
    vltLOGICAL         isSOS_;
    vltLOGICAL         isArchive_;
    
    // is setup allowed while exp is running
    vltLOGICAL          allowSetupWhileRunning_;

    dbSYMADDRESS       dbRef;

    ccsERROR           osErrorStack;

private:
    // error handling for setup 
    ccsCOMPL_STAT SetupErrorReply(msgMESSAGE &msg); 

    //support function for retrieving data from cfg file
    ccsCOMPL_STAT GetCfgKeyword(char * kwname,char *kwvalue);

    // private empty assignment and copy 
    bossSERVER& operator=(const bossSERVER&);
    bossSERVER (const bossSERVER&);

    // Application configuration filename
    slxFILENAME        instrumentIdName;

    // this is for the automati interface generation
    bossINTERFACE   *interfaces[bossMAX_SUBSYST];
    
    
    // For the communication between the main and archiver process (VLTSW20030312)
    evtEVENT        evtArchiver_;
    evtEVENT        evtArchFailed_; 
    bossArchErrHndl archErrHandle_;
    
    // Invalid exposure event (SOS)
    evtEVENT        evtInvalidExp_;
    //evtEVENT        *eventPtr;
    
    //setup noExposure flag
    vltLOGICAL noExposure;

    //VLTSW20030249
    vltINT32 loglevel_;
};

#include "bossSERVER.icc"
#endif /*!bossSERVER_H*/
