#ifndef bossStates_H
#define bossStates_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: bossStates.h,v 1.153 2005/08/23 16:46:41 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* zins      05/10/98  created
* epozna    10/10/00  added state loaded
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

#include "evhStates.h"

#define bossEXPOID_UNDEFINED  -9999 
#define bossEXPOID_NOEXPOSURE -1 

#define bossSTATE_ERROR       255
#define bossSTATE_UNKNOWN     evhSTATE_UNK
#define bossSTATE_OFF         evhSTATE_OFF
#define bossSTATE_STANDBY     evhSTATE_STANDBY
#define bossSTATE_ONLINE      evhSTATE_ONLINE
#define bossSTATE_LOADED      evhSTATE_LOADED // loaded as state also

#define bossSTATE_ERROR_STR   "ERROR"
#define bossSTATE_UNKNOWN_STR "UNKNOWN"
#define bossSTATE_OFF_STR     "OFF"
#define bossSTATE_STANDBY_STR "STANDBY"
#define bossSTATE_ONLINE_STR  "ONLINE"
#define bossSTATE_LOADED_STR  "LOADED"        // loaded as state also


#define bossSUBSTATE_ERROR           255

#define bossSUBSTATE_UNKNOWN         0
#define bossSUBSTATE_NOT_RUNNING     1
#define bossSUBSTATE_LOADED          evhSTATE_LOADED
#define bossSUBSTATE_IDLE            3
#define bossSUBSTATE_BUSY            4
#define bossSUBSTATE_SETUP           5
#define bossSUBSTATE_OBSERVING       6
#define bossSUBSTATE_PAUSED          7

//VLTSW20010724
#define  bossSUBSTATE_UI_UNKNOWN        0
#define  bossSUBSTATE_UI_NOT_RUNNING    1
#define  bossSUBSTATE_UI_LOADED         2
#define  bossSUBSTATE_UI_IDLE           4
#define  bossSUBSTATE_UI_BUSY           8
#define  bossSUBSTATE_UI_SETUP         16
#define  bossSUBSTATE_UI_OBSERVING     32
#define  bossSUBSTATE_UI_PAUSED        64
//VLTSW20010669
#define  bossSUBSTATE_UI_EXPSTART      128
#define  bossSUBSTATE_UI_EXPEND        256
#define  bossSUBSTATE_UI_MERGE         512
#define  bossSUBSTATE_UI_ERROR         1024

#define bossSUBSTATE_ERROR_STR       "ERROR"
#define bossSUBSTATE_UNKNOWN_STR     "UNKNOWN"
#define bossSUBSTATE_NOT_RUNNING_STR "NOT RUNNING"
#define bossSUBSTATE_LOADED_STR      "LOADED"
#define bossSUBSTATE_IDLE_STR        "IDLE"
#define bossSUBSTATE_BUSY_STR        "BUSY"
#define bossSUBSTATE_SETUP_STR       "SETUP"
#define bossSUBSTATE_OBSERVING_STR   "OBSERVING"
#define bossSUBSTATE_PAUSED_STR      "PAUSED"


#endif /*!bossStates_H*/
