#ifndef bossWaitCmdHandler_H
#define bossWaitCmdHandler_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: bossWaitCmdHandler.h,v 1.153 2005/08/23 16:46:42 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* epozna  29/03/01  created
* epozna  20/11/01  VLTSW20010575:added func GetParamFirstFromMsg
* - - - - - - - MAR2002 - - - - - - - - - - - - - - -- - -- - - 
* epozna  21/01/01  VLTSW20010669 GetParamHeaderFromMsg
* - - - - - - - APR 2003 - - - - - - - - - - - - - - - - - - - - 
* epozna  08/09/03 VLTSW20030350 Wait -all -cond <>
*                  WaitCond  
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

#include "eccsErr.h"
#include "evhHANDLER.h"

#include "inscExpStates.h"
#include "bossINTERFACE.h"
#include "bossINTERFACE_LIST.h"
#include "bossEXPOSURE.h"
#include "bossArchErrHndl.h"

enum WaitCond          {OBS_END=1, MERGING, HEADER }  ;
#define  COND_HEADER   "CanSetupNextObs"
#define  COND_MERGING  "CanStartNextObs"
#define  COND_OBSEND   "ObsEnd"

class  bossWaitCmdHandler: public fndOBJECT, public eccsERROR_CLASS
{
public:
 
    // construcror 
    bossWaitCmdHandler();
    
    //desructor
    virtual ~bossWaitCmdHandler();
  
    //init
    virtual ccsCOMPL_STAT  Init(bossINTERFACE_LIST *subSystemListPtr,
				bossEXPOSURE       *exposurePtr,
				bossArchErrHndl    *errHndl);

    //functions to handle wait cmd hash table
    virtual ccsCOMPL_STAT  AddWaitCmd(msgMESSAGE &msg,int currExpoId);
    virtual ccsCOMPL_STAT  RemoveWaitCmd(msgMESSAGE *msg,char *replyBuffer);
    virtual ccsCOMPL_STAT  ReleaseWaitCmds(vltINT32   expoId,char *detId,
					   vltINT32   expoStatus, 
					   vltLOGICAL checkObsStatus);
    virtual ccsCOMPL_STAT  ReleasePendingWaitCmd(vltINT32 expoId,char *detId,
						 vltINT32 expoStatus);

    //this function is not used
    virtual bossINTERFACE  *GetSubsystem(char *procName);

    // functions to specify the parameters of wait cmds
    ccsCOMPL_STAT GetParamFirstFromMsg(msgMESSAGE &msg,vltLOGICAL* first);
    ccsCOMPL_STAT GetParamCondFromMsg(msgMESSAGE &msg,WaitCond* wcond);
    
    // function for synchronisation
    ccsCOMPL_STAT  IsExpOutOfScope(vltINT32    expoId  , vltLOGICAL &isoutofscope);
    ccsCOMPL_STAT  IsExpOutOfScope(const char* detId   , vltLOGICAL &isoutofscope);
    ccsCOMPL_STAT  IsHeaderReady  (const char* detId   , vltLOGICAL &isheader);
    ccsCOMPL_STAT  IsHeaderReady  (vltINT32    expoId  , vltLOGICAL &isheader);
    ccsCOMPL_STAT  IsDetectorWait (const char *detId   ,vltINT32 waitCmdExpoId, WaitCond cond,
				   vltLOGICAL &isDetWait, char* comment);

protected:
    // supplementary functions
    ccsCOMPL_STAT GetDetIdFromMsg    (msgMESSAGE &msg,char *detId);
    ccsCOMPL_STAT GetExpoIdFromMsg   (msgMESSAGE &msg,int *expoId);
    ccsCOMPL_STAT AddExpoIdToMsg     (msgMESSAGE &msg,int expoId);
    vltLOGICAL    IsExpoIdGivenInMsg (msgMESSAGE &msg);
    ccsCOMPL_STAT SendReply(msgMESSAGE &msg, 
			    vltINT32 &expoStatus,
			    vltLOGICAL lastReply,
			    const char* detId, 
			    vltINT32 expoId); 
    
    //function to check if wait cmd can be relesed
    vltLOGICAL CheckWaitCmdExpoIdWithSubsystExpoId(
	vltINT32 waitcmdExpoId,  const char *waitCmdDetId);
    vltLOGICAL CheckHeaderReady(vltINT32 expoId, 
				const char *detId=NULL);

    // List of pending WAIT commands
    vltINT32                 noOfPendingWaitCmds_;
    ixacHASH                 waitCmdTable_;

    // pointers to system data
    bossArchErrHndl      *archErrHandlPtr;
    bossINTERFACE_LIST   *subSystemListPtr;
    bossEXPOSURE         *exposurePtr;

private:
    // Declaration of copy constructor and assignment operator as private
    // methods, in order to hide them from the users.
    bossWaitCmdHandler& operator=(const bossWaitCmdHandler&);
    bossWaitCmdHandler (const bossWaitCmdHandler&); 
  
};

#endif /*!bossWaitCmdHandler_H*/
