/*************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: ccdDatabase.h,v 4.11 2005/06/22 10:58:08 vltsccm Exp $"
*
* who          when      what
* --------     --------  ----------------------------------------------
* N.Fiebig     31/08/94  created
* A.Longinotti 24/11/94  moved to ws directory (used both by ws and lcu)
* A.Longinotti 22/05/95  updated after reordering of DB for dbLoader
* C.Cumani     10/07/95  updated after reordering of DB
*                        ccdrdtDB_CON_OPMODE deleted
*                        ccdDB_CON_RDTHWOPM deleted
*                        ccdDB_CON_SHTOPMODE deleted
*                        ccdDB_IT_STA_WS_LINE deleted
* C.Cumani     14/07/95  ccdDB_EXP_POINT definition added
*                        ccdDB_CLK_POINT definition added
* C.Cumani     17/07/95  ccdDB_SET_XFIR_WIN1 definition added
*                        ccdDB_SET_XLST_WIN1 definition added
*                        ccdDB_SET_YFIR_WIN1 definition added
*                        ccdDB_SET_YLST_WIN1 definition added
*                        ccdDB_SET_XFIR_WIN2 definition added
*                        ccdDB_SET_XLST_WIN2 definition added
*                        ccdDB_SET_YFIR_WIN2 definition added
*                        ccdDB_SET_YLST_WIN2 definition added
* C.Cumani     18/07/95  ccdDB_STA_EXPTYPE definition added
*                        ccdDB_NEX_POINT definition added
* A.Longinotti 19/07/95  changes for Data Interface Dictionary (M.Albrecht)
*                        ccdDB_SET_XLST_WIN1 replaced with ccdDB_SET_XDIM_WIN1
*                        ccdDB_SET_YLST_WIN1 replaced with ccdDB_SET_YDIM_WIN1
*                        ccdDB_SET_XLST_WIN2 replaced with ccdDB_SET_XDIM_WIN2
*                        ccdDB_SET_YLST_WIN2 replaced with ccdDB_SET_YDIM_WIN2
* C.Cumani     19/07/95  ccdrdtDB_STA_MSTA -> ccdDB_STA_MSTA
*                        ccdrdtDB_STA_CSTA -> ccdDB_STA_CSTA
*                        ccdrdtDB_STA_PERCENT -> ccdDB_STA_PERCENT
*                        ccdrdtDB_STA_GAIN -> ccdDB_STA_GAIN
*                        ccdrdtDB_STA_ADCTIME -> ccdDB_STA_ADCTIME
*                        ccdrdtDB_CON_NWIPES -> ccdDB_CON_NWIPES
*                        ccdrdtDB_CON_WINT -> ccdDB_CON_WINT
*                        ccdrdtDB_CON_WXBIN -> ccdDB_CON_WXBIN
*                        ccdrdtDB_CON_WYBIN -> ccdDB_CON_WYBIN
*                        ccdrdtDB_CON_PREFIX -> ccdDB_CON_PREFIX
*                        ccdrdtDB_STA_OUTPUT -> ccdDB_STA_ELEADU
*                        ccdrdtDB_STA_LINE -> ccdDB_STA_LINE
*                        ccdrdtDB_STA_START -> ccdDB_STA_START
*                        ccdrdtDB_STA_TIME -> ccdDB_STA_TIME
*                        ccdrdtDB_STA_REPR -> ccdDB_STA_REPR
*                        ccdDB_CON_NOUTPUTS deleted
*                        ccdDB_CON_CHIPOUT deleted
*                        ccdDB_CHP_POINT definition added
*                        ccdDB_OUT_POINT definition added
*                        ccdDB_CON_CHIPAVAIL definition added
*                        ccdDB_CON_OUTPAVAIL definition added
* C.Cumani     20/07/95  ccdDB_STA_CLOCK definition added
*                        ccdDB_STA_READPIX definition added
*                        ccdDB_STA_MPPMODE definition added
* C.Cumani     21/07/95  ccdDB_STA_OUTPUT definition added
*                        ccdDB_WIN_SUBPOINT definition added
*                        ccdDB_STA_ENAB definition added
*                        ccdDB_STA_XBIN definition added
*                        ccdDB_STA_YBIN definition added
*                        ccdDB_STA_XFIR definition added
*                        ccdDB_STA_XDIM definition added
*                        ccdDB_STA_YFIR definition added
*                        ccdDB_STA_YDIM definition added
* A.Longinotti 24/07/95  ccdDB_OBS_POINT updated to new database
*                        ccdDB_OBS_READ_SPEED --> ccdDB_OBS_READ_CLOCK
*                        ccdDB_STA_WS added
*                        ccdDB_STA_LCU added
* C.Cumani     02/08/95  ccdDB_CON_TRANSF definition added
* A.Longinotti 08/08/95  added a "." before root point attributes names
*                        ccdDB_OBS_xxx deleted. Obsolete with setup editor
* C.Cumani     08/08/95  IMPORTANT caution added
* A.Longinotti 11/08/95  ccdDB_STA_LASTEXPID definition added
* A.Longinotti 16/08/95  ccdDB_STA_SHTSTATUS definition added
* A.Longinotti 17/08/95  ccdDB_CON_FRAMETRAN definition added
*                        ccdDB_CON_SKIPPER definition added
*                        ccdDB_CON_MPP definition added
*                        ccdDB_CON_CHIPXLOC definition added
*                        ccdDB_CON_CHIPYLOC definition added
*                        ccdDB_CON_OUTPCHIP definition added
*                        ccdDB_CON_OUTPXLOC definition added
*                        ccdDB_CON_OUTPYLOC definition added
*                        ccdDB_CON_OUTPXPRE definition added
*                        ccdDB_CON_OUTPYPRE definition added
*                        ccdDB_CON_OUTPXPIX definition added
*                        ccdDB_CON_OUTPYPIX definition added
*                        ccdDB_CON_OUTPXOVE definition added
*                        ccdDB_CON_OUTPYOVE definition added
*                        ccdDB_CON_OUTFIRST definition added
*                        ccdDB_CON_NWIN definition added
*                        ccdDB_CON_ADCTIME definition added
* A.Longinotti 29/08/95  ccdDB_CON_CLOCKDES definition added
* A.Longinotti 09/09/95  ccdDB_EXP_FILEUNC definition added
* A.Longinotti 29/09/95  public attributes moved to ccdDbPublic.h
* P.Duhoux     06/02/96  added ccdDB_CON_OUTPHDIR and ccdDB_CON_OUTPVDIR
* P.Duhoux     11/04/96  added ccdDB_SET_USER_FUNC & ccdDB_SET_USER_BUFF
* P.Duhoux     19/07/96  added ccdDB_STA_SINGLEEXP
* P.Duhoux     29/08/96  added ccdDB_SET_FRMTYPE  (DET.FRAM.TYPE)
* A.Longinotti 13/12/96  added ccdDB_NEW_DATA for stand-alone mode
* P.Duhoux     21/01/97  added ccdDB_WCS_... for WorldCoord attributes
* P.Duhoux     11/02/97  moved ccdDB_WCS_RA & ccdDB_WCS_DEC to ccdDbPublic.h
*                        added macros ccdDB_WCS_XREFPIX / ccdDB_WCS_YREFPIX
* P.Duhoux     27/02/97  added macros for images:process_2
* P.Duhoux     04/03/97  Renamed point <process> into <process_1>
* P.Duhoux     02/04/97  added macro ccdMONITOR_PERIOD for TEL/TMP sampling
* P.Duhoux     16/04/97  ccdDB_CON_GAINIDX definition added
* P.Duhoux     30/06/97  added ccdDB_SET_STEPDEF, 
*                        added ccdDB_SET_LINESHIFTTYPE, ccdDB_SET_LINESHIFTMULTI 
*                        added ccdDB_SET_TIMEDEFIDEM, ccdDB_SET_TIMEDEFMULTI
*                        added ccdDB_CON_ELADU
* P.Duhoux     26/07/97  added ccdDB_SET_SIMIMG
* P.Duhoux     14/10/97  set ccdMONITOR_PERIOD = 60 for TEL/TMP sampling
* A.Longinotti 12/05/98  added ccdDB_SET_WIPETIME ccdDB_SET_XFERSYNC
* P.Duhoux     24/11/99  added ccdDB_WCS_FLAGS    "wcs.flags"
*/

/*************************************************************************
*  This file contains all DB definitions used by WS AND LCU CCD sw modules.
*************************************************************************/

/*************************************************************************
*
*  IMPORTANT : Root Point Attribute Macros MUST begin with a "."
*
*************************************************************************/

#ifndef CCDDATABASE_H
#define CCDDATABASE_H

/*
 * Database points
 */

#define ccdDB_NXT_POINT      "exposures:exposure_next"
#define ccdDB_CLK_POINT      "readout:clock"
#define ccdDB_OBS_POINT      "observations:observation_1"
#define ccdDB_CHP_POINT      "detector:chip"
#define ccdDB_OUT_POINT      "detector:output"

#define ccdDB_POINT_DET      "detector"
#define ccdDB_POINT_DET_OUTi "detector:output_%i"
#define ccdDB_POINT_DET_CHPi "detector:chip_%i"
#define ccdDB_POINT_PRC      "process"
#define ccdDB_POINT_PRC_WINi "process:window_%i"
#define ccdDB_POINT_XFR      "transfer"
#define ccdDB_POINT_IMG      "images"
#define ccdDB_POINT_RTD      "display"
#define ccdDB_POINT_RDT      "readout"
#define ccdDB_POINT_RDT_CLKi "readout:clock_%i"
#define ccdDB_POINT_RDT_WINi "readout:window_%i"
#define ccdDB_POINT_EXP      "exposures"
#define ccdDB_POINT_EXP_NEXT "exposures:exposure_next"
#define ccdDB_POINT_EXP_EXPi "exposures:exposure_%i"
#define ccdDB_POINT_SHT      "shutter"
#define ccdDB_POINT_TEL      "telemetry"
#define ccdDB_POINT_TMP      "temperature"

/*
 * Configuration Attributes
 */
 
/* FITS log mask */
#define ccdDB_CON_FITSLOGMASK ".logMask"

/* system state */
#define ccdDB_STA_INITDONE    ".initDone"

/* 
 * exposure coordination 
 */

/* bits per pixel */
#define ccdDB_CON_BITSPIX    "readout.bitsPixel"

/* frame transfer CCD */
#define ccdDB_CON_FRAMETRAN  "detector.frameTransfer"

/* skipper CCD */
#define ccdDB_CON_SKIPPER    "detector.skipper"

/* CCD supporting mpp mode */
#define ccdDB_CON_MPP        "detector.mpp"

/* Dual CCD  */
#define ccdDB_CON_DUAL       "detector.dual"

/* number of columns on chip */
#define ccdDB_CON_XPIX       "detector.xPixels"

/* number of rows on chip */
#define ccdDB_CON_YPIX       "detector.yPixels"

/* 
 * readout and wiping 
 */
/* name of file containing DSP program - under ccdDB_CLK_POINT_<clockIndex> */
#define ccdDB_CON_CLOCKDES     "description"

/* readout speeds - under ccdDB_CLK_POINT_<clockIndex> */
#define ccdDB_CON_SPEED     "speed"

/* output enable - under ccdDB_CLK_POINT_<clockIndex> */
#define ccdDB_CON_OUTPUT    "outEnab"

/* output generating first pixel - under ccdDB_CLK_POINT_<clockIndex> */
#define ccdDB_CON_OUTFIRST  "firstOutput"

/* default gain index for clock - under ccdDB_CLK_POINT_<clockIndex> */
#define ccdDB_CON_GAINIDX   "gainIndex"

/* maximum number of windows supported - under ccdDB_CLK_POINT_<clockIndex> */
#define ccdDB_CON_NWIN      "nWindows"

/* usec to convert one pixel value - under ccdDB_CLK_POINT_<clockIndex> */
#define ccdDB_CON_ADCTIME   "adcTime"

/* electron per ADU value - under ccdDB_CLK_POINT_<clockIndex> */
#define ccdDB_CON_ELADU     "elAdu"

/* chip availabilty - under ccdDB_CHP_POINT_<chipIndex> */
#define ccdDB_CON_CHIPAVAIL   "available"

/* chip x location - under ccdDB_CHP_POINT_<chipIndex> */
#define ccdDB_CON_CHIPXLOC   "xLocation"

/* chip y location - under ccdDB_CHP_POINT_<chipIndex> */
#define ccdDB_CON_CHIPYLOC   "yLocation"

/* output description - under ccdDB_OUT_POINT_<outputIndex> */
#define ccdDB_CON_OUTPDESC    "description"
#define ccdOUTPUT_LEFT  "L"
#define ccdOUTPUT_RIGHT "R"

/* output availabilty - under ccdDB_OUT_POINT_<outputIndex> */
#define ccdDB_CON_OUTPAVAIL   "available"

/* index of chip where output is - under ccdDB_OUT_POINT_<outputIndex> */
#define ccdDB_CON_OUTPCHIP   "chipIndex"

/* output x location - under ccdDB_OUT_POINT_<outputIndex> */
#define ccdDB_CON_OUTPXLOC   "xLocation"

/* output y location - under ccdDB_OUT_POINT_<outputIndex> */
#define ccdDB_CON_OUTPYLOC   "yLocation"

/* output hor direction - under ccdDB_OUT_POINT_<outputIndex> */
#define ccdDB_CON_OUTPHDIR   "leftToRight"

/* output ver direction - under ccdDB_OUT_POINT_<outputIndex> */
#define ccdDB_CON_OUTPVDIR   "downToUp"

/* output x prescan - under ccdDB_OUT_POINT_<outputIndex> */
#define ccdDB_CON_OUTPXPRE   "xPrescan"

/* output y prescan - under ccdDB_OUT_POINT_<outputIndex> */
#define ccdDB_CON_OUTPYPRE   "yPrescan"

/* output x active pixels - under ccdDB_OUT_POINT_<outputIndex> */
#define ccdDB_CON_OUTPXPIX   "xPix"

/* output y active pixels - under ccdDB_OUT_POINT_<outputIndex> */
#define ccdDB_CON_OUTPYPIX   "yPix"

/* output x overscan - under ccdDB_OUT_POINT_<outputIndex> */
#define ccdDB_CON_OUTPXOVE   "xOverscan"

/* output y overscan - under ccdDB_OUT_POINT_<outputIndex> */
#define ccdDB_CON_OUTPYOVE   "yOverscan"

/* wipe count */
#define ccdDB_CON_NWIPES "readout.nWipes"

/* wipe periode */
#define ccdDB_CON_WINT   "readout.wipePeriod"

/* wipe hor. binning */
#define ccdDB_CON_WXBIN  "readout.wipeXBin"

/* wipe ver. binning */
#define ccdDB_CON_WYBIN  "readout.wipeYBin"

/* DCL prefix */
#define ccdDB_CON_PREFIX "readout.hwDescription"


/* 
 * image transfer 
 */
/* name of compressed FITS file */
#define ccdDB_EXP_FILECOM     "transfer.fileNameComp"

/* transfer method  */
#define ccdDB_CON_TRANSF    "images:transfer.transferMethod"

/* dxf packet Size  */
#define ccdDB_CON_DXFSIZE   "images:transfer.itPacketSize"

/* Size of FITS image header (in FITS blocks) */
#define ccdDB_CON_FITSSIZE   "images:transfer.itHeaderSize"

/* default sampling period for TEL/TMP */
#define ccdMONITOR_PERIOD    60           

/* 
 *  telemetry
 */

/*  */
#define ccdDB_CON_TELAVAIL  "telemetry.available"

/* 
 * temperature 
 */

/*  */
#define ccdDB_CON_TMPAVAIL  "temperature.available"

/* 
 * shutter 
 */

/*  */
#define ccdDB_CON_SHTAVAIL  "shutter.available"

/*  */
#define ccdDB_CON_SHTTYPE   "shutter.type"

/*  */
#define ccdDB_CON_SHTDESCR  "shutter.description"

/*  */
#define ccdDB_CON_SHTHWDESC "shutter.hwDescription"

/*  */
#define ccdDB_CON_SHTTIMOUT "shutter.timeout"


/* 
 * DCL's 
 */

/* DCL device name */
#define ccdDB_CON_DCLDEV    "ace.devName"

/* DCL device timeout */
#define ccdDB_CON_DCLTOUT   "ace.devTimeout"


/*
 * Setup Attributes
 */
 
/* 
 * EXPOSURE COORDINATION 
 */

/* exposure type */
#define ccdDB_SET_EXPTYPE   "exposures:exposure_next.expType"

/* number of steps for Multi step exposure */
#define ccdDB_SET_STEPDEF   "exposures:exposure_next.expStepsDef"

/* defined exposure time */
#define ccdDB_SET_TIMEDEFIDEM  "exposures:exposure_next.timeDefIdem"
#define ccdDB_SET_TIMEDEF      "exposures:exposure_next.timeDef"
#define ccdDB_SET_TIMEDEFMULTI "exposures:exposure_next.timeDefMulti"

/* defined exposure time start */
#define ccdDB_SET_TIMESTART "exposures:exposure_next.timeStart"

/* defined exposure time repeat */
#define ccdDB_SET_TIMEREP   "exposures:exposure_next.timeRepeat"

/* times are absolute/relative */
#define ccdDB_SET_TIMEABS   "exposures:exposure_next.timeAbsolute"

/* defined exposure repetitions */
#define ccdDB_SET_EXPREPS   "exposures:exposure_next.expRepeatDef"

/* type of frame it has to be */
#define ccdDB_SET_FRMTYPE   "exposures:exposure_next.frameType"

/* perform wipe before each exposure in a loop or not */
#define ccdDB_SET_WIPETIME   "exposures:exposure_next.expWipeTime"


/* 
 * IMAGE TRANSFER 
 */

/* transfer synchronous or not */
#define ccdDB_SET_XFERSYNC  "exposures:exposure_next:transfer.itSync"

/* disk save method */
#define ccdDB_SET_DISKSAVE  "exposures:exposure_next:transfer.diskSaveMethod"

/* name of uncompressed FITS file */
#define ccdDB_SET_FILEUNC   "exposures:exposure_next:transfer.fileNameUnComp"

/* name of compressed FITS file */
#define ccdDB_SET_FILECOM   "exposures:exposure_next:transfer.fileNameComp"

/* pixel representation */
#define ccdDB_SET_PIXREPR   "exposures:exposure_next:transfer.itPixRepr"

/* bit shift */
#define ccdDB_SET_BITSHIFT  "exposures:exposure_next:transfer.itBitShift"

/* compression mode */
#define ccdDB_SET_COMPRESS  "exposures:exposure_next:transfer.itCompression"

/* transfer sampling */
#define ccdDB_SET_SAMPLING  "exposures:exposure_next:transfer.itSampling"

/* 
 * REAL TIME DISPLAY 
 */

/* real-time display flag */
#define ccdDB_SET_DISPLAY   "exposures:exposure_next:display.frameId"

/* 
 * IMAGE PROCESSING
 */

/* Search for extrema */
#define ccdDB_SET_WIN1_MINMAX    "exposures:exposure_next:process:window_1.ipMinMax"
#define ccdDB_SET_WIN2_MINMAX    "exposures:exposure_next:process:window_2.ipMinMax"

/* Average over N frames */
#define ccdDB_SET_WIN1_AVERAGE   "exposures:exposure_next:process:window_1.ipAverageN"
#define ccdDB_SET_WIN2_AVERAGE   "exposures:exposure_next:process:window_2.ipAverageN"

/* Bias correction */
#define ccdDB_SET_WIN1_BIAS      "exposures:exposure_next:process:window_1.ipBias"
#define ccdDB_SET_WIN2_BIAS      "exposures:exposure_next:process:window_2.ipBias"

/* Flat Field correction */
#define ccdDB_SET_WIN1_FLAT      "exposures:exposure_next:process:window_1.ipFlatField"
#define ccdDB_SET_WIN2_FLAT      "exposures:exposure_next:process:window_2.ipFlatField"

/* Compute Image Centroid */
#define ccdDB_SET_WIN1_CENTROID  "exposures:exposure_next:process:window_1.ipCentroiding"
#define ccdDB_SET_WIN2_CENTROID  "exposures:exposure_next:process:window_2.ipCentroiding"

/* User Function */
#define ccdDB_SET_WIN1_USERFUNC  "exposures:exposure_next:process:window_1.ipUserFuncName"
#define ccdDB_SET_WIN2_USERFUNC  "exposures:exposure_next:process:window_2.ipUserFuncName"

/* User Buffer */
#define ccdDB_SET_WIN1_USERBUFF  "exposures:exposure_next:process:window_1.ipUserBuffName"
#define ccdDB_SET_WIN2_USERBUFF  "exposures:exposure_next:process:window_2.ipUserBuffName"

/* Reference point X */
#define ccdDB_SET_WIN1_REFX      "exposures:exposure_next:process:window_1.ipCentrRefX"
#define ccdDB_SET_WIN2_REFX      "exposures:exposure_next:process:window_2.ipCentrRefX"

/* Reference point X */
#define ccdDB_SET_WIN1_REFY      "exposures:exposure_next:process:window_1.ipCentrRefY"
#define ccdDB_SET_WIN2_REFY      "exposures:exposure_next:process:window_2.ipCentrRefY"

/* Threshold Min */
#define ccdDB_SET_WIN1_THRMIN    "exposures:exposure_next:process:window_1.ipCentrThreshMin"
#define ccdDB_SET_WIN2_THRMIN    "exposures:exposure_next:process:window_2.ipCentrThreshMin"

/* Threshold Max */
#define ccdDB_SET_WIN1_THRMAX    "exposures:exposure_next:process:window_1.ipCentrThreshMax"
#define ccdDB_SET_WIN2_THRMAX    "exposures:exposure_next:process:window_2.ipCentrThreshMax"

/* Sky BackGround */
#define ccdDB_SET_WIN1_BACKGND   "exposures:exposure_next:process:window_1.ipBackGround"
#define ccdDB_SET_WIN2_BACKGND   "exposures:exposure_next:process:window_2.ipBackGround"

/* Processing sub-Window offsets */
#define ccdDB_SET_WIN1_IPLLX     "exposures:exposure_next:process:window_1.ipLLX"
#define ccdDB_SET_WIN2_IPLLX     "exposures:exposure_next:process:window_2.ipLLX"
#define ccdDB_SET_WIN1_IPLLY     "exposures:exposure_next:process:window_1.ipLLY"
#define ccdDB_SET_WIN2_IPLLY     "exposures:exposure_next:process:window_2.ipLLY"
#define ccdDB_SET_WIN1_IPURX     "exposures:exposure_next:process:window_1.ipURX"
#define ccdDB_SET_WIN2_IPURX     "exposures:exposure_next:process:window_2.ipURX"
#define ccdDB_SET_WIN1_IPURY     "exposures:exposure_next:process:window_1.ipURY"
#define ccdDB_SET_WIN2_IPURY     "exposures:exposure_next:process:window_2.ipURY"

/* 
 * READOUT & WIPE
 */
 
/* number of lines to shift */
#define ccdDB_SET_LINESHIFTTYPE \
                            "exposures:exposure_next:readout.linesToShiftType"
#define ccdDB_SET_LINESHIFT "exposures:exposure_next:readout.linesToShift"
#define ccdDB_SET_LINESHIFTMULTI \
                            "exposures:exposure_next:readout.linesToShiftMulti"

/* number of times the same pixel is read (skipper CCDs only) */
#define ccdDB_SET_READPIX   "exposures:exposure_next:readout.readPixelN"

/* MPP mode */
#define ccdDB_SET_MPPMODE   "exposures:exposure_next:readout.mpp"

/* read-out clock to use */
#define ccdDB_SET_CLOCK     "exposures:exposure_next:readout.clockIndex"

/* read-out gain index */
#define ccdDB_SET_GAIN      "exposures:exposure_next:readout.gainIndex"

/* read-out simulated image file name */
#define ccdDB_SET_SIMIMG    "exposures:exposure_next:readout.fileNameSimu"

/* readout windows */
#define ccdDB_SET_WIN1_ENAB "exposures:exposure_next:readout:window_1.enabled"
#define ccdDB_SET_WIN2_ENAB "exposures:exposure_next:readout:window_2.enabled"

/* binning factors of readout windows */
#define ccdDB_SET_WIN1_XBIN "exposures:exposure_next:readout:window_1.xBinning"
#define ccdDB_SET_WIN1_YBIN "exposures:exposure_next:readout:window_1.yBinning"
#define ccdDB_SET_WIN2_XBIN "exposures:exposure_next:readout:window_2.xBinning"
#define ccdDB_SET_WIN2_YBIN "exposures:exposure_next:readout:window_2.yBinning"

/* windows first and last pixels */
#define ccdDB_SET_WIN1_XFIR "exposures:exposure_next:readout:window_1.xFirst"
#define ccdDB_SET_WIN1_XDIM "exposures:exposure_next:readout:window_1.xDim"
#define ccdDB_SET_WIN1_YFIR "exposures:exposure_next:readout:window_1.yFirst"
#define ccdDB_SET_WIN1_YDIM "exposures:exposure_next:readout:window_1.yDim"
#define ccdDB_SET_WIN2_XFIR "exposures:exposure_next:readout:window_2.xFirst"
#define ccdDB_SET_WIN2_XDIM "exposures:exposure_next:readout:window_2.xDim"
#define ccdDB_SET_WIN2_YFIR "exposures:exposure_next:readout:window_2.yFirst"
#define ccdDB_SET_WIN2_YDIM "exposures:exposure_next:readout:window_2.yDim"

/* output enabled flags - under ccdDB_EXP_POINT_<expIndex> */
#define ccdDB_SET_OUTPUTEN  "readout.readOutputEn"

/* 
 * shutter 
 */
/* none */


/*
 * Status Attributes
 */

/* 
 * exposure coordination 
 */
/* last exposure started ID */
#define ccdDB_STA_LASTEXPID "exposures.lastExpId"          

/* CCD sw WS state */
#define ccdDB_STA_WS     ".opStateWs"

/* CCD sw LCU state */
#define ccdDB_STA_LCU     ".opStateLcu"

/* exposure type - under ccdDB_EXP_POINT_<expIndex> */
#define ccdDB_STA_EXPTYPE   "expType"

/* single exposure status - under ccdDB_EXP_POINT_<expIndex> */
#define ccdDB_STA_SINGLEEXP   "singleExpStatus"

/* elapsed exposure time for each step - under ccdDB_EXP_POINT_<expIndex> */
#define ccdDB_STA_TIMEELA    "timeEla"   

/* elapsed exposure time for multi step - under ccdDB_EXP_POINT_<expIndex> */
#define ccdDB_STA_TIMEELAMULTI    "timeElaMulti"   

/* elapsed dark current time for each step - under ccdDB_EXP_POINT_<expIndex> */
#define ccdDB_STA_TIMEDARK   "timeDark"

/* start of first step integration start - under ccdDB_EXP_POINT_<expIndex> */
#define ccdDB_STA_TIMESTART  "timeStarted"

/* end of last step integration time - under ccdDB_EXP_POINT_<expIndex> */
#define ccdDB_STA_TIMEENDED  "timeEnded" 

/* exposure repetition count - under ccdDB_EXP_POINT_<expIndex> */
#define ccdDB_STA_EXPREPS    "expRepeatCur" 

/* 
 * readout and wiping 
 */
 
/* wiping start time */
#define ccdDB_STA_WIPESTART  "readout.wipeStarted"

/* time needed for one wiping */
#define ccdDB_STA_WIPEEND    "readout.wipeTime"

/* readout module state */
#define ccdDB_STA_MSTA    "readout.opState"

/* completion status   */
#define ccdDB_STA_CSTA    "readout.status"

/* percentage of image read     */
#define ccdDB_STA_PERCENT "readout.percent"

/* gain factor for selected speed - under ccdDB_EXP_POINT_<expIndex> */
#define ccdDB_STA_GAIN    "readout.gainIndex"

/* ADC time for sel. speed - under ccdDB_EXP_POINT_<expIndex> */
#define ccdDB_STA_ADCTIME "readout.readAdcTime" 

/* information about outputs - under ccdDB_EXP_POINT_<expIndex> */
#define ccdDB_STA_ELEADU  "readout.readElAdu" 

/* readout clock index - under ccdDB_EXP_POINT_<expIndex> */
#define ccdDB_STA_CLOCK   "readout.clockIndex"

/* number of times the same pixel is read - under ccdDB_EXP_POINT_<expIndex> */
#define ccdDB_STA_READPIX    "readout.readPixelN"

/* MPP mode - under ccdDB_EXP_POINT_<expIndex> */
#define ccdDB_STA_MPPMODE    "readout.mpp"

/* output enable - under ccdDB_EXP_POINT_<clockIndex> */
#define ccdDB_STA_OUTPUT    "readout.outEnab"

/* last line read */ 
#define ccdDB_STA_LINE    "readout.last"

/* read-out start time (mjd) */ 
#define ccdDB_STA_START   "readout.started"

/* read-out duration */ 
#define ccdDB_STA_TIME    "readout.time"

/* frame representation - under ccdDB_EXP_POINT_<expIndex> */
#define ccdDB_STA_REPR    "frameRepr"   

/* readout windows */
#define ccdDB_STA_ENAB "enabled"

/* binning factors of readout windows */
#define ccdDB_STA_XBIN "xBinning"
#define ccdDB_STA_YBIN "yBinning"

/* windows first and last pixels */
#define ccdDB_STA_XFIR "xFirst"
#define ccdDB_STA_XDIM "xDim"
#define ccdDB_STA_YFIR "yFirst"
#define ccdDB_STA_YDIM "yDim"

/* 
 * image transfer 
 */

/* transfer status */
#define ccdDB_IT_STA_TSTA    "images:transfer.opState"

/* transfer Compl Status */
#define ccdDB_IT_STA_CSTA    "images:transfer.status"

/* info for real time dis. */
#define ccdDB_IT_RTD         "images:display.frame"

/* transfer start time */
#define ccdDB_IT_STA_START   "images:transfer.started"

/* transfer duration */
#define ccdDB_IT_STA_TIME    "images:transfer.time"

/* image list */
#define ccdDB_STA_IMAGELST   "images.frame"

/* 
 * shutter 
 */

/* time when open action started */
#define ccdDB_STA_OPENSTART     "shutter.openStarted"

/* time needed to open */
#define ccdDB_STA_OPENTIME      "shutter.openTime"

/* time when close action started */
#define ccdDB_STA_CLOSESTART    "shutter.closeStarted"

/* time needed to close */
#define ccdDB_STA_CLOSETIME     "shutter.closeTime"

/*
 * database paths for common attributes 
 */

/* unknown attribute */
#define ccdDB_OBS_UNKNOWN ""

/* setup files dir. */
#define ccdDB_OBS_STP_DIR "observations.setupDirectory"

/* new data for Archive (used when in stand-alone) */
#define ccdDB_NEW_DATA_POINT    "<alias>newData"
#define ccdDB_NEW_DATA_FILE_UNC "newDataFileName"

/* attributes for WCS handling */
#define ccdDB_POINT_WCS    "wcs"
#define ccdDB_WCS_XREFPIX  "wcs.xRefPix"
#define ccdDB_WCS_YREFPIX  "wcs.yRefPix"
#define ccdDB_WCS_SECPIX   "wcs.secPix"
#define ccdDB_WCS_ROTATE   "wcs.rotate"
#define ccdDB_WCS_EQUINOX  "wcs.equinox"
#define ccdDB_WCS_EPOCH    "wcs.epoch"
#define ccdDB_WCS_PROJ     "wcs.proj"
#define ccdDB_WCS_FLAGS    "wcs.flags"

#endif /* ! CCDDATABASE_H */
