/*************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: ccdInternal.h,v 4.11 2005/06/22 10:58:08 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* alongino  31/08/94  created
* alongino  22/05/95  new definitions added
* ccumani   10/07/95  updated after reordering of DB
*                     ccdMPPMODE and ccdREAD_CLOCK added
* ccumani   17/07/95  ccdREAD_WIN1_FIR_X definition added
*                     ccdREAD_WIN1_LST_X definition added
*                     ccdREAD_WIN2_FIR_X definition added
*                     ccdREAD_WIN2_LST_X definition added
*                     ccdREAD_WIN1_FIR_Y definition added
*                     ccdREAD_WIN1_LST_Y definition added
*                     ccdREAD_WIN2_FIR_Y definition added
*                     ccdREAD_WIN2_LST_Y definition added
* ccumani   19/07/95  ccdREAD_WIN1_LST_X -> ccdREAD_WIN1_DIM_X
*                     ccdREAD_WIN2_LST_X -> ccdREAD_WIN2_DIM_X
*                     ccdREAD_WIN1_LST_Y -> ccdREAD_WIN1_DIM_Y 
*                     ccdREAD_WIN2_LST_Y -> ccdREAD_WIN2_DIM_Y 
* alongino  24/07/95  definitions used by external modules moved to ccd.h
*                     commands common to WS moved to ccd.h
* alongino  04/08/95  added expId to FITSBASIC
* alongino  10/08/95  deleted ccdVERSION (replaced by cmm $Revision: 4.11 $)
* alongino  17/08/95  ccdCAMERANAME and ccdCAMERANAME_LEN moved to ccd.h
* alongino  18/08/95  SET parameters moved to ccd.h
* alongino  24/08/95  added prototypes for ccdconNumPixels and 
*                     ccdconGetImageDim
*                     literal for commands modified (prefix CMD_ added)
* alongino  04/09/95  ccdconGetIndexFromId changed to ccdGetIndexFromId
* alongino  04/09/95  ccdGetIndexFromId moved to ccd.h
*                     ccdconNumPixels changed to ccdNumPixels
* alongino  12/09/95  ccdMODULE renamed ccdMOD_WS (conflicts with ccdsht.h)
* alongino  29/09/95  added ccdDatabase.h (taken out from ccd.h)
* ccumani   09/10/95  ccdPID_ILLEGAL added
* alongino  17/10/95  added ccdLAST_IMAGE_ID
* pduhoux   16/11/95  added ccdSENSOR & ccdPARAMETER data structures
* alongino  30/01/96  added definitions for command parameters
* alongino  02/02/96  ccdMOD_WS removed (errors have been unified)
* alongino  05/02/96  In ccdFITSBASIC display replaced with frameId
* pduhoux   04/03/96  added fct prototype ccdGetImageXYDim
* pduhoux   07/03/96  modified fct prototype ccdGetImageXYDim ccdGetImageDim
*                     -> removed 'const'
* alongino  12/07/96  ccdconTASK_NAME_ACT_FMT moved from ccdLcuInternal.h
*                     ccditMODULE moved from ccdit/lcu/ccdit.h
* alongino  24/07/96  ccdrdtSTATE moved from ccdrdt module
* pduhoux   06/08/96  ccdconTASK_NAME_ACT_FMT renamed to ccdTASK_NAME_ACT_FMT
* pduhoux   21/01/97  added prototypes for ccdPack/UnpackFitsHeader/Trailer  
* pduhoux   12/03/97  added Window Enabled Flag <on> in ccdFITSWIND
* alongino  01/04/97  slx.h removed: not used on LCU
* pduhoux   29/04/97  added <gainIdx>/<gainFct> replacing <gain> in ccdFITSOUTP
* pduhoux   06/05/97  moved ccdPROG_TEC/SCI from ccdLcuInternal.h
* alongino  22/05/97  added ccdCMD_DEBUG and ccdDEBUG_XXX defines
* alongino  05/02/02  added CCD_SWAP_INT* macros
*/

/*************************************************************************
*  This file contains all definitions used by WS AND LCU CCD sw modules.
*************************************************************************/

#ifndef CCDINTERNAL_H
#define CCDINTERNAL_H

#ifdef __cplusplus
extern "C" {
#endif

/*
 * VLT header files
 */
#include "dxf.h"
#include "slx.h"

/*
 * CCD main header file
 */
#include "ccd.h"
          
/*
 * CCD database header file
 */
#include "ccdDatabase.h"            

/*
 * CCD version header file
 */
#include "ccdintDefines.h"

/*
 * CCDLIB Version 
 */
#define ccdlibVERSION "$Revision: 4.11 $"

/*
 * Constants
 */
#define IN 
#define OUT
#define INOUT

#define ILLEGAL 0                     /* illegal value for most type enum  */
#define NO_ERROR 0
#define FD_INVALID -1                 /* invalid file descriptor number    */
#define ccdPID_ILLEGAL 0              /* invalid process id                */

#define ccdCAMERANAME_LEN 8           /* maximum lenght of camera name     */
#define ccdMAXFILELEN 64              /* maximum lenght of image file name */
#define ccdMAXPATHLEN 256             /* maximum lenght of full path name  */
#define ccdLAST_IMAGE_ID -1           /* Id of last image read             */

#define ccdTASK_NAME_ACT_FMT "%sAct_%s" /* format for LCU action task name*/
#define ccditMODULE       "ccdit"     /* name of ccdit module              */

/* ID for logging system */
#define ccdLOG_ID             130    

#if defined(i386) || defined(__i386)
#define CCD_SWAP_INT16(v)  v = CCS_SWAP_INT16(v)
#define CCD_SWAP_INT32(v)  v = CCS_SWAP_INT32(v)
#define CCD_SWAP_FLOAT(v)  {vltINT32 *i1; i1=(vltINT32 *)&(v); *i1 = CCS_SWAP_INT32(*i1);}
#define CCD_SWAP_DOUBLE(v) {vltINT32 *i1,*i2; i1=(vltINT32 *)&(v); i2=i1+1;CCS_SWAP_2INT32(i1,i2);}
#else
#define CCD_SWAP_INT16(v)
#define CCD_SWAP_INT32(v)
#define CCD_SWAP_FLOAT(v)
#define CCD_SWAP_DOUBLE(v)
#endif

/* log IDs */
enum ccdLogId {
    ccdLOG_START = logAUTO_RANGE + 1,
    ccdLOG_OPMODE,
    ccdLOG_SIGNAL,
    ccdLOG_SETUP_SAVE,
    ccdLOG_SETUP_RESTORE,
    ccdLOG_STOP_LOG_REPLY_ERROR,
    ccdLOG_END
};

/*
 * image transfer completion status
 */
typedef enum
    {
    ccditNONE = 1,                 /* no transfer completed yet */
    ccditSUCCESS,                  /* last transfer completed successfully */
    ccditFAILURE,                  /* last transfer stopped with error */
    ccditABORTED,                  /* last transfer aborted by command */
    } ccditCOMPSTATUS;

/*
 * state of readout sub-system
 */
typedef enum
    {
    ccdrdtOFF         = ccdOFF,
    ccdrdtLOADED      = ccdLOADED,
    ccdrdtSTANDBY     = ccdSTANDBY,
    ccdrdtONLINE_IDLE = ccdONLINE,     /* on-line but nothing to do         */
    ccdrdtONLINE_WIPE,                 /* chip wiping active                */
    ccdrdtONLINE_READY,                /* read-out ready                    */
    ccdrdtONLINE_READ                  /* read-out active                   */
    } ccdrdtSTATE;

/* 
 * Test commands
 */
#define ccdCMD_DEBUG       "DEBUG"
#define ccdPAR_DEBUG_LEVEL "level"

/* debug levels definitions (bitfield) 
 * The following convention is used on ranges to be used:
 * general functionality (e.g. messages, database): 0x00000000-0x0000000f
 * ccdcon                                         : 0x00000010-0x000000f0
 * ccdit                                          : 0x00000100-0x00000f00
 * ccdrdt                                         : 0x00001000-0x0000f000
 * ccdsht                                         : 0x00010000-0x000f0000
 * ccdip                                          : 0x00100000-0x00f00000
 * ccdtel                                         : 0x01000000-0x0f000000
 * ccdtem                                         : 0x10000000-0xf0000000
 */
#define ccdDEBUG_NONE    0x00000000   /* no debug                            */
#define ccdDEBUG_MSG     0x00000001   /* commands/replies WS <-> LCU         */
#define ccdDEBUG_FIS     0x00000002   /* FIS control                         */
#define ccdDEBUG_ACE     0x00000004   /* ACE control                         */
#define ccdDEBUG_TIM     0x00000008   /* TIM control                         */

#define ccdDEBUG_STARTUP 0x00000010   /* startup info                        */
#define ccdDEBUG_SETUP   0x00000020   /* setup info                          */
#define ccdDEBUG_COORD   0x00000040   /* exposure coordination info          */
#define ccdDEBUG_STATUS  0x00000080   /* exposure status info                */

#define ccdDEBUG_IT_MSG  0x00000100   /* image receive MSG flow              */
#define ccdDEBUG_IT_FIS  0x00000200   /* image receive FIS sync              */
#define ccdDEBUG_IT_DXF  0x00000400   /* image receive DXF info              */
#define ccdDEBUG_IT_RECV 0x00000800   /* image receive info                  */

#define ccdDEBUG_RD_MSG  0x00001000   /* image readout MSG flow              */
#define ccdDEBUG_RD_FIS  0x00002000   /* image readout FIS sync              */
#define ccdDEBUG_RD_ACE  0x00004000   /* image readout ACE info              */
#define ccdDEBUG_RD_READ 0x00008000   /* image readout info                  */

#define ccdDEBUG_SH_MSG  0x00010000   /* shutter control MSG flow            */
#define ccdDEBUG_SH_FIS  0x00020000   /* shutter control FIS sync            */
#define ccdDEBUG_SH_ACE  0x00040000   /* shutter control ACE info            */
#define ccdDEBUG_SH_SHUT 0x00080000   /* shutter info                        */

#define ccdDEBUG_IP_MSG  0x00100000   /* image processing MSG flow           */
#define ccdDEBUG_IP_FIS  0x00200000   /* image processing FIS sync           */
#define ccdDEBUG_IP_PROC 0x00400000   /* image processing PROC info          */
#define ccdDEBUG_IP_USER 0x00800000   /* image processing USER func info     */

#define ccdDEBUG_TL_MSG  0x01000000   /* telemetry control MSG flow          */
#define ccdDEBUG_TL_FIS  0x02000000   /* telemetry control FIS sync          */
#define ccdDEBUG_TL_ACE  0x04000000   /* telemetry control ACE info          */
#define ccdDEBUG_TL_TELE 0x08000000   /* telemetry info                      */

#define ccdDEBUG_TM_MSG  0x10000000   /* temperature control MSG flow        */
#define ccdDEBUG_TM_FIS  0x20000000   /* temperature control FIS sync        */
#define ccdDEBUG_TM_ACE  0x40000000   /* temperature control ACE info        */
#define ccdDEBUG_TM_TEMP 0x80000000   /* temperature info                    */

/* 
 * commands to LCU
 */
#define ccdCMD_BREAK      "BREAK"
#define ccdCMD_KILL       "KILL"
#define ccdCMD_SET        "SET"

/* command parameters */

/*
 * New types definitions
 */

    /* Chip ability for line shifting */
typedef enum
    {
    ccdLINE_SHIFT_NONE = 0,     /* CCD does not support lineShift    */
    ccdLINE_SHIFT_UP,           /* only Shift Up supported           */
    ccdLINE_SHIFT_DOWN,         /* only Shift Down supported         */
    ccdLINE_SHIFT_BOTH          /* both Shift Up & Down supported    */
    } ccdLINESHIFT_MODE;

/*
 * Note: the file name, although not modified by the LCU sw, better "follows"
 * the exposure path as all other setup parameters. If it stops at WS level, 
 * problems of merging information coming from the same exposure between 
 * LCU and WS, specially when more exposures are running simultaneously.
 */
typedef struct {                      /* FITS info for each window          */
    vltLOGICAL on;                    /* Window enabled                     */
    vltINT16   strx;                  /* X window start                     */
    vltINT16   stry;                  /* Y window start                     */
    vltINT16   nx;                    /* X window size                      */
    vltINT16   ny;                    /* Y window size                      */
    vltINT8    binx;                  /* X binning factor                   */
    vltINT8    biny;                  /* Y binning factor                   */
} ccdFITSWIND;

typedef struct {                       /* FITS file header basic information */
    /* This part is used to build the FITS header(s) */
    vltINT32    bitPix;                /* bits per pixel                     */
    vltINT32    windowN;               /* number of windows used             */
    ccdFITSWIND winInfo[ccdMAXWINDOW]; /* info for each used window          */
    vltBYTES8   dateObs;               /* date when exposure started         */
    vltDOUBLE   bscale;                /* real = file * BSCALE + BZERO       */
    vltDOUBLE   bzero;                 /* real = file * BSCALE + BZERO       */
    ccsTIMEVAL  utcObs;                /* UTC time of exposure start         */
    vltDOUBLE   expTime;               /* actual exposure time               */

    /* This part is used by the WS part */
    vltINT32    expId;                 /* ID of associated exposure          */

    /* This part is used by the WS part for FITS */
    char        fileUnc[ccdMAXFILELEN];/* name of file for image uncompressed*/
    vltINT32    diskSaveMethod;        /* disk save method                   */
    vltINT32    overWrite;             /* file overwrite flag                */

    /* This part is used by the WS part for RTD */
    vltINT32    frameId;               /* real-time display frame ID         */
} ccdFITSBASIC;

typedef struct {                      /* FITS info for each output used     */
    vltINT32   index;                 /* index of output on chip            */
    vltFLOAT   elAdu;                 /* conversion factor e- to ADU        */
    vltFLOAT   gainFct;               /* gain factor                        */
    vltINT32   gainIdx;               /* gain index                         */
} ccdFITSOUTP;

typedef struct {                      /* FITS info for each integration     */
    vltDOUBLE  uit;                   /* defined by the user                */
    vltDOUBLE  dit;                   /* elapsed                            */
} ccdFITSINTE;

typedef struct {                      /* info for each temper. sensor used  */
    vltINT32   index;                 /* index of sensor                    */
    vltFLOAT   start;                 /* temp. value at start of exposure   */
    vltFLOAT   stop;                  /* temp. value at end of exposure     */
#ifdef ccdONLY_FOR_OPS_LOG
    vltFLOAT   mean;                  /* temp. average during exposure      */
    vltFLOAT   drift;                 /* temp. variance during exposure     */
#endif
} ccdFITSTEMP;

typedef struct {                      /* info for each telem. source used   */
    vltINT32   index;                 /* index of source                    */
    vltFLOAT   start;                 /* tel. value at start of exposure    */
    vltFLOAT   stop;                  /* tel. value at end of exposure      */
#ifdef ccdONLY_FOR_OPS_LOG
    vltFLOAT   mean;                  /* tel. average during exposure       */
    vltFLOAT   drift;                 /* tel. variance during exposure      */
#endif
} ccdFITSTELE;

typedef struct {                       /* FITS hierarchical information      */
    vltINT32    readPixelN;            /* Times same pixel has been read     */
    vltBYTES16  readMode;              /* readout mode used                  */
    vltBYTES16  readSpeed;             /* readout speed used                 */
    vltBYTES32  readClock;             /* clock pattern used for readout     */
    vltINT32    readPixTime;           /* readout time / pixel [us]          */
    vltINT32    readShiftType;         /* line shift type                    */
    vltINT32    readShift[ccdMAXINTEGR];/* number of lines shifted / intgr   */
    vltINT32    expType;               /* type of exposure                   */
    vltINT32    outputN;               /* number of outputs used             */
    ccdFITSOUTP outInfo[ccdMAXOUTPUT]; /* info for each used output          */
    vltINT32    outRef;                /* refer. output (image orientation)  */
    vltINT32    frmId;                 /* image sequential number            */
    vltINT32    frmType;               /* type of frame                      */
    vltINT32    frmNaver;              /* number of frames averaged          */
    vltLOGICAL  frmBias;               /* bias substraction done             */
    vltLOGICAL  frmFlatf;              /* flatF division done                */
    vltINT32    integrN;               /* number of integrations             */
    ccdFITSINTE intTime[ccdMAXINTEGR]; /* integration time information       */
    vltDOUBLE   startReadTime;         /* mjd when readout has started       */
    vltDOUBLE   readTime;              /* image readout time [s]             */
    vltDOUBLE   startProcTime;         /* mjd when process has started       */
    vltDOUBLE   procTime;              /* image processing time [s]          */
    vltDOUBLE   startTranTime;         /* mjd when transfer has started      */
    vltDOUBLE   tranTime;              /* image transfer time [s]            */
    vltDOUBLE   stopWipeTime;          /* mjd last wipe done before readout  */
    vltDOUBLE   darkTime;              /* total dark time [s]                */
    vltDOUBLE   shutOpenTime;          /* shutter open  time [s]             */
    vltDOUBLE   shutCloseTime;         /* shutter close time [s]             */
#ifdef ccdONLY_FOR_OPS_LOG
    vltINT32    tmpPeriod;             /* sampling period [s]                */
#endif
    vltINT32    tmpSnsN;               /* number of temp. sensors enabled    */
    ccdFITSTEMP tmpSns[ccdMAXTMPSRC];  /* info on enabled temp. sensors      */
#ifdef ccdONLY_FOR_OPS_LOG
    vltINT32    telPeriod;             /* sampling period [s]                */
    vltINT32    telSrcN;               /* number of tel. sources enabled     */
    ccdFITSTELE telSrc[ccdMAXTELSRC];  /* info on enabled tel. sources       */
#endif
} ccdFITSHIERARCH;

/* data structure for sensors (telemetry & temperature) */
typedef struct {                     /* Mapping of DB sensor table         */
    vltLOGICAL      readOnly;        /* Parameter is Read Only             */
    vltLOGICAL      available;       /* Signal is available                */
    vltLOGICAL      enabled;         /*                                    */
    vltLOGICAL      reserved;        /* Reserved for align / future use    */
    vltBYTES16      description;     /* Sensor type description            */
    vltBYTES16      id;              /* Sensor Id                          */
    vltBYTES8       unit;            /* Unit of physical value             */
    vltDOUBLE       low;             /* Lowest tolerated value             */
    vltDOUBLE       high;            /* Highest tolerated value            */
    vltDOUBLE       reference;       /* Reference value                    */
} ccdSENSOR;

/* data structure for sensors parameters (telemetry & temperature) */
typedef struct {
    vltBYTES8       parName;         /* Parameter name                     */
    vltDOUBLE       parValue;        /* Parameter value                    */
} ccdPARAMETER;

/* 
 * Macros 
 */
/* CCD ACE Program names Scientific/Technical */
#define ccdPROG_SCI     "acesci"
#define ccdPROG_SCI_TRA "acesci.btl"
#define ccdPROG_TEC     "acetec"
#define ccdPROG_TEC_TRA "acetec.btl"
#define ccdPROG_TEC_DSP "acetecARC.bin"
#define ccdPROG_TEC_ARC "acetecE2V"

/*
 * function prototypes
 */
/* Build a full DB path from <prefix>_<index>.<attribute> */
ccsCOMPL_STAT ccdSetIndexAttr(
    IN  const dbSYMADDRESS    attrPath,  /* path (rel. or abs.) before index */
    IN        vltINT32        index,     /* index                            */
    IN  const dbSYMADDRESS    attrName,  /* attribute name                   */
    OUT       dbSYMADDRESS    attrFullName);   /* returned full path         */

/* returns number of pixels taking into account binning factor */
vltINT32 ccdNumPixels(
    IN vltINT32 dim,             /* dimension in pixels                      */
    IN vltINT32 binning);        /* binning factor                           */

/* calculate total number of pixels selected windows */
ccsCOMPL_STAT ccdGetImageDim (
    IN  ccdCONFIG       *config,   /* configuration of  camera used          */
    IN  ccdSETUP        *setup,    /* setup information                      */
    OUT vltINT32        *winDim,   /* window dimension                       */
    OUT ccsERROR        *error);   /* error structure                        */

/* calculate number of pixels/direction selected windows */
ccsCOMPL_STAT ccdGetImageXYDim (
    IN  ccdCONFIG       *config,   /* configuration of  camera used          */
    IN  ccdSETUP        *setup,    /* setup information                      */
    OUT vltINT32        *winXDim,  /* window X dimension                     */
    OUT vltINT32        *winYDim,  /* window Y dimension                     */
    OUT ccsERROR        *error);   /* error structure                        */

/* FITS header/trailer Pack/Unpack functions */
ccsCOMPL_STAT ccdPackFitsHeader ( 
    IN  ccdFITSBASIC *header,      /* FITS header to pack to byte stream     */
    OUT char         *buffer,      /* packed FITS header                     */
    OUT ccsERROR     *error );     /* error structure                        */
ccsCOMPL_STAT ccdUnpackFitsHeader ( 
    IN  char         *buffer,      /* byte stream containing the packed hdr  */
    OUT ccdFITSBASIC *header,      /* unpacked FITS header                   */
    OUT ccsERROR     *error );     /* error structure                        */
ccsCOMPL_STAT ccdPackFitsTrailer ( 
    IN  ccdFITSHIERARCH *trailer,  /* FITS trailer to pack to byte stream    */
    OUT char            *buffer,   /* packed FITS trailer                    */
    OUT ccsERROR        *error );  /* error structure                        */
ccsCOMPL_STAT ccdUnpackFitsTrailer ( 
    IN  char            *buffer,   /* byte stream containing the packed trl  */
    OUT ccdFITSHIERARCH *trailer,  /* unpacked FITS trailer                  */
    OUT ccsERROR        *error );  /* error structure                        */
/* Set new debugging level */
void ccdDebugSet(
    IN vltINT32 level);            /* new debug level to be set              */
/* Get current debugging level */
vltINT32 ccdDebugGet( void );
/* Compare current debugging level with passed one */
vltLOGICAL ccdDebugCheck(
    IN vltINT32 level);            /* debug level to be compared with        */

/* FITS Logging functions */
ccsCOMPL_STAT ccdLogFitsComment    ( const char *msg );
ccsCOMPL_STAT ccdLogFitsAction     ( const logFITS_KEY  sub,
				     const logFITS_KEY  key, 
				     const logACTION    act );
ccsCOMPL_STAT ccdLogFitsParameter  ( const logFITS_KEY  sub, 
				     const logFITS_KEY  key, 
				     const logFITS_KEY  par,
				     const void        *val );
ccsCOMPL_STAT ccdLogFitsUnforeseen ( const char *msg );
ccsCOMPL_STAT ccdLogFitsRecovery   ( const char *msg );

#ifdef __cplusplus
}
#endif

#endif /* ! CCDINTERNAL_H */
