#ifndef ctooCONFIG_H
#define ctooCONFIG_H
/******************************************************************************
*  E.S.O. - VLT project
* 
*  "@(#) $Id: ctooCONFIG.h,v 1.52 2005/09/06 23:52:04 vltsccm Exp $"
* 
*  who       when      what
*  --------  --------  ----------------------------------------------
*  rschmutz  12/05/02  var. category added.
*  rschmutz  31/01/01  method GetAll added.
*  rschmutz  09/11/98  created.
*/

/*************************************************************************
* 
*-------------------------------------------------------------------------
*/

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

#include "oslxCONFIG.h"


/****************************************************************
* class ctooCONFIG
*----------------------------------------------------------------
*/

class ctooCONFIG: private oslxCONFIG
{
  public:
    // Constructor method that reads the configuration
    // from the current INS_ROOT.
    ctooCONFIG(const char* name);
    ~ctooCONFIG();

    const char* Name();
    const char* Category();
    ccsCOMPL_STAT Get(const slxKEYW_LINE name, oslxKEYWORD* keyw);
    ccsCOMPL_STAT GetAll(oslxKEYW_FILTER *filter, oslxCONFIG* oslxCfg);
    ccsCOMPL_STAT ErrStatus() const;

  protected:
    const eccsERROR_CLASS &ErrStatus(const ccsCOMPL_STAT s) const;

  private:
    char name[80];
    char category[16];
};


inline ccsCOMPL_STAT ctooCONFIG::ErrStatus() const
{
    return oslxCONFIG::ErrStatus();
}

inline const eccsERROR_CLASS 
	&ctooCONFIG::ErrStatus(const ccsCOMPL_STAT s) const
{
    return oslxCONFIG::ErrStatus(s);
}

#endif /* !ctooCONFIG_H */

/************************************************************************/
/* ___oOo___ */
