/*************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: dbv44cmd.h,v 2.140 2005/10/17 15:16:58 vltsccm Exp $"
*
* who       when      what
* rdonalds  22/01/99  Copied from Jens Benners updated version for
*                     new benner board ioctls
*************************************************************************/
/************************************************************************

  File: dbv44cmd.h

  Date: 13.11.97

  VME/DSP Adapter Board Commands

************************************************************************/

#ifndef _dbv44cmd_h
#define _dbv44cmd_h

#define DBV44_IOC(n)		('D' << 8 | n)

/* added to provide IOC for the new VME / DSP Adapter Board */

#define VMEIF_IOC(n)		(('D' << 8 | n ) + 30) /* to follow from LIA40_IOC */


/* DBV 44 board level ioctls: These can only be sent to 'dbv44:board' devices */

#define DBV44_RESET		DBV44_IOC(0)	/* Reset all processors	*/
#define DBV44_GETCONTROL	DBV44_IOC(1)	/* Returns CSR status	*/
#define DBV44_GETSTATUS		DBV44_IOC(2)	/* Returns LIA status 	*/

/* IOCs for the new VME / DSP Adapter Board  */ 

#define VMEIF_SET_ISELREG	VMEIF_IOC(0)    /* Write to Interupt Select Register */    
#define VMEIF_SET_STATIDREG	VMEIF_IOC(1)    /* Write to Status ID Register */ 
#define VMEIF_SET_IENREG	VMEIF_IOC(2)    /* Write to Interrupt Enable Register */
#define VMEIF_SET_CTRLREG	VMEIF_IOC(3)    /* Write to Control Register */
#define VMEIF_SET_TDREG 	VMEIF_IOC(4)    /* Write to Transmit Data Register */

#define VMEIF_GET_STATREG	VMEIF_IOC(5)    /* Read from Status Register */     
#define VMEIF_GET_ISTATREG	VMEIF_IOC(6)    /* Read from Interrupt Status Register */
#define VMEIF_GET_STATIDREG	VMEIF_IOC(7)	/* Read from Status ID Register */
#define VMEIF_GET_CTRLREG	VMEIF_IOC(8)	/* Read from Control Register */
#define VMEIF_GET_RDREG 	VMEIF_IOC(9)	/* Read from Receive Data Register */

#define VMEIF_SET_CPDCTRLREG 	VMEIF_IOC(10)	/* Write to CPD Control Register */
#define VMEIF_SET_CPDCUHIREG 	VMEIF_IOC(11)	/* Write to CPD Counter Update Register High Byte */
#define VMEIF_SET_CPDCULOREG 	VMEIF_IOC(12)	/* Write to CPD Counter Update Register Low Byte */

#define VMEIF_GET_CPDCTRLREG 	VMEIF_IOC(13)	/* Read from CPD Control Register */
#define VMEIF_GET_CPDCUHIREG 	VMEIF_IOC(14)	/* Read from CPD Counter Update Register High Byte */
#define VMEIF_GET_CPDCULOREG 	VMEIF_IOC(15)	/* Read from CPD Counter Update Register Low Byte */

#define VMEIF_GET_CPDFSTATREG 	VMEIF_IOC(16)	/* Read from CPD FIFO Status Register */

#define VMEIF_SET_TBCREG    	VMEIF_IOC(17)	/* Read from Test Bus Controller */ 
#define VMEIF_GET_TBCREG    	VMEIF_IOC(18)	/* Read from Test Bus Controller */ 

struct vmeifcmd 
       {
	   short reg;
	   short value;
       };


/* Include lia40cmd.h for link level ioctls */
#include "lia40cmd.h"

#endif /* _dbv44cmd_h */
