#ifndef DLIF_H
#define DLIF_H

/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: dlif.h,v 1.67 2005/05/12 15:27:38 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* bgilli  2003-03-24 corrected invalid comment in modifs section.
* bgilli  2003-03-12 merged with dlif 1.31.1.7
* bgilli  2001-05-24 added dlifDATA_REFDL, dlifDATA_DLCS
* rkarban 2001-02-21 created
*/

/************************************************************************
 * Public interface definition of the TCS Interface (tif)
 *----------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

#include "tif.h"


/*
 * Defines for named data items (see tifGetByName)
 * These defines allow to select data items to be read by name.
 * A database table contains the mapping from names to database
 * symbolic address and data types.
 */
#define dlifDATA_MOTION         "dlifDATA_MOTION"
#define dlifDATA_MEAS_1         "dlifDATA_MEAS_1"
#define dlifDATA_MEAS_2         "dlifDATA_MEAS_2"
#define dlifDATA_MEAS_3         "dlifDATA_MEAS_3"
#define dlifDATA_MEAS_4         "dlifDATA_MEAS_4"
#define dlifDATA_DUT1           "dlifDATA_DUT1"
#define dlifDATA_REFDL          "dlifDATA_REFDL"
#define dlifDATA_DLCS           "dlifDATA_DLCS"

#define dlifDATA_ASM_TEMPERATURE        "dlifDATA_ASM_TEMPERATURE"
#define dlifDATA_SIDERIAL_OPD_PREFIX    "dlifDATA_SIDERIAL_OPD"

#define dlifDATA_ASM_PRESSURE           "dlifDATA_ASM_PRESSURE"
#define dlifDATA_ASM_HUMIDITY           "dlifDATA_ASM_HUMIDITY"
#define dlifDATA_ASM_TL_RATE            "dlifDATA_ASM_TL_RATE"
#define dlifDATA_ASM_LONGITUDE          "dlifDATA_ASM_LONGITUDE"
#define dlifDATA_ASM_LATITUDE           "dlifDATA_ASM_LATITUDE"
#define dlifDATA_ASM_HEIGHT             "dlifDATA_ASM_HEIGHT"
#define dlifDATA_SIDERIAL_OPD1           "dlifDATA_SIDERIAL_OPD1"
#define dlifDATA_SIDERIAL_OPD2           "dlifDATA_SIDERIAL_OPD2"
#define dlifDATA_SIDERIAL_OPD3           "dlifDATA_SIDERIAL_OPD3"

/*
 * Defines for named event items (see tifAttachEvent)
 * These defines allow to select data items to be read by name.
 * A database table contains the mapping from names to database
 * symbolic address and event types.
 */
#define dlifEVENT_TRACKING_LOST "dlifEVENT_TRACKING_LOST"
#define dlifEVENT_REMTRACK_LOW  "dlifEVENT_REMTRACK_LOW"

/*
 * DL Position Data Structure
 */
struct dlifPOSITION 
    {
    vltDOUBLE x;
    vltDOUBLE y;
    vltDOUBLE z;
    };
    
    
//ccsCOMPL_STAT dlifGetPosition(dltifPOSITION *position, ccsERROR *error = NULL);


#endif /*!DLIF_H*/
