#ifndef eccsAlrmMsg_H
#define eccsAlrmMsg_H
/*******************************************************************************
* E.S.O. - VLT project
#
# "@(#) $Id: eccsAlrmMsg.h,v 1.134 2005/04/08 08:34:15 vltsccm Exp $" 
*
* eccsAlrm.h
*
* who       when      what
* --------  --------  ----------------------------------------------
* gchiozzi  22/08/97  Removed LogString(), added TraceMsgString()
* vltsw  15/10/96  Added default NULL parameter to Parse()
* rabuter   20/11/95  Created
*/

/************************************************************************
*
*----------------------------------------------------------------------
*/

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

#ifndef eccs_H
  #include "eccs.h"
#endif
#ifndef eccsMsg_H
  #include "eccsMsg.h"
#endif
extern "C" {
   #include "alrmCCS.h"
   #include "evt.h"
}
#include "eccsAlrmCon.h"

class  alrmMESSAGE : public msgRAW_MESSAGE  {

  public:
    
    alrmMESSAGE(const msgHEADER *msg = NULL); 
    alrmMESSAGE(const alrmMESSAGE &source);
    virtual ~alrmMESSAGE();

    ccsCOMPL_STAT Parse(const msgHEADER *msg = NULL);
    ccsCOMPL_STAT Receive( msgTIMEOUT              timeout = msgNO_TIMEOUT,
			   const msgRECEIVEFILTER *filter  = NULL);
    
    /* Methods to access safely the values of parameters */
    vltUINT8            Type() const;

    const char         *Command() const;
    msgCMDID            CommandId() const;

    const char         *EnvName() const;
    const char         *Point() const;
    const char         *Subpoint() const;
    const char         *Attribute() const;
    const char         *AttrValue() const;
    const vltINT16      Plin() const;
    const vltINT16      Ain() const;
    const vltINT32      Size() const;
    const vltUINT8      AttrType() const;
    const vltUINT16     Severity() const;
    const vltUINT8      Scope() const;
    const vltINT32      Timeout() const;
    const vltINT16      Ack() const;
    const char         *Message() const;
    const vltUINT8      Action() const;
    const vltUINT16     Next() const;

  protected:
    const char         *TraceMsgString(char *buf, vltLOGICAL recv=TRUE) const;

  private:
    void Init();

    ccsENVNAME   envname;
    dbSYMADDRESS point;
    dbSYMADDRESS subpoint;
    dbATTRIBUTE  attribute;
    char        *attrvalue;
    vltINT16 plin;
    vltINT16 ain;
    vltINT32 size;
    vltUINT8 attrtype;
    vltUINT16 severity;
    vltUINT8  scope;
    vltUINT32 timeout;
    vltINT16  ack;
    char     *message;
    vltUINT8  type;
    vltINT16  id;           //Connection identifier
    vltUINT8  action;
    vltUINT16 next;

};
#include "eccsAlrmMsg.icc"

#endif /* ! ECCSALRMCON_H */
