#ifndef eccsEvtIdMap_H
#define eccsEvtIdMap_H
/*******************************************************************************
* E.S.O. - VLT project
#
# "@(#) $Id: eccsEvtIdMap.h,v 1.134 2005/04/08 08:34:16 vltsccm Exp $" 
*
* eccsEvtIdMap.h
*
* who       when      what
* --------  --------  ----------------------------------------------
* gchiozzi 2002-08-01 gcc 3.1: added <functional> include
* gchiozzi 2002-08-01 gcc 3.1: changed <xxx.h> sys includes with <xxx>
* gfilippi  25/05/99  std/string.h removed (port to gcc 2.8.1)
* vltsw  23/07/96  Derived public virtual from eccsERROR_CLASS
* gchiozzi  23/05/96  Modified to include filter in event id data
* gchiozzi  15/05/96  Replaced map with multimap
* gchiozzi  01/04/96  Added include std/string.h. Not clear why it is necessary.
* rabuter   20/02/96  Created
*
*/

/************************************************************************
*
*----------------------------------------------------------------------
*/

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

#ifndef eccs_H
  #include "eccs.h"
#endif
#ifndef eccsMsg_H
  #include "eccsMsg.h"
#endif

extern "C" {
   #include "evt.h"
}

#include <algorithm>
#include <functional>
#include <map>
#include <queue>

using namespace std;

#include "eccsEVENT_ID_OBJ.h"



typedef multimap<eccsEVENT_ID_OBJ, vltUINT16>  eventID_MAP;

class  evtID_MAP : virtual public eccsERROR_CLASS  {

  public:    
    evtID_MAP(){ idWaterMark = 1; }
    ccsCOMPL_STAT Insert( const evtEVENT_ID &e );
    ccsCOMPL_STAT Remove( const evtEVENT_ID &e );
    vltUINT16 Search( const evtEVENT_ID &e );
  private:
    eventID_MAP        map;

    /* In order to reuse rtap even IDs that get freed,     */
    /* we use a queue to store an ID when it is released   */
    /* When we need a new ID we first check if there are   */
    /* unused ones in the queue, otherwise we take the     */
    /* next never used one, as indicating by the waterMark */
    std::queue<vltUINT16>   idQueue;
    vltUINT16          idWaterMark;
};


/* Include the code for inline methods */
#include "eccsEvtIdMap.icc"

#endif /* ! ECCSEVTIDMAP_H */








