/****************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: errCCS.h,v 2.36 2005/07/27 12:48:47 vltsccm Exp $" 
*
*
* <err.h> - CCS ERROR SYSTEM Interface File
*
* who        when      what
* ---------  --------  ----------------------------------------------
* B.GILLI    29/04/93  Preliminary version
* B.GILLI    27/05/93  for PDR
* B.GILLI    08/07/93  add param to routine errAdd()
*                      suppress param from routine errLogError()
*                      vlt types definitions introduced.
* B.GILLI    20/07/93  added    loc_id to   routine errAdd(), 
*                      suppress loc_id from errLogError().
*                      logLOC_ID is now a ccsLOC_ID.
*                      param increased to 256 bytes.
* M.COMIN    16/08/93  Modified errAdd() to include a variable number of
*                      run time parameters.
*
* M.COMIN    16/08/93  Add errSysAdd() to log system errors.
* M.COMIN    26/10/93  Add routine errConvRtapErr()
*
* M.COMIN    10/11/93  Change type of second parameter from msgHEADER 
*                      to msgMSG
*
* M.COMIN    12/01/94  Modifications for CCS 1.0
*                      - errDisplay() replaced with errCloseStack
*
* M.COMIN    28/09/94  taken away "char locId[100]"
*
* M.COMIN    27/10/94  Add routine errDisplay, errSetProcInfo
* M.COMIN    17/11/94  Add errPrint
* B.GUSTAFSSON 28/11/94 Created CCS specific include file
* --------------------
*
* M.COMIN    29/04/96   Add errClear routine
*            07/05/96   Add errMergeStack routine
*            27/02/97   Add errIsReason routine
*            14/03/97   Add routine to convert LCC errors to CCS errors
*            20/08/98   Add errInStack
*
*****************************************************************************/

/*
 ************************************ 
 *  Error System  definitions       *
 ************************************
 */

#define errNOT_CONVERTED  -1

/*
 *******************************************************************
 * ERROR SYSTEM  : Application  Programmer  Routines               *
 *******************************************************************
 */

/*
 *  The following routines are for internal use of other CCS modules
 */

ccsCOMPL_STAT errSetProcInfo (     /* Initialize the information concerning */ 
                                   /* the local process   */
    char      *procName            /* Process Name        */
    );

ccsCOMPL_STAT errDisplay (      /* Display the current error stack on the */
                                /* local environment and close the stack  */
    ccsERROR    *error,         /* Current error structure   */
    vltLOGICAL  suspend         /* Specifies a 'synchrounous' display or not */
    );

ccsCOMPL_STAT errOpenDisplay (  /* Display the current error stack on the */
                                /* local environment                      */
    ccsERROR    *error,         /* Current error structure   */
    vltLOGICAL  suspend         /* Specifies a 'synchrounous' display or not */
    );

void errConvRtapErr(            /* Convert RTAP error into CCS error  */
     vltINT16 *ccsError         /* CCS equivalent error */
    );


/* Convert LCC errors into CCS error  */

vltINT16 errLccToCcs ( ccsERROR  *error );     /* Error Stack    */

ccsCOMPL_STAT errAddUnix (  /* Logs UNIX error into CCS error stack */
    const ccsLOC_ID  locId,
    ccsERROR         *error             
    );
