/*************************************************************************
* E.S.O. - VLT project
#
# "@(#) $Id: errPrivate.h,v 2.36 2005/07/27 12:48:47 vltsccm Exp $" 
*
* <errPrivate.h> - CCS ERROR SYSTEM Internal Interface
*                  This interface is used by the inner most levels 
*                  of the error system library.
*
* who        when      what
* ---------  --------  ----------------------------------------------
* M.COMIN    29/04/93  First version
*
*---------------------
*
* M.COMIN    10/03/94  Official version for release 1.1
*
* M.COMIN    25/07/94  Add routine errSendError()
*
* B.GUSTAFSSON 28/11/94  Inserted const declaration of errGetFormat and 
*                        errAddUnix prototype
*---------------------
* M.COMIN      30/04/96   Add routine errCopy, errSetProcessInfo
*              14/05/96   Add routine errCheckStackSize
*              27/06/96   Add routine errDebugFlag
*
*************************************************************************/

#ifndef ERR_PRIVATE_H
#define ERR_PRIVATE_H

/*
 *   Define Constants
 */

#define  errMAX_STACK_ID        10000
#define  errMAX_LOG_FORMAT      128

vltLOGICAL errDebugFlag ( 
    ccsERROR *error
    );

ccsCOMPL_STAT errSetProcessInfo (
    ccsERROR *error
    );

ccsCOMPL_STAT errCheckStackSize (
    ccsERROR *error
    );


void errReadFormat (
    const ccsMODULEID  moduleId ,
    vltINT16           errorNumber,
    FILE              *fh, 
    vltINT32           offset,
    char              *format
    );

vltINT32 errGetFormat (
    const ccsMODULEID  moduleId,
    vltINT16           errorNumber,
    vltINT8            *severity,
    char               *format
    );

ccsCOMPL_STAT errSendError(      /* Sends the error log to another RTAP */
                                 /* environment                         */
    ccsERROR  *error             
    );                          
 
 
ccsCOMPL_STAT errAddRtap(        /* Logs RTAP stack into CCS error stack  */
    ccsERROR  *error             
    );              

ccsCOMPL_STAT errOpenFile(
    char      *fileName,
    char      *mode,
    FILE      **fileHandle
    );

vltUINT32 errGetStackId ();     /* Return a new value of the stackId  */


void errLogError (              /* Stores the error log in the log File */  
    ccsERROR  *error
    );

/* Function Prototypes for gcc  compiler   */


ccsCOMPL_STAT getIndexFile(    /* Reads the modERRORS.IDX configuration file */
    const char     *moduleId,
    long           *offset,
    int            *error,
    vltINT8        *severity,
    int            *totalError
    );

int getErrIndex(               /* Returns the index to a given error  */
    int errNumb,
    int max,
    int *error
    );

#endif /*!ERR_PRIVATE_H*/

