#ifndef evhCALLBACK_H
#define evhCALLBACK_H
/*******************************************************************************
* E.S.O. - VLT project
#
# "@(#) $Id: evhCALLBACK.h,v 1.135 2005/07/21 12:41:44 vltsccm Exp $" 
*
* evhCALLBACK.h
*
* who       when      what
* --------  --------  ----------------------------------------------
* gchiozzi  12/06/97  Split .h and .icc file
* vltsw  23/07/96  Derived public virtual from eccsERROR_CLASS
* 
*/

/************************************************************************
*
*----------------------------------------------------------------------
*/

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

#ifndef fndOBJECT_H
  #include <fndOBJECT.h>
#endif

#ifndef eccsMsg_H
  #include "eccsMsg.h"
#endif
#ifndef evhErrors_H
  #include "evhErrors.h"
#endif

/* Defines for the return value from callback routines                       */
/* Group of valuee must be in OR to build the actual return code             */
/* Some examples of return codes:                                            */
/*    evhCB_DELETE                    SUCCESS and delete the callback        */
/*    evhCB_DELETE | evhCB_SUCCESS    SUCCESS and delete the callback        */
/*    evhCB_DELETE | evhCB_FAILURE    FAILURE and delete the callback        */
/*    evhCB_DELETE | evhCB_FAILURE    FAILURE and delete the callback        */
/*    evhCB_NO_DELETE                 SUCCESS and do not delete the callback */
/*    evhCB_FAILURE                   FAILURE and DO NOT delete the cb.      */
/*                                                                           */
/*    Returning 0 means:   evhCB_NO_DELETE | evhCB_SUCCESS                   */

typedef vltUINT32 evhCB_COMPL_STAT;

// Bit 1:    1 if FAILURE       0 if SUCCESS
#define evhCB_FAILURE   1
#define evhCB_SUCCESS   0

// Bit 2:    0 if NO DELETE     1 if delete requested
#define evhCB_NO_DELETE 0
#define evhCB_DELETE    2

// Bit 3     1 if return from main loop requested
#define evhCB_RETURN    4     

// Bit 4     1 if no callback installed for a received message
#define evhCB_NOCALLS   8


/* Typedef for the callback proc type */
typedef evhCB_COMPL_STAT(*evhCB_PROC )(const msgRAW_MESSAGE &, void* );
typedef evhCB_COMPL_STAT(*evhCB_PROC2 )(const msgMESSAGE &, void* );

/* A callback is described as a pointer to function + the data to be passed */
#define  evhCALLBACK_CLASS  (classType)evhCALLBACK::CreateNew

class evhCALLBACK: public fndOBJECT, virtual public eccsERROR_CLASS
{
  public:
    evhCALLBACK();
    evhCALLBACK(const evhCB_PROC procedure,void *udata = NULL);
    evhCALLBACK(const evhCB_PROC2 procedure,void *udata = NULL);
    evhCALLBACK(const evhCALLBACK &source);

    evhCALLBACK &Proc(const evhCB_PROC procedure) ;
    evhCALLBACK &Proc(const evhCB_PROC2 procedure) ;
    evhCALLBACK &UserData(void *udata);

    virtual   int           IsEqual( const fndOBJECT& ) const;

    evhCALLBACK &operator =(const evhCALLBACK &source);

    virtual evhCB_COMPL_STAT Run(const msgRAW_MESSAGE &msg);
    virtual evhCALLBACK *Clone() const;

    fndStdObjectDef(evhCALLBACK, fndOBJECT);

  protected:
    void      *UserData() const { return userData; }
  private:
    evhCB_PROC       proc;
    void            *userData;

}; /* end class evhCALLBACK */

#include "evhCALLBACK.icc"

#endif /*!evhCALLBACK_H*/
