#ifndef evhCALLBACK_DICT_H
#define evhCALLBACK_DICT_H
/*******************************************************************************
* E.S.O. - VLT project
#
# "@(#) $Id: evhCALLBACK_DICT.h,v 1.135 2005/07/21 12:41:45 vltsccm Exp $" 
*
* evhCALLBACK_DICT.h
*
* who       when      what
* --------  --------  ----------------------------------------------
* vltsw  23/07/96  Derived public virtual from eccsERROR_CLASS
* vltsw  23/07/96  Added memory collector to make safer callback removal
* 
*/

/************************************************************************
*
*----------------------------------------------------------------------
*/

#ifndef fndDICTIONARY_H
  #include <fndDICTIONARY.h>
#endif
#ifndef fndASSOCIATION_H
  #include <fndASSOCIATION.h>
#endif

#ifndef evhMSG_TYPE_KEY_H
  #include "evhMSG_TYPE_KEY.h"
#endif
#ifndef evhCALLBACK_H
  #include "evhCALLBACK.h"
#endif
#ifndef evhOBJ_CALLBACK_H
  #include "evhOBJ_CALLBACK.h"
#endif

/* The callback dictionary has some special methods */
#define  evhCALLBACK_DICT_CLASS  (classType)evhCALLBACK_DICT::CreateNew

class evhCALLBACK_DICT: public fndDICTIONARY, virtual public eccsERROR_CLASS
{
  public:

    evhCALLBACK_DICT(const unsigned sz = fndDEFAULT_DICT_SIZE ):
                     fndDICTIONARY(sz) { collector.DelItemsOnDelete(); }

    virtual ccsCOMPL_STAT AddCallback(const evhMSG_TYPE_KEY &key,
				      const evhCALLBACK &cb);
    virtual ccsCOMPL_STAT ClearCallback(const evhMSG_TYPE_KEY &key);
    virtual ccsCOMPL_STAT DelCallback(const evhMSG_TYPE_KEY &key,
				      const evhCALLBACK &cb);
    virtual evhCB_COMPL_STAT Run(const evhMSG_TYPE_KEY &key, 
				 const msgRAW_MESSAGE &msg);

    virtual ccsCOMPL_STAT Collect();

    fndStdObjectDef(evhCALLBACK_DICT, fndDICTIONARY);

  protected:
    fndLIST collector;

}; /* end class evhCALLBACK_DICT */



#endif /*!evhCALLBACK_DICT_H*/




