#ifndef evhCOMMAND_H
#define evhCOMMAND_H
/*******************************************************************************
* E.S.O. - VLT project
#
# "@(#) $Id: evhCOMMAND.h,v 1.135 2005/07/21 12:41:45 vltsccm Exp $" 
*
* evhTIMEOUT.h
*
* who       when      what
* --------  --------  ----------------------------------------------
* gchiozzi  12/06/97  Replace ccsTIMEVAL with eccsTIMEVAL.
* gchiozzi  12/06/97  Split in .h and .icc
* gchiozzi  07/10/96  Added TimeoutRefresh() method
* gchiozzi  04/10/96  Added call to ResetTimeout() in SetTimeout()
* vltsw  23/07/96  Derived public virtual from eccsERROR_CLASS
* gchiozzi  12/05/95  Added protected methods to interface private members
* 
*/

/************************************************************************
*
*----------------------------------------------------------------------
*/

#ifndef fndOBJECT_H
  #include <fndOBJECT.h>
#endif

#ifndef eccsMsg_H
  #include "eccsMsg.h"
#endif
#ifndef evhCALLBACK_H
  #include "evhCALLBACK.h"
#endif
#ifndef evhTIMEOUT_H
  #include "evhTIMEOUT.h"
#endif

#define  evhCOMMAND_CLASS  (classType)evhCOMMAND::CreateNew

class evhCOMMAND: public fndOBJECT, virtual public eccsERROR_CLASS
{
  public:
    evhCOMMAND();
   ~evhCOMMAND();

    static eccsTIMEVAL nullInterval;

    virtual ccsCOMPL_STAT Send(msgMESSAGE &msg); /* Send the command    */
    virtual vltLOGICAL    Status() const;   /* Gets the internal status */
    virtual ccsCOMPL_STAT Reset();          /* Reset the command handler */   

    virtual ccsCOMPL_STAT Reply(evhCALLBACK &cb);
    virtual ccsCOMPL_STAT ErrReply(evhCALLBACK &cb);

    virtual ccsCOMPL_STAT Timeout(evhCALLBACK &cb, eccsTIMEVAL interval);
    virtual ccsCOMPL_STAT Timeout(eccsTIMEVAL interval);
    virtual ccsCOMPL_STAT TimeoutRefresh(eccsTIMEVAL interval = evhCOMMAND::nullInterval);

    const char        *Command() const;
    msgCMDID           CommandId() const;

    virtual   int           IsEqual( const fndOBJECT& ) const;

    fndStdObjectDef(evhCOMMAND, fndOBJECT);


  protected:
    virtual int  _ReplyCB(msgMESSAGE &msg, void *udata);
    virtual int  _ErrReplyCB(msgMESSAGE &msg, void *udata);
    virtual int  _TimeoutCB(msgMESSAGE &msg, void *udata);

    virtual evhCOMMAND &Status(vltLOGICAL newStatus);

    evhCALLBACK *Reply() const;
    evhCALLBACK *ErrReply() const;
    evhCALLBACK *Timeout() const;

    ccsCOMPL_STAT SetCallbacks(msgMESSAGE &msg);
    ccsCOMPL_STAT ResetCallbacks();
    ccsCOMPL_STAT SetTimeout();
    ccsCOMPL_STAT ResetTimeout();
    
  private:
    vltLOGICAL   status;

    evhCALLBACK *reply;
    evhCALLBACK *errReply;
    evhCALLBACK *timeout;
    eccsTIMEVAL  interval;
    evhTIMEOUT  *timeHndl;

    msgCMD       command;
    msgCMDID     commandId;

}; /* end class evhCOMMAND */

#include "evhCOMMAND.icc"

#endif /*!evhCOMMAND_H*/
