#ifndef evhCRONOMETER_H
#define evhCRONOMETER_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: evhCRONOMETER.h,v 1.135 2005/07/21 12:41:52 vltsccm Exp $" 
*
* who       when      what
* --------  --------  ----------------------------------------------
* gchiozzi  12/06/97  Replace ccsTIMEVAL with eccsTIMEVAL.
* gchiozzi  12/06/97  Split in .h and .icc
* vltsw  23/07/96  Derived public virtual from eccsERROR_CLASS
* rabuter  25/10/95   created
* 
*/
/************************************************************************
*
*----------------------------------------------------------------------
*/
#ifndef _UNISTD_INCLUDED
  #include <unistd.h>
#endif
#ifndef _STDLIB_INCLUDED
  #include <stdlib.h>
#endif
#ifndef _LIMITS_INCLUDED
  #include "limits.h"
#endif
#ifndef eccsMsg_H
  #include "eccsMsg.h"
#endif
#ifndef evhCALLBACK_H
  #include "evhCALLBACK.h"
#endif
#ifndef evhTIMEOUT_H
  #include "evhTIMEOUT.h"
#endif

extern "C" {
#include "timer.h"
#include "tims.h"
}



// Status
#define CRONOMETER_RUNNING                  1
#define CRONOMETER_STOPPED                  0
// Units
#define CRONOMETER_MSEC                     2
#define CRONOMETER_USEC                     1
#define CRONOMETER_SEC                      0


class evhCRONOMETER : virtual public eccsERROR_CLASS
{
  public:
    evhCRONOMETER();
    virtual ~evhCRONOMETER(){};

    virtual ccsCOMPL_STAT Reset();
    virtual ccsCOMPL_STAT Start();
    virtual vltUINT32 Stop( vltLOGICAL unit = CRONOMETER_MSEC );
    vltLOGICAL   Status()const;
    vltUINT32 ElapsedUsec();
    vltUINT32 ElapsedSec();
    vltUINT32 ElapsedMsec();

  private:
    eccsTIMEVAL *Elapsed();
    eccsTIMEVAL  elapsed;
    vltLOGICAL   status;
    eccsTIMEVAL  start_time;
    eccsTIMEVAL  stop_time;
}; /* end class evhCRONOMETER */

#include "evhCRONOMETER.icc"

#endif /*!evhCRONOMETER_H*/
