#ifndef evhDB_CMD_SERIAL_H
#define evhDB_CMD_SERIAL_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: evhDB_CMD_SERIAL.h,v 1.135 2005/07/21 12:41:49 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* rkarban 2001-02-11 overload ActualSendCommand
* gchiozzi  31/07/98  Added proper fndStdObject...() calls
* gchiozzi  15/05/96  Necessary to add also Timeout(evhCALLBACK &cb). GCC bug?
* gchiozzi  02/05/95  created
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

#ifndef evhDB_CMD_SEND_H
  #include "evhDB_CMD_SEND.h"
#endif
#ifndef fndLIST_H
  #include "fndLIST.h"
#endif

class evhDB_CMD_SERIAL : public evhDB_CMD_SEND
{
  public:
    evhDB_CMD_SERIAL(const dbSYMADDRESS  dbPoint, evhDB_COMMAND_TYPE type);
    ~evhDB_CMD_SERIAL();

    virtual ccsCOMPL_STAT Init();
    virtual ccsCOMPL_STAT Reset();
    virtual ccsCOMPL_STAT Send(const msgCMD command, 
		            const char *newBuffer, msgLENGTH newBuflen=0,
			    evhDB_SEND_ID *sendId = NULL, 
 			    evhDB_SEND_ID  waitId = evhDB_CMD_SEND::noWaitId);
    virtual ccsCOMPL_STAT Timeout(int timeout);
    virtual ccsCOMPL_STAT Timeout(evhCALLBACK &cb);

    virtual ccsCOMPL_STAT SendCommand(evhDB_SEND_ID &);

  protected:
    ccsCOMPL_STAT             ActualSendCommand();
    virtual ccsCOMPL_STAT     Notify(); 
    virtual ccsCOMPL_STAT     SelfClean(evhDB_SEND_ID &);

    /* Real callbacks. Call hooks and do internal administration */
    virtual evhCB_COMPL_STAT  EventCompletedCB(msgMESSAGE &msg, void *udata);
    virtual evhCB_COMPL_STAT  EventErrorCB(msgMESSAGE &msg, void *udata);
    virtual evhCB_COMPL_STAT  EventTimeoutCB(msgMESSAGE &msg, void *udata);

    virtual evhDB_COMMAND *Cmd();

    ccsCOMPL_STAT     QueueCheck();

    evhDB_CMD_SERIAL(); // NON to be used!!!

    fndStdObjectDef(evhDB_CMD_SERIAL, evhDB_CMD_SEND);

  private:
    fndLIST         queue;
    evhDB_COMMAND  *cmdAlt;
    vltLOGICAL      cmdSwitchFlag;

};


#endif /*!evhDB_CMD_SERIAL_H*/
