#ifndef evhDB_SYNC_H
#define evhDB_SYNC_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: evhDB_SYNC.h,v 1.135 2005/07/21 12:41:51 vltsccm Exp $" 
*
* who       when      what
* --------  --------  ----------------------------------------------
* gchiozzi 2001-09-18 Changed attribute from eccsDB_INT32 to plain eccsDB_ATTR
* gchiozzi 2001-09-18 Added data type
* gchiozzi  01/06/95  Created
* 
*/

/************************************************************************
*
*----------------------------------------------------------------------
*/

#ifndef evhSYNC_H
  #include "evhSYNC.h"
#endif
#ifndef eccsEvt_H
  #include "eccsEvt.h"
#endif
#ifndef eccsDB_ATTR_H
  #include "eccsDB_ATTR.h"
#endif

class evhDB_SYNC: public evhSYNC
{
  public:
    evhDB_SYNC();
   ~evhDB_SYNC(); 

    ccsCOMPL_STAT AddCondition(const evhMSG_TYPE_KEY &key, 
			       int *flag = NULL, int value = TRUE);
    ccsCOMPL_STAT AddCondition(const dbSYMADDRESS attr, 
			       int value = TRUE, int check = FALSE);

    fndStdObjectDef(evhDB_SYNC, evhSYNC);

  protected:
    virtual evhCB_COMPL_STAT  HandlerCB(msgMESSAGE &msg, void *udata);

}; /* end class evhDB_SYNC */


/* This is a special class, used privately only */
/* by the class evhDB_SYNC to hold the conditions  */
/* to be tested                                 */
class evhDB_CONDITION : public evhCONDITION
{
  public:
    evhDB_CONDITION();
    evhDB_CONDITION(const dbSYMADDRESS attr, 
		    int value = TRUE);
    
    virtual   ccsCOMPL_STAT Reset(evhCALLBACK &ocb);
    virtual   ccsCOMPL_STAT Run(evhCALLBACK &ocb);
    virtual   int           Status();
    virtual   int           StatusCheckDbFirst(vltLOGICAL *qualityIsBad);
    virtual   ccsCOMPL_STAT TryUpdate(msgMESSAGE &msg);

    virtual   int           IsEqual( const fndOBJECT& ) const;

    evhDB_CONDITION  &operator         =( const evhDB_CONDITION& );

    virtual   evhCONDITION     &Status(int status);
  
    fndStdObjectDef(evhDB_CONDITION, evhCONDITION);

  private:
    evtEVENT         evt;
    dbTYPE           dataType;
    eccsDB_ATTR      attribute;

};

#endif /*!evhDB_SYNC_H*/








