#ifndef evhDB_TASK_H
#define evhDB_TASK_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: evhDB_TASK.h,v 1.135 2005/07/21 12:41:50 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* gchiozzi  31/07/98  Added proper fndStdObject...() calls
* gchiozzi  18/08/97  Added handling of db write access rules
* gchiozzi  16/04/97  DbPoint is now virtual
* gchiozzi  28/07/95  Moved Init command handling in base class evhTASK
* gchiozzi  24/04/95  created
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */

#ifndef evhHANDLER_H
  #include "evhHANDLER.h"
#endif
#ifndef evhTASK_H
  #include "evhTASK.h"
#endif
#ifndef eccsDB_ATTR_H
  #include "eccsDB_ATTR.h"
#endif
#ifndef fndNAME_MAP_H
  #include "fndNAME_MAP.h"
#endif



/************************************/
/* Defines for commonly used states */
/************************************/
#ifndef evhStates_H
  #include "evhStates.h"
#endif

class evhDB_TASK : public evhTASK
{
  public:
    evhDB_TASK(const dbSYMADDRESS  dbPoint);
    virtual ~evhDB_TASK();

    vltINT32            State();
    const char*         StateName();

    virtual const char *DbPoint() const;

    fndStdObjectDef(evhDB_TASK, evhTASK);

  protected:
    vltLOGICAL         DbWriteEnabled() const;

    ccsCOMPL_STAT      State(vltINT32 state);
    const fndNAME_MAP *StateNames() const;

    ccsCOMPL_STAT      SetStateNamesTable(fndNAME_AND_INDEX *newTable,
					 unsigned int nelem);
    ccsCOMPL_STAT      SetStateNamesTable(fndNAME_MAP *newNameMap);

    evhDB_TASK();     // NON to be used!!!

  private:

    dbSYMADDRESS      dbPoint;

    vltLOGICAL        dbWriteEnabled;
    vltINT32          state;
    eccsDB_INT32      dbState;

    fndNAME_MAP      *stateNames;
    vltLOGICAL        privStateNames;

    static fndNAME_AND_INDEX stateNamesTable[];
};


#endif /*!evhDB_TASK_H*/
