#ifndef evhDUMMY_H
#define evhDUMMY_H
/***********************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: evhDUMMY.h,v 1.135 2005/07/21 12:41:44 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* gchiozzi  31/07/98  Added proper fndStdObject...() calls
* gchiozzi  13/06/97  Created
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif


#include "fndSTRING.h"
#include "fndASSOCIATION.h"
#include "fndINT.h"
#include "fndDICTIONARY.h"

/* Include files for EasyCCS and Evh Toolkit */
#include "ECCS.h"
#include "eccsTestTools.h"
#include "evhHANDLER.h"
#include "evhTIMEOUT.h"
#include "evhTASK.h"

#include "evhErrors.h"

/*
 * Commands accepted by the class
 */

#define REGISTER_CMD     "REGCMD"
#define UNREGISTER_CMD   "UREGCMD"
#define PRINT_CMD        "PRNCMD"
#define DMEXIT_CMD       "DMEXIT"

/**************************************/
/* Support class for defining a reply */
/**************************************/

class evhDUMMY_REP_DATA: public fndOBJECT
{
  public:
    fndSTRING reply;              // Message buffer
    fndINT    errReply;           // FALSE/TRUE (error reply)
    fndINT    errCode;            // 0 or code for error reply
    fndINT    timeout;            // Timeout in seconds (0 == no timeout)

    void      PrintOn( ostream& ) const;
    
    fndStdObjectDef(evhDUMMY_REP_DATA, fndOBJECT)

}; /* end class evhDUMMY_REP_DATA */


/*************************************************/
/* Support class to pass reply data and original */
/* message to the reply callback                 */
/*************************************************/

class evhDUMMY_CB_DATA: public fndOBJECT
{
  public:
    evhDUMMY_CB_DATA(msgMESSAGE &m,evhDUMMY_REP_DATA &d) : 
	msg(m), data(d), timeout(NULL) {};
    ~evhDUMMY_CB_DATA() { if(timeout) delete timeout; }

    msgMESSAGE         msg;
    evhDUMMY_REP_DATA  data;

    /* We save here, if any, the pointer to the timeout for the    */
    /* waiting before sending the reply. In this way is at garbage */
    /* collection the timeout is not expired, it will be cleanly   */
    /* deleted                                                     */
    evhTIMEOUT        *timeout;

    fndStdObjectDef(evhDUMMY_CB_DATA, fndOBJECT);

  private:
    evhDUMMY_CB_DATA() {}; // NON to be used!!!

}; /* end class evhDUMMY_CB_DATA */


/******************************************/
/* Definition for the evhDUMMY class   */
/******************************************/
class evhDUMMY: public evhTASK
{
  public:
    evhDUMMY();

    ccsCOMPL_STAT     LoadCommands(char *fname);

    virtual evhCB_COMPL_STAT  GenericCB(msgMESSAGE &msg, void *udata);
    evhCB_COMPL_STAT  PrintCmdListCB(msgMESSAGE &msg, void *udata);

    evhCB_COMPL_STAT  RegisterCB(msgMESSAGE &msg, void *udata);
    evhCB_COMPL_STAT  UnregisterCB(msgMESSAGE &msg, void *udata);

    virtual ccsCOMPL_STAT StdMain(int argc, char *argv[]);
    virtual ccsCOMPL_STAT PrintCLineHelp(void);
    virtual ccsCOMPL_STAT ParseArguments(int argc, char *argv[]);

    fndStdObjectDef(evhDUMMY, evhTASK);

  protected:
    virtual evhCB_COMPL_STAT  SendReplyCB(msgMESSAGE &msg, evhDUMMY_CB_DATA *);
    virtual ccsCOMPL_STAT     SendErrorReply(msgMESSAGE &msg);
    virtual ccsCOMPL_STAT     SendReply(msgMESSAGE &msg, evhDUMMY_REP_DATA &data);

    evhDUMMY_REP_DATA        &Lookup(fndSTRING &cmd);
    ccsCOMPL_STAT             RegisterReply(msgMESSAGE &msg, evhDUMMY_REP_DATA &data);
    virtual ccsCOMPL_STAT     ParseCommandDesc(const char *mbuffer,
				       fndSTRING &cmd, evhDUMMY_REP_DATA &data);

    fndDICTIONARY     &RegCommands();

    char *procName;     // Name of the evhDUMMY process
    char *dataFile;     // Name of the data configuration file

  private:
    fndDICTIONARY     cmdDict;

    /* List to contain dynamic objects created by RegisterReply() */
    /* of type evhDUMMY_CB_DATA. This allow garbage collection of */
    /* all the memory used for replies waiting to be sent when    */
    /* the object is deleted                                      */
    fndLIST collector;


}; /* end class evhDUMMY */

#endif /*!evhDUMMY_H*/
