/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: evhEtDB_CMD_TEST.h,v 1.24 2005/04/08 08:53:31 vltsccm Exp $" 
*
* who       when      what
* --------  --------  ----------------------------------------------
* gchiozzi  19/08/95  created from an idea of mnastvog
* mnastvog  10/07/95  created
*/

#define _POSIX_SOURCE 1
#include "vltPort.h"
#include <limits.h>

// Include files for ECCS and Evh Toolkit
#include "eccsErr.h"
#include "eccsTestTools.h"

#include "evhEtErrors.h"
#include "evhDB_CMD_SEND.h"

/***********************************************/
/* Definition for the evhEtDB_CMD_TEST class   */
/***********************************************/

#include <string.h>
#include <stdarg.h>

#define evhEtEXPECT_STOP LONG_MIN
#define evhEtMAX_STATES  32

/* Support data structure for expect values */

struct evhEtEXPECT
{
    evhEtEXPECT();
    evhEtEXPECT(vltINT32 state1, ...);
    evhEtEXPECT( const evhEtEXPECT& sourceInteger );

    evhEtEXPECT &operator =( const evhEtEXPECT& );

    vltINT32 states[evhEtMAX_STATES];
};




class evhEtDB_CMD_TEST: public evhTASK
{
  public:
    
    evhEtDB_CMD_TEST(const dbSYMADDRESS  dbPoint,
		     evhDB_CMD_SEND     *to, 
		     const char         *oname);

    ~evhEtDB_CMD_TEST();

    void              Reset();
    void              EvtRegister();
    void              EvtSetExpect(const evhEtEXPECT&);
    ccsCOMPL_STAT     DoTest(ccsCOMPL_STAT stat,
			     int           testNum,
			     char         *methodDescr,
	                     vltLOGICAL    reg = TRUE);

  protected:
    evhCB_COMPL_STAT  TimeoutCB(msgMESSAGE &msg, void *udata);
    evhCB_COMPL_STAT  DbEventCB(evtEVENT_MSG &msg, void *udata);

    char        objName[80];
    evhEtEXPECT expect;
    int         expectIndex;

    evhDB_CMD_SEND  *testObj;
    evtEVENT         evt;
    evhTIMEOUT      *currTimeout;
    ccsTIMEVAL       interval;

}; /* end class evhEtDB_CMD_TEST */



/*
 *****************************************************************************
 */


/*___oOo___*/


























