#ifndef evhEtFRAME_H
#define evhEtFRAME_H
/*****************************************************************************
* E.S.O. - VLT project
#
# "@(#) $Id: evhEtFRAME.h,v 1.24 2005/04/08 08:53:31 vltsccm Exp $" 
*
* evhEtFRAME.h
*
* who       when      what
* --------  --------  ----------------------------------------------
* therlin   09/01/95  created
******************************************************************************
*/

/*
 * System Headers
 */
#include <signal.h>

/* 
 * Local Headers
 */
#include "ECCS.h"
#include "evhHANDLER.h"

#include "evhTIMEOUT.h"

// Include file for the evhCOMMAND class 
#include "evhCOMMAND.h"

// Include for the basic class
#include "evhTASK.h"

#include "evhEtTEST.h"

/*******************************************/
/* Defines                                 */
/*******************************************/
#define evhEtSTAY 0
#define evhEtCONTINUE 1



/*******************************************/
/* Definition for the test table structure */
/*******************************************/
typedef struct evhEtTABLE {
    char          *string;
    ccsCOMPL_STAT (*fptr)(void *);
    void          *arg;
    int           state;
};

/******************************************/
/* Definition for the TEST class          */
/******************************************/
class evhEtFRAME:public evhEtTEST
{
  public:    
    //
    evhEtFRAME();
    virtual ~evhEtFRAME();
    // 
    ccsCOMPL_STAT Init(evhEtTABLE *);
    // Convenience functions
    static ccsCOMPL_STAT Send(void *);
    static ccsCOMPL_STAT Signal(void *);
    ccsCOMPL_STAT SendSelf(void *);
    // Callback for receiving TSYNC command
    virtual evhCB_COMPL_STAT RecvSyncCB(msgMESSAGE &msg, void *udata);
    virtual evhCB_COMPL_STAT TestTimeoutCB(msgMESSAGE &msg, void *udata);

  private:
    int             testCount; // table element counter
    evhEtTABLE*     testTable; // table of test to be performed
    evhTIMEOUT*     timeOut;

    static evhEtFRAME* last; 

}; /* end class TEST */

/* 
 * Cast support
 */
typedef ccsCOMPL_STAT (*evhEtFUNCPTR)(void *);
#endif
/*___oOo___*/






















