#ifndef evhEtTEST_H
#define evhEtTEST_H
/*******************************************************************************
* E.S.O. - VLT project
#
# "@(#) $Id: evhEtTEST.h,v 1.24 2005/04/08 08:53:31 vltsccm Exp $" 
*
* evhEtTEST.h
*
* who       when      what
* --------  --------  ----------------------------------------------
* therlin   09/01/95  created
*/

/* 
 * Local Headers
 */

#include "ECCS.h"
#include "evhHANDLER.h"

// Include file for the evhCOMMAND class 
#include "evhCOMMAND.h"

// Include for the basic class
#include "evhTASK.h"

/*
 * DEFINES 
 */
#define evhEtSYNC "ETSYNC"

/******************************************/
/* Definition for the TEST class          */
/******************************************/
class evhEtTEST:public evhTASK
{
  public:   

    evhEtTEST(int delMode = TRUE);  
    virtual ~evhEtTEST();
    //
    ccsCOMPL_STAT Sync();
    static ccsCOMPL_STAT Log(const char *, ...);

    // Definition for the callbacks to be used receiving the 
    // replies from the sent command
    virtual evhCB_COMPL_STAT ReplyCB(msgMESSAGE &msg, void *udata);
    virtual evhCB_COMPL_STAT ErrReplyCB(msgMESSAGE &msg, void *udata);
    virtual evhCB_COMPL_STAT TimeoutCB(msgMESSAGE &msg, void *udata);

  protected:
            int         DelToo();  
            evhCOMMAND &Cmd();
  private:
    evhCOMMAND cmd;    // Object to handle the commands
    int        delToo; // Used to test if the obj has to delete itself 
                       // when done
}; // end class TEST 


/******************/
/* Inline methods */
/******************/

inline evhEtTEST::evhEtTEST(int delMode) : delToo(delMode)
{
    /******************************************************/
    /* The  evhCOMMAND cmd  data member is available and  */
    /* must be initialized, setting the callbacks for the */
    /* events                                             */
    /******************************************************/
    
    evhOBJ_CALLBACK cb(this);
    ccsTIMEVAL      interval;
    
    interval.tv_sec  = 5;
    interval.tv_usec = 0;
    
    cmd.Reply(cb.Proc((evhCB_METHOD)&evhEtTEST::ReplyCB));
    cmd.ErrReply(cb.Proc((evhCB_METHOD)&evhEtTEST::ErrReplyCB));
    cmd.Timeout(cb.Proc((evhCB_METHOD)&evhEtTEST::TimeoutCB),interval); /* with the time */
    
}

inline ccsCOMPL_STAT evhEtTEST::Sync()
{
    msgMESSAGE msg;
    ccsCOMPL_STAT stat;
    ccsENVNAME  envName;
    ccsPROCNUM  procNum;
    ccsPROCNAME procName;
    // Get my own process name and environment and
    // Setup the synchronization command
    stat = ccsGetMyProcId(envName, &procNum, procName);
    msg.Command(evhEtSYNC);
    msg.Destenv(envName);
    msg.Destproc(procName);
    msg.Buffer("Synchronize");

    ///////////////////////////////////////////
    // Then I send the Sync command.         //
    ///////////////////////////////////////////
    msg.SendCommand();

    return SUCCESS;
}

inline evhEtTEST::~evhEtTEST()
{
    // Log("Called sync from ~etTEST");
    Sync();
}

inline int evhEtTEST::DelToo()
{
    return delToo;
}

inline evhCOMMAND &evhEtTEST::Cmd()
{
    return cmd;
}


#endif
/*___oOo___*/






















