#ifndef evhFILEIO_H
#define evhFILEIO_H
/*******************************************************************************
* E.S.O. - VLT project
#
# "@(#) $Id: evhFILEIO.h,v 1.135 2005/07/21 12:41:46 vltsccm Exp $" 
*
* evhFileIO.h
*
* who       when      what
* --------  --------  ----------------------------------------------
* gchiozzi  03/08/98  Added conditional include of evhSELECT.h
* jknudstr  09/01/95  created
*/

/************************************************************************
*  Contains definition of FILEIO class for the CCS Event Handler 
*  module. Use to handle list of file descriptors.
*----------------------------------------------------------------------
*/

#ifndef eccs_H
  #include "eccs.h"
#endif
#ifndef eccsMsg_H
  #include "eccsMsg.h"
#endif
#ifndef evhSELECT_H
  #include "evhSELECT.h"
#endif

#define evhFILE_IO_CMD       "EVHFDIO"

// The file IO class for handling input from UNIX file descriptors 
class evhFILEIO: eccsERROR_CLASS
{
  public:
    evhFILEIO(int fd);
   ~evhFILEIO();

    // To attach the fd stored in the object to be polled
    ccsCOMPL_STAT Attach();

    // To detach the fd so that no events for this are detected
    ccsCOMPL_STAT  Detach();
  
    // Returns the fd for this object
    int  Fd() const;

    // Indicates whether the fd for this obejct is attached or not 
    vltLOGICAL Status() const;

    // Builds a 'fake' message if event was file IO
    static ccsCOMPL_STAT BuildMsg(int fd, msgMSG *fileIoMsg);

    // Returns the pointer to the fds list
    static const int *FdsList();

  private:
    int             file;
    static int      fds[evhMAX_NO_OF_FDS];
};

#endif /*!evhFILEIO_H*/
