#ifndef evhHANDLER_H
#define evhHANDLER_H
/*******************************************************************************
* E.S.O. - VLT project
#
# "@(#) $Id: evhHANDLER.h,v 1.135 2005/07/21 12:41:46 vltsccm Exp $" 
*
* evhHANDLER.h
*
* who       when      what
* --------  --------  ----------------------------------------------
* gchiozzi  12/06/97  Split in .h and .icc
* gchiozzi  24/09/96  Added checking of incoming commands
* vltsw  23/07/96  Derived public virtual from eccsERROR_CLASS
* vltsw  12/07/96  Added destructor
* gchiozzi  24/11/95  Added convenience methods to Add/Del command callbacks
* G.Chiozzi 18/01/94  Added headers and documentation
*/

/************************************************************************
*
*----------------------------------------------------------------------
*/

#ifndef evhErrors_H
  #include "evhErrors.h"
#endif

#ifndef eccsMsg_H
  #include "eccsMsg.h"
#endif
#ifndef eccsEvt_H
  #include "eccsEvt.h"
#endif
#ifndef evhCRONOMETER_H
  #include "evhCRONOMETER.h"
#endif
#ifndef evhCALLBACK_DICT_H
  #include "evhCALLBACK_DICT.h"
#endif
#ifndef evhSELECT_H
  #include "evhSELECT.h"
#endif
#ifndef eccsAlrmCon_H
  #include "eccsAlrmCon.h"
#endif
#ifndef eccsAlrmMsg_H
  #include "eccsAlrmMsg.h"
#endif

/* The callback dictionary has some special methods */
#define  evhHANDLER_CLASS  (classType)evhHANDLER::CreateNew

class evhHANDLER: public fndOBJECT, virtual public eccsERROR_CLASS
{
  public:

    evhHANDLER();
    virtual ~evhHANDLER();

    virtual ccsCOMPL_STAT AddCallback(const evhMSG_TYPE_KEY &key,
                                      const evhCALLBACK &cb);
    virtual ccsCOMPL_STAT ClearCallback(const evhMSG_TYPE_KEY &key);
    virtual ccsCOMPL_STAT DelCallback(const evhMSG_TYPE_KEY &key,
                                      const evhCALLBACK &cb);
    virtual ccsCOMPL_STAT SetCallback(const evhMSG_TYPE_KEY &key,
                                      const evhCALLBACK &cb);

    virtual ccsCOMPL_STAT AddCmdCallback(const msgCMD   cmd,
                                         const evhCB_PROC procedure);
    virtual ccsCOMPL_STAT AddCmdCallback(const msgCMD   cmd,
                                         fndOBJECT *obj,
		                         const evhCB_METHOD procedure);
    virtual ccsCOMPL_STAT DelCmdCallback(const msgCMD   cmd,
                                         const evhCB_PROC procedure);
    virtual ccsCOMPL_STAT DelCmdCallback(const msgCMD   cmd,
                                         fndOBJECT *obj,
		                         const evhCB_METHOD procedure);
    virtual ccsCOMPL_STAT SetCmdCallback(const msgCMD   cmd,
                                         const evhCB_PROC procedure);
    virtual ccsCOMPL_STAT SetCmdCallback(const msgCMD   cmd,
                                         fndOBJECT *obj,
		                         const evhCB_METHOD procedure);

    virtual ccsCOMPL_STAT UseSelect(vltLOGICAL mode = TRUE);
    virtual ccsCOMPL_STAT MainLoop();

    ccsCOMPL_STAT SetDefCmdHandler(evhCB_PROC newHandler = NULL);

    ccsCOMPL_STAT CbTimeMonitor(vltLOGICAL mode = TRUE, vltUINT32 msec = 100);
    static ccsCOMPL_STAT Trace(vltLOGICAL mode = TRUE);
    static ccsCOMPL_STAT CheckCmd(vltLOGICAL mode = TRUE);

    fndStdObjectDef(evhHANDLER, fndOBJECT)

  protected:

    virtual msgRAW_MESSAGE   *Parse(msgHEADER *msgh);
    virtual ccsCOMPL_STAT     Receive(msgHEADER **msgh);
    virtual ccsCOMPL_STAT     CheckCmd(msgMESSAGE *msg);

    evhCB_PROC        GetDefCmdHandler() const;
    evhCALLBACK_DICT &Dictionary();
    evhSELECT        &Select();
    vltLOGICAL        UseSelect() const;
    vltLOGICAL        CbTimeMonitor() const;

    static vltLOGICAL TraceStatus();
    static vltLOGICAL CheckCmdStatus();

  private:
    
    static vltLOGICAL       trace;
    static vltLOGICAL       checkCmd;

    vltLOGICAL       cbtimemonitor;

    /*Max default callback execution time*/
    vltUINT32        cbtimedefault;

    evhCALLBACK_DICT dict;
    evhCB_PROC       defCmdHandler;

    /* Object used to select on files and  signals    */
    vltLOGICAL useSelect;
    evhSELECT  select;

    /* Variables to hold known messages after parsing */
    msgMESSAGE      cmdMsg;
    evtEVENT_MSG    evtMsg;
    alrmMESSAGE     alrmMsg;   
    /* Object to monitor callbacks exec time*/
    evhCRONOMETER cbCronometer;
    

}; /* end class evhHANDLER */

/* Standard event handler */
extern evhHANDLER *evhHandler;

#include "evhHANDLER.icc"

#endif /*!evhHANDLER_H*/
