#ifndef evhOBJ_CALLBACK_H
#define evhOBJ_CALLBACK_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: evhOBJ_CALLBACK.h,v 1.135 2005/07/21 12:41:47 vltsccm Exp $" 
*
* who       when      what
* --------  --------  ----------------------------------------------
* gchiozzi  12/06/97  Split in .h and .icc
* gfilippi  09/07/99  (evhCB_METHOD)NULL -> NULL  in  const evhCB_METHOD ... 
* 
*/

/************************************************************************
*
*----------------------------------------------------------------------
*/

#ifndef fndOBJECT_H
  #include <fndOBJECT.h>
#endif

#ifndef evhCALLBACK_H
  #include "evhCALLBACK.h"
#endif

/* Typedef for the callback proc type */
typedef evhCB_COMPL_STAT 
              (fndOBJECT::*evhCB_METHOD)(const msgRAW_MESSAGE &,void*);
typedef evhCB_COMPL_STAT 
              (fndOBJECT::*evhCB_METHOD2)(const msgMESSAGE &,void*);

/* A callback is described as a pointer to function + the data to be passed */
#define  evhCALLBACK_CLASS  (classType)evhCALLBACK::CreateNew

class evhOBJ_CALLBACK: public evhCALLBACK
{
  public:
    evhOBJ_CALLBACK();
    evhOBJ_CALLBACK(fndOBJECT *obj,
		    const evhCB_METHOD procedure = NULL,
		    void *udata = NULL);
    evhOBJ_CALLBACK(fndOBJECT *obj,
		    const evhCB_METHOD2 procedure,void *udata = NULL);
    evhOBJ_CALLBACK(const evhOBJ_CALLBACK &source);

    evhOBJ_CALLBACK &Object(fndOBJECT *obj);
    evhOBJ_CALLBACK &Proc(const evhCB_METHOD procedure) ;
    evhOBJ_CALLBACK &Proc(const evhCB_METHOD2 procedure) ;

    virtual   int           IsEqual( const fndOBJECT& ) const;

    evhOBJ_CALLBACK &operator =(const evhOBJ_CALLBACK &source);

    virtual evhCB_COMPL_STAT Run(const msgRAW_MESSAGE &msg);
    virtual evhCALLBACK *Clone() const;

    fndStdObjectDef(evhOBJ_CALLBACK, evhCALLBACK)

  private:
    fndOBJECT     *object;
    evhCB_METHOD   method;

}; /* end class evhOBJ_CALLBACK */


#include "evhOBJ_CALLBACK.icc"

#endif /*!evhOBJ_CALLBACK_H*/
