#ifndef evhSTD_COMMANDS_H
#define evhSTD_COMMANDS_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: evhSTD_COMMANDS.h,v 1.135 2005/07/21 12:41:51 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* gchiozzi  31/07/98  Added proper fndStdObject...() calls
* gchiozzi  24/04/95  created
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */

#ifndef evhHANDLER_H
  #include "evhHANDLER.h"
#endif
#ifndef evhDB_TASK_H
  #include "evhDB_TASK.h"
#endif

/**********************************************************/
/* Defines for selection of implemented standard commands */
/**********************************************************/

// All commands
#define evhSTD_USE_ALL     0xffffffff

// Standard commands
#define evhSTD_USE_STATE   0x00000001
#define evhSTD_USE_STATUS  0x00000002
#define evhSTD_USE_STANDBY 0x00000004
#define evhSTD_USE_ONLINE  0x00000008
#define evhSTD_USE_OFF     0x00000010
#define evhSTD_USE_SELFTST 0x00000020
#define evhSTD_USE_TEST    0x00000040
#define evhSTD_USE_SIMULAT 0x00000080
#define evhSTD_USE_STOPSIM 0x00000100
#define evhSTD_USE_VERBOSE 0x00000200
#define evhSTD_USE_VERSION 0x00000400
#define evhSTD_USE_EXIT    0x00000800
#define evhSTD_USE_STOP    0x00001000
#define evhSTD_USE_INIT    0x00002000

// Special commands handled by CCS
#define evhSTD_USE_KILL    0x00004000
#define evhSTD_USE_BREAK   0x00008000
#define evhSTD_USE_PING    0x00010000


/**********************************************************/
/* Command names for implemented standard commands        */
/**********************************************************/

#include "evhSTD_COMMANDS_NAMES.h"

class evhSTD_COMMANDS : public evhDB_TASK
{
  public:
    evhSTD_COMMANDS(const dbSYMADDRESS  dbPoint, 
		    vltUINT32 commands = evhSTD_USE_ALL,
		    const char *version = "No module version set");
   ~evhSTD_COMMANDS();

    virtual evhCB_COMPL_STAT  StateCB(msgMESSAGE &msg, void *udata);
    virtual evhCB_COMPL_STAT  StatusCB(msgMESSAGE &msg, void *udata);
    virtual evhCB_COMPL_STAT  StandByCB(msgMESSAGE &msg, void *udata);
    virtual evhCB_COMPL_STAT  OnlineCB(msgMESSAGE &msg, void *udata);
    virtual evhCB_COMPL_STAT  OffCB(msgMESSAGE &msg, void *udata);
    virtual evhCB_COMPL_STAT  SelfTestCB(msgMESSAGE &msg, void *udata);
    virtual evhCB_COMPL_STAT  TestCB(msgMESSAGE &msg, void *udata);
    virtual evhCB_COMPL_STAT  SimulatCB(msgMESSAGE &msg, void *udata);
    virtual evhCB_COMPL_STAT  StopSimCB(msgMESSAGE &msg, void *udata);
    virtual evhCB_COMPL_STAT  VerboseCB(msgMESSAGE &msg, void *udata);
    virtual evhCB_COMPL_STAT  VersionCB(msgMESSAGE &msg, void *udata);
    virtual evhCB_COMPL_STAT  StopCB(msgMESSAGE &msg, void *udata);

    vltLOGICAL        Simulation();
    ccsCOMPL_STAT     Simulation(vltLOGICAL value);
    vltLOGICAL        Verbose();
    ccsCOMPL_STAT     Verbose(vltLOGICAL value);

    fndStdObjectDef(evhSTD_COMMANDS, evhDB_TASK);

  protected:
    virtual evhCB_COMPL_STAT  SetStateCB(vltINT32 newState,
					 msgMESSAGE &msg, 
					 void *udata);

    evhSTD_COMMANDS(); // NON to be used!!!

  private:

    vltUINT32       commands;
    const char     *version;

    vltLOGICAL     simulation;
    vltLOGICAL     verbose;
    eccsDB_LOGICAL dbSimulation;
    eccsDB_LOGICAL dbVerbose;
};

#endif /*!evhSTD_COMMANDS_H*/
