#ifndef evhSYNC_H
#define evhSYNC_H
/*******************************************************************************
* E.S.O. - VLT project
#
# "@(#) $Id: evhSYNC.h,v 1.135 2005/07/21 12:41:44 vltsccm Exp $" 
*
* evhSYNC.h
*
* who       when      what
* --------  --------  ----------------------------------------------
* gchiozzi 2001-09-18 evhSYNC inherits virtual public eccsERROR_CLASS as well.
* rkarban  06/08/99  remove defaulting to NULL in Action method
* gchiozzi  12/06/97  Replace ccsTIMEVAL with eccsTIMEVAL.
* vltsw  23/07/96  Derived public virtual from eccsERROR_CLASS
* gchiozzi  28/06/95  Restructured class
* gchiozzi  01/06/95  Completely restructured.
* gchiozzi  20/02/95  created
* 
*/

/************************************************************************
*
*----------------------------------------------------------------------
*/

#ifndef fndLIST_H
  #include "fndLIST.h"
#endif
#ifndef eccsMsg_H
  #include "eccsMsg.h"
#endif
#ifndef evhTIMEOUT_H
  #include "evhTIMEOUT.h"
#endif

class evhSYNC: public fndLIST, virtual public eccsERROR_CLASS
{
  public:
    evhSYNC();
   ~evhSYNC(); 

    ccsCOMPL_STAT Action(evhCALLBACK &newCB);
    ccsCOMPL_STAT AddCondition(const evhMSG_TYPE_KEY &key, 
			       int *flag = NULL, int value = TRUE);
    ccsCOMPL_STAT Timeout(evhCALLBACK &cb, eccsTIMEVAL interval);
    ccsCOMPL_STAT Timeout(eccsTIMEVAL interval);

    virtual int           Check();
    virtual ccsCOMPL_STAT ClearConditions();
    virtual ccsCOMPL_STAT Reset();
    virtual ccsCOMPL_STAT Run();

    virtual vltLOGICAL Status();

    fndStdObjectDef(evhSYNC, fndLIST);

  protected:
    virtual evhCB_COMPL_STAT  HandlerCB(msgMESSAGE &msg, void *udata);

    virtual evhCB_COMPL_STAT  _HandlerCB(msgMESSAGE &msg, void *udata);
    virtual evhCB_COMPL_STAT  _TimeoutCB(msgMESSAGE &msg, void *udata);

  private:
    vltLOGICAL   status;

    evhCALLBACK *cb;
    evhCALLBACK *timeout;
    eccsTIMEVAL  interval;
    evhTIMEOUT  *timeHndl;

}; /* end class evhSYNC */


/* This is a special class, used privately only */
/* by the class evhSYNC to hold the conditions  */
/* to be tested                                 */
class evhCONDITION : public fndOBJECT, virtual public eccsERROR_CLASS
{
  public:
    evhCONDITION();
    evhCONDITION(const evhMSG_TYPE_KEY &key,int *flag = NULL,int value = TRUE);
    
    virtual   ccsCOMPL_STAT Reset(evhCALLBACK &ocb);
    virtual   ccsCOMPL_STAT Run(evhCALLBACK &ocb);
    virtual   int           Status();
    virtual   ccsCOMPL_STAT TryUpdate(msgMESSAGE &msg);

    virtual   int IsEqual( const fndOBJECT& ) const;

    evhCONDITION  &operator         =( const evhCONDITION& );

    fndStdObjectDef(evhCONDITION, fndOBJECT);

  protected:
    
    virtual   evhMSG_TYPE_KEY  &Key();
    virtual   evhCONDITION     &Key(evhMSG_TYPE_KEY  &key);
    virtual   evhCONDITION     &Status(int status);

    int               Value();

  private:
    evhMSG_TYPE_KEY  key;
    int             *flag;
    int              value;
    int              status;
};

#endif /*!evhSYNC_H*/
