#ifndef evhTASK_H
#define evhTASK_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: evhTASK.h,v 1.135 2005/07/21 12:41:47 vltsccm Exp $" 
*
* who       when      what
* --------  --------  ----------------------------------------------
* gchiozzi  31/07/98  Added proper fndStdObject...() calls
* gchiozzi  12/06/97  Split in .h and .icc
* gchiozzi  13/02/97  Added include of evhCALLBACK.h
* gchiozzi  13/02/97  Added include of fndOBJECT.h
* gchiozzi  29/08/96  Added LogExitWarning()
* vltsw     23/07/96  Derived public virtual from eccsERROR_CLASS
* gchiozzi  28/07/95  Added class instances counter
* gchiozzi  28/07/95  Added INIT command handling
* gchiozzi  08/12/94  created
*/

#ifndef eccsMsg_H
  #include "eccsMsg.h"
#endif

#ifndef fndOBJECT_H
  #include "fndOBJECT.h"
#endif
#ifndef evhCALLBACK_H
  #include "evhCALLBACK.h"
#endif

#define evhEXIT_CMD "EXIT"
#define evhPING_CMD "PING"
#define evhINIT_CMD "INIT"

/************************************/
/* Definition for the evhTASK class */
/************************************/
class evhSIMPLE_TASK: public fndOBJECT, virtual public eccsERROR_CLASS
{
  public:
     evhSIMPLE_TASK();

     const char  *Name() const;

    fndStdObjectDef(evhSIMPLE_TASK, fndOBJECT);

  protected:
    char         *name;        /* Task name                           */

}; /* end class evhSIMPLE_TASK */


class evhTASK: public evhSIMPLE_TASK
{
  public:
    evhTASK();
    virtual ~evhTASK();
    
    virtual evhCB_COMPL_STAT  ExitCB(msgMESSAGE &msg, void *udata);
    virtual evhCB_COMPL_STAT  InitCB(msgMESSAGE &msg, void *udata);

    virtual ccsCOMPL_STAT     Init();

    static ccsCOMPL_STAT      LogExitWarning(vltLOGICAL flag=TRUE);

    fndStdObjectDef(evhTASK, evhSIMPLE_TASK);

  protected:
    static vltUINT32 TaskInstances();

  private:
    static vltUINT32  counter;
    static vltLOGICAL logExitWarning;

}; /* end class evhTASK */

#include "evhTASK.icc"

#endif /*!evhTASK_H*/
