#ifndef evhTIMEOUT_H
#define evhTIMEOUT_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: evhTIMEOUT.h,v 1.135 2005/07/21 12:41:47 vltsccm Exp $" 
*
* who       when      what
* --------  --------  ----------------------------------------------
* gchiozzi  12/06/97  Replace ccsTIMEVAL with eccsTIMEVAL.
* gchiozzi  12/06/97  Split in .h and .icc
* vltsw  23/07/96  Derived public virtual from eccsERROR_CLASS
* gchiozzi  28/06/95  The static 'cmd' is now allocated dynamically
* G.Chiozzi 11/02/94  Added headers and documentation
*/

/************************************************************************
*
*----------------------------------------------------------------------
*/

#ifndef fndOBJECT_H
  #include <fndOBJECT.h>
#endif

#ifndef eccsMsg_H
  #include "eccsMsg.h"
#endif
#ifndef evhCALLBACK_H
  #include "evhCALLBACK.h"
#endif
#ifndef evhMSG_TYPE_KEY_H
  #include "evhMSG_TYPE_KEY.h"
#endif


#define  evhTIMEOUT_CMD "TIMEOUT"

#define  evhTIMEOUT_CLASS  (classType)evhTIMEOUT::CreateNew

class evhTIMEOUT: public fndOBJECT, virtual public eccsERROR_CLASS
{
  public:
    evhTIMEOUT(evhCALLBACK &user_cb, eccsTIMEVAL interval);
   ~evhTIMEOUT();

    virtual   int           IsEqual( const fndOBJECT& ) const;

    fndStdObjectDef(evhTIMEOUT, fndOBJECT);

  protected:

    evhTIMEOUT(evhCALLBACK &user_cb); /* This is only for subclasses */
    vltLOGICAL   Status() const;
    virtual int  TimeoutCB(msgMESSAGE &msg, void *udata);

    void Init(evhCALLBACK &user_cb); /* Used by const. to init data struct */

    vltUINT32        requestId;
    evhCALLBACK     *cb;
    evhMSG_TYPE_KEY  key;

    static vltUINT32   count;
    static msgMESSAGE *cmd;

    evhTIMEOUT(){ /* not allowed */ };

  private:
    evhTIMEOUT &operator =(const evhTIMEOUT &) { 
                                 return *this; /* not allowed */ };

}; /* end class evhTIMEOUT */

#include "evhTIMEOUT.icc"

#endif /*!evhTIMEOUT_H*/
