/**************************************************************************
* E.S.O. - VLT project
#
# "@(#) $Id: evtCCS.h,v 2.53 2005/09/22 21:51:53 vltsccm Exp $" 
*
* <evt.h>  -  CCS/ON-LINE DATABASE EVENT Interface File
*
* who        when      what
* ---------  --------  ----------------------------------------------
* T.Herlin   13/09/94  Created
* T.Herlin   21/09/94  Changed filter type defines to enum evtFILTER
*                      Type changed on 'message' of evtParseMsg.
* T.Herlin   23/09/94  Removed evtPROC_INFO structure and replaced usage
*                      with msgPROCESSID.
* T.Herlin   27/09/94  Added evtAttachExt() and extended evtParseMsg() with
*                      the return of a userMsg.
* T.Herlin   29/09/94  Change evtEVENT to evtEVENT_ID due to LCC compliance.
* T.Herlin   28/10/94  Added LCU event message type
* M.COMIN    21/11/94  Add definitions for error mnemonics
* B.GUSTAFSSON 28/11/94 Created CCS specific include file
* T.EBERT    30/06/95  Include of Rtap header files by ccsRtap.h
*
************************************************************************
*/

/*
 *  Header Files
 */
#include "ccsRtap.h"
#include "evtErrors.h"


/*
 ***********************************************************************
 *  Database Event Generation                                          *
 ***********************************************************************
 */


/*
 *   Event Interface (Function Prototypes)
 */

ccsCOMPL_STAT evtAttachExt(        /* Extended evtAttach                   */
    dbSYMADDRESS        attrName,  /* Attribute name                       */
    evtFILTER           filter,    /* Condition to generate the event      */
    ccsENVNAME          evtEnv,    /* Event receiver process environment   */
    ccsPROCNAME         evtProc,   /* Event receiver process               */
    char                *userMsg,  /* User message attached to event       */
    evtEVENT_ID         *eventId,  /* Returned event identifier            */
    ccsERROR            *error     /* returned error structure             */
    );

vltLOGICAL evtIsEqual(evtEVENT_ID   *eventId1, /* Comparison between       */
                      evtEVENT_ID   *eventId2);/* evtEVENT_ID's            */ 







