/**************************************************************************
* E.S.O. - VLT project
#
# "@(#) $Id: evtPrivate.h,v 2.53 2005/09/22 21:51:54 vltsccm Exp $" 
*
* <evtPrivate.h>  -  CCS/ON-LINE DATABASE EVENT Private Interface File
*
* who        when      what
* ---------  --------  ----------------------------------------------
* T.Herlin   27/01/95  Created
* T.Ebert    05/02/96  Added include of string.h
* T.Ebert    19/01/00  removed prototype of dbGetHandle()
* B.Gilli    06/06/00  Moved evtMSG_STRUCT from evtLite.h, server commands also,
*                      but modified name to match LCU ones.
* T.Ebert    18/01/01  Added DEBUG command
*
************************************************************************
*/

#ifndef EVTPRIVATE_H
#define EVTPRIVATE_H

#define _POSIX_SOURCE 1
#include <vltPort.h>

/*
 * System Headers
 */
#include <stdlib.h>
#include <string.h>

/*
 *  Local Header Files
 */
#include "err.h"
#include "evt.h"

#define EVT_ATTACH   "EVTATT"
#define EVT_DETACH   "EVTDET"
#define EVT_ENABLE   "EVTSEN"
#define EVT_DISABLE  "EVTSDI"
#define EVT_DEBUG    "DEBUG"
#define EVT_BLOCKON  "EVTBLK"
#define EVT_BLOCKOFF "EVTUBL"

typedef struct
    {
    rtDbAddress    addr;
    dbSYMADDRESS   sym;
    dbPOINT        point;
    rtProcessId    proc;
    vltUINT8       enable;
    rtHangerStatus status;
    vltINT32       pri;
    vltUINT16      size;
    } evtMSG_STRUCT;

typedef struct
    {
    rtEventId   eventId;
    rtUInt8     enable;
    rtProcessId who;
    } evtMSG_CTRL;

/* 
 * function prototypes
 */ 
ccsCOMPL_STAT evtDirAddrToName(ccsENVNAME     envName,
			       dbDIRADDRESS   *dirAddr,
			       dbSYMADDRESS   pointName,       
			       ccsERROR       *error);

ccsCOMPL_STAT evtCheckType(dbSYMADDRESS pointName,
			  dbATTRTYPE   *attrType,
			  ccsERROR     *error);

ccsCOMPL_STAT evtSendCmd(msgCMD          command,
                         ccsENVNAME      envName,
                         char           *buffer,
                         msgLENGTH       bufLen,
                         msgCHECKFLAG    flag,
                         char           **recParam,
                         ccsERROR       *error);

#ifdef CCS_LIGHT
rtEventId *rtAttachDbEvent     (rtDbConnection dbConnection, rtDbAddress addr,
                                rtProcessId *who, rtUInt8 enable, rtHangerStatus status,
                                rtInt32 pri, rtUInt16 size, rtHangerMsg *msg);

rtInt32    rtDetachFromEvent   (rtEventId eventId, rtProcessId *who, rtUInt8 enable);

rtInt      rtChangeEventStatus (rtEventId eventId, rtProcessId *who, rtUInt8 enable,
                                rtHangerStatus status);
#else
rtEventId *rtAttachDbEventLite     (rtDbConnection dbConnection, rtDbAddress addr,
                                rtProcessId *who, rtUInt8 enable, rtHangerStatus status,
                                rtInt32 pri, rtUInt16 size, rtHangerMsg *msg);

rtInt32    rtDetachFromEventLite   (rtEventId eventId, rtProcessId *who, rtUInt8 enable);

rtInt      rtChangeEventStatusLite (rtEventId eventId, rtProcessId *who, rtUInt8 enable,
                                rtHangerStatus status);
#endif

#endif /* EVTPRIVATE_H */










