/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: fcdBENNER.h,v 2.140 2005/10/17 15:17:04 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* rdonalds  22/01/99  Created
*/

/*************************************************************************
 *  This file contains Internal definitions for C++ modules
*************************************************************************/

#ifndef FCDBENNER_H
#define FCDBENNER_H

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

#include <fcdGLOBAL.h>
#include <fcdBennerIf.h>


class fcdBENNER
{
  public:
    fcdBENNER();
    ~fcdBENNER();

    /*
     *# Initialise/unitialise the object
     */
    ccsCOMPL_STAT Init(vltLOGICAL simHw, vltLOGICAL aoMode);
    ccsCOMPL_STAT Uninit();
    
    /*
     *# Return indication of FIFOs present or not
     */
    vltLOGICAL     Populated() {return populated;};

    /*
     *# Set the sub-sampling of the board to N
     */
    ccsCOMPL_STAT  SSample(vltINT32 n);

    /*
     *# Enable/disable the acquisition of frames
     */
    ccsCOMPL_STAT  Enable();
    ccsCOMPL_STAT  Disable();
    ccsCOMPL_STAT  PassThrough(vltLOGICAL v);

  private:
    
    /*
     *# Set and get register contents
     */
    ccsCOMPL_STAT SetReg(int reg, unsigned int value);
    ccsCOMPL_STAT GetReg(int reg, unsigned int *value);

    vltLOGICAL    initialised;

    vltLOGICAL    simHw;     /* H/W simulated flag */
    
    vltLOGICAL    populated; /* flag indicating that the FIFOs are present */
    
    int           boardFd;   /* file descriptor to board */
};


#endif /* ! _H */
