#ifndef FCDBOARD_CONFIG_PARSERH
#define FCDBOARD_CONFIG_PARSERH
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: fcdBOARD_CONFIG_PARSER.h,v 2.140 2005/10/17 15:16:56 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* rdonalds  23/05/96  created
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif


// Include files for standard C++ library components
#include <iostream>
#include <fstream>
#include <string>
#include <vector>

// Normal fcd includes
#include "fcd.h"

#include "fcdTOKENISER.h"	// for Tokenising the ASCII files
#include "fcdBOARD_CONFIG.h"	// Definition of board config etc

/*************************************/
/*************************************/


/*
 *# fcdBOARD_PARSER
 *#
 *# Board definition  parser
 */
class fcdBOARD_PARSER
{
public:
  /*
   *# ParseDef
   *# Get an ASCII representation from file using tokeniser
   */
  ccsCOMPL_STAT	ParseDef (fcdBOARD *board,
			  fcdTOKENISER &tok, fcdTOKEN &token);
private:
  // Local pointer to the board being parsed
  fcdBOARD *board;

    // Internal parsing functions for the list of simms and each simm
  ccsCOMPL_STAT	ParseSimm(fcdSIMM &simm,
			fcdTOKENISER &tok, fcdTOKEN &token);

  // Methods to parse each type of board definition
  ccsCOMPL_STAT	ParseClkdrvbrd(fcdTOKENISER &tok, fcdTOKEN &token);
  ccsCOMPL_STAT	ParseCommbrd(fcdTOKENISER &tok, fcdTOKEN &token);
  ccsCOMPL_STAT	ParseVidbrd(fcdTOKENISER &tok, fcdTOKEN &token);
  ccsCOMPL_STAT	ParseAnabiasbrd(fcdTOKENISER &tok, fcdTOKEN &token);
};

/*
 *# fcdBOARD_CONFIG_PARSER
 *#
 *# Board definition list  parser
 */
class fcdBOARD_CONFIG_PARSER
{
public:
    /*
     *# GetFromDir
     *#
     *# Get an ASCII representation from files in a given directory
     */
    ccsCOMPL_STAT	GetFromDir(fcdBOARD_CONFIG *,
				const string &dirName);

    // Output in ASCII
    ccsCOMPL_STAT	PutToDir(fcdBOARD_CONFIG *,
				const string &dirName);
    ccsCOMPL_STAT	PutToFile(fcdBOARD_CONFIG *,
				const string &fileName);
private:
    fcdBOARD_CONFIG	*config;

    ccsCOMPL_STAT	GetFromFile(const string &fileName);
};

#endif /*!FCDBOARD_CONFIG_PARSERH*/
