#ifndef FCDCAMERANAMES_H
#define FCDCAMERANAMES_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: fcdCAMERA_NAMES.h,v 2.140 2005/10/17 15:16:56 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* rdonalds  14/04/97  created
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

#include "fcdINTERNAL.h"

class fcdCAMERA_NAMES
{
public:
  // c'tor d'tor
  fcdCAMERA_NAMES();
  ~fcdCAMERA_NAMES();

  /*
   *# Initialise and uninitialise routines
   */
  ccsCOMPL_STAT Init ();
  ccsCOMPL_STAT Uninit ();

  /* 
   *# Get the camera names for this controller from a 
   *# given config directory
   */
  ccsCOMPL_STAT GetFromDir(fcdCAMERANAME cameraName, char *dirname);

  /*
   *# Return the number of cameras in this configuration
   *# and the name of the given Camera
   */
  vltINT32 NumCameras();
  fcdCAMERANAME &operator[](vltINT32);

  /*
   *# find the index for a given camera name or -1 if !exists
   */
  vltINT32 Index (char *cameraName);

  /*
   *# Compare two camera configurations
   */
  int eq( fcdCAMERA_NAMES &) ;
private:
  vltINT32      numCameras;
  fcdCAMERANAME cameraNames[fcdMAXDETECTORS];

  /*
   *# Add camera to current list
   */
  ccsCOMPL_STAT AddCamera (char *cameraName);
};

/*****************************************************************
    INLINE METHODS
*****************************************************************/

inline vltINT32 fcdCAMERA_NAMES::NumCameras()  {return numCameras;}

#endif /*!_H*/
