#ifndef FCDCSTATE
#define FCDCSTATE
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: fcdCSTATE.h,v 2.140 2005/10/17 15:16:46 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* rdonalds  01/05/96  created
* rdonalds  5/06/98  moved to ws branch
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

#include "fcdINTERNAL.h"

class fcdCSTATE
{
public:
  /*
   *# The database point can be set either at creation time or
   *# using the Init method.
   */
  fcdCSTATE(const fcdCAMERANAME name = "",
	    const dbSYMADDRESS address = "");
  ccsCOMPL_STAT Init (const fcdCAMERANAME, const dbSYMADDRESS address);
  ~fcdCSTATE();

  ccsCOMPL_STAT State(fcdSTATE newState);	// Set state
  fcdSTATE	State(void);			// Get state
  
private:
  // Name of the camera this STATE is for
  fcdCAMERANAME cameraName;

  // Local copy of the database point to be updated
  dbSYMADDRESS  dbPoint;

  // The current value
  fcdSTATE	opState;

  // Update function
  ccsCOMPL_STAT UpdateDB();
};
/*****************************************************************
  INLINE METHODS
*****************************************************************/
inline fcdSTATE fcdCSTATE::State ()
{
    return (opState);
}

#endif /*!FCDPROC_STATE_H*/
