/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: fcdDETCONFIG.h,v 2.140 2005/10/17 15:16:46 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* rdonalds  04/04/97  created 
* rdonalds  5/06/98  moved to ws branch
* rdonalds  23/07/98  Added double buffer and clock speed attributes
* rdonalds  28/10/98  Support for maxFrames
*/

/************************************************************************
*   NAME
*   
* 
*   SYNOPSIS
*
*   
*   PARENT CLASS
*
* 
*   DESCRIPTION
*
*
*   PUBLIC METHODS
*
*
*   PUBLIC DATA MEMBERS
*
*
*   PROTECTED METHODS
*
*
*   PROTECTED DATA MEMBERS
*
*
*   PRIVATE METHODS
*
*
*   PRIVATE DATA MEMBERS
*
*
*   FILES
*
*   ENVIRONMENT
*
*   COMMANDS
*
*   RETURN VALUES
*
*   CAUTIONS 
*
*   EXAMPLES
*
*   SEE ALSO
*
*   BUGS   
* 
*------------------------------------------------------------------------
*/
#ifndef FCDDETCONFIG_H
#define FCDDETCONFIG_H


#define _POSIX_SOURCE 1

#include "vltPort.h"

#include "fcdINTERNAL.h"
#include "fcdDETID.h"

/*
 * fcdDETCONFIG
 *
 * Class representing a detector configuration. This is read from the OL-DB
 * at startup
 *
 */
class fcdDETCONFIG
{
public:
    fcdDETCONFIG();
    ~fcdDETCONFIG();

    // Get the configuration from the DB
    ccsCOMPL_STAT        Init (fcdDETID *detName);

    // Accessor functions
    vltINT32	TotalPixels();
    vltINT32	TotalPixelBytes();
    vltINT32    MaxFrames() {return config.maxFrames;}
    vltINT32	XTotalPixels() {return (config.xTotalPixels);}
    vltINT32	YTotalPixels() {return (config.yTotalPixels);}
    vltINT32	BitsPixel()    {return (config.bitsPixel);}
    vltINT32	BytesPixel()   {return (BitsPixel() / 8);}

    // Return the reference pixel for detector
    vltDOUBLE   Crval1();
    vltDOUBLE   Crval2();
  
    vltLOGICAL    FrameTransfer() {return (config.frameTransfer);}
  
    vltLOGICAL    DoubleBuffered() {return (config.doubleBuffered);}
    vltLOGICAL    SyncMaster() {return (config.syncMaster);}
    vltLOGICAL    AODetector() {return (config.aoDetector);}
    vltDOUBLE     ClockSpeed() {return (config.clockSpeed);}


    fcdCONFIG     &Config() {return (config);}
  private:
    fcdCONFIG            config;   /* 'C' structure holding config info */
};


#endif /* _H */

/*___oOo___*/
