#ifndef FCDDETID_H
#define FCDDETID_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: fcdDETID.h,v 2.140 2005/10/17 15:16:44 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* rdonalds  14/04/97  created
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

#define _POSIX_SOURCE 1

#include "vltPort.h"
#include "fcdINTERNAL.h"

/* class which holds name and environement for a camera */
class fcdDETID
{
public:
  fcdDETID();
  ~fcdDETID();
  
  /*
   *# Init for a given camera name
   */
  ccsCOMPL_STAT Init (fcdCAMERANAME name);

  /*
   *# Accessor functions
   */
  fcdCAMERANAME   &Name() {return (name);}
  char            *CCDDictName() {return (ccdDictName);}
  char            *FCDDictName() {return (fcdDictName);}
  string          &DbBaseAddr(){return (addrPref);}
  char            *DbBaseAddrC(){return ((char *)addrPref.c_str());}
private:
  fcdCAMERANAME   name;        /* camera name      */
  fcdFILENAME     ccdDictName;    /* name of the CCD data dictionary */
  fcdFILENAME     fcdDictName;    /* name of our dictionary */
  string          addrPref;    /* prefix common to all DB attributes     */
};


/*****************************************************************
    INLINE METHODS
*****************************************************************/

#endif /*!_H*/
