/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: fcdDETTIMES.h,v 2.140 2005/10/17 15:16:57 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* rdonalds  04/04/97  created 
*/

/************************************************************************
*   NAME
*   
* 
*   SYNOPSIS
*
*   
*   PARENT CLASS
*
* 
*   DESCRIPTION
*
*
*   PUBLIC METHODS
*
*
*   PUBLIC DATA MEMBERS
*
*
*   PROTECTED METHODS
*
*
*   PROTECTED DATA MEMBERS
*
*
*   PRIVATE METHODS
*
*
*   PRIVATE DATA MEMBERS
*
*
*   FILES
*
*   ENVIRONMENT
*
*   COMMANDS
*
*   RETURN VALUES
*
*   CAUTIONS 
*
*   EXAMPLES
*
*   SEE ALSO
*
*   BUGS   
* 
*------------------------------------------------------------------------
*/
#ifndef FCDDETTIMES_H
#define FCDDETTIMES_H

/* POSIX does not work on Solaris
#define _POSIX_SOURCE 1
*/
#include "vltPort.h"

// Need to forward declare exposure class
class fcdEXPOSURE;

#include "fcdINTERNAL.h"
#include "fcdtimsTIME.h"
#include "fcdSHUTTER.h"

/* forward declaration of classes used by fcdDETTIMES */
class fcdDETECTOR;
class fcdEXPOSURE;

/*
 *# fcdT_DETTIMES
 *# 
 *# Structure holding the times significant for a detector in shared mem
 */
typedef struct
{
  fcdtimsTIME darkStart;         /* start of dark current integration time */

  fcdtimsTIME wipeStart;         /* wipe times                             */
  vltDOUBLE   wipeTime;
  fcdtimsTIME wipeEnd;

  fcdT_SHUTTER_TIME shutOpen;   /* shutter timing */
  fcdT_SHUTTER_TIME shutClose;
} fcdT_DETTIMES;
/*
 *# fcdDETTIMES
 *# 
 *# Class used to access the DETTIMES structure in shared memory
 */
class fcdDETTIMES
{
public:
  /* c'tor d'tor */
   fcdDETTIMES();
  ~fcdDETTIMES();

  /* create, attach, detach */
  ccsCOMPL_STAT Create(fcdDETECTOR *, fcdT_DETTIMES *);
  ccsCOMPL_STAT Attach(fcdDETECTOR *, fcdT_DETTIMES *);
  ccsCOMPL_STAT Detach();

  /* wipe start/end recording */
  ccsCOMPL_STAT WipeStart();
  ccsCOMPL_STAT WipeEnd();

  /* end of readout recording ... updates dark start */
  ccsCOMPL_STAT ReadEnd();
  
  /* store/return  shutter open/close timing */
  void ShutterCloseTime(fcdT_SHUTTER_TIME &t) {shTimes->shutClose = t;}
  void ShutterOpenTime(fcdT_SHUTTER_TIME &t)  {shTimes->shutOpen = t;}
  fcdtimsTIME &ShutterOpenTime () {return (shTimes->shutOpen.middle);}
  vltDOUBLE   ShutterOpenDuration () {return (shTimes->shutOpen.duration);}
  fcdtimsTIME &ShutterCloseTime () {return (shTimes->shutClose.middle);}
  vltDOUBLE   ShutterCloseDuration () {return (shTimes->shutClose.duration);}

  /* dark start */
  fcdtimsTIME   DarkStart() {return (shTimes->darkStart);}
private:
  // Pointer to the time structure in shared mem
  fcdT_DETTIMES *shTimes;
  fcdDETECTOR   *det;

  // Initialise shared data
  ccsCOMPL_STAT CreateT_DETTIMES();
};

#endif /* _H */

/*___oOo___*/
