/*************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: fcdDLListPtr.h,v 2.140 2005/10/17 15:16:57 vltsccm Exp $"
*
* who       when      what
*************************************************************************/
/* @(#) DLListPtr.h Release 1.6 11/30/94 */
/***************************** module header ***********************************
*   ESTEC/WGE                              *
*                                          *
*   ****    *****   *****   *****  *****   *   Project: EGSE Kernel
*   *   *   *       *       *      *       *
*   *   *   *       *       *      *       *
*   *   *   *****   * ***   *****  *****   *   Filename: DLListPtr.H
*   *   *   *       *   *       *  *       *
*   *   *   *       *   *       *  *       *
 *   ****    *****   *****   *****  *****  *
*                                          *
*   Distributed EGSE                       *
********************************************************************************
** Description:**

	C++ header file for class maintaining a double linked list
	of pointers.

	This is stolen from G++ because I wanted to avoid using templates
	(these are not very well supported using the CenterLine compiler)

	List contains pointers only, lists are indexed by a Pix

********************************************************************************
** Update record:**  <date> <name> <description...> 

Thu May 19 15:43:30 MET DST 1994
	R. Donaldson
	Original

******************************** end of module header *************************/

#ifndef fcdDLListPtr_H
#define fcdDLListPtr_H

typedef void *Pix;

class fcdDLNodePtr
{
public:
    fcdDLNodePtr *fd;
    fcdDLNodePtr *bk;
    void *item;

    fcdDLNodePtr (void *x);
};

class fcdDLListPtr
{
    fcdDLNodePtr *h;

public:
    fcdDLListPtr();
    ~fcdDLListPtr();

    // insert an item returning its Pix
    Pix append (void *item);
    Pix prepend (void *item);

    // insert an item before the item identified by Pix p
    Pix ins_before (Pix p, void *item);
    
    // remove front/rear and return it
    void *remove_front ();
    void *remove_rear ();

    // return length of list
    int length();

    // EGSE_boolean empty
    int empty();

    // Make the list empty
    void clear();

    // index the list by Pix and return the item there
    // i.e. item = list(p)
    void *operator () (Pix p);

    // return Pix of first item
    Pix first();

    // return next using Pix returned by first
    void next (Pix& p);

    // delete thing refered to by Pix advancing the pointer as needed
    void del (Pix &p);

    // return front of list
    void *front();
};
#endif
