#ifndef FCDFITS_H
#define FCDFITS_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: fcdFITS.h,v 2.140 2005/10/17 15:17:01 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* rdonalds  25/05/98
*/

/************************************************************************
 *
 * Class to encapsulte the creation of FITS information for transfer
 * to the WS
 *
 * We currently have two different formats for this information. One
 * which is inherited from the ACE CCD S/W and used with the "old"
 * fcdit process, and the other used by the "new" fcdit process
 * which handles image extensions
 *----------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif


// Include files for standard C++ library components
#include <iostream>
#include <fstream>
#include <string>

// Normal fcd includes
#include "fcdINTERNAL.h"
#include "fcdEXPOSURE.h"
#include "slx.h"

class fcdFITS
{
  public:
    fcdFITS();
    ~fcdFITS();
  
    ccsCOMPL_STAT Init();
    ccsCOMPL_STAT Uninit();
  
    /*
     *# Prepare the appropriate structures
     */
    ccsCOMPL_STAT PrepareOldFITSLoop (fcdEXPOSURE *exp);
    ccsCOMPL_STAT PrepareOldFITSBasic (fcdEXPOSURE *exp);
    ccsCOMPL_STAT PrepareOldFITSHier (fcdEXPOSURE *exp);

    /*
     *# Return the structures
     */
    fcdFITSBASIC      &OldFITSBasic() {return (oldExpFITSBasic);};
    fcdFITSHIERARCH   &OldFITSHier()  {return (oldExpFITSHier);};

  private:
    fcdEXPOSURE *curExposure;
    vltLOGICAL  initialised;

    fcdFITSBASIC      oldExpFITSBasic;/* FITS basic header		    */
    fcdFITSHIERARCH   oldExpFITSHier; /* FITS Hierarchical header        */
};
/*****************************************************************************
*	INLINE METHODS
*****************************************************************************/

#endif /*!_H */
