/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: fcdGLOBAL.h,v 2.140 2005/10/17 15:16:58 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* rdonalds  04/04/97  created 
*/

/************************************************************************
*   NAME
*   
* 
*   SYNOPSIS
*
*   
*   PARENT CLASS
*
* 
*   DESCRIPTION
*
*
*   PUBLIC METHODS
*
*
*   PUBLIC DATA MEMBERS
*
*
*   PROTECTED METHODS
*
*
*   PROTECTED DATA MEMBERS
*
*
*   PRIVATE METHODS
*
*
*   PRIVATE DATA MEMBERS
*
*
*   FILES
*
*   ENVIRONMENT
*
*   COMMANDS
*
*   RETURN VALUES
*
*   CAUTIONS 
*
*   EXAMPLES
*
*   SEE ALSO
*
*   BUGS   
* 
*------------------------------------------------------------------------
*/
#ifndef FCDGLOBAL_H
#define FCDGLOBAL_H

#define _POSIX_SOURCE 1

#include "vltPort.h"
#include "fcdINTERNAL.h"
#include "fcdDETECTOR.h"
#include "fcdSLCU_PROCESS.h"
#include "fcdSHARED_DATA.h"
#include "fcdTIM.h"

class fcdCAMERA_NAMES;


/*
 * fcdT_GLOBAL
 *
 * Sructure which goes into shared memory holding the global information
 */
typedef struct {
    int            seqSemId;   /* semaph used for exclusive sequencing */

    fcdFILENAME    configDir;   /* name of the configuration */
    vltINT32       numDetectors;  /* number of detectors in configuration  */
    fcdCAMERANAME  detectorNames[fcdMAXDETECTORS]; /* names of the detectors */

    /* shared info for each detector up to numDetectors */
    fcdT_DETECTOR  detectors[fcdMAXDETECTORS];
} fcdT_GLOBAL;

/*
 * fcdGLOBAL
 *
 * Global configuration and dynamic information
 */
class fcdGLOBAL
{
  public:
    /* c'tor d'tor */
    fcdGLOBAL();
    ~ fcdGLOBAL();

    /* Create, attach, detach */
    ccsCOMPL_STAT Create (fcdSLCU_PROCESS *proc);
    ccsCOMPL_STAT Attach (fcdSLCU_PROCESS *proc, int shmId);
    ccsCOMPL_STAT Detach();

    /* 
       operations for exclusive access to the detector head 
       coordinate via a semaphore, this can be modified by the
       functions or directly using the SeqSemId(). the semaphore
       functions should be sem_wait(), sem_try_wait(), sem_signal()
       defined in semaph.h
       */
    int           SeqSemId() {return (shGlobal->seqSemId);}
    ccsCOMPL_STAT CheckExclusive();
    ccsCOMPL_STAT CheckSetExclusive();
    ccsCOMPL_STAT WaitSetExclusive();
    ccsCOMPL_STAT ReleaseExclusive();

    /*
      return the shared memory Id of the T_GLOBAL, this is necessary
      for the process which creates the object. It must get the shmId
      so it can pass this to other processes to allow them to Attach
      */
    int           ShmId() {return (shData.ShmId());}

    /* return rhe number of detectors  and the specified detector */
    vltINT32      NumDetectors() {return shGlobal->numDetectors;}
    fcdDETECTOR   *Detector(const fcdCAMERANAME name, vltINT32 *detIndex);
    fcdDETECTOR   *Detector(vltINT32 index);

    /* directory where the fiera config files are read from */
    fcdFILENAME   &ConfigDir() {return shGlobal->configDir;}
    
    /* return pointer to tim object */
    fcdTIM         *Tim() {return &tim;}
  private:
    vltLOGICAL     initialised;
    vltLOGICAL     created; // necessary so we can delete the semaphore

    /* shared memory object */
    fcdSHARED_DATA  shData;

    /* interface to TIM board */
    fcdTIM          tim;

    /* pointer to shared stuff */
    fcdT_GLOBAL    *shGlobal;

    /* the process identifier of the creator */
    fcdSLCU_PROCESS *proc;

    fcdDETECTOR    detectors[fcdMAXDETECTORS];     /* the detector objects */

    /* create, attach, detach function for the shared mem segment */
    ccsCOMPL_STAT  CreateT_GLOBAL(fcdFILENAME     configDirName,
				  fcdCAMERA_NAMES &cameraNames);
    ccsCOMPL_STAT  AttachT_GLOBAL(int shmId);
    ccsCOMPL_STAT  DetachT_GLOBAL();
};

#endif
/*___oOo___*/
