#ifndef FCDLOG_H
#define FCDLOG_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: fcdLOG.h,v 2.140 2005/10/17 15:16:47 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* rdonalds  17/04/97  created
* rdonalds  5/06/98  moved to ws branch
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */

#ifdef __cplusplus
extern "C" {
#endif

#include <stdio.h>
#include <stdarg.h>

#include <fcd.h>

/*
 *# Definition of loging level
 */
typedef enum {
  fcdLOG_ERROR_val,
  fcdLOG_ALLWAYS_val,
  fcdLOG_INFO1_val,
  fcdLOG_INFO2_val,

  /* leave this one as a marker for the end */
  fcdLOG_LAST_val
} fcdLOG_LEVEL;

/*
 *# Control of log level and log destination
 */
void fcdLogToScreen (vltLOGICAL toScreen);
void fcdLogToLog (vltLOGICAL toLog);
void fcdLogLevel (fcdLOG_LEVEL logLevel);
fcdLOG_LEVEL fcdLogGetLevel(void);

/*
 *# Logging functions
 */
void fcdLogInfo (
	     fcdLOG_LEVEL level, 
	     const char *format, 
	     ...
	     );

void fcdLogAllways (const char *format, ...);
void fcdLogInfo1 (const char *format, ...);
void fcdLogInfo2 (const char *format, ...);
void fcdLogError ( const char *format,  ... );


/*
 *# Special function for logging into the DB progress display
 */
void fcdLogProgress (const char *format, ...);

/*
 *# Macros which can be used to remove logging at compile time
 */
#define fcdLOG(stuff)        fcdLogAllways stuff;
#define fcdLOG_INFO1(stuff)  fcdLogInfo1 stuff;
#define fcdLOG_INFO2(stuff)  fcdLogInfo2 stuff;

#ifdef __cplusplus
}
#endif

#endif /*!_H*/
