#ifndef FCDPP_H
#define FCDPP_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: fcdPP.h,v 2.140 2005/10/17 15:17:01 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* rdonalds  23/05/96  created
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif


// Include files for standard C++ library components
#include <iostream>
#include <fstream>
#include <string>

// Normal fcd includes
#include "fcdINTERNAL.h"
#include "fcdEXPOSURE.h"
#include "fcdDETECTOR.h"
#include "rtd/rtdImageEvent.h"

#define fcdPP_PREP_CALC 1
#define fcdPP_PREP_RTD  2
#define fcdPP_PREP_FITS 4

class fcdPP
{
  public:
    fcdPP();
    ~fcdPP();
  
    ccsCOMPL_STAT Init(fcdDETECTOR *det);
    ccsCOMPL_STAT Uninit();
  
    /*
     *# Preparation for a loop and for the individual exposure
     *# The prepWhich should be orred fromfcdPREP_CALC, RTD
     */
    ccsCOMPL_STAT PrepareLoop (fcdEXPOSURE *exp, vltINT32 prepWhich);
    ccsCOMPL_STAT PrepareExposure (fcdEXPOSURE *exp);
  
    ccsCOMPL_STAT PP();
    ccsCOMPL_STAT DisplayUpdate();
    ccsCOMPL_STAT StoreExposure();
    ccsCOMPL_STAT LocalCalculation();
  
  private:
    vltINT32 prepWhich;

    rtdIMAGE_EVT_HNDL rtdHandle;
    rtdIMAGE_INFO     rtdInfo;         /* info needed by rtd         */

    ccsCOMPL_STAT ReInitPP ();
  
    ccsCOMPL_STAT RtdUpdate ();
    ccsCOMPL_STAT WindowLocalCalculation (vltINT32 winNum,
					  vltLOGICAL rms, vltLOGICAL minMax,
					  fcdEXPOSURE_WINDOW *win,
					  fcdCSETUP *setup);

    ccsCOMPL_STAT PrepareRTD();
  
    fcdCAMERANAME	cameraName;
    vltLOGICAL initialised;

    fcdEXPOSURE *curExposure;
};
/*****************************************************************************
*	INLINE METHODS
*****************************************************************************/

#endif /*!FCDPP_H */
