/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: fcdPULPO_CONFIG.h,v 2.140 2005/10/17 15:17:03 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* rdonalds  16/06/97  created
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

#ifndef FCDPULPO_CONFIGH
#define FCDPULPO_CONFIGH

/*
 * FCD header files
 */
#include "fcdINTERNAL.h"
#include "fcdPULPO.h"


#define fcdMAX_PULPO 2

/*
 *# Structure holding a unit id and the pulpo itself
 */
typedef struct
{
    vltINT32 unit;
    fcdFILENAME device;
    fcdPULPO pulpo;
} fcdPULPO_ENTRY;
/*
 *# Class which reads the PULPO configuration and holds a list
 *# ofavailable PULPO objects
 */
class fcdPULPO_CONFIG
{
  public:
    /* ctor dtor */
    fcdPULPO_CONFIG();
    ~fcdPULPO_CONFIG();

    vltLOGICAL Simulated() {return simulated;};


    /*
     *# GetFromDir
     *#
     *# Initialise the config from given directory
     */
    ccsCOMPL_STAT GetFromDir (const string &dirName);

    /*
     *# Init
     *#
     *# Initialise the PULPO interface objects with the provided level of
     *# simulation
     */
    ccsCOMPL_STAT Init( char *cfgPath, vltLOGICAL simulate);
    ccsCOMPL_STAT Uninit();

    /*
     *# Return a pointer to the PULPO with a given unit number
     */
    fcdPULPO *FindPulpo (vltINT32 unit);

    /*
     *# GetSensor 
     *#
     *# Get sensor id
     */
    ccsCOMPL_STAT GetSensor (vltINT32 unit, vltINT32 sensorId, 
			     vltDOUBLE *value);

  private:
    vltLOGICAL simulated;
    vltINT32 nPulpos;
    fcdPULPO_ENTRY pulpo[fcdMAX_PULPO];
};

#endif /*!_H*/
