#ifndef fcdSLCUPARAM_BUFFER_H
#define fcdSLCUPARAM_BUFFER_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: fcdParamBuffer.h,v 2.140 2005/10/17 15:17:02 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* rdonalds  03/06/97  created
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is C++
#endif

#include "vltPort.h"
#include "fcdInternal.h"

#define fcdPARAM_BUFFER_LEN 255

/*
 *# We have to change the parameter buffers sent to processes like fcdcon
 *# so that they have the Detector Name in them, otherwise fcdexp will
 *# not know which detector the command is for.
 *#
 *# Hence we must copy the parameter buffers :-(
 *#
 */
typedef char fcdPARAM_BUFFER[fcdPARAM_BUFFER_LEN+1];

/*
 *# fcdSlcuMakeParamBuffer 
 *#
 *# Make a new parameter buffer by adding the detector id at the front
 */
extern ccsCOMPL_STAT fcdSlcuMakeParamBuffer (
			  char          *cameraName,
			  char          *oldParamBuffer,
			  char          *newParamBuffer
			  );

/*
 *# fcdSlcuInterpretParamBuffer 
 *#
 *# Interpret a parameter buffer which should contain a detector
 *# name and the real parameter data. Makes paramBuffer point to the start
 *# of the original parameter data, and cameraName point to the detname
 */
extern ccsCOMPL_STAT fcdSlcuInterpretParamBuffer (
			  char          *oldParamBuffer,
			  char          **cameraName,
			  char          **paramBuffer
			  );

#ifdef __cplusplus
#endif

#endif /*!_H*/
