#ifndef FCDSEQUENCE_CREATOR_H
#define FCDSEQUENCE_CREATOR_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: fcdSEQUENCE_CREATOR.h,v 2.140 2005/10/17 15:17:03 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* rdonalds  23/05/96  created
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif


// Include files for standard C++ library components

// Normal fcd includes
#include "fcd.h"
#include "fcdCSETUP.h"
#include "fcdFIERA_CONFIG.h"
#include "fcdDETECTOR.h"
#include "fcdC40.h"

class fcdSEQUENCE_CREATOR
{
  public:
    fcdSEQUENCE_CREATOR();
    ~fcdSEQUENCE_CREATOR();

    /*
     *# Create a sequence for reading out a window
     *# defined in setup
     */
    ccsCOMPL_STAT CreateWindowedReadSeq(
					   fcdDETECTOR     *det,
					   fcdCSETUP       *setup,
					   fcdCONFMODE     *mode,
					   fcdFIERA_CONFIG *config,
					   fcdSEQUENCE     **seq
					   );

    /*
     *# Create the shift sequence required for
     *# a EXP_MULTI exposure
     */
    ccsCOMPL_STAT CreateShiftSeq(
					   fcdDETECTOR     *det,
					   fcdCSETUP       *setup,
					   fcdCONFMODE     *mode,
					   fcdFIERA_CONFIG *config,
					   fcdSEQUENCE     **seq
					   );
  private:
};
#endif /*!FCDSEQUENCE_H*/
