/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: fcdSHARED_DATA.h,v 2.140 2005/10/17 15:16:46 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* rdonalds  04/04/97  created 
* rdonalds  5/06/98  moved to ws branch
*/

/************************************************************************
*   NAME
*   
* 
*   SYNOPSIS
*
*   
*   PARENT CLASS
*
* 
*   DESCRIPTION
*
*
*   PUBLIC METHODS
*
*
*   PUBLIC DATA MEMBERS
*
*
*   PROTECTED METHODS
*
*
*   PROTECTED DATA MEMBERS
*
*
*   PRIVATE METHODS
*
*
*   PRIVATE DATA MEMBERS
*
*
*   FILES
*
*   ENVIRONMENT
*
*   COMMANDS
*
*   RETURN VALUES
*
*   CAUTIONS 
*
*   EXAMPLES
*
*   SEE ALSO
*
*   BUGS   
* 
*------------------------------------------------------------------------
*/
#ifndef fcdSHAREDDATA_H
#define fcdSHAREDDATA_H

#include "vltPort.h"
#include "fcdINTERNAL.h"
#include "errno.h"

/*
 *# fcdSHARED_DATA
 *# 
 *# Class for manipulating a shared memory block
 *# This class needs to be extended to support allocating sub-blocks
 *# from within the shared memory
 */
class fcdSHARED_DATA
{
public:
  /* c'tor, d'tor */
  fcdSHARED_DATA();
  ~fcdSHARED_DATA();

  /* create, attach, detach */
  ccsCOMPL_STAT Create(vltINT32 size);
  ccsCOMPL_STAT Attach(vltINT32 size, vltINT32 shmId);
  ccsCOMPL_STAT Detach();

  void          *Data();       /* return the data */
  int           ShmId();       /* reurn shared memory id */
private:
  /* init the shared segment when attaching or creating */
  ccsCOMPL_STAT     Init();

  vltLOGICAL        initialised; /* initialised yet ? */
  vltLOGICAL        attached;    /* attached or created ? */


  void              *data;       /* the data mapped into local space */

  vltINT32	    shmSize;	/* size of shared memory segment    */
                                /* in bytes			    */
  int		    shmId;	/* shared memory identifier (int)   */
                                /* because that's what shmat(2)     */
                                /* returns			    */
};

/*
 *#############################################################################
 *# Inline methods
 *#############################################################################
 */
inline void *fcdSHARED_DATA::Data() {return (data);}
inline int   fcdSHARED_DATA::ShmId() {return (shmId);}

#endif /* _H */

/*___oOo___*/
