#ifndef FCDSOCK_H
#define FCDSOCK_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: fcdSOCK.h,v 2.140 2005/10/17 15:16:44 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* abalestr  01/12/97  created
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

/*#define _POSIX_SOURCE 1*/

#include "vltPort.h"

/* 
*# Not very POSIX typedefs....
*# but otherwise these typedefs (defined in types.h) are not included under 
*# Solaris as they are processed only if _POSIX_C_SOURCE is not defined...
*# 
*/
typedef	unsigned char	unchar;
typedef	unsigned short	ushort;
typedef	unsigned int	uint;
typedef	unsigned long	ulong;
typedef unsigned char	u_char;
typedef unsigned short	u_short;
typedef unsigned int	u_int;
typedef unsigned long	u_long;
typedef	 	 long	hostid_t;
/* 
*# End of not very POSIX typedefs....
*/

#include <fcntl.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/uio.h>
#include <netinet/in.h>
#include <netdb.h>
#include <arpa/inet.h>
#include <errno.h>

#include <ECCS.h>
#include <fcd.h>
#include <fcdInternal.h>

#define SRVLEN 32

class fcdSOCK
{
public:

  fcdSOCK();
  ~fcdSOCK();

  /*
   *# InitServer
   *#
   */
  // using a service name
  ccsCOMPL_STAT InitServer(int &, char const *);
  // using a port number
  ccsCOMPL_STAT InitServer(int &, const int);

  /*
   *# Connect
   *#
   */
  // for clients using a service name
  ccsCOMPL_STAT Connect(int &, char const *, char const *);
  // for clients using a port number
  ccsCOMPL_STAT Connect(int &, char const *, const int);
  // for servers
  ccsCOMPL_STAT Connect(const int, int &, char *);

  /*
   *# Send data
   *#
   */ 
  // a buffer
  ccsCOMPL_STAT Send(const int , char const *, const int);
  // an array of buffers (iovec structure, see sys/socket.h and sys/uio.h)
  ccsCOMPL_STAT Send(const int , const struct iovec *, const int);


  /*
   *# Receive data
   *#
   */
  // exactly that number of bytes
  ccsCOMPL_STAT Receive(const int, char *, const int);
  // whatever but less than a maximum
  ccsCOMPL_STAT Receive(const int, char *, int &);
  // an array of buffers (iovec structure, see sys/socket.h and sys/uio.h)
  ccsCOMPL_STAT Receive(const int, iovec *, const int);

  /*
   *# Set nonblocking flag
   *#
   */
  ccsCOMPL_STAT SetNonBlocking(const int);

  /*
   *# Close connection
   *#
   */
  ccsCOMPL_STAT Close(const int);
  
  /*
   *# Operator overloading
   *#
   */

  /*
   *# Accessor functions
   */

private:

  struct sockaddr_in addr;
  void errorManage(const char *);
};

#endif /*!_H*/
