/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: fcdSUX.h,v 2.140 2005/10/17 15:17:00 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* abalestr   28/08/03  created
 * abalestr   15/01/04 Added capability.h for linux uint_ types
*
*/

/*************************************************************************
 *  This file contains Internal definitions for C++ modules
*************************************************************************/

#ifndef FCDSUX_H
#define FCDSUX_H

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <errno.h>
#include <fcntl.h>
#include <unistd.h>
#include <string>

#ifdef LINUX
#include <sys/capability.h> // For linux uint_ types
#endif

#include "eccs.h"
#include "ccsLite.h"
#include "fcd.h"
#include "fcdLOG.h"
#include "sux_if.h"

using namespace std;

class fcdSUX
{
public:
  fcdSUX();
  ~fcdSUX();

  /*
   *# Initialise/unitialise the object
   */
  ccsCOMPL_STAT Init();
  ccsCOMPL_STAT Uninit();

  /*
   *# Prepare/Get the next buffer of data
   */
  ccsCOMPL_STAT PrepareDma(int numOfBytes, char *data);
  ccsCOMPL_STAT WaitForBuffer(void);

  /* 
   *# Block unblock DMA for synchronizing with DSP
   *# if flag is true then DSP code will block until DMA is ready (flag=false)
   */
  void BlockDma(vltLOGICAL flag);

  /*
   *# Interfaces to ioctls
   */
  ccsCOMPL_STAT GetCounter(int &count);
  void fcdSUX::ResetCounter(void);
  void fcdSUX::SendSyncSig(void);

  // Accessor functions
  vltINT32 GetBytes2Receive() {return bytes2Receive;}
  ccsCOMPL_STAT GetDmaStatus() {return dmaStatus;}
  void SetDmaStatus(ccsCOMPL_STAT status) {dmaStatus = status;}
  
private:

  static const string sux_interface;

  vltLOGICAL    initialised;
  vltLOGICAL    dmaInitialised;
  ccsCOMPL_STAT	dmaStatus;
  vltINT32	suxfd;



  char *dataBuffer;		// data buffer
  vltINT32 bytes2Receive;	// number of bytes to receive
};


#endif /* ! _H */
