#ifndef fcdWIPE_H
#define fcdWIPE_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: fcdWIPE.h,v 2.140 2005/10/17 15:16:55 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* rdonalds  09/07/96  created
* abalestr  08/03/05  added sync wiping
* 
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

#include "fcdINTERNAL.h"
#include "fcdEXPOSURE.h"
#include "fcdC40.h"
#include "fcdFIERA_CONFIG.h"

/*
 * Class encapsulating the functionality of wiping
 */
class fcdWIPE
{
public:
  // Default ctor
  fcdWIPE();
  
  // Initialise on command
  ccsCOMPL_STAT Init(
		     fcdDETECTOR     *det,
		     fcdC40          *gC40
		     );
  ccsCOMPL_STAT Uninit();
  
  /* Perform a wipe setting the last time etc flags using coordSemId
     to coordinate with other processes which may be accessing the
     C40 interface. If the coordSemId < 0 no coordination will
     take place */
  ccsCOMPL_STAT	Wipe(vltINT32     wipeSeqId,
		     vltINT32     wipeVoltTable,
                     vltINT32     coordSemId);

  /* Same but synchronized */
  ccsCOMPL_STAT	WipeSync(vltINT32 wipeSeqId,
		     vltINT32     wipeVoltTable,
		     vltINT32     coordSemId);
private:
  fcdC40      *gC40;
  fcdDETECTOR *gDet;

  vltLOGICAL   initialised;
};



#endif /*!fcdWIPE_H*/
