/************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: fcdc40srvif.h,v 2.14 2004/01/14 15:12:45 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* rdonalds  25/04/96  created
* rdonalds  4/12/97   removed unnecessary include of fcd.h
* abalestr  18/01/00  cosmetics in order to remove warnings (FEB2000)
************************************************************************/
#ifndef FCDC40IFLIB_H
#define FCDC40IFLIB_H

#ifdef __cplusplus
extern "C" {
#endif

#include "fcdc40Errors.h"


/*
 *# fcdc40IfInit
 *#
 *# Initialise the link to the C40 I/F server
 */
int fcdc40IfInit(int);
int fcdc40IfUninit(int);

/*
 *# fcdc40IfSendCmdWaitReply
 *#
 *# Sends a command and parmaters to the c40 and awaits a reply from the
 *# c40 TO THIS COMMAND.
 */
extern int fcdc40IfSendCmdWaitReply (
		vltINT32	Dest,		/* dest channel on c40 */
		vltINT32	Cmd, 		/* command word */
		vltINT32	*Data,		/* parameters */
		vltINT32	DataLen,	/* length in words of params */
		vltINT32	*RespType,	/* type of response */
		vltINT32	*Resp,		/* returned parameters */
		vltINT32	RespLen,	/* length of Resp (words) */
		vltINT32	*ActRespLen, /* actual return length(words) */
		vltINT32	Tmo		/* time allowed in milseconds */
		);

/*
 *# fcdc40IfSendCmdNoWaitReply
 *#
 *# Sends a command and parmaters to the c40 but does not wait for any
 *# reply from the c40.
 */
extern int fcdc40IfSendCmdNoWaitReply (
		vltINT32	Dest,		/* dest channel on c40 */
		vltINT32	Cmd, 		/* command word */
		vltINT32	*Data,		/* parameters */
		vltINT32	DataLen	/* length in words of params */
		);

/*
 *# fcdc40IfWaitReply
 *#
 *# awaits a reply from the c40.
 */
extern int fcdc40IfWaitReply (
		vltINT32	*Command,	/* Command recvd*/
		vltINT32	*ReplyType,	/* type of reply */
		vltINT32	*Resp,		/* returned parameters */
		vltINT32	RespLen,	/* length of Resp (words) */
		vltINT32	*ActRespLen,	/* actual return length(words) */
		vltINT32	Tmo		/* time allowed in milseconds */
		);

/*
 *# fcdc40IfWaitSpecificReply 
 *#
 *# 
 */
extern int fcdc40IfWaitSpecificReply (
		vltINT32	Command,	/* Command recvd*/
		vltINT32	*ReplyType,	/* type of reply */
		vltINT32	*Resp,		/* returned parameters */
		vltINT32	RespLen,	/* length of Resp (words) */
		vltINT32	*ActRespLen,	/* actual return length(words) */
		vltINT32	Tmo		/* time allowed in milseconds */
		);


#ifdef __cplusplus
}
#endif
#endif
