#ifndef FCDL_H
#define FCDL_H
/************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: fcdl.h,v 3.50 2005/04/13 09:14:23 vltsccm Exp $"
*
* fcdl.h
*
* who       when      what
* --------  --------  ----------------------------------------------
* ccumani   10/01/97  created as fcddsplib.h
* ccumani   21/04/97  - renamed as fcdl.h
*                     - "fcddsplib" replaced with "fcdl"
* ccumani   17/06/97  - logging macros added
*                     - function prototypes updated
* ccumani   19/06/97  fcdlDetPoll_iiof3() function prototype modified
* ccumani   20/06/97  fcdlMsqBroadcastExec() function prototype modified
* ccumani   26/06/97  function prototype of fcdlDetReadFast() deleted
* ccumani   07/07/97  function prototype of fcdlGenDspRate() added
* ccumani   07/07/97  function prototype of fcdlDsp2Set() added
* ccumani   11/07/97  fcdlMsqChkErrStatres renamed as fcdlMsqCheckOverrun
* ccumani   23/07/97  function prototype of fcdlVidOffline() added
* ccumani   24/07/97  - function prototypes of fcdlVidCheck() and 
*                       fcdlClkOffline() added
*                     - fcdlGenHexstrToNum type set to RSTATUS
* ccumani   25/07/97  - fcdlGenSleep, fcdlSprcRead, fcdlSprcWrite type 
*                       set to RSTATUS
*                     - fcdlMsqReadSram function prototype modified
* ccumani   28/07/97  - fcdlDetWrite renamed as fcdlWrite and extracted
*                       from fcdlDet* function prototypes list
*                     - fcdlDetRead and fcdlDetReadSigned renamed as 
*                       fcdlRead and fcdlReadSigned and extracted
*                       from fcdlDet* function prototypes list
* ccumani   22/08/97  - flags added to fcdlMsqsInit() function
*                       prototype
* ccumani   11/08/97  - fcdl.lib library splitted in more libraries
*                       all the contents of the original fcdl.h
*                       have been divided among the different
*                       library header files.
*                       FROM NOW ON, THIS FILE CONTAINS ONLY THE
*                       DEFINITIONS IN COMMON AMONG THE DIFFERENT
*                       LIBRARIES
* ccumani   07/07/99  - definition of DSPABORTED added
* ccumani   11/08/99  - definition of fcdlCMD_LOAD_TEST added
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */


/*******************************************************************
 *# Local include files
 *******************************************************************/

#include "fcdlIntf.h"

/*******************************************************************
 *# Macro Declarations
 *******************************************************************/

/*
 * host indipendent type declarations
 */
#define TRUE            1
#define FALSE           0
 
typedef int             BOOL;
typedef int             RSTATUS;
typedef unsigned short  SWORD;
typedef int             LWORD;
typedef int             REC_DATA;

/*
 * DSP errors
 */
#define DSPSUCCESS 0
#define DSPFAILURE 1
#define DSPABORTED 2

/*
 * Internal Commands
 */
#define fcdlCMD_LOAD_TEST (fcdlCMD_LAST+100)

#endif /*!FCDL_H*/
