#ifndef FCDLPR_H
#define FCDLPR_H
/************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: fcdlPR.h,v 3.50 2005/04/13 09:14:25 vltsccm Exp $"
*
* fcdlPR.h
*
* who       when      what
* --------  --------  ----------------------------------------------
* ccumani   11/09/97  - created from fcdl.h, moving all the information
*                       related to DSP2 inside fcdlD2.h
* ccumani   12/09/97  - fcdlMsqCheckOverrun function prototype deleted
*                     - function prototypes for Sparc connections
*                       moved in fcdlSP.h
* ccumani   17/09/97  - fcdlSqExec renamed as fcdlSqEx
* ccumani   13/01/98  - fcdlVidSetGain1, fcdlVidSetGain2, fcdlVidSetTVidOn,
*                       fcdlVidSetFilt, fcdlVidSetOffset, fcdlVidSetPriph,
*                       fcdlVidInitPriph and fcdlVidLoadMultilevelSram
*                       function prototypes deleted
*                     - fcdlVidStorePriph, fcdlVidLoadPriph and fcdlVidLog
*                       function prototypes added
* ccumani   14/01/98  - fcdlAnbSetPriph changed in fcdlAnbStoreLoadPriph
*                     - fcdlAnbInitPrih function prototype deleted
*                     - fcdlClkInitPriph and fcdlClkSetPriph function
*                       prototypes deleted
*                     - fcdlClkLoadPriph and fcdlClkStorePriph function
*                       prototypes added
*                     - fcdlDetInitPriph, fcdlDetSetPriph and 
*                       fcdlDetSetVoltages function prototypes deleted
*                     - fcdlDetLoadVoltages and fcdlDetLoadVoltTable function
*                       prototypes added
*                     - fcdlDetCleanTables function prototype added
*                     - I2Cbus functions removed
* ccumani   15/01/98  - fcdlAnbStorePriph and fcdlAnbLoadPriph function
*                       prototypes added
*                     - fcdlAnbRelayOff and fcdlAnbRelayOn function
*                       prototypes deleted
*                     - fcdlDetPoll_iiof3 function prototype deleted
* ccumani   16/01/98  - fcdlDetTstEclLoopback function prototype deleted
*                     - fcdlDetFlickerLeds function prototype added
*                     - log levels fcdlLOG_INFO4 and fcdlLOG_INFO5 added
* ccumani   20/01/98  - fcdlVidGetStoredVolt, fcdlClkGetStoredVolt,
*                       fcdlAnbGetStoredVolt and fcdlDetGetVoltage 
*                       function prototypes added
* ccumani   26/02/98  - test flag added in fcdlClkLoadPriph function
*                       prototype
* ccumani   11/08/98  - fcdlSqExAtSig function prototype added
* ccumani   15/09/98  - function prototypes for SPARC communication
*                       added
* ccumani   05/10/98  - fcdlDetCleanTables function prototype moved
*                       in fcdlDet.h, as static
*                     - fcdlDetPrepare function prototype added
* ccumani   09/02/99  - function prototype of fcdlDetDoTest modified
*                       (channels added)
*                     - include "chan.h" added
* ccumani   11/05/99  - function prototype of fcdlMsqReset added
*                     - function prototype of fcdlMsqPoll added
*                     - function prototypes of fcdlMsqsCheck and 
*                       fcdlMsqReadSram deleted
* ccumani   15/06/99  - hasPreamp2 added to fcdlVidInit function prototype
*                     - function prototype of fcdlExecNSeqsParams added
* ccumani   08/07/99  - function prototype of fcdlLogWarning added
* ccumani   19/03/03  - function prototype of fcdlAnbReadCurrent added
* ccumani   24/04/03  - definitions of max number of allowed boards
*                       moved here from fcdlLPR.h
*                     - definition of struct fcdlAnbBoards added
*                     - function prototypes of fcdlAnbOn/Offline modified
* ccumani   14/08/03  - function prototype of fcdlDetIntEnable added
* ccumani   04/02/04  - function prototype of fcdlDetIntDisable added
*                     - function prototype of fcdlDetSemaReset added
* ccumani   07/02/04  - function prototype of fcdlDetSemaEnable added
*                     - function prototype of fcdlDetSemaWait added
*                     - function prototype of fcdlDetSemaRead added
* ccumani   21/01/05  - function prototype of fcdlDetIntOrTimeoutIIOF1 added
* ccumani   23/02/05  - function prototype of fcdlDetIntOrTimeoutIIOF1 removed
*                     - function prototypes of fcdlDetSemaEnable,
*                       fcdlDetSemaRead, fcdlDetSemaReset and
*                       fcdlDetSemaWait removed
*                     - function prototypes of fcdlDetIntAttach added
*/


/************************************************************************
 *
 *----------------------------------------------------------------------
 */

/* 
 * System Headers
 */
#include <chan.h>

/* 
 * Local Headers
 */
#include "fcdl.h"


/*******************************************************************
 *# Logging utility macros
 *******************************************************************/

/* maximum length of a log message */
#define fcdlLOG_MAX_LEN 256

typedef enum {
  fcdlLOG_ERROR,
  fcdlLOG_ALWAYS,
  fcdlLOG_INFO1,
  fcdlLOG_INFO2,
  fcdlLOG_INFO3,
  fcdlLOG_INFO4,
  fcdlLOG_INFO5,

  /* leave this one as a marker for the end */
  fcdlLOG_LAST
} fcdlLOG_LEVEL;


/*******************************************************************
 *# Max boards allowed
 *******************************************************************/
#define CLKDRV_MAX     4
#define VIDBRD_MAX     4
#define ANABIAS_MAX    4


/*******************************************************************
 *# Table of Anabias Boards
 *******************************************************************/
typedef struct
{
    int num;              /* number of Anabias Boards in the system */
    int id[ANABIAS_MAX];  /* boardId of the Anabias Boards          */
} fcdlAnbBoards;


/*******************************************************************
 *# Function prototypes
 *******************************************************************/

/*
 * for the Detector Electronics Analogue Bias Board(s)
 * ---------------------------------------------------
 */

extern RSTATUS fcdlAnbCheck (
    int board
    );

extern RSTATUS fcdlAnbGetStoredVolt (
    int     board, 
    int     priph,
    int    *value
    );

extern RSTATUS fcdlAnbInit (
    int board
    );

extern RSTATUS fcdlAnbLoadPriph (
    int board
    );

extern RSTATUS fcdlAnbStorePriph (
    int board,
    int periph, 
    int value
    );

extern RSTATUS fcdlAnbOffline (
    fcdlAnbBoards *fcdlAnbBrd
    );

extern RSTATUS fcdlAnbOnline (
    fcdlAnbBoards *fcdlAnbBrd
    );

extern RSTATUS fcdlAnbReadCurrent (
    int    board
    );

extern RSTATUS fcdlAnbSelftest (
    int board
    );

/*
 * for the Detector Electronics Clock Driver Board(s)
 * --------------------------------------------------
 */

extern RSTATUS fcdlClkCheck (
    int board
    );

extern RSTATUS fcdlClkGetStoredVolt (
    int     board, 
    int     priph,
    int    *value
    );

extern RSTATUS fcdlClkInit (
    int          board,
    fcdlCLK_TYPE dacTypes[]
    );

extern RSTATUS fcdlClkLoadPriph (
    int  board,
    BOOL test
    );

extern RSTATUS fcdlClkOffline (
    int board
    );

extern RSTATUS fcdlClkOnline (
    int board
    );

extern RSTATUS fcdlClkSelftest (
    int board
    );

extern RSTATUS fcdlClkStorePriph (
    int board,
    int periph, 
    int value
    );

/*
 * for the Detector Electronics Communication Board
 * ------------------------------------------------
 */

extern RSTATUS fcdlComInit (
    void
    );

extern RSTATUS fcdlComOffline (
    void
    );

extern RSTATUS fcdlComOnline (
    void
    );

extern RSTATUS fcdlComSelftest (
    void
    );

/* 
 * for Detector Electronics handling
 * ---------------------------------
 */

extern RSTATUS fcdlDetCheck (
    void
    );

extern RSTATUS fcdlDetCheckStatus (
    void
    );

extern RSTATUS fcdlDetDoTest (
    fcdlDoTestParams *par,
    CHAN             *in_ports[],
    CHAN             *out_ports[]
    );

extern RSTATUS fcdlDetDSPbusInit (
    int *ram_start
    );

extern RSTATUS fcdlDetErrorExit (
    void
    );

extern RSTATUS fcdlDetFlickerLeds (
    int times
    );

extern RSTATUS fcdlDetGetVoltage (
    int                    *repLength, 
    fcdlGetVoltageParams   *volts
    );

extern RSTATUS fcdlDetInit (
    void
    );

extern RSTATUS fcdlDetIntDisable (
    void
    );

extern RSTATUS fcdlDetIntEnable (
    void
    );

extern RSTATUS fcdlDetIntAttach (
    void
    );

extern RSTATUS fcdlDetLoadVoltages (
    fcdlSetVoltageParams   *volt
    );

extern RSTATUS fcdlDetLoadVoltTable (
    int   voltTableId
    );

extern RSTATUS fcdlDetOffline (
    void
    );

extern RSTATUS fcdlDetOnline (
    void
    );

extern RSTATUS fcdlDetPrepare (
    void
    );

extern RSTATUS fcdlDetReset (
    void
    );

extern RSTATUS fcdlDetSelftest (
    void
    );

extern RSTATUS fcdlDetSetConfig (
    fcdlSetConfigParams *config
    );

extern RSTATUS fcdlDetStartupFiber (
    int wait
    );

extern RSTATUS fcdlDetSetVoltTable (
    fcdlSetVoltTableParams *vt
    );

/*
 * General utilities
 * -----------------
 */

extern RSTATUS fcdlGenDspRate (
    unsigned int *rate,
    BOOL          internal
    );

extern double fcdlGenFround (
    double value
    );

extern RSTATUS fcdlGenHexstrToNum (
    char *str, 
    int  *value
    );

extern RSTATUS fcdlGenSleep (
    int wait
    );

/*
 * for Logging
 * -----------
 */

extern void fcdlLogError (
    const char *format, 
    ...
    );

extern void fcdlLogWarning (
    const char *format, 
    ...
    );

extern fcdlLOG_LEVEL fcdlLogGetLevel (
    void
    );

extern void fcdlLogInfo (
    fcdlLOG_LEVEL level, 
    const char *format, 
    ...
    );

extern void fcdlLogLevel (
    fcdlLOG_LEVEL logLevel
    );

extern void fcdlLogToScreen (
    BOOL toScreen
    );

extern void fcdlLogVersion (
    const char *string
    );

/*
 * for Microsequences handling
 * ---------------------------
 */

extern RSTATUS fcdlMsqBroadcastExec (
    int  startAddr,
    int  length, 
    int  loopCount
    );

extern RSTATUS fcdlMsqCheck (
    int  board
    );

extern RSTATUS fcdlMsqLoadBilevelSram (
    int  board,
    int  startAddr, 
    int  length,
    int *pattern
    );

extern RSTATUS fcdlMsqLoadSram (
    int  board,
    int  startAddr,
    int  length, 
    int *pattern,
    int  cSel,
    int  readMask
    );

extern RSTATUS fcdlMsqPoll (
    int            board,
    unsigned short mask
    );

extern RSTATUS fcdlMsqPollBusy (
    int  board
    );

extern RSTATUS fcdlMsqPollPipe (
    int  board
    );

extern RSTATUS fcdlMsqReset (
    int             board
    );

extern RSTATUS fcdlMsqSetOut (
    int            board,
    char           cSel, 
    unsigned short data, 
    int            enableOut
    );

extern RSTATUS fcdlMsqSramTest (
    int            board,
    unsigned short end_cnt,
    int            num
    );

extern RSTATUS fcdlMsqsInit (
    int   numBoards,
    int  *boards, 
    int   enableOut,
    int   divideRate,
    BOOL  check,
    BOOL  disable
    );

/*
 * for Shutter control
 * -------------------
 */

extern RSTATUS fcdlShutClose (
    void
    );

extern RSTATUS fcdlShutOpen (
    fcdlOpenShutterParams *params
    );

/*
 * for Communication with SPARC
 * ----------------------------
 */

extern RSTATUS fcdlSprcClose (
    void
    );

extern RSTATUS fcdlSprcOpen (
    void
    );

extern RSTATUS fcdlSprcRead (
    int  length, 
    int *data
    );

RSTATUS fcdlSprcReadNoBlock (
    int  length, 
    int *data
    );

extern RSTATUS fcdlSprcWrite (
    int  length, 
    int *data
    );

/*
 * for Pattern, Micro/Sequence storage
 * -----------------------------------
 */

extern RSTATUS fcdlSqDefineBilevelPattern (
    fcdlDefineBilevelPatternParams *pattern
    );

extern RSTATUS fcdlSqDefineMultilevelPattern (
    fcdlDefineMultilevelPatternParams *pattern
    );

extern RSTATUS fcdlSqDefineSeq (
    fcdlDefineSeqParams *sequence
    );

extern RSTATUS fcdlSqDefineUseq (
    fcdlDefineUseqParams *usequence
    );


/*
 * for Sequence execution
 * ----------------------
 */
extern RSTATUS fcdlSqEx (
    fcdlExecSeqParams *sequence
    );

extern RSTATUS fcdlSqExAtSig (
    fcdlExecSeqParams *sequence
    );

extern RSTATUS fcdlSqExN (
    fcdlExecNSeqsParams *sequences
    );


/*
 * for the Detector Electronics Video Board(s)
 * -------------------------------------------
 */

extern RSTATUS fcdlVidCheck (
    int board
    );

extern RSTATUS fcdlVidGetStoredVolt (
    int     board, 
    int     priph,
    int    *value
    );

extern RSTATUS fcdlVidInit (
    int  board,
    int  hasPreamp,
    int  hasPreamp2
    );

extern RSTATUS fcdlVidLoadPriph (
    int  board
    );

extern RSTATUS fcdlVidLog (
    fcdlVoltTableEntry *vt
    );

extern RSTATUS fcdlVidOffline (
    int  board
    );

extern RSTATUS fcdlVidOnline (
    int  board
    );

extern RSTATUS fcdlVidSelftest (
    int  board
    );

extern RSTATUS fcdlVidStorePriph (
    int board,
    int periph,
    int value
    );

extern RSTATUS fcdlVidTestVideo (
    BOOL on
    );

/*
 * for writing to the Detector Electronics
 * ---------------------------------------
 */

extern RSTATUS fcdlWrite (
    int            address,
    int            value
    );

/*
 * for reading from the Detector Electronics
 * ---------------------------------------
 */

extern RSTATUS fcdlRead (
    int  address,
    int *value
    );

extern RSTATUS fcdlReadSigned (
    int  address,
    int *value
    );


#endif /*!FCDLPR_H*/
