#ifndef FCDPEXP_H
#define FCDPEXP_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: fcdpExp.h,v 1.59 2005/10/24 11:39:44 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* hpieper   08/07/97  created
* rdonalds  03/02/98  changed ExpChangeTime to use the INC and DEC
*                     pulpo commands
* abalestr  17/01/00  Added prototype for function fcdpExpChangeType
* ccumani   13/12/04  include unistd.h added
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */
#ifdef  __cplusplus
extern "C" {
#endif

#include <unistd.h> /* for sleep() */

#include "fcdpCommand.h"

#define FCDP_EXP_DARK                 0
#define FCDP_EXP_SCIENTIFIC           1
#define FCDP_EXP_LED_ONLY             2
#define FCDP_EXP_LED_SCIENTIFIC       3

ccsCOMPL_STAT fcdpExpSetup       ( vltINT32 pulpoID, 
				   vltINT32 mode,
				   vltDOUBLE seconds,
				   ccsERROR *pErr);
ccsCOMPL_STAT fcdpExpSetTime     ( vltINT32 pulpoID, 
				   vltDOUBLE seconds,
				   ccsERROR *pErr);
ccsCOMPL_STAT fcdpExpGetTime     ( vltINT32 pulpoID, 
				   vltDOUBLE *seconds,
				   ccsERROR *pErr);

ccsCOMPL_STAT fcdpExpStart       ( 
				  vltINT32 pulpoID,
				  vltDOUBLE *od, 
				  ccsERROR *pErr);
ccsCOMPL_STAT fcdpExpStartNew    ( 
				  vltINT32 pulpoID, 
				  vltINT32 mode,
				  vltDOUBLE seconds,
				  vltDOUBLE *od, 
				  ccsERROR *pErr);
ccsCOMPL_STAT fcdpExpChangeTime    ( 
				  vltINT32 pulpoID, 
				  vltDOUBLE oldDuration,
				  vltDOUBLE newDuration,
				  ccsERROR *pErr);
ccsCOMPL_STAT fcdpExpPause       ( 
				  vltINT32 pulpoID,
				  vltDOUBLE *cd, 
				  ccsERROR *pErr
				  );
ccsCOMPL_STAT fcdpExpContinue    ( vltINT32 pulpoID,
				   vltDOUBLE *od, 
				   ccsERROR *pErr);
ccsCOMPL_STAT fcdpExpWait        ( 
				  vltINT32 pulpoID,
				  vltDOUBLE *cd,
				  vltDOUBLE tmoInSec,
				  ccsERROR *pErr
				  );
ccsCOMPL_STAT fcdpExpAbort       ( 
				  vltINT32 pulpoID,
  				  vltDOUBLE *cd, 
				  ccsERROR *pErr
				  );
ccsCOMPL_STAT fcdpExpChangeType  ( vltINT32  pulpoID, 
				  vltINT32 type,
				  ccsERROR *pErr
				  );

#ifdef  __cplusplus
}
#endif

#endif /*!FCDPEXP_H*/
