#ifndef FCDPINIT_H
#define FCDPINIT_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: fcdpInit.h,v 1.59 2005/10/24 11:39:45 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* hpieper  26/05/97  created
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */
#ifdef  __cplusplus
extern "C" {
#endif

#include "fcdpCommand.h"


#define FCDP_CFG_FILENAME      "pulpo.cfg"
#define FCDP_CFGDAT_FILENAME   "pulpo.dat"


/*-----------------------------------------------------------------------
 * pulpo SERVER-SIDE INIT and CLOSE functions PUBLIC
 *----------------------------------------------------------------------*/
ccsCOMPL_STAT fcdpCREATE_PULPO( vltLOGICAL *simMode, 
				ccsERROR *pErr);
ccsCOMPL_STAT fcdpKILL_PULPO  ( ccsERROR *pErr);

/*-----------------------------------------------------------------------
 * pulpo CLIENT-SIDE Library INIT and CLOSE functions PUBLIC
 *----------------------------------------------------------------------*/
ccsCOMPL_STAT fcdpINIT_PULPO( vltINT32 pulpoID, vltLOGICAL simMode, 
			      ccsERROR *pErr);
ccsCOMPL_STAT fcdpINIT_CFG_PULPO( vltINT32 pulpoID, vltLOGICAL simMode, 
			      char *cfgPath, ccsERROR *pErr);
ccsCOMPL_STAT fcdpCLOSE_PULPO( vltINT32 pulpoID, ccsERROR *pErr);

	 
/*-----------------------------------------------------------------------
 * pulpo control operations USER LEVEL
 *----------------------------------------------------------------------*/

ccsCOMPL_STAT fcdpCTRLMode       ( vltINT32 pulpoID, ccsERROR *pErr);
ccsCOMPL_STAT fcdpTMMode         ( vltINT32 pulpoID, ccsERROR *pErr);
ccsCOMPL_STAT fcdpCtrlSensor     ( vltINT32 pulpoID, ccsERROR *pErr);
ccsCOMPL_STAT fcdpDBGMode        ( vltINT32 pulpoID, ccsERROR *pErr);
ccsCOMPL_STAT fcdpECModeON       ( vltINT32 pulpoID, ccsERROR *pErr);
ccsCOMPL_STAT fcdpECModeOFF      ( vltINT32 pulpoID, ccsERROR *pErr);

ccsCOMPL_STAT fcdpSetTime        ( vltINT32 pulpoID, time_t *tPtr,
				   ccsERROR *pErr);
ccsCOMPL_STAT fcdpGetTime        ( vltINT32 pulpoID, time_t *tPtr, 
				   ccsERROR *pErr);
ccsCOMPL_STAT fcdpDisableLEDS    ( vltINT32 pulpoID, ccsERROR *pErr);
ccsCOMPL_STAT fcdpGetDewarModel  ( vltINT32 pulpoID, vltINT32 *dm, 
				   ccsERROR *pErr);
ccsCOMPL_STAT fcdpSetDewarModel  ( vltINT32 pulpoID, vltINT32 dm, 
				   ccsERROR *pErr);

ccsCOMPL_STAT fcdpGetSWVersion ( 
				vltINT32 pulpoID, 
				vltDOUBLE *rev,
				ccsERROR *pErr
				);
				     
ccsCOMPL_STAT fcdpSafeInit(
			   vltINT32 pulpoID,
			   ccsERROR *pErr
			   );
#ifdef  __cplusplus
}
#endif

#endif /*!FCDPINIT_H*/
