#ifndef FCDPTELEM_H
#define FCDPTELEM_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: fcdpTelem.h,v 1.59 2005/10/24 11:39:44 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* hpieper   08/07/97  created
* ccumani   17/02/05  max Sensor and Heater defined
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */

#ifdef  __cplusplus
extern "C" {
#endif

#include "fcdpCommand.h"
    
#define maxHeater 9
#define maxSensor 439


ccsCOMPL_STAT fcdpTELSetHTSP       ( vltINT32 pulpoID, vltINT32 hID, 
				     vltDOUBLE tmp, ccsERROR *pErr);
ccsCOMPL_STAT fcdpTELGetHTSP       ( vltINT32 pulpoID, vltINT32 hID, 
				     vltDOUBLE *tmp, ccsERROR *pErr);
ccsCOMPL_STAT fcdpTELGetSAduStdDev ( vltINT32 pulpoID, vltINT32 sID,
				     vltDOUBLE *temp, vltDOUBLE *stdDev,
				     ccsERROR *pErr);
ccsCOMPL_STAT fcdpTELGetSAdu       ( vltINT32 pulpoID, vltINT32 sID,
				     vltDOUBLE *temp,
				     ccsERROR *pErr);
ccsCOMPL_STAT fcdpTELGetSStdDev    ( vltINT32 pulpoID, vltINT32 sID,
				     vltDOUBLE *stdDev,
				     ccsERROR *pErr);
ccsCOMPL_STAT fcdpTELSetHTSensor   ( vltINT32 pulpoID, vltINT32 hID,
				     vltINT32 sID, ccsERROR *pErr);
ccsCOMPL_STAT fcdpTELGetHTSensor   ( vltINT32 pulpoID, vltINT32 hID, 
				     vltINT32 *sID, ccsERROR *pErr);
ccsCOMPL_STAT fcdpTELSetHTPIDMode  ( vltINT32 pulpoID, vltINT32 hID, 
				     vltINT32 mode, ccsERROR *pErr);
ccsCOMPL_STAT fcdpTELGetHTPIDMode  ( vltINT32 pulpoID, vltINT32 hID, 
				     vltINT32 *mode, ccsERROR *pErr);
ccsCOMPL_STAT fcdpTELGetHTMode     ( vltINT32 pulpoID, vltINT32 hID,
				     vltINT32 *mode, ccsERROR *pErr);
ccsCOMPL_STAT fcdpTELSetHTMode     ( vltINT32 pulpoID, vltINT32 hID,
				     vltINT32 mode, ccsERROR *pErr);
ccsCOMPL_STAT fcdpTELHWTest        ( vltINT32 pulpoID, ccsERROR *pErr);

ccsCOMPL_STAT fcdpTELSetPID        ( vltINT32 pulpoID, vltINT32 pidID,
				     vltDOUBLE kp, 
				     vltDOUBLE ki, 
				     vltDOUBLE kd,
				     ccsERROR *pErr);
ccsCOMPL_STAT fcdpTELSetPIDKP      ( vltINT32 pulpoID, 
				     vltINT32 pidID,
				     vltDOUBLE kp,
				     ccsERROR *pErr);
ccsCOMPL_STAT fcdpTELSetPIDKI      ( vltINT32 pulpoID, 
				     vltINT32 pidID,
				     vltDOUBLE ki,
				     ccsERROR *pErr);
ccsCOMPL_STAT fcdpTELSetPIDKD      ( vltINT32 pulpoID, 
				     vltINT32 pidID,
				     vltDOUBLE kd,
				     ccsERROR *pErr);
ccsCOMPL_STAT fcdpTELGetPID        ( vltINT32 pulpoID, 
				     vltINT32 pidID,
				     vltDOUBLE *kp, 
				     vltDOUBLE *ki, 
				     vltDOUBLE *kd,
				     ccsERROR *pErr);
ccsCOMPL_STAT fcdpTELGetPIDKP      ( vltINT32 pulpoID, 
				     vltINT32 pidID,
				     vltDOUBLE *kp,
				     ccsERROR *pErr);
ccsCOMPL_STAT fcdpTELGetPIDKI      ( vltINT32 pulpoID, 
				     vltINT32 pidID,
				     vltDOUBLE *ki,
				     ccsERROR *pErr);
ccsCOMPL_STAT fcdpTELGetPIDKD      ( vltINT32 pulpoID, 
				     vltINT32 pidID,
				     vltDOUBLE *kd,
				     ccsERROR *pErr);

ccsCOMPL_STAT fcdpTELGetSensor     ( vltINT32 pulpoID, vltINT32 sID,
				     vltDOUBLE *val, ccsERROR *pErr);
				  
ccsCOMPL_STAT fcdpTELGetHTPower    ( vltINT32 pulpoID, vltINT32 hID,
				     vltINT32 *val, ccsERROR *pErr);
ccsCOMPL_STAT fcdpTELSetHTPower    ( vltINT32 pulpoID, vltINT32 hID,
				     vltINT32 val, ccsERROR *pErr);

ccsCOMPL_STAT fcdpTELGetHTResist   ( vltINT32 pulpoID, vltINT32 hID,
				     vltDOUBLE *r, ccsERROR *pErr);
ccsCOMPL_STAT fcdpTELSetHTResist   ( vltINT32 pulpoID, vltINT32 hID,
				     vltDOUBLE r, ccsERROR *pErr);
ccsCOMPL_STAT fcdpTELGetStatus     ( vltINT32 pulpoID, vltINT32 byteID,
				     vltINT32 *s, ccsERROR *pErr);

ccsCOMPL_STAT fcdpTELGetTempSlope (
				   vltINT32 pulpoID, 
				   vltDOUBLE *val,
				   ccsERROR *pErr
				   );
ccsCOMPL_STAT fcdpTELSetTempSlope (
				   vltINT32 pulpoID, 
				   vltDOUBLE val,
				   ccsERROR *pErr
				   );

ccsCOMPL_STAT fcdpTELSetATMode   (
				   vltINT32 pulpoID, 
				   vltINT32 mode,
				   ccsERROR *pErr
				   );
ccsCOMPL_STAT fcdpTELGetATMode   (
				   vltINT32 pulpoID, 
				   vltINT32 *mode,
				   ccsERROR *pErr
				   );

ccsCOMPL_STAT  fcdpTELSetBLedPower (
				    vltINT32 pulpoID, 
				    vltDOUBLE val,
				    ccsERROR *pErr
				    );
ccsCOMPL_STAT  fcdpTELGetBLedPower (
				    vltINT32 pulpoID, 
				    vltDOUBLE *val,
				    ccsERROR *pErr
				    );
ccsCOMPL_STAT  fcdpTELSetVGaPower (
				   vltINT32 pulpoID, 
				   vltINT32 mode,
				   ccsERROR *pErr
				   );
ccsCOMPL_STAT  fcdpTELGetVGaPower (
				 vltINT32 pulpoID, 
				 vltINT32 *mode,
				 ccsERROR *pErr
				 );
ccsCOMPL_STAT  fcdpTELSetAlarmMode (
				    vltINT32 pulpoID, 
				    vltINT32 hID,
				    vltINT32 mode,
				    ccsERROR *pErr
				    );
ccsCOMPL_STAT  fcdpTELGetAlarmMode (
				    vltINT32 pulpoID, 
				    vltINT32 hID,
				    vltINT32 *mode,
				    ccsERROR *pErr
				    );

#ifdef  __cplusplus
}
#endif
#endif /*!FCDPTELEM_H*/
