#ifndef fcdtimsTIME_H
#define fcdtimsTIME_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: fcdtimsTIME.h,v 1.6 2004/01/19 09:25:54 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* rdonalds  17/06/96  created
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif


#include "fcd.h"

class fcdtimsTIME
{
public:
    fcdtimsTIME();
    ~fcdtimsTIME();

    void             SetToCCSTime (ccsTIMEVAL t) {timsTime = t;}
    void 	     SetToZero();		// set to 0
    void 	     SetToInfinity();		// set to 0
    ccsCOMPL_STAT    SetToNow();		// set to now using tims
    void	     SetMs(double milliseconds);// set to a number of ms
    void             SetMJD(double mjd);        // set to a particular MJD
    void	     SetS(double seconds);	// set to a number of s


    // store time as string in str
    // format should be timsABS_TIME, timsTIME_OF_DAY
    // as defined for timsTimeToString
    ccsCOMPL_STAT ToString (
			    char *str,
			    timsTIME_FORMAT format,
			    ccsERROR *error
			    );

    double 	Seconds();		// Retrieve as seconds
    long 	Microseconds();		// Retrieve the Microseconds
    double      MJD();                  // Value as a MJD
    double 	Milliseconds();		// Retrieve the total as ms
    ccsTIMEVAL  &CCSTime (){return timsTime;}

    fcdtimsTIME	operator+ (const fcdtimsTIME &) const;
    fcdtimsTIME	operator+ (vltDOUBLE) const;     // add seconds
    fcdtimsTIME	operator- (vltDOUBLE) const;     // add seconds
    fcdtimsTIME	operator- (const fcdtimsTIME &) const;
    int		operator> (const fcdtimsTIME &) const;
    int		operator>= (const fcdtimsTIME &) const;
    int		operator< (const fcdtimsTIME &) const;
    int		operator<= (const fcdtimsTIME &) const;
    int		operator== (const fcdtimsTIME &) const;

  private:
    ccsTIMEVAL	timsTime;
};


#endif /*!fcdtimsTIME_H*/
