#ifndef fndASSOCIATION_H
#define fndASSOCIATION_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: fndASSOCIATION.h,v 1.46 2005/04/08 07:41:45 vltsccm Exp $" 
*
* who       when      what
* --------  --------  ----------------------------------------------
* gchiozzi 2005-04-08 Empty value for Key and Value is NOOBJECT.
* gchiozzi 2001-12-06 Init delItemsOnDelete in default constructor
* gchiozzi  04/01/00  Renamed destroy as destroyFlag to avoid shadowing
* gchiozzi  03/01/00  Copy Constructor: added explicit call to base copy constructor
* vltsw  02/07/96  Added DelItemsOnDelete()
* G.Chiozzi 18/01/95  Created
* 
*/

/************************************************************************
*
*----------------------------------------------------------------------
*/

#ifndef fndPort_H
  #include <fndPort.h>
#endif
#ifndef fndOBJECT_H
  #include <fndOBJECT.h>
#endif

#define fndASSOCIATION_CLASS    (classType)fndASSOCIATION::CreateNew

class fndASSOCIATION : public fndOBJECT
{
  public:

    fndASSOCIATION( ) { aKey=fndOBJECT::ZERO; aValue=fndOBJECT::ZERO; delItemsOnDelete=FALSE;}
    fndASSOCIATION( fndOBJECT &k, fndOBJECT &v ) 
        { aKey = &k; aValue = &v; delItemsOnDelete=FALSE;}
    fndASSOCIATION( const fndASSOCIATION &a ) :
	fndOBJECT(a)
	{ aKey=a.aKey; aValue=a.aValue; delItemsOnDelete=a.delItemsOnDelete; }
    virtual ~fndASSOCIATION();

    fndOBJECT &Key() const { return *aKey; }
    fndOBJECT &Value() const { return *aValue; }
    virtual void SetKey(   fndOBJECT &k ); 
    virtual void SetValue( fndOBJECT &v );
    virtual hashValueType HashValue() const { return aKey->HashValue(); }
    virtual int IsEqual( const fndOBJECT &toTest) const;
    virtual int IsAssociation() const { return 1; }

    virtual void  PrintOn( ostream& outputStream)const;

    virtual void DelItemsOnDelete(int destroyFlag = TRUE) 
                     { delItemsOnDelete=destroyFlag; };

  protected:
    int       delItemsOnDelete;

  private:

    fndOBJECT *aKey;
    fndOBJECT *aValue;
    
    fndStdObjectDef(fndASSOCIATION, fndOBJECT)

};

#endif

/* __o0o__ */
