#ifndef fndBAG_H
#define fndBAG_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: fndBAG.h,v 1.46 2005/04/08 07:41:45 vltsccm Exp $" 
*
* who       when      what
* --------  --------  ----------------------------------------------
* vltsw  02/07/96  Added destructor
* gchiozzi  14/11/95  Deleted virtual outside class declaration
* G.Chiozzi 18/01/95  Created
* 
*/

/************************************************************************
*
*----------------------------------------------------------------------
*/

#ifndef fndPort_H
  #include <fndPort.h>
#endif
#ifndef fndResource_H
  #include <fndResource.h>
#endif
#ifndef fndHASH_TABLE_H
  #include <fndHASH_TABLE.h>
#endif

#define fndBAG_CLASS          (classType)fndBAG::CreateNew

class fndBAG : public fndCOLLECTION
{
  public:

    fndBAG( sizeType bagSize = fndDEFAULT_BAG_SIZE );
    ~fndBAG();

    virtual void      Add( fndOBJECT &o );
    virtual void      Detach( const fndOBJECT &o, int dt=0) ;
    virtual int       IsEmpty() const;
    virtual countType GetItemsInContainer() const;
            void      ForEach( iterFuncType f, void *args ) const;

    const fndOBJECT &FirstThat( condFuncType f, void *args) const;
    const fndOBJECT &LastThat( condFuncType f, void *args) const;

    virtual int        HasMember( const fndOBJECT  &o ) const;
    virtual fndOBJECT &FindMember( const fndOBJECT  &o ) const;
    virtual void       Empty( int deleteToo=FALSE );
    virtual void       PrintOn( ostream& ) const;

    virtual fndCONTAINER_ITERATOR  &InitIterator() const;

  private:
    fndHASH_TABLE table;
    fndStdObjectDef(fndBAG, fndCOLLECTION)
};


/* Inline methods */

inline fndBAG::fndBAG( sizeType bagSize) : table( bagSize ) 
{ 
}

inline void fndBAG::Empty( int deleteToo) 
{
    table.Empty( deleteToo );
}

inline fndBAG::~fndBAG()
{ 
    Empty(delItemsOnDelete);
}

inline void fndBAG::Add( fndOBJECT &o ) 
{ 
    table.Add( o ); 
}

inline void fndBAG::Detach( const fndOBJECT &o, int dt) 
{ 
    table.Detach( o, dt ); 
}

inline int fndBAG::IsEmpty() const 
{ 
    return table.IsEmpty(); 
}

inline countType fndBAG::GetItemsInContainer() const 
{
    return table.GetItemsInContainer();
}

inline void fndBAG::ForEach( iterFuncType f, void *args ) const 
{
    table.ForEach( f, args );
}

inline const fndOBJECT &fndBAG::FirstThat( condFuncType f, void *args) const 
{
    return table.FirstThat( f, args );
}

inline const fndOBJECT &fndBAG::LastThat( condFuncType f, void *args) const 
{
    return table.LastThat( f, args );
}

inline int fndBAG::HasMember( const fndOBJECT  &o ) const 
{
    return table.HasMember( o );
}

inline fndOBJECT &fndBAG::FindMember( const fndOBJECT  &o ) const 
{
    return table.FindMember(o);
}

inline fndCONTAINER_ITERATOR  &fndBAG::InitIterator() const 
{
    return table.InitIterator();
}


#endif

/* __o0o__ */
