#ifndef fndCONTAINER_H
#define fndCONTAINER_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: fndCONTAINER.h,v 1.46 2005/04/08 07:41:46 vltsccm Exp $" 
*
* who       when      what
* --------  --------  ----------------------------------------------
* gchiozzi 2002-07-31 gcc 3.1: Replace <xxx.h> sys includes with <xxx>a
* gchiozzi  04/01/00  Renamed destroy as destroyFlag to avoid shadowing
* vltsw  02/07/96  Added deletion of items on delete.
* 
*/

/************************************************************************
*
*----------------------------------------------------------------------
*/

#ifndef fndPort_H
  #include <fndPort.h>
#endif

#include <iostream>

#ifndef fndOBJECT_H
  #include <fndOBJECT.h>
#endif


/***********/
/* Defines */
/***********/

#define fndCONTAINER_CLASS       (classType)fndCONTAINER::CreateNew

class fndCONTAINER:  public fndOBJECT
{
  friend  class fndCONTAINER_ITERATOR;
  public:

    fndCONTAINER() { itemsInContainer = 0; delItemsOnDelete = FALSE;}
    fndCONTAINER( const fndCONTAINER& );

    virtual ~fndCONTAINER();

    virtual hashValueType HashValue() const;
    virtual int       IsEqual( const fndOBJECT& ) const;
    virtual void      ForEach( iterFuncType, void* ) const;
    virtual void      PrintOn( ostream& ) const;
    virtual void      PrintHeader( ostream& ) const;
    virtual void      PrintSeparator( ostream& ) const;
    virtual void      PrintTrailer( ostream& ) const;

    virtual const fndOBJECT& FirstThat( condFuncType, void* ) const;
    virtual const fndOBJECT& LastThat( condFuncType, void* ) const;

    virtual fndCONTAINER_ITERATOR& InitIterator() const = 0;

    int IsEmpty() const { return (itemsInContainer == 0); }
    /* Returns a 1 if the container has no member. */

    virtual void Empty( int destroyFlag = FALSE ) {destroyFlag=TRUE; /* VOID code */ };
    virtual void DelItemsOnDelete(int destroyFlag = TRUE) 
                     { delItemsOnDelete=destroyFlag; };

    countType GetItemsInContainer() const { return itemsInContainer; }
    /* Returns the current number of objects in any container. */

    fndStdObjectDef(fndCONTAINER,fndOBJECT)

  protected:

    countType itemsInContainer;
    int       delItemsOnDelete;

};



class  fndCONTAINER_ITERATOR 
{
  public:

    virtual                ~fndCONTAINER_ITERATOR();
    virtual  fndOBJECT     &GetCurrent() = 0;
    virtual  operator       int() = 0;
    virtual  operator       fndOBJECT&() = 0;

    virtual  fndOBJECT     &operator ++(int) = 0;
    virtual  fndOBJECT     &operator ++() = 0;

    virtual  void           Restart() = 0;
};



#endif /*!fndCONTAINER_H*/

/* __o0o__ */
