#ifndef fndDEQUE_H
#define fndDEQUE_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: fndDEQUE.h,v 1.46 2005/04/08 07:41:46 vltsccm Exp $" 
*
* who       when      what
* --------  --------  ----------------------------------------------
* vltsw  02/07/96  Added call to correct empty in destructor
* G.Chiozzi 18/01/95  Created
* 
*/

/************************************************************************
*
*----------------------------------------------------------------------
*/

#ifndef fndPort_H
  #include <fndPort.h>
#endif

#ifndef fndCONTAINER_H
  #include <fndCONTAINER.h>
#endif
#ifndef fndLIST_H
  #include <fndLIST.h>
#endif

#define fndDEQUE_CLASS      (classType)fndDEQUE::CreateNew

class fndDEQUE : public fndCONTAINER
{
  public:

    ~fndDEQUE() { Empty(delItemsOnDelete); }

    fndOBJECT &PeekLeft() const { return list.PeekAtHead(); }
    fndOBJECT &PeekRight() const { return list.PeekAtTail(); }
    fndOBJECT &GetLeft();
    fndOBJECT &GetRight();
    void        PutLeft( fndOBJECT &o ) {
        list.AddAtHead( o );
        itemsInContainer++;
	}
    void        PutRight( fndOBJECT &o ) {
        list.AddAtTail( o );
        itemsInContainer++;
	}
    virtual void Empty( int deleteToo = FALSE ) {
        list.Empty( deleteToo );
	}
    virtual int IsEmpty() const { return list.IsEmpty(); }
    virtual countType GetItemsInContainer() const {
        return list.GetItemsInContainer();
	}
    virtual void ForEach( iterFuncType f, void  *arg ) const {
        list.ForEach( f, arg );
	}
    virtual const fndOBJECT  &FirstThat( condFuncType f, void  *arg ) const {
        return list.FirstThat( f, arg );
	}
    virtual const fndOBJECT  &LastThat( condFuncType f, void  *arg ) const {
        return list.LastThat( f, arg );
	}

    virtual hashValueType HashValue() const { return list.HashValue(); }
    virtual int           IsEqual( const fndOBJECT &obj ) const {
        return list.IsEqual( obj );
	}
    virtual int  IsSortable() const { return list.IsSortable(); }
    virtual int  IsAssociation() const { return list.IsAssociation(); }
    virtual void PrintOn( ostream& os ) const {
        os << NameOf() << " {\n" << list << "} end " << NameOf() << '\n'; }

    virtual fndCONTAINER_ITERATOR &InitIterator() const;

  private:
    
    fndLIST list;

    fndStdObjectDef(fndDEQUE, fndCONTAINER)
};

#endif

/* __o0o__ */
