#ifndef fndFLOAT_H
#define fndFLOAT_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: fndFLOAT.h,v 1.46 2005/04/08 07:41:46 vltsccm Exp $" 
*
* who       when      what
* --------  --------  ----------------------------------------------
* gchiozzi  03/01/00  Copy Constructor: added explicit call to base copy constructor
* G.Chiozzi 18/01/95  Created
* 
*/

/************************************************************************
*
*----------------------------------------------------------------------
*/

#ifndef fndPort_H
  #include <fndPort.h>
#endif

#ifndef fndSORTABLE_H
  #include <fndSORTABLE.h>
#endif

#define fndFLOAT_CLASS   (classType)fndFLOAT::CreateNew

class fndFLOAT:  public fndSORTABLE {

  public:

    fndFLOAT( const float aFloat=0 );
    fndFLOAT( const fndFLOAT& sourceFloat );

    virtual   int       IsEqual( const fndOBJECT& ) const;
    virtual   int       IsLessThan( const fndOBJECT& ) const;
    virtual   void      PrintOn( ostream& ) const;

    fndFLOAT  &operator         =( const fndFLOAT& );
    operator const float() const;

    fndStdObjectDef(fndFLOAT, fndSORTABLE)
	
  protected:
    float       theFloat;
};

/* inline methods */

inline fndFLOAT::fndFLOAT(const float aFloat): theFloat(aFloat) {}

inline fndFLOAT::fndFLOAT(const fndFLOAT& sourceFloat) :
    fndSORTABLE(sourceFloat),
    theFloat( sourceFloat.theFloat) {}

inline fndFLOAT::operator const float() const { return theFloat; }

#endif

/* __o0o__ */
