#ifndef fndHASH_TABLE_H
#define fndHASH_TABLE_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: fndHASH_TABLE.h,v 1.46 2005/04/08 07:41:46 vltsccm Exp $" 
*
* who       when      what
* --------  --------  ----------------------------------------------
* G.Chiozzi 18/01/95  Created
* 
*/

/************************************************************************
*
*----------------------------------------------------------------------
*/

#ifndef fndPort_H
  #include <fndPort.h>
#endif

#ifndef fndResource_H
  #include <fndResource.h>
#endif
#ifndef fndCOLLECTION_H
  #include <fndCOLLECTION.h>
#endif
#ifndef fndLIST_H
  #include <fndLIST.h>
#endif
#ifndef fndARRAY_H
  #include <fndARRAY.h>
#endif

class fndCONTAINER_ITERATOR;
class fndHASH_TABLE;
class fndHASH_TABLE_ITERATOR;

#define fndHASH_TABLE_CLASS          (classType)fndHASH_TABLE::CreateNew

class fndHASH_TABLE : public fndCOLLECTION
{
  public:

    friend class fndHASH_TABLE_ITERATOR;

    fndHASH_TABLE( sizeType = fndDEFAULT_HASH_TABLE_SIZE );
    virtual ~fndHASH_TABLE();

    virtual void Add( fndOBJECT  &toAdd );
    virtual void Detach( const fndOBJECT &toDetach, int deleteToo= 0 );
    virtual void Empty( int deleteToo = FALSE );

    virtual   void      PrintOn( ostream& ) const;

    virtual int IsEmpty() const {
        return itemsInContainer == 0;
	}
    virtual countType GetItemsInContainer() const {
        return itemsInContainer;
	}
    virtual fndOBJECT             &FindMember(const fndOBJECT &toFind ) const;
    virtual fndCONTAINER_ITERATOR &InitIterator() const;

  private:

    hashValueType GetHashValue( const fndOBJECT & ) const;
    sizeType      size;
    fndARRAY      table;

    fndStdObjectDef(fndHASH_TABLE, fndCOLLECTION)
};


class fndHASH_TABLE_ITERATOR : public fndCONTAINER_ITERATOR
{
  public:

    fndHASH_TABLE_ITERATOR( const fndHASH_TABLE  & );
    ~fndHASH_TABLE_ITERATOR();
    
    virtual operator int();
    virtual operator fndOBJECT&();

    virtual fndOBJECT  &GetCurrent();
    virtual fndOBJECT  &operator ++ ( int );
    virtual fndOBJECT  &operator ++ ();
    virtual void        Restart();

  private:
    
    fndCONTAINER_ITERATOR  *arrayIterator;
    fndCONTAINER_ITERATOR  *listIterator;
    const fndHASH_TABLE    &beingIterated;

    void Scan();
};


/* Inline methods */

inline hashValueType fndHASH_TABLE::GetHashValue( 
			const fndOBJECT  &ofObject ) const
{
    return ofObject.HashValue() % size;
}


#endif

/* __o0o__ */
