#ifndef fndINT_H
#define fndINT_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: fndINT.h,v 1.46 2005/04/08 07:41:46 vltsccm Exp $" 
*
* who       when      what
* --------  --------  ----------------------------------------------
* gchiozzi  03/01/00  Copy COnstructor: added explicit call to base copy constructor
* gchiozzi  09/05/95  Corrected bug: inline function had no "inline" keyword
* gchiozzi  18/01/95  Created
* 
*/

/************************************************************************
*
*----------------------------------------------------------------------
*/

#ifndef fndPort_H
  #include <fndPort.h>
#endif
#ifndef fndSORTABLE_H
  #include <fndSORTABLE.h>
#endif

#define fndINT_CLASS   (classType)fndINT::CreateNew

class fndINT:  public fndSORTABLE {

  public:
    fndINT( const int anInt=0 );
    fndINT( const fndINT& sourceInteger );

    virtual hashValueType HashValue() const;

    virtual   int       IsEqual( const fndOBJECT& ) const;
    virtual   int       IsLessThan( const fndOBJECT& ) const;
    virtual   void      PrintOn( ostream& ) const;

    fndINT  &operator         =( const fndINT& );
    operator const int() const;

    fndStdObjectDef(fndINT, fndSORTABLE)

  private:
    int       theInteger;
};

inline fndINT::fndINT( const int anInt)    
{ 
    theInteger = anInt; 
}

inline fndINT::fndINT( const fndINT& sourceInteger ) : 
    fndSORTABLE(sourceInteger)
{
    theInteger = sourceInteger.theInteger; 
}

inline hashValueType fndINT::HashValue() const 
{ 
    return (hashValueType)theInteger;
}

inline fndINT::operator const int() const 
{ 
    return theInteger; 
}

#endif

/* __o0o__ */
