#ifndef fndNAME_MAP_H
#define fndNAME_MAP_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: fndNAME_MAP.h,v 1.46 2005/04/08 07:41:48 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* bgilli    03/03/2005  added stdlib.h needed for size_t define.
* bgilli    02/07/2003  nelem is now ulong for new gcc, only HP.
* bgilli    10/06/2003  nelem is now ulong for new gcc.
* gchiozzi  03/05/95  created
*/

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

#include <stdlib.h>


#define fndNELEM(array) (sizeof(array)/sizeof((array)[0]))
struct fndNAME_AND_INDEX {
    const char *name;
    unsigned int   index;
};

class fndNAME_MAP {
  public:
    fndNAME_MAP(fndNAME_AND_INDEX *array, unsigned int nelem);
    const char *String(unsigned int index) const;
    int         Index(const char *string) const;

  protected:
    static int compString(const void *, const void *);
    static int compIndex(const void *, const void *);

  private:
    fndNAME_AND_INDEX *data;
    size_t nelem;

};

#endif /*!fndNAME_MAP_H*/

/* __o0o__ */
