#ifndef fndPOINTER_H
#define fndPOINTER_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: fndPOINTER.h,v 1.46 2005/04/08 07:41:47 vltsccm Exp $" 
*
* who       when      what
* --------  --------  ----------------------------------------------
* gchiozzi  03/01/00  Copy Constructor: added explicit call to base copy constructor
* G.Chiozzi 18/01/95  Created
* 
*/

/************************************************************************
*
*----------------------------------------------------------------------
*/

#ifndef fndPort_H
  #include <fndPort.h>
#endif

#ifndef fndOBJECT_H
  #include <fndOBJECT.h>
#endif

#define fndPOINTER_CLASS   (classType)fndPOINTER::CreateNew

class fndPOINTER:  public fndOBJECT {

  public:

    fndPOINTER(caddr_t newValue = NULL);
    fndPOINTER(const fndPOINTER &newPointer);

    virtual caddr_t GetValue();
    virtual int   IsEqual(const fndOBJECT&) const;
    virtual void  PrintOn(ostream&) const;

    fndPOINTER &operator =(const fndPOINTER&);
    operator const caddr_t () const;

    fndStdObjectDef(fndPOINTER,fndOBJECT)
    
  protected:
         caddr_t thePointer;
};


inline fndPOINTER::fndPOINTER( caddr_t newValue )
{
 thePointer = newValue;
}

inline fndPOINTER::fndPOINTER( const fndPOINTER& sourcePointer ):
    fndOBJECT(sourcePointer)
{
 thePointer = sourcePointer.thePointer;
}

inline caddr_t fndPOINTER::GetValue() 
{ 
    return thePointer; 
}

inline fndPOINTER::operator const caddr_t () const
{
 return thePointer;
}


#endif

/* __o0o__ */
