#ifndef fndSORTABLE_H
#define fndSORTABLE_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: fndSORTABLE.h,v 1.46 2005/04/08 07:41:48 vltsccm Exp $" 
*
* who       when      what
* --------  --------  ----------------------------------------------
* gchiozzi  03/01/00  Added constructors
* gchiozzi  29/03/96  Relational operators now return bool instead of int
* G.Chiozzi 18/01/95  Created
* 
*/

/************************************************************************
*
*----------------------------------------------------------------------
*/


#ifndef fndPort_H
  #include <fndPort.h>
#endif
#ifndef fndOBJECT_H
  #include <fndOBJECT.h>
#endif

#define fndSORTABLE_CLASS        (classType)fndSORTABLE::CreateNew

class  fndSORTABLE:  public fndOBJECT {

  protected:
    
  public:
    fndSORTABLE();
    fndSORTABLE( const fndSORTABLE& );
    
    virtual ~fndSORTABLE();
    
    virtual  int IsLessThan( const fndOBJECT& ) const;
    virtual  int IsSortable() const;
    
    fndStdObjectDef(fndSORTABLE,fndOBJECT)
};


inline  int fndSORTABLE::IsLessThan( const fndOBJECT& ) const 
{ 
    return FALSE; 
}


inline  bool operator < ( const fndSORTABLE& test1, const fndSORTABLE& test2 )

/*      Determines whether the first object is less than the second.  We
        do type checking on the two objects (objects of different
        classes can't be compared, even if they're derived from each other).

        Parameters: test1 -  The first object we are testing.
                    test2 -  The second object we are testing.

        Return value: Returns 1 if this is less than a test object. */

{
        return ( (test1.IsA() == test2.IsA()) && test1.IsLessThan(test2) );
}


inline  bool operator > ( const fndSORTABLE& test1, const fndSORTABLE& test2 )

/*      Determines whether the first object is greater than the second.  We
        just reverse the condition returned from operator < and test for
        inequality.

        Parameters: test1 - The first object we are testing.
                    test2 - The second object we are testing.

        Return value: Returns 1 if this is greater than a test object. */


{
        return !( test1 < test2 ) && test1 != test2;
}


inline  bool operator >=( const fndSORTABLE& test1, const fndSORTABLE& test2 )

/*      Determines whether the first object is greater than or equal to
        the second.  We just reverse the condition returned from operator <.

        Parameters: test1 - The first object we are testing.
                    test2 - The second object we are testing.

        Return value: Returns 1 if this is greater than or equal to a
                      test object.  */

{
        return ( !( test1 <( test2 ) ) );
}


inline  bool operator <=( const fndSORTABLE& test1, const fndSORTABLE& test2 )

/*      Determines whether test1 is less than or equal to test2.
        We just combine the less than and equal to operators.

        Parameters: test1 - The first object we are testing.
                    test2 - The second object we are testing.

        Return value: Returns 1 if this is less than or equal to a test. */

{
        return ( test1 < test2 || test1 == test2 );
}

#endif

/* __o0o__ */
