#ifndef fndSTACK_H
#define fndSTACK_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: fndSTACK.h,v 1.46 2005/04/08 07:41:48 vltsccm Exp $" 
*
* who       when      what
* --------  --------  ----------------------------------------------
* vltsw  02/07/96  Added destructor to call correct Empty()
* G.Chiozzi 18/01/95  Created
* 
*/

/************************************************************************
*
*----------------------------------------------------------------------
*/

#ifndef fndPort_H
  #include <fndPort.h>
#endif
#ifndef fndCONTAINER_H
  #include <fndCONTAINER.h>
#endif
#ifndef fndLIST_H
  #include <fndLIST.h>
#endif

#define fndSTACK_CLASS    (classType)fndSTACK::CreateNew

class fndSTACK : public fndCONTAINER
{
  public:

    ~fndSTACK();

    void        Push( fndOBJECT  & );
    fndOBJECT  &Pop();
    fndOBJECT  &Top() const;

    virtual countType        GetItemsInContainer() const;
    virtual void             ForEach(iterFuncType f, void  *arg ) const;
    virtual const fndOBJECT &FirstThat(condFuncType f, void  *arg ) const;
    virtual const fndOBJECT &LastThat(condFuncType f, void  *arg ) const;
    virtual hashValueType    HashValue() const;
    virtual void             Empty(int deleteToo = FALSE );
    virtual int              IsAssociation() const;
    virtual int              IsEmpty() const;
    virtual int              IsEqual(const fndOBJECT& obj ) const;
    virtual int              IsSortable() const;
    virtual void             PrintOn(ostream& os ) const;

    virtual fndCONTAINER_ITERATOR  &InitIterator() const;

private:

    fndLIST list;

    fndStdObjectDef(fndSTACK, fndCONTAINER)
};


/* Inline methods */

inline fndOBJECT  &fndSTACK::Top() const   
{ 
    return list.PeekAtHead(); 
}

inline int fndSTACK::IsEmpty() const 
{ 
    return list.IsEmpty(); 
}

inline countType fndSTACK::GetItemsInContainer() const 
{
    return list.GetItemsInContainer();
}

inline void fndSTACK::ForEach( iterFuncType f, void  *arg ) const 
{
    list.ForEach( f, arg );
}

inline const fndOBJECT &fndSTACK::FirstThat(condFuncType f, void  *arg ) const 
{
    return list.FirstThat( f, arg );
}

inline const fndOBJECT &fndSTACK::LastThat(condFuncType f, void  *arg ) const 
{
    return list.LastThat( f, arg );
}

inline hashValueType fndSTACK::HashValue() const 
{ 
    return list.HashValue(); 
}
    
inline void fndSTACK::Empty(int deleteToo) 
{
    list.Empty( deleteToo );
}

inline int fndSTACK::IsEqual( const fndOBJECT& obj ) const 
{
    return list.IsEqual( obj );
}

inline int fndSTACK::IsSortable() const 
{ 
    return list.IsSortable(); 
}
    
inline int fndSTACK::IsAssociation() const 
{ 
    return list.IsAssociation(); 
}

inline void fndSTACK::PrintOn( ostream& os ) const 
{
    os << NameOf() << " {\n" << list << "} end " << NameOf() << '\n'; 
}
    
#endif

/* __o0o__ */
