#ifndef fntpubACCESS_DATA_H
#define fntpubACCESS_DATA_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: fntpubAccessData.h,v 1.16 2004/08/12 10:20:13 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* jott      23/06/03  changed interfaces of all functions. Database parameters
*                     now are only specified by environment variables.
* jott      18/02/03  added definition 'fntpubPERF_DATA_NUM_ELEMENTS' and
*                     structure 'fntpubPERF_DATA'
*                     changed interface of fntpubInitLib() function
*                     added function fntpubClearPerformanceData()
* jott      07/08/02  quick-shot adaption for use with ISS
* jott      04/06/02  created
*/

/************************************************************************
 * Public interface definition of the FINITO data access library
 *----------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

#include "db.h"
#include "fntpubDefines.h"

/*
 * FINITO performance data
 */
#define fntpubPERF_DATA_NUM_ELEMENTS   13
typedef struct
    {
    vltLOGICAL     perfDataValid;
    vltDOUBLE      opdPhaseMeanCh1;
    vltDOUBLE      opdPhaseMeanCh2;
    vltDOUBLE      opdPhaseRmsCh1;
    vltDOUBLE      opdPhaseRmsCh2;
    vltDOUBLE      opdCoherenceMeanCh1;
    vltDOUBLE      opdCoherenceMeanCh2;
    vltDOUBLE      opdCoherenceRmsCh1;
    vltDOUBLE      opdCoherenceRmsCh2;
    vltDOUBLE      visibilityMeanCh1;
    vltDOUBLE      visibilityMeanCh2;
    vltDOUBLE      visibilityRmsCh1;
    vltDOUBLE      visibilityRmsCh2;
    }fntpubPERF_DATA;


/*
 * global variables
 */
extern fntpubPERF_DATA     gFntpubPerfData;
extern dbLISTID            gReadPerfData;
extern dbLISTID            gWritePerfData;


/*
 *******************************************************************************
 *                                                                             *
 *  Common initialization function for the library                             *
 *                                                                             *
 *******************************************************************************
 */
ccsCOMPL_STAT fntpubInitLib(ccsERROR *error = NULL);

/*
 *******************************************************************************
 *                                                                             *
 *  Performance Data access function                                           *
 *                                                                             *
 *******************************************************************************
 */
ccsCOMPL_STAT fntpubGetPerformanceData(ccsERROR *error = NULL);

/*
 *******************************************************************************
 *                                                                             *
 *  Function cleaning the local copy of FINITO performance data                *
 *                                                                             *
 *******************************************************************************
 */
ccsCOMPL_STAT fntpubClearPerformanceData(ccsERROR *error = NULL);


#endif /* ! fntpubACCESS_DATA_H */

/* __oOo__  */
