#ifndef fntpubLINT_H
#define fntpubLINT_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: fntpubLint.h,v 1.16 2004/08/12 10:20:14 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* jott      04/06/02  created
*/

/************************************************************************
 * Decide whether PC Lint is used for code checking
 *----------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

#ifdef PC_LINT
    /*
     * PC_LINT is defined:
     * Because the Windows system can not correctly distinguish between lower
     * and upper case letters, we use links for the different ccs include files
     * as follows:
     *
     *  ccs.h  is linked to lcl_ccs.h     (lower case letters)
     *  CCS.h  is linked to ucl_ccs.h     (upper case letters)
     *  eccs.h is linked to lcl_eccs.h    (lower case letters)
     *  ECCS.h is linked to ucl_eccs.h    (upper case letters)
     */
    #include "lcl_ccs.h"
    #include "ucl_ccs.h"
    #include "lcl_eccs.h"
    #include "ucl_eccs.h"

#else
    /*
     * PC_LINT is not defined:
     * We can use the normal names of ccs include files.
     */
    #include "ccs.h"
    #include "CCS.h"
    #include "eccs.h"
    #include "ECCS.h"
#endif  /* !PC_LINT */

#endif /* ! fntpubLINT_H */

/* __oOo__  */
