#ifndef ibacERR_H
#define ibacERR_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: ibacErr.h,v 1.33 2005/09/01 15:18:02 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* dumont    15/09/99  created
* gzins     22/11/99  for OCT99, removed #pragma macro used for ATTOL 
*                     (not supported by the new GNU C preprocessor)
* gzins     11/09/00  removed NOCCS support
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */

#ifdef __cplusplus
extern "C" {
#endif

/*
 * VLT Software Headers
 */
#include "ccs.h"
    
/*
 * Functions' Prototype
 */
   
#ifndef IN
#define IN
#define OUT
#endif

/* log an error */
extern ccsCOMPL_STAT ibacErrorAdd(
    OUT ccsERROR    *error,       /* Error structure      */
    IN  ccsMODULEID  moduleID,    /* ID of current module */
    IN  ccsLOC_ID    locID,       /* Error's location     */
    IN  int          errorNumber, /* Number of error      */
    IN  ...
);  

/*
 * Macros
 */

#ifndef __cplusplus
#ifndef __FILE_LINE__
#define ibacIToStr(a) #a
#define ibacIToStr2(a) ibacIToStr(a) 
#define __FILE_LINE__ __FILE__ ":" ibacIToStr2(__LINE__)
#endif
#endif

#define ibacErrAdd(_errNum,_arg...) \
    ibacErrorAdd(error, APP_MODULE_ID, __FILE_LINE__, _errNum, ##_arg)

#ifdef __cplusplus
}
#endif

#endif /*!ibacERR_H*/
