#ifndef ic0COMPONENT_H
#define ic0COMPONENT_H
/*******************************************************************************
* E.S.O. - VLT project
#
# "@(#) $Id: ic0COMPONENT.h,v 2.14 2005/09/22 07:54:20 vltsccm Exp $" 
*
* ic0COMPONENT.h
*
* who       when      what
* --------  --------  ----------------------------------------------
* therlin   10/01/96  Created
*/

/************************************************************************
*
*----------------------------------------------------------------------
*/

#include <fndOBJECT.h>
#include "ECCS.h"
#include "ic0KEYWORD.h"
#include "ic0HANDLER.h"
#include "ic0DEBUG.h"


class ic0COMPONENT: public fndOBJECT, public eccsERROR_CLASS
{
  public:
    ic0COMPONENT();
    ic0COMPONENT(ic0HANDLER *handler,char *keyw);
    ic0COMPONENT(const ic0COMPONENT &source);

    virtual ~ic0COMPONENT();

    fndStdObjectDef(ic0COMPONENT, fndOBJECT)

    virtual ccsCOMPL_STAT TestTrigger(const ic0KEYWORD &keyword, void*);

    virtual ccsCOMPL_STAT GetKeywords(vltINT32 *no,
				      ic0KEYWORD **keywPtr,
				      msgCMD cmd);

    virtual ccsCOMPL_STAT SetValue(const char *value);
    virtual ccsCOMPL_STAT Valid(const vltLOGICAL);
    virtual vltLOGICAL    Valid();
    virtual ccsCOMPL_STAT ClearFlags();
    
    // Data accessing methods
    ccsCOMPL_STAT Id(const char *newId);
    const char *Id() const;

    ccsCOMPL_STAT DbRef(const dbSYMADDRESS newRef);
    const char    *DbRef() const;

    ic0COMPONENT &operator =(const ic0COMPONENT &source);

  protected:
    dbSYMADDRESS        dbRef;
    vltBYTES32          id;
    vltLOGICAL          setupFlag;
    vltLOGICAL          statusFlag;
    vltLOGICAL          valid;

    ic0DEBUG            debug;
  private:
    

}; /* end class ic0COMPONENT */

inline ccsCOMPL_STAT ic0COMPONENT::Valid(const vltLOGICAL value) 
{    
    valid = value;
    return SUCCESS;
};

inline vltLOGICAL ic0COMPONENT::Valid() {
    return (valid);
};
#endif /*!ic0COMPONENT_H*/











