#ifndef ic0CtrlMAIN_HANDLER_H
#define ic0CtrlMAIN_HANDLER_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: ic0CtrlMAIN_HANDLER.h,v 2.14 2005/09/22 07:54:25 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* alongino  16/06/97  created
*/

/************************************************************************
 * This file contains definitions used by class ic0CtrlMAIN_HANDLER
 *----------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

/* 
 * VLT Headers
 */

#define ic0LCU_NUM 10           // maximum number of LCUs supported
#define ic0LCU_SERVER	"ic0lcuServer"
#include "ic0lcuINTERFACE.h"    // ic0lcuSERVER 
#include "ic0SERVER.h"          // ic0SERVER
#include "ic0MAIN_HANDLER.h"    // parent class

class ic0CtrlMAIN_HANDLER : public ic0MAIN_HANDLER
{
  public:
      ic0CtrlMAIN_HANDLER(char *cfg);     // constructor

  protected:
      vltINT32 lcuNum;                    // number of lcus used
      vltINT32 lcuTot;                    // number of total lcus defined
      vltINT32 lcuIndex[ic0LCU_NUM];      // index, taking into account LCUs not available
      ic0lcuSERVER lcuServer[ic0LCU_NUM]; // lcus information
      dbSYMADDRESS dbRoot;                // OLDB root point for ICS WS proc.

      virtual ccsCOMPL_STAT CreateServer(const char *version); // create server and model
      virtual ic0SERVER *NewServer(ccsPROCNAME  simServer); // create server
      virtual ccsCOMPL_STAT DeleteServer(); // delete server instance
      virtual void Usage();                 // on-line help method
      virtual ccsCOMPL_STAT Parse(int argc, char *argv[]); // parse runstring

  private:
      ic0SERVER *ic0Server;               // pointer to server used

      void Defaults();                    // defaults setting method
      ccsCOMPL_STAT setMode();            // set operational mode
      char *ProcName(char *prefix);       // return server process name
};


#endif /*!ic0CtrlMAIN_HANDLER_H*/
