#ifndef IC0_DEBUG_H
#define IC0_DEBUG_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: ic0DEBUG.h,v 2.14 2005/09/22 07:54:20 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* therlin   21/11/95  Created  
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */


#include "ic0.h"
#include "ECCS.h"

/*
 * Class definition
 */
class ic0DEBUG
{
  public: 
    ic0DEBUG();
   ~ic0DEBUG();
    ccsCOMPL_STAT Log(ccsMODULEID mod,
		      vltINT32 level,
		      const char *logText, ...);
    ccsCOMPL_STAT SetLevel(vltINT32);
    vltINT32      GetLevel();
    ccsCOMPL_STAT SetVerbose(vltLOGICAL);
    vltLOGICAL    GetVerbose();
    ccsCOMPL_STAT SetLog(vltLOGICAL);
    vltLOGICAL    GetLog();
    ccsCOMPL_STAT TimeoutTime(ccsTIMEVAL *);
    ccsTIMEVAL    *TimeoutTime();

  protected:    
    static vltINT32   debugLevel;
    static vltLOGICAL verbose;
    static vltLOGICAL log;
    static vltLOGICAL timeout;
    static ccsTIMEVAL time;
 
  private:
};

/*
 * Convenience macros
 */
#define IC0_LOG0(format, arg...) \
	debug.Log(ic0MOD, 0,"0 - " __FILE_LINE__ ":\t" format, ##arg)

#define  IC0_LOG1(format, arg...) \
	debug.Log(ic0MOD, 1,"1 - " __FILE_LINE__ ":\t" format, ##arg)

#define  IC0_LOG2(format, arg...) \
	debug.Log(ic0MOD, 2,"2 - " __FILE_LINE__ ":\t" format, ##arg)

#define  IC0_LOG3(format, arg...) \
	debug.Log(ic0MOD, 3,"3 - " __FILE_LINE__ ":\t" format, ##arg)

#define  IC0_LOG4(format, arg...) \
	debug.Log(ic0MOD, 4,"4 - " __FILE_LINE__ ":\t" format, ##arg)


#endif /*!IC0_DEBUG_H*/
