#ifndef IC0_DEFAULTS_H
#define IC0_DEFAULTS_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: ic0Defaults.h,v 2.14 2005/09/22 07:54:27 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* alongino  19/09/01  created
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */

#include "ic0FACTORY.h"      // RegisterStorable
#include "ic0INS_DEVICE.h"
#include "ic0INS_LAMP.h"
#include "ic0INS_SHUTTER.h"
#include "ic0INS_MOTOR.h"
#include "ic0INS_ADC.h"
#include "ic0INS_DROT.h"
#include "ic0INS_GRAT.h"
#include "ic0INS_SLIT2.h"
#include "ic0INS_DEKK2.h"
#include "ic0INS_TILT.h"
#include "ic0INS_SENSOR.h"
#include "ic0INS_PMT.h"
#include "ic0INS_ASSEMBLY.h"
#include "ic0INS_MODEL.h"

// Definition of default classes to be used for certain type of objects.
// This definition can be overloaded by instrument specific definitions, either
// for all devices of a certain type or for individual devices.
// See example in the Template Instrument (xxiControl.C).
// In order to allow overloading of single type of devices, without having
// to copy the rest of this file, #ifndef instructions are provided
//
// The first argument of RegisterStorable is the id of the object type
// Example: RegisterStorable(ICSMOTOR,     ic0INS_MOTOR)
// means that for all devices of type motor, the class to be used is ic0INS_MOTOR
#ifndef NO_DEFAULT_ICSSPECIAL
RegisterStorable(ICSSPECIAL,  ic0INS_DEVICE)
#endif
#ifndef NO_DEFAULT_ICSLAMP
RegisterStorable(ICSLAMP,     ic0INS_LAMP)
#endif
#ifndef NO_DEFAULT_ICSSHUTTER
RegisterStorable(ICSSHUTTER,  ic0INS_SHUTTER)
#endif
#ifndef NO_DEFAULT_ICSMOTOR
RegisterStorable(ICSMOTOR,    ic0INS_MOTOR)
#endif
#ifndef NO_DEFAULT_ICSADC
RegisterStorable(ICSADC,      ic0INS_ADC)
#endif
#ifndef NO_DEFAULT_ICSDROT
RegisterStorable(ICSDROT,     ic0INS_DROT)
#endif
#ifndef NO_DEFAULT_ICSGRAT
RegisterStorable(ICSGRAT,     ic0INS_GRAT)
#endif
#ifndef NO_DEFAULT_ICSSLIT2
RegisterStorable(ICSSLIT2,    ic0INS_SLIT2)
#endif
#ifndef NO_DEFAULT_ICSDEKK2
RegisterStorable(ICSDEKK2,    ic0INS_DEKK2)
#endif
#ifndef NO_DEFAULT_ICSTILT
RegisterStorable(ICSTILT,     ic0INS_TILT)
#endif
#ifndef NO_DEFAULT_ICSSENSOR
RegisterStorable(ICSSENSOR,   ic0INS_SENSOR)
#endif
#ifndef NO_DEFAULT_ICSPMT
RegisterStorable(ICSPMT,      ic0INS_PMT)
#endif
#ifndef NO_DEFAULT_ICSTIM
RegisterStorable(ICSTIM,      ic0INS_DEVICE)
#endif
#ifndef NO_DEFAULT_ICSASSEMBLY
RegisterStorable(ICSASSEMBLY, ic0INS_ASSEMBLY)
#endif
#ifndef NO_DEFAULT_ICSMODE
RegisterStorable(ICSMODE,     ic0INS_MODE)
#endif
#ifndef NO_DEFAULT_ICSPATH
RegisterStorable(ICSPATH,     ic0INS_PATH)
#endif
#ifndef NO_DEFAULT_ICSMODEL
RegisterStorable(ICSMODEL,    ic0INS_MODEL)
#endif

#endif /*!IC0_DEFAULTS_H*/

/* __o0o__ */
