#ifndef IC0_DEFINES_H
#define IC0_DEFINES_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: ic0Defines.h,v 2.14 2005/09/22 07:54:21 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* therlin   30/08/95  Created  
* therlin   17/09/96  Added new commands
* therlin   18/03/97  Added MOVE and MOVEREL
* rschmutz  19/07/99  ic0VERSION added.
* alongino  11/12/99  added efinition for HW_SIM
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */

/*
 * DEFINES
 */
/* Module ID */
#define ic0MOD "ic0"
#define ic0VERSION "@(#) ic0 $Revision: 2.14 $"

/* 
 * State definitions
 */ 

#include "evhStates.h"

/* Local remapping of some standard states (just for convenience) */
#define ic0STATE_OFF                         evhSTATE_OFF
#define ic0STATE_LOADED                      evhSTATE_LOADED
#define ic0STATE_STANDBY                     evhSTATE_STANDBY
#define ic0STATE_ONLINE                      evhSTATE_ONLINE
#define ic0STATE_ERROR                       evhSTATE_ERROR
#define ic0STATE_READY                       evhSTATE_READY

/* Defines for name states */
#define    ic0STATE_OFF_STR                  evhSTATE_STR_OFF 
#define    ic0STATE_LOADED_STR               evhSTATE_STR_LOADED 
#define    ic0STATE_STANDBY_STR              evhSTATE_STR_STANDBY 
#define    ic0STATE_ONLINE_STR               evhSTATE_STR_ONLINE    
#define    ic0STATE_OPERATING_STR            "OPERATING" 
#define    ic0STATE_READY_STR                evhSTATE_STR_READY
#define    ic0STATE_ERROR_STR                evhSTATE_STR_ERROR 
#define    ic0STATE_LOADED_OR_STANDBY_STR    "LOADED or STANDBY"
#define    ic0STATE_STANDBY_OR_ONLINE_STR    "STANDBY or ONLINE"

/* examples of ic0 substates */
/* Note: decoupled from evh states */
#define ic0SUBSTATE_ERROR                    0
#define ic0SUBSTATE_IDLE                     1
#define ic0SUBSTATE_BUSY                     2
#define ic0SUBSTATE_INITIALISING             3
#define ic0SUBSTATE_INITIALISED              4
#define ic0SUBSTATE_STOPPING	             5
#define ic0SUBSTATE_COLD_STARTING	     6
#define ic0SUBSTATE_STARTING	             7
#define ic0SUBSTATE_SETUP_RUNNING	     8
#define ic0SUBSTATE_STATUS_RUNNING           9

#define ic0SUBSTATE_ERROR_STR               "ERROR"
#define ic0SUBSTATE_IDLE_STR                "IDLE"
#define ic0SUBSTATE_BUSY_STR                "BUSY"
#define ic0SUBSTATE_INITIALISING_STR        "INITALISING"
#define ic0SUBSTATE_INITIALISED_STR         "INITALISED"
#define ic0SUBSTATE_STOPPING_STR            "STOPPING"
#define ic0SUBSTATE_COLD_STARTING_STR       "COLD_STARTING"
#define ic0SUBSTATE_STARTING_STR            "STARTING"
#define ic0SUBSTATE_SETUP_RUNNING_STR       "SETUP_RUNNING"
#define ic0SUBSTATE_STATUS_RUNNING_STR      "STATUS_RUNNING"

/* 
 * ic0 Standard Command definitions
 */

#define ic0SETUP_CMD          "SETUP"
#define ic0SIM_CMD            "SIMULAT"
#define ic0SIMULAT_CMD        "SIMULAT"
#define ic0STATUS_CMD         "STATUS"
#define ic0STATE_CMD          "STATE"
#define ic0STOP_CMD           "STOP"
#define ic0STOPSIM_CMD        "STOPSIM"
#define ic0ONLINE_CMD         "ONLINE"
#define ic0OFF_CMD            "OFF"
#define ic0STANDBY_CMD        "STANDBY"
#define ic0DEBUG_CMD          "DEBUG"
#define ic0MOVE_CMD           "MOVE"
#define ic0EXPSTART_CMD       "EXPSTRT"
#define ic0EXPEND_CMD         "EXPEND"
#define ic0VERSION_CMD        "VERSION"
#define ic0EXIT_CMD           "EXIT"

/* Commands below are obsolete. Definitions are kept for backwards compatibility only */
#define ic0COMMENT_CMD        "COMMENT"
#define ic0DISABLE_CMD        "DISABLE"
#define ic0ENABLE_CMD         "ENABLE"
#define ic0LOCK_CMD           "LOCK"
#define ic0UNLOCK_CMD         "UNLOCK"
#define ic0INIT_CMD           "INIT"
#define ic0PDOWN_CMD          "PDOWN"
#define ic0SELFTST_CMD        "SELFTST"
#define ic0SETMODE_CMD        "SETMODE"
#define ic0TEST_CMD           "TEST"
#define ic0OPERATE_CMD        "OPERATE"
#define ic0GETVAL_CMD         "GETVAL"
#define ic0SETVAL_CMD         "SETVAL"
#define ic0CFGELEM_CMD        "CFGELEM"
#define ic0MOVE_CMD           "MOVE"
#define ic0MOVEREL_CMD        "MOVEREL"

/*
 * Command parameter names
 */
#define ic0FUNCTION_PARAM             "function"
#define ic0SETUP_FUNCTION_PARAM_INDX  2 
#define ic0FUNCTION_PARAM_INDX        0
#define ic0STATUS_FUNCTION_PARAM_INDX 1
#define ic0PATH_PARAM                 "path"
#define ic0PATH_PARAM_INDX            0
#define ic0EXPOID_PARAM               "expoId"
#define ic0EXPOID_PARAM_INDX          0
#define ic0DETID_PARAM                "detId"
#define ic0DETID_PARAM_INDX           0
#define ic0FILE_PARAM                 "file"
#define ic0FILE_PARAM_INDX            1
/*
 * status related paramters
 */
#define ic0GLOBAL_PARAM               "global"
#define ic0GLOBAL_PARAM_INDX          2  
#define ic0HEADER_PARAM               "header"
#define ic0HEADER_PARAM_INDX          3   
#define ic0CONFLOG_PARAM               "conflog"
#define ic0CONFLOG_PARAM_INDX         4    
#define ic0OPSLOG_PARAM               "opslog"
#define ic0OPSLOG_PARAM_INDX          5  
#define ic0CONDLOG_PARAM              "condlog"
#define ic0CONDLOG_PARAM_INDX         6  
#define ic0DUMPFITS_PARAM             "dumpFITS"
#define ic0DUMPFITS_PARAM_INDX        7  
#define ic0SAVEASSETUP_PARAM           "saveAsSetup"
#define ic0SAVEASSETUP_PARAM_INDX     8 
/*
 *
 */
#define ic0NOMOVE_PARAM               "noMove"
#define ic0NOMOVE_PARAM_INDX          3
#define ic0CHECK_PARAM                "check"
#define ic0CHECK_PARAM_INDX           4
#define ic0QUEUE_PARAM                "queue"
#define ic0QUEUE_PARAM_INDX           5
#define ic0STRING_PARAM               "string"
#define ic0STRING_PARAM_INDX          1
#define ic0CLEAR_PARAM                "clear"
#define ic0CLEAR_PARAM_INDX           2
#define ic0ALL                        "all"
#define ic0LEVEL_PARAM                "level"
#define ic0LEVEL_PARAM_INDX           0
#define ic0LOG_PARAM                  "log"
#define ic0LOG_PARAM_INDX             1
#define ic0VERBOSE_PARAM              "verbose"
#define ic0VERBOSE_PARAM_INDX         2  
#define ic0TIMEOUT_PARAM              "timeout"
#define ic0TIMEOUT_PARAM_INDX         3  
#define ic0OPMODE_PARAM               "opMode"
#define ic0OPMODE_PARAM_INDX          0  
#define ic0MAINTENANCE_PARAM          "maintenanceMode"
#define ic0MAINTENANCE_PARAM_INDX     1  
#define ic0POSITION_PARAM             "position"
#define ic0POSITION_PARAM_INDX        1  
#define ic0CFG_ID_PARAM               "id"
#define ic0CFG_ID_PARAM_INDX          2  
#define ic0CFG_VALUES_PARAM           "values"
#define ic0CFG_VALUES_PARAM_INDX      3 
#define ic0SETVAL_NAME_PARAM          "name"
#define ic0SETVAL_NAME_PARAM_INDX     1 
#define ic0SETVAL_VALUE_PARAM         "value"
#define ic0SETVAL_VALUE_PARAM_INDX    2 

/* string definitions */
#define ic0ON                 "ON"
#define ic0OFF                "OFF"


/* SETMODE definitions */
#define ic0MAINT_BIT           1
#define ic0NORMAL_BIT          0
#define ic0NORMAL              0
#define ic0NORMAL_STR          "NORMAL"
#define ic0NONE_STR            "NONE"
#define ic0LCUSIM              1
#define ic0LCUSIM_STR          "LCU_SIM"
#define ic0HWSIM               2
#define ic0HWSIM_STR           "HW_SIM"


/* Filters */
#define ic0INS_FILTER "{INS} {*} {*}"

/* Timeouts */
#define ic0TIMEOUT            45000

/* misc sizes */
#define ic0ENV_SIZE           256
#define ic0FILE_SIZE          ic0ENV_SIZE
#define ic0CMD_SIZE           1024
#define ic0SINGLE_OFFSET      250
#define ic0MULTI_OFFSET       500

/* STATUS file types */
#define ic0STATUS_FITS        1
#define ic0STATUS_SETUP       2

/* 
 * VLTSW20040335
 */
#define ic0SETUP_OK           "SETUPOK"
#define ic0SETUP_ERR          "SETUPER"

#endif /*!IC0_DEFINES_H*/

/* __o0o__ */
