#ifndef ic0FACTORY_H
#define ic0FACTORY_H
/*******************************************************************************
* E.S.O. - VLT project
#
# "@(#) $Id: ic0FACTORY.h,v 2.14 2005/09/22 07:54:25 vltsccm Exp $" 
*
* ic0FACTORY.h
*
* who       when      what
* --------  --------  ----------------------------------------------
* alongino  17/01/00  created
*/

/************************************************************************
*
*----------------------------------------------------------------------
*/

#include <fndDICTIONARY.h>
#include <fndASSOCIATION.h>
#include <fndSTRING.h>
#include <fndPOINTER.h>
#include "ECCS.h"

class ic0FACTORY_REG;
class ic0FACTORY_DICT : public fndDICTIONARY
{
  public:
    ic0FACTORY_DICT( unsigned sz = fndDEFAULT_DICT_SIZE ) : fndDICTIONARY(sz) { }
    ic0FACTORY_REG &Lookup( const char *toLookup,  
                              vltLOGICAL exact=FALSE) const;
    fndStdObjectDef(ic0FACTORY_DICT,fndDICTIONARY)

}; /* end class ic0FACTORY_DICT */


class ic0FACTORY_REG : public fndASSOCIATION
{
  public:
    ic0FACTORY_REG(const char *cname=NULL, 
                     classType ctype=NULL, 
                     vltLOGICAL reg=TRUE);
    static ic0FACTORY_DICT *creators;
    fndStdObjectDef(ic0FACTORY_REG,fndASSOCIATION)

  private:
    fndSTRING name;
    fndPOINTER value;

}; /* end class ic0FACTORY_REG */

creator GetCreateNew(const char *cname);

#define  RegisterStorable(mask, cname)            \
  static ic0FACTORY_REG __##mask##_Reg("INS."#mask, (classType)cname::CreateNew);

#endif /*!ic0FACTORY_H*/











