#ifndef ic0HANDLER_H
#define ic0HANDLER_H
/*******************************************************************************
* E.S.O. - VLT project
#
# "@(#) $Id: ic0HANDLER.h,v 2.14 2005/09/22 07:54:21 vltsccm Exp $" 
*
* ic0HANDLER.h
*
* who       when      what
* --------  --------  ----------------------------------------------
* therlin   10/01/96  Created
*/

/************************************************************************
*
*----------------------------------------------------------------------
*/

#include "ic0Errors.h"

#include "ic0TRIGGER_DICT.h"

/* The callback dictionary has some special methods */
#define  ic0HANDLER_CLASS  (classType)ic0HANDLER::CreateNew

class ic0INS_MODEL; // to avoid compilation errors with mutual dependencies

class ic0HANDLER: public fndOBJECT, public eccsERROR_CLASS
{
  public:

    ic0HANDLER();

    virtual ccsCOMPL_STAT AddTrigger(const ic0KEYW_KEY &key,
                                      const ic0TRIGGER &cb);  
    virtual ccsCOMPL_STAT ClearTrigger(const ic0KEYW_KEY &key);

    virtual ccsCOMPL_STAT Dispatch(ic0KEYWORD_LIST *keywordList);

    virtual ccsCOMPL_STAT Lookup(ic0KEYWORD &keyword);

    virtual ccsCOMPL_STAT KeepKeysWithoutTrigger(ic0INS_MODEL *mod);

    fndStdObjectDef(ic0HANDLER, fndOBJECT);

  protected:

  private:
    
    vltLOGICAL       trace;
    ic0TRIGGER_DICT  dict;
    ic0DEBUG         debug;         // debug object
    ic0INS_MODEL     *model;        // pointer to instrument model
    vltLOGICAL       forwAllKeys;   // forward also keys without trigger
    ic0KEYWORD_LIST  dispatchKeys;  // list of keywords dispatched

}; /* end class ic0HANDLER */

#endif /*!ic0HANDLER_H*/













