#ifndef ic0INS_ASSEMBLY_H
#define ic0INS_ASSEMBLY_H
/*******************************************************************************
* E.S.O. - VLT project
#
# "@(#) $Id: ic0INS_ASSEMBLY.h,v 2.14 2005/09/22 07:54:25 vltsccm Exp $" 
*
* ic0INS_ASSEMBLY.h
*
* who       when      what
* --------  --------  ----------------------------------------------
* alongino  22/11/04  VLTSW20040376
* alongino  02/02/01  VLTSW20000565 VLTSW20000564 VLTSW20000506 VLTSW20000503
* alongino  19/01/00  created
*/

/************************************************************************
*
*----------------------------------------------------------------------
*/

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

/* 
 * System Headers
 */

/* 
 * VLT Headers
 */
#include <fndDICTIONARY.h>
#include "eccsDB_ATTR.h"         // eccsDB_STRING

/* 
 * UVES Headers
 */
#include "ic0INS_DEVICE.h"       // parent class

class ic0INS_ASSEMBLY: public ic0INS_DEVICE
{
  public:
    ic0INS_ASSEMBLY();
    virtual ccsCOMPL_STAT Init(ic0INS_DEVICE_CONF &device);    

    fndStdObjectDef(ic0INS_ASSEMBLY, ic0INS_DEVICE)

  protected:
    fndDICTIONARY keyDic;
    slxKEYW_LINE nextStepBuf;

    virtual ccsCOMPL_STAT DevTrigger(ic0KEYWORD &keyword, void*);
    virtual ccsCOMPL_STAT AddNextStepKeyword(ic0KEYWORD &keyword, vltLOGICAL alloc);
    virtual ccsCOMPL_STAT AddWsKeyword(ic0KEYWORD &keyword, vltLOGICAL alloc);
    vltLOGICAL FirstCmd();          // check if first command in a multi-step SETUP
    virtual char* Value(vltINT32 index = 0);
    virtual char* Key(vltINT32 index = 0);
    virtual ccsCOMPL_STAT Value(const char *val, vltINT32 index = 0);
    virtual ccsCOMPL_STAT Key(const char *val, vltINT32 index = 0);
   
  private:
    vltINT32 assIndex; // index used in INS.ASSEMBLYi

};



class ic0INS_MODE: public ic0INS_ASSEMBLY
{
  public:
    ic0INS_MODE();
    fndStdObjectDef(ic0INS_MODE, ic0INS_ASSEMBLY)

  protected:
    virtual ccsCOMPL_STAT DevTrigger(ic0KEYWORD &keyword, void*);
   
  private:

};



class ic0INS_PATH: public ic0INS_ASSEMBLY
{
  public:
    ic0INS_PATH();
    fndStdObjectDef(ic0INS_PATH, ic0INS_ASSEMBLY)

  protected:
    virtual ccsCOMPL_STAT DevTrigger(ic0KEYWORD &keyword, void*);
   
  private:

};



#endif /*!ic0INS_ASSEMBLY_H*/











