#ifndef ic0INS_PMT_H
#define ic0INS_PMT_H
/*******************************************************************************
* E.S.O. - VLT project
#
# "@(#) $Id: ic0INS_PMT.h,v 2.14 2005/09/22 07:54:27 vltsccm Exp $" 
*
* ic0INS_PMT.h
*
* who       when      what
* --------  --------  ----------------------------------------------
* alongino  18/09/01  created
*/

/************************************************************************
*
*----------------------------------------------------------------------
*/

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

#include "ic0INS_DEVICE.h"    // parent class
#include "ic0HISTORIAN.h"     // ic0HISTORIAN

// Photomultiplier device
class ic0INS_PMT: public ic0INS_DEVICE
{
  public:

    ic0INS_PMT();
    ~ic0INS_PMT();
    fndStdObjectDef(ic0INS_PMT, ic0INS_DEVICE)
    virtual ccsCOMPL_STAT Init(ic0INS_DEVICE_CONF &device);

  protected:

    virtual ccsCOMPL_STAT DevTrigger(ic0KEYWORD &keyword, void*);
    virtual ccsCOMPL_STAT AddStatisticsKeys(ic0KEYWORD &keyword);
    virtual ccsCOMPL_STAT Statistics(vltINT32 size, vltDOUBLE *buffer);

  private:
    ic0HISTORIAN historian;
    vltLOGICAL statisticsDone;

    virtual ccsCOMPL_STAT StartStatistics();
    virtual ccsCOMPL_STAT StopStatistics();
}; /* end class ic0INS_PMT */

#endif /*!ic0INS_PMT_H*/











