#ifndef ic0INS_SENSOR_H
#define ic0INS_SENSOR_H
/*******************************************************************************
* E.S.O. - VLT project
#
# "@(#) $Id: ic0INS_SENSOR.h,v 2.14 2005/09/22 07:54:26 vltsccm Exp $" 
*
* ic0INS_SENSOR.h
*
* who       when      what
* --------  --------  ----------------------------------------------
* alongino  11/12/99  created
*/

/************************************************************************
*
*----------------------------------------------------------------------
*/

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

#include "ic0INS_DEVICE.h"    // parent class
#include "ic0HISTORIAN.h"

typedef struct 
    {
    char         name[16];
    char         fits[32];
    ic0HISTORIAN historian;
    vltLOGICAL   doStatistics;           
    vltLOGICAL   statisticsDone;           
    vltLOGICAL   min;
    vltLOGICAL   max;
    vltLOGICAL   mean;
    vltLOGICAL   rms;
    vltLOGICAL   tmean;
    vltLOGICAL   grad;
    vltLOGICAL   lrconst;
    vltLOGICAL   lrrms;
    vltLOGICAL   detcoef;
    } ic0INS_SENSOR_INFO;

// Sensor device
class ic0INS_SENSOR: public ic0INS_DEVICE
{
  public:

    ic0INS_SENSOR();
    ~ic0INS_SENSOR();
    fndStdObjectDef(ic0INS_SENSOR, ic0INS_DEVICE)
    virtual ccsCOMPL_STAT Init(ic0INS_DEVICE_CONF &device);
    vltINT32 Num() { return nSensor; }
    vltINT32 Index( ic0KEYWORD &keyword );

  protected:

    virtual ccsCOMPL_STAT DevTrigger(ic0KEYWORD &keyword, void*);
    virtual ccsCOMPL_STAT Statistics(vltINT32 index, vltINT32 size, vltDOUBLE *buffer);
    virtual ccsCOMPL_STAT AddStatisticsKeys(ic0KEYWORD &keyword);
    virtual vltLOGICAL DoStat(vltINT32 index)   { return info[index].doStatistics; }
    virtual vltLOGICAL DoMin(vltINT32 index)    { return info[index].min; }
    virtual vltLOGICAL DoMax(vltINT32 index)    { return info[index].max; }
    virtual vltLOGICAL DoMean(vltINT32 index)   { return info[index].mean; }
    virtual vltLOGICAL DoRms(vltINT32 index)    { return info[index].rms; }
    virtual vltLOGICAL DoTMean(vltINT32 index)  { return info[index].tmean; }
    virtual vltLOGICAL DoGrd(vltINT32 index)    { return info[index].grad; }
    virtual vltLOGICAL DoDetCoef(vltINT32 index) { return info[index].detcoef; }

  private:
    vltINT32 nSensor;
    ic0INS_SENSOR_INFO *info;

    virtual ccsCOMPL_STAT StartStatistics();
    virtual ccsCOMPL_STAT StopStatistics();

}; /* end class ic0INS_SENSOR */

#endif /*!ic0INS_SENSOR_H*/











