#ifndef IC0_KEYWORD_H
#define IC0_KEYWORD_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: ic0KEYWORD.h,v 2.14 2005/09/22 07:54:21 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* therlin   30/08/95  Created  
* therlin   13/01/97  Added oslxDICTIONARY include
* alongino  25/08/97  added const to method LcuNo()
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */


#include <fndOBJECT.h>
#include "eccsErr.h"

#include "oslxKEYWORD.h"
#include "ic0.h"
#include "ic0DEBUG.h"

/*
 * Class definition
 */
class ic0KEYWORD : public oslxKEYWORD, public fndOBJECT
{
  public:   
    ic0KEYWORD();

    ic0KEYWORD(const char *key_value, 
	       const char *cmd = NULL, 
	       vltINT32 lcuNo = 0,
               vltLOGICAL dictionaryCheck = FALSE);

    ic0KEYWORD(const ic0KEYWORD &source);
   ~ic0KEYWORD();
    ccsCOMPL_STAT SetKeyword(const char *key_value, 
			     const char *cmd = NULL,
			     vltINT32   lcuNo = -1,
                             vltLOGICAL dictionaryCheck = FALSE);
    ccsCOMPL_STAT InsKeyword(const char *keyw);
    char         *InsKeyword() const;
    ccsCOMPL_STAT Command(const char *cmd);
    char         *Command() const {  return  (char *)command; };
    ccsCOMPL_STAT LcuNo(vltINT32 no);
    vltINT32      LcuNo() const { return lcuNo; };

    ic0KEYWORD &operator =(const ic0KEYWORD &source);
  protected:    
    msgCMD   command;
    vltINT32 lcuNo;
  private:
    vltBYTES32 insKeyword;
    ic0DEBUG   debug;
    vltLOGICAL splitOK;

    // oslxKEYWORD functions
    char           *Keyword() const;
    ccsCOMPL_STAT  Keyword(const slxKEYW_LINE keywLine);
};
inline char *ic0KEYWORD::InsKeyword() const
{    
    return  (char *)insKeyword;
}


inline ccsCOMPL_STAT ic0KEYWORD::LcuNo(vltINT32 no)
{
    lcuNo = no;
    return  SUCCESS;
}
#endif /*!IC0_KEYWORD_H*/
