#ifndef IC0_KEYWORD_LIST_H
#define IC0_KEYWORD_LIST_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: ic0KEYWORD_LIST.h,v 2.14 2005/09/22 07:54:21 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* therlin   30/08/95  Created  
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */


#include <fndARRAY.h>
#include "eccsErr.h"

#include "ic0.h"
#include "ic0KEYWORD.h"
#include "ic0DEBUG.h"

/*
 * Class definition
 */

class ic0KEYWORD_LIST : public fndARRAY, public eccsERROR_CLASS
{
  public: 
    ic0KEYWORD_LIST(vltINT32 no, const char **keyArray, const char *cmd = NULL);
    ic0KEYWORD_LIST();
   ~ic0KEYWORD_LIST();

    ccsCOMPL_STAT    SetList(vltINT32 no,
			     const char **keyArray,
			     const char *cmd = NULL);
    ic0KEYWORD       &KeyElement(vltINT32 no);
    ccsCOMPL_STAT    SetElement(vltINT32 no, 
				const char *key_value,
				const char *cmd = NULL);

    vltINT32         GetKeywordIndex(char *id);

    ccsCOMPL_STAT    AddElement(const char *key_value,
				const char *cmd = NULL);

    ccsCOMPL_STAT    AddList(ic0KEYWORD_LIST *list);

    ccsCOMPL_STAT    AddTop(ic0KEYWORD *keyword);
    ccsCOMPL_STAT    AddAfter(char *id, ic0KEYWORD *keyword);
    ccsCOMPL_STAT    AddBefore(char *id, ic0KEYWORD *keyword);
    
    ccsCOMPL_STAT    DeleteElement(const char *keyw);
    ccsCOMPL_STAT    DeleteElement(vltINT32 index);
    
    vltINT32         NoKeys();
    vltINT32         NoKeys(vltINT32 lcuNo);
    char             **KeyParamArray(vltINT32 lcuNo = -1);
    void             KeyParamArrayFree();
    const char       *KeywordList(vltLOGICAL showNo = ccsTRUE);

    fndStdObjectDef(ic0KEYWORD_LIST, fndARRAY)
  protected:    
    ccsCOMPL_STAT    AddIndex(vltINT32 index, ic0KEYWORD *keyword);
    void             ParamArrayFree();
    vltINT32         noKeys;
  private:
    char             keywList[msgBODYMAXLEN];
    ic0DEBUG         debug;
    char             **paramArray;
    vltINT32         paramNo;
};

#endif /*!IC0_KEYWORD_LIST_H*/
