#ifndef ic0KEYW_KEY_H
#define ic0KEYW_KEY_H
/*******************************************************************************
* E.S.O. - VLT project
#
# "@(#) $Id: ic0KEYW_KEY.h,v 2.14 2005/09/22 07:54:22 vltsccm Exp $" 
*
* ic0KEYW_KEY.h
*
* who       when      what
* --------  --------  ----------------------------------------------
* 
*/

/************************************************************************
*
*----------------------------------------------------------------------
*/


#include "fndOBJECT.h"
#include "ic0.h"
#include "ic0KEYWORD.h"

/* A first key is based on TYPE, COMMAND and COMMANDID */
#define  ic0KEYW_KEY_CLASS  (classType)ic0KEYW_KEY::CreateNew

class ic0KEYW_KEY: public fndOBJECT, public eccsERROR_CLASS
{
  public:
//    ic0KEYW_KEY();
    ic0KEYW_KEY(const ic0KEYW_KEY &keyword);
    ic0KEYW_KEY(const char   *keyword = NULL,
		 const msgCMD cmd     = NULL);

    const char      *Keyword() const;
    ic0KEYW_KEY &Keyword(const char *keyw);
    const char      *Command() const;
    ic0KEYW_KEY &Command(const msgCMD cmd);

    virtual   int           IsEqual( const fndOBJECT& ) const;
    virtual   hashValueType HashValue() const;
    virtual   void          PrintOn( ostream& ) const;

    ic0KEYW_KEY  &operator         =( const ic0KEYW_KEY& );

    fndStdObjectDef(ic0KEYW_KEY, fndOBJECT)

  private:
    char        keyword[32];
    msgCMD      command;
    

}; /* end class ic0KEYW_KEY */


/******************/
/* Inline methods */
/******************/

inline ic0KEYW_KEY::ic0KEYW_KEY(const ic0KEYW_KEY &source) 
{
    *this=source;
}

inline const char *ic0KEYW_KEY::Keyword() const
{
    return (keyword);
}

inline const char *ic0KEYW_KEY::Command() const
{
    return (command);
}
#endif /*!ic0KEYW_KEY_H*/

// __o0o__

