#ifndef ic0MAIN_HANDLER_H
#define ic0MAIN_HANDLER_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: ic0MAIN_HANDLER.h,v 2.14 2005/09/22 07:54:24 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* alongino  09/12/03  removed one Exit method
* alongino  11/12/99  created
*/

/************************************************************************
 * This file contains definitions used by class ic0MAIN_HANDLER
 *----------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

/* 
 * VLT Headers
 */
#include "ctooCONFIG.h"  // ctooCONFIG

/* 
 * ic0 Headers
 */
#include "ic0DEBUG.h"    // ic0DEBUG

class ic0MAIN_HANDLER : public eccsERROR_CLASS
{
  public:
      ic0MAIN_HANDLER(char *cfg);                             // constructor
      virtual ~ic0MAIN_HANDLER();                             // destructor
      ccsCOMPL_STAT Init(int argc, char *argv[], const char *version=NULL); //Init method
      virtual void Exit(vltINT32 status, 
                        vltLOGICAL dereg = ccsTRUE); // Exit method

  protected:
      ic0DEBUG debug;                     // debug information
      ctooCONFIG cfg;                     // inctrument configuration
      ccsPROCNAME  procName;              // name of this process
      char         dictionary[256];       // dictionary name
      char         alias[256];            // alias table name
      char         insId[20];             // INS Id
      char         icsId[20];             // ICS Id
      char         icsPrefix[20];         // ICS prefix
      char         cfgCat[20];            // configuration category
      dbSYMADDRESS icsDbRoot;             // ICS OLDB root point

      virtual void Defaults();            // defaults setting method

  private:
      virtual void Usage() = 0;           // on-line help method
      virtual ccsCOMPL_STAT CreateServer(const char *version) = 0; // create server instance
      virtual ccsCOMPL_STAT DeleteServer() = 0; // delete server instance
      virtual ccsCOMPL_STAT Parse(int argc, char *argv[]) = 0; // parse runstring
      virtual char *ProcName(char *prefix) = 0;   // return server process name
};


#endif /*!ic0MAIN_HANDLER_H*/
