#ifndef ic0SimMAIN_HANDLER_H
#define ic0SimMAIN_HANDLER_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: ic0SimMAIN_HANDLER.h,v 2.14 2005/09/22 07:54:26 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* alongino  10/09/01  created
*/

/************************************************************************
 * This file contains definitions used by class ic0SimMAIN_HANDLER
 *----------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

/* 
 * VLT Headers
 */
#include "ic0MAIN_HANDLER.h"    // parent class
#include "ic0simSERVER.h"       // ic0simSERVER

class ic0SimMAIN_HANDLER : public ic0MAIN_HANDLER
{
  public:
      ic0SimMAIN_HANDLER(char *cfg);     // constructor

  protected:
      dbSYMADDRESS dbRoot;                // OLDB root point for ICS WS proc.

      virtual void Usage();                 // on-line help method
      virtual ccsCOMPL_STAT CreateServer(const char *version); // create server and model
      virtual ccsCOMPL_STAT Parse(int argc, char *argv[]); // parse runstring
      virtual ic0simSERVER *NewServer(); // create server
      virtual ccsCOMPL_STAT DeleteServer(); // delete server instance

  private:
      ic0simSERVER *ic0Server;            // pointer to server used

      void Defaults();                    // defaults setting method
      char *ProcName(char *prefix);       // return server process name
};


#endif /*!ic0SimMAIN_HANDLER_H*/
