#ifndef ic0TRIGGER_H
#define ic0TRIGGER_H
/*******************************************************************************
* E.S.O. - VLT project
#
# "@(#) $Id: ic0TRIGGER.h,v 2.14 2005/09/22 07:54:22 vltsccm Exp $" 
*
* ic0TRIGGER.h
*
* who       when      what
* --------  --------  ----------------------------------------------
* therlin   10/01/96  Created 
* alongino  07/06/99  Run adapted to new gcc (error with previous one)
*/

/************************************************************************
*
*----------------------------------------------------------------------
*/

#include <fndOBJECT.h>

#include "eccsMsg.h"
#include "ic0Errors.h"
#include "ic0KEYWORD.h"


/* Typedef for the callback proc type */
typedef ccsCOMPL_STAT (fndOBJECT::*ic0TRIGGER_PROC)(const ic0KEYWORD &keyw, void* );

class ic0TRIGGER: public fndOBJECT, public eccsERROR_CLASS
{
  public:
    ic0TRIGGER();
    ic0TRIGGER(const ic0TRIGGER_PROC procedure,void *udata = NULL);
    ic0TRIGGER(const ic0TRIGGER &source);

    ic0TRIGGER &Proc(const ic0TRIGGER_PROC procedure) ;
    ic0TRIGGER &UserData(void *udata);

    virtual   int           IsEqual( const fndOBJECT& ) const;

    ic0TRIGGER &operator =(const ic0TRIGGER &source);

    virtual ccsCOMPL_STAT Run(const ic0KEYWORD &keyw);
    virtual ic0TRIGGER *Clone() const;

    fndStdObjectDef(ic0TRIGGER, fndOBJECT)

  protected:
    void      *UserData() const { return userData; }
  private:
    ic0TRIGGER_PROC proc;
    void            *userData;

}; /* end class ic0TRIGGER */


/******************/
/* Inline methods */
/******************/

inline ic0TRIGGER::ic0TRIGGER() 
{
    proc     = (ic0TRIGGER_PROC) NULL;
    userData = (void *)NULL;
}


inline ic0TRIGGER::ic0TRIGGER(const ic0TRIGGER_PROC procedure,void *udata) 
{
    ErrReset();
    errClassNullPtr(procedure);
    proc = procedure;
    userData = udata;
}

inline ic0TRIGGER &ic0TRIGGER::Proc(const ic0TRIGGER_PROC procedure) 
{
    ErrReset();
    errClassNullPtr(procedure);
    proc=procedure;
    return *this;
}

inline ic0TRIGGER &ic0TRIGGER::UserData(void *udata) 
{
    userData=udata;
    return *this;
}

inline ic0TRIGGER &ic0TRIGGER::operator =(const ic0TRIGGER &source)
{
    proc=source.proc;
    userData=source.userData;
    return *this;
}

inline ic0TRIGGER::ic0TRIGGER(const ic0TRIGGER &source) 
{
    *this = source;
}

inline ccsCOMPL_STAT ic0TRIGGER::Run(const ic0KEYWORD &keyw)
{
  cout << "ic0TRIGGER::Run" << endl;
    ErrReset();
    if(proc == (ic0TRIGGER_PROC)NULL) 
	{
	ErrStack().ErrAdd(ic0MOD,ic0ERR_TRIGGER,__FILE_LINE__,
		       "No trigger procedure specified","");
	ErrStatus(FAILURE);
	return FAILURE;
	}
    else
        {
        //ALO990607 Next line returns an error with OCT99 gcc
        //return proc(keyw, userData);
        return (this->*proc)(keyw, userData);
	}

}

#endif /*!ic0TRIGGER_H*/











