#ifndef ic0TRIGGER_DICT_H
#define ic0TRIGGER_DICT_H
/*******************************************************************************
* E.S.O. - VLT project
#
# "@(#) $Id: ic0TRIGGER_DICT.h,v 2.14 2005/09/22 07:54:22 vltsccm Exp $" 
*
* ic0TRIGGER_DICT.h
*
* who       when      what
* --------  --------  ----------------------------------------------
* alongino  28/05/03  Added method CbFound(vltINT32 counts)
*/

/************************************************************************
*
*----------------------------------------------------------------------
*/

#include <fndDICTIONARY.h>
#include <fndASSOCIATION.h>

#include "ic0KEYW_KEY.h"
#include "ic0KEYWORD_LIST.h"
#include "ic0TRIGGER_LIST.h"

/* The callback dictionary has some special methods */
#define  ic0TRIGGER_DICT_CLASS  (classType)ic0TRIGGER_DICT::CreateNew

class ic0TRIGGER_DICT: public fndDICTIONARY, public eccsERROR_CLASS
{
  public:

    ic0TRIGGER_DICT(const unsigned sz = fndDEFAULT_DICT_SIZE ):
                     fndDICTIONARY(sz) { }

    virtual ccsCOMPL_STAT AddTrigger(const ic0KEYW_KEY &key,
				      const ic0TRIGGER   &cb);
    virtual ccsCOMPL_STAT ClearTrigger(const ic0KEYW_KEY &key);
    virtual ccsCOMPL_STAT Run(const ic0KEYW_KEY &key, 
			      const ic0KEYWORD &keyword);

    virtual vltINT32       CbFound();
    virtual ccsCOMPL_STAT  CbFound(vltINT32 counts);

    fndStdObjectDef(ic0TRIGGER_DICT, fndDICTIONARY)

	private:
    vltINT32      cbFound;
    

}; /* end class ic0TRIGGER_DICT */


inline vltINT32 ic0TRIGGER_DICT::CbFound()
{
    return cbFound;
}

inline ccsCOMPL_STAT ic0TRIGGER_DICT::CbFound(vltINT32 counts)
{
    cbFound = counts;
    return SUCCESS;
}

#endif /*!ic0TRIGGER_DICT_H*/




