#ifndef ic0TRIGGER_OBJ_H
#define ic0TRIGGER_OBJ_H
/*******************************************************************************
* E.S.O. - VLT project
#
# "@(#) $Id: ic0TRIGGER_OBJ.h,v 2.14 2005/09/22 07:54:23 vltsccm Exp $" 
*
* ic0TRIGGER_OBJ.h
*
* who       when      what
* --------  --------  ----------------------------------------------
* alongino  11/08/99  OCT99: ic0TRIGGER_PROC procedure = 0 instead of NULL
* alo/rsc   19/07/99  OCT99: '(<type>)NULL' replaced with just 'NULL'.
* therlin   10/01/96  Taken from evhOBJ_CALLBACK
*/

/************************************************************************
*
*----------------------------------------------------------------------
*/

#include "ic0TRIGGER.h"

/* Typedef for the callback proc type */
/*
typedef ccsCOMPL_STAT 
              (fndOBJECT::*evhCB_METHOD)(const msgRAW_MESSAGE &,void*);
	      */
/* A callback is described as a pointer to function + the data to be passed */
/*
#define  evhCALLBACK_CLASS  (classType)evhCALLBACK::CreateNew
*/
class ic0TRIGGER_OBJ: public ic0TRIGGER
{
  public:
    ic0TRIGGER_OBJ();
    ic0TRIGGER_OBJ(fndOBJECT *obj,
		   const ic0TRIGGER_PROC procedure = 0,
		   void *udata = NULL);
    ic0TRIGGER_OBJ(const ic0TRIGGER_OBJ &source);

    ic0TRIGGER_OBJ &Object(fndOBJECT *obj);
    ic0TRIGGER_OBJ &Proc(const  ic0TRIGGER_PROC procedure) ;

    virtual   int  IsEqual( const fndOBJECT& ) const;

    ic0TRIGGER_OBJ &operator =(const ic0TRIGGER_OBJ &source);

    virtual ccsCOMPL_STAT Run(const ic0KEYWORD &keyw);
    virtual ic0TRIGGER *Clone() const;

    fndStdObjectDef(ic0TRIGGER_OBJ, ic0TRIGGER)

  private:
    fndOBJECT         *object;
    ic0TRIGGER_PROC   method;

}; /* end class ic0TRIGGER_OBJ */


/******************/
/* Inline methods */
/******************/

inline ic0TRIGGER_OBJ &ic0TRIGGER_OBJ::operator =(
    const ic0TRIGGER_OBJ &source)
{
    object=source.object;
    method=source.method;
    UserData(source.UserData());
    return *this;
}

inline ic0TRIGGER_OBJ::ic0TRIGGER_OBJ() 
{
    object   = NULL;
    method   = (ic0TRIGGER_PROC)NULL;
}

inline ic0TRIGGER_OBJ::ic0TRIGGER_OBJ(const ic0TRIGGER_OBJ &source) 
{
    *this = source;
}

inline ic0TRIGGER_OBJ::ic0TRIGGER_OBJ(fndOBJECT             *obj,
				      const ic0TRIGGER_PROC procedure,
				      void                  *udata) 
{
    ErrReset();

    object   = obj;
    method   = procedure;
    UserData(udata);
}

inline ic0TRIGGER_OBJ &ic0TRIGGER_OBJ::Object(fndOBJECT *obj) 
{
    ErrReset();
    errClassNullPtr(obj);

    object=obj;
    return *this;
}

inline ic0TRIGGER_OBJ &ic0TRIGGER_OBJ::Proc(const ic0TRIGGER_PROC procedure) 
{
    ErrReset();
    errClassNullPtr(procedure);

    method=procedure;
    return *this;
}

inline  ccsCOMPL_STAT ic0TRIGGER_OBJ::Run(const ic0KEYWORD &keyw)
{

    ErrReset();
    if(method == (ic0TRIGGER_PROC)NULL) 
	{
	ErrStack().ErrAdd(ic0MOD,ic0ERR_TRIGGER,__FILE_LINE__,
		       "No trigger procedure specified","");
	ErrStatus(FAILURE);
	return FAILURE;
	}
    else if(object == NULL)
	{
	ErrStack().ErrAdd(ic0MOD,ic0ERR_TRIGGER,__FILE_LINE__,
		       "Null object specified","");
	ErrStatus(FAILURE);
	return FAILURE;
	}
    
    if  ((object->*method)(keyw, UserData()) != SUCCESS)
	{
	// ErrStack().Add(ic0MOD,ic0ERR_RUN_TRIGGER,__FILE_LINE__,keyw.Keyword());
	// Information is removed if another error is added here
	ErrStatus(FAILURE);
	return FAILURE;
	}

    return SUCCESS;
}


#endif /*!ic0TRIGGER_OBJ_H*/











