#ifndef IC0CHK_INTERFACE_H
#define IC0CHK_INTERFACE_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: ic0chkINTERFACE.h,v 2.14 2005/09/22 07:54:23 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* therlin   30/08/95  Created  
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */

#include "ic0genINTERFACE.h"

#include "oslxDICTIONARY.h"
#include "oslxKEYW_FILTER.h"
#include "oslxALIAS.h"
#include "oslxFITS.h"
#include "oslxSETUP.h"



class ic0chkINTERFACE;

typedef  ic0chkINTERFACE* (*ic0chkType)();
#define   ic0chkINTERFACE_CLASS     (ic0chkType)ic0chkINTERFACE::CreateNew

/*
 * Class definition
 */
class ic0chkINTERFACE : public ic0genINTERFACE
{
  public: 
    ic0chkINTERFACE();
   ~ic0chkINTERFACE();

    static ic0chkINTERFACE* CreateNew();
    virtual ccsCOMPL_STAT   ClearBuffer();

    virtual ccsCOMPL_STAT   CheckFile(char *setupFile);
    virtual ccsCOMPL_STAT   ListFile(char *setupFile);
    virtual ccsCOMPL_STAT   CheckKeyword(char *keyWord, char *value);
    virtual ccsCOMPL_STAT   LookupKeyword(char *keyWord);
    virtual ic0KEYWORD      *LookupAlias(char *alias);
    virtual ccsCOMPL_STAT   ListMergedKeywords(ic0KEYWORD_LIST *keywordList,
					       const char      *cmd = NULL);
    virtual ccsCOMPL_STAT   SetFilter(char *prefix);

    virtual ccsCOMPL_STAT   DumpFits(char *fileName);

    virtual ccsCOMPL_STAT   ClearFits();
    virtual ccsCOMPL_STAT   SaveSetup(char     *fileName);

    virtual ccsCOMPL_STAT   StoreFitsKeyword(ic0KEYWORD_LIST *keyword);
    virtual ccsCOMPL_STAT   StoreSetupKeywords(ic0KEYWORD_LIST *keyword);

    virtual ccsCOMPL_STAT   AddComment(char *comment);
    virtual ccsCOMPL_STAT   ClearComments();

    virtual ccsCOMPL_STAT   LoadOslxInfo(char *dictionary, char *alias);
    virtual ccsCOMPL_STAT   LoadDictionary(char *dictionary);
    virtual ccsCOMPL_STAT   LoadAlias(char *alias);

    ccsCOMPL_STAT           ExtFitsHeader(vltLOGICAL value);
    char*                   GetDictionaryName();

    
  protected:
    char             *insRoot; // INS directory structure reference
    char             *insUser; // INS directory user default SYSTEM
    char             *aliasFile;// Alias table
    char             *dictionaryFile;// Dictionary
    char             *cmdBuffer; // internal send buffer
    int              globalFilterNo;
    oslxDICTIONARY   dictionary; // dictionary
    oslxALIAS        alias;   // Alias table
    oslxKEYW_FILTER  filter;
    oslxKEYW_FILTER  headerFilter;
    vltLOGICAL       extHeader;
    oslxKEYW_FILTER  extHeaderFilter;
    oslxFITS         fits;
    oslxSETUP        setup;

    char*            GetErrKey(char *errorString);
  private:
};

#endif /*!IC0CHK_INTERFACE_H*/
