#ifndef IC0LCU_INTERFACE_H
#define IC0LCU_INTERFACE_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: ic0lcuINTERFACE.h,v 2.14 2005/09/22 07:54:24 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* alo/rsc   18/11/02  'virtual' removed from inherited classes
* alongino  27/06/02  multiple inheritance: virtual added (run-time error with gcc 3.0.4)
* alo/src   19/07/99  OCT99: '(<type>)NULL' replaced with just 'NULL'.
* therlin   18/09/96  Added default replies to Forward
* therlin   08/11/95  Created  
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */


#include "ic0.h"
#include "ic0genINTERFACE.h"
#include "evhSYNC.h"


class ic0lcuINTERFACE;

typedef struct{
    ccsENVNAME      lcuName; 
    ccsPROCNAME     serverName;
} ic0lcuSERVER;

typedef struct{
    void           *forwardObj; 
    evhCB_METHOD   replyCB;
    evhCB_METHOD   errorCB;
    evhCB_METHOD   timeoutCB;
} ic0lcuMULTI_CAST;


typedef  ic0lcuINTERFACE* (*ic0lcuType)();
#define   ic0lcuINTERFACE_CLASS     (ic0lcuType)ic0lcuINTERFACE::CreateNew

class ic0lcuINTERFACE : public fndOBJECT, public ic0genINTERFACE
{
  public: 
    ic0lcuINTERFACE();
   ~ic0lcuINTERFACE();

    static ic0lcuINTERFACE* CreateNew();

    // 
    virtual ccsCOMPL_STAT ComParameters(vltINT32     lcuNo,
					ic0lcuSERVER *lcuEnvServers);
    virtual ccsCOMPL_STAT InitCommunication();

    virtual ccsCOMPL_STAT Send();
    virtual ccsCOMPL_STAT Send(cmdPARAM_LIST   *paramList,
                               ic0KEYWORD_LIST *keywordList); // VLTSW980686
    virtual ccsCOMPL_STAT Send(vltINT32     lcuNo);
    virtual ccsCOMPL_STAT Forward(const char      *command,
				  cmdPARAM_LIST   *paramList,
				  ic0KEYWORD_LIST *keywordList,
				  ic0genFORWARD   *forwardObj,
				  evhCB_METHOD    replyCB = NULL,
                                  evhCB_METHOD    errorCB = NULL,
				  evhCB_METHOD    timeoutCB = NULL);
    virtual ccsCOMPL_STAT Forward(const char      *command,
				        char      *message,
				  ic0genFORWARD   *forwardObj,
				  evhCB_METHOD    replyCB = NULL,
                                  evhCB_METHOD    errorCB = NULL,
				  evhCB_METHOD    timeoutCB = NULL);

    // return reply buffer
    virtual const char *Reply(vltINT32 lcuNo = 0);
    virtual ccsCOMPL_STAT     NextReply(vltINT32 lcuNo = 0);
    virtual vltLOGICAL        LastReply(vltINT32 lcuNo = 0);
    virtual vltLOGICAL        ReplyFlag(vltINT32 lcuNo = 0);
    virtual ccsCOMPL_STAT     ReplyFlag(vltLOGICAL flag, 
                                        vltINT32 lcuNo = 0);

    virtual ccsPROCNAME   *ServerName();
    virtual ccsPROCNAME   *ServerName(vltINT32 lcuNo);
    ccsENVNAME            *LcuName();
    ccsENVNAME            *LcuName(vltINT32 lcuNo);
    vltINT32              LcuNum();
    
  protected:
    vltINT32           lcuNum;
    ic0lcuSERVER       *lcuServers;
    ic0genINTERFACE    *lcuInterfaceList;
    vltLOGICAL         *lcuMsg;
    ic0lcuMULTI_CAST   multiCastInfo;
    evhCOMMAND         multiCastCmd;
  private:
};


#endif /*!IC0LCU_INTERFACE_H*/
