#ifndef inscExpStates_H
#define inscExpStates_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: inscExpStates.h,v 1.52 2005/09/30 09:26:37 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* eallaert  05/06/96  created
*/

/************************************************************************
 *
 * This include file contains standard definitions for state codes and 
 * names.
 * It can be used both by C code and by dbLoader database definitions
 *----------------------------------------------------------------------
 */

//******************************************************************
//* Defines for DCS exposure status (see also inscEXPSTATUS.class) *
//******************************************************************

// bit 0: inactive (initial status after start-up)
//     1: pending (after receiving START command but before opening
//                 the shutter and/or starting integration time)
//     2: integrating
//     3: paused
//     4: reading out
//     5: processing (numerical calculations on the image)
//     6: transferring the image from LCU to WS
//     7: completed successfully
//     8: failed because of error
//     9: aborted by user
#define    inscEXP_UNDEFINED      0
#define    inscEXP_INACTIVE       1
#define    inscEXP_PENDING        2
#define    inscEXP_INTEGRATING    4
#define    inscEXP_PAUSED         8
#define    inscEXP_READING_OUT    16
#define    inscEXP_PROCESSING     32
#define    inscEXP_TRANSFERRING   64
#define    inscEXP_COMPL_SUCCESS  128
#define    inscEXP_COMPL_FAILURE  256
#define    inscEXP_COMPL_ABORTED  512

#endif /*!inscExpStates_H*/
