#ifndef IPHASEIC
#define IPHASEIC

#ifdef __cplusplus
extern "C" {
#endif

#include <stdio.h>

/*
**  - - - - - - - - -
**   i p h a s e . h
**  - - - - - - - - -
**
**  IPHASE function prototypes #include file.
**
**  Last revision:   27 January 2000
**
**  Copyright 2000 P.T.Wallace.  All rights reserved.
*/

int iphAbort ( int );
int iphAppend ( int );
void iphAppend_ ( void );
int iphCall ( char* );
void iphCall_ ( void );
int iphCapt ( int );
void iphCapt_ ( void );
int iphClist ( int );
void iphClist_ ( void );
int iphClrng ( int );
void iphClrng_ ( void );
int iphClval ( char*, int*, char* );
int iphCmdlcl ( char* );
int iphCsrv ( char*, int, int, double* );
void iphCsrv_ ( void );
int iphEcho ( int );
void iphEcho_ ( void );
int iphEnd ( void );
void iphEnd_ ( void );
int iphFit ( int fit );
void iphFit_ ( void );
int iphFittol ( double );
void iphFittol_ ( void );
int iphFix ( char* );
void iphFix_ ( void );
int iphFrame ( int );
void iphFrame_ ( void );
int iphG ( int, double );
void iphG_ ( void );
int iphGc ( int, char* );
void iphGc_ ( void );
int iphGdist ( void );
void iphGdist_ ( void );
int iphGetl ( char*, char*, int* );
int iphGmap ( double );
void iphGmap_ ( void );
int iphGsmap ( int, double );
void iphGsmap_ ( void );
int iphHelp ( char* );
void iphHelp_ ( void );
void iphHist ( double[], int, int, int, int, double[], double,
               double, double, double, double );
int iphIndat ( char*, int* );
void iphIndat_ ( void );
int iphInmod ( char* );
void iphInmod_ ( void );
int iphInpro ( char* );
void iphInpro_ ( void );
int iphInst ( char* );
void iphInst_ ( void );
int iphLose ( char* );
void iphLose_ ( void );
int iphMarkh ( double );
void iphMarkh_ ( void );
int iphMaskc ( int, int, int, double );
int iphMaskn ( int, int, int);
void iphMaskun_ ( void );
int iphMeslev ( int, int );
void iphMeslev_ ( void );
void iphMess ( int, char* );
void iphMessm ( int, char* );
void iphMessr ( int, char* );
int iphNactob ( void );
int iphOutdat ( char* );
void iphOutdat_ ( void );
int iphOutmod ( char* );
void iphOutmod_ ( void );
void iphPbeg ( void );
int iphPcapt ( double, double );
void iphPend ( void );
int iphPens ( int, int, int, int, int, int );
void iphPens_ ( void );
int iphPerfct ( void );
void iphPerfct_ ( void );
int iphPfirst ( void );
void iphPlotsq ( double , double );
void iphPlotst ( double, double );
int iphPltoff ( void );
void iphPltoff_ ( void );
int iphPlton ( char*, int );
void iphPlton_ ( void );
int iphPltz ( int, double, double, double, double );
void iphPltz_ ( void );
int iphPread ( char* );
int iphPterm ( int, double, double, double, double, double, double, double,
               double*, double*, double*, double* );
void iphPterml ( int, double, double, double, double, double,
                 double*, double*, double*, double*, int* );
void iphPterms ( int, double, double, double, double, double,
                 double*, double*, double*, double*, int* );
void iphPtermg ( char*, char*, double, double, double,
                 double*, double*, double*, double*, int* );
int iphPutl ( char* );
void iphPutlr ( int, int, char* );
void iphPwait ( void );
void iphQnobs ( int*, int*, int* );
int iphReplen ( int );
void iphReplen_ ( void );
int iphReset ( void );
void iphReset_ ( void );
void iphReturn ( void );
int iphScat ( char*, int*, double*, double*, double*,
              double*, double*, char*, double*, double* );
int iphSetcap ( char* );
void iphSetcap_ ( void );
void iphSetabo ( int ( * ) ( int ) );
void iphSetmes ( int ( * ) ( FILE*, FILE*, int, int, int, char* ) );
int iphShow ( void );
void iphShow_ ( void );
int iphSlist ( double, int );
void iphSlist_ ( void );
int iphSpawn ( char* );
void iphSpawn_ ( void );
int iphTerm ( char* );
int iphIpinit ( int ( * ) ( int ),
                int ( * ) ( FILE*, FILE*, int, int, int, char* ),
                int, int, char*, char*, char*, char* );
int iphIphini ( void );
int iphIphrun ( char* );
void iphTrmloc ( int*, char[][9] );
void iphTrmstd ( int*, char[][9] );
int iphTxf ( int, int );
void iphTxf_ ( void );
int iphTxp ( int );
void iphTxp_ ( void );
int iphUnfit ( int );
void iphUnfit_ ( void );
int iphUse ( char* );
void iphUse_ ( void );
int iphVt ( int, int );
void iphVt_ ( void );
void iphVtget ( void );
void iphVtinit ( void );

#ifdef __cplusplus
}
#endif

#endif
