#ifndef _iracqDTT_EVH_h
#define _iracqDTT_EVH_h

/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: iracqDTT_EVH.h,v 1.113 2005/09/13 07:27:09 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* jstegmei  27/07/99  created
*/

/************************************************************************
 *
 *  iracqDTT_EVH.h - data transfer task class definition (CCS extension)
 *
 *----------------------------------------------------------------------
 */


#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

#include "ECCS.h"

#include "evhHANDLER.h"
#include "evhTASK.h"
#include "evhFILEIO.h"

#include "iracqDTT.h"
#include "iracqErrors.h"

class iracqDTT_EVH: public evhTASK, public iracqDTT
{
  public:

  iracqDTT_EVH();             // constructor  
  virtual ~iracqDTT_EVH();    // destructor 
  
  void                  Verbose(const char *, ...);
  void                  ExitHandler(int);

  void                  PrintUsage(const char *);
  ccsCOMPL_STAT         ParseInputPars(int, char **);

  // data link callback handling
  void                  AttachDataLink(int);
  void                  DetachDataLink(int);

  // initialization routine
  ccsCOMPL_STAT         Init();
  ccsCOMPL_STAT         ReplaceEnv(char *);

  // FITS header
  ccsCOMPL_STAT         FitsAppend(const char *, int, const char *);
  ccsCOMPL_STAT         FitsAppend(const char *, float, const char *);
  ccsCOMPL_STAT         FitsAppend(const char *, double, const char *);
  ccsCOMPL_STAT         FitsAppend(const char *, const char *, const char *);
  ccsCOMPL_STAT         FitsAppend(const char *, const char *);
  ccsCOMPL_STAT         AddFits(const char *, int *, const char *);
  ccsCOMPL_STAT         AddFits(const char *, float *, const char *);
  ccsCOMPL_STAT         AddFits(const char *, double *, const char *);
  ccsCOMPL_STAT         AddFits(const char *, char *, const char *);
  ccsCOMPL_STAT         AddFits(const char *);

  ccsCOMPL_STAT         SendFileEvent(const char *);

  protected:

  private:
  vltINT32              log_;
  vltINT32              logOnStdout_;

  evhFILEIO            *fioSrvCmd_;
  evhFILEIO            *fioSrvEvt_;
  evhFILEIO            *fioData_[iracqDTT_MAX_DATALINK];

  evhCB_COMPL_STAT      SrvCmdCB_(msgMESSAGE &msg, void *udata);
  evhCB_COMPL_STAT      SrvEvtCB_(msgMESSAGE &msg, void *udata);
  evhCB_COMPL_STAT      CmdCB_(msgMESSAGE &msg, void *udata);
  evhCB_COMPL_STAT      EvtCB_(msgMESSAGE &msg, void *udata);
  evhCB_COMPL_STAT      DataCB_(msgMESSAGE &msg, void *udata);
};

#endif /*!_iracqDTT_EVH_h*/
