#ifndef ISS_H
#define ISS_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: iss.h,v 2.21 2005/06/03 15:38:25 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* jott     2005-05-20 In framework of SPR VLTSW20050153:
*                     Added definitions  issMODNAME_xx and issNUM_MSW_MODULES
* jott     2005-04-08 SPR VLTSW20050014:
*                     Increased issMAX_NUM_OPT_ELEM from 11 to 19,
*                     added definition issINS_FEED_OPT_LAST_NUM
*                     added image alignment sensor definitions issIAS_TCCD_STR,
*                     issIAS_IRIS_STR
*                     SPR VLTSW20050128:
*                     Added definition issTRACKING_QUERY for new process in
*                     isstrkws module
* jott     2005-02-18 Added definitions issDB_MACAO_PERF_DATA_READY, issNUM_UT
*                     (SPR VLTSW20050036)
* nhousen  2005-01-28 Added definitions issLIGHTDUCT_*, issM12_*INSTALLED,
*                      issCOVER_*INSTALLED
* jott     2004-11-02 Added definitions issDB_SELECT_IRIS_FILTER,
*                     issDB_IRIS_GUIDING_FLAG, issIRIS_BEAM_TEL_QUAD_TABLE
*                     to support IRIS integration
* jott     2004-10-06 SPR VLTSW20040230:
*                     Added definition issDB_SELECTED_INS
* jott     2004-08-24 SPRs VLTSW20040225 to VLTSW20040230:
*                     Added definitions issIMAGE_ALIGNMENT_SENSOR_ADDR,
*                     issIMAGE_ALIGN_SENSOR_ATTR_NAME
* jott     2004-02-12 Added support for delay lines 4 to 6 (SPR VLTSW20030502)
* jott     2003-12-04 Added definitions issVLTI_RA2000_DEG and
*                     issVLTI_DEC2000_DEG to solve SPR VLTSW20030510
* rrollf    14/08/03  Added defines for telescope types
* rrollf    11/02/03  Removed unused definitions issPRS_AH_WR_PREDPOS and
*                     issPRS_ACQ_WR_PREDPOS
*                     Added definitions issVLTI_GOBACK_RUNFLAGS,
*                     issVLTI_GOBACK_RA and issVLTI_GOBACK_DEC for GOBACK data
* jott      14/10/02  Added definition issFIELDS_CFG_TABLE2 for extended
*                     Array Config Table containing pupilIn0 and pupilOut0
*                     values (SPR VLTSW20020429)
* jott      08/07/02  Added definition issMAX_NUM_OPT_ELEM (SPR VLTSW20020438)
* rrollf    06/08/02  Added macros issExec(a,b) and issErrAdd(a,b)
* jott      30/07/02  Added definition issNUM_INPUT_CHANNELS
* rrollf    22/07/02  Added definitions for FINITO beams
*                     Changed definitions for DEL.FT.SENSOR
*                         FINITO_CH1, FINITO_CH2, FINITO_BOTH removed
*                         FINITO added
*                     Added definitions for DLCS Motion Phase
*                     Added definitions for Mapping of VLTI Input Channel
*                     to FINITO beam
*                     Added definitions for Strings to match in userField
*                     of module table
* rrollf    07/05/02  Added definitions for enums of DEL.FT.SENSOR
* jott      08/04/02  added definition issFIELDS_CFG_TABLE for number of
*                     fields in Array Configuration Table and corresponding
*                     database pathes
* rrollf    19/02/02  Added definitions for predicted positions:
*                     issVLTI_PRED_POS_ALT, issVLTI_PRED_POS_AZ,
*                     issVLTI_PRED_POS_DL1, ... , issVLTI_PRED_POS_DL4
* jott      22/11/01  Improved comments for definitions issVLTI_ENVIRONMENT and
*                     tcsVLTI_ENVNAME (SPR VLTSW20010692)
* rrollf    20/11/01  Added issVLTI_STATION_UVW definition
* rrollf    12/11/01  Added issVLTI_LST definition
* rrollf    12/10/01  added issVLTI_RA and issVLTI_DEC defines
* jott      08/10/01  changed definition issNO_OF_PHYSICAL_DELAY_LINES to
*                     issNUM_CURR_SUPP_DL
* jott      21/09/01  added definition issNO_OF_PHYSICAL_DELAY_LINES
* rrollf    18/09/01  added issVLTI_GLOBAL_STATE and issVLTI_SUBSTATE
* jott      17/09/01  adopted definitions for Coude Guiding Modes to the
*                     new defined ones
* jott      13/09/01  adopted definitions for Coude Guiding Modes to the
*                     values used in mvoPrivate.h
* rrollf    25/07/01  added some defines of database addresses for subsystems
* rrollf    22/06/01  added definitions issPRESET_BROADCAST and
*                     issPRESET_REACQUIRE
*                     added definitions for database attribute addresses used
*                     from ISS (like subsystem branch)
* jott      10/05/01  Definition issVLTI_ENVIRONMENT added
* jott      30/04/01  third version (Version 1 of ISS)
* jott      22/03/01  intermediate version
* jott      20/02/01  first version
* jott      09/01/01  created
*/

/************************************************************************
 * General definitions concerning VLTI ISS
 *----------------------------------------------------------------------
 */
#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

/*
 * Root point for TCS database branch
 */
#define tcsVLTI_DBPOINT       "VLTI_DBPOINT"
#define tcsVLTI_DBPOINT_DEF   ":Appl_data:VLTI"

/*
 * Default environment name for ISS workstation environment
 */
#define issVLTI_ENVIRONMENT   "wvgvlti"

/*
 * Environment variable containing the name for ISS workstation environment
 * if not the default name is used. If ISS runs on another environment than
 * specified by issVLTI_ENVIRONMENT this environment variable must be set.
 * Otherwise the use of the issif library functions fails.
 */
#define tcsVLTI_ENVNAME       "VLTI_ENVNAME"

/*
 * ISS module names
 */
#define issMOD              "iss"
#define issDLCS_MOD_NAME    "DLCS"

/*
 * ISS process names (local environment)
 */
#define issINTERFACE              "issifControl"
#define issMODE_SWITCHING         "issmswControl"
#define issARRAY_CONTROL          "issarrayControl"
#define issPRESET_INTERFACE       "issprsControl"
#define issPRESET_BROADCAST       "issprsBroadcast"
#define issPRESET_ACTION_HANDLER  "issprsAction"
#define issPRESET_REACQUIRE       "issprsReacquire"
#define issTRACKING_CONTROL       "isstrkwsControl"
#define issTRACKING_QUERY         "isstrkwsQuery"
#define issMONITORING             "issmonControl"
#define issALIGNMENT_CONTROL      "issalignControl"

/* ISO Time String for ccsTIMEVAL = {0, 0} */
#define issISO_ZERO_TIME "1970-01-01T01:00:00.000000"

/* Maximum number of interferometric arms  */
#define issMAX_NUM_ARMS             3

/* Number of UNIT Telescopes */
#define issNUM_UT                   4


/* Number of physical telescopes */
#define issNUM_PHYSICAL_TEL         9

/* Number of physical delay lines */
#define issNUM_PHYSICAL_DL          6

/* Number of optical elements per light path from sky to entrance of
   instrument */
#define issMAX_NUM_OPT_ELEM         19

/* Number of Nasmyth devices */
#define issMAX_NUM_NASMYTH_DEVICE   issNUM_UT

/*
 * Number of physical delay line currently supported by DLCS
 */
#define issNUM_CURR_SUPP_DL         issNUM_PHYSICAL_DL

/* Number of used fields of VLTI Array Configuration Table */
#define issFIELDS_CFG_TABLE         15
#define issFIELDS_CFG_TABLE2        17  /* table extension */

/* Database module branch of VLTI Array Configuration Table */
#define issARRAY_MOD "issarray"

/* Database sub-point of VLTI Array Configuration Table */
#define issARRAY_DB_DATA_POINT "data"

/* Attribute name of VLTI Array Configuration Table */
#define issARRAY_CONF_TABLE_NAME "configTable"

/*
 * IDs of the VLTI telescopes, DLCS and Coude stations
 */
#define  issTELESCOPE_NAME_NONE  0
#define  issTELESCOPE_NAME_UT1   1
#define  issTELESCOPE_NAME_UT2   2
#define  issTELESCOPE_NAME_UT3   3
#define  issTELESCOPE_NAME_UT4   4
#define  issTELESCOPE_NAME_SID1  5
#define  issTELESCOPE_NAME_SID2  6
#define  issTELESCOPE_NAME_AT1   7
#define  issTELESCOPE_NAME_AT2   8
#define  issTELESCOPE_NAME_AT3   9
#define  issTELESCOPE_NAME_DLCS  10
#define  issTELESCOPE_NAME_COU1  11
#define  issTELESCOPE_NAME_COU2  12
#define  issTELESCOPE_NAME_COU3  13
#define  issTELESCOPE_NAME_COU4  14

/*
 * Number of the VLTI telescope names
 */
#define  issNUMBER_OF_TELESCOPE_NAMES  10

/*
 * Names of the VLTI telescopes
 */
#define  issTELESCOPE_STRING_EMPTY "undefined"
#define  issTELESCOPE_STRING_UT1   "UT1"
#define  issTELESCOPE_STRING_UT2   "UT2"
#define  issTELESCOPE_STRING_UT3   "UT3"
#define  issTELESCOPE_STRING_UT4   "UT4"
#define  issTELESCOPE_STRING_SID1  "SID1"
#define  issTELESCOPE_STRING_SID2  "SID2"
#define  issTELESCOPE_STRING_AT1   "AT1"
#define  issTELESCOPE_STRING_AT2   "AT2"
#define  issTELESCOPE_STRING_AT3   "AT3"

/*
 * Name of DLCS
 */
#define  issDELAY_STRING_DLCS  "DLCS"

/*
 * Names of the VLTI Coude systems
 */
#define  issCOUDE_STRING_UT1       "COU1"
#define  issCOUDE_STRING_UT2       "COU2"
#define  issCOUDE_STRING_UT3       "COU3"
#define  issCOUDE_STRING_UT4       "COU4"

/*
 * Definitions for the telescope station names
 */
#define  issSTATION_NONE         "undefined"
#define  issSTATION_A0           "A0"
#define  issSTATION_A1           "A1"
#define  issSTATION_B0           "B0"
#define  issSTATION_B1           "B1"
#define  issSTATION_B2           "B2"
#define  issSTATION_B3           "B3"
#define  issSTATION_B4           "B4"
#define  issSTATION_B5           "B5"
#define  issSTATION_C0           "C0"
#define  issSTATION_C1           "C1"
#define  issSTATION_C2           "C2"
#define  issSTATION_C3           "C3"
#define  issSTATION_D0           "D0"
#define  issSTATION_D1           "D1"
#define  issSTATION_D2           "D2"
#define  issSTATION_E0           "E0"
#define  issSTATION_G0           "G0"
#define  issSTATION_G1           "G1"
#define  issSTATION_G2           "G2"
#define  issSTATION_H0           "H0"
#define  issSTATION_I1           "I1"
#define  issSTATION_J1           "J1"
#define  issSTATION_J2           "J2"
#define  issSTATION_J3           "J3"
#define  issSTATION_J4           "J4"
#define  issSTATION_J5           "J5"
#define  issSTATION_J6           "J6"
#define  issSTATION_K0           "K0"
#define  issSTATION_L0           "L0"
#define  issSTATION_M0           "M0"
#define  issSTATION_U1           "U1"
#define  issSTATION_U2           "U2"
#define  issSTATION_U3           "U3"
#define  issSTATION_U4           "U4"

/*
 * Definitions for the light duct names
 */
#define  issLIGHTDUCT_NONE       "undefined"
#define  issLIGHTDUCT_A          "A"
#define  issLIGHTDUCT_B          "B"
#define  issLIGHTDUCT_C          "C"
#define  issLIGHTDUCT_D          "D"
#define  issLIGHTDUCT_E          "E"
#define  issLIGHTDUCT_G          "G"
#define  issLIGHTDUCT_H          "H"
#define  issLIGHTDUCT_I          "I"
#define  issLIGHTDUCT_J          "J"
#define  issLIGHTDUCT_K          "K"
#define  issLIGHTDUCT_L          "L"
#define  issLIGHTDUCT_M          "M"
#define  issLIGHTDUCT_U1         "U1"
#define  issLIGHTDUCT_U2         "U2"
#define  issLIGHTDUCT_U3         "U3"
#define  issLIGHTDUCT_U4         "U4"

/*
 * Definitions for the telescope station name identifiers
 */
#define  issSTATION_NONE_ID       0
#define  issSTATION_A0_ID         1
#define  issSTATION_A1_ID         2
#define  issSTATION_B0_ID         3
#define  issSTATION_B1_ID         4
#define  issSTATION_B2_ID         5
#define  issSTATION_B3_ID         6
#define  issSTATION_B4_ID         7
#define  issSTATION_B5_ID         8
#define  issSTATION_C0_ID         9
#define  issSTATION_C1_ID        10
#define  issSTATION_C2_ID        11
#define  issSTATION_C3_ID        12
#define  issSTATION_D0_ID        13
#define  issSTATION_D1_ID        14
#define  issSTATION_D2_ID        15
#define  issSTATION_E0_ID        16
#define  issSTATION_G0_ID        17
#define  issSTATION_G1_ID        18
#define  issSTATION_G2_ID        19
#define  issSTATION_H0_ID        20
#define  issSTATION_I1_ID        21
#define  issSTATION_J1_ID        22
#define  issSTATION_J2_ID        23
#define  issSTATION_J3_ID        24
#define  issSTATION_J4_ID        25
#define  issSTATION_J5_ID        26
#define  issSTATION_J6_ID        27
#define  issSTATION_K0_ID        28
#define  issSTATION_L0_ID        29
#define  issSTATION_M0_ID        30
#define  issSTATION_U1_ID        31
#define  issSTATION_U2_ID        32
#define  issSTATION_U3_ID        33
#define  issSTATION_U4_ID        34

/*
 * Number of telecope station name identifiers
 */
#define  issNUMBER_OF_STATION_IDS   35

/*
 * Definitions for M12 configurations
 */
#define  issM12_NOT_INSTALLED       0
#define  issM12_INSTALLED           1

/*
 * Definitions for light duct cover configurations
 */
#define  issCOVER_NOT_INSTALLED  0
#define  issCOVER_INSTALLED      1

/*
 * Definitions for the delay line names
 */
#define issSTRING_DELAYLINE_NONE "undefined"
#define issSTRING_DELAYLINE1     "DL1"
#define issSTRING_DELAYLINE2     "DL2"
#define issSTRING_DELAYLINE3     "DL3"
#define issSTRING_DELAYLINE4     "DL4"
#define issSTRING_DELAYLINE5     "DL5"
#define issSTRING_DELAYLINE6     "DL6"


/*
 * Definitions for the switchyard configuration names
 */
#define issSTRING_SWYARD_NONE    "none"
#define issSTRING_SWYARD_DIRECT  "direct"
#define issSTRING_SWYARD_BC      "compressed"
#define issSTRING_SWYARD_DDL     "differential"

/*
 * Definitions for the feed optics  names
 */
#define issSTRING_FEED_OPT_NOT_CONF   "undefined"
#define issSTRING_FEED_OPT_FREE       "free"
#define issSTRING_FEED_OPT_MIRR       "mirror"
#define issSTRING_FEED_OPT_DICHR      "dichroic"

/*
 * Chopping states
 */
#define issCHOP_INACTIVE         0
#define issCHOP_ACTIVE           1
#define issCHOP_UNDEFINED        2
#define issCHOP_NULLING          3

/*
 * Coude Auto Guiding States
 */
#define issAG_STATE_EVH_UNK      0
#define issAG_STATE_ERROR        6
#define issAG_STATE_IDLE         7
#define issAG_STATE_OPERATING    121
#define issAG_STATE_GUIDING      122

/*
 * Coude Guiding Modes
 */
#define issAG_MODE_NONE          0
#define issAG_MODE_AUTO_GUIDE    1
#define issAG_MODE_FIELD_STAB    2
#define issAG_MODE_FSTCCD        3
#define issAG_MODE_ADAPT_OPT     4
#define issAG_MODE_AOTCCD        5

/*
 * Stings for Coude Guiding Modes
 */
#define issCOU_AG_MODE_STR_NONE         "NONE"
#define issCOU_AG_MODE_STR_AUTO_GUIDE   "AUTO_GUIDE"
#define issCOU_AG_MODE_STR_FIELD_STAB   "FIELD_STAB"
#define issCOU_AG_MODE_STR_FSTCCD       "FIELD_STAB_TCCD"
#define issCOU_AG_MODE_STR_ADAPT_OPT    "ADAPT_OPT"
#define issCOU_AG_MODE_STR_AOTCCD       "ADAPT_OPT_TCCD"


/*
 * Delay line identifiers
 */
#define issDL_ID_NONE            0
#define issDL_ID_DL1             1
#define issDL_ID_DL2             2
#define issDL_ID_DL3             3
#define issDL_ID_DL4             4
#define issDL_ID_DL5             5
#define issDL_ID_DL6             6


/*
 * Number of delay line identifiers
 */
#define issNUMBER_OF_DELAY_LINE_IDS   7


/*
 * Input channels in lab
 */
#define issINPUT_NONE            0
#define issINPUT_1               1
#define issINPUT_2               2
#define issINPUT_3               3
#define issINPUT_4               4
#define issINPUT_5               5
#define issINPUT_6               6
#define issINPUT_7               7
#define issINPUT_8               8

#define issNUM_INPUT_CHANNELS    8


/*
 * Input channel strings in lab
 */
#define issINPUT_STR_NONE        "none"
#define issINPUT_STR_1           "Input1"
#define issINPUT_STR_2           "Input2"
#define issINPUT_STR_3           "Input3"
#define issINPUT_STR_4           "Input4"
#define issINPUT_STR_5           "Input5"
#define issINPUT_STR_6           "Input6"
#define issINPUT_STR_7           "Input7"
#define issINPUT_STR_8           "Input8"

/*
 * Number of input channel identifiers
 */
#define issNUMBER_OF_INPUT_CHANNEL_IDS  9


/*
 * FINITO beams
 */

/* FINITO beam Ids */
#define issFINITO_BEAM_NONE    -1
#define issFINITO_BEAM_0        0
#define issFINITO_BEAM_1        1
#define issFINITO_BEAM_2        2

/* FINITO beam strings */
#define issFINITO_BEAM_STR_NONE "none"
#define issFINITO_BEAM_STR_0    "FINITO beam 0"
#define issFINITO_BEAM_STR_1    "FINITO beam 1"
#define issFINITO_BEAM_STR_2    "FINITO beam 2"

/* Number of FINITO beam identifiers */
#define issNUMBER_OF_FINITO_BEAM_IDS    4


/*
 * Switchyard configuration
 */
#define issSWYARD_NONE           0
#define issSWYARD_DIRECT         1
#define issSWYARD_BEAM_COMP      2
#define issSWYARD_DIFFERENTIAL   3

/*
 * Instrument feeding optics:
 * free, mirror, dichroic, ...
 */
#define issINS_FEED_OPT_NOT_CONF       0
#define issINS_FEED_OPT_FREE           1
#define issINS_FEED_OPT_MIRROR         2
#define issINS_FEED_OPT_DICHROIC       3
#define issINS_FEED_OPT_LAST_NUM       issINS_FEED_OPT_DICHROIC

/*
 * PRIMA: differential delay line states
 */
#define issPRI_DDL_STATUS_FIX    0
#define issPRI_DDL_STATUS_BLIND  1
#define issPRI_DDL_STATUS_FRINGE 2

/*
 * PRIMA: fringe sensor states
 */
#define issPRI_FR_SENS_STATUS_INACTIVE      0
#define issPRI_FR_SENS_STATUS_TRACKING      1
#define issPRI_FR_SENS_STATUS_LOOKING       2
#define issPRI_FR_SENS_STATUS_CALIBRATING   3
#define issPRI_FR_SENS_STATUS_COHERENCING   4

/*
 * PRIMA metrology system states
 */
#define issPRI_MET_STATUS_OFF               0
#define issPRI_MET_STATUS_TRACKING          1

/*
 * Defines for data of DEL.FT.SENSOR (fringe sensor)
 */
#define issFTS_NIL                         -1
#define issFTS_VINCI                        1
#define issFTS_MIDI                         2
#define issFTS_FINITO                       3
#define issFTS_FSUA                         4
#define issFTS_FSUB                         5
#define issFTS_MET                          6

#define issFTS_STR_VINCI                    "VINCI"
#define issFTS_STR_MIDI                     "MIDI"
#define issFTS_STR_FINITO                   "FINITO"
#define issFTS_STR_FSUA                     "FSUA"
#define issFTS_STR_FSUB                     "FSUB"
#define issFTS_STR_MET                      "MET"


/*
 * DLCS Motion Phase
 */

/* DLCS Motion Phase Ids */
#define issMOTION_PHASE_UNDEFINED   0
#define issMOTION_PHASE_IDLE        1
#define issMOTION_PHASE_POSITION    2
#define issMOTION_PHASE_PRESETTING  3
#define issMOTION_PHASE_ZPDSEARCH   4
#define issMOTION_PHASE_BLIND       5
#define issMOTION_PHASE_FRINGE      6

/* DLCS Motion Phase strings */
#define issMOTION_PHASE_STR_UNDEFINED   "UNDEFINED"
#define issMOTION_PHASE_STR_IDLE        "IDLE"
#define issMOTION_PHASE_STR_POSITION    "POSITION"
#define issMOTION_PHASE_STR_PRESETTING  "PRESETTING"
#define issMOTION_PHASE_STR_ZPDSEARCH   "ZPDSEARCH"
#define issMOTION_PHASE_STR_BLIND       "BLIND"
#define issMOTION_PHASE_STR_FRINGE      "FRINGE"

/* Number of DLCS Motion Phase identifiers */
#define issNUMBER_OF_MOTION_PHASE_IDS    7


/*
 * Definitions for database attribute addresses of iss modules
 * (public database) needed by other iss modules
 */
#define issVLTI_TRACKING_STATE  \
    ":Appl_data:VLTI:isstrkws.trackingState"

#define issVLTI_GUIDING_STATE   \
    ":Appl_data:VLTI:isstrkws.guidingState"

#define issVLTI_RA              \
    ":Appl_data:VLTI:isstrkws:data:position:actPos.RA"

#define issVLTI_RA2000_DEG      \
    ":Appl_data:VLTI:isstrkws:data:position:actPos.RA2000Deg"

#define issVLTI_DEC             \
    ":Appl_data:VLTI:isstrkws:data:position:actPos.dec"

#define issVLTI_DEC2000_DEG     \
    ":Appl_data:VLTI:isstrkws:data:position:actPos.dec2000Deg"

#define issVLTI_TEL_RA2000      \
    ":Appl_data:VLTI:isstrkws:data:position:actPos.telRA2000"

#define issVLTI_TEL_DEC2000     \
    ":Appl_data:VLTI:isstrkws:data:position:actPos.telDec2000"

#define issVLTI_LST             \
    ":Appl_data:VLTI:isstrkws:data:times.lst"

#define issDB_MACAO_PERF_DATA_READY  "<alias>isstrkwsControl:data:macao.allDataUpdated"

#define issVLTI_GLOBAL_STATE    \
    ":Appl_data:VLTI:issmsw.state"

#define issVLTI_SUBSTATE        \
    ":Appl_data:VLTI:issmsw.substate"

#define issVLTI_STATION_UVW     \
    ":Appl_data:VLTI:issarray:parameter.stationCentre"

#define issVLTI_PRED_POS_ALT    ":Appl_data:VLTI:issprs:predPos.alt"
#define issVLTI_PRED_POS_AZ     ":Appl_data:VLTI:issprs:predPos.az"
#define issVLTI_PRED_POS_DL1    ":Appl_data:VLTI:issprs:predPos.oplDL1"
#define issVLTI_PRED_POS_DL2    ":Appl_data:VLTI:issprs:predPos.oplDL2"
#define issVLTI_PRED_POS_DL3    ":Appl_data:VLTI:issprs:predPos.oplDL3"
#define issVLTI_PRED_POS_DL4    ":Appl_data:VLTI:issprs:predPos.oplDL4"
#define issVLTI_PRED_POS_DL5    ":Appl_data:VLTI:issprs:predPos.oplDL5"
#define issVLTI_PRED_POS_DL6    ":Appl_data:VLTI:issprs:predPos.oplDL6"

#define issIRIS_BEAM_TEL_QUAD_TABLE  "<alias>issarrayControl:data:iris.beamIrisConf"

/*
 * Database addresses of attributes used by iss modules
 * for data exchange
 */
#define issVLTI_RESET_UVW_OFFS  ":Appl_data:VLTI:dataExchange.resetUvwOffsets"
#define issVLTI_GOBACK_DATA     ":Appl_data:VLTI:dataExchange:goback"
#define issVLTI_RUNFLAGS        "runFlags"
#define issVLTI_RA2000          "ra2000"
#define issVLTI_DEC2000         "dec2000"
#define issVLTI_GOBACK_RUNFLAGS issVLTI_GOBACK_DATA "." issVLTI_RUNFLAGS
#define issVLTI_GOBACK_RA2000   issVLTI_GOBACK_DATA "." issVLTI_RA2000
#define issVLTI_GOBACK_DEC2000  issVLTI_GOBACK_DATA "." issVLTI_DEC2000

/*
 * Database addresses of attributes used for global VLTI parameters
 */
#define issINPUT_CH_FNT_BEAM_MAP    ":Appl_data:VLTI"   \
                                    ":parameter"        \
                                    ".inputChFntBeamMap"

/*
 * Module number and module names of ISS mode switching table
 */
#define issNUM_MSW_MODULES     21

#define issMODNAME_SID1        "SID1"
#define issMODNAME_SID2        "SID2"
#define issMODNAME_UT1         "UT1"
#define issMODNAME_UT2         "UT2"
#define issMODNAME_UT3         "UT3"
#define issMODNAME_UT4         "UT4"
#define issMODNAME_AT1         "AT1"
#define issMODNAME_AT2         "AT2"
#define issMODNAME_AT3         "AT3"
#define issMODNAME_DLCS        "DLCS"
#define issMODNAME_COU1        "COU1"
#define issMODNAME_COU2        "COU2"
#define issMODNAME_COU3        "COU3"
#define issMODNAME_COU4        "COU4"
#define issMODNAME_ARAL        "ARAL"
#define issMODNAME_PRIMA       "PRIMA"
#define issMODNAME_ISSPRS      "issprs"
#define issMODNAME_ISSTRKWS    "isstrkws"
#define issMODNAME_ISSMON      "issmon"
#define issMODNAME_ISSARRAY    "issarray"
#define issMODNAME_ISSALIGN    "issalign"
#define issMODNAME_NONE        "none"


/*
 * strings to match in userField of module table
 */
#define issMSW_TELESCOPE_STRING     "TELESCOPE"
#define issMSW_GUIDING_STRING       "GUIDING"
#define issMSW_DELAY_STRING         "DELAY"
#define issMSW_AO_STRING            "AO"
#define issMSW_PRIMA_STRING         "PRIMA"
#define issMSW_ARAL_STRING          "ARAL"

/*
 * Defines for telescope types
 */
#define issNUM_TEL_TYPES         3               /* SID, UT, AT */

#define issTEL_TYPE_NONE         0
#define issTEL_TYPE_SID          1
#define issTEL_TYPE_UT           2
#define issTEL_TYPE_AT           3
#define issTEL_TYPE_MIX          4

#define issTEL_TYPE_STR_NONE     ""
#define issTEL_TYPE_STR_SID      "SID"
#define issTEL_TYPE_STR_UT       "UT"
#define issTEL_TYPE_STR_AT       "AT"
#define issTEL_TYPE_STR_MIX      "MIX"


/*
 * Database attribute for name of VLTI image alignment sensor starting from
 * VLTI database root
 */
#define issIMAGE_ALIGN_SENSOR_ATTR_NAME "alignSensor"
#define issIMAGE_ALIGNMENT_SENSOR_ADDR   issARRAY_MOD ":data." issIMAGE_ALIGN_SENSOR_ATTR_NAME

/*
 * Database attribute for name of currently selected VLTI instrument
 */
#define issDB_SELECTED_INS        "<alias>issmswControl:insData.selectedIns"


/*
 * Image alignment sensor names
 */
#define  issIAS_TCCD_STR          "TCCD"
#define  issIAS_IRIS_STR          "IRIS"

/*
 * Database attribute for currently selected IRIS filter and guidging flag
 */
#define issDB_SELECT_IRIS_FILTER        "<alias>IRIS.filterName"
#define issDB_IRIS_GUIDING_FLAG         "<alias>IRIS.guidingState"


/*
 * Macros for ISS modules
 */
#define issExec(a,b)        if ( (a) == SUCCESS )                   \
                                {                                   \
                                errFlag((a),(b));                   \
                                }

#define issErrAdd(a,b)      if ( (a) == FAILURE )                   \
                                {                                   \
                                ErrAdd b ;                          \
                                }

#endif /* ISS_H */
