#ifndef issCALC_H
#define issCALC_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: issCalc.h,v 2.21 2005/06/03 15:38:25 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* jott     2004-10-06 renamed elements 'targWlen' and 'aralTccdWlen' of
*                     structure issCALC_TADC_IN_DATA to 'zeroWavelen' and
*                     'iasWaveLen' to avoid confusion when IRIS is used
* jott     2003-10-20 added structures issCALC_TADC_IN_DATA, issSLALIB_PRMS
* jott     2003-09-19 added file header comment
* rrollf    02/04/02  created
*/

/************************************************************************
 * Header file for structures used in
 *----------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

#include "CCS.h"
#include "iss.h"
#include "issConfigTable.h"

/*
 * VLTI config table
 */
typedef struct {
    issVLTI_CFG_FIELDS  arm[issMAX_NUM_ARMS];
} issVLTI_CFG_TABLE;


/* UVW Coordinates of a telescope (location) */
typedef struct
    {
    vltDOUBLE   u;
    vltDOUBLE   v;
    vltDOUBLE   w;
    } issUVW;

typedef vltDOUBLE   issOPL_DL[issNUM_PHYSICAL_DL];


/*
 * Structure containing all input data needed for TADC computation
 */
typedef struct
    {
    vltDOUBLE       zeroWavelen;           /*          [nm] */
    vltDOUBLE       iasWaveLen;            /*          [nm] */
    vltDOUBLE       ra;                    /*      [HHMMSS] */
    vltDOUBLE       dec;                   /*      [DDMMSS] */
    vltDOUBLE       epoch;                 /*          year */
    vltDOUBLE       temperature;           /*      [Kelvin] */
    vltDOUBLE       pressure;              /*        [mbar] */
    vltDOUBLE       humidity;              /* rel. fraction */
    vltDOUBLE       tempLapseRate;         /*         value */
    vltDOUBLE       longitude;             /*         [rad] */
    vltDOUBLE       latitude;              /*         [rad] */
    vltDOUBLE       height;                /*           [m] */
    } issCALC_TADC_IN_DATA;

/*
 * parameter structures to use slalib
 */
typedef struct
    {
    vltDOUBLE amprms[21];
    vltDOUBLE aoprms[14];
} issSLALIB_PRMS;


#endif /* !issCALC_H */
