#ifndef ISS_CONFIG_TABLE_H
#define ISS_CONFIG_TABLE_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: issConfigTable.h,v 2.21 2005/06/03 15:38:26 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* jott      14/10/02  added structure issVLTI_CFG_FIELDS2 for extended
*                     Array configuration table (SPR VLTSW20020429)
* jott      08/04/02  created
*/

/************************************************************************
 * Structures concerning VLTI Array Configuartion table
 *----------------------------------------------------------------------
 */

/* Complete Array configuration Table structure */
typedef struct
    {
    vltINT32            telescopeNum;
    vltINT32            telescopeName;
    vltBYTES20          location;
    vltINT32            physDelayLine;
    vltINT32            inputChannel;
    vltINT32            swYardConfig;
    vltINT32            secInputChannel;
    vltINT32            secSwYardConfig;
    vltINT32            opticsMidi;
    vltINT32            opticsVinci;
    vltINT32            opticsFinito;
    vltINT32            opticsPrimaFsuA;
    vltINT32            opticsPrimaFsuB;
    vltINT32            opticsAmber;
    vltDOUBLE           oplZero;
    } issVLTI_CFG_FIELDS;


/* Complete Array configuration Table structure (extended table, version 2) */
typedef struct
    {
    vltINT32            telescopeNum;
    vltINT32            telescopeName;
    vltBYTES20          location;
    vltINT32            physDelayLine;
    vltINT32            inputChannel;
    vltINT32            swYardConfig;
    vltINT32            secInputChannel;
    vltINT32            secSwYardConfig;
    vltINT32            opticsMidi;
    vltINT32            opticsVinci;
    vltINT32            opticsFinito;
    vltINT32            opticsPrimaFsuA;
    vltINT32            opticsPrimaFsuB;
    vltINT32            opticsAmber;
    vltDOUBLE           oplZero;
    vltDOUBLE           pupIn0;
    vltDOUBLE           pupOut0;
    } issVLTI_CFG_FIELDS2;



#endif   /* ISS_CONFIG_TABLE_H */
