#ifndef issalign_H
#define issalign_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: issalign.h,v 3.17 2005/06/08 13:37:01 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* jott     2005-05-09 Added element issalignREF_PIX_DL_TRIGGER_IAS_CHANGE
*                     to enumeration issalignREF_PIX_DL_TRIGGER
* jott     2005-02-21 SPR VLTSW20050019:
*                     Added structure issalignOPSLOGPIX,
*                     added members issalignREF_PIX_DL_TRIGGER_TADCMODE and
*                     issalignREF_PIX_DL_TRIGGER_CHREFPX to
*                     enumeration type issalignREF_PIX_DL_TRIGGER,
*                     added members  issalignIMAGE_EXE_IRIS_MOD_ZERO_REF
*                     and issalignIMAGE_EXE_IRIS_MOD_TADC_USE to enumeration
*                     type issalignIMG_STATE
* jott     2004-12-02 SPR VLTSW20040228:
*                     Added members issalignIMAGE_EXE_IRIS_START_LAG and
*                     issalignIMAGE_EXE_IRIS_STOP_LAG to enumeration
*                     type issalignIMG_STATE
* jott     2004-11-05 SPRs VLTSW20040228, VLTSW20040230:
*                     Added enumeration types issalignREF_PIX_TAB_STATUS and
*                     issalignREF_PIX_DL_TRIGGER
*                     Modified structure issalignREF_PIX_CONF to contain
*                     a member array issalignREF_PIXEL_REC[] and removed member
*                     array beamStr[] because already contained in member array
*                     refTable[]
* jott     2004-10-14 VLTSW20040230:
*                     Modified structure issalignREF_PIX_CONF to contain arrays
*                     for reference pixels, sizes and beamStrings, and removed
*                     member beamId.
*                     Added structures issalignREF_OFFSET_REC,
*                     issalignIAS_INS_RECORD
*                     Added enumeration issalignTADC_USE_ZERO_WLEN
*                     Added external variable issaligZeroWlenKeywordMap
* jott     2004-10-04 VLTSW20040230:
*                     added external variable 'issaligSensorNameMaps'
*                     added structures issalignREF_PIX_CONF,
*                     issalignREF_PIX_IRIS_REC, issalignIRIS_WLEN,
*                     issalignIRIS_INFO
*                     added  definition issalignREF_PIX_IRIS_MAX_FIELD_NUM
*                     added enumeration issalignIRIS_COMPL_STAT
* jott     2004-03-05 added inline functions DebugEnter() and DebugLeft() to
*                     be able to port to APR2004
* jott     2003-10-16 extended structure issalignREF_PIXEL_REC by field 'beam'
*                     (SPR VLTSW20030425)
*                     added struct issalignTADC_IN_DATA
* rrollf    30/01/03  Revisited implementation of reference pixel manager
* jott      11/10/02  added command processing state
*                     issalignIMAGE_EXE_SETUP_LOOP
* jott      08/10/02  SPR VLTSW20020554:
*                     added states issalignIMAGE_ERR_RESET_ARAL and
*                     issalignIMAGE_EXE_RESTART_EXP for improved error
*                     handling
*                     added states issalignIMAGE_EXE_START_LOOP and
*                     issalignIMAGE_EXE_WAIT_LOOP
* jott      12/07/02  Created
*/

/************************************************************************
 *
 *   General header file for "issalign" containing type definitions and
 *   declarations which cannot be used in dbl files.
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

#include "db.h"
#include "fndNAME_MAP.h"
#include "issCalc.h"
#include "issalignDefines.h"


/*
 * Command processing states
 */
typedef enum
    {
    issalignIMAGE_IDLE,                     //  0
    issalignIMAGE_EXE_CHECK_ARAL,           //  1
    issalignIMAGE_EXE_STOP_EXP,             //  2
    issalignIMAGE_EXE_SETUP1_ARAL,          //  3
    issalignIMAGE_EXE_START1_EXP,           //  4
    issalignIMAGE_EXE_WAIT_EXP,             //  5
    issalignIMAGE_EXE_OFFSGUV,              //  6
    issalignIMAGE_EXE_SETUP2_ARAL,          //  7
    issalignIMAGE_EXE_START2_EXP,           //  8
    issalignIMAGE_CHECK_GUID_SYS,           //  9
    issalignIMAGE_CHECK_LOOK_UP,            // 10
    issalignIMAGE_CHECK_CALC_ERROR,         // 11
    issalignIMAGE_CHECK_READ_ERROR,         // 12
    issalignIMAGE_ALIGNED,                  // 13
    issalignIMAGE_ERR_RESET_ARAL,           // 14
    issalignIMAGE_ERR_RESTART_EXP,          // 15
    issalignIMAGE_EXE_START_LOOP,           // 16
    issalignIMAGE_EXE_WAIT_LOOP,            // 17
    issalignIMAGE_EXE_SETUP_LOOP,           // 18
    issalignIMAGE_EXE_IRIS_ACTIVE,          // 19
    issalignIMAGE_EXE_IRIS_LG_ACTIVE,       // 20
    issalignIMAGE_EXE_IRIS_START_LAG,       // 21
    issalignIMAGE_EXE_IRIS_STOP_LAG,        // 22
    issalignIMAGE_EXE_IRIS_MOD_ZERO_REF,    // 23
    issalignIMAGE_EXE_IRIS_MOD_TADC_USE,    // 24
    issalignIMAGE_INVALID
    } issalignIMG_STATE;

/*
 * Structure and containing the mapping of configured beam number to
 * receiver preocess name.
 * ATTENTION: Ordering according input channel numbers does not work because
 *            allowed channels are 1, 3, 5, and 7.
 */
typedef struct
    {
    vltLOGICAL      configured;
    dbSYMADDRESS    guidingAttr;
    } issalignBeamGuideSysMap;

/*
 * Structure representing a record of the reference position look-up table.
 */
#define issalignREF_PIXEL_MAX_FIELD_NUM     6
typedef struct
    {
    vltBYTES32     beam;
    vltDOUBLE      refX;
    vltDOUBLE      refY;
    vltINT32       startX;
    vltINT32       startY;
    vltINT32       sizeX;
    vltINT32       sizeY;
    } issalignREF_PIXEL_REC;


/*
 * Structure representing a record of the reference position look-up table for
 * the image alignment sensor IRIS.
 */
#define issalignREF_PIX_IRIS_MAX_FIELD_NUM  2
typedef struct
    {
    vltBYTES32     beam;
    vltDOUBLE      refX;
    vltDOUBLE      refY;
    } issalignREF_PIX_IRIS_REC;

typedef struct
    {
    vltDOUBLE      x;
    vltDOUBLE      y;
    } issalignREF_OFFSET_REC;

typedef struct
    {
    vltBYTES8   filter;
    vltDOUBLE   waveLen;
    } issalignIRIS_WLEN;

typedef struct
    {
    issCALC_TADC_IN_DATA    iss;
    vltDOUBLE               tccdWaveLen;
    issalignIRIS_WLEN       irisWaveLen[issalignIRIS_NUM_FILTERS];
    vltDOUBLE               telTargWLen;
    vltDOUBLE               delFntTrkWLen;
    vltDOUBLE               tempCelsius;
    vltDOUBLE               percentHumidity;
    } issalignTADC_IN_DATA;


/*
 * Structure describing current configuration for reference pixel computation
 */
typedef struct
    {
    vltINT32                sensorId;
    vltLOGICAL              ignorePntOffs;
    vltLOGICAL              ignoreTadc;
    issalignREF_PIXEL_REC   refTable[issalignMAX_NUM_ARMS];
    } issalignREF_PIX_CONF;


/*
 * Enumeration for completion status of IRIS image alignment
 */
typedef enum
    {
    issalignIRIS_TIMEOUT,
    issalignIRIS_FAILURE,
    issalignIRIS_SUCCESS
    } issalignIRIS_COMPL_STAT;


/*
 * Structure providing IRIS with information about VLTI configuration and
 * command parameters of image alignment commands
 */
typedef struct
    {
    vltINT32    beam;
    vltLOGICAL  beamActive[issalignMAX_NUM_ARMS];
    vltINT32    inputCh[issalignMAX_NUM_ARMS];
    vltINT32    secInputCh[issalignMAX_NUM_ARMS];
    vltINT32    maxLoops;
    vltDOUBLE   tolerance;
    } issalignIRIS_INFO;


/*
 * Record of IAS instrument configuration table
 */
typedef struct
    {
    vltBYTES32   instrument;
    vltBYTES64   keyword;
    vltDOUBLE    waveLen;
    vltLOGICAL   useKeyword;
    } issalignIAS_INS_RECORD;

/*
 * Enumeration values for zero wavelength to be used
 */
typedef enum
    {
    issalignTADC_USE_INVALID            = -1,
    issalignTADC_USE_FIXED              = 0,
    issalignTADC_USE_TEL_TARG_WLEN,
    issalignTADC_USE_DEL_TARG_WLEN
    } issalignTADC_USE_ZERO_WLEN;


/*
 * Enumeration value for reference pixel computation status (including error
 * codes):
 * Specifies which part of computation raised problems.
 */
typedef enum
    {
    issalignREF_PIX_TAB_UNKNOWN      = 0,
    issalignREF_PIX_ERR_INIT,
    issalignREF_PIX_ERR_CHIP_SIZE,
    issalignREF_PIX_ERR_DOWNLOAD,
    issalignREF_PIX_INIT_OK,
    issalignREF_PIX_DOWNLOADED,
    issalignREF_PIX_ERR_IRIS_LAG,
    issalignREF_PIX_ERR_IRIS_REPLY,
    issalignREF_PIX_ERR_IRIS_TIMEOUT,
    issalignREF_PIX_ERR_IRIS_SEND
    } issalignREF_PIX_TAB_STATUS;

/*
 * Enumeration value for trigger events which cause a re-computation of
 * reference pixels and download to IRIS
 */
typedef enum
    {
    issalignREF_PIX_DL_TRIGGER_TADCFLAG   = 0,
    issalignREF_PIX_DL_TRIGGER_CHREFPX,
    issalignREF_PIX_DL_TRIGGER_TADCMODE,
    issalignREF_PIX_DL_TRIGGER_IAS_CHANGE
    } issalignREF_PIX_DL_TRIGGER;


/*
 * Structure used for ops-logging of reference pixels
 */
typedef struct
    {
    vltLOGICAL      active[issalignMAX_NUM_ARMS];
    vltDOUBLE       refX[issalignMAX_NUM_ARMS];
    vltDOUBLE       refY[issalignMAX_NUM_ARMS];
    } issalignOPSLOGPIX;

/*
 *  Name/value conversion tables:
 */
extern fndNAME_MAP issalignStateNameMap;
extern fndNAME_MAP issalignSubStateNameMap;
extern fndNAME_MAP issalignCommandNameMap;
extern fndNAME_MAP issalignImgCmdStateMap;
extern fndNAME_MAP issalignCommandHandlerMap;
extern fndNAME_MAP issalignSensorNameMap;
extern fndNAME_MAP issalignZeroWlenKeywordMap;
extern fndNAME_MAP issalignDummyReplyMap;
extern fndNAME_MAP issalignRefPixDownloadStatusMap;


// JOT DEBUG to find the reason for the core dump when porting to APR2004
// release
#define JOT_PRINTF_DEBUG 0
#if JOT_PRINTF_DEBUG
    extern int gCallCnt;
    extern FILE *gFile;

    #define DebugEnter(at, object, addr)                                                    \
        ::fprintf(gFile, "DebugEnter -> %s (depth: %d)\n", at, gCallCnt);                   \
        ::fprintf(gFile, "              address of <%s>: %p\n", object, addr);              \
        ::fflush(gFile);                                                                    \
        gCallCnt++;

    #define DebugLeft(at, object, addr)                                                     \
        gCallCnt--;                                                                         \
        ::fprintf(gFile, "DebugLeft  <- %s (depth: %d) \n", at, gCallCnt);                  \
        ::fprintf(gFile, "              address of <%s>: %p\n", object, addr);              \
        ::fflush(gFile);

#else
    #define DebugEnter(a, object, addr) ;
    #define DebugLeft(a, object, addr)  ;
#endif

/**********************************************************/
/* Macro to check whether the currently selected image    */
/* alignment sensor is NONE and if so send a dummy reply  */
/**********************************************************/
#define HANDLE_IAS_NONE(ias, cmdId, msg, retCb)                             \
    if (ias == issalignIAS_NONE_ID)                                         \
        {                                                                   \
        if (msg.SendReply(issalignDummyReplyMap.String(cmdId))              \
            == FAILURE )                                                    \
            {                                                               \
            ErrAdd(issalignMOD, issalignERR_SEND_OK_REPLY, __FILE_LINE__,   \
                   msg.Command());                                          \
            }                                                               \
        return retCb;                                                       \
        }

#endif /* !issalign_H */
