#ifndef issalignREFPIX_MNGR_H
#define issalignREFPIX_MNGR_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: issalignREFPIX_MNGR.h,v 3.17 2005/06/08 13:37:02 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* jott     2004-10-25 SPR VLTSW20040230:
*                     Added members mDbAddress2, mEvent2
*                     Added parameter 'dbAddress2' to constructor,
*                     added parameter 'sensor' to method Backup()
* jott     2004-02-26 ported to APR2004 release
* rrollf    30/01/03  Revisited implementation of reference pixel manager
* rka/awa 2002-11-17  Created
*/

/************************************************************************
 * Header file for class issalignREFPIX_MNGR
 *----------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

/*
 * Include error messages
 */
#include "eccsTestTools.h"
#include "issalignErrors.h"

/*
 * Include parent classes
 */
#include "evhTASK.h"
#include "issalign.h"

class issalignREFPIX_MNGR : public evhTASK
    {
    public:
        issalignREFPIX_MNGR(const dbSYMADDRESS  dbAddress  = NULL,
                            const dbSYMADDRESS  dbAddress2 = NULL);
        virtual ~issalignREFPIX_MNGR(void);

        ccsCOMPL_STAT   Initialize(void);
        ccsCOMPL_STAT   Restore(void);
        ccsCOMPL_STAT   Backup(vltINT32 sensor);

    protected:

    	ccsCOMPL_STAT EnableEvents();
    	ccsCOMPL_STAT DisableEvents();

    	ccsCOMPL_STAT EvtRegister(evtEVENT      *evt,
                                  const char    *dbAttr,
                                  evhCB_METHOD   DbEventCB);

    	ccsCOMPL_STAT EvtDetach(evtEVENT        *evt,
                                evhCB_METHOD     DbEventCB);

    	evhCB_COMPL_STAT EventCB(msgMESSAGE &msg, void *);

    private:

        dbSYMADDRESS    mDbAddress;
        dbSYMADDRESS    mDbAddress2;
	    evtEVENT        mEvent;
	    evtEVENT        mEvent2;

    };


#endif /* !issalignREFPIX_MNGR_H */

/* ___oOo___ */
