#ifndef issarrayDEFINES_H
#define issarrayDEFINES_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: issarrayDefines.h,v 2.26 2005/03/21 13:03:12 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* jott     2005-02-02 SPR VLTSW20050031:
*                     Added definition issarrayTUNNEL_TABLE_NUM_OLD_VERSIONS,
*                     modified issarrayTUNNEL_TABLE_VERSION_STRING,
*                     issarrayTUNNEL_TABLE_MAX_FIELD_NUM
* jott     2005-01-31 SPR VLTSW20050031:
*                     Added definitions issarrayTUNNEL_TABLE_BACKUP_FILE,
*                     issarrayTUNNEL_TABLE_VERSION_STRING,
*                     issarrayTUNNEL_TABLE_MAX_FIELD_NUM
* nhousen  2005-01-28 Added definition issarrayMAX_NUM_DUCTS
* jott     2005-01-11 SPR VLTSW20040399:
*                     Added definitions issarrayMAX_NUM_TESTCONFS,
*                     issarrayCMD_TSTCONF, issarrayCMD_TSTCONF_ID
* jott     2004-09-22 SPR VLTSW20040225:
*                     Added definitions issarrayDB_IRIS_CONF_STATUS,
*                     issarrayIAS_BACKUP_FILE
* jott     2004-08-19 SPR VLTSW20040225:
*                     Added definitions issarrayDB_POINT_IRIS,
*                     issarrayDB_ATTR_NAME_IAS, issarrayCMD_GETIAS,
*                     issarrayCMD_SETIAS,  issarraySEND_SETIRIS_ID,
*                     issarraySEND_CLRIRIS, issarrayCMD_SETIRIS,
*                     issarrayCMD_CLRIRIS, issarrayIRIS_GUIDE_MODE_xxx,
*                     issarrayIRIS_FEED_MODE_xxx, issarrayIRIS_MAX_USED_INPUT_CH,
*                     issarrayDB_IRIS_CONF_TABLE
* jott     2004-02-12 Added support for delay lines 4 to 6 (SPR VLTSW20030502)
* jott      02/04/03  Added definitions for M16 positions issarrayM16_XXXX to
*                     solve SPR VLTSW20020683
* rrollf    06/03/03  Added definition for CLRREQ command and synchMngr db point
* jott      15/10/02  added definition issarrayCMD_GETPUP for get pupil position
*                     command
* jott      01/08/02  added definitions for database attributes (look-up tables)
*                     used for pupil calculation
*                     added telescope type definitions
* jott      08/04/02  mapped issarrayDB_DATA_POINT and issarrayCONF_TABLE_NAME to
*                     corresponding definitions of module iss
* jott      21/02/02  added definitions issarrayPOINT_MODEL_xxx to solve SPR
*                     VLTSW20020013
* jott      13/12/01  mapped definitions issarrayRECNUM_STAT_XX to
*                     issSTATION_XX_ID definitions
* jott      06/11/01  removed definition issarrayTELESCOPE_COMMON_W_COORDINATE
*                     due introduction of W coordinate in nominal station centre
*                     added definitions issarrayQUERY_CMD_TIMEOUT,
*                     issarrayCMD_GETDEL, issarrayGETDEL_BUF_SIZE,
*                     issarrayDEL_STR_LEN, and issarrayDEL_STR_PREFIX.
*                     (SPR VLTSW20010634)
* jott      27/07/01  added definition issarrayUT_FOCUS_COUDE
* jott      19/07/01  added some definitions to solve SPR VLTSW20010322
* jott      28/06/01  code reviewed
* jott      30/04/01  third version (Version 1 of ISS)
* jott      05/04/01  intermediate version
* jott      20/02/01  second version
* jott      20/12/00  first version
* jott      11/12/00  created
*/

/************************************************************************
 * Header file containing definitions which are common to the issarray
 * module
 *----------------------------------------------------------------------
 */
#include "evhStates.h"
#include "mswDefines.h"
#include "iss.h"

/*
 * File name suffix for saving array configuration table
 */
#define issarrayCONF_BACKUP_FILE        "IssarrayConfTable.dat"

/*
 * File name suffix for saving Image Alignment Sensor configuration
 */
#define issarrayIAS_BACKUP_FILE         "IssarrayIasCfg.dat"

/*
 * Use CDT or skip it
 * ATTENTION: Setting this value to FALSE may be dangerous because the
 * issarrayControl process relies on a correct command and parameter syntax !!
 */
#define  issarrayCONTROL_USE_CDT        ccsTRUE

/*
 *  Timeout in seconds for Query commands to DLCS (GETDEL)
 */
#define  issarrayQUERY_CMD_TIMEOUT      10

/*
 *  Size of Buffer to store the reply of GETDEL command to DLCS
 */
#define  issarrayGETDEL_BUF_SIZE       128

/*
 *  String length of the delay lines keywords in the reply buffer of GETDEL
 *  command. (currently "dlX")
 */
#define  issarrayDEL_STR_LEN             3

/*
 * Prefix of the delay lines keywords in the reply buffer of GETDEL
 *  command. (currently "dlX")
 */
#define  issarrayDEL_STR_PREFIX          "dl"


/*
 * Module name and database branch definitions
 */
#define issarrayMOD                     "issarray"
#define issarrayDB_BASE_POINT           "issarray"
#define issarrayDB_CONTROL_POINT        "control"
#define issarrayDB_DATA_POINT           issARRAY_DB_DATA_POINT
#define issarrayDB_DEST_LIST_POINT      "Sid1"
#define issarrayDB_TABLE_MNGR_POINT     "TableMngr"
#define issarrayDB_SYNCH_MNGR_POINT     "synchMngr"
#define issarrayDB_SUBSTATE_NAME        "subState"
#define issarrayDB_VERBOSE_NAME         "verbose"
#define issarrayDB_PARAM_POINT          "parameter"
#define issarrayDB_NAME_ATTR_NUMTEL     "numTelescopes"
#define issarrayDB_NAME_ATTR_TELSTRING  "telescopeString"
#define issarrayCONF_TABLE_NAME         issARRAY_CONF_TABLE_NAME
#define issarrayDB_POINT_IRIS           "iris"
#define issarrayDB_ATTR_NAME_IAS        issIMAGE_ALIGN_SENSOR_ATTR_NAME
#define issarrayDB_IRIS_CONF_TABLE      "channelConf"
#define issarrayDB_IRIS_CONF_STATUS     "irisConfStatus"

/*
 * Database attributes for pupil calculation look-up tables
 */
#define issarrayDB_ATTR_LKUP_UT_PUP_BEFORE_DL   "parameter.UTPupilBeforeDL"
#define issarrayDB_ATTR_LKUP_TEL_PUP            "parameter.dTelPup"
#define issarrayDB_ATTR_LKUP_PUP_REF_POS_OUT    "parameter.PupRefPosOut"


/*
 * Definitions for issarray substates
 */
/* The first set is defined in a way to be compatible with evh  */
#define issarraySUBSTATE_UNK             evhSTATE_UNK
#define issarraySUBSTATE_OFF             evhSTATE_OFF
#define issarraySUBSTATE_LOADED          evhSTATE_LOADED
#define issarraySUBSTATE_STANDBY         evhSTATE_STANDBY
#define issarraySUBSTATE_ONLINE          evhSTATE_ONLINE
#define issarraySUBSTATE_READY           evhSTATE_READY
#define issarraySUBSTATE_ERROR           evhSTATE_ERROR
#define issarraySUBSTATE_IDLE            evhSTATE_IDLE
#define issarraySUBSTATE_WAITING         evhSTATE_WAITING
#define issarraySUBSTATE_BUSY            evhSTATE_BUSY
#define issarraySUBSTATE_Q_CHECK         evhSTATE_Q_CHECK
#define issarraySUBSTATE_STANDALONE      evhSTATE_STANDALONE
/* Special substates used by issarray                           */
#define issarraySUBSTATE_CONFIGURE       30
#define issarraySUBSTATE_INITIALIZING    31
#define issarraySUBSTATE_TERMINATED      33


/*
 * Name strings for the substate names
 */
/* The first set is defined in a way to be compatible with evh  */
#define issarraySUBSTATE_STR_UNK             "UNKNOWN"
#define issarraySUBSTATE_STR_OFF             "OFF"
#define issarraySUBSTATE_STR_LOADED          "LOADED"
#define issarraySUBSTATE_STR_STANDBY         "STANDBY"
#define issarraySUBSTATE_STR_ONLINE          "ONLINE"
#define issarraySUBSTATE_STR_READY           "READY"
#define issarraySUBSTATE_STR_ERROR           "ERROR"
#define issarraySUBSTATE_STR_IDLE            "IDLE"
#define issarraySUBSTATE_STR_WAITING         "WAITING"
#define issarraySUBSTATE_STR_BUSY            "BUSY"
#define issarraySUBSTATE_STR_Q_CHECK         "QUEUE_CHECK"
#define issarraySUBSTATE_STR_STANDALONE      "STANDALONE"
/* Special substates used by issarray                           */
#define issarraySUBSTATE_STR_CONFIGURE       "CONFIGURING"
#define issarraySUBSTATE_STR_INITIALIZING    "INITIALIZING"

/*
 * Maximum number of commands which silmultaneously can be proccesed
 */
#define issarrayMAX_CMD_IN_PROGRESS      50

/*
 * Maximum number of M11 telescope mirrors
 */
#define issarrayMAX_NUM_M11              9

/*
 * Maximum number of telescope stations
 */
#define issarrayMAX_NUM_STATIONS         34

/*
 * Maximum number of light ducts (connecting stations to the tunnel)
 */
#define issarrayMAX_NUM_DUCTS            16

/*
 * Highest field number of M12 and light covers table
 */
#define issarrayTUNNEL_TABLE_MAX_FIELD_NUM   10

/*
 * Name of backup file for M12 and light covers table data
 * (without environment specific prefic)
 */
#define issarrayTUNNEL_TABLE_BACKUP_FILE  "IssarrayTunnelTable.dat"

/*
 * Version string for M12 and light covers table backup file
 */
#define issarrayTUNNEL_TABLE_VERSION_STRING "Version_2"

/*
 * Number of old backup version strings
 */
#define issarrayTUNNEL_TABLE_NUM_OLD_VERSIONS   1

/*
 * Maximum number of delay lines
 */
#define issarrayMAX_NUM_DELAY_LINES      issNUM_PHYSICAL_DL

/*
 * Maximum number of lab input channels
 */
#define issarrayMAX_NUM_INPUT_CHANNELS   8

/*
 * Maximum number of interferometric arms
 */
#define issarrayMAX_NUM_ARMS             issMAX_NUM_ARMS

/*
 * Value indicating that the UT focus is set to Coud
 */
#define issarrayUT_FOCUS_COUDE           mswCOUDE_FOCUS

/*
 * Maximum number of processes the PING commands can be sent to
 */
#define issarrayMAX_NUM_PING             16

/*
 * Database root point for the mode switching table
 */
#define issarrayMSW_TABLE_POINT         ":Appl_data:VLTI:issmsw:list"

/*
 * Command definitions
 */
#define issarrayCMD_GETARR                  "GETARR"
#define issarrayCMD_GETCONF                 "GETCONF"
#define issarrayCMD_SETARR                  "SETARR"
#define issarrayCMD_SETCONF                 "SETCONF"
#define issarrayCMD_GETOPL0                 "GETOPL0"
#define issarrayCMD_DISARM                  "DISARM"
#define issarrayCMD_GETPUP                  "GETPUP"
#define issarrayCMD_GETIAS                  "GETIAS"
#define issarrayCMD_SETIAS                  "SETIAS"
#define issarrayCMD_TSTCONF                 "TSTCONF"

/* Commands sent by issarray                                    */
#define issarrayCMD_CLRREQ                  "CLRREQ"
#define issarrayCMD_SETREQ                  "SETREQ"
#define issarrayCMD_GETDEL                  "GETDEL"
#define issarrayCMD_SETDEL                  "SETDEL"
#define issarrayCMD_SETDELD                 "SETDELD"
#define issarrayCMD_PING                    "PING"
#define issarrayCMD_SETIRIS                 "SETIRIS"
#define issarrayCMD_CLRIRIS                 "CLRIRIS"
/* indicator for startup (no real command) received by issarray */
#define issarrayCMD_STARTUP                 "STARTUP"

/*
 * Identifiers for configuration commands
 */
#define issarrayCMD_SETARR_ID               1
#define issarrayCMD_SETCONF_ID              2
#define issarrayCMD_DISARM_ID               3
#define issarrayCMD_STARTUP_ID              4
#define issarrayCMD_INIT_ID                 5
#define issarrayCMD_ONLINE_ID               6
#define issarrayCMD_TSTCONF_ID              7

/*
 * Identifiers for commands sent by issarrayControl
 */
#define issarraySEND_SETDELD_ID             20
#define issarraySEND_PING_ID                21
#define issarraySEND_SETDEL_ID              22
#define issarraySEND_SYNCHMSW_ID            23
#define issarraySEND_SETIRIS_ID             24
#define issarraySEND_CLRIRIS_ID             25

/*
 * Required reply buffer size for GETARR/GETCONF commands
 */
#define issarrayMIN_BUF_LEN_CONF_SHORT      30
#define issarrayMIN_BUF_LEN_CONF_COMPLETE   140

/*
 * Definitions for the record numbers of parameters
 * given in the look-up tables
 */
#define issarrayRECNUM_UT1                  0
#define issarrayRECNUM_UT2                  1
#define issarrayRECNUM_UT3                  2
#define issarrayRECNUM_UT4                  3
#define issarrayRECNUM_AT1                  4
#define issarrayRECNUM_AT2                  5
#define issarrayRECNUM_AT3                  6
#define issarrayRECNUM_SID1                 7
#define issarrayRECNUM_SID2                 8

#define issarrayRECNUM_STAT_A0              issSTATION_A0_ID - 1
#define issarrayRECNUM_STAT_A1              issSTATION_A1_ID - 1
#define issarrayRECNUM_STAT_B0              issSTATION_B0_ID - 1
#define issarrayRECNUM_STAT_B1              issSTATION_B1_ID - 1
#define issarrayRECNUM_STAT_B2              issSTATION_B2_ID - 1
#define issarrayRECNUM_STAT_B3              issSTATION_B3_ID - 1
#define issarrayRECNUM_STAT_B4              issSTATION_B4_ID - 1
#define issarrayRECNUM_STAT_B5              issSTATION_B5_ID - 1
#define issarrayRECNUM_STAT_C0              issSTATION_C0_ID - 1
#define issarrayRECNUM_STAT_C1              issSTATION_C1_ID - 1
#define issarrayRECNUM_STAT_C2              issSTATION_C2_ID - 1
#define issarrayRECNUM_STAT_C3              issSTATION_C3_ID - 1
#define issarrayRECNUM_STAT_D0              issSTATION_D0_ID - 1
#define issarrayRECNUM_STAT_D1              issSTATION_D1_ID - 1
#define issarrayRECNUM_STAT_D2              issSTATION_D2_ID - 1
#define issarrayRECNUM_STAT_E0              issSTATION_E0_ID - 1
#define issarrayRECNUM_STAT_G0              issSTATION_G0_ID - 1
#define issarrayRECNUM_STAT_G1              issSTATION_G1_ID - 1
#define issarrayRECNUM_STAT_G2              issSTATION_G2_ID - 1
#define issarrayRECNUM_STAT_H0              issSTATION_H0_ID - 1
#define issarrayRECNUM_STAT_I1              issSTATION_I1_ID - 1
#define issarrayRECNUM_STAT_J1              issSTATION_J1_ID - 1
#define issarrayRECNUM_STAT_J2              issSTATION_J2_ID - 1
#define issarrayRECNUM_STAT_J3              issSTATION_J3_ID - 1
#define issarrayRECNUM_STAT_J4              issSTATION_J4_ID - 1
#define issarrayRECNUM_STAT_J5              issSTATION_J5_ID - 1
#define issarrayRECNUM_STAT_J6              issSTATION_J6_ID - 1
#define issarrayRECNUM_STAT_K0              issSTATION_K0_ID - 1
#define issarrayRECNUM_STAT_L0              issSTATION_L0_ID - 1
#define issarrayRECNUM_STAT_M0              issSTATION_M0_ID - 1
#define issarrayRECNUM_STAT_U1              issSTATION_U1_ID - 1
#define issarrayRECNUM_STAT_U2              issSTATION_U2_ID - 1
#define issarrayRECNUM_STAT_U3              issSTATION_U3_ID - 1
#define issarrayRECNUM_STAT_U4              issSTATION_U4_ID - 1

#define issarrayRECNUM_DL_1                 0
#define issarrayRECNUM_DL_2                 1
#define issarrayRECNUM_DL_3                 2
#define issarrayRECNUM_DL_4                 3
#define issarrayRECNUM_DL_5                 4
#define issarrayRECNUM_DL_6                 5


#define issarrayRECNUM_INPUT_1              0
#define issarrayRECNUM_INPUT_2              1
#define issarrayRECNUM_INPUT_3              2
#define issarrayRECNUM_INPUT_4              3
#define issarrayRECNUM_INPUT_5              4
#define issarrayRECNUM_INPUT_6              5
#define issarrayRECNUM_INPUT_7              6
#define issarrayRECNUM_INPUT_8              7

/*
 * Name of the attribute containing the V coordinate of
 * the reference plane at the switchyard entrance
 */
#define issarrayREF_PLANE_NAME              "refPlaneVCoord"

/*
 * Enumeration values for Pointing models which are allowed by the CDT
 * as OPDModel parameters in SETARR or SETCONF commands
 */
#define issarrayPOINT_MODEL_NONE            "NONE"
#define issarrayPOINT_MODEL_DEFAULT         "DEFAULT"


/*
 * Definitions for telescope types
 */
#define issarrayTELESCOPE_TYPE_NONE          0
#define issarrayTELESCOPE_TYPE_UT            1
#define issarrayTELESCOPE_TYPE_AT            2
#define issarrayTELESCOPE_TYPE_SID           3

/*
 * Define the maximum length of the configuration string used for
 * synchronization with msw at init sequence
 */
#define issarrayMAX_LEN_CFG_STR 200


/*
 * Definitions for M16 positions
 */
#define  issarrayM16_UNDEFINED  0
#define  issarrayM16_1_I        1
#define  issarrayM16_1_S        2
#define  issarrayM16_2_I        3
#define  issarrayM16_2_S        4
#define  issarrayM16_3_I        5
#define  issarrayM16_3_S        6
#define  issarrayM16_4_I        7
#define  issarrayM16_4_S        8


/*
 * Definitions for IRIS guiding modes
 */
#define  issarrayIRIS_GUIDE_MODE_AG         "AG"
#define  issarrayIRIS_GUIDE_MODE_FS         "FS"
#define  issarrayIRIS_GUIDE_MODE_PRIMA_S    "PRIMA_S"
#define  issarrayIRIS_GUIDE_MODE_PRIMA_D    "PRIMA_D"

/*
 * Definitions for IRIS feeding modes
 */
#define issarrayIRIS_FEED_MODE_SINGLE       "SINGLE"
#define issarrayIRIS_FEED_MODE_PRIMARY      "PRIMARY"
#define issarrayIRIS_FEED_MODE_SECONDARY    "SECONDARY"

/*
 * Number of VLTI input channels which can be aligned by IRIS
 */
#define issarrayIRIS_MAX_USED_INPUT_CH      5


/*
 * Maximum number od VLTI test configurations stored in a database table
 */
#define issarrayMAX_NUM_TESTCONFS           10

#endif /* !issarrayDEFINES_H */

/* __oOo__ */
