#ifndef issarraySYNCH_MNGR_H
#define issarraySYNCH_MNGR_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: issarraySYNCH_MNGR.h,v 2.26 2005/03/21 13:03:14 vltsccm Exp $"
*
* who       when        what
* --------  ----------  ----------------------------------------------
* jott      2003-04-02  Added class destructor
* rrollf    2003-03-05  Created (see SPR VLTSW20020539)
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

/*
 * Include error messages
 */
#include "eccsTestTools.h"
#include "issarrayErrors.h"

/*
 * Include parent classes
 */
#include "db.h"
#include "evhStates.h"
#include "evhTASK.h"
#include "evhDB_COMMAND.h"
#include "issarray.h"


class issarraySYNCH_MNGR : public evhTASK
    {
    public:

        issarraySYNCH_MNGR(const dbSYMADDRESS  dbPoint);
        ~issarraySYNCH_MNGR(void);

        virtual ccsCOMPL_STAT       Initialize(void);
        virtual ccsCOMPL_STAT       Reset(void);

        ccsCOMPL_STAT   Install(evhCALLBACK &replyCb,
                                evhCALLBACK &errorCb,
                                evhCALLBACK &timeoutCb,
                                vltUINT32    timeout);

        ccsCOMPL_STAT   Run(const char *configString,
                            vltUINT16  &currMsgId);

    protected:

        virtual evhCB_COMPL_STAT    ReplyCB(msgMESSAGE &msg, void *udata);
        virtual evhCB_COMPL_STAT    CompletedCB(msgMESSAGE &msg, void *udata);
        virtual evhCB_COMPL_STAT    ErrorCB(msgMESSAGE &msg, void *udata);
        virtual evhCB_COMPL_STAT    TimeoutCB(msgMESSAGE &msg, void *udata);


                ccsCOMPL_STAT       SendClrReq(void);
                ccsCOMPL_STAT       SendSetReq(void);

    private:
        evhDB_COMMAND           mSendCmd;

        /* Callback to install */
        evhCALLBACK            *mUserCompletedCB;
        evhCALLBACK            *mUserErrorCB;
        evhCALLBACK            *mUserTimeoutCB;

        /* Timeout for commands to issmswControl */
        vltUINT32               mTimeout;

        /* Message of the command */
        msgMESSAGE              mSendMsg;

        /* Synchronization message identifier */
        vltUINT16               mSynchMsgId;

        /* Current object state */
        vltINT32                mState;

        /* Configuration string to be sent to msw */
        char                    mConfigString[issarrayMAX_LEN_CFG_STR + 1];

    };


#endif /* !issarraySYNCH_MNGR_H */
