#ifndef issarrayTUNNEL_TABLE_MNGR_H
#define issarrayTUNNEL_TABLE_MNGR_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: issarrayTUNNEL_TABLE_MNGR.h,v 2.26 2005/03/21 13:03:15 vltsccm Exp $"
*
* who       when        what
* --------  ----------  ----------------------------------------------
* jott      2005-03-18  Added methods MatchesDlAndM12Station() and
*                       StationHasTwoCovers()
* jott      2005-02-02  Added parameters to method CheckM12Configuration()
* jott      2005-01-31  Created
*/

/************************************************************************
 * Header file for class issarrayTUNNEL_TABLE_MNGR
 *----------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

/*
 * Include error messages
 */
#include "eccsTestTools.h"
#include "issarrayErrors.h"

/*
 * Include parent classes
 */
#include "db.h"
#include "eccsEvt.h"
#include "evhTASK.h"
#include "issarrayDefines.h"
#include "issarray.h"

class issarrayTUNNEL_TABLE_MNGR : public evhTASK
    {
    public:
        issarrayTUNNEL_TABLE_MNGR(const dbSYMADDRESS  dbAddress = NULL);
        virtual ~issarrayTUNNEL_TABLE_MNGR(void);

        ccsCOMPL_STAT   Initialize(void);
        ccsCOMPL_STAT   Restore(void);
        ccsCOMPL_STAT   Backup(void);
        ccsCOMPL_STAT   CheckM12Configuration(msgMESSAGE   *cmd,
                                              vltBYTES32    station,
                                              vltINT32      dlId,
                                              vltLOGICAL    *startupWarningLogged);


    protected:
    	ccsCOMPL_STAT EnableEvents();
    	ccsCOMPL_STAT DisableEvents();

    	ccsCOMPL_STAT EvtRegister(evtEVENT      *evt,
                                  const char    *dbAttr,
                                  evhCB_METHOD   DbEventCB);

    	ccsCOMPL_STAT EvtDetach(evtEVENT        *evt,
                                evhCB_METHOD     DbEventCB);

    	evhCB_COMPL_STAT EventCB(msgMESSAGE &msg, void *);

    private:
        vltLOGICAL  MatchesDlAndM12Station(int dlIndexInM12Table,
                                           int stationRecord);
        vltLOGICAL  StationHasTwoCovers(int stationRecord);

        dbSYMADDRESS            mDbAddress;
	    evtEVENT                mEvent;
        issarrayTUNNEL_RECORD   mTunnelTable[issarrayMAX_NUM_DUCTS];

    };


#endif /* !issarrayTUNNEL_TABLE_MNGR_H */

/* ___oOo___ */
