#ifndef issifDEFINES_H
#define issifDEFINES_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: issifDefines.h,v 2.35 2005/06/07 14:02:25 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* jott     2005-06-06 SPR VLTSW20040333: Added definitions issifDATA_ISS_PBLAxx
*                     for projected baseline angles
* jott     2005-02-16 Added named data items for MACAO (SPR VLTSW20050036)
*                     added definition issifMAX_REC_NAMED_DATA
* jott     2005-01-25 Added named data items for IRIS (SPR VLTSW20050014)
* jott     2005-01-17 Added definition issifDATA_IAS_SELECTED (SPR VLTSW20040225)
* jott     2005-01-10 Added definition issifDATA_ASM_LRATE (SPR VLTSW20040415)
* jott     2004-06-23 Added definition issifDATA_CHOP_GUIDE (SPR VLTSW20040164)
* awalland 2003-11-02 Removed "dirty" character on line 338
* rrollf    11/08/03  Added support pupil rotation per beam as public data
*                     (SPR VLTSW20030273)
* jott      26/06/03  Added support image rotation per beam as public data
*                     (SPR VLTSW20030273)
* rrollf    12/05/03  Removed issifDATA_FRINGES, Added issifDATA_DL_MOTION_PHASE
*                     Added definitions for motionPhase
* jott      03/04/03  added definition issifDATA_DL_REFBEAM to solve SPR
*                     VLTSW20030106
* jott      23/10/02  added definitin issifDATA_CURR_SLOT
* jott      17/10/02  added definition issifDATA_TCCD_GUV_SCALE
*                     added definitions issifDATA_AMBI_PRES,
*                     issifDATA_AMBI_TEMPDEW, issifDATA_REF_DEC, and
*                     issifDATA_REF_RA (SPR VLTSW20020567)
* jott      23/09/02  mapped issifDATA_ASM_TAU0 to value of tifDATA_ASM_TAU0
*                     in tif version 1.135
*                     (additional ASM datum tau0)
* jott      09/08/02  updated definitions when splitting the two
*                     FITS binary tables into three (SPR VLTSW20020438)
* jott      05/08/02  added definitions for missing named data items to align
*                     to ICD 2/prep.3 (VLT-ICD-ESO-15410-2117) and mapping
*                     of FINITO tracking modes and channel selections.
* jott      06/05/02  added named data item issifDATA_DL_FRINGE_SENSOR
*                     for used fringe sensor
* jott      19/11/01  added named data items issifDATA_ISS_PBL12,
*                     issifDATA_ISS_PBL13, and issifDATA_ISS_PBL23
*                     (SPR VLTSW20010671)
* jott      04/10/01  removed definitions  "issifSTATE" and "issifSUBSTATE".
*                     Should be replaced by "issVLTI_GLOBAL_STATE" and
*                     "issVLTI_SUBSTATE".
* jott      03/09/01  Moved definitions from issif.h to here
*                     Added issifDATA_DIFF_TRAK_RA and issifDATA_DIFF_TRAK_DEC
* jott      02/08/01  Changed definition issifSUBSTATE from "issmsw.substate"
*                     to "issmsw.subState"
* jott      25/05/01  Added definitions for the header keywords of the
*                     FITS binary tables
* jott      14/05/01  Removed definition issifMAX_NUM_ARMS (use should
*                     be made directly of issMAX_NUM_ARMS)
*                     Added definitions issifSTART_FITS_CMD, and
*                     issifSTOP_FITS_CMD
* jott      30/04/01  third version (Version 1 of ISS)
* jott      05/04/01  intermediate version
* jott      20/02/01  second version
* jott      20/12/00  first version
* jott      07/11/00  created
*/

/************************************************************************
 * This file contains common definitions for the issif module used both
 * by C/C++ files and dbLoader files
 *----------------------------------------------------------------------
 */

#include "fntpubDefines.h"


/*
 * Module name
 */
#define issifMOD  "issif"

/*
 * Replaces tifMAX_NAMES_RECS because issif may require a larger named data
 * item table than tif (especially when inlcuding PRIMA)
 *  NOTE: This definition affects only the named data item table. For the event
 *        table tifMAX_NAMES_RECS is still used and more than sufficient!!
 */
#define issifMAX_REC_NAMED_DATA  200

/*
 *  Commands to start/stop FITS binary data collection
 */
#define issifSTART_FITS_CMD             "STARTEX"
#define issifSTOP_FITS_CMD              "ENDEX"


/*
 * Timeout for the START/STOP FITS data collection commands
 */
#define issifFITS_CMD_TIMEOUT           60  /* seconds */

/*
 * Defines for named data items (see issifGetByName)
 * These defines allow to select data items to be read by name.
 * A database table contains the mapping from names to database
 * symbolic address and data types.
 */
#define issifDATA_VERSION               "issifDATA_VERSION"
#define issifDATA_RELEASE               "issifDATA_RELEASE"
#define issifDATA_LST                   "issifDATA_LST"
#define issifDATA_UTC                   "issifDATA_UTC"
#define issifDATA_HA                    "issifDATA_HA"
#define issifDATA_RA                    "issifDATA_RA"
#define issifDATA_DEC                   "issifDATA_DEC"
#define issifDATA_RA2000                "issifDATA_RA2000"
#define issifDATA_DEC2000               "issifDATA_DEC2000"
#define issifDATA_RA2000DEG             "issifDATA_RA2000DEG"
#define issifDATA_DEC2000DEG            "issifDATA_DEC2000DEG"
#define issifDATA_ALT                   "issifDATA_ALT"
#define issifDATA_AZ                    "issifDATA_AZ"
#define issifDATA_AIRMASS               "issifDATA_AIRMASS"
#define issifDATA_WAVELEN               "issifDATA_WAVELEN"
#define issifDATA_PRLTIC                "issifDATA_PRLTIC"
#define issifDATA_DIFF_TRAK_RA          "issifDATA_DIFF_TRAK_RA"
#define issifDATA_DIFF_TRAK_DEC         "issifDATA_DIFF_TRAK_DEC"
#define issifDATA_IMAGEROT_BEAM1        "issifDATA_IMAGEROT_BEAM1"
#define issifDATA_IMAGEROT_BEAM2        "issifDATA_IMAGEROT_BEAM2"
#define issifDATA_IMAGEROT_BEAM3        "issifDATA_IMAGEROT_BEAM3"
#define issifDATA_PUPILROT_BEAM1        "issifDATA_PUPILROT_BEAM1"
#define issifDATA_PUPILROT_BEAM2        "issifDATA_PUPILROT_BEAM2"
#define issifDATA_PUPILROT_BEAM3        "issifDATA_PUPILROT_BEAM3"
#define issifDATA_TRACK                 "issifDATA_TRACK"
#define issifDATA_REMTIME               "issifDATA_REMTIME"
#define issifDATA_CGS_WAVELEN           "issifDATA_CGS_WAVELEN"
#define issifDATA_CGS_MAGNITUDE         "issifDATA_CGS_MAGNITUDE"
#define issifDATA_CGS_RA2000            "issifDATA_CGS_RA2000"
#define issifDATA_CGS_DEC2000           "issifDATA_CGS_DEC2000"
#define issifDATA_CGS_MODE              "issifDATA_CGS_MODE"
#define issifDATA_AG_STATUS             "issifDATA_AG_STATUS"
#define issifDATA_CHOP_STATUS           "issifDATA_CHOP_STATUS"
#define issifDATA_CHOP_STRT_TIME        "issifDATA_CHOP_STRT_TIME"
#define issifDATA_CHOP_FREQ             "issifDATA_CHOP_FREQ"
#define issifDATA_CHOP_THROW            "issifDATA_CHOP_THROW"
#define issifDATA_CHOP_PVR              "issifDATA_CHOP_PVR"
#define issifDATA_CHOP_POSANG           "issifDATA_CHOP_POSANG"
#define issifDATA_CHOP_GUIDE            "issifDATA_CHOP_GUIDE"
#define issifDATA_ASM_WINDSPEED         "issifDATA_ASM_WINDSPEED"
#define issifDATA_ASM_WINDDIR           "issifDATA_ASM_WINDDIR"
#define issifDATA_ASM_HUMIDITY          "issifDATA_ASM_HUMIDITY"
#define issifDATA_ASM_SEEING            "issifDATA_ASM_SEEING"
#define issifDATA_ASM_TEMP              "issifDATA_ASM_TEMP"
#define issifDATA_ASM_SEISMIC           "issifDATA_ASM_SEISMIC"
#define issifDATA_ASM_TAU0              "issifDATA_ASM_TAU0"
#define issifDATA_ASM_LRATE             "issifDATA_ASM_LRATE"
#define issifDATA_LONGI                 "issifDATA_LONGI"
#define issifDATA_LATI                  "issifDATA_LATI"
#define issifDATA_LEVEL                 "issifDATA_LEVEL"
#define issifDATA_DL1OPL                "issifDATA_DL1OPL"
#define issifDATA_DL2OPL                "issifDATA_DL2OPL"
#define issifDATA_DL3OPL                "issifDATA_DL3OPL"
#define issifDATA_DLREF                 "issifDATA_DLREF"
#define issifDATA_DLREFOPL              "issifDATA_DLREFOPL"
#define issifDATA_DL_FRINGE_SENSOR      "issifDATA_DL_FRINGE_SENSOR"
#define issifDATA_DL_MOTION_PHASE       "issifDATA_DL_MOTION_PHASE"
#define issifDATA_FNT_TRK_MODE          "issifDATA_FNT_TRK_MODE"
#define issifDATA_FNT_CH_SEL            "issifDATA_FNT_CH_SEL"
#define issifDATA_FNT_PH_MEAN_1         "issifDATA_FNT_PH_MEAN_1"
#define issifDATA_FNT_PH_MEAN_2         "issifDATA_FNT_PH_MEAN_2"
#define issifDATA_FNT_PH_RMS_1          "issifDATA_FNT_PH_RMS_1"
#define issifDATA_FNT_PH_RMS_2          "issifDATA_FNT_PH_RMS_2"
#define issifDATA_FNT_COH_MEAN_1        "issifDATA_FNT_COH_MEAN_1"
#define issifDATA_FNT_COH_MEAN_2        "issifDATA_FNT_COH_MEAN_2"
#define issifDATA_FNT_COH_RMS_1         "issifDATA_FNT_COH_RMS_1"
#define issifDATA_FNT_COH_RMS_2         "issifDATA_FNT_COH_RMS_2"
#define issifDATA_FNT_VIS_MEAN_1        "issifDATA_FNT_VIS_MEAN_1"
#define issifDATA_FNT_VIS_MEAN_2        "issifDATA_FNT_VIS_MEAN_2"
#define issifDATA_FNT_VIS_RMS_1         "issifDATA_FNT_VIS_RMS_1"
#define issifDATA_FNT_VIS_RMS_2         "issifDATA_FNT_VIS_RMS_2"
#define issifDATA_NUMOFTEL              "issifDATA_NUMOFTEL"
#define issifDATA_TELESCOP              "issifDATA_TELESCOP"
#define issifDATA_T1NAME                "issifDATA_T1NAME"
#define issifDATA_T1STATION             "issifDATA_T1STATION"
#define issifDATA_T1DL                  "issifDATA_T1DL"
#define issifDATA_T1INPUT               "issifDATA_T1INPUT"
#define issifDATA_T1SWYARD              "issifDATA_T1SWYARD"
#define issifDATA_T1INPUT2              "issifDATA_T1INPUT2"
#define issifDATA_T1SWYARD2             "issifDATA_T1SWYARD2"
#define issifDATA_T1X                   "issifDATA_T1X"
#define issifDATA_T1Y                   "issifDATA_T1Y"
#define issifDATA_T1Z                   "issifDATA_T1Z"
#define issifDATA_T2NAME                "issifDATA_T2NAME"
#define issifDATA_T2STATION             "issifDATA_T2STATION"
#define issifDATA_T2DL                  "issifDATA_T2DL"
#define issifDATA_T2INPUT               "issifDATA_T2INPUT"
#define issifDATA_T2SWYARD              "issifDATA_T2SWYARD"
#define issifDATA_T2INPUT2              "issifDATA_T2INPUT2"
#define issifDATA_T2SWYARD2             "issifDATA_T2SWYARD2"
#define issifDATA_T2X                   "issifDATA_T2X"
#define issifDATA_T2Y                   "issifDATA_T2Y"
#define issifDATA_T2Z                   "issifDATA_T2Z"
#define issifDATA_T3NAME                "issifDATA_T3NAME"
#define issifDATA_T3STATION             "issifDATA_T3STATION"
#define issifDATA_T3DL                  "issifDATA_T3DL"
#define issifDATA_T3INPUT               "issifDATA_T3INPUT"
#define issifDATA_T3SWYARD              "issifDATA_T3SWYARD"
#define issifDATA_T3INPUT2              "issifDATA_T3INPUT2"
#define issifDATA_T3SWYARD2             "issifDATA_T3SWYARD2"
#define issifDATA_IAS_SELECTED          "issifDATA_IAS_SELECTED"
#define issifDATA_T3X                   "issifDATA_T3X"
#define issifDATA_T3Y                   "issifDATA_T3Y"
#define issifDATA_T3Z                   "issifDATA_T3Z"
#define issifDATA_TEMPLAB1              "issifDATA_TEMPLAB1"
#define issifDATA_TEMPLAB2              "issifDATA_TEMPLAB2"
#define issifDATA_TEMPLAB3              "issifDATA_TEMPLAB3"
#define issifDATA_TEMPLAB4              "issifDATA_TEMPLAB4"
#define issifDATA_TEMPTUN1              "issifDATA_TEMPTUN1"
#define issifDATA_TEMPTUN2              "issifDATA_TEMPTUN2"
#define issifDATA_TEMPTUN3              "issifDATA_TEMPTUN3"
#define issifDATA_TEMPTUN4              "issifDATA_TEMPTUN4"
#define issifDATA_ISS_PBL12             "issifDATA_ISS_PBL12"
#define issifDATA_ISS_PBL13             "issifDATA_ISS_PBL13"
#define issifDATA_ISS_PBL23             "issifDATA_ISS_PBL23"
#define issifDATA_ISS_PBLA12            "issifDATA_ISS_PBLA12"
#define issifDATA_ISS_PBLA13            "issifDATA_ISS_PBLA13"
#define issifDATA_ISS_PBLA23            "issifDATA_ISS_PBLA23"
#define issifDATA_LEO_LAMP              "issifDATA_LEO_LAMP"
#define issifDATA_LEO_OPTI1_NAME        "issifDATA_LEO_OPTI1_NAME"
#define issifDATA_LEO_OPTI2_NAME        "issifDATA_LEO_OPTI2_NAME"
#define issifDATA_IAS_OPTI3_NAME        "issifDATA_IAS_OPTI3_NAME"
#define issifDATA_IAS_OPTI4_NAME        "issifDATA_IAS_OPTI4_NAME"
#define issifDATA_IAS_MIRR9_NAME        "issifDATA_IAS_MIRR9_NAME"
#define issifDATA_IAS_OPTI6_NAME        "issifDATA_IAS_OPTI6_NAME"
#define issifDATA_ARAL_MIRR10           "issifDATA_ARAL_MIRR10"
#define issifDATA_ARAL_MIRR11           "issifDATA_ARAL_MIRR11"
#define issifDATA_ARAL_MIRR12           "issifDATA_ARAL_MIRR12"
#define issifDATA_ARAL_MIRR13           "issifDATA_ARAL_MIRR13"
#define issifDATA_ARAL_MIRR14           "issifDATA_ARAL_MIRR14"
#define issifDATA_ARAL_MIRR15           "issifDATA_ARAL_MIRR15"
#define issifDATA_ARAL_MIRR16           "issifDATA_ARAL_MIRR16"
#define issifDATA_ARAL_MIRR17           "issifDATA_ARAL_MIRR17"
#define issifDATA_ARAL_MIRR18           "issifDATA_ARAL_MIRR18"
#define issifDATA_ARAL_MIRR19           "issifDATA_ARAL_MIRR19"
#define issifDATA_ARAL_MIRR20           "issifDATA_ARAL_MIRR20"
#define issifDATA_ARAL_MIRR21           "issifDATA_ARAL_MIRR21"
#define issifDATA_PH_MEAN_1             "issifDATA_PH_MEAN_1"
#define issifDATA_PH_MEAN_2             "issifDATA_PH_MEAN_2"
#define issifDATA_PH_RMS_1              "issifDATA_PH_RMS_1"
#define issifDATA_PH_RMS_2              "issifDATA_PH_RMS_2"
#define issifDATA_COH_MEAN_1            "issifDATA_COH_MEAN_1"
#define issifDATA_COH_MEAN_2            "issifDATA_COH_MEAN_1"
#define issifDATA_COH_RMS_1             "issifDATA_COH_RMS_1"
#define issifDATA_COH_RMS_2             "issifDATA_COH_RMS_2"
#define issifDATA_VIS_MEAN_1            "issifDATA_VIS_MEAN_1"
#define issifDATA_VIS_MEAN_2            "issifDATA_VIS_MEAN_2"
#define issifDATA_VIS_RMS_1             "issifDATA_VIS_RMS_1"
#define issifDATA_VIS_RMS_2             "issifDATA_VIS_RMS_2"
#define issifDATA_TCCD_GUV_SCALE        "issifDATA_TCCD_GUV_SCALE"
#define issifDATA_AMBI_PRES             "issifDATA_AMBI_PRES"
#define issifDATA_AMBI_TEMPDEW          "issifDATA_AMBI_TEMPDEW"
#define issifDATA_REF_RA                "issifDATA_REF_RA"
#define issifDATA_REF_DEC               "issifDATA_REF_DEC"
#define issifDATA_CURR_SLOT             "issifDATA_CURR_SLOT"
#define issifDATA_DL_REFBEAM            "issifDATA_DL_REFBEAM"


/* named data items for IRIS */
#define issifDATA_ARAL_MIRR22           "issifDATA_ARAL_MIRR22"
#define issifDATA_ARAL_MIRR23           "issifDATA_ARAL_MIRR23"
#define issifDATA_ARAL_MIRR24           "issifDATA_ARAL_MIRR24"
#define issifDATA_ARAL_MIRR25           "issifDATA_ARAL_MIRR25"
#define issifDATA_ARAL_MIRR26           "issifDATA_ARAL_MIRR26"
#define issifDATA_ARAL_IRIS_FILTER      "issifDATA_ARAL_IRIS_FILTER"
#define issifDATA_IAS_OPTI7_NAME        "issifDATA_IAS_OPTI7_NAME"
#define issifDATA_IAS_OPTI8_NAME        "issifDATA_IAS_OPTI8_NAME"


/*
 * named data items for MACAO quality control data
 */
#define issifDATA_MACAO1_STREHL_M       "issifDATA_MACAO1_STREHL_M"
#define issifDATA_MACAO1_STREHL_R       "issifDATA_MACAO1_STREHL_R"
#define issifDATA_MACAO1_WFE_M          "issifDATA_MACAO1_WFE_M"
#define issifDATA_MACAO1_WFE_R          "issifDATA_MACAO1_WFE_R"
#define issifDATA_MACAO1_FWHM_M         "issifDATA_MACAO1_FWHM_M"
#define issifDATA_MACAO1_FWHM_R         "issifDATA_MACAO1_FWHM_R"
#define issifDATA_MACAO1_ENC_M          "issifDATA_MACAO1_ENC_M"
#define issifDATA_MACAO1_ENC_R          "issifDATA_MACAO1_ENC_R"
#define issifDATA_MACAO1_L0_M           "issifDATA_MACAO1_L0_M"
#define issifDATA_MACAO1_L0_R           "issifDATA_MACAO1_L0_R"
#define issifDATA_MACAO1_R0_M           "issifDATA_MACAO1_R0_M"
#define issifDATA_MACAO1_R0_R           "issifDATA_MACAO1_R0_R"
#define issifDATA_MACAO1_T0_M           "issifDATA_MACAO1_T0_M"
#define issifDATA_MACAO1_T0_R           "issifDATA_MACAO1_T0_R"
#define issifDATA_MACAO1_VALID          "issifDATA_MACAO1_VALID"

#define issifDATA_MACAO2_STREHL_M       "issifDATA_MACAO2_STREHL_M"
#define issifDATA_MACAO2_STREHL_R       "issifDATA_MACAO2_STREHL_R"
#define issifDATA_MACAO2_WFE_M          "issifDATA_MACAO2_WFE_M"
#define issifDATA_MACAO2_WFE_R          "issifDATA_MACAO2_WFE_R"
#define issifDATA_MACAO2_FWHM_M         "issifDATA_MACAO2_FWHM_M"
#define issifDATA_MACAO2_FWHM_R         "issifDATA_MACAO2_FWHM_R"
#define issifDATA_MACAO2_ENC_M          "issifDATA_MACAO2_ENC_M"
#define issifDATA_MACAO2_ENC_R          "issifDATA_MACAO2_ENC_R"
#define issifDATA_MACAO2_L0_M           "issifDATA_MACAO2_L0_M"
#define issifDATA_MACAO2_L0_R           "issifDATA_MACAO2_L0_R"
#define issifDATA_MACAO2_R0_M           "issifDATA_MACAO2_R0_M"
#define issifDATA_MACAO2_R0_R           "issifDATA_MACAO2_R0_R"
#define issifDATA_MACAO2_T0_M           "issifDATA_MACAO2_T0_M"
#define issifDATA_MACAO2_T0_R           "issifDATA_MACAO2_T0_R"
#define issifDATA_MACAO2_VALID          "issifDATA_MACAO2_VALID"

#define issifDATA_MACAO3_STREHL_M       "issifDATA_MACAO3_STREHL_M"
#define issifDATA_MACAO3_STREHL_R       "issifDATA_MACAO3_STREHL_R"
#define issifDATA_MACAO3_WFE_M          "issifDATA_MACAO3_WFE_M"
#define issifDATA_MACAO3_WFE_R          "issifDATA_MACAO3_WFE_R"
#define issifDATA_MACAO3_FWHM_M         "issifDATA_MACAO3_FWHM_M"
#define issifDATA_MACAO3_FWHM_R         "issifDATA_MACAO3_FWHM_R"
#define issifDATA_MACAO3_ENC_M          "issifDATA_MACAO3_ENC_M"
#define issifDATA_MACAO3_ENC_R          "issifDATA_MACAO3_ENC_R"
#define issifDATA_MACAO3_L0_M           "issifDATA_MACAO3_L0_M"
#define issifDATA_MACAO3_L0_R           "issifDATA_MACAO3_L0_R"
#define issifDATA_MACAO3_R0_M           "issifDATA_MACAO3_R0_M"
#define issifDATA_MACAO3_R0_R           "issifDATA_MACAO3_R0_R"
#define issifDATA_MACAO3_T0_M           "issifDATA_MACAO3_T0_M"
#define issifDATA_MACAO3_T0_R           "issifDATA_MACAO3_T0_R"
#define issifDATA_MACAO3_VALID          "issifDATA_MACAO3_VALID"


/* the following definitions are for PRIMA */
#define issifDATA_HA_PS                 "issifDATA_HA_PS"
#define issifDATA_HA_SS                 "issifDATA_HA_SS"
#define issifDATA_RA_PS                 "issifDATA_RA_PS"
#define issifDATA_RA_SS                 "issifDATA_RA_SS"
#define issifDATA_DEC_PS                "issifDATA_DEC_PS"
#define issifDATA_DEC_SS                "issifDATA_DEC_SS"
#define issifDATA_RA2000_PS             "issifDATA_RA2000PS"
#define issifDATA_RA2000_SS             "issifDATA_RA2000SS"
#define issifDATA_DEC2000_PS            "issifDATA_DEC2000PS"
#define issifDATA_DEC2000_SS            "issifDATA_DEC2000SS"
#define issifDATA_STS_AG_STATUS_PS      "issifDATA_STS_AG_STATUS_PS"
#define issifDATA_STS_AG_STATUS_SS      "issifDATA_STS_AG_STATUS_SS"
#define issifDATA_STS_CHOP_STATUS       "issifDATA_STS_CHOP_STATUS"
#define issifDATA_STS_CHOP_STRT_TIME    "issifDATA_STS_CHOP_STRT_TIME"
#define issifDATA_STS_CHOP_FREQ         "issifDATA_STS_CHOP_FREQ"
#define issifDATA_STS_CHOP_THROW        "issifDATA_STS_CHOP_THROW"
#define issifDATA_STS_CHOP_PVR          "issifDATA_STS_CHOP_PVR"
#define issifDATA_STS_CHOP_POSANG       "issifDATA_STS_CHOP_POSANG"
#define issifDATA_STS_STATUS            "issifDATA_STS_STATUS"
#define issifDATA_PRI_DDL1PS_OPL        "issifDATA_PRI_DDL1PS_OPL"
#define issifDATA_PRI_DDL2PS_OPL        "issifDATA_PRI_DDL2PS_OPL"
#define issifDATA_PRI_DDL1SS_OPL        "issifDATA_PRI_DDL1SS_OPL"
#define issifDATA_PRI_DDL2SS_OPL        "issifDATA_PRI_DDL2SS_OPL"
#define issifDATA_PRI_DDL1PS_STATUS     "issifDATA_PRI_DDL1PS_STATUS"
#define issifDATA_PRI_DDL2PS_STATUS     "issifDATA_PRI_DDL2PS_STATUS"
#define issifDATA_PRI_DDL1SS_STATUS     "issifDATA_PRI_DDL1SS_STATUS"
#define issifDATA_PRI_DDL2SS_STATUS     "issifDATA_PRI_DDL2SS_STATUS"
#define issifDATA_PRI_FSUP_STATUS       "issifDATA_PRI_FSUP_STATUS"
#define issifDATA_PRI_FSUP_FREQ         "issifDATA_PRI_FSUP_FREQ"
#define issifDATA_PRI_FSUS_STATUS       "issifDATA_PRI_FSUS_STATUS"
#define issifDATA_PRI_FSUS_FREQ         "issifDATA_PRI_FSUS_FREQ"
#define issifDATA_PRI_MET_STATUS        "issifDATA_PRI_MET_STATUS"

/*
 * Defines for named event items (see issifAttachEvent)
 * These defines allow to select data items to be read by name.
 * A database table contains the mapping from names to database
 * symbolic address and event types.
 */
#define issifEVENT_TRACKING_OK          "issifEVENT_TRACKING_OK"
#define issifEVENT_TRACKING_LOST        "issifEVENT_TRACKING_LOST"
#define issifEVENT_GUIDING_OK           "issifEVENT_GUIDING_OK"
#define issifEVENT_GUIDING_LOST         "issifEVENT_GUIDING_LOST"
#define issifEVENT_REMTRACK_LOW         "issifEVENT_REMTRACK_LOW"
#define issifEVENT_FRINGES_LOCKED       "issifEVENT_FRINGES_LOCKED"
#define issifEVENT_FRINGES_LOST         "issifEVENT_FRINGES_LOST"
#define issifEVENT_SEISMIC_HIGH         "issifEVENT_SEISMIC_HIGH"
#define issifEVENT_SYSTEM_ERROR         "issifEVENT_SYSTEM_ERROR"
/* the following definitions are for PRIMA */
#define issifEVENT_PRI_TRACKING_OK      "issifEVENT_PRI_TRACKING_OK"
#define issifEVENT_PRI_TRACKING_LOST    "issifEVENT_PRI_TRACKING_LOST"
#define issifEVENT_PRI_FRINGES_PS_LOCKED "issifEVENT_PRI_FRINGES_PS_LOCKED"
#define issifEVENT_PRI_FRINGES_SS_LOCKED "issifEVENT_PRI_FRINGES_SS_LOCKED"
#define issifEVENT_PRI_FRINGES_PS_LOST  "issifEVENT_PRI_PS_LOST"
#define issifEVENT_PRI_FRINGES_SS_LOST  "issifEVENT_PRI_SS_LOST"
#define issifEVENT_PRI_MET_OK           "issifEVENT_PRI_MET_OK"
#define issifEVENT_PRI_MET_LOST         "issifEVENT_PRI_MET_LOST"

/*
 * Definitions for fringe tracking modes
 */
#define issFNT_FR_TRK_MODE_UNKNOWN      fntpubFR_TRK_MODE_UNKNOWN
#define issFNT_FR_TRK_MODE_STANDARD     fntpubFR_TRK_MODE_STANDARD
#define issFNT_FR_TRK_MODE_SLOW         fntpubFR_TRK_MODE_SLOW
#define issFNT_FR_TRK_MODE_FAST         fntpubFR_TRK_MODE_FAST

#define issFNT_FR_TRK_MODE_UNKNOWN_STR   fntpubFR_TRK_MODE_UNKNOWN_STR
#define issFNT_FR_TRK_MODE_STANDARD_STR  fntpubFR_TRK_MODE_STANDARD_STR
#define issFNT_FR_TRK_MODE_SLOW_STR      fntpubFR_TRK_MODE_SLOW_STR
#define issFNT_FR_TRK_MODE_FAST_STR      fntpubFR_TRK_MODE_FAST_STR

/*
 * Definitions for channel selections
 */
#define issFNT_SELECT_UNKNOWN            fntpubSELECT_UNKNOWN
#define issFNT_SELECT_CHANNEL1           fntpubSELECT_CHANNEL1
#define issFNT_SELECT_CHANNEL2           fntpubSELECT_CHANNEL2
#define issFNT_SELECT_BOTH_CHANNELS      fntpubSELECT_BOTH_CHANNELS

#define issFNT_SELECT_UNKNOWN_STR        fntpubSELECT_UNKNOWN_STR
#define issFNT_SELECT_CHANNEL1_STR       fntpubSELECT_CHANNEL1_STR
#define issFNT_SELECT_CHANNEL2_STR       fntpubSELECT_CHANNEL2_STR
#define issFNT_SELECT_BOTH_CHANNELS_STR  fntpubSELECT_BOTH_CHANNELS_STR

/*
 * Definitions for motionPhase (copied from dlprsDefines.h)
 */

/* Basic DL LCU state */
#define issifMOTION_PHASE_STATE_UNDEF               0
#define issifMOTION_PHASE_STATE_IDLE                1
#define issifMOTION_PHASE_STATE_POSITION            2
#define issifMOTION_PHASE_STATE_PRESETTING          3
#define issifMOTION_PHASE_STATE_ZPDSEARCH           4
#define issifMOTION_PHASE_STATE_BLIND_TRACK         5
#define issifMOTION_PHASE_STATE_FRINGE_TRACK        6


/* Basic DL LCU state strings */
#define issifMOTION_PHASE_STATE_STR_UNDEF           "Undef"
#define issifMOTION_PHASE_STATE_STR_IDLE            "Idle"
#define issifMOTION_PHASE_STATE_STR_POSITION        "Positioning"
#define issifMOTION_PHASE_STATE_STR_PRESETTING      "Presetting"
#define issifMOTION_PHASE_STATE_STR_ZPDSEARCH       "Zpd Searching"
#define issifMOTION_PHASE_STATE_STR_BLIND_TRACK     "Blind Tracking"
#define issifMOTION_PHASE_STATE_STR_FRINGE_TRACK    "Fringe Tracking"


#endif /*!issifDEFINES_H*/

/* __oOo__ */
