#ifndef issmswDEFINES_H
#define issmswDEFINES_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: issmswDefines.h,v 2.17 2005/05/04 06:41:09 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* jott     2004-06-17 Added definitions for sub-states and names,
*                     added definitions for CALIB and ECALIB commands
*                     (SPR VLTSW20040134)
* jott     2004-01-12 Added definition issmswDB_INS_NOM_FOC_TABLE to solve
*                     remarks from 02-Dec-2003 and 08-Dec-2003 to
*                     SPR VLTSW20020475
* jott      25/07/03  Added definitions issmswDB_INS_TBCONF_ATTR and
*                     issmswNUM_PARA_TCS_GETINSD_CMD,
*                     issmswSETINSD_DEFAULT_INS to continue
*                     solving SPR VLTSW20020475
*                     Increased issmswNUM_MOD4INS to 15
*                     Added definition issmswPNTOFFS_CMD
* jott      03/07/03  Added definitions issmswMODNAME_ARAL, issmswNUM_MOD4INS,
*                     issmswDB_INS_CFG_MGR, issmswDB_INS_CFG_COMPLETION,
*                     issmswINS_DEST_INACTIVE, issmswDB_INS_CFG_TIMEOUT,
*                     issmswNO_COMMAND and issmswINS_*
* rrollf    07/03/03  Added definition for CLRREQ cmd (see SPR VLTSW20020539)
* jott      24/09/02  added definitions issmswMSW_BACKUP_VERS for version
*                     of mode switching table backup file and
*                     issmswMSW_BACKUP_STRING for the string itself
* jott      26/08/02  added issmswNO_OF_INSTRUMENTS and modified some
*                     definitions to solve SPR VLTSW20020475
* jott      19/02/02  removed obsolete mapping of issmswSTATEs and
*                     issmswSUB_STATEs. Used definitions already existing in
*                     msw module
* jott      20/11/01  added definitions issmswDB_INS_POINT for instrument
*                     configuration table, issmswREF_BUFFER_SIZE,
*                     issmswMAX_NUM_TEL_SYSTEMS, issmswCMD_PROC_STATE_IDLE,
*                     issmswCMD_PROC_STATE_BUSY, issmswNUM_UT,
*                     issmswUT_FOCUS_COUDE and mapping of the SETINSD suit
*                     of commands from msw module.
* jott      10/07/01  code reviewed
*                     added issmswMSW_BACKUP_FILE for solving
*                     SPR VLTSW20010322
* rrollf    07/06/01  added define issmswPRIMA_STRING
* jott      30/04/01  third version (Version 1 of ISS)
* jott      05/04/01  intermediate version
* jott      20/02/01  second version
* jott      20/12/00  first version
* jott      04/12/00  created
*/

/************************************************************************
 * Header file containing definitions which are common to the issmsw
 * module
 *----------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

/*
 * Include local headers
 */
#include "evhStates.h"
#include "evhSTD_COMMANDS_NAMES.h"
#include "iss.h"
#include "mswDefines.h"


/*******************************************************************************
 *                                                                             *
 * issmsw common definitions                                                   *
 *                                                                             *
 ******************************************************************************
 */
/* module name */
#define issmswMOD "issmsw"

/* Use CDT or skip it */
#define  issmswCONTROL_USE_CDT     ccsTRUE

/* File name and version for saving mode switching table */
#define issmswMSW_BACKUP_FILE     "IssmswTable.dat"
#define issmswMSW_BACKUP_VERS     2
#define issmswMSW_BACKUP_STRING   "***ISS-MSW_Backup_File_Version_"

/* Subsystem names */
#define issmswMODNAME_SID1        "SID1"
#define issmswMODNAME_SID2        "SID2"
#define issmswMODNAME_UT1         "UT1"
#define issmswMODNAME_UT2         "UT2"
#define issmswMODNAME_UT3         "UT3"
#define issmswMODNAME_UT4         "UT4"
#define issmswMODNAME_AT1         "AT1"
#define issmswMODNAME_AT2         "AT2"
#define issmswMODNAME_AT3         "AT3"
#define issmswMODNAME_DLCS        "DLCS"
#define issmswMODNAME_COU1        "COU1"
#define issmswMODNAME_COU2        "COU2"
#define issmswMODNAME_COU3        "COU3"
#define issmswMODNAME_COU4        "COU4"
#define issmswMODNAME_ARAL        "ARAL"
#define issmswMODNAME_PRIMA       "PRIMA"
#define issmswMODNAME_ISSPRS      "issprs"
#define issmswMODNAME_ISSTRKWS    "isstrkws"
#define issmswMODNAME_ISSMON      "issmon"
#define issmswMODNAME_ISSARRAY    "issarray"
#define issmswMODNAME_ISSALIGN    "issalign"
#define issmswMODNAME_NONE        "none"

/* required field string */
#define issmswMOD_REQUIRED        "yes"
#define issmswMOD_NOT_REQUIRED    "no"

/*
 * Defines for command names
 */
/* User commands mapped to those of msw module */
#define issmswGETINS_CMD         mswGETINS_CMD
#define issmswGETINSD_CMD        mswGETINSD_CMD
#define issmswSELINS_CMD         mswSELINS_CMD
#define issmswSETINSD_CMD        mswSETINSD_CMD


/* ISS internal commands */
#define issmswSETREQ_CMD        "SETREQ"
#define issmswCLRREQ_CMD        "CLRREQ"
#define issmswNO_COMMAND        "NO_CMD"
#define issmswPNTOFFS_CMD       "PNTOFFS"
#define issmswCALIB_CMD         "CALIB"
#define issmswECALIB_CMD        "ECALIB"

/*
 * maximum number of modules in module table
 * (different from 'mswNO_OF_MODULES')
 */
#define issmswNO_OF_MODULES            21


/*
 * Number of Unit Telescopes
 */
#define issmswNUM_UT                   4

/*
 * Value indicating that the UT focus is set to Coud
 */
#define issmswUT_FOCUS_COUDE           mswCOUDE_FOCUS

/*
 * strings to match in userField of module table
 */
#define issmswTELESCOPE_STRING  "TELESCOPE"
#define issmswGUIDING_STRING    "GUIDING"
#define issmswDELAY_STRING      "DELAY"
#define issmswAO_STRING         "AO"
#define issmswPRIMA_STRING      "PRIMA"


/*
 * Database symbolic addresses
 */
/* Redefine module entry point (path to append after mainHandler.DbRoot()) */
#define issmswDB_ENTRY_POINT        "issmsw"

/* Relative to the (iss)mswDB_ENTRY_POINT */
#define issmswDB_SUBSTATE_ATTR      "substate"
#define issmswDB_READY_TIMEOUT_ATTR "readyTimeout"
#define issmswDB_STOP_TIMEOUT_ATTR  "stopTimeout"
#define issmswDB_LIST_POINT         "list"
#define issmswDB_INS_POINT          "insData"
#define issmswDB_LIST_ATTRIBUTE     "modules"
#define issmswDB_INS_DATA_POINT     "insData"
#define issmswDB_FOCUS_POINT        "foc"
#define issmswDB_FORCE_SETTING      "forceSetting"
#define issmswDB_INS_CFG_MGR        "insConfigMgr"
#define issmswDB_INS_CFG_COMPLETION "confComplStatus"
#define issmswDB_INS_CFG_TIMEOUT    "totConfTimeout"


/* Relative to (iss)mswDB_LIST_POINT */
#define issmswDB_MODULES_ATTR       "systems"      /* different to       */
                                                   /* mswDB_MODULES_ATTR */
#define issmswDB_LIST_CHANGED_ATTR  "listchanged"
#define issmswDB_UNIT_CHANGED_ATTR  "unitchanged"

/* Relative to (iss)mswDB_INS_DATA_POINT */
#define issmswDB_INS_ID_ATTR         "selectedIns"
#define issmswDB_INS_DATA_ATTR       "vltiData"
#define issmswDB_INS_TBCONF_ATTR     "InstrumentTBConf"
#define issmswDB_INS_NOM_FOC_TABLE   "nominalFocus"

/*
 * Size of reference buffer for comparison of GETINS/GETINSD replies
 */
#define issmswREF_BUFFER_SIZE         msgBODYMAXLEN

/*
 * Command processing states for the SETINSD suit of commands
 */
#define issmswCMD_PROC_STATE_IDLE     0
#define issmswCMD_PROC_STATE_BUSY     1

#define issmswNO_OF_INSTRUMENTS       mswNO_OF_INSTRUMENTS

/*
 * Timeout for the SETINSD suite of commands
 */
#define issmswSETINS_DATA_TIMEOUT     3


/*
 * Start and stop record numbers in mode switching table for specific groups
 * of subsystems which may have different user field entries but belong to the
 * same physical type. E.g. Siderostats are telescopes like UTs but flagged as
 * guiding systems. These definitions refer to the type definition
 * issmswMOD_SELECTION is header file issmsw.h
 */
#define issmswSEL_TELESCOPE_FIRST   0
#define issmswSEL_TELESCOPE_LAST    8

/*
 * Maximum number of ISS TELESCOPE sub-systems which may be accessed with an
 * instrument selection command.
 * (one real telescope per VLTI beam)
 */
#define issmswMAX_NUM_TEL_SYSTEMS      issMAX_NUM_ARMS

/* Number of sub-system modules which may be addressed during instrument
 * configuration (SETINS suit of commands -> SPR VLTSW20020475):
 * SID1 -> COU4 and issprs (9 real telescopes, 4 Coude's, and 1 DLCS)
 */
#define issmswNUM_MOD4INS         15


/*
 * Number of fields in the ISS specific instrument data table
 */
#define issmswINSDATA_TABLE_FIELDS  22

/*
 * Configuration completion states
 */
#define issmswINS_CONF_COMPL_OK        0
#define issmswINS_CONF_COMPL_ERROR     1
#define issmswINS_CONF_COMPL_TIMEOUT   2

/*
 * Destination of evhDB_COMMAND which is used when the receiver module is
 * not required or ignored
 */
#define issmswINS_DEST_INACTIVE        "inactive"

/*
 * setup keywords used by exclusively by issmswControl to configure instruments
 * on VLTI sub-systems
 */
#define issmswINS_DEL_TARG_TYPE_KW     "DEL.TARG.TYPE  NO_TARGET"
#define issmswINS_TEL_TARG_TYPE_KW     "TEL.TARG.TYPE  NO_TARGET"
#define issmswINS_CONF_PUP_OFFSU_KW    "DEL.VCM.OFFS"
#define issmswINS_CONF_PUP_OFFSV_KW    "COU.M10.OFFSET_V"
#define issmswINS_CONF_PUP_OFFSW_KW    "COU.M10.OFFSET_W"
#define issmswINS_CONF_OPL_OFFS_KW     "DEL.TRCK.OFFSET"

/*
 * Maximum number of configuration commands per SELINS command
 */
#define issmswINS_MAX_NUM_CONF_CMDS       3

/*
 * Number of reply parameters in GETINSD command to TCS
 */
#define issmswNUM_PARA_TCS_GETINSD_CMD   17

/*
 * Default string for instrument name in SETINSD command
 * -> use currently selected
 */
#define issmswSETINSD_DEFAULT_INS        "CURRENT"


/*
 *  Not all msw sub-states are needed, but additional are:
 *  CALIBRATING
 */
#define issmswSUB_STATE_UNK                 mswSUB_STATE_UNK
#define issmswSUB_STATE_ERROR               mswSUB_STATE_ERROR          /* 19 */
#define issmswSUB_STATE_STEADY              mswSUB_STATE_STEADY         /* 20 */
#define issmswSUB_STATE_IDLE                mswSUB_STATE_IDLE           /* 21 */
#define issmswSUB_STATE_COLDSTARTING        mswSUB_STATE_COLDSTARTING   /* 22 */
#define issmswSUB_STATE_SHUTTINGDOWN        mswSUB_STATE_SHUTTINGDOWN   /* 23 */
#define issmswSUB_STATE_PAUSED              mswSUB_STATE_PAUSED         /* 24 */
#define issmswSUB_STATE_PAUSING             mswSUB_STATE_PAUSING        /* 25 */
#define issmswSUB_STATE_STARTING            mswSUB_STATE_STARTING       /* 26 */
#define issmswSUB_STATE_STOPPING            mswSUB_STATE_STOPPING       /* 27 */
#define issmswSUB_STATE_PRESETTING          mswSUB_STATE_PRESETTING     /* 29 */
#define issmswSUB_STATE_CHANGINGFOCUS       mswSUB_STATE_CHANGINGFOCUS  /* 30 */
#define issmswSUB_STATE_ALIGNING            mswSUB_STATE_ALIGNING       /* 31 */
#define issmswSUB_STATE_OFFSET              40
#define issmswSUB_STATE_CALIBRATING         issmswSUB_STATE_OFFSET + 1  /* 41 */

#define issmswSUB_STATE_STR_UNK             "UNKNOWN"
#define issmswSUB_STATE_STR_ERROR           mswSUB_STATE_STR_ERROR
#define issmswSUB_STATE_STR_STEADY          mswSUB_STATE_STR_STEADY
#define issmswSUB_STATE_STR_IDLE            mswSUB_STATE_STR_IDLE
#define issmswSUB_STATE_STR_COLDSTARTING    mswSUB_STATE_STR_COLDSTARTING
#define issmswSUB_STATE_STR_SHUTTINGDOWN    mswSUB_STATE_STR_SHUTTINGDOWN
#define issmswSUB_STATE_STR_PAUSED          mswSUB_STATE_STR_PAUSED
#define issmswSUB_STATE_STR_PAUSING         mswSUB_STATE_STR_PAUSING
#define issmswSUB_STATE_STR_STARTING        mswSUB_STATE_STR_STARTING
#define issmswSUB_STATE_STR_STOPPING        mswSUB_STATE_STR_STOPPING
#define issmswSUB_STATE_STR_PRESETTING      mswSUB_STATE_STR_PRESETTING
#define issmswSUB_STATE_STR_CHANGINGFOCUS   mswSUB_STATE_STR_CHANGINGFOCUS
#define issmswSUB_STATE_STR_ALIGNING        mswSUB_STATE_STR_ALIGNING
#define issmswSUB_STATE_STR_CALIBRATING     "CALIBRATING"

#endif /*!issmswDEFINES_H*/

/* __oOo__ */
