#ifndef issprsBR_ALIGN_H
#define issprsBR_ALIGN_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: issprsBR_ALIGN.h,v 2.56 2005/06/08 13:29:45 vltsccm Exp $"
*
* who       when        what
* --------  ----------  ----------------------------------------------
* jott      2004-08-16  Added member 'mOkReplyBuffer' to pass reply buffer
*                       of final OK reply back to originator.
* jott      2004-07-26  Made method Reset() public to make  CALFNT and
*                       OPTFLUX/FNDBEAM interruptable (SPR VLTSW20040196)
* jott      2003-10-06  Created
*/

/************************************************************************
 * Header file for class issprsBR_ALIGN handling the beam alignment commands
 * within the issprsBroadcast process
 *----------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

#include "evhTASK.h"
#include "evhOBJ_CALLBACK.h"
#include "evhDB_COMMAND.h"
#include "issprs.h"

class issprsBR_ALIGN  :  public  evhTASK
    {
    public:
        issprsBR_ALIGN(dbSYMADDRESS dbPoint);
        ~issprsBR_ALIGN();

        virtual ccsCOMPL_STAT     Init(evhOBJ_CALLBACK &finshCb);
        virtual ccsCOMPL_STAT     AbortBeamAlign(void);

        virtual evhCB_COMPL_STAT  ExecuteBeamAlignCB(msgMESSAGE &msg, void *udata = NULL);
        virtual evhCB_COMPL_STAT  BeamAlignCB(msgMESSAGE &msg, void *udata);
        virtual evhCB_COMPL_STAT  ErrorReplyCB(msgMESSAGE &msg, void *udata);
        virtual evhCB_COMPL_STAT  TimeoutCB(msgMESSAGE &msg, void *udata);

        virtual ccsCOMPL_STAT     SetDlcsStatus(vltLOGICAL active);
        ccsCOMPL_STAT             Reset(void);

    protected:
        ccsCOMPL_STAT             BeamAlignCompleted(ccsCOMPL_STAT result);
        evhDB_COMMAND             mIssmswCommand;
        evhDB_COMMAND             mDlcsCommand;


    private:
        dbSYMADDRESS              mDbPoint;
        msgCMD                    mLastCommand;
        msgMESSAGE                mAlignMsg;
        vltUINT32                 mOptfluxTimeout;
        vltUINT32                 mFndBeamTimeout;
        vltUINT32                 mIssmswTimeout;
        vltLOGICAL                mDlcsActive;
        evhOBJ_CALLBACK           mComplCb;
        char                      mOkReplyBuffer[msgMAXLEN];
    };

#endif /* !issprsBR_ALIGN_H */
