#ifndef issprsBR_CALIB_H
#define issprsBR_CALIB_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: issprsBR_CALIB.h,v 2.56 2005/06/08 13:29:45 vltsccm Exp $"
*
* who       when        what
* --------  ----------  ----------------------------------------------
* jott      2004-07-26  Made method Reset() public to make  CALFNT and
*                       OPTFLUX/FNDBEAM interruptable (SPR VLTSW20040196)
* jott      2004-06-21  Created
*/

/************************************************************************
 * Header file for class issprsBR_CALIB handling the FINITO detector calibration
 * commands within the issprsBroadcast process
 *----------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

#include "evhTASK.h"
#include "evhOBJ_CALLBACK.h"
#include "evhDB_COMMAND.h"
#include "issprs.h"

class issprsBR_CALIB  :  public  evhTASK
    {
    public:
        issprsBR_CALIB(dbSYMADDRESS dbPoint);
        ~issprsBR_CALIB();

        virtual ccsCOMPL_STAT     Init(evhOBJ_CALLBACK &finshCb);
        virtual ccsCOMPL_STAT     AbortCalibration(void);

        virtual evhCB_COMPL_STAT  ExecuteCalibrationCB(msgMESSAGE &msg, void *udata = NULL);
        virtual evhCB_COMPL_STAT  CalibrateCB(msgMESSAGE &msg, void *udata);
        virtual evhCB_COMPL_STAT  ErrorReplyCB(msgMESSAGE &msg, void *udata);
        virtual evhCB_COMPL_STAT  TimeoutCB(msgMESSAGE &msg, void *udata);

        virtual ccsCOMPL_STAT     SetDlcsStatus(vltLOGICAL active);
        ccsCOMPL_STAT             Reset(void);

    protected:
        ccsCOMPL_STAT             CalibrationCompleted(ccsCOMPL_STAT result);
        evhDB_COMMAND             mIssmswCommand;
        evhDB_COMMAND             mDlcsCommand;

    private:
        dbSYMADDRESS              mDbPoint;
        msgCMD                    mLastCommand;
        msgMESSAGE                mCalibMsg;
        vltUINT32                 mCalFntTimeout;
        vltUINT32                 mIssmswTimeout;
        vltLOGICAL                mDlcsActive;
        evhOBJ_CALLBACK           mComplCb;
    };

#endif /* !issprsBR_CALIB_H */
