#ifndef issprsDEFINES_H
#define issprsDEFINES_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: issprsDefines.h,v 2.56 2005/06/08 13:29:41 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* rrollfin 2005-02-18 SPR VLTSW20050036: Added issprsCMD_WAITMV
* rrollf   2004-10-06 SPR VLTSW20040230: Added issprsSK_TRK_WLENGTH and
*                     issprsSK_SUBS_FNT
* rrollf   2004-09-06 SPR VLTSW20040226: ISS to support IRIS - setup
*                     Added issprsSTOPLAG_CMD, issprsARAL_LEAVE_TEL_CHOP and
*                     issprsARAL_LEAVE_TEL_CHOP_L
* jott     2004-06-21 SPR VLTSW20040134: Support FINITO detector calibration
*                     Added  definitions issprsMSW_CALIB_CMD,
*                     issprsMSW_END_CALIB_CMD
* jott     2004-05-18 Added definitions issprsBR_CALFNT_TIMEOUT and
*                     issprsCALFNT_CMD (SPR VLTSW 20040134)
* jott     2004-03-11 Added definitions issprsOFFSGP_CMD,
*                     issprsDB_FIELD_ROT_ANG_PRE,issprsDB_LOCAL_DEC2000
*                     and issprsARCSEC_LAB2SKY to solve SPR VLTSW20040055
* jott     2003-10-22 Added definitions issprsSTARTAO_CMD and issprsSTOPAO_CMD
*                     (SPR VLTSW20030424)
*                     Added definition issprsSK_EPOCH
* jott     2003-10-15 Removed definitions issprsPNTOFFS_CMD,
*                     issprsPNTOFFS_CMD_NUM_PARAM, and issprsDB_APPL_GUV_OFFS
*                     (SPR VLTSW20030425)
* jott     2003-10-11 Added definition issprsDLCS_STOPOPT_CMD
*                     (SPR VLTSW20030410)
* jott     2003-10-02 Added definitions issprsBR_MSW_DB_CMD and
*                     issprsBR_DLCS_DB_CMD for ALIGN/EALIGN command handler,
*                     added issprsMSW_ALIGN_CMD and issprsMSW_END_ALIGN_CMD
*                     added definition issprsMSW_REC_NUM_OF_DLCS
*                     (SPR VLTSW20030410)
* jott     2003-09-23 Added definitions issprsGOBACK_STR_WAIT_SBS_TRACKING,
*                     issprsGOBACK_STR_WAIT_SBS_TRACK_EVT,
*                     issprsSTATE_RECOVER_UVW, issprsSTATE_STR_RECOVER_UVW and
*                     issprsACQ_WAIT_TRACK_TIMEOUT
* rrollf    04/08/03  Changed tcsXXX defines to issprsTCS_XXX and issmswXXX to
*                     issprsMSW_XXX
* rrollf    23/07/03  Added definitions issprsPNTOFFS_CMD,
*                     issprsPNTOFFS_CMD_NUM_PARAM, issprsINSTR_GUV_OFFS and
*                     issprsDB_APPL_GUV_OFFS (see SPR VLTSW20020475)
* rrollf    22/07/03  Removed definitions issprsAH_WAITUT_TIMEOUT,
*                     issprsACQ_NAS_GUIDE_TIMEOUT, issprsNOT_WAITING,
*                     issprsWAITING, issprsDB_AH_WAIT_FOR_UT_ATTR,
*                     issprsDB_ACQ_WAIT_FOR_UT_ATTR, issprsDB_WAIT_FOR_UT_ATTR
*                     (see SPR VLTSW20030237)
* rrollf    07/07/03  Added definition issprsCOU_ACQ_SAFE and issprsCOU_GS_MAG
*                     (see SPR VLTSW20030272)
* jott      02/06/03  Changed definition issprsDB_FRINGE_SENSOR because the
*                     fringe sensor name now is provided by dlif and no longer
*                     captured by issprs. And added definitions
*                     issprsDB_FR_SENSOR_PT, issprsFNDBEAM_CMD,
*                     issprsOFFSFTS_CMD, issprsSETFNTM_CMD, issprsZEROOPD_CMD,
*                     issprsBR_FNDBEAM_TIMEOUT, issprsBR_FNT_SHORT_TIMEOUT,
*                     issprsBR_FNT_LONG_TIMEOUT
* rrollf    19/05/03  Added OPTFLUX command (see SPR VLTSW20030203)
* rrollf    06/05/03  Removed definitions issprsDEL_REF_MODE_NO_AUTO and
*                     issprsDEL_REF_MODE_AUTO (no more needed)
* rrollf    21/10/02  Added definitions issprsDB_REF_RA and issprsDB_REF_DEC
* rrollf    10/10/02  Added definition issprsMAX_OFFSETS (max. allowed steps)
* rrollf    08/10/02  Added some definitions for issprsSEQ_MAIN_TASK
* jott      29/08/02  Added definition issprsFITS_BIN_TAB_PROD_RECORDS
* rrollf    01/08/02  Added define issprsOFFSTEL_CMD for OFFSTEL command
* rrollf    23/07/02  Added defines for setup of ARAL subsystem
* rrollf    19/07/02  Added defines of attribute names for timeouts
*                     (see SPR VLTSW20020347)
* jott      11/06/02  adapted to APR2003 and gcc 3.0.4
* rrollf    03/05/02  Added defines for the SETUP command
* rrollf    28/02/02  Added defines issprsDB_AH_WAIT_FOR_UT_ATTR,
*                     issprsDB_ACQ_WAIT_FOR_UT_ATTR, issprsNOT_WRITING,
*                     issprsWRITING, issprsMAX_WRCHK_RETRY
* rrollf    27/02/02  Added defines for upper case delay line strings
*                     (issprsSTR_UC_DLx)
* rrollf    12/02/02  Added issprsSK_SUBS_REF, issprsSK_MODE
* rrollf    11/02/02  Renamed issprsGOBACK_STR_WAIT_RECOGUV to
*                     issprsGOBACK_STR_ACCEPT_RECOGUV
* rrollf    08/02/02  Added definitions issprsNOT_WAITING; issprsWAITING;
*                     issprsDB_WAIT_FOR_UT_ATTR
* rkarban 2002-02-01 add definitions for more COU setup keywords
* jott      16/01/02  To solve SPR VLTSW20010787 and SPR VLTSW20020019:
*                     Added definitions issprsRECOGUV,
*                     issprsRECOGUV_PARA_CALIB, issprsRECOGUV_CALIB_ID,
*                     issprsRECOGUV_REMEMB_ID, and issprsRECOGUV_PARA_REMEMB.
*                     Changed enumeration value
*                     issprsGOBACK_STR_WAIT_STRCAG_REPLY to
*                     issprsGOBACK_STR_WAIT_RECOGUV.
*                     Replaced definition issprsCMD_GOBACK_TIMEOUT by a database
*                     attribute.
*                     Added definitions issprsREACQUIRE_GOBACK_TIMEOUT,
*                     issprsREACQUIRE_NAS_GUIDE_TIMEOUT,
*                     issprsREACQUIRE_RECOGUV_TIMEOUT, and
*                     issprsDB_UVW_OFFSET_xxx.
* jott      15/01/02  Split issprsSETUP_FORM_ATSID into issprsSETUP_FORM_AT
*                     and issprsSETUP_FORM_SID and modified issprsSETUP_FORM_UT.
*                     Further added issprsCOU_STP_NDFIDX, issprsCOU_STP,
*                     issprsSK_NDFIDX, and issprsSK_SUBS_STP to solve SPR
*                     VLTSW20010783
*                     Added definitions for keywords TEL.AG.TYPE, TEL.AG.OBJCNT,
*                     TEL.AG.START, TEL.AO.START to solve SPR VLTSW20020021
* jott      06/12/01  Added issprsGOBACK_STR_WAIT_STOPCAG_REPLY to solve
*                     SPR VLTSW20010746
* rrollf    25/10/01  Added issprsOPTDLCS_CMD definition
* jott      11/10/01  added definitions for the states stepping throu GOBACK
*                     command.
* rrollf    09/10/01  added definitions tcsSUSPEND_CMD and tcsRESUME_CMD
* jott      04/10/01  removed definition issprsLAST_OPL_OFFS
*                     added definitions issprsDEL_TARG_TYPE_STR and
*                     issprsSETUP_FORM_DLCS
* rrollf    29/08/01  moved defines of database addresses for
*                     subsystems to issSbsDbDefines.h (iss module)
* rrollf    30/04/01  third version (Version 1 of ISS)
* jott      20/02/01  first version
* jott      12/01/01  created
*/

/************************************************************************
 *
 * This file contains common defines used both by C/C++ files and
 * dbLoader files
 *----------------------------------------------------------------------
 */

/*
 *  Defines for the target telescope VLT
 */

#include "tcsDefines.h"

/* Module name */
#define issprsMOD                   "issprs"

/* Process names */
#define issprsCONTROL               "issprsControl"
#define issprsACTION                "issprsAction"
#define issprsBROADCAST             "issprsBroadcast"
#define issprsREACQUIRE             "issprsReacquire"

/* Task names */
#define issprsBR_MAIN_NAME          "issprsBR_MAIN_TASK"

/* Database root point names */
#define issprsDB_ROOT_BROADCAST     "broadcast"

/* Defines for database attributes of issprs module */
#define issprsSEQ_PRESET_DB_CMD         "presetDbCmd"
#define issprsSEQ_ARAL_DB_CMD           "aralSetupCmd"
#define issprsBR_MSW_DB_CMD             "issmswCommand"
#define issprsBR_DLCS_DB_CMD            "dlcsCommand"

#define issprsDB_FBP_POINT              "fitsBinProducer"
#define issprsDB_FBP_ATTRIBUTE          "modules"
#define issprsDB_UVW_OFFSET_BASE        "calibOffsets"
#define issprsDB_UVW_OFFSET_UT_POINT    "ut"
#define issprsDB_UVW_OFFSET_AT_POINT    "at"
#define issprsDB_UVW_OFFSET_SID_POINT   "sid"
#define issprsDB_UVW_OFFSET_UT_ATTR     "utOffsets"
#define issprsDB_UVW_OFFSET_AT_ATTR     "atOffsets"
#define issprsDB_UVW_OFFSET_SID_ATTR    "sidOffsets"


/* Defines of attribute names for timeouts */
#define issprsSEQ_READY_TIMEOUT         "readyTimeout"
#define issprsSEQ_ARAL_TIMEOUT          "aralTimeout"
#define issprsSEQ_STD_MSG_TIMEOUT       "stdMsgTimeout"

#define issprsAH_PRESET_TIMEOUT         "presetReadyTimeout"
#define issprsAH_BR_SHORT_TIMEOUT       "brShortTimeout"
#define issprsAH_BR_LONG_TIMEOUT        "brLongTimeout"
#define issprsAH_MSW_TIMEOUT            "modeSwitchTimeout"
#define issprsAH_STOPOPT_TIMEOUT        "stopOptTimeout"

#define issprsBR_STD_TIMEOUT            "broadcastTimeout"
#define issprsBR_PRSOPL_TIMEOUT         "prsoplTimeout"
#define issprsBR_PRSNAME_TIMEOUT        "prsnameTimeout"
#define issprsBR_OPTDLCS_TIMEOUT        "optdlcsTimeout"
#define issprsBR_OPTCGS_TIMEOUT         "optcgsTimeout"
#define issprsBR_OPTFLUX_TIMEOUT        "optfluxTimeout"
#define issprsBR_FNDBEAM_TIMEOUT        "fndBeamTimeout"
#define issprsBR_FNT_SHORT_TIMEOUT      "fntShortTimeout"
#define issprsBR_FNT_LONG_TIMEOUT       "fntLongTimeout"
#define issprsBR_CALFNT_TIMEOUT         "calFntTimeout"

#define issprsACQ_READY_TIMEOUT         "readyTimeout"
#define issprsACQ_MSW_TIMEOUT           "modeSwitchTimeout"
#define issprsACQ_BR_SHORT_TIMEOUT      "brShortTimeout"
#define issprsACQ_BR_LONG_TIMEOUT       "brLongTimeout"
#define issprsACQ_BR_VERY_LONG_TIMEOUT  "brVeryLongTimeout"
#define issprsACQ_WAIT_TRACK_TIMEOUT    "waitTrackTimeout"

/* Use CDT or skip it */
#define issprsCONTROL_USE_CDT       ccsTRUE
#define issprsACTION_USE_CDT        ccsTRUE
#define issprsBROADCAST_USE_CDT     ccsTRUE
#define issprsREACQUIRE_USE_CDT     ccsTRUE


/* Standard OK message */
#define issprsOK_MSG            "OK"
#define issprsOK_ABORT_REPLY    "OK, superseded by valid equivalent command"

/* Contents of message buffer for standard commands used globally   */
/* and to be propagated to issprsAction                             */
#define issprsMSG_BUFF_ALL      tcsMSG_BUFF_ALL

/*
 * Defines for states values and names
 * These enum and string vector are used in the whole module
 * to identify states and substates.
 * The values must be coordinated with the standard states defined in
 * evhStates.h
 */

#include "evhStates.h"


/* Local remapping of some standard states (just for convenience) */
#define issprsSTATE_OFF             evhSTATE_OFF
#define issprsSTATE_LOADED          evhSTATE_LOADED
#define issprsSTATE_STANDBY         evhSTATE_STANDBY
#define issprsSTATE_ONLINE          evhSTATE_ONLINE
#define issprsSTATE_ERROR           evhSTATE_ERROR
#define issprsSTATE_READY           evhSTATE_READY
#define issprsSTATE_IDLE            evhSTATE_IDLE
#define issprsSTATE_BUSY            evhSTATE_BUSY

/*
 * New states for issprs which are not already defined in evhStates.h
 * starting from 17 to be sure not to clash
 */
#define issprsSTATE_PRESETTING      17
#define issprsSTATE_STOPPING        18
#define issprsSTATE_INIT            19
#define issprsSTATE_RECOVER_UVW     20

/*
 * New states used by issprsBR_OFFSTEL
 */
#define issprsSTATE_SEND_STOPCAG            31
#define issprsSTATE_SEND_OFFSET             32

/* Defines for named states */
#define issprsSTATE_STR_OFF         evhSTATE_STR_OFF
#define issprsSTATE_STR_LOADED      evhSTATE_STR_LOADED
#define issprsSTATE_STR_STANDBY     evhSTATE_STR_STANDBY
#define issprsSTATE_STR_ONLINE      evhSTATE_STR_ONLINE
#define issprsSTATE_STR_READY       evhSTATE_STR_READY
#define issprsSTATE_STR_ERROR       evhSTATE_STR_ERROR
#define issprsSTATE_STR_IDLE        evhSTATE_STR_IDLE
#define issprsSTATE_STR_BUSY        evhSTATE_STR_BUSY
#define issprsSTATE_STR_PRESETTING  "PRESETTING"
#define issprsSTATE_STR_STOPPING    "STOPPING"
#define issprsSTATE_STR_INIT        "INIT"
#define issprsSTATE_STR_RECOVER_UVW "RECOVER_UVW"


/* Defines for named states used while processing GOBACK command */
#define issprsGOBACK_STR_IDLE                   "IDLE"
#define issprsGOBACK_STR_WAIT_PRESET_REPLY      "WAIT FOR PRESET REPLY"
#define issprsGOBACK_STR_WAIT_PRSNAME_REPLY     "WAIT FOR PRSNAME REPLY"
#define issprsGOBACK_STR_WAIT_SETUP_REPLY       "WAIT FOR SETUP REPLY"
#define issprsGOBACK_STR_WAIT_FOR_GUIDING       "WAIT FOR NASMYTH GUIDING"
#define issprsGOBACK_STR_WAIT_STOPCAG_REPLY     "WAIT FOR STOPCAG REPLY"
#define issprsGOBACK_STR_ACCEPT_RECOGUV         "ACCEPT RECOGUV REMEMBERED"
#define issprsGOBACK_STR_WAIT_OFFSOPD_REPLY     "WAIT FOR OFFSOPD REPLY"
#define issprsGOBACK_STR_WAIT_SBS_TRACKING      "WAIT FOR VLTI TRACKING"
#define issprsGOBACK_STR_WAIT_SBS_TRACK_EVT     "WAIT FOR VLTI TRACKING EVENT OR TIMEOUT"
#define issprsGOBACK_STR_SEND_EPRESET_REPLY     "READY TO SEND EPRESET"
#define issprsGOBACK_STR_WAIT_EPRESET_REPLY     "WAIT FOR EPRESET REPLY"


/*
 *********************************
 * Defines for command names     *
 *********************************
 */

/*
 * New commands accepted by issprsControl process
 */

/* Handle a new setup configuration */
#define issprsSETUP_CMD             "SETUP"
/* Clear ready SETUP file */
#define issprsCLRSTP_CMD            "CLRSTP"
/* Preset VLTI to given coordinates */
#define issprsPRSCOOR_CMD           "PRSCOOR"

/*
 * New commands accepted by issprsAction process
 */

/* Preset command with an action */
#define issprsPRESET_CMD            "PRESET"
#define issprsPRESET_CMD_NUM_PARAM  5


/*
 * New commands accepted by issprsBroadcast process
 */

/* Detect best object and take it as guide star */
#define issprsDETCGS_CMD            "DETCGS"
/* Optimize Coud Guiding Loop */
#define issprsOPTCGS_CMD            "OPTCGS"
/* Apply an Alpha/Delta offset on all telescopes */
#define issprsOFFSADG_CMD           "OFFSADG"
/* Apply an offset to guiding probe */
#define issprsOFFSGP_CMD           "OFFSGP"
/* Apply an ra-dec-offset on all telescopes */
#define issprsOFFSTEL_CMD           "OFFSTEL"
#define issprsOFFSTEL_CMD_NUM_PARAM 3
/* Apply an OPD offset to delay line */
#define issprsOFFSOPD_CMD           "OFFSOPD"
/* Apply an OPD offset to FINITO beam */
#define issprsOFFSFNT_CMD           "OFFSFNT"
/* Apply an UVW offset for a single telescope */
#define issprsOFFSGUV_CMD           "OFFSGUV"
/* Preset all telescopes to named position */
#define issprsPRSNAME_CMD           "PRSNAME"
/* Preset delay line to given OPL position */
#define issprsPRSOPL_CMD            "PRSOPL"
/* Start Coude auto guiding */
#define issprsSTRTCAG_CMD           "STRTCAG"
/* Stop Coude auto guiding */
#define issprsSTOPCAG_CMD           "STOPCAG"
/* Stop Laboratory auto guiding */
#define issprsSTOPLAG_CMD           "STOPLAG"
/* Apply an UVW offset for a single beam (with laboratory guiding) */
#define issprsLGOFFS                "LGOFFS"
/* Start synchronized chopping */
#define issprsSTRTCHP_CMD           "STRTCHP"
/* Stop synchronized chopping */
#define issprsSTOPCHP_CMD           "STOPCHP"
/* Start fringe tracking */
#define issprsSTRTFTK_CMD           "STRTFTK"
/* Stop fringe tracking */
#define issprsSTOPFTK_CMD           "STOPFTK"
/* Start data collection in FITS binary tables */
#define issprsSTARTEX_CMD           "STARTEX"
/* Stop data collection in FITS binary tables */
#define issprsENDEX_CMD             "ENDEX"
/* Optimize DLCS */
#define issprsOPTDLCS_CMD           "OPTDLCS"
/* Optimize Flux (FINITO) */
#define issprsOPTFLUX_CMD           "OPTFLUX"
/* Find Beam (FINITO) */
#define issprsFNDBEAM_CMD           "FNDBEAM"
/* Offset translation stages(FINITO) */
#define issprsOFFSFTS_CMD           "OFFSFTS"
/* Set operational mode (FINITO) */
#define issprsSETFNTM_CMD           "SETFNTM"
/* Store Zero OPD positions (FINITO) */
#define issprsZEROOPD_CMD           "ZEROOPD"
/* Start active optics on UTs and ATs */
#define issprsSTARTAO_CMD           "STARTAO"
/* Stop active optics on UTs and ATs */
#define issprsSTOPAO_CMD            "STOPAO"
/* Calibrate detector algorithms (FINITO) */
#define issprsCALFNT_CMD            "CALFNT"


/*
 * New commands accepted by issprsReacquire process
 */

/* Store current telescope positions */
#define issprsREMEMB_CMD            "REMEMB"
/* Return to last positions stored with REMEMB */
#define issprsGOBACK_CMD            "GOBACK"

/* Return to the UVW offsets */
#define issprsRECOGUV               "RECOGUV"
/* Parameter indication to return to calibration values */
#define issprsRECOGUV_PARA_CALIB    "CALIBRATED"
#define issprsRECOGUV_CALIB_ID      1
/* Parameter indicating to return to remembered values */
#define issprsRECOGUV_PARA_REMEMB   "REMEMBERED"
#define issprsRECOGUV_REMEMB_ID     2

/**************************************/
/* Commands send to other modules     */
/**************************************/

/* General commands */
#define issprsTCS_SETUP_CMD    "SETUP"
#define issprsTCS_STOPTRK_CMD  "STOPTRK"
#define issprsTCS_SUSPEND_CMD  "SUSPEND"
#define issprsTCS_RESUME_CMD   "RESUME"
#define issprsTCS_MOVBXA_CMD   "MOVBXA"
#define issprsTCS_SETPATH_CMD  "SETPATH"

/* To Mode Switch: */
#define issprsMSW_PRESET_CMD    "PRESET"
#define issprsMSW_EPRESET_CMD   "EPRESET"
#define issprsMSW_ALIGN_CMD     "ALIGN"
#define issprsMSW_END_ALIGN_CMD "EALIGN"
#define issprsMSW_CALIB_CMD     "CALIB"
#define issprsMSW_END_CALIB_CMD "ECALIB"


/* DLCS commands */
#define issprsDLCS_STOPOPT_CMD  "STOPOPT"

/* Commands to isstrkws */
#define issprsCMD_WAITMV            "WAITMV"

/*
 *  Target types
 */
#define issprsTARG_NONE         0
#define issprsTARG_ALAZ         1
#define issprsTARG_COOR         2
#define issprsTARG_NAME         3

#define issprsTARG_STR_NONE         "NO_TARGET"
#define issprsTARG_STR_ALAZ         "ALT_AZ"
#define issprsTARG_STR_COOR         "COORDINATE"
#define issprsTARG_STR_NAME         "NAMED_POS"

/* Target types for delay lines */
#define issprsTARG_DL_NONE      0
#define issprsTARG_DL_ALAZ      1
#define issprsTARG_DL_OBJCOOR   2
#define issprsTARG_DL_NAME      3
#define issprsTARG_DL_COOR      4

#define issprsDEL_TARG_TYPE_STR     "DEL.TARG.TYPE"
#define issprsTARG_STR_DL_NONE      "NO_TARGET"
#define issprsTARG_STR_DL_ALAZ      "ALT_AZ"
#define issprsTARG_STR_DL_OBJCOOR   "OBJ_COORD"
#define issprsTARG_STR_DL_NAME      "NAMED_POS"
#define issprsTARG_STR_DL_COOR      "DL_COORD"

/*
 *  Preset types
 */
#define issprsPRS_ERR         0
#define issprsPRS_ASTRO       1
#define issprsPRS_ENG         2

#define issprsPRS_STR_ERR     "ERROR"
#define issprsPRS_STR_ASTRO   "ASTRONOMICAL"
#define issprsPRS_STR_ENG     "ENGINEERING"

/*
 *   Auto guide type
 */
#define issprsAG_NONE              0
#define issprsAG_AUTO_GUIDE        1
#define issprsAG_FIELD_STAB        2

#define issprsAG_STR_NONE              "NONE"
#define issprsAG_STR_AUTO_GUIDE        "AUTO_GUID"
#define issprsAG_STR_FIELD_STAB        "FIELD_STAB"

/*
 *  Defines for setup file keywords
 */

/* Setup file category */
#define issprsSK_CAT_COU    "COU"
#define issprsSK_CAT_DEL    "DEL"
#define issprsSK_CAT_ISS    "ISS"
#define issprsSK_CAT_TEL    "TEL"

/* Setup file subsystems */
#define issprsSK_SUBS_ACQ   "ACQ"
#define issprsSK_SUBS_AG    "AG"
#define issprsSK_SUBS_AO    "AO"
#define issprsSK_SUBS_CONF  "CONF"
#define issprsSK_SUBS_FT    "FT"
#define issprsSK_SUBS_GS    "GS"
#define issprsSK_SUBS_GS1   "GS1"
#define issprsSK_SUBS_GUID  "GUID"
#define issprsSK_SUBS_REF   "REF"
#define issprsSK_SUBS_ROT   "ROT"
#define issprsSK_SUBS_STP   "STP"
#define issprsSK_SUBS_TARG  "TARG"
#define issprsSK_SUBS_TIME  "TIME"
#define issprsSK_SUBS_FNT   "FNT"

/* Setup file keywords */
#define issprsSK_TYPE           "TYPE"
#define issprsSK_ALPHA          "ALPHA"
#define issprsSK_DELTA          "DELTA"
#define issprsSK_EPOCHSYSTEM    "EPOCHSYSTEM"
#define issprsSK_EPOCH          "EPOCH"
#define issprsSK_EQUINOX        "EQUINOX"
#define issprsSK_PMA            "PMA"
#define issprsSK_PMD            "PMD"
#define issprsSK_RADVEL         "RADVEL"
#define issprsSK_PARALLAX       "PARALLAX"
#define issprsSK_COORDTYPE      "COORDTYPE"
#define issprsSK_ALT            "ALT"
#define issprsSK_AZ             "AZ"
#define issprsSK_NAME           "NAME"
#define issprsSK_WLENGTH        "WLENGTH"
#define issprsSK_TRK_WLENGTH    "TRK_WLENGTH"
#define issprsSK_EPOCH          "EPOCH"
#define issprsSK_OFFSETALPHA    "OFFSETALPHA"
#define issprsSK_OFFSETDELTA    "OFFSETDELTA"
#define issprsSK_ADDVELALPHA    "ADDVELALPHA"
#define issprsSK_ADDVELDELTA    "ADDVELDELTA"
#define issprsSK_PRSCRIT        "PRSCRIT"
#define issprsSK_OFFANGLE       "OFFANGLE"
#define issprsSK_ENABLED        "ENABLED"
#define issprsSK_ALTAZTRACK     "ALTAZTRACK"
#define issprsSK_AGTYPE         "TYPE"
#define issprsSK_START          "START"
#define issprsSK_OBJCNT         "OBJCNT"
#define issprsSK_AGMINMAG       "MINMAG"
#define issprsSK_AGMAXMAG       "MAXMAG"
#define issprsSK_AGVIGLIM       "VIGLIM"
#define issprsSK_RESET          "RESET"
#define issprsSK_ZENITH         "ZENITH"
#define issprsSK_ABSPOS         "ABSPOS"
#define issprsSK_DTIME          "DTIME"
#define issprsSK_GSCAT          "CAT"
#define issprsSK_ADCTYPE        "TYPE"
#define issprsSK_GUIDESTAR      "GUIDESTAR"
#define issprsSK_GSSOURCE       "GSSOURCE"
#define issprsSK_DTIME          "DTIME"
#define issprsSK_LAMRED         "LAMRED"
#define issprsSK_LAMBLUE        "LAMBLUE"
#define issprsSK_OPL            "OPL"
#define issprsSK_MODE           "MODE"
#define issprsSK_SENSOR         "SENSOR"
#define issprsSK_SAFE           "SAVE"


/* setup file keywords for GS subsystem */
#define issprsSK_WAVELEN        "WAVELEN"
#define issprsSK_MAG            "MAG"
#define issprsSK_RA             "RA"
#define issprsSK_DEC            "DEC"
#define issprsSK_NDFIDX         "NDFIDX"

/* ISS.*.* */
#define issprsSK_LSTMIN         "LSTMIN"
#define issprsSK_LSTMAX         "LSTMAX"
#define issprsSK_NTEL           "NTEL"
#define issprsSK_LOCT1          "LOCT1"
#define issprsSK_LOCT2          "LOCT2"
#define issprsSK_LOCT3          "LOCT3"


/* Number of send objects used by issprsReacquire */
#define issprsACQ_NO_OF_SEND_OBJ 7 /* for 3 arms (3 UT + 3 COU + 1 DLCS) */

/* Definitions for memory positions used by REMEMB and GOBACK commands */
#define issprsMEM_POS_NONE      "NONE"
#define issprsMEM_POS_SCI       "SCI"
#define issprsMEM_POS_CAL1      "CAL1"
#define issprsMEM_POS_CAL2      "CAL2"
#define issprsMEM_POS_ID_NONE   0
#define issprsMEM_POS_ID_SCI    1
#define issprsMEM_POS_ID_CAL1   2
#define issprsMEM_POS_ID_CAL2   3

/* Defines for delay line strings and indices used by PRSOPL command */
#define issprsSTR_NONE      "undefined"
#define issprsSTR_DL1       "dl1"
#define issprsSTR_DL2       "dl2"
#define issprsSTR_DL3       "dl3"
#define issprsSTR_DL4       "dl4"
#define issprsSTR_DL5       "dl5"
#define issprsSTR_DL6       "dl6"
#define issprsSTR_DL7       "dl7"
#define issprsSTR_DL8       "dl8"
#define issprsSTR_UC_DL1    "DL1"
#define issprsSTR_UC_DL2    "DL2"
#define issprsSTR_UC_DL3    "DL3"
#define issprsSTR_UC_DL4    "DL4"
#define issprsSTR_UC_DL5    "DL5"
#define issprsSTR_UC_DL6    "DL6"
#define issprsSTR_UC_DL7    "DL7"
#define issprsSTR_UC_DL8    "DL8"

#define issprsIDX_NONE  0
#define issprsIDX_DL1   1
#define issprsIDX_DL2   2
#define issprsIDX_DL3   3
#define issprsIDX_DL4   4
#define issprsIDX_DL5   5
#define issprsIDX_DL6   6
#define issprsIDX_DL7   7
#define issprsIDX_DL8   8

/* Database attibutes for issprsReacquire */
#define issprsREACQUIRE_SLOT_DATAOK                 "dataOk"
#define issprsREACQUIRE_SLOT_TIMESTAMP              "timeStamp"
#define issprsREACQUIRE_SLOT_TELE                   "tele"
#define issprsREACQUIRE_SLOT_DLCS_RA2000            "delayRA2000"
#define issprsREACQUIRE_SLOT_DLCS_DEC2000           "delayDEC2000"
#define issprsREACQUIRE_SLOT_DLCS_OFFS              "delayOplOffs"
#define issprsREACQUIRE_SLOT_DLCS_REFDL             "refDl"
#define issprsREACQUIRE_SLOT_DLCS_REFOPL            "refOpl"
#define issprsREACQUIRE_SLOT_DLCS_REFMODE           "refMode"

/*
 * Setup keywords used by issprsReacquire
 */

/* Help function already defined in issSbsDefines.h */
#define xcat(x,y) x y

/* First level concatenations */
#define issprsTEL_TARG  xcat(xcat(issprsSK_CAT_TEL,"."),issprsSK_SUBS_TARG)
#define issprsTEL_AG    xcat(xcat(issprsSK_CAT_TEL,"."),issprsSK_SUBS_AG)
#define issprsTEL_GS1   xcat(xcat(issprsSK_CAT_TEL,"."),issprsSK_SUBS_GS1)
#define issprsCOU_ACQ   issprsSK_CAT_COU "." issprsSK_SUBS_ACQ
#define issprsCOU_GS    issprsSK_CAT_COU "." issprsSK_SUBS_GS
#define issprsCOU_GUID  xcat(xcat(issprsSK_CAT_COU,"."),issprsSK_SUBS_GUID)
#define issprsCOU_STP   xcat(xcat(issprsSK_CAT_COU,"."),issprsSK_SUBS_STP)
#define issprsTEL_AO    xcat(xcat(issprsSK_CAT_TEL,"."),issprsSK_SUBS_AO)
#define issprsCOU_AG    xcat(xcat(issprsSK_CAT_COU,"."),issprsSK_SUBS_AG)


/* Second level concatenations */
#define issprsUNKNOWN           "UNKNOWN"
#define issprsCOU_AG_GSSOURCE   xcat(xcat(issprsCOU_AG,"."),issprsSK_GSSOURCE)
#define issprsTEL_TARG_TYPE     xcat(xcat(issprsTEL_TARG,"."),issprsSK_TYPE)
#define issprsTEL_TARG_ALPHA    xcat(xcat(issprsTEL_TARG,"."),issprsSK_ALPHA)
#define issprsTEL_TARG_DELTA    xcat(xcat(issprsTEL_TARG,"."),issprsSK_DELTA)
#define issprsTEL_AG_GUIDESTAR  xcat(xcat(issprsTEL_AG,"."),issprsSK_GUIDESTAR)
#define issprsTEL_GS1_ALPHA     xcat(xcat(issprsTEL_GS1,"."),issprsSK_ALPHA)
#define issprsTEL_GS1_DELTA     xcat(xcat(issprsTEL_GS1,"."),issprsSK_DELTA)
#define issprsCOU_GUID_RA       xcat(xcat(issprsCOU_GUID,"."),issprsSK_RA)
#define issprsCOU_GUID_DEC      xcat(xcat(issprsCOU_GUID,"."),issprsSK_DEC)
#define issprsCOU_AG_ALPHA      xcat(xcat(issprsCOU_AG,"."),issprsSK_ALPHA)
#define issprsCOU_AG_DELTA      xcat(xcat(issprsCOU_AG,"."),issprsSK_DELTA)
#define issprsCOU_GS_MAG        issprsCOU_GS  "." issprsSK_MAG
#define issprsCOU_ACQ_SAFE      issprsCOU_ACQ "." issprsSK_SAFE
#define issprsCOU_STP_NDFIDX    xcat(xcat(issprsCOU_STP,"."),issprsSK_NDFIDX)
#define issprsTEL_AG_TYPE       xcat(xcat(issprsTEL_AG,"."),issprsSK_TYPE)
#define issprsTEL_AG_OBJCNT     xcat(xcat(issprsTEL_AG,"."),issprsSK_OBJCNT)
#define issprsTEL_AG_START      xcat(xcat(issprsTEL_AG,"."),issprsSK_START)
#define issprsTEL_AO_START      xcat(xcat(issprsTEL_AO,"."),issprsSK_START)


/*
 * Message buffer format for setup cmd to UT's
 *
 * keywords:
 *  TEL.TARG.TYPE,
 *  TEL.TARG.ALPHA, TEL.TARG.DELTA,
 *  TEL.AG.GUIDESTAR,
 *  TEL.GS1.ALPHA, TEL.GS1.DELTA
 *  TEL.AG.TYPE, TEL.AG.OBJCNT, TEL.AG.START, TEL.AO.START
 */
#define issprsSETUP_FORM_UT     ",,%s %s %s %f %s %f %s %s %s %f %s %f %s %s %s %c %s %c %s %c"

/*
 * Message buffer format for setup cmd to COU's
 *
 * keywords:
 *  TEL.TARG.TYPE,
 *  TEL.TARG.ALPHA, TEL.TARG.DELTA,
 *  COU.AG.GSSOURCE,
 *  COU.AG.ALPHA, COU.AG.DELTA
 *  COU.STP.NDFIDX
 */
#define issprsSETUP_FORM_COU    ",,%s %s %s %f %s %f %s %s %s %f %s %f %s %d"

/*
 * Message buffer format for setup cmd to COU's (MACAO)
 *
 * keywords:
 *  TEL.TARG.TYPE,
 *  TEL.TARG.ALPHA, TEL.TARG.DELTA,
 *  COU.AG.GSSOURCE,
 *  COU.AG.ALPHA, COU.AG.DELTA
 *  COU.GS.MAG, COU.ACQ.SAFE
 */
#define issprsSETUP_FORM_COU_AO ",,%s %s %s %f %s %f %s %s %s %f %s %f %s %f %s %s"

/*
 * Message buffer format for setup cmd to AT's & SID's
 *
 * keywords:
 *  TEL.TARG.TYPE,
 *  TEL.TARG.ALPHA, TEL.TARG.DELTA,
 *  TEL.AG.GUIDESTAR,
 *  COU.GUID.RA, COU.GUID.DEC
 *  COU.STP.NDFIDX
 */
#define issprsSETUP_FORM_AT   ",,%s %s %s %f %s %f %s %s %s %f %s %f %s %d"

/*
 * Message buffer format for setup cmd to AT's & SID's
 *
 * keywords:
 *  TEL.TARG.TYPE,
 *  TEL.TARG.ALPHA, TEL.TARG.DELTA,
 *  TEL.AG.GUIDESTAR,
 *  COU.GUID.RA, COU.GUID.DEC
 */
#define issprsSETUP_FORM_SID  ",,%s %s %s %f %s %f %s %s %s %f %s %f"

/*
 * Message buffer format for setup cmd to DLCS
 *
 * keywords:
 *  DEL.TARG.TYPE,
 *  TEL.TARG.ALPHA, TEL.TARG.DELTA,
 *  TEL.AG.GUIDESTAR
 *
 */
#define issprsSETUP_FORM_DLCS  ",,%s %s %s %f %s %f %s %s"

/*
 * Message buffer format2 for setup cmd to DLCS (for OPTDLCS)
 *
 * keywords:
 *  DEL.TARG.TYPE,
 *  TEL.TARG.ALPHA, TEL.TARG.DELTA
 *
 */
#define issprsSETUP_FORM2_DLCS  ",,%s %s %s %f %s %f"

/*
 * DB names of attributes used by OFFSGUV command (issprsBroadcast)
 */
#define issprsDB_TRANSF_MAT     "matrix"
#define issprsPAR_X_WITH_BC     "paramXwithBC"
#define issprsPAR_X_NO_BC       "paramXnoBC"
#define issprsPAR_S_LOC_NORTH   "paramSlocNorth"
#define issprsPAR_S_LOC_SOUTH   "paramSlocSouth"
#define issprsACCU_UVW_OFFS     "offsets.uvwOffsets"
#define issprsMAX_OFFSETS       "offsets.maxSteps"
#define issprsINSTR_GUV_OFFS    "offsets.instrGuvOffsets"


/* Defines for issprsBroadcast */
#define issprsLOC_NORTH     0
#define issprsLOC_SOUTH     1

/* Defines for write flag of issprs for predPos */
#define issprsNOT_WRITING   0
#define issprsWRITING       1
#define issprsMAX_WRCHK_RETRY   50

/*
 * Defines for the SETUP command
 */
#define issprsNUM_TEL_TYPES         3               /* SID, UT, AT */

#define issprsTEL_TYPE_NONE         0
#define issprsTEL_TYPE_SID          1
#define issprsTEL_TYPE_UT           2
#define issprsTEL_TYPE_AT           3
#define issprsTEL_TYPE_MIX          4

#define issprsTEL_TYPE_STR_NONE     ""
#define issprsTEL_TYPE_STR_SID      "SID"
#define issprsTEL_TYPE_STR_UT       "UT"
#define issprsTEL_TYPE_STR_AT       "AT"
#define issprsTEL_TYPE_STR_MIX      "MIX"

/* Database attributes */
#define issprsDB_GUIDE_TYPE_TABLE   "guideTypeTab"
#define issprsDB_NASMYTH_DEVICE     "nasmythDevice"
#define issprsDB_FR_SENSOR_PT       ":subSystems:wdline:fringeTracker"
#define issprsDB_FRINGE_SENSOR      "ftSensor"
#define issprsDB_REF_RA             "refRa"
#define issprsDB_REF_DEC            "refDec"
#define issprsDB_CURR_SLOT          "currSlot"
#define issprsDB_FIELD_ROT_ANG_PRE  "isstrkws:data.imageRotBeam"
#define issprsDB_LOCAL_DEC2000      "coord.decLocalTel2000"
#define issprsDB_IRIS_GUIDING       "subSystems:waral:iris.guidingState"

/* Defines for setup of ARAL subsystem */
#define issprsARAL_SUBST_DET1       "ISS.DET1."
#define issprsARAL_SUBST_LEO        "ISS.LEO."
#define issprsARAL_SUBST_IAS        "ISS.IAS."
#define issprsARAL_SUBST_ARAL       "ISS.ARAL."
#define issprsARAL_LEAVE_TEL_CHOP   "TEL.CHOP."

/* Length of the above defines, not to be used in '.db' and '.class' files */
#define issprsARAL_SUBST_DET1_LEN   ::strlen(issprsARAL_SUBST_DET1)
#define issprsARAL_SUBST_LEO_LEN    ::strlen(issprsARAL_SUBST_LEO)
#define issprsARAL_SUBST_IAS_LEN    ::strlen(issprsARAL_SUBST_IAS)
#define issprsARAL_SUBST_ARAL_LEN   ::strlen(issprsARAL_SUBST_ARAL)
#define issprsARAL_LEAVE_TEL_CHOP_L ::strlen(issprsARAL_LEAVE_TEL_CHOP)


/* Defines for OFFSTEL Handler */
#define issprsSENDER_ID_UNK         0
#define issprsSENDER_ID_STD         1
#define issprsSENDER_ID_UT          2

/* Number of FITS binary producer table records */
#define issprsFITS_BIN_TAB_PROD_RECORDS   22

/* Record number of DLCS in mode switching table */
#define issprsMSW_REC_NUM_OF_DLCS   9

/* Conversion factor from arcsec/lab to arcsec/sky */
#define issprsARCSEC_LAB2SKY        (1.0/444.0)

/*
 * Minimum difference of declination to 90 degree to avoid that tranformation
 * matrix elements grow against infinity. Unit is degrees with floating
 * decimals (not DDMMSS.SS)
 */
#define issprsEPS_DEC_OFFGP     1.0e-10

#endif /* !issprsDEFINES_H */
