#ifndef ISSTRKWS_H
#define ISSTRKWS_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: isstrkws.h,v 2.23 2005/06/18 20:24:54 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* jott     2005-06-06 SPR VLTSW20040333:
*                     Added members angTxTy to structure isstrkwsPROJ_BL,
*                     added type isstrkwsXyzCoords
* jott     2005-02-11 SPR VLTSW20050036:
*                     Added structure isstrkwsMACAO_QUAL_CTRL,
*                     added enumeration isstrkwsPHYS_MACAO_ID,
*                     added external declarations 'isstrkwsPhysMacaoToCouIndexInMsw[4][2]',
*                     'isstrkwsPhysMacaoToUtName[4][2]'
* jott     2004-06-23 SPR VLTSW20040164:
*                     Added member chopGuide to structures isstrkwsTEL_DATA and
*                     isstrkwsINFO,
*                     added chopGuideId to enumeration isstrkwsSbsDataId,
*                     added member guide to structure isstrkwsCHOP
* jott     2004-05-14 Added enumeration members dlcsOplOffs3Id to
*                     isstrkwsDelDataId,
*                     Renamed member 'value' to 'opl' and added member 'oplOffset'
*                     to isstrkwsDELAY_DATA,
*                     Added members oplXOffset to structure isstrkwsLOG_DELAY,
*                     Added member dlcsOplOffsets to struct isstrkwsINFO,
*                     (SPR VLTSW20040089)
* jott     2004-04-22 added enumerations isstrkwsTEL_ATTR_INDEX and
*                     isstrkwsMSW_MOD_INDEX to continue solving
*                     SPR VLTSW20040055
* jott     2004-03-19 added elements 'adaptOptCycleId' to enumeration
*                     'isstrkwsSbsDataId' and 'adaptOptCycle' to structures
*                     'isstrkwsINFO' and 'isstrkwsTEL_DATA'
* jott     2004-03-16 Added element guidingMode to struct isstrkwsTEL_DATA to
*                     allow UT Nasmyth guiding (SPR VLTSW20040055)
* jott     2004-02-12 Added support for delay lines 4 to 6 (SPR VLTSW20030502)
* jott     2003-11-14 Added element skipErrLogTime to structure isstrkwsCFG to
*                     make suppression of error flooding more comfortable,
*                     done inn course of SPR VLTSW20030427.
* rrollf    12/08/03  Extended pupilRot to pupilRotBeamX (SPR VLTSW20030273)
*                     Added data structure isstrkwsIMG_PUP_ROT_DATA
*                     Moved isstrkwsStationNameMap to issMap as
*                     issStationNameMap
*                     Updated isstrkwsSbsDataId
* rrollf    26/06/03  Extended imageRot to imageRotBeamX (SPR VLTSW20030273)
* jott      03/04/03  SPR VLTSW20030106:
*                     Added refBeam to struct isstrkwsLOG_DELAY, and
*                     dlcsReference to isstrkwsINFO
*                     Added refDl to structure isstrkwsDELAY_DATA
*                     Added isstrkwsDelayLineNameMap
* rrollf    20/11/01  Added isstrkwsPROJ_BL structure to isstrkwsDATA
* rrollf    06/11/01  Use of issMAX_NUM_ARMS instead of isstrkwsMAX_NUM_ARMS
* rrollf    25/10/01  Added ra2000 and dec2000 to isstrkwsDELAY_DATA
*                     Added telRa2000/telDec2000 to isstrkwsACT_POS
*                     and isstrkwsINFO
* rrollf    19/09/01  Removed isstrkwsBAD_QUALITY_FLAGS and added
*                     new structures isstrkwsATTR_INFO and isstrkwsINFO
* rrollf    13/09/01  Added some new attributes have to be monitored
* rrollf    30/04/01  Second version (Version 1 of ISS)
* rrollf    20/02/01  First version
* rrollf    31/01/01  Created
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

#include "mswMOD_LIST.h"
#include "issmswDefines.h"
#include "isstrkwsDefines.h"

extern fndNAME_MAP  isstrkwsDbTelescopeNameMap;
extern fndNAME_MAP  isstrkwsTelescopeNameMap;
extern fndNAME_MAP  isstrkwsDbDelayLineNameMap;
extern fndNAME_MAP  isstrkwsStateNameMap;
extern fndNAME_MAP  isstrkwsInstrNameMap;
extern fndNAME_MAP  isstrkwsModulNameMap;
extern vltUINT8     isstrkwsCfgToMsw[issNUM_PHYSICAL_TEL][3];
extern vltUINT8     isstrkwsUtCouIndexInMsw[4][2];
extern fndNAME_MAP  isstrkwsDelayLineNameMap;
extern fndNAME_MAP  isstrkwsChopGuideNamesMap;
extern vltUINT8     isstrkwsPhysMacaoToCouIndexInMsw[4][2];
extern vltUINT8     isstrkwsPhysMacaoToUtName[4][2];


/* mode switching table from issmsw */
typedef mswMOD_DB_RECORD    isstrkwsMSW_MOD_TABLE[issmswNO_OF_MODULES];

/* arm of VLTI config table */
typedef struct
    {
    vltINT32    telescopeNum;
    vltINT32    telescopeName;
    vltBYTES20  location;
    vltINT32    physDelayLine;
    } isstrkwsVLTI_CFG_FIELDS;

/* VLTI config table */
typedef struct
    {
    isstrkwsVLTI_CFG_FIELDS     arm[issMAX_NUM_ARMS];
    } isstrkwsVLTI_CFG_TABLE;

/*
 * here are some structs for the public database attributes
 */

/* isstrkwsTIMES */
typedef struct
    {
    vltDOUBLE   lst;        /* local sidereal time        */
    vltDOUBLE   utc;        /* universal time coordinates */
    } isstrkwsTIMES;

/* isstrkwsACT_POS */
typedef struct
    {
    vltDOUBLE   ha;         /* target actual hour angle                       */
    vltDOUBLE   ra;         /* target actual right ascension                  */
    vltDOUBLE   dec;        /* target actual declination                      */
    vltDOUBLE   ra2000;     /* right ascension at mean place of J2000         */
    vltDOUBLE   dec2000;    /* declination at mean place of J2000 in ddmmss   */
    vltDOUBLE   telRa2000;  /* right ascension (J2000) only telescopes        */
    vltDOUBLE   telDec2000; /* declination (J2000) only telescopes            */
    vltDOUBLE   ra2000deg;  /* right ascension at mean place of J2000 in deg  */
    vltDOUBLE   dec2000deg; /* declination at mean place of J2000 in deg      */
    vltDOUBLE   alt;        /* telescopes altitude                            */
    vltDOUBLE   az;         /* telescopes azimuth                             */
    vltDOUBLE   prltic;     /* parallactic                                    */
    vltINT32    phRemTrack; /* physical remaining tracking time               */
    vltINT32    remTrack;   /* total remaining tracking time                  */
    vltDOUBLE   dvelra;     /* Diff trak ra [asec/sec]                        */
    vltDOUBLE   dveldec;    /* Diff trak dec [asec/sec]                       */
    } isstrkwsACT_POS;

/* isstrkwsPOSITION */
typedef struct
    {
    isstrkwsACT_POS     actPos;     /* actual position */
    } isstrkwsPOSITION;

/* isstrkwsLOG_DELAY */
typedef struct
    {
    /* Number of max arms attributes */
    vltDOUBLE       opl1;       /* delay line 1 OPL position    */
    vltDOUBLE       opl2;       /* delay line 2 OPL position    */
    vltDOUBLE       opl3;       /* delay line 3 OPL position    */
    vltDOUBLE       opl1Offset; /* delay line 1 OPL offset      */
    vltDOUBLE       opl2Offset; /* delay line 2 OPL offset      */
    vltDOUBLE       opl3Offset; /* delay line 3 OPL offset      */
    vltINT32        refBeam;    /* beam of reference delay line */
    } isstrkwsLOG_DELAY;

/* isstrkwsLOG_TEL */
typedef struct
    {
    /* Number of max arms attributes */
    vltDOUBLE       t1xyz[3];   /* tixyz(0:2):                              */
    vltDOUBLE       t2xyz[3];   /* x, y, z coordinates of the telescope     */
    vltDOUBLE       t3xyz[3];   /* connected with the logical delay line i  */
    } isstrkwsLOG_TEL;

/* isstrkwsPROJ_BL */
typedef struct
    {
    vltDOUBLE   T1T2;    /* projected baseline for telescopes T1 and T2       */
    vltDOUBLE   T1T3;    /* projected baseline for telescopes T1 and T3       */
    vltDOUBLE   T2T3;    /* projected baseline for telescopes T2 and T3       */
    vltDOUBLE   angT1T2; /* projected baseline angle for telescopes T1 and T2 */
    vltDOUBLE   angT1T3; /* projected baseline angle for telescopes T1 and T3 */
    vltDOUBLE   angT2T3; /* projected baseline angle for telescopes T2 and T3 */
    } isstrkwsPROJ_BL;

/* isstrkwsDATA */
typedef struct
    {
    isstrkwsTIMES       times;          /* time values                        */
    isstrkwsPOSITION    position;       /* position of VLTI                   */
    isstrkwsLOG_DELAY   logDelay;       /* logical delay lines                */
    isstrkwsLOG_TEL     logTel;         /* logical telescopes                 */
    isstrkwsPROJ_BL     projBL;         /* projected baselines                */
    vltDOUBLE           airMass;        /* actual airmass                     */
    vltDOUBLE           waveLen;        /* effective wavelength of target     */
    vltDOUBLE           imageRotBeam1;  /* image rotation for VLTI beam #1    */
    vltDOUBLE           imageRotBeam2;  /* image rotation for VLTI beam #2    */
    vltDOUBLE           imageRotBeam3;  /* image rotation for VLTI beam #3    */
    vltDOUBLE           pupilRotBeam1;  /* pupil rotation                     */
    vltDOUBLE           pupilRotBeam2;  /* pupil rotation                     */
    vltDOUBLE           pupilRotBeam3;  /* pupil rotation                     */
    vltDOUBLE           cgsRa2000;      /* RA of current guide star           */
    vltDOUBLE           cgsDec2000;     /* declination of current guide star  */
    vltINT32            cgsMode;        /* Coud guide mode                   */
    vltDOUBLE           cgsMag;         /* magnitude                          */
    vltDOUBLE           cgsWavelen;     /* CGS wave length                    */
    vltLOGICAL          cgsProbeInPos;  /* CGS Probe in pos. (yes or no)      */
    } isstrkwsDATA;

/* isstrkwsCHOP */
typedef struct
    {
    vltDOUBLE           frequency;  /* frequency                       */
    vltINT32            state;      /* chopping status (active or not) */
    vltBYTES32          startTime;  /* start time                      */
    vltDOUBLE           telThrow;   /* amplitude                       */
    vltDOUBLE           pvr;        /* peak valley ratio               */
    vltDOUBLE           posAng;     /* chopping angle                  */
    vltBYTES32          guide;      /* beam to guide while chopping    */
    } isstrkwsCHOP;

/* isstrkwsCFG - configuration branch of isstrkws */
typedef struct
    {
    vltUINT32       pollTime;       /* polling time of isstrkwsControl  */
    vltUINT32       skipErrLogTime; /* number of skipped error logs to  */
                                    /* suppress error flooding          */
    vltUINT32       shadowTime;     /* shadowing time of isstrkwsControl*/
    isstrkwsDATA    data;           /* data of isstrkws                 */
    isstrkwsCHOP    chop;           /* chopping data of isstrkws        */
    } isstrkwsCFG;

/* isstrkwsDELAY_DATA - for delay line data */
typedef struct
    {
    vltINT32    trackingState;                /* tracking state of DLCS     */
    vltINT32    state;                        /* state of DLCS              */
    vltINT32    substate;                     /* substate of DLCS           */
    vltINT32    dlRemtime;                    /* remaining tracking time    */
    vltINT32    motionPhase;                  /* motion phase of DLCS       */
    vltDOUBLE   ra2000;                       /* ra2000 of DLCS             */
    vltDOUBLE   dec2000;                      /* dec2000 of DLCS            */
    vltDOUBLE   opl[issNUM_PHYSICAL_DL];      /* OPLs of delay lines        */
    vltDOUBLE   oplOffs[issNUM_PHYSICAL_DL];  /* OPL offsets of delay lines */
    vltBYTES20  refDl;                        /* reference delay line name  */
    vltDOUBLE   tixyz[issNUM_PHYSICAL_DL][3]; /* xyz of tele. of ph. dli    */
    } isstrkwsDELAY_DATA;


/* struct for telescope data */
typedef struct
    {
    vltDOUBLE   lst;                    /* local sidereal time                */
    vltDOUBLE   utc;                    /* universal time coordinates         */
    vltDOUBLE   ha;                     /* target actual hour angle           */
    vltDOUBLE   ra;                     /* target actual right ascension      */
    vltDOUBLE   dec;                    /* target actual declination          */
    vltDOUBLE   ra2000;                 /* right ascension at mean place      */
    vltDOUBLE   dec2000;                /* declination at mean place of J2000 */
    vltDOUBLE   ra2000deg;              /* right ascension at mean place      */
    vltDOUBLE   dec2000deg;             /* declination at mean place of J2000 */
    vltDOUBLE   alt;                    /* telescopes altitude                */
    vltDOUBLE   az;                     /* telescopes azimuth                 */
    vltDOUBLE   prltic;                 /* parallactic                        */
    vltDOUBLE   remtime;                /* remaining tracking time            */
    vltDOUBLE   airmass;                /* actual airmass                     */
    vltDOUBLE   dvelra;                 /* Diff trak ra [asec/sec]            */
    vltDOUBLE   dveldec;                /* Diff trak dec [asec/sec]           */
    vltDOUBLE   cgsRa2000;              /* right ascension of current gs      */
    vltDOUBLE   cgsDec2000;             /* declination of current guide star  */
    vltINT32    cgsMode;                /* Coud guide mode                   */
    vltDOUBLE   cgsMag;                 /* Coud guide star magnitude         */
    vltDOUBLE   cgsWavelen;             /* Coud guide star wavelength        */
    vltLOGICAL  cgsProbeInPos;          /* CGS Probe in pos.                  */
    vltDOUBLE   chopFreq;               /* frequency                          */
    vltINT32    chopStatus;             /* chopping status (active or not)    */
    vltBYTES32  chopStartTime;          /* start time                         */
    vltDOUBLE   chopThrow;              /* amplitude                          */
    vltDOUBLE   chopPeakValleyRatio;    /* peak valley ratio                  */
    vltDOUBLE   chopPosAng;             /* chopping angle                     */
    vltINT32    chopGuide;              /* guiding beam while chopping        */
    vltINT32    guidingState;           /* guiding state of the telescope     */
    vltINT32    guidingMode;            /* guiding mode of the telescope      */
    vltLOGICAL  tcsStateTrack;          /* tracking state of the telescope    */
    vltINT32    adaptOptCycle;          /* flags whether AO cycle M1M2 is OK  */
    } isstrkwsTEL_DATA;


typedef struct
    {
    vltLOGICAL  badQuality;
    vltUINT8    number;
    } isstrkwsATTR_INFO;

/* Flag for Attributes if get bad quality from dbRead */
typedef struct
    {
    isstrkwsATTR_INFO  lst;
    isstrkwsATTR_INFO  utc;
    isstrkwsATTR_INFO  ha;
    isstrkwsATTR_INFO  ra;
    isstrkwsATTR_INFO  dec;
    isstrkwsATTR_INFO  ra2000;
    isstrkwsATTR_INFO  dec2000;
    isstrkwsATTR_INFO  telRa2000;
    isstrkwsATTR_INFO  telDec2000;
    isstrkwsATTR_INFO  ra2000deg;
    isstrkwsATTR_INFO  dec2000deg;
    isstrkwsATTR_INFO  alt;
    isstrkwsATTR_INFO  az;
    isstrkwsATTR_INFO  prltic;
    isstrkwsATTR_INFO  remtime;
    isstrkwsATTR_INFO  airmass;
    isstrkwsATTR_INFO  dvelra;
    isstrkwsATTR_INFO  dveldec;
    isstrkwsATTR_INFO  cgsRa2000;
    isstrkwsATTR_INFO  cgsDec2000;
    isstrkwsATTR_INFO  cgsMode;
    isstrkwsATTR_INFO  cgsMag;
    isstrkwsATTR_INFO  cgsWavelen;
    isstrkwsATTR_INFO  cgsProbeInPos;
    isstrkwsATTR_INFO  chopFreq;
    isstrkwsATTR_INFO  chopStatus;
    isstrkwsATTR_INFO  chopStartTime;
    isstrkwsATTR_INFO  chopThrow;
    isstrkwsATTR_INFO  chopPeakValleyRatio;
    isstrkwsATTR_INFO  chopPosAng;
    isstrkwsATTR_INFO  chopGuide;
    isstrkwsATTR_INFO  guidingState;
    isstrkwsATTR_INFO  guidingMode;
    isstrkwsATTR_INFO  tcsStateTrack;
    isstrkwsATTR_INFO  adaptOptCycle;
    isstrkwsATTR_INFO  dlcsTrkOk;
    isstrkwsATTR_INFO  dlcsState;
    isstrkwsATTR_INFO  dlcsSubstate;
    isstrkwsATTR_INFO  dlcsRemtime;
    isstrkwsATTR_INFO  dlcsMotionPhase;
    isstrkwsATTR_INFO  dlcsReference;
    isstrkwsATTR_INFO  dlcsData[issNUM_PHYSICAL_DL];
    isstrkwsATTR_INFO  dlcsOplOffsets[issNUM_PHYSICAL_DL];
    isstrkwsATTR_INFO  tixyz[issNUM_PHYSICAL_DL];
    } isstrkwsINFO;

typedef enum
    {
    lstId,
    utcId,
    haId,
    raId,
    decId,
    ra2000Id,
    dec2000Id,
    ra2000degId,
    dec2000degId,
    altId,
    azId,
    prlticId,
    remtimeId,
    airmassId,
    dvelraId,
    dveldecId,
    cgsRa2000Id,
    cgsDec2000Id,
    cgsModeId,
    cgsMagId,
    cgsWavelenId,
    cgsProbeInPosId,
    chopFreqId,
    chopStatusId,
    chopStartTimeId,
    chopThrowId,
    chopPeakValleyRatioId,
    chopPosAngId,
    chopGuideId,
    guidingStateId,
    guidingModeId,
    tcsStateTrackId,
    adaptOptCycleId
    } isstrkwsSbsDataId;

typedef enum
    {
    dlcsTrackingStateId,
    dlcsStateId,
    dlcsSubstateId,
    dlcsRemtimeId,
    dlcsMotionPhaseId,
    dlcsRa2000Id,
    dlcsDec2000Id,
    dlcsOpl1Id,
    dlcsOpl2Id,
    dlcsOpl3Id,
    dlcsOpl4Id,
    dlcsOpl5Id,
    dlcsOpl6Id,
    dlcsOplOffs1Id,
    dlcsOplOffs2Id,
    dlcsOplOffs3Id,
    dlcsOplOffs4Id,
    dlcsOplOffs5Id,
    dlcsOplOffs6Id,
    dlcsRefBeamId,
    t1xyzId,
    t2xyzId,
    t3xyzId,
    t4xyzId,
    t5xyzId,
    t6xyzId
    } isstrkwsDelDataId;

/* Structs for attribute lists for better handling the read of telescope data */
typedef struct
    {
    vltLOGICAL      active;
    dbSYMADDRESS    addr;
    vltUINT16       offset;
    vltUINT8        size;
    } isstrkwsAttrEntry;

typedef struct
    {
    vltUINT8        telescopeId;
    isstrkwsAttrEntry attr[isstrkwsNUM_OF_TEL_ATTR];
    } isstrkwsTelAttrList;

typedef struct
    {
    isstrkwsAttrEntry attr[isstrkwsNUM_OF_DEL_ATTR];
    } isstrkwsDelAttrList;

typedef struct
    {
    vltDOUBLE   u;
    vltDOUBLE   v;
    vltDOUBLE   w;
    } isstrkwsUvwCoords;

typedef struct
    {
    vltDOUBLE   x;
    vltDOUBLE   y;
    vltDOUBLE   z;
    } isstrkwsXyzCoords;

/*
 * Data structure for computing the image rotation and pupil rotation
 * with function GetImgPupRot(isstrkwsIMG_PUP_ROT_DATA* data)
 */
typedef struct
    {
    vltDOUBLE  alt;         /* IN  */
    vltDOUBLE  az;          /* IN  */
    vltDOUBLE  paralactic;  /* IN  */
    vltUINT8   teleType;    /* IN  */
    vltLOGICAL isNorthOfDl; /* IN  */
    vltDOUBLE  imageRot;    /* OUT */
    vltDOUBLE  pupilRot;    /* OUT */
    } isstrkwsIMG_PUP_ROT_DATA;

/*
 * Enumeration values representing the index of the specified telescope/guiding
 * system within the table of subsystem attributes:
 * -> isstrkwsTelAttrList listOfTelAttr[isstrkwsMAX_NUM_TELESCOPES]
 */
typedef enum
    {
    isstrkwsATTR_INDEX_SID1 = 0,
    isstrkwsATTR_INDEX_SID2,
    isstrkwsATTR_INDEX_UT1,
    isstrkwsATTR_INDEX_UT2,
    isstrkwsATTR_INDEX_UT3,
    isstrkwsATTR_INDEX_UT4,
    isstrkwsATTR_INDEX_AT1,
    isstrkwsATTR_INDEX_AT2,
    isstrkwsATTR_INDEX_AT3,
    isstrkwsATTR_INDEX_COU1,
    isstrkwsATTR_INDEX_COU2,
    isstrkwsATTR_INDEX_COU3,
    isstrkwsATTR_INDEX_COU4
    } isstrkwsTEL_ATTR_INDEX;

/*
 * Enumeration values representing the index of the UT telescope/guiding
 * systems within the mode switching table.
 */
typedef enum
    {
    isstrkwsMSW_INDEX_UT1   = 2,
    isstrkwsMSW_INDEX_UT2,
    isstrkwsMSW_INDEX_UT3,
    isstrkwsMSW_INDEX_UT4,
    isstrkwsMSW_INDEX_COU1  = 10,
    isstrkwsMSW_INDEX_COU2,
    isstrkwsMSW_INDEX_COU3,
    isstrkwsMSW_INDEX_COU4
    } isstrkwsMSW_MOD_INDEX;


/*
 * MACAO quality control data
 */
typedef struct
    {
    vltDOUBLE   strehlMean;
    vltDOUBLE   strehlRms;
    vltDOUBLE   wfeMean;
    vltDOUBLE   wfeRms;
    vltDOUBLE   encMean;
    vltDOUBLE   encRms;
    vltDOUBLE   fwhmMean;
    vltDOUBLE   fwhmRms;
    vltDOUBLE   L0Mean;
    vltDOUBLE   L0Rms;
    vltDOUBLE   r0Mean;
    vltDOUBLE   r0Rms;
    vltDOUBLE   t0Mean;
    vltDOUBLE   t0Rms;
    vltLOGICAL  dataValid;
    } isstrkwsMACAO_QUAL_CTRL;

/*
 * Enumeration for physical UT MACAO systems
 */
typedef enum
    {
    isstrkwsPHYS_MACAO_1 = 0,
    isstrkwsPHYS_MACAO_2,
    isstrkwsPHYS_MACAO_3,
    isstrkwsPHYS_MACAO_4
    } isstrkwsPHYS_MACAO_ID;

#endif /*!ISSTRKWS_H*/
/* __oOo__ */
