#ifndef isstrkwsDEFINES_H
#define isstrkwsDEFINES_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: isstrkwsDefines.h,v 2.23 2005/06/18 20:24:54 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* jott     2005-06-06 SPR VLTSW20050606:
*                     Added definitions isstrkwsDATA_PROJBL_ATxTy
* jott     2005-04-19 SPR VLTSW20050128:
*                     Added definitions isstrkwsDB_QUERY_POINT,
*                     isstrkwsMSG_CHANGE_ALL, isstrkwsCMD_GETWCS
* jott     2005-03-23 SPR VLTSW20040276:
*                     Added definitions isstrkwsDB_MOON_TRACK_POINT,
*                     isstrkwsDB_MOON_COORD_POINT
* jott     2005-02-18 SPR VLTSW20050036:
*                     Added definition isstrkwsCMD_WAITMV
* jott     2005-02-14 SPR VLTSW20050036:
*                     Added definitions isstrkwsDB_MACAO_POINT,
*                     isstrkwsDB_MACAO_QAL_PREFIX
* jott     2004-08-05 Added definition isstrkwsUSE_SCANNED_PARALLACTIC_ANGLES
*                     for a workaround to test SPR VLTSW20040055 at Paranal
* jott     2004-06-23 SPR VLTSW20040164:
*                     Added definition isstrkwsCHOP_GUIDE
*                     Increased isstrkwsNUM_OF_TEL_ATTR to 33
* jott     2004-05-14 Increased definition isstrkwsNUM_OF_DEL_ATTR to 26 in
*                     order to provide OPL offsets
*                     added definitions isstrkwsDATA_LOGDL_OPLXOFFS for OPL
*                     offsets in VLTI beam notation
*                     (SPR VLTSW20040089)
* jott     2004-03-19 Mapped isstrkwsMOD_xxx to isstrkwsTELESCOPE_NAME_xxx for
*                     UNKNOWN to COUDE4 to simplify understanding for some
*                     mixed uses.
*                     Increased isstrkwsNUM_OF_TEL_ATTR to 32
* jott     2004-03-16 Increased isstrkwsNUM_OF_TEL_ATTR to 31 to allow Nasmyth
*                     guiding for UTs (SPR VLTSW20040055) and added definitions
*                     isstrkwsUTx_NAS_GUIDING, isstrkwsDB_ATTR_GS_SOURCE
* jott     2004-02-12 Added support for delay lines 4 to 6 (SPR VLTSW20030502)
* jott     2003-11-14 Added definition isstrkwsCFG_SKIP_ERROR_TIME to make
*                     supressing of error flooding more comfortable, done in
*                     course of solving SPR VLTSW20030427
* rrollf    06/08/03  Added definitions isstrkwsGUIDING_OK and isstrkwsOPTICS_OK
*                     Moved isstrkwsNUM_OF_TEL_ATTR and isstrkwsNUM_OF_DEL_ATTR
*                     from module iss to isstrkws
* jott      03/04/03  added definition isstrkwsDATA_LOGDELAY_REF to solve
*                     SPR VLTSW20030106
* jott      11/06/02  adapted to APR2003 and gcc 3.0.4
* rrollf    12/12/01  Added isstrkwsDB_SUBSTATE and defines for state "UNKNOWN"
* rrollf    20/11/01  Added definitions of isstrkwsDATA_PROJBL_T1T2,
*                     isstrkwsDATA_PROJBL_T1T3 and isstrkwsDATA_PROJBL_T2T3
* rrollf    06/11/01  Removed definition of isstrkwsMAX_NUM_ARMS, already
*                     defined in iss.h as issMAX_NUM_ARMS
* rrollf    05/11/01  Removed defines for database address of array config
*                     table, already defined in issarrayDefines.h
* rrollf    13/09/01  New defines for shadowing and autoguiding
* rrollf    30/04/01  Second version (Version 1 of ISS)
* rrollf    20/02/01  First version
* rrollf    31/01/01  Created
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */

#include "evhStates.h"
#include "iss.h"
#include "issSbsDbDefines.h"
#include "issmswDefines.h"

/* eps for double */
#define issEPS 1e-13

/*
 *    Standard OK reply
 */
#define isstrkwsOK_REPLY    "OK"

/*
 * Number of DB addresses of telescope attributes used in isstrkws.C
 * for big table listOfTelAttr
 */
#define isstrkwsNUM_OF_TEL_ATTR 33       /* without imageRot and pupilRot   */
#define isstrkwsNUM_OF_DEL_ATTR 26       /* Number of delay line attributes */

/* Local remapping of some standard states (just for convenience) */
#define isstrkwsSTATE_UNK             evhSTATE_UNK      /* 0 */
#define isstrkwsSTATE_OFF             evhSTATE_OFF      /* 1 */
#define isstrkwsSTATE_LOADED          evhSTATE_LOADED   /* 2 */
#define isstrkwsSTATE_STANDBY         evhSTATE_STANDBY  /* 3 */
#define isstrkwsSTATE_ONLINE          evhSTATE_ONLINE   /* 4 */
#define isstrkwsSTATE_READY           evhSTATE_READY    /* 5 */
#define isstrkwsSTATE_ERROR           evhSTATE_ERROR    /* 6 */
#define isstrkwsSTATE_IDLE            evhSTATE_IDLE     /* 7 */

/* New states. I start from 100 to be shure not to clash */
#define isstrkwsSTATE_STOPPING       101
#define isstrkwsSTATE_PRESETTING     103
#define isstrkwsSTATE_TRACKING       104

/* Defines for name states */
#define    isstrkwsSTATE_STR_UNK        evhSTATE_STR_UNK
#define    isstrkwsSTATE_STR_OFF        evhSTATE_STR_OFF
#define    isstrkwsSTATE_STR_LOADED     evhSTATE_STR_LOADED
#define    isstrkwsSTATE_STR_STANDBY    evhSTATE_STR_STANDBY
#define    isstrkwsSTATE_STR_ONLINE     evhSTATE_STR_ONLINE
#define    isstrkwsSTATE_STR_ERROR      evhSTATE_STR_ERROR
#define    isstrkwsSTATE_STR_READY      evhSTATE_STR_READY
#define    isstrkwsSTATE_STR_IDLE       evhSTATE_STR_IDLE

#define    isstrkwsSTATE_STR_STOPPING   "STOPPING"
#define    isstrkwsSTATE_STR_PRESETTING "PRESETTING"
#define    isstrkwsSTATE_STR_TRACKING   "TRACKING"


/* Module name and database branch */
#define isstrkwsMOD                 "isstrkws"
#define isstrkwsDB_BASE_POINT       "isstrkws"
#define isstrkwsDB_CONTROL_POINT    "control"
#define isstrkwsDB_QUERY_POINT      "query"
#define isstrkwsDB_DATA_POINT       "data"
#define isstrkwsDB_CHOP_POINT       "chop"
#define isstrkwsDB_SUBSTATE         "subState"
#define isstrkwsDB_MACAO_POINT      "macao"
#define isstrkwsDB_MACAO_QAL_PREFIX "qualCtrl"
#define isstrkwsDB_MOON_TRACK_POINT "moon"
#define isstrkwsDB_MOON_COORD_POINT ":tcsmon:control:moonCalc:moon"

/*
 * Maximum number of active telescopes
 * (SID1, SID2, UT1, UT2, UT3, UT4, AT1, AT2, AT3, COU1, COU2, COU3, COU4) */
#define isstrkwsMAX_NUM_TELESCOPES  13

/* Maximum number of lab input channels    */
#define isstrkwsMAX_NUM_INPUT_CHANNELS   8

/*
 * Command definitions
 */
#define isstrkwsCMD_INIT              "INIT"
#define isstrkwsCMD_OFF               "OFF"
#define isstrkwsCMD_ONLINE            "ONLINE"
#define isstrkwsCMD_STANDBY           "STANDBY"
#define isstrkwsCMD_WAITMV            "WAITMV"
#define isstrkwsCMD_GETWCS            "GETWCS"



/* Attribute names of latitude and longitude */
#define isstrkwsLATITUDE    ":Appl_data:VLTI:issarray:data:site.latitude"
#define isstrkwsLONGITUDE   ":Appl_data:VLTI:issarray:data:site.longitude"

/* Attribute name for guide star source */
#define isstrkwsDB_ATTR_GS_SOURCE     "issprs.guideStarSource"

/* Attribute names of isstrkws cfg data */
#define isstrkwsCFG_DD_TIMES_LST      "cfg:dataDelta:times.lst"
#define isstrkwsCFG_DD_TIMES_UTC      "cfg:dataDelta:times.utc"
#define isstrkwsCFG_DD_POS_HA         "cfg:dataDelta:position:actPos.HA"
#define isstrkwsCFG_DD_POS_RA         "cfg:dataDelta:position:actPos.RA"
#define isstrkwsCFG_DD_POS_DEC        "cfg:dataDelta:position:actPos.dec"
#define isstrkwsCFG_DD_POS_RA2000     "cfg:dataDelta:position:actPos.RA2000"
#define isstrkwsCFG_DD_POS_DEC2000    "cfg:dataDelta:position:actPos.dec2000"
#define isstrkwsCFG_DD_POS_TELRA2000  "cfg:dataDelta:position:actPos.telRA2000"
#define isstrkwsCFG_DD_POS_TELDEC2000 "cfg:dataDelta:position:actPos.telDec2000"
#define isstrkwsCFG_DD_POS_RA2000DEG  "cfg:dataDelta:position:actPos.RA2000Deg"
#define isstrkwsCFG_DD_POS_DEC2000DEG "cfg:dataDelta:position:actPos.dec2000Deg"
#define isstrkwsCFG_DD_POS_ALT        "cfg:dataDelta:position:actPos.alt"
#define isstrkwsCFG_DD_POS_AZ         "cfg:dataDelta:position:actPos.az"
#define isstrkwsCFG_DD_POS_PRLTIC     "cfg:dataDelta:position:actPos.prltic"
#define isstrkwsCFG_DD_POS_DVELRA     "cfg:dataDelta:position:actPos.dvelra"
#define isstrkwsCFG_DD_POS_DVELDEC    "cfg:dataDelta:position:actPos.dveldec"
#define isstrkwsCFG_DD_LOGDELAY_OPL1  "cfg:dataDelta:logDelay.opl1"
#define isstrkwsCFG_DD_LOGDELAY_OPL2  "cfg:dataDelta:logDelay.opl2"
#define isstrkwsCFG_DD_LOGDELAY_OPL3  "cfg:dataDelta:logDelay.opl3"

#define isstrkwsCFG_DD_AIRMASS        "cfg:dataDelta.airMass"
#define isstrkwsCFG_DD_IMAGEROT       "cfg:dataDelta.imageRot"
#define isstrkwsCFG_DD_PUPILROT       "cfg:dataDelta.pupilRot"
#define isstrkwsCFG_DD_CGSRA2000      "cfg:dataDelta.cgsRA2000"
#define isstrkwsCFG_DD_CGSDEC2000     "cfg:dataDelta.cgsDEC2000"
#define isstrkwsCFG_DD_CGSMODE        "cfg:dataDelta.cgsMode"
#define isstrkwsCFG_DD_CGSMAG         "cfg:dataDelta.cgsMag"
#define isstrkwsCFG_DD_CGSWAVELEN     "cfg:dataDelta.cgsWavelen"
#define isstrkwsCFG_DD_CGSPIP         "cfg:dataDelta.cgsProbeInPos"
#define isstrkwsCFG_CD_FREQUENCY      "cfg:chopDelta.frequency"
#define isstrkwsCFG_CD_STATE          "cfg:chopDelta.state"
#define isstrkwsCFG_CD_STARTTIME      "cfg:chopDelta.startTime"
#define isstrkwsCFG_CD_THROW          "cfg:chopDelta.throw"
#define isstrkwsCFG_CD_PVR            "cfg:chopDelta.pvr"
#define isstrkwsCFG_CD_POSANG         "cfg:chopDelta.posAng"
#define isstrkwsCFG_POLLTIME          "cfg.pollTime"
#define isstrkwsCFG_SKIP_ERROR_TIME   "cfg.skipErrLogTime"
#define isstrkwsCFG_SHADOWTIME        "cfg.shadowTime"

/* Attribute names of isstrkws data */
#define isstrkwsDATA_TIMES_LST        "data:times.lst"
#define isstrkwsDATA_TIMES_UTC        "data:times.utc"
#define isstrkwsDATA_POS_HA           "data:position:actPos.HA"
#define isstrkwsDATA_POS_RA           "data:position:actPos.RA"
#define isstrkwsDATA_POS_DEC          "data:position:actPos.dec"
#define isstrkwsDATA_POS_RA2000       "data:position:actPos.RA2000"
#define isstrkwsDATA_POS_DEC2000      "data:position:actPos.dec2000"
#define isstrkwsDATA_POS_TELRA2000    "data:position:actPos.telRA2000"
#define isstrkwsDATA_POS_TELDEC2000   "data:position:actPos.telDec2000"
#define isstrkwsDATA_POS_RA2000DEG    "data:position:actPos.RA2000Deg"
#define isstrkwsDATA_POS_DEC2000DEG   "data:position:actPos.dec2000Deg"
#define isstrkwsDATA_POS_ALT          "data:position:actPos.alt"
#define isstrkwsDATA_POS_AZ           "data:position:actPos.az"
#define isstrkwsDATA_POS_PRLTIC       "data:position:actPos.prltic"
#define isstrkwsDATA_POS_PHREMTRACK   "data:position:actPos.phRemTrack"
#define isstrkwsDATA_POS_SHREMTRACK   "data:position:actPos.shRemTrack"
#define isstrkwsDATA_POS_REMTRACK     "data:position:actPos.remTrack"
#define isstrkwsDATA_POS_SHADOW       "data:position:actPos.shadow"
#define isstrkwsDATA_POS_DVELRA       "data:position:actPos.dvelra"
#define isstrkwsDATA_POS_DVELDEC      "data:position:actPos.dveldec"
#define isstrkwsDATA_LOGDELAY_OPL1    "data:logDelay.opl1"
#define isstrkwsDATA_LOGDELAY_OPL2    "data:logDelay.opl2"
#define isstrkwsDATA_LOGDELAY_OPL3    "data:logDelay.opl3"
#define isstrkwsDATA_LOGDL_OPL1OFFS   "data:logDelay.opl1Offset"
#define isstrkwsDATA_LOGDL_OPL2OFFS   "data:logDelay.opl2Offset"
#define isstrkwsDATA_LOGDL_OPL3OFFS   "data:logDelay.opl3Offset"
#define isstrkwsDATA_LOGDELAY_REF     "data:logDelay.refBeam"
#define isstrkwsDATA_LOGTEL_T1XYZ     "data:logTel.t1xyz"
#define isstrkwsDATA_LOGTEL_T2XYZ     "data:logTel.t2xyz"
#define isstrkwsDATA_LOGTEL_T3XYZ     "data:logTel.t3xyz"
#define isstrkwsDATA_PROJBL_T1T2      "data:projBL.T1T2"
#define isstrkwsDATA_PROJBL_T1T3      "data:projBL.T1T3"
#define isstrkwsDATA_PROJBL_T2T3      "data:projBL.T2T3"
#define isstrkwsDATA_PROJBL_AT1T2     "data:projBL.angT1T2"
#define isstrkwsDATA_PROJBL_AT1T3     "data:projBL.angT1T3"
#define isstrkwsDATA_PROJBL_AT2T3     "data:projBL.angT2T3"
#define isstrkwsDATA_AIRMASS          "data.airMass"
#define isstrkwsDATA_IMAGEROT         "data.imageRot"
#define isstrkwsDATA_PUPILROT         "data.pupilRot"
#define isstrkwsDATA_CGSRA2000        "data.cgsRA2000"
#define isstrkwsDATA_CGSDEC2000       "data.cgsDEC2000"
#define isstrkwsDATA_CGSMODE          "data.cgsMode"
#define isstrkwsDATA_CGSMAG           "data.cgsMag"
#define isstrkwsDATA_CGSWAVELEN       "data.cgsWavelen"
#define isstrkwsDATA_CGSPIP           "data.cgsProbeInPos"
#define isstrkwsCHOP_FREQUENCY        "chop.frequency"
#define isstrkwsCHOP_STATE            "chop.state"
#define isstrkwsCHOP_STARTTIME        "chop.startTime"
#define isstrkwsCHOP_THROW            "chop.throw"
#define isstrkwsCHOP_PVR              "chop.pvr"
#define isstrkwsCHOP_POSANG           "chop.posAng"
#define isstrkwsCHOP_GUIDE            "chop.guide"
#define isstrkwsGUIDINGSTATE          "guidingState"
#define isstrkwsTRACKINGSTATE         "trackingState"
#define isstrkwsGUIDING_OK            "guidingOk"
#define isstrkwsUT1_NAS_GUIDING       "ut1NasGuiding"
#define isstrkwsUT2_NAS_GUIDING       "ut2NasGuiding"
#define isstrkwsUT3_NAS_GUIDING       "ut3NasGuiding"
#define isstrkwsUT4_NAS_GUIDING       "ut4NasGuiding"
#define isstrkwsOPTICS_OK             "opticsOk"

/* Delay lines */
#define isstrkwsDELAYLINE_SYSTEM        "wdline"
#define isstrkwsDELAYLINE_1             issDL_ID_DL1
#define isstrkwsDELAYLINE_2             issDL_ID_DL2
#define isstrkwsDELAYLINE_3             issDL_ID_DL3
#define isstrkwsDELAYLINE_4             issDL_ID_DL4
#define isstrkwsDELAYLINE_5             issDL_ID_DL5
#define isstrkwsDELAYLINE_6             issDL_ID_DL6

#define isstrkwsDELAYLINE_1_DB_STRING   issSBS_DLCS_OPL1
#define isstrkwsDELAYLINE_2_DB_STRING   issSBS_DLCS_OPL2
#define isstrkwsDELAYLINE_3_DB_STRING   issSBS_DLCS_OPL3
#define isstrkwsDELAYLINE_4_DB_STRING   issSBS_DLCS_OPL4
#define isstrkwsDELAYLINE_5_DB_STRING   issSBS_DLCS_OPL5
#define isstrkwsDELAYLINE_6_DB_STRING   issSBS_DLCS_OPL6


#define isstrkwsDL_REM_TRK_TIME         "dlcsState.remTrkTime"
#define isstrkwsDL_TRK_STATE            "dlcsState.trkOkFlag"


/* Defines for offsets and sizes of telescope attributes */
#define isstrkwsOFFS(x)  offsetof(isstrkwsTEL_DATA,x)
#define isstrkwsSIZE(x)  sizeof(((isstrkwsTEL_DATA *)0)->x)

/* Defines for offsets and sizes of delay line attributes */
#define isstrkwsDOFFS(x)  offsetof(isstrkwsDELAY_DATA,x)
#define isstrkwsDSIZE(x)  sizeof(((isstrkwsDELAY_DATA *)0)->x)

/*
 * Telescope name mapping TELESCOPE + GUIDING
 * (this is an other order as in issTELESCOPE_NAME_...
 *  order like in msw table)
 */
#define isstrkwsTELESCOPE_NAME_NONE  0
#define isstrkwsTELESCOPE_NAME_SID1  1
#define isstrkwsTELESCOPE_NAME_SID2  2
#define isstrkwsTELESCOPE_NAME_UT1   3
#define isstrkwsTELESCOPE_NAME_UT2   4
#define isstrkwsTELESCOPE_NAME_UT3   5
#define isstrkwsTELESCOPE_NAME_UT4   6
#define isstrkwsTELESCOPE_NAME_AT1   7
#define isstrkwsTELESCOPE_NAME_AT2   8
#define isstrkwsTELESCOPE_NAME_AT3   9
#define isstrkwsDLCS_NAME           10
#define isstrkwsCOUDE_NAME_UT1      11
#define isstrkwsCOUDE_NAME_UT2      12
#define isstrkwsCOUDE_NAME_UT3      13
#define isstrkwsCOUDE_NAME_UT4      14
/* the strings */
#define isstrkwsTELESCOPE_STRING_NONE   "empty"
#define isstrkwsTELESCOPE_STRING_SID1   "SID1"
#define isstrkwsTELESCOPE_STRING_SID2   "SID2"
#define isstrkwsTELESCOPE_STRING_UT1    "UT1"
#define isstrkwsTELESCOPE_STRING_UT2    "UT2"
#define isstrkwsTELESCOPE_STRING_UT3    "UT3"
#define isstrkwsTELESCOPE_STRING_UT4    "UT4"
#define isstrkwsTELESCOPE_STRING_AT1    "AT1"
#define isstrkwsTELESCOPE_STRING_AT2    "AT2"
#define isstrkwsTELESCOPE_STRING_AT3    "AT3"
#define isstrkwsDLCS_STRING             "DLCS"
#define isstrkwsCOUDE_STRING_UT1        "COU1"
#define isstrkwsCOUDE_STRING_UT2        "COU2"
#define isstrkwsCOUDE_STRING_UT3        "COU3"
#define isstrkwsCOUDE_STRING_UT4        "COU4"
/* and the data base string */
#define isstrkwsTELESCOPE_DB_STRING_NONE    "empty"
#define isstrkwsTELESCOPE_DB_STRING_SID1    "watsid1"
#define isstrkwsTELESCOPE_DB_STRING_SID2    "watsid2"
#define isstrkwsTELESCOPE_DB_STRING_UT1     "wt1tcs"
#define isstrkwsTELESCOPE_DB_STRING_UT2     "wt2tcs"
#define isstrkwsTELESCOPE_DB_STRING_UT3     "wt3tcs"
#define isstrkwsTELESCOPE_DB_STRING_UT4     "wt4tcs"
#define isstrkwsTELESCOPE_DB_STRING_AT1     "wat1tcs"
#define isstrkwsTELESCOPE_DB_STRING_AT2     "wat2tcs"
#define isstrkwsTELESCOPE_DB_STRING_AT3     "wat3tcs"
#define isstrkwsDLCS_DB_STRING              "wdline"
#define isstrkwsCOUDE_DB_STRING_UT1         "wop1"
#define isstrkwsCOUDE_DB_STRING_UT2         "wop2"
#define isstrkwsCOUDE_DB_STRING_UT3         "wop3"
#define isstrkwsCOUDE_DB_STRING_UT4         "wop4"


/* Defines for instrument types of iss */
#define isstrkwsINSTR_TYPE_NONE         0
#define isstrkwsINSTR_TYPE_TELESCOPE    1
#define isstrkwsINSTR_TYPE_GUIDING      2
#define isstrkwsINSTR_TYPE_AO           3
#define isstrkwsINSTR_TYPE_DELAY        4
/* and the strings */
#define isstrkwsINSTR_STR_NONE          ""
#define isstrkwsINSTR_STR_TELESCOPE     "TELESCOPE"
#define isstrkwsINSTR_STR_GUIDING       "GUIDING"
#define isstrkwsINSTR_STR_AO            "AO"
#define isstrkwsINSTR_STR_DELAY         "DELAY"


/* Number of used records (moduls) of mswTable (issmsw) */
#define isstrkwsNO_OF_USED_MSW_MODULES    14

/* Defines for name mapping of modul names (UNDEFINED to COU4 are 0...14 */
#define isstrkwsMOD_UNDEFINED    isstrkwsTELESCOPE_NAME_NONE
#define isstrkwsMOD_SID1         isstrkwsTELESCOPE_NAME_SID1
#define isstrkwsMOD_SID2         isstrkwsTELESCOPE_NAME_SID2
#define isstrkwsMOD_UT1          isstrkwsTELESCOPE_NAME_UT1
#define isstrkwsMOD_UT2          isstrkwsTELESCOPE_NAME_UT2
#define isstrkwsMOD_UT3          isstrkwsTELESCOPE_NAME_UT3
#define isstrkwsMOD_UT4          isstrkwsTELESCOPE_NAME_UT4
#define isstrkwsMOD_AT1          isstrkwsTELESCOPE_NAME_AT1
#define isstrkwsMOD_AT2          isstrkwsTELESCOPE_NAME_AT2
#define isstrkwsMOD_AT3          isstrkwsTELESCOPE_NAME_AT3
#define isstrkwsMOD_DLCS         isstrkwsDLCS_NAME
#define isstrkwsMOD_COU1         isstrkwsCOUDE_NAME_UT1
#define isstrkwsMOD_COU2         isstrkwsCOUDE_NAME_UT2
#define isstrkwsMOD_COU3         isstrkwsCOUDE_NAME_UT3
#define isstrkwsMOD_COU4         isstrkwsCOUDE_NAME_UT4
#define isstrkwsMOD_PRIMA        15
#define isstrkwsMOD_ISSPRS       16
#define isstrkwsMOD_ISSTRKWS     17
#define isstrkwsMOD_ISSMON       18
#define isstrkwsMOD_ISSARRAY     19
#define isstrkwsMOD_ISSALIGN     20
/* the strings */
#define isstrkwsMOD_NAME_UNDEFINED  ""
#define isstrkwsMOD_NAME_SID1       "SID1"
#define isstrkwsMOD_NAME_SID2       "SID2"
#define isstrkwsMOD_NAME_UT1        "UT1"
#define isstrkwsMOD_NAME_UT2        "UT2"
#define isstrkwsMOD_NAME_UT3        "UT3"
#define isstrkwsMOD_NAME_UT4        "UT4"
#define isstrkwsMOD_NAME_AT1        "AT1"
#define isstrkwsMOD_NAME_AT2        "AT2"
#define isstrkwsMOD_NAME_AT3        "AT3"
#define isstrkwsMOD_NAME_DLCS       "DLCS"
#define isstrkwsMOD_NAME_COU1       "COU1"
#define isstrkwsMOD_NAME_COU2       "COU2"
#define isstrkwsMOD_NAME_COU3       "COU3"
#define isstrkwsMOD_NAME_COU4       "COU4"
#define isstrkwsMOD_NAME_PRIMA      "PRIMA"
#define isstrkwsMOD_NAME_ISSPRS     "issprs"
#define isstrkwsMOD_NAME_ISSTRKWS   "isstrkws"
#define isstrkwsMOD_NAME_ISSMON     "issmon"
#define isstrkwsMOD_NAME_ISSARRAY   "issarray"
#define isstrkwsMOD_NAME_ISSALIGN   "issalign"

/* Defines for the shadowing algorithm */
#define isstrkwsNOOF_RAY_RAD_CURR 10
#define isstrkwsNOOF_RAY_ANG_CURR 15
#define isstrkwsNOOF_RAY_RAD_PRED 0
#define isstrkwsNOOF_RAY_ANG_PRED 1

/* this is taken from agwsDefines */
#define isstrkwsAG_STATE_GUIDING    issAG_STATE_GUIDING

/* Time to wait to second trigger of shadow cycle (if VLTI goes TRACKING) */
#define isstrkwsSHADOW_SEC_TRIGGER  5

/*
 * If the flag is set the prallactic angles scanned from TCS databases are
 * taken. Otherwise the parallactic angle is computed using the ISS averaged
 * hour angle
 */
#define isstrkwsUSE_SCANNED_PARALLACTIC_ANGLES  1

/*
 * Value of message buffer if a state changing command shall be forwarded to
 * other isstrkws processes
 */
#define isstrkwsMSG_CHANGE_ALL        "ALL"


#endif /*!isstrkwsDEFINES_H*/

/* __oOo__ */
