#ifndef isstrkwsMACAO_H
#define isstrkwsMACAO_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: isstrkwsMACAO.h,v 2.23 2005/06/18 20:24:55 vltsccm Exp $"
*
* who       when        what
* --------  ----------  ----------------------------------------------
* jott      2005-02-18  Added WaitMvCB() to synchronize with issprs
*                       for MACAO quality data update (SPR VLTSW20050036)
*                       added members mParamList and mWaitForMacaoSystem
* jott      2005-02-11  Created (SPR VLTSW20050036)
*/

/************************************************************************
 * Header file of the class isstrkwsMACAO which tracks changes od MACAO public
 * data
 *----------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif


/* local headers */
#include "cmd.h"
#include "db.h"
#include "eccsEvt.h"
#include "evhTASK.h"
#include "iss.h"
#include "isstrkws.h"


class isstrkwsMACAO : public evhTASK
    {
    public:
        isstrkwsMACAO(const dbSYMADDRESS  dbVltiBasePoint,
                      const dbSYMADDRESS  dbProcBasePoint);
        ~isstrkwsMACAO(void);

        ccsCOMPL_STAT  Init(void);
        ccsCOMPL_STAT  ConfigurationChanged(vltLOGICAL mswTable,
                                            vltLOGICAL configTable);

        evhCB_COMPL_STAT    MacaoDataEventCB(evtEVENT_MSG &msg, void *udata);
        vltUINT32           GetNumMacaoDataEvents(void);

        evhCB_COMPL_STAT    WaitMvCB(msgMESSAGE &msg, void *udata);

    protected:
        ccsCOMPL_STAT   CleanOutputData(void);
        ccsCOMPL_STAT   ReadInputData(isstrkwsPHYS_MACAO_ID macaoId);
        ccsCOMPL_STAT   UpdateOutputData(isstrkwsPHYS_MACAO_ID macaoId);


    private:
        ccsCOMPL_STAT   PrepareDatabaseLists(void);
        ccsCOMPL_STAT   CreateDatabaseEvents(void);
        ccsCOMPL_STAT   DeleteDatabaseEvents(void);
        ccsCOMPL_STAT   GetDirectDbAddresses(void);
        ccsCOMPL_STAT   ReadMswTable(void);
        ccsCOMPL_STAT   ReadConfigTable(void);
        ccsCOMPL_STAT   MapPhysMacaoToBeam(void);


        dbSYMADDRESS                mVltiBasePoint;
        dbSYMADDRESS                mDbProcBasePoint;
        dbSYMADDRESS                mMswTabSymAddr;
        dbSYMADDRESS                mCfgTabSymAddr;
        dbDIRADDRESS                mMswTabDirAddr;
        dbDIRADDRESS                mCfgTabDirAddr;
        dbLISTID                    mBeamMacaoLists[issMAX_NUM_ARMS];
        dbLISTID                    mPhysMacaoLists[issNUM_UT];
        isstrkwsMACAO_QUAL_CTRL     mQualityData[issMAX_NUM_ARMS];
        isstrkwsMACAO_QUAL_CTRL     mMacaoInData[issNUM_UT];
        vltLOGICAL                  mUpdateMswTable;
        vltLOGICAL                  mUpdateConfigTable;
        isstrkwsMSW_MOD_TABLE       mMswTable;
        isstrkwsVLTI_CFG_TABLE      mVltiConfigTable;
        evtEVENT                   *mEvtMacaoData[issNUM_UT];
        int                         mBeamOfMacaoSys[issNUM_UT];
        vltUINT32                   mMacaoDataEventCounter;
        cmdPARAM_LIST               mParamList;
        vltLOGICAL                  mWaitForMacaoSystem[issNUM_UT];
        vltLOGICAL                  mAllMacaoDataReady;
    };

#include "isstrkwsMACAO.icc"

#endif /*!isstrkwsMACAO_H*/
