#ifndef isstrkwsMOON_H
#define isstrkwsMOON_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: isstrkwsMOON.h,v 2.23 2005/06/18 20:24:55 vltsccm Exp $"
*
* who       when        what
* --------  ----------  ----------------------------------------------
* jott      2005-03-23  Created (SPR VLTSW20040276)
*/

/************************************************************************
 * Header file of the class isstrkwsMOON which tracks the distance
 * target - moon
 *----------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif


/* local headers */
#include "db.h"
#include "eccsEvt.h"
#include "evhTASK.h"
#include "evhTIMER.h"
#include "isstrkws.h"


class isstrkwsMOON : public evhTASK
    {
    public:
        isstrkwsMOON(const dbSYMADDRESS  dbVltiBasePoint,
                     const dbSYMADDRESS  dbProcBasePoint);
        ~isstrkwsMOON(void);

        ccsCOMPL_STAT       Init(void);
        evhCB_COMPL_STAT    MoonDistTimerCB(msgMESSAGE &msg, void *udata);
        evhCB_COMPL_STAT    VltiTrackingEventCB(evtEVENT_MSG &msg, void *udata);

    protected:
        ccsCOMPL_STAT       UpdateOutput(ccsCOMPL_STAT status);


    private:
        ccsCOMPL_STAT       PrepareDatabaseAccess(void);
        ccsCOMPL_STAT       ComputeTargetDistance(vltLOGICAL enforce = ccsFALSE);

        dbSYMADDRESS        mVltiBasePoint;
        dbSYMADDRESS        mDbProcBasePoint;

        vltFLOAT            mMoonAlt;
        vltFLOAT            mMoonAz;
        vltDOUBLE           mTargetAlt;
        vltDOUBLE           mTargetAz;
        vltDOUBLE           mTargDistance;
        vltINT32            mUpdateTime;
        vltINT32            mUpdateStatus;
        vltLOGICAL          mVltiTrackingFlag;

        dbLISTID            mInputList;
        dbLISTID            mOutputList;

        evhTIMER           *mDistTimer;

        evtEVENT            mEvtVltiTracking;
    };

#endif /*!isstrkwsMOON_H*/
