#ifndef isstrkwsQUERY_MAIN_H
#define isstrkwsQUERY_MAIN_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: isstrkwsQUERY_MAIN.h,v 2.23 2005/06/18 20:24:55 vltsccm Exp $"
*
* who       when        what
* --------  ----------  ----------------------------------------------
* jott      2005-04-19  Created in framework of SPR VLTSW20050128
*/

/************************************************************************
 * Header file of the isstrkwsQUERY_MAIN class which is the main class of
 * the query command handling process of the ISS tracking module
 *----------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

/* Include error messages */
#include "eccsTestTools.h"
#include "isstrkwsErrors.h"

/* Include parent classes */
#include "evhTIMER.h"
#include "evhHANDLER.h"
#include "evhSTD_COMMANDS.h"
#include "evhCOMMAND.h"
#include "db.h"
#include "isstrkws.h"
#include "isstrkwsQueryTypes.h"
#include "isstrkwsQUERY_WCS.h"


class isstrkwsQUERY_MAIN : public evhSTD_COMMANDS
    {
    public:
        isstrkwsQUERY_MAIN(const dbSYMADDRESS  dbQueryPoint,
                           const dbSYMADDRESS  dbBasePoint);
        ~isstrkwsQUERY_MAIN(void);

        ccsCOMPL_STAT            Init(void);
        ccsCOMPL_STAT            Recover(void);

        /*
         * Standard command callbacks
         */
        virtual evhCB_COMPL_STAT InitCB(msgMESSAGE &msg, void *udata);
        virtual evhCB_COMPL_STAT StatusCB(msgMESSAGE &msg, void *udata);
        virtual evhCB_COMPL_STAT ExitCB(msgMESSAGE &msg, void *udata);
        virtual evhCB_COMPL_STAT VerboseCB(msgMESSAGE &msg, void *udata);

        /*
         * Query commands callbacks
         */
        evhCB_COMPL_STAT         GetwcsCB(msgMESSAGE &msg, void *udata);


        /*
         * Callbacks for database events
         */
        evhCB_COMPL_STAT         DbMswTabEventCB(evtEVENT_MSG &msg, void *udata);
        evhCB_COMPL_STAT         DbCfgTabEventCB(evtEVENT_MSG &msg, void *udata);
        evhCB_COMPL_STAT         VltiGoesTrackingEventCB(evtEVENT_MSG &msg,
                                                         void *udata);

    protected:
        ccsCOMPL_STAT            SubState(vltINT32 subState);
        vltINT32                 SubState();

    private:
        ccsCOMPL_STAT            ReadMswTable(void);
        ccsCOMPL_STAT            ReadConfigTable(void);


        /*
         * Database addresses
         */
        dbSYMADDRESS             mVltiBasePoint;
        dbSYMADDRESS             mDbQueryPoint;

        /*
         * data structures
         */
        isstrkwsMSW_MOD_TABLE    mMswTable;
        isstrkwsVLTI_CFG_TABLE   mVltiConfigTable;

        /*
         * database events
         */
        evtEVENT                 mEvtMswTab;
        evtEVENT                 mEvtCfgTab;

        /*
         * flags
         */
        vltLOGICAL               mNewMswTable;
        vltLOGICAL               mNewVltiConfigTable;

        /*
         * Objects handling individual query commands
         */
        isstrkwsQUERY_WCS        mGetwcs;

    };

#endif /*!isstrkwsQUERY_MAIN_H*/
