#ifndef ixacAPP_CONFIG_H
#define ixacAPP_CONFIG_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: ixacAPP_CONFIG.h,v 1.49 2005/04/08 12:44:31 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* zins		09/06/98  created
* martiny   18/05/99  declared ATTOL class as friend to be able to access
*                     private and protected members for unit test purposes
* gzins     12/07/00  changed oslxSHORT_FITS parent class to oslxCONFIG
* gzins     12/07/00  changed private members to protected
* gzins     17/11/00  removed ATTOL macros
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif
/* 
 * System Headers 
 */

/*
 * VLT Software
 */
#include "oslxCONFIG.h"

/*
 * ISF Headers
 */
#include "ixacHASH.h"


class ixacAPP_CONFIG : public oslxCONFIG
{
  public:
    ixacAPP_CONFIG(const oslxDICTIONARY *dictionary  = NULL, 
                   const oslxALIAS      *aliasTable  = NULL);   
    virtual ~ixacAPP_CONFIG();

    // Give in the list of mandatory keywords
    virtual ccsCOMPL_STAT SetRefList (const char **refList);

    // Load application configuration file
    virtual ccsCOMPL_STAT Load(const char *fileName = NULL);
    virtual ccsCOMPL_STAT Load(oslxSHORT_FITS &shortFits);

    // Set/Reset filter to extract Application Configuration Keywords
    virtual void ClearKeywFilter();

    virtual ccsCOMPL_STAT AddKeywFilter(const slxKEYW_LINE  keyword);

  protected:
    // Look up mandatory keywords according to the refence list
    ccsCOMPL_STAT LookUp();

    // List of mandatory keywords
    ixacHASH        refList_;

    // Filter to extract Application Configuration Keywords from a list of
    // keywords 
    oslxKEYW_FILTER keywFilter_;

  private:
    // Declaration of copy constructor and assignment operator as private 
    // methods, in order to hide them to users.
    ixacAPP_CONFIG& operator=(const ixacAPP_CONFIG&);
    ixacAPP_CONFIG(const ixacAPP_CONFIG&);
    
};

/* Include the code for inline methods */
#include "ixacAPP_CONFIG.icc"

#endif /*!ixacAPP_CONFIG_H*/
