#ifndef ixacARF_MGR_H
#define ixacARF_MGR_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: ixacARF_MGR.h,v 1.49 2005/04/08 12:44:31 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* jknudstr  14/02/99  created
* gzins     12/07/00  changed private members to protected
* gzins     17/11/00  changed private methods to protected
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

#define  ixacARF_DIRECTORY "$INS_ROOT/$INS_USER/DETDATA"

#include "eccsErr.h"
#include "slx.h"
#include "oslxDICTIONARY.h"

class ixacARF_MGR : public eccsERROR_CLASS
{
public:
    ixacARF_MGR(oslxDICTIONARY *dictionary=NULL);
    ~ixacARF_MGR();

    ccsCOMPL_STAT Clear();

    ccsCOMPL_STAT AddMergeTag(const slxFILENAME  targetFile,
                              ...);
    ccsCOMPL_STAT AddAppendTag(const slxFILENAME targetFile,
                               ...);
    ccsCOMPL_STAT AddArchiveTag(const slxFILENAME file1,
                                ...);
    ccsCOMPL_STAT AddRemoveTag(const slxFILENAME file1,
                               ...);
    ccsCOMPL_STAT DeleteArchiveTag();
    ccsCOMPL_STAT WriteProtect(const slxFILENAME fitsFile);
    ccsCOMPL_STAT RemoveWriteProtect(const slxFILENAME fitsFile);

    ccsCOMPL_STAT GenerateArf(const slxFILENAME fileName,
                              vltLOGICAL noArchive=ccsFALSE);

    ccsCOMPL_STAT GetArfs();
    vltINT32      NoOfArfs();
    ccsCOMPL_STAT GetArf(const vltINT32  no, slxFILENAME arf);
    ccsCOMPL_STAT LoadArf(const slxFILENAME arf);
    ccsCOMPL_STAT HandleArf(const slxFILENAME arf, 
                            const char *volacNewDataFileNameDbAttr=NULL);
    ccsCOMPL_STAT BuildArfName(const slxFILENAME fileName,
                               slxFILENAME       completeFileName);
protected:
    ccsCOMPL_STAT AddTag(const char         *tag, 
                          const slxFILENAME  targetFile,
                          va_list            argList);

    ccsCOMPL_STAT DeleteTag(const char *tag);

    ccsCOMPL_STAT CompleteFileName(const slxFILENAME fileName,
                                   slxFILENAME       completeFileName,
                                   vltINT32          fileType);

    oslxDICTIONARY  *dictionary_;

    miscHASH_TABLE  arfTable_;
    vltINT32        arfEntryCount_;

    vltINT32        noOfArfs_;
    miscHASH_TABLE  arfFileTable_;

    slxKEYW_LINE    tmpBuf_;

private:
    // Declaration of copy constructor and assignment operator as private
    // methods, in order to hide them from the users.
    ixacARF_MGR& operator=(const ixacARF_MGR&);
    ixacARF_MGR (const ixacARF_MGR&);

};

#endif /*!ixacARF_MGR_H*/
