#ifndef ixacBITSET_H
#define ixacBITSET_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: ixacBITSET.h,v 1.49 2005/04/08 12:44:31 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* zins      24/09/98  created
* martiny   20/05/99  declared ATTOL class as friend to be able to access
*                     private and protected members for unit test purposes
* gzins     12/07/00  changed private members to protected
* gzins     17/11/00  removed ATTOL macros
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

#include "ccs.h"
#include "eccs.h"

class ixacBITSET: public eccsERROR_CLASS 
{
public:
    ixacBITSET();
    virtual ~ixacBITSET();

    virtual ccsCOMPL_STAT Set ();
    virtual ccsCOMPL_STAT Set (vltUINT32 pos, vltLOGICAL val=ccsTRUE);

    virtual ccsCOMPL_STAT Reset ();
    virtual ccsCOMPL_STAT Reset (vltUINT32 pos);

    virtual ccsCOMPL_STAT Flip ();
    virtual ccsCOMPL_STAT Flip (vltUINT32 pos);
    
    virtual vltLOGICAL Test (vltUINT32 pos); 

protected:
    vltUINT32 set;

private:
    // Declaration of copy constructor and assignment operator as private
    // methods, in order to hide them from the users.
    ixacBITSET& operator=(const ixacBITSET&);
    ixacBITSET  (const ixacBITSET&);
};

#endif /*!ixacBITSET_H*/
