#ifndef ixacHASH_H
#define ixacHASH_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: ixacHASH.h,v 1.49 2005/04/08 12:44:32 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* jknudstr  14/02/99  created
* martiny   20/05/99  declared ATTOL class as friend to be able to access
*                     private and protected members for unit test purposes
* gzins     12/07/00  changed private members to protected
* gzins     17/11/00  removed ATTOL macros
* epozna    28/01/02  VLTSW20020060 added RemoveTable
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

#include "eccsErr.h"
#include "miscHash.h"
typedef void(*ixacHASH_DEL_FUNC )(void *elPtr);

class ixacHASH : public eccsERROR_CLASS
{
public:
    ixacHASH();
    ~ixacHASH();

    ccsCOMPL_STAT  FreeTable();
    ccsCOMPL_STAT  DeleteTable();
    ccsCOMPL_STAT  RemoveTable();

    ccsCOMPL_STAT  AddEl(const char      *key,
			 void            **element);
    ccsCOMPL_STAT  DelEl(const char      *key);
    ccsCOMPL_STAT  GetEl(const char      *key,
			 void            **element);
    ccsCOMPL_STAT  AddIntEl(const char      *key,
			    const vltINT32  intVal);
    ccsCOMPL_STAT  GetIntEl(const char      *key,
			    vltINT32        *intVal);
    ccsCOMPL_STAT  GetSeq(const vltLOGICAL  initialize,
			  char              *key,
			  void              **element);

    void SetDeleteElFct(ixacHASH_DEL_FUNC  fct);

protected:
    miscHASH_TABLE  hashTable_;

private:
    char*                  StrDup(const char *string);
    miscHASH_EL*           HashGetHashEl(const miscHASH_TABLE  hashTable, 
					 const char            *key);
    vltUINT32              HashGetValue(const char  *key);
    void                   DeleteEl(void *elPtr);
    ixacHASH_DEL_FUNC      deleteElFunc_;
    
    // Declaration of copy constructor and assignment operator as private
    // methods, in order to hide them from the users.
    ixacHASH& operator=(const ixacHASH&);
    ixacHASH (const ixacHASH&);

};

#endif /*!ixacHASH_H*/
