#ifndef ixacKEYW_HANDLER_H
#define ixacKEYW_HANDLER_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: ixacKEYW_HANDLER.h,v 1.49 2005/04/08 12:44:32 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* martiny   20/05/99  declared ATTOL class as friend to be able to access
*                     private and protected members for unit test purposes
* marteau   19/05/99  created
* gzins     12/07/00  changed private members to protected
* gzins     17/11/00  removed ATTOL macros
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

#include "oslx.h"
#include "ixacKFILT_TRIGGER_LIST.h"

class ixacKEYW_HANDLER: public fndOBJECT, virtual public eccsERROR_CLASS
{
public:

    ixacKEYW_HANDLER();
    virtual ~ixacKEYW_HANDLER();


    virtual ccsCOMPL_STAT AddTrigger(const msgCMD command,
                                     const oslxKEYW_FILTER &keywFilter,
                                     const ixacKFILT_TRIGGER &trigger);

    virtual ccsCOMPL_STAT Dispatch(const msgCMD command,
                                   oslxSHORT_FITS &keywordList);

    fndStdObjectDef(ixacKEYW_HANDLER, fndOBJECT);

protected:
    ixacKFILT_TRIGGER_LIST   keywTriggerList;
    
private:
    // Declaration of copy constructor and assignment operator as private
    // methods, in order to hide them from the users.
    ixacKEYW_HANDLER& operator=(const ixacKEYW_HANDLER&);
    ixacKEYW_HANDLER (const ixacKEYW_HANDLER&);
};


#endif /*! ixacKEYW_HANDLER_H */
