#ifndef ixacKFILT_KEY_H
#define ixacKFILT_KEY_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: ixacKFILT_KEY.h,v 1.49 2005/04/08 12:44:33 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* martiny   20/05/99  declared ATTOL class as friend to be able to access
*                     private and protected members for unit test purposes
* marteau  20/05/99   created
* gzins     12/07/00  changed private members to protected
* gzins     17/11/00  removed ATTOL macros
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

#include <fndOBJECT.h>
#include "oslx.h"


#define  ixacKFILT_KEY_CLASS  (classType)ixacKFILT_KEY::CreateNew

class ixacKFILT_KEY: public fndOBJECT, public eccsERROR_CLASS
{
public:
    
    ixacKFILT_KEY();
    ixacKFILT_KEY(const ixacKFILT_KEY &keyword);
    ixacKFILT_KEY(const oslxKEYW_FILTER &keywordFilter,
                  const msgCMD cmd);

    virtual ~ixacKFILT_KEY();
    
    oslxKEYW_FILTER* GetKeywordFilter() ;
    ixacKFILT_KEY&   SetKeywordFilter(oslxKEYW_FILTER *keywordFilter);
    const char*      GetCommand() const;
    ixacKFILT_KEY&   SetCommand(const msgCMD cmd);

    fndStdObjectDef(ixacKFILT_KEY, fndOBJECT)
    
protected:
    // Declaration of assignment operator as private methods, in order to hide
    // it from the users.
    ixacKFILT_KEY& operator=(const ixacKFILT_KEY&);

    oslxKEYW_FILTER *keywordFilter ;
    msgCMD          command ;
    

}; /* end class ixacKFILT_KEY */

/******************/
/* Inline methods */
/******************/

#include "ixacKFILT_KEY.icc"

#endif /*! ixacKFILT_KEY_H */
