#ifndef ixacKFILT_OBJ_TRIGGER_H
#define ixacKFILT_OBJ_TRIGGER_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: ixacKFILT_OBJ_TRIGGER.h,v 1.49 2005/04/08 12:44:33 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* marteau   27/05/99  created
* gzins     12/07/00  changed private members to protected
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

#include "ixacKFILT_TRIGGER.h"

/* Typedef for the callback proc type */
typedef evhCB_COMPL_STAT (fndOBJECT::*ixacKFILT_TRIGGER_METHOD)
    (const msgCMD command, const oslxKEYW_FILTER &keywFilter,
     oslxSHORT_FITS &keywordList, void* );

class ixacKFILT_OBJ_TRIGGER: public ixacKFILT_TRIGGER
{
public:
    ixacKFILT_OBJ_TRIGGER();
    ixacKFILT_OBJ_TRIGGER(fndOBJECT *obj,
                          const ixacKFILT_TRIGGER_METHOD proc =
                          (ixacKFILT_TRIGGER_METHOD)NULL,
                          void *userData = NULL);
    ixacKFILT_OBJ_TRIGGER(const ixacKFILT_OBJ_TRIGGER &source);

    ixacKFILT_OBJ_TRIGGER &Object(fndOBJECT *obj);
    ixacKFILT_OBJ_TRIGGER &Proc(const ixacKFILT_TRIGGER_METHOD proc) ;

    virtual int IsEqual(const fndOBJECT&) const;

    ixacKFILT_OBJ_TRIGGER &operator =(const ixacKFILT_OBJ_TRIGGER &source);

    virtual evhCB_COMPL_STAT Run(const msgCMD command,
                                 const oslxKEYW_FILTER &keywFilter,
                                 oslxSHORT_FITS &keywordList);
    virtual ixacKFILT_TRIGGER *Clone() const;

    fndStdObjectDef(ixacKFILT_OBJ_TRIGGER, ixacKFILT_TRIGGER)

protected:
    fndOBJECT                 *object;
    ixacKFILT_TRIGGER_METHOD  method;

}; /* end class ixacKFILT_OBJ_TRIGGER */

#include "ixacKFILT_OBJ_TRIGGER.icc"

#endif /*! ixacKFILT_OBJ_TRIGGER_H */
