#ifndef ixacKFILT_TRIGGER_H
#define ixacKFILT_TRIGGER_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: ixacKFILT_TRIGGER.h,v 1.49 2005/04/08 12:44:33 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* marteau   27/05/99  created 
* gzins     12/07/00  changed private members to protected
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

#include <fndOBJECT.h>

#include "eccsMsg.h"
#include "evhCALLBACK.h"
#include "oslx.h"

/* Typedef for the callback proc type */
typedef evhCB_COMPL_STAT (*ixacKFILT_TRIGGER_PROC)
    (const msgCMD command, const oslxKEYW_FILTER &keywFilter,
     oslxSHORT_FITS &keywordList, void* );

#define ixacKFILT_TRIGGER_CLASS (classType)ixacKFILT_TRIGGER::CreateNew

class ixacKFILT_TRIGGER: public fndOBJECT, public eccsERROR_CLASS
{
public:
    ixacKFILT_TRIGGER();
    ixacKFILT_TRIGGER(const ixacKFILT_TRIGGER_PROC procedure,
                      void* userData = NULL);
    ixacKFILT_TRIGGER(const ixacKFILT_TRIGGER &source);

    virtual ~ixacKFILT_TRIGGER();
    
    ixacKFILT_TRIGGER &Proc(const ixacKFILT_TRIGGER_PROC procedure);
    ixacKFILT_TRIGGER &UserData(void *userData);

    virtual int IsEqual(const fndOBJECT&) const;

    ixacKFILT_TRIGGER &operator =(const ixacKFILT_TRIGGER &source);

    virtual evhCB_COMPL_STAT Run(const msgCMD command,
                                 const oslxKEYW_FILTER &keywFilter,
                                 oslxSHORT_FITS &keywordList);
    virtual ixacKFILT_TRIGGER *Clone() const;

    fndStdObjectDef(ixacKFILT_TRIGGER, fndOBJECT)

protected:
    void *UserData() const { return userData; }
    ixacKFILT_TRIGGER_PROC procedure;
    void             *userData;
    
private:
    
};

#include "ixacKFILT_TRIGGER.icc"

#endif /*! ixacKFILT_TRIGGER_H */
