#ifndef ixacTASK_H
#define ixacTASK_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: ixacTASK.h,v 1.49 2005/04/08 12:44:34 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
*  zins     23/03/99  created
*  martiny  19/05/99  declared ATTOL class as friend to be able to access
*                     private and protected members for unit test purposes
*  zins     14/06/99  added '-version' option
* gzins     12/07/00  changed private members to protected
* gzins     17/11/00  removed ATTOL macros
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

#include "evhTASK.h"
#include "evhHANDLER.h"

class ixacTASK : public evhTASK
{
public:
    ixacTASK();
    virtual ~ixacTASK();

    virtual ccsCOMPL_STAT Usage();
    virtual ccsCOMPL_STAT AppUsage();
    virtual ccsCOMPL_STAT ParseOptions(vltINT32 argc, vltINT8 *argv[]);
    virtual ccsCOMPL_STAT ParseAppOptions(vltINT32 argc, vltINT8 *argv[],
                                          vltINT32 *optind);
    virtual vltLOGICAL IsLogOption();
    virtual vltLOGICAL IsVerboseOption();
    virtual vltLOGICAL IsActionOption();
    virtual vltLOGICAL IsTimerOption();

    virtual const char *GetSwVersion();

    virtual vltLOGICAL NoExit();
    virtual void HandleNoExit();
     
    // Callbacks for commands
    virtual evhCB_COMPL_STAT DebugCB   (msgMESSAGE &msg, void *userData);
    virtual evhCB_COMPL_STAT ExitCB    (msgMESSAGE &msg, void *userData);
    virtual evhCB_COMPL_STAT VerboseCB (msgMESSAGE &msg, void *userData);
    virtual evhCB_COMPL_STAT VersionCB (msgMESSAGE &msg, void *userData);

protected:
    vltLOGICAL logOption, verboseOption, actionOption, timerOption;
    vltLOGICAL noExitOption;

private:
    // Declaration of copy constructor and assignment operator as private
    // methods, in order to hide them from the users.
    ixacTASK& operator=(const ixacTASK&);
    ixacTASK (const ixacTASK&);

};

#endif /*! ixacTASK__H */
