#ifndef ixacTIMER_LOGS_H
#define ixacTIMER_LOGS_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: ixacTIMER_LOGS.h,v 1.49 2005/04/08 12:44:34 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* zins      25/09/98  created
* martiny   20/05/99  declared ATTOL class as friend to be able to access
*                     private and protected members for unit test purposes
* gzins     12/07/00  changed private members to protected
* gzins     17/11/00  removed ATTOL macros
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

/* 
 * System Headers
 */
#include <time.h>

/*
 * VLT Software
 */
#include "ccs.h"
#include "eccs.h"
#include "slx.h"


class ixacTIMER_LOGS : public eccsERROR_CLASS
{
public:
    ixacTIMER_LOGS();
    virtual ~ixacTIMER_LOGS();

    ccsCOMPL_STAT         ClkTck();
    virtual ccsCOMPL_STAT Start(const char* actionName, 
                                vltLOGICAL errorIgnored=ccsTRUE);   
    virtual ccsCOMPL_STAT Stop(ccsMODULEID mod, vltINT32 level,
                               const char* actionName,
                               vltLOGICAL errorIgnored=ccsTRUE);
    static  ccsCOMPL_STAT SetLevel(vltINT32 level,
                                   vltLOGICAL change=ccsTRUE);
    virtual ccsCOMPL_STAT Clear();  
    
    
protected: 
   
    static miscHASH_TABLE  actionHashTable;
    static vltLOGICAL      hashTableInitialized;
    static vltINT32        level; 
   

private:

    // Declaration of copy constructor and assignment operator as private
    // methods, in order to hide them from the users.
    ixacTIMER_LOGS& operator=(const ixacTIMER_LOGS&);
    ixacTIMER_LOGS  (const ixacTIMER_LOGS&);

    vltINT32        itClkTck_;
  
};


#endif /*!ixacTIMER_LOGS_H*/
