#ifndef ixacXKEYW_FILTER_H
#define ixacXKEYW_FILTER_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: ixacXKEYW_FILTER.h,v 1.49 2005/04/08 12:44:34 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* martiny   20/05/99  declared ATTOL class as friend to be able to access
*                     private and protected members for unit test purposes
* rondeaux  27/10/98  created
* gzins     12/07/00  changed private members to protected
* gzins     17/11/00  removed ATTOL macros
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

/*
 * VLT headers
 */ 
#include "oslx.h" 
#include "eccsErr.h"

#define KEYW_FILT_MAX_NB  99 // Max nb of keyword filters

class ixacXKEYW_FILTER : public eccsERROR_CLASS
{
public:
    ixacXKEYW_FILTER(const char *keywFiltersLine);
    virtual ~ixacXKEYW_FILTER();

    virtual ccsCOMPL_STAT ExtractKeywFilters(vltLOGICAL extension = ccsTRUE);
    virtual vltINT32      NoExtractedKeywFilters();
    virtual slxKEYW_LINE  &CurrKeywFilterLine();
    virtual ccsCOMPL_STAT NextExtractedKeywFilter
        (const vltLOGICAL init = ccsFALSE);

protected:
    char             *keywFiltersLine;
    slxKEYW_LINE     keywFiltersArray[KEYW_FILT_MAX_NB];
    vltINT32         keywFiltersNb;         // Total nb of filters
    vltINT32         noCurrKeywFilter;      // Current filter number
    slxKEYW_LINE     currKeywFilterLine;    // Current keyword line

private:
    // Declaration of copy constructor and assignment operator as private
    // methods, in order to hide them from the users.
    ixacXKEYW_FILTER& operator=(const ixacXKEYW_FILTER&);
    ixacXKEYW_FILTER (const ixacXKEYW_FILTER&);

    ccsCOMPL_STAT    ExtendFilter(slxKEYW_LINE &filter);
};

#endif /*!ixacXKEYW_FILTER_H*/
