/*************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: lia40cmd.h,v 2.140 2005/10/17 15:16:58 vltsccm Exp $"
*
* who       when      what
*************************************************************************/
/************************************************************************
*									*
*	Loughborough Sound Images plc					*
*	Loughborough Park						*
*	Ashby Road							*
*	Loughborough			Tel   : (+44) 1509 634444	*
*	Leicestershire			Fax   : (+44) 1509 634450	*
*	LE11 3NE							*
*									*
*	Date	    : June 1994						*
*	Filename    : lia40cmd.h					*
*	Description : ioctl() numbers for Solaris 2.x LIA device driver.*
*	Author	    : Geoff Hackworth					*
*									*
*	History								*
*	Date	  Who	Vers	Comments				*
*	xx/06/94  RJG	1.00	created					*
*									*
************************************************************************/

#ifndef _lia40cmd_h
#define _lia40cmd_h

/* 
 * link level ioctls for LIA40 and DBV4x boards:
 * These can only be sent to 'dbv44:[abcd]' and 'dbv42:[ab]' devices
 */

#define LIA40_IOC(n)		(('D' << 8 | n) + 10)	/* to follow on from  */
							/* board level ioctls */

#define LIA_ENABLEGPI		LIA40_IOC(0)	/* DBV44 links only */
#define LIA_DISABLEGPI		LIA40_IOC(1)	/* DBV44 links only */
#define LIA_LEDSTATUS		LIA40_IOC(2)	/* DBV44 links only */
#define LIA_GETGPICOUNT		LIA40_IOC(3)	/* DBV44 links only */
#define LIA_CLRGPICOUNT		LIA40_IOC(4)	/* DBV44 links only */
#define LIA_GETANDCLRGPICOUNT	LIA40_IOC(5)	/* DBV44 links only */
#define LIA_ENABLESIG		LIA40_IOC(6)	/* DBV44 links only */
#define LIA_DISABLESIG		LIA40_IOC(7)	/* DBV44 links only */
#define LIA_SETGPISIG		LIA40_IOC(8)	/* DBV44 links only */

#define LIA_CTLRTYPE		LIA40_IOC(10)
#define LIA_CTLRMINOR		LIA40_IOC(11)
#define LIA_CTLRSITE		LIA40_IOC(12)

/* Board type definitions for values returned from LIA_CTLRTYPE */
#define	BOARD_DBV44		0
#define BOARD_DBV42		1
#endif /* _lia40cmd_h */
