/*************************************************************************
* E.S.O. - VLT project
#
# "@(#) $Id: logCCS.h,v 4.26 2005/10/24 07:59:42 vltsccm Exp $" 
*
* <log.h> - CCS LOGGING SYSTEM Interface File
*
* who        when      what
* ---------  --------  ----------------------------------------------
* B.GILLI    29/04/93  Preliminary version
*    "       27/05/93  logLOC_ID & control of automatic logging
*
* M.COMIN    20/07/93  Typedef  logLOC_ID moved to ccs.h 
*
* M.COMIN    05/01/94  Routine to enable/disable automatic logs moved to
*                      private routines.
*
*                      Routine logData returnes no error structure.
*
* M.COMIN    25/01/94  Modifications according to the design 1.0
*                      - Add format of the log message from LCU
*
* M.COMIN    02/11/94  Add routine logFormatTime
*                      Add declaration for non-POSIX functions
* G.CHIOZZI  07/11/94  Deleted declarations for gettimeofday()
*
*************************************************************************/


/*
 *******************************************************************
 * LOGGING SYSTEM  : Application  Programmer  Routines             *
 *******************************************************************
 */
 


ccsCOMPL_STAT logFormatTime ( /* Formats the current time into ASCII string */
    ccsTIMEVAL   *timeStamp,  /* Time stamp    */
    char         *strTime     /* Time stamp converted in ASCII string */
);


ccsCOMPL_STAT logFormatData (   /* Stores a formatted log in a log file   */
    const ccsMODULEID   moduleId,     /* Module reporting the log.  */
          vltINT16      logId,        /* Log Mnemonic               */
          ccsTIMEVAL   *timeStamp,    /* User Defined time stamp    */
          ...                         /* Parameter list             */    
);

ccsCOMPL_STAT logFormatData_v ( 
    const ccsMODULEID   moduleId,     /* Module reporting the log.  */
          vltINT16      logId,        /* Log Mnemonic               */
          ccsTIMEVAL   *timeStamp,    /* User Defined time stamp    */
          va_list       va_parList    /* Parameter list             */    
    );

/************************************/
/* Here for backward compatibility  */
/************************************/

ccsCOMPL_STAT logFormatData (   /* Stores a formatted log in a log file   */
    const ccsMODULEID   moduleId,     /* Module reporting the log.  */
          vltINT16      logId,        /* Log Mnemonic               */
          ccsTIMEVAL   *timeStamp,    /* User Defined time stamp    */
          ...                         /* Parameter list             */
    );

ccsCOMPL_STAT logFormatData_v (
    const ccsMODULEID   moduleId,     /* Module reporting the log.  */
          vltINT16      logId,        /* Log Mnemonic               */
          ccsTIMEVAL   *timeStamp,    /* User Defined time stamp    */
          va_list       va_parList    /* Parameter list             */
    );


/**************************************************************************
 *    The following function prototypes have been included in order       *
 *    not to have gcc complain ... they are not POSIX functions           *
 **************************************************************************/


void syslog(               /* Programmatic interface to syslogd   */
           int priority,
     const char  *format,
           ...
     );

void closelog(void);

void openlog(
      const char *ident,
            int  option,
            int  facility
      );

/************** end NON POSIX functions ******************/



