#ifndef LQS_ERROR_H
#define LQS_ERROR_H
/******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: lqsError.h,v 2.23 2005/10/11 16:20:37 vltsccm Exp $" 
*
* lqsError.h
*
* who        when       what
* ---------- ---------- ----------------------------------------------
* ---v2.1---
* S.Sandrock 06.10.1994 New comment header
*	     17.10.1994 Added macros 'lqsERRSTR...'
* ---v2.2--- 31.10.1994 ---RELEASED---
*/

/************************************************************************
* Copyright (c) 1992	European  Southern  Observatory			*
*									*
*									*
*			Very Large Telescope Software			*
*			*****************************			*
*									*
*	Subsystem   :	Local Control Unit				*
*									*
*	Module      :	Q Server					*
*									*
*	Component   :	lqsError.h					*
*									*
*	Produced by :	SpaceBel Informatique s.a.			*
*									*
*	Author      :	T. Phan Duc					*
*									*
*	Description :	Literals of Receive and Send errors.		*
*									*
*									*
*	Change history :						*
*									*
*	Author	Date	Version		Description of change		*
*									*
*	Phan  	2Dec92	  0.0		First version			*
*       AWA    12Mar93    1.1           Partly VLT Programming Standard *
*									*
*************************************************************************/

#define lqsERR_PIPE		-10
#define lqsERRSTR_PIPE		"lqsERR_PIPE: generic pipe error"
				/*driver error or id not existing */

#define lqsERR_CLOSE_PIPE	-12
#define lqsERRSTR_CLOSE_PIPE	"lqsERR_CLOSE_PIPE: failed to close pipe"

#define	lqsERR_MSGQ		-20
#define	lqsERRSTR_MSGQ		"lqsERR_MSGQ: generic msgQ error"

#define lqsERR_INV_MSGQ		-21
#define lqsERRSTR_INV_MSGQ	"lqsERR_INV_MSGQ: invalid message queue identifier"

#define lqsERR_NO_MEMORY_MSGQ	-22
#define lqsERRSTR_NO_MEMORY_MSGQ "lqsERR_NO_MEMORY_MSGQ: no memory available to allocate msg"

#define lqsERR_INV_MSG_LENGTH	-23
#define lqsERRSTR_INV_MSG_LENGTH "lqsERR_INV_MSG_LENGTH: invalid msg length"

#define lqsERR_NO_MSG_AVAILABLE	-24
#define lqsERRSTR_NO_MSG_AVAILABLE "lqsERR_NO_MSG_AVAILABLE: no msg available"
				/* (only if NO_WAIT) */

#define lqsERR_TIMEOUT		-25
#define lqsERRSTR_TIMEOUT	"lqsERR_TIMEOUT: no msg available after timeout"

#define lqsERR_LQS_DEAD		-26
#define lqsERRSTR_LQS_DEAD	"lqsERR_LQS_DEAD: lqs is not running"
				/* msg Q has been deleted (lqs died?) */

#define lqsERR_INV_PAR		-30
#define lqsERRSTR_INV_PAR	"lqsERR_INV_PAR: invalid parameter in call"

#define lqsERR_NO_ROOM		-31
#define lqsERRSTR_NO_ROOM	"lqsERR_NO_ROOM: out of memory"

#define lqsERR_NO_COMM_ID	-32
#define lqsERRSTR_NO_COMM_ID	"lqsERR_NO_COMM_ID: process has no comm id"

#define lqsERR_INV_SEM		-33
#define lqsERRSTR_INV_SEM	"lqsERR_INV_SEM: internal semaphore error"

#define lqsERR_ENVIRONMENT	-40
#define lqsERRSTR_ENVIRONMENT	"lqsERR_ENVIRONMENT: no such environment"

#define lqsERR_CONNECTION	-50
#define lqsERRSTR_CONNECTION	"lqsERR_CONNECTION: remote connection error"

#define lqsERR_PROC_NUM		-51
#define lqsERRSTR_PROC_NUM	"lqsERR_PROC_NUM: no such process number"

#define lqsERR_PROC_NAME	-52
#define lqsERRSTR_PROC_NAME	"lqsERR_PROC_NAME: no such process name"


#endif /* !LQS_ERROR_H */
