#ifndef m2com_H
#define m2com_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: m2com.h,v 1.7 2003/12/05 10:29:26 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* tcsmgr  18/10/98  Replaced (phi,theta) with (alpha,delta)
* gchiozzi  13/08/98  Added support for NOCCS.
* gchiozzi  26/06/97  created
*/

/* 
 * If NOCCS is defined, no CCS error handling is provided
 */
#ifdef NOCCS
   #include "miscNoCcs.h"
   #include "m2comErrorsNoCcs.h"
#else
   #include "CCS.h"
   #include "m2comErrors.h"
#endif

/*
 * Module name
 */
#define m2comMOD "m2com"

/**************************************/
/*   Port numbers and types           */
/*                                    */
/*   This are in m2tc.h and are now   */
/*   just copied here for testing     */
/**************************************/

/* #include "m2tc.h" */

#define  M2TC_DEFAULT_TILT_RECV_PORT	8067
#define  M2TC_DEFAULT_BOOK_ID           1

typedef struct {
    vltDOUBLE alpha;
    vltDOUBLE delta;
} m2tcFS_OFFSET;

typedef struct  {
    int bookId; 
    int relative;
    m2tcFS_OFFSET offset;
} m2tcFS_SEND_BUF;

/***********************/
/*  Library functions  */
/***********************/

ccsCOMPL_STAT m2comConnect(int *fd, char *host, ccsERROR *error);
ccsCOMPL_STAT m2comSend(int fd, m2tcFS_SEND_BUF *data, ccsERROR *error);
ccsCOMPL_STAT m2comDisconnect(int fd, ccsERROR *error);


#endif /*!m2com_H*/
