/******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: mac4Defines.h,v 3.15 2005/09/22 15:03:49 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* pduhoux   07/07/95  Created for Release 2.2
* P.Duhoux  06/08/95  Adapted for Release 2.5 (STP support)
*                     - new command mac4CMD_VER : get board version
*                     - new enum type mac4BOARD : board types
*                     - new macro definitions for SW Limits
*                       -> mac4LOWER_SW_MIN_INC/SSI/STP
*                       -> mac4UPPER_SW_MAX_INC/SSI/STP
* P.Duhoux  20/12/95  Adapted for Firmware Release 4.0
*                     Macros for encoder address
*/

#ifndef MAC4_DEFINES_H
#define MAC4_DEFINES_H

/************************************************************************
 * mac4Defines.h - MAC4 definition file
 *----------------------------------------------------------------------*/
/* Maccon Firmware versions */
#define mac4FIRMWARE_312 0x0312
#define mac4FIRMWARE_4XX 0x0400

/* Number of configuration parameters */
#define mac4MAX_PAR_CFG 47

/* Number of runtime parameters */
#define mac4MAX_PAR_RUN 72

/* Number of status words */
#define mac4MAX_PAR_STS 3

/* number of interrupts */
#define mac4MAX_INT     4

/* types for axis */
#define mac4AXIS_OFF          0
#define mac4AXIS_LINEAR       1
#define mac4AXIS_CIRCULAR     2
#define mac4AXIS_CIRCULAR_OPT 3

/* types for encoder */
#define mac4ENCODER_INT_CNT 0       /* STP only */
#define mac4ENCODER_INT_REL 1       /* All      */
#define mac4ENCODER_INT_ABS 2       /* SSI Only */
#define mac4ENCODER_EXT_REL 3       /* All      */
#define mac4ENCODER_EXT_ABS 4       /* All      */

/* min. lower & max. upper SW limits */
#define mac4LOWER_SW_MIN_INC        -1000000000
#define mac4UPPER_SW_MAX_INC         1000000000
#define mac4LOWER_SW_MIN_SSI         0
#define mac4UPPER_SW_MAX_SSI         16777215
#define mac4LOWER_SW_MIN_STP        -10000000
#define mac4UPPER_SW_MAX_STP         10000000

/* min. & max. speed */
#define mac4SPEED_MIN           -250.0e+06
#define mac4SPEED_MAX            250.0e+06

/* types for SSI coding */
#define mac4SSI_BINARY 0
#define mac4SSI_GRAY   1

/* types for polarity */
#define mac4POLARITY_INITIAL 0
#define mac4POLARITY_REVERSE 1

/* types for signal logic : Lower/Upper HW Limit Switches */
/*                          Reference Switches            */
/*                          Drive Fault Signal            */
#define mac4SIGNAL_OFF  0
#define mac4SIGNAL_LOW  1
#define mac4SIGNAL_HIGH 2

/* types for DL values : Define Limit for mac4MODE_FIND */
#define mac4DL_REF 0
#define mac4DL_LOW 1
#define mac4DL_UP  2

/* encoder addresses */
#define mac4ENCODER_BASE_ADDR 0x330A
#define mac4ENCODER_INCR_ADDR 0x0400
#define mac4ENCODER_ADDR_MASK 0x0FFFF

#endif /*!MAC4_DEFINES_H*/

/*************************************************************************/

/*___oOo___*/
