/******************************************************************************
* E.S.O. - VLT project
#
# "@(#) $Id: msgCCS.h,v 2.41 2005/07/28 04:07:01 vltsccm Exp $" 
*
* msgCCS.h
*
* who         when      what
* ---------   --------  -------------------------------------------------------
* B.GILLI     29/04/93  Preliminary version
*    "        27/05/93  for PDR
* A.WALLANDER 21/07/93  error handling, prototypes
* A.WALLANDER 20/08/93  many changes and clarifications after CDR
* J.AYASSE    19/11/93  Declaration of msgStartMon and msgStopMon.
* B.GILLI     10/02/94  Added qsemu.h according to SPR 09/02/94 from Birger.
* B.GILLI     13/09/94  Added msgBODYMAXLEN SPR 940032
* B.GILLI     23/09/94  Added new equivalent Rtap message types.
* T.HERLIN    18/10/94  Added defines for checkflag
* T.HERLIN    21/10/94  Added msgTYPE_SIMREPLY
* B.GILLI     12/11/94  Added msgNO_CHECK
* B.GILLI     14/11/94  Modified union decl. for message structure.SPR 940032
* M.COMIN     21/11/94  Add include file to define error mnemonics
* B.GUSTAFSSON 29/11/94 Created CCS specific include file
* T.EBERT     30/01/95  Modified for integration 
* T.EBERT     31/01/95  Added reply-flag in prototype for msgPing() 
* T.EBERT     26/06/95  Added prototypes of msgCompareProcids()/
*                       msgMonitorQueue()
* T.EBERT     05/03/96  Added prototype of msgSelect()
* T.EBERT     08/05/96  Changed redefinition of _POSIX_C_SOURCE
* T.EBERT     09/05/96  Changed signature of msgSelect(), because
*                       of problems on SUN/HP -> fd_set
*
*----------------------------------------------------------------------------*/
/*
 * <msgCCS.h> - CCS/MESSAGE SYSTEM - Interface File
 */
#ifndef MSGCCS_H
#define MSGCCS_H

/*
 * Include Error Definitions
 */
#include "msgErrors.h"

/*
 * schedule flags
 */ 
#define msgDEFAULT_RUNSTRING  0x01    /* -> rtDEFAULT_RUNSTRING */
#define msgNOTIFY             0x02    /* -> rtNOTIFY            */
#define msgMERGE_RUNSTRING    0x04    /* -> rtMERGE_RUNSTRING   */

/*
 * name of CCS Message System Server
 */
#define msgSERVER          "msgServer"

/* 
 * Functions prototypes 
 */
ccsCOMPL_STAT msgPing  (
    ccsENVNAME   envName,    /* environment name           */
    ccsPROCNAME  procName,   /* process name               */
    vltLOGICAL   reply,      /* reply flag                 */
    ccsERROR    *error       /* Returned error structure   */
    );
    
int msgCompareProcids (
                      msgPROCESSID *id1,
                      msgPROCESSID *id2
                      );

ccsCOMPL_STAT msgMonitorQueue (
                              int        *fd,
                              vltLOGICAL  state,
                              ccsERROR   *error
                              );

ccsCOMPL_STAT msgGetProcIdByName (
                                 const ccsENVNAME   envName,
                                 const ccsPROCNAME  procName,
                                 msgPROCESSID      *procId,
                                 ccsERROR          *error
                                 );

int msgSelect (
              int             width,
              void           *readFds,    
              void           *writeFds, 
              void           *exceptFds, 
              ccsTIMEVAL     *timeOut  
              );


#endif /*!MSGCCS_H*/
