#ifndef mswCHANGE_FOCUS_H
#define mswCHANGE_FOCUS_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: mswCHANGE_FOCUS.h,v 1.126 2005/09/26 14:24:01 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* jargomed  21/02/98  Added focus offset setting
* gchiozzi  14/01/97  Made virtual some more methods
* nttmgr    08/12/96  Overloaded Init() method to read config data from DB
* gchiozzi  31/10/96  Removed DEC95 sections
* gchiozzi  05/07/96  modified to use mswFOCUS class
* gchiozzi  10/05/96  Porting to JUN96 (activated commented sections)
* mverola   03/04/96  Added methods and data to support change focus task
* gchiozzi  30/03/95  created
*/

/************************************************************************
 * NOTE (03/04/96) mverola:
 *       The name of this file has been changed from mswSWITCH_FOCUS.h
 *       to mswCHANGE_FOCUS.h (see ../src/ChangeLog).
 *----------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

#include "eccsErr.h"
#include "evhDB_TASK.h"
#include "evhDB_SYNC.h"

#include "evhDB_CMD_SERIAL.h"

#include "msw.h"
#include "mswMOD_LIST_MANAGER.h"
#include "mswEVAL_STATE.h"
#include "mswFOCUS.h"

#include "tcsBASE.h"

class mswCHANGE_FOCUS : public evhDB_TASK
{
  public:
    mswCHANGE_FOCUS(mswMOD_LIST_MANAGER &listManager);
    mswCHANGE_FOCUS(const dbSYMADDRESS   dbPoint,
                    mswMOD_LIST_MANAGER &listManager);
    ~mswCHANGE_FOCUS();

    // Pure virtual Execute method
    // It must be replaced by the corresponding method
    //  in the derived class (NTT/VLT)
    virtual ccsCOMPL_STAT     Execute(msgMESSAGE &msg) = 0;
    
    ccsCOMPL_STAT             RegisterCallbacks(evhOBJ_CALLBACK okCB,
                                        evhOBJ_CALLBACK errCB);
    virtual vltINT32          CurrentFocus();
    
    virtual ccsCOMPL_STAT     Init();

    virtual ccsCOMPL_STAT     CheckModeSwitchingState(vltINT32 actState,
						      vltINT32 actSubState) = 0;

    vltDOUBLE                 GetFocusOffset(void);
    void                      SetFocusOffset(vltDOUBLE offset);

  protected: 
    virtual mswCHANGE_FOCUS  &CurrentFocus(vltINT32 currFoc);
    virtual ccsCOMPL_STAT     ReadMirrorsPos(vltINT32 *currFoc);

    virtual ccsCOMPL_STAT     CheckPresetToZenith(vltLOGICAL *zenith);

  protected:
    vltDOUBLE            focusOffset;
    mswFOCUS             focus;
    mswMOD_LIST_MANAGER &modListManager;

    msgMESSAGE           chFocusMsg;

    evhOBJ_CALLBACK      chFocusOkCB;
    evhOBJ_CALLBACK      chFocusErrorCB;
};

#include "mswCHANGE_FOCUS.icc"

#endif /*!mswCHANGE_FOCUS_H*/
