#ifndef mswCHANGE_FOCUS_VLT_H
#define mswCHANGE_FOCUS_VLT_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: mswCHANGE_FOCUS_VLT.h,v 1.126 2005/09/26 14:24:01 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* tphan     14/03/99  added trkws
* pduhoux   03/11/98  Removed M1 object since unsused
* gchiozzi  26/11/97  Added ReadMirrorsPos() method
* mverola   03/04/96  Added Execute, EndM3CmdCB, ErrorM3CmdCB
* awalland  07/06/95  created
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

#include "mswCHANGE_FOCUS.h"

#include "mswM3.h"
#include "mswM4.h"
#include "mswADROT.h"
#include "mswADC.h"
#include "mswALT.h"
#include "mswTRKWS.h"

#include "tcsDB_SYNC_ERR_CHECK.h"

#define READY_TIMEOUT     ".readyTimeout"

class mswCHANGE_FOCUS_VLT : public mswCHANGE_FOCUS
{
  public:
    mswCHANGE_FOCUS_VLT(const dbSYMADDRESS  dbName,
			mswMOD_LIST_MANAGER &listManager);
    ~mswCHANGE_FOCUS_VLT();

    virtual ccsCOMPL_STAT  Init();

    // This method overrides the pure virtual parent method
    virtual ccsCOMPL_STAT  Execute(msgMESSAGE &msg);
    virtual ccsCOMPL_STAT  ReadMirrorsPos(vltINT32 *currFoc);
    virtual ccsCOMPL_STAT  CheckModeSwitchingState(vltINT32 actState,
						   vltINT32 actSubState);

  protected:
    evhCB_COMPL_STAT ExecuteCB(msgMESSAGE &msg, void *);

    ccsCOMPL_STAT    FocusStandby();
    evhCB_COMPL_STAT FocusStandbyCB(msgMESSAGE &msg, void *);

    ccsCOMPL_STAT    ParkAdc();
    evhCB_COMPL_STAT ParkAdcCB(msgMESSAGE &msg, void *);

    ccsCOMPL_STAT    SwitchFocus();
    evhCB_COMPL_STAT SwitchFocusCB(msgMESSAGE &msg, void *);

    ccsCOMPL_STAT    FocusOnline();
    evhCB_COMPL_STAT FocusOnlineCB(msgMESSAGE &msg, void *);

    ccsCOMPL_STAT    FocusStatus();
    evhCB_COMPL_STAT FocusStatusCB(msgMESSAGE &msg, void *);

    ccsCOMPL_STAT    InitOnChangeFocus();

    ccsCOMPL_STAT    Focus(vltINT32  focus);
    ccsCOMPL_STAT    Focus(vltINT32 *focus);

    ccsCOMPL_STAT    LoadChangeFocusModules();
    ccsCOMPL_STAT    LoadModuleData(const char *point, 
				    const char *name,
				    const mswMOD_RECORD_ARRAY &modArray);

  protected:
    vltINT32 actFocus,newFocus;

    mswM3   m3;
    mswM4   m4;
    mswADROT adapter;
    mswADC  adc;
    mswALT  alt;
    mswTRKWS  trkws;

    tcsDB_SYNC_ERR_CHECK waitParkAdcReady;
    tcsDB_SYNC_ERR_CHECK waitSwitchFocusReady;
    tcsDB_SYNC_ERR_CHECK waitFocusStatusReady;

  private:
    vltINT32        readyTimeout;

    eccsERROR       executeErrorStack;
    eccsERROR_CLASS executeErrorClass;
};

#endif /*!mswCHANGE_FOCUS_VLT_H*/
