#ifndef mswCONTROL_H
#define mswCONTROL_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: mswCONTROL.h,v 1.126 2005/09/26 14:24:07 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* rkarban 2002-12-13 created
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

#include "msw.h"
#include "evhDB_TASK.h"
#include "evhCOMMAND.h"
#include "evhDB_SYNC.h"
#include "mswMOD_LIST_MANAGER.h"
#include "mswINS_CONFIG_TABLE.h"
#include "mswEVAL_STATE.h"

/* Include with error messages */
#include "eccsTestTools.h"
#include "mswErrors.h"

#include "mswDefines.h"

class mswCONTROL : public evhDB_TASK
{
  public:
    mswCONTROL(mswMOD_LIST_MANAGER &listManager,
                    mswEVAL_STATE       &eval);
    mswCONTROL(const dbSYMADDRESS  dbPoint,
                    mswMOD_LIST_MANAGER &listManager,
                    mswEVAL_STATE       &eval);
    virtual ~mswCONTROL();
                    
    
    virtual ccsCOMPL_STAT Init();  
    ccsCOMPL_STAT Recover();
    
  protected:
    virtual evhCB_COMPL_STAT TcsColdStartCB      (msgMESSAGE &msg, void *udata);
    virtual evhCB_COMPL_STAT TcsStartCB          (msgMESSAGE &msg, void *udata);
    virtual evhCB_COMPL_STAT TcsStopCB           (msgMESSAGE &msg, void *udata);
    virtual evhCB_COMPL_STAT TcsShutdownCB       (msgMESSAGE &msg, void *udata);
    virtual evhCB_COMPL_STAT TcsPauseCB          (msgMESSAGE &msg, void *udata);
    virtual evhCB_COMPL_STAT TcsPresetCB         (msgMESSAGE &msg, void *udata);
    virtual evhCB_COMPL_STAT TcsEndPresetCB      (msgMESSAGE &msg, void *udata);
    virtual evhCB_COMPL_STAT TcsAlignCB          (msgMESSAGE &msg, void *udata);
    virtual evhCB_COMPL_STAT TcsEndAlignCB       (msgMESSAGE &msg, void *udata);

    // Overloading of inherited commands
    virtual evhCB_COMPL_STAT ExitCB(msgMESSAGE &msg, void *udata);
    virtual evhCB_COMPL_STAT InitCB(msgMESSAGE &msg, void *udata);
    virtual evhCB_COMPL_STAT MswDoneCB(msgMESSAGE &msg, void *udata);
    virtual evhCB_COMPL_STAT MswErrorCB(msgMESSAGE &msg,
					vltLOGICAL chFocusErr = ccsFALSE);

    virtual evhCB_COMPL_STAT CompletedCB(msgMESSAGE &,void *);
    virtual evhCB_COMPL_STAT ErrorCB(msgMESSAGE &,void *);
    virtual evhCB_COMPL_STAT TimeoutCB(msgMESSAGE &,void *);

    vltLOGICAL    CommandInProgress(msgMESSAGE &msg);
    ccsCOMPL_STAT GetState(vltINT32 &stateValue);
    ccsCOMPL_STAT GetState(vltINT32 &stateValue,vltINT32 &subStateValue);
    ccsCOMPL_STAT SetSubState(vltINT32 subStateValue);

    mswMOD_LIST_MANAGER   &modListManager;

    msgMESSAGE            mswMsg;                   
    mswEVAL_STATE         &evalState;

  private:

    // Utilility methods to gather always identical pieces of code.
    ccsCOMPL_STAT ActivateSyncObj(int readyState);

    // The following methods take care correctly of error handling 
    ccsCOMPL_STAT BroadcastCommand(msgCMD cmdName, char *cmdBuf = "",
				   vltINT8 phase = mswSEND_NO_PHASE);

    // don't make it virtual because each class uses its own version
    ccsCOMPL_STAT ConstructorInit();

    evhDB_SYNC            waitAllReady;

    // Configuration parameters (read from DB) in Init():
    vltINT32     readyTimeout;
    vltINT32     stopTimeout;
};


#endif /*!mswCONTROL_H*/
