#ifndef mswCONTROL_MAIN_H
#define mswCONTROL_MAIN_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: mswCONTROL_MAIN.h,v 1.126 2005/09/26 14:24:02 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* rkarban 2000-10-27 make destructor virtual
* gchiozzi  17/02/97  Added members to handle instrument config data handling
* gchiozzi  30/10/96  Added callbacks to handle M1 Force Setting
* gchiozzi  28/06/96  Fixed handling of multi-step commands
* gchiozzi  27/06/96  Added phase mode to BroadcaseCommand()
* mverola   09/04/96  Changed MswErrorCB 
*                     Added ActivateSyncObj,GetState,SetSubState,
*                      CommandInProgress,BroadcastCommand,EndTcsChangeFocusCB
* tphan     19/10/95  Add readyTimeout and stopTimeout into private
* gchiozzi  07/09/95  Moved StatusCB() in mswSTD_COMMANDS.h
* gchiozzi  29/08/95  Added ExitCB methos
* gchiozzi  29/08/95  Removed version command
* gchiozzi  29/08/95  Added InitCB() and Recover() methods
* gchiozzi  30/03/95  created
* awalland  10/08/95  added most commands
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

#include "mswCHANGE_FOCUS.h"
#include "mswCONTROL.h"


class mswCONTROL_MAIN : public mswCONTROL
{
  public:
    mswCONTROL_MAIN(mswMOD_LIST_MANAGER &listManager,
		    mswINS_CONFIG_TABLE &insTable,
                    mswEVAL_STATE       &eval,
                    mswCHANGE_FOCUS     &changeFoc);

    mswCONTROL_MAIN(const dbSYMADDRESS  dbPoint,
                    mswMOD_LIST_MANAGER &listManager,
		    mswINS_CONFIG_TABLE &insTable,
                    mswEVAL_STATE       &eval,
                    mswCHANGE_FOCUS     &changeFoc);
    virtual ~mswCONTROL_MAIN();
                    
    
    virtual ccsCOMPL_STAT Init();  

  protected:
    virtual evhCB_COMPL_STAT GetInsCB            (msgMESSAGE &msg, void *udata);
    virtual evhCB_COMPL_STAT GetInsDataCB        (msgMESSAGE &msg, void *udata);
    virtual evhCB_COMPL_STAT SetInsDataCB        (msgMESSAGE &msg, void *udata);
    virtual evhCB_COMPL_STAT TcsChangeFocusCB    (msgMESSAGE &msg, void *udata);
    virtual evhCB_COMPL_STAT EndTcsChangeFocusCB (msgMESSAGE &msg, void *udata);
    virtual evhCB_COMPL_STAT TcsPermForceSetCB   (msgMESSAGE &msg, void *udata);
    virtual evhCB_COMPL_STAT TcsRelForceSetCB    (msgMESSAGE &msg, void *udata);

    vltLOGICAL       IsSelectIntrument(msgMESSAGE &msg);
    vltLOGICAL       ForceSetting();
    mswCONTROL &ForceSetting(const vltLOGICAL);

  private:
    // don't make it virtual because each class has its version it has to use at construction time
    ccsCOMPL_STAT ConstructorInit();

    mswINS_CONFIG_TABLE   &insTable;
    mswCHANGE_FOCUS       &changeFocus;
};

#include "mswCONTROL_MAIN.icc"

#endif /*!mswCONTROL_MAIN_H*/
