#ifndef mswEVAL_STATE_H
#define mswEVAL_STATE_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: mswEVAL_STATE.h,v 1.126 2005/09/26 14:24:02 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* awalland 2004-06-28 Made Evaluate method virtual
* mverola   03/04/96  Changed ReadSubState into SubState 
*                     Changed stateVector  into addrVector
* tphan     12/10/95  Add method ReadSubState
* awalland  10/08/95  added methods and private data members
* gchiozzi  30/03/95  created
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

#include "eccsErr.h"
#include "mswMOD_LIST_MANAGER.h"

class mswEVAL_STATE : public evhDB_TASK
{
  public:
    mswEVAL_STATE(mswMOD_LIST_MANAGER &listManager);
    mswEVAL_STATE(const dbSYMADDRESS  dbPoint,
                  mswMOD_LIST_MANAGER &listManager);
   ~mswEVAL_STATE();

    ccsCOMPL_STAT       Disable();
    ccsCOMPL_STAT       Enable();
    vltLOGICAL          Enabled();
    
    virtual ccsCOMPL_STAT       Evaluate();
    
    ccsCOMPL_STAT       SubState(vltINT32 substate);
    vltINT32            SubState();

  protected:
    evhCB_COMPL_STAT    RequiredListChangedCB(evtEVENT_MSG &msg,
                                              void *udata); 
    evhCB_COMPL_STAT    StateChangedCB(evtEVENT_MSG &msg, void *udata); 

  private:
    ccsCOMPL_STAT ConstructorInit();

    evtEVENT            evtList; 
    evtEVENT            evtUnit; 
    mswMOD_LIST_MANAGER &modListManager;
    vltLOGICAL          enabled;

};

#endif /*!mswEVAL_STATE_H*/
