#ifndef mswINS_CONFIG_DATA_H
#define mswINS_CONFIG_DATA_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: mswINS_CONFIG_DATA.h,v 1.126 2005/09/26 14:24:04 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* gchiozzi  11/02/97  Created
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */
#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

#include "msw.h"
#include "mswINS_DATA_RECORD.h"

// mswINS_CONFIG_DATA usage and behaviour
// -------------------------------- 
// mswINS_CONFIG_DATA class is not only used by msw, but also by trkws, 
// which links the libmsw.a.
// trkws must access always the DB to get data from the table,
// so it uses the mswINS_DATA class.

const mswINSID mswSELECTED_INS = "";

class mswINS_CONFIG_DATA : public eccsERROR_CLASS
{
  public:
    mswINS_CONFIG_DATA(const dbSYMADDRESS dbPoint = dbEMPTY);
    virtual ~mswINS_CONFIG_DATA();

    mswINSID           &InsId(); 
    mswINS_DATA_RECORD &InsData(const mswINSID &ins = mswSELECTED_INS); 

    vltLOGICAL          IsInsData(const mswINSID &ins);
    vltLOGICAL          IsSelIns(const mswINSID &ins);

    virtual ccsCOMPL_STAT DbPoint(const dbSYMADDRESS point);
    virtual const char   *DbPoint() const;
    
  protected:
    // Loads the table from DB
    virtual ccsCOMPL_STAT  LoadTable();

    // Address of the root point for the instrument 
    // configuration data table
    dbSYMADDRESS        modPoint;
    
    // Full table of instruments.
    // Loaded from the database every time LoadTable() is called
    mswINS_DATA_RECORD  insTable[mswNO_OF_INSTRUMENTS]; 

  private:
    // These members are used to store the values retrieved by
    // InsId() and InsData() methods.
    // They can change at the next call of the methods, so the user
    // must copy them upon return.
    mswINSID            currentIns;  // The current selected instrument
    mswINS_DATA_RECORD  lastRecord;  // The last queried record
};


// include inline code for support classes
#include "mswINS_CONFIG_DATA.icc"

#endif /*!mswINS_CONFIG_DATA_H*/
