#ifndef mswMOD_LIST_COMMAND_H
#define mswMOD_LIST_COMMAND_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: mswMOD_LIST_COMMAND.h,v 1.126 2005/09/26 14:24:03 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* gchiozzi  04/04/97  Removed _CACHE subclasses
* gchiozzi  26/06/96  Added handling of START/STOP phase
* awalland  24/04/96  Added SEND_GUIDING option
* gchiozzi  22/01/96  Added CopyConfig() method
* gchiozzi  18/08/95  Put "list" data member private. 
* gchiozzi  11/08/95  Removed method SetMswPoint(), replaced by DbPoint()
* gchiozzi  11/08/95  Removed counter data member: use inherited
* awalland  04/08/95  created
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */
#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

#include "msw.h"
#include "mswMOD_LIST.h"
#include "evhDB_LIST_COMMAND.h"

/* Send mode selection for used units */
#define mswSEND_REQUIRED    1
#define mswSEND_TRACKING    2
#define mswSEND_GUIDING     3
#define mswSEND_ONFOCUS     4
#define mswSEND_INITCHFOC   5

/* Send mode selection for send phase to be used */
#define mswSEND_NO_PHASE     1
#define mswSEND_START_PHASE  2
#define mswSEND_STOP_PHASE   3

#define mswMOD_LIST_COMMAND_CLASS  \
        (classType)mswMOD_LIST_COMMAND::CreateNew

class mswMOD_LIST_COMMAND : public evhDB_LIST_COMMAND
{
  public:
    mswMOD_LIST_COMMAND();
    mswMOD_LIST_COMMAND(const dbSYMADDRESS  dbPoint);
    ~mswMOD_LIST_COMMAND();

    virtual ccsCOMPL_STAT   Send(msgMESSAGE &msg);
    virtual ccsCOMPL_STAT   Send(msgMESSAGE &msg, 
				 const vltINT8 mode, 
				 const vltINT8 phase = mswSEND_NO_PHASE,
				 const vltINT8 focus = 0);

    ccsCOMPL_STAT           SetSendMode(const vltINT8 mode, 
					const vltINT8 phase = mswSEND_NO_PHASE,
					const vltINT8 focus = 0);

    virtual const char     *DbPoint();
    virtual ccsCOMPL_STAT   DbPoint(const dbSYMADDRESS  dbPoint);

    mswMOD_LIST *GetList();

    virtual ccsCOMPL_STAT CopyConfig(evhDB_COMMAND &cmd);

    virtual const char *Destination();

    fndStdObjectDef(mswMOD_LIST_COMMAND, evhDB_LIST_COMMAND)

  protected:
    virtual mswMOD_LIST      *CreateList();
    virtual int              _ReplyCB(msgMESSAGE &msg, void *udata);
    virtual int              _ErrReplyCB(msgMESSAGE &msg, void *udata);

    ccsCOMPL_STAT             Selection();
    ccsCOMPL_STAT             SendPhaseStep();

  private:
    mswMOD_LIST     *list;

    vltINT8          sendMode;
    vltINT8          sendPhase;
    vltINT8          sendFocus;

    vltINT8          currentSendMode;
    vltINT8          currentSendPhase;
    vltINT8          currentPhase;

    vltINT8          maxPhase;
    msgMESSAGE       msg;
};

#endif /*!mswMOD_LIST_COMMAND_H*/
