#ifndef mswMOD_LIST_MANAGER_H
#define mswMOD_LIST_MANAGER_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: mswMOD_LIST_MANAGER.h,v 1.126 2005/09/26 14:24:03 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* gchiozzi  04/04/97  Removed _CACHE subclasses
* gchiozzi  28/06/96  Now inherits from evhDB_CMD_SERIAL
* gchiozzi  27/06/96  Added phase mode to SendAll()
* awalland  22/05/96  Replaced GetAddrVector with GetRequiredModules
* mverola   03/04/96  Added CheckReqModState, UpdateReqModList
*                     Changed GetStateVector into GetAddrVector
* awalland  10/08/94  moved methods to MOD_LIST_COMMAND and MOD_LIST
* gchiozzi  30/03/95  created
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */
#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

#include "msw.h"
#include "evhDB_CMD_SERIAL.h"
#include "mswMOD_LIST_COMMAND.h"
#include "mswMOD_LIST.h"

class mswMOD_LIST_MANAGER : public evhDB_CMD_SERIAL
{
  public:
    mswMOD_LIST_MANAGER();
    mswMOD_LIST_MANAGER(const dbSYMADDRESS  dbPoint);
    ~mswMOD_LIST_MANAGER();

    ccsCOMPL_STAT             SendAll(msgMESSAGE &msg, 
				      const vltINT8 phase = mswSEND_NO_PHASE,
				      const vltINT8 mode  = mswSEND_REQUIRED,
				      const vltINT8 focus = 0);
    ccsCOMPL_STAT             UpdateCallbacks();

    const mswMOD_RECORD_ARRAY &GetRequiredModules();

    //MVE added
    vltLOGICAL               CheckReqModState(vltINT32 stateToCheck);
    ccsCOMPL_STAT            UpdateReqModList(vltINT8 oldFocus,
                                              vltINT8 newFocus);

    ccsCOMPL_STAT DisableModulesListEvent();
    ccsCOMPL_STAT EnableModulesListEvent();

  protected:
    virtual evhCB_COMPL_STAT ListChangedCB(evtEVENT_MSG &msg, void *udata);
    virtual evhCB_COMPL_STAT UnitStateChangedCB(evtEVENT_MSG &msg, void *udata);

  private:
    ccsCOMPL_STAT            ConstructorInit();
    ccsCOMPL_STAT            TriggerEvaluation(vltINT8 whatToTrigger);

    evtEVENT                 evt;  
    evtEVENT                 unitEvent[mswNO_OF_MODULES];  
    
    mswMOD_LIST             *modList;
    
    dbSYMADDRESS             modPoint;    
};

#endif /*!mswMOD_LIST_MANAGER_H*/
