#ifndef PCOUTIL_H
#define PCOUTIL_H
/******************************************************************************
* E.S.O. - VLT project
#
# "@(#) $Id: pcoUtil.h,v 1.32 2005/06/03 13:45:51 vltsccm Exp $" 
*
* pcoUtil.h
*
* who       when      what
* --------  --------  ----------------------------------------------
* jknudstr  21/10/94  created
*/

/************************************************************************
*  Contains definitions for the internal usage of PCO
*----------------------------------------------------------------------
*/

/*
 * Structure to contain the unpacked information from the message received
 */

typedef struct {
    pcoCOMMAND_TYPE     pcoCommand;
    char                protocol[pcoPROTOCOL_ID_LEN];
    pcoPROTOCOL         pcoProtocol;
    char                processID[pcoPROCESS_ID_LEN];
    char                hostName[pcoHOST_NAME_LEN];
    char                midasKeyName[pcoMIDAS_KEY_NAME_LEN];
    char                attributeName[pcoATTRIB_NAME_LEN];
    pcoMIDAS_KEY_TYPE   midasKeyType;
    vltUINT16           elementSize;
    vltUINT16           firstElement;
    vltUINT16           noOfElements;
    char                message[pcoMAX_MSG_LEN];
    vltUINT16           msgLen;
} pcoMESSAGE_INFO;



/*
 * General utility functions
 */

ccsCOMPL_STAT pcoMonitor(pcoPROC_HANDLE  *procListStart,
                         vltLOGICAL      *ccsMsg,
                         vltLOGICAL      *nonCcsMsg, 
                         ccsERROR        *error);

ccsCOMPL_STAT pcoUnpackMsg(msgCMD           command, 
                           char             *buffer, 
                           msgLENGTH        buflen,
                           pcoMESSAGE_INFO  *pcoMsgInfo,
                           ccsERROR         *error);

ccsCOMPL_STAT ccsCheckExtCon(pcoMESSAGE_INFO   *msgInfo,
                             pcoPROC_HANDLE    *procListStart,
                             pcoPROC_HANDLE    **targetProc,
                             ccsERROR          *error);

ccsCOMPL_STAT pcoGetNextField(char       *bufPtr, 
			      vltINT32   maxLen, 
			      char       *targetBuf, 
			      char       **newPos,
			      ccsERROR   *error);

char *pcoNextField(char *bufPtr, ccsERROR *error);

void pcoCleanUp(pcoPROC_HANDLE *procStart);


/*
 * Read/write key utility functions
 */

ccsCOMPL_STAT pcoReadKey(pcoPROC_HANDLE     *pcoProcStart, 
                         pcoMESSAGE_INFO    *pcoMsgInfo, 
                         char               **replyMsg,
                         ccsERROR           *error);

ccsCOMPL_STAT pcoWriteKey(pcoPROC_HANDLE     *pcoProcStart, 
                          pcoMESSAGE_INFO    *pcoMsgInfo, 
                          ccsERROR           *error);

/*
 * Event utility functions
 */


ccsCOMPL_STAT pcoAttachProc(pcoPROC_HANDLE     *pcoProcStart, 
                            pcoMESSAGE_INFO    *pcoMsgInfo, 
                            ccsERROR           *error);

ccsCOMPL_STAT pcoDetachProc(pcoPROC_HANDLE     *pcoProcStart, 
                            pcoMESSAGE_INFO    *pcoMsgInfo, 
                            ccsERROR           *error);

ccsCOMPL_STAT pcoForwardEvent(pcoPROC_HANDLE   *pcoProcStart, 
                              evtEVENT_ID      eventID,
                              evtDATA          eventInfo,
                              char             *userMsg,
                              ccsERROR         *error);

#endif /*!PCOUTIL_H*/

