#ifndef prs_H
#define prs_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: prs.h,v 1.117 2005/08/24 12:35:03 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* gchiozzi  22/05/96  Added name map for ADC type
* gchiozzi  17/08/95  Added include of tcs.h
* gchiozzi  01/08/95  Added include to new tcs.h
* gchiozzi  03/05/95  created
*/

/************************************************************************
 *
 *   General include file for the "prs" module.
 *   It contains common definitions used in every component of the module
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

#include "eccsTestTools.h"

#include "tcs.h"

/* 
 * Includes with error messages 
 */
#include "prsErrors.h"


/* 
 *  Defines for the target telescope.
 *  The default target is VLT
 *  Up to now only VLT and NTT
 *  All other common defines used both in C/C++ code and dbLoader definitions
 */

#include "tcs.h"
#include "prsDefines.h"

/*
 *  Value/Name conversion tables:
 *  The defines for both values and names are in prsDefines.h
 *  Other applications sending or receiving these values/string
 *  can include this file and link the file prs.C with the code
 *  for the mapping functions.
 *  We have to think if there is a better place where to put these
 *  common things.
 */

#include "fndNAME_MAP.h"

extern fndNAME_MAP prsTargetNameMap;
extern fndNAME_MAP prsPrsTypeNameMap;
extern fndNAME_MAP prsStateNameMap;
extern fndNAME_MAP prsAutoGuideNameMap;
extern fndNAME_MAP prsAdcTypeNameMap;

#include "oslx.h"

#endif /*!prs_H*/
