#ifndef prsAH_MAIN_TASK_H
#define prsAH_MAIN_TASK_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: prsAH_MAIN_TASK.h,v 1.117 2005/08/24 12:35:04 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* tcsmgr  22/10/98  Factorised Reset() of objects to allow extensions in subclass
* gchiozzi  31/07/96  Added OnlineCB
* gchiozzi  01/08/95  Class prsDB_SYNC_... moved in "tcs" module  
* gchiozzi  28/04/95  created
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

#include "prs.h"
#include "evhDB_TASK.h"
#include "evhCOMMAND.h"
#include "fndSTRING.h"


#include "prsAH_TRACK.h"
#include "prsAH_GUIDE.h"
#include "prsAH_AO.h"
#include "prsAH_STD_MOD.h"
#include "tcsDB_SYNC_ERR_CHECK.h"

class prsAH_MAIN_TASK : public evhDB_TASK
{
  public:
    prsAH_MAIN_TASK(const dbSYMADDRESS  dbPoint,
                    prsAH_TRACK   &track, 
		    prsAH_GUIDE   &guide, 
		    prsAH_AO      &ao, 
		    prsAH_STD_MOD &stdMod);   
   ~prsAH_MAIN_TASK();

    virtual evhCB_COMPL_STAT ExitCB(msgMESSAGE &msg, void *udata);
    virtual evhCB_COMPL_STAT InitCB(msgMESSAGE &msg, void *udata);
    virtual evhCB_COMPL_STAT OnlineCB(msgMESSAGE &msg, void *udata);
    virtual evhCB_COMPL_STAT PresetCB(msgMESSAGE &msg, void *udata);
    virtual evhCB_COMPL_STAT SaveCurrSetupCB(msgMESSAGE &msg, void *udata);
    virtual evhCB_COMPL_STAT StopCB(msgMESSAGE &msg, void *udata);

    ccsCOMPL_STAT    Init();
    ccsCOMPL_STAT    Recover();

    vltINT32  ReadyTimeout();
    vltINT32  ModeSwitchTimeout();
    
  protected:
    virtual evhCB_COMPL_STAT  ExePresetCB(msgMESSAGE &msg, void *udata) = 0;
    virtual evhCB_COMPL_STAT  ErrorSwitchModeCB(msgMESSAGE &msg, void *udata);

    virtual evhCB_COMPL_STAT  ReadyCB(msgMESSAGE &msg, void *udata);
    virtual evhCB_COMPL_STAT  ErrorCB(msgMESSAGE &msg, void *udata);

    virtual evhCB_COMPL_STAT  StopOKCB(msgMESSAGE &msg, void *udata);
    virtual evhCB_COMPL_STAT  ErrorStopCB(msgMESSAGE &msg, void *udata);

    virtual ccsCOMPL_STAT     PresetAbort(vltINT16 errorNumber);

    virtual ccsCOMPL_STAT     PresetAbortPermitted (vltLOGICAL &permitted, fndSTRING &reason);

    virtual ccsCOMPL_STAT     Reset();

  protected:
    prsAH_TRACK   &track; 
    prsAH_GUIDE   &guide;
    prsAH_AO      &ao;
    prsAH_STD_MOD &stdMod;

    evhDB_COMMAND  switchMode;
    evhDB_COMMAND  switchModeEnd;
    tcsDB_SYNC_ERR_CHECK     waitAllReady; 
    tcsDB_SYNC_ERR_CHECK     waitStopReady; 

    oslxSETUP  *currentSetupFile;

  private:
    msgMESSAGE     presetMsg;
    msgMESSAGE     objectMsg;

    vltBYTES64   currentSetup;
    vltINT32     readyTimeout;
    vltINT32     modeSwitchTimeout;
};


#endif /*!prsAH_MAIN_TASK_H*/
