#ifndef prsAH_TRACK_H
#define prsAH_TRACK_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: prsAH_TRACK.h,v 1.117 2005/08/24 12:35:05 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* nttmgr  14/12/96  Added methods for rotator angle, additional velocity and wavelength
* gchiozzi  02/05/95  created
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif


#include "prs.h"
#include "evhDB_CMD_SERIAL.h"


typedef vltINT32 prsTRACK_MODE;


class prsAH_TRACK : public evhDB_CMD_SERIAL
{
  public:
    prsAH_TRACK(const dbSYMADDRESS  dbPoint);
    ~prsAH_TRACK();
    
    ccsCOMPL_STAT AddVelocity(oslxSETUP &setup,
			     evhDB_SEND_ID *sendId=NULL, 
			     evhDB_SEND_ID waitId=0); 
    ccsCOMPL_STAT OffsetStep(oslxSETUP &setup,
			     evhDB_SEND_ID *sendId=NULL, 
			     evhDB_SEND_ID waitId=0); 
    ccsCOMPL_STAT RotAngle(oslxSETUP &setup,
			   evhDB_SEND_ID *sendId=NULL, 
			   evhDB_SEND_ID waitId=0); 
    ccsCOMPL_STAT Preset(oslxSETUP &setup, prsTRACK_MODE *tmode,
			 evhDB_SEND_ID *sendId=NULL, 
			 evhDB_SEND_ID waitId=0); 
    ccsCOMPL_STAT WaveLength(oslxSETUP &setup,
			     evhDB_SEND_ID *sendId=NULL, 
			     evhDB_SEND_ID waitId=0); 
    ccsCOMPL_STAT Stop();

  protected:
    ccsCOMPL_STAT MakeBuffAlaz(oslxSETUP &setup, char *msgBuff);
    ccsCOMPL_STAT MakeBuffCoor(oslxSETUP &setup, char *msgBuff);
    ccsCOMPL_STAT MakeBuffMobj(oslxSETUP &setup, char *msgBuff);
    ccsCOMPL_STAT MakeBuffName(oslxSETUP &setup, char *msgBuff);
    ccsCOMPL_STAT MakeBuffObj(oslxSETUP &setup, char *msgBuff);

  private:     
};


#endif /*!prsAH_TRACK_H*/
