#ifndef prsSEQ_MAIN_TASK_H
#define prsSEQ_MAIN_TASK_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: prsSEQ_MAIN_TASK.h,v 1.117 2005/08/24 12:35:06 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* gchiozzi  05/09/97  Added checkSetupFile
* gchiozzi  04/09/97  Removed MARK command
* gchiozzi  02/08/96  Added method to reject commands when state is not ONLINE
* gchiozzi  31/07/96  Added OnlineCB
* gchiozzi  22/05/96  Removed callbacks for obsolete commands
* gchiozzi  28/04/95  created
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

#include "prs.h"
#include "evhDB_TASK.h"
#include "evhSTD_COMMANDS.h"
#include "evhDB_COMMAND.h"

/* Defines */

#define  prsNOMOVE                 0
#define  prsMOVE                   1


class prsSEQ_MAIN_TASK : public evhDB_TASK
{
  public:
    prsSEQ_MAIN_TASK(const dbSYMADDRESS  dbPoint);
   ~prsSEQ_MAIN_TASK();

    // Callbacks for public commands
    virtual evhCB_COMPL_STAT CenterObjCB(msgMESSAGE &msg, void *udata);
    virtual evhCB_COMPL_STAT ClearReadySetupCB(msgMESSAGE &msg, void *udata);

    virtual evhCB_COMPL_STAT PrsAltAzCB(msgMESSAGE &msg, void *udata);
    virtual evhCB_COMPL_STAT PrsCoordCB(msgMESSAGE &msg, void *udata);
    virtual evhCB_COMPL_STAT PrsNamedPosCB(msgMESSAGE &msg, void *udata);
    virtual evhCB_COMPL_STAT SetupCB(msgMESSAGE &msg, void *udata);
    virtual evhCB_COMPL_STAT StopCB(msgMESSAGE &msg, void *udata);
    virtual evhCB_COMPL_STAT SaveCurrSetupCB(msgMESSAGE &msg, void *udata);
    virtual evhCB_COMPL_STAT SaveReadySetupCB(msgMESSAGE &msg, void *udata);

    // Overloading of inherited commands
    virtual evhCB_COMPL_STAT ExitCB(msgMESSAGE &msg, void *udata);
    virtual evhCB_COMPL_STAT InitCB(msgMESSAGE &msg, void *udata);
    virtual evhCB_COMPL_STAT OnlineCB(msgMESSAGE &msg, void *udata);

    ccsCOMPL_STAT    Init();
    ccsCOMPL_STAT    Recover();

  protected:
    virtual evhCB_COMPL_STAT Execute(msgMESSAGE &msg,
				     vltLOGICAL moveFlag=prsMOVE);
    virtual evhCB_COMPL_STAT ExeReadyCB(msgMESSAGE &msg, void *udata);
    virtual evhCB_COMPL_STAT ExeErrorCB(msgMESSAGE &msg, void *udata);

    virtual evhCB_COMPL_STAT StopOKCB(msgMESSAGE &msg, void *udata);
    virtual evhCB_COMPL_STAT StopErrorCB(msgMESSAGE &msg, void *udata);

    ccsCOMPL_STAT RejectIfNotOnline(msgMESSAGE &msg, vltLOGICAL *rejected);

    oslxSETUP      *readySetupFile;
    oslxSETUP      *checkSetupFile;
    evhDB_COMMAND   stopCmd;
    evhDB_COMMAND   presetCmd;

  private:
    msgMESSAGE      stopMsg;  
    msgMESSAGE      setupMsg; 

    // Configuration parameters (read from DB) in Init():
    vltBYTES64   readySetup;
    vltBYTES64   defaultSetup;
    vltBYTES64   currentSetup;
    vltBYTES64   setupDictionary;
    vltBYTES64   setupAliasTable;
    vltINT32     readyTimeout;
    vltINT32     stopTimeout;
};


#endif /*!prsSEQ_MAIN_TASK_H*/
