#ifndef SAMP_H
#define SAMP_H

/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: samp.h,v 2.45 2005/10/18 14:33:13 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* mcomin  23/05/00    Re-aranged to VLT standards
*/


#ifdef __cplusplus
extern "C" {
#endif

/*
 * Message constants
 */

#define sampMODE_NOW_STRING      "Now"
#define sampMODE_EVENT_STRING    "Event"

#define sampLOGIC_EQ_STRING      "EQ"
#define sampLOGIC_NE_STRING      "NE"
#define sampLOGIC_GT_STRING      "GT"
#define sampLOGIC_GE_STRING      "GE"
#define sampLOGIC_LT_STRING      "LT"
#define sampLOGIC_LE_STRING      "LE"
#define sampLOGIC_ANY_STRING     "ANY"

#define sampTYPE_INTEGER_STRING  "Integer"
#define sampTYPE_REAL_STRING     "Real"

/*
 * data types
 */
 
typedef struct {                    /* Reply for SMPSTRT command        */
    vltUINT32       headerSize;     /* Size of sampling message header  */
    vltUINT32       numValues;      /* Number of items sampled          */
    vltUINT32       numSamples;     /* Number of samples reported with  */
                                    /* this message                     */
    ccsTIMEVAL      timeStamp;      /* Time stamp (UTC) of first sample */
    vltUINT32       samplePeriod;   /* Number of microseconds between   */
                                    /* samples                          */
} sampSMPSTRT_REPLY;


#ifdef MAKE_VXWORKS
#include "sampLCC.h"
#else
#include "sampCCS.h"
#endif

#ifdef __cplusplus
}
#endif

#endif /*!SAMP_H*/

