#ifndef sampCCS_H
#define sampCCS_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: sampCCS.h,v 2.45 2005/10/18 14:33:14 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* mcomin  17/09/00  created
*/

#include "sampErrors.h"

/*
 * Define point class numbers : these numbers are used to find
 * all the history and the plot points in the database
 */

#define ccsHIST_PT_CLASS    65411
#define ccsPLOT_PT_CLASS    65501

/*
 * Definitions
 */

#define sampNUM_OF_TYPES                8
#define sampMAX_DELAYED_REPLIES         6
#define sampMISSED_REPLIES	        16
#define sampMAX_NUM_PARAMS              40
#define sampMIN_NUM_PARAMS              4
#define sampMAX_NUM_SAMPLES             8
#define sampMAX_NUM_VALUES_PER_MSG	505
#define sampMAX_RTAP_FAILED_CATCH_UP    6
#define sampSTART_SAMP_CMDID            1
#define sampSTOP_SAMP_CMDID             2

/* Define standard table field names */

#define sampPLOT_PATH       ""
#define sampPLOT_NAME       "ccs_config:plot config:samplePlot"
#define sampPLOT_TABLE      "plot_table"
#define sampPLOT_DATA       "data"
#define sampPLOT_FIRST_REC  "firstRecord"
#define sampPLOT_NEXT_REC   "nextRecord"
#define sampPLOT_OLDEST_REC "oldestRecord1"

#define sampLOG_TXT(text)        \
         logData(ccsSAMP,0,text)

#define sampLOG(format,params...)        \
         logData1(ccsSAMP,0,format,params)

#define sampLOG_V(format,params...)         \
      if (sampCblk->verbose)                \
         {                                  \
         logData1(ccsSAMP,0,format,params); \
         }

#define sampLOG_D(format,params...)         \
      if (sampCblk->debug)                  \
         {                                  \
         logData1(ccsSAMP,0,format,params); \
         }

typedef struct {
    dbSYMADDRESS   attrName;
    dbDIRADDRESS   attrDirect;
    dbATTRTYPE	   attrType;
    dbTYPE	   dataType[dbMAX_FIELD_CNT+1];

    /* Add field to use the same structure in ccsPlotDisp */
    vltDBXREF      xrefAddr;
    vltUINT8       fieldCnt;
    vltUINT16      recCnt;
    vltUINT32      recSize;
} sampDB_POINT;


typedef struct {
    vltUINT16		writeToDb;
    vltUINT16		rtapCatchUpFailed;
    dbSYMADDRESS        plotRoot;
    vltUINT32		nextRecCnt;
    vltUINT32		newNextRecCnt;
    sampDB_POINT        table;
    sampDB_POINT        first;
    sampDB_POINT	oldest;
    sampDB_POINT	next;
} sampWS_DB_CONTROL;


typedef struct {
   vltINT32           numbPoints;
   dbSYMADDRESS       plotPoint;
   dbTYPE             sourceDataType[sampMAX_NUM_SAMPLES+1];
   sampWS_DB_CONTROL  plotTable;

  /* Indexes describing the history table */

   vltUINT16     dbOldest;
   vltUINT16     dbNext;
} sampPLOT_TABLE_DESCR;


/***********************************************************
*               Function Declaration
************************************************************/


ccsCOMPL_STAT sampWrPlotIndex(
   sampDB_POINT *dbInfo, 
   char         *buffer,
   ccsERROR     *error
   );


#endif /*!_H*/
