#ifndef SCAN_LITE_H
#define SCAN_LITE_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: scanLite.h,v 2.60 2005/07/31 20:47:24 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* tebert    14/07/99  created
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */

#define rtRTAP_SCAN_MNGR         CCSSCANMANAGER
#define rtSD_SI_STATUS_AIN       3
#define rtCP_STATUS_AIN          3

#define rtCNTRL_DISABLE_SS       0      /* disable scan system */
#define rtCNTRL_ENABLE_SS        1      /* enable scan system */
#define rtCNTRL_DISABLE_CP       2
#define rtCNTRL_ENABLE_CP        3
#define rtCNTRL_DISABLE_SD_SI    4
#define rtCNTRL_ENABLE_SD_SI     5
#define rtCNTRL_DISABLE_SD_SO    6
#define rtCNTRL_ENABLE_SD_SO     7
#define rtCNTRL_DISABLE_SD_SI_PT 8
#define rtCNTRL_ENABLE_SD_SI_PT  9
#define rtCNTRL_DISABLE_SD_SO_PT 10
#define rtCNTRL_ENABLE_SD_SO_PT  11
#define rtCNTRL_COMM_PORT_MODE   12
#define rtCNTRL_POLL_PERIOD      13
#define rtCNTRL_PRBX_PERIOD      14
#define rtCNTRL_POLL_TYPE        15
#define rtCNTRL_PRBX_TYPE        16
#define rtCNTRL_FORCE_POLL_TYPE  17
#define rtCNTRL_FORCE_PRBX_TYPE  18
#define rtCNTRL_FORCE_POLL       19
#define rtCNTRL_FORCE_PRBX       20
#define rtCNTRL_COLD_RST_DEVICE  21
#define rtCNTRL_WARM_RST_DEVICE  22
#define rtCNTRL_SNAP             23
#define rtCNTRL_SNAP_WITH_VERIFY 24
#define rtCNTRL_SET_TIME         25

#define rtQUERY_SS_STATE         0
#define rtQUERY_SCAN_TASK_STATE  1

#define rtSS_MAX_CNTRL_CNT      255

#define rtSCAN_DISABLE                  0
#define rtSCAN_ENABLE                   1
typedef rtUInt32 rtSsAction;

#define rtSCAN_DISABLED                 0
#define rtSCAN_ENABLED                  1
#define rtSCAN_FAILED                   2
#define rtSCAN_UNKNOWN                  3
typedef rtUInt32 rtSsState;

typedef rtUInt16 rtSsDcAction;

/*
 * scan system rtSsmaQuality definitions
 */
typedef enum    
    {
    rtSSMA_NO_DATA = 0,
    rtSSMA_OK,
    rtSSMA_FAILED,
    rtSSMA_DISABLED
    } rtSsmaQuality;

typedef rtInt        rtSsConnection;

typedef struct
    {
    rtBitfld  ptControl:8;   
    rtBitfld  ptStatus:8;    
    rtBytes4  pollTypes;
    rtUInt16  stBuffSize;
    rtUInt32  offset;
    rtUInt16  elemCnt;
    rtBitfld  rtapDeType:8;   
    rtBitfld  deadbandType:8;
    rtDouble  deadband;
    rtDbXref  linkAddress;
    rtInt32   reserved;
    } rtScanInputRecord;

#define rtSS_MAX_CNTRL_CNT  255
#define rtSS_MAX_QUERY_CNT  128

typedef struct
    {
    rtInt32  status[rtSS_MAX_CNTRL_CNT];
    } rtSsCntrlSsCpSd;

typedef struct
    {
    rtInt32 status[rtSS_MAX_CNTRL_CNT];
    } rtSsCntrlRestartDev;

typedef struct
    {
    rtInt32   status;
    rtSsState state;
    } rtScanState;

typedef struct
    {
    rtScanState  scanState[rtSS_MAX_QUERY_CNT];
    } rtSsQueryState;

typedef rtUInt16        rtSsCqAction;

typedef struct
    {
    rtSsCqAction    action;
    rtUInt16        addrCnt;
    rtDbAddress    *addr;
    rtUInt8        *buffer;
    rtUInt16        size;
    rtUInt16        actual;
    } rtSsCq;

typedef struct
    {
    rtSsDcAction    action;
    rtDbAddress     addr;
    rtUInt8        *data;
    rtUInt16        dataSize;
    rtUInt16        timeOut;  
    rtUInt8        *reply;
    rtUInt16        replySize;
    rtInt32         status;
    } rtSsDirectCommand;

rtInt   rtOpenSsma        (void);
rtInt   rtCloseSsma       (void);
rtInt   rtSpareSsma       (void);
rtInt   rtSizeSsma        (void);
rtInt   rtSetSsmaStatus   (rtScanInputRecord *scanRecord, rtSsState newStatus);
rtInt   rtReadSsma        (rtUInt32 offset, rtSsmaQuality *ssmaQlty, rtUInt8 *failCnt,
                           rtUInt32 dataSize, rtUInt8 *dataBuffer, rtUInt16 stBuffSize, 
                           rtUInt8 *stBuffer);
rtInt   rtReadSsmaWithLock(rtUInt32 offset, rtSsmaQuality *ssmaQlty, rtUInt8 *failCnt,
                           rtUInt32 dataSize, rtUInt8 *dataBuffer, rtUInt16 stBuffSize, 
                           rtUInt8 *stBuffer);
rtInt   rtWriteSsma       (rtUInt32 offset, rtSsmaQuality ssmaQlty, rtUInt8 failCnt,
                           rtUInt32 dataSize, rtLogical writeData, rtUInt8 *dataBuffer,
                           rtUInt16 stBuffSize, rtUInt8 *stBuffer);
void    rtTriggerCe       (void);
rtSsConnection rtOpenScanSys(rtChar *env);
rtInt   rtControlScanSys  (rtSsConnection ssConnection, rtSsCq *ssCq);
rtInt32 rtCloseScanSys    (rtSsConnection ssConnection);
rtInt   rtDirectCmdSS     (rtSsConnection ss_connection, rtSsDirectCommand *ss_dc);
rtInt   rtQueryScanSys    (rtSsConnection ssConnection, rtSsCq *ssCq);

#endif /*!SCAN_LITE_H*/
