#ifndef SGSIC
#define SGSIC

#ifdef __cplusplus
extern "C" {
#endif

#include <stdio.h>

/*
**  - - - - - -
**   s g s . h
**  - - - - - -
**
**  Simple Graphics System function prototypes include file.
**
**  !!! Version for use with plotting via Tcl/Tk !!!
**
**  Last revision:   27 January 2000
**
**  Copyright 2000 P.T.Wallace.  All rights reserved.
*/

/* Function prototypes: public */
void sgsAl2gr ( void );
void sgsApoly ( double, double );
void sgsAtext ( char* );
void sgsAtxb ( char*, int );
void sgsAtxi ( int, int );
void sgsAtxr ( double, int, int );
void sgsArc ( double, double, double, double, double );
void sgsBox ( double, double, double, double );
void sgsBpoly ( double, double );
void sgsBtext ( double, double );
void sgsCircl ( double, double, double );
void sgsClose ( void );
void sgsClrbl ( double, double, double, double );
void sgsClrz ( void );
int sgsClswk ( int );
void sgsFlush ( void );
int sgsGcntrl ( int, int, char* );
void sgsGqplr ( int, int, int, int*, int*, float*, int* );
void sgsGr2al ( FILE*, int, char* );
int sgsIcurw ( void );
int sgsIcurz ( void );
int sgsImode ( void );
int sgsInit ( FILE* );
void sgsIpen ( int* );
void sgsIpens ( int*, int*, int*, int*, int*, int*, int* );
void sgsItxa ( int*, int*, double*, double*, double*, double*,
               double*, char* );
double sgsItxl ( char* );
void sgsIzone ( double*, double*, double*, double*, double*, double* );
void sgsLine ( double, double, double, double );
int sgsOpen ( char*, int* );
int sgsOpnwk ( char*, int* );
void sgsOpoly ( void );
void sgsOtext ( void );
void sgsRelz ( int );
int sgsSelz ( int );
void sgsSfont ( int );
void sgsShtx ( double );
void sgsSpen ( int );
void sgsSprec ( int );
void sgsStxj ( char* );
void sgsSuptx ( double, double );
void sgsTx ( double, double, char* );
void sgsTxi ( double, double, int, int );
void sgsTxr ( double, double, double, int, int );
int sgsSw ( double, double, double, double );
int sgsWlist ( FILE* );
int sgsZone ( double, double, double, double, int* );
int sgsZshap ( double, char*, int* );

/* Function prototypes: internal */
int sgs_Bnorm ( double, double, double, double,
                double*, double*, double*, double* );
int sgs_Getz ( int );
void sgs_Lineto ( double, double );
void sgs_Moveto ( double, double );
void sgs_Newz ( int, double, double, double, double );
void sgs_Norm ( double, double, double*, double* );
int sgs_Pnz ( double, double, double, double,
              double, double, char*, int* );
double sgs_Slop ( int, char*, double, double, double, double, double );
char *sgs_Upcas ( char*, char* );
void sgs_Wc2dc ( double, double, double*, double* );

#ifdef __cplusplus
}
#endif

#endif
