#ifndef SUX_IF_H
#define SUX_IF_H
/*******************************************************************************
* E.S.O. - VLT project
*
* who       when        what
* --------  ----------  ----------------------------------------------
* abalestr  XX/XX/XX    created
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */

#if defined (SUN_COMP)
#include <sys/ioccom.h>
#endif

#include <stdint.h>
#include <features.h>
#include <sys/ioctl.h>

/* Mapping between registers spaces and pcibar areas */
#define SUX_PCIBAR0	1
#define SUX_PCIBAR1	2
#define SUX_PCIBAR2	3

typedef struct sux_param {
  uint32_t reg;
  uint32_t val;
  uint32_t off;
} sux_param_t;

/*
 * IOCTL's
 */

enum sux_ioctl { 
  SUX_D_GET_DSP_PDREG = 1,
  SUX_D_GET_DSP_STAT,
  SUX_D_GET_DSP_ISEL,
  SUX_D_GET_DSP_SID,
  SUX_D_GET_DSP_IEN,
  SUX_D_GET_DSP_CTRL,
  SUX_D_GET_DSP_TEST,
  SUX_D_SET_DSP_PDREG,
  SUX_D_SET_DSP_STAT,
  SUX_D_SET_DSP_ISTAT,
  SUX_D_SET_DSP_SID,
  SUX_D_SET_DSP_CTRL,
  SUX_D_SET_DSP_TEST,
  SUX_D_DSP_RESET,
  SUX_D_DSP_GET,
  SUX_D_DSP_SET,
  SUX_D_DMA_RESET,
  SUX_D_DMA_CHECK,
  SUX_D_DMA_ABORT,
  SUX_D_DMA_BLOCK,
  SUX_D_DMA_UNBLOCK,
  SUX_D_DMA_GETPXCTR,
  SUX_D_DMA_PXCTRRESET,
  SUX_D_DMA_SYNCREG,
  SUX_D_CFG_GET,
  SUX_D_CFG_SET,
  SUX_D_RTC_SET,
  SUX_D_RTC_WFRAME,
  SUX_D_DSP_SYNCRESET
};

/* Control bits */

/* DSP reset command */
#define	SUX_DSP_RESET	_IO('S', (SUX_D_DSP_RESET))

/* read commands for DSP */
#define	SUX_GET_DSP_PDREG	_IOR('S', (SUX_D_GET_DSP_PDREG), uint32_t)
#define SUX_GET_DSP_STAT	_IOR('S', (SUX_D_GET_DSP_STAT), uint32_t)
#define SUX_GET_DSP_ISEL	_IOR('S', (SUX_D_GET_DSP_ISEL), uint32_t)
#define SUX_GET_DSP_SID		_IOR('S', (SUX_D_GET_DSP_SID), uint32_t)
#define SUX_GET_DSP_IEN		_IOR('S', (SUX_D_GET_DSP_IEN), uint32_t)
#define SUX_GET_DSP_CTRL	_IOR('S', (SUX_D_GET_DSP_CTRL), uint32_t)
#define SUX_GET_DSP_TEST	_IOR('S', (SUX_D_GET_DSP_TEST), uint32_t)

/* write commands for DSP */
#define	SUX_SET_DSP_PDREG	_IOW('S', (SUX_D_SET_DSP_PDREG), uint32_t)
#define SUX_SET_DSP_STAT	_IOW('S', (SUX_D_SET_DSP_STAT), uint32_t)
#define SUX_SET_DSP_ISTAT	_IOW('S', (SUX_D_SET_DSP_ISTAT), uint32_t)
#define SUX_SET_DSP_SID		_IOW('S', (SUX_D_SET_SID), uint32_t)
#define SUX_SET_DSP_CTRL	_IOW('S', (SUX_D_SET_DSP_CTRL), uint32_t)
#define SUX_SET_DSP_TEST	_IOW('S', (SUX_D_SET_DSP_TEST), uint32_t)

/* general GET/SET ioctl's for DSP */
#define	SUX_DSP_GET		_IOR('S', (SUX_D_DSP_GET), sux_param_t)
#define	SUX_DSP_SET		_IOW('S', (SUX_D_DSP_SET), sux_param_t)

/* ioctl's for DMA */
#define	SUX_DMA_CHECK		_IOR('S', (SUX_D_DMA_CHECK), uint32_t)
#define SUX_DMA_GETPXCTR	_IOR('S', (SUX_D_DMA_GETPXCTR), uint32_t)
#define	SUX_DMA_ABORT		_IOW('S', (SUX_D_DMA_ABORT), sux_param_t)
#define	SUX_DMA_RESET		_IO('S', (SUX_D_DMA_RESET))
#define SUX_DMA_BLOCK		_IO('S', (SUX_D_DMA_BLOCK))
#define SUX_DMA_UNBLOCK		_IO('S', (SUX_D_DMA_UNBLOCK))
#define SUX_DMA_CTRRESET	_IO('S', (SUX_D_DMA_PXCTRRESET))
#define SUX_DMA_SYNCREG		_IO('S', (SUX_D_DMA_SYNCREG))
/* TODO #define SUX_DSP_ABORT		_IO('S', (SUX_D_DSP_ABORT)) */
#define SUX_DSP_SYNCRESET	_IO('S', (SUX_D_DSP_SYNCRESET))

/* general GET/SET ioctl's for CFG */
#define	SUX_CFG_GET		_IOR('S', (SUX_D_CFG_GET), sux_param_t)
#define	SUX_CFG_SET		_IOW('S', (SUX_D_CFG_SET), sux_param_t)

/* RTC ioctls' */
#define SUX_RTC_SET             _IOW('S', (SUX_D_RTC_SET), uint32_t)
#define SUX_RTC_WFRAME          _IOW('S', (SUX_D_RTC_WFRAME), uint32_t)


#endif /*!SUX_IF_H*/
