#ifndef tcsBASE_H
#define tcsBASE_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: tcsBASE.h,v 1.153 2005/08/02 12:52:43 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* rkarban  14/04/98  remove logFits patch
* tcsmgr  30/03/98  PATCH: moved here temporarily logFITS class.
* tcsmgr  26/03/98  add singleton instance of logFITS
* gchiozzi  20/07/95  created
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

#include "tcs.h"
#include "eccsLog.h"
#include "eccsErr.h"

class tcsBASE
{
  public:
    tcsBASE();

    static const char* DbRoot();
    static const char* EnvName();
    static const char* ProcName();

    static logFITS    &LogFits();

    static ccsCOMPL_STAT DbRoot(const dbSYMADDRESS &root);
    static ccsCOMPL_STAT EnvName(const ccsENVNAME &env);
    static vltLOGICAL    ObjectOk(eccsERROR_CLASS *object, const char *name);

  private:
    static dbSYMADDRESS dbRoot;
    static ccsENVNAME   envName;
    static ccsPROCNAME  procName;

    static logFITS      logFits;
};

/* Creating this static instance makes sure that    */
/* the static data members are properly initialysed */
static tcsBASE tcsBaseInit;

/* Convenience functions to hide the class */
const char* tcsDbRoot();
const char* tcsEnvName();
const char* tcsProcName();

const char* tcsMakeDbPoint(const dbSYMADDRESS dbRoot, 
			   const char *format,
			   ...);
const char* tcsMakeDbPoint_v(const dbSYMADDRESS dbRoot, 
			     const char *format,
			     va_list va_parList);

/* Define to hide the fact that global logFITS */
/* instance is actually a static member of     */
/* the tcsBASE "singleton"                     */
#define tcsLogFits tcsBASE::LogFits()

#include "tcsBASE.icc"

#endif /*!tcsBASE_H*/
