#ifndef tcsCMD_HANDLER_H
#define tcsCMD_HANDLER_H
/******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: tcsCMD_HANDLER.h,v 1.153 2005/08/02 12:52:44 vltsccm Exp $"
*
* who       when      what
* --------  --------  --------------------------------------------------------
* rkarban  10/10/97  add IsOwnProcess
* nfiebig   29/10/96  created
*/

/******************************************************************************
 * Declaration of class tcsCMD_HANDLER.
 *-----------------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

#include <evhHANDLER.h>
#include <evhSTD_COMMANDS_NAMES.h>
#include <evhStates.h>
#include "tcs.h"
#include "tcsSTATE.h"

// This class is only a helper class for tcsCMD_HANDLER_T
// it implements the counter for all possible active objects
// independently of the implemented policy
// because tcsCMD_HANDLER_T inherits from it
// it must not be used 
class tcsCMD_HANDLER_COUNT
{
  protected:
    const vltINT32 ActiveCount() const {return activeCount;};
    void           IncActiveCount() {activeCount++;};
    void           DecActiveCount() {activeCount--;};
  private:
    static vltINT32 activeCount;
};

template <class StatePolicy=tcsSTATE>
class tcsCMD_HANDLER_T : public StatePolicy, private tcsCMD_HANDLER_COUNT
{
  public:
    tcsCMD_HANDLER_T(const dbSYMADDRESS dbRoot, const msgCMD cmdName,
                     const evhCALLBACK *cb = NULL, const vltLOGICAL allowMultiple = ccsFALSE);
    virtual ~tcsCMD_HANDLER_T();
    virtual ccsCOMPL_STAT Init();
    virtual ccsCOMPL_STAT Reset();
    const char   *CmdName();
    vltLOGICAL    IsActive();
    ccsCOMPL_STAT SendReply(const char *buffer, msgLENGTH size = 0, 
                            vltLOGICAL last = ccsTRUE);
    ccsCOMPL_STAT SendReply(const ccsERROR &error);
    void          MsgCaller(msgMESSAGE &msg);
    const char *  MsgCallerName();
    vltLOGICAL    InternalCall();

  protected:
    evhCB_COMPL_STAT CommandCB(msgMESSAGE &msg, void *udata);
    virtual vltLOGICAL ExecutionPermitted(msgMESSAGE &msg);
    virtual vltLOGICAL IsOwnProcess(msgMESSAGE &msg);
    virtual evhCB_COMPL_STAT Execute(msgMESSAGE &msg, void *udata);
    msgMESSAGE &  MsgCaller();
    void          SetActive(vltLOGICAL flag=TRUE);

  private:
    msgCMD       command;         // name of command handled by this instance
    msgMESSAGE   orgMsg;          // originator command message
    evhCALLBACK *userCB;          // user's command callback
    vltLOGICAL   cmdActive;       // flag if a command is active
    vltLOGICAL   allowMultiple;   // allow command multiple
};


#include "tcsCMD_HANDLER.icc"
// __oOo__

#endif // !tcsCMD_HANDLER_H
