#ifndef tcsCMD_TRANSFER_H
#define tcsCMD_TRANSFER_H
/******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: tcsCMD_TRANSFER.h,v 1.153 2005/08/02 12:52:45 vltsccm Exp $"
*
* who       when      what
* --------  --------  --------------------------------------------------------
* rkarban 2002-03-12 created from chopwsTRANSFER
*/

/******************************************************************************
 * Declaration of class tcsCMD_TRANSFER.
 *-----------------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

#include <evhOBJ_CALLBACK.h>
#include <evhCOMMAND.h>
#include "tcsCMD_HANDLER.h"

class tcsCMD_TRANSFER : public tcsCMD_HANDLER
{
  public:
    tcsCMD_TRANSFER(const dbSYMADDRESS dbRoot, const msgCMD cmdName,
                  const ccsENVNAME env, const ccsPROCNAME proc, 
                  vltINT32 timeout);
    virtual ~tcsCMD_TRANSFER();
    virtual ccsCOMPL_STAT Init(const ccsENVNAME env, const ccsPROCNAME proc,
			       vltINT32 timeout);
    virtual ccsCOMPL_STAT Reset();

  protected:
    evhCB_COMPL_STAT Execute(msgMESSAGE &msg, void *udata);
    evhCB_COMPL_STAT ReplyCB(msgMESSAGE &msg, void *udata);
    evhCB_COMPL_STAT ErrorCB(msgMESSAGE &msg, void *udata);
    evhCB_COMPL_STAT TimeoutCB(msgMESSAGE &msg, void *udata);

  private:
    evhCOMMAND  command;  // command handling with sub-system
    ccsENVNAME  destEnv;  // name of destination environment
    ccsPROCNAME destProc; // name of destination process
    ccsTIMEVAL  timeout;  // reply timeout
};

#endif // !tcsCMD_TRANSFER_H
