#ifndef tcsCON_SUBSYSTEM_H
#define tcsCON_SUBSYSTEM_H
/******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: tcsCON_SUBSYSTEM.h,v 1.153 2005/08/02 12:52:45 vltsccm Exp $"
*
* who       when      what
* --------  --------  --------------------------------------------------------
* rkarban 2002-03-12 created from chopwsCON_SUB_SYSTEM
*/

/******************************************************************************
 * Declaration of class tcsCON_SUBSYSTEM.
 *-----------------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

#include "tcs.h"
#include "tcsCMD_TRANSFER.h"
#include <tcsSTATE.h>
#include <evhCOMMAND.h>

class tcsCON_SUBSYSTEM : public tcsSTATE
{
  public:
    tcsCON_SUBSYSTEM(const dbSYMADDRESS dbState, const dbSYMADDRESS dbSubsystem);
    virtual ~tcsCON_SUBSYSTEM();

    virtual ccsCOMPL_STAT Init();
    virtual const char *LcuEnvName();
    virtual vltINT32 Timeout();
    virtual const char *LcuServer();

    virtual ccsCOMPL_STAT Stop(tcsCMD_HANDLER *);
    virtual ccsCOMPL_STAT Stop(fndOBJECT    *obj,
			       evhCB_METHOD  reply,
			       evhCB_METHOD  errReply, 
			       evhCB_METHOD  timeout = NULL,
			       void         *udata   = NULL);

  protected:
    virtual ccsCOMPL_STAT    SendStop();
    virtual evhCB_COMPL_STAT StopReplyCB(msgMESSAGE &msg, void *);
    virtual evhCB_COMPL_STAT StopErrorCB(msgMESSAGE &msg, void *);
    virtual evhCB_COMPL_STAT StopTimeoutCB(msgMESSAGE &msg, void *);
    virtual void Clear();

  private:
    dbSYMADDRESS    dbPoint; // DB TRANSFER point
    tcsCMD_TRANSFER **objList;  // array of pointers to hosted transfer objects
    vltINT32        objCount; // number of hosted transfer command objects
    ccsENVNAME      lcuEnvName;
    ccsPROCNAME     lcuServer;
    vltINT32        timeout;
    evhCOMMAND      stopCommand;
    tcsCMD_HANDLER *stopHandler;
};

#endif // !tcsCON_SUBSYSTEM_H
