#ifndef tcsDBBACKUP_H
#define tcsDBBACKUP_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: tcsDB_BACKUP.h,v 1.153 2005/08/02 12:52:43 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* gchiozzi  02/04/97  Added include of sys/param.h
* gchiozzi  26/02/97  Changed method names to capital
* rkarban   31/01/97  created
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

#include <sys/param.h>

#include "eccsErr.h"

#define DELIM ",\0"
#define dbBACKUP_RCS  "@(#) $Id: tcsDB_BACKUP.h,v 1.153 2005/08/02 12:52:43 vltsccm Exp $"

#define dbBACKUPMAX (msgBODYMAXLEN-1000)

/*
 * names used in output/input files
 */

#define dbBACKUP_BRANCH    "BRANCH"
#define dbBACKUP_CWP       "CWP"
#define dbBACKUP_POINT     "POINT"
#define dbBACKUP_ATTRIBUTE "ATTRIBUTE"
 
#define dbRESTORE_CWP          "<CWP>:"
#define dbRESTORE_POINT        "<POINT>:"   
#define dbRESTORE_ATTRIBUTE    "<ATTRIBUTE>:"
#define dbRESTORE_TYPE         "<TYPE>:"
#define dbRESTORE_REC          "<REC>:"
#define dbRESTORE_FIELDS       "<FIELDS>:"

class tcsDB_BACKUP : public eccsERROR_CLASS
{
  public:
    tcsDB_BACKUP(const dbSYMADDRESS symAddr, vltLOGICAL branch, const char *backupFile);
    ~tcsDB_BACKUP();

    ccsCOMPL_STAT DoBackup();

    void SetBackupFile (const char *backupFile);
    void SetSymAddr(const dbSYMADDRESS symAddr);
    void SetTypeBranch(vltLOGICAL branch);
    void ChangeCWPinBackupFile(const char *cwp);

  protected:

  private:
    ccsCOMPL_STAT DbBackupSingleAttr (ccsENVNAME     env,
                                      dbSYMADDRESS   symAddr,
                                      dbDIRADDRESS  *dirAddr );
                                 
    ccsCOMPL_STAT DbBackupPoint(ccsENVNAME    env,
                                dbSYMADDRESS  alias,
                                vltLOGICAL    branch);
                           
    ccsCOMPL_STAT DbBackupFct(dbSYMADDRESS  symAddr,
                              vltLOGICAL    branch);

    dbSYMADDRESS  symCwp;
    FILE         *dbBackupFd;                  /* file descriptor of output file */
    char          dbBackupOut[MAXPATHLEN+1];     /* output file */
    char         *dbBackupPtr;
    int           dbBackupSize;
    vltLOGICAL    dbBranch;
    dbSYMADDRESS  dbOvlCwp;
}; 



#endif /*!tcsDBBACKUP_H*/
