#ifndef tcsMOON_H
#define tcsMOON_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: tcsMOON.h,v 1.153 2005/08/02 12:52:44 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* awalland  02/10/97  Moved from nttsm module. Restructured.
* jspyromi  22/12/96  changed long and lat to be those of the NTT
*                     rather than the random place Anders selected!
* awalland  01/07/96  created
*-------------------------------------------------------------------
*/

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

#include "eccsDb.h"
#include "eccsErr.h"
#include "eccsDB_ATTR.h"

class tcsMOON : public eccsERROR_CLASS
{
  public:
    tcsMOON(const dbSYMADDRESS  dbPoint = "",
            const vltDOUBLE     longitude = 0.0,
            const vltDOUBLE     latitude  = 0.0,
	    const vltDOUBLE     height = 0.0);
    ~tcsMOON(); 

    ccsCOMPL_STAT   GetMoonPosition();
    ccsCOMPL_STAT   GetMoonPosition(ccsTIMEVAL atTime);
    
  protected:
  
  private:
    ccsCOMPL_STAT   CalculateMoonPosition(ccsTIMEVAL atTime);

    vltDOUBLE       Longitude;
    vltDOUBLE       Latitude;
    vltDOUBLE       Height;

    /* DB Attributes accessed in write mode for update */
    eccsDB_FLOAT    *altitudeDB;
    eccsDB_FLOAT    *azimuthDB;
    eccsDB_INT32    *phaseDB;
    eccsDB_DOUBLE   *raDB;    
    eccsDB_DOUBLE   *decDB;
};

#endif /*!tcsMOON_H*/                 
