#ifndef TCSMON_H
#define TCSMON_H
/****************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: tcsmon.h,v 2.44 2005/09/07 07:02:24 vltsccm Exp $"
*
* who       when      what
* --------  --------  -----------------------------------------------------
* rkarban   14/05/97  created
*/

/****************************************************************************
 * Common service routines.
 *---------------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

#include <ECCS.h>
#include <eccsTestTools.h>
#include <fndOBJECT.h>
#include <fndSTRING.h>
#include <evhCALLBACK.h>
#include <evhTASK.h>
#include <eccsDB_ATTR.h>

#include "tcsmonDefines.h"
#include "tcsmonErrors.h"

/*
 * Macros to read from and write to the database
 */
#define DB_READ(var,type,attrName)                                   \
	{                                                            \
        eccsDB_##type attrName##Attr(dbPoint, attrName);             \
	var = attrName##Attr;                                        \
	if (attrName##Attr.ErrStatus() == FAILURE)                   \
            {                                                        \
            ErrAdd(tcsmonMOD, tcsmonERR_DB_READ, __FILE_LINE__,        \
                   "configuration parameter", dbPoint, attrName);    \
            return FAILURE;                                          \
            }                                                        \
    	}

#define DB_READ_STRING(var,attrName)                                 \
	{                                                            \
        eccsDB_STRING attrName##Attr(dbPoint, attrName);             \
	strcpy(var, (const char *)attrName##Attr);                   \
	if (attrName##Attr.ErrStatus() == FAILURE)                   \
            {                                                        \
            ErrAdd(tcsmonMOD, tcsmonERR_DB_READ, __FILE_LINE__,        \
                   "configuration parameter", dbPoint, attrName);    \
            return FAILURE;                                          \
            }                                                        \
    	}

#define DB_WRITE(value,type,attrName)                                \
	{                                                            \
        eccsDB_##type attrName##Attr(dbPoint, attrName);             \
	attrName##Attr = value;                                      \
	if (attrName##Attr.ErrStatus() == FAILURE)                   \
            {                                                        \
            ErrAdd(tcsmonMOD, tcsmonERR_DB_WRITE, __FILE_LINE__,       \
                   "status parameter", dbPoint, attrName);           \
            return FAILURE;                                          \
            }                                                        \
    	}


/* 
 * Prototypes
 */
vltLOGICAL tcsmonObjectOk(eccsERROR_CLASS *object, const char *name);

#endif // !TCSMON_H
