#ifndef tcsmonCON_ENVIRONMENT_H
#define tcsmonCON_ENVIRONMENT_H
/******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: tcsmonCON_ENVIRONMENT.h,v 2.44 2005/09/07 07:02:25 vltsccm Exp $"
*
* who       when      what
* --------  --------  --------------------------------------------------------
* tcsmgr 2002-09-05 lossam renamed to rflrms
* asmmgr 2002-07-19 added lossam, tau0 and theta0
* ssandroc 2000-02-12 float -> double
* ssandroc  04/07/98  Minor changes in asm inteface
* rkarban   14/03/98  created
*/

/******************************************************************************
 * Declaration of class tcsmonCON_ENVIRONMENT.
 *-----------------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

#include <evhTIMER.h>
#include <asmTCS_INTERFACE.h>
#include "tcsSTATE.h"

class tcsmonCON_ENVIRONMENT : public tcsSTATE
{
  public:
    tcsmonCON_ENVIRONMENT(const dbSYMADDRESS dbRoot);
    virtual ~tcsmonCON_ENVIRONMENT();
    ccsCOMPL_STAT  Init();
    ccsCOMPL_STAT  Start();
    ccsCOMPL_STAT  Stop();

  protected:
    virtual evhCB_COMPL_STAT AsmEventCB(evtEVENT_MSG &msg, void *);

  private:
    dbSYMADDRESS    dbPoint;         // class DB support point
    ccsTIMEVAL      interval;         // asm poll interval
    vltLOGICAL      timerActive;
    evhTIMER       *timer;
    asmTCS_INTERFACE *asmIf;
    asmTCS_DATA_t   asmData;
    vltUINT32       errorCounter;
    eccsDB_DOUBLE   *windSpeed;
    eccsDB_DOUBLE   *windDir;
    eccsDB_DOUBLE   *temperature;
    eccsDB_DOUBLE   *lapseRate;
    eccsDB_DOUBLE   *pressure;
    eccsDB_DOUBLE   *humidity;
    eccsDB_DOUBLE   *dewPoint;
    eccsDB_DOUBLE   *seeing;
    eccsDB_DOUBLE   *obsSeeing;
  //eccsDB_DOUBLE   *obsAirmass;
  //  eccsDB_DOUBLE   *obsWavelength;
  vltDOUBLE obsAirmass;
  vltDOUBLE obsWavelength;
    eccsDB_INT32    *asmStatus;
    eccsDB_INT32    *obsSeeingStatus;
    eccsDB_DOUBLE   *tau0;
    eccsDB_DOUBLE   *theta0;
    eccsDB_DOUBLE   *rflrms;
};

#endif // !tcsmonCON_ENVIRONMENT_H
