#ifndef tcsmonCON_MAIN_TASK_H
#define tcsmonCON_MAIN_TASK_H
/******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: tcsmonCON_MAIN_TASK.h,v 2.44 2005/09/07 07:02:24 vltsccm Exp $"
*
* who       when      what
* --------  --------  --------------------------------------------------------
* imunoz    2000-07-14 removed obsolete objects hbLog and conLog
* awalland  29/06/98  added temp logger
* rkarban   14/05/97  created
*/

/******************************************************************************
 * Declaration of class tcsmonCON_MAIN_TASK.
 *-----------------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

#include "tcsmon.h"
#include "tcsSTATE.h"
#include "tcsCMD_HANDLER.h"
#include "tcsmonCON_MOON_CALC.h"
#include "tcsmonCON_ENVIRONMENT.h"
#include "tcsmonSchedHandler.h"


class tcsmonCON_MAIN_TASK : public tcsSTATE
{
  public:
    tcsmonCON_MAIN_TASK(const dbSYMADDRESS dbRoot);
    virtual ~tcsmonCON_MAIN_TASK();
    ccsCOMPL_STAT Recover();

    virtual evhCB_COMPL_STAT InitCB(msgMESSAGE &msg, void *);
    virtual evhCB_COMPL_STAT ExitCB(msgMESSAGE &msg, void *);
    virtual evhCB_COMPL_STAT StopCB(msgMESSAGE &msg, void *);
    virtual evhCB_COMPL_STAT OnlineCB(msgMESSAGE &msg, void *);
    virtual evhCB_COMPL_STAT StandbyCB(msgMESSAGE &msg, void *);
    virtual evhCB_COMPL_STAT OffCB(msgMESSAGE &msg, void *);
    virtual evhCB_COMPL_STAT StatusCB(msgMESSAGE &msg, void *udata);
    virtual evhCB_COMPL_STAT VerboseCB(msgMESSAGE &msg, void *udata);


  protected:
    virtual ccsCOMPL_STAT    Init();
    virtual ccsCOMPL_STAT    Stop();
    virtual ccsCOMPL_STAT    Start();

  private:
    dbSYMADDRESS       dbPoint;
    tcsCMD_HANDLER    *initHandler;    // INIT command handler
    tcsCMD_HANDLER    *exitHandler;    // EXIT command handler
    tcsCMD_HANDLER    *stopHandler;    // STOP command handler
    tcsCMD_HANDLER    *onlineHandler;  // ONLINE command handler
    tcsCMD_HANDLER    *standbyHandler; // STANDBY command handler
    tcsCMD_HANDLER    *offHandler;     // OFF command handler
    tcsCMD_HANDLER    *statusHandler;     // STATUS command handler
    tcsCMD_HANDLER    *verboseHandler;     // VERBOSE command handler

    tcsmonCON_MOON_CALC   *conMoonCalc;
    tcsmonCON_ENVIRONMENT *conEnvironment;
    tcsmonSchedHandler    *schedLog;
};

#endif // !tcsmonCON_MAIN_TASK_H
