#ifndef tcsmonDEFINES_H
#define tcsmonDEFINES_H
/******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: tcsmonDefines.h,v 2.44 2005/09/07 07:02:24 vltsccm Exp $"
*
* who       when      what
* --------  --------  -------------------------------------------------------
* sidmgr 2002-10-05 removed hardcoded DB paths
* tcsmgr 2002-09-05 lossam renamed rflrms
* asmmgr  2002-07-19 added lossam, tau0 and tetha0 defines
* mkiekebu  12/08/99  cableWrap definitions added
* awalland  26/03/99  Added alt/az torque and poserr rms
* awalland  02/12/98  Correct mapping of M1 temperatures
* awalland  25/09/98  add db definitions for alt and az position
* awalland  29/06/98  add temp log definitions
* rkarban   14/05/97  created
*/

/******************************************************************************
 * General definitions, to be used by code and database classes.
 *-----------------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

/* 
 * Module name
 */
#define tcsmonMOD "tcsmon"

/* 
 * Defines for the target telescope. Up to now only VLT and NTT.
 * The default target is VLT.
 */
#include <tcsDefines.h>

/*
 * Module and process states values and names
 */
#include <evhStates.h>
#include <evhSTD_COMMANDS_NAMES.h>


/*
 * Database point and attribute names
 */
#define tcsmonDB_ENTRY_POINT                  "tcsmon"
#define tcsmonDB_STATE                        "state"
#define tcsmonDB_SUBSTATE                     "substate"

#define tcsmonDB_CONTROL_POINT                "control"
#define tcsmonDB_CONTROL_STATE                "state"
#define tcsmonDB_CONTROL_SIMULATION           "simulation"
#define tcsmonDB_CONTROL_VERBOSE              "verbose"

/*
 * tcsmon Commands
 */



/*
 * definitions for DB
 */
#define tcsmonDB_SCHED_LOG_POINT	"schedLog"

#define tcsmonDB_HB_LOG_POINT		"hbLog"
#define tcsmonDB_HB_LOG_period		"period"
#define tcsmonDB_HB_LOG_enable		"enable"

#define tcsmonDB_MOON_CALC_POINT            "moonCalc"
#define tcsmonDB_MOON_CALC_PERIOD           "period"
#define tcsmonDB_MOON_CALC_MOON             "moon"

#define tcsmonDB_SITE_CONSTANTS_POINT       "siteConstants"
#define tcsmonDB_SITE_CONSTANTS_LONG        "longitude"
#define tcsmonDB_SITE_CONSTANTS_LAT         "latitude"
#define tcsmonDB_SITE_CONSTANTS_HEIGHT      "height"

#define tcsmonDB_ENVIRONMENT_POINT		"environment"
#define tcsmonDB_ENVIRONMENT_PERIOD		"pollPeriod"
#define tcsmonDB_ENVIRONMENT_WINDSPEED		"windspeed"
#define tcsmonDB_ENVIRONMENT_WINDDIR		"winddir"
#define tcsmonDB_ENVIRONMENT_TEMPERATURE	"temperature"
#define tcsmonDB_ENVIRONMENT_PRESSURE		"pressure"
#define tcsmonDB_ENVIRONMENT_HUMIDITY		"humidity"
#define tcsmonDB_ENVIRONMENT_LAPSE_RATE		"lapseRate"
#define tcsmonDB_ENVIRONMENT_SEEING		"seeing"
#define tcsmonDB_ENVIRONMENT_OBS_SEEING		"obsSeeing"
#define tcsmonDB_ENVIRONMENT_DEW_POINT		"dewPoint"
#define tcsmonDB_ENVIRONMENT_ASM_STATUS		"asmStatus"
#define tcsmonDB_ENVIRONMENT_OBS_SEEING_STATUS	"obsSeeingStatus"
#define tcsmonDB_ENVIRONMENT_TAU0		"tau0"
#define tcsmonDB_ENVIRONMENT_THETA0		"theta0"
#define tcsmonDB_ENVIRONMENT_RFLRMS		"rflrms"


/*
 * definitions for alarm names
 */
#define tcsmonASM_STATUS_ALARM_NORMAL  0
#define tcsmonASM_STATUS_ALARM_WARNING 1


#define tcsmonERROR_MAX 5
#endif // !tcsmonDEFINES_H
