#ifndef tcsmonattr_H
#define tcsmonattr_H
/************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: tcsmonattr.h,v 2.44 2005/09/07 07:02:25 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* imunoz  06/10/99  created
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */

#include "ccs.h"
#include "db.h"
#include <vector>
#include <iostream>


class node {
public:

    vltBYTES256 name;		// attr name.
    vltBYTES256 fitsKw;		// FTIS keyword.
    vltUINT16 period;		// monitoring period in secs
    int gid;			// Group id.  
    // must match  actual DB value in order to allow logging
    vltINT32  okValue;
    
    // attr that don't come from the DB
    vltUINT32 size;   
    dbTYPE    type;
    dbVALUE   value;
    dbDIRADDRESS  dirAddr;
    
   
    node(void):
	okValue(0)
	{
	    name[0]= fitsKw[0] = 0;
	    period = gid = 0;
	    size = 0;
	    type = (dbATTRTYPE)-1;
	}
    
    node (const node &n) :
	period(n.period),
	gid(n.gid),
	okValue(n.okValue),
	size(n.size),
	type(n.type),
	dirAddr(n.dirAddr)
	{
	    if (&n == this)
		return;
	    strncpy((char*)name, (const char*)n.name, 256);
	    strncpy((char*)fitsKw, (const char*)n.fitsKw, 256);
	}

    void print(void)
	{
	    cout << "Name: " << name << " Period: " << period << endl;
	    cout << "Fits: " << fitsKw << endl;
	}
};


class nodeGroup : public node
{
  public:
    vector<node*> nodes;
    // copy constructor
    nodeGroup(void) : node()
	{}
    nodeGroup( const nodeGroup &n) : node(n)
	{
	    if (&n == this)	// self copy, do nothing.
		return;
	    nodes = n.nodes;
	    
	}
    ~nodeGroup()
	{
	    vector<node*>::iterator  i;
	    
	    for (i=nodes.begin(); i != nodes.end(); ++i)
		delete *i;
	}
};
#endif /*!attr_H*/
