#ifndef tifDefines_H
#define tifDefines_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: tifDefines.h,v 1.153 2005/07/25 11:18:53 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* awalland 2002-01-11 Added defines for guiding state and mode
* gchiozzi 2001-03-05 tifMAX_NAMES_RECS from 100 to 200 (spr. 20000473)
* gchiozzi  10/09/97  Table size defines reduced to 100 entries. This should be OK
* gchiozzi  23/04/97  Added tifMAX_CMD_RECS
* gchiozzi  01/12/95  created
*/

/************************************************************************
 *
 * This file contains common defines used both by C/C++ files and 
 * dbLoader files
 *----------------------------------------------------------------------
 */

/* Module name */
#define tifMOD "tif"

/* Maximum number of records in the cmd table */
#define tifMAX_CMD_RECS 100
/* Maximum number of records in the data info and event info tables */
#define tifMAX_NAMES_RECS 200

/* Some useful defines for guiding */
#define tifAG_STATE_OPERATING     121
#define tifAG_STATE_GUIDING       122
#define tifAG_STATE_MANUAL        123

#define tifAG_MODE_NONE           0   
#define tifAG_MODE_AUTOGUIDE      1
#define tifAG_MODE_FIELDSTAB      2
#define tifAG_MODE_PROBEGUIDE     3

#endif /*!tifDefines_H*/
