#ifndef TIMER_LITE_H
#define TIMER_LITE_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: timerLite.h,v 2.35 2005/09/13 16:35:13 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* tebert  30/06/98  created
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */

#define rtWILD          -1      /* wildcard */
#define CCSTIMEKEEPER   "timsTimeKeeper"
#define TIMER_START     "STARTTI"
#define TIMER_STOP      "STOPTI"
#define TIMER_REPORT    "REPORT"
#define TIMER_DEBUG_ON  "DEBON"
#define TIMER_DEBUG_OFF "DEBOFF"

#define timsLeapYear(Y) ((((Y)%4==0) && (((Y)%100!=0) || ((Y)%400==0))) ? 1 : 0)

typedef struct 
    {
    rtInt16         year;   /* 1970 to 2037 or rtWILD (-1) */
    rtInt16         month;  /* 1 to 12 or rtWILD (-1)      */
    rtInt16         day;    /* 1 to 31 or rtWILD (-1)      */
    rtInt16         hour;   /* (-12) to 23                 */
    rtInt16         minute; /* (-30) to 59                 */
    rtInt16         second; /* (-30) to 59                 */
    rtInt32         usec;   /* 0 to 999999                 */
    } rtStartTime;

typedef struct
    {
    rtInt16         days;
    rtInt16         hours;
    rtInt32         minutes;
    rtInt32         seconds;
    rtInt32         usecs;
    } rtInterval;


typedef struct
    {
    struct timeval  time;
    rtUInt8         cyclic;
    } rtTimerResponse;

typedef struct
    {
    rtProcessId   who;
    rtStartTime   start;
    rtInterval    interval;
    rtUInt32      size;
    rtInt32       prio;
    rtInt32       verify;
    rtTimerId     id;
    } timerREQUEST_MSG;

/* prototypes */

rtInt      rtCancelTimer       (rtChar *env, rtTimerId *id, rtUInt8 *type, 
                                struct timeval *when, rtInt32 verify); 
rtInt      rtRequestTimeReport (rtChar *env, rtChar *filename, rtInt32 verify); 
rtTimerId *rtStartTimer        (rtChar *env, rtProcessId *who, rtStartTime *start,
                                rtInterval *interval, rtUInt8 *message, rtUInt32 msize, 
                                rtInt32 mpriority, rtInt32 verify, struct timeval *next); 
void       rtNap               (rtInt32 microseconds);

#endif /*!TIMER_LITE_H*/
