#ifndef TPOINTIC
#define TPOINTIC

#ifdef __cplusplus
extern "C" {
#endif

#include <stdio.h>

/*
**  - - - - - - - - -
**   t p o i n t . h
**  - - - - - - - - -
**
**  TPOINT function prototypes #include file.
**
**  Last revision:   28 October 2000
**
**  Copyright 2000 P.T.Wallace.  All rights reserved.
*/

int tptAbo ( int );
int tptAbort ( int );
int tptAcon ( int, double*, int, double, double, double* );
int tptAcon2 ( double*, int, int, double*, double* );
int tptAdjust ( int m );
void tptAdjust_ ( void );
int tptAppend ( int );
void tptAppend_ ( void );
int tptArg1 ( char* );
int tptCall ( char* );
void tptCall_ ( void );
int tptCapt ( int );
void tptCapt_ ( void );
int tptChain ( char* );
void tptChain_ ( void );
int tptClist ( int );
void tptClist_ ( void );
int tptClrng ( int );
void tptClrng_ ( void );
int tptClval ( char*, int*, char* );
int tptCmdlcl ( char* );
int tptCsrv ( char*, int, int, double* );
void tptCsrv_ ( void );
void tptD2hms ( int, double, int*, long* );
double tptDatn2 ( double, double );
void tptDecode ( char*, int, double*, int*, int*, int* );
int tptDnstrB ( double, double, double,
                double, double, double,
                double, double, double,
                double, double, double, double[3][3],
                double*, double* );
int tptEcho ( int );
void tptEcho_ ( void );
int tptEnd ( void );
void tptEnd_ ( void );
void tptExstr ( int, char*, int*, char* );
int tptFit ( int fit );
void tptFit_ ( void );
int tptFittol ( double );
void tptFittol_ ( void );
int tptFix ( char* );
void tptFix_ ( void );
int tptFop ( FILE**, char*, int, char* );
int tptFrame ( int );
void tptFrame_ ( void );
int tptG ( int, int, double );
void tptG_ ( void );
int tptGam ( int, int, double );
void tptGam_ ( void );
int tptGc ( int, char* );
void tptGc_ ( void );
int tptGdist ( void );
void tptGdist_ ( void );
int tptGetl ( char*, char*, int* );
void tptGetstr ( char*, int, char* );
int tptGhyst ( int, int, double );
void tptGhyst_ ( void );
int tptGmap ( int, double );
void tptGmap_ ( void );
int tptGscat ( int, double );
void tptGscat_ ( void );
int tptGsmap ( int, double );
void tptGsmap_ ( void );
int tptHelp ( char* );
void tptHelp_ ( void );
void tptHist ( double[], int, int, int, int, double[], double,
               double, double, double, double );
int tptIndat ( char*, int* );
void tptIndat_ ( void );
int tptInmod ( char* );
void tptInmod_ ( void );
int tptInpro ( char* );
void tptInpro_ ( void );
int tptInst ( char* );
void tptInst_ ( void );
int tptIntip ( char*, int*, int* );
int tptLength ( char* );
int tptLose ( char* );
void tptLose_ ( void );
int tptMarkh ( double );
void tptMarkh_ ( void );
int tptMaskc ( int, int, int, double );
int tptMaskn ( int, int, int);
void tptMaskun_ ( void );
int tptMeslev ( int, int );
void tptMeslev_ ( void );
int tptMesrep ( FILE*, FILE*, int, int, int, char* );
void tptMess ( int, char* );
void tptMessm ( int, char* );
void tptMessr ( int, char* );
int tptMinit ( int, int, int[], int*, int*, int*, char[][9] );
int tptNactob ( void );
int tptOutdat ( char* );
void tptOutdat_ ( void );
int tptOutmod ( char* );
void tptOutmod_ ( void );
int tptParal ( char* );
void tptParal_ ( void );
void tptPbeg ( void );
int tptPcapt ( double, double );
void tptPend ( void );
int tptPens ( int, int, int, int, int, int );
void tptPens_ ( void );
int tptPerfct ( double );
void tptPerfct_ ( void );
int tptPfirst ( void );
void tptPlotsq ( double, double );
void tptPlotst ( double, double );
int tptPltoff ( void );
void tptPltoff_ ( void );
int tptPlton ( char*, int );
void tptPlton_ ( void );
int tptPltz ( int, double, double, double, double );
void tptPltz_ ( void );
int tptPmappl ( int, double[7], double, double, double, double[3], double[3] );
int tptPread ( char* );
int tptPterm ( int, double, double*, int, double*, double, double,
               int, double[3][3], int, int, int, char[][9], char[][9],
               int, double*, double[8] );
int tptPutl ( char* );
void tptPutlr ( int, int, char* );
void tptPwait ( void );
void tptQnobs ( int*, int*, int* );
void tptR2dms ( int, double, int*, long* );
void tptR2hms ( int, double, int*, long* );
int tptReplen ( int );
void tptReplen_ ( void );
int tptReset ( void );
void tptReset_ ( void );
void tptReturn ( void );
int tptScat ( char*, int*, double*, double*, double*,
              double*, double*, char* );
int tptScomp ( char*, char* );
int tptScondn ( int, char*, char*, char* );
int tptSetcap ( char* );
void tptSetcap_ ( void );
void tptSetabo ( int ( * ) ( int ) );
void tptSetmes ( int ( * ) ( FILE*, FILE*, int, int, int, char* ) );
int tptSevlev ( int );
int tptShow ( void );
void tptShow_ ( void );
int tptSlist ( double, int );
void tptSlist_ ( void );
int tptSpawn ( char* );
void tptSpawn_ ( void );
int tptSread ( FILE*, int, char*, char*, char* );
int tptTerm ( char*, int, int*, char[][9], char[][9] );
int tptTpinit ( int ( * ) ( int ),
                int ( * ) ( FILE*, FILE*, int, int, int, char* ),
                int, int, char*, char*, char*, char* );
int tptTptini ( void );
int tptTptrun ( char* );
char *tptTrim ( char* );
char* tptTrmgen ( char* );
void tptTrmloc ( int*, char[][9] );
void tptTrmstd ( int*, char[][9] );
int tptTxf ( int, int );
void tptTxf_ ( void );
int tptTxp ( int );
void tptTxp_ ( void );
char *tptUc ( char*, char* );
int tptUnfit ( int );
void tptUnfit_ ( void );
void tptUpstrA ( double, double, double, double, double,
                 double, double, double,
                 double, double, double, double[3][3],
                 double*, double*, double* );
int tptUse ( char* );
void tptUse_ ( void );
int tptVt ( int, int );
void tptVt_ ( void );
void tptVtget ( void );
void tptVtinit ( void );

#ifdef __cplusplus
}
#endif

#endif
