#ifndef trkwsCON_MAIN_TASK_H
#define trkwsCON_MAIN_TASK_H
/*******************************************************************************
* E.S.O. - VLT project

*
* "@(#) $Id: trkwsCON_MAIN_TASK.h,v 1.166 2005/07/25 15:44:47 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* rkarban 2001-01-31 add setdut SELFCMD
* tcsmgr2 1999-11-30 Added restore attribute method.
* rkarban  08/09/98  remove code for guide probe control
* gchiozzi  19/08/96  Restructured handling of position calculation event
* gchiozzi  02/08/96  Added returned valid substate from CheckSubstate
* gchiozzi  30/07/96  Added OnlineCB
* mnastvog  26/03/96  Added support for GETREM command
* gchiozzi  31/08/95  Callbacks that can receive messages or database events, receivemsgRAW_MESSAGE &msg 
* kwirenst  02/06/95  created
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */


#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

#include "trkws.h"
#include "trkwsTRANSFER.h"   
#include "trkwsTRANSFER_SER.h"   
#include "trkwsNEW_PCM_SER.h"   
#include "trkwsTRANSFER_ASM.h"
#include "trkwsRING_BUFFER.h"
#include "trkwsREM_TRK_LIST_COMMAND.h"   
#include "trkwsMANAGE_LIST.h"   
#include "trkwsPOS_CALC.h"
#include "evhDB_TASK.h"
#include "evhSTD_COMMANDS.h"
#include "evhDB_COMMAND.h"
#include "tcsDB_SYNC_ERR_CHECK.h"
#include "fndString.h"
#include "math.h"
#include "mswFOCUS.h"
#include "trkwsFOCUS_DATA.h"

#ifndef TARGET_TCS
#error TARGET_TCS has to be define to either VLT_TCS or NTT_TCS,
#error have to define correct focus handling object
#endif

#if TARGET_TCS == VLT_TCS
#include "mswCHANGE_FOCUS_VLT.h"
#endif

#if TARGET_TCS == NTT_TCS
#include "mswCHANGE_FOCUS_NTT.h"
#endif

extern "C" {
#include "cmd.h"
#include "tcsVcc.h"
#include "slalib.h"
#include "slamac.h"
}
class trkwsCON_MAIN_TASK : public evhDB_TASK
{
  public:
    trkwsCON_MAIN_TASK(const dbSYMADDRESS  dbPoint,
		       trkwsFOCUS_DATA &focusData,
		       trkwsMANAGE_LIST &LCUList,
		       mswFOCUS &focus);
   ~trkwsCON_MAIN_TASK();

    // Callbacks for public commands

   virtual evhCB_COMPL_STAT OffsetsCB(msgMESSAGE &msg, void *udata);
   virtual evhCB_COMPL_STAT PresetStarCB(msgMESSAGE &msg, void *udata);
   virtual evhCB_COMPL_STAT PresetFixCB(msgMESSAGE &msg, void *udata);
   virtual evhCB_COMPL_STAT PresetNameCB(msgMESSAGE &msg, void *udata);
   virtual evhCB_COMPL_STAT TransfersCB(msgMESSAGE &msg, void *udata);
   virtual evhCB_COMPL_STAT NewPcmCB(msgMESSAGE &msg, void *udata);
   virtual evhCB_COMPL_STAT SetupsCB(msgMESSAGE &msg, void *udata);
   virtual evhCB_COMPL_STAT ReadAsmCB(msgMESSAGE &msg, void *udata);
   virtual evhCB_COMPL_STAT ReadPosCB(msgMESSAGE &msg, void *udata);
   virtual evhCB_COMPL_STAT ReadSidCB(msgMESSAGE &msg, void *udata);
   virtual evhCB_COMPL_STAT SetRLimCB(msgMESSAGE &msg, void *udata);
   virtual evhCB_COMPL_STAT GetRemTrkTimeCB(msgMESSAGE &msg, void *udata);
   virtual evhCB_COMPL_STAT SetFocusStationCB(msgMESSAGE &msg, void *udata);

    ccsCOMPL_STAT    Init(evhCALLBACK *okCb = NULL, evhCALLBACK *errorCb = NULL,
			  vltLOGICAL pollFocusIfNotReady = ccsTRUE);
    ccsCOMPL_STAT    Recover();

    // Overloading of inherited commands

   virtual evhCB_COMPL_STAT ExitCB(msgMESSAGE &msg, void *udata);
   virtual evhCB_COMPL_STAT InitCB(msgMESSAGE &msg, void *udata);
   virtual evhCB_COMPL_STAT OnlineCB(msgMESSAGE &msg, void *udata);

  protected:
   virtual evhCB_COMPL_STAT NotImplCB(msgMESSAGE &msg, void *udata);

   virtual evhCB_COMPL_STAT StartupOKCB(msgMESSAGE &msg, void *udata);
   virtual evhCB_COMPL_STAT StartupErrorCB(msgMESSAGE &msg, void *udata);

   virtual evhCB_COMPL_STAT InitOKCB(msgMESSAGE &msg, void *udata);
   virtual evhCB_COMPL_STAT InitErrorCB(msgMESSAGE &msg, void *udata);

   virtual evhCB_COMPL_STAT OffsetsOKCB(msgRAW_MESSAGE &msg, void *udata);
   virtual evhCB_COMPL_STAT OffsetsErrorCB(msgRAW_MESSAGE &msg, void *udata);

   virtual evhCB_COMPL_STAT PresetsOKCB(msgRAW_MESSAGE &msg, void *udata);
   virtual evhCB_COMPL_STAT PresetStarUpdFocOKCB(msgRAW_MESSAGE &msg, void *udata);
   virtual evhCB_COMPL_STAT PresetStarUpdRotOKCB(msgRAW_MESSAGE &msg, void *udata);
   virtual evhCB_COMPL_STAT PresetStarUpdOaxOKCB(msgRAW_MESSAGE &msg, void *udata);
   virtual evhCB_COMPL_STAT PresetsErrorCB(msgRAW_MESSAGE &msg, void *udata);

   virtual evhCB_COMPL_STAT GetRemOKCB(msgMESSAGE &msg, void *udata);
   virtual evhCB_COMPL_STAT GetRemErrorCB(msgMESSAGE &msg, void *udata);

   virtual evhCB_COMPL_STAT SetupsOKCB(msgMESSAGE &msg, void *udata);
   virtual evhCB_COMPL_STAT SetupsErrorCB(msgMESSAGE &msg, void *udata);

   virtual evhCB_COMPL_STAT SetDutOKCB(msgMESSAGE &msg, void *udata);
   virtual evhCB_COMPL_STAT SetDutErrorCB(msgMESSAGE &msg, void *udata);

   virtual vltLOGICAL IsOwnProcess(msgMESSAGE &msg);
   virtual void NewPresetProlog(msgMESSAGE &msg,void *udata);

   vltINT32      ReadModSubstate();
   vltINT32      ReadModState();
   ccsCOMPL_STAT CheckSubstate(msgMESSAGE &msg,vltINT32 substate, vltINT32 *valid=NULL);
   ccsCOMPL_STAT PresetAct(msgMESSAGE &msg, void *udata);
   ccsCOMPL_STAT ExpandCmd(msgMESSAGE &msg);

    trkwsFOCUS_DATA       &trkwsFocusData;
    trkwsMANAGE_LIST      &trkwsLCUList;
    mswFOCUS              &trkwsFocus;
    tcsDB_SYNC_ERR_CHECK  waitOffsets;
    tcsDB_SYNC_ERR_CHECK  waitPresets;
    trkwsTRANSFER         *transOffs;
    trkwsTRANSFER         *transPres;  
    trkwsTRANSFER_SER     *transRest;  
    trkwsNEW_PCM_SER     *transNewPcm;  
    trkwsTRANSFER_ASM     *transASM;  
    trkwsTRANSFER         *transGetRem;
    trkwsMANAGE_LIST      *manageLCUs;
    trkwsPOS_CALC         *posCalc;
  private:
    ccsCOMPL_STAT  BackupAttr  (const char *attr, vltDOUBLE value);
    ccsCOMPL_STAT  RestoreAttr (const char *attr, vltDOUBLE *value);
    ccsCOMPL_STAT CheckLimits (vltDOUBLE ra,
			       vltDOUBLE de,
			       vltBYTES4 syst,
			       vltDOUBLE ep, 
			       vltDOUBLE eq,
			       vltDOUBLE pma, 
			       vltDOUBLE pmd, 
			       vltDOUBLE rv, 
			       vltDOUBLE plx,
			       vltBYTES8  type,
			       vltLOGICAL *limitsOk);

    evhDB_COMMAND   setupCmd;
    msgMESSAGE      msg;  
    msgMESSAGE      setupMsg; 
    msgMESSAGE      getremMsg; 
    msgMESSAGE      initCBMsg; 
    vltLOGICAL      initPending;
    msgMESSAGE      offsPendMsg; 
    msgMESSAGE      offsNewMsg; 
    vltLOGICAL      offsPending;
    msgMESSAGE      presPendMsg; 
    msgMESSAGE      presNewMsg; 
    vltLOGICAL      presPending;
    msgMESSAGE      stopPendMsg; 
    msgMESSAGE      stopNewMsg; 
    vltLOGICAL      stopPending;
    vltLOGICAL      presAstro;
    dbSYMADDRESS    dbBasePoint;
    dbSYMADDRESS    dbDataPoint;
    dbSYMADDRESS    dbDataSetupPoint;
    dbSYMADDRESS    dbControlPoint;
    trkwsSELF_CMD   setdut;
    vltLOGICAL pollFocus;

    // Configuration parameters (read from DB) in Init():
    vltINT32     offsetTimeout;
    vltINT32     presetTimeout;
    vltINT32     setupTimeout;
    vltINT32     transferTimeout;
    vltLOGICAL   checkLimits;
};



#endif /*!trkwsCON_MAIN_TASK_H*/
