#ifndef trkwsPOS_READ_LIST_H
#define trkwsPOS_READ_LIST_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: trkwsPOS_READ_LIST.h,v 1.166 2005/07/25 15:44:49 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* gchiozzi  24/10/96  Added maxDifference to Match() method
* gchiozzi  20/08/96  Added new attributes
* gchiozzi  19/08/96  created
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

#include "evhHANDLER.h"
#include "eccsDB_ATTR.h"
#include "trkws.h"
#include "trkwsRING_BUFFER.h"

class trkwsPOS_READ_LIST:  public fndOBJECT, public eccsERROR_CLASS
{
  public:
    trkwsPOS_READ_LIST(const dbSYMADDRESS dbPoint,
		       fndOBJECT *obj,
		       const evhCB_METHOD procedure);
    virtual ~trkwsPOS_READ_LIST();

    ccsCOMPL_STAT     ReadPosition();
    ccsCOMPL_STAT     Match(vltDOUBLE timeStamp, vltDOUBLE maxDifference=0.0);
    ccsCOMPL_STAT     Select(vltINT32 offset);

    trkwsRING_BUFFER &RingBuffer() { return ringBuffer; };
    evtEVENT         &Evt()        { return evt;   };

    vltDOUBLE         Position()   { return position;  };
    vltDOUBLE         AlphaAgc()   { return alphaAgc;  };
    vltDOUBLE         DeltaAgc()   { return deltaAgc;  };
    vltDOUBLE         PosEncoder() { return posEncoder;};
    vltDOUBLE         TimeStamp()  { return timeStamp; };

    const char *DbPoint() { return dbPoint;}

  private:
    dbSYMADDRESS     dbPoint;
    trkwsRING_BUFFER ringBuffer;
    evtEVENT         evt;

    dbLISTID         listId;
    vltDOUBLE        position;
    vltDOUBLE        posEncoder;
    vltDOUBLE        timeStamp;
    vltDOUBLE        alphaAgc;
    vltDOUBLE        deltaAgc;
    
    fndOBJECT          *obj;
    const evhCB_METHOD  procedure;
};



#endif /*!trkwsPOS_READ_LIST_H*/
