#ifndef trkwsRING_BUFFER_H
#define trkwsRING_BUFFER_H
/*******************************************************************************
* E.S.O. - VLT project

*
* "@(#) $Id: trkwsRING_BUFFER.h,v 1.166 2005/07/25 15:44:50 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* gchiozzi  20/08/96  Added posEncoder attribute
* gchiozzi  20/08/96  Renamed posFrame as trkwsPOS_FRAME
* mnastvog  02/06/95  created
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */


#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

// class to describe the data which should reside in a ring buffer element
// This should be changed into a template!

class trkwsPOS_FRAME
{
  public:
    trkwsPOS_FRAME();
    trkwsPOS_FRAME(vltDOUBLE p,vltDOUBLE pe,vltDOUBLE t);
//  private:
    vltDOUBLE position;
    vltDOUBLE posEncoder;
    vltDOUBLE timeStamp;
  friend class trkwsRING_BUFFER;
};

inline trkwsPOS_FRAME::trkwsPOS_FRAME()
{
    position   = 0;
    posEncoder = 0;
    timeStamp  = 0;
}

inline trkwsPOS_FRAME::trkwsPOS_FRAME(vltDOUBLE p,vltDOUBLE pe,vltDOUBLE t)
{
    position   = p;
    posEncoder = pe;
    timeStamp  = t;
}


#define bufEle trkwsPOS_FRAME





class trkwsRING_BUFFER 
{
  public:
    trkwsRING_BUFFER(int size);
   ~trkwsRING_BUFFER();

   bufEle * Read();
   bufEle * Peek(int offset);
   ccsCOMPL_STAT Write(bufEle value);   
   void Init();
   

  protected:
   int writeIndex;
   int readIndex;
   int diff;
   int valCount;
   int bufferSize;
   bufEle * data;
};
#endif
 
