#ifndef trkwsTRANSFER_SER_H
#define trkwsTRANSFER_SER_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: trkwsTRANSFER_SER.h,v 1.166 2005/07/25 15:44:51 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* kwirenst  01/10/96  Added overloaded SendAll() to send a message different from the received
* gchiozzi  25/08/95  Added protected method MessageQueue
* gchiozzi  24/08/95  Completely restructured
* kwirenst  07/06/95  created
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

#include "fndQUEUE.h"

#include "trkws.h"
#include "evhDB_CMD_SEND.h"
#include "evhDB_CMD_SERIAL.h"
#include "tcsDB_SYNC_ERR_CHECK.h"
#include "mswMOD_LIST_COMMAND.h"

class trkwsTRANSFER_SER : public evhDB_CMD_SERIAL
{
  public:
    trkwsTRANSFER_SER(const dbSYMADDRESS  dbPoint, 
		    const dbSYMADDRESS destDbPoint = NULL);
    ~trkwsTRANSFER_SER();

    ccsCOMPL_STAT DestinationDbPoint(const dbSYMADDRESS dbPoint);
    ccsCOMPL_STAT SendAll(msgMESSAGE &msg);
    ccsCOMPL_STAT SendAll(msgMESSAGE &originalMsg, msgMESSAGE &toBeSentMsg);

    virtual ccsCOMPL_STAT Reset();

  protected:

    virtual evhCB_COMPL_STAT  CompletedCB(msgMESSAGE &msg, void *udata);
    virtual evhCB_COMPL_STAT  ErrorCB(msgMESSAGE &msg, void *udata);
    virtual evhCB_COMPL_STAT  TimeoutCB(msgMESSAGE &msg, void *udata);

    fndQUEUE &MessageQueue();

  private:
    fndQUEUE messages;
}; 


/* 
 ********************************************
 *                                          *
 * Local class to store messages in the     *  
 * internal queue                           *
 *                                          *
 ******************************************** 
*/

class trkwsMSG_QUEUE_ITEM : public fndOBJECT, public msgMESSAGE
{
  public:
    trkwsMSG_QUEUE_ITEM();
    trkwsMSG_QUEUE_ITEM(const msgMESSAGE &source);
    
    fndStdObjectDef(trkwsMSG_QUEUE_ITEM, fndOBJECT);
};


#endif /*!_H*/
