#ifndef vltisimSetupDefines_H
#define vltisimSetupDefines_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: vltisimSetupDefines.h,v 3.8 2005/06/08 21:11:25 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* nhousen  2004-10-20 added vltisimPrsMOD
* nhousen  2002-05-10 modified PRESETTING state from 17 to 29; added more states
* jalatalo 2000-11-08 created
*/

/************************************************************************
 *
 * This file contains common defines used both by C/C++ files and 
 * dbLoader files
 *----------------------------------------------------------------------
 */

/* 
 *  Defines for the target telescope.
 *  The default target is VLT
 *  Up to now only VLT and NTT
 */


/* Module name */
#define vltisimSetupMOD "vltisimSetup"
#define vltisimPrsMOD   "vltisimPrs"

/*
 * Defines for states values and names
 * These enum and string vector are used in the whole module
 * to identify states and substates.
 * The values must be coordinated with the standard states defined in 
 * evhStates.h
 */

#include "evhStates.h"


/* States */
#define vltisimSetupSTATE_ERROR           19
#define vltisimSetupSTATE_STEADY          20
#define vltisimSetupSTATE_IDLE            21
#define vltisimSetupSTATE_COLD_STARTING   22
#define vltisimSetupSTATE_SHUTTING_DOWN   23
#define vltisimSetupSTATE_PAUSED          24
#define vltisimSetupSTATE_PAUSING         25
#define vltisimSetupSTATE_STARTING        26
#define vltisimSetupSTATE_STOPPING        27
#define vltisimSetupSTATE_TRACKING        28
#define vltisimSetupSTATE_PRESETTING      29

#define vltisimSetupTRACKINGSTATE_TRACKING     TRUE
#define vltisimSetupTRACKINGSTATE_NOT_TRACKING FALSE

/* Defines for name states */
#define vltisimSetupSTATE_STR_ERROR         "ERROR"
#define vltisimSetupSTATE_STR_STEADY        "STEADY"
#define vltisimSetupSTATE_STR_IDLE          "IDLE"
#define vltisimSetupSTATE_STR_COLD_STARTING "COLD STARTING"
#define vltisimSetupSTATE_STR_SHUTTING_DOWN "SHUTTING DOWN"
#define vltisimSetupSTATE_STR_PAUSED        "PAUSED"
#define vltisimSetupSTATE_STR_PAUSING       "PAUSING"
#define vltisimSetupSTATE_STR_STARTING      "STARTING"
#define vltisimSetupSTATE_STR_STOPPING      "STOPPING"
#define vltisimSetupSTATE_STR_TRACKING      "TRACKING"
#define vltisimSetupSTATE_STR_PRESETTING    "PRESETTING"

#define vltisimSetupTRACKINGSTATE_STR_TRACKING     "TRACKING"
#define vltisimSetupTRACKINGSTATE_STR_NOT_TRACKING "NOT TRACKING"


/*
 * Defines for command names
 */

/* Command accepted by issifControl process */
#define vltisimSetupSETUP_CMD     "SETUP"


/* Standard OK message */
#define vltisimSetupOK_MSG            "OK"
//#define vltisimSetupOK_ABORT_REPLY   "OK, superseded by valid equivalent command"


#endif 

