#*******************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: babGuiPublic.tcl,v 1.30 2004/11/19 13:26:34 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# bbauvir   12/07/01  created
# ahuxley   15/07/04  added support for pre- and post- state change call
#                     back function in user's application.
#
#************************************************************************
#   NAME
#     babState - 
#
#   SYNOPSIS
#     babSendStandardCommand $cmd
#
#   DESCRIPTION
#     The procedure babSendStandardCommand sends a standard command to the
#     LCU server '$gvar(modName)Server' with the parameter $gvar(modName).
#
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#
#   SEE ALSO
#
#   BUGS     
#
#------------------------------------------------------------------------
#
proc babSendStandardCommand { cmdandpars } {

    global gvar 
    
    #  See if possible to chop a word of the front of the command and parameters
    set x [string range $cmdandpars 0 [expr {[string first " " $cmdandpars] - 1}]]

    #  If not possible then we only have a command and there are no parameters.
    if { $x == "" } {
        set cmd $cmdandpars
        set pars ""

    #  If is possible then that word is the command and the parameters are the rest
    } else {
        set cmd $x
        set pars [string range $cmdandpars [expr {[string first " " $cmdandpars] + 1}] end]
    }

    #puts "cmdandpars: $cmdandpars"
    #puts "cmd:        $cmd"
    #puts "pars:       $pars"

    #
    #  Call application-specified callback if it exists.
    #
    if {[info exists gvar(babAppStateChangeCallback)] == 1} {
        $gvar(babAppStateChangeCallback) PRE $cmd 
    }
    panSendCommand $gvar(babLcuEnv) $gvar(babLcuServer) $cmd "" $gvar(babLcuStdCmdTimeout) $pars
    #
    #  Call application-specified callback if it exists.
    #
    if {[info exists gvar(babAppStateChangeCallback)] == 1} {
        $gvar(babAppStateChangeCallback) POST $cmd 
    }
}
