
#*******************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: ccdCallPanel.tcl,v 2.7 2005/05/11 03:10:36 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# alongino  10/05/95  created
# alongino  06/03/96  patch for bug in panCallPanel
#

#************************************************************************
#   NAME
#   ccdCallPanel - pop-up another panel and set CWP
# 
#   SYNOPSIS
#   ccdCallPanel <panel name>
# 
#   DESCRIPTION
#   Tcl procedure, used within CCD GUI panels, to pop-up another panel and
#   automatically pass to it the database current working point used.
#
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#   ccdCallPanel ccdSetup
#
#   SEE ALSO
#   panCallPanel
#
#   BUGS     
#
#------------------------------------------------------------------------
#

proc ccdCallPanel { name args } {      

 # Declare any variable as global

   global cwp 

 # Variable Initialization

   set parList $args ; # Parameter list initialisation

 # define database current working point as the same in this panel

 # AL960306 Bug in panel 2.57 (SPR 960145)
 # when one starts a panel, containing imported classes, the name of the
 # variables associated to widgets in one class and DB attributes change
 # depending if cwp is defined on runstring or not.
 # Example: panCallPanel ccdConfig "gvar(maint)=1" "cwp=<alias>ccdUvR"
 #          varaible gvar(<alias>ccdUvR:detector:output_1.xLocation)
 #          panCallPanel ccdConfig "gvar(maint)=1"
 #          varaible gvar(detector:output_1.xLocation)
 # Note: by removing cwp in the runstring one might have problems with
 # cwp, because it is derived from environment variables definition, which
 # have to be defined in .cshrc
 # lappend parList "cwp=$cwp"
   lappend parList "cwpTmp=$cwp"

 # pop-up panel for setup definition
   panCallPanel $name $parList
}


#
# ___oOo___


