#************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: ccdConfig.tcl,v 2.7 2005/05/11 03:10:41 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# alongino  21/02/97  moved from ccdMisc
# alongino  24/02/97  added setting of standard speeds
#

#************************************************************************
#   NAME ccdConfigRefresh, ccdEnableContainers, ccdSetClockList, ccdSelectClock
# 
#   SYNOPSIS
# 
#   DESCRIPTION
#        Tcl procedures used within ccdConfig panel
#
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#
#   SEE ALSO
#
#   BUGS     
#
#------------------------------------------------------------------------
#

# procedure to draw borders in the ccdConfig panel
proc ccdConfigDrawBorders { } {
  global cv 
  # Rectangle for CAMERA GENERAL
  $cv create rectangle    10  10  485 180 -outline Blue

  # Rectangle for CRYOSTAT
  $cv create rectangle    10 190  485 290 -outline Blue

  # Rectangle for SHUTTER
  $cv create rectangle    10 300  485 400 -outline Blue

  # Rectangle for DETECTOR
  $cv create rectangle   490  10 1235 800 -outline Blue

  # Rectangle for READOUT
  $cv create rectangle   495 450 1230 795 -outline Blue
#  $cv create rectangle   500 510 1225 790 -outline Blue

  # Rectangle for TEMPERATURE
  $cv create rectangle    10 405  485 565 -outline Blue
  $cv create rectangle    15 500  480 560 -outline Blue

  # Rectangle for TELEMETRY
  $cv create rectangle    10 570  485 800 -outline Blue
  $cv create rectangle    15 735  480 795 -outline Blue
}




# Refresh the whole ccdConfig panel according to DB contents
proc ccdConfigRefresh { } {                     

# AL961016 Still needed with NOV96. Not all fields are refreshed according
#          to change of DB value (e.g. entry fields)
   dbInputRefresh all
# Now the classContainer button must be set to the value according to
# DB contents
   ccdEnableContainers
}






# Enables/disable containers according to DB contents
proc ccdEnableContainers {} {
   global cv gvar 
   global ccdSize
      
   # Display the cryostat 
   set status [dbRead "cryostat.available"]
   $cv.ccdCryostat configure -show $status

   # Display the shutter 
   set status [dbRead "shutter.available"]
   $cv.ccdShutter configure -show $status

   # Display the ccd redout outputs information
   set numReadout 4     
   for { set i 1} { $i <= $numReadout } {incr i} {   
     set status [dbRead "detector:output_${i}.available"]
     $cv.ccdReadout${i} configure -show $status
   }
    
   # Display telemetry
   ccdEnableTelemetry

   # Display temperature
   ccdEnableTemperature

   # Display readout modes
   ccdEnableReadout
}


#
# ___oOo___
