#************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: ccdConfigTel.tcl,v 2.7 2005/05/11 03:10:42 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# mcomin    05/02/96  created
# alongino  06/03/97  telemetry only
#

#************************************************************************
#   NAME 
#   ccdConfigTelInit, ccdFormatTel, ccdEnableTelemetry, ccdClearTelemetry, 
#   ccdSaveTelemetry, ccdTelBoxToEdit, ccdTelModify, ccdTelDelete
# 
#   SYNOPSIS
# 
#   DESCRIPTION
#   These procedures are used within the ccdConfig panel to handle the
#   telemetry parameters
#
#------------------------------------------------------------------------
#

#
# Initialise variables for telemetry list box
proc ccdConfigTelInit { } {

  global cv
  global telRows telCol telDbAttr telWdg telFormatProc
  global telIndex telNames telRec telButton
  global telTable telDisp 

  # set common stuff for telemetry and temperature
  ccdConfigTelTemInit Tel telIndex telNames telRec telButton

  set telRows 100; # maximum number of rows, as from DB
  set telCol 10;   # maximum number of columns, as from DB
  set telWdg $cv.ccdTelemetry
  set telFormatProc ccdFormatTel

  # set path to DB values
  ccdTelDbInit $telRows telDbAttr

  # attach call to selection of one row
  $telWdg setBind <B1-ButtonRelease> {ccdTelBoxToEdit}
}



# formats one row in the telemetry list box
proc ccdFormatTel { text } {

  global telIndex
 
  ccdConfigFormatTelTem telIndex $text
}



#
# Enable/disable telemetry in the panel ccdConfig
proc ccdEnableTelemetry {  } {

  global telRows telCol telDbAttr telWdg telFormatProc
  global telButton
  global telTable telDisp 

  ccdEnableBox telTable telDisp telButton $telRows $telCol telDbAttr $telWdg $telFormatProc
}


#
# Reset the telemetry list box and optionally clean table
proc ccdClearTelemetry { } {
   global telTable telWdg telRec

   ccdClearBox $telWdg telTable $telRec(clean)
}


#
# Stores the current telemetry table into the database
proc ccdSaveTelemetry { } {
 
  global telTable telRows telCol telDbAttr telRec
  
  ccdSaveBoxToDb telTable $telRows $telCol telDbAttr $telRec(clean)
}


#
# Show in the edit section the selected record from the telemetry list
proc ccdTelBoxToEdit { } {

  global telNames telIndex telTable telWdg

  ccdBoxToEdit telNames telIndex telTable $telWdg
}



#
#
# Add or modify one entry in the telemetry list box
proc ccdTelModify { } {

  global telWdg
  global telIndex telNames telRec
  global telTable telDisp telFormatProc

  ccdEditToBox telNames telIndex telTable telDisp $telWdg $telFormatProc telRec 1
}



#
# Delete one entry in the telemetry list box
proc ccdTelDelete { } {

  global telWdg
  global telIndex telNames telRec
  global telTable telDisp telFormatProc

  ccdEditToBox telNames telIndex telTable telDisp $telWdg $telFormatProc telRec 0
}

#
# ___oOo___
