#************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: ccdConfigTelTem.tcl,v 2.7 2005/05/11 03:10:42 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# mcomin    05/02/96  created
# alongino  04/03/97  enhanced for temperature implementation
# alongino  06/03/97  only common part for telemetry and temperature
#

#************************************************************************
#   NAME 
#   ccdConfigTelTemInit, ccdConfigFormatTelTem
# 
#   SYNOPSIS
# 
#   DESCRIPTION
#   These procedures are used within the ccdConfig panel to handle the
#   telemetry and temperature parameters
#
#------------------------------------------------------------------------
#

#
# Initialise variables for telemetry and temperature list boxes
proc ccdConfigTelTemInit { cat index name template button} {

   upvar $index ccdIndex
   upvar $name ccdName
   upvar $template ccdTempl
   upvar $button ccdButton

   # set names of edit part variables
   set ccdName(0)  ccd${cat}Rec
   set ccdName(1)  ccd${cat}Init
   set ccdName(2)  ccd${cat}Type
   set ccdName(3)  ccd${cat}Index
   set ccdName(4)  ccd${cat}Id
   set ccdName(5)  ccd${cat}Unit
   set ccdName(6)  ccd${cat}Ref
   set ccdName(7)  ccd${cat}Low
   set ccdName(8)  ccd${cat}High

   # set indexes in a row corresponding to ccdName
   set ccdIndex(0) 0
   set ccdIndex(1) 1
   set ccdIndex(2) -5; # combined value
   set ccdIndex(3) -5; # combined value
   set ccdIndex(4) 6
   set ccdIndex(5) 7
   set ccdIndex(6) 10
   set ccdIndex(7) 8
   set ccdIndex(8) 9

   # define name of buttons
   set ccdButton(0) ccd${cat}Add
   set ccdButton(1) ccd${cat}Del

   # define record templates
   set ccdTempl(clean) {0 0 0 0 0 "" "" "" 0 0 0}; # used when removing records
   set ccdTempl(mask)  {0 0 1 1 0 "" "" "" 0 0 0}; # used when adding records
}





# formats on row in the telemetry or temperature list box
proc ccdConfigFormatTelTem { index text } {

   upvar $index ccdIndex

   set par1 "No"
   if {[lindex $text 1] == 0} { set par1 "Yes" }
   set recInd $ccdIndex(0)
   set descInd [expr {-1 * $ccdIndex(2)}]
   set idInd $ccdIndex(4)
   set unitInd $ccdIndex(5)
   set refInd $ccdIndex(6)
   set lowInd $ccdIndex(7)
   set highInd $ccdIndex(8)
   
   return [format "%-2s %-3s %-10s %-11s %-2s %5s %5s %5s" \
          [lindex $text $recInd] $par1 \
          [lindex $text $descInd] [lindex $text $idInd] \
          [lindex $text $unitInd] [lindex $text $refInd] \
          [lindex $text $lowInd] [lindex $text $highInd]]
}



#
# ___oOo___
