#************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: ccdConfigTem.tcl,v 2.7 2005/05/11 03:10:43 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# alongino  06/03/97  created
#

#************************************************************************
#   NAME 
#   ccdConfigTemInit, ccdFormatTem, cdEnableTemperature, ccdClearTemperature,
#   ccdSaveTemperature, ccdTemBoxToEdit, ccdTemModify, ccdTemDelete
# 
#   SYNOPSIS
# 
#   DESCRIPTION
#   These procedures are used within the ccdConfig panel to handle the
#   temperature parameters
#
#------------------------------------------------------------------------
#

#
# Initialise variables for temperature list box
proc ccdConfigTemInit { } {

  global cv
  global temRows temCol temDbAttr temWdg temFormatProc
  global temIndex temNames temRec temButton
  global temTable temDisp 

  # set common stuff for telemetry and temperature
  ccdConfigTelTemInit Tem temIndex temNames temRec temButton

  set temRows 10; # maximum number of rows, as from DB
  set temCol 10;   # maximum number of columns, as from DB
  set temWdg $cv.ccdTemperature
  set temFormatProc ccdFormatTem

  # set path to DB values
  ccdTemDbInit $temRows temDbAttr

  # attach call to selection of one row
  $temWdg setBind <B1-ButtonRelease> {ccdTemBoxToEdit}
}



# formats one row in the temperature list box
proc ccdFormatTem { text } {

  global temIndex
 
  ccdConfigFormatTelTem temIndex $text
}




#
# Enable/disable temparature in the panel ccdConfig
proc ccdEnableTemperature {  } {

  global temRows temCol temDbAttr temWdg temFormatProc
  global temButton
  global temTable temDisp 

  ccdEnableBox temTable temDisp temButton $temRows $temCol temDbAttr $temWdg $temFormatProc
}



#
# Reset the temperature list box and optionally clean table
proc ccdClearTemperature { } {
   global temTable temWdg temRec

   ccdClearBox $temWdg temTable $temRec(clean) 
}




#
# Store the current temperature table into the database
proc ccdSaveTemperature { } {
 
  global temTable temRows temCol temDbAttr temRec
  
  ccdSaveBoxToDb temTable $temRows $temCol temDbAttr $temRec(clean)
}





#
# Show in the edit section the selected record from the temperature list
proc ccdTemBoxToEdit { } {

  global temNames temIndex temTable temWdg

  ccdBoxToEdit temNames temIndex temTable $temWdg
}



#
# Add or modify one entry in the temperature list box
proc ccdTemModify { } {

  global temWdg
  global temIndex temNames temRec
  global temTable temDisp temFormatProc

  ccdEditToBox temNames temIndex temTable temDisp $temWdg $temFormatProc temRec 1
}



#
# Delete one entry in the temperature list box
proc ccdTemDelete { } {

  global temWdg
  global temIndex temNames temRec
  global temTable temDisp temFormatProc

  ccdEditToBox temNames temIndex temTable temDisp $temWdg $temFormatProc temRec 0
}


#
# ___oOo___
