#************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: ccdCtrl.tcl,v 2.7 2005/05/11 03:10:41 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# alongino  21/02/97  moved from ccdMisc
# alongino  26/02/97  added ccdDrawBorders, ccdSetDefaults
# alongino  15/04/97  added STANDAL options
# alongino  20/05/97  procedures associated to control buttons moved from .pan
# alongino  10/06/97  added THRMIN BACKGND IPLLX IPLLY IPURX IPURY
# alongino  13/10/97  added SIMIMG SHIFTYP SHIFT NDIT ASUIT 
# alongino  12/05/98  added XFERSYN
# pduhoux   13/08/98  renamed ASUIT to ASUIT1
#

#************************************************************************
#   NAME ccdRdtModesUpdate, ccdRdtIndex2Mode, ccdRdtMode2Index, 
#        ccdSetRdtOutputs, ccdSetRdtSpeed, ccdEnableRdtWindow,
#        ccdEnableImgProcess, ccdEnableExpOpt, ccdEnableImgOpt, 
#        ccdEnableWindowing, ccdChangeWidgets, ccdDrawBorders, 
#        ccdSetDefaults, ccdSetOpState, ccdInitialize, ccdStartup, 
#        ccdShutdown, ccdStart, ccdPerWipe, ccdAbort, ccdStopWipe,
#        ccdPause, ccdContinue, ccdStop, ccdChangeTime, ccdWipe,
#        ccdDump, ccdStopLoop, ccdStartDisplay, ccdSetTrace, ccdTrace
# 
#   SYNOPSIS
# 
#   DESCRIPTION
#        Tcl procedures used within ccdCtrl panel
#
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#
#   SEE ALSO
#
#   BUGS     
#
#------------------------------------------------------------------------
#

# procedure to set default values in the ccdCtrl panel
proc ccdSetDefaults { } {
  global gvar
  global ccdMaxWin

 # Determine if sprBrowse can run in this environment
 # AL960412 catch added (see SPR 960221)
   catch {exec which sprBrowse} fileName
   set gvar(sprBrowse) [file executable $fileName]
   if {$gvar(sprBrowse) == 0} {
     panDisableMenu "Utilities" "" "Problem Report"
   }

 # set default values for numeric variables
 set gvar(ccdContext) 1;
 set gvar(ccdFits) 0;
 set gvar(ccdArchive) 0;
 set gvar(ccdMainCtrl_startupFast) 0;
 set gvar(setup.1145.DET.WIN1.UIT1) 1;
 set gvar(setup.2.DET.EXP.NREP) 1;
 set gvar(setup.9.DET.DISPLAY) 0;
 set gvar(setup.5.DET.READ.CLKIND) 1;
 set gvar(setup.6.DET.OUT1.GAININD) 1;

 # set default values for variables from imported classes
 set gvar(ccdExpOpt_setup.0.DET.EXP.TYPE) Normal;
 set gvar(ccdExpOpt_setup.61.DET.EXP.WIPETIM) 0;
 set gvar(ccdExpOpt_setup.40.DET.EXP.TIMEREP) 0;
 set gvar(ccdExpMulti_setup.1141.DET.WIN1.NDIT) 1;
 set gvar(ccdExpMulti_setup.1142.DET.WIN1.ASUIT1) T;
 set gvar(ccdExpMulti_setup.1143.DET.READ.SHIFTYP) list;
 set gvar(ccdExpMulti_setup.1144.DET.READ.SHIFT1) 0;
 set gvar(ccdExpMulti_multiMod) 1;
 set gvar(ccdExpMulti_multiDel) 1;
 set gvar(imageOpt_setup.30.DET.FRAM.TYPE) Normal;
 set gvar(imageOpt_setup.24.DET.FRAM.SAMPLE) 1;
 set gvar(imageOpt_setup.60.DET.FRAM.XFERSYN) T;
 set gvar(imageOpt_setup.50.DET.READ.SIMIMG) "";

 for { set i 1} { $i <= $ccdMaxWin } {incr i} {
   set gvar(setup.${i}10.DET.WIN$i.ST) F;
   set gvar(setup.${i}11.DET.WIN$i.STRX) 1;
   set gvar(setup.${i}12.DET.WIN$i.NX)  20;
   set gvar(setup.${i}13.DET.WIN$i.STRY) 1;
   set gvar(setup.${i}14.DET.WIN$i.NY)  20;

   set gvar(setup.${i}31.DET.WIN$i.IPLLX) 0;
   set gvar(setup.${i}32.DET.WIN$i.IPLLY) 0;
   set gvar(setup.${i}33.DET.WIN$i.IPURX) 0;
   set gvar(setup.${i}34.DET.WIN$i.IPURY) 0;
   set gvar(setup.${i}27.DET.WIN$i.BIAS)  F;
   set gvar(setup.${i}28.DET.WIN$i.FLATF)  F;
   set gvar(setup.${i}23.DET.WIN$i.MINMAX)  F;
   set gvar(setup.${i}20.DET.WIN$i.CENTROID)  none;
   set gvar(setup.${i}29.DET.WIN$i.BACKGND) -1.0;
   set gvar(setup.${i}30.DET.WIN$i.THRMIN) -1.0;
   set gvar(setup.${i}21.DET.WIN$i.REFX)  1;
   set gvar(setup.${i}22.DET.WIN$i.REFY)  1;
   set gvar(setup.${i}25.DET.WIN$i.IPFUNC)  None;
   set gvar(setup.${i}26.DET.WIN$i.IPBUFF)  None;
 }

 # work-around bug JUN96 with scale widgets
 set gvar(setup.15.DET.WIN1.BINX) 1;
 set gvar(setup.16.DET.WIN1.BINY) 1;
}




# procedure to draw borders in the ccdCtrl panel
proc ccdCtrlDrawBorders { } {
 global cv

 # Rectangle for GENERAL
   $cv create rectangle    10  1 1015  85  -outline Blue -width 2

 # Rectangle for SETUP
   $cv create rectangle    10 90 1015 515 -outline Blue -width 2
 # Rectangle for EXPOSURE
   $cv create rectangle    15 115 330 325 -outline Blue
 # Rectangle for IMAGE
   $cv create rectangle    15 330 330 485 -outline Blue
 # Rectangle for READOUT
   $cv create rectangle    335 115 1010 485 -outline Blue

 # Rectangle for STATUS
   $cv create rectangle    10 520 1015 810 -outline Blue -width 2

 # Rectangle for CONTROL
   $cv create rectangle    10 815 1015 905 -outline Blue -width 2

 # disable status containers   
   $cv.ccdStatusMisc configure -show 0
   $cv.ccdStatusDisk configure -show 0
   $cv.ccdStatusIp   configure -show 0
}





# procedure to be called after any change in the OLDB CCD configuration
proc ccdRdtModesUpdate { {minClock {1}} {maxClock {10}} } {
  global cv gvar
  global ccdRdtStdSpeed
  global ccdRdtClockList ccdRdtSpeedList ccdRdtOutList ccdRdtGainList
  global ccdRdtSpeedOpt ccdRdtOutOpt
  global ccdTecGain ccdSciGain

  set ccdRdtClockList {} ;    # List of available clock patterns
  set ccdRdtSpeedList {} ;    # List of related readout speeds
  set ccdRdtOutList   {} ;    # List of related readout output enabled
  set ccdRdtGainList  {} ;    # List of related default readout gains 
  set ccdRdtSpeedOpt  {} ;    # List of all possible readout speeds
  set ccdRdtOutOpt    {} ;    # List of all possible readout output enabled

# Get from OLDB the list of readout modes defined and related characteristics
  for { set i $minClock} { $i <= $maxClock } {incr i} { 
    set tmp [dbRead "readout:clock_${i}.description"]
     
    if { ([string trim $tmp " "] != "") } {
      lappend ccdRdtClockList $i
      set rdtSpeed   [dbRead "readout:clock_${i}.speed"]
      set rdtOutEnab [dbRead "readout:clock_${i}.outEnab"]
      set rdtGain    [dbRead "readout:clock_${i}.gainIndex"]
      lappend ccdRdtSpeedList $rdtSpeed
      lappend ccdRdtGainList  $rdtGain
      # convert output enabled list in a string with index of outputs enabled
      set rdtOut {}
      set j 0
      while {$j < [llength $rdtOutEnab]} {
	if { ([lindex $rdtOutEnab $j] == 1) } {
	    lappend rdtOut "#[expr {$j + 1}]"
        }
        incr j
      }
      set rdtOutString [join $rdtOut " "]
      lappend ccdRdtOutList   $rdtOutString
    }
  }

  # Build list of options for option button widgets in ccdCtrl for readout
  set i 0
  while {$i < [llength $ccdRdtClockList]} {
    set rdtSpeed [lindex $ccdRdtSpeedList $i]
    if { ([lsearch -exact $ccdRdtSpeedOpt $rdtSpeed] == -1) } {
      lappend ccdRdtSpeedOpt $rdtSpeed
    }
    set rdtOutString [lindex $ccdRdtOutList $i]
    if { ([lsearch -exact $ccdRdtOutOpt $rdtOutString] == -1) } {
      lappend ccdRdtOutOpt $rdtOutString
    }
# puts "# [lindex $ccdRdtClockList $i] SPEED [lindex $ccdRdtSpeedList $i] OUTPUTS [lindex $ccdRdtOutList $i] GAIN [lindex $ccdRdtGainList $i]"
    incr i
  }

  # put in order standard speeds in option button
  set tmpSpeedList {}
  set i 0
  while {$i < [llength $ccdRdtStdSpeed]} {
    set speedName [lindex $ccdRdtStdSpeed $i]
    set speedInd [lsearch -exact $ccdRdtSpeedOpt $speedName]
    if { ($speedInd != -1) } {;
      lappend tmpSpeedList $speedName
      set ccdRdtSpeedOpt [lreplace $ccdRdtSpeedOpt $speedInd $speedInd]
    }
    incr i
  }
  # add not standard speeds possibly defined
  set ccdRdtSpeedOpt [concat $tmpSpeedList $ccdRdtSpeedOpt]
  
  # Configure speed and outputs option button with the current configuration
  $cv.ccdRdtSpeed configure -itemList $ccdRdtSpeedOpt
  $cv.ccdRdtOutput configure -itemList $ccdRdtOutOpt
  # Configure gain option button with the list of available gains
  if {$gvar(ccdMainCtrl_type) == "technical"} {
      set gainList $ccdTecGain
  } else {
      set gainList $ccdSciGain
  }
  $cv.ccdGainList configure -itemList $gainList

  set gvar(ccdRdtSpeed) [ccdSetRdtSpeed $gvar(ccdRdtSpeed)]
}







# Convert index to readout mode
proc ccdRdtIndex2Mode {index} {

  global ccdRdtClockList ccdRdtSpeedList ccdRdtOutList ccdRdtGainList

  set rdtMode {undefined undefined 1}
  set rdtIndex -1;    # default index not found
  # Look for a mode corresponding to the passed index
  set i 0
  while {$i < [llength $ccdRdtClockList]} {
    set rdtIndex [lindex $ccdRdtClockList $i]
    if { $index == $rdtIndex } {;    # valid readout mode index
      break
    }
    incr i
  }
  # If index not found, set it to first in the list
  if { $i == [llength $ccdRdtClockList]} {
    set i 0
  }
  set rdtMode [lreplace $rdtMode 0 0 [lindex $ccdRdtSpeedList $i]]
  set rdtMode [lreplace $rdtMode 1 1 [lindex $ccdRdtOutList $i]]
  set rdtMode [lreplace $rdtMode 2 2 [lindex $ccdRdtGainList $i]]
  return $rdtMode
}






# Convert readout mode to index
proc ccdRdtMode2Index {speed outputs {exact {1}}} {

  global ccdRdtSpeedList ccdRdtOutList

  set rdtIndex -1;    # default index not found
  set rdtIndexTmp -1;
  # Look for a mode index corresponding to the passed characteristics
  set i 0
  while {$i < [llength $ccdRdtSpeedList]} {
    set rdtSpeed [lindex $ccdRdtSpeedList $i]
    set rdtOut [lindex $ccdRdtOutList $i]
    if {![string compare $rdtSpeed $speed]} {;    # same speed
      if {![string compare $rdtOut $outputs]} {;  # same outputs
        set rdtIndex $i
        break
      } elseif {$rdtIndexTmp == -1} {; # look for first possible combination
        set rdtIndexTmp $i
      }
    }
    incr i
  }
  # if exact combination not found, accept first possible one with that speed
  if {($rdtIndex == -1) && ($exact != 1) && ($rdtIndexTmp != -1)} {
    set rdtIndex $rdtIndexTmp
  }
  return $rdtIndex
}






# Procedure to be called whenever a new set of readout outputs is selected
proc ccdSetRdtOutputs {speed args} {
  global cv gvar
  global ccdRdtClockList ccdRdtSpeedList ccdRdtOutList ccdRdtGainList
  global ccdRdtOutOpt

  set outputs [join $args]
  # Get readout mode index from speed and outputs currently selected
  set rdtIndex [ccdRdtMode2Index $speed $outputs 0]
  # Set outputs and  default gain for that index
  set newOut [lindex $ccdRdtOutList $rdtIndex]
  if {[string compare $gvar(ccdRdtOutput) $newOut]} {; # outputs to be updated
    set gvar(ccdRdtOutput) $newOut
  }
  set gvar(setup.6.DET.OUT1.GAININD) [lindex $ccdRdtGainList $rdtIndex]
  # Set clock index for setup
  set gvar(setup.5.DET.READ.CLKIND) [lindex $ccdRdtClockList $rdtIndex]
}






# Procedure to be called whenever a new speed is selected
proc ccdSetRdtSpeed {speed} {
  global cv gvar
  global ccdRdtSpeedList ccdRdtOutList ccdRdtGainList
  global ccdRdtSpeedOpt ccdRdtOutOpt

  # if defined speed is NOT supported, change it to first supported in the list
  set speedInd [lsearch -exact $ccdRdtSpeedOpt $speed]
  if { ($speedInd == -1) } {; # speed not supported
    set speed [lindex $ccdRdtSpeedList 0]
  }

  # Extract, from the list of supported readout mode, those with a given speed
  set tmpOutList {}
  set i 0
  while {$i < [llength $ccdRdtSpeedList]} {
    set rdtSpeed [lindex $ccdRdtSpeedList $i]
    if {![string compare $rdtSpeed $speed]} {
      lappend tmpOutList [lindex $ccdRdtOutList $i]
    }
    incr i
  }

  # Disable readout outputs if not supported for the specified speed
  set i 0
  while {$i < [llength $ccdRdtOutOpt]} {
    set tmpOut [lindex $ccdRdtOutOpt $i]
    if { ([lsearch -exact $tmpOutList $tmpOut] == -1) } {; # not defined
      $cv.ccdRdtOutput disableEntry $i
    } else {
      $cv.ccdRdtOutput enableEntry $i
    }
    incr i
  }

  # Now select accordingly the set of outputs and default gain
  ccdSetRdtOutputs $speed $gvar(ccdRdtOutput)
  return $speed
}





# enable/disable windowed readout container widget
proc ccdEnableRdtWindow { } {
   global cv gvar
   global ccdMaxWin

   # window setup
   for { set i 1} { $i <= $ccdMaxWin } {incr i} { 
     if {[info exists gvar(setup.${i}10.DET.WIN$i.ST)]} {
        set status $gvar(setup.${i}10.DET.WIN$i.ST)
        if {[string compare $status F]} {set status 1
           } else {set status 0}
        $cv.ccdWindowFrame$i configure -show $status
     }
   }
}




# enable/disable image processing container widget
proc ccdEnableImgProcess { } {
   global cv gvar
   global ccdMaxWin

   for { set i 1} { $i <= $ccdMaxWin } {incr i} { 
     set status 1
     set value $gvar(ccdSetupIp${i}_ipCentroid)
     if {![string compare $value none]} {
       set value $gvar(ccdSetupIp${i}_ipUsrFlag)
       if {!($value)} {
         set value $gvar(ccdSetupIp${i}_ipMinMax)
         if {![string compare $value F]} {
           set value $gvar(ccdSetupIp${i}_ipBias)
           if {![string compare $value F]} {
             set value $gvar(ccdSetupIp${i}_ipFF)
             if {![string compare $value F]} {set status 0}
           }
         }
       }
     }
     $cv.ccdSetupIp$i configure -show $status
   }
}




# enable/disable exposure options container widget
proc ccdEnableExpOpt { } {
   global cv gvar

   set status 1
   # do not show if no option selected
   # period makes sense ONLY for repeated exposures
   if {![string compare $gvar(ccdExpOpt_setup.0.DET.EXP.TYPE) Normal]} {
       if {$gvar(ccdExpOpt_setup.61.DET.EXP.WIPETIM) == 0} {
           if {$gvar(ccdExpOpt_rep) == 0} {
               set status 0
           }
       }
   }
   $cv.ccdExpOpt configure -show $status
   set status 1
   if {[string compare $gvar(ccdExpOpt_setup.0.DET.EXP.TYPE) Multiple]} {
       set status 0
   }
   $cv.ccdExpMulti configure -show $status
}




# enable/disable image options container widget
proc ccdEnableImgOpt { } {
   global cv gvar

   set status 1
   # do not show if no option selected
   if {![string compare $gvar(imageOpt_setup.30.DET.FRAM.TYPE) Normal]} {
       if {$gvar(imageOpt_setup.24.DET.FRAM.SAMPLE) == 1} {
           if {![string compare $gvar(imageOpt_setup.60.DET.FRAM.XFERSYN) T]} {
               if {[string length $gvar(imageOpt_setup.50.DET.READ.SIMIMG)] \
                    == 0} {
                   if {$gvar(imageOpt_rtdRf) == 0} {
                       set status 0
                   }
               }
           }
       }
   }
   $cv.imageOpt configure -show $status
}




# enable/disable windowed readout and image processing container widgets
proc ccdEnableWindowing { } {
   global cv gvar

   # exposure setup options
   ccdEnableExpOpt
   # image setup options
   ccdEnableImgOpt
   # window setup
   ccdEnableRdtWindow
   # image process setup
   ccdEnableImgProcess
}






# enable/disable widgets according to camera type
proc ccdChangeWidgets {} {
    global gvar cv
    global $cv.ccdExpOpt.ckShow
    
    # determine if technical or scientific CCD
    set tmp [dbRead "readout:clock_1.description"]
    if {[string match ccd*.clk $tmp]} {
	set gvar(ccdMainCtrl_type) scientific
    } else {   
	set gvar(ccdMainCtrl_type) technical
    }

    # disable Dark exposure type option if no shutter available
    set widget [$cv.ccdExpOpt getClassPath]
    set gvar(shutAvai) [dbRead "shutter.available"]
    if {$gvar(shutAvai) == 0} {;  # no shutter
	$widget.cv.ccdExpType disableEntry 1
    } else {
	$widget.cv.ccdExpType enableEntry 1
    }
    # disable Multi-step exposure type option if scientific camera (not impl.)
    if {$gvar(ccdMainCtrl_type) == "scientific"} {
	$widget.cv.ccdExpType disableEntry 2
    } else {
	$widget.cv.ccdExpType enableEntry 2
    }
    
    # Update supported readout modes
    ccdRdtModesUpdate
}




# set operational state. Used in simulation
proc ccdSetOpState {opState} {

 # Declare global variables

   global gvar

 # User Initialization
   panDbWrite ".opStateWs" $opState;       # set operational state
}



# startup CCD stand-alone control processes
proc ccdInitialize {} {
  global gvar
  global camera wsenv simul

  set status 0
  if {$simul != 1} {;        # no simulation
      # send command INIT
      set timeout 10000;     # 10 secs timeout
      set status [panSendCommand $wsenv "ccdconCI_$camera" "INIT" 0 60000]
      if {$status != "FAILURE"} {
        # send command STANDBY
        set status [panSendCommand $wsenv "ccdconCI_$camera" "STANDBY" 0 $timeout]
      }
      if {$status != "FAILURE"} {
        # send command ONLINE
        set status [panSendCommand $wsenv "ccdconCI_$camera" "ONLINE" 0 $timeout]
      }
      if {$status != "FAILURE"} {
        # send command STANDAL
        set fits ""
        set archive ""
	if {$gvar(ccdFits)} { set fits "-on" }
	if {$gvar(ccdArchive)} { set archive "-archive" }
        set status [panSendCommand $wsenv "ccdconCI_$camera" "STANDAL" 0 $timeout "$fits $archive"]
      }
  } else {;                                       # simulation
      ccdSetOpState $gvar(ccdSTATE_ONLINE);       # state ONLINE
  }

  if {$status == "FAILURE"} {
    set status 1
  } else {
    set status 0
  }
  return $status
}




# startup CCD stand-alone control processes
proc ccdStartup {} {
  global gvar camera wsenv lcuenv insroot simul

  set status 0
  # execute startup script
  if {$simul != 1} {;           # no simulation
    set mode [dbRead ".opMode"]
    set ws [ccdWsEnv $wsenv $mode]
    set lcu [ccdLcuEnv $lcuenv $mode]
    set pid [exec ccdDcsWarmStart.sh $camera $ws $lcu &]
    set status [lindex [wait $pid] 2]; # wait for children to finish
  } else {;                               # simulation
    ccdSetOpState $gvar(ccdSTATE_ONLINE); # set operational state to ONLINE
  }

  # initialize
  if {$status == 0} {
    set status [ccdInitialize]
  }

  # print final result of procedure
  ccdPrintResult $status "Startup for camera $camera"
}



# shutdown CCD stand-alone control processes
proc ccdShutdown {} {

  global gvar simul camera wsenv lcuenv

  set status 0
  # execute shutdown script
  if {$simul != 1} {;       # no simulation
      # If something is going on, ask for confirmation
      set msg ""
      if {$gvar(ccdContext)} {;            # context sensitive
        if {$gvar(ccdExpCtrl_wiping)} {
          set msg "CCD chip wiping active"
        } elseif {(!($gvar(ccdExpCtrl_notRunning))) && \
                  ($gvar(opState) == $gvar(ccdSTATE_ONLINE))} {
          set msg "Exposure active"
        }
      }
      if {[string length $msg] > 0} {
       set status [tk_dialog .dialog "WARNING" $msg question 1 Continue cancel]
       if {$status} { return }
      }
      set mode [dbRead ".opMode"]
      set ws [ccdWsEnv $wsenv $mode]
      set lcu [ccdLcuEnv $lcuenv $mode]
      set pid [exec ccdDcsStop.sh $camera $ws $lcu &]
      set status [lindex [wait $pid] 2]; # wait for children to finish
  } else {;                              # simulation
      ccdSetOpState $gvar(ccdSTATE_OFF); # operational state OFF
  }

  # print final result of procedure
  ccdPrintResult $status "Shutdown for camera $camera"
}



# start an exposure
proc ccdStart {} {
 global camera wsenv gvar simul
 global ccdAbortFlag

 set dir [dbRead "observations.setupDirectory"]
 set setupfile "ccdSetupCurrent_$camera.det"
 # save current setup
 set status [ccdSaveSetup $setupfile]
 if {$status != "FAILURE"} {
   if {$simul != 1} {;               # no simulation
     set setupfile $dir/$setupfile
     set process "ccdconCI_$camera"
     set expId $gvar(ccdEXP_NEXT);   # next exposure
     set timeout 20000;              # 20 sec timeout
     set param "-expoId $expId -file $setupfile"
     set status [panSendCommand $wsenv $process "SETUP" 0 $timeout "$param"]
     if {$status != "FAILURE"} {
       set status [panSendCommand $wsenv $process "START" 0 $timeout]
     }
   } else {;                         # simulation
     set ccdAbortFlag 0
     after 1 ccdExpSim 0 0
   }
 }
}




proc ccdPerWipe {} {
   global camera wsenv gvar simul ccdReadStateAttr

   if {$simul != 1} {;    # no simulation
       set timeout 60000; # 60 sec timeout
       set status [panSendCommand $wsenv "ccdconCI_$camera" "STARTWP" 0 $timeout "1"]
   } else {;                         # simulation
       panDbWrite $ccdReadStateAttr $gvar(ccdSTATE_ONLINE_WIPING)
   }
}




proc ccdAbort {} {
   global camera wsenv gvar simul
   global ccdAbortFlag

   if {$simul != 1} {;     # no simulation
       set timeout 10000;  # 10 sec timeout
       set status [panSendCommand $wsenv "ccdconCI_$camera" "ABORT" 0 $timeout]
   } else {;               # simulation
       set ccdAbortFlag 1
   }
}




proc ccdStopWipe {} {
   global camera wsenv gvar simul ccdReadStateAttr

   if {$simul != 1} {;          # no simulation
       set timeout 20000;       # 20 sec timeout
       set status [panSendCommand $wsenv "ccdconCI_$camera" "STOPWP" 0 $timeout]
   } else {;                         # simulation
       panDbWrite $ccdReadStateAttr 0
   }
}




proc ccdPause {} {
   global camera wsenv gvar simul
   global ccdPauseFlag

   if {$simul != 1} {;        # no simulation
       set timeout 10000;     # 10 sec timeout
       set status [panSendCommand $wsenv "ccdconCI_$camera" "PAUSE" 0 $timeout]
   } else {;                  # simulation
       set ccdPauseFlag 1
   }
}




proc ccdContinue {} {
   global camera wsenv gvar simul
   global ccdPauseFlag

   if {$simul != 1} {;        # no simulation
       set timeout 10000;     # 10 sec timeout
       set status [panSendCommand $wsenv "ccdconCI_$camera" "CONT" 0 $timeout]
   } else {;                  # simulation
       set ccdPauseFlag 0
   }
}




proc ccdStop {} {

   global camera wsenv gvar simul
   global ccdStopFlag

   if {$simul != 1} {;     # no simulation
       set timeout 10000;  # 10 sec timeout
       set status [panSendCommand $wsenv "ccdconCI_$camera" "END" 0 $timeout]
   } else {;               # simulation
       set ccdStopFlag 1
   }
}




proc ccdChangeTime {} {

  global camera wsenv gvar simul
  global ccdChangeFlag

  if {$simul != 1} {;     # no simulation
    set timeout 10000;  # 10 sec timeout
    set process "ccdconCI_$camera"
    set newTime $gvar(setup.1145.DET.WIN1.UIT1); # taken from setup area  
    set param "-expoId $gvar(ccdEXP_LAST) -function DET.WIN1.UIT1 $newTime"
    set status [panSendCommand $wsenv $process "SETUP" 0 $timeout "$param"]
  } else {;               # simulation
    set ccdChangeFlag 1
  }
}

proc ccdChangeRate {} {

  global camera wsenv gvar simul
  global ccdChangeRate

  if {$simul != 1} {;     # no simulation
    set timeout 10000;  # 10 sec timeout
    set process "ccdconCI_$camera"
    set newRate $gvar(imageOpt_setup.24.DET.FRAM.SAMPLE); # taken from setup area  
    set param "-expoId $gvar(ccdEXP_LAST) -function DET.FRAM.SAMPLE $newRate"
    set status [panSendCommand $wsenv $process "SETUP" 0 $timeout "$param"]
  } else {;               # simulation
    set ccdChangeRate 1
  }
}




proc ccdWipe {} {
   global camera wsenv gvar simul

   if {$simul != 1} {;     # no simulation
       set timeout 60000;  # 60 sec timeout
       set status [panSendCommand $wsenv "ccdconCI_$camera" "STARTWP" 0 $timeout "0"]
   }
}




proc ccdDump {} {
   global camera wsenv gvar simul

   if {$simul != 1} {;     # no simulation
       set timeout 20000;  # 20 secs timeout
       set status [panSendCommand $wsenv "ccdconCI_$camera" "DUMP" 0 $timeout]
   } else {;               # simulation
     after 1 ccdExpSim 1 0
   }
}




proc ccdStopLoop {} {
   global camera wsenv gvar simul
   global ccdLoopFlag

   if {$simul != 1} {;     # no simulation
       set timeout 40000;  # 40 secs timeout (20 not enough, see SPR 960285)
       set status [panSendCommand $wsenv "ccdconCI_$camera" "STOP" 0 $timeout]
       if {$status != "FAILURE"} { set ccdLoopFlag 1 }
   } else {;               # simulation
     set ccdLoopFlag 1
   }
}




proc ccdStartDisplay {} {
   global camera imageDir

   exec sh -c "cd $imageDir; rtd -camera $camera" &
}





# set or reset variables to be traced within ccdCtrl
proc ccdSetTrace {op} {

 global gvar

 # Trace operations needed for interaction among widgets
   trace $op gvar(ccdExpOpt_expNrep) w ccdTrace
   trace $op gvar(ccdExpOpt_nrep) w ccdTrace
   trace $op gvar(imageOpt_rtdRf) w ccdTrace
   trace $op gvar(rtd) w ccdTrace
   trace $op gvar(.id) w ccdTrace
   trace $op gvar(setup.15.DET.WIN1.BINX) w ccdTrace
   trace $op gvar(setup.16.DET.WIN1.BINY) w ccdTrace
}






# trace procedure for ccdCtrl panel
proc ccdTrace {name element op} {

  global cv gvar oldId
  global ccdMaxWin

  if {(![string compare $element "ccdExpOpt_expNrep"])
       || (![string compare $element "ccdExpOpt_nrep"])} {
    set isInt [regexp {^[0-9]+$} $gvar(ccdExpOpt_expNrep)]
    if {($gvar(ccdExpOpt_nrep) == 0) || 
        (($gvar(ccdExpOpt_expNrep) != 1) && ($isInt))} {
      set gvar(ccdExpOpt_rep) 1
      # AL970521 Added to reduce risk of filling disk for infinite loop
      if {$gvar(ccdExpOpt_nrep) == 0} {
        set gvar(setup.7.DET.FRAM.FITSMTD) 0
      }
    } else {
      set gvar(ccdExpOpt_rep) 0
    }
    if {![string compare $element "ccdExpOpt_expNrep"]} {
      set gvar(ccdExpOpt_nrep) 2
    }
  } elseif {![string compare $element "imageOpt_rtdRf"]} {
    if {$gvar($element)} {set gvar(rtd) 1}
  } elseif {![string compare $element "rtd"]} {
    if {!($gvar($element))} {set gvar(imageOpt_rtdRf) 0}
  } elseif {![string compare $element ".id"]} {
    if {![info exists oldId]} { set oldId "" }
# AL970221 If one does NOT change camera, but just a couple of parameters
#          (e.g. readout speed), the panel has to be refreshed
#    if {$gvar($element) != $oldId } { after 2000 ccdChangeWidgets }
#          Note: 1 sec delay is not enough in some cases. id is one of the
#          first attributes being updated in the DB, therefore the trigger
#          here comes when not all attributed have been updated yet. One
#          has to wait a bit: hopefully 2 secs are enough in all cases.
    after 2000 ccdChangeWidgets
    set oldId $gvar($element)
  } elseif {(![string compare $element "setup.15.DET.WIN1.BINX"])
           || (![string compare $element "setup.16.DET.WIN1.BINY"])} {
# AL970225 This part somehow works, but not completely.
#          Something should be done at level of classContainer. 
#          One needs a variable associated to the check button (already 
#          existing, but only in read mode with some limitations/bugs)
#          such that one can programmatically select the class to display
#          or retreve the class currently displayed. It should also
#          be possible (through the same variable ?) to disable the button
#          (no selection possible any more). Through variable setting/reading
#          is of course simpler for the application. If not possible, then
#          equivalent methods should be implemented.
#          Left for Mauro.
#          Example: variable winEnb
#          winEnb = -1      class container disabled
#          winEnb = 0       no frame shown
#          winEnb = 1       first frame in the list shown
    if { ($gvar(ccdMainCtrl_type) == "technical") } {; # TCCDS
      if { ($gvar($element) > 1) } {; # binning > 1: no window possible
# window readout parameters must be disabled and real-time image processing
# on window 2 as well
        for { set i 1} { $i <= $ccdMaxWin } {incr i} { 
	  $cv.ccdWindowFrame$i configure -show 0
	  if { $i > 1 } { $cv.ccdSetupIp$i configure -show 0 }
#	   $cv.ccdWindowFrame$i configure -wdgClassList {}
        }
      } elseif {($gvar(setup.15.DET.WIN1.BINX) == 1) &&
	        ($gvar(setup.16.DET.WIN1.BINY) == 1) } {; # no binning
#        for { set i 1} { $i <= $ccdMaxWin } {incr i} { 
#          $cv.ccdWindowFrame$i configure -wdgClassList ccdWindow_uifClass
#        }
      }
    }
  }
}


#
# ___oOo___
