
#*******************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: ccdGetOpState.tcl,v 2.7 2005/05/11 03:10:38 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# alongino  25/07/95  created
# alongino  08/07/96  global variables names modified to coexist with
#                     ccdExpCtrlUpdate
#                     added context sensitivity disabled
# alongino  13/08/97  operational state values taken from ccdUsrGlobalData
#

#************************************************************************
#   NAME
#   ccdGetOpState - read from the database the current camera operational state
# 
#   SYNOPSIS
#   ccdGetOpState
# 
#   DESCRIPTION
#   Tcl procedure, used within CCD GUI panels, to read from the database
#   the current camera operational state and set it in the global variable
#   gvar(opState)
#
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#   ccdGetOpState
#
#   SEE ALSO
#
#
#   BUGS     
#
#------------------------------------------------------------------------
#

proc ccdGetOpState { } {        

 # Declare global variables 

   global gvar

 # User Initialization

   set gvar(opState) [dbRead ".opState"]; # get current operational state
   set gvar(opMode)  [dbRead ".opMode"];  # get current operational mode
   
 # enable/disable buttons according to current operational state

   if {$gvar(ccdContext)} {;   # context sensitive
     set gvar(ccdMainCtrl_ccdNotLoaded) 0
     set gvar(ccdMainCtrl_ccdLoaded)    0
     set gvar(ccdMainCtrl_ccdRunning)   0
# AL960222 mode 1 (WS simulation is used for demo session)
     if {$gvar(opMode) > $gvar(ccdMODE_INVALID_LOW)} {;     # available
         if {$gvar(opState) <= $gvar(ccdSTATE_OFF)} {;      # state OFF
            set gvar(ccdMainCtrl_ccdNotLoaded) 1
         } elseif {$gvar(opState) > $gvar(ccdSTATE_OFF)} {; # at least LOADED
            set gvar(ccdMainCtrl_ccdLoaded) 1
          set gvar(ccdMainCtrl_ccdRunning) 1
        }  
     }
   } else {;                   # buttons always enabled
     set gvar(ccdMainCtrl_ccdNotLoaded) 1
     set gvar(ccdMainCtrl_ccdLoaded)    1
     set gvar(ccdMainCtrl_ccdRunning)   1     
   }
# puts "context = $gvar(ccdContext)"
# puts "not Loaded = $gvar(ccdMainCtrl_ccdNotLoaded)"
# puts "loaded     = $gvar(ccdMainCtrl_ccdLoaded)"
# puts "running    = $gvar(ccdMainCtrl_ccdRunning)"     
}


#
# ___oOo___


