#************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: ccdTel.tcl,v 2.7 2005/05/11 03:10:41 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# alongino  10/03/97  created
#

#************************************************************************
#   NAME 
#   ccdTelInitialise
# 
#   SYNOPSIS
# 
#   DESCRIPTION
#   These procedures are used within the ccdConfig, ccdTelSet and ccdTelemetry
#   panel to handle the telemetry parameters
#
#------------------------------------------------------------------------
#

#
# Initialise variables
proc ccdTelInitialise { } {

  global cv
  global telRows telCol  
  global telTable telDbAttr telAvail
  global telDbCurr telWdg telFormatProc

  set telRows 100; # maximum number of rows, as from DB
  set telCol 10;   # maximum number of columns, as from DB
  set telDbCurr "telemetry.current"
  set telWdg $cv.ccdTelListBox
  set telFormatProc ccdFormatTelStatus

  # set path to DB values
  ccdTelDbInit $telRows telDbAttr

  # Read element by element from OLDB and set internal table
  ccdDbToTable telTable $telRows $telCol telDbAttr

  # Build list with only the available elements
  ccdTableAvail telTable telAvail telDbAttr

}



#
# Initialise variables for telemetry and temperature list boxes
proc ccdTelDbInit { rows dbAttr } {

  upvar $dbAttr ccdDbAttr

  # set path to DB values
  set ccdDbAttr(avail) telemetry.available
  for { set i 0 } { $i < $rows } {incr i } {
    set ccdDbAttr($i,availInd) 2; # available flag is at position 2 in record
    set ccdDbAttr($i,availVal) 0; # not available value
    set ccdDbAttr($i) telemetry.sensor($i)
  }
}

#
# ___oOo___
