#************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: ccdTelSet.tcl,v 2.7 2005/05/11 03:10:43 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# alongino  10/03/97  created
#

#************************************************************************
#   NAME 
#   ccdTelSetInitialise
# 
#   SYNOPSIS
# 
#   DESCRIPTION
#   These procedures are used within the ccdTelSet panel
#
#------------------------------------------------------------------------
#

#
# Initialise variables
proc ccdTelSetInitialise { } {

  # read from db and build table
  ccdTelInitialise

  # update option button with available telemetry entries
  ccdTelSetOptions
}



#
# Update option button for selection of telemetry entry
proc ccdTelSetOptions { } {

  global cv gvar
  global telAvail telDbAttr

  set ccdList [ccdTelTemGetList telAvail telDbAttr]
  $cv.ccdTelEntry configure -itemList $ccdList

  # Set other widgets
  set gvar(ccdTelChange) 0
  if {[llength $ccdList]} {; # options available. Default to first entry
    if {$gvar(maint)} {set gvar(ccdTelChange) 1}
    set gvar(ccdTelEntry) [lindex $ccdList 0]
    ccdTelSetSelect $gvar(ccdTelEntry)
  } 
}



#
# Procedure called when new option is selected
proc ccdTelSetSelect { entry } {

  global gvar telAvail

  set rec [ccdTelTemGetListRec $entry telAvail]
  if {$rec >= 0} {
    # update reference and range accordingly
    set gvar(ccdTelRef)  [lindex $telAvail($rec) 10]
    set gvar(ccdTelLow)  [lindex $telAvail($rec)  8]
    set gvar(ccdTelHigh) [lindex $telAvail($rec)  9]
    set gvar(ccdTelInd)  [lindex $telAvail($rec)  0]
    set gvar(ccdTelVal) $gvar(ccdTelRef)
  }
}



#
# Send command to set new telemetry value in the hw 
proc ccdTelSetApply {} {

  global camera wsenv gvar simul

  set timeout 10000;            # timeout 10 sec
  set command "panSendCommand $wsenv ccdconCI_$camera SET 0 $timeout DET.TEL$gvar(ccdTelInd) $gvar(ccdTelVal)"
  set status [puts $command]
}

#
# ___oOo___
