#************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: ccdTem.tcl,v 2.7 2005/05/11 03:10:41 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# alongino  10/03/97  created
#

#************************************************************************
#   NAME 
#   ccdTemInitialise
# 
#   SYNOPSIS
# 
#   DESCRIPTION
#   These procedures are used within the ccdConfig and ccdTelemetry
#   panel to handle the temperature parameters
#
#------------------------------------------------------------------------
#

#
# Initialise variables
proc ccdTemInitialise { } {

  global cv
  global temRows temCol  
  global temTable temDbAttr temAvail
  global temDbCurr temWdg temFormatProc

  set temRows 10; # maximum number of rows, as from DB
  set temCol 10;   # maximum number of columns, as from DB
  set temDbCurr "temperature.current"
  set temWdg $cv.ccdTemListBox
  set temFormatProc ccdFormatTemStatus

  # set path to DB values
  ccdTemDbInit $temRows temDbAttr

  # Read element by element from OLDB and set internal table
  ccdDbToTable temTable $temRows $temCol temDbAttr

  # Build list with only the available elements
  ccdTableAvail temTable temAvail temDbAttr

}



#
# Initialise variables for telemetry and temperature list boxes
proc ccdTemDbInit { rows dbAttr } {

  upvar $dbAttr ccdDbAttr

  # set path to DB values
  set ccdDbAttr(avail) temperature.available
  for { set i 0 } { $i < $rows } {incr i } {
    set ccdDbAttr($i,availInd) 2; # available flag is at position 2 in record
    set ccdDbAttr($i,availVal) 0; # not available value
    set ccdDbAttr($i) temperature.sensor($i)
  }
}

#
# ___oOo___
