#*******************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: ccsMonAlarms.tcl,v 0.31 2005/10/14 10:40:01 vltsccm Exp $"
#
# who       when        what
# --------  ----------  ----------------------------------------------
# mcomin  2005-08-10  created
#

#************************************************************************
#   NAME
# 
#   SYNOPSIS
# 
#   DESCRIPTION
#
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#
#   SEE ALSO
#
#   BUGS     
#
#------------------------------------------------------------------------
#

proc ccsMonConfigAlarm { } {
    global gvar RTAPENV

    set flag -1
    set tmpList [concat [split [ccsMonGetProcs] ","]]

    set gvar(alarmProc) [lindex [lindex $tmpList 0] 0]
    set c .alarmStart
    toplevel $c
    frame $c.middle   -relief raised -border 1
    frame $c.bot      -relief raised -border 1

    iwidgets::combobox $c.middle.cb1 -labeltext "Select Process:"  \
	-editable false -dropdown false \
	-arrowrelief ridge -popupcursor hand2 \
	-textvariable gvar(alarmProc) 

    $c.middle.cb1 configure -listheight 80

    pack $c.middle.cb1  -padx 10 -pady 10 -fill x
    iwidgets::Labeledwidget::alignlabels $c.middle.cb1 

    button  $c.bot.ok  -text "Ok" -width 10 -command \
	"set flag 1; ccsMonConfAlarm; destroy $c"

    button  $c.bot.cancel -text "Cancel" -width 10 -command "set flag 1; destroy $c"

    pack $c.middle $c.bot -fill x 
    pack $c.bot.ok $c.bot.cancel -side left -pady 10 -expand 1

    set cnt [llength $tmpList]
    for {set i 1} {$i<$cnt} {incr i} {
        eval $c.middle.cb1 insert list end {[lindex [lindex $tmpList $i] 0]}
    }

    wm geometry $c +400+400
    wm title $c "CCS Monitor System"

    grab $c
    vwait flag;      # Stops until variable as been modified
}


proc ccsMonRemoveAlarm { } {
    global gvar RTAPENV

    set flag -1

    if { [catch {seq_msgSendCommand $RTAPENV ccsMonitor MONGETA "" } cmdId ] } {
        set jobLst ""
    } else { 
        set msg [seq_msgRecvReply $cmdId errNr -all]
        if { $errNr != 0 } {
            set jobLst ""
        } else {
            set jobLst [concat [split $msg ","]]
        }
    }

    if { [llength $jobLst] <= 1 } {
        ccsMonMessage message ERROR "No alarms configured"
        return
    }
    set gvar(alarmStopJob) [lindex $jobLst 1]
    set c .alarmStop
    toplevel $c
    frame $c.middle   -relief raised -border 1
    frame $c.bot      -relief raised -border 1

    iwidgets::combobox $c.middle.cb1 -labeltext "Select Alarm:" \
	-editable false -dropdown false \
	-arrowrelief ridge -popupcursor hand2 \
	-textvariable gvar(alarmStopJob) 

    $c.middle.cb1 configure -listheight 80

    pack $c.middle.cb1  -padx 10 -pady 10 -fill x
    iwidgets::Labeledwidget::alignlabels $c.middle.cb1 

    button  $c.bot.ok  -text "Ok" -width 10 -command \
	"set flag 1; ccsMonStopTheAlarm; destroy $c"

    button  $c.bot.cancel -text "Cancel" -width 10 -command "set flag 1; destroy $c"

    pack $c.middle $c.bot -fill both 
    pack $c.bot.ok  $c.bot.cancel -side left -pady 10 -expand 1

    set cnt [llength $jobLst]
    for {set i 1} {$i<$cnt} {incr i} {
        eval $c.middle.cb1 insert list end {[lindex $jobLst $i]}
    }

    wm geometry $c +400+400
    wm title $c "CCS Monitor System"

    grab $c
    vwait flag;      # Stops until variable as been modified
}

proc ccsMonChangeMsgLimits { } {
    global gvar RTAPENV

    set flag -1
    set values ""

    if { [catch {seq_msgSendCommand $RTAPENV ccsMonitor MONGMSL "" } cmdId ] } {
        ccsMonMessage message ERROR $cmdId
        return
    }

    set msg [seq_msgRecvReply $cmdId errNr -all]
    if { $errNr != 0 } {
	ccsMonMessage message ERROR $cmdId
	return
    } else {
	set values [concat [split $msg ","]]
	set gvar(ccsMonMsgAlLimWarn) [lindex $values 0]
	set gvar(ccsMonMsgAlLimSer)  [lindex $values 1]
    }

    set c .msgLimits
    toplevel $c

    frame $c.middle   -relief raised -border 1
    frame $c.bot      -relief raised -border 1

    iwidgets::entryfield $c.middle.e1 -validate numeric -labeltext "Warning Limit:" \
                    -invalid {ccsMonMessage message ERROR "Use only Numbers"}        \
                    -textvariable gvar(ccsMonMsgAlLimWarn)
    iwidgets::entryfield $c.middle.e2 -validate numeric -labeltext " Serious Limit:" \
                    -invalid {ccsMonMessage message ERROR "Use only Numbers"}    \
                    -textvariable gvar(ccsMonMsgAlLimSer)

    pack $c.middle.e1 $c.middle.e2  -padx 10 -pady 10 -fill x
    button  $c.bot.ok  -text "Ok" -width 10 -command \
	"set flag 1; ccsMonSetupMsgLimits; destroy $c"

    button  $c.bot.cancel -text "Cancel" -width 10 -command "set flag 1; destroy $c"
    pack $c.middle $c.bot -fill x
    pack $c.bot.ok $c.bot.cancel -side left -pady 15 -expand 1

    wm geometry $c +400+400
    wm title $c "CCS Monitor System"

    grab $c
    vwait flag;      # Stops until variable as been modified
}


proc ccsMonChangeEvtLimits { } {
    global gvar RTAPENV

    set flag -1

    set values ""
    if { [catch {seq_msgSendCommand $RTAPENV ccsMonitor MONGEVL "" } cmdId ] } {
        ccsMonMessage message ERROR $cmdId
        return
    } else { 
        set msg [seq_msgRecvReply $cmdId errNr -all]
        if { $errNr != 0 } {
            ccsMonMessage message ERROR $cmdId
            return
        } else {
            set values [concat [split $msg ","]]
            set gvar(ccsMonEvtAlLimWarn) [lindex $values 0]
            set gvar(ccsMonEvtAlLimSer)  [lindex $values 1]
        }
    }

    set c .evtLimits
    toplevel $c

    frame $c.middle   -relief raised -border 1
    frame $c.bot      -relief raised -border 1

    iwidgets::entryfield $c.middle.e1 -validate numeric -labeltext "Warning Limit:" \
                    -invalid {ccsMonMessage message ERROR "Use only Numbers"}    \
                    -textvariable gvar(ccsMonEvtAlLimWarn)
    iwidgets::entryfield $c.middle.e2 -validate numeric -labeltext " Serious Limit:" \
                    -invalid {ccsMonMessage message ERROR "Use only Numbers"}    \
                    -textvariable gvar(ccsMonEvtAlLimSer)

    pack $c.middle.e1 $c.middle.e2  -padx 10 -pady 10 -fill x
    button  $c.bot.ok  -text "Ok" -width 10 -command \
	"set flag 1; ccsMonSetupEvtLimits; destroy $c"

    button  $c.bot.cancel -text "Cancel" -width 10 -command "set flag 1; destroy $c"

    pack $c.middle $c.bot -fill x
    pack $c.bot.ok $c.bot.cancel -side left -pady 15 -expand 1

    wm geometry $c +400+400
    wm title $c "CCS Monitor System"

    grab $c
    vwait flag;      # Stops until variable as been modified
}


proc ccsMonConfAlarm { } {
    global gvar RTAPENV

    if {[catch {set procnum [ccsMonGetProcnum $RTAPENV $gvar(alarmProc)]} msg]} {
        ccsMonMessage message ERROR $msg
        return
    }
    if { [catch {seq_msgSendCommand $RTAPENV ccsMonitor MONMSGA $procnum } cmdId ] } {
        ccsMonMessage message ERROR $cmdId
    } else { 
        set msg [seq_msgRecvReply $cmdId errNr -all]
        if { $errNr != 0 } {
            ccsMonMessage message ERROR $msg
        }
    }
    return
}


proc ccsMonStopTheAlarm { } {
    global gvar RTAPENV

    set process [lindex $gvar(alarmStopJob) 0]
    if { [string range $process 0 2] == "???" } {
        set procnum [string range $process 4 end]
    } else {
        if {[catch {set procnum [ccsMonGetProcnum $RTAPENV $process]} msg]} {
            ccsMonMessage message ERROR $msg
            return
        }
    }
    if { [catch {seq_msgSendCommand $RTAPENV ccsMonitor MONDMGA $procnum } cmdId ] } {
        ccsMonMessage message ERROR $cmdId
    } else { 
        set msg [seq_msgRecvReply $cmdId errNr -all]
        if { $errNr != 0 } {
            ccsMonMessage message ERROR $msg
        }
    }
}


proc ccsMonSetupMsgLimits { } {
    global gvar RTAPENV

    set parameter [format "%d,%d" $gvar(ccsMonMsgAlLimWarn) $gvar(ccsMonMsgAlLimSer)]
    if { [catch {seq_msgSendCommand $RTAPENV ccsMonitor MONMSGL $parameter } cmdId ] } {
        ccsMonMessage message ERROR $cmdId
    } else { 
        set msg [seq_msgRecvReply $cmdId errNr -all]
        if { $errNr != 0 } {
            ccsMonMessage message ERROR $msg
        }
    }
}


proc ccsMonSetupEvtLimits { } {
    global gvar RTAPENV

    set parameter [format "%d,%d" $gvar(ccsMonEvtAlLimWarn) $gvar(ccsMonEvtAlLimSer)]
    if { [catch {seq_msgSendCommand $RTAPENV ccsMonitor MONEVTL $parameter } cmdId ] } {
        ccsMonMessage message ERROR $cmdId
    } else { 
        set msg [seq_msgRecvReply $cmdId errNr -all]
        if { $errNr != 0 } {
            ccsMonMessage message ERROR $msg
        }
    }
}


proc ccsMonEnableMsgAlarm { } {
    global RTAPENV gvar

    if { $gvar(ccsMonAlarmMsgOn) == 0 } {
        if { [catch {seq_msgSendCommand $RTAPENV ccsMonitor MONMSGO "" } cmdId ] } {
            ccsMonMessage message ERROR $cmdId
        } else { 
            set msg [seq_msgRecvReply $cmdId errNr -all]
            if { $errNr != 0 } {
                ccsMonMessage message ERROR $msg
            } 
        }
    } else {
        if { [catch {seq_msgSendCommand $RTAPENV ccsMonitor MONMSGS "" } cmdId ] } {
            ccsMonMessage message ERROR $cmdId
            set gvar(ccsMonAlarmMsgOn) 0
        } else { 
            set msg [seq_msgRecvReply $cmdId errNr -all]
            if { $errNr != 0 } {
                ccsMonMessage message ERROR $msg
                set gvar(ccsMonAlarmMsgOn) 0
            }
        }
    }
}


proc ccsMonEnableEvtAlarm { } {
    global RTAPENV gvar

    if { $gvar(ccsMonAlarmEvtOn) == 0 } {
        if { [catch {seq_msgSendCommand $RTAPENV ccsMonitor MONEVTO "" } cmdId ] } {
            ccsMonMessage message ERROR $cmdId
        } else { 
            set msg [seq_msgRecvReply $cmdId errNr -all]
            if { $errNr != 0 } {
                ccsMonMessage message ERROR $msg
            } 
        }
    } else {
        if { [catch {seq_msgSendCommand $RTAPENV ccsMonitor MONEVTS "" } cmdId ] } {
            ccsMonMessage message ERROR $cmdId
            set gvar(ccsMonAlarmEvtOn) 0
        } else { 
            set msg [seq_msgRecvReply $cmdId errNr -all]
            if { $errNr != 0 } {
                ccsMonMessage message ERROR $msg
                set gvar(ccsMonAlarmEvtOn) 0
            }
        }
    }
}



#
# ___oOo___
