#*******************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: ccsMonPage.tcl,v 0.31 2005/10/14 10:40:02 vltsccm Exp $"
#
# who       when        what
# --------  ----------  ----------------------------------------------
# mcomin  2005-08-10  created
#

#************************************************************************
#   NAME
# 
#   SYNOPSIS
# 
#   DESCRIPTION
#
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#
#   SEE ALSO
#
#   BUGS     
#
#------------------------------------------------------------------------
#


proc ccsMonChangeUid { } {
    global gvar

    if { $gvar(uid) == 1 } {
        set gvar(uid) 0
        $gvar(tblSys).tbl columnconfigure 3 -title "USER"
        $gvar(tblSys).tbl columnconfigure 3 -sortmode ascii
    } else {
        set gvar(uid) 1
        $gvar(tblSys).tbl columnconfigure 3 -title "UID"
        $gvar(tblSys).tbl columnconfigure 3 -sortmode integer
    }
    ccsMonStartProcInfo
}

proc ccsMonStartProcInfo {} {
    global gvar menuTrending

    catch {after cancel $gvar(update)}

    $menuTrending entryconfigure 1 -state disabled

    if { $gvar(ccsMonUpdateOn) == 1 } {
        if { $gvar(uid) == 1 } {
            set gvar(ccsMonSysList) [concat [split [ccsMonGetProcInfo -1] ","]]
        } else {
            set tmpList [concat [split [ccsMonGetProcInfo -1] ","]]
            ccsMonPrintName $tmpList
        }
        set col [$gvar(tblSys).tbl sortcolumn]
        set order [$gvar(tblSys).tbl sortorder]
        if { $col != -1 } {
            $gvar(tblSys).tbl sortbycolumn $col -$order
        }
    }
    set gvar(update) [after $gvar(period) ccsMonStartProcInfo]
}

proc ccsMonPrintName { tmpList } {
    global gvar

    set cnt [llength $tmpList]
    set usrCnt [llength $gvar(userList)]

    set newList ""
    for { set i 0 } { $i<$cnt } {incr i} {
        set xx [lindex $tmpList $i]
        for { set j 0 } {$j<$usrCnt} {incr j} {
            set yy [lindex $gvar(userList) $j]
            if { [lindex $xx 3] == [lindex $yy 1] } {
                lappend newList [lreplace $xx 3 3 [lindex $yy 0]]
	    }
        }

    }
    set gvar(ccsMonSysList) $newList
}

proc ccsMonCreateTblSys { page } {
    global gvar

    set gvar(tblSys) $page

    set colConfig {0 "Process Name" left
                         0 "PNUM" right 0 "PID" right 0 "UID" right 0 "GID" right 
                         0 "MSGID" right 0 "MONITOR-PID" right 0 "MONITOR-SEM" right 0 "JANITOR-SEM" right } 

    set wtbl [ccsMonCreatePage $page $colConfig gvar(ccsMonSysList) \
		  [list 1 2 3 4 5 6 7 8 ] [list 1 3 5 7] ]

    set body [$wtbl bodypath]
    bind $body <Button-1> {
	set wtbl [winfo parent %W]
        set tablelist::x [expr {%x + [winfo x %W]}]
        set tablelist::y [expr {%y + [winfo y %W]}]
	if { [$wtbl nearestcolumn $tablelist::x] == 3 } {
            ccsMonChangeUid
	} 
    }
}

#-------------------------------------------------------------

proc ccsMonCreateRT { page } {
    global gvar

    set gvar(tblRT) $page

    set colConfig  {0 "Process Name" left 0 "PNUM" right 0 "PID" right 0 "SCHEDULING" right 0 "PRIORITY" right }

    set wtbl [ccsMonCreatePage $page $colConfig gvar(ccsRTDataList) \
		  [list 1 2 4] [list 1 3] ]
    return
}

proc ccsMonStartRT { } {
    global gvar

    catch {after cancel $gvar(update)}

    if { $gvar(ccsMonUpdateOn) == 1 } {
        set gvar(ccsRTDataList) [concat [split [ccsMonGetRTData] ","]]
        set col [$gvar(tblRT).tbl sortcolumn]
        set order [$gvar(tblRT).tbl sortorder]
        if { $col != -1 } {
             $gvar(tblRT).tbl sortbycolumn $col -$order
        }
    }
    set gvar(update) [after $gvar(period) ccsMonStartRT]
}

#-------------------------------------------------------------


proc ccsMonCreateTblLoad { page } {
    global gvar

    set gvar(tblLoad) $page

    set colConfig {0 "Process Name" left  0 "PNUM" right 0 "PID" right 0 \
		       "%CPU" right 0 "SIZE" right 0 "RES-SIZE" right 0 "START TIME" left }

    set wtbl [ccsMonCreatePage $page $colConfig gvar(ccsMonLoadList) \
		  [list 1 2 4 5] [list 1 3 5] ]

    $wtbl columnconfigure 3 -sortmode real

    return
}

proc ccsMonStartLoadInfo { } {
    global gvar menuTrending

    catch {after cancel $gvar(update)}

    $menuTrending entryconfigure 1 -state disabled

    if { $gvar(ccsMonUpdateOn) == 1 } {
        set tmpLst  [concat [split [ccsMonGetSysData -1] ","]]
        set gvar(ccsMonLoadList) [lrange $tmpLst 0 [expr {[llength $tmpLst] - 2}] ]
        set col   [$gvar(tblLoad).tbl sortcolumn]
        set order [$gvar(tblLoad).tbl sortorder]
        if { $col != -1 } {
            $gvar(tblLoad).tbl sortbycolumn $col -$order
        }

        set elem [lindex $tmpLst end]
	set CPU [lindex  $elem 0]
        set MEM [lindex  $elem 1]
        set RES [lindex  $elem 2]

        set header [format "CPU (%5s %%)" $CPU]
        $gvar(tblLoad).tbl columnconfigure 3 -title $header 
        set header [format "SIZE (%s kB)" $MEM]
        $gvar(tblLoad).tbl columnconfigure 4 -title $header 
        set header [format "RSIZE (%s kB)" $RES]
        $gvar(tblLoad).tbl columnconfigure 5 -title $header 

    }
    set gvar(update) [after $gvar(period) ccsMonStartLoadInfo]
}

#-------------------------------------------------------------


proc ccsMonCreateTblConf { page } {
    global gvar

    set gvar(tblConf) $page

    set colConfig  {0 "Process Name" left 0 "PNUM" right 0 "RESTART" center 0 \
			"LOCKED" center 0 "CLEANUP" center  0 "GETOBI" center }                  

    set wtbl [ccsMonCreatePage $page $colConfig gvar(ccsMonConfList) \
		  [list 1 ] [list 1 3 5] ]
    return
}


proc ccsMonStartProcConf { } {
    global gvar menuTrending

    catch {after cancel $gvar(update)}

    $menuTrending entryconfigure 1 -state disabled

    if { $gvar(ccsMonUpdateOn) == 1 } {
        set gvar(ccsMonConfList) [concat [split [ccsMonGetProcConfig -1] ","]]
        set col [$gvar(tblConf).tbl sortcolumn]
        set order [$gvar(tblConf).tbl sortorder]
        if { $col != -1 } {
             $gvar(tblConf).tbl sortbycolumn $col -$order
        }
    }
    set gvar(update) [after $gvar(period) ccsMonStartProcConf]
}

#-------------------------------------------------------------


proc ccsMonCreateTblQstats { page } {
    global gvar

    set gvar(tblQstats) $page

    set colConfig  {0 "Process Name" left 0 "PNUM" right 0 "PID" right 0  \
			"MSGS" right 0 "BYTES" right 0 "LAST MSG FROM" right 0 \
			"DROPPED AT" left 0 "RETRIEVED AT" left } 

    set wtbl [ccsMonCreatePage $page $colConfig gvar(ccsMonQstatsList) \
		  [list 1 2 3 4 5] [list 1 3 5 7] ]

    set body [$wtbl bodypath]
    bind $body <Button-1> {
	set wtbl [winfo parent %W]
        set tablelist::x [expr {%x + [winfo x %W]}]
	if { [$wtbl nearestcolumn $tablelist::x] == 5 } {
            ccsMonChangeProc "tblQstats"
	} 
    }
}

proc ccsMonChangeProc { what } {
    global gvar

    if { $gvar(pid1) == 1 } {
        set gvar(pid1) 0
        $gvar($what).tbl columnconfigure 5 -title "LAST MSG FROM"
        $gvar($what).tbl columnconfigure 5 -sortmode ascii
    } else {
        set gvar(pid1) 1
        $gvar($what).tbl columnconfigure 5 -title "LAST MSG FROM"
        $gvar($what).tbl columnconfigure 5 -sortmode integer
    }
    ccsMonStartQstats
}


proc ccsMonStartQstats { } {
    global gvar menuTrending

    catch {after cancel $gvar(update)}

    $menuTrending entryconfigure 1 -state disabled

    if { $gvar(ccsMonUpdateOn) == 1 } {
        if { $gvar(pid1) == 0 } {
            set tmpList1 [concat [split [ccsMonGetMsgStat -1] ","]]
            set tmpList2 [concat [split [ccsMonGetProcs] ","]]
            set gvar(ccsMonQstatsList) [ccsMonPrintProc $tmpList1 $tmpList2 5]
        } else {
            set gvar(ccsMonQstatsList) [concat [split [ccsMonGetMsgStat -1] ","]]
        }
        set col [$gvar(tblQstats).tbl sortcolumn]
        set order [$gvar(tblQstats).tbl sortorder]
        if { $col != -1 } {
            $gvar(tblQstats).tbl sortbycolumn $col -$order
        }
    }
    set gvar(update) [after $gvar(period) ccsMonStartQstats]
}

#-------------------------------------------------------------


proc ccsMonCreateTblMsgs { page } {
    global gvar

    set gvar(tblMsgs) $page

    set colConfig  {0 "Process Name" 0 "REPLIES SENT" right  0  "COMMANDS SENT" right 0 \
			"OTHERS SENT" right 0 "BYTES SENT" right 0 "REPLIES RECV" right 0 \
			"COMMANDS RECV" right 0 "OTHERS RECV" right 0 "BYTES RECV" right }   

    set wtbl [ccsMonCreatePage $page $colConfig gvar(ccsMonMsgsList) \
		  [list 1 2 3 4 5 6 7 8] [list 1 3 5 7] ]
}

proc ccsMonStartMsgs { } {
    global gvar menuTrending

    catch {after cancel $gvar(update)}

    $menuTrending entryconfigure 1 -state disabled

    if { $gvar(ccsMonUpdateOn) == 1 } {
        if {[catch {set gvar(ccsMonMsgsList) [concat [split [ccsMonGetMsgData -1] ","]]}]} {
            set gvar(ccsMonMsgsList) DISABLED
        }
        set col [$gvar(tblMsgs).tbl sortcolumn]
        set order [$gvar(tblMsgs).tbl sortorder]
        if { $col != -1 } {
            $gvar(tblMsgs).tbl sortbycolumn $col -$order
        }
    }
    set gvar(update) [after $gvar(period) ccsMonStartMsgs]
}
#-------------------------------------------------------------

proc ccsMonCreateIntQ { page } {
    global gvar

    set gvar(tblIntQ) $page

    set colConfig  {0 "Process Name" 0 "CCS-Response " right  0  "CCS-Respond" right 0 \
			"CCS-Others" right   0 "CCS-Bytes" right 0 "MSG-Response" right 0 \
			"MSG-Respond" right  0 "MSG-Other" right 0 "MSG-Bytes" right }

    set wtbl [ccsMonCreatePage $page $colConfig gvar(ccsMonIntList) \
		  [list 1 2 3 4 5 6 7 8] [list 1 3 5 7] ]
}

proc ccsMonStartIntQ { } {
    global gvar menuTrending

    catch {after cancel $gvar(update)}

    $menuTrending entryconfigure 1 -state disabled

    if { $gvar(ccsMonUpdateOn) == 1 } {
        if {[catch {set gvar(ccsMonIntList) [concat [split [ccsMonGetIntData -1] ","]]}]} {
            set gvar(ccsMonIntList) DISABLED
        }
        set col [$gvar(tblIntQ).tbl sortcolumn]
        set order [$gvar(tblIntQ).tbl sortorder]
        if { $col != -1 } {
            $gvar(tblIntQ).tbl sortbycolumn $col -$order
        }
    }
    set gvar(update) [after $gvar(period) ccsMonStartIntQ]
}

#-------------------------------------------------------------

proc ccsMonCreateIpc { page } {
    global gvar

    set pw $page.pw
    panedwindow $pw -orient horizontal  -showhandle 1
    set sem  [frame $pw.sem  -background Grey80 -borderwidth 0 ]
    set text [frame $pw.text -background Grey80 -borderwidth 0 ]
    $pw add $sem
    $pw add $text
    set cs(sem)  $pw.sem
    set cs(text) $pw.text

    label $cs(text).txt -bg white
    label $cs(sem).txt  -bg white

    iwidgets::scrolledlistbox $cs(text).txt.slb \
	  -vscrollmode static -hscrollmode static -labeltext "IPC Usage" \
          -textbackground white -listvariable gvar(ipcusage) -labelfont {courier 16 bold} \
          -textfont {courier 10 normal}

    frame $cs(sem).txt.fr
    message $cs(sem).txt.fr.part0 -justify center -text  "Message Queues" \
                                   -font {courier 16 bold} -width 15c
    tablelist::tablelist $cs(sem).txt.fr.tbl0 -activestyle frame -columns {0 "Parameter" left  \
                         0 "Value" right 0 "Recommendation" right} -background grey96          \
                         -selectbackground navy  -stripebg {#e0e8f0}  -selectforeground white  \
                         -height 10 -width 100 -setgrid yes -stretch all                       \
                         -listvariable gvar(ipcmsg)  -fg black -height 6 -showseparators 1
    message $cs(sem).txt.fr.part1 -justify center -text  "Semaphores" \
                                   -font {courier 16 bold} -width 15c
    tablelist::tablelist $cs(sem).txt.fr.tbl3 -activestyle frame -columns {0 "Parameter" left  \
                         0 "Value" right 0 "Recommendation" right} -background grey96          \
                         -selectbackground navy  -stripebg {#e0e8f0}  -selectforeground white  \
                         -height 10 -width 100 -setgrid yes -stretch all                       \
                         -listvariable gvar(ipcsem)  -fg black  -height 8  -showseparators 1
    message $cs(sem).txt.fr.part2  -justify center -text  "Shared Memory" \
                                    -font {courier 16 bold} -width 15c
    tablelist::tablelist $cs(sem).txt.fr.tbl2 -activestyle frame -columns {0 "Parameter" left  \
                         0 "Value" right 0 "Recommendation" right} -background grey96          \
                         -selectbackground navy  -stripebg {#e0e8f0}  -selectforeground white  \
                         -height 10 -width 100 -setgrid yes -stretch all                       \
                         -listvariable gvar(ipcshm)  -fg black  -height 4  -showseparators 1
   
    pack $cs(text).txt.slb -anchor n -padx 5 -pady 5 -expand 1 -fill both

    pack $cs(sem).txt.fr.part0 -padx 5 -pady 5
    pack $cs(sem).txt.fr.tbl0 -padx 5 -pady 5 -fill x -expand 1
    pack $cs(sem).txt.fr.part1 -padx 5 -pady 5
    pack $cs(sem).txt.fr.tbl3 -padx 5 -pady 5 -fill x -expand 1
    pack $cs(sem).txt.fr.part2 -padx 5 -pady 5
    pack $cs(sem).txt.fr.tbl2 -padx 5 -pady 5 -fill x -expand 1
    pack $cs(sem).txt.fr -anchor n -padx 5 -pady 5 -fill x -expand 1

    pack $cs(sem).txt $cs(text).txt -fill both -expand 1
    pack $pw -fill both -expand 1
}

proc ccsMonStartIpc { } {
    global gvar ipcName tcl_platform ipc

    catch {after cancel $gvar(update)}
    catch {exec ipcs -a } gvar(ipcusage)
    set gvar(ipcusage) [split $gvar(ipcusage) "\n"]
    wm geometry $gvar(top) 50x23
    ccsMonStartIpc2

    set cnt [llength $ipcName]
    for {set i 0} {$i<$cnt} {incr i} {
        set name [lindex $ipcName $i]
        set ipcVal($name) "NOT-Applicable"
    }

    if { [llength $gvar(ipcall)] != 0 } {
        return
    }

    if { $tcl_platform(os) == "SunOS" } {
        set destDir [ccsMonGetFileFromEso kernelParametersSUN]
        if { "$destDir" != "" } {
            set source [format "%s/%s" $destDir kernelParametersSUN]
            if { [catch {open $source r} fileId] } {
                ccsMonMessage message ERROR [format "failed to open file: %s" $fileId]
                exec rm -rf $destDir
                return
            }

            while {[gets $fileId line] >= 0} {
                for {set i 0} {$i < $cnt} {incr i} {
                    set name [lindex $ipcName $i]
                    set pattern [format "*%s*" $name]
                    if { [string match $pattern $line] != 0 } {
                        set ipcVal($name) [lindex $line 0]
  	   	    }
	        }
	    }
            close $fileId
            exec rm -rf $destDir
        }
    }

    if { $tcl_platform(os) == "HP-UX" } {
        set destDir [ccsMonGetFileFromEso kernelParametersHP]
        if { "$destDir" != "" } {
            set source [format "%s/%s" $destDir kernelParametersHP]
            if { [catch {open $source r} fileId]} {
                ccsMonMessage message ERROR [format "failed to open file: %s" $fileId]
                exec rm -rf $destDir
                return
            }

            while {[gets $fileId line] >= 0} {
                for {set i 0} {$i < $cnt} {incr i} {
                    set name [lindex $ipcName $i]
                    set pattern [string toupper [lindex [split [lindex $line 0] _] 0]]
                    if { "$name" == "$pattern" } {
                        if { [string first "X" [lindex $line 1]] != -1 } {
                            set ipcVal($name) [format "%d" [lindex $line 1]]
                        } else {
                            set ipcVal($name) [lindex $line 1]
			}
  	   	    }
	        }
	    }
            close $fileId
            exec rm -rf $destDir
        }
    }

    if { $tcl_platform(os) == "Linux" } {
        set destDir [ccsMonGetFileFromEso kernelParametersLinux]
        if { "$destDir" != "" } {
            set source [format "%s/%s" $destDir kernelParametersLinux]
            if {[catch {open $source r} fileId]} {
                ccsMonMessage message ERROR [format "failed to open file: %s" $fileId]
                exec rm -rf $destDir
                return
            }

            while {[gets $fileId line] >= 0} {
                for {set i 0} {$i < $cnt} {incr i} {
                    set name [lindex $ipcName $i]
                    set pattern [format "kernel.%s" [string tolower $name]]
                    if { "[lindex $line 0]" == "$pattern" } {
                        set ipcVal($name) [lindex $line 2]
  	   	    } elseif { "[lindex $line 0]" == "kernel.sem" } {
                        set ipcVal(SEMMSL) [lindex $line 2]
                        set ipcVal(SEMMNS) [lindex $line 3]
                        set ipcVal(SEMOPM) [lindex $line 4]
                        set ipcVal(SEMMNI) [lindex $line 5]
		    }
	        }
	    }
            close $fileId
            exec rm -rf $destDir
        }
    }

    for {set i 0} {$i<$cnt} {incr i} {
        set name [lindex $ipcName $i]
        lappend gvar(ipcall) $name $ipc($name) $ipcVal($name)
    }

    lappend gvar(ipcshm) [lrange $gvar(ipcall)  0  2] [lrange $gvar(ipcall)  3  5] \
                         [lrange $gvar(ipcall)  6  8] [lrange $gvar(ipcall)  9 11]
    lappend gvar(ipcmsg) [lrange $gvar(ipcall) 36 38] [lrange $gvar(ipcall) 39 41] \
                         [lrange $gvar(ipcall) 42 44] [lrange $gvar(ipcall) 45 47] \
                         [lrange $gvar(ipcall) 48 50] [lrange $gvar(ipcall) 51 53] 
 
    lappend gvar(ipcsem) [lrange $gvar(ipcall) 12 14] [lrange $gvar(ipcall) 15 17] \
                         [lrange $gvar(ipcall) 18 20] [lrange $gvar(ipcall) 21 23] \
                         [lrange $gvar(ipcall) 24 26] [lrange $gvar(ipcall) 27 29] \
                         [lrange $gvar(ipcall) 30 32] [lrange $gvar(ipcall) 33 35] 

    return
}

proc ccsMonStartIpc2 { } {
    global gvar

    if { $gvar(ccsMonUpdateOn) == 1 } {
        catch {exec ipcs -a } gvar(ipcusage)
        set gvar(ipcusage) [split $gvar(ipcusage) "\n"]
    }
    set gvar(update) [after $gvar(period) ccsMonStartIpc2]
}


#-------------------------------------------------------------

proc ccsMonCreateTblQuery { page } {
    global gvar

    set pw $page.pw
    # iwidgets::panedwindow $pw -orient vertical  -showhandle 1
    # foreach p {table text} {
    #       $pw add $p
    #       set cs($p) [$pw childsite $p]
    # }   
    # $pw fraction 55 45

    panedwindow $pw -orient horizontal  -showhandle 1
    set table [frame $pw.table -background Grey80 -borderwidth 0 ]
    set text  [frame $pw.text  -background Grey80 -borderwidth 0 ]
    $pw add $table
    $pw add $text

    set cs(table) $pw.table
    set cs(text) $pw.text
  
    label $cs(text).txt -bg white
    set gvar(tblQuery) $cs(table)

    set colConfig {0 "Process Name" left 0 "PNUM" right 0 "QUERIES" right  0 \
		       "CONTROLS" right 0 "CONFIGS" right }

    set wlist [ ccsMonCreateTable $cs(table) $colConfig 120 10 all gvar(ccsMonQueryList)]
    lassign $wlist tblSys vsbSys hsbSys

    set gvar(dbGlobal1)  "Local Database is:\nPID of dbStartup:\
                         \nID of Database SHM segment:\nSize of SHM segment:\
                         \nAttached to Address:\nFree Blocks in SHM:\
                         \nFree Bytes in SHM segment:\nBiggest Block available:\
                         \nUsed Blocks in SHM segment:\nAllocated Bytes in SHM segment:"

    set gvar(dbGlobal3)  "Number of Points:\nNumber of Attributes:\
                         \nNumber of Processes attached:\
                         \nLast Attachment to Database:\
                         \nLast Detachment from Database:\
                         \nProcess doing the last operation:"

    frame $cs(text).txt.fr 
    message $cs(text).txt.fr.part1  -justify center -text  "Database Shared Memory" \
                                    -font {courier 16 bold} -width 15c

    frame $cs(text).txt.fr.fr -bg white
    message $cs(text).txt.fr.fr.part2 -justify left -textvariable gvar(dbGlobal1)\
            -font {courier 10 normal} -width 10c -bg white
    message $cs(text).txt.fr.fr.part3 -textvariable gvar(dbGlobal2)\
            -font {courier 10 normal} -width 10c -bg white

    message $cs(text).txt.fr.part2  -justify center -text  "Runtime Statistics" \
                                    -font {courier 16 bold} -width 15c

    frame $cs(text).txt.fr.fr2 -bg white
    message $cs(text).txt.fr.fr2.part2 -justify left -textvariable gvar(dbGlobal3)\
            -font {courier 10 normal} -width 10c -bg white
    message $cs(text).txt.fr.fr2.part3 -textvariable gvar(dbGlobal4)\
            -font {courier 10 normal} -width 10c -bg white

    pack $cs(text).txt.fr.fr.part2 -anchor n -side left -padx 5 -pady 5
    pack $cs(text).txt.fr.fr.part3 -anchor n -side right -padx 5 -pady 5
    pack $cs(text).txt.fr.fr2.part2 -anchor n -side left -padx 5 -pady 5
    pack $cs(text).txt.fr.fr2.part3 -anchor n -side right -padx 5 -pady 5
    pack $cs(text).txt.fr.part1 -padx 5 -pady 5
    pack $cs(text).txt.fr.fr -padx 5 -pady 5 -fill x -expand 1
    pack $cs(text).txt.fr.part2 -padx 5 -pady 5
    pack $cs(text).txt.fr.fr2 -padx 5 -pady 5 -fill x -expand 1
    pack $cs(text).txt.fr -anchor n -padx 5 -pady 5 -fill x -expand 1

    pack $vsbSys -side right -fill y  -expand 1
    pack $hsbSys -side bottom -fill x  
    pack $tblSys -padx 5 -pady 5
    pack $cs(table).tbl $cs(text).txt -fill both -expand 1
    pack $pw -fill both -expand 1

    foreach col {1 2 3 4} {  
        $tblSys columnconfigure $col -sortmode integer
    }
    foreach col {1 3} {  
        $tblSys configure -showseparators yes
        $tblSys columnconfigure $col -background {#e0e8f0}
        }

    $tblSys columnconfigure 0 -resizable 0
}

proc ccsMonStartQuery { } {
    global gvar menuTrending

    catch {after cancel $gvar(update)}

    $menuTrending entryconfigure 1 -state disabled

    if { $gvar(ccsMonUpdateOn) == 1 } {
        set gvar(ccsMonQueryList) [concat [split [ccsMonGetDbQuery -1] ","]]
        set col [$gvar(tblQuery).tbl sortcolumn]
        set order [$gvar(tblQuery).tbl sortorder]
        if { $col != -1 } {
            $gvar(tblQuery).tbl sortbycolumn $col -$order
        }
        set gvar(ccsMonDbStats) [ccsMonGetDbStatistics]
        set gvar(ccsMonAttrs)   [ccsMonGetAttrCnt]

        set gvar(dbGlobal2) [format "%10s\n%10d\n%10d\n%10d\n%s\n%10d\n%10d\n%10d\n%10d\n%10d" \
                   [lindex $gvar(ccsMonDbStats) 0] [lindex $gvar(ccsMonDbStats) 2]         \
                   [lindex $gvar(ccsMonDbStats) 1] [lindex $gvar(ccsMonDbStats) 3]         \
                   [lindex $gvar(ccsMonDbStats) 8] [lindex $gvar(ccsMonDbStats) 9]         \
                   [lindex $gvar(ccsMonDbStats) 10] [lindex $gvar(ccsMonDbStats) 11]       \
                   [lindex $gvar(ccsMonDbStats) 12] [lindex $gvar(ccsMonDbStats) 13] ]
        set gvar(dbGlobal4) [format "%12d\n%12d\n%12d\n%12s\n%12s\n%12s"                   \
                        [lindex $gvar(ccsMonDbStats) 14] $gvar(ccsMonAttrs)             \
                        [lindex $gvar(ccsMonDbStats) 7] [lindex $gvar(ccsMonDbStats) 4] \
                        [lindex $gvar(ccsMonDbStats) 5] [lindex $gvar(ccsMonDbStats) 6]]
    }
    set gvar(update) [after $gvar(period) ccsMonStartQuery]
}


#-------------------------------------------------------------

proc ccsMonCreateTblMon { page } {
    global gvar

    set gvar(tblMon) $page

    set colConfig  {0 "Process Name" left  0 "PNUM" right 0 "DB-System" center 0 \
			"EVT-System" center 0 "MSG-System" center}                


    set wtbl [ccsMonCreatePage $page $colConfig gvar(ccsMonMonList) \
		  [list 1 ] [list 1 3] ]

    set body [$wtbl bodypath]
    bind $body <Button-1> {
	set wtbl [winfo parent %W]
        set tablelist::x [expr {%x + [winfo x %W]}]
        set tablelist::y [expr {%y + [winfo y %W]}]
	ccsMonChgLev [$wtbl nearestcell $tablelist::x $tablelist::y] 
    }
}

proc ccsMonChgLev { x } {
    global gvar

    set lis [split $x ", "]
    if { [lindex $lis 0] == -1 } {
        return
    }
    set cell [$gvar(tblMon).tbl cellcget $x -text]
    set lis [split $x ", "]
    set col [lindex $lis 0]
    set row [lindex $lis 1]
    set newCel [format "%d,%d" $col 0]
    set newCel1 [format "%d,%d" $col 1]
    set process [$gvar(tblMon).tbl cellcget $newCel -text]
    set procNum [$gvar(tblMon).tbl cellcget $newCel1 -text]

    switch $row {
        2 {set sys "db"  }
        3 {set sys "evt" }
        4 {set sys "msg" }
        default {return}
    }

    set result [ccsMonAsk $cell $sys $process]

    if { $result == [lindex $gvar(states) 0] } {
        ccsMonSetLev $sys $procNum "L1"
    }
    if { $result == [lindex $gvar(states) 1] } {
        ccsMonSetLev $sys $procNum "L2"
    }
    return
}

proc ccsMonSetLev { sys procNum level } {
    global gvar RTAPENV

    set body [format "%s,%s,%s" $sys $procNum $level]
    set cmdId [seq_msgSendCommand $RTAPENV ccsMonitor MONLEVL $body]
    set msg [seq_msgRecvReply $cmdId errNr -all]
    if { $errNr != 0 } {
        ccsMonMessage message ERROR $msg
    }
    ccsMonStartMonitor
    return
}

proc ccsMonStartMonitor { } {
    global gvar menuTrending

    catch {after cancel $gvar(update)}

    $menuTrending entryconfigure 1 -state disabled

    if { $gvar(ccsMonUpdateOn) == 1 } {
        if { [catch {set gvar(ccsMonMonList) [concat [split [ccsMonGetMonLevel ALL ALL] ","]]} ] } {
            set gvar(ccsMonMonList) ""
        }
        set col [$gvar(tblMon).tbl sortcolumn]
        set order [$gvar(tblMon).tbl sortorder]
        if { $col != -1 } {
            $gvar(tblMon).tbl sortbycolumn $col -$order
        }
    }
    set gvar(update) [after $gvar(period) ccsMonStartMonitor]
}



#-------------------------------------------------------------

proc ccsMonCreateTblRW { page } {
    global gvar

    set gvar(tblRW) $page

    set colConfig  {0 "Process Name" left 0 "READ" right 0 "MULTI-READ" right 0 \
			"BYTES READ" right 0 "WRITE" right 0 "MULTI-WRITE" right 0 \
			"BYTES WRITTEN" right }
    
    set wtbl [ccsMonCreatePage $page $colConfig gvar(ccsMonRWList) \
		  [list 1 2 3 4 5 6] [list 1 3 5] ]
}

proc ccsMonStartRW { } {
    global gvar menuTrending

    catch {after cancel $gvar(update)}

    $menuTrending entryconfigure 1 -state disabled

    if { $gvar(ccsMonUpdateOn) == 1 } {
        set gvar(ccsMonRWList) [concat [split [ccsMonGetDbRW -1] ","]]
        set col [$gvar(tblRW).tbl sortcolumn]
        set order [$gvar(tblRW).tbl sortorder]
        if { $col != -1 } {
            $gvar(tblRW).tbl sortbycolumn $col -$order
        }
    }
    set gvar(update) [after $gvar(period) ccsMonStartRW]
}



#-------------------------------------------------------------

proc ccsMonCreateAlarms { page } {
    global gvar

    set gvar(tblAlarms) $page

    set colConfig  {0 "Process" left 0 "ALARM ATTRIBUTE" left 0 "STATE" left }
    
    set wtbl [ccsMonCreatePage $page $colConfig gvar(ccsMonAlarmList) {} {}]

    $wtbl columnconfigure 1 -background {#e0e8f0}
    $wtbl configure -showseparators yes
}

proc ccsMonStartAlarms { } {
    global gvar RTAPENV

    catch {after cancel $gvar(update)}

    if { $gvar(ccsMonUpdateOn) == 1 } {
        if { [catch {seq_msgSendCommand $RTAPENV ccsMonitor MONGETA "" } cmdId ] } {
            set gvar(ccsMonAlarmList) ""
        } else {
            set msg [seq_msgRecvReply $cmdId errNr -all]
            if { $errNr == 0 } {
                set gvar(ccsMonAlarmList) [concat [split $msg ","]]
            } else {
                set gvar(ccsMonAlarmList) ""
	    }
        }

        set nbr [llength $gvar(ccsMonAlarmList)]
        for { set i 0 } { $i < $nbr} {incr i} {
            set state [$gvar(tblAlarms).tbl cellcget $i,2 -text]
            if { $state == "ACTIVE" } {
                $gvar(tblAlarms).tbl cellconfigure $i,2 -fg green
            } else {
                $gvar(tblAlarms).tbl cellconfigure $i,2 -fg red
            }
        }

        set col [$gvar(tblAlarms).tbl sortcolumn]
        set order [$gvar(tblAlarms).tbl sortorder]
        if { $col != -1 } {
            $gvar(tblAlarms).tbl sortbycolumn $col -$order
        }
    }
    if { $gvar(period) < 5000 } {
        set gvar(update) [after 5000 ccsMonStartAlarms]
    } else { 
        set gvar(update) [after $gvar(period) ccsMonStartAlarms]
    }
}


#-------------------------------------------------------------

proc ccsMonCreateTrends { page } {
    global gvar

    set gvar(tblTrends) $page

    set colConfig {0 "Job/Type" left 0 "PARAMETER" left 0 "STORAGE" left 0 "HISTORY POINT" left }
    
    set wtbl [ccsMonCreatePage $page $colConfig gvar(ccsMonTrendList) [list 1 3] {}]
}

proc ccsMonStartTrends { } {
    global gvar RTAPENV menuTrending

    catch {after cancel $gvar(update)}

    $menuTrending entryconfigure 1 -state normal

    if { $gvar(ccsMonUpdateOn) == 1 } {
        if { [catch {seq_msgSendCommand $RTAPENV ccsMonitor MONHISP "" } cmdId ] } {
            set gvar(histPoints) ""
        } else {
            set msg [seq_msgRecvReply $cmdId errNr -all]
            if { $errNr != 0 } {
                set gvar(histPoints) ""
            } else {
                set gvar(histPoints) [concat [split $msg ","]]
            }
        }

        set gvar(ccsMonTrendList2) ""
        if { [catch {seq_msgSendCommand $RTAPENV ccsMonitor MONPIGT ALL } cmdId ] } {
        } else {
            set msg [seq_msgRecvReply $cmdId errNr -all]
            if { $errNr == 0 } {
                set gvar(ccsMonTrendList2) [concat [split $msg ","]]
            }
        }
        if { [catch {seq_msgSendCommand $RTAPENV ccsMonitor MONLDGT ALL } cmdId ] } {
        } else {
            set msg [seq_msgRecvReply $cmdId errNr -all]
            if { $errNr == 0 } {
                set tmpLst [concat [split $msg ","]]
                set gvar(ccsMonTrendList2) [concat $gvar(ccsMonTrendList2) $tmpLst]
            }
        }
        if { [catch {seq_msgSendCommand $RTAPENV ccsMonitor MONMEGT ALL } cmdId ] } {
        } else {
            set msg [seq_msgRecvReply $cmdId errNr -all]
            if { $errNr == 0 } {
                set tmpLst [concat [split $msg ","]]
                set gvar(ccsMonTrendList2) [concat $gvar(ccsMonTrendList2) $tmpLst]
            }
        }
        set gvar(ccsMonTrendList) $gvar(ccsMonTrendList2)

        set cnt [llength $gvar(histPoints)]
        set gvar(histPointsStatus) ""
        for { set i 0 } { $i < $cnt} {incr i} {
            if { [catch {seq_msgSendCommand $RTAPENV hisDHMngr HTINFO [lindex $gvar(histPoints) $i]} cmdId ] } {
                lappend gvar(histPointStatus) 0
	    } else {
                set msg [seq_msgRecvReply $cmdId errNr -all]
                if { $errNr != 0 } {
                    lappend gvar(histPointStatus) 0
		} else {
                    set tmpList [concat [split $msg ","]]
                    lappend gvar(histPointsStatus) [lindex $tmpList 1]
		}
	    }
        }

        set nbr [llength $gvar(ccsMonTrendList)]
        for { set i 0 } { $i < $nbr} {incr i} {
            set point [$gvar(tblTrends).tbl cellcget $i,3 -text]
            for { set j 0} { $j < $cnt } {incr j} {
                if { $point == [lindex $gvar(histPoints) $j] } {
                    if { [lindex $gvar(histPointsStatus) $j] == 3 } {
                        $gvar(tblTrends).tbl cellconfigure $i,3 -fg green
                    } else {
                        $gvar(tblTrends).tbl cellconfigure $i,3 -fg red
                    }
                }
            }
        }

        set col [$gvar(tblTrends).tbl sortcolumn]
        set order [$gvar(tblTrends).tbl sortorder]
        if { $col != -1 } {
            $gvar(tblTrends).tbl sortbycolumn $col -$order
        }
    }
    if { $gvar(period) < 5000 } {
        set gvar(update) [after 5000 ccsMonStartTrends]
    } else { 
        set gvar(update) [after $gvar(period) ccsMonStartTrends]
    }
}

#-------------------------------------------------------------

proc ccsMonCreateTblRem { page } {
    global gvar

    set gvar(tblRem) $page

    set colConfig {0 "Remote Env" left 0 "ATTEMPTS" right 0 "FAILED CONNECTS" right 0 \
		       "RECV" right 0 "BYTES RECV"  right 0 "SENT" right 0  "BYTES SENT" right } 
    
    set wtbl [ccsMonCreatePage $page $colConfig gvar(ccsMonRemList) \
		  [list 1 2 3 4 5 6] [list 1 3 5] ]
}

proc ccsMonStartRem { } {
    global gvar menuTrending

    catch {after cancel $gvar(update)}

    $menuTrending entryconfigure 1 -state disabled

    if { $gvar(ccsMonUpdateOn) == 1 } {
        if { [catch {set gvar(ccsMonRemList) [concat [split [ccsMonGetRemStat ALL] ","]]} ] } {
            set gvar(ccsMonRemList) ""
        }
        set col [$gvar(tblRem).tbl sortcolumn]
        set order [$gvar(tblRem).tbl sortorder]
        if { $col != -1 } {
            $gvar(tblRem).tbl sortbycolumn $col -$order
        }
    }
    set gvar(update) [after $gvar(period) ccsMonStartRem]
}


#-------------------------------------------------------------

proc ccsMonCreateTblEvt { page } {
    global gvar

    set pw $page.pw
    #iwidgets::panedwindow $pw -orient vertical  -showhandle 1
    #foreach p {table text} {
    #      $pw add $p
    #      set cs($p) [$pw childsite $p]
    #}
    #$pw fraction 45 55

    panedwindow $pw -orient horizontal  -showhandle 1
    set table [frame $pw.table -background Grey80 -borderwidth 0 ]
    set text  [frame $pw.text  -background Grey80 -borderwidth 0 ]
    $pw add $table
    $pw add $text

    set cs(table) $pw.table
    set cs(text)  $pw.text

    set gvar(tblEvt) $cs(table)

    label $cs(text).txt -bg white

    set colConfig {0 "Process Name" left 0 "PNUM" right 0 "ATTACHMENTS" right 0 \
		       "NOTIFICATIONS" right } 

    set wlist [ ccsMonCreateTable $cs(table) $colConfig 120 10 all gvar(ccsMonEvtList)]

    lassign $wlist tblSys vsbSys hsbSys
 
    set gvar(evtGlobal1) "Active Events:\
                          \nNotifications sent in total:\
                          \nEvents reported by dbMQDBM:\
                          \nSize of internal Event Queue:\
                          \nUsage of Internal Event Queue:"

    frame $cs(text).txt.fr 
    message $cs(text).txt.fr.part1  -justify center -text  "Statistics" -font {courier 16 bold} \
                                    -width 15c
    frame $cs(text).txt.fr.fr -bg white
    message $cs(text).txt.fr.fr.part2 -justify left -textvariable gvar(evtGlobal1)\
            -font {courier 10 normal} -width 10c -bg white
    message $cs(text).txt.fr.fr.part3 -textvariable gvar(evtGlobal2)\
            -font {courier 10 normal} -width 10c -bg white

    pack $cs(text).txt.fr.fr.part2 -anchor n -side left -padx 5 -pady 5
    pack $cs(text).txt.fr.fr.part3 -anchor n -side right -padx 5 -pady 5
    pack $cs(text).txt.fr.part1 -padx 5 -pady 5
    pack $cs(text).txt.fr.fr -padx 5 -pady 5 -fill x -expand 1
    pack $cs(text).txt.fr -anchor n -padx 5 -pady 5 -fill x -expand 1

    pack $vsbSys -side right -fill y  -expand 1
    pack $hsbSys -side bottom -fill x  
    pack $tblSys -padx 5 -pady 5
    pack $cs(table).tbl $cs(text).txt -fill both -expand 1
    pack $pw -fill both -expand 1

    foreach col {1 2 3} {  
        $tblSys columnconfigure $col -sortmode integer
    }
    foreach col {1 3} {  
        $tblSys configure -showseparators yes
        $tblSys columnconfigure $col -background {#e0e8f0}
    }

    $tblSys columnconfigure 0 -resizable 0
}

proc ccsMonStartEvt { } {
    global gvar menuTrending

    catch {after cancel $gvar(update)}

    $menuTrending entryconfigure 1 -state disabled

    if { $gvar(ccsMonUpdateOn) == 1 } {
        set gvar(ccsMonEvt) [ccsMonGetEvtGlobal]
        set gvar(ccsMonEvtList) [concat [split [ccsMonGetEvtData -1] ","]] 
        set col [$gvar(tblEvt).tbl sortcolumn]
        set order [$gvar(tblEvt).tbl sortorder]
        if { $col != -1 } {
            $gvar(tblEvt).tbl sortbycolumn $col -$order
        }
        set gvar(evtGlobal2) [format "%11d\n%11d\n%11d\n%11d\n      %5.2f"        \
                          [lindex $gvar(ccsMonEvt) 0] [lindex $gvar(ccsMonEvt) 1] \
                          [lindex $gvar(ccsMonEvt) 2] [lindex $gvar(ccsMonEvt) 3] \
                          [lindex $gvar(ccsMonEvt) 4]]
    }
    set gvar(update) [after $gvar(period) ccsMonStartEvt]
}



#-------------------------------------------------------------

proc ccsMonCreateTblCe { page } {
    global gvar

    set pw $page.pw
    #iwidgets::panedwindow $pw -orient vertical -showhandle 1
    #foreach p {table text} {
    #      $pw add $p
    #      set cs($p) [$pw childsite $p]
    #}
    #$pw fraction 55 45

    panedwindow $pw -orient horizontal  -showhandle 1
    set table [frame $pw.table -background Grey80 -borderwidth 0 ]
    set text  [frame $pw.text  -background Grey80 -borderwidth 0 ]
    $pw add $table
    $pw add $text

    set cs(table) $pw.table
    set cs(text) $pw.text

    set gvar(tblCe) $cs(table)

    label $cs(text).txt -bg white

    set colConfig {0 "CE-FCT" 0 "CALLS" right}
    set wlist [ ccsMonCreateTable $cs(table) $colConfig 120 10 all gvar(ccsMonCeList)]
    lassign $wlist tblSys vsbSys hsbSys

    set gvar(tblCeVar1) [format "CE runs in total:\
                               \nCE functions defined:"]

    set gvar(ceDefs) ""

    frame $cs(text).txt.fr 
    message $cs(text).txt.fr.part1 -justify center -text  "CE-Statistics" -font {courier 16 bold} \
	-width 15c

    frame $cs(text).txt.fr.fr -bg white
    message $cs(text).txt.fr.fr.part2 -justify left -textvariable gvar(tblCeVar1)\
            -font {courier 10 normal} -width 10c -bg white
    message $cs(text).txt.fr.fr.part3 -textvariable gvar(tblCeVar2)\
            -font {courier 10 normal} -width 10c -bg white

    iwidgets::scrolledlistbox $cs(text).txt.slb \
	  -vscrollmode static -hscrollmode static -labeltext "CE Definitions" \
          -textbackground white -listvariable gvar(ceDefs) -labelfont {courier 16 bold} \
          -textfont {courier 10 normal}

    pack $cs(text).txt.fr.fr.part2 -anchor n -side left -padx 5 -pady 5
    pack $cs(text).txt.fr.fr.part3 -anchor n -side right -padx 5 -pady 5
    pack $cs(text).txt.fr.part1 -padx 5 -pady 5
    pack $cs(text).txt.fr.fr -padx 5 -pady 5 -fill x -expand 1
    pack $cs(text).txt.fr -anchor n -padx 5 -pady 5 -fill x -expand 1
    pack $cs(text).txt.slb -side top -padx 5 -pady 5 -expand 1 -fill both

    pack $vsbSys -side right -fill y -expand 1
    pack $hsbSys -side bottom -fill x
    pack $tblSys -padx 5 -pady 5 -expand 1
    pack $cs(table).tbl $cs(text).txt -fill both -expand 1
    pack $pw -fill both -expand 1

    $tblSys columnconfigure 1 -sortmode integer
    $tblSys configure -showseparators yes
    $tblSys columnconfigure 1 -background {#e0e8f0}
    $tblSys columnconfigure 0 -resizable 0
}

proc ccsMonStartCe { } {
    global gvar menuTrending

    catch {after cancel $gvar(update)}

    $menuTrending entryconfigure 1 -state disabled

    if { $gvar(ccsMonUpdateOn) == 1 } {
        set tmpList [concat [split [ccsMonGetCeInfo] ","]]
        set ceNum   [lindex $tmpList 0]
        if { $ceNum == "" } {
            set ceNum 0
        } 

        set tmpList2 "" 
        set cnt [llength $tmpList]
        for { set i 0 } { $i < $cnt} {incr i} {
            if { [lindex [lindex $tmpList $i] 0] != "UNUSED" } {
                lappend tmpList2 [lindex $tmpList $i]
            }
        }
        set tmpList $tmpList2
        set gvar(ccsMonCeList) [lrange $tmpList 1 end]
        set col [$gvar(tblCe).tbl sortcolumn]
        set order [$gvar(tblCe).tbl sortorder]
        if { $col != -1 } {
             $gvar(tblCe).tbl sortbycolumn $col -$order
        }

        set tmpList1 ""
        set cnt 0
        if {[catch {set fd [open $gvar(ceFile) r]}]} {
            set tmpList1 "UNKNOWN"
        } else {
            set nc [gets $fd line]
            while {$nc > 0} {
                incr cnt
                set nc [gets $fd line]
                lappend tmpList1 $line
	    }
            close $fd
        }

        set gvar(tblCeVar2) [format "%11d\n%11d" $ceNum $cnt]
        set gvar(ceDefs) $tmpList1
    }
    set gvar(update) [after $gvar(period) ccsMonStartCe]
}



#
# ___oOo___
