#*******************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: ccsMonProcs.tcl,v 0.31 2005/10/14 10:40:02 vltsccm Exp $"
#
# who       when        what
# --------  ----------  ----------------------------------------------
# mcomin  2005-08-10  created
#

#************************************************************************
#   NAME
# 
#   SYNOPSIS
# 
#   DESCRIPTION
#
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#
#   SEE ALSO
#
#   BUGS     
#
#------------------------------------------------------------------------
#



proc ccsMonMessage { name type message } {
   global gvar

   set c .$name
   set flag -1
   set gvar(ccsMonMessage) 0

   toplevel $c

   frame $c.middle         -relief raised -border 1
   frame $c.bot            -relief raised -border 1
   frame $c.middle.center  -relief groove -border 1

   button  $c.bot.ok       -text "Ok" -width 10 -command \
                           "set flag 1; set gvar(ccsMonMessage) 1; destroy $c"

   if { $type == "QUESTION" } {
       button  $c.bot.cancel -text "Cancel" -width 10 -command \
                             "set flag 1; destroy $c"
   } elseif { $type == "ASK" } {
       button  $c.bot.fix -text "Fix" -width 10 -command \
                          "set flag 1; set gvar(ccsMonMessage) 2; destroy $c"
   }

   message $c.middle.center.msg  -justify left -text "$message" \
           -font "-Adobe-courier-bold-r-normal--14*" -width 15c

   if { $type == "ERROR" } {
       label $c.middle.left -bitmap warning
   } elseif { $type == "QUESTION" } {
       label $c.middle.left -bitmap questhead
   } elseif { $type == "ASK" } {
       label $c.middle.left -bitmap question
   } else {
       label $c.middle.left -bitmap info
   }

   $c.middle.left config  -foreground red -borderwidth 5 -height 40 -width 30

   pack $c.middle  $c.bot -fill x

   if { $type == "QUESTION" } {
       pack $c.bot.ok $c.bot.cancel -side left -pady 15 -expand 1
   } elseif { $type == "ASK" } {
       pack $c.bot.ok $c.bot.fix -side left -pady 15 -expand 1
   } else {
       pack $c.bot  $c.bot.ok -side left -pady 15 -expand 1
   }

   pack $c.middle  $c.middle.center           -side right -padx 10 -fill both
   pack $c.middle.left                        -side left  -expand 1 -fill y -padx 1 -pady 1
   pack $c.middle.center $c.middle.center.msg -side right -expand 1 -padx 10 -pady 10 -fill y

   wm geometry $c +400+400
   wm title $c "CCS Monitor System Info"

   tkwait visibility $c
   grab $c
   vwait flag;      # Stops until variable as been modified
   }


proc ccsMonAsk { selection sys process} {
    global gvar

    set c .ccsMonAsk
    set flag -1
    set gvar(ccsMonAsk) NONE

    toplevel $c

    frame $c.top            -relief raised -border 1
    frame $c.middle         -relief raised -border 1
    frame $c.bot            -relief raised -border 1
    frame $c.middle.center  -relief groove -border 1

    iwidgets::spinner $c.middle.center.sm -labeltext "Enter Level : " \
                 -width 8 -fixed 3  -validate blockInput            \
                 -decrement {ccsMonSpinLevel -1} -increment {ccsMonSpinLevel 1}

    $c.middle.center.sm insert 0 $selection

    set gvar(spin) $c.middle.center.sm

    set msg [format "  New Logging Level\n %s-System / %s " $sys $process]
    message $c.top.msg  -justify left -text $msg \
           -font {courier 12 bold italic} -width 15c

    button  $c.bot.ok       -text "Ok" -width 10 -command \
	"set flag 1; ccsMonSL $gvar(spin); destroy $c"

    button  $c.bot.cancel -text "Cancel" -width 10 -command \
                            "set flag 1; destroy $c"


    label $c.middle.left -bitmap question

    $c.middle.left config  -foreground red -borderwidth 5 -height 40 -width 30

    pack $c.top $c.middle $c.bot -fill x

    pack $c.top.msg -side right -expand 1 -padx 10 -pady 10 -fill y

    pack $c.bot.ok $c.bot.cancel -side left -pady 15 -expand 1

    pack $c.middle.center -side right -padx 10  -fill both
    pack $c.middle.left   -side left  -expand 1 -fill y  -padx 1 -pady 1
    pack $c.middle.center $c.middle.center.sm -side right -expand 1 -padx 10 -pady 20

    wm geometry $c +500+400
    wm title $c "CCS Monitor Change Level"

    tkwait visibility $c
    grab $c
    vwait flag;      # Stops until variable as been modified
    return $gvar(ccsMonAsk)
}


proc ccsMonAbout { } {
    global gvar seq_ccsEnvName RCS RTAPENV env

    if {[catch {set user $env(USER)}]} {set user dummy}
    regexp {Id: (.*) Exp} $RCS -> version

    set output "\n    About CCS Monitor System DISPLAY\n\
                \n$version\n\
                \n           started by $user\n\
                \n    at $gvar(startTime)\n\
                \n         in environment $RTAPENV"

    ccsMonMessage message INFO $output
}


proc ccsMonDelay { } {
    global gvar

    focus [.pd component prompt component entry]
    .pd center

    if {[.pd activate]} {
        set newVal [.pd get]
        if { [catch {expr {$newVal} }] } {
	    # Value is not a number
            ccsMonMessage message ERROR "Invalid Value (0 < value < 60)"
        } elseif { $newVal < 1 || $newVal > 60 } {
            ccsMonMessage message ERROR "Value out of range (0 < value < 60)"
        } else {
            set gvar(period) [expr {$newVal * 1000}]
        }
    }   
}


proc ccsMonCreateTable { top colConfig tblWidth tblHeight sflag listVarName } {

    set fcolor "\#e0e8f0"
    set vsb   $top.vsb
    set hsb   $top.hsb
    set wtbl  $top.tbl
    scrollbar $vsb -orient vertical   -command [list $wtbl yview]
    scrollbar $hsb -orient horizontal -command [list $wtbl xview]

    tablelist::tablelist $wtbl -activestyle frame -columns $colConfig              \
        -labelcommand tablelist::sortByColumn -background grey96                   \
        -selectbackground navy -stripebg $fcolor -yscrollcommand [list $vsb set] \
        -xscrollcommand [list $hsb set] -selectforeground white -height $tblHeight \
        -selectforeground white  -width $tblWidth -setgrid yes \
        -listvariable $listVarName  -fg black

    if {![cequal $sflag "" ]} {
	$wtbl configure -stretch $sflag
    }

    grid $wtbl -row 0 -column 0 -sticky news -padx 5 -pady 5
    grid $vsb  -row 0 -column 1 -sticky ns -padx 5 -pady 5
    grid $hsb  -row 1 -column 0 -sticky ew -padx 5 -pady 5
    grid rowconfigure    $top 0 -weight 1
    grid columnconfigure $top 0 -weight 1

    return [list $wtbl $vsb $hsb]
}


proc ccsMonCreatePage { page colConfig listVarName listCol1 listCol2 } {
    global gvar

    set wlist [ ccsMonCreateTable $page $colConfig 120 10 all $listVarName]

    lassign $wlist wtbl vsb hsb

    foreach col $listCol1 {
        $wtbl columnconfigure $col -sortmode integer
    }

    foreach col $listCol2 {  
        $wtbl configure -showseparators yes
        $wtbl columnconfigure $col -background {#e0e8f0}
    }
	
    $wtbl columnconfigure 0 -resizable 0

    return $wtbl
}


proc ccsMonInitMenu { topMenu } {
    global gvar VLTSWR menuTrending

    set menuBar [ makeMenuFrame $topMenu ]

    #  File Menu
    
    set m [addMenu $menuBar  File  0];
    $m add command -label "Quit" -underline 0 -accel Ctrl-q -command exit

    #  Config Menu
    
    set m [addMenu $menuBar  Config  0];

    $m add command -label "Register"    -und 0 -accel Ctrl-r -command ccsMonDoRegister
    $m add separator
    $m add command -label "Update Rate" -und 0 -accel Ctrl-u -command ccsMonDelay
    $m add separator
    $m add check -label "Update On/Off" -und 7 -accel Ctrl-o -variable gvar(ccsMonUpdateOn)
    $m add separator
    $m add command -label "FTP Access" -und 0 -accel Ctrl-f -command ccsMonFtpPar


    #  Monitoring Menu
    set m [addMenu $menuBar  Monitoring  0];

    $m add check -label "Enable/Disable System" -underline 15 -accel Ctrl-s \
	-variable gvar(ccsMonSysIsOn) -command ccsMonEnaDisSystem
    $m add separator
    $m add check -label "CCS On/Off" -underline 0 -accel Ctrl-c \
	-variable gvar(ccsOn) -command {ccsMonSubSysEnaDis ccs $gvar(ccsOn)}
    $m add check -label "DB On/Off" -underline 0 -accel Ctrl-d \
	-variable gvar(dbOn) -command {ccsMonSubSysEnaDis db $gvar(dbOn)}
    $m add check -label "EVT On/Off" -underline 0 -accel Ctrl-e \
	-variable gvar(evtOn) -command {ccsMonSubSysEnaDis evt $gvar(evtOn)}
    $m add check -label "MSG On/Off" -underline 0 -accel Ctrl-m \
	-variable gvar(msgOn) -command {ccsMonSubSysEnaDis msg $gvar(msgOn)}
    $m add separator
    $m add check -label "DB  - Detailed" -variable gvar(dbOnDet) \
	-command {ccsMonSetLevDet db $gvar(dbOnDet)}
    $m add check -label "EVT - Detailed" -variable gvar(evtOnDet) \
	-command {ccsMonSetLevDet evt $gvar(evtOnDet)}
    $m add check -label "MSG - Detailed" -variable gvar(msgOnDet) \
	-command {ccsMonSetLevDet msg $gvar(msgOnDet)}    

    #  Trending Menu
    set m [addMenu $menuBar  Trending  0];

    # Name of this menu is exported to allow dynamic configuration
    set menuTrending $m

    $m add command -label "Enable/Disable History" -underline 15 -accel Ctrl-e \
	-command ccsMonEnaDisHistory -state disabled
    $m add separator
    $m add command -label "CPU Load - Start" -underline 0 -accel Ctrl-c \
	-command {ccsMonStartTrendCpu  MONLDST}
    $m add command -label "Memory Usage - Start" -underline 0 -accel Ctrl-m \
	-command {ccsMonStartTrendCpu MONMEST}
    $m add command -label "Ping Delay - Start" -underline 0 -accel Ctrl-p \
	-command {ccsMonStartPing}
    $m add separator
    $m add command -label "Stop Trend Job" -underline 0 -accel Ctrl-s \
	-command ccsMonStopTrendJob
    $m add separator
    $m add command -label "Start hisConfigTool" -underline 6 -accel Ctrl-h \
	-command ccsMonStartHistoryTool
    $m add separator
    $m add command -label "Plot Trend(s)" -underline 6 -accel Ctrl-t \
	-command ccsMonConfigTrend

    #  Alarms Menu
    set m [addMenu $menuBar  Alarms  0];

    $m add check -label "Event Queue" -underline 0 -accel Ctrl-e \
	-variable gvar(ccsMonAlarmEvtOn) -command ccsMonEnableEvtAlarm
    $m add check -label "Msg Queues" -underline 0 -accel Ctrl-m \
	-variable gvar(ccsMonAlarmMsgOn) -command ccsMonEnableMsgAlarm
    $m add separator
    $m add command -label "Change Limits Evt" -underline 0 -accel Ctrl-c \
	-command ccsMonChangeEvtLimits
    $m add command -label "Change Limits Msg" -underline 1 -accel Ctrl-h \
	-command ccsMonChangeMsgLimits
    $m add separator
    $m add command -label "Configure Alarm" -underline 1 -accel Ctrl-o \
	-command ccsMonConfigAlarm
    $m add command -label "Remove Alarm" -underline 0 -accel Ctrl-r \
	               -command ccsMonRemoveAlarm

    #  Selection Menu
    set m [addMenu $menuBar  Selection  0];
    
    $m add command -label "System Information"              -command {$gvar(tab) select  0}
    $m add command -label "System Load"                     -command {$gvar(tab) select  1}
    $m add command -label "CCS Configuration"               -command {$gvar(tab) select  2}
    $m add command -label "Message Queue Status"            -command {$gvar(tab) select  3}
    $m add command -label "Message System Statistics"       -command {$gvar(tab) select  4}
    $m add command -label "DB Query Statistics"             -command {$gvar(tab) select  5}
    $m add command -label "DB Read/Write Statistics"        -command {$gvar(tab) select  6}
    $m add command -label "Remote Communication Statistics" -command {$gvar(tab) select  7}
    $m add command -label "CE Statistics/Configuration"     -command {$gvar(tab) select  8}
    $m add command -label "Event System Statistics"         -command {$gvar(tab) select  9}
    $m add command -label "Monitoring System Configuration" -command {$gvar(tab) select 10}
    $m add command -label "Trending Configuration"          -command {$gvar(tab) select 11}
    $m add command -label "Alarm Configuration"             -command {$gvar(tab) select 12}
    $m add command -label "Internal Queues Statistics"      -command {$gvar(tab) select 13}
    $m add command -label "IPC Configuration"               -command {$gvar(tab) select 14}
    $m add command -label "Realtime Priorities"             -command {$gvar(tab) select 15}
    
    #  Installation Menu
    set m [addMenu $menuBar  Installation  0];
    
    $m add command -label "VLTSW Release ($VLTSWR)" -underline 0 -accel Ctrl-v \
	-command ccsMonCheckCoreVltsw
    $m add command -label "Against Reference File" -underline 0 -accel Ctrl-v \
	-command ccsMonCheckRefFile
    $m add separator
    $m add command -label "Patch Level ($VLTSWR)" -underline 0 -accel Ctrl-v \
	-command ccsMonCheckPatches
    $m add separator
    $m add command -label "Create Reference File" -underline 1 -accel Ctrl-c \
	-command {exec ccsMonVersion &}
    
    #  Help Menu
    set m [addMenu $menuBar  Help 0 right];
    $m add command -label "Man Page" -und 0 -accel Ctrl-M -command {exec tkman ccsMonGui&}
    $m add command -label "About"    -und 0 -accel Ctrl-A -command ccsMonAbout

    set gvar(pd) "NONE"
}

proc ccsMonSetFtpPar { } {
    global gvar

    set gvar(ftpDest) $gvar(ftpDestNew)
    set gvar(userCmd) $gvar(userCmdNew)
    return
}


proc ccsMonFtpPar { } {
    global gvar

    set c .ccsMonFtpVar

    toplevel $c

    frame $c.middle -relief raised -border 1
    frame $c.bot    -relief raised -border 1

    set gvar(ftpDestNew) $gvar(ftpDest)
    set gvar(userCmdNew) $gvar(userCmd)

    iwidgets::entryfield $c.middle.e1 -labeltext "FTP-Server:" \
	-textvariable gvar(ftpDestNew) -width 35
    iwidgets::entryfield $c.middle.e2 -labeltext "User and Password:" \
	-textvariable gvar(userCmdNew) -width 30

    pack $c.middle.e1 $c.middle.e2  -padx 10 -pady 10 -fill x

    button  $c.bot.ok  -text "Ok" -width 10 -command \
	"set flag 1; ccsMonSetFtpPar; destroy $c"

    button  $c.bot.cancel -text "Cancel" -width 10 -command "set flag 1; destroy $c"

    pack $c.middle $c.bot        -fill x
    pack $c.bot.ok $c.bot.cancel -side left -pady 15 -expand 1 

    wm geometry $c +400+400
    wm title $c "CCS Monitor System"

    grab $c
    vwait flag;      # Stops until variable as been modified
}


proc ccsMonSL { spin } {
    global gvar

    set gvar(ccsMonAsk) [$spin get]
}


proc ccsMonSpinLevel { direction } {
    global gvar

    set index [expr {[lsearch $gvar(states) [$gvar(spin) get]] + $direction}]

    if {$index < 0} {set index 1}
    if {$index > 1} {set index 0}

    $gvar(spin) delete 0 end
    $gvar(spin) insert 0 [lindex $gvar(states) $index]
    return
}


proc ccsMonSetLevDet { sys var } {
    global gvar

    if { $var == 0 } {
        set level L1
    } else {
        set level L2
    }
    ccsMonSetLev $sys 0 $level
}


proc ccsMonSubSysEnaDis { sysName  val} {
    global gvar RTAPENV

    if { $val == 0 } {
        set command MONDISA 
    } else {
        set command MONENAB 
    }
    set cmdId [seq_msgSendCommand $RTAPENV ccsMonitor $command $sysName]
    set msg [seq_msgRecvReply $cmdId errNr -all]
    if { $errNr != 0 } {
        ccsMonMessage message ERROR $msg
    }
}


proc ccsMonEnaDisSystem { } {
    global seq_ccsEnvName gvar RTAPENV

    if { [ccsMonGetGlobalStatus] == 0 } {
        if {[catch {exec ccsRunCmd -u ccsMonitor} msg]} {
            ccsMonMessage message ERROR $msg
        }
    } else {
        set cmdId [seq_msgSendCommand $RTAPENV ccsMonitor MONEXIT ""]
        set msg [seq_msgRecvReply $cmdId errNr -all]
        if { $errNr != 0 } {
            ccsMonMessage message ERROR $msg
	}
    }
}

proc ccsMonUpdateTime {} {
    global gvar RTAPENV

    $gvar(top).fr.tf show now
    after 2000 ccsMonUpdateTime

    set gvar(ccsMonSysEnabled)  [ccsMonGetGlobalStatus]
    if { $gvar(ccsMonSysEnabled) != $gvar(ccsMonSysEnabledOld) } {
        if { $gvar(ccsMonSysEnabled) == 0 } {
            wm title $gvar(top) "CCS Monitor System GUI - Monitoring Disabled"
        } else {
            wm title $gvar(top) "CCS Monitor System GUI - Monitoring Enabled"
        }
        set gvar(ccsMonSysEnabledOld) $gvar(ccsMonSysEnabled)

        if { [catch {seq_msgSendCommand $RTAPENV ccsMonitor MONEVTA "" } cmdId ] } {
            set gvar(ccsMonAlarmEvtOn) 0
        } else { 
            set msg [seq_msgRecvReply $cmdId errNr -all -4000]
            if { $errNr != 0 } {
                set gvar(ccsMonAlarmEvtOn) 0
            } else {
                if { $msg == "ON" } {    
                    set gvar(ccsMonAlarmEvtOn) 1
	        } else {
                    set gvar(ccsMonAlarmEvtOn) 0
	        }
	    }
        }
        if { [catch {seq_msgSendCommand $RTAPENV ccsMonitor MONGMAS "" } cmdId ] } {
            set gvar(ccsMonAlarmMsgOn) 0
        } else { 
            set msg [seq_msgRecvReply $cmdId errNr -all -4000]
            if { $errNr != 0 } {
                set gvar(ccsMonAlarmMsgOn) 0
            } else {
                if { $msg == "ON" } {    
                    set gvar(ccsMonAlarmMsgOn) 1
	        } else {
                    set gvar(ccsMonAlarmMsgOn) 0
	        }
	    }
        }
    }
    set gvar(ccsMonSysIsOn)       $gvar(ccsMonSysEnabled)

    if { [catch {set gvar(ccsMonSubSysOn) [concat [split [ccsMonGetSubSysStatus ALL] " "]] } inf ]} {
        set gvar(ccsMonSubSysOn) [concat 0 0 0 0]
    }
    set gvar(ccsOn)  [lindex $gvar(ccsMonSubSysOn) 0]
    set gvar(dbOn)   [lindex $gvar(ccsMonSubSysOn) 1]
    set gvar(evtOn)  [lindex $gvar(ccsMonSubSysOn) 2]
    set gvar(msgOn)  [lindex $gvar(ccsMonSubSysOn) 3]
}


proc ccsMonUpdateDate {} {
    global gvar

    $gvar(top).fr.df show now
    after 10000 ccsMonUpdateDate
}


proc ccsMonDoRegister { } {
    global gvar seq_ccsEnvName RTAPENV

    if { [catch {seq_ccsInit ccsMonGui} inf ]} {
        ccsMonMessage message ERROR $inf
        return
    }

    set gvar(title)  [format "CCS Environment %s (ACTIVE)"  $RTAPENV]
    $gvar(titleWidget) configure -foreground green

    if { [catch {ccsMonTool INIT ccsMonGui} inf ]} {
        ccsMonMessage message ERROR $inf
        return 
    }

    seq_ccsAsyncInput open
    return
}



#
# ___oOo___
