#*******************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: ccsMonTrending.tcl,v 0.31 2005/10/14 10:40:02 vltsccm Exp $"
#
# who       when        what
# --------  ----------  ----------------------------------------------
# mcomin  2005-08-10  created
#

#************************************************************************
#   NAME
# 
#   SYNOPSIS
# 
#   DESCRIPTION
#
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#
#   SEE ALSO
#
#   BUGS     
#
#------------------------------------------------------------------------
#

proc ccsMonEnaDisHistory { } {
    global gvar

    set flag -1

    set gvar(histPointSel)    [lindex $gvar(histPoints) 0]
    set gvar(histPointAction) "Start"
    set gvar(histPointDelay)  "5"

    set c .hist
    toplevel $c

    frame $c.middle   -relief raised -border 1
    frame $c.bot      -relief raised -border 1

    iwidgets::combobox $c.middle.cb1 -labeltext "History Point:" -editable false -dropdown false \
	                             -arrowrelief ridge -popupcursor hand2 \
	                             -textvariable gvar(histPointSel) 
    iwidgets::combobox $c.middle.cb2 -labeltext "Operation:" -arrowrelief ridge -completion false\
                              -popupcursor hand2 -textvariable gvar(histPointAction)
    iwidgets::combobox $c.middle.cb3 -labeltext "Poll Period (secs):" -editable false \
                         -arrowrelief ridge -popupcursor hand1 -textvariable gvar(histPointDelay)
    $c.middle.cb1 configure -listheight 80
    $c.middle.cb2 configure -listheight 80
    $c.middle.cb3 configure -listheight 80

    pack $c.middle.cb1 $c.middle.cb2 $c.middle.cb3 -padx 10 -pady 10 -fill x
    iwidgets::Labeledwidget::alignlabels $c.middle.cb1 $c.middle.cb2 $c.middle.cb3

    button  $c.bot.ok  -text "Ok" -width 10 -command \
                       "set flag 1; ccsMonManageHistory; destroy $c"

    button  $c.bot.cancel -text "Cancel" -width 10 -command "set flag 1; destroy $c"
    pack $c.middle  $c.bot -fill x
    pack $c.bot.ok $c.bot.cancel -side left -pady 15 -expand 1

    eval $c.middle.cb1 insert list end $gvar(histPoints)
    eval $c.middle.cb2 insert list end {Start} {Stop&ClearTable&Start} {Restart} {Stop}
    eval $c.middle.cb3 insert list end 5 10 15 30 60 120 300

    wm geometry $c +400+400
    wm title $c "CCS Monitor System"

    grab $c
    vwait flag;      # Stops until variable as been modified
}

#-------------------------------------------------------------

proc ccsMonManageHistory { } {
    global gvar RTAPENV

    if { $gvar(histPointSel) == "" } return

    if { $gvar(histPointAction) == "Stop" } {
        if { [catch {seq_msgSendCommand $RTAPENV hisDHMngr HTCTRL $gvar(histPointSel),disarm} cmdId ] } {
            ccsMonMessage message ERROR $cmdId
        } else {
            set msg [seq_msgRecvReply $cmdId errNr -all]
            if { $errNr != 0 } {
                ccsMonMessage message ERROR $msg
            }
	}
    }

    if { $gvar(histPointAction) == "Start" } {
        set para "$gvar(histPointSel),0,TRUE,armed,2000-00-00 00:00:00,1,,$gvar(histPointDelay),seconds,disarmed,0,days,,,0,TRUE"
        if { [catch {seq_msgSendCommand $RTAPENV hisDHMngr CFGSTUP $para} cmdId ] } {
            ccsMonMessage message ERROR $cmdId
        } else {
            set msg [seq_msgRecvReply $cmdId errNr -all]
            if { $errNr != 0 } {
                ccsMonMessage message ERROR $msg
                return
            }
	}
        set para "$gvar(histPointSel),30,seconds,2,7"
        if { [catch {seq_msgSendCommand $RTAPENV hisDHMngr CFGSTAT $para} cmdId ] } {
            ccsMonMessage message ERROR $cmdId
        } else {
            set msg [seq_msgRecvReply $cmdId errNr -all]
            if { $errNr != 0 } {
                ccsMonMessage message ERROR $msg
                return
            }
	}
        set para "$gvar(histPointSel),enable"
        if { [catch {seq_msgSendCommand $RTAPENV hisDHMngr DATWRAP $para} cmdId ] } {
            ccsMonMessage message ERROR $cmdId
        } else {
            set msg [seq_msgRecvReply $cmdId errNr -all]
            if { $errNr != 0 } {
                ccsMonMessage message ERROR $msg
                return
            }
	}
        set para "$gvar(histPointSel),arm"
        if { [catch {seq_msgSendCommand $RTAPENV hisDHMngr HTCTRL $para} cmdId ] } {
            ccsMonMessage message ERROR $cmdId
        } else {
            set msg [seq_msgRecvReply $cmdId errNr -all]
            if { $errNr != 0 } {
                ccsMonMessage message ERROR $msg
                return
            }
	}
    }

    if { $gvar(histPointAction) == "Restart" } {
        if { [catch {seq_msgSendCommand $RTAPENV hisDHMngr HTCTRL $gvar(histPointSel),disarm} cmdId ] } {
            ccsMonMessage message ERROR $cmdId
        } else {
            set msg [seq_msgRecvReply $cmdId errNr -all]
            if { $errNr != 0 } {
                ccsMonMessage message ERROR $msg
                return
            }
	}
        set para "$gvar(histPointSel),0,TRUE,armed,2000-00-00 00:00:00,1,,$gvar(histPointDelay),seconds,disarmed,0,days,,,0,TRUE"
        if { [catch {seq_msgSendCommand $RTAPENV hisDHMngr CFGSTUP $para} cmdId ] } {
            ccsMonMessage message ERROR $cmdId
        } else {
            set msg [seq_msgRecvReply $cmdId errNr -all]
            if { $errNr != 0 } {
                ccsMonMessage message ERROR $msg
                return
            }
	}
        set para "$gvar(histPointSel),enable"
        if { [catch {seq_msgSendCommand $RTAPENV hisDHMngr DATWRAP $para} cmdId ] } {
            ccsMonMessage message ERROR $cmdId
        } else {
            set msg [seq_msgRecvReply $cmdId errNr -all]
            if { $errNr != 0 } {
                ccsMonMessage message ERROR $msg
                return
            }
	}
        set para "$gvar(histPointSel),arm"
        if { [catch {seq_msgSendCommand $RTAPENV hisDHMngr HTCTRL $para} cmdId ] } {
            ccsMonMessage message ERROR $cmdId
        } else {
            set msg [seq_msgRecvReply $cmdId errNr -all]
            if { $errNr != 0 } {
                ccsMonMessage message ERROR $msg
                return
            }
	}
    }

    if { $gvar(histPointAction) == "Stop&ClearTable&Start" } {
        if { [catch {seq_msgSendCommand $RTAPENV hisDHMngr HTCTRL $gvar(histPointSel),disarm} cmdId ] } {
            ccsMonMessage message ERROR $cmdId
        } else {
            set msg [seq_msgRecvReply $cmdId errNr -all]
            if { $errNr != 0 } {
                ccsMonMessage message ERROR $msg
                return
            }
	}
        if { [catch {seq_msgSendCommand $RTAPENV hisDHMngr HTCLEAR $gvar(histPointSel)} cmdId ] } {
            ccsMonMessage message ERROR $cmdId
        } else {
            set msg [seq_msgRecvReply $cmdId errNr -all]
            if { $errNr != 0 } {
                ccsMonMessage message ERROR $msg
                return
            }
	}
        set para "$gvar(histPointSel),0,TRUE,armed,2000-00-00 00:00:00,1,,$gvar(histPointDelay),seconds,disarmed,0,days,,,0,TRUE"
        if { [catch {seq_msgSendCommand $RTAPENV hisDHMngr CFGSTUP $para} cmdId ] } {
            ccsMonMessage message ERROR $cmdId
        } else {
            set msg [seq_msgRecvReply $cmdId errNr -all]
            if { $errNr != 0 } {
                ccsMonMessage message ERROR $msg
                return
            }
	}
        set para "$gvar(histPointSel),enable"
        if { [catch {seq_msgSendCommand $RTAPENV hisDHMngr DATWRAP $para} cmdId ] } {
            ccsMonMessage message ERROR $cmdId
        } else {
            set msg [seq_msgRecvReply $cmdId errNr -all]
            if { $errNr != 0 } {
                ccsMonMessage message ERROR $msg
                return
            }
	}
        set para "$gvar(histPointSel),arm"
        if { [catch {seq_msgSendCommand $RTAPENV hisDHMngr HTCTRL $para} cmdId ] } {
            ccsMonMessage message ERROR $cmdId
        } else {
            set msg [seq_msgRecvReply $cmdId errNr -all]
            if { $errNr != 0 } {
                ccsMonMessage message ERROR $msg
                return
            }
	}
    }
}

#----------------------------------------------------------------------------

proc ccsMonStartTrendCpu { command } {
    global gvar RTAPENV

    set flag -1
    set tmpList [concat [split [ccsMonGetProcs] ","]]

    set gvar(trendCpuProc)    [lindex [lindex $tmpList 0] 0]
    set gvar(trendCpuPeriod)  "10"

    set c .trendCpu
    toplevel $c

    frame $c.middle   -relief raised -border 1
    frame $c.bot      -relief raised -border 1

    iwidgets::combobox $c.middle.cb1 -labeltext "Process:" -editable false -dropdown false \
	                             -arrowrelief ridge -popupcursor hand2 \
	                             -textvariable gvar(trendCpuProc) 
    iwidgets::combobox $c.middle.cb2 -labeltext "Period:" -arrowrelief ridge -completion false\
                              -popupcursor hand2 -textvariable gvar(trendCpuPeriod)

    $c.middle.cb1 configure -listheight 80
    $c.middle.cb2 configure -listheight 80

    pack $c.middle.cb1 $c.middle.cb2 -padx 10 -pady 10 -fill x
    iwidgets::Labeledwidget::alignlabels $c.middle.cb1 $c.middle.cb2 

    button  $c.bot.ok  -text "Ok" -width 10 -command \
	"set flag 1; ccsMonManageTrendCpu $command {$tmpList}; destroy $c"

    button  $c.bot.cancel -text "Cancel" -width 10 -command "set flag 1; destroy $c"
    pack $c.middle  $c.bot -fill x
    pack $c.bot.ok $c.bot.cancel -side left -pady 15 -expand 1

    set cnt [llength $tmpList]
    eval $c.middle.cb1 insert list end "Total"
    for {set i 0} {$i<$cnt} {incr i} {
        eval $c.middle.cb1 insert list end [lindex [lindex $tmpList $i] 0] 
    }
    eval $c.middle.cb2 insert list end 5 10 15 20 30 60 120 240 300

    wm geometry $c +400+400
    wm title $c "CCS Monitor System"

    grab $c
    vwait flag;      # Stops until variable as been modified
}


proc ccsMonManageTrendCpu { command procLst } {
    global gvar RTAPENV

    set procNum -1
    if { "$gvar(trendCpuProc)" == "Total" } {
        set procNum 0
    } else { 
        set cnt [llength $procLst]
        for {set i 0} {$i<$cnt} {incr i} {
            if { [lindex [lindex $procLst $i] 0]  == $gvar(trendCpuProc) } {
                set procNum [lindex [lindex $procLst $i] 1]
            }
        }
    }

    set para [format "%s,%s" $procNum $gvar(trendCpuPeriod)]
    if { [catch {seq_msgSendCommand $RTAPENV ccsMonitor $command $para} cmdId ] } {
        ccsMonMessage message ERROR $cmdId
    } else {
        set msg [seq_msgRecvReply $cmdId errNr -all] 
        if { $errNr != 0 } {
            ccsMonMessage message ERROR $msg
        }
    }
}

#----------------------------------------------------------------------------

proc ccsMonStartPing { } {
    global gvar RTAPENV

    set c .trendPing
    toplevel $c

    frame $c.middle   -relief raised -border 1
    frame $c.bot      -relief raised -border 1

    set gvar(hisPointPingEnv)   $RTAPENV
    set gvar(hisPointPingProc)  qsemu
    set gvar(hisPingDelay)      10

    iwidgets::entryfield $c.middle.e1  -validate alphanumeric -labeltext "Environment Name:" \
                    -invalid {ccsMonMessage message ERROR "Use only Letters and Numbers"}    \
                    -textvariable gvar(hisPointPingEnv)
    iwidgets::entryfield $c.middle.e2  -validate alphanumeric -labeltext "      Process Name:" \
                    -invalid {ccsMonMessage message ERROR "Use only Letters and Numbers"}    \
                    -textvariable gvar(hisPointPingProc)
    iwidgets::combobox   $c.middle.cb3 -labeltext " Poll Period (secs):" -editable false      \
                    -arrowrelief ridge -popupcursor hand1 -textvariable gvar(hisPingDelay)

    $c.middle.cb3 configure -listheight 80

    pack $c.middle.e1 $c.middle.e2 $c.middle.cb3 -padx 10 -pady 10 -fill x
    iwidgets::Labeledwidget::alignlabels $c.middle.cb3

    button  $c.bot.ok  -text "Ok" -width 10 -command \
	"set flag 1; ccsMonManageTrendPing; destroy $c"

    button  $c.bot.cancel -text "Cancel" -width 10 -command "set flag 1; destroy $c"
    pack $c.middle $c.bot -fill x
    pack $c.bot.ok $c.bot.cancel -side left -pady 15 -expand 1

    eval $c.middle.cb3 insert list end 5 10 15 20 30 60 120 240 300

    wm geometry $c +400+400
    wm title $c "CCS Monitor System"

    grab $c
    vwait flag;      # Stops until variable as been modified
}

#----------------------------------------------------------------------------

proc ccsMonManageTrendPing { } {
    global gvar RTAPENV

    if {[catch {set result [ccsMonGetProcnum $gvar(hisPointPingEnv) $gvar(hisPointPingProc)]} msg]} {
        ccsMonMessage message ERROR $msg
    }

    set para [format "%s,%s,%s" $gvar(hisPointPingEnv) $gvar(hisPointPingProc) $gvar(hisPingDelay)]
    if { [catch {seq_msgSendCommand $RTAPENV ccsMonitor MONPIST $para} cmdId ] } {
        ccsMonMessage message ERROR $cmdId
    } else {
        set msg [seq_msgRecvReply $cmdId errNr -all] 
        if { $errNr != 0 } {
            ccsMonMessage message ERROR $msg
        }
    }
    return
}


proc ccsMonStopTrendJob { } {
    global gvar RTAPENV

    set flag -1

    if { [catch {seq_msgSendCommand $RTAPENV ccsMonitor MONJOBS "" } cmdId ] } {
        set jobLst ""
    } else { 
        set msg [seq_msgRecvReply $cmdId errNr -all]
        if { $errNr != 0 } {
            set jobLst ""
        } else {
            set jobLst [concat [split $msg ","]]
        }
    }

    set gvar(trendStopJobs) [lindex $jobLst 0]
    set c .trendStop
    toplevel $c

    frame $c.middle   -relief raised -border 1
    frame $c.bot      -relief raised -border 1

    iwidgets::combobox $c.middle.cb1 -labeltext "Job to Stop:" -editable false -dropdown false \
	                             -arrowrelief ridge -popupcursor hand2 \
	                             -textvariable gvar(trendStopJobs) 

    $c.middle.cb1 configure -listheight 80

    pack $c.middle.cb1  -padx 10 -pady 10 -fill x
    iwidgets::Labeledwidget::alignlabels $c.middle.cb1 

    button  $c.bot.ok  -text "Ok" -width 10 -command \
	"set flag 1; ccsMonStopTheJob; destroy $c"

    button  $c.bot.cancel -text "Cancel" -width 10 -command "set flag 1; destroy $c"
    pack $c.middle $c.bot -fill both
    pack $c.bot.ok $c.bot.cancel -side left -pady 15 -expand 1

    set cnt [llength $jobLst]
    for {set i 0} {$i<$cnt} {incr i} {
        eval $c.middle.cb1 insert list end {[lindex $jobLst $i]}
    }

    wm geometry $c +400+400
    wm title $c "CCS Monitor System"

    grab $c
    vwait flag;      # Stops until variable as been modified
}

#----------------------------------------------------------------------------

proc ccsMonStartHistoryTool { } {
     global gvar
     exec hisConfigTool &
}

#----------------------------------------------------------------------------


proc ccsMonConfigTrend { } {
    global gvar RTAPENV

    set flag -1

    if { [catch {seq_msgSendCommand $RTAPENV ccsMonitor MONJOBS "" } cmdId ] } {
        set jobLst ""
    } else { 
        set msg [seq_msgRecvReply $cmdId errNr -all]
        if { $errNr != 0 } {
            set jobLst ""
        } else {
            set jobLst [concat [split $msg ","]]
        }
    }

    if { [catch {seq_msgSendCommand $RTAPENV ccsMonitor MONPLOP "" } cmdId ] } {
        set plList ""
    } else {
        set msg [seq_msgRecvReply $cmdId errNr -all]
        if { $errNr != 0 } {
            set plList ""
        } else {
            set plList [concat [split $msg ","]]
        }
    }

    set c .trendPlot
    toplevel $c

    set gvar(ccsMonPlotPoint) [lindex $plList 0]
    frame $c.top      -relief raised -border 1
    frame $c.middle   -relief raised -border 1
    frame $c.bot      -relief raised -border 1

    iwidgets::combobox $c.top.cb1 -labeltext "Plot Point" -editable false      \
             -arrowrelief ridge -popupcursor hand1 -textvariable gvar(ccsMonPlotPoint)
    
    iwidgets::disjointlistbox $c.middle.dj  -buttonplacement center \
             -lhslabeltext "Active Trends" -rhslabeltext "Selected Trends" \
             -lhsbuttonlabel "Select" -rhsbuttonlabel "Remove"

    $c.middle.dj setlhs $jobLst

    pack $c.top.cb1   -padx 10 -pady 10 -fill x
    pack $c.middle.dj -padx 10 -pady 10 -fill x

    button  $c.bot.ok  -text "Ok" -width 10 -command \
	"ccsMonManagePlotList $c.middle.dj; set flag 1; ccsMonStartPlots {$jobLst}; destroy $c"

    button  $c.bot.cancel -text "Cancel" -width 10 -command "set flag 1; destroy $c"
    pack $c.top $c.middle $c.bot -fill x
    pack $c.bot.ok $c.bot.cancel -side left -pady 15 -expand 1

    set cnt [llength $plList]
    for {set i 0} {$i<$cnt} {incr i} {
        eval $c.top.cb1 insert list end {[lindex $plList $i]}
    }

    wm geometry $c +400+400
    wm title $c "CCS Monitor System"

    grab $c
    vwait flag;      # Stops until variable as been modified
}

#----------------------------------------------------------------------------

proc ccsMonStartPlots { jobLst } {
    global gvar RTAPENV

    if { [catch {seq_msgSendCommand $RTAPENV plotServer PING ""} cmdId ] } {
        if {[catch {exec ccsRunCmd -u plotServer} msg]} {
            ccsMonMessage message ERROR $msg
        }
    } else {
        if { [catch {seq_msgSendCommand $RTAPENV plotServer USEPLOT [string range $gvar(ccsMonPlotPoint) 7 end]} cmdId ] } {
            ccsMonMessage message ERROR $cmdId
            return
        }
        set msg [seq_msgRecvReply $cmdId errNr -all] 
        if { $errNr != 0 } {
            ccsMonMessage message ERROR $msg
            return
        }
        if { $msg >= 0 } {
            set msg [format "plot-point %s already in use"  $gvar(ccsMonPlotPoint)]
            ccsMonMessage message ERROR $msg
            return
	}
    }

    
    lappend color "green" "yellow" "cyan" "magenta" "blue" "brown" "violet" "gold"
    set plotCnt [llength $gvar(ccsMonSelectedTrends)]
    if { $plotCnt <= 0 } {
        return
    }
    if { $plotCnt > 8 } {
        set plotCnt 8
    }
    set value "CCS Monitoring System"
    if { [catch {seq_dbWriteSymbolic $gvar(ccsMonPlotPoint).title $value} ret] } {
        ccsMonMessage message ERROR $ret
        return
    }
    if { [catch {seq_dbWriteSymbolic $gvar(ccsMonPlotPoint).xAxisVisible 1} ret] } {
        ccsMonMessage message ERROR $ret
        return
    }
    if { [catch {seq_dbWriteSymbolic $gvar(ccsMonPlotPoint).xAxisLabel Time} ret] } {
        ccsMonMessage message ERROR $ret
        return
    }
    if { [catch {seq_dbWriteSymbolic $gvar(ccsMonPlotPoint).xAxisStyle 8978} ret] } {
        ccsMonMessage message ERROR $ret
        return
    }
    if { [catch {seq_dbWriteSymbolic $gvar(ccsMonPlotPoint).xAxisScalingMode 5} ret] } {
        ccsMonMessage message ERROR $ret
        return
    }
    if { [catch {seq_dbWriteSymbolic $gvar(ccsMonPlotPoint).xAxisMinima 0} ret] } {
        ccsMonMessage message ERROR $ret
        return
    }
    if { [catch {seq_dbWriteSymbolic $gvar(ccsMonPlotPoint).xAxisMaxima 240} ret] } {
        ccsMonMessage message ERROR $ret
        return
    }
    if { [catch {seq_dbWriteSymbolic $gvar(ccsMonPlotPoint).xAxisDivisions 4} ret] } {
        ccsMonMessage message ERROR $ret
        return
    }

    for {set i 0} {$i<$plotCnt} {incr i} {
        if { [catch {seq_dbWriteSymbolic $gvar(ccsMonPlotPoint).curves($i,visible) 1} ret] } {
            ccsMonMessage message ERROR $ret
            return
        }
        if { [catch {seq_dbWriteSymbolic $gvar(ccsMonPlotPoint).curves($i,yAxisSelect) -1} ret] } {
            ccsMonMessage message ERROR $ret
            return
        }
    }

    for {set i $plotCnt} {$i<8} {incr i} {
        if { [catch {seq_dbWriteSymbolic $gvar(ccsMonPlotPoint).curves($i,visible) 0} ret] } {
            ccsMonMessage message ERROR $ret
            return
        }
        if { [catch {seq_dbWriteSymbolic $gvar(ccsMonPlotPoint).curves($i,yAxisSelect) -1} ret] } {
            ccsMonMessage message ERROR $ret
            return
        }
    }

    if { [catch {seq_dbWriteSymbolic $gvar(ccsMonPlotPoint).updateDisplay 0} ret] } {
        ccsMonMessage message ERROR $ret
        return
    }

    # configure PENs
    for {set i 0} {$i<$plotCnt} {incr i} {
        set label [format "%s %s (%s)" [lindex [lindex $gvar(ccsMonSelectedTrends) $i] 0] [lindex [lindex $gvar(ccsMonSelectedTrends) $i] 1] [lindex [lindex $gvar(ccsMonSelectedTrends) $i] 2]]
	set attribute [lindex [lindex $gvar(ccsMonSelectedTrends) $i] 3]
        set tmpLst [split $attribute "."]
        set historyPoint [format "%s:%s" [lindex $tmpLst 0] history]

        if { [seq_catch {seq_dbGetDirAddr $attribute} dirAttr] } {
            ccsMonMessage message ERROR $dirAttr
            return
	}
        if { [seq_catch {seq_dbGetDirAddr $historyPoint} dirPoint] } {
            ccsMonMessage message ERROR $dirPoint
            return
	}

        set col [lindex $color $i]
        if { [catch {seq_dbWriteSymbolic $gvar(ccsMonPlotPoint).traits($i,markerStyle) 0} ret] } {
            ccsMonMessage message ERROR $ret
            return
        }
        if { [catch {seq_dbWriteSymbolic $gvar(ccsMonPlotPoint).traits($i,markerColor) $col} ret] } {
            ccsMonMessage message ERROR $ret
            return
        } 
        if { [catch {seq_dbWriteSymbolic $gvar(ccsMonPlotPoint).traits($i,lineVisible) 1} ret] } {
            ccsMonMessage message ERROR $ret
            return
        }
        if { [catch {seq_dbWriteSymbolic $gvar(ccsMonPlotPoint).traits($i,lineStyle) 0} ret] } {
            ccsMonMessage message ERROR $ret
            return
        } 
        if { [catch {seq_dbWriteSymbolic $gvar(ccsMonPlotPoint).traits($i,lineColor) $col} ret] } {
            ccsMonMessage message ERROR $ret
            return
        } 
        if { [catch {seq_dbWriteSymbolic $gvar(ccsMonPlotPoint).curves($i,visible) 1} ret] } {
            ccsMonMessage message ERROR $ret
            return
        }
        if { [catch {seq_dbWriteSymbolic $gvar(ccsMonPlotPoint).curves($i,sampleRate) 0} ret] } {
            ccsMonMessage message ERROR $ret
            return
        }
        if { [catch {seq_dbWriteSymbolic $gvar(ccsMonPlotPoint).curves($i,gridStyle) 1025} ret] } {
            ccsMonMessage message ERROR $ret
            return
        }
        if { [catch {seq_dbWriteSymbolic $gvar(ccsMonPlotPoint).curves($i,gridVisible) 0} ret] } {
            ccsMonMessage message ERROR $ret
            return
        }
        if { [catch {seq_dbWriteSymbolic $gvar(ccsMonPlotPoint).curves($i,yAxisSelect) -1} ret] } {
            ccsMonMessage message ERROR $ret
            return
        } 
        if { [catch {seq_dbWriteSymbolic $gvar(ccsMonPlotPoint).curves($i,yAxisVisible) -1} ret] } {
            ccsMonMessage message ERROR $ret
            return
        }
        if { [catch {seq_dbWriteSymbolic $gvar(ccsMonPlotPoint).curves($i,yAxisLabel) $label} ret] } {
            ccsMonMessage message ERROR $ret
            return
        }
        if { [catch {seq_dbWriteSymbolic $gvar(ccsMonPlotPoint).curves($i,yAxisColor) $col} ret] } {
            ccsMonMessage message ERROR $ret
            return
        }
        if { [catch {seq_dbWriteSymbolic $gvar(ccsMonPlotPoint).curves($i,yAxisStyle) 9024} ret] } {
            ccsMonMessage message ERROR $ret
            return
        }
        if { [catch {seq_dbWriteSymbolic $gvar(ccsMonPlotPoint).curves($i,yAxisScalingMode) 3} ret] } {
            ccsMonMessage message ERROR $ret
            return
        }
        if { [catch {seq_dbWriteSymbolic $gvar(ccsMonPlotPoint).curves($i,yAxisMinima) 0} ret] } {
            ccsMonMessage message ERROR $ret
            return
        }
        if { [catch {seq_dbWriteSymbolic $gvar(ccsMonPlotPoint).curves($i,yAxisMaxima) 100} ret] } {
            ccsMonMessage message ERROR $ret
            return
        }
        if { [catch {seq_dbWriteSymbolic $gvar(ccsMonPlotPoint).curves($i,yAxisDivisions) 4} ret] } {
            ccsMonMessage message ERROR $ret
            return
        }
        if { [catch {seq_dbWriteSymbolic $gvar(ccsMonPlotPoint).curves($i,traitAttr) {@[]}} ret] } {
            ccsMonMessage message ERROR $ret
            return
        }
        if { [catch {seq_dbWriteSymbolic $gvar(ccsMonPlotPoint).curves($i,yAxisSelect) -1} ret] } {
            ccsMonMessage message ERROR $ret
            return
        }
        if { [catch {seq_dbWriteSymbolic $gvar(ccsMonPlotPoint).curves($i,yAttrOrSourceAddr) "$dirAttr"} ret] } {
            ccsMonMessage message ERROR $ret
            return
        } 
        if { [catch {seq_dbWriteSymbolic $gvar(ccsMonPlotPoint).curves($i,dataSourceType) 1} ret] } {
            ccsMonMessage message ERROR $ret
            return
        }
        if { [catch {seq_dbWriteSymbolic $gvar(ccsMonPlotPoint).curves($i,xAttrOrHistTable) "$dirPoint"} ret] } {
            ccsMonMessage message ERROR $ret
            return
        }
        if { [catch {seq_dbWriteSymbolic $gvar(ccsMonPlotPoint).curves($i,gridColor) $col} ret] } {
            ccsMonMessage message ERROR $ret
            return
        }
        if { [catch {seq_dbWriteSymbolic $gvar(ccsMonPlotPoint).updateDisplay 0} ret] } {
            ccsMonMessage message ERROR $ret
            return
        }
    }

    exec plotDisplay [string range $gvar(ccsMonPlotPoint) 7 end] &

    return
}


proc ccsMonManagePlotList { wid } {
    global gvar RTAPENV

    set gvar(ccsMonSelectedTrends) [$wid getrhs]
    return
}

#----------------------------------------------------------------------------

proc ccsMonStopTheJob { } {
    global gvar RTAPENV

    set job       [lindex $gvar(trendStopJobs) 0]
    set trendType [lindex $gvar(trendStopJobs) 1]

    if { $trendType == "CPU" } {
        set command MONLDSP
    } elseif { $trendType == "MEM" } {
        set command MONMESP
    } elseif { $trendType == "PING" } {
        set command MONPISP
    } else {
        set command ERROR
    }

    if { [catch {seq_msgSendCommand $RTAPENV ccsMonitor $command $job} cmdId ] } {
        ccsMonMessage message ERROR $cmdId
    } else {
        set msg [seq_msgRecvReply $cmdId errNr -all] 
        if { $errNr != 0 } {
            ccsMonMessage message ERROR $msg
        }
    }
}



#
# ___oOo___
