#*******************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: ccseiDbProcs.tcl,v 3.11 2005/09/14 14:11:15 vltsccm Exp $"
#
# who       when        what
# --------  ----------  ----------------------------------------------
# mcomin  2004-10-07  created
#

#************************************************************************
#   NAME
# 
#   SYNOPSIS
# 
#   DESCRIPTION
#
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#
#   SEE ALSO
#
#   BUGS     
#
#------------------------------------------------------------------------
#

proc ccseiGuiPuts { Arg } {
    global ccseiDb_v
    if {$ccseiDb_v(guiDebug)} {
	puts $Arg
    }
}


proc ccseiGetDataType { dbTypeList } {
    set dbStrType ""

    foreach dbType $dbTypeList {
	switch $dbType {
	    1 { lappend dbStrType dbLOGICAL }
	    2 { lappend dbStrType dbINT8 }
	    3 { lappend dbStrType dbUINT8 }
	    4 { lappend dbStrType dbINT16 }
	    5 { lappend dbStrType dbUINT16 }
	    6 { lappend dbStrType dbINT32 }
	    7 { lappend dbStrType dbUINT32 }
	    8 { lappend dbStrType dbFLOAT }
	    9 { lappend dbStrType dbDOUBLE }
	    10 { lappend dbStrType dbPOLAR }
	    11 { lappend dbStrType dbRECTANGULAR }
	    16 { lappend dbStrType dbBYTES4 }
	    17 { lappend dbStrType dbBYTES8  }
	    18 { lappend dbStrType dbBYTES12 }
	    19 { lappend dbStrType dbBYTES16  }
	    20 { lappend dbStrType dbBYTES20  }
	    21 { lappend dbStrType dbBYTES32  }
	    22 { lappend dbStrType dbBYTES48  }
	    23 { lappend dbStrType dbBYTES64  }
	    24 { lappend dbStrType dbBYTES80  }
	    25 { lappend dbStrType dbBYTES128 }
	    26 { lappend dbStrType dbBYTES256 }
	    28 { lappend dbStrType dbXREF }
	    29 { lappend dbStrType dbDATE }
	    30 { lappend dbStrType dbTIME_OF_DAY }
	    31 { lappend dbStrType dbABS_TIME }
	    default { lappend dbStrType UNDEFINED }
	}
    }

    return $dbStrType
}




proc ccseiCreateScrollWidget { w wsx wsy } {
    $w configure -yscrollcommand [list $wsy set] -xscrollcommand [list $wsx set]
    $wsx configure -command [list $w xview]
    $wsy configure -command [list $w yview]

    pack $wsy -side right  -fill y
    pack $wsx -side bottom -fill x
    pack $w -side left -fill both -expand yes
}


proc ccseiCreateScrollTable { w tbName {flag expand} } {

    set f1  [frame $w.tbFrame]

    set wdgTable [ tablelist::tablelist $f1.$tbName   \
		       -labelcommand tablelist::sortByColumn    \
		       -selectbackground navy  -stripebg Gray80  \
		       -setgrid yes -stretch all -showseparators yes  -fg Black \
		       -font "-Adobe-courier-medium-r-normal--12*-iso8859-1" \
		       -width 0]

    set wsy [scrollbar $w.yscroll  -orient vertical   ]
    set wsx [scrollbar $f1.xscroll -orient horizontal ]    
    
    $wdgTable configure -yscrollcommand [list $wsy set] -xscrollcommand [list $wsx set]
    $wsx configure -command [list $wdgTable xview]
    $wsy configure -command [list $wdgTable yview]
    
    if {[cequal $flag expand]} {
	pack $f1  -side left -fill both -expand yes
	pack $wsy -side left -fill y

	pack $wdgTable -fill both -expand yes
	pack $wsx      -fill x
    } else {
	pack $f1  -side left -fill both
	pack $wsy -side left -fill y
	pack $wdgTable -fill both
	pack $wsx      -fill x
    }

    return $wdgTable
}

# This routine is used to read all the class names and ID

proc ccseiDbReadListClass {} {
    global dbListClassNames  dbListClassID dbListSuperClass ccseiDb_v

    set dbListClassNames {}
    set dbListClassID    {}
    set dbListSuperClass {}

    set attrName "@$ccseiDb_v(Env)<alias>class config.names"

    if {[catch {ccseiDbAttrInfo $attrName "" } attrInfo]} {
	return
    }

    lassign $attrInfo attrType dbTypes maxRecs maxFields

    incr maxRecs -1

    if {[catch {seq_dbReadSymbolic "${attrName}(0:$maxRecs,0)" } dbListClassID]} {
	set tmp "ccseiDb Cannot read list of class IDs from attribute $attrName"
	set ccseiDb_v(Message) $tmp
	return
    }

    if {[catch {seq_dbReadSymbolic "${attrName}(0:$maxRecs,1)" } dbListClassNames]} {
	set tmp "ccseiDb Cannot read list of class Names from attribute $attrName"
        set ccseiDb_v(Message) $tmp
	return
    }

    if {[catch {seq_dbReadSymbolic "${attrName}(0:$maxRecs,2)" } dbListSuperClass]} {
	set tmp "ccseiDb Cannot read list of 'super class' from attribute $attrName"
	set ccseiDb_v(Message) $tmp
	return
    }
}

#---------------------------------------------------------------------------------
#                 OLD ccseiDb procs
#---------------------------------------------------------------------------------



proc ccseiDbGlobals {} {
    global ccseiDb_v cv ccseiDbAttList gvar
    global attrTblName monTblName

    # Check if current version of seq provides Set/Get CE 
    set ccseiDb_v(dbCE) [info commands seq_dbSetCe]


    set ccseiDb_v(guiDebug) 0

    set ccseiDb_v(cour12B) "-Adobe-Courier-bold-r-normal--12*-iso8859-1"
    set ccseiDb_v(cour14B) "-Adobe-Courier-bold-r-normal--14*-iso8859-1"
    set ccseiDb_v(cour14)  "-Adobe-Courier-medium-r-normal--14*-iso8859-1"
    set ccseiDb_v(cour12)  "-Adobe-Courier-medium-r-normal--12*-iso8859-1"

    set ccseiDb_v(${attrTblName}_hideAttrType) 1
    set ccseiDb_v(${attrTblName}_hideQFlag)    1
    set ccseiDb_v(ptInfo)                      0 ;# Flags used to hide detailed point info.
    set ccseiDb_v(${attrTblName}_hideDbType)   1 ;# Flags used to hide the data type columns

    set ccseiDb_v(${monTblName}_hideAttrType) 1
    set ccseiDb_v(${monTblName}_hideQFlag)    1
    set ccseiDb_v(${monTblName}_hideDbType)   1 ;# Flags used to hide the data type columns

    set ccseiDb_v(moveToList)   0
    set ccseiDb_v(editAttrList) 0

    set gvar(dbUpdatePeriod)	1	;# contents of monitor period entry
    set gvar(dbMonActive)	0	;# state of monitor activate button
    set gvar(dbNavNodeId)      ""

   # variables that reflect the current contents/status:
#   set ccseiDb_v(Ses)	     ""
    set ccseiDb_v(Env)	     ""	  ;# Environment-entry
    set ccseiDb_v(Cwp)	     ":"  ;# CWP-entry
    set ccseiDb_v(Message)   ""	  ;# contents of message display

    set ccseiDb_v(na)     "n.a."
}

proc ccseiDbEvhForSelectEnv { envName } {
    global ccseiDb_v ccseiDb_w gvar dbTreeName wdgDbTree ccsei_v
    global wdgAttrTable

    ccseiPuts "ccseiDbEvhForSelectEnv  Environment = $envName"

    if {[cequal $ccseiDb_v(Env) $envName]} {
	set tmp "Environment $envName already selected"

	if {[tk_dialog .dialog "Error Dialog" $tmp info 0 "OPEN" "CANCEL"]} {
	    return
	}

	set ccseiDb_v(Message) "Environment $envName re-opened"
    }

    set gvar(dbMonActive)     0 ;# Disable monitoring
    set ccseiDb_v(Env) $envName ;# save selected value in a global variable

    if {[catch {seq_dbGetCwp $ccseiDb_v(Env)} cwp]} {
       set tmp "Environment $ccseiDb_v(Env) not active or does not Exist"

       if {[tk_dialog .dialog "Error Dialog" $tmp info 0 OK "SHOW ERROR"]} {
          seq_errDisplay
       }
       
       return ""
    }

    # Close all opened dialogs

    foreach wname [winfo children .] {
	if {[string match ".pt*" $wname]} {
	    destroy $wname
	}
    }

    # Re-draw DB tree

    $wdgDbTree  delete all  ;# Delete current tree in widget
    $dbTreeName delete all  ;# Delete tree structure

    # Clear all info fields

    set gvar(dbNavPLIN)       ""
    set gvar(dbAliasName)     ""
    set gvar(dbPointName)     ""
    set gvar(dbNavClassName)  ""
    set gvar(dbPointPLIN)     ""
    set gvar(dbBaseClassName) ""
    set gvar(dbClassID)       ""
    set gvar(dbPointID)       ""
    set gvar(dbClassName)     ""
    set gvar(dbNavAlias)      ""
    
    $wdgAttrTable delete 0 end 

    # Create New tree structure and new tree display
#    set dbTreeName [blt::tree create "dbTree"]
#    $wdgDbTree configure -tree $dbTreeName

    ccseiDbEvhForSelectCwp $cwp ;# CWP of selected env
    ccseiDbAddChildren ":" 0    ;# Show the children under the root point.
    ccseiDbReadListClass        ;# Read class definitions

    return $envName
}

proc ccseiDbEvhForSelectCwp { Cwp } {
    global ccseiDb_v ccseiDb_w

    ccseiPuts "ccseiDbEvhForSelectCwp Cwp = $Cwp"

    set ccseiDb_v(Cwp) $Cwp ;# save selected value in a global variable
    seq_dbSetCwp @$ccseiDb_v(Env)$Cwp ;# set CWP of selected env

    return $Cwp
}


proc ccseiDbGetAlias { dbName } {
    global ccseiDb_v env

    # Direct address can be retrieved only for the local environment

    if {[catch {seq_dbGetAlias $dbName } dbAlias ] } {
	set ccseiDb_v(Message) $dbAlias
	return "UNKNOWN"
    }

    return [string range $dbAlias 7 end]
}


proc ccseiDbGetDirAddr { dbName } {
    global ccseiDb_v env

    if {$ccseiDb_v(guiDebug)} {
       puts "ccseiDbGetDirAddr RTAPENV $env(RTAPENV)    $dbName"
    }

    # Direct address can be retrieved only for the local environment
    if {![cequal $env(RTAPENV) $ccseiDb_v(Env)]} {
	set dirAddr ""
    } else {

	if {[catch {seq_dbGetDirAddr $dbName } dirAddr ] } {
	    set ccseiDb_v(Message) $dirAddr
	    seq_errCloseStack
	    return -code error $dirAddr
	}
    }

    return $dirAddr
}


proc ccseiDbGetFieldNames { dbName numFields } {
    global ccseiDb_v env

#    puts "ccseiDbGetFieldNames $dbName"

    # Field Names can be retrieved only for the local environment

    if {[catch {seq_dbGetFieldNames "${dbName}" } flist ] } {

	set ccseiDb_v(Message) $flist
	set idx 0
	set flist ""
	while {$idx < $numFields} {
	    lappend flist "field${idx}"
	    incr idx
	}
    }

#    puts "ccseiDbGetFieldNames field Names = $flist"
    return $flist
}


proc ccseiDbAttrInfo { dbPath dbAttr } {
    global ccseiDb_v

    if {![cequal $dbAttr ""]} {
	append dbPath ".${dbAttr}"
    }

    ccseiPuts "ccseiDbAttrInfo $dbPath"

    if {[catch {seq_dbGetAttrInfo $dbPath } attrInfo ] } {
	set ccseiDb_v(Message) "Cannot Get Info for attribute $dbPath"
	return -code error $attrInfo
    }

    ccseiPuts "ccseiDbAttrInfo ==> $attrInfo"
    return $attrInfo
}


proc ccseiDbAttrNames { dbPath } {
    global ccseiDb_v

    ccseiPuts "ccseiDbAttrNames $dbPath"

    if {[catch {seq_dbGetAttrNames "${dbPath}" } nameList ] } {
	set ccseiDb_v(Message) $nameList
	return -code error $nameList
    }

    ccseiPuts "ccseiDbAttrNames  ==> $nameList"
    return $nameList
}

proc ccseiDbWriteSymbolic { Attribute Value errDisplayFlag } {
    global ccseiDb_v

    ccseiPuts "ccseiDbWriteSymbolic $Attribute \"$Value\" "

    if {[catch {seq_dbWriteSymbolic $Attribute "${Value}" } err]} {
	set ccseiDb_v(Message) $err

	if {$errDisplayFlag} {
	    seq_errDisplay
	}
	
	ccseiPuts "ccseiDbWriteSymbolic FAILED ==> $err"
	return -code error $err
    }

#    # Read the written value back for security:
#    set value [lindex [ccseiDbReadSymbolic $Attribute] 1]
#    return $value

    return
}

#
# This procedure reads a database symbolic attribute and returns a list
# containing two values : dataQuality and current value.
#

proc ccseiDbReadSymbolic { Attribute {errDisplayFlag 0} } {
    global ccseiDb_v errorInfo

#    puts "DBG> ccseiDbReadSymbolic $Attribute"

    if {[catch {seq_dbReadSymbolic $Attribute -noBadQLog badQuality } value] } {
	set ccseiDb_v(Message) $value	;# display error in panel
	set value "READ ERROR"

	if {$errDisplayFlag} {
	    seq_errDisplay
	}

	return -code error $value	;# generate a Tcl error pop-up box
    }

    ccseiPuts "ccseiDbReadSymbolic  $Attribute ==> \"$value\" badQuality = $badQuality"

    set ccseiDb_v(Message) ""		;# clear message on successful read

    return [list $badQuality $value]
}


#
# Event-handler for `Options' menu
#

proc ccseiDbOptionEnableDebug { } {
    ccseiDebugControl
}


#
# Event-handler for `Help' menu
#

proc ccseiDbHelpInfo { } {
    global ccseiDb_c
    ccseiDialog "ccseiDb Version $ccseiDb_c(version)\
	    \nDatabase-Monitor of the\nCCS Engineering User Interface"
}

proc ccseiDbHelpExtHelp { } {
    global argv0
    exec vltMan ccseiDb &
}


#
# ___oOo___
