#*******************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: ctooCommon.tcl,v 1.52 2005/09/06 23:52:05 vltsccm Exp $"
#
# who       when        what
# --------  ----------  ----------------------------------------------
# rschmutz  2000-09-02  ctooShowHelptext: update idletasks added.
# rschmutz  1999-12-24  ctooStr* functions added.
# rschmutz  1999-08-22  ctooObjectExists added.
# rschmutz  1999-04-06  created
#

#************************************************************************
#   NAME
#      ctooCommon
#
#   SYNOPSIS
# 
#   DESCRIPTION
#      General purpose routines 
#       
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#
#   SEE ALSO
#
#   BUGS     
#
#------------------------------------------------------------------------
#


proc ctooGetWdVar { widget } {
    global gvar wdList

    set var [panParseVar [$wdList($widget) cget -variable]]
    return $gvar($var)
}

proc ctooSetWdVar { widget value } {
    global gvar wdList

    set var [panParseVar [$wdList($widget) cget -variable]]
    set gvar($var) $value
}

proc ctooDbRead { name } {
    global dbList

    return [seq_dbReadSymbolic $dbList($name)]
}

proc ctooDbWrite { name value } {
    global dbList

    seq_dbWriteSymbolic $dbList($name) $value
}

proc ctooUpdateWdVar { widget {name {}} } {
    if { "$name" == "" } {
	set name $widget
    }
    ctooSetWdVar $widget [ctooDbRead $name]
}

proc ctooTreeNext {} {
    global wdList

    $wdList(tree) next
}


proc ctooTreePrev {} {
    global wdList

    $wdList(tree) prev
}


proc ctooTreeBack {} {
    global wdList

    $wdList(tree) back
}


proc ctooTreeForward {} {
    global wdList

    $wdList(tree) forward
}

proc ctooShowHelptext { text } {
    global shArea

    if {[info exists shArea]} {
	$shArea displayText "$text"
	update idletasks
    }
}

proc ctooHelparea {} {
    global shArea

    if {[info exists shArea]} {
	return $shArea
    }
    return ""
}

proc ctooObjectExists { name } {
    if { "[find objects $name]" == "$name" } {
	return 1
    } else {
	return 0
    }
}


#************************************************************************
# Aux. string functions
#------------------------------------------------------------------------
#
proc ctooStrFirst { text } {
    set text [string trimleft $text]
    return [ctoken text " \t\n\r"]
}

proc ctooStrTail { text } {
    set text [string trimleft $text]
    ctoken text " \t\n\r"
    return [string trimleft $text]
}

proc ctooStrTrim { text } {
    set text [string trim $text]
    if { "[csubstr $text 0 1]" == "\"" && "[csubstr $text end 1]" == "\"" } {
        set text [crange $text 1 end-1]
    }
    return $text
}


#
# ___oOo___
