
#*******************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: fcdConfigSave.tcl,v 2.83 2005/09/30 08:26:28 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# alongino  07/08/95  created
# alongino  19/02/96  modified for new cwp feature of dbBackup
# alongino  23/04/96  introduced fcdDcsDbSave.sh
#

#************************************************************************
#   NAME
#   fcdConfigSave - read from the database the current camera configuration
# 
#   SYNOPSIS
#   fcdConfigSave <file>
# 
#   DESCRIPTION
#   Tcl procedure, used within CCD GUI panels, to read from the database
#   the values of attributes defined in the file fcdConfig.inp.
#   This file is used as input for the CCS utility dbBackup to save the 
#   values in the file <file>
#
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#   fcdConfigSave $CFGDIR/$CCDNAME.dbcfg
#
#   SEE ALSO
#
#
#   BUGS     
#
#------------------------------------------------------------------------
#

proc fcdConfigSave { file } {                                                                                                                                                                 

    global insroot camera wsenv cwp

#
# select default directory according to INS common sw specs
#
    set dir $insroot/SYSTEM/COMMON/CONFIGFILES
#
# select file
#
    if {$file == ""} {
      set filter "*.dbcfg"
      if { [set outfile [panSelectFile $dir $filter]] == ""} {
        return
      }
    } else {
      set outfile $dir/$file
    }
    exec fcdDcsDbSave.sh $camera $wsenv $outfile
}


#
# ___oOo___


