#************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: fcdConfigTelTem.tcl,v 2.83 2005/09/30 08:26:38 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# mcomin    05/02/96  created
# alongino  04/03/97  enhanced for temperature implementation
# alongino  06/03/97  only common part for telemetry and temperature
# rdonalds  03/06/98  ported from CCD
#

#************************************************************************
#   NAME 
#   fcdConfigTelTemInit, fcdConfigFormatTelTem
# 
#   SYNOPSIS
# 
#   DESCRIPTION
#   These procedures are used within the fcdConfig panel to handle the
#   telemetry and temperature parameters
#
#------------------------------------------------------------------------
#

#
# Initialise variables for telemetry and temperature list boxes
proc fcdConfigTelTemInit { cat index name template button} {

   upvar $index fcdIndex
   upvar $name fcdName
   upvar $template fcdTempl
   upvar $button fcdButton

   # set names of edit part variables
   set fcdName(0)  fcd${cat}Rec
   set fcdName(1)  fcd${cat}Type
   set fcdName(2)  fcd${cat}BoardId
   set fcdName(3)  fcd${cat}SensorId
   set fcdName(4)  fcd${cat}Name
   set fcdName(5)  fcd${cat}Id
   set fcdName(6)  fcd${cat}Units
   set fcdName(7)  fcd${cat}Low
   set fcdName(8)  fcd${cat}High
   set fcdName(9)  fcd${cat}ConvFact

   # set indexes in a row corresponding to fcdName
   set fcdIndex(0) 0
   set fcdIndex(1) 11
   set fcdIndex(2) 12
   set fcdIndex(3) 13
   set fcdIndex(4) 5
   set fcdIndex(5) 6
   set fcdIndex(6) 7
   set fcdIndex(7) 8
   set fcdIndex(8) 9
   set fcdIndex(9) 4

   # define name of buttons
   set fcdButton(0) fcd${cat}Add
   set fcdButton(1) fcd${cat}Del

   # define record templates
   set fcdTempl(clean) {0 0 0 0 0 "" "" "" 0 0 0 0 0 0 }; # used when removing records
   set fcdTempl(mask)  {0 0 1 1 0 "" "" "" 0 0 0 0 0 0}; # used when adding records
}





# formats on row in the telemetry or temperature list box
proc fcdConfigFormatTelTem { index text } {

   upvar $index fcdIndex

   set recInd $fcdIndex(0)
   set typeInd $fcdIndex(1)
   set boardIdInd $fcdIndex(2)
   set sensorIdInd $fcdIndex(3)
   set nameInd $fcdIndex(4)
   set idInd $fcdIndex(5)
   set unitsInd $fcdIndex(6)
   set lowInd $fcdIndex(7)
   set highInd $fcdIndex(8)
   set convFactInd $fcdIndex(9)
   
   return [format "%-5s %-6s %-4s %-4s %-16s %-16s %-4s %-4s %-4s %-4s" \
          [lindex $text $recInd]  \
          [lindex $text $typeInd]  \
          [lindex $text $boardIdInd]  \
          [lindex $text $sensorIdInd]  \
          [lindex $text $nameInd]  \
          [lindex $text $idInd]  \
          [lindex $text $unitsInd]  \
          [lindex $text $lowInd]  \
          [lindex $text $highInd]  \
          [lindex $text $convFactInd]]
}



#
# ___oOo___
