#
#*************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: fcdExpInfo_uifClass.tcl,v 2.83 2005/09/30 08:26:29 vltsccm Exp $" 
#
# fcdExpInfo_uifClass.tcl
#
# This file has been produced by the panel editor
#   version: panel.tcl,v 3.7
#   date   : Fri Jul  4 11:23:19 MESZ 1997
#
#      !!!!!!!!!!  DO NOT MANUALLY EDIT THIS FILE  !!!!!!!!! 
#
#--------------------------------------------------------------


class fcdExpInfo_uifClass { 
  inherit UifPanel 

  constructor {args} { 

    setPublicVar
    #
    # Link class to user libraries 
    #
    set panUsrLib   {}  
    set panClassLib {}
    panSetAutoPath  $panUsrLib $panClassLib
    #
    # Build the class 
    #
    parseClassName $this 

    itk_component add top {
       canvas $itk_interior.cv -width 337 -height 153 \
              -borderwidth 2 -highlightthickness 0
    } {
       keep -relief 
    }

    pack $itk_component(top) -fill both -expand 1 
    eval itk_initialize 

    configure -relief groove ; # Default value

    UifOutputString    $cv.fcdExpInfo-expType -anchor center \
                       -canvasAnchor nw -dbMode dbEvent -evtFilter {"w"} \
                       -evtScript {panEvtDbUpdate fcdExpInfo-expType %A %T %D} \
                       -font -Adobe-courier-medium-r-normal--14* -frame 1 \
                       -listColors {Black Black Black} \
                       -listStrings {Normal Dark Multi-step} \
                       -listValues {1 2 3} \
                       -variable gvar(exposures:exposure_1.expType) \
                       -width 10
    UifOutput          $cv.fcdExpInfo-rdtTime -anchor center \
                       -canvasAnchor nw -color Black -dbMode dbPoll \
                       -evtFilter {"w"} \
                       -evtScript {panEvtDbUpdate fcdExpInfo-rdtTime %A %T %D} \
                       -font -Adobe-courier-medium-r-normal--14* -frame 1 \
                       -variable gvar(readout.time) -width 6
    UifBarChart        $cv.fcdExpInfo-wdg1 -axis 0 -canvasAnchor nw \
                       -dbMode dbPoll -evtFilter {"w"} \
                       -label {Readout (Det. Electr.->SLCU)} -length 200 \
                       -maxVal 100 -minVal 0 -orient h -ticks 0 \
                       -variable gvar(readout.percent)
    UifOutput          $cv.fcdExpInfo-wdg2 -anchor center -canvasAnchor nw \
                       -color Black -dbMode dbEvent -evtFilter {"w"} \
                       -evtScript {panEvtDbUpdate fcdExpInfo-wdg2 %A %T %D} \
                       -font -Adobe-courier-medium-r-normal--14* -frame 1 \
                       -variable gvar(exposures:exposure_1:readout.modeIndex) \
                       -width 2
    UifOutput          $cv.fcdExpInfo-wdg3 -anchor center -canvasAnchor nw \
                       -color Black -dbMode dbPoll -evtFilter {"w"} \
                       -evtScript {panEvtDbUpdate fcdExpInfo-wdg3 %A %T %D} \
                       -font -Adobe-courier-medium-r-normal--14* -frame 1 \
                       -variable gvar(images:transfer.time) -width 6
    UifBarChart        $cv.fcdExpInfo-wdg4 -axis 0 -canvasAnchor nw \
                       -dbMode dbPoll -evtFilter {"w"} \
                       -label {Transfer (SLCU->WS)} -length 150 -maxVal 100 \
                       -minVal 0 -orient h -ticks 0 \
                       -variable gvar(images:transfer.percent)

    #
    #  Canvas Items
    #

    $cv create text 8 20 -tags "text fcdExpInfo-item1 classItem fcdExpInfo" -anchor w \
              -text "Exposure Type" \
              -fill black -font helvR14 

    $cv create text 250 63 -tags "text fcdExpInfo-item2 classItem fcdExpInfo" -anchor nw \
              -text "Time(sec)" \
              -fill black -font -Adobe-helvetica-medium-r-normal--14* 

    $cv create text 7 42 -tags "text fcdExpInfo-item3 classItem fcdExpInfo" -anchor nw \
              -text "Readout Mode" \
              -fill black -font -Adobe-helvetica-medium-r-normal--14* 


    eval configure $args 
  }; # end of constructor

  #-------------------------------------------
  #*# Method init

  public method init { } {
    global ::panWidget ::gvar ::panDbData ::panWidgetHlp 
    set top $className 

    #
    # Set Widget Configuration
    #
    set panWidget(${top}.fcdExpInfo-expType)  {UifOutputString 107.0 9.0 1 1 0 0 1 exposures:exposure_1.expType 0 {}}
    set panWidget(${top}.fcdExpInfo-rdtTime)  {UifOutput 250 80 1 1 0 0 1 readout.time 0 %.2f {}}
    set panWidget(${top}.fcdExpInfo-wdg1)  {UifBarChart 6 63 1 1 0 0 1 readout.percent 0 0 0 100 0 0}
    set panWidget(${top}.fcdExpInfo-wdg2)  {UifOutput 109.0 37.0 1 1 0 0 1 exposures:exposure_1:readout.modeIndex 0 {} {}}
    set panWidget(${top}.fcdExpInfo-wdg3)  {UifOutput 250 124 1 1 0 0 1 images:transfer.time 0 %.2f {}}
    set panWidget(${top}.fcdExpInfo-wdg4)  {UifBarChart 6 109 1 1 0 0 1 images:transfer.percent 0 0 0 100 0 0}

    #
    # Set Database Configuration
    #
    set panDbData(${top}.fcdExpInfo-expType)  {out local exposures:exposure_1.expType 0 0 0 0 0 0 0 {}}
    set panDbData(${top}.fcdExpInfo-rdtTime)  {out local readout.time 0 0 0 0 0 0 1 {}}
    set panDbData(${top}.fcdExpInfo-wdg1)  {out local readout.percent 0 0 0 0 0 0 1 {}}
    set panDbData(${top}.fcdExpInfo-wdg2)  {out local exposures:exposure_1:readout.modeIndex 0 0 0 0 0 0 0 {}}
    set panDbData(${top}.fcdExpInfo-wdg3)  {out local images:transfer.time 0 0 0 0 0 0 1 {}}
    set panDbData(${top}.fcdExpInfo-wdg4)  {out local images:transfer.percent 0 0 0 0 0 0 1 {}}

    #
    # Set Short Help for each widget
    #
    set panWidgetHlp(${top}.fcdExpInfo-expType)  {Type of exposure}
    set panWidgetHlp(${top}.fcdExpInfo-rdtTime)  {Time (sec) needed to perform the last readout}
    set panWidgetHlp(${top}.fcdExpInfo-wdg1)  {Percentage of image read}
    set panWidgetHlp(${top}.fcdExpInfo-wdg2)  {Index of mode used for readout}
    set panWidgetHlp(${top}.fcdExpInfo-wdg3)  {Time (sec) needed to transfer the image to WS}
    set panWidgetHlp(${top}.fcdExpInfo-wdg4)  {Percentage of image transferred to WS}


    setInstanceData
    set initDone 1 
  }; # end of init

} ; #end of the class 
