
#*******************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: fcdGetOpState.tcl,v 2.83 2005/09/30 08:26:30 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# alongino  25/07/95  created
# alongino  08/07/96  global variables names modified to coexist with
#                     fcdExpCtrlUpdate
#                     added context sensitivity disabled
#

#************************************************************************
#   NAME
#   fcdGetOpState - read from the database the current camera operational state
# 
#   SYNOPSIS
#   fcdGetOpState
# 
#   DESCRIPTION
#   Tcl procedure, used within CCD GUI panels, to read from the database
#   the current camera operational state and set it in the global variable
#   gvar(opState)
#
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#   fcdGetOpState
#
#   SEE ALSO
#
#
#   BUGS     
#
#------------------------------------------------------------------------
#

proc fcdGetOpState { } {        

 # Declare global variables 

   global gvar

 # User Initialization

   set gvar(opState) [dbRead ".opState"]; # get current operational state
   set gvar(opMode)  [dbRead ".opMode"];  # get current operational mode
   
 # enable/disable buttons according to current operational state

   if {$gvar(fcdMainCtrl_fcdContext)} {;   # context sensitive
     set gvar(fcdMainCtrl_fcdNotLoaded) 0
     set gvar(fcdMainCtrl_fcdLoaded)    0
     set gvar(fcdMainCtrl_fcdRunning)   0
# AL960222 mode 1 (WS simulation is used for demo session)
     if {$gvar(opMode) > 0} {;                # available
         if {$gvar(opState) <= 1} {;          # state OFF
            set gvar(fcdMainCtrl_fcdNotLoaded) 1
         } elseif {$gvar(opState) > 1} {;     # at least LOADED
            set gvar(fcdMainCtrl_fcdLoaded) 1
          set gvar(fcdMainCtrl_fcdRunning) 1
        }  
     }
   } else {;                   # buttons always enabled
     set gvar(fcdMainCtrl_fcdNotLoaded) 1
     set gvar(fcdMainCtrl_fcdLoaded)    1
     set gvar(fcdMainCtrl_fcdRunning)   1     
   }
# puts "context = $gvar(fcdMainCtrl_fcdContext)"
# puts "not Loaded = $gvar(fcdMainCtrl_fcdNotLoaded)"
# puts "loaded     = $gvar(fcdMainCtrl_fcdLoaded)"
# puts "running    = $gvar(fcdMainCtrl_fcdRunning)"     
}


#
# ___oOo___


