
#*******************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: fcdSetupFilePath.tcl,v 2.83 2005/09/30 08:26:31 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# alongino  04/09/95  created
#

#************************************************************************
#   NAME
#   fcdSetupFilePath - retrieve the full path of a setup file
# 
#   SYNOPSIS
#   fcdSetupFilePath <file>
# 
#   DESCRIPTION
#   Tcl procedure used within CCD OSS GUI panels to retrieve the full path
#   of a setup file
#
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#   set path [fcdSetupFilePath mySetup.det]
#
#   SEE ALSO
#
#
#   BUGS     
#
#------------------------------------------------------------------------
#

proc fcdSetupFilePath { file } {                                                         

   # select directory
   set dbAttr "observations.setupDirectory"
   set dir [dbRead $dbAttr]

   # select file
   if {[string length $file] == 0} {
       set filter "*.det"
       set file [panSelectFile $dir $filter]
   } else {
       set file $dir/$file
   }

   return $file
}

#
# ___oOo___


