#************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: fcdTel.tcl,v 2.83 2005/09/30 08:26:37 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# alongino  10/03/97  created
#

#************************************************************************
#   NAME 
#   fcdTelInitialise
# 
#   SYNOPSIS
# 
#   DESCRIPTION
#   These procedures are used within the fcdConfig, fcdTelSet and fcdTelemetry
#   panel to handle the telemetry parameters
#
#------------------------------------------------------------------------
#

#
# Initialise variables
proc fcdTelInitialise { } {

  global cv
  global telRows telCol  
  global telTable telDbAttr telAvail
  global telDbCurr telWdg telFormatProc

  set telRows 100; # maximum number of rows, as from DB
  set telCol 10;   # maximum number of columns, as from DB
  set telDbCurr "telemetry.current"
  set telWdg $cv.fcdTelListBox
  set telFormatProc fcdFormatTelStatus

  # set path to DB values
  fcdTelDbInit $telRows telDbAttr

  # Read element by element from OLDB and set internal table
  fcdDbToTable telTable $telRows $telCol telDbAttr

  # Build list with only the available elements
  fcdTableAvail telTable telAvail telDbAttr

}



#
# Initialise variables for telemetry and temperature list boxes
proc fcdTelDbInit { rows dbAttr } {

  upvar $dbAttr fcdDbAttr

  # set path to DB values
  set fcdDbAttr(avail) telemetry.available
  for { set i 0 } { $i < $rows } {incr i } {
    set fcdDbAttr($i,availInd) 2; # available flag is at position 2 in record
    set fcdDbAttr($i,availVal) 0; # not available value
    set fcdDbAttr($i) telemetry.sensor($i)
  }
}

#
# ___oOo___
