#************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: fcdWriteConfig.tcl,v 2.83 2005/09/30 08:26:27 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# abalestr  09/07/97  created (ported from CCD software)
#
#************************************************************************
#   NAME
#   fcdWriteConfig - write configuration on file
# 
#   SYNOPSIS
#   fcdWriteConfig
# 
#   DESCRIPTION
#   Tcl procedure used within FIERA OSS GUI panels to write configuration on 
#   a file. parameter flag specifies if it is a user defined file (flag=1) 
#   or the default file (flag=0).
#
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#
#   SEE ALSO
#
#
#   BUGS     
#
#------------------------------------------------------------------------
#


proc fcdWriteConfig {flag} {
   global env gvar

   set dir $env(INS_ROOT)/$gvar(insuser)/COMMON/CONFIGFILES

   if { $flag == 1 } {
   
     set filter *.dbcfg
     set file [panSelectFile $dir $filter]

     if { $file != "" } {
       exec fcdDcsDbSave.sh $env(CCDNAME) $env(RTAPENV) $file
   }

   } else {
     set file $dir/$env(CCDNAME).dbcfg
     exec fcdDcsDbSave.sh $env(CCDNAME) $env(RTAPENV) $file
   }
}
