#*******************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: FileTree.tcl,v 1.20 2004/01/16 15:28:34 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# hpieper  10/07/97  adapted from Micheal McLennan Example
#

#************************************************************************
#   NAME
# 
#   SYNOPSIS
# 
#   DESCRIPTION
#
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#
#   SEE ALSO
#
#   BUGS     
#
#------------------------------------------------------------------------
#
# ----------------------------------------------------------------------
#  EXAMPLE: FileTree class
# ----------------------------------------------------------------------
#     BOOK: Tcl/Tk Extensions for O'Reilly & Associates
#   AUTHOR: Michael J. McLennan, AT&T Bell Laboratories
# ======================================================================
#               Copyright (c) 1996  AT&T Bell Laboratories
# ======================================================================

class FileTree {
    inherit Tree

    public variable procreate ""

    private variable file ""
    private variable mtime 0

    constructor {fname args} {
        if {![file exists $fname]} {
            error "file not found: $fname"
        }
        set file $fname
        eval configure $args
    }

    public method contents {}
    private method populate {}
}

body FileTree::populate {} {
    if {[file mtime $file] != $mtime} {
        clear
        foreach f [glob -nocomplain $file/*] {
            add [uplevel #0 $procreate $f]
        }
        set mtime [file mtime $file]
    }
}
body FileTree::contents {} {
    populate
    return [Tree::contents]
}
