#*******************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: fcdpmsBulletLog.tcl,v 1.20 2004/01/16 15:28:32 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# hpieper  15/09/97  created
# ccumani  01/03/98  bitmap files search corrected
#

#************************************************************************
#   NAME
# 
#   SYNOPSIS
# 
#   DESCRIPTION
#
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#
#   SEE ALSO
#
#   BUGS     
#
#------------------------------------------------------------------------
#

itk::usual fcdpmsBulletLog {
    keep -short_help
}

class fcdpmsBulletLog {
    inherit itk::Widget
    constructor             {args} {}
    destructor                     {}

    itk_option define    -orient       orient Orient   "horiz"
    itk_option define    -name         name   Name     ""
    itk_option define    -logproc      logprog Logproc ""
    itk_option define    -logconfigure logConfigure    LogConfigure ""
    itk_option define    -short_help   short_help      Short_help ""
    itk_option define    -valwidth     valwidth        Valwidth   "20"
    itk_option define    -valheight    valheight       Valheight  "2"


    private  variable    blinkImg [image create photo \
	    -file [fcdpmsFindVLT bitmaps/yellow.gif]]

    private  variable    Img [image create photo \
	    -file [fcdpmsFindVLT bitmaps/blue.gif]]

    protected variable      interv             "2000"
    private   variable      LOG_PROC           ""
    private   common        VAL     

    #methods for logging the status
    public   method getInterv         {}         {return $interv}
    public   method setInterv         {interv_}  {set interv $interv_}
    public   method logActive         {}
    public   method log               {}          
    public   method doLog             {interv}
    public   method stopLog           {}
    public   method continueLog       {}
    public   method other             {}
    public   method popupMenu         {}
};#fcdpmsBulletLog

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# fcdpmsBulletLog::constructor
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body fcdpmsBulletLog::constructor {args} {

    
    #create the status word display holders
    if {[llength $args] != 0 } {
	eval itk_initialize $args
    }
    itk_component add tfr {
	frame $itk_interior.tfr -bd 0 -relief flat
    }
    
    itk_component add img {
	label $itk_component(tfr).img \
		-image $Img \
		-bd 2 \
		-anchor nw 
    } {
	usual
	ignore -relief -font
	ignore -background
	ignore -foreground
	
    }
    $itk_option(-short_help) add_short_help $itk_component(hull) "Press mouse button <3> \
	    over bullet for popup menu"
					
    itk_component add label {
	label $itk_component(tfr).label \
		-anchor nw 
    } {
	usual
	rename -text -name name Name
	ignore -relief -font
	ignore -background
	ignore -foreground
	
    }

    itk_component add val {
	text $itk_interior.val \
		-borderwidth 0 \
		-wrap word \
		-relief flat
    } {
	ignore -font
	rename -width -valwidth valwidth Valwidth
	rename -height -valheight valheight Valheight

    }
    itk_component add popupMenu {
	menu $itk_interior.menu -tearoff 0
    } {
	usual
	ignore -tearoff
    }
    
   
    $itk_component(popupMenu) add command \
	    -label "Get Value" \
	    -command [code $this log]
    $itk_component(popupMenu) add command \
	    -label "Stop Logging" \
	    -command [code $this stopLog]
    $itk_component(popupMenu) add command \
	    -label "Continue Logging" \
	    -command [code $this continueLog]
    $itk_component(popupMenu) add command \
	    -label "Poperties" \
	    -command $itk_option(-logconfigure)


    bind $itk_component(img) <Enter> \
	    [code "$itk_component(img) configure -relief groove -bd 2"]
    bind $itk_component(img) <Leave> \
	    [code "$itk_component(img) configure -relief flat -bd 2"]

    bind $itk_component(img) <Button-3> \
	    [code $this popupMenu]
    
    if [string match $itk_option(-orient) "horiz"] {	
	pack $itk_component(img) -padx 2 -side left -fill x
	pack $itk_component(label) -padx 2 -side left -fill x
	pack $itk_component(tfr) -padx 2 -side left -fill x
	pack $itk_component(val) -padx 2 -side left -fill x
    } else {	
	pack $itk_component(img) -padx 2 -side left -fill x
	pack $itk_component(label) -padx 2 -side left -fill x
	pack $itk_component(tfr) -padx 2 -side top -fill x
	pack $itk_component(val) -padx 2 -side bottom -fill x
    }
    $itk_component(val) tag configure blue -foreground blue
    $itk_component(val) tag configure green -foreground DarkGreen 

}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# fcdpmsBulletLog::destructor
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body fcdpmsBulletLog::destructor {} {
    
}

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# fcdpmsBulletLog::popupMenu       {}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body fcdpmsBulletLog::popupMenu {} {
    set w $itk_component(img)
    tk_popup $itk_component(popupMenu) \
	    [expr [winfo rootx $w] + [winfo reqwidth $w]] \
	    [winfo rooty $w]
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# fcdpmsBulletLog::logActive    {}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body fcdpmsBulletLog::logActive {} {
    if {$LOG_PROC == ""} {
	return 0
    } else {
	return 1
    }
}

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# fcdpmsBulletLog::stopLog    {}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body fcdpmsBulletLog::stopLog {} {
    if [info exists LOG_PROC] {
	after cancel $LOG_PROC
	set LOG_PROC ""
    }
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# fcdpmsBulletLog::continueLog    {}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body fcdpmsBulletLog::continueLog {} {
    doLog $interv
}

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# fcdpmsBulletLog::other         {}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body fcdpmsBulletLog::other {} {
    
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# fcdpmsBulletLog::log         {}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body fcdpmsBulletLog::log {} {

    $itk_component(img) configure -image $blinkImg
    set VAL($this) [$itk_option(-logproc)]
    $itk_component(val) config -state normal
    $itk_component(val) delete 0.0 end
    foreach i [split $VAL($this)] {
	if [regsub \~ $i  "" i] { 
	    $itk_component(val) insert end "$i " green
	} else {
	    $itk_component(val) insert end "$i " blue
	} 
    }
    $itk_component(val) config -state disabled

    $itk_component(img) configure -image $Img   

}; # doLog

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# fcdpmsBulletLog::doLog         {}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body fcdpmsBulletLog::doLog {interv_} {
    
    set interv $interv_
    if [info exists LOG_PROC] {
	after cancel $LOG_PROC
	set LOC_PROC ""
    }
    log
    set LOG_PROC [after $interv [code $this doLog $interv]]
    
}; # doLog

#
# ___oOo___
