#*******************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: fcdpmsCmdEval.tcl,v 1.20 2004/01/16 15:28:30 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# hpieper  10/07/97  created
#

#************************************************************************
#   NAME
# 
#   SYNOPSIS
# 
#   DESCRIPTION
#
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#
#   SEE ALSO
#
#   BUGS     
#
#------------------------------------------------------------------------
#
#-----------------------------------------------------------------------

itk::usual fcdpmsCmdEval {}

class fcdpmsCmdEval {
    inherit itk::Widget fcdpmsPHW

    constructor     {unit_ args} {}
    destructor      {}

    private    variable   cmdcnt     "1"

    private    variable   prompt     ""
    #private    variable   insert     ""

    public    method     evalCommand   {}
    public    method     track         {W}
    public    method     clear         {} {
	$itk_component(txt) clear
	$itk_component(txt) insert insert $prompt prompt
    }
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# fcdpmsCmdEval::constructor
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body fcdpmsCmdEval::constructor { unit_ args} {
    # set the unit number in the base class fcdpmsHW
    set fcdpmsPHW::unit $unit_
    set fcdpmsPHW::console $this

    itk_component add txt {
        scrolledtext $itk_interior.txt \
		-labeltext "Console" \
		-labelpos nw \
                -background Grey90\
                -foreground Black\
                -wrap none \
		-width 250 \
		-height 50
    } {
        usual	
	ignore -foreground -background
	ignore -width -height -textfont 
    }
    


    if {[llength $args] != 0 } {
	eval itk_initialize $args
	eval configure $args
    }
    pack $itk_component(txt) -side left -expand true -fill both
    [$itk_component(txt) component text] tag configure prompt -foreground blue
    [$itk_component(txt) component text] tag configure reply -foreground red 
    
    set prompt " <$cmdcnt> % "
    $itk_component(txt) insert insert $prompt prompt
    [$itk_component(txt) component text] mark set limit insert
    [$itk_component(txt) component text] mark gravity limit left
    focus $itk_component(txt)
    # Keybindings that limit input and eval things
    bind [$itk_component(txt) component text] <Return>  "[code $this evalCommand];break"
    bind [$itk_component(txt) component text] <Any-Key> [code $this track %W]
	
    bindtags [$itk_component(txt) component text] \
	    "[$itk_component(txt) component text] Text all"
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# fcdpmsCmdEval::destructor
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body fcdpmsCmdEval::destructor {} {
    
    
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# fcdpmsCmdEval::track 
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body fcdpmsCmdEval::track {W} {
    if [$W compare insert < limit] {
	$W mark set insert end
    }
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# fcdpmsCmdEval::evalCommand
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body fcdpmsCmdEval::evalCommand {} {
    set command [$itk_component(txt) get limit end]
    set command [string trim $command \n]
    if {$command != ""} {
	set reply [execute $command]
	regsub ^OK, $reply "" rc 
	$itk_component(txt) insert insert "\n $reply\n" reply
    } else {
	$itk_component(txt) insert insert "\n"
    }
    incr cmdcnt
    set prompt " <$cmdcnt> % "
    $itk_component(txt) insert insert $prompt prompt
    [$itk_component(txt) component text] see insert 
    [$itk_component(txt) component text] mark set limit insert

}
