#*******************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: fcdpmsCmdIf.tcl,v 1.20 2004/01/16 15:28:28 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# hpieper  10/07/97  created
#

#************************************************************************
#   NAME
# 
#   SYNOPSIS
# 
#   DESCRIPTION
#
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#
#   SEE ALSO
#
#   BUGS     
#
#------------------------------------------------------------------------
#
#-----------------------------------------------------------------------
# first setup the necessary information where to look for 
# the interface libraries


itk::usual fcdpmsCmdIf {
    keep -short_help
}



class fcdpmsCmdIf {
    inherit  itk::Widget fcdpmsPHW
    constructor             {unit_ args} {}
    destructor                     {}

    itk_option define       -env        env      Env       ""
    itk_option define       -ttyname    ttyname  TTYname   ""
    itk_option define       -short_help   short_help      Short_help ""

    private  variable       PER_ID
    private  variable       SW_VERSION  "??"
    private  variable       LOG_PROC
    private  variable       LOG_TIME
    private  variable       PAR
    private  variable       SERVER     "fcdpServer"
    private  variable       HEATER
    # the directory name and 
    # the filename of the file containing the
    # PULPO Configuration information
    public   variable       cfgDIR     "."
    public   variable       cfgFILE    "./pulpo.cfg"
    # the server we want to talk to
    #the number of sensores supported
    public   variable       NOF_SENSORS "6"
    #the number of heaters supported
    public   variable       NOF_HEATERS "3"
   
    public   method onGetCmd     {}
    public   method init         {}
    public   method getTime      {}
    public   method getSensorVal {sID}     {}
    public   method logSensorVal {enable}
    public   method pDoLog       {sID t}   {}
    public   method wipeScreen   {}

    public   method getCfg       {}
    public   method setCfg       {}
    public   method save         {}
 
    public   method         write          {str} {
	$itk_component(txt) insert end $str
	$itk_component(txt) see end
    }
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# fcdpmsCmdIf::constructor
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body fcdpmsCmdIf::constructor {unit_ args} {
    set unit $unit_
    
    if {[llength $args] != 0 } {
	eval itk_initialize $args
    }
    set serverenv $itk_option(-env)
    # add the unit specific menu bar, commands and labels

    itk_component add menubar {
	frame $itk_interior.menubar -relief raised -bd 2
    } {
	usual
	ignore -background
    }
 
    itk_component add mb1 {
	menubutton $itk_component(menubar).mb2 -text "Option"\
		-underline 0 -width 8
    } {
	usual
	ignore -background
    }
    itk_component add mb2 {
	menubutton $itk_component(menubar).mb3 -text "View"\
		-underline 0 -width 8
    } {
	usual
	ignore -background
    }

    itk_component add mb3 {
	menubutton $itk_component(menubar).mb5 -text "Help"\
		-underline 0 -width 8
    } {
	usual
	ignore -background
    }
    $itk_component(mb1) config -menu $itk_component(mb1).menu
    $itk_component(mb2) config -menu $itk_component(mb2).menu
    $itk_component(mb3) config -menu $itk_component(mb3).menu
    set menu1 [menu $itk_component(mb1).menu -tearoff 0]	
    set menu2 [menu $itk_component(mb2).menu -tearoff 0]
    set menu3 [menu $itk_component(mb3).menu -tearoff 0]    

    
    $menu1 add command -label "Preferences"\
	    -command {}
    $menu2 add command -label "Clear Console Display"\
	    -command [code $this wipeScreen]
    $menu3 add command -label "About Fcdpms"\
	    -command {}
    itk_component add cfr {
	frame $itk_interior.cfr -relief flat -bd 0
    }
    itk_component add cfrl {
	frame $itk_component(cfr).cfrl -relief ridge -bd 2
    }
    itk_component add cfrr {
	frame $itk_component(cfr).cfrr -relief ridge -bd 2
    }
    itk_component add periphSel {
	tabnotebook $itk_component(cfrr).periphSel \
		-tabpos e \
		-angle 15 \
		-foreground yellow \
		-width 650 \
		-height 300
    } {
	ignore -background -foreground
    }
    itk_component add sensorFrame {
	fcdpmsSensorFrame $itk_component(cfrl).sensorFrame \
		$unit \
		-short_help $itk_option(-short_help)
    } {
	usual
    }

    
    itk_component add console {
        fcdpmsCmdEval $itk_component(cfrr).console $unit
    }
    
    pack $itk_component(mb1) -side left
    pack $itk_component(mb2) -side left
    pack $itk_component(mb3) -side left

    pack $itk_component(menubar) -anchor nw  -fill x   

    $itk_component(periphSel) add -label "Generic"		
    itk_component add generic {
	fcdpmsGeneric [$itk_component(periphSel) childsite "Generic"].generic \
		$unit \
		-short_help $itk_option(-short_help)
    } {
	usual
    }
    pack $itk_component(generic) -padx 2 -pady 2 -side left -expand true -fill x
    after idle [$itk_component(generic) getValues;$itk_component(generic) reset]
    
    for {set i 1} {$i <= $NOF_HEATERS} {incr i} {
	set name h$i
	$itk_component(periphSel) add -label "Heater $i"		
	itk_component add $name {
	    fcdpmsHeater [$itk_component(periphSel) childsite "Heater $i"].$name \
		    $unit \
		    $i \
		    -short_help $itk_option(-short_help)
	} {
	    usual
	}
	pack $itk_component(h$i) -padx 2 -pady 2 -side left -expand true -fill x
	after idle [$itk_component(h$i) getValues;$itk_component(h$i) reset]
    }
    $itk_component(periphSel) select 0    
    
    itk_component add status {
	fcdpmsStatus $itk_component(cfrl).status \
		$unit \
		-short_help $itk_option(-short_help)
    } {
	usual
    }
    
    pack $itk_component(sensorFrame) -side top -fill x
    pack $itk_component(status) -side top -fill x
    
    pack $itk_component(periphSel) -side top -fill both -expand true
    pack $itk_component(console) -side top -fill both -expand true
    pack $itk_component(cfrl) -side left -fill x -expand true
    pack $itk_component(cfrr) -side left -fill both -expand true
    pack $itk_component(cfr) -side top -fill x -expand true

    set SW_VERSION [getSWVersion]

    after idle [$itk_component(status) getValues]
    
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# fcdpmsCmdIf::destructor
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body fcdpmsCmdIf::destructor {} {
    

}
    
body fcdpmsCmdIf::wipeScreen {} {
    $itk_component(console) clear
}
body fcdpmsCmdIf::onGetCmd  {} {
    set i 0
    if {[set cmd [$itk_component(cmd) get]] == ""} {
	return
    }
    
    write "<$cmd> [execute $cmd]\n"
    $itk_component(cmd) clear
}


#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# fcdpmsCmdIf::init
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body fcdpmsCmdIf::init {} {
    for {set i 1} {$i <= $NOF_HEATERS} {incr i} {
	set name h$i
	$itk_component($name) getValues
	$itk_component($name) reset
    }

    $itk_component(generic) getValues
    $itk_component(generic) reset
}

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# fcdpmsCmdIf::getTime
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body fcdpmsCmdIf::getTime {} {
#    global seq_ccsEnvName

    set msg [execute "ST"]
    regsub ^OK, $msg "" time
    return $time
}

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# fcdpmsCmdIf::pDoLog
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body fcdpmsCmdIf::pDoLog {sID t} {
   
    write "<[incr LOG_TIME($sID)]> sensor $sID : [getSensorVal $sID]\n"
    
    set LOG_PROC($sID) [after $t [code $this pDoLog $sID $t]] 
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# fcdpmsCmdIf::logSensorVal
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body fcdpmsCmdIf::logSensorVal {enable} {

    if {$enable == 1} {
	set pdlg [dialog $itk_interior.#auto \
		-title "Log Periodically" -modality application]
	$pdlg hide Apply
	set cs [$pdlg childsite]
	
	set nSensors $NOF_SENSORS
	$pdlg hide Apply
	$pdlg hide Help
	$pdlg buttonconfigure OK -text Ok \
	    -command [code "$pdlg deactivate Ok"]
	$pdlg buttonconfigure Cancel -text Cancel \
	    -command [code "$pdlg deactivate Cancel"]
	set t 10
	set sID 1
	entryfield $cs.sID \
		-labeltext "Sensor ID :" \
		-textvariable sID \
		-validate "forcePosInt %P 1 $nSensors"
	entryfield $cs.t \
		-labeltext "T.(ms)    :" \
		-textvariable t 
	pack $cs.sID -padx 5 -pady 5 -side top -fill x -expand true
	pack $cs.t -padx 5 -pady 5 -side top -fill x -expand true
	$pdlg center

	switch [$pdlg activate] {
	    Ok {
		set sID [$cs.sID get]
		set t [$cs.t get]
		
		if {($sID > 0) && ($t > 0) && ($t < 100000) && \
			![info exists LOG_PROC($sID)]} {
		    set LOG_TIME($sID) 0
		    set time [getTime]
		    write "$time. logging sensor $sID val every $t ms."
		    set LOG_PROC($sID) [after $t [code $this pDoLog $sID $t]]
		   
		}
	    }
	}
	
	write "\n"
    } elseif {$enable == 0} {
	set pdlg [dialog $itk_interior.#auto \
		-title "Stop Logging" -modality application]
	$pdlg hide Apply
	set cs [$pdlg childsite]
	
	set nSensors $NOF_SENSORS
	$pdlg hide Apply
	$pdlg hide Help
	$pdlg buttonconfigure OK -text Ok \
	    -command [code "$pdlg deactivate Ok"]
	$pdlg buttonconfigure Cancel -text Cancel \
	    -command [code "$pdlg deactivate Cancel"]
	set t 10
	set sID 1
	entryfield $cs.sID \
		-labeltext "Sensor ID :" \
		-textvariable sID \
		-validate "forcePosInt %P 1 $nSensors"
	
	pack $cs.sID -padx 5 -pady 5 -side top -fill x -expand true
	$pdlg center

	switch [$pdlg activate] {
	    Ok {
		set sID [$cs.sID get]
		
		if {$sID > 0} {
		    if {[info exists LOG_PROC($sID)]} {
			after cancel $LOG_PROC($sID) 
			write "stopping logging of sensor $sID."
			unset LOG_PROC($sID)
		    }
		    
		}
	    }
	}
    } elseif {$enable == 2} {
	foreach sID [array names LOG_PROC] {
	    after cancel $LOG_PROC($sID) 
	    write "stopping logging of sensor $sID."
	    unset LOG_PROC($sID)
	}
    }
	
	write "\n"	
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# fcdpmsCmdIf::getSensorVal
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body fcdpmsCmdIf::getSensorVal {sID} {    
    set cmd "SE,$sID"    
    set msg [execute $cmd]
    return $msg
}

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# fcdpmsCmdIf::getCfg
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body fcdpmsCmdIf::getCfg {} {
    
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# fcdpmsCmdIf::setCfg
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body fcdpmsCmdIf::setCfg {} {

}

body fcdpmsCmdIf::save {} {
    set pSel [classWESFileSel $itk_interior.#auto -title "Save Display" \
	    -directory [pwd] -fileson 1]
    $pSel center

    switch -exact [$pSel activate] {
	"OK" {
	    set f [$pSel get]
	    if [file isfile $f] {
		set d [messagedialog $itk_interior.#auto -title "Warning" -bitmap info\
			-text "Overwrite $f"]
		$d hide Help
		$d hide Apply
		$d buttonconfigure OK -text Ok \
			-command [code "$d deactivate OK"]
		$d buttonconfigure Cancel -text Cancel \
			-command [code "$d deactivate Cancel"]
		$d center
		switch -exact [$d activate] {
		    
		    Cancel {
			 delete object $d
			return
		    }
		}
		delete object $d
	    }
	}
	Cancel {
	    return
	}
	
    }

   
    set text [$itk_component(txt) get 0.0 end]
    if [catch {open $f w} outFileID] {
	bell
	return
    } else {	
	puts "writing to $f"
	foreach l [split $text \n] {
	    puts $outFileID $l
	}
	close $outFileID			    
    }

    delete object $pSel
}

#
# ___oOo___
