#*******************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: fcdpmsHeater.tcl,v 1.20 2004/01/16 15:28:28 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# hpieper  15/09/97  created
#

#************************************************************************
#   NAME
# 
#   SYNOPSIS
# 
#   DESCRIPTION
#
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONSx
#
#   EXAMPLES
#
#   SEE ALSO
#
#   BUGS     
#
#------------------------------------------------------------------------
#

itk::usual fcdpmsHeater {}

class fcdpmsHeater {
    inherit itk::Widget fcdpmsHeaterPeriph
    constructor             {unit_ hid_ args} {}
    destructor                     {}

    itk_option   define    -short_help  short_help Short_help ""

    private  variable      name      "Heater 1"    
    private  variable      hid       "1"
    private  variable      unit      ""

    public   method       getValues {}
    public   method       reset     {}

};#fcdpmsHeater

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# fcdpmsHeater::constructor
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body fcdpmsHeater::constructor {unit_ hid_ args} {
    set unit $unit_
    set hid $hid_

    set name "Heater $hid"
    itk_component add mfr {
	scrolledframe  $itk_interior.mfr \
		-vscrollmode static \
		-hscrollmode static \
		-width 250 \
		-height 300
    } {
	usual
	ignore -width -height 
	keep -background -foreground
    }
    itk_component add lfr {
	frame $itk_interior.lfr
    } {
	ignore -relief
    }
    itk_component add label_name {
	label $itk_component(lfr).label_name \
		-text "Name" \
		-justify left \
		-anchor nw \
		-width 15 \
		-relief flat \
		-bd 2
    } {
	usual
	ignore -relief -font
	ignore -background
	ignore -foreground
    }    
    itk_component add label_entry {
	label $itk_component(lfr).label_entry \
		-text "Value"  \
		-justify left \
		-anchor nw \
		-width 15 \
		-relief flat \
		-bd 2
    } {
	usual
	ignore -relief -font
	ignore -background
	ignore -foreground
    }    
    itk_component add label_ival {
	label $itk_component(lfr).label_ival \
		-text "Initial" \
		-justify left \
		-relief flat -bd 2 \
		-anchor nw \
		-width 8
    } {
	usual
	ignore -relief -font
	ignore -background
	ignore -foreground
    }
    itk_component add label_min {
	label $itk_component(lfr).label_min \
		-text "Min." \
		-justify left \
		-relief flat -bd 2 \
		-anchor nw \
		-width 8
    } {
	usual
	ignore -relief -font
	ignore -background
	ignore -foreground
    }
    itk_component add label_max {
	label $itk_component(lfr).label_max \
		-text "Max." \
		-justify left \
		-relief flat -bd 2 \
		-anchor nw \
		-width 8
    } {
	usual
	ignore -relief -font
	ignore -background
	ignore -foreground
    }
    itk_component add label_base {
	label $itk_component(lfr).label_base \
		-text "Base" \
		-justify left \
		-relief flat -bd 2 \
		-anchor nw \
		-width 8
    } {
	usual
	ignore -relief -font
	ignore -background
	ignore -foreground
    }

    if {[llength $args] != 0 } {
	eval itk_initialize $args
    }
    $itk_option(-short_help) add_short_help $itk_component(hull) "Press mouse button <3> \
	    over Peripheral Name for popup menu"
    foreach field {name entry ival min max base} {
	pack $itk_component(label_$field) -padx 2 -side left  -expand 0
    }
    pack $itk_component(lfr) -padx 2 -side top -fill x
    foreach periph $PERIPHLIST {
	set name "FCDP_HEATER$hid\_[lindex $periph 1]" 
	set LOOKUP($name) [fcdpmsPeriph [$itk_component(mfr) childsite].#auto \
		$unit \
		[lindex $periph 0] \
		$name]	
	pack $LOOKUP($name) -padx 2 -anchor nw -expand true
	
    }
    
    pack $itk_component(mfr) -padx 2 -pady 2 -side top -fill both -expand true

# AB   [$itk_component(mfr) component lwchildsite] configure \
# AB	    -relief ridge -bd 2    
    
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# fcdpmsHeater::destructor
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body fcdpmsHeater::destructor {} {    

}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# fcdpmsHeater::getValues
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body fcdpmsHeater::getValues {} {

    foreach periph [array names LOOKUP] {	
	$LOOKUP($periph) getVal
    }
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# fcdpmsHeater::reset
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body fcdpmsHeater::reset {} {

    foreach periph [array names LOOKUP] {	
	$LOOKUP($periph) resetVal
    }
}

#
# ___oOo___
