#*******************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: fcdpmsPHW.tcl,v 1.20 2004/01/16 15:28:29 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# hpieper  27/10/97  created
#

#************************************************************************
#   NAME
# 
#   SYNOPSIS
# 
#   DESCRIPTION
#
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#
#   SEE ALSO
#
#   BUGS     
#
#------------------------------------------------------------------------
#

itk::usual fcdpmsPHW {}

class fcdpmsPHW {
    constructor             {args} {}
    destructor                     {}

    protected common         console    ""
    protected common         serverenv  ""
    private   common         servername "fcdpServer"

    protected variable       unit       ""
    private   variable       cmdID      ""

    public    method         connect   {unit_ serverenv_}
    public    method         execute   {cmd}
    
    public    method         getpInit   {peripheral}
    public    method         getpVal   {peripheral}
    public    method         getpBase  {peripheral}
    public    method         getpRange {peripheral}

    public    method         getSWVersion {}
    public    method         setpval   {peripheral val}
    public    method         getSensor {sensorID}
    public    method         getStatus {wordID}
}

body fcdpmsPHW::constructor {args} {
    
}

body fcdpmsPHW::destructor {} {
    
}

body fcdpmsPHW::connect {unit_ serverenv_} {
    set unit $unit_

    set cmdID [seq_msgSendCommand $serverenv $servername PING ""]
   
    set msg [seq_msgRecvReply $cmdID errNr -all]
    if {$errNr != 0} {
        puts stderr "Error on receiving message for cmd $cmdID"
	return {}
    }
    
    set cmdID [seq_msgSendCommand $serverenv $servername $unit "GUT"]
    set msg [seq_msgRecvReply $cmdID errNr -all]
    if {$errNr != 0} {
        puts stderr "Error on receiving message for cmd $cmdID"
	return {}
    }

    return $msg
}

body fcdpmsPHW::getSWVersion {} {
    set reply [execute "VS"]
    if [regexp OK $reply] { 
	regsub ^OK, $reply "" rc 
    } else {
	set rc "-1" 
    }
    return $rc
}

body fcdpmsPHW::execute {cmd} {
    #puts "excuting CMD $cmd"
    set cmdID [seq_msgSendCommand $serverenv $servername $unit $cmd]
    set msg [seq_msgRecvReply $cmdID errNr -all]
    if {$errNr != 0} {
	#an error has occurred
        #puts stderr "Error on receiving message for cmd $cmdID"
	puts "reply $msg"
    }
    return $msg
}

body fcdpmsPHW::getSensor {sensorID} {
    set reply [execute "SE,$sensorID"]
    if [regexp OK $reply] { 
	regsub ^OK, $reply "" rc 
    } else {
	set rc "-1" 
    }
    return $rc
}

body fcdpmsPHW::getStatus {wordID} {
    set reply [execute "SB,$wordID"]
    if [regexp OK $reply] { 
	regsub ^OK, $reply "" rc 
    } else {
	set rc "-1" 
    }
    return $rc
}

body fcdpmsPHW::getpVal {peripheral} {    
    set reply [execute "GTV,$unit,$peripheral"]
    if [regexp OK $reply] { 
	regsub ^OK, $reply "" rc 
    } else {
	set rc "-1" 
    }
    return $rc
}

body fcdpmsPHW::getpBase {peripheral} {
    set reply [execute "GVB,$unit,$peripheral"]
    if [regexp OK $reply] { 
	regsub ^OK, $reply "" rc 
    } else {
	set rc "-1" 
    }
    return $rc
}

body fcdpmsPHW::getpInit {peripheral} {
    set reply [execute "GIV,$unit,$peripheral"]
    if [regexp OK $reply] { 
	regsub ^OK, $reply "" rc 
    } else {
	set rc "-1" 
    }
    return $rc
}

body fcdpmsPHW::getpRange {peripheral} {
    set reply [execute "GVR,$unit,$peripheral"]
    if [regexp OK $reply] { 
	regsub ^OK, $reply "" rc 
	set rc [split $rc \,]
    } else {
	set rc "-1" 
    }
    return $rc
}

body fcdpmsPHW::setpval {peripheral val} {    
    set reply [execute "STV,$unit,$val,$peripheral"]
    if [regexp OK $reply] { 	
	set rc 0
    } else {
	set rc "-1" 
    }
    return $rc
}
#
# ___oOo___
