#*******************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: fcdpmsPeriph.tcl,v 1.20 2004/01/16 15:28:30 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# hpieper  15/10/97  created
#

#************************************************************************
#   NAME
# 
#   SYNOPSIS
# 
#   DESCRIPTION
#
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#
#   SEE ALSO
#
#   BUGS     
#
#------------------------------------------------------------------------
#


itk::usual fcdpmsPeriph {
    ignore -font
}

class fcdpmsPeriph {    
    inherit itk::Widget fcdpmsPHW

    constructor             {unit_ periphname_ periphid_ args} {}
    destructor                     {}

    private  common     VAL
    private  common     BASE
    private  common     INIT
    private  common     MIN
    private  common     MAX
    private  variable   name       ""
    private  variable   id         ""
    
    public   method     showProp   {} {}
    public   method     getVal     {} {}
    public   method     setVal     {} {}
    public   method     resetVal   {} {}
    public   method     popupMenu     {} {}
}

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# fcdpmsPeriph::constructor
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body fcdpmsPeriph::constructor {unit_ periphname_ periphid_ args} {
    set unit $unit_
    set name $periphname_
    set id $periphid_        

    itk_component add label_$id {
	label $itk_interior.label_$id \
		-text $name \
		-justify left \
		-anchor nw \
		-width 15 \
		-relief flat \
		-bd 2
    } {
	usual
	ignore -relief -font
	ignore -background
	ignore -foreground
    }    
    itk_component add entry_$id {
	entry $itk_interior.entry_$id \
		-relief sunken \
		-width 10 \
		-justify right \
		-textvariable [scope VAL($this)]
    } {
	usual
	ignore -foreground -background -font	
    }
    itk_component add ival_$id {
	label $itk_interior.ival_$id \
		-textvariable [scope INIT($this)] \
		-justify center \
		-relief groove -bd 2 \
		-anchor nw \
		-width 8
    } {
	usual
	ignore -relief -font
	ignore -background
	ignore -foreground
    }
    itk_component add min_$id {
	label $itk_interior.min_$id \
		-textvariable [scope MIN($this)] \
		-justify center \
		-relief groove -bd 2 \
		-anchor nw \
		-width 8
    } {
	usual
	ignore -relief -font
	ignore -background
	ignore -foreground
    }
    itk_component add max_$id {
	label $itk_interior.max_$id \
		-textvariable [scope MAX($this)] \
		-justify center \
		-relief groove -bd 2 \
		-anchor nw \
		-width 8
    } {
	usual
	ignore -relief -font
	ignore -background
	ignore -foreground
    }
    itk_component add base_$id {
	label $itk_interior.base_$id \
		-textvariable [scope BASE($this)] \
		-justify center \
		-relief groove -bd 2 \
		-anchor nw \
		-width 8
    } {
	usual
	ignore -relief -font
	ignore -background
	ignore -foreground
    }
    itk_component add popupMenu {
	menu $itk_interior.menu -tearoff 0
    } {
	usual
	ignore -tearoff
    }
    $itk_component(popupMenu) add command \
	    -label "Read" \
	    -command [code $this getVal]
    $itk_component(popupMenu) add command \
	    -label "Reset to Startup" \
	    -command [code $this resetVal]
    $itk_component(popupMenu) add command \
	    -label "Write" \
	    -command [code $this setVal]
    $itk_component(popupMenu) add command \
	    -label "Poperties" \
	    -command [code $this showProp]

    if {[llength $args] != 0 } {
	eval itk_initialize $args
    }           
    
    bind $itk_component(entry_$id) <Return> "[code $this setVal];break"
    bind $itk_component(label_$id) <Enter> \
	    [code "$itk_component(label_$id) configure -relief groove -bd 2"]
    bind $itk_component(label_$id) <Leave> \
	    [code "$itk_component(label_$id) configure -relief flat -bd 2"]
    bind $itk_component(label_$id) <Button-3> \
	    [code $this popupMenu]
    pack $itk_component(label_$id) -padx 2 -side left -fill x -expand true
    pack $itk_component(entry_$id) -padx 2 -side left -fill x -expand true
    pack $itk_component(ival_$id) -padx 2 -side left -fill x -expand true
    pack $itk_component(min_$id) -padx 2 -side left -fill x -expand true
    pack $itk_component(max_$id) -padx 2 -side left -fill x -expand true
    pack $itk_component(base_$id) -padx 2 -side left -fill x -expand true

}

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# fcdpmsPeriph::getVal
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body fcdpmsPeriph::getVal {} {
    if {($unit == "") || ($id == "")} {
	return ""
    }
    set BASE($this) [getpBase $id]
    set VAL($this)  [getpVal $id] 
    set INIT($this) [getpInit $id]
    if {[set range  [getpRange $id]] != -1} {
	set MIN($this) [lindex $range 0]
	set MAX($this) [lindex $range 1]
    }
}

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# fcdpmsPeriph::showProp
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body fcdpmsPeriph::showProp {} {
    set message\
	    "Peripheral ID : $id\n\
	    Pulpo Unit ID : FCDP_PULPO_$unit\n\n\
	    Range         : $MIN($this) - $MAX($this)\n\
	    Base          : $BASE($this)\n\n\
	    Initial Value : $INIT($this)\n\
	    (see pulpo.dat)\n\n"

    info_dialog $message
}

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# fcdpmsPeriph::setVal
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body fcdpmsPeriph::setVal {} {
    if {($unit == "") || ($id == "")} {
	return ""
    }   
    if {[setpval $id $VAL($this)] != -1} {
    
    }
}

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# fcdpmsPeriph::resetVal
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body fcdpmsPeriph::resetVal {} {
    if {($unit == "") || ($id == "")} {
	return ""
    }   
    
    if {[setpval $id $INIT($this)] != -1} {
	set VAL($this) $INIT($this)
    }
}

body fcdpmsPeriph::popupMenu {} {
    set w $itk_component(label_$id)
    tk_popup $itk_component(popupMenu) \
	    [expr [winfo rootx $w] + [winfo reqwidth $w]] \
	    [winfo rooty $w]
}

#
# ___oOo___
