#*******************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: fcdpmsSLogCfgDlg.tcl,v 1.20 2004/01/16 15:28:34 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# hpieper  03/11/97  created
#

#************************************************************************
#   NAME
# 
#   SYNOPSIS
# 
#   DESCRIPTION
#
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#
#   SEE ALSO
#
#   BUGS     
#
#------------------------------------------------------------------------
#

itk::usual fcdpmsSLogCfgDlg {}

class fcdpmsSLogCfgDlg {
    inherit util::TopLevelWidget
    
    itk_option         define   -dir  dir   Dir ""  
    itk_option         define   -file file  File  "" {
	set fullpath($this) $itk_option(-file)
    }
    itk_option         define   -timeout timeout Timeout "0" {
	set timeout($this) $itk_option(-timeout)
    }
    itk_option         define   -logtitle   title Title "" {
	set logtitle($this) $itk_option(-logtitle)
    }
    protected   common result 
    protected   common fullpath
    protected   common timeout
    protected   common logtitle
    constructor        {args} {

	itk_component add top {
	    frame $w_.top -borderwidth 3 -relief groove
	}

	itk_component add left {
	    frame $itk_component(top).left -borderwidth 3 -relief groove
	}	
	
	itk_component add right {
	    frame $itk_component(top).right -borderwidth 3 -relief groove
	}
	
	itk_component add selection {
	    entryfield $itk_component(right).selection \
		    -labeltext "Selection" \
		    -textvariable [scope fullpath($this)]		    
	}
	itk_component add timeout {
	    entryfield $itk_component(right).timeout \
		    -labeltext "Timeout (1s < T < 3600s)" \
		    -textvariable [scope timeout($this)] \
		    -validate numeric
	}
	itk_component add logtitle {
	    entryfield $itk_component(right).logtitle \
		    -labeltext "Log Title" \
		    -textvariable [scope logtitle($this)] 
	}
	itk_component add viewer {
	    Fileviewer $itk_component(left).viewer \
		    -troughcolor NavyBlue \
		    -selectcommand [code $this select %n]
	}	
	# button Row
	itk_component add btns {
	    util::ButtonFrame $w_.btns \
		  -ok_label "Set" \
		  -ok_cmd [code $this ok] \
		  -cancel_cmd [code $this quit]
	}
	set lw1 $itk_component(selection)
	set lw2 $itk_component(timeout)
	set lw3 $itk_component(logtitle)
	Labeledwidget::alignlabels $lw1 $lw2 $lw3
	if {[llength $args] != 0 } {
	    eval itk_initialize $args
	}
	
	#set fullpath($this)   $itk_option(-file)
	#set timeout($this)    $itk_option(-timeout)
	pack $itk_component(viewer) -side top -fill x -expand true -padx 4 -padx 4
	pack $itk_component(selection) -side top -fill x -expand true -padx 4 -padx 4
	pack $itk_component(timeout) -side top -fill x -expand true -padx 4 -padx 4
	pack $itk_component(logtitle) -side top -fill x -expand true -padx 4 -padx 4

	pack $itk_component(left) \
	    -anchor nw -fill both -expand 1 
	pack $itk_component(right) \
	    -anchor nw -fill x -expand 1
	pack $itk_component(top) \
	    -side top -fill both -expand 1
	pack $itk_component(btns) \
		-side bottom -fill x -expand 1 -ipady 1m			
	
    }
    destructor         {}

   
    method select {sel} {
	set fullpath($this) $sel
	
    }
    method display {dir} {
	$itk_component(viewer) display $itk_option(-dir)
	set $fullpath($this) $dir
    }
    
    method ok {} {   
	if {($fullpath($this) != "") &&\
		($timeout($this) != "") &&\
		($logtitle($this) != "")} {	
	    set result [list $fullpath($this) $timeout($this) $logtitle($this)]
	}	 
    }
    method quit {} {
	set result ""
	
    }
    
    method activate {} {
	
	vwait [scope result]
	wm withdraw $w_
	return $result
    }
    
}

proc sensor_log_dialog {{timeout 0} {logfile ""} {logtitle ""} {title ""} {parent ""}} {
    global env
    if {"$parent" != ""} {
	if {"[set parent [winfo toplevel $parent]]" == "."} {
	    set parent ""
	}
    }
    if {$logfile != ""} {
	if [catch [set dir [file dirname $logfile]]] {
	   set dir $env(HOME)
	}
    } else {
	set dir $env(HOME)

    }

    set w $parent.sensor_log_dialog
    if [winfo exists $w] {
	set d $w
	$w configure -dir $dir \
		-timeout $timeout \
		-logtitle $logtitle \
		-file $logfile \
		-title $title
	wm deiconify $w	
    } else {
	set d [fcdpmsSLogCfgDlg $w \
		-title $title \
		-dir $dir \
		-timeout $timeout \
		-logtitle $logtitle \
		-file $logfile \
		-transient 1]
    }
    $w display $dir
    return [$d activate]
}

#
# ___oOo___
