#*******************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: fcdpmsStatus.tcl,v 1.20 2004/01/16 15:28:31 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# hpieper  15/09/97  created
#

#************************************************************************
#   NAME
# 
#   SYNOPSIS
# 
#   DESCRIPTION
#
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#
#   SEE ALSO
#
#   BUGS     
#
#------------------------------------------------------------------------
#

itk::usual fcdpmsStatus {
        keep -short_help
}

class fcdpmsStatus {
    inherit iwidgets::Labeledwidget fcdpmsStatusPeriph

    itk_option define -short_help short_help Short_help  ""

    constructor             {unit_ args} {}
    destructor                     {}

    #methods for logging the status
    public   method logConfigure      {enable interv}
    public   method logStatus         {}
    public   method getValues         {}
};#fcdpmsStatus

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# fcdpmsStatus::constructor
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body fcdpmsStatus::constructor {unit_ args} {
    set unit $unit_

    set i 0
    

    if {[llength $args] != 0 } {
	eval itk_initialize $args
    }
    itk_component add status {
	fcdpmsBulletLog $itk_interior.status \
		    -logproc [code $this logStatus] \
		    -logconfigure {} \
		    -name "Status" \
		    -short_help $itk_option(-short_help) \
		    -orient vert \
		    -valwidth 40 \
		    -valheight 12
    } {	 
	usual
    }          
    pack $itk_component(status) -anchor nw -fill both -expand true
    $this configure -labeltext "Status"
    $this configure -labelpos nw

# AB    $itk_component(lwchildsite) configure -relief ridge -bd 2
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# fcdpmsStatus::destructor
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body fcdpmsStatus::destructor {} {
    
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# fcdpmsStatus::getValues {} 
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body fcdpmsStatus::getValues {} {
    $itk_component(status) log
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# fcdpmsStatus::logConfigure
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body fcdpmsStatus::logConfigure  {enable interv} {
    
    
}; # logStatus

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# fcdpmsStatus::logStatus         {}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body fcdpmsStatus::logStatus {} {
    set i 0
    set stat ""
    foreach periph $PERIPHLIST {
	set name [lindex $periph 1]	
	if {[set val [getStatus [incr i]]] != -1} {
	    set stat "$stat[lookup $name $val]\n"
	}
    }
    return $stat
}; # doLog

#
# ___oOo___
