#*******************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: fcdpmsStatusPeriph.tcl,v 1.20 2004/01/16 15:28:31 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# hpieper  15/10/97  created
#

#************************************************************************
#   NAME
# 
#   SYNOPSIS
# 
#   DESCRIPTION
#
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#
#   SEE ALSO
#
#   BUGS     
#
#------------------------------------------------------------------------
#


itk::usual fcdpmsStatusPeriph {}

class fcdpmsStatusPeriph { 
    inherit fcdpmsPHW
    constructor             {args} {}
    destructor                     {}
    
    private    variable   NOF_BITS  "8"
    private    variable   LOOKUP

    protected  variable   PERIPHLIST   

    protected  method     lookup    {entry word}
}

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# fcdpmsStatusPeriph::constructor
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body fcdpmsStatusPeriph::constructor {args} {

    array set LOOKUP {
	-1              ERROR

	FCDP_STATUS_1,128 LEDen
	FCDP_STATUS_1,64 Dion
	FCDP_STATUS_1,32 Bzon
	FCDP_STATUS_1,16 LNal
	FCDP_STATUS_1,8 VAal
	FCDP_STATUS_1,4 T3al
	FCDP_STATUS_1,2 T2al
	FCDP_STATUS_1,1 T1al
	
	FCDP_STATUS_2,128 ShEr
	FCDP_STATUS_2,64 SRav
	FCDP_STATUS_2,32 SCav
	FCDP_STATUS_2,16 SOav
	FCDP_STATUS_2,8  ShNc
	FCDP_STATUS_2,4  ExAc
	FCDP_STATUS_2,2  ExPa
	FCDP_STATUS_2,1  ShOp
	
	FCDP_STATUS_3,128 S5nc
	FCDP_STATUS_3,64 S4nc
	FCDP_STATUS_3,32 S3nc
	FCDP_STATUS_3,16 S2nc
	FCDP_STATUS_3,8 S1nc
	FCDP_STATUS_3,4 H3nc
	FCDP_STATUS_3,2 H2nc
	FCDP_STATUS_3,1 H1nc

	FCDP_STATUS_4,128 TuAc
	FCDP_STATUS_4,64 DePa
	FCDP_STATUS_4,32 P3on
	FCDP_STATUS_4,16 P2on
	FCDP_STATUS_4,8 P1on
	FCDP_STATUS_4,4 VAnc
	FCDP_STATUS_4,2 S7nc
	FCDP_STATUS_4,1 S6nc

	FCDP_STATUS_5,128 Hcur
	FCDP_STATUS_5,64 BLon
	FCDP_STATUS_5,32 Shrm
	FCDP_STATUS_5,16 Shnd
	FCDP_STATUS_5,8 LOac
	FCDP_STATUS_5,4 Tcse
	FCDP_STATUS_5,2 RCse
	FCDP_STATUS_5,1 RTCe

	FCDP_STATUS_6,128 Spa1
	FCDP_STATUS_6,64 Spa2
	FCDP_STATUS_6,32 GAle
	FCDP_STATUS_6,16 LNAe
	FCDP_STATUS_6,8 VAle
	FCDP_STATUS_6,4 TA3e
	FCDP_STATUS_6,2 TA2e
	FCDP_STATUS_6,1 TA1e

    }



    if {[llength $args] != 0 } {eval configure $args}
    
    lappend PERIPHLIST [list "status byte 1" FCDP_STATUS_1]
    lappend PERIPHLIST [list "status byte 2" FCDP_STATUS_2]
    lappend PERIPHLIST [list "status byte 3" FCDP_STATUS_3]
    lappend PERIPHLIST [list "status byte 4" FCDP_STATUS_4]
    lappend PERIPHLIST [list "status byte 5" FCDP_STATUS_5]
    lappend PERIPHLIST [list "status byte 6" FCDP_STATUS_6]


    
};#constructor
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# fcdpmsStatusPeriph::lookup
#
# returns a string indicatig the settings of the word
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body fcdpmsStatusPeriph::lookup {id word} {
    set result ""
    if [catch {expr $word/1}] {
	return ""
    } 

    for {set i 1} {$i <= 128} {set i [expr $i << 1]} {
	if {($word & $i) == $i} {
	    set result "$result $LOOKUP($id,$i)" 
	} else {
	    set result "$result ~$LOOKUP($id,$i)" 
	}
    }
    return $result
}
#
# ___oOo___
