#*******************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: fileutil.tcl,v 1.20 2004/01/16 15:28:35 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# hpieper  06/11/97  created
#

#************************************************************************
#   NAME
# 
#   SYNOPSIS
# 
#   DESCRIPTION
#          file handling utility functions for reading, writing, 
#                  appending data to files
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#
#   SEE ALSO
#
#   BUGS     
#
#------------------------------------------------------------------------
#


proc util::fcanwrite {f} {
    set result ""

    if [catch {file owner $f}] {
	set result "File \"$f\" not owned by current USER\n"
    }
    if [catch {file readable $f}] {
	set result $result"File \"$f\" not readable\n"
    }
    if [catch {file writable $f}] {
	set result $result"File \"$f\" not writable"
    }
    if {$result == ""} {
	return OK
    } else {
	return $result
    }
}

proc util::fopenr {f desc} {
    upvar $desc  fd 
    
    set result ""
    if [catch {file readable $f}] {
	set result "File \"$f\" not readable\n"
    }
    if [catch {open $f r} fd] {
	set result $result"Cannot open file \"$f\""
    }
    if {$result == ""} {
	return OK
    } else {
	return $result
    }
}

proc util::fopenw {f desc} {
    upvar $desc  fd 

    set result ""
    if [catch {file writable $f}] {
	set result "File \"$f\" not writable\n"
    }
    if [catch {open $f w} fd] {
	set result $result"Cannot open file \"$f\""
    }
    if {$result == ""} {
	return OK
    } else {
	return $result
    }
}

proc util::fopena {f desc} {
    upvar $desc  fd 

    set result ""
    if [catch {file writable $f}] {
	set result "File \"$f\" not writable\n"
    }
    if [catch {open $f a} fd] {
	set result $result"Cannot open file \"$f\""
    }
    if {$result == ""} {
	return OK
    } else {
	return $result
    }
}

proc util::ftruncate {f} {
    set result ""
    if [catch {open $f w} fd] {
	set result "Cannot truncate file \"$f\""
    } else {
	close $fd
    }
    if {$result == ""} {
	return OK
    } else {
	return $result
    }
}


proc util::fname {f} {
    return [file tail $f]
}

proc util::fpath {f} {
    return [file dirname $f]
}

proc util::fexists {f} {
    return [file exists $f]
}

proc util::fcreate {f} {
    set result ""
    if [catch {open $f w} fd] {
	set result "Cannot create file \"$f\""
    } else {
	close $fd
    }
    if {$result == ""} {
	return OK
    } else {
	return $result
    }
}

proc util::fclose {fd} {
    catch {close $fd}
}
#
# ___oOo___
