#*************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: hisSelectPoint.tcl,v 1.33 2004/09/23 09:25:06 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# mcomin  07/11/00  created
#

#************************************************************************
#   NAME
# 
#   SYNOPSIS
# 
#   DESCRIPTION
#
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#
#   SEE ALSO
#
#   BUGS     
#
#------------------------------------------------------------------------
#

proc hisGetAllHistPoint {} {
   global hpList historyPoints numHistPoints histPtSize hpInfoList
   global hpPlin hpAlias hpAbsolute

   # Get list of history points

   if {[cequal [panDbRead ${historyPoints} hpList] FAILURE]} {
      puts "Cannot read attribute $historyPoints"
      return
   }

   # Retrieve alias and absolute names for each history point

   if {[info exists hpPlin]}     { unset hpPlin}
   if {[info exists hpAlias]}    { unset hpAlias}
   if {[info exists hpAbsolute]} { unset hpAbsolute}

   set idx 0

   foreach hpDirAddr $hpList {

      # Skip CCS history table template
      if {[cequal $hpDirAddr "@\[6\]"]} { continue }

      # Loop until the first 'empty' address is found
      if {[cequal $hpDirAddr "@\[\]"]} { break }

      set tmp [hisGetPtNames $hpDirAddr]
      if {[cequal $tmp ""]} { return }

      lassign $tmp nameAbsAddr nameAlias

      set hpPlin($idx)     $hpDirAddr
      set hpAlias($idx)    $nameAlias
      set hpAbsolute($idx) $nameAbsAddr

      incr idx
   }

   set numHistPoints $idx
}

proc hisDisplayHpList {w} {
   global gvar numHistPoints
   global hpPlin hpAlias hpAbsolute

   $w deleteItem 0 end

   if {[cequal $gvar(hpSymbAddr) alias]} {

      for {set idx 0} {$idx < $numHistPoints} {incr idx} {
          $w addItem end [format "%-8s %s"  $hpPlin($idx) $hpAlias($idx)]
      }

   } else {
      for {set idx 0} {$idx < $numHistPoints} {incr idx} {
          $w addItem end [format "%-8s %s"  $hpPlin($idx)  $hpAbsolute($idx)]
      }
   }

}

#
# ___oOo___
