#*******************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: icbpanSensorSqr.tcl,v 1.47 2005/07/01 13:25:36 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# dimarcan  16/11/00  created
#

#************************************************************************
#   NAME
#    icbpanSensorSqr - subclass of icbpanSensor optimizing space in a square
# 
#   SYNOPSIS
#    icbpanSensorSqr .w \
#              -background Grey90 \
#              -relief flat       \
#              -cfgObj $cfgObj    \
#              -cwp "<alias>${devName}" \
#              -devType $devType]
#
#     where cfgObj is a ctooCONFIG object;
#           devType is extracted from INS.CON.DEVICE${i}
#           devName is extracted from ${devType}.DEVNAME
# 
#   DESCRIPTION
#    Subclass of icbpanSensor to handle sensor devices.
#    Sensor values are displayed equally distributed
#    vertically and horizontally.
# 
#   SEE ALSO
#    icbpanSensor(8)
#
#   BUGS     
#
#------------------------------------------------------------------------
#


class icbpanSensorSqr {
   inherit icbpanSensor

   constructor {args} {
      eval icbpanSensor::constructor $args -nCol -1
   } {
   }

}


#
# ___oOo___
