#******************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: inducerLib.tcl,v 1.65 2003/12/17 19:26:26 vltsccm Exp $"
#
# who        when       what
# ---------- ---------- ----------------------------------------------
# S.Sandrock 15.03.1995 created
#

#************************************************************************
#   NAME
#	inducerLib,
#	inducerPuts,
#	inducerDialog,
#	inducerTBD
#	- internal inducer utility procedures
# 
#   SYNOPSIS
# 
#   DESCRIPTION
#
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#
#   SEE ALSO
#
#   BUGS     
#
#------------------------------------------------------------------------
#


###############################################################################
#
#	G L O B A L   V A R I A B L E S
#	"Declaration" of global variables
#
###############################################################################
# Rules: see inducer.tcl
#
###############################################################################


# Variables that can be changed during run-time:
# ---------
if {! [info exists inducer(fDebug)]} {
    set inducer(fDebug)	0		;# enable flag for debugging outputs
}
if {! [info exists inducer(fDialog)]} {
    set inducer(fDialog) 1		;# enable flag for dialog-boxes
}
# not used:
#if {! [info exists inducer(vTimeout)]} {
#   set inducer(vTimeout) 10000		;# timeout in ms for seq_msgRecvReply
#}



###############################################################################
#
#	P R O C E D U R E S
#
###############################################################################
# Rules: see inducer.tcl
#
###############################################################################

proc inducerPuts { Arg } {
    global inducer
    if {$inducer(fDebug)} {
	if {[catch {lindex [info level -1] 0} procname]} {set procname top}
	puts "$procname: $Arg"
    }
}

proc inducerDialog { Message } {
    global inducer
    if {$inducer(fDialog)} {
	tk_dialog .dialog "[wm title .]: Confirm" $Message info 0 OK
    }
}

proc inducerTBD { {What ""} } {
    global inducerTBDflag    ;# array of What's that have already appeared here

    # if no `What' is given explicitly, determine the calling proc-name:
    if {$What == ""} {
	set What [lindex [info level -1] 0]
    }

    # expose a pop-up window, but only if not already done once before:
    if {! [info exists inducerTBDflag($What)]} {
	inducerDialog "Note: $What is not implemented yet"
	set inducerTBDflag($What) 1
    }
}

# ___oOo___
