#*******************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: lcubootLib.tcl,v 1.11 2003/11/11 13:37:01 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# imunoz  30/09/96  created
#

#************************************************************************
#   NAME
# 
#   SYNOPSIS
# 
#   DESCRIPTION
#
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#
#   SEE ALSO
#
#   BUGS     
#
#-----------------------------------------------------------------------

vccInit

proc lcubootPrepareLogFile { Host lcuEnv } {
    global env

    if {! [lempty $Host]} {
	set path [vccRemPath $Host \$VLTDATA]
	if {[lempty $path]} {
	    error "could not resolve VLTDATA in Host $Host"
	    return ""
	}
	set path $path/ENVIRONMENTS/$lcuEnv/lcubootLogFile
    } else {
	set path $env(VLTDATA)/ENVIRONMENTS/$lcuEnv/lcubootLogFile
    }
    vccRemExec $Host  "cp /dev/null $path"
    return $path
}

proc lcubootWatchBoot { lcuEnv } {
    global env gvar 
    
    set host      [vccInfo GetByEnv  $lcuEnv hostName]  
    set bootEnv   [vccInfo GetBootEnvByEnv $lcuEnv]
    set localHost [vccInfo GetByEnv $env(RTAPENV) hostName]
    set bootHost  [vccInfo GetByEnv $bootEnv  hostName]
    
    if {$localHost != $bootHost} {
	set logFile [lcubootPrepareLogFile $bootHost $lcuEnv]
	# mark node to show lcubootLogFile when LCC is ok on that LCU
	lappend gvar(showLog,$lcuEnv) $bootHost:$logFile
	# reboot lcu
	seq_msgSendCommand $lcuEnv lccServer LCCBOOT
	lcustatAddDead "$lcuEnv rebooted"
    } else {
	set logFile [lcubootPrepareLogFile {} $lcuEnv]
	seq_msgSendCommand $lcuEnv lccServer LCCBOOT
	# ask to be checked -> will be displayed in dead list
	lcustatAddDead "$lcuEnv rebooted"
	lcubootMonitorLog $logFile
    }
}

proc lcubootMonitorLog {logFile } {
    global logData logTailProc
    

    trace variable logData w lcubootTraceCB
    blt::bgexec logTailProc -update logData tail -f $logFile
    #vwait logTailProc
}

proc lcubootShowLog { text } {

    set W .lcubootLog	;# window-name of the exec-panel
    
    # If exec-panel exists already, then only put it on top and return:
    if {! [winfo exists $W]} {
	# Build new toplevel window:
	toplevel $W
	wm title $W "[wm title .]: Exec Output"
	wm iconbitmap $W [wm iconbitmap .]
	wm minsize $W 1 1
	# !! -bd and -borderwidth options are not reognized in
	# UifWidgets
	UifText $W.text -relief groove -width 80 -height 25
	frame $W.but
	UifButton $W.but.clear -label "Clear" -width 10 \
		-command [list $W.text deleteText 1.0 end]

	UifButton $W.but.close -label "Close" -width 10 \
	    -command [list lcubootCloseLogWin $W]
	pack $W.text -side top  -padx 1m -pady 1m
	#!! NOTE: the next line is a workaround (geometry bug in UifText ?):
	#pack $W.text.txt -expand yes -fill both
	pack $W.but -side bottom -anchor s -fill x -padx 1m -pady 1m
	pack $W.but.clear -side left  -anchor w
	pack $W.but.close -side right -anchor e
	$W.text insertText end $text	;# show the text
    } else {
	wm deiconify $W			;# make sure that it's not an icon
	#!! NOTE: the `raise' causes sometimes panel blocking. Don't know why!
	#raise $W			;# put window on top
	$W.text insertText end $text	;# show the text

	#!! NOTE: the following bypasses the class's callable interface
	#         uses direct access to the TK text widget inside
	#         UifText
	set textWdg [$W.text getComponentPath uifText]
	$textWdg mark set insert end	;# move cursor to the very end
	$textWdg yview -pickplace end ;# make sure that cursor is visible
    }
}

proc lcubootCloseLogWin { W } {
    global logData logTailProc
    
    set logTailProc {};			
    destroy $W
    set tinfo [trace vinfo logData]
    if {![lempty $tinfo]} {
        trace vdelete logData w lcubotTraceCB
    }
}

proc lcubootTraceCB {name index op} {
    global logTailProc;			# to kill tail process
    upvar $name var

    lcubootShowLog $var
    
    if { [string match "*lcuboot end" $var] } {
	set logTailProc {};		# kill tail process
    }
}