#*******************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: lcustatDb.tcl,v 1.11 2003/11/11 13:37:01 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# imunoz    18/10/96  created
# imunoz    08/11/96  gvar(lcuEnvList) was not properly initialized 
#                     to empty
#

#************************************************************************
#   NAME
# 
#   SYNOPSIS
# 
#   DESCRIPTION
#
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#
#   SEE ALSO
#
#   BUGS     
#
#------------------------------------------------------------------------
#
proc lcustatDbInit { {lock 0} {root ":Appl_data:lcustat"} } {
    global lcustatDb gvar lcustatWd

    set lcustatDb(path) $root.lcuEnvs
    set lcustatDb(lock) $root.lock
    
    # check if branch is available
    if { [seq_catch [list seq_dbReadSymbolic $lcustatDb(path)(0:$,0:1)] \
	    lcustat [info script]] } {
	set msg "DB branch \":Appl_data:lcustat\" needed for lcustat applications "
	append msg "does not exist. Please see user manual to create it."
	tk_dialog .d Error $msg "" 0 OK
	exit
    }

    # if {$lock > 0} {
    # 	if {[info exist gvar(unlock)]} {
    # 	     seq_dbWriteSymbolic $root.lock 0
    # 	}
    # 	set l [seq_dbReadSymbolic $root.lock]
    # 	if {$l > 0} {
    # 	    set msg "Another server is already running"
    # 	    tk_dialog .d Error $msg "" 0 OK
    # 	    exit
    # 	} else {
    # 	    seq_dbWriteSymbolic $root.lock 1
    # 	}
    #     }
    
    set gvar(lcuEnvList) ""
    set lcustatDb(size) [lindex [seq_dbGetAttrInfo $lcustatDb(path)] 2]
    set i 0 
    foreach el $lcustat {
	set lcu  [lindex $el 0]
	if {![lempty $lcu]} {
	    lappend gvar(lcuEnvList) $lcu
	    set lcustatDb($lcu) $i
	    set lcustatWd($lcu) [lindex $el 1]
	}
	incr i
    }
    
    if {[lsearch $gvar(lcuEnvList) l*] < 0} {
	return FAILURE
    }
}

proc lcustatDbReleaseLock { } {
    global lcustatDb

    seq_dbWriteSymbolic $lcustatDb(lock) 0
}

proc lcustatDbAttachEvents { Proc } {
    global lcustatDb

    # REMARK:
    # TABLE attribute can be configured to report
    # only on 'write' events
    set lcustatDb(evt) [seq_evtAttach $lcustatDb(path) w $Proc]
}

proc lcustatDbProcessEvent {data type} {
    global lcustatDb

    if {$type != "TABLE"} {
	puts "Error data type is not a table"
	return
    }
    set start [lindex $data 0]
    set end   [lindex $data 1]
    set elemList [seq_dbReadSymbolic $lcustatDb(path)($start:$end)]

    set len [expr $end-$start +1]
 #   
 #   while {![lempty $elemList]} {
 #	set el [lvarpop elemList]
 #	# do something with it			 
 #	puts "Readed: <[set el]>"
 #   }
}

set dummyList {lte14 lte21 lte23 lte24 lte25 lte26 lte32 lte33 \
	lte38 lte40 lte42 lte46 lte47 lte48 lte50 lte51 lte52 \
	lte66 lte8 lted}

proc lcustatDbWriteTbl { tbl {wd ""}} {
    global lcustatDb 
    
    set sz  [llength $tbl]
    if { $sz> $lcustatDb(size)} {
	set msg "Too many records\n"
	append msg "Max: $lcustatDb(size), \#records: $sz"
	
	tk_dialog .d Error $msg "" 0 OK
	return
    }
    if {![lempty $wd] } {
	upvar  $wd a
    }
    for {set i 0} {$i < $sz} {incr i} {
	set lcu [lvarpop tbl]
	seq_dbWriteSymbolic $lcustatDb(path)($i,0) $lcu
	if {[info exist a($lcu)]} {
	    seq_dbWriteSymbolic $lcustatDb(path)($i,1) $a($lcu)
	}
    }
}
#
# ___oOo___
