#*******************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: lcustatSetup.tcl,v 1.11 2003/11/11 13:37:02 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# imunoz  20/10/96  created
#

#************************************************************************
#   NAME
# 
#   SYNOPSIS
# 
#   DESCRIPTION
#
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#
#   SEE ALSO
#
#   BUGS     
#
#------------------------------------------------------------------------
#
vccInit

proc lcustatSetupInitPanel { } {
    global gvar lcustatDb lcustatWd lcuLocalWd cv

    
    vccWinBusy . {Initializing Panel Data } {	
	lcustatDbInit
	lcustatSetupGetLcus
	# set binding
	$cv.lcuEnvsTbl  setBind <B1-ButtonRelease> \
		[list lcustatSetupSelect $cv.lcuEnvsTbl]
	lcustatSetupListBoxes
    }
}

proc lcustatSetupGetLcus { } {
    global seq_ccsEnvName gvar
    
    set gvar(lcuList) {}
    foreach el  [vccInfo GetEnvs l*] {
	if {[vccInfo GetBootEnvByEnv $el] == $seq_ccsEnvName} {
	    lappend gvar(lcuList) $el
	}
    }
}

proc lcustatSetupAdd { } {
    global cv gvar lcuLocalWd

    set lcu [$cv.lcuEnvsVcc getSelection]
    if {[lempty $lcu]} return
    
    if {![info exist lcuLocalWd($lcu)]} {
	set  lcuLocalWd($lcu) 0
    } elseif { $lcuLocalWd($lcu) > 0 } {
	set lcu "$lcu WD"
    }
    $cv.lcuEnvsVcc deleteItem [$cv.lcuEnvsVcc getIndex]
    $cv.lcuEnvsTbl addItem end $lcu
}

proc lcustatSetupAddAll { } {
    global cv gvar lcuLocalWd
    
    set newList {}
    foreach el  [$cv.lcuEnvsVcc getList] {
	set lcu $el
	if {![info exist lcuLocalWd($el)]} {
	    set  lcuLocalWd($el) 0
	} elseif { $lcuLocalWd($el) > 0 } {
	    set lcu  [list $el WD]
	} 
	lappend newList $lcu
    }
    if {![lempty $newList]} {
	$cv.lcuEnvsTbl addItemList end $newList
        $cv.lcuEnvsVcc configure -itemList {}
    }
}

proc lcustatSetupRemove {} {
    global cv gvar lcuLocalWd
    
    set lcu [lindex [$cv.lcuEnvsTbl getSelection] 0]
    if {[lempty $lcu]} return
    
    #unset lcuLocalWd($lcu)
    
    $cv.lcuEnvsTbl deleteItem [$cv.lcuEnvsTbl getIndex]
    $cv.lcuEnvsVcc addItem end $lcu
}

proc lcustatSetupRemoveAll { } {
    global cv gvar lcuLocalWd
    
    set newList {}
    foreach el  [$cv.lcuEnvsTbl getList] {
	#unset lcuLocalWd($el)
	lappend newList [lindex $el 0]
    }
    if {![lempty $newList]} {
	$cv.lcuEnvsVcc addItemList end $newList
	$cv.lcuEnvsTbl configure -itemList {}
    }
}

proc lcustatSetupApply { } {
    global gvar cv lcustatDb lcuLocalWd
    global seq_ccsEnvName
    

    set wrtList {}    
    foreach el  [$cv.lcuEnvsTbl getList] {
	lappend wrtList [lindex $el 0]
    }
    set sz [$cv.lcuEnvsTbl getSize]
    if {$sz < $lcustatDb(size)} {
	for {set i 0} {$i < [expr $lcustatDb(size)-$sz]} {incr i} {
	    lappend wrtList {}
	}
    }
    lcustatDbWriteTbl $wrtList lcuLocalWd

    # check if lcuwdTrig is running, 
    # if not start it
    if {[lempty [lcustatPingServer lcuwdTrig]]} {
	set prg  [vccFindFile bin/lcuwdTrig]
	if {[lempty $prg]} {
	    set msg "Could not find lcuwdTrig program"
	    tk_dialog .dialog "Dialog Box" $msg info 0 OK
	    return ""
	}
	vccWinBusy . "Starting lcuwdTrig server" {
	    blt::bgexec myVar $prg &
	    # give it 5 sec
	    sleep 5
	    if {[lempty [lcustatPingServer lcuwdTrig]]} {
		puts "could not start server"
		return ""
	    }
	}
    }

    # send init command to lcuwdTrig server
    vccWinBusy . "Sending INIT command to server lcuwdTrig" {
	if {[panSendCommand \
		$seq_ccsEnvName lcuwdTrig INIT ""] == "FAILURE"} {
	    set msg "Could not send command INIT to $seq_ccsEnvName/lcuwdTrig"
	    tk_dialog .dialog "INFO" $msg info 0 OK
	}
    }
}

proc lcustatSetupReset {} {
    global gvar cv lcustatWd
    
    lcustatDbWriteTbl $gvar(lcuEnvList) lcustatWd
    lcustatSetupListBoxes
}

proc lcustatSetupSelect {wdg} {
    global gvar lcustatDb  lcuLocalWd

    set lcu [lindex [$wdg getSelection] 0]
    if {[lempty $lcu]} return 
    #if { ! [info exist lcustatDb($lcu)] } return
    
    set gvar(lcuName) $lcu
    set gvar(lcuWdStart) $lcuLocalWd($lcu)
}

proc lcustatSetupWd { } {
    global gvar lcustatDb lcuLocalWd cv
    
    #if {! [info exist lcustatDb($gvar(lcuName))] } return
    set lcuLocalWd($gvar(lcuName)) $gvar(lcuWdStart) 
    
    set idx [lsearch [$cv.lcuEnvsTbl getList] "$gvar(lcuName)[ ]*"]
    if {$idx < 0} return 
    
    if {  $gvar(lcuWdStart) > 0} {
	set lcu  "$gvar(lcuName) WD"
    } else {
	set lcu $gvar(lcuName)
    }
    $cv.lcuEnvsTbl deleteItem $idx
    $cv.lcuEnvsTbl addItem $idx $lcu
}

proc lcustatSetupListBoxes { } {
    global gvar lcustatWd lcuLocalWd cv

    set lcuEnvsTbl {}
    foreach el $gvar(lcuEnvList) {
	set lcuLocalWd($el) $lcustatWd($el)
	if {$lcustatWd($el)!=0} {
	    set wd "WD"
	} else {
	    set wd ""
	}
	lappend lcuEnvsTbl "$el $wd"
    }
    
    $cv.lcuEnvsTbl configure -itemList $lcuEnvsTbl
    $cv.lcuEnvsVcc addItemList end [lindex \
	    [intersect3 $gvar(lcuList)  $gvar(lcuEnvList)] 0]
}

proc lcustatPingServer { server } {
    global seq_ccsEnvName
   
    if { [catch \
	    "seq_msgSendCommand $seq_ccsEnvName $server PING" cmdId] } {
	return ""
    }
    return [seq_msgRecvReply $cmdId errNr -all -ascii]
}
#
# ___oOo___
