#*************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: logMonitorMenuBar.tcl,v 4.26 2005/10/24 07:59:59 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# mcomin    20/03/96  created
#           30/07/96  Changed selectmode to extended
#           28/08/96  Add menu check button to enable/disable scrolling
#

#************************************************************************
#   NAME
# 
#   SYNOPSIS
# 
#   DESCRIPTION
#
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#
#   SEE ALSO
#
#   BUGS     
#
#------------------------------------------------------------------------
#

proc logCreateMenuBar { topMenu } {

   global shArea CheckList EnablelogFont env wname selectBox dispsw dspOffset
   global logStripFlag ckErrOnly ckFitsFilter

   set menuBar [ makeMenuFrame $topMenu ] 
   set mb [addMenu $menuBar  Help  1 right];      # Help Menu

   addMenuCmd $mb "Extended Help"  0  {puts "Not Implemented"}  

   #
   #  File Menu
   #

   set mb [addMenu $menuBar  File  1]; 

   addMenuCmd $mb "Normal    Logs" -1  "logSetType Normal"
   addMenuCmd $mb "Automatic Logs" -1  "logSetType Automatic"
   $mb  add   separator
   addMenuCmd $mb "Select Log File ..." -1  "logSetType User-Defined"
   $mb  add   separator
   addMenuCmd $mb "Extract FITS ..." -1  {exec logFitsDisplay &}
   $mb  add   separator
   addMenuCmd $mb  "Quit"  -1  "logDeleteTailFile; exit"

   #
   #  Screen Menu
   #

   set mb [addMenu $menuBar  Screen  1];
   addMenuRb $mb "Small  Font"  0 logSetListFont logFont small
   addMenuRb $mb "Medium Font"  0 logSetListFont logFont medium
   addMenuRb $mb "Large  Font"  0 logSetListFont logFont large
   $mb add separator
   set logStripFlag 0
   addMenuCk $mb "Enable strip background"   0 "logEnableStrip"  logStripFlag
   $mb add separator
   addMenuCk $mb "Help On Error"  0 "checkHelpOnError .f6"  logHelpOnError    

   set logFont medium

   #
   # Field Selection Menu
   #

   set mb [addMenu $menuBar "Field Selection"  0];

   set wname(dspMENU) $mb

   # Add unformatted output
   addMenuCmd $mb "Default  Fields"  0 {logSetFields default}
   addMenuCmd $mb "Show All Fields"  0 {logSetFields all}

   $mb add separator
   $mb add separator

   set dspOffset 7
   foreach i $selectBox {
       set name  [lindex $i 0]

       addMenuCk $mb [lindex $i 1]  0 "logCheckField $name" dispsw($name)
       set dispsw($name) [lindex $i 2];  # Set default value
   }

    catch { unset dispsw() }

   #
   #  Store Logs
   #

   set mb [addMenu $menuBar "Store Logs"  0];
   addMenuCmd $mb "Select All Logs" 1       "$wname(LOGS) select set 0 end"
   addMenuCmd $mb "Clear Log Selection" 1   "$wname(LOGS) select clear 0 end"
   $mb  add   separator
   addMenuCmd $mb "Store Selected Logs ..." 1  "logStoreFile"

   #
   #  Filter Menu
   #

   set mb [addMenu $menuBar "Filters"  0];
   addMenuCk $mb "FITS Only"    0  logFilterFits      ckFitsFilter  
   addMenuCk $mb "Errors Only"  0  logFilterErrorOnly ckErrOnly
   $mb  add   separator
   addMenuCmd $mb "Clear Filter Menus"  1  logClearFilterMenu
   $mb  add   separator
   addMenuCmd $mb "Other Filters ..."   1  "logConfigOtherFilters $shArea"
   $mb  add   separator
   addMenuCk $mb "Collect Values For Menus"  0  ""  CheckListEnable 
}

# ___oOo___
