#*************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: moteiCFixPos.tcl,v 2.43 2005/04/19 12:32:51 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# pduhoux   05/02/98  created
#

#************************************************************************
#   NAME
#       moteiCFixPos - configure the Fixed-Position
# 
#   SYNOPSIS
#       moteiCFixPos <top>
# 
#   DESCRIPTION
#       The panel contains a set of widgets allowing the setting
#       of the fixed position for this operational mode. 
#
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#       This panel is not intended to be invoked from the UNIX Shell 
#       but only from the configuration panel.
#       It is built using ITCL code, therefore is not editable with the 
#       panel editor.
#
#   EXAMPLES
#
#   SEE ALSO
#       motei(1), moteiMain(7), moteiConfig(7)
#       moteiConfig(7) via the MenuBar Help->Extended Help button of the 
#           Configuration Panel
#
#   BUGS     
#
#------------------------------------------------------------------------
#

proc moteiCFixPos { top } {
   global gvar

   if {[winfo exists $top]} { wm deiconify $top ; raise $top ; return }

   toplevel $top

   set f0 [frame $top.f0 ]
   set fc [frame $top.fc ]

   pack $f0 $fc -pady 5 -fill both

   # Create/Pack  widgets
   label $f0.title -text "Fixed Position" \
                   -font "-Adobe-helvetica-bold-r-normal--24*"
   pack $f0.title -expand 1


   UifButton $fc.close -label Close -command "destroy $top"
   pack $fc.close  -expand 1

   # Variable Initialization

}

#
# ___oOo___
