#*************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: moteiCSetSam.tcl,v 2.43 2005/04/19 12:32:54 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# pduhoux   30/01/98  created
#

#************************************************************************
#   NAME
#       moteiCSetSam - set the status sampling period
# 
#   SYNOPSIS
#       moteiCSetSam <top>
# 
#   DESCRIPTION
#       This panel contains a set of widgets allowing the setting
#       of the status sampling period. 
#
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#       This panel is not intended to be invoked from the UNIX Shell 
#       but only from the control panel.
#       It is built using ITCL code, therefore is not editable with the 
#       panel editor.
#
#   EXAMPLES
#
#   SEE ALSO
#       motei(1), moteiMain(7), moteiControl(7)
#       moteiControl(7) via the MenuBar Help->Extended Help button of the 
#           Control Panel
#
#   BUGS     
#
#------------------------------------------------------------------------
#

proc moteiCSetSam { top } {
   global gvar

   if {[winfo exists $top]} { wm deiconify $top ; raise $top ; return }

   toplevel $top

   set f0 [frame $top.f0 ]
   set f1 [frame $top.f1 ]    
   set f2 [frame $top.f2 ]
   set f3 [frame $top.f3 ]
   set f4 [frame $top.f4 ]
   set f5 [frame $top.f5 ]
   set fb [frame $top.fb ]

   pack $f0 $f1 -pady 5 -fill both
   pack $f2 $f3 $f4 $f5 -pady 0 -fill both
   pack $fb -pady 5 -fill both

   # Create/Pack  widgets
   label $f0.title -text "Status Sampling" \
                   -font "-Adobe-helvetica-bold-r-normal--24*"
   pack $f0.title -expand 1

   UifScale $f1.rate  -length 260 -maxVal 30 -minVal -100 \
	   -variable gvar(samplingRate) -label "Sampling Rate"
   pack $f1.rate -expand 1

   label $f2.help -text "Rate : >  0 : Period in seconds" \
	   -font "-Adobe-courier-medium-r-normal--14*"
   pack $f2.help -side left -padx 10
   label $f3.help -text "          0 : Rate from database" \
	   -font "-Adobe-courier-medium-r-normal--14*"
   pack $f3.help -side left -padx 10
   label $f4.help -text "         -1 : Continuous update" \
	   -font "-Adobe-courier-medium-r-normal--14*"
   pack $f4.help -side left -padx 10
   label $f5.help -text "       < -1 : Frequency in Hz" \
	   -font "-Adobe-courier-medium-r-normal--14*"
   pack $f5.help -side left -padx 10

   UifButton $fb.close -label Close -command "destroy $top"
   UifButton $fb.update -label Update -command moteiInitSampling
   pack $fb.close  -side left -padx 20
   pack $fb.update -side right -padx 20 

   # Variable Initialization
   if {![info exist gvar(samplingRate)]} { set gvar(samplingRate) 0 }
   if {($gvar(samplingRate) < -100) || ($gvar(samplingRate) > 30)} { 
       set gvar(samplingRate) 0 
   }
}

#
# ___oOo___
