#*******************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: moteiSVME4SA.tcl,v 2.43 2005/04/19 12:33:04 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# pduhoux   10/02/98  created
#

#************************************************************************
#   NAME
#       moteiSVME4SA - ESO VME4SA Servo Amplifier status panel
# 
#   SYNOPSIS
#       moteiSVME4SA <args>
#
#   DESCRIPTION
#       The panel moteiSVME4SA.pan contains a full set of output widgets 
#       showing the complete status of the ESO VME4SA Servo Amplifier.
#       All widgets are updated on database change. 
#       The file moteiSVME4SA.tcl contains all associated procedures.
#       
#   FILES
#       
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#       This panel is not intended to be invoked from the UNIX Shell 
#       but only from the main panel.
#
#   EXAMPLES
#
#   SEE ALSO
#       moteiStatus(7) via the MenuBar Help->Extended Help button
#
#   BUGS
#
#------------------------------------------------------------------------
#

proc moteiSVME4SA_CV { what data } {
    global gvar ; set gvar($what) [lindex $data 2]
}

proc moteiSVME4SA_EH { data } {
    global gvar ; set gvar(HOM) [lindex $data 2]
    
    moteiSVME4SA_SWI
}

proc moteiSVME4SA_AS { data } {
    global gvar
    set as [expr {[lindex $data 2] & 0x00FF}]
    set gvar(AS) [format "%02X" $as]
    set gvar(MOD) [expr { $as & 0x03}]
    set gvar(POW) [expr {($as & 0x0C) >> 2}]
    set gvar(LIM) [expr {($as & 0x30) >> 4}]
    moteiSVME4SA_SWI
}

proc moteiSVME4SA_SWI { } {
    global gvar

    set swiSave $gvar(SWI)
    if {$gvar(LIM)} {
	set gvar(SWI) $gvar(LIM)
    } else {
	set gvar(SWI) 0
	if {$gvar(HOM)} {
	    set gvar(SWI) 4
	}
    }
    if {$swiSave != $gvar(SWI)} {
	update idletasks
	after 10
    }
}

proc moteiSVME4SA_BS { data } {
    global gvar
    set bs [expr {[lindex $data 2] & 0x00FF}]
    set gvar(BS)  [format "%02X" $bs]
    set ba [expr {$bs & 0x0F}]
    for {set b 0; set adr 0} {$b < 4} {incr b} {
	if {[expr {($ba & (1 << $b)) >> $b}] == 1} {
	    incr adr [expr {0x1 << (4*(3-$b))}]
	}
    }
    set gvar(ADR) [format "%04X" $adr]
    set gvar(HOT) [expr {($bs & 0x20) >> 4}]
    set gvar(ERR) [expr {($bs & 0x40) >> 5}]
}

#
# ___oOo___











