#******************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: pkginSTEP.tcl,v 1.105 2005/10/12 19:47:35 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# rschmutz  13/05/00  created.
#

#************************************************************************
#   NAME
#	pkginSTEP - pkgin build/install step
# 
#   SYNOPSIS
#	pkginSTEP name -name <name> -cmd <command>
# 
#   DESCRIPTION
#	pkginSTEP is used to execute a build/install step.
#
#   PARENT
#	ctooOBJ_BASE pkginLOG
#
#   PUBLIC METHODS
#	Exec
#	    Executes the step.
#
#   PUBLIC DATA
#	name:    step name.
#	command: command executed by method Exec.
#
#   CAUTIONS
#
#   EXAMPLES
#
#   SEE ALSO
#
#   BUGS
#
#------------------------------------------------------------------------
#


#************************************************************************
#*# class: pkginSTEP
#------------------------------------------------------------------------

class pkginSTEP {
    inherit ctooOBJ_BASE pkginLOG

    #****************************************************************
    #*# constructor
    #----------------------------------------------------------------

    constructor { args } {
    	eval configure $args
	configure -objType STEP
    }

    #****************************************************************
    #*# method: Exec
    #----------------------------------------------------------------

    public method Exec {} {
    	if { "$command" != "" } {
    	    uplevel #0 eval $command
	}
    }

    #****************************************************************
    #*# variables
    #----------------------------------------------------------------

    public variable command ""
}


#************************************************************************
#___oOo___

