#*******************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: plotCursorProcs.tcl,v 2.40 2005/08/09 07:51:00 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# mcomin    21/03/2002  created
#

#************************************************************************
#   NAME
# 
#   SYNOPSIS
# 
#   DESCRIPTION
#
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#
#   SEE ALSO
#
#   BUGS     
#
#------------------------------------------------------------------------
#

proc disableCrossHair { w } {
    global plotCHFlag
    set plotCHFlag 0
    enableCHCursor
}


proc crossHairDialog { tflag } {
    global chxValue chyValue

    set top .chd

    if {[winfo exists $top]} { destroy $top }

    toplevel $top

    if {$tflag} {
	set twidth 24
    } else {
	set twidth 12
    }


    UifOutput $top.xval -label "X = " -font "-Adobe-courier-bold-r-normal--12*" -width $twidth \
	    -variable chxValue -frame 0 -anchor w
    UifOutput $top.yval -label "Y = " -font "-Adobe-courier-bold-r-normal--12*" -width 12 \
	    -variable chyValue -frame 0 -anchor w

    pack $top.xval $top.yval -side left -padx 5 -pady 2 -fill both

    scan [winfo geometry .] "%dx%d+%d+%d" wid hei posx posy    ;# Calculate geometry

    wm group     $top  "."
    wm transient $top  "."
    wm title     $top  "cross-hair dialog"
    set posy [expr {$posy - 25}]
    set posx [expr {$posx - 6}]
#    wm overrideredirect $top 1
    wm geometry   $top  +${posx}+${posy}
    wm resizable $top 1 0

    wm protocol $top WM_DELETE_WINDOW "disableCrossHair $top"
}


proc setCrossHair { frameId plot x y logAxis} {
    global chxValue chyValue tcl_precision
    $plot setcursor cross 0 0 1
    set tcl_precision 6

#    puts "setCrossHair $frameId $plot $x $y '$logAxis'"

    set xval [$plot world x $x]
    set chxValue [plotGetXVal $frameId $xval]

    if {$logAxis} {
	set chyValue [expr {pow(10,[$plot world y $y])}]
    } else {
	set chyValue [$plot world y $y]
    }

    update
}

################################################
#               ZOOM procs
################################################


proc plotSetZoomMin {w dispId frameId} {
    $w setcursor vline 0 0 1
    bind $w <1> "plotSetZoomMax $w $dispId $frameId %x"
}

proc plotSetZoomMax {w dispId frameId xc} {
    set xmin [$w world x $xc]
    $w setcursor xrng $xmin 0 1
    bind $w <1> "plotZoomFinish %W $dispId $frameId $xmin %x"
}

proc plotZoomFinish {w dispId frameId xmin x} {
    set xmax [$w world x $x]

    bind $w <1> {} ;# Cancel binding
    $w clrcursor   ;# Reset cursor mode

    plotDoZoom $w $dispId $frameId $xmin $xmax
}


proc plotDoZoom { w dispId frameId xmin xmax} {
#    puts "plotDoZoom  $w $dispId $frameId $xmin $xmax\n"

    if { $xmin > $xmax } {
	plotZoomIN $dispId $frameId $xmax $xmin
    } else {
	plotZoomIN $dispId $frameId $xmin $xmax
    }
}

#
# ___oOo___
