#******************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: stooALARM.tcl,v 1.47 2005/08/23 08:02:49 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# rschmutz  07/11/02  RtapASDisplay replaced with alrmDisplay.
# rschmutz  08/02/00  created.
#

#************************************************************************
#   NAME
#	stooALARM - start alarm panel
# 
#   SYNOPSIS
#	stooALARM alarm
# 
#   DESCRIPTION
#	stooALARM allows to start/stop the standard alarm panel.
#
#   PARENT
#	stooPANEL
#
#   PUBLIC METHODS
#	Start
#	    Start the RTAP alarm window.
#	Stop
#	    Stop the RTAP alarm window.
#
#   FILES
#	$VLTDATA/tmp/<envName>.alarm.pid  --  lock file
#
#   SEE ALSO
#	stooPANEL
#
#   BUGS
#
#------------------------------------------------------------------------
#

#************************************************************************
#*# class: stooALARM
#------------------------------------------------------------------------

class stooALARM {
    inherit stooPANEL

    #****************************************************************
    #*# constructor
    #----------------------------------------------------------------

    constructor { args } {
    	configure -name ALARM -execCmd "alrmDisplay -se" \
		  -desc "$infoHeader Alarm Display"
    	eval configure $args
	if { "$envName" != "" } {
	    configure -execCmd "alrmDisplay -se -e $envName"
	}
	Debug "ALARM UIF: envname   = '$envName'" 5
    }

    #****************************************************************
    #*# method: Config
    #----------------------------------------------------------------

    public method Config { cfg } {
        global stooInsMulti

	#*# 1. set name
	if { $stooInsMulti == 1 && $name == "ALARM" } {
    	    configure -name [cconcat [$cfg Get INS.CON.ID] "_ALARM"]
	}

	#*# 2. set default start
	set txt "F"
	catch { set txt [$cfg Get START.ALARM.DEFAULT] }
	configure -default [Logical2Num $txt]
	Debug "ALARM UIF: default    = '$default'" 5
    }
}


#___oOo___

