#******************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: stooAPPL_SET.tcl,v 1.47 2005/08/23 08:02:54 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# rschmutz  07/11/02  created.
#

#************************************************************************
#   NAME
#	stooAPPL_SET - container class for applications
# 
#   SYNOPSIS
#	stooAPPL_SET ins
# 
#   DESCRIPTION
#	stooCONTAINER can be used to create application hierarchies,
#	this is e.g. used to create an hierarchy of instruments.
#
#   PARENT CLASS
#	ctooOBJ_CONTAINER stooBASE
#
#   PUBLIC METHODS
#	Config <cfg>
#	    Configure the application set.
#
#	Standby
#	    Set application set in state STANDBY.
#
#   SEE ALSO
#	stooAPPLICATION
#
#   BUGS
#
#------------------------------------------------------------------------
#

#************************************************************************
#*# class: stooAPPL_SET
#------------------------------------------------------------------------

class stooAPPL_SET {
    inherit ctooOBJ_CONTAINER stooBASE

    #****************************************************************
    #*# constructor
    #----------------------------------------------------------------

    constructor { args } {
    	configure -objType APPL_SET
    	eval configure $args
    }

    #****************************************************************
    #*# method: Config
    #----------------------------------------------------------------

    public method Config { cfg } {
    	#*# 1. default: do nothing
    }

    #****************************************************************
    #*# method: Standby
    #----------------------------------------------------------------

    public method Standby {} {
    	#*# 1. default: do nothing
    }
}


#___oOo___
