#*******************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: stooSPININT.tcl,v 1.47 2005/08/23 08:02:52 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# rschmutz  15/04/00  created, copied from tcouifSpinint.tcl.
# mkiekebu  08/12/98  enable and disable added
# mkiekebu  04/11/98  fixed setRange and setSize added
# mkiekebu  31/07/98  setLabel and setRange added
# rschmutz  22/05/98  range: 0-2
# mkiekebu  20/01/98  created
#

#************************************************************************
#   NAME
#       
#   SYNOPSIS
# 
#   DESCRIPTION
#
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#
#   SEE ALSO
#
#   BUGS     
#
#------------------------------------------------------------------------
#

### ---------------------------------------------------------------------
###           CLASS       stooSPININT
### ---------------------------------------------------------------------

class stooSPININT {
    inherit itk::Widget

### ------------  Constructor --------------------------------------

    constructor {args} {
      itk_component add contents {
            frame $itk_interior.contents
      }
      pack $itk_component(contents) -expand yes -fill both -padx 4 -pady 4

      itk_component add spinint {
          spinint $itk_interior.temp -fixed 2 -step 1 -width 2
      } {
      	  keep -labeltext -fixed -range -step -width -textvariable
      }
      pack $itk_component(spinint) -padx 5 -pady 5
      set itk_interior $itk_component(contents)
      eval itk_initialize $args
  }

  public method getValue {}            
  public method setValue { value }
  public method setLabel { string }
  public method setRange { startRange endRange }
  public method setSize { size }
  public method setEnable {}
  public method setDisable {}
}

#--------------------------------------------------------------
#- method getValue
#--------------------------------------------------------------
body stooSPININT::getValue {} {
    return [$itk_component(spinint) get]
}

#--------------------------------------------------------------
#- method setValue
#--------------------------------------------------------------
body stooSPININT::setValue { value } {
    $itk_component(spinint) clear
    $itk_component(spinint) insert 0 $value
}

#--------------------------------------------------------------
#- method setLabel
#--------------------------------------------------------------
body stooSPININT::setLabel { string } {
   $itk_component(spinint) configure -labeltext $string
}

#--------------------------------------------------------------
#- method setRange
#--------------------------------------------------------------
body stooSPININT::setRange { startRange endRange } {
    $itk_component(spinint) configure -range "$startRange $endRange"
}

body stooSPININT::setSize { size } {
    $itk_component(spinint) configure -fixed $size -width $size
}

#--------------------------------------------------------------
#- method enable
#--------------------------------------------------------------
body stooSPININT::setEnable {} {
    $itk_component(spinint) configure -foreground black
    $itk_component(spinint) configure -state normal
}
#--------------------------------------------------------------
#- method disable
#--------------------------------------------------------------
body stooSPININT::setDisable {} {
    $itk_component(spinint) configure -foreground grey
    $itk_component(spinint) configure -state disabled
}


#
# ___oOo___
