#*******************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: stooStartupHistory.tcl,v 1.47 2005/08/23 08:02:47 vltsccm Exp $"
#
# who       when        what
# --------  ----------  ----------------------------------------------
# dpopovic  05/11/2004  New proc stooStartupHistoryCheckPopup
# rschmutz  2000-01-21  re-created as stooSTARTUP_HISTORY.tcl.
# mkiekebu  06/10/99  procheck warnings removed
# rschmutz  22/05/98  do not close startup panel if there was an error.
# rschmutz  14/05/98  Log added to Info.
# rschmutz  12/05/98  created
#

#************************************************************************
#   NAME
# 
#   SYNOPSIS
# 
#   DESCRIPTION
#
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#
#   SEE ALSO
#
#   BUGS     
#
#------------------------------------------------------------------------
#

#************************************************************************
#*# proc: stooStartupHistoryInitX
#------------------------------------------------------------------------

proc stooStartupHistoryInitX {} {
    global argc argv

    #*# 1. if no arguments: return silently.
    #*#    (assume panel was called from the panel editor)
    if { $argc == 0 } {
	return
    }

    #*# 2. register info. widget
    panGetCvNames stooStartupHistory lcv lbcv
    stooLOG::SetWidget ${lcv}.startupHistoryWdg

    #*# 3. argv1 is the cmd, the rest the arguments
    if {[catch { set script [stooSTARTUP #auto]	}]} {
	return
    }
    if {[catch { $script [lindex $argv 0] [lrange $argv 1 end] }]} {
	return
    }
    $script Sleep 10
    exit
}

#************************************************************************
#*# proc: stooStartupHistoryCheckPopup
#------------------------------------------------------------------------

proc stooStartupHistoryCheckPopup {} {
    global argc argv argv0 env

    set showPopup 0
    
    #*# 1. if no arguments: return silently.
    #*#    (assume panel was called from the panel editor)
    if { $argc == 0 } {
	return
    }


    #*# 2. If modifiers -nopopup or -standby are present, or 
    #      if we are running a TAT test, there is no need for popup.
    if {[lcontain $argv "-nopopup"]} {
	# Remove "-nopopup" from the argv, decrement argc
	set pos  [lsearch  $argv "-nopopup"]
	set argv [lreplace $argv $pos $pos]
	set argc [expr { $argc - 1}]
	return
    }

    if {[lcontain $argv "-standby"]} {
	return
    }

    set tat_test ""
    catch { set tat_test $env(TAT_TEST) }
    if { "$tat_test" != "" } {
	return
    }
    

    #*# 3. Check if -proc or -panel is present.
    #      If none is present, we shold popup a confirmation
    #      dialog since it is an atempt to start complete instrument.
    if { ![lcontain $argv "-proc"]  &&  ![lcontain $argv "-panel"]} {
	set showPopup 1
    }
    

    #*# 3. If <instrument> == <proc> that means that we want to start
    #      all instrument processes. We need a popup in this case as well.
    #      <instrument> is at the second place (index 1) in argv.
    if { [lcontain $argv "-proc"] } {
	set procIndex [expr {[lsearch  $argv "-proc"] + 1}]
	if { [lindex $argv 1] == [lindex $argv $procIndex] } {
	set showPopup 1
	}
    }
    
    
    # Show confirmation dialog if needed.
    if { $showPopup } {
	set text "Do you really want to [lindex $argv 0] the complete [lindex $argv 1] instrument?"
	if { [ tk_dialog .stooDialog "Confirmation" $text question 1 Continue Cancel] == 1 } {
	    exit 1
	} 
    }
    
    return
}

# ___oOo___



