# -*- tcl -*-
#************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: tplFIERA.tcl,v 1.64 2005/10/07 22:29:46 vltsccm Exp $"
#
# tplFIERA.tcl
#
# who       when      what
# --------  --------  ----------------------------------------------
# alongino  24/10/00  created
#
#************************************************************************
#   NAME
#   	tplFIERA - FIERA detector class interface for templates.
# 
#   SYNOPSIS
#	tplFIERA dcs <dbAlias> <subsystem> [<detIndex>] [<imageScale>]
# 
#   DESCRIPTION
#	FIERA detector interface for BOB templates.
#
#   PARENT
#	tplDCS
#
#   PUBLIC METHODS
#	see tplDCS man page.
#
#   EXAMPLES
#       see xxoseq module
#
#   SEE ALSO
#	tplACE tplDCS tplMIDAS
#
#   BUGS     
#
#------------------------------------------------------------------------
#

#########################################################################
# FIERA CCD procedures
#
class tplFIERA {
    inherit tplDCS

    #--------------------------------------------------------------------
    # constructor
    #
    constructor { dbAlias subsys {index ""} {scale -2} } {
	tplDCS::constructor $dbAlias $subsys $index $scale
    } {
	global env

	#
	# 1. get all modes
	#
	set modes {}
	set clkinds {}
	for { set i 0 } { $i < 20 } { incr i } {
	    set mode [seq_dbReadSymbolic "<alias>$detName:readout:mode_$i.speed"]
	    if { "$mode" != "" } {
	        lappend modes $mode
		lappend clkinds $i
	    }
	}

    }

}


#########################################################################
# ___oOo___

