#*******************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: tpltooFMT.tcl,v 1.15 2005/09/12 02:25:18 vltsccm Exp $"
#
# who       when        what
# --------  ----------  ----------------------------------------------
# mkiekebu  2005-05-02  created
#

#************************************************************************
#   NAME
#       tpltooFMT - Base class for TSF report tool
# 
#   SYNOPSIS
#       tpltooFMT <obj>
# 
#   DESCRIPTION
#       This class provides the basic and common functionality to obtain 
#       reports of TSF files in the different formats.
#
#   PARENT CLASS
#	tpltooLOG
#
#   PUBLIC METHODS
#	setFile <filename>
#            Define the output file name.
#       
#       emptyTblList
#            Empty arrays.
#
#   FILES
#	*.tsf:	template signature files
#
#   SEE ALSO
#	
#
#   BUGS     
#
#------------------------------------------------------------------------
#

class tpltooFMT {
    inherit tpltooLOG

    constructor { args } {
	eval configure $args
    }
   
    destructor  {
	close $fd
    }
    
    public method setFile { {filename ""} } {
	catch {close $fd}
	if {"$filename" == ""} {
	    if {"$dir" == ""} {
		set report [format "%s.%s" $repName $format]
	    } else {
		set report [format "%s/%s.%s" $dir $repName $format]
	    }
	} else {
	    set report [format "%s/%s.%s" $dir $filename $format]
	}
	set fd [open $report "w+"]
    }
    

    public method emptyTblList {} {
	set varKeyList {}
	set fixKeyList {}
    }
    
    public variable dir       {} ;             # Report directory
    public variable repName   "tsfReport" ;    # Report file
    public variable fd        "" ;             # Report file descriptor
    public variable format    "";              # Report file extension
    public variable debug     "" ;             # Debug variable

    public variable varKeyList {}
    public variable fixKeyList {}
}


#
# ___oOo___








