#*******************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: tpltooISF.tcl,v 1.15 2005/09/12 02:25:16 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# rschmutz  08/06/01  created.
#

#************************************************************************
#   NAME
#	tpltooISF - Instrument signature file interface
# 
#   SYNOPSIS
#	tpltooISF isf
# 
#   DESCRIPTION
#	Itcl interface to an ISF.
#
#   PARENT
#	tpltooPAF
#
#   PUBLIC METHODS
#	see tpltooPAF.
#
#   ENVIRONMENT
#	INS_ROOT	Instrument root area
#
#   CAUTION
#
#   EXAMPLES
#
#   SEE ALSO
#	tpltooPAF(8)
#
#   BUGS
#
#------------------------------------------------------------------------
#


#************************************************************************
#*# class: tpltooISF
#------------------------------------------------------------------------

class tpltooISF {
    inherit tpltooPAF

    #****************************************************************
    #*# constructor
    #----------------------------------------------------------------

    constructor { args } {
        tpltooPAF::constructor -objType ISF -name ISF
	eval configure $args

	#*# 1. load file
	Load
    }

    #****************************************************************
    #*# method: Load
    #----------------------------------------------------------------

    public method Load { {fileName ""} } {
        global env

    	if { "$fileName" != "" } {
    	    configure -file $fileName
	}
	set fileName $file
	if { "$file" != "" } {
	    if { ![file exists $file] && [file tail $file] == $file } {
	        configure -file "$env(INS_ROOT)/SYSTEM/COMMON/CONFIGFILES/$file"
	        if { ![file exists $file] } {
	            configure -file "$env(INTROOT)/config/INS_ROOT/SYSTEM/COMMON/CONFIGFILES/$fileName"
	        }
	    }
	    if { ![file exists $file] } {
	        error "File $fileName not found."
	    }
	    tpltooPAF::Load "" 1
	}
    }
}

#
# ___oOo___
