#*******************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: tpltooOBDV.tcl,v 1.15 2005/09/12 02:25:18 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# rschmutz  20/06/01  created.
#

#************************************************************************
#   NAME
#	tpltooOBDV - OBDV file interface
# 
#   SYNOPSIS
#	tpltooOBDV obdv
# 
#   DESCRIPTION
#	Itcl interface to a OBDV file.
#
#   PARENT
#	tpltooPAF
#
#   PUBLIC METHODS
#	see tpltooPAF.
#
#   ENVIRONMENT
#	INS_ROOT	Instrument root area
#
#   CAUTION
#
#   EXAMPLES
#
#   SEE ALSO
#	tpltooPAF(8)
#
#   BUGS
#
#------------------------------------------------------------------------
#


#************************************************************************
#*# class: tpltooOBDV
#------------------------------------------------------------------------

class tpltooOBDV {
    inherit tpltooPAF

    #****************************************************************
    #*# constructor
    #----------------------------------------------------------------

    constructor { args } {
        tpltooPAF::constructor -objType OBDV
	eval configure $args

	#*# 1. add PAF entries
	set now [clock format [clock seconds] -format "%Y-%m-%dT%H:%M:%S.00"]
	Set PAF.HDR.START	""
	Set PAF.TYPE            "Template Signature"
	Set PAF.ID              ""
	Set PAF.NAME            ""
	Set PAF.DESC            ""
	Set PAF.CRTE.NAME       "tpltoo"
	Set PAF.CRTE.DAYTIM     "$now"
	Set PAF.LCHG.NAME       ""
	Set PAF.LCHG.DAYTIM     "$now"
	Set PAF.CHCK.NAME       ""
	Set PAF.CHCK.DAYTIM     ""
	Set PAF.CHCK.CHECKSUM   ""
	Set PAF.HDR.END         ""

	#*# 2. load file
	Load
    }

    #****************************************************************
    #*# method: Load
    #----------------------------------------------------------------

    public method Load { {fileName ""} } {
        global env

    	if { "$fileName" != "" } {
    	    configure -file $fileName
	}
	set fileName $file
	if { "$file" != "" } {
	    if { ![file exists $file] && [file tail $file] == $file } {
	        configure -file "$env(INS_ROOT)/SYSTEM/COMMON/CONFIGFILES/$file"
	        if { ![file exists $file] } {
	            configure -file "$env(INTROOT)/config/SYSTEM/COMMON/CONFIGFILES/$fileName"
	        }
	    }
	    if { ![file exists $file] } {
	        error "File $fileName not found."
	    }
	    tpltooPAF::Load
	}
    }

}

#
# ___oOo___
