#******************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: vccLogo.tcl,v 2.116 2005/10/21 14:15:13 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# ssandroc  12/09/97  created
#

#************************************************************************
#   NAME
#	VccLogo - logo widget
#
#   SYNOPSIS
#	VccLogo <name>
#
#   DESCRIPTION
#	This is a label widget with a pixmap as image.
#	The pixmap is taken from a file.
#
#   FILES
#	A pixmap is located using vccFindPixmapFile, see there.
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#
#   SEE ALSO
#	vccFindPixmapFile(n)
#
#   BUGS     
#
#------------------------------------------------------------------------
#

class VccLogo {
    
    inherit itk::Widget

    constructor { args } {
	itk_component add logo {
	    label $itk_interior.logo
	} { usual }

	set f [vccFindPixmapFile]
	if {$f == ""} {set f [vccFindPixmapFile vcc]}
	if {$f != ""} {
	    set i [image create pixmap -file $f]
	    $itk_component(logo) configure -image $i
	}
	pack $itk_component(logo)
    }
    
    destructor {}
}

# ___oOo___
