#*******************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: classWESBoard.tcl,v 4.5 2004/01/16 15:24:57 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# hpieper  04/06/97  created
#

#************************************************************************
#   NAME
# 
#   SYNOPSIS
# 
#   DESCRIPTION
#
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#
#   SEE ALSO
#
#   BUGS     
#
#------------------------------------------------------------------------
#

itk::usual ClassWESBoard {}
class ClassWESBoard {
    inherit ClassWESError
    constructor            {args}       {}
    destructor                          {}
    public      variable   type         "FIXED";#VAR
    public      variable   name         ""
    public      variable   cfgFileName  ""
    private     variable   SIMM
    private     variable   nof_simms    "0"
    public      method     createSIMM   {}
    public      method     hasSIMM      {simmName}
    public      method     nofSIMMS     { return $nof_simms}
    public      method     getSIMMS     {}
    public      method     getMLSIMMS   {}
    public      method     clear        {}
    public      method     resizeSIMMS  {l}
    public      method     clearSIMMS   {}
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESBoard::constructor
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESBoard::constructor {args} {
    if {[llength $args] != 0 } {eval configure $args}
    
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESBoard::destructor
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESBoard::destructor {} {
    #destroy all 
    clear
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESBoard::clear
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESBoard::clear {} {
    #destroy all 
    foreach s [array names SIMM] {
	delete object $SIMM($s)
	unset SIMM($s)
    }
    set nof_simms 0
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESBoard::createSIMM
# PURPOSE : creates a blank SIMM object and returns the object name 
#           the object will then have to be configured in the caller's 
#           scope
# RETURN  : a blank and empty SIMM object
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESBoard::createSIMM {} {
    incr nof_simms
    
    set SIMM($nof_simms) [ClassWESSIMM $this."si$nof_simms" -board $name]
    #puts "creating SIMM $nof_simms $name $SIMM($nof_simms)"
    return $SIMM($nof_simms)
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESBoard::resizeSIMMS
# PURPOSE : resize the SIMM objects
# RETURN  : 
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESBoard::resizeSIMMS {l} {
    foreach s [getSIMMS] {
	$s resize $l
    }
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESBoard::clearSIMMS
# PURPOSE : resize the SIMM objects
# RETURN  : 
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESBoard::clearSIMMS {} {
    foreach s [getSIMMS] {
	$s setData {{0 0}}
    }
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESBoard::getSIMMS
# PURPOSE : acces the internal list of SIMM objects
# RETURN  : return the the list of al SIMM object in the 
#           board 
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESBoard::getSIMMS {} {
    set sList {}
    if [info exists SIMM] {
	for {set i 1} {$i <= $nof_simms} {incr i} {
	    lappend sList $SIMM($i)
	}
	
	return $sList
    } else {
	return {}
    }
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESBoard::getMLSIMMS
# PURPOSE : acces the internal list of SIMM objects
# RETURN  : return the the list of all ML SIMM objects in the 
#           board 
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESBoard::getMLSIMMS {} {
    set sList {}
    if [info exists SIMM] {
	foreach s [array names SIMM] {
	    if [regexp [$SIMM($s) cget -type] "MULTILEVEL"] {
		lappend sList [$SIMM($s) cget -name]
	    }
	}
	return $sList
    } else {
	return {}
    }
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESBoard::hasSIMM
# PURPOSE : check whether SIMM simName is present on board
# RETURN  : return the SIMM object which corresponds to the name simmName
#           or an empty string if not present
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESBoard::hasSIMM {simmName} {
    foreach s [array names SIMM] {
	if {[string compare  $simmName [$SIMM($s) cget -name]] == 0} {
	    return $SIMM($s)
	}
    }
    return $FAILED
}
#
# ___oOo___


