#*******************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: classWESBoardData.tcl,v 4.5 2004/01/16 15:24:58 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# hpieper  04/06/97  created
#

#************************************************************************
#   NAME
# 
#   SYNOPSIS
# 
#   DESCRIPTION
#
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#
#   SEE ALSO
#
#   BUGS     
#
#------------------------------------------------------------------------
#
itk::usual ClassWESBoardData {}
class ClassWESBoardData {
    inherit ClassWESDataBase
    constructor            {args} {}
    destructor                    {}
    private  variable  BOARD
    public   method    createProfile   {b s st et sv ev type}
    public   method    clearBoards     {}
    public   method    clearWave       {}
    public   method    createBoard     {b cfgFile}
    public   method    getBoardObject  {b}
    public   method    getMLSimms      {b}
    public   method    getBoards       {}
    public   method    getBoardNames   {}
    public   method    resize          {l}
};#ClassWESBoardData

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESBoardData::constructor
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESBoardData::constructor {args} {
    if {[llength $args] != 0 } {eval configure $args}
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESBoardData::clearBoards
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESBoardData::clearBoards {} {
    ClassWESDataBase::clearWave
    foreach b [array names BOARD] {
	#puts "deleting object $BOARD($b)"
	delete object $BOARD($b)
        unset BOARD($b)
    }
    setTick 0
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESBoardData::clearWave
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESBoardData::clearWave {} {
    ClassWESDataBase::clearWave
    foreach b [array names BOARD] {
	$BOARD($b) clearSIMMS
    }
    setTick $MIN_PAT_LENGTH
    set sCount 0
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESBoardData::createBoard
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESBoardData::createBoard {b cfgFile} {
    
    if ![info exists BOARD($b)] {
	#puts "creating board $b"
	set BOARD($b) [ClassWESBoard $this.b$b -name $b]
    } else {
	if {[wesError BOARD_OVERWRITE "Overwrite BOARD $b"] == "OK"} {
	    #puts "overwriting board $b"
	    $BOARD($b) clear 
	} else {
	    return ""
	}	
    }
    return $BOARD($b)
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESBoardData::getBoardObject
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESBoardData::getBoardObject {b} {
    if [info exists BOARD] {
	if [info exists BOARD($b)] {
	    return $BOARD($b) 
	} else {
	    return ""
	}
    } else {
	return ""
    }
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESBoardData::getBoards
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESBoardData::getBoards {} {
    set sList {}
    foreach b [array names BOARD] {
	lappend sList $BOARD($b)
    }
    return $sList
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESBoardData::getBoardNames
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESBoardData::getBoardNames {} {
    set sList {}
    foreach b [array names BOARD] {
	lappend sList [$BOARD($b) cget -name]
    }
    return $sList
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESBoardData::resize
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESBoardData::resize {l} {
    foreach e [array names BOARD] {
	$BOARD($e) resizeSIMMS $l
    }
    setTick $l
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESBoardData::createProfile
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESBoardData::createProfile {b s st et sv ev type} {
    if [info exists BOARD] {
	if [info exists BOARD($b)] {
	    if {[set simm [$BOARD($b) hasSIMM $s]] != ""} {
		return [$simm insertProfile $st $et $sv $ev $type]
	    } else {
		return 0
	    }
	}
    }
    wesError CREATE_PROFILE_FAIL "Cannot create profile for SIMM $s\n\
	    on BOARD $b"
    return 0
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESBoardData::getMLSimms
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESBoardData::getMLSimms {b} {
    if [info exists BOARD] {
	if [info exists BOARD($b)] {
	    return [$BOARD($b) getMLSIMMS]
	} else {
	    wesError BOARD_NOT_PRESENT "Board $b does not exist"
	    return {}
	}
    } else {
	wesError BOARD_DATA_EMPTY "The current Board Config is empty"
	return {}
    }
}
#
# ___oOo___


