#*******************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: classWESCommand.tcl,v 4.5 2004/01/16 15:24:58 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# hpieper  22/06/97  created
#

#************************************************************************
#   NAME
# 
#   SYNOPSIS
# 
#   DESCRIPTION
#
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#
#   SEE ALSO
#
#   BUGS     
#
#------------------------------------------------------------------------
#
itk::usual ClassWESCommand {}
class ClassWESCommand {
    inherit ClassWESError
    constructor            {args}         {}
    destructor                            {}

    
    public    common    undoStackLen      "3"
    private   variable  undoStack         {}  
    private   variable  redoStack         {}
    public    method    pushRedoStack     {op}
    public    method    popRedoStack      {}
    public    method    pushUndoStack     {op}
    public    method    popUndoStack      {}
    public    method    clearCommandStack {}
    public    method    canUndo           {}
    public    method    canRedo           {}
    public    method    undo              {{caller ""}}
    public    method    redo              {{caller ""}}
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESCommand::constructor
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESCommand::constructor {args} {
    if {[llength $args] != 0 } {eval configure $args}

    set undoStack {}
    set redoStack {}
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESCommand::destructor
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESCommand::destructor {} {
    unset undoStack 
    unset redoStack
}

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESCommand::clearCommandStack  
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESCommand::clearCommandStack {} {
    set undoStack {}
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESCommand::pushUndoStack  
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESCommand::pushUndoStack {op} {
    set rc 0
    #puts "UNDO -> $op"
    if [info exists undoStack] {
	if {[llength $undoStack] >= $undoStackLen} {
	    set undoStack {}
	    lappend undoStack $op
	} else {
	    set undoStack [linsert $undoStack 0 $op]
	}
	set rc 1
    } else {
	lappend undoStack $op
    }
    return $rc
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESCommand::popUndoStack  
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESCommand::popUndoStack {} {
    set rc ""
    if [info exists undoStack] {
	if {[set rc [lindex $undoStack 0]] != ""} {
	    set undoStack [lreplace $undoStack 0 0]
	}
    }
    #puts "POPUNDOSTACK $rc" 
    return $rc
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESCommand::clearCommandStack  
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESCommand::clearCommandStack {} {
    set undoStack {}
    set redoStack {}
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESCommand::pushRedoStack  
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESCommand::pushRedoStack {op} {
    set rc 0
    #puts "REDO -> $op"
    if [info exists redoStack] {
	if {[llength $redoStack] >= $redoStackLen} {
	    set redoStack {}
	    lappend redoStack $op
	} else {
	    set redoStack [linsert $redoStack 0 $op]
	}
	set rc 1
    } else {
	lappend redoStack $op
    }
    return $rc
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESCommand::popRedoStack  
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESCommand::popRedoStack {} {
    set rc ""
    if [info exists redoStack] {
	if {[set rc [lindex $redoStack 0]] != ""} {
	    set undoStack [lreplace $redoStack 0 0]
	}
    }
    return $rc
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESCommand::canUndo 
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESCommand::canUndo {} {
    set rc 0
    if [info exists undoStack] {
	if {[llength $undoStack] > 0} {
	    set rc 1
	}
    }
    return $rc
} 
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESCommand::canRedo 
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESCommand::canRedo {} {
    set rc 0
    if [info exists redoStack] {
	if {[llength $redoStack] > 0} {
	    set rc 1
	}
    }
    return $rc
} 
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESCommand::undo 
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESCommand::undo {{caller ""}} {
    if {[set op [popUndoStack]] != ""} {
	#puts "executing $op at $caller context"
	if {$caller != ""} {
	    eval "$caller $op" 
	} else {
	    $op
	}
    }
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESCommand::redo 
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESCommand::redo {{caller ""}} {
    if {[set op [popRedoStack]] != ""} {
	#puts "executing $op at $caller context"
	code $caller $op
    }
}
#
# ___oOo___


