#*******************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: classWESCtrlStat.tcl,v 4.5 2004/01/16 15:24:58 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# vlttc  14/05/97  created
#

#************************************************************************
#   NAME
# 
#   SYNOPSIS
# 
#   DESCRIPTION
#
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#
#   SEE ALSO
#
#   BUGS     
#
#------------------------------------------------------------------------
#


itk::usual ClassWESCtrlStat {}
class ClassWESCtrlStat {
    inherit ClassWESWaveCommon
    constructor              {args}                {}
    destructor                                     {}
    public    variable       start               "0";#start-tick
    public    variable       end                 "0";#end-tick
    public    variable       next                ""
    public    variable       prev                ""
    public    variable       text                ""
    public    variable       freq                "50Mhz"
    public    variable       tickT               ""
    public    variable       ctrlType            ""
    public    method         setBlock              {t s v e txt}
    public    method         insertBlock           {t s v e txt}
    public    method         getBlocks             {}
    public    method         clear                 {}
    private   variable       cmdBlock
    private   variable       cmdCount              "0"
};#ClassWESCtrlStat
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESCtrlStat::constructor
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESCtrlStat::constructor {args} {
    set hilit(W)  blue
    set hilit(X)  green
    set hilit(R)  red
    set hilit(R1) red
    set hilit(R2) red
    set hilit(R3) red
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESCtrlStat::clear
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
##body ClassWESCtrlStat::clear {} {
##    #puts "ClassWESCtrlStat::clear" 
##    if [info exists cmdBlock] {
##	foreach e [array names cmdBlock] {
##	    $cmdBlock($e) clear
##	    delete object $cmdBlock($e)
##	}
##	unset cmdBlock
##    }
##    set cmdCount 0
##}
body ClassWESCtrlStat::clear {} {
    #puts "ClassWESCtrlStat::clear" 
    foreach e [array names cmdBlock] {
	$cmdBlock($e) clear
	delete object $cmdBlock($e)
	unset cmdBlock($e)
    }
    set cmdCount 0
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESCtrlStat::setBlock
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESCtrlStat::setBlock {t s v e txt} {
    set cmdBlock($cmdCount) \
		    [ClassWESCtrlStat $this.bl$cmdCount]
    $cmdBlock($cmdCount) configure -ctrlType $t -start $s -absTime $v \
		    -end $e -text $txt
    update
    if {$cmdCount > 0} {
	#set prev $cmdBlock([expr $cmdCount -1])
	#$prev configure -next $cmdBlock($cmdCount)
	#$cmdBlock($cmdCount) configure -prev $prev
    }
    #puts "setBlock $cmdBlock($cmdCount) [$cmdBlock($cmdCount) cget -ctrlType]"
    incr cmdCount
    return $cmdBlock([expr $cmdCount -1])
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESCtrlStat::insertBlock
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESCtrlStat::insertBlock {t s v e txt} {
#    puts "insertBlock $cmdCount" 
    if {$cmdCount > 0} { 
	set rc [$cmdBlock([expr $cmdCount -1]) setBlock \
		$t $s $v $e $txt]
    } else {
	set rc [setBlock $t $s $v $e $t]  
    }
    return $rc
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESCtrlStat::getBlocks
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESCtrlStat::getBlocks {} {
    set sList {}
    for {set tmp 0} {$tmp < $cmdCount} {incr tmp} {
	lappend sList $cmdBlock($tmp)
    }
    #puts "ClassWESCtrlStat::getBlocks $cmdCount $sList"
    return $sList
}
#
# ___oOo___


