#*******************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: classWESDisplData.tcl,v 4.5 2004/01/16 15:24:59 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# hpieper  02/02/97  created
#

#************************************************************************
#   NAME
# 
#   SYNOPSIS
# 
#   DESCRIPTION
#
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#
#   SEE ALSO
#
#   BUGS
#
#------------------------------------------------------------------------
#

itk::usual ClassWESDisplData {}
class ClassWESDisplData {
    constructor            {args} {}
    destructor                    {}
    public     variable simmList        {}
    private    variable cmdCnt          "0"
    private    variable zoomX           "1.0"
    private    variable zoomY           "1.0"
    private    variable eCount          "0"
    private    variable DISPLAY

    public     variable timeBase 
    public     method   changeTagOrder  {tag o n}
    public     method   getTags         {}
    public     method   getSimmCount    {} {return $eCount}
    public     method   insertPhase     {obj}
    public     method   insertBus       {obj}
#    public     method   loadDisplayList {}
#    public     method   saveDisplayList {}
    public     method   clear           {}

};#ClassWESDisplData

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

body ClassWESDisplData::constructor {args} {
    #init
    if {[llength $args] != 0 } {eval configure $args}
    
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESDisplData::clear           {} {
    #puts "ClassWESDisplData::clear"
    foreach e [array names DISPLAY] {
	$DISPLAY($e) configure -display 0
	unset DISPLAY($e)
    }
    set eCount 0    
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESDisplData::changeTagOrder
# RETURN
#     reorder the current display list
#     
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESDisplData::changeTagOrder   {tag o n} {
    set rc {}
    
    if {[info exists DISPLAY($n)] && [info exists DISPLAY($o)]} {
	set so "[$DISPLAY($o) cget -board],[$DISPLAY($o) cget -name]"
	set sn "[$DISPLAY($n) cget -board],[$DISPLAY($n) cget -name]"
	if {([set soix [lsearch -exact $simmList $so]] >= 0) && \
		([set snix [lsearch -exact $simmList $sn]] >= 0)} {
	    set simmList [lreplace $simmList $snix $snix $so]
	    set simmList [lreplace $simmList $soix $soix $sn]
	}

	#puts $simmList
	#puts ""
	set tmp $DISPLAY($n)
	set DISPLAY($n) $DISPLAY($o)
	set DISPLAY($o) $tmp
	return [getTags]
    } else {
	return {}
    }
    return $rc
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESDisplData::getTags 
# RETURN
#     the sorted tag list according to the boards in the
#     current configuration  
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESDisplData::getTags         {} {
    set tList {}
    set sList [lsort -integer [array names DISPLAY]]
    foreach e $sList {
	lappend tList $DISPLAY($e) 
    }
    return $tList
}

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESDisplData::insertPhase
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESDisplData::insertPhase     {s} {
    if ![$s cget -display] {
	#puts "ClassWESDisplData::insertPhase $s, [$s cget -name],[$s cget -board]"
	set sTag "[$s cget -board],[$s cget -name]"
	if {[set ix [lsearch -exact $simmList $sTag]] >= 0} {
	    set DISPLAY($ix) $s
	    
	}
	incr eCount
	$s configure -display 1
    }
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESDisplData::insertBus       {b} {    
    set DISPLAY($eCount) $b
    incr eCount
}

#
# ___oOo___


