#*******************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: classWESError.tcl,v 4.5 2004/01/16 15:25:00 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# hpieper  04/06/97  created
#

#************************************************************************
#   NAME
# 
#   SYNOPSIS
# 
#   DESCRIPTION
#
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#
#   SEE ALSO
#
#   BUGS     
#
#------------------------------------------------------------------------
#

itk::usual ClassWESError {}
class ClassWESError {
    constructor                               {args} {}
    destructor                                {}
    #wesError IDs ...
    protected common   SUCCESS             "0"
    protected common   SYNTAX_ERROR        "1"
    protected common   CANNOT_OPEN_FILE    "2"
    protected common   FAILED              "3"
    protected common   WAVEFORM_EMPTY      "4"
    protected common   OVERWRITE_WAVEFORM  "5"
    protected common   OVERWRITE_TICK      "6"
    protected common   DUPLICATE_PATTERN   "7"
    #other constants  ...
    protected common   MIN_PAT_LENGTH    "5";# 0-5 -> 6

    protected common        errno             "0" 
    private   common        errStack
    public    method        displayErrorStack {}
    public    method        wesError          {errID errMsg {noHelp "1"}}
    public    method        wesInfo           {infoID infoMsg}
    public    method        wesConfirm        {infoID infoMsg}
    public    method        pushError         {errID errMsg} {}
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESError::constructor
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESError::constructor {args} {
    if {[llength $args] != 0 } {eval configure $args}

}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESError::wesError
# PURPOSE : display an wesError dialog Box
# RETURN  : the user button
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESError::wesError {errID errMsg {noHelp "1"}} {
    set errno $errID
    unfreezeEvents
    set dlg [messagedialog .#auto -bitmap error\
	    -title "WES Error"\
	    -text "$errMsg"\
	    -modality application]
    if {$noHelp} {
	$dlg hide Help
    } else {
	$dlg buttonconfigure Help -text Help \
		-command [code "$dlg deactivate Help"]
	$dlg show Help
    }
    $dlg buttonconfigure OK -text OK \
	    -command [code "$dlg deactivate OK"]
    $dlg show  OK
    $dlg hide  Cancel
    $dlg hide Apply
    $dlg default OK
    $dlg center
    if {[set rc [$dlg activate]] == "Help"} {
	delete object $dlg
	set hdlg [messagedialog .#auto -title "WES" \
	    -text "For Help on the WES SW,\n please consult the Online\
	    User Manual" \
	    -modality application]
    
	$hdlg hide Apply
	$hdlg hide Cancel
	$hdlg hide Help
	$hdlg center
	$hdlg activate
	delete object $hdlg
    } else {

	delete object $dlg
    }
    #return the user choice
    return $rc
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESError::info
# PURPOSE : display an info dialog Box
# RETURN  : the user button
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESError::wesInfo {infoID infoMsg} {
    unfreezeEvents
    set dlg [messagedialog .#auto -bitmap info\
	    -title "WES Info"\
	    -text $infoMsg\
	    -modality application]
    $dlg buttonconfigure Help -text Help \
	    -command [code "$dlg deactivate Help"]
    $dlg show Help
    $dlg buttonconfigure OK -text OK \
	    -command [code "$dlg deactivate OK"]
    $dlg show  OK
    $dlg hide Cancel
    $dlg hide Apply
    $dlg default OK
    $dlg center
    if {[set rc [$dlg activate]] == "Help"} {
	delete object $dlg
	set hlp [hyperhelp .#auto \
		-topics { intro getStarted menuTb textedit graphedit manipulate} \
		-helpdir [wesFindVLT bitmaps] \
		-modality none]
	
	$hlp center
	$hlp activate
	
	$hlp showtopic "intro"
    } else {

	delete object $dlg
    }
    #return the user choice
    return $rc
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESError::wesConfirm
# PURPOSE : display an confirmation dialog Box
# RETURN  : the user button
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESError::wesConfirm {infoID infoMsg} {
    unfreezeEvents
    set dlg [messagedialog .#auto -bitmap info\
	    -title "WES Confirm"\
	    -text $infoMsg\
	    -modality application]
    $dlg buttonconfigure Apply -text Cancel \
	    -command [code "$dlg deactivate Cancel"]
    $dlg show Apply
    $dlg buttonconfigure OK -text OK \
	    -command [code "$dlg deactivate OK"]
    $dlg show  OK
    $dlg hide Cancel
    $dlg hide Help
    $dlg default OK
    $dlg center
    set rc [$dlg activate]
    #return the user choice
    return $rc
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESError::displayErrorStack
# PURPOSE : display the complete wesError stack
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESError::displayErrorStack {} {
    
}
#
# ___oOo___


