#************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: classWESGrWLabel.tcl,v 4.5 2004/01/16 15:25:01 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# hpieper  18/10/96  created
#

#************************************************************************
#   NAME
# 
#   SYNOPSIS
# 
#   DESCRIPTION
#
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#
#   SEE ALSO
#
#   BUGS     
#
#------------------------------------------------------------------------
#
itk::usual ClassWESGrWLabel { }
class ClassWESGrWLabel {
    inherit itk::Widget

    constructor       {args} {}
    destructor               {}

    itk_option define    -name name Name ""
    itk_option define    -height height Height "50"
    itk_option define    -width  width  Width    "60"
    itk_option define    -container   container   Container     ""
    protected variable  oldBg        ""
    protected variable  xc           0
    protected variable  yc           0
    protected method    defbindings  {}  
    protected method    idB1Clicked  {x y} 
    public    method    display      {} 
    public    method    highlight    {} {}
    public    method    noHighlight  {} {}
};#ClassWESGrWLabel

# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# INTERFACE
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

body ClassWESGrWLabel::constructor {args} {
    itk_component add f  {
	frame $itk_interior.f  -relief flat -bd 0
    } {
	usual
	ignore -relief
	keep -width
	keep -height
    }    
    itk_component add id {
	canvas $itk_component(f).id -relief flat -bd 0
    } {
	usual
	ignore -relief
	keep -width
	keep -height
    }	     

    eval itk_initialize $args 
    if {[llength $args] != 0 } {eval configure $args}
    pack $itk_component(id) -side left -fill x -expand true
    pack $itk_component(f) -side left -fill x -expand true
    set oldBg [$itk_component(id) cget -background]
}


body ClassWESGrWLabel::highlight {} {
    $itk_component(id) delete widgetLabel 
    $itk_component(id) configure -background Grey75
    $itk_component(id) create text $xc $yc\
	    -anchor w\
	    -text $itk_option(-name)\
	    -fill red\
	    -tags widgetLabel
}

body ClassWESGrWLabel::noHighlight {} {
    $itk_component(id) configure -background $oldBg
    $itk_component(id) delete widgetLabel 
    $itk_component(id) create text $xc $yc\
	    -anchor w\
	    -text $itk_option(-name)\
	    -fill black\
	    -tags widgetLabel
}

body ClassWESGrWLabel::display {} {
    #calculate the center of the id widget
    $itk_component(id) delete widgetLabel 
    set lw [winfo pixels . $itk_option(-width)]
    set dh [winfo pixels . $itk_option(-height)]
    set xc [expr $lw/10]
    set yc [expr $dh/2]
    $itk_component(id) create text $xc $yc\
	    -anchor w\
	    -text $itk_option(-name)\
	    -fill black\
	    -tags widgetLabel

}

body ClassWESGrWLabel::idB1Clicked {x y} {

}

body ClassWESGrWLabel::defbindings {} {
#    puts "ClassWESGrWLabel::defbindings"
    bind $itk_component(cv) <Button-1> [code $this cvB1Clicked %x %y]
    bind $itk_component(id) <Button-1> [code $this idB1Clicked %x %y]
    bind $this <Enter>\
	    [$itk_component(id) configure -background red]
    bind $this <Leave>\
	    [$itk_component(id) configure -background Grey90]
}

#
# ___oOo___


