#*******************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: classWESPatData.tcl,v 4.5 2004/01/16 15:25:02 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# hpieper  29/04/97  created
#

#************************************************************************
#   NAME
# 
#   SYNOPSIS
# 
#   DESCRIPTION
#
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#
#   SEE ALSO
#
#   BUGS     
#
#------------------------------------------------------------------------
#
itk::usual ClassWESPatData {}
class ClassWESPatData {
    inherit ClassWESBoardData
    constructor            {args} {}
    destructor                    {}

    private  variable  PATTERN
    public   method    insertTicksAt   {at t}
    public   method    createPattern   {pat brd}
    public   method    setPatternAt    {brd t}
    public   method    renamePattern   {pat n}
    public   method    isPattern       {pat}
    public   method    getPattern      {}
    public   method    clearWave       {}
};#ClassWESPatData

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESPatData::constructor
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESPatData::constructor {args} {
    if {[llength $args] != 0 } {eval configure $args}
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESPatData::init
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESPatData::clearWave {} {
    #clear all
    #puts "patdata clearwave"
    ClassWESBoardData::clearWave
    foreach p [array names PATTERN] {
	delete object $PATTERN($p)
	unset PATTERN($p)
    }
}

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESPatData::createPattern
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESPatData::createPattern {p brd} {
    #puts "createPattern $p $brd"
    if {[set bObj [getBoardObject $brd]] == ""} {
	wesError BOARD_NOT_PRESENT "Board $brd does not exists"
	return $FAILED
    }
    if ![info exists PATTERN($p)] {
	set PATTERN($p) [ClassWESPattern $this.p$p -name $p -type "PATTERN"]
	if ![$PATTERN($p) setBoard $bObj] {
	    return FAILED
	}
    } else {
	#if {[wesInfo PATTERN_OVERWRITE "Overwrite PATTERN $p"] == "OK"} {
	#    $PATTERN($p) clear 
	#    if ![$PATTERN($p) setBoard $bObj] {
	#	return $FAILED
	#    }
	#} else {
	#    return $FAILED
	#}	
    }
    return $PATTERN($p)
}

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESPatData::setPatternAt
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESPatData::setPatternAt    {pat t} {
    if [info exists PATTERN] {
	if {[info exists PATTERN($pat)]} {
	    return [$PATTERN($pat) setPatternAt $t]
	} else {
	    return 0
	}
    }
    return 0
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESPatData::getPattern
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESPatData::getPattern      {} {
    if {![info exists PATTERN]} {
	return {}
    }
    return [array names PATTERN]
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESPatData::isPattern
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESPatData::isPattern       {pat} {
    return [info exists PATTERN($pat)]
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESPatData::renamePattern
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESPatData::renamePattern {pat n} {
    set rc 0
    if {[info exists PATTERN([$pat cget -name])]} {
	unset PATTERN([$pat cget -name])
	$pat configure -name $n 
	set PATTERN($n) $pat
	set rc 1
    }	
    return $rc
}
#
# ___oOo___


