#*******************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: classWESPattern.tcl,v 4.5 2004/01/16 15:25:02 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# hpieper  04/06/97  created
#

#************************************************************************
#   NAME
# 
#   SYNOPSIS
# 
#   DESCRIPTION
#
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#
#   SEE ALSO
#
#   BUGS     
#
#------------------------------------------------------------------------
#
itk::usual ClassWESPattern {}
class ClassWESPattern {
    inherit ClassWESWaveCommon
    constructor                            {args} {}
    destructor                             {}
    public   variable   ticks              "0"
    private  variable   BOARD              ""
    private  variable   SIMM_HASH
    public   method     getBoard           {} {return $BOARD}
    public   method     setBoard           {brd}
    public   method     getBlocks          {} {return {}}
    public   method     setAt              {t {v ""}}
    public   method     setSIMMAt          {s t {v ""}}
    public   method     getSIMMSAt         {t}
    public   method     clear              {} 
    public   method     resize             {t}
    public   method     insertTicks        {at t}
    public   method     undo               {} {}
    public   method     redo               {} {}
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESPattern::constructor
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESPattern::constructor {args} {
    if {[llength $args] != 0 } {eval configure $args}
    set type "PATTERN"
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESPattern::undo
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESPattern::undo {} {
    ClassWESCommand::undo $this
    if [info exists SIMM_HASH] {
	foreach s [array names SIMM_HASH] {
	    $SIMM_HASH($s) undo $SIMM_HASH($s)
	}
    }
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESPattern::redo
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESPattern::redo {} {
    ClassWESCommand::redo $this
    if [info exists SIMM_HASH] {
	foreach s [array names SIMM_HASH] {
	    $SIMM_HASH($s) redo $SIMM_HASH($s)
	}
    }
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESPattern::clear
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESPattern::clear {} {
    set BOARD ""
    set ticks 0
    if [info exists SIMM_HASH] {
	foreach s $SIMM_HASH {
	    unset SIMM_HASH($s)
	}
    }
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESPattern::setBoard {board}
# PURPOSE : create an addition copy of the SIMM object instance
#           for faster access
# RETURN  : 1 SUCCESS, 0 FAILURE
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESPattern::setBoard {board} {
    set BOARD $board
    foreach s [$BOARD getSIMMS] {
	set SIMM_HASH([$s cget -name]) $s
    }
    return 1
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESPattern::getSIMMSAt
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESPattern::getSIMMSAt {t} {
    set sList {}
    foreach s [$BOARD getSIMMS] {
	if [$s hasTransitAt $t] {
	    lappend sList "$s"
	}
    }
    return $sList
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESPattern::setSIMMAt
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESPattern::setSIMMAt {s t {v ""}} {
    if [info exists SIMM_HASH] {
	if [info exists SIMM_HASH($s)] {
	    return [$SIMM_HASH($s) setAt $t $v]
	} else {
	    wesError SIMM_NOT_PRESENT "SIMM $s does not exists on board $BOARD"
	    return 0
	}

    } else {
	wesError PATTERN_NO_SIMMS "Pattern $name on Board $BOARD\n\
		does not contain any SIMM assignments.\n\
		Check the Board Configuration File."
	return 0
    }
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESPattern::setPatternAt
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESPattern::setAt {t {v ""}} {
    if [info exists SIMM_HASH] {
	foreach s [array names SIMM_HASH] {
	    if [$SIMM_HASH($s) setAt t $v] {
		
	    } else {
		return 0
	    }
	}
	return 1
    } else {
	wesError PATTERN_NO_SIMMS "Pattern $name on Board $BOARD\n\
		does not contain any SIMM assignments.\n\
		Check the Board Configuration File."
	return 0
    }
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESPattern::resize
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESPattern::resize {t} {
    if [info exists SIMM_HASH] {
	puts "SIMM_HASH exists"
	foreach s [array names SIMM_HASH] {
	    $SIMM_HASH($s) resize $t
	}
	return 1
    } else {
	return 0
    }
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESPattern::insertTicksAt
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESPattern::insertTicks {at n} {
    if [info exists SIMM_HASH] {
	foreach s [array names SIMM_HASH] {
	    #puts "ClassWESPattern::insertTicks $at $n"
	    $SIMM_HASH($s) insertTicks $at $n
	}
	return 1
    } else {
	puts "SIMM_HASH does not exist"
	return 0
    }
}
#
# ___oOo___


