#*******************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: classWESRuler.tcl,v 4.5 2004/01/16 15:25:02 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# hpieper  18/10/96  created
#

#************************************************************************
#   NAME
# 
#   SYNOPSIS
# 
#   DESCRIPTION
#
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#
#   SEE ALSO
#
#   BUGS     
#
#------------------------------------------------------------------------
#

itk::usual ClassWESRuler { }
class ClassWESRuler {
    inherit itk::Widget ClassWESError
    constructor       {args} {}
    destructor               {}
    itk_option define    -zoom        zoom        Zoom          "1.0"
    itk_option define    -xoffset     xoffset     Xoffset       "2"
    itk_option define    -canvas      canvas      Canvas        ""
    itk_option define    -rw          rw          Rw            "100"     
    itk_option define    -ticks       ticks       Ticks         "10"
    itk_option define    -px          px          Px            "0"
    itk_option define    -py          py          Py            "0" 
    itk_option define    -object      object      Object        ""
    private variable ctrlFlow
    private variable tScale 
    private variable time
    private variable ctrlLev "0"
    private variable y0
    private variable y1
    private variable y2
    private variable y3
    protected method   defbindings   {}
    public    method   display       {}
    public    method   gotoTick      {xt xn}
    public    method   cvMotion      {x y} 
    public    method   drawCtrlStat  {bl}
};#ClassWESRuler
 
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# INTERFACE
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

body ClassWESRuler::constructor {args} {
    
    eval itk_initialize $args 
    if {[llength $args] != 0 } {eval configure $args}
    
    defbindings
}


body ClassWESRuler::defbindings {} {
    
}

body ClassWESRuler::drawCtrlStat {bl} {

    if {$bl == {}} {
	return
    } else {
	set s [$bl cget -start]
	set e [$bl cget -end]
	set st [expr $itk_option(-px)+$s*$itk_option(-xoffset)]
	set et [expr $itk_option(-px)+$e*$itk_option(-xoffset)]

	switch -exact [$bl cget -ctrlType] {
	    "X" {
		set filColCmd {-fill green}
		eval {$itk_option(-canvas) create rect $st $y0 $et $y1 -tag block} $filColCmd
		for {set i $s} {$i < $e} {incr i} {
		    lappend ctrlFlow($i) [$bl cget -text]
		    lappend tScale($i) [$bl cget -freq] [$bl cget -tickT] 
		}
		if {![info exists time([expr $i -1])]} {
		    set time([expr $i-1]) [$bl cget -absTime]
		}
	    }
	    "R" {
		set filColCmd {-fill red}
		eval {$itk_option(-canvas) create rect $st 0 $et $y0 -tag block} $filColCmd
		for {set i $s} {$i < $e} {incr i} {
		    lappend ctrlFlow($i) [$bl cget -text] 
		}
		set time([expr $i-1]) [$bl cget -absTime]
	    }
	    "W" {
		
		set filColCmd {-fill blue}
		eval {$itk_option(-canvas) create rect $st $y0 $et $y1 -tag block} $filColCmd
		for {set i $s} {$i < $e} {incr i} {
		    lappend ctrlFlow($i) [$bl cget -text] 
		}
		if {![info exists time([expr $i -1])]} {
		    set time([expr $i-1]) [$bl cget -absTime]
		}
	    }
	}
	#eval {$itk_option(-canvas) create line $st 0 $st $y3 -tag block} $filColCmd
	incr ctrlLev
	foreach cmd [$bl getBlocks] {
	    drawCtrlStat $cmd
	}
    }
}

body ClassWESRuler::display {} {
    set ctrLev 0
    foreach a {ctrlFlow tScale time} {
	foreach e [array names $a] {
	    unset ${a}($e)
	}
    }
    #puts "Ruler display $itk_option(-ticks) ticks"

    #draw the time axis
    set y0 [expr 5+$itk_option(-py)]
    set y1 [expr 22+$itk_option(-py)]
    set y2 [expr 32+$itk_option(-py)]
    set y3 [expr 40+$itk_option(-py)]

    set x0 $itk_option(-px)
    set dx $itk_option(-xoffset)
    set xE [expr $x0+$itk_option(-rw)]
    $itk_option(-canvas) delete all

    $itk_option(-canvas) create line  $x0 $y1 $xE $y1 -fill black -tag clock
    for {set i 0;set x $x0} {$i <$itk_option(-ticks)} \
	    {incr i; set x [expr $x + $dx]} {
	$itk_option(-canvas) create line $x $y1 $x $y3 -fill black -tag clock
	
	for {set j 1} {($j <= 9) && ([expr $i+$j] < $itk_option(-ticks))} \
		{incr j} {
	    set x [expr $x+$dx]
	    $itk_option(-canvas) create line $x $y1 $x $y2\
		    -fill black -tag clock
	    incr i
	}  
	
    }
    $itk_option(-canvas) create line $x $y1 $x $y3 -fill black -tag clock

    foreach cmd [$itk_option(-object) getBlocks] {
	drawCtrlStat $cmd
    }
    foreach p [array names time] {
	$itk_option(-canvas) create text \
		[expr $itk_option(-px)+$p*$itk_option(-xoffset)] $y3 \
		-fill black -text $time($p) -tag clock
    }
    $itk_option(-canvas) raise clock
}

body ClassWESRuler::gotoTick {xt xn} {
    $itk_option(-canvas) delete rPos
    $itk_option(-canvas) create line $xt 22 $xt 50\
		-fill red -tag rPos
    if [info exists ctrlFlow($xn)] {
	#puts $ctrlFlow($xt)
	if {[info exists tScale($xn)]} {
	    return [list [join $ctrlFlow($xn) " . "] [join $tScale($xn) " / "]]
	} else {
	    return [list [join $ctrlFlow($xn)]]
	} 
    } else {
	return {}
    }
}

body ClassWESRuler::cvMotion {x y} {

}
configbody ClassWESRuler::ticks {
    #puts "ruler configure ticks $itk_option(-ticks)"
}

configbody ClassWESRuler::zoom {
    #set zoom $itk_option(-zoom)
    $itk_option(-canvas) scale all $itk_option(-px) $itk_option(-py) $itk_option(-zoom) 1
}
#
# ___oOo___


