#*******************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: classWESSIMM.tcl,v 4.5 2004/01/16 15:25:03 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# hpieper  04/06/97  created
#

#************************************************************************
#   NAME
# 
#   SYNOPSIS
# 
#   DESCRIPTION
#
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#
#   SEE ALSO
#
#   BUGS     
#
#------------------------------------------------------------------------
#
itk::usual ClassWESSIMM {}
class ClassWESSIMM {
    inherit ClassWESWaveCommon
    constructor            {args}     {}
    destructor                        {}
    public    variable     display    "0"
    public    variable     type       "BILEVEL"
    public    variable     pos        "0"
    public    variable     name       ""
    public    variable     board      ""
    private   variable     data       {{0 0}}

    public    method       setIniAt   {t val}
    public    method       setAt      {t val}
    public    method       setOnlyAt  {t val max}
    public    method       getAt      {t}
    public    method       hasTransitAt    {t}
    public    method       insertProfile   {st et sv ev type} {}
    public    method       insertTicks     {at n}
    public    method       resize          {t} {}
    public    method       getData         {ticks}
    public    method       setData         {d}

}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESSIMM::constructor
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESSIMM::constructor {args} {
    if {[llength $args] != 0 } {eval configure $args}
    set display 0
}

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESSIMM::setOnlyAt
# PURPOSE : set value at tick t to v
#
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESSIMM::setOnlyAt {t val max} {
    pushUndoStack "setData [list $data]"
    set ll [llength $data]
    set i 0
    set el [lindex $data $i]
    set tt [lindex $el 0]
    set v [lindex $el 1]
    set sList {}
    for {set i 0} {$i < $ll} {incr i} {
	set el [lindex $data $i]
	if {[lindex $el 0] >= $t} {
	    break
	}
    }
    # i now contains the transition of the element,
    # or the index of the following transition
    #delete the element

    set ibb 0
    set act 0
    set iff $ll
    set lbb {}
    set lff {}
    if {[lindex $el 0] == $t} {
	if {[lindex $el 1] == $val} {
	    return
	}
	if {($i != 0) && ($t == 0)} {
	    set lbb {}
	} elseif {$i > 0} {
	    set ibb [expr $i -1]
	    set lbb [lrange $data 0 $ibb]
	}
	if {$i < [expr $ll - 1]} {
	    set iff [expr $i + 1]
	}
	set act [lindex $el 1]
    } else {
	if {$i > 0} {
	    set ibb [expr $i -1]
	}
	set lbb [lrange $data 0 $ibb]
	set act [lindex [lindex $data $ibb] 1]
	if {$i < $ll} {
	    set iff $i
	} else {
	}
    }
    set lff [lrange $data $iff end]

    #puts "$lbb, $lff"
    set ppp ""
    set prev [lindex $lbb end]
    set next [lindex $lff 0]
    lappend ins "$t $val"
    #puts "set at $ins, p $prev, n $next"
    
    if {[set prev [lindex $lbb end]] != ""} {
	if {[set ppp [lindex $prev 1]] == $val} {
	    set ins ""
	}
    }
    if {[expr $t + 1] >= $max} {
	set data [concat $lbb $ins $lff]
	#puts "$name $data"
	#puts ""
	return
    } 
    if {[set next [lindex $lff 0]] != ""} {
	if {[set ft [lindex $next 0]] == [expr $t + 1]} {
	    set v [lindex $next 1]
	    if {$prev != ""} {
		if {($act != $ppp) && ($val != $v)} {
		    lappend ins "[expr $t +1] $act"
		}
	    } else {
		if {($act != $v) && ($val != $v)} {
		    lappend ins "[expr $t +1] $act"
		}
	    }
	    set lff [lreplace $lff 0 0] 
	} else {
	    lappend ins "[expr $t + 1] $act" 
	}
    } else {
	lappend ins "[expr $t +1] $act"
    }

    set data [concat $lbb $ins $lff]
    #puts "$name $data"
    #puts ""
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESSIMM::setAt
# PURPOSE : set value at tick t to v
#           if v is empty only the number of ticks is increased 
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESSIMM::setAt {t val} {
    pushUndoStack "setData [list $data]"
    set ll [llength $data]
    set i 0
    set el [lindex $data $i]
    set tt [lindex $el 0]
    set v [lindex $el 1]
    set sList {}
    for {set i 0} {$i < $ll} {incr i} {
	set el [lindex $data $i]
	if {[lindex $el 0] >= $t} {
	    break
	}
    }
    # i now contains the transition of the element,
    # or the index of the following transition
    #delete the element

    set ibb 0
    set iff $ll
    set lbb {}
    set lff {}
    if {[lindex $el 0] == $t} {
	if {[lindex $el 1] == $val} {
	    return
	}
	if {($i != 0) && ($t == 0)} {
	    set lbb {}
	} elseif {$i > 0} {
	    set ibb [expr $i -1]
	    set lbb [lrange $data 0 $ibb]
	}
	if {$i < [expr $ll - 1]} {
	    set iff [expr $i + 1]
	}
    } else {
	if {$i > 0} {
	    set ibb [expr $i -1]
	}
	set lbb [lrange $data 0 $ibb]
	if {$i < $ll} {
	    set iff $i
	}
    }
    set lff [lrange $data $iff end]
    set prev [lindex $lbb end]
    set next [lindex $lff 0]
    lappend ins "$t $val"

    if {[set prev [lindex $lbb end]] != ""} {
	if {[lindex $prev 1] == $val} {
	    set ins ""
	}
    }
    if {[set next [lindex $lff 0]] != ""} {
	if {[lindex $next 1] == $val} {
	    
	    set lff [lreplace $lff 0 0]
	} 
    }
    set data [concat $lbb $ins $lff]
    #puts "$name $data"
    #puts ""
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESSIMM::setIniAt
# PURPOSE : set value at tick t to v
#           if v is empty only the number of ticks is increased 
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESSIMM::setIniAt {t val} {
    set ll [llength $data]
    set i 0
    set el [lindex $data $i]
    set tt [lindex $el 0]
    set v [lindex $el 1]
    
    if {($ll > 0) && ([lindex [lindex $data [expr $ll -1]] 0] == 0) && \
	    ($t == 0)} {
	set data ""
	lappend data "$t $val"
	return $SUCCESS
    } else {
	if {($ll > 0) && ([lindex [lindex $data [expr $ll -1]] 0] < $t)} {
	    if {$val != [lindex [lindex $data [expr $ll -1]] 1]} {
		lappend data "$t $val"
	    }
	    return $SUCCESS
	} else {
	    wesError OVERWRITE_TICK "Invalid Assignment at tick $t\n\
		    \"$name = $val\"."
	    return $FAILED
	}

    }
    return $FAILED
}

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESSIMM::getAt
# RETURN  : the value of the SIMM at tick $t
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESSIMM::getAt {t} {
    set rc ""
    set ll [llength $data]
    set prv 0
    for {set i 0} {$i < $ll} {incr i} {
	set el [lindex $data $i]
	set tt [lindex $el 0]
	if {$tt < $t} {
	    set prv $i
	} elseif {$tt == $t} {
	    set rc [lindex $el 1]
	    break
	} else {
	    set prev [lindex $data $prv]
	    set rc [lindex $prev 1]    
	    break 
	}
    }
    if {$rc == ""} {
	set last [lindex $data [expr $ll - 1]]
	set rc [lindex $last 1]
    }
    return $rc
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESSIMM::transitAt
# RETURN  : true of false
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESSIMM::hasTransitAt {t} {
    if {[lsearch $data "$t *"] >= 0} {
	return 1
    } else {
	return 0
    }
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESSIMM::insertTicks
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESSIMM::insertTicks {at n} {
    pushUndoStack "setData [list $data]"
    #puts "ClassWESSIMM::insertTicks $at $n"
    set ll [llength $data]
    if {$ll > 1} {
	#puts $s
	#puts "before $data"
	set i 0
	set sList {}
	for {} {$i < $ll} {incr i} {
	    set el [lindex $data $i]
	    set tt [lindex $el 0]
	    if {$tt > $at} {
		break
	    }
	    lappend sList $el
	}
	for {} {$i < $ll} {incr i} {
	    set el [lindex $data $i]
	    set tt [lindex $el 0]
	    set v [lindex $el 1]
	    lappend sList "[expr $n + $tt] $v"
	}
	set data $sList
	#puts "after  $data"
    }
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESSIMM::getData 
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESSIMM::getData {ticks} {
    set tList {}
    set last [lindex $data [expr [llength $data] -1]]
    set tList $data
    if {[lindex $last 0] != $ticks} {
	lappend tList "$ticks [lindex $last 1]"
    }
    set ll [llength $tList] 
    set sList {}
    set prev 0
    switch -exact $type {
	"BILEVEL" {
	    for {set i 0} {$i < $ll} {incr i} {
		set e0 [lindex [lindex $tList $i] 0]
		set e1 [lindex [lindex $tList $i] 1]
		set pr1 [lindex [lindex $tList $prev] 1]
		if {$e1 != $pr1} {
		    lappend sList "$e0 $pr1"
		}
		lappend sList "$e0 $e1"
		set prev $i
	    }
	}
	"MULTILEVEL" {
	    for {set i 0} {$i < $ll} {incr i} {
		set e0 [lindex [lindex $tList $i] 0]
		set e1 [lindex [lindex $tList $i] 1]
		set pr1 [lindex [lindex $tList $prev] 1]
		if {$e1 != $pr1} {
		    lappend sList "$e0 [expr $pr1/255.0]"
		}
		lappend sList "$e0 [expr $e1/255.0]"
		set prev $i
	    }
	}
    }
    return $sList
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESSIMM::setData 
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESSIMM::setData {d} {
    set data $d
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESSIMM::resize 
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESSIMM::resize {t} {
    pushUndoStack "setData [list $data]"
    set sList {}
    set ll [llength $data]
    for {set i 0} {$i < $ll} {incr i} {
	set el [lindex $data $i]
	set tt [lindex $el 0]
	if {$tt < $t} {
	    lappend sList $el
	}
    }
    set data $sList
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESSIMM::insetProfile
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESSIMM::insertProfile {st et sv ev type} {
    pushUndoStack "setData [list $data]"
    set sList {}
    set vs [getAt $st]
    set ll [llength $data]
    set prv [getAt $st]
    switch -exact $type {
	exp1 {
	    set i 0
	    for {set i 0} {$i < $ll} {incr i} {
		set el [lindex $data $i]
		set tt [lindex $el 0]
		if {$tt < $st} {
		    lappend sList $el
		}
	    }
	    set tau [expr (-1.0)*$et/log(255.0)]
	    for {set j $st} {$j <= $et} {incr j} {
		set v [expr int([expr exp([expr (-1.0)*$j/$tau])])]
		#puts "set $s at $i to $v"
		if {$v != $prv} {
		    lappend sList "$j $v"
		    set prv $v
		}
	    }
	    for {;} {$i < $ll} {incr i} {
		lappend sList [lindex $data $i]
	    }
	    set data $sList
	}
	exp2 {
	    set i 0
	    for {set i 0} {$i < $ll} {incr i} {
		set el [lindex $data $i]
		set tt [lindex $el 0]
		if {$tt < $st} {
		    lappend sList $el
		}
	    }
	    set tau [expr (-1.0)*$et/log(255.0)]
	    for {set j $st} {$j <= $et} {incr j} {
		set v [expr 255 - int([expr exp([expr (-1.0)*$j/$tau])])]
		#puts "set $s at $i to $v"
		if {$v != $prv} {
		    lappend sList "$j $v"
		    set prv $v
		}
	    }
	    for {;} {$i < $ll} {incr i} {
		lappend sList [lindex $data $i]
	    }
	    set data $sList
	}
	ramp1 {
	    set i 0
	    for {set i 0} {$i < $ll} {incr i} {
		set el [lindex $data $i]
		set tt [lindex $el 0]
		if {$tt < $st} {
		    lappend sList $el
		}
	    }
	    set a [expr 255.0/($et - $st)]
	    for {set j $st} {$j <= $et} {incr j} {
		set v [expr int([expr $a*$j])]
		#puts "set $s at $i to $v"	
		if {$v != $prv} {
		    lappend sList "$j $v"
		    set prv $v
		}
	    }
	    for {;} {$i < $ll} {incr i} {
		lappend sList [lindex $data $i]
	    }
	    set data $sList
	}
	ramp2 {
	    set i 0
	    for {set i 0} {$i < $ll} {incr i} {
		set el [lindex $data $i]
		set tt [lindex $el 0]
		if {$tt < $st} {
		    lappend sList $el
		}
	    }
	    set a [expr 255.0/($et - $st)]
	    for {set j $st} {$j <= $et} {incr j} {
		set v [expr 255 - int([expr $a*$j])]
		#puts "set $s at $i to $v"
		if {$v != $prv} {
		    lappend sList "$j $v"
		    set prv $v
		}
	    }
	    for {;} {$i < $ll} {incr i} {
		lappend sList [lindex $data $i]
	    }
	    set data $sList
	}
    }
    unset sList
}
#
# ___oOo___


