#*******************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: classWESSeqData.tcl,v 4.5 2004/01/16 15:25:04 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# hpieper  29/04/97  created
#

#************************************************************************
#   NAME
# 
#   SYNOPSIS
# 
#   DESCRIPTION
#
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#
#   SEE ALSO
#
#   BUGS     
#
#------------------------------------------------------------------------
#
itk::usual ClassWESSeqData {}
class ClassWESSeqData {
    inherit ClassWESUSeqData
    constructor            {args} {}
    destructor                    {}
    private variable  SEQUENCE
    public  method    renameSeq       {seq n}
    public  method    createSeq       {s px py po}
    public  method    isSeq           {s}
    public  method    getPV           {s}
    public  method    getSeq          {}
    public  method    clearWave       {}
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESSeqData::constructor
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESSeqData::constructor {args} {
    if {[llength $args] != 0 } {eval configure $args}
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESSeqData::renameSeq
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESSeqData::renameSeq {seq n} {
    set rc 0
    if {[info exist SEQUENCE([$seq cget -name])]} {
	unset SEQUENCE([$seq cget -name])
	$seq configure -name $n 
	set SEQUENCE($n) $seq
	set rc 1
    }	
    return $rc
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESSeqData::clearWave 
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESSeqData::clearWave       {} {
    ClassWESUSeqData::clearWave
    foreach s [array names SEQUENCE] {
	delete object $SEQUENCE($s)
	unset SEQUENCE($s)
    } 
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESSeqData::createSeq 
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESSeqData::createSeq       {s px py po} {
    if ![info exists SEQUENCE($s)] {
	set SEQUENCE($s) [ClassWESSequence $this.sq$s \
		-px $px -py $py -porder $po -name $s -type "SEQUENCE"]
	
    } 
    return $SEQUENCE($s)
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESSeqData::isSeq 
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESSeqData::isSeq           {s} {
    return [info exists SEQUENCE($s)]
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESSeqData:getPV 
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESSeqData::getPV           {s} {
    if ![isSeq $s] {
	set rc ""
    } else {
	set rc [list \
		[$SEQUENCE($s) cget -px] \
		[$SEQUENCE($s) cget -py] \
		[$SEQUENCE($s) cget -porder] \
		]
    }
    return $rc
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESSeqData::getSeq 
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESSeqData::getSeq          {} {
    set sList {}
    foreach s [array names SEQUENCE] {
	lappend sList $SEQUENCE($s)
    }
    return $sList
}

#
# ___oOo___


