#*******************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: classWESTeEditor.tcl,v 4.5 2004/01/16 15:25:05 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# hpieper  28/04/97  created
#

#************************************************************************
#   NAME
# 
#   SYNOPSIS
# 
#   DESCRIPTION
#
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#
#   SEE ALSO
#
#   BUGS     
#
#------------------------------------------------------------------------
#
itk::usual ClassWESTeEditor { }
class ClassWESTeEditor {
    inherit itk::Widget ClassWESError
    constructor       {args} {}
    destructor               {}
    itk_option define  -waveData  waveData  WaveData  ""
    itk_option define  -displData displData DisplData ""
    itk_option define  -debug     debug     Debug     ""
    itk_option define  -label     label     Label     ""    
    itk_option define  -object    object    Object    ""
    itk_option define  -path      path      Path      ""
    public    method   clear              {}
    public    method   load               {f {mode 0}}
    public    method   reload             {}
    
    public    method   save               {}
    public    method   saveAs             {f}
    public    method   display            {{redraw 1}}
    public    method   markDirty          {} 
    protected method defbindings        {}
    
};#ClassWESTeEditor

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESTeEditor::constructor
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESTeEditor::constructor {args} {
    itk_component add mfr {
	frame $itk_interior.mfr
    } {
	usual
	keep -width
	keep -height
    }
    itk_component add scrltext {
	scrolledtext $itk_component(mfr).wesTextDisplay\
		-labelpos nw -labeltext "" \
		-background Grey90\
		-foreground Black\
		-vscrollmode static -hscrollmode static \
		-textfont "-Adobe-helvetica-medium-r-normal--12*" \
		-wrap none
    } {
	usual
	keep -height
	keep -width
	rename -labeltext -label label Label 
	ignore -textfont
    }
    itk_component add bfr {
	frame $itk_component(mfr).bfr -width 15
    } {
	usual
	ignore -width
	keep   -height
    }
    itk_component add textPos {
	label $itk_component(bfr).sbar -textvariable PROP(line) \
		-relief groove -bd 1 -anchor ne
    }
    eval itk_initialize $args 
    if {[llength $args] != 0 } {eval configure $args}

    pack $itk_component(scrltext) -side left   -fill both -expand true
    #pack $itk_component(textPos)  -side left   -fill both -expand true
    #pack $itk_component(bfr)      -side left   -fill y -expand true -anchor ne
    pack $itk_component(mfr)      -side left   -fill both -expand true
    defbindings
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESTeEditor::clear
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESTeEditor::clear {} {
    $itk_component(scrltext) clear
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESTeEditor::defbindings
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESTeEditor::defbindings {} {
    bind [$itk_component(scrltext) component text] <KeyPress> \
	    [code $this markDirty] 
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESTeEditor::markDirty
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESTeEditor::markDirty {} {
    if {$itk_option(-object) != ""} {
	$itk_option(-object) markDirty 1 TEXT
    }
    
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESTeEditor::display
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESTeEditor::display {{redraw 1}} {
    #puts "ClassWESTeEditor::display -> $itk_option(-object)."
    $itk_component(scrltext) clear
    set parser [ClassWESParser #auto]
    $parser setOutputBuffer $itk_component(scrltext)
    set rc [$itk_option(-waveData) writeWaveform [code $parser] $itk_option(-object)]
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESTeEditor::load
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESTeEditor::load {f {mode 0}} {
    $itk_option(-waveData) clearWave
    $itk_option(-displData) clear
    $itk_component(scrltext) clear
    $itk_component(scrltext) import $f
    return [$itk_option(-waveData) load $itk_component(scrltext)]    
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESTeEditor::reload
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESTeEditor::reload {} {
    set obj ""
    set rc $SUCCESS
    if {(($itk_option(-object) != "") && [$itk_option(-object) isDirty] && \
	    ([$itk_option(-object) getDirtyMode] == "TEXT")) \
	    || ($itk_option(-object) == "")} {
	$itk_option(-waveData) clearWave
	$itk_option(-displData) clear
	set parser [ClassWESParser #auto]
	$parser setInputBuffer $itk_component(scrltext)
	set rc [$itk_option(-waveData) \
		readWaveform [code $parser] 0]
	delete object $parser
	return $rc
    }
    return $rc
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESTeEditor::save
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESTeEditor::save {} {
    return [$itk_option(-waveData) save $itk_option(-object)]
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESEditor::saveAs 
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESTeEditor::saveAs {f} {
    set w [$itk_option(-waveData) saveAs $itk_option(-object) $f]
    update
    display
}
configbody ClassWESTeEditor::object {
    #$itk_component(scrltext) clear
    $this configure -label ""
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESTeEditor::path
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
configbody ClassWESTeEditor::path {
    #set ClassWESTranslator::path $itk_option(-path)
    #$itk_option(-waveData) configure -path $itk_option(-path)
    #puts "configure path $itk_option(-path)"
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESTeEditor::waveData
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
configbody ClassWESTeEditor::waveData {
    #set ClassWESTranslator::waveData $itk_option(-waveData)
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESTeEditor::displData
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
configbody ClassWESTeEditor::displData {
    #set ClassWESTranslator::displData $itk_option(-displData)
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESTeEditor::debug
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
configbody ClassWESTeEditor::debug {
    #set ClassWESTranslator::debug $itk_option(-debug)
}
#
# ___oOo___


