#*******************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: classWESTrUSeq.tcl,v 4.5 2004/01/16 15:25:08 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# hpieper  29/04/97  created
#

#************************************************************************
#   NAME
# 
#   SYNOPSIS
# 
#   DESCRIPTION
#
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#
#   SEE ALSO
#
#   BUGS     
#
#------------------------------------------------------------------------
#
itk::usual ClassWESTrUSeq { }

class ClassWESTrUSeq { 
    inherit ClassWESTrPat
    constructor               {args}      {}
    destructor                            {} 
    public    method   readUSeq          {parser {zero 0} {saveFlg 0}}
    public    method   readInUSeq        {parser {zero 0}}
    public    method   readOutUSeq       {parser {zero 0}}
    public    method   scanUSeq          {useq}
    public    method   writeOutUSeq      {parser useq {saveToHD 0}}
    public    method   writeInUSeq       {parser useq {saveToHD 0}}
}
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESTrUSeq::constructor
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESTrUSeq::constructor {args} {
    if {[llength $args] != 0 } {eval configure $args}
}
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESTrUSeq::readUSeq
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESTrUSeq::readUSeq {parser {zero 0} {saveFlg 0}} {
    set rc $FAILED
    #puts "zero is $zero"
    #puts "readUSeq"
    while {[set t [$parser getToken]] != ""} {
	switch -exact $t {
	    "USEQUENCE" {
		set rc [readInUSeq $parser $zero]
	    }
	    "USEQUENCE_START" {
		set rc [readOutUSeq $parser $zero]
		if {$saveFlg && ($rc != 0)} {
		    set pars [ClassWESParser #auto]
		    set f $path/[$rc cget -name]$inUSeqFileExt
		    dbg "saving USEQ \"[rc cget -name]\" to file \"$f\"."
		    $pars setOutputFile $f
		    writeInUSeq [code $pars] $rc
		    $pars closeOutput
		    delete object $pars
		    clearWave
		    $displData clear
		}
	    }
	}
    }
    if {$rc == $FAILED} {
	set msg "[$parser getInfo]\n\
		does not contain valid  USequence definitions."
	dbg "<<ERROR-Translator>> $msg"
	wesError $SYNTAX_ERROR "$msg"
	return $FAILED
    }
    return $rc   
}
# ----------------------------------------------------------------------------------
# Read USequence Input Format
# ----------------------------------------------------------------------------------

body ClassWESTrUSeq::readInUSeq {parser {zero 0}} {
    set rc $WAVEFORM_EMPTY
    #puts "readInUSeq"
    set t ""
    setTick 0

    #expect the keyword USEQUENCE first"
    if {[set useq  [$parser getToken]] != ""} {
	if {[set t [$parser getToken]] != "\{"} {
	    set msg "USeq Definition in [$parser getInfo]:\n\
		    is corrupt.\n\"\{\" expected but found \"$t\"."
	    dbg "<<ERROR-Translator>> $msg"
	    wesError $SYNTAX_ERROR "$msg"
	    return $FAILED
	}
	dbg "<Translator> Processing USequence \"$useq\""
	if {[set useqObj [createUSeq $useq]] != $FAILED} {
	    if {[$parser getBuffer] == "file"} {
		 markDirty $useq 0
	    }		
	    while {1} {
		set p [$parser getToken]
		switch -exact $p {
		    "\}" {break}
		    ""   {break}
		    default 
		    {   
			set f "$path/$p$inPatFileExt"
			set pars [ClassWESParser #auto]
			set tick [getTicks]
			#puts "before readPattern $tick"
			if {![$useqObj isUSeqPattern $p] || ($zero != 0)} {
			    if {[$pars setInputFile $f] != 0} {
				if {[set patObj [readPattern [code $pars] $zero]] == $FAILED} {
				    delete object $pars
				    set msg "cannot read pattern $p in USEQ\"$useq\"" 
				    dbg "<ERROR-Translator> $msg"
				    wesError $SYNTAX_ERROR "$msg"
				    return $FAILED
				}
				delete object $pars
				#puts "after readPattern [getTicks]"
				if {[ getTicks] < $tick} {
				    #puts "setting ticks to $tick"
				    if {[wesConfirm $OVERWRITE_WAVEFORM "adjust Pattern [$patObj cget -name]\
					    length to [expr $tick+1] Ticks.\n\
					    as used in USequence [$useqObj cget -name]"] == "OK"} {
					setTick $tick
					set patPars [ClassWESParser #auto]
					ClassWESWaveIF::save $patObj
				    }
				}
				if {![$useqObj isUSeqPattern $p]} {
				    if ![$useqObj insertPattern $patObj] {
					return $FAILED
				    }
				}
			    } else {
				set msg "USequence Definition in [$parser getInfo] is corrupt.\n\
					cannot open file \"$f\"."
				dbg "<<ERROR-Translator>> $msg"
				wesError $CANNOT_OPEN_FILE "$msg"
				return $FAILED
			    }		
			}
			if {[set t [$parser getToken]] != ";"} {
			    #wesError, the definition has to end with a semi colon
			    set msg "Pattern Definition in [$parser getInfo] is corrupt.\n\
				    missing \";\"."
			    dbg "<<ERROR-Translator>> $msg"
			    wesError $SYNTAX_ERROR "$msg"
			    return $FAILED
			}
			set rc $useqObj	
		    }
		}
	    }
	    $useqObj createComment [$parser cget -comment]
	    $parser configure -comment {}
	}
    } else {
	#wesError
	set m "USequence Definition in [$parser getInfo]: <useq_name> is corrupt"
	dbg "<<ERROR-Translator>> $m"
	wesError SYNTAX_ERROR $m
	return $FAILED
    }
    if {$rc == $WAVEFORM_EMPTY} {
	set msg "cannot find  pattern defs in USEQ\"$useq\"" 
	dbg "<ERROR-Translator> $msg"
	wesError $WAVEFORM_EMPTY "$msg"
	return $FAILED
    }
    $useqObj configure -length "[expr [getTicks] +1] ticks"
    return $useqObj
}
# ----------------------------------------------------------------------------------
# Read USequence Output Format
# ----------------------------------------------------------------------------------
body ClassWESTrUSeq::readOutUSeq {parser {zero 0}} {
    set rc $WAVEFORM_EMPTY
    #puts "readOutUSeq"
    setTick 0
    if {[set useq  [$parser getToken]] != ""} {
	dbg "<Translator> Processing USequence \"$useq\""
	if {[set useqObj [createUSeq $useq]] != $FAILED} {
	    if {[$parser getBuffer] == "file"} {
		 $useqObj markDirty 0
	    }		
	    while {1} {
		set p [$parser getToken]
		switch -exact $p {
		    "USEQUENCE_END" {break}
		    ""   {break}
		    default 
		    {   
			
			set f "$path/$p$inPatFileExt"
			set tick [ getTicks]
			if {![$useqObj isUSeqPattern $p] || ($zero != 0)} {
			    set pars [ClassWESParser #auto]
			    if {[$pars setInputFile $f] != 0} {
				if {[set patObj [readPattern [code $pars] $zero]] == $FAILED} {
				    delete object $pars
				    set msg "cannot read pattern $p in USEQ\"$useq\"" 
				    dbg "<ERROR-Translator> $msg"
				    wesError $SYNTAX_ERROR "$msg"
				    return $FAILED
				}
			    } else {
				set msg "USequence Definition in [$parser getInfo] is corrupt.\n\
					cannot open file \"$f\"."
				dbg "<<ERROR-Translator>> $msg"
				wesError $CANNOT_OPEN_FILE "$msg"
				return $FAILED
			    }
			    delete object $pars
			    if {[ getTicks] < $tick} {
				#puts "setting ticks to $tick"
				if {[wesConfirm $OVERWRITE_WAVEFORM "adjust Pattern [$patObj cget -name]\
					length to [expr $tick+1] Ticks.\n\
					as used in USequence [$useqObj cget -name]"] == "OK"} {
				    setTick $tick
				    set patPars [ClassWESParser #auto]
				    ClassWESWaveIF::save $patObj				   
				}
			    }
			    if ![$useqObj isUSeqPattern $p] {
				if ![$useqObj insertPattern $patObj] {
				    return $FAILED
				}
			    }
			    
			}
		    }
		}
	    }
	    $useqObj createComment [$parser cget -comment]
	    $parser configure -comment {}
	    set rc $useqObj
	}
	
    } else {
	#wesError
	set m "USequence Definition in [$parser getInfo]: <useq_name> is corrupt"
	dbg "<<ERROR-Translator>> $m"
	wesError $SYNTAX_ERROR $m
	return $FAILED
    } 
    if {$rc == $WAVEFORM_EMPTY} {
	set msg "cannot find  pattern defs in USEQ\"$useq\"" 
	dbg "<ERROR-Translator> $msg"
	wesError $WAVEFORM_EMPTY "$msg"
	return $FAILED
    }
    $useqObj configure -length "[expr [getTicks] + 1] ticks"
    return $useqObj
}
# ----------------------------------------------------------------------------------
# Write USequence Input Format
# ----------------------------------------------------------------------------------

body ClassWESTrUSeq::writeInUSeq {parser useqObj {saveToHD 0}} {
    foreach c [$useqObj getComment] {
	set cmt [lindex $c 1]
	$parser putToken "$cmt"    
    }
    set patList [$useqObj getUSeqPattern]
    $parser putToken "USEQUENCE [$useqObj cget -name]"
    $parser putToken "\{"
    foreach p $patList {
	$parser putToken "    [$p cget -name];"
    }
    $parser putToken "\}"
    if {$saveToHD} {
	foreach p $patList {
	    #scanPat $p
	    set pars [ClassWESParser #auto]
	    set f $path/[$p cget -name]$inPatFileExt
	    dbg "saving PATTERN \"[$p cget -name]\" to file \"$f\"."
	    $pars setOutputFile $f
	    writeInPattern [code $pars] $p
	    $pars closeOutput
	    delete object $pars
	}
    }
}
# ----------------------------------------------------------------------------------
# Write USequence in Output Format
# ----------------------------------------------------------------------------------
body ClassWESTrUSeq::writeOutUSeq {parser useqObj {saveToHD 0}} {
    foreach c [$useqObj getComment] {
	set cmt [lindex $c 1]
	$parser putToken "$cmt"    
    }
    set patList [$useqObj getUSeqPattern]
    $parser putToken "USEQUENCE_START [$useqObj cget -name]"
    foreach p $patList {
	$parser putToken "    [$p cget -name]"
    }
    $parser putToken "USEQUENCE_END"
    if {$saveToHD} {
	foreach p $patList {
	    #scanPat $p
	    set pars [ClassWESParser #auto]
	    set f $path/[$p cget -name]$outPatFileExt
	    dbg "saving PATTERN \"[$p cget -name]\" to file \"$f\"."
	    $pars setOutputFile $f
	    writeOutPattern [code $pars] $p
	    $pars closeOutput
	    delete object $pars
	}
    }
}
# ----------------------------------------------------------------------------------
# ClassWESTrUSeq::scanUSeq 
# ----------------------------------------------------------------------------------
body ClassWESTrUSeq::scanUSeq {useq} {
    set parser [ClassWESParser #auto]
    set f "$path/$useq$inUSeqFileExt"
    $parser setInputFile $f
    createComment $useq [$parser cget -comment]
    delete object $parser
}
#
# ___oOo___


