#*******************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: classWESTranslator.tcl,v 4.5 2004/01/16 15:25:08 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# hpieper  29/10/96  created
#

#************************************************************************
#   NAME
#       ClassWESTranslator - Translator for waveform description formats
#   SYNOPSIS
# 
#   DESCRIPTION
#
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#
#   SEE ALSO
#
#   BUGS     
#
#------------------------------------------------------------------------
#

itk::usual ClassWESTranslator { }

class ClassWESTranslator {
    inherit ClassWESTrSeq
    constructor               {args}      {}
    destructor                            {} 

    public    method   readWaveform      {parser {zero 0}}
    public    method   writeWaveform     {parser w}
}

body ClassWESTranslator::constructor {args} {
    
}


# ----------------------------------------------------------------------------------
# Reading the Waveform File
# ----------------------------------------------------------------------------------
body ClassWESTranslator::readWaveform {parser {zero 0}} {
    set rc $FAILED
    while {[set t [$parser getToken]] != ""} {
	switch -exact $t {
	    "PATTERN" {
		set rc [readInPattern $parser $zero]
	    }
	    "PATTERN_START" {
		$displData clear
		clearWave
		set rc [readOutPattern $parser $zero]
		if {$rc != $FAILED} {
		    set pars [ClassWESParser #auto]
		    set f $path/[$rc cget -name]$inPatFileExt
		    dbg "saving PATTERN \"[$rc cget -name]\" to file \"$f\"."
		    if [$pars setOutputFile $f] {
			dbg "saving PATTERN \"[$rc cget -name]\" to file \"$f\"."
			writeInPattern [code $pars] $rc
			$pars closeOutput
		    } else {
			dbg "cannot write to file $f"
		    }
		    delete object $pars
		}
	    }
	    "USEQUENCE" {
		set rc [readInUSeq $parser $zero]
	    }
	    "USEQUENCE_START" {
		$displData clear
		clearWave
		set rc [readOutUSeq $parser $zero]
		if {$rc != $FAILED} {
		    set pars [ClassWESParser #auto]
		    set f $path/[$rc cget -name]$inUSeqFileExt
		    if [$pars setOutputFile $f] {
			dbg "saving USequence \"[$rc cget -name]\" to file \"$f\"."
			writeInUSeq [code $pars] $rc
			$pars closeOutput
		    } else {
			dbg "cannot write to file $f"
		    }
		    delete object $pars
		}
	    }
	    "SEQUENCE" {
		set rc [readInSeq $parser]
	    }
	    "SEQUENCE_START" {
		$displData clear
		clearWave
		set rc [readOutSeq $parser]
		if {$rc != $FAILED} {
		    set pars [ClassWESParser #auto]
		    set f $path/[$rc cget -name]$inSeqFileExt
		     if [$pars setOutputFile $f] {
			 $pars setOutputFile $f
			 dbg "saving SEQUENCE \"[$rc cget -name]\" to file \"$f\"."
			 writeInSeq [code $pars] $rc
			 $pars closeOutput
		     } else {
			dbg "cannot write to file $f"
		    }
		    delete object $pars
		    #clearWave
		    #$displData clear
		}
	    }
	    "BOARDCONFIG_START" {
		
	    }
	}
	#puts "rc = $rc"
    }
    if {$rc == $FAILED} {
	set msg "[$parser getInfo]\n\
		does not contain valid Waveform definitions."
	dbg "<<ERROR-Translator>> $msg"
	wesError "Translator" "$msg" 0
	return  $FAILED
    }
    return $rc

}
body ClassWESTranslator::writeWaveform {parser w} {
    set rc 0
    switch -exact [$w cget -type] {
	"PATTERN" {
	    writeInPattern $parser $w
	}
	"USEQUENCE" {
	    writeInUSeq $parser $w
	    
	}
	"SEQUENCE" {
	    writeInSeq $parser $w
	    
	}
	default {
	    puts "unknown type \"$w\"." 
	}
    }
}
#
# ___oOo___


