#*******************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: classWESUSequence.tcl,v 4.5 2004/01/16 15:25:09 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# hpieper  04/06/97  created
#

#************************************************************************
#   NAME
# 
#   SYNOPSIS
# 
#   DESCRIPTION
#
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#
#   SEE ALSO
#
#   BUGS     
#
#------------------------------------------------------------------------
#
itk::usual ClassWESUSequence {}
class ClassWESUSequence {
    inherit ClassWESWaveCommon
    constructor            {args}    {}
    destructor                       {}
    public   variable      ticks     "0"
    
    private  variable      PATTERNS	{}
    public   method        clear         {}
    public   method        getBlocks     {}  {return {}}
    public   method        insertPattern {p}
    public   method        isUSeqPattern {p}   
    public   method        getUSeqPattern  {}
    public   method        setAt         {t {v ""}}
    public   method        getBoard      {}
    public   method        insertTicks   {at n}
    public   method        undo          {} {}
    public   method        redo          {} {}
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESUSequence::constructor
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESUSequence::constructor {args} {
    if {[llength $args] != 0 } {eval configure $args}
    set type USEQUENCE
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESUSequence::destructor
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESUSequence::destructor {} {
    #destroy all
    clear
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESUSequence::undo
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESUSequence::undo {} {
    ClassWESCommand::undo $this
    if [info exists PATTERNS] {
	foreach p $PATTERNS {
	    $p undo
	}
    }
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESUSequence::redo
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESUSequence::redo {} {
    ClassWESCommand::redo $this
    if [info exists PATTERNS] {
	foreach p $PATTERNS {
	    $p redo
	}
    }
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESUSequence::clear
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESUSequence::clear {} {
    set PATTERNS {}
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESUSequence::insetTicks
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESUSequence::insertTicks   {at n} {
    set rc 1
    if ![info exists PATTERNS] {
	return 0
    }
    #puts "patterns $PATTERNS"
    foreach p $PATTERNS {
	if ![$p insertTicks $at $n] {
	    return 0
	} 
    }
    return $rc
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESUSeqData::setUSeqAt 
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESUSequence::setAt       {t {v ""}} {
    set rc 0
    foreach p $PATTERNS {
	set rc [$p setAt $t $v] 
    }
    return $rc
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESUSequence::isUSeqPattern 
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESUSequence::isUSeqPattern   {p} {
    if ![info exists PATTERNS] {
	return 0
    }
    if {[lsearch $PATTERNS $p] >= 0} {
	return 1
    } else {
	return 0
    }
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESUSequence::isUSeqPattern 
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESUSequence::getUSeqPattern   {} {
    if ![info exists PATTERNS] {
	return {}
    }
    return $PATTERNS
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESUSequence::getBoard 
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESUSequence::getBoard {} {
    set sList {}
    foreach p $PATTERNS {
	lappend sList [$p getBoard]
    }
    return $sList
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESUSequence::insertPattern
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESUSequence::insertPattern {pObj} {
    if [info exists PATTERNS] {
	if {[lsearch -exact $PATTERNS $pObj] >= 0} {
	    wesError DUPLICATE_PATTERN "PATTERN [$pObj cget -name]\n\
		    already exists in USEQUENCE $name."
	    return 0
	} else {
	    foreach p $PATTERNS {
		if [string match [[$pObj getBoard] cget -name] \
			[[$p getBoard] cget -name]] {
		    wesError DUPLICATE_PATTERN "PATTERN for BOARD [$p getBoard]\n\
			    already exists in USEQUENCE $name."
		    return 0
		}
	    }
	    lappend PATTERNS $pObj
	    return 1
	}
    } else {
	lappend PATTERNS $pObj
	return 1
   }
    
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESUSequence::isUSeqPattern
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESUSequence::isUSeqPattern {p} {
    set rc 0
    if [info exists PATTERNS] {
	foreach e $PATTERNS {
	    if [string match [$e cget -name] $p] {
		return 1
	    }
	}
    }
    return $rc
}
#
# ___oOo___


