#*******************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: classWESWaveCommon.tcl,v 4.5 2004/01/16 15:25:10 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# hpieper  04/06/97  created
#

#************************************************************************
#   NAME
# 
#   SYNOPSIS
# 
#   DESCRIPTION
#
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#
#   SEE ALSO
#
#   BUGS     
#
#------------------------------------------------------------------------
#
itk::usual ClassWESWaveCommon {}
class ClassWESWaveCommon {
    inherit ClassWESCommand
    constructor            {args}     {}
    destructor                        {}
    #sequencer freq is 50Mhz
    public    common    baseClkF            "50.0e+6"
    #sequencer tickT is 20ns
    public    common    baseClkT            "20.0e-9"


    public    variable  absTime        "0.0"
    public    variable  length         "0"  
    public    variable  type           ""
    public    variable  name           ""
    protected variable  readOnly       "0"
     
    private   variable  dirty          "0"
    private   variable  dirtyType      "TEXT";#GRAPHIC
    private   variable  COMMENT		{}
    public    method    createComment   {c} 
    public    method    getComment      {}
    public    method    noModify       {} {return $readOnly}
    public    method    markDirty      {flag {mode ""}}
    public    method    isDirty        {} {return $dirty} 
    public    method    getDirtyMode   {} {return $dirtyType}

    public    method    setLength      {l}
    public    method    getLength      {} {return $length}
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESWaveCommon::constructor
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESWaveCommon::constructor {args} {
    if {[llength $args] != 0 } {eval configure $args}
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESWaveCommon::destructor
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESWaveCommon::destructor {} {
    #destroy all
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESWaveCommon::setLength
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESWaveCommon::setLength {l} {
    pushUndoStack "configure -length [list $length]"
    set length $l
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESWaveCommon::markDirty 
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESWaveCommon::markDirty {flag {mode ""}} {
    set dirty $flag
    set dirtyType    $mode
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESWaveCommon::createComment
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESWaveCommon::createComment {c} {
    set COMMENT $c
    #puts "COMMENT for $this is \"$COMMENT\"."
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESWaveCommon::getComment
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESWaveCommon::getComment {} {
    if [info exists COMMENT] {
	#puts "COMMENT for $this is \"$COMMENT\"."
	return $COMMENT
    } else {
	#puts "no comments for $this"
	return {}
    }
}
#
# ___oOo___


