#*******************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: classWESWaveIF.tcl,v 4.5 2004/01/16 15:25:11 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# vlttc  20/05/97  created
#

#************************************************************************
#   NAME
# 
#   SYNOPSIS
# 
#   DESCRIPTION
#
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#
#   SEE ALSO
#
#   BUGS     
#
#------------------------------------------------------------------------
#
itk::usual ClassWESWaveIF {}
class ClassWESWaveIF {
    inherit ClassWESTranslator
    constructor                       {args} {}
    destructor                        {}
    public  method    load            {b}
    public  method    save            {w}
    public  method    saveAs          {w f}

};#ClassWESWaveIF

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESWaveIF::constructor 
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESWaveIF::constructor {args} {
    if {[llength $args] != 0 } {eval configure $args}
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESWaveIF::save 
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESWaveIF::save {w} {
    set rc ""
    set f1 ""
    set f2 ""
    #puts "ClassWESWaveIF::save $w."
    
    if {$w != ""} {
	switch [$w cget -type] {
	    "PATTERN" {
		Busy "saving PAT [$w cget -name]"   
		set f1 "$path/[$w cget -name]$inPatFileExt"
		set f2 "$path/[$w cget -name]$outPatFileExt"
		set parser [ClassWESParser #auto]
		dbg "saving PATTERN \"[$w cget -name]\" to file \"$f1\"."
		$parser setOutputFile $f1
		set rc [writeInPattern [code $parser] $w 1]
		$parser closeOutput
		dbg "saving PATTERN \"[$w cget -name]\" to file \"$f2\"."
		$parser setOutputFile $f2
		set rc [writeOutPattern [code $parser] $w 1]
		$parser closeOutput
		delete object $parser
		Busy end
	    }
	    "USEQUENCE" {
		Busy "saving USEQ [$w cget -name]"   
		set f1 "$path/[$w cget -name]$inUSeqFileExt"
		set f2 "$path/[$w cget -name]$outUSeqFileExt"
		set parser [ClassWESParser #auto]
		dbg "saving USEQ \"[$w cget -name]\" to file \"$f1\"."
		$parser setOutputFile $f1
		set rc [writeInUSeq [code $parser] $w 1]
		$parser closeOutput
		dbg "saving USEQ \"[$w cget -name]\" to file \"$f2\"."
		$parser setOutputFile $f2
		set rc [writeOutUSeq [code $parser] $w 1]
		$parser closeOutput
		delete object $parser
		Busy end
	    }
	    "SEQUENCE" {
		Busy "saving SEQ [$w cget -name]"   
		set f1 "$path/[$w cget -name]$inSeqFileExt"
		set f2 "$path/[$w cget -name]$outSeqFileExt"
		set parser [ClassWESParser #auto]
		dbg "saving SEQ \"[$w cget -name]\" to file \"$f1\"."
		$parser setOutputFile $f1
		set rc [writeInSeq [code $parser] $w]
		$parser closeOutput
		dbg "saving SEQ \"[$w cget -name]\" to file \"$f2\"."
		$parser setOutputFile $f2
		set rc [writeOutSeq [code $parser] $w]
		$parser closeOutput
		delete object $parser
		Busy end
	    }
	    default {
		puts "unknown type [$w cget -name]"
	    }
	}
	if {($f1 !="") && ($f2 != "")} { 
	    $w markDirty 0
	}
    } else {
	puts "invalid waveform"
    }
    return $f1
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESWaveIF::load
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESWaveIF::load {b} {
    set absTime 0.0
    set parser [ClassWESParser #auto]
    if {[file isfile $b]} {
	$parser setInputFile $b
    } else {
	$parser setInputBuffer $b
    }
    #puts "ClassWESWaveIF::load $obj"
    return [readWaveform [code $parser] 0]  
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# ClassWESWaveIF::saveAs
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
body ClassWESWaveIF::saveAs {w f} {
    set ftail [file tail $f]
    set fn [file rootname $ftail]

    #puts "ClassWESWaveIF::saveAs $w $fn"
    switch -exact [$w cget -type] {
	"PATTERN" 
	{   
	    renamePattern $w $fn
	    Busy "saving PATTERN $fn"
	    set f1 "$path/$fn$inPatFileExt"
	    set f2 "$path/$fn$outPatFileExt"
	    set parser [ClassWESParser #auto]
	    if [$parser setOutputFile $f1] {
		dbg "saving PATTERN \"[$w cget -name]\" to file \"$f1\"."
		set rc [writeInPattern [code $parser] $w]
		$parser closeOutput
	    } else {
		dbg "cannot write to file $f1"
	    }
	    
	    if [$parser setOutputFile $f2] {
		dbg "saving PATTERN \"[$w cget -name]\" to file \"$f1\"."
		set rc [writeOutPattern [code $parser] $w]
		$parser closeOutput
	    } else {
		dbg "cannot write to file $f2"
	    }
	    delete object $parser
	    Busy end
	}
	"USEQUENCE"    
	{
	    #puts "USEQ -> write XXX."
	    renameUSeq $w $fn
	    Busy "saving USEQ $fn"	    
	    set f1 "$path/$fn$inUSeqFileExt"
	    set f2 "$path/$fn$outUSeqFileExt"
	    set parser [ClassWESParser #auto]
	    if [$parser setOutputFile $f1] {
		dbg "saving USEQ \"[$w cget -name]\" to file \"$f1\"."
		set rc [writeInUSeq [code $parser] $w 0]
		$parser closeOutput
	    } else {
		dbg "cannot write to file $f1"
	    }
	    if [$parser setOutputFile $f2] {
		dbg "saving USEQ \"[$w cget -name]\" to file \"$f2\"."
		set rc [writeOutUSeq [code $parser] $w 0]
		$parser closeOutput
	    } else {
		dbg "cannot write to file $f2"
	    }
	    delete object $parser
	    Busy end
	}
	"SEQUENCE"     
	{
	    renameSeq $w $fn
	    Busy "saving SEQ $fn"    
	    set f1 "$path/$fn$inSeqFileExt"
	    set f2 "$path/$fn$outSeqFileExt"
	    set parser [ClassWESParser #auto]
	    
	    if [$parser setOutputFile $f1] {
		dbg "saving SEQ \"$w\" to file \"$f1\"."
		set rc [writeInSeq [code $parser] $w]
		$parser closeOutput
	    } else {
		dbg "cannot write to file $f1"
	    }
	    
	    if [$parser setOutputFile $f2] {
		dbg "saving SEQ \"$w\" to file \"$f2\"."
		set rc [writeOutSeq [code $parser] $w]
		$parser closeOutput
	    } else {
		dbg "cannot write to file $f2"
	    }
	    delete object $parser
	    Busy end
	}
	default {
	    puts "unknown Object-Type : \"[$w cget -name]\""
	    return
	}
    }
    $w markDirty 0
    update
    return $fn
}
#
# ___oOo___


