#*******************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: wesLockUIF.tcl,v 4.5 2004/01/16 15:25:12 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# hpieper  13/06/97  created
#

#************************************************************************
#   NAME
# 
#   SYNOPSIS
# 
#   DESCRIPTION
#
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#
#   SEE ALSO
#
#   BUGS     
#
#------------------------------------------------------------------------
#
#######################################################################
# Author:       C. Zerbst
# Description:  this procedure is used to lock the interface while 
#               some processes are working
#      17/02/1997 adapted by hpieper
#
proc BusyXXX {message} {
    global ::WES
    set message [string trim $message]
    
    set b .busy     
    if {[set ww [expr 3 + [string length $message]]] < 25} {
	set ww 25
    }
    if {![winfo exists $b] && ![string match end $message]} {
	. configure -cursor watch
	set WES(status) $message
	toplevel $b
	wm override $b 1
	wm withdraw $b
	wm positionfrom $b program
	set x [expr int([winfo x .] + 0.5 * [winfo width .])-100]
	set y [expr int([winfo y .] + 0.5 * [winfo height .])-50]       
	wm transient $b .
	pack [label $b.l -highlightt 0 \
		-text "WES\n$message" \
		-relief raised -bd 1 -background Grey90 \
		-width $ww \
		-height 3] -expand true
	wm geometry $b +$x+$y
	wm deiconify $b
	raise $b
	grab $b
	update idletask
    } elseif {[string match end $message] && [winfo exists $b]} {
	. configure -cursor top_left_arrow
	grab release $b
	destroy $b  
	set WES(status) ""
    } elseif [winfo exists $b] {
        set WES(status) $message
	$b.l configure -width $ww -text "WES\n$message"
	update idletask         
    }
}
proc Busy {message} {
    global ::WES
    set message [string trim $message]
   
    if {![string match end $message]} {
	freezeEvents
	. configure -cursor watch
	set WES(status) $message
	update idletask
    } else {
	unfreezeEvents
	. configure -cursor top_left_arrow
	set WES(status) ""
    }
}

proc applyBindtag {w} {
    set oldtags [bindtags $w]
    if {[lsearch $oldtags "FreezeEvents"] == -1} {
	set bindtags [concat FreezeEvents $oldtags]
	bindtags $w $bindtags
    }
    foreach child [winfo children $w] {
	applyBindtag $child
    }
}

proc freezeEvents {} {
    foreach event [list KeyPress KeyRelease \
	    ButtonPress ButtonRelease] {
	bind FreezeEvents <Any-$event> {break}
    }
    . configure -cursor watch
}

proc unfreezeEvents {} {
    foreach event [list KeyPress KeyRelease \
	    ButtonPress ButtonRelease] {
	bind FreezeEvents <Any-$event> {}
    }
    . configure -cursor top_left_arrow

}

#
# ___oOo___
