.\" This Man Page has been automatically produced. DO NOT EDIT THIS FILE!!!!!!
.\" Input file:  acroxDevice.tcl
.\" Formatter :  @(#) $Id: docDoManPages.c,v 1.37 2005/09/30 13:12:01 vltsccm Exp $
.\" -----------------------------------------------
.TH AcroxDevice n "VLTSW-JAN2006 27/10/05-17:02"
.SH NAME 
    AcroxDevice - Class description for a "acro" digital I/O device

.SH SYNOPSIS 
.nf 
.LP 
    AcroxDevice <object-name> ?<options>?

.SH DESCRIPTION 
.nf 
.LP 
    AcroxDevice defines the class for a "acro" digital I/O device.
    It makes the functionality of the device and the corresponding
    "acro" driver available through a graphical user interface.

    An object of this class is created by:

            AcroxDevice <object-name> -<Option> <Value> ...

    This will create all sub-objects for user interaction and
    an object to handle the connection to a server-task in the
    LCU environment i.e. effectively to the physical device.

.SH OPTIONS 
.nf 
.LP 
    Options represent public variables of the object and can be set with:

            <object-name> configure -<Option> <Value> ...

    The following device-specific options are publicly available:

    -numberOfSignals        specifies the total number of signals
                            of the device. The maximum value and default
                            is 64.

    -numberOfRows           specifies the number of rows in which the
                            signals shall be organized on the layout.
                            The default is 2.

    -firstSignal            specifies the number of the first signal.
                            The default is 0.

    Several options are inherited from InducerDevice and are therefore also
    available within the scope of this class. See InducerDevice(n) for a
    detailed description of those common options.

.SH METHODS 
.nf 
.LP 
    Methods represent procedures on the object and are invoked with:

            <object-name> <Method> <Arguments> ...

    There are no special device-specific methods available.

    Several method are inherited from InducerDevice and overloaded here
    with device-specific actions. See InducerDevice(n) for a detailed
    description of those common methods.

.SH SEE ALSO 
.nf 
.LP 
    acroxInducer(1),
    InducerClass(n), InducerDevice(n), InducerLine(n)

