.\" This Man Page has been automatically produced. DO NOT EDIT THIS FILE!!!!!!
.\" Input file:  aioxDevice.tcl
.\" Formatter :  @(#) $Id: docDoManPages.c,v 1.37 2005/09/30 13:12:01 vltsccm Exp $
.\" -----------------------------------------------
.TH AioxDevice n "VLTSW-JAN2006 27/10/05-17:02"
.SH NAME 
    AioxDevice - Class description for an "aio" Analog I/O device

.SH SYNOPSIS 
.nf 
.LP 
    AioxDevice <object-name> ?<options>?

.SH DESCRIPTION 
.nf 
.LP 
    AioxDevice defines the class for a "aio" analog I/O device.
    It makes the functionality of the device and the corresponding
    "aio" driver available through a graphical user interface.

    An object of this class is created by:

            AioxDevice <object-name> -<Option> <Value> ...

    This will create all sub-objects for user interaction and
    an object to handle the connection to a server-task in the
    LCU environment i.e. effectively to the physical device.

.SH OPTIONS 
.nf 
.LP 
    Options represent public variables of the object and can be set with:

            <object-name> configure -<Option> <Value> ...

    The following device-specific options are publicly available:

    -nInputSignals          specifies the total number of input signals
                            of the device. The maximum value and default
                            is 16. This number must to be divisible by 4.

    -nFirstSignal           specifies the number of the first input signal.
                            The default is 0.

    Several options are inherited from InducerDevice and are therefore also
    available within the scope of this class. See InducerDevice(n) for a
    detailed description of those common options.

.SH METHODS 
.nf 
.LP 
    Methods represent procedures on the object and are invoked with:

            <object-name> <Method> <Arguments> ...

    There are no special device-specific methods available.

    Several method are inherited from InducerDevice and overloaded here
    with device-specific actions. See InducerDevice(n) for a detailed
    description of those common methods.

.SH SEE ALSO 
.nf 
.LP 
    aioxInducer(1),
    InducerClass(n), InducerDevice(n), InducerLine(n)

