.\" This Man Page has been automatically produced. DO NOT EDIT THIS FILE!!!!!!
.\" Input file:  aiox_Signal.tcl
.\" Formatter :  @(#) $Id: docDoManPages.c,v 1.37 2005/09/30 13:12:01 vltsccm Exp $
.\" -----------------------------------------------
.TH AioxSignal n "VLTSW-JAN2006 27/10/05-17:02"
.SH NAME 
    AioxSignal - Class description for a signal of an anlaog
                     I/O device.

.SH SYNOPSIS 
.nf 
.LP 
    AioxSignal <widget-name> ?<options>?

.SH DESCRIPTION 
.nf 
.LP 
    AioxSignal defines a base class for a signal in analog I/O
    device. This class is intended to be used only as a base class.
    Derived classes must take care of the differences between
    input and output signals.

.SH OPTIONS 
.nf 
.LP 
    Options represent public variables of the object and can be set with:

            <object-name> configure -<Option> <Value> ...

    The following options are publicly available:

    -sNum           specifies the number of the signal within the device.
                    The valid range depends of the type of signal.
.SH METHODS 
.nf 
.LP 
    Methods are invoked with:

            <object-name> <Method> <Arguments> ...

    All the methods in this class are currently intended to be used from
    derived classes.

    setInputConfig   -  specifies the input signal range.

    readSignalConfig -  read configuration value of the signal.

.SH PROCS 
.nf 
.LP 
    Procs are invoked with:

            <object-name> <Proc> <Arguments> ...

    The following procs are publicly available:

    setLine <object-name>   - make the object-name of the InducerLine
            object known to the signal, that is used to communicate with
            the LCU environment. All signals of a device must use the
            same line-object.

.SH CAUTIONS 
.nf 
.LP 
    The class uses common variables.
    All signals must belong to the same device.
    In this implementation it is not possible to have signals
    that belong to different devices at the same time.

.SH SEE ALSO 
.nf 
.LP 
    aioxInducer(1),
    InducerClass(n), InducerDevice(n), AioxDevice(n)

