.\" This Man Page has been automatically produced. DO NOT EDIT THIS FILE!!!!!!
.\" Input file:  canioxAnalogOSignal.tcl
.\" Formatter :  @(#) $Id: docDoManPages.c,v 1.37 2005/09/30 13:12:01 vltsccm Exp $
.\" -----------------------------------------------
.TH CanioxAnalogOSignal n "VLTSW-JAN2006 27/10/05-16:52"
.SH NAME 
    CanioxAnalogOSignal - Class description for an output signal of an analog
                  I/O device.

.SH SYNOPSIS 
.nf 
.LP 
    CanioxAnalogOSignal <widget-name> ?<options>?

.SH DESCRIPTION 
.nf 
.LP 
    CanioxAnalogOSignal inherits from the base class canioxAnalogSignal general
    attributes common to I/O signals and defines particular
    attributes of output signals of an analog I/O device.
    This class is intended to be used only as a base class. Derived
    classes must take care of the interaction with the user and call the
    methods provided here to comunicate with the device's input line.

    An object of this class is created by:

    CanioxAnalogOSignal <object-name> -<Option> <Value> ...

which is typically done by the constructor of the derived class.


.SH OPTIONS 
.nf 
.LP 
Options represent public variables of the object and can be set with:

    <object-name> configure -<Option> <Value> ...

The are no special options for this class.


.SH METHODS 
.nf 
.LP 
Methods are invoked with:

    <object-name> <Method> <Arguments> ...

All the methods in this class are currently intended to be used from
    derived classes.

    writeValue       -  write value in volts or in the internal
            representation to the output signal.

loadData     -  set internal state from data list (saved
            with a Save Panel).

configLcc    - set internal state from data list with LCC
                       configuration for analog I/O signals.

    This class inherits methods from the base clas AioxSignal.

.SH CAUTIONS 
.nf 
.LP 
The class uses common variables.
    The class asumes the existence of the global array ${this}, defined in
    the base class and extends it.
All signals must belong to the same device.
In this implementation it is not possible to have signals
that belong to different devices at the same time.

.SH SEE ALSO 
.nf 
.LP 
aioxInducer(1),
InducerClass(n), InducerDevice(n), AioxDevice(n)
    AioxSignal(n)

