.\" This Man Page has been automatically produced. DO NOT EDIT THIS FILE!!!!!!
.\" Input file:  canioxDigitalSignal.tcl
.\" Formatter :  @(#) $Id: docDoManPages.c,v 1.37 2005/09/30 13:12:01 vltsccm Exp $
.\" -----------------------------------------------
.TH CanioxDigitalSignal n "VLTSW-JAN2006 27/10/05-16:52"
.SH NAME 
CanioxDigitalSignal - Class description for signal of a digital I/O device

.SH SYNOPSIS 
.nf 
.LP 
CanioxDigitalSignal <widget-name> ?<options>?

.SH DESCRIPTION 
.nf 
.LP 
CanioxDigitalSignal defines the class for a signal of a digital I/O device.
It makes the functionality of the signal and the corresponding
"canio" driver available through a graphical user interface.

An object of this class is created by:

    CanioxDigitalSignal <object-name> -<Option> <Value> ...

which is typically done by the constructor of the AcroxDevice class.

.SH OPTIONS 
.nf 
.LP 
Options represent public variables of the object and can be set with:

    <object-name> configure -<Option> <Value> ...

The following options are publicly available:

-signalNumber   specifies the number of the signal within the device.
        It can be in the range 0 to 63, the default is 0.

-linearNumbering selects linear (0-63) or byte-wise (0.0-7.7) labels
        Default: 1 (linear)

-showLabels specifies whether the buttons of the signal shall be
        displayed with or without labels. Usually only the
        rightmost signal in a row should be displayed with
        labels, otherwise there would be too little space.
        "yes" shows the labels, which is the default.

-useBitmaps whether to use symbols or pure text as labels
        Default: 1

-pedantic   if 1, some control elements are enabled or disabled
        dynamically depending on some other values.
        Since this is done inside a monitor-loop, it can be
        VERY time-consuming. That is why it is usually better
        not to do this dynamic widget-update.
        The default is 0 (off).

The following colors can be set usually via the option database:

-dirSelectColor selector of Input/Output checkbutton    Yellow
-actSelectColor selector of active H/L checkbutton  Blue
-setSelectColor selector of SET radiobutton     Red
-clrSelectColor selector of CLEAR radiobutton       Green
-mstSelectColor selector of Master/Slave checkbutton    Black
-configColor    indicator for configured signal     Orange

.SH METHODS 
.nf 
.LP 
Methods are invoked with:

    <object-name> <Method> <Arguments> ...

Most of the methods in this class are only used locally.

The following methods are currently intended to be used from outside:

startMonitor    - to start the monitoring of the device-status to
          update the corresponding signal-objects.
          The link to the LCU environment via a InducerLine
          object must have been established before.

stopMonitor - to stop the monitoring.

.SH PROCS 
.nf 
.LP 
Procs are invoked with:

    <object-name> <Proc> <Arguments> ...

The following procs are publicly available:

setLine <object-name>   - make the object-name of the InducerLine
    object known to the signal, that is used to communicate with
    the LCU environment. All signals of a device must use the
    same line-object.

.SH CAUTIONS 
.nf 
.LP 
The class uses common variables.
Only up to 64 signal (blocks 0 and 1) are supported.
All signals must belong to the same device.
In this implementation it is not possible to have signals
that belong to different devices at the same time.

.SH SEE ALSO 
.nf 
.LP 
canioxInducer(1),
InducerClass(n), InducerDevice(n), AcroxDevice(n)

