.\" This Man Page has been automatically produced. DO NOT EDIT THIS FILE!!!!!!
.\" Input file:  ikonxDevice.tcl
.\" Formatter :  @(#) $Id: docDoManPages.c,v 1.37 2005/09/30 13:12:01 vltsccm Exp $
.\" -----------------------------------------------
.TH IkonxDevice n "VLTSW-JAN2006 27/10/05-17:02"
.SH NAME 
    IkonxDevice - Class description for a "ikon" device

.SH SYNOPSIS 
.nf 
.LP 
    IkonxDevice <object-name> ?<options>?

.SH DESCRIPTION 
.nf 
.LP 
    IkonxDevice defines the class for a "ikon" encoder interface device.
    It makes the functionality of the device and the corresponding
    "ikon" driver available through a graphical user interface.

    An object of this class is created by:

            IkonxDevice <object-name> -<Option> <Value> ...

    This will create all sub-objects for user interaction and
    an object to handle the connection to a server-task in the
    LCU environment i.e. effectively to the physical device.

.SH OPTIONS 
.nf 
.LP 
    Options represent public variables of the object and can be set with:

            <object-name> configure -<Option> <Value> ...

    -displayFont    specifies the font to be used for the position,
                    counter and interpolation displays.
                    Default: 10x20

    Several options are inherited from InducerDevice and are therefore also
    available within the scope of this class. See InducerDevice(n) for a
    detailed description of those common options.

.SH METHODS 
.nf 
.LP 
    Methods represent procedures on the object and are invoked with:

            <object-name> <Method> <Arguments> ...

    There are no special public device-specific methods available.

    Several method are inherited from InducerDevice and overloaded here
    with device-specific actions. See InducerDevice(n) for a detailed
    description of those common methods.

.SH SEE ALSO 
.nf 
.LP 
    ikonxInducer(1),
    InducerClass(n), InducerDevice(n), InducerLine(n)

