.\" This Man Page has been automatically produced. DO NOT EDIT THIS FILE!!!!!!
.\" Input file:  inducerClass.tcl
.\" Formatter :  @(#) $Id: docDoManPages.c,v 1.37 2005/09/30 13:12:01 vltsccm Exp $
.\" -----------------------------------------------
.TH InducerClass n "VLTSW-JAN2006 27/10/05-17:02"
.SH NAME 
    InducerClass - Abstract class for inducer widgets

.SH SYNOPSIS 
.nf 
.LP 
    inherit InducerClass

.SH DESCRIPTION 
.nf 
.LP 
    InducerClass is used to inherit special features for the
    implementation of objects to be used in "Inducer Panels".
    All OPTIONS and METHODS of this class are then also available
    in the objects that inherit from this class.

.SH INHERITANCE 
.nf 
.LP 
    VccDebug

.SH PUBLIC OPTIONS 
.nf 
.LP 
    Options represent public variables of the object and can be set with:

            <object-name> configure -<Option> <Value> ...

    The following options are publicly available:

    -wHelparea      Object-name of short-help.
                    By default the panel-editor defined area is used.
                    (Note: this is a direct reference which may change!)

.SH METHODS 
.nf 
.LP 
    Methods represent procedures on the object and are invoked with:

            <object-name> <Method> <Arguments> ...

    The following methods are publicly available:

    debugPrint ?<string>?
            This can be called from the body of a method or config-body
            of a public variable to print debugging information.
            If the option `debugFlag' is enabled, then a line in the form:

                    (<object-name>) <method-name> <args>: <string>

            is printed to standard-output, where "<object-name>" is the
            name of the object and "<method-name> <args>" is the name of
            the method from which the call was made and it's arguments.
            If the call was not made from a method, this field is empty.
            An optional "<string>" can also be printed.
            NOTE: debugPrint can not be called from the body of a proc!

    More methods: see VccDebug(n)

.SH EXAMPLES 
.nf 
.LP 
    itcl_class AcroxSignal {
        inherit FrameWidget InducerClass

        #*# constructor
        constructor { config } {
            ...
        }
        method abc {
            debugPrint "..."
        }
            ...
    }


.SH SEE ALSO 
.nf 
.LP 
    VccDebug(n)

