.\" This Man Page has been automatically produced. DO NOT EDIT THIS FILE!!!!!!
.\" Input file:  inducerDevice.tcl
.\" Formatter :  @(#) $Id: docDoManPages.c,v 1.37 2005/09/30 13:12:01 vltsccm Exp $
.\" -----------------------------------------------
.TH InducerDevice n "VLTSW-JAN2006 27/10/05-17:02"
.SH NAME 
    InducerDevice - Abstract class for inducer Device objects

.SH SYNOPSIS 
.nf 
.LP 
    inherit InducerDevice

.SH DESCRIPTION 
.nf 
.LP 
    InducerDevice is used to inherit special features for the
    implementation of Device objects to be used in "Inducer Panels".
    All OPTIONS and METHODS of this class are then also available
    in the objects that inherit from this class.

    Device-specific methods shall be provided in the derived classes
    which overload the mostly empty default-methods contained herein.

.SH OPTIONS 
.nf 
.LP 
    Options represent public variables of the object and can be set with:

            <object-name> configure -<Option> <Value> ...

    The following options are publicly available:

    vEnv    - enviroment name
    vDev    - device name
    vMode   - open-mode to be used: TEST, EXCLUSIVE, SHARED, READONLY

.SH METHODS 
.nf 
.LP 
    Methods represent procedures on the object and are invoked with:

            <object-name> <Method> <Arguments> ...

    The following methods are publicly available:

    constructor ?<options>?

            At the beginning of each device-specific class should be
            a call of "InducerDevice::constructor". This creates an
            InducerLine object that serves as a link to the inducerServer
            task on the LCU. The object name is saved in the protected
            variable `lineW'.

    The following methods should be overloaded by the derived class
    with appropriate device-specific actions. This base-class provides
    only some default actions. If the required action is not available
    for the specific device, then the method need not be overloaded.

    GetVersion      - must return the version-string of the program

    InitDevice      - must first call `InducerDevice::InitDevice' to open
                      the link to the device, then start the monitor task,
                      and possibly do specific actions.
                      Must return an empty string on success or an
                      error description.

    ExitDevice      - must stop the monitor task, and at the end call
                      `InducerDevice::ExitDevice' to close the link to
                      the device. Must return an empty string.

    ResetDevice     - must reset the connected device.

    GetDeviceId     - must retrieve and return a device-ID-string
                      to be displayed in the panel.

    LoadDevice <data> - must restore the device-status from the string
                    `data' which is in the same format as from SaveDevice.

    SaveDevice      - must retrieve and return the device-status as a
                      a string which is suitable for LoadDevice.

    Disconnect      - requests that all further user interactions remain
                      local to the panel, neither are changes forwarded
                      to the device, nor is the panel updated from the
                      device. However, the channel is kept opened.

    Resume          - requests that the current panel settings are
                      forwared to the device in one go. After that the
                      normal operation and update policy is resumed.

.SH SEE ALSO 
.nf 
.LP 
    InducerClass(n), InducerLine(n)

