.\" This Man Page has been automatically produced. DO NOT EDIT THIS FILE!!!!!!
.\" Input file:  timxTimer.tcl
.\" Formatter :  @(#) $Id: docDoManPages.c,v 1.37 2005/09/30 13:12:01 vltsccm Exp $
.\" -----------------------------------------------
.TH TimxTimer n "VLTSW-JAN2006 27/10/05-17:02"
.SH NAME 
    TimxTimer - Class to display status window of a tim's device timer.

.SH SYNOPSIS 
.nf 
.LP 
    TimxTimer <object-name> ?<options>?

.SH DESCRIPTION 
.nf 
.LP 
    TimxTimer defines the class for a tim's timer status display
    window.

    An object of this class is created by:

            TimxTimer <object-name> -<Option> <Value> ...

    This will create the TimxTimer object and initialize its internal
    variables

.SH OPTIONS 
.nf 
.LP 
    Options represent public variables of the object and can be set with:

            <object-name> configure -<Option> <Value> ...

    The following option is publicly available :

    number -  tim's device timer number.

.SH METHODS 
.nf 
.LP 
    Methods represent procedures on the object and are invoked with:

            <object-name> <Method> <Arguments> ...

    The following method is publicly available :

    display { data } - displays timer's status information as is
    defined in "data", this is a list with the following elements:
    status, startStatus, timerMode, time of last interrupt and
    time of next interrupt.

.SH PROCS 
.nf 
.LP 
    Procs are invoked with:

            <object-name> <Proc> <Arguments> ...

    The following procs are publicly available:

    setOwner <object-name>  - set the object-name of the "owner"
            of all the timers, TimxTimer objects invokes its
            owner's procedure getTimerStatus when asking for an
            update of the status display.

.SH CAUTIONS 
.nf 
.LP 
    The class uses common variables.
    All timers must belong to the same device.
    In this implementation it is not possible to have timers
    that belong to different devices at the same time.

.SH SEE ALSO 
.nf 
.LP 
    timxDevice(n),
    InducerClass(n), InducerDevice(n), InducerLine(n)

