.\" This Man Page has been automatically produced. DO NOT EDIT THIS FILE!!!!!!
.\" Input file:  vccCompletion.tcl
.\" Formatter :  @(#) $Id: docDoManPages.c,v 1.37 2005/09/30 13:12:01 vltsccm Exp $
.\" -----------------------------------------------
.TH VccCompletion n "VLTSW-JAN2006 27/10/05-16:59"
.SH NAME 
    VccCompletion - abstract class for completion operations

.SH SYNOPSIS 
.nf 
.LP 
    inherit VccCompletion

.SH DESCRIPTION 
.nf 
.LP 
    The VccCompletion command creates a new object, used for
    completion of words based on search-lists.

    Several modes - including completion on both ends of a word - can
    be selected.

.SH INHERITANCE 
.nf 
.LP 
    Internal debugging support from VccDebug(n).

.SH PUBLIC OPTIONS 
.nf 
.LP 
    The following options are specific to objects of this class:

    -completionMode
            Can be a combination of:
                enabled     - no operation if not set
                ignorecase  - ignore case for completion
                leading     - complete at beginning of item
                trailing    - complete at end of item

            Default is: {enabled ignorecase leading trailing}

    -completionIgnore
            is a list of items to be ignored in the argument list given
            to the operations `new' and `add'.
            Default is: {""}        (i.e. empty strings are ignored)

.SH METHODS 
.nf 
.LP 
    The VccSelector command creates a new command whose name is <pathName>.
    This command may be used to invoke the `Completion' method:

    Completion <Operation> <Item> ?<Mode>?

    Operation: specifies one of the following operations:

      new   Create new completion list consisting of the word(s) `Item',
            overwrite the list if already existing.

      add   Add the word(s) in `Item' to the completion list.

      all   Determine all possible completions for word `Item' from the
            completion list, and return them as a list.

      get   Return a unique completion for word `Item' from the
            completion list, or an empty string if there is none.

      best  Return the best possible completion for word `Item' from the
            completion list. Normally this will be the longest common
            part of all matches, or simply the given word itself.
            An empty string is returned if there is no completion at all.

      info  Return information on internal state as a text string.

    Item:   single search-item or list, depends on Operation, see there

    Mode:   to override temporarily the default `completionMode',
            except for the `enabled' keyword, which cannot be overridden.

    Return value depends on Operation, see there.

.SH SEE ALSO 
.nf 
.LP 
    VccDebug(n)

