.\" This Man Page has been automatically produced. DO NOT EDIT THIS FILE!!!!!!
.\" Input file:  vccDebug.tcl
.\" Formatter :  @(#) $Id: docDoManPages.c,v 1.37 2005/09/30 13:12:01 vltsccm Exp $
.\" -----------------------------------------------
.TH VccDebug n "VLTSW-JAN2006 27/10/05-16:59"
.SH NAME 
    VccDebug - Abstract class with debugging support

.SH SYNOPSIS 
.nf 
.LP 
    inherit VccDebug

    method abc { args } {
        debugEnter
            ...
        debugPrint "irgenwas"
            ...
        debugReturn [expr cos(1)]
    }

    VccDebug::Enable

.SH INHERITANCE 
.nf 
.LP 
    None.

.SH METHODS 
.nf 
.LP 
    All methods are intended to be called from inside a method of
    an object of a derived class.

    debugEnter
            To be called at the beginning of a method.
            Prints "(<objName>) ... <methodName args>: <String>" to stdout
            if debugging is enabled.

    debugPrint ?<string>?
            To be called in the middle of a method.
            Prints "(<objName>) ... <String>" to stdout if debugging is
            enabled.

    debugReturn ?<value>?
            To be called at the end of a method.
            Prints "(<objName>) ... ==> <Value>" to stdout if debugging is
            enabled, and then returns with <value> from the calling method.

    "..." indicates a string of dots with a length corresponding to the
    call-stack level.

.SH PROCS 
.nf 
.LP 
    Enable  - enables debugging outputs
    Disable - disables debugging outputs
    Control <OnOff> - dto. depending on given argument

    The initial state is taken from the global variable `vcc(debug)'.
    The enable-state applies to ALL derived objects of this class.

.SH ENVIRONMENT 
.nf 
.LP 
    vcc(debug)      global variable that enables debug outputs.
                    It is set to 0 if not already defined before.

.SH CAUTIONS 
.nf 
.LP 
    Usage of the methods contained herein do not make the calling methods
    faster - of course. They should not be used for time-critical tasks.

