.\" This Man Page has been automatically produced. DO NOT EDIT THIS FILE!!!!!!
.\" Input file:  vccSelectorAll.tcl
.\" Formatter :  @(#) $Id: docDoManPages.c,v 1.37 2005/09/30 13:12:01 vltsccm Exp $
.\" -----------------------------------------------
.TH VccSelectorAll n "VLTSW-JAN2006 27/10/05-16:59"
.SH NAME 
    VccSelectorAll - base-class for VccInfo-based selection widget

.SH SYNOPSIS 
.nf 
.LP 
    inherit VccSelectorAll
    constructor { args } {
            set infoMethod ...
            eval VccSelectorAll::constructor $args
            ...
    }

.SH DESCRIPTION 
.nf 
.LP 
    VccSelectorAll is a generic VccInfo-based selector widget.

.SH INHERITANCE 
.nf 
.LP 
    It has the same properties as the VccSelector base class, except for
    some specific deviations listed below.

.SH PUBLIC OPTIONS 
.nf 
.LP 
    The following options are different from VccSelector:

    -vccInfoObj     Name of a VccInfo object to be used for VCCDB queries.
                    If an empty string is given, then a private VccInfo
                    object will be created, and deleted automatically
                    when the selector widget is destroyed.
                    Otherwise the explicitly given object, which must
                    already exist, is used; it will not be deleted.
                    Default: vccInfo (i.e. the global VccInfo object)

    -menuFilter     A glob-style filter expression that all menu entries
                    must match. It can also be a list of filters, which
                    are then or-combined.
                    Default: *

    -queryModes     Maps into VccInfo::queryModes.

    -validate       Specifies whether a selected item shall be checked
                    for validity with the `validate' method.
                    A Tcl error with the appropriate message is
                    generated if the validation fails.
                    Default: 0 (off)

.SH METHODS 
.nf 
.LP 
    validate {Item} This method must be overloaded by the derived class
                    in order to check `Item' for validity.
                    It is called internally by the `invoke' method
                    if the option `validate' is enabled.
                    Return value must be an empty string on success,
                    or a non-empty string describing the fault.
                    (The generic method here returns always OK.)

.SH SEE ALSO 
.nf 
.LP 
    VccSelector(n), VccInfo(n)

