.\" This Man Page has been automatically produced. DO NOT EDIT THIS FILE!!!!!!
.\" Input file:  inducerGetLib.tcl
.\" Formatter :  @(#) $Id: docDoManPages.c,v 1.37 2005/09/30 13:12:01 vltsccm Exp $
.\" -----------------------------------------------
.TH inducerGetLib n "VLTSW-JAN2006 27/10/05-17:02"
.SH NAME 
    inducerGetLib,
    inducerGetDevices,
    inducerGetTickRate,
    inducerGetIoctlCommands,
    inducerGetIoctlCmdNum,
    inducerGetTools,
    inducerGetToolArg
    - get information in the inducer environment

.SH SYNOPSIS 
.nf 
.LP 
    inducerGetDevices       Environment ?Filters?
    inducerGetTickRate      Environment
    inducerGetIoctlCommands Device
    inducerGetIoctlCmdNum   CmdNameOrNumList
    inducerGetTools         Devices
    inducerGetToolArg       Device Tool

.SH DESCRIPTION 
.nf 
.LP 
    These procs are called by the inducer program.

    inducerGetDevices       - query the installed devices from a LCU
                              environment and return them as a list,
                              passing at least one of the optional filters
                              in `Filters' (e.g. {/acro* /aio*}).
                              Only devices with VLT conform names are
                              returned, matching the regexp "/[a-z]+[0-9]+"

    inducerGetTickRate      - query the system-clock-rate from the LCU
                              in ticks per second.

    inducerGetIoctlCommands - query the command-literals for a given
                              device from the corresponding driver
                              header file. Returns a list-representation
                              for a cascaded menu, suitable for MakeMenu.
                              (same behaviour as in lcudrvTk)

    inducerGetIoctlCmdNum   - translate a command-literal(-list) into it's
                              corresponding number(-list). The literal must
                              be given without the driver-specific prefix,
                              e.g. "READ_BITS" (not "acroCMD_READ_BITS").
                              No translation is done if the literal does
                              not exist or if it is already a number.

    inducerGetTools         - query the tool-functions for a given list of
                              `Devices' from the corresponding driver
                              header file. Returns a list of functions.
                              (same behaviour as in lcudrvTk)

    inducerGetToolArg       - determines the proper argument for a tool
                              function `Tool' when applied on a specific
                              `Device'. This depends on the function's
                              argument declaration in the driver header
                              file, which can be:
                              - empty for a "void" argument declaration
                              - device-name if "name" is declared
                              - unit-number if "unit" or "axis" is declared
                              - else empty (unknown)
                              (same behaviour as in lcudrvTk)

.SH SEE ALSO 
.nf 
.LP 
    lcudrvTk(1)

