.\" This Man Page has been automatically produced. DO NOT EDIT THIS FILE!!!!!!
.\" Input file:  ist3State.tcl
.\" Formatter :  @(#) $Id: docDoManPages.c,v 1.37 2005/09/30 13:12:01 vltsccm Exp $
.\" -----------------------------------------------
.TH ist3State n "VLTSW-JAN2006 27/10/05-17:12"
.SH NAME 
ist3State - three state button area widget for controlling element functions

.SH SYNOPSIS 
.nf 
.LP 
ist3State  <widget-name>

.SH DESCRIPTION 
.nf 
.LP 
ist3State is a mega widget which defines a three state button area.
The ist3State can be used for instrumentation panel which control an
instrument function such as a filter wheel.

The ist3State widget defines a set of elements which are controled by
buttons. The individual buttons have three states: unselected, selected
and accepted.
In unselected state the element button looks like other default buttons.
In selected state the button color changes (default skyBlue) and font
changes. Only one element can be selected at a time. The selection is
done by pressing the button. A selection is equal to a setup parameter.
If a selection variable is passed (-selectVariable) this variable is
updated with the current selection.

In accpeted state the button color (default gold) changes and the font
is larger then the other states in order to clearly show what the current
status of the element is. If a accept variable is passed (-selectVariable)
this variable is updated with the current accepted value.

Callbacks can be specified in order to control the selection.


The title of the ist3State button area is also a button which can be used
to activate a function which could be a dialog showing more details of a
function.


The user create a widget of this class (called instance) by :

  ist3State  <widget-name> <config-parameters>
where :

  <widget-name>         is any valid TK widget name
  <config-parameters>   sequence of widget resources

Standard widget resources can be set using :

   <widget-name> configure <resource-name> <value>

The current value of the widget resources is returned by :

   <name-of-instance> cget <resource-name>


.SH METHODS 
.nf 
.LP 
  select <no>
     Changes the state of an element numbert <no> to selected.

  accept
     Changes the state of the selected element to accepted.

  clear
     Clear the selection.

  now     <no>
     Indicates the temporay position of a moving functions.
     Feature not supported yet !

  selectItem
     Returns the currently selected item text string.

  selectNo
     Returns the currently selected item number.

  keyword
     Returns the short FITS keyword of the element function.

  accepted
     Returns the currently accepted item number.

  disable
     Disable the selection of element buttons.

  enable
     Enable the selection of element buttons.

.SH PUBLIC VARIABLES 
.nf 
.LP 
  elements       <list of element names>

  current        <element name>

  label          <function name>

  keyword        <short FITS keyword>

  selectCB       <callback function> - function has 2 parameters: keyword value

  detailCB       <callback function> - function has no parameters

  selectBg       <color>  - rgb color e.g. blue

  selectFont     <font>   - X11 font name

  acceptBg       <color>  - named color see rgb.txt

  acceptFont     <font>   - see above.

  labelBg        <color>  - see above.

  labelFg        <color>  - see above.

  labelFont      <font>   - see above.

  nowBg          <color>  - see above.

  nowFont        <font>   - see above.

  orient         <h/v>    - h = horizontal v = vertical layout

  index          <number> - start of numbering index default 0

  selectVariable <var>    - variable set with selected value

  acceptVariable <var>    - variable set with accepted value

  lblWidth       <width>  - label width in number of characters

  statusDb       <attr>   - database point and attribute name


.SH EXAMPLES 
.nf 
.LP 
  Create an instance

  ist3State   .myFunction  -label myFunction -current Open \\
                      -elements {Open Closed J K} -keyword "INS.OPTI-1" \\
                      -selectCB funcSelect

  proc funcSelect { keyword value } {
       puts "Function: $keyword has value: $value"
  }

