.\" This Man Page has been automatically produced. DO NOT EDIT THIS FILE!!!!!!
.\" Input file:  ist3StateMenubutton.tcl
.\" Formatter :  @(#) $Id: docDoManPages.c,v 1.37 2005/09/30 13:12:01 vltsccm Exp $
.\" -----------------------------------------------
.TH ist3StateMenubutton n "VLTSW-JAN2006 27/10/05-17:12"
.SH NAME 
ist3StateMenubutton - three state button area widget for controlling
                      element functions

.SH SYNOPSIS 
.nf 
.LP 
ist3StateMenubutton  <widget-name>

.SH DESCRIPTION 
.nf 
.LP 
IMPORTANT - The ist3StateMenubutton is a new version of the ist3State widget
providing the posibility to display the buttons either into a row/colunm
table (like ist3State) or into a menu widget. This feature is controlled by
the -type option.  The ist3StateMenubutton is fully compatible with the
ist3State, and should replace this one in the future development. Due to the
important changes needed to support the '-type' option, it has been decided
to implement a new widget instead of upgrading the existing one, in order to
avoid any risk of bugs for the existing applications.
In addition, the '-showLabel' and '-showCurrent' options have been added
and bugs in relation with the '-current' option and the selectKeyword
(renamed to valuedKeyword) methods have been fixed.

ist3StateMenubutton is a mega widget which defines a three state button
area. The ist3StateMenubutton can be used for instrumentation panel which
control an instrument function such as a filter wheel.

The ist3StateMenubutton widget defines a set of elements which are controled
with a list of buttons either placed into a table or into a menu.
In 'table' option (like ist3State widget), the individual buttons have three
states: unselected, selected and accepted. In unselected state the element
button looks like other default buttons. In selected state the button color
changes (default skyBlue) and font changes.  Only one element can be
selected at a time. The selection is done by pressing the button. A
selection is equal to a setup parameter. If a selection variable is passed
(-selectVariable) this variable is updated with the current selection.
In accepted state the button color (default gold) changes and the font
is larger than the other states in order to clearly show what the current
status of the element is. If a accept variable is passed (-acceptVariable)
this variable is updated with the current accepted value.

In 'menu' option, the individual buttons are selectable using a menu. The
selected element is displayed in menu button and the color and font change
(same as 'table' option). The selection is done by selecting the element in
the menu.
The accepted value is displayed in a additionnal button placed above the
menu. When a element is accepted, it is displayed in this button and the
color and font change (same as 'table' option).

Callbacks can be specified in order to control the selection.

The title of the ist3StateMenubutton button area is also a button which can
be used to activate a function which could be a dialog showing more details
of a function.


The user create a widget of this class (called instance) by :

  ist3StateMenubutton  <widget-name> <config-parameters>
where :

  <widget-name>         is any valid TK widget name
  <config-parameters>   sequence of widget resources

Standard widget resources can be set using :

   <widget-name> configure <resource-name> <value>

The current value of the widget resources is returned by :

   <name-of-instance> cget <resource-name>


.SH PUBLIC METHODS 
.nf 
.LP 
  select <no> <callUserFct>
    Changes the state of an element numbert <no> to selected.
    If <callUserFct> is TRUE (default), the user fonction defined with
    -selectCB option is called.

  accept
    Changes the state of the selected element to accepted.

  clear
    Clear the selection.

  now     <no>
    Indicates the temporay position of a moving functions.

  selectItem
    Returns the currently selected item text string.

  selectNo
    Returns the currently selected item number.

  valuedKeyword
    Return either an empty string when no item is selected or short FITS
    keyword with current selected item name which could be used as parameter
    of the SETUP command to setup the instrument.

  keyword
    Returns the short FITS keyword of the element function.

  accepted
    Returns the currently accepted item number.

  disable
    Disable the selection of element buttons.

  enable
    Enable the selection of element buttons.

WIDGET-SPECIFIC OPTIONS
  -elements       <list of element names>

  -current        <element name>

  -label          <function name>

  -showLabel      <0/1>    - show/hide the label

  -keyword        <short FITS keyword>

  -selectCB       <callback function> - function has 2 parameters: keyword
                                        value

  -detailCB       <callback function> - function has no parameters

  -selectBg       <color>  - rgb color e.g. blue

  -selectFont     <font>   - X11 font name

  -acceptBg       <color>  - named color see rgb.txt

  -acceptFont     <font>   - see above.

  -showCurrent    <0/1>    - show/hide the current value (only when type
                             menu is selected)
  -showMenuButton <0/1>    - show/hide the menu button (only when type
                             menu is selected)
  -currentHelp    <help text> - short help text for the widget displaying
                             the current value (only when type menu is
                             selected)

  -labelBg        <color>  - see above.

  -labelFg        <color>  - see above.

  -labelFont      <font>   - see above.

  -labelHelp      <help text> - short help text for the label

  -lblWidth       <width>  - label width in number of characters

  -nowBg          <color>  - see above.

  -nowFont        <font>   - see above.

  -orient         <h/v>    - h = horizontal v = vertical layout

  -type           <menu/table> - see above. By default 'table' to be
                                 compatible with ist3State

  -index          <number> - start of numbering index default 0

  -selectVariable <var>    - variable set with selected value

  -acceptVariable <var>    - variable set with accepted value

  -buttonWidth    <width>  - button width in number of characters

  -buttonHelp     <help text> - short help text for the menu button or
                             the buttons of the table.

.SH EXAMPLES 
.nf 
.LP 
  Create an instance

  ist3StateMenubutton .myFunction  -label myFunction -current Open \\
                      -elements {Open Closed J K} -keyword "INS.OPTI-1" \\
                      -selectCB funcSelect -type menu

  proc funcSelect { keyword value } {
       puts "Function: $keyword has value: $value"
  }

