.\" This Man Page has been automatically produced. DO NOT EDIT THIS FILE!!!!!!
.\" Input file:  istDiskMon.tcl
.\" Formatter :  @(#) $Id: docDoManPages.c,v 1.37 2005/09/30 13:12:01 vltsccm Exp $
.\" -----------------------------------------------
.TH istDiskMon n "VLTSW-JAN2006 27/10/05-17:12"
.SH NAME 
istDiskMon - panel editor class to display the disk space usage


.SH SYNOPSIS 
.nf 
.LP 
   istDiskMon <name>

.SH DESCRIPTION 
.nf 
.LP 
   istDiskMon is a panel editor class that can be inserted when
   developing a control panel. It displays a barchart with the
   current disk space usage of the disk entered in the entry field
   below. The disk space is queried by sending a query command to
   the istServer.
   The disk name can either be entered by typing into the entry
   field or setting the environment INS_DISK. When this environement
   is set the entry field is locked and the disk name can not be
   changed.

   The radio buttons "Percent" and "MByte" toggle the free disk
   space value in the respective unit.
   When the update button is checked in the disk space is queried
   periodically.

.SH OPTIONS 
.nf 
.LP 
  Options represent public variables of the object and can be set with:

    <object-name> configure -<Option> <Value> ...

   istDiskMon accepts following configuration options:

    -diskName       <file> Filename of the disk monitored.

    -diskUpdate     <0|1>  Toggle the update checkbutton. 1 = update the
                           widget with diskUpdateFreq. 0 = don't update.

    -diskUpdateFreq <sec>  Update frequency in seconds (default 5).

    -percent        <0|1>  Show value in percent (default).

    -MByte          <0|1>  Show value in MByte.

    -smallLayout    <0|1>  Change layout to a smaller size with widget
                           controls in a seperate dialog window.

    -cfgWinGeometry <geo>  Define the geometry of the seperate configuration
                           dialog window. Only relevant when -smallLayout
                           is true.

.SH ENVIRONMENT VARIABLES 
.nf 
.LP 
   The evironment INS_DISK is used as disk reference when it is
   specified.

.SH EXAMPLE 
.nf 
.LP 
 In this example the auto_path is assumed set correctly.
 seqWish> istDiskMon .diskMonitor
 seqWish> pack .diskMonitor
 seqWish> .diskMonitor -diskName "/diskc" -mByte 1
 seqWish> .diskMonitor -diskUpdate 1 -diskUpdateFreq  5

