.\" This Man Page has been automatically produced. DO NOT EDIT THIS FILE!!!!!!
.\" Input file:  istLinearMotor3State.tcl
.\" Formatter :  @(#) $Id: docDoManPages.c,v 1.37 2005/09/30 13:12:01 vltsccm Exp $
.\" -----------------------------------------------
.TH istLinearMotor3State n "VLTSW-JAN2006 27/10/05-17:12"
.SH NAME 
istLinearMotor3State - three state button area widget for controlling
                       linear motor

.SH SYNOPSIS 
.nf 
.LP 
istLinearMotor3State  <widget-name>

.SH DESCRIPTION 
.nf 
.LP 
The istLinearMotor3State is dedicated widget for controlling linear  motor.
It inherits the basic facilities provided by istMotor3State, but enhances it
with specific features needed by linear motor such as:
    - enter to new encoder position,
    - display the current encoder position.

This widget simply includes an 'istEntry' widget allowing the user to
specify a new encoder position and an label widget to display the current
position, which is updated when the database attribute containing the
motor position changes.

.SH PUBLIC METHODS 
.nf 
.LP 
  positionDbUpdate
    Callback attached to the 'position' database event. It updates the
    current position of the motor. The 'precision' option is used to format
    the value to be displayed in widget (number of significant digits).

  getEntryWdg
    Return the reference to entry widget (istEntry object), to be used for
    configuration.

  getValue
  setValue {value}
    Get/Set the current entered value (e.g. new motor position).

  accept  {{no ""}}
  clear   {}
  disable {}
  enable  {}
    Call the method of both parent class and 'istEntry' instance.

  valuedKeyword {{encoderOrder 0}}
    Returns the short FITS keyword with the currently selected element to
    set-up a new named position or the short FITS keyword with the new
    encoder value (when encoderOrder is set to 1) to move motor to the new
    encoder position.

WIDGET-SPECIFIC OPTIONS
  -positionDb    <position db point> - name of the database attribute where
                                       is stored the current encoder
                                       position of the motor.
  -positionFg    <color>             - color used to display current encoder
                                       position of the motor.

  -positionFont  <font>              - font used to display current encoder
                                       position of the motor.

  -positionHelp  <help text>         - short help text for the widget
                                       displaying the current position
  -precision     <number of digits>  - number of significant digits to
                                       format the current encoder position
                                       of the motor.
  -entryHelp     <help text>         - short help text for the entry widget

.SH EXAMPLES 
.nf 
.LP 
  Create an instance

  istLinearMotor3State .myFunction  -label myFunction -current Open \\
                      -elements {Open Closed J K} -keyword "INS.OPTI1" \\
                      -selectCB funcSelect -type menu -precision 2 \\
                      -statusDb <alias>slider:mcmStatus.posIndex\\
                      -motionStatusDb <alias>slider:mcmStatus.motionStatus \\
                      -enabledDb <alias>slider.enabled \\
                      -stateDb <alias>slider.state \\
                      -positionDb <alias>slider:mcmStatus.posEnc

  proc funcSelect { keyword value } {
       puts "Function: $keyword has value: $value"
  }

