.\" This Man Page has been automatically produced. DO NOT EDIT THIS FILE!!!!!!
.\" Input file:  istPanScan.tcl
.\" Formatter :  @(#) $Id: docDoManPages.c,v 1.37 2005/09/30 13:12:01 vltsccm Exp $
.\" -----------------------------------------------
.TH istPanScan n "VLTSW-JAN2006 27/10/05-17:12"
.SH NAME 
istPanScan, panScan, PanScan, istLoadPanScan - utility to define update
            of gvar() variables in a panel

.SH SYNOPSIS 
.nf 
.LP 
When initializing the panel (in the Tcl code):

istLoadPanScan <panel name>


.SH DESCRIPTION 
.nf 
.LP 
The Pan Scan feature makes it possible to define the update of output
widgets in guis made with the panel editor. This is advantageous
compared to 'hard coding' the links between outputs and DB directly into
the panel themselves.

For using the feature a file must be created with extension ".panscan"
and with the same name as the panel. The format of the file is as
follows (example):

   set DATA   <alias>irdcs:dataInfo
   set DET    <alias>irdcs:detector
   set EXPO   <alias>irdcs:exposure
   set GEN    <alias>irdcs:generalInfo
   set IRACE  <alias>irdcs:irace
   set MON    <alias>irdcs:monitor

   # Attributes in the Exposure Point
   $EXPO.exposureNo       NE saExposureNo
   $EXPO.DIT              NE saDIT         irdosRound3Decs
   $EXPO.NDIT             NE saNDIT
   $EXPO.MINDIT           NE saMINDIT      irdosRound3Decs
   $EXPO.STARTX           NE saSTARTX
   $EXPO.STARTY           NE saSTARTY
   $EXPO.NX               NE saNX
   $EXPO.NY               NE saNY
   $EXPO.RSPEED           NE saRSPEED
   $EXPO.RSPEEDADD        NE saRSPEEDADD
   $EXPO.ditCount         NE saDitCount
   $EXPO.intCount         NE saIntCount
   $EXPO.stdevCount       NE saStdevCount
   $EXPO.choppingMode     NE choppingMode  irdosState2OnOff
   $EXPO.chopState        NE choppingMode  irdosChopPos
   ...

It is possible to define constants to refer to attribute points.
When defining the dependencies the format as shown above is:

<attribute>   <update type>  <gvar index>  [<processing function>]

- where <attribute> is the atrribute name, <update type> is the
criteria for updating the attribute (see man-page of seq_evtAttach),
<gvar index> is the index in the global gvar array used for accessing
variables in the panels, and <processing function> is an optional
Tcl procedure that can be called on attribute read to reformat it e.g.
This procedure must return the processed value.

The <panel name>.panscan files must be installed in the
$INTROOT/include or $VLTROOT/include directories.

