.\" This Man Page has been automatically produced. DO NOT EDIT THIS FILE!!!!!!
.\" Input file:  istSupportProc.tcl
.\" Formatter :  @(#) $Id: docDoManPages.c,v 1.37 2005/09/30 13:12:01 vltsccm Exp $
.\" -----------------------------------------------
.TH istSupportProc n "VLTSW-JAN2006 27/10/05-17:12"
.SH NAME 
istSupportProc - support procedures for instrument GUI panels

.SH SYNOPSIS 
.nf 
.LP 
istMenuReadFile <menu file>
istWindowOnTop  <window name>
istClassDialog  <uif class> <name> <title>

.SH DESCRIPTION 
.nf 
.LP 
istSupport is a series of support functions for developing instrument
GUI panels. There usage cover various area such as:

 - dynamic menus
 - window manager handling

istMenuReadFile is a function that can add menu items which are described
in a menu file. The menu file is located in the $VLTDATA/config directory
and allows to add the menu elements: separator, command, checkbutton or
radiobutton.
The menu file has the following syntax:

menu  <menu name> separator
menu  <menu name> command     <text> <proc>
menu  <menu name> checkbutton <text> <proc> <var>
menu  <menu name> radiobutton <text> <proc> <var>

The <menu name> must already exist in the panel generated by panel editor.

istWindowOnTop is a procedure to allow windows to stay on top on the
master panel. This is especially usefull when developping dialog windows
where you want to avoid that the dialog 'disappears' behind the main
panel.

istClassDialog build a dialog window out of a panel editor class.

.SH EXAMPLES 
.nf 
.LP 
  Example of menu file:
  ____________________________________________________________________
  menu     Options   command     "Profile ..."   isouifProfile
  menu     Options   command     "INS User ..."  istDummyCmd
  menu     Options   separator
  menu     Options   radiobutton "No TCS"        isouifTcsMode tcsMode
  menu     Options   radiobutton "TCS present"   isouifTcsMode tcsMode
  menu     Status    command     "ICS ..."       {isouifStatus ICS}
  menu     Status    command     "DCS ..."       {isouifStatus DCS}
  menu     Status    command     "TCS ..."       {isouifStatus TCS}
  menu     Commands  command     SETUP           isouifSetup
  menu     Commands  separator
  menu     Commands  command     START           isouifStart
  menu     Commands  separator
  menu     Commands  command     STOP            isouifStop
  menu     Commands  separator
  menu     Commands  command     ABORT           isouifAbort
  ___________________________________________________________________

  Example of using istClassDialog:

  istClassDialog testPanelClass_uifClass test "This is a test dialog"

