.\" This Man Page has been automatically produced. DO NOT EDIT THIS FILE!!!!!!
.\" Input file:  lcustatCheck.tcl
.\" Formatter :  @(#) $Id: docDoManPages.c,v 1.37 2005/09/30 13:12:01 vltsccm Exp $
.\" -----------------------------------------------
.TH lcustatCheck n "VLTSW-JAN2006 27/10/05-17:02"
.SH NAME 
   lcustatCheck - Check LCU environments status

.SH SYNOPSIS 
.nf 
.LP 
   lcustatCheck [-unlock]

.SH DESCRIPTION 
.nf 
.LP 
lcustatCheck monitors the status of a list of LCU environments
and updates a table in the WS database with its information.

The table is located under the lcustat application branch
(:Appl_data:lcustat), the attribute name is 'lcuEnvs'. To
configure the table use lcustatSetup(n)

When starting, lcustatCheck checks and set its lock attribute
(:Appl_data:lcustat.lock), if the lock is already set, then another
lcustatCheck process is already running and the current one
exits. If the lock was left set by a died server (it might happen if the
process gets a KILL command) then the lock can be released by a newer
lcustatCheck process by specifying the -unlock argument in the command
line.

The server checks and updates the status of the LCU environments
as follows: The UNIX ping command is used to detect if the
node is reachable, then if the LCU node is alive, a PING command is
sent to the lccServer on the LCU environment running in that
node.
The status attribute in the table used to store the LCU's status is
updated depending of the result of the previous checks with the
following values:

0 - UNIX ping command failed, host is down
1 - UNIX ping succeed (host ok), lccServer not responding
2 - UNIX ping succeed and there is communication with lccServer

.SH ENVIRONMENT 
.nf 
.LP 
RTAPENV is used implicitly to reister into the local environment.

.SH CAUTIONS 
.nf 
.LP 
The server caught the signal SIGTERM to clean temporary files
used to store the output of the UNIX's ping command. If the server
gets a KILL command or a SIGSTOP signal a number of small files <=40
named as LCU environments could be left.
This files might be get deleted by the next running server
(if its configuration does not change).

.SH SEE ALSO 
.nf 
.LP 
lcustat(n), lcustatSetup(n)

