.\" This Man Page has been automatically produced. DO NOT EDIT THIS FILE!!!!!!
.\" Input file:  seqCatch.tcl
.\" Formatter :  @(#) $Id: docDoManPages.c,v 1.37 2005/09/30 13:12:01 vltsccm Exp $
.\" -----------------------------------------------
.TH seq_catch n "VLTSW-JAN2006 27/10/05-17:00"
.SH NAME 
seq_catch - evaluate a command and return its completion status

.SH SYNOPSIS 
.nf 
.LP 
seq_catch <command> ?<msg>? ?<sourceId>?

.SH DESCRIPTION 
.nf 
.LP 
seq_catch has an identical syntax and behaves as the Tcl "catch" command.

<command>  : any Sequencer script
<msg>      : variable name where to store the result string for <command>
<sourceid> : string containing location identifier; remark that only the
             first word of this string will be transmitted to the CCS
             error logging system

On top of what "catch" does, seq_catch logs the error (if any) produced
by <command> to the CCS error logging system.  For that purpose it can use
the optional <sourceId> argument, which is for the error system known as
the "location identifier".  Typically the caller could set <sourceId> to
[info script].  If <sourceId> is not specified, it will be set to the name
of the script file which executes this seq_catch command.

.SH ENVIRONMENT 
.nf 
.LP 
no environment nor Tcl variables are read nor set

.SH RETURN VALUES 
.nf 
.LP 
identical to "catch":

returns OK, with the result string set to "0" if <command> did not produce
an error.  If <command> returned an error, the result string contains 1
and <msg>, if given, will be set to the error message left by <command>.

returns ERROR with corresponding message in the result string under the
following conditions:
- "wrong # args: should be "seq_catch <command> ?<msg>? ?<sourceId>?"" if
  there were more than 2 arguments given to this <command>.

.SH EXAMPLES 
.nf 
.LP 
(For clarity's sake, the example is for an interactive session with
input typed by the user coming after the "seqWish>" prompt, and all
replies on a new line)

 .....
seqWish>seq_catch {set a $b} msg "MyProcedure"
0
seqWish>seq_catch {set a $c} msg "MyProcedure"
1
seqWish>set msg
can't read "c": no such variable
seqWish>.....

.SH SEE ALSO 
.nf 
.LP 
"Tcl and the Tk toolkit", John K. Ousterhout, ISBN 0-201-6337-X
catch(n), seq_errAdd(n)

