.\" This Man Page has been automatically produced. DO NOT EDIT THIS FILE!!!!!!
.\" Input file:  seqDbGetAttrInfo.c
.\" Formatter :  @(#) $Id: docDoManPages.c,v 1.37 2005/09/30 13:12:01 vltsccm Exp $
.\" -----------------------------------------------
.TH seq_dbGetAttrInfo n "VLTSW-JAN2006 27/10/05-17:00"
.SH NAME 
seq_dbGetAttrInfo - get the detailed characteristics of an attribute

.SH SYNOPSIS 
.nf 
.LP 
seq_dbGetAttrInfo <attrSymAddress>

.SH DESCRIPTION 
.nf 
.LP 
seq_dbGetAttrInfo will retrieve the detailed description of an attribute.

<attrSymAddress> : string containing a symbolic address of the attribute,
                   in a format as permitted by dbGetAttrInfo(3)

seq_dbGetAttrInfo will return 4 values, in the following order:
- the attribute type (SCALAR, VECTOR or TABLE)
- a list of data types.  In the case of SCALARs and VECTORs this list
  contains a single element (without braces).  For TABLEs this list
  contains one element per field; if no field indices were specified, the
  data types of all fields will be returned.
- the number of records; always 1 for SCALARS; for TABLES it is according
  to the record indices, or the total number of records in the table if no
  record indices were given
- the number of fields; always 1 for SCALARS and VECTORs; for TABLES it is
  according to the field indices, or the total number of fields in the
  table if no field indices were given

.SH ENVIRONMENT 
.nf 
.LP 
no environment nor Tcl variables are read nor set

.SH RETURN VALUES 
.nf 
.LP 
OK return if no errors occurred.  In this case the result string contains
    the attribute type, the list of data types (a single element for
    SCALARs and VECTORs), the number of records and number of fields.
ERROR return if one of the following conditions is met (with corresponding
error message here between quotes):
  - "wrong # args : should be "seq_dbGetAttrInfo <attrSymAddress>": the
    command was given with the wrong number of arguments;
  - "cannot get info on "<attrSymAddress>": dbGetAttrInfo returned an
    error for this argument

.SH EXAMPLES 
.nf 
.LP 
(For clarity's sake, the example is for an interactive session with
input typed by the user coming after the "seqWish>" prompt, and all
replies on a new line)

 .....
seqWish>seq_dbGetAttrInfo <alias>eric.myScalar
SCALAR 5 1 1
seqWish>seq_dbGetAttrInfo <alias>eric.myVector
VECTOR 6 15 1
seqWish>seq_dbGetAttrInfo <alias>eric.myTable
TABLE {20 24 25} 5 3
seqWish>seq_dbGetAttrInfo <alias>eric.myTable(0:0,1:2)
TABLE {24 25} 1 2
seqWish>.....

.SH SEE ALSO 
.nf 
.LP 
"Tcl and the Tk toolkit", John K. Ousterhout, ISBN 0-201-6337-X
seqDbGetAttrInfo(3), dbGetDirAddr(3)

