.\" This Man Page has been automatically produced. DO NOT EDIT THIS FILE!!!!!!
.\" Input file:  seqDbGetDirAddr.c
.\" Formatter :  @(#) $Id: docDoManPages.c,v 1.37 2005/09/30 13:12:01 vltsccm Exp $
.\" -----------------------------------------------
.TH seq_dbGetDirAddr n "VLTSW-JAN2006 27/10/05-17:00"
.SH NAME 
seq_dbGetDirAddr, seq_dbDirAddrToName - get the internal address of a
point or attribute, or convert the direct address into a symbolic one.

.SH SYNOPSIS 
.nf 
.LP 
seq_dbGetDirAddr <attrSymAddress>

seq_dbDirAddrToName <directAddress> <

.SH DESCRIPTION 
.nf 
.LP 
seq_dbGetDirAddr will retrieve the detailed description of an attribute.
  <attrSymAddress> : string containing a symbolic address of the attribute,
                     in a format as permitted by dbGetDirAddr(3);
  seq_dbGetDirAddr will return a formatted string which is understood by
  several db/Rtap routines and utilities as a direct address.

seq_dbDirAddrToName will convert the direct address into a symbolic one
  <directAddress> : string with a direct address of a point/attribute;
  <view>          : view specifier for the address; can be either ABSOLUTE,
                    ALIAS or RELATIVE (both upper- and lowercase allowed)
  seq_dbDirAddrToName will return the corresponding address in the form
  as specified in <view>

.SH ENVIRONMENT 
.nf 
.LP 
no environment nor Tcl variables are read nor set

.SH RETURN VALUES 
.nf 
.LP 
OK return if no errors occurred.  In this case the result string contains
    the address.
ERROR return if one of the following conditions is met (with corresponding
error message here between quotes):
  - "wrong # args : should be "seq_dbGetDirAddr <attrSymAddress>": the
    command was given with the wrong number of arguments;
  - "wrong # args : should be "seq_dbDirAddrToName <directAddress> <view>":
    the command was given with the wrong number of arguments;
  - "cannot get internal address of "<attrSymAddress>"": dbGetDirAddr(3)
    returned an error for this argument
  - "wrong view specifier: should be ABSOLUTE, ALIAS or RELATIVE";
  - "cannot convert "<directAddress>" to a symblic address":
    dbDirAddrToName(3) returned an error for this argument

.SH CAUTIONS 
.nf 
.LP 
Suffering from the same limitations as dbGetDirAddr(3) resp.
dbDirAddrToName(3) these commands work only for the local environment (i.e.
there should be no environment-name part in <attrSymAddress> nor
<directAddress>)

.SH EXAMPLES 
.nf 
.LP 
(For clarity's sake, the example is for an interactive session with
input typed by the user coming after the "seqWish>" prompt, and all
replies on a new line)

 .....
seqWish>seq_dbGetDirAddr <alias>eric
@[10]
seqWish>seq_dbGetDirAddr <alias>eric.myVector
@[10.0]
seqWish>seq_dbGetDirAddr <alias>eric.myVector(1:2)
@[10.0(1:2)]
seqWish>seq_dbDirAddrToName @[10.0] alias
<alias>eric.myVector
seqWish>.....

.SH SEE ALSO 
.nf 
.LP 
"Tcl and the Tk toolkit", John K. Ousterhout, ISBN 0-201-6337-X
seqDbGetDirAddr(3), dbGetDirAddr(3), seqDbDirAddrToName(3),
dbDirAddrToName(3)

