.\" This Man Page has been automatically produced. DO NOT EDIT THIS FILE!!!!!!
.\" Input file:  seqDbLockPoint.c
.\" Formatter :  @(#) $Id: docDoManPages.c,v 1.37 2005/09/30 13:12:01 vltsccm Exp $
.\" -----------------------------------------------
.TH seq_dbLockPoint n "VLTSW-JAN2006 27/10/05-17:00"
.SH NAME 
seq_dbLockPoint, seq_dbUnlockPoint - lock/unlock a database point

.SH SYNOPSIS 
.nf 
.LP 
seq_dbLockPoint <pointName> ?<timeout>?

seq_dbUnlockPoint <pointName>

.SH DESCRIPTION 
.nf 
.LP 
seq_dbLockPoint:
    will lock a single point in the database.

    <pointName> : symbolic name or alias of the point to lock
    <timeout>   : number of seconds the point will be locked (range: 3 to
                  60); default: 3

    The point will remain locked for <timeout> seconds, unless a
    seq_dbUnlockPoint command is given before the timeout expires

seq_dbUnlockPoint:
    will unlock a locked database point.

.SH ENVIRONMENT 
.nf 
.LP 
no environment nor Tcl variables are read nor set

.SH RETURNVALUES 
.nf 
.LP 
OK return if no errors occurred.  The result string is empty.
ERROR return if one of the following conditions is met (with corresponding
error message here between quotes):
  - "wrong # args : should be "seq_dbLockPoint <pointName> ?<timeout>?":
    the command was given with the wrong number of arguments;
  - "wrong # args : should be "seq_dbUnlockPoint <pointName>": the command
    was given with the wrong number of arguments;
  - error message left by Tcl_GetInt applied on <timeout>;
  - "cannot lock point "<pointName>": dbLockPoint returned an error for
    this argument
  - "cannot unlock point "<pointName>": dbUnlockPoint returned an error

.SH CAUTIONS 
.nf 
.LP 
If the point is already locked, this command will hang until the point
has been released.

.SH EXAMPLES 
.nf 
.LP 
(For clarity's sake, the example is for an interactive session with
input typed by the user coming after the "seqWish>" prompt, and all
replies on a new line)

 .....
seqWish>seq_dbLockPoint "<alias>eric"
seqWish>seq_dbread "<alias>eric.my scalar"
199.5
seqWish>seq_dbUnlockPoint "<alias>eric"
seqWish>.....

.SH SEE ALSO 
.nf 
.LP 
"Tcl and the Tk toolkit", John K. Ousterhout, ISBN 0-201-6337-X
seqDbLockPoint(3), seqDbUnlockPoint(3)

