.\" This Man Page has been automatically produced. DO NOT EDIT THIS FILE!!!!!!
.\" Input file:  seqDbMulti.c
.\" Formatter :  @(#) $Id: docDoManPages.c,v 1.37 2005/09/30 13:12:01 vltsccm Exp $
.\" -----------------------------------------------
.TH seq_dbMultiRead n "VLTSW-JAN2006 27/10/05-17:00"
.SH NAME 
seq_dbMultiRead, seq_dbMultiWrite -
     commands for the handling of db multi-read/write operations

.SH SYNOPSIS 
.nf 
.LP 
seq_dbMultiRead <listId1> ?<listId2>? ...

seq_dbMultiWrite ?-block? <listId1> ?<listId2>? ...

.SH DESCRIPTION 
.nf 
.LP 
seq_dbMultiRead:
  read a list of attributes on a particular environment
  <listIdN> : list handle as returned by seq_dbListCreate

  seq_dbMultiRead will do the actual database access for all attributes
  in the multi-read/write list <listIdN>, which was created and prepared
  previously with the seq_dbList* commands.  The actual values read can
  be extracted with the seq_dbListExtract command.

seq_dbMultiWrite:
  write a list of attributes on a particular environment
  -block : option that signals that all attributes should be considered
           a unit, and consequently to succeed all addresses must be
           correct and writable by the user. Default: no blocking
  <listIdN> : list handle as returned by seq_dbListCreate

  seq_dbMultiWrite will do the actual database access for all attributes
  in the multi-read/write list <listIdN>, which was created and prepared
  previously with the seq_dbList* commands.

.SH ENVIRONMENT 
.nf 
.LP 
no environment nor Tcl variables are read nor set

.SH RETURN VALUES 
.nf 
.LP 
OK return if no errors occurred.  The result string is empty.
ERROR return if one of the following conditions is met (with corresponding
error message here between single quotes):
  - 'wrong # args : should be "seq_dbMultiRead <listId1> ?<listId2>? ..."':
    the command was given with the wrong number of arguments
  - 'wrong # args : should be "seq_dbMultiWrite ?-block? <listId1>
    ?<listId2>? ..."': the command was given with the wrong number of
    arguments
  - 'invalid list handle: "<listId>"': <listId> does not start with the
    word "list"
  - 'multi-read/write list "<listId>" is currently undefined': the shell
    does not know of any multi-read/write list with this particular
    <listId>
  - 'multi-read for list "<listId> failed': the call to dbMultiRead failed.
  - 'multi-write for list "<listId> failed': the call to dbMultiWrite
    failed

.SH EXAMPLES 
.nf 
.LP 
(For clarity's sake, the example is for an interactive session with
input typed by the user coming after the "seqWish>" prompt, and all
replies on a new line)

 .....
seqWish>seq_dbListCreate wte67 r
list0
seqWish>set attribute1 :PARAMS:SCALARS.scalar_float
seqWish>set attribute2 :PARAMS:VECTORS.vector_double(1:2)
seqWish>set attribute3 :PARAMS:TABLES.full_table(1:2,3:4)
seqWish>seq_dbListAdd list0 $attribute1 $attribute2 $attribute3
seqWish>....
seqWish>seq_dbListPut list0 $attribute1 321.5 $attribute2 {3 7}
seqWish>seq_dbListPut list0 $attribute3 {{1.2 {hi there}} {2. hi!}}
seqWish>seq_dbMultiWrite list0
seqWish>....
 ....

.SH SEE ALSO 
.nf 
.LP 
"Tcl and the Tk toolkit", John K. Ousterhout, ISBN 0-201-6337-X
seqDbListCreate(3), seqDbListAdd(3), seqDbListRemove(3),
seqDbListDestroy(3),

