.\" This Man Page has been automatically produced. DO NOT EDIT THIS FILE!!!!!!
.\" Input file:  seqDbCe.c
.\" Formatter :  @(#) $Id: docDoManPages.c,v 1.37 2005/09/30 13:12:01 vltsccm Exp $
.\" -----------------------------------------------
.TH seq_dbSetCe n "VLTSW-JAN2006 27/10/05-17:00"
.SH NAME 
seq_dbSetCe, seq_dbGetCe - set/get the CE definition for an attribute

.SH SYNOPSIS 
.nf 
.LP 
seq_dbSetCe <attrName> <CE definition>

seq_dbGetCe <attrName>

.SH DESCRIPTION 
.nf 
.LP 
seq_dbSetCe:
    will set the CE definition of an attribute

    <attrName>      : the database attribute name, in one of the usual
                      forms
    <CE definition> : a string containing the definition of the calcuation
                      engine function for that attribute. The syntax is as
                      defined in the CCS User Manual.

seq_dbGetCe:
    will return the CE definition of an attribute

    <attrName>      : the database attribute name, in one of the usual
                      forms

.SH ENVIRONMENT 
.nf 
.LP 
The seq_dbSetCe function will only function if a particular environment
variable has been set - see the dbSetCe() manpage and CCS User Manual.

.SH RETURN VALUES 
.nf 
.LP 
OK return if no errors occurred.  For seq_dbGetCe the result string
    contains the CE definition.
ERROR return if one of the following conditions is met (with corresponding
error message here between quotes):
  - 'wrong # args : should be "seq_dbSetCe <attrName> <CE definition>"':
    the corresponding Sequencer command was given with the wrong number of
    arguments;
  - 'cannot set CE function for "<attrName>": CE definition can only be up
    to 2048 chars': when the <CE definition> string is too long
  - 'cannot set CE function for "<attrName>"': dbSetCe returned an error
    for this argument
  - 'wrong # args : should be "seq_dbGetCe <attrName>"': the corresponding
    Sequencer command was given with the wrong number of arguments;
  - 'cannot get CE function for "<attrName>"': dbGetCe returned an error

.SH CAUTIONS 
.nf 
.LP 
Modifying the CE definition of a live environment can completely change its
characteristics. This is why the dbSetCe() requires the setting of a
particular environment variable.
There are further restrictions on the use of seq_dbSetCe and seq_dbGetCe
which come from the underlying dbSetCe() and dbGetCe() functions; see their
respective manpages.

.SH EXAMPLES 
.nf 
.LP 
(For clarity's sake, the example is for an interactive session with
input typed by the user coming after the "seqWish>" prompt, and all
replies on a new line)

 .....
seqWish>seq_dbSetCe <alias>erik.scalar_int32 {MIN([.var1], [.var2])}
seqWish>seq_dbGetCe <alias>erik.scalar_int32
MIN([.var1], [.var2])
seqWish>.....

.SH SEE ALSO 
.nf 
.LP 
"Tcl and the Tk toolkit", John K. Ousterhout, ISBN 0-201-6337-X
seqDbSetCe(3), seqDbGetCe(3)

