.\" This Man Page has been automatically produced. DO NOT EDIT THIS FILE!!!!!!
.\" Input file:  seqDbCwp.c
.\" Formatter :  @(#) $Id: docDoManPages.c,v 1.37 2005/09/30 13:12:01 vltsccm Exp $
.\" -----------------------------------------------
.TH seq_dbSetCwp n "VLTSW-JAN2006 27/10/05-17:00"
.SH NAME 
seq_dbSetCwp, seq_dbGetCwp - set/get the current working point

.SH SYNOPSIS 
.nf 
.LP 
seq_dbSetCwp <pointName>

seq_dbGetCwp ?<envName>?

.SH DESCRIPTION 
.nf 
.LP 
seq_dbSetCwp:
    will set the current working point

    <pointName> : the database point to set the current working directory
                  to; is either a symbolic address or its alias.

seq_dbGetCwp:
    will return the current working point

    <envName> : name of the environment whose current working point has to
                be returned; defaults to the current environment.

.SH ENVIRONMENT 
.nf 
.LP 
no environment nor Tcl variables are read nor set

.SH RETURN VALUES 
.nf 
.LP 
OK return if no errors occurred.  For seq_dbGetCwp the result string
    contains the current working point (not including the environment
    name).
ERROR return if one of the following conditions is met (with corresponding
error message here between quotes):
  - 'wrong # args : should be "seq_dbSetCwp <pointName>"': the corresponding
    Sequencer command was given with the wrong number of arguments;
  - 'wrong # args : should be "seq_dbGetCwp ?<envName>?"': the
    corresponding  Sequencer command was given with the wrong number of
    arguments;
  - 'cannot set CWP to "<pointName>"': dbSetCwp returned an error
    for this argument
  - 'cannot get CWP from "<envName>"': dbGetCwp returned an error

.SH CAUTIONS 
.nf 
.LP 
none

.SH EXAMPLES 
.nf 
.LP 
(For clarity's sake, the example is for an interactive session with
input typed by the user coming after the "seqWish>" prompt, and all
replies on a new line)

 .....
seqWish>seq_dbSetCwp "<alias>erik"
seqWish>seq_dbGetCwp
:users config:eallaert
seqWish>.....

.SH SEE ALSO 
.nf 
.LP 
"Tcl and the Tk toolkit", John K. Ousterhout, ISBN 0-201-6337-X
seqDbSetCwp(3), seqDbGetCwp(3)

