.\" This Man Page has been automatically produced. DO NOT EDIT THIS FILE!!!!!!
.\" Input file:  seqErrLog.tcl
.\" Formatter :  @(#) $Id: docDoManPages.c,v 1.37 2005/09/30 13:12:01 vltsccm Exp $
.\" -----------------------------------------------
.TH seq_errLog n "VLTSW-JAN2006 27/10/05-17:00"
.SH NAME 
seq_errLog - log a single Sequencer error

.SH SYNOPSIS 
.nf 
.LP 
seq_errLog <error> <srcId>

.SH DESCRIPTION 
.nf 
.LP 
seq_errLog will handle the logging of a single error for the Sequencer,
i.e. it will first reset the error stack, then log <error> and finally
close (and thereby reset) the error stack.

<error> : string containing a description of the error
<srcId> : string containing the source identifier

.SH ENVIRONMENT 
.nf 
.LP 
no environment nor Tcl variables are read nor set

.SH RETURN VALUES 
.nf 
.LP 
OK return if no errors occurred.  The result string is empty.
ERROR return if seq_errAdd fails, with a corresponding error message as
generated by seq_errAdd.

.SH CAUTIONS 
.nf 
.LP 
none

.SH EXAMPLES 
.nf 
.LP 
(For clarity's sake, the example is for an interactive session with
input typed by the user coming after the "seqWish>" prompt, and all
replies on a new line)

 .....
seqWish>seq_errLog "Who the hell deleted this file??" "file_proc"
seqWish>.....

.SH SEE ALSO 
.nf 
.LP 
"Tcl and the Tk toolkit", John K. Ousterhout, ISBN 0-201-6337-X
seq_errResetStack(n), seq_errAdd(n), seq_errCloseStack(n)

