.\" This Man Page has been automatically produced. DO NOT EDIT THIS FILE!!!!!!
.\" Input file:  seqMsgFlush.tcl
.\" Formatter :  @(#) $Id: docDoManPages.c,v 1.37 2005/09/30 13:12:01 vltsccm Exp $
.\" -----------------------------------------------
.TH seq_msgFlush n "VLTSW-JAN2006 27/10/05-17:00"
.SH NAME 
seq_msgFlush - flush pending replies

.SH SYNOPSIS 
.nf 
.LP 
seq_msgFlush ?<option>? <filter>

.SH DESCRIPTION 
.nf 
.LP 
seq_msgFlush waits a certain time for all replies to flush them as they
come in, or optionally flushes replies that are already available.

<option> can be either:
    * -nowait : flags not to wait, i.e. flush only replies which are
                available at the time the command is given
    * <nnn> : an integer giving the timeout in ms to wait for replies
    If no <option> is specified, the wait will be forever.

<filter> is a list with at least one element; it is either:
    * the environment, and optionally, the process name for which
      we want to flush the replies
    * the word "all" to indicate replies to all commands


.SH ENVIRONMENT 
.nf 
.LP 
No Tcl variables are accessed.

.SH RETURN VALUES 
.nf 
.LP 
OK, with and empty result string if no errors
ERROR with corresponding message in the result string under the following
conditions:
- "called "seq_msgFlush" with too many arguments" if there were more
  than 2 arguments given to this command.
- "wrong filter: should be "{<envName> ?<procName>?}"" if <filter> is wrong
- "wrong option: should be "-nowait" or "<nnn>"" if <option> is not correct
- any error message returned by seq_msgRecvReply

.SH CAUTIONS 
.nf 
.LP 
The timeout given is applied to all replies separately, i.e. the total,
cumulative timeout may be much larger than given by this number

.SH EXAMPLES 
.nf 
.LP 
(For clarity's sake, the example is for an interactive session with
input typed by the user coming after the "seqWish>" prompt, and all
replies on a new line)

 .....
seqWish>seq_msgList
{cmd5 {wte13 OS INIT}} {cmd9 {lte18 ICS RESET}} {cmd27 {wte13 DCS INIT}}
seqWish>seq_msgFlush wte13
seqWish>seq_msgList
{cmd9 {lte18 ICS RESET }}
seqWish>.....

.SH SEE ALSO 
.nf 
.LP 
"Tcl and the Tk toolkit", John K. Ousterhout, ISBN 0-201-6337-X
seq_msgRecvReply(n)

