.\" This Man Page has been automatically produced. DO NOT EDIT THIS FILE!!!!!!
.\" Input file:  vccConfigLcuLib.tcl
.\" Formatter :  @(#) $Id: docDoManPages.c,v 1.37 2005/09/30 13:12:01 vltsccm Exp $
.\" -----------------------------------------------
.TH vccConfigLcuLib n "VLTSW-JAN2006 27/10/05-16:59"
.SH NAME 
    vccConfigLcuLib - LCU configuration library

.SH SYNOPSIS 
.nf 
.LP 
    vccConfigLcuGet ConfigArray_ref LcuEnv \\
                    ?BwsEnv? ?VltHost? ?IntHost? ?ModHost? ?LcuHost?

    vccConfigLcuParseBootScript ConfigArray_ref BootScript

    vccConfigLcuGenerateBootScript ConfigArray_ref \\
                    ?LcubootSource? ?UserScriptEnable?

    vccConfigLcuMakeBootScript ConfigArray_ref Modules FileName LcuEnv \\
                    ?BwsEnv? ?VltHost? ?IntHost? ?ModHost? ?LcuHost? \\
                    ?LcubootSource? ?UserScriptEnable?

    vccConfigLcuGenerateBootChange ConfigArray_ref ?BootScript?

    vccConfigLcuEvalBspName bspname ?proc? ?size?

    vccConfigLcuGetNFS Path ModHost ?NfsHost? ?NfsPath?

.SH DESCRIPTION 
.nf 
.LP 
  vccConfigLcuGet - Queries the configuration from the database

    ConfigArray_ref <i/o>   array containing configuration options
    LcuEnv          <in>    name of LCU environment
    BwsEnv          <in>    name of WS boot environment
    VltHost         <in>    host where VLTROOT or ACSROOT resides
    IntHost         <in>    host where INTROOT resides
    ModHost         <in>    host where MODROOT resides
    LcuHost         <in>    host assigned to the LCU

    The configuration array is filled from the database.
    All options are also returned as a keyed list.
    Omitted optional arguments default to the database values.

  vccConfigLcuParseBootScript - Interprets the boot-script

    ConfigArray_ref <i/o>   array containing configuration options
    BootScript      <in>    contents of bootScript as a string

    The configuration array is filled from the contents of BootScript.
    All options are also returned as a keyed list.

  vccConfigLcuGenerateBootScript - Generates the boot-script as a string

    ConfigArray_ref  <in>   array containing configuration options
    LcubootSource    <in>   where lcuboot module shall be loaded from,
                            either VLTROOT or INTROOT
    UserScriptEnable <in>   flag whether userScript shall be executed.

    A bootScript corresponding to the configuration array is generated
    and returned as a string.

  vccConfigLcuMakeBootScript - Makes a standard boot-script file

    ConfigArray_ref <i/o>   array containing configuration options
    FilePath <in>   full path where bootScript shall be written;
                    if empty, then the default BOOTHOME is used.
    Modules  <in>   is the list of modules to be loaded;
                    additionally the type of bootScript to produce
                    can be specified by a special keyword in the list:
                    "minimum": only LCC and lqs, no drivers etc.
                    "maximum": all common modules shall be loaded
                    otherwise: exactly as specified in database
    Other arguments are as above.

    A standard bootScript is produced and written to a file.
    This is a combination of `vccConfigLcuGet' and
    `vccConfigLcuGenerateBootScript'.

  vccConfigLcuGenerateBootChange - generate `bootChange' sequence

    ConfigArray_ref  <in>   array containing configuration options
    BootScript       <in>   full path of bootScript to be set,
                            by default use no bootScript.

    Generates a script to be sourced by LCU to configure the boot-line
    and returns it as a string.

  vccConfigLcuEvalBspName - analyse or construct BSP name
                    based on size and proc convention

  vccConfigLcuGetNFS - retrieve real path and NFS host from /etc/auto_home
                       for NFS mouted users
.SH ENVIRONMENT 
.nf 
.LP 
    VLTDATA         path to VLT data area
    VLTROOT         path to VLT code area
    INTROOT         path to private integration code area (optional)
    MODROOT         path to private module area (optional)
    VXROOT          path to VxWorks files

    Other variables see VccInfo(n).

.SH BUGS 
.nf 
.LP 
    vccConfigLcuGenerateBootScript: the generated lines are not checked
    for a maximum length. This can lead to problems when the bootScript
    is sourced under the VxWorks shell, since here max. 128 chars or so
    are permitted. If this is exceeded, the boot will fail.

.SH SEE ALSO 
.nf 
.LP 
    bootScript(5), userScript(5), module.boot(5),
    VccInfo(n),
    lcuboot(1)

