.\" This Man Page has been automatically produced. DO NOT EDIT THIS FILE!!!!!!
.\" Input file:  vccFindLib.tcl
.\" Formatter :  @(#) $Id: docDoManPages.c,v 1.37 2005/09/30 13:12:01 vltsccm Exp $
.\" -----------------------------------------------
.TH vccFindLib n "VLTSW-JAN2006 27/10/05-16:59"
.SH NAME 
    vccFindLib,
    vccFindFile, vccFindConfigFile, vccFindRcFile,
    vccFindBitmapFile, vccFindPixmapFile
    - VLT Central Configuration Find File Library

.SH SYNOPSIS 
.nf 
.LP 
    vccFindFile <RelativePath>      ==> <AbsolutePath> | ""
    vccFindConfigFile ?<Name> ...?  ==> <AbsolutePath> | ""
    vccFindRcFile ?<Name> ...?      ==> <AbsolutePath> | ""
    vccFindBitmapFile ?<Name> ...?  ==> <AbsolutePath> | ""
    vccFindPixmapFile ?<Name> ...?  ==> <AbsolutePath> | ""

.SH DESCRIPTION 
.nf 
.LP 
  The functions contained herein locate an explicitly for implicitly
  given file in the VLT standard areas. See also vccSourceLib(n) for
  functions that locate and immediately source scripts.

  vccFindFile               - Locate a file by its relative path

    This function should be used to locate a file at run time.
    The file given as relative path is searched with the following order:

    1. in the current module area:  "../<RelativePath>"
    2. in INTDATA (if defined):     "$INTDATA/<RelativePath>"
    3. in VLTDATA:                  "$VLTDATA/<RelativePath>"
    4. in INTROOT (if defined):     "$INTROOT/<RelativePath>"
    5. in VLTROOT:                  "$VLTROOT/<RelativePath>"


  vccFindConfigFile         - Loacte a config file

    This function should be used to locate a config file at run time.
    <Name> can be given as filename without path, e.g. "abc.config".
    Multiple names are possible which are then searched in order.
    If no argument is given, then the name is automatically derived from
    the current program name, i.e. "[file tail $argv0]".
    The file is first searched by its plain name, and then by
    appending the extension ".config".
    It is searched with the same priority order as for `vccFindFile'
    in the "config" sub-directory.


  vccFindRcFile             - Locate a user-config file

    This function should be used to locate a user-config file at run time.
    <Name> can be given as filename without path, e.g. "abcProg".
    Multiple names are possible which are then searched in order.
    If no argument is given, then the name is automatically derived from
    the current program name, i.e. "[file tail $argv0]".
    It is searched in the following priority order:

    1. "~/.<Name>"
    2. "~/.<Name>" where <Name> is converted to all lower case
    3. "~/.<Name>Rc"
    4. "~/.<Name>rc" where <Name> is converted to all lower case

    The following files would be found for a program "abcProg":
    "~/.abcProg", "~/.abcprog", "~/.abcProgRc", "~/.abcprogrc".

  vccFindBitmapFile         - Locate a bitmap file
  vccFindPixmapFile         - Locate a pixmap file

    This function can be used to locate a bit/pixmap file at run time.
    If <Name> is given then it must be without extension.
    Similar rules as for vccFindConfigFile are applied.


.SH RETURN VALUES 
.nf 
.LP 
    The absolute path of the first found file is returned,
    or an empty string if none was found.

    The file must be readable for the calling user, otherwise it will
    be ignored even if it exists.

.SH FILES 
.nf 
.LP 
    The explicitly or implicitly specified files are accessed by the
    procs in read-onlv mode. They must be readable by the calling user.

.SH ENVIRONMENT 
.nf 
.LP 
    VLTROOT - path to VLT code area
    INTROOT - path to intgration code area (optional)
    VLTDATA - path to VLT data area
    INTDATA - path to intgration data area (optional)

.SH SEE ALSO 
.nf 
.LP 
    vcc(n), vccSourceLib(n)

