.\" This Man Page has been automatically produced. DO NOT EDIT THIS FILE!!!!!!
.\" Input file:  vccRemLib.tcl
.\" Formatter :  @(#) $Id: docDoManPages.c,v 1.37 2005/09/30 13:12:01 vltsccm Exp $
.\" -----------------------------------------------
.TH vccRemLib n "VLTSW-JAN2006 27/10/05-16:59"
.SH NAME 
    vccRemLib,
    vccRemOpen, vccRemClose,
    vccRemPath, vccRemExec,
    vccRemLogin
    - VLT Central Configuration Remote Host Operations Library

.SH SYNOPSIS 
.nf 
.LP 
    vccRemOpen      <Host> <File> ?<Mode>? ?<Options>?      ==> <fd>
    vccRemClose     <Fd>                                    ==> ""
    vccRemPath      <Host> <Path>                           ==> <dir> | ""
    vccRemExec      <Host> <Command>                        ==> <stdout>
    vccRemLogin     <Host>                                  ==> <fd>

.SH DESCRIPTION 
.nf 
.LP 
    vccRemOpen -    opens a remote file on `Host' with pathname `File'

            `Host' denotes the host on which `File' resides.
            The host can also be included in the form "<host>:<file>"
            in `File', which then takes precedence over `Host'.
            If no host specification is given in either form,
            then a local access is assumed.
            For local accesses the `File' is opened directly.
            For remote accesses the concatenation "<host>:<file>"
            is passed to rcp(1) in order to make a local copy of the file
            in a tmp directory (see FILES). This file is then opened.
            The access-mode `Mode' is as in open(n): r, r+, w, w+, a, a+.
            "r" is the default.
            `Options' can be "-dialog" to ask for confirmation to
            overwrite a file if it already exists, otherwise it is
            replaced without asking.
            Returns a file-identifier to be used in subsequent
            file commands like gets(n), puts(n), and `vccRemClose'.

    vccRemClose -   closes a file previously opened by `vccRemOpen'

            If the file was not opened remotely in read-only mode, then
            the local copy is written back with rcp(1) to it's original
            place. The local copy is then deleted.
            Returns an empty string.

    vccRemPath -    gets a remote directory-path in resolved notation

            The value of `Path' must denote the name of a directory on
            `Host' and may contain environment-variables to be resolved.
            Returns the expanded physical path-name of the directory via
            pwd(1), or an empty string if the directory does not exist.

    vccRemExec -    executes a shell-command on a remote host

            `Command' is executed as a shell-command on `Host'.
            Returns the standard-output of the command.

    vccRemLogin -   rlogin to a remote host

            Opens a `rlogin' pipe to a remote `Host'.
            Returns a file-identifier for the pipe that is open for
            writing. If the rlogin was not successful, a dialog-box
            is opened for information, as an empty string is returned.
            The rlogin session will be closed by a `close <fd>',
            which may yield a Tcl error due to some stderr writing.
            See also CAUTIONS.

.SH FILES 
.nf 
.LP 
    Temporary files are used for local copies of remote files.
    The variable `vcc_n(tmpDir)' defines the target directory,
    which is "/tmp" by default.

.SH ENVIRONMENT 
.nf 
.LP 
    Note that environment-variables on remote hosts should be defined
    e.g. in "$HOME/.cshrc" resp. "$HOME/.cshrc.local" for VLT.
    Otherwise they may be undefined when accessed through a remote
    operation like `remsh'.

.SH CAUTIONS 
.nf 
.LP 
    All procs shall only be used with a windowing shell, eg. seqWish.

    Note that I/O operation are usually buffered. In particular, an
    explicit `flush' is necessary after each `puts' to a pipe opened
    with `vccRemLogin'.

.SH EXAMPLES 
.nf 
.LP 
    set fd [vccRemOpen te1 /vlt/config/xyz] ;# open file on te1 for read
    set x [read $fd]                        ;# read it's contents
    vccRemClose $fd                         ;# close the file

    set v [vccRemVar te16 HOME]             ;# get variable HOME on te16
    set w [vccRemPath te49 \\$VLTROOT]       ;# get path to VLTROOT on te49

.SH SEE ALSO 
.nf 
.LP 
    vccLib(n),
    open(n), close(n), puts(n), gets(n), read(n),
    rcp(1), remsh(1), rsh(1), cd(1), pwd(1), echo(1)

.SH BUGS 
.nf 
.LP 
    vccRemOpen: do not specify "-dialog" for read modes.

