.\" This Man Page has been automatically produced. DO NOT EDIT THIS FILE!!!!!!
.\" Input file:  vccSourceLib.tcl
.\" Formatter :  @(#) $Id: docDoManPages.c,v 1.37 2005/09/30 13:12:01 vltsccm Exp $
.\" -----------------------------------------------
.TH vccSourceLib n "VLTSW-JAN2006 27/10/05-16:59"
.SH NAME 
    vccSourceLib,
    vccSourceConfigFile, vccSourceRcFile, vccSourceConfigAndRc
    - VLT Central Configuration Source File Library

.SH SYNOPSIS 
.nf 
.LP 
    vccSourceConfigFile ?<Name>?    ==> <script-return-value> | ""
    vccSourceRcFile ?<Name>?        ==> <script-return-value> | ""
    vccSourceConfigAndRc ?<ConfigName> <RcName>?
                                    ==> { <script1-value> <script2-value> }

.SH DESCRIPTION 
.nf 
.LP 
  The functions contained herein are build on top of vccFindLib.
  They not only locate a script file, but also immediately source it.
  If a suitable script is found, then - before sourcing it - a line
  indicating the script's name is output to stdout.

  vccSourceConfigFile       - Locate and source a config file

    This function should be used to source a config file at run time.
    It calls `vccFindConfigFile' and sources it when found.
    The return value of the sourced script is returned,
    or an empty string if none was found.


  vccSourceRcFile           - Locate and source a user-config file

    This function should be used to source a user-config file at run time.
    It calls `vccFindRcFile' and sources it when found.
    The return value of the sourced script is returned,
    or an empty string if none was found.


  vccSourceConfigAndRc      - Locate and source both config files

    This function should be used to source both config files at run time.
    It first calls `vccFindConfigFile' and sources it when found.
    Then it calls `vccSourceRcFile' and sources it when found.
    The return values of both sourced scripts are returned as a list,
    or an empty string (for either script) if none was found.

.SH RETURN VALUES 
.nf 
.LP 
    As stated in DESCRIPTION.

.SH FILES 
.nf 
.LP 
    See vccFindLib.

.SH ENVIRONMENT 
.nf 
.LP 
    See vccFindLib.

.SH CAUTIONS 
.nf 
.LP 
    All scripts are sourced at global level.

.SH EXAMPLES 
.nf 
.LP 
    The usual case for an application is that it sources its configuration
    scripts before entering the event loop. This can be achived by only
    one statement placed at the end of the application script:

            vccSourceConfigAndRc

    This will source automatically the configuration scripts whose names
    are derived from the program name (argv0).

.SH SEE ALSO 
.nf 
.LP 
    vccFindLib(n)

