.\" This Man Page has been automatically produced. DO NOT EDIT THIS FILE!!!!!!
.\" Input file:  vccStdLib.tcl
.\" Formatter :  @(#) $Id: docDoManPages.c,v 1.37 2005/09/30 13:12:01 vltsccm Exp $
.\" -----------------------------------------------
.TH vccStdLib n "VLTSW-JAN2006 27/10/05-16:59"
.SH NAME 
    vccStdLib,
    vccStdMain, vccStdToplevel
    - VLT Central Configuration Standardized Windows Library

.SH SYNOPSIS 
.nf 
.LP 
    vccStdMain ?<CloseHandler>?
    vccStdToplevel <Window> ?<Title>?

.SH DESCRIPTION 
.nf 
.LP 
  vccStdMain - Configure a main panel in a standard way

    This function should be used to perform a standard panel config
    procedure. It should be called before entering the event-loop.
    It sets up the following window-manager attributes:

    title      - derived from existing title, prefixed with "prog@host"
    iconname   - set to "prog@host"
    iconbitmap - loaded from file with vccFindBitmapFile(n)
    client     - set to "host", to tell the WM where the prog is running
    command    - set to "$argv0 $argv", to tell the WM how to start it

    Then it calls the routine vccSourceConfigAndRc to execute the
    config and rc files, if present.

    If `CloseHandler' is given, then it is executed when the window is
    closed from the window-manager.

  vccStdToplevel - Configure a toplevel sub-window in a standard way

    This function should be used to perform a standard toplevel
    sub-window config procedure. It sets up the window-manager
    attributes derived from those of the main window.
    If `Title' is not given, then the window will be marked as transient
    and placed (roughly) on top of the main window. The actual title
    is derived from the main window and `Window' then.

.SH SEE ALSO 
.nf 
.LP 
    vcc(n), vccWinLib(n), vccFindBitmapFile(n)

