#******************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: b016_68k.boot,v 3.3 2002/04/30 06:15:16 vltsccm Exp $"
#
# VxWorks script for automatic installation of b016 driver and devices
#
# who       when      what
# --------  --------  ----------------------------------------------
# ccumani   12/02/96  created
#                     (replaces b016Install.sh and b016InstallSw.sh)
#
######################################################################
#
#  NAME
#  b016.boot - script file to load and install b016 driver
#
#  SYNOPSIS   
#  b016.boot
#
#  DESCRIPTION
#  This script file:
#  a) loads the b016 driver for VxWorks
#  b) installs and configures the b016 driver
#  c) installs and configures the b016 devices
#
#  RETURN VALUES
#  none
#
#  CAUTIONS
#
#  EXAMPLE
#  vxworks> < b016.boot
#
#------------------------------------------------------------------------------
#

###################################################################
# Install b016 Driver.
b016N = lcubootAutoDevRegister ("/bxvi00",0x2d,0x4001)
b016N = lcubootAutoDevRegister ("/bxvi01",0x2d,0x4001)
b016N = lcubootAutoDevRegister ("/bxvi02",0x2d,0x4001)
b016N = lcubootAutoDevRegister ("/bxvi03",0x2d,0x4001)

lcubootAutoDrvInstall "b016",b016N,0,0,(b016N/4),4

###################################################################
# Add 4 devices to b016 Driver.
lcubootAutoDevCreate ("/bxvi00",0,0,0x2d,0x4000,0x02000000,200,3)
lcubootAutoDevCreate ("/bxvi01",0,1,0x2d,0x4000,0x02000000,200,3)
lcubootAutoDevCreate ("/bxvi02",0,2,0x2d,0x4000,0x02000000,200,3)
lcubootAutoDevCreate ("/bxvi03",0,3,0x2d,0x4000,0x02000000,200,3)

###################################################################
# verify loading
b016Version

# __oOo__
