#******************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: ikon.boot,v 2.5 2003/07/24 13:22:50 vltsccm Exp $"
#
# VxWorks script for automatic installation of driver and devices
#
# who       when       what
# --------  ---------- ----------------------------------------------
# ssandroc  24.04.1995 created
#
#
# standard driver installation procedure
# -> detect for physical device on VME bus at 
#    address 0xC<F-b><C-4c>000 in A24 domain
#    where : <b> is the board number [0..4]
#            <c> is the channel number on the board [0..3] 
#
ikonN = lcubootAutoDevRegister("/ikon0", 0x3d,0xcfc000,1,1,1)
ikonN = lcubootAutoDevRegister("/ikon1", 0x3d,0xcf8000,1,1,1)
ikonN = lcubootAutoDevRegister("/ikon2", 0x3d,0xcf4000,1,1,1)
ikonN = lcubootAutoDevRegister("/ikon3", 0x3d,0xcf0000,1,1,1)
ikonN = lcubootAutoDevRegister("/ikon4", 0x3d,0xcec000,1,1,1)
ikonN = lcubootAutoDevRegister("/ikon5", 0x3d,0xce8000,1,1,1)
ikonN = lcubootAutoDevRegister("/ikon6", 0x3d,0xce4000,1,1,1)
ikonN = lcubootAutoDevRegister("/ikon7", 0x3d,0xce0000,1,1,1)
ikonN = lcubootAutoDevRegister("/ikon8", 0x3d,0xcdc000,1,1,1)
ikonN = lcubootAutoDevRegister("/ikon9", 0x3d,0xcd8000,1,1,1)
ikonN = lcubootAutoDevRegister("/ikon10",0x3d,0xcd4000,1,1,1)
ikonN = lcubootAutoDevRegister("/ikon11",0x3d,0xcd0000,1,1,1)
ikonN = lcubootAutoDevRegister("/ikon12",0x3d,0xccc000,1,1,1)
ikonN = lcubootAutoDevRegister("/ikon13",0x3d,0xcc8000,1,1,1)
ikonN = lcubootAutoDevRegister("/ikon14",0x3d,0xcc4000,1,1,1)

#
# standard driver installation procedure
# -> install driver
#
lcubootAutoDrvInstall "ikon"

#
# standard driver installation procedure
# -> create IKON devices with interrupts level 3 vectors [143..129]
#
lcubootAutoDevCreate "/ikon0", 0xcfc000,0x8000,143,3,1,0x0000,0,0
lcubootAutoDevCreate "/ikon1", 0xcf8000,0x8000,142,3,1,0x0000,0,0
lcubootAutoDevCreate "/ikon2", 0xcf4000,0x8000,141,3,1,0x0000,0,0
lcubootAutoDevCreate "/ikon3", 0xcf0000,0x8000,140,3,1,0x0000,0,0
lcubootAutoDevCreate "/ikon4", 0xcec000,0x8000,139,3,1,0x0000,0,0
lcubootAutoDevCreate "/ikon5", 0xce8000,0x8000,138,3,1,0x0000,0,0
lcubootAutoDevCreate "/ikon6", 0xce4000,0x8000,137,3,1,0x0000,0,0
lcubootAutoDevCreate "/ikon7", 0xce0000,0x8000,136,3,1,0x0000,0,0
lcubootAutoDevCreate "/ikon8", 0xcdc000,0x8000,135,3,1,0x0000,0,0
lcubootAutoDevCreate "/ikon9", 0xcd8000,0x8000,134,3,1,0x0000,0,0
lcubootAutoDevCreate "/ikon10",0xcd4000,0x8000,133,3,1,0x0000,0,0
lcubootAutoDevCreate "/ikon11",0xcd0000,0x8000,132,3,1,0x0000,0,0
lcubootAutoDevCreate "/ikon12",0xccc000,0x8000,131,3,1,0x0000,0,0
lcubootAutoDevCreate "/ikon13",0xcc8000,0x8000,130,3,1,0x0000,0,0
lcubootAutoDevCreate "/ikon14",0xcc4000,0x8000,129,3,1,0x0000,0,0

ikonInterruptVerbose=1 /* for verbose interrupt logs */

ikonDevCreateRefMoveEnable=0 /* for implicit REF_MOVE during ikonDevCreate */

# ___oOo___
