#! /bin/sh
#******************************************************************************
#
# E.S.O. - VLT Project
# 
# "@(#) $Id: inmosDefineTermTEK.sh,v 1.14 2005/06/22 12:40:20 vltsccm Exp $"
#
# inmosDefineTermTEK.sh
#
# who        when      what
# ---------  --------  --------------------------------------------------------
# J.Ayasse   29/09/93  first release
# C.Cumani   04/08/94  adapted to VLT ESO standards
# C.Cumani   26/09/95  made compatible with CMM
#
#******************************************************************************
# NAME
# inmosDefineTermTEK.sh - define the TekXpress keyboard configuration, for the 
# Inmos editor inmosF.
#
# SYNOPSIS   
# inmosDefineTermTEK.sh
#
# DESCRIPTION
# This script is used to define the TekXpress keyboard configuration for the 
# Inmos editor inmosF.
#
# RETURN VALUES
# none
#
# CAUTIONS
# This script does not save keysym assignment for the keys which will be  
# modified by inmosDefineTermTEK.sh. 
#
# EXAMPLE
# source inmosDefineTermTEK.sh
#
# SEE ALSO
# inmosRestoreTermTEK.sh
#
#------------------------------------------------------------------------------
#/

# define modifier Mode_switch

xmodmap -e 'keycode 96 = Mode_switch'
xmodmap -e 'add Mod2 = Mode_switch'
xmodmap -e 'remove Control = Mode_switch'

# define keysyms for the Inmos editor f

xmodmap -e 'keysym F1  = F11 F11 Find F31'
xmodmap -e 'keysym F2  = F2  F12 F22 F32'
xmodmap -e 'keysym F3  = F3  F13 F23 Select'
xmodmap -e 'keysym F4  = F4  F4  F24 F34'
xmodmap -e 'keysym F5  = Menu  F15'
xmodmap -e 'keysym F6  = F6  F16'
xmodmap -e 'keysym F7  = F7  F1  F27 F25'
xmodmap -e 'keysym F8  = F8  F21 F28 F26'
xmodmap -e 'keysym F9  = F9  F5  F29 F35'
xmodmap -e 'keysym F10 = F10 F33 F30 F14'

xmodmap -e 'keysym Num_Lock = Escape'
xmodmap -e 'keysym KP_0 = KP_F1'
xmodmap -e 'keysym KP_Decimal = KP_F2'
xmodmap -e 'keysym KP_8 = Up'
xmodmap -e 'keysym KP_2 = Down'
xmodmap -e 'keysym KP_4 = Left  KP_4 KP_F3'
xmodmap -e 'keysym KP_6 = Right KP_6 KP_F4'

xmodmap -e 'keysym KP_1 = End'
xmodmap -e 'keysym KP_7 = Insert'
xmodmap -e 'keysym KP_9 = Prior'
xmodmap -e 'keysym KP_3 = Next' 

# __oOo__

