#******************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: lcc.boot,v 4.97.1.1 2005/10/24 13:56:57 vltsccm Exp $"
#
# VxWorks script for automatic installation of lcc module
#
# who       when      what
# --------  --------  ----------------------------------------------
# bgustafs 2005-09-21 changed documentation of lccReadDbSignal
# bgustafs 2005-04-21 set lccReadDbSignal to make it possible not to read 
#                     signals when reading db attributes, SPR20050048
# bgustafs 2002-05-17 added lccCmdStackSize
# bgustafs 2000-12-12 added documentation of configuration parameters
# bgustafs  17/05/00  removed task spawn flag VX_STDIO (obsolete), SPR20000134
# ssandroc  24.04.1995 created
# bgustafs  07/12/95   lccMapNameNumber modified
# bgustafs  11/03/96   modified stack for lccInitAll
# bgustafs  15/03/96   added lccEvtDiscardDN/DT and lccLogDiscardDN/DT
# bgustafs  03/05/96   increased stack size of lccInitAll
# bgustafs  18/09/96   increased lccMapNameNumber
# imunoz    22.01.97   added definition for lccSnapshotDb
# imunoz    26.08.97   added definition for lccHwWdTimeout
# bgustafs  21/09/98   set shell priority to 65
# bgustafs  22/04/99   filter error logs as default
#

# Loading and initialisation of LCC Common Software
# Configurable parameters are initialised with default values except
# path of database to be loaded at boot time.

lcubootAutoLoad 1,"lcc"

#
# LCC configurable parameters. Reboot after changing any of these parameters.
#
# Size of input message queue for events and alarms (no of events) to lccEvent
lccEventQueueSize  = 200
# Size of input message queue for logs (no of logs) to lccLogger
lccLogQueueSize    = 200
# Size of input message queue for error logs (no of bytes) to lccLogger. Errors
# are discarded when buffer overflows
lccErrorBufferSize = 15000
# Size of input message queue for processes registered with ccsInit 
# (no of messages)
lccMsgQueueSize    = 200
# Maximum number of names (points, aliases and attributes) defined in the
# database
lccMapNameNumber   = 6000
# Timer to be used for sampling rates faster than one VxWorks tick
lccSamplingTimer   = 2
# Timer to be used for timerSleep function
lccSleepTimer      = 1
# Interval (seconds) for testing hardware device probe address
lccDevicePollTime  = 10
# Time-out for replies from device control processes
lccDeviceTimeOut   = 5
# Maximum number of identical events/alarms taken into account during the 
# interval defined by lccEvtDiscardDT (seconds). A value of zero of 
# lccEvtDiscardDN or lccEvtDiscardDT means that all events/alarms are processed
lccEvtDiscardDN    = 0
lccEvtDiscardDT    = 0
# Maximum number of identical errors taken into account during the 
# interval defined by lccLogDiscardDT (seconds). A value of zero of 
# lccLogDiscardDN or lccLogDiscardDT means that all errors are processed
lccLogDiscardDN    = 10
lccLogDiscardDT    = 2
# Timeout for the hardware watchdog timer (seconds). Valid values are 0 and 
# between 5 and 13. Value zero disables the watchdog timer.
lccHwWdTimeout     = 13
# Default stack size of task spawned by a command. If set to zero then the 
# default size of 50000 will be used. The size should not be less than 15000.
# Be careful not to get stack overflow. Check with checkStack()
lccCmdStackSize    = 50000
# If a database attribute corresponds to an input signal, then a call to dbReadSymbolic
# will actually not only read the database value but instead the actual hardware signal
# if this variable is set to ccsTRUE (= 1). This is the default. Any other value will 
# disable this functionality
lccReadDbSignal = 1

strcpy &lccBootDir, getenv("BOOTHOME")
strcpy &lccBootDatabase, getenv("BOOTDB")
strcpy &lccLoggingFile, getenv("LOGFILE")
strcpy &lccSnapshotDb, "lccSnapshot.db"

shellTaskPriority=65

lcubootAutoSpawn 1,"tlccInitAll",100,0x8,60000,"lccInitAll"
lcubootAutoExec 1,"lccWaitInit"

lcubootAutoLccRegisterDevs /* register all devices previously installed */

lcubootAutoExec 1,"lccNfsCheck"

# ___oOo___
