#******************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: ntp.boot,v 1.37 2002/03/30 21:48:42 vltsccm Exp $"
#
#   NAME
#	ntp.boot - module boot script for ntp module
# 
#   SYNOPSIS
#	lcubootAutoCdBoot 1,"ntp.boot"
#       < ntp.boot
# 
#   DESCRIPTION
#	Standard boot-script for loading and initialization the ntp
#	module into an LCU. If all goes OK a client NTP daemon must
#	be spawned.
#	At start-up the daemon looks for the NTP configuration file (ntp.conf)
#	under $BOOTHOME. If the file it's not there then the file it's 
#	search under $VLTDATA/config. The file must exist in at least one
#	of those locations.
#	By default $VLTDATA/config/ntp.conf define as time server
#	the machine where the ntp module was build.
#	Specific applications could use customized ntp.conf files providing
#	one into the directory of the environment ($BOOTHOME).
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#	The file "ntp.conf" must exists in at least one of the following
#	directories:	$VLTDATA/config
#			$BOOTHOME/
#	First it's search the BOOTHOME directory.
#	The ntp.conf under $VLTDATA/config it's used by all the LCUs
#	booting from the same workstation. Any change into 
#	$VLTDATA/config/ntp.conf will affect all those LCUs.
#
#   EXAMPLES
#
#   SEE ALSO
#	xntpd(1M), lcubootAutoCdBoot(1)
#
#   BUGS     
#
#------------------------------------------------------------------------
lcubootAutoLoad 1,"ntp"
lcubootAutoExec 1,"ntpStart",-1,-1,-1,-1 /* ntpdate and ntpd stuff */
