#! /bin/sh
#******************************************************************************
#
# E.S.O. - VLT Project
# 
# "@(#) $Id: inmosRestoreTermHP.sh,v 1.14 2005/06/22 12:40:22 vltsccm Exp $"
#
# inmosRestoreTermHP.sh
#
# who        when      what
# ---------  --------  --------------------------------------------------------
# J.Ayasse   29/09/93  first release
# C.Cumani   04/08/94  adapted to VLT ESO standards
# C.Cumani   26/09/95  made compatible with CMM
#
#******************************************************************************
# NAME
# inmosRestoreTermHP.sh - restore the standard HP keyboard configuration.
#
# SYNOPSIS   
# inmosRestoreTermHP.sh
#
# DESCRIPTION
# This script is used to restore the standard HP keyboard configuration,
# which has been modified with inmosDefineTermHP.sh.
#
# RETURN VALUES
# none
#
# CAUTIONS
# This script makes the standard keysym assignment for the keys which have been
# modified by inmosDefineTermHP.sh. The configuration before inmosDefineTermHP 
# was run is not restored.
#
# EXAMPLE
# source inmosRestoreTermHP.sh
#
# SEE ALSO
# inmosDefineTermHP.sh
#
#------------------------------------------------------------------------------
#/

# restore modifiers

xmodmap -e 'remove Mod2 = Mode_switch'
xmodmap -e 'keycode 66 = Alt_R'
xmodmap -e 'add Mod1 = Alt_R'

# restore keysyms

xmodmap -e 'keycode 16 = F1'
xmodmap -e 'keycode 24 = F2'
xmodmap -e 'keycode 32 = F3'
xmodmap -e 'keycode 40 = F4'
xmodmap -e 'keycode 48 = F5'
xmodmap -e 'keycode 56 = F6'
xmodmap -e 'keycode 64 = F7'
xmodmap -e 'keycode 72 = F8'
xmodmap -e 'keycode 80 = F9 KP_F1'
xmodmap -e 'keycode 88 = F10 KP_F2'

xmodmap -e 'keycode 114 = KP_1 End'
xmodmap -e 'keycode 116 = KP_4 Left'
xmodmap -e 'keycode 117 = KP_7 Home'
xmodmap -e 'keycode 121 = KP_0 Insert'
xmodmap -e 'keycode 122 = KP_Decimal Delete'
xmodmap -e 'keycode 123 = KP_2 Down'
xmodmap -e 'keycode 125 = KP_6 Right'
xmodmap -e 'keycode 126 = KP_8 Up'
xmodmap -e 'keycode 127 = Num_Lock'
xmodmap -e 'keycode 131 = KP_3 Next'
xmodmap -e 'keycode 134 = KP_9 Prior'

# __oOo__
