#! /bin/sh
#******************************************************************************
#
# E.S.O. - VLT Project
# 
# "@(#) $Id: inmosRestoreTermTEK.sh,v 1.14 2005/06/22 12:40:22 vltsccm Exp $"
#
# inmosRestoreTermTEK.sh
#
# who        when      what
# ---------  --------  --------------------------------------------------------
# J.Ayasse   29/09/93  first release
# C.Cumani   04/08/94  adapted to VLT ESO standards
# C.Cumani   26/09/95  made compatible with CMM
#
#******************************************************************************
# NAME
# inmosRestoreTermTEK.sh - restore the standard TekXpress keyboard configuration.
#
# SYNOPSIS   
# inmosRestoreTermTEK.sh
#
# DESCRIPTION
# This script is used to restore the standard TekXpress keyboard configuration,
# which has been modified with inmosDefineTermTEK.sh.
#
# RETURN VALUES
# none
#
# CAUTIONS
# This script makes the standard keysym assignment for the keys which have been
# modified by inmosDefineTermTEK.sh. The configuration before inmosDefineTermTEK
# was run is not restored.
#
# EXAMPLE
# source inmosRestoreTermTEK.sh
#
# SEE ALSO
# inmosDefineTermTEK.sh
#
#------------------------------------------------------------------------------
#/

# restore modifiers

xmodmap -e 'remove Mod2 = Mode_switch'
xmodmap -e 'keycode 96 = Control_R'
xmodmap -e 'add Control = Control_R'

# restore keysyms

xmodmap -e 'keycode 15 = F1'
xmodmap -e 'keycode 23 = F2'
xmodmap -e 'keycode 31 = F3'
xmodmap -e 'keycode 39 = F4'
xmodmap -e 'keycode 47 = F5'
xmodmap -e 'keycode 55 = F6'
xmodmap -e 'keycode 63 = F7'
xmodmap -e 'keycode 71 = F8'
xmodmap -e 'keycode 79 = F9'
xmodmap -e 'keycode 87 = F10'

xmodmap -e 'keycode 113 = KP_1'
xmodmap -e 'keycode 115 = KP_4'
xmodmap -e 'keycode 116 = KP_7'
xmodmap -e 'keycode 120 = KP_0'
xmodmap -e 'keycode 121 = KP_Decimal'
xmodmap -e 'keycode 122 = KP_2'
xmodmap -e 'keycode 124 = KP_6'
xmodmap -e 'keycode 125 = KP_8 '
xmodmap -e 'keycode 126 = Num_Lock'
xmodmap -e 'keycode 130 = KP_3'
xmodmap -e 'keycode 133 = KP_9'

# __oOo__
