#******************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: mcon.boot,v 2.35 2003/11/11 13:40:40 vltsccm Exp $"
#
# VxWorks script for automatic installation of driver and devices
#
# who       when       what
# --------  ---------- ----------------------------------------------
# ssandroc  24.04.1995 created
#

#
# standard driver installation procedure
# -> detect for physical device on VME bus at 
#    address 0xC<b+1>2<c<<1>00 in A24 domain
#    where : <b> is the board number [0..6]
#            <c> is the channel number on the board [0..3] 
#
mconN = lcubootAutoDevRegister("/mcon0", 0x3d,0xc12000,2,1,1)
mconN = lcubootAutoDevRegister("/mcon1", 0x3d,0xc12200,2,1,1)
mconN = lcubootAutoDevRegister("/mcon2", 0x3d,0xc12400,2,1,1)
mconN = lcubootAutoDevRegister("/mcon3", 0x3d,0xc12600,2,1,1)
mconN = lcubootAutoDevRegister("/mcon4", 0x3d,0xc22000,2,1,1)
mconN = lcubootAutoDevRegister("/mcon5", 0x3d,0xc22200,2,1,1)
mconN = lcubootAutoDevRegister("/mcon6", 0x3d,0xc22400,2,1,1)
mconN = lcubootAutoDevRegister("/mcon7", 0x3d,0xc22600,2,1,1)
mconN = lcubootAutoDevRegister("/mcon8", 0x3d,0xc32000,2,1,1)
mconN = lcubootAutoDevRegister("/mcon9", 0x3d,0xc32200,2,1,1)
mconN = lcubootAutoDevRegister("/mcon10",0x3d,0xc32400,2,1,1)
mconN = lcubootAutoDevRegister("/mcon11",0x3d,0xc32600,2,1,1)
mconN = lcubootAutoDevRegister("/mcon12",0x3d,0xc42000,2,1,1)
mconN = lcubootAutoDevRegister("/mcon13",0x3d,0xc42200,2,1,1)
mconN = lcubootAutoDevRegister("/mcon14",0x3d,0xc42400,2,1,1)
mconN = lcubootAutoDevRegister("/mcon15",0x3d,0xc42600,2,1,1)
mconN = lcubootAutoDevRegister("/mcon16",0x3d,0xc52000,2,1,1)
mconN = lcubootAutoDevRegister("/mcon17",0x3d,0xc52200,2,1,1)
mconN = lcubootAutoDevRegister("/mcon18",0x3d,0xc52400,2,1,1)
mconN = lcubootAutoDevRegister("/mcon19",0x3d,0xc52600,2,1,1)
mconN = lcubootAutoDevRegister("/mcon20",0x3d,0xc62000,2,1,1)
mconN = lcubootAutoDevRegister("/mcon21",0x3d,0xc62200,2,1,1)
mconN = lcubootAutoDevRegister("/mcon22",0x3d,0xc62400,2,1,1)
mconN = lcubootAutoDevRegister("/mcon23",0x3d,0xc62600,2,1,1)

#
# standard driver installation procedure
# -> install driver
#
lcubootAutoDrvInstall "mcon"

#
# standard driver installation procedure
# -> create MCON devices with interrupts level 1 
#    vectors [0xA0..0xFE] but 0xAF,0xBF,0xCF,0xDF,0xEF
#    * AnswerReady   : vector = 0x<A+b><4*c>
#    * DriveFault    : vector = 0x<A+b><4*c+1>
#    * MotionEnd     : vector = 0x<A+b><4*c+2>
#    * EmergencyStop : vector = 0x<A+b>3
#
#    where : <b> is the board number [0..6]
#            <c> is the channel number on the board [0..3] 
#
lcubootAutoDevCreate "/mcon0", 0xc10000,1,1,0xa0,0xa1,0xa2,0xa3,1,0
lcubootAutoDevCreate "/mcon1", 0xc10000,2,1,0xa4,0xa5,0xa6,0xa3,1,0
lcubootAutoDevCreate "/mcon2", 0xc10000,3,1,0xa8,0xa9,0xaa,0xa3,1,0
lcubootAutoDevCreate "/mcon3", 0xc10000,4,1,0xac,0xad,0xae,0xa3,1,0
lcubootAutoDevCreate "/mcon4", 0xc20000,1,2,0xb0,0xb1,0xb2,0xb3,1,0
lcubootAutoDevCreate "/mcon5", 0xc20000,2,2,0xb4,0xb5,0xb6,0xb3,1,0
lcubootAutoDevCreate "/mcon6", 0xc20000,3,2,0xb8,0xb9,0xba,0xb3,1,0
lcubootAutoDevCreate "/mcon7", 0xc20000,4,2,0xbc,0xbd,0xbe,0xb3,1,0
lcubootAutoDevCreate "/mcon8", 0xc30000,1,3,0xc0,0xc1,0xc2,0xc3,1,0
lcubootAutoDevCreate "/mcon9", 0xc30000,2,3,0xc4,0xc5,0xc6,0xc3,1,0
lcubootAutoDevCreate "/mcon10",0xc30000,3,3,0xc8,0xc9,0xca,0xc3,1,0
lcubootAutoDevCreate "/mcon11",0xc30000,4,3,0xcc,0xcd,0xce,0xc3,1,0
lcubootAutoDevCreate "/mcon12",0xc40000,1,4,0xd0,0xd1,0xd2,0xd3,1,0
lcubootAutoDevCreate "/mcon13",0xc40000,2,4,0xd4,0xd5,0xd6,0xd3,1,0
lcubootAutoDevCreate "/mcon14",0xc40000,3,4,0xd8,0xd9,0xda,0xd3,1,0
lcubootAutoDevCreate "/mcon15",0xc40000,4,4,0xdc,0xdd,0xde,0xd3,1,0
lcubootAutoDevCreate "/mcon16",0xc50000,1,5,0xe0,0xe1,0xe2,0xe3,1,0
lcubootAutoDevCreate "/mcon17",0xc50000,2,5,0xe4,0xe5,0xe6,0xe3,1,0
lcubootAutoDevCreate "/mcon18",0xc50000,3,5,0xe8,0xe9,0xea,0xe3,1,0
lcubootAutoDevCreate "/mcon19",0xc50000,4,5,0xec,0xed,0xee,0xe3,1,0
lcubootAutoDevCreate "/mcon20",0xc60000,1,6,0xf0,0xf1,0xf2,0xf3,1,0
lcubootAutoDevCreate "/mcon21",0xc60000,2,6,0xf4,0xf5,0xf6,0xf3,1,0
lcubootAutoDevCreate "/mcon22",0xc60000,3,6,0xf8,0xf9,0xfa,0xf3,1,0
lcubootAutoDevCreate "/mcon23",0xc60000,4,6,0xfc,0xfd,0xfe,0xf3,1,0

#
# spawn MCON interrupt handler task
# -> priority is 20
#
lcubootAutoSpawn mconN,"tintMCON",20,0x8,2000,"mconInt"

# ___oOo___
