#******************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: net01.boot.PPC604,v 1.6 2003/03/13 15:51:52 vltsccm Exp $"
#
# who       when       what
# --------  ---------- ----------------------------------------------
# ssandroc  07.04.1997 created
#

# Note: indentations are done for proper man-page generation!

#********************************************************************
# NAME
# net01.boot - automatic installation of NAT NET01 boards

# DESCRIPTION
# This script installs up to 2 NET01 boards.

# ADDRESS PROBING AND LOADING
# This allows for automatic installation. If rigid checking is needed,
# then use direct calls instead of indirect way via lcuboot.

  net01N = lcubootAutoProbe(0xfad00000,0xfad80000)
  lcubootAutoLoad net01N>0,"net01"

# PORT ATTACHING
# This integrates the driver into the VxWorks system.

  lcubootAutoExec net01N>0, "natAttach",0,0xfad00000,0xc0,3
  lcubootAutoExec net01N>1, "natAttach",1,0xfad80000,0xc1,3

# SUBNET MASK SETTING
# The default value is good for whole ESO, elsewhere it may be different.

  lcubootAutoExec net01N>0, "ifMaskSet","nat0",0xffffff00
  lcubootAutoExec net01N>1, "ifMaskSet","nat1",0xffffff00

# IP ADDRESS SETTING
# They are taken from environment variables.

  lcubootAutoExec net01N>0, "ifAddrSet","nat0",getenv("LOCALIPADDRESS_1")
  lcubootAutoExec net01N>1, "ifAddrSet","nat1",getenv("LOCALIPADDRESS_2")

#********************************************************************
