#******************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: rmn_ppc.boot,v 1.12 2002/04/29 08:36:15 vltsccm Exp $"
#
# VxWorks script for automatic installation of driver and devices
#
# who      when       what
# -------- --------   ----------------------------------------------
# mverola  01/08/97   created
# fcarbogn 14/06/00   Base Address 0x0a000000, interrupt level from 4 to 5
#		      corrected wrong A24 configuration on lcubootAutoDevCreate
# bgustafs 07/03/01   modified interrupt numbers to be able to use more than 3 mac4
# bgustafs 21/06/01   Changed base address for A32 to 0x09000000, SPR20010314
# pduhoux  2002-04-04 Changed base address for A32 to 0x12000000, SPR20020204
#

#
# NOTE: 
# =====
# On Single CPU Systems, based on MVME167, 
#   the base address shall be set to 0x09000000
#   RMN seen at 0x17000000 on Master
#   RMN seen at 0x11000000 on Slave
# For the Dual CPU Systems of the Delays Lines, based on MVME167 and MVME162,
#   the base address shall be set to 0x0A000000
#   RMN seen at 0x17000000 on Master
#   RMN seen at 0x12000000 on Slave
#
# On Single and Dual CPU Systems, based on MVME2600, 
#   RMN seen at 0x20000000
#
# This file MUST be accordingly modified locally in the environment directory.
#

# check if "/rmnX" is present in the system and register it:
# A32 configuration
rmnN = lcubootAutoDevRegister("/rmn0",0x0d,0x12000001,1,1,1)
rmnN = lcubootAutoDevRegister("/rmn1",0x0d,0x12400001,1,1,1)
rmnN = lcubootAutoDevRegister("/rmn2",0x0d,0x12800001,1,1,1)
rmnN = lcubootAutoDevRegister("/rmn3",0x0d,0x12C00001,1,1,1)

# A24 configuration
#rmnN = lcubootAutoDevRegister("/rmn0",0x3d, 0x000001,1,1,1)
#rmnN = lcubootAutoDevRegister("/rmn1",0x3d, 0x100001,1,1,1)

# install the driver if any devices were found:
lcubootAutoDrvInstall "rmn"

# install device "/rmnX" if present:
# A32 configuration - 256 KB memory option
lcubootAutoDevCreate "/rmn0",32,0x12000000,256,0x74,5
lcubootAutoDevCreate "/rmn1",32,0x12400000,256,0x7C,5
lcubootAutoDevCreate "/rmn2",32,0x12800000,256,0xE0,5
lcubootAutoDevCreate "/rmn3",32,0x12C00000,256,0xE4,5

# A24 configuration - 256 KB memory option
#lcubootAutoDevCreate "/rmn0",24,0x000000,256,0x74,5
#lcubootAutoDevCreate "/rmn1",24,0x100000,256,0x7C,5

# ___oOo___
