#******************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: tim.boot,v 3.12 2005/07/26 08:51:42 vltsccm Exp $"
#
# VxWorks script for automatic installation of driver and devices
#
# who       when       what
# --------  ---------- ----------------------------------------------
# ssandroc  24.04.1995 created
#

#
# set boot task priority to 100
# -> lower priority than tintTIM
#    so that tintTIM is scheduled on interrupt during boot
# set other system task priorities
# set System Clock rate to 100 ticks/second
# 
taskPrioritySet(taskNameToId("tEvtTask"),4)
taskPrioritySet(taskNameToId("tRlogind"),5)
taskPrioritySet(taskNameToId("tLogTask"),70)
taskPrioritySet(0,100)
shellTaskPriority = 80
spyTaskPriority = 5
sysClkRateSet(100)
#
# standard driver installation procedure
# -> detect for physical device on VME bus at address 0x0112 in Short IO domain
# -> install driver
# -> create TIM device with interrupts level 6 vector 128
#
timN = lcubootAutoDevRegister("/tim0",0x2d,0x0112,1,1,1)
lcubootAutoDrvInstall "tim"
lcubootAutoDevCreate "/tim0",0x0100,128,6
#
# spawn TIM interrupt handler task
# -> priority is 1 
#    no other task on LCU shall run at this priority
# 
lcubootAutoSpawn timN,"tintTIM",1,0x8,2000,"timInt"
#
# check TIM is generating interrupts
# -> schedule timer 1 shot after 500ms
#
lcubootAutoExec  timN,"timCheckInterruptLevel",0

#
# To use 10ms interrupt as sysclk timer:
#
# lcubootAutoExec  timN,"timClkInstall","/tim0"
# lcubootAutoExec  timN,"timClkEnable"

# ___oOo___
