#ifndef ACECCDRT_H
#define ACECCDRT_H
/*************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: aceccdRT.h,v 1.14 2000/01/13 13:26:50 vltsccm Exp $"
*
* aceccdRT.h
*
* who       when      what
* --------  --------  ----------------------------------------------
* ccumani   15/06/94  created
* ccumani   03/11/94  aceccdRTDIRECTION separated into 
*                     aceccdRTHORDIRECTION and aceccdRTVERDIRECTION 
* ccumani   26/09/95  made compatible with CMM
*/

/*************************************************************************
*  This file contains the definitions of the commands used by the 
*  LCU-Transputer Interface Readout Transmission routines.
*************************************************************************/

#include "aceccd.h"
#include "aceccdRC.h"

/*
 * Parameters for the aceccdRTGIVPARAM and aceccdRTSETPARAM commands
 */

/* BEGIN PARAMETERS */

/* STATUS: result of self check: bit 0 RAM, bit 1 Peltier, bit 3 port, bit 4 register */
#define aceccdRTSELFCHECK                 aceccdRCSELFCHECK

/* STATUS: last read and stored line per output */
#define aceccdRTLASTLINE                  aceccdRCLASTLINE

/* STATUS: next read line to be transmitted per output */
#define aceccdRTNEXTLINE                  aceccdRCNEXTLINE

/* CONFIGURATION: horizontal chips number in mosaic */
#define aceccdRTHCHIP                     aceccdRCHCHIP

/* CONFIGURATION: vertical chips number in mosaic */
#define aceccdRTVCHIP                     aceccdRCVCHIP

/* CONFIGURATION: horizontal pixels per chip */
#define aceccdRTHPIX                      aceccdRCHPIX

/* CONFIGURATION: horizontal prescan length per chip */
#define aceccdRTHPRESCAN                  aceccdRCHPRESCAN

/* CONFIGURATION: horizontal overscan per chip */
#define aceccdRTHOVERSCAN                 aceccdRCHOVERSCAN

/* CONFIGURATION: vertical lines per chip */
#define aceccdRTVLINES                    aceccdRCVLINES

/* CONFIGURATION: vertical prescan length per chip */
#define aceccdRTVPRESCAN                  aceccdRCVPRESCAN

/* CONFIGURATION: vertical overscan per chip */
#define aceccdRTVOVERSCAN                 aceccdRCVOVERSCAN

/* CONFIGURATION: outputs per chip */
#define aceccdRTNUMOUTPUTS                aceccdRCNUMOUTPUTS

/* CONFIGURATION: horizontal output location per chip */
#define aceccdRTOUTPUTHORLOC              aceccdRCOUTPUTHORLOC

/* CONFIGURATION: vertical output location per chip */
#define aceccdRTOUTPUTVERLOC              aceccdRCOUTPUTVERLOC

/* CONFIGURATION: ID of the output in the chip */
#define aceccdRTOUTPUTID                  aceccdRCOUTPUTID 

/* CONFIGURATION: output enabled or not */
#define aceccdRTOUTPUTENABLED             aceccdRCOUTPUTENABLED

/* CONFIGURATION: bits for pixel per output (ADC resolution) */
#define aceccdRTBITPIX                    aceccdRCBITPIX

/* CONFIGURATION: total horizontal pixels number per output */
#define aceccdRTOUTPUTTOTHOR              aceccdRCOUTPUTTOTHOR

/* CONFIGURATION: horizontal prescan per output */
#define aceccdRTOUTPUTHORPRE              aceccdRCOUTPUTHORPRE

/* CONFIGURATION: horizontal overscan per output */
#define aceccdRTOUTPUTHOROVER             aceccdRCOUTPUTHOROVER

/* CONFIGURATION: total vertical pixels number per output */
#define aceccdRTOUTPUTTOTVER              aceccdRCOUTPUTTOTVER

/* CONFIGURATION: vertical prescan per output */
#define aceccdRTOUTPUTVERPRE              aceccdRCOUTPUTVERPRE

/* CONFIGURATION: vertical overscan per output */
#define aceccdRTOUTPUTVEROVER             aceccdRCOUTPUTVEROVER

/* CONFIGURATION: performed horizontal readout direction per output */
#define aceccdRTHORDIRECTION              aceccdRCHORDIRECTION

/* CONFIGURATION: performed vertical readout direction per output */
#define aceccdRTVERDIRECTION              aceccdRCVERDIRECTION

/* CONFIGURATION: index of first connected output per board */
#define aceccdRTBOARDOUT1                 aceccdRCBOARDOUT1

/* CONFIGURATION: index of second connected output per board */
#define aceccdRTBOARDOUT2                 aceccdRCBOARDOUT2

/* CONFIGURATION: index of third connected output per board */
#define aceccdRTBOARDOUT3                 aceccdRCBOARDOUT3

/* CONFIGURATION: index of fourth connected output per board */
#define aceccdRTBOARDOUT4                 aceccdRCBOARDOUT4

/* CONFIGURATION: optional datalink used or not */
#define aceccdRTOPTLNK          (short)   100

/* CONFIGURATION: transputer-made byte swapping */
#define aceccdRTBYTESWAP        (short)   101

/* CONFIGURATION: send start readout command reply without data structure */
#define aceccdRTDATASTRUCTNOT   (short)   102

/* CONFIGURATION: start value for sinthetic image in simulation mode */
#define aceccdRTSIMSTARTVAL     (short)   103

/* CONFIGURATION: offset value between pixel values in simulation mode */
#define aceccdRTSIMOFFVAL       (short)   104

/* CONFIGURATION: timeout */
#define aceccdRTTIMEOUT                   aceccdRCTIMEOUT

/* SETUP: horizontal binning factor per window */
#define aceccdRTHBIN                      aceccdRCHBIN

/* SETUP: verical binning factor per window */
#define aceccdRTVBIN                      aceccdRCVBIN

/* SETUP: horizontal direction of first pixel per window */
#define aceccdRTWINDHORSTRT               aceccdRCWINDHORSTRT

/* SETUP: vertical direction of first pixel per window */
#define aceccdRTWINDVERSTRT               aceccdRCWINDVERSTRT

/* SETUP: horizontal direction of last pixel per window */
#define aceccdRTWINDHORSTOP               aceccdRCWINDHORSTOP

/* SETUP: vertical direction of last pixel per window */
#define aceccdRTWINDVERSTOP               aceccdRCWINDVERSTOP

/* SETUP: current size of window array per window */
#define aceccdRTWNDCNT                    aceccdRCWNDCNT

/* SETUP: readout of window enabled */
#define aceccdRTWINENABLE                 aceccdRCWINENABLE

/* END PARAMETERS */


/* LCU ONLY - BEGIN *****************************************************
 */


/*
 * Define command codes with bitwise inclusive OR operator |
 */

/**************************
 * High priority commands *
 **************************/

 /* reset readout transmission
    Parameters: NONE 
    Reply: error/ok message - sends aceccdRCRESET */
#define aceccdRTRESET     (long)                                 \
   (((long) acecomHIPRI << 24) | ((long) aceccdRDOUTRANSM << 16) \
   | ((long) acecomRESET))

 /* break readout transmission
    Parameters: NONE 
    Reply: error/ok message - sends aceccdRCBREAK */
#define aceccdRTBREAK     (long)                                 \
   (((long) acecomHIPRI << 24) | ((long) aceccdRDOUTRANSM << 16) \
   | ((long) acecomBREAK))


/*********************************
 * Low priority command type IDs *
 *********************************/

 /* initialize readout transmission
    Parameters: self test configuration aceccdON or aceccdOFF
    Reply: if error: error message - if ok: sends aceccdRCINIT */
#define aceccdRTINIT     (long)                                  \
   (((long) acecomLOPRI << 24) | ((long) aceccdRDOUTRANSM << 16) \
   | ((long) acecomINIT))

 /* receive parameter from readout transmission
    Parameters: parameter code(s), array index (if needed)
    Reply: error/ok message, if ok the parameter code(s) and value(s) follow */
#define aceccdRTGIVPARAM     (long)                              \
   (((long) acecomLOPRI << 24) | ((long) aceccdRDOUTRANSM << 16) \
   | ((long) acecomGIVPARAM))

 /* send params to readout transmission
    Parameters: param. code(s), array index (if needed), parameter value(s)
    Reply: error/ok message */
#define aceccdRTSETPARAM     (long)                              \
   (((long) acecomLOPRI << 24) | ((long) aceccdRDOUTRANSM << 16) \
   | ((long) acecomSETPARAM))

 /* read readout transmission status
    Parameters: NONE
    Reply: error/ok message, if ok status value follows */
#define aceccdRTSTATUS     (long)                                \
   (((long) acecomLOPRI << 24) | ((long) aceccdRDOUTRANSM << 16) \
   | ((long) acecomSTATUS))

 /* switch into/return from simulation mode
    Parameters: aceccdNORMAL or aceccdSIMULATION
    Reply: if error: error message - if ok: sends aceccdRCSIM */
#define aceccdRTSIM        (long)                                \
   (((long) acecomLOPRI << 24) | ((long) aceccdRDOUTRANSM << 16) \
   | ((long) acecomSIMUL))

 /* put readout transmission in standby mode 
    Parameters: NONE
    Reply: if error: error message - if ok: sends aceccdRCSTANDBY */
#define aceccdRTSTANDBY     (long)                               \
   (((long) acecomLOPRI << 24) | ((long) aceccdRDOUTRANSM << 16) \
   | ((long) acecomSTANDBY))

 /* stop repeated command 
    Parameters: command to be stopped 
    Reply: if error: error message - if ok: sends aceccdRCCOMMSTOP */
#define aceccdRTCOMMSTOP     (long)                              \
   (((long) acecomLOPRI << 24) | ((long) aceccdRDOUTRANSM << 16) \
   | ((long) aceccdCOMMSTOP))

 /* read image on dedicated link
    Parameters: NONE 
    Reply: if error: error message - if ok: sends aceccdRCREADIMAGE */
#define aceccdRTREADIMAGE     (long)                             \
   (((long) acecomLOPRI << 24) | ((long) aceccdRDOUTRANSM << 16) \
   | ((long) aceccdREADIMAGE))

 /* read image rows on dedicated link
    Parameters: number of rows
    Reply: if error: error message - if ok: sends aceccdRCREADROW */
#define aceccdRTREADROW     (long)                               \
   (((long) acecomLOPRI << 24) | ((long) aceccdRDOUTRANSM << 16) \
   | ((long) aceccdREADROW))

 /* read image on the same command/reply link
    Parameters: NONE 
    Reply: if error: error message - if ok: sends aceccdRCREADIMAGELOCK */
#define aceccdRTREADIMAGELOCK   (long)                               \
   (((long) acecomLOCKLOPRI << 24) | ((long) aceccdRDOUTRANSM << 16) \
   | ((long) aceccdREADIMAGE))

 /* read image row the same command/reply link
    Parameters: number of rows
    Reply: if error: error message - if ok: sends aceccdRCREADROWLOCK */
#define aceccdRTREADROWLOCK     (long)                               \
   (((long) acecomLOCKLOPRI << 24) | ((long) aceccdRDOUTRANSM << 16) \
   | ((long) aceccdREADROW))


/* LCU ONLY - END *****************************************************
 */

#endif /*!ACECCDRT_H*/
