#ifndef ACESCI_H
#define ACESCI_H
/*************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: acesci.h,v 1.44 2000/01/14 08:52:57 vltsccm Exp $"
*
* acesci.h
*
* who       when      what
* --------  --------  ----------------------------------------------
* ccumani   20/06/95  - created from rreiss dspcmds.inc and ccdcmds.inc
*                       occam files 
*                     - acesciMOD_NAME, acesciMOD_DESC and 
*                       acesciVERSION_DATE definitions added
* ccumani   28/09/95  - made compatible with CMM
* ccumani   13/11/95  - acesciMAX.COM.LEN.BIG definition modified for
*                       compatibility with acetec module (aceccdRCPATTERN
*                       command)
* ccumani   07/02/96  - LCU constant names corrected
*                     - #include "aceccd.h" -> #include "acecom.h"
* ccumani   03/03/96  - acesciVERSION_DATE set to "FEB96"
* ccumani   21/05/96  - acesciVERSION_DATE set to "JUL96"
* ccumani   06/09/96  - acesciVERSION_DATE set to "NOV96"
* ccumani   02/12/96  - acesciVERSION_DATE set to "APR97"
* ccumani   18/03/97  - acesciVERSION_DATE set to "MAY97"
* ccumani   28/08/97  - acesciVERSION_DATE set to "NOV97"
*/

/*************************************************************************
*  This file contains definitions used by the acesci module.
*  The corresponding occam .inc file MUST be produced from
*  the present file using the utility acecomH2Inc
*************************************************************************/

#include "aceccd.h"
#include "acesciErrors.h"

/* max number of CCD and ADC */
#define acesciMAX_CCD             1
#define acesciNUM_ADC             4

/* number of channel in DSP handler */
#define acesciDHCHAN              3

/* max command length in short and byte dim */
#define acesciMAX_COM_LEN_SMAL    64
#define acesciMAX_COM_LEN_SMAL_2  (acesciMAX_COM_LEN_SMAL * 2)

/* max dsp length in short and byte dim */
#define acesciMAX_DSP_LEN         256

/* max big command length in short and byte dim */
#define acesciMAX_COM_LEN_BIG     (acesciMAX_DSP_LEN+3)
#define acesciMAX_COM_LEN_BIG_2   (acesciMAX_COM_LEN_BIG * 2)


/* LCU ONLY - BEGIN *****************************************************
 */

/*
 * Constants
 */
#define acesciMOD_NAME       "acesci"
#define acesciMOD_DESC       "Scientific CCDs Controller software module"
#define acesciVERSION        "$Revision: 1.44 $"
#define acesciVERSION_DATE   "FEB2000"

/*
 * Header files, used by utility functions
 */

#include "aceccdSH.h"
#include "aceccdRT.h"

/*
 * Local definitions, used by utility functions
 */

#define APPLICATION    "CCDTEST"
#define TIMEOUT        60000         /* timeout in milliseconds          */

#define FITSRECORD        36
#define BZERO          32768         /* data offset for FITS image       */
#define BITSPIX           16         /* bits per pixel                   */

/*
 * Function Prototypes
 */

ccsCOMPL_STAT acesciExpo ( void );
ccsCOMPL_STAT acesciFhdr ( FILE     *fp,
			   vltINT32  rows,
			   vltINT32  columns,
			   vltINT32  expTime );

ccsCOMPL_STAT acesciFtrl ( FILE *fp, vltINT32 imaBytes );

vltINT32      acesciNpix ( vltINT32 pixels, vltINT16 binning );

ccsCOMPL_STAT acesciVersion ( vltBYTES80 version );


/* LCU ONLY - END *****************************************************
 */


#endif /*!ACESCI_H*/
