#ifndef ACESCITL_H
#define ACESCITL_H
/*************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: acesciTL.h,v 1.44 2000/01/14 08:52:57 vltsccm Exp $"
*
* acesciTL.h
*
* who       when      what
* --------  --------  ----------------------------------------------
* ccumani   12/12/96  created
* ccumani   12/03/97  voltages splitted in different arrays
*/

/*************************************************************************
*  This file contains definitions used by the acesci module.
*  The corresponding occam .inc file MUST be produced from
*  the present file using the utility acecomH2Inc
*************************************************************************/

#include "acesci.h"
#include "aceccdTL.h"

/*
 * parameter IDs
 */
/* telemetry values */
#define acesciTLvalues 		(short) 201


/*
 * NOTES : 
 * 1) all the voltages must be expressed in hundredths of Volt
 * 2) the following arrays must be requested SEPARATELY, otherwise
 *    the reply buffer is not long enough
 */

/*
 * Elements of tlm.address[0]
 * READ ONLY
 */

#define AGND 	 00 
#define TENVOLT	 01 
#define VREF	 02 
#define VOFF	 03 
#define VAA.P	 04 
#define VA.P	 05 
#define VA.N	 06 
#define VAA.N	 07 
#define VCC	 08 
#define VDD.P	 09 
#define VDD.N	 10 
#define SPARE	 11 
#define HEATER	 12 
#define REFTMP	 13 
#define BRDTMP	 14 
#define DACREF	 15 

/*
 * Elements of tlm.address[1]
 * READ/WRITE
 * it must be 
 *       0 <= UDC00 <= 2550
 *       0 <= UDC01 <= 2550
 *       0 <= UDC02 <= 2550
 *       0 <= UDC03 <= 2550
 *   -1280 <= UDC04 <= 1270
 *   -1280 <= UDC05 <= 1270
 *   -1280 <= UDC06 <= 1270
 *   -1280 <= UDC07 <= 1270
 */

#define UDC00	 00 
#define UDC01	 01 
#define UDC02	 02 
#define UDC03	 03 
#define UDC04	 04 
#define UDC05	 05 
#define UDC06	 06 
#define UDC07	 07 

/*
 * Elements of tlm.address[2]
 * READ/WRITE
 * it must be 
 *   -1280 <= CLK<XX>_LOW < CLK<XX>_HIGH <= 1270
 */

#define   CLK00_LOW	 00 
#define   CLK00_HIGH	 01 
#define   CLK01_LOW	 02 
#define   CLK01_HIGH	 03 
#define   CLK02_LOW	 04 
#define   CLK02_HIGH	 05 
#define   CLK03_LOW	 06 
#define   CLK03_HIGH	 07 
#define   CLK04_LOW	 08 
#define   CLK04_HIGH	 09 
#define   CLK05_LOW	 10 
#define   CLK05_HIGH	 11 
#define   CLK06_LOW	 12 
#define   CLK06_HIGH	 13 
#define   CLK07_LOW	 14 
#define   CLK07_HIGH	 15 
#define   CLK08_LOW	 16 
#define   CLK08_HIGH	 17 
#define   CLK09_LOW	 18 
#define   CLK09_HIGH	 19 
#define   CLK10_LOW	 20 
#define   CLK10_HIGH	 21 
#define   CLK11_LOW	 22 
#define   CLK11_HIGH	 23 
#define   CLK12_LOW	 24 
#define   CLK12_HIGH	 25 
#define   CLK13_LOW	 26 
#define   CLK13_HIGH	 27 
#define   CLK14_LOW	 28 
#define   CLK14_HIGH	 29 
#define   CLK15_LOW	 30 
#define   CLK15_HIGH	 31 
#define   CLK16_LOW	 32 
#define   CLK16_HIGH	 33 
#define   CLK17_LOW	 34 
#define   CLK17_HIGH	 35 
#define   CLK18_LOW	 36 
#define   CLK18_HIGH	 37 
#define   CLK19_LOW	 38 
#define   CLK19_HIGH	 39 
#define   CLK20_LOW	 40 
#define   CLK20_HIGH	 41 
#define   CLK21_LOW	 42 
#define   CLK21_HIGH	 43 
#define   CLK22_LOW	 44 
#define   CLK22_HIGH	 45 
#define   CLK23_LOW	 46 
#define   CLK23_HIGH	 47 

/* LCU ONLY - BEGIN *****************************************************
 */


/* LCU ONLY - END *****************************************************
 */


#endif /*!ACESCITL_H*/
