#ifndef ACRO_H
#define ACRO_H
/******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: acro.h,v 1.31 2005/10/11 09:06:49 vltsccm Exp $" 
*
* acro.h  - This is the interface file for the LCU Acromag device driver which 
*           forms a module of the VLT software. It contains the declarations
*           user available constants, data types and variables as well as the
*           function prototypes.
*
* who       when      what
* --------  --------  ----------------------------------------------
* bgustafs 2002-04-19 Added function acroPulsebitMicrosecSet 
* ---v1.3---
* S.Sandrock 02.09.1994 updated comments, added acroVERSION and acroVersion,
*			added acroDevShow.
* ---v1.4---
* S.Sandrock 09.11.1994 Updated version to 1.4.1
* --v1.4.1-- 09.11.1994 ---RELEASED---
*/

#include "lcudrv.h"		/* Include common driver literals */
#include "acroCommands.h"	/* Include acro command definitions */
#include "acroErrors.h"		/* Include acro error codes and literals */
#include "lculog.h"             /* Include logging message system header file*/


#define acroVERSION	"@(#) acro $Revision: 1.31 $"


/*
 * acro driver provided functions
 */
int acroDrv ( int devices, int channels, int timeout );
int acroDevCreate ( char *name, void *baseAddr, int irNumber, int irLevel );
STATUS	acroPulsebitMicrosecSet (char *deviceName, int value);

/*
 * acro tool functions
 */
void acroVersion(void);
void acroDevShow(void);
void acroSt (int unitNumber);
void acroConfig (int unitNumber);
void acroReg (int unitNumber);
void acroErrorPrint (int unitNumber);
void acroSizeofPrint ( void );
void acroTbl ( void );

#endif /* !ACRO_H */
