#ifndef AIO_H
#define AIO_H
/******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: aio.h,v 1.33 2005/10/11 09:48:17 vltsccm Exp $" 
*
* aio.h  -  This is the interface file for the LCU AIO device driver which 
*           forms a module of the VLT software. It contains the declarations
*           user available constants, data types and variables as well as the
*           function prototypes.
*
* who        when       what
* ---------  ---------- ----------------------------------------------
* S.Sandrock 02.09.1994 changed version number
*/

#include "lcudrv.h"		/* Include common driver literals */
#include "aioCommands.h"	/* Include AIO command definitions */
#include "aioErrors.h"		/* Include AIO error codes and literals */


/*
 * Version number
 */
#define aioVERSION	"@(#) aio $Revision: 1.33 $"


/*
 * AIO driver provided functions
 */
int aioDrv(int devices, int channels, int aioeout);
int aioDevCreate(char *name, void *baseAddr, int irNumber, int irLevel,int id);


/*
 * AIO driver tool functions
 */
int aioVersion ( void );
int aioDevShow ( void );
int aioPrintRegs ( int unit );
int aioPrintDevice ( int unit );
int aioPrintChannel ( int fd );
int aioPrintError ( int errorCode );
int aioPrintCmd ( int cmdCode );


#endif /* !AIO_H */
