#ifndef AMPL_H
#define AMPL_H
/******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: ampl.h,v 1.13 2004/07/21 13:19:00 vltsccm Exp $" 
*
* ampl.h - This is the interface file for the LCU SERVO AMPLIFIER device 
*	   driver which forms a module of the VLT software. It contains the 
*	   declarations user available constants, data types and variables 
*	   as well as the function prototypes
*
* who        when       what
* ---------  ---------- ----------------------------------------------
* S.Sandrock 05.09.1994 Comments updated, added amplVersion and amplDevShow.
* ---v1.3---
* S.Sandrock 09.11.1994 Updated version to 1.3.1
* --v1.3.1-- 09.11.1994 ---RELEASED---
*/

#include "lcudrv.h"		/* include common driver literals   */
#include "amplCommands.h"	/* include AMPL command definitions */
#include "amplErrors.h"         /* include AMPL error codes and literals */
#include "lculog.h"


#define amplVERSION	"@(#) ampl $Revision: 1.13 $"


/*
 * AMPL driver provided functions
 */
int amplDrv(int devices, 
	    int channels, 
	    int timeout);
int amplDevCreate(char *name, 
		  void *baseAddr, 
		  int devNumber, 
		  int backplaneAddr);


/*
 * AMPL tools
 */
void amplVersion(void);
void amplDevShow(void);
STATUS amplReg (int axis);
STATUS amplStAmpli (int axis);
STATUS amplSt (int axis);
STATUS amplProbe (int axis);
void amplRegAll ( void );
void amplStAll ( void );
void amplTbl ( void );
void amplSizeofPrint ( void );
void amplErrorPrint (int err);

#endif /* !AMPL_H */
