#ifndef AMPL_COMMANDS_H
#define AMPL_COMMANDS_H
/******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: amplCommands.h,v 1.13 2004/07/21 13:19:00 vltsccm Exp $" 
*
* amplCommands.h - Contains literals of all defined commands and structure
*                  types for commands with multiple parameters
*
* who        when       what
* ---------  ---------- ----------------------------------------------
* T. EBERT   17/12/93   Two new commands added:
*			amplCMD_WRITE_DAC_OFFSET, amplCMD_READ_DAC_OFFSET
* S.Sandrock 05.09.1994 Comments updated, macros re-arranged.
*/


/*
 * Mode commands
 */
#define amplCMD_MODE_ZERO			101
#define amplCMD_MODE_HANDSET			102
#define amplCMD_MODE_NORMAL			103
#define amplCMD_MODE_DAC			104


/*
 * Read commands
 */
#define amplCMD_READ_MOTOR_CURRENT		201
#define amplCMD_READ_AMPLI_STATUS		202
#define amplCMD_READ_CHANNEL_STATUS		203
#define amplCMD_READ_DAC_OFFSET                 204

/*
 * Write commands
 */
#define amplCMD_WRITE_VELOCITY_REF		301
#define amplCMD_WRITE_MOTOR_CONNECT		302
#define amplCMD_WRITE_MOTOR_DISCONNECT		303
#define amplCMD_WRITE_MOTOR_CONNECT_LOWER	304
#define amplCMD_WRITE_MOTOR_DISCONNECT_LOWER	305
#define amplCMD_WRITE_MOTOR_CONNECT_UPPER	306
#define amplCMD_WRITE_MOTOR_DISCONNECT_UPPER	307
#define amplCMD_WRITE_DAC_OFFSET                308

/*
 * General Commands
 */
#define amplCMD_RESET				105
#define amplCMD_SET_TIMEOUT_TICK		1101
#define amplCMD_GET_TIMEOUT_TICK		1102
#define amplCMD_FREE_DEVICE			1201
#define amplCMD_BLOCK_SEMAPHORE			1202

#endif /* !AMPL_COMMANDS_H */
