#ifndef ARC_DRV_H
#define ARC_DRV_H

/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: arcdrv.h,v 1.14 2005/08/04 14:27:07 vltsccm Exp $"
*
* who       when        what
* --------  ----------  ----------------------------------------------
* pduhoux  2003-02-06  created
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */

#include "lcudrv.h"             /* Include common driver literals             */
#include "lculog.h"             /* Include logging message system header file */


/* The following piece of code alternates the linkage type to C for all 
functions declared within the braces, which is necessary to use the 
functions in C++-code.
*/

#ifdef __cplusplus
extern C {
#endif
    
/* module name */
#define arcdrvMODULE       "arcdrv"
#define arcdrvMODULE_NAME  "ARC TCCD Controller Driver"
 
/* module version */
#define arcdrvVERSION      "$Revision: 1.14 $"

/*************************************************
 *        Interrupt Service Routine Prototype
 *************************************************/
typedef void ( *arcdrvDataReadISR )( int pixelRead, int pixelInImage );

/*
 * arcdrv driver provided functions
 */
int arcdrvDrv       ( int devices, int channels, int timeout );
int arcdrvDevCreate ( char *devName, 
		      int pciBaseAddr, 
		      int boardNumber ); 

/*
 * arcdrv tool functions
 */
void arcdrvVersion     ( char *version );
void arcdrvDevShow     ( void );
void arcdrvSt          ( int unitNumber );
void arcdrvConfig      ( int unitNumber );
void arcdrvReg         ( int unitNumber );
void arcdrvErrorPrint  ( int unitNumber );
void arcdrvSizeofPrint ( void );
void arcdrvTbl         ( void );

#ifdef __cplusplus
}
#endif

#endif /*!ARCDRV_H*/
