#ifndef ARCDRV_COMMANDS_H
#define ARCDRV_COMMANDS_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: arcdrvCommands.h,v 1.14 2005/08/04 14:27:07 vltsccm Exp $"
*
* who       when        what
* --------  ----------  ----------------------------------------------
* vltuser5  2003-02-24  created
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */

/* The following piece of code alternates the linkage type to C for all 
functions declared within the braces, which is necessary to use the 
functions in C++-code.
*/

#ifdef __cplusplus
extern C {
#endif

/*
 * General commands
 */
#define arcdrvCMD_RST  0x201   /* Reset Controller                     */      

#define arcdrvCMD_SDA  0x202   /* SetDMA Address                    */      
/*  
 *   Parameter 1 : int *dmaAddress;
 */

#define arcdrvCMD_GDA  0x203   /* GetDMA Address                    */      
/*  
 *   Parameter 1 : int *dmaAddress;
 */

#define arcdrvCMD_CMA  0x204   /* Setup Controller master           */      
/*  
 *   Parameter 1 : select controller master
 *                 arcdrvBoard_TIM or
 *                 arcdrvBoard_UTL
 */

#define arcdrvCMD_CBA  0x205   /* Set Callback function on DMA transmission */
                               /* ready                                     */      
/*  
 *   Parameter 1 : arcdrvDataReadCB Pointer to Callback function;
 */

#define arcdrvCMD_DLD  0x206   /* Download PCI File                 */      
/*  
 *   Parameter 1 : int number of data;
 *   Parameter 2 : int start address; 
 *   Parameter 3 : int *pPciCode; 
 */

#define arcdrvCMD_DMS  0x207   /* Set DMA Blocksize                 */      
/*  
 *   Parameter 1 : DMA Blocksize;
 */

#define arcdrvCMD_PRG  0x208   /* Get Progress(read pixel count)   */      

/*
 * TCCD Simple Board commands
 */
#define arcdrvCMD_AEX  0x100   /* Abort Exposure                   */      
#define arcdrvCMD_CLR  0x101   /* Clear Array                      */
#define arcdrvCMD_LDA  0x103   /* Load Application                 */
/*  
 *   Parameter 1 : int applicationNumber;
 */

#define arcdrvCMD_MPP  0x105   /* Multi-Pinned Phase Mode          */
/*
 *   Parameter 1 : int mppMode;
 */

#define arcdrvCMD_POF  0x106   /* Power Off                        */
#define arcdrvCMD_PON  0x107   /* Power On                         */
#define arcdrvCMD_RCC  0x108   /* Read Controller Configuration    */
#define arcdrvCMD_RDI  0x109   /* Read Image                       */
#define arcdrvCMD_RDM  0x10A   /* Read Memory                      */
/*
 *   Parameter 1 : int type1Address;
 */

#define arcdrvCMD_RET  0x10B   /* Read Elapsed Time                */
#define arcdrvCMD_SB1  0x10C   /* Set Bias Number. CMD SBN with arg3 = 0x00564944 = VID */
/*
 *   Parameter 1 :   int videoOffsetBoardID;
 *   Parameter 2 :   int dacNumber;
 *   Parameter 3 :   int videoOffsetVoltage;
 */

#define arcdrvCMD_SB2  0x10D   /* Set Bias Number. CMD SBN with arg3 = 0x00434C4B = CLK */
/*
 *   Parameter 1 : int clockDriverInput;
 *   Parameter 2 : int clockDriverNumber;
 *   Parameter 3 : int clockDriverVoltage;
 */

#define arcdrvCMD_SBV  0x10E   /* Set Bias Voltage                 */
#define arcdrvCMD_SET  0x10F   /* Set Exposure Time                */
/*
 *   Parameter 1 : int exposureTime;
 */

#define arcdrvCMD_SEX  0x110   /* Start Exposure                   */
#define arcdrvCMD_SGN  0x111   /* Set Gain                         */
/*
 *   Parameter 1 : int gain;
 *   Parameter 2 : int speed;
 */

#define arcdrvCMD_SRM  0x112   /* Set Readout Mode - CDS or single */
/*
 *   Parameter 1 : int arrayResetMode;
 */

#define arcdrvCMD_SSP  0x113   /* Set Subarray Positions           */
/*
 *   Parameter 1 : int boxYOffset;
 *   Parameter 2 : int boxXOffset;
 *   Parameter 3 : int biasOffset;
 */

#define arcdrvCMD_SSS  0x114   /* Set Subarray Sizes               */
/*
 *   Parameter 1 : int biasWidth;
 *   Parameter 2 : int boxWidth;
 *   Parameter 3 : int boxHeight;
 */

#define arcdrvCMD_TDL  0x115   /* Test Data Link                   */
/*
 *   Parameter 1 : int data;    
 */

#define arcdrvCMD_WRM  0x116   /* Write Memory                     */

#define arcdrvCMD_SOS  0x11B   /* Select Output Source             */
/*
 *   int amplifier;
 */

#define arcdrvCMD_SPT  0x11C   /* Set Pass Through Mode            */
/*
 *   int passThroughMode;
 */

#define arcdrvCMD_IDL  0x11D   /* Set Idle Mode                    */
#define arcdrvCMD_ABR  0x11F   /* Abort readout                    */
#define arcdrvCMD_RRN  0x120   /* Read Revision                    */
#define arcdrvCMD_SLD  0x121   /* Shift down lines                 */
#define arcdrvCMD_SLU  0x122   /* Shift up lines                   */

#define arcdrvCMD_SBC  0x123   /* Set Column binning parameter     */
#define arcdrvCMD_SBR  0x124   /* Set Row binning parameter        */

#define arcdrvCMD_TEC  0x125   /* Switch Peltier Cooler            */
#define arcdrvCMD_RCT  0x126   /* Read CCD Temperature             */

#define arcdrvCMD_SCR  0x127   /* Set Image Rows                   */
#define arcdrvCMD_SCC  0x128   /* Set Image Cols                   */

#define arcdrvCMD_TBS  0x129   /* Test Byte Swapping               */
#define arcdrvCMD_SBS  0x12A   /* Set  Byte Swapping               */

#define arcdrvCMD_RDC  0x12B   /* Read Array                       */

#define arcdrvCMD_RCS  0x12C   /* Read Controller Status           */
#define arcdrvCMD_RIS  0x12D   /* Read Interface Status            */
#define arcdrvCMD_SDM  0x12E   /* Set Dither Mode                  */
#define arcdrvCMD_SNW  0x12F   /* Set Num Wipes                    */
#define arcdrvCMD_SBO  0x130   /* Set Bias Offsets                 */

/*
 * ---- Alternative Names ---
 */
#define  arcdrvCMD_ABORT_READOUT          arcdrvCMD_ABR 
#define  arcdrvCMD_ABORT_EXPOSURE         arcdrvCMD_AEX 
#define  arcdrvCMD_SET_CALLBACK           arcdrvCMD_CBA  
#define  arcdrvCMD_WIPE_CHIP              arcdrvCMD_CLR 
#define  arcdrvCMD_SET_MASTER             arcdrvCMD_CMA  
#define  arcdrvCMD_DOWNLOAD_PCI           arcdrvCMD_DLD  
#define  arcdrvCMD_GET_DMA_ADDRESS        arcdrvCMD_GDA  
#define  arcdrvCMD_SET_IDLE_MODE          arcdrvCMD_IDL 
#define  arcdrvCMD_LOAD_APPLICATION       arcdrvCMD_LDA 
#define  arcdrvCMD_SET_MPP_MODE           arcdrvCMD_MPP 
#define  arcdrvCMD_SET_POWER_OFF          arcdrvCMD_POF 
#define  arcdrvCMD_SET_POWER_ON           arcdrvCMD_PON 
#define  arcdrvCMD_GET_PROGRESS           arcdrvCMD_PRG 
#define  arcdrvCMD_READ_CONFIGURATION     arcdrvCMD_RCC 
#define  arcdrvCMD_READ_TIM_STATUS        arcdrvCMD_RCS
#define  arcdrvCMD_READ_PMC_STATUS        arcdrvCMD_RIS
#define  arcdrvCMD_READ_TEMPERATURE       arcdrvCMD_RCT 
#define  arcdrvCMD_READ_ARRAY             arcdrvCMD_RDC 
#define  arcdrvCMD_READ_IMAGE             arcdrvCMD_RDI 
#define  arcdrvCMD_READ_MEMORY            arcdrvCMD_RDM 
#define  arcdrvCMD_GET_ELAPSED_TIME       arcdrvCMD_RET
#define  arcdrvCMD_GET_REVISION           arcdrvCMD_RRN
#define  arcdrvCMD_RESET                  arcdrvCMD_RST 
#define  arcdrvCMD_SET_VIDEO_BIAS         arcdrvCMD_SB1 
#define  arcdrvCMD_SET_CLOCK_BIAS         arcdrvCMD_SB2 
#define  arcdrvCMD_SET_BYTE_SWAPPING      arcdrvCMD_SBS 
#define  arcdrvCMD_SET_BINNING_COL        arcdrvCMD_SBC
#define  arcdrvCMD_SET_BINNING_ROW        arcdrvCMD_SBR
#define  arcdrvCMD_SET_BIAS_VOLTAGES      arcdrvCMD_SBV 
#define  arcdrvCMD_SET_CHIP_ROWS          arcdrvCMD_SCR
#define  arcdrvCMD_SET_CHIP_COLS          arcdrvCMD_SCC
#define  arcdrvCMD_SET_DMA_ADDRESS        arcdrvCMD_SDA  
#define  arcdrvCMD_SET_DITHER_MODE        arcdrvCMD_SDM  
#define  arcdrvCMD_SET_EXPOSURE_TIME      arcdrvCMD_SET 
#define  arcdrvCMD_START_EXPOSURE         arcdrvCMD_SEX 
#define  arcdrvCMD_SET_GAIN               arcdrvCMD_SGN 
#define  arcdrvCMD_SHIFT_LINES_DOWN       arcdrvCMD_SLD  
#define  arcdrvCMD_SHIFT_LINES_UP         arcdrvCMD_SLU  
#define  arcdrvCMD_SELECT_OUTPUT          arcdrvCMD_SOS 
#define  arcdrvCMD_SET_PASS_THROUGH       arcdrvCMD_SPT 
#define  arcdrvCMD_SET_READOUT            arcdrvCMD_SRM 
#define  arcdrvCMD_SET_SUBARRAY_POSITION  arcdrvCMD_SSP
#define  arcdrvCMD_SET_SUBARRAY_SIZE      arcdrvCMD_SSS 
#define  arcdrvCMD_TEST_BYTE_SWAPPING     arcdrvCMD_TBS 
#define  arcdrvCMD_TEST_DATA_LINK         arcdrvCMD_TDL 
#define  arcdrvCMD_SWITCH_PELTIER_COOLER  arcdrvCMD_TEC 
#define  arcdrvCMD_WRITE_MEMORY           arcdrvCMD_WRM 
#define  arcdrvCMD_SET_NUM_WIPES          arcdrvCMD_SNW 
#define  arcdrvCMD_SET_BIAS_OFFSETS       arcdrvCMD_SBO 

/*
 * ----- Argument Data Structure -----
 */


/* Maximum Number of arguments */
#define arcdrvMAX_ARGS  5

/* Maximum Number of reply values */
#define arcdrvMAX_REPS  1

/* 
 * The structure arcdrvCMD_ARGUMENTS or the List arcdrvARG_LIST could be 
 * used alternative 
 */

/* Argument Data Structure */
typedef struct
{
    vltINT32 arg1;        /* Argument 1   */
    vltINT32 arg2;        /* Argument 2   */
    vltINT32 arg3;        /* Argument 3   */
    vltINT32 arg4;        /* Argument 4   */
    vltINT32 arg5;        /* Argument 5   */
    vltINT32 reply;       /* Reply value  */
} arcdrvARG_STRUCT;
typedef arcdrvARG_STRUCT  *arcdrvARG_STRUCT_PTR;

/* Argument Data List */
typedef vltINT32           arcdrvARG_LIST[arcdrvMAX_ARGS + arcdrvMAX_REPS];
typedef arcdrvARG_LIST    *arcdrvARG_LIST_PTR;

/* Definition of List indices */
#define arcdrvIDX_ARG1     0
#define arcdrvIDX_ARG2     1
#define arcdrvIDX_ARG3     2
#define arcdrvIDX_ARG4     3
#define arcdrvIDX_ARG5     4
#define arcdrvIDX_REPL     5

/*************************************************
*   Readout modes
*************************************************/
#define arcdrvAMPLIFIER_A      0x5F5F41    /* Ascii __A amp A.                 */
#define arcdrvAMPLIFIER_B      0x5F5F42    /* Ascii __B amp B.                 */
#define arcdrvAMPLIFIER_C      0x5F5F43    /* Ascii __C amp C.                 */
#define arcdrvAMPLIFIER_D      0x5F5F44    /* Ascii __D amp D.                 */
#define arcdrvAMPLIFIER_L      0x5F5F4C    /* Ascii __L left amp.              */
#define arcdrvAMPLIFIER_R      0x5F5F52    /* Ascii __R left amp.              */
#define arcdrvAMPLIFIER_LR     0x5F4C52    /* Ascii _LR right two amps.        */
#define arcdrvAMPLIFIER_AB     0x5F4142    /* Ascii _AB top two amps A & B.    */
#define arcdrvAMPLIFIER_CD     0x5F4344    /* Ascii _CD bottom two amps C & D. */
#define arcdrvAMPLIFIER_ALL    0x414C4C    /* Ascii ALL four amps (quad).      */

#define arcdrvNO_PASS_THROUGH  0
#define arcdrvPASS_THROUGH     1

/*************************************************
*   Define gain and speed constants
*************************************************/
#define arcdrvGAIN_ONE         1
#define arcdrvGAIN_TWO         2
#define arcdrvGAIN_FIVE        5
#define arcdrvGAIN_TEN        10

#define arcdrvSPEED_SLOW       0
#define arcdrvSPEED_FAST       1

#define arcdrvRESET_GLOBAL     0
#define arcdrvRESET_ROWBYROW   1

#define arcdrvDAC_A            1
#define arcdrvDAC_B            3

#define  arcdrvMIN_APPLICATION_NUMBER    0   /* Min. application number */
#define  arcdrvMAX_APPLICATION_NUMBER    3   /* Max. application number */

#define  arcdrvMIN_VIDEO_OFFSET_BOARD    1   /* Min. for videoOffset board id */
#define  arcdrvMAX_VIDEO_OFFSET_BOARD   16   /* Max. for videoOffset board id */

#define  arcdrvMIN_VIDEO_OFFSET_VOLTAGE    0 /* Min. for videoOffset voltage */
#define  arcdrvMAX_VIDEO_OFFSET_VOLTAGE 4095 /* Max. for videoOffset voltage */

#define  arcdrvMIN_COADDS      1               
#define  arcdrvMAX_COADDS  65535  

#define  arcdrvMIN_SAMPLES     1             /* Min. number of samples */
#define  arcdrvMAX_SAMPLES 65535             /* Max. number of samples */

#define  arcdrvMIN_RAMPS       2              /* Min. number of ramps */
#define  arcdrvMAX_RAMPS   65535              /* Max. number of ramps */

#define  arcdrvMIN_DMA_BLOCKSIZE    1024      /* Min. DMA block size */
#define  arcdrvMAX_DMA_BLOCKSIZE  262144      /* Max. DMA block size */

/*************************************************
 *        Slot Number of PMC board
 *************************************************/
#define arcdrvPMC_SLOT1 0x00
#define arcdrvPMC_SLOT2 0x01

/*************************************************
 *        Board Destination
 *************************************************/
#define arcdrvBOARD_PCI 0x01    /* PCI */
#define arcdrvBOARD_TIM 0x02    /* Timing Board */
#define arcdrvBOARD_UTL 0x03    /* Utility Board*/

/*************************************************
 *        Memory Type
 *************************************************/
#define arcdrvMEMORY_P  0x100000
#define arcdrvMEMORY_X  0x200000
#define arcdrvMEMORY_Y  0x400000
#define arcdrvMEMORY_R  0x800000

/*************************************************
 *        Temperature Flags
 *************************************************/
#define arcdrvTEMP_2HOT_BIT    0
#define arcdrvTEMP_COLD_BIT    1
#define arcdrvTEMP_TPWR_BIT    2

#define arcdrvTEMP_TOO_HOT     (1 << arcdrvTEMP_2HOT_BIT)
#define arcdrvTEMP_COLD_OK    ((1 << arcdrvTEMP_COLD_BIT) | (1 << arcdrvTEMP_TPWR_BIT))
#define arcdrvTEMP_COOLING     (1 << arcdrvTEMP_TPWR_BIT)

#define arcdrvTEMP_ILLEGAL_STR "Illegal Temperature status"
#define arcdrvTEMP_NO_TPWR_STR "Peltier is switched Off"
#define arcdrvTEMP_TOO_HOT_STR "CCD too hot !"
#define arcdrvTEMP_COOLING_STR "Cooling down ..."
#define arcdrvTEMP_COLD_OK_STR "CCD Temperature = -30C"

#ifdef __cplusplus
}
#endif

#endif /*!ARCDRV_COMMANDS_H*/

