#ifndef ARCDRV_ERRORS_H
#define ARCDRV_ERRORS_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: arcdrvErrors.h,v 1.14 2005/08/04 14:27:08 vltsccm Exp $"
*
* arcdrvError.h  -  Contains literals for arcdrv TCCD driver error codes
*
*
* who       when        what
* --------  ----------  ----------------------------------------------
* vltuser5  2003-02-26  created
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */

/* The following piece of code alternates the linkage type to C for all 
functions declared within the braces, which is necessary to use the 
functions in C++-code.
*/

#ifdef __cplusplus
extern C {
#endif

/*
 *  Set arcdrv TCCD  driver error definitions
 */
#define arcdrvERROR_NO_EXCLUSIVE            -60
#define arcdrvERROR_CONFIGURATION           -61
#define arcdrvERROR_INTERRUPT_NOT_CLEARED   -62

/* Driver errors */
#define arcdrvERROR_SEMAPHORE_TIMEOUT       -63
#define arcdrvERROR_START_TIMER             -64
#define arcdrvERROR_STOP_TIMER              -65

#define arcdrvERROR_EDEADLK                 -66      /* Resource deadlock avoided             */
#define arcdrvERROR_NOREPLYVALUE            -67      /* No correct Reply value received       */    
#define arcdrvERROR_INPUT_FIFO_NOT_EMPTY    -68      /* Input FIFO not empty                  */    
#define arcdrvERROR_OUTPUT_FIFO_EMPTY       -69      /* Output FIFO is empty                  */    
#define arcdrvERROR_INVALID_PARAMETER       -70      /* Invalid Parameter                     */    
#define arcdrvERROR_INVALID_REPLY           -71      /* Invalid command reply                 */    
#define arcdrvERROR_NOREADOUT               -72      /* Read Elapsed called but no readout    */
#define arcdrvERROR_NOTREADY                -73      /* Controller not ready                  */
#define arcdrvERROR_ERRREPLY                -74      /* Controller returned error             */
#define arcdrvERROR_COMMAND                 -75      /* Command returned error                */

#define arcdrvERROR_PCI_NOT_FOUND           -80   
#define arcdrvERROR_PCI_MEM_MAP             -81   

#ifdef __cplusplus
}
#endif

#endif /*!ARCDRV_ERRORS_H*/
