/******************************************************************************
*  E.S.O. - VLT project
* 
*  "@(#) $Id: autoTest.h,v 1.11 2001/09/11 22:25:23 vltsccm Exp $"
* 
*  who        when      what
*  ---------- --------  ----------------------------------------------
*  rschmutzer 12/01/96  Created by eccsgen V0.56 (December 1995)
*
*
*    !!!!!!!!!  CAUTION: THIS FILE IS UPDATED BY ECCSGEN  !!!!!!!!!
*/

/*************************************************************************
*   NAME
*	autoTest - class
*
*   SYNOPSIS
*	#include "autoTest.h"
*
*	ccsCOMPL_STAT autoTestNewObj(
*	    IN    dbSYMADDRESS	point,
*	    IN    egenOBJ*	owner,
*	    OUT   egenOBJ*	obj,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT autoTestDeleteObj(
*	    INOUT egenOBJ*	obj,
*	    OUT   ccsERROR*	error)
*
*	egenOBJ* autoTestGetOwner(
*	    IN const egenOBJ* obj)
*
*	egenOBJ* autoTestLogData(
*	    IN const egenOBJ*	obj,
*	    IN const char*	format,
*	    IN 			...)
*
*	ccsCOMPL_STAT autoTestTest1(
*	    INOUT egenOBJ*	obj,
*	    IN    vltINT32	delay,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT autoTestTest2(
*	    INOUT egenOBJ*	obj,
*	    IN    vltINT32	delay,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT autoTestTest3(
*	    INOUT egenOBJ*	obj,
*	    IN    vltINT32	delay,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT autoTestTest4(
*	    INOUT egenOBJ*	obj,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT autoTestTest42(
*	    INOUT egenOBJ*	obj,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT autoTestTest43(
*	    INOUT egenOBJ*	obj,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT autoTestTest44(
*	    INOUT egenOBJ*	obj,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT autoTestTest4S(
*	    INOUT egenOBJ*	obj,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT autoTestTest5(
*	    INOUT egenOBJ*	obj,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT autoTestTest6(
*	    INOUT egenOBJ*	obj,
*	    IN    vltINT32	delay,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT autoTestReadState(
*	    IN    egenOBJ*	obj,
*	    OUT   void*		buf,
*	    OUT   ccsERROR*	error)
*	
*	ccsCOMPL_STAT autoTestWriteState(
*	    INOUT egenOBJ*	obj,
*	    IN    void*		buf,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT autoTestReadSubstate(
*	    IN    egenOBJ*	obj,
*	    OUT   void*		buf,
*	    OUT   ccsERROR*	error)
*	
*	ccsCOMPL_STAT autoTestWriteSubstate(
*	    INOUT egenOBJ*	obj,
*	    IN    void*		buf,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT autoTestReadError(
*	    IN    egenOBJ*	obj,
*	    OUT   void*		buf,
*	    OUT   ccsERROR*	error)
*	
*	ccsCOMPL_STAT autoTestWriteError(
*	    INOUT egenOBJ*	obj,
*	    IN    void*		buf,
*	    OUT   ccsERROR*	error)
*
*
*   PARENT CLASS
*	-
*
*   DESCRIPTION
*       Class to test module auto.
*
*   PUBLIC METHODS (COMMANDS)
*	autoTestNewObj(point,owner,obj,error)
*	    Initialises an instance of the class type autoTEST.
*
*	    point	<IN>	OLDB point where the owned attributes are
*				located.
*	    owner	<IN>	Pointer to the owner of the new instance.
*	    obj		<OUT>	Handle for the new instance (the handle
*				must be allocated by the caller).
*
*	autoTestDeleteObj(obj,error)
*	    The function lcctooDeleteObj deletes an
*	    instance of the class type autoTEST
*
*	autoTestTest1(obj,delay,error) (TEST1)
*	   Includes a delay to be able to execute Test4S.
*
*	autoTestTest2(obj,delay,error) (TEST2)
*	   Includes a delay to be able to execute Test4S and Test5.
*
*	autoTestTest3(obj,delay,error) (TEST3)
*	   Includes a delay to be able to execute Test2, Test4S and Test5.
*
*	autoTestTest4(obj,error) (TEST4)
*
*	autoTestTest42(obj,error) (TEST42)
*
*	autoTestTest43(obj,error) (TEST43)
*
*	autoTestTest44(obj,error) (TEST44)
*
*	autoTestTest4S(obj,error) (TEST4S)
*
*	autoTestTest5(obj,error) (TEST5)
*
*	autoTestTest6(obj,delay,error) (TEST6)
*	   Includes a delay to be able to test IDLE substate.
*
*
*	autoTestErr<error>(...)
*	    The macros autoTestErr*() log an error with lcctooLOG_0 and
*	    call errAdd with the corresponding error parameters.
*
*	autoTestRead<attr>(...)
*	autoTestWrite<attr>(...)
*	    The above macros read from/write to the data attributes
*	    of the class.
*	    The attributes are described in autoTestDb(5).
*
*   PROTECTED METHODS
*   PRIVATE METHODS
*
*   DEFINES
*
*   FILES
*
*   ENVIRONMENT
*
*   RETURN VALUES
*	If the function prototype allows, methods return ccsCOMPL_STAT.
*
*	Methods can generate the following errors:
*
*   CAUTIONS
*
*   EXAMPLES
*
*   SEE ALSO
*
*   BUGS
*
* 
*-------------------------------------------------------------------------
*/

#ifndef AUTO_TEST_H
#define AUTO_TEST_H

#include "egen.h"
#include "autoErrors.h"

/*
 * class type identifier
 */
#define autoTEST_ID	114

/*
 * attribute table
 */
#define autoTEST_ATTR_STATE	0
#define autoTEST_ATTR_SUBSTATE	1
#define autoTEST_ATTR_ERROR	2

#define autoTEST_AUTOMATA	0

/*
 * function table
 */
#define autoTEST_FCT_DELETE_OBJ	0
#define autoTEST_FCT_TEST1	1
#define autoTEST_FCT_TEST2	2
#define autoTEST_FCT_TEST3	3
#define autoTEST_FCT_TEST4	4
#define autoTEST_FCT_TEST42	5
#define autoTEST_FCT_TEST43	6
#define autoTEST_FCT_TEST44	7
#define autoTEST_FCT_TEST4_S	8
#define autoTEST_FCT_TEST5	9
#define autoTEST_FCT_TEST6	10

/*
 * automata states
 */
#define autoTEST_STATE_NOSTATE	-1
#define autoTEST_STATE_STATE1	0
#define autoTEST_STATE_STATE2	1
#define autoTEST_STATE_STATE3	2
#define autoTEST_STATE_STATE4	3

/*
 * automata substates
 */
#define autoTEST_SUBSTATE_ERROR	0
#define autoTEST_SUBSTATE_IDLE	1
#define autoTEST_SUBSTATE_BUSY	2
#define autoTEST_SUBSTATE_SUBST21	3
#define autoTEST_SUBSTATE_SUBST34	4
#define autoTEST_SUBSTATE_SUBST12	5
#define autoTEST_SUBSTATE_SUBST23	6
#define autoTEST_SUBSTATE_SUBST41	7

/*
 * automata events
 */
#define autoTEST_EVENT_TEST1	0
#define autoTEST_EVENT_TEST2	1
#define autoTEST_EVENT_TEST3	2
#define autoTEST_EVENT_TEST4	3
#define autoTEST_EVENT_TEST5	4
#define autoTEST_EVENT_TEST6	5


/*
 * function pointer types
 */
typedef ccsCOMPL_STAT (*autoTEST_FCTPTR_TEST1)(
    INOUT egenOBJ*	obj,
    IN    vltINT32	delay,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*autoTEST_FCTPTR_TEST2)(
    INOUT egenOBJ*	obj,
    IN    vltINT32	delay,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*autoTEST_FCTPTR_TEST3)(
    INOUT egenOBJ*	obj,
    IN    vltINT32	delay,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*autoTEST_FCTPTR_TEST4)(
    INOUT egenOBJ*	obj,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*autoTEST_FCTPTR_TEST42)(
    INOUT egenOBJ*	obj,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*autoTEST_FCTPTR_TEST43)(
    INOUT egenOBJ*	obj,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*autoTEST_FCTPTR_TEST44)(
    INOUT egenOBJ*	obj,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*autoTEST_FCTPTR_TEST4_S)(
    INOUT egenOBJ*	obj,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*autoTEST_FCTPTR_TEST5)(
    INOUT egenOBJ*	obj,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*autoTEST_FCTPTR_TEST6)(
    INOUT egenOBJ*	obj,
    IN    vltINT32	delay,
    OUT   ccsERROR*	error);


/*
 * log function
 */
#define autoTestLogData(obj, format, arg...) \
	{ \
	char tmpLogBuf[lcctooTMP_BUFFER_SIZE]; \
	\
	sprintf(tmpLogBuf, (format), ##arg); \
	logData("auto", (obj)->id, tmpLogBuf); \
	}


/*
 * get object owner
 */
#define autoTestGetOwner(obj) ((obj)->owner)


/*
 * attribute access functions
 */
#define autoTestReadState(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,autoTEST_ATTR_STATE,(buf),(error))
#define autoTestWriteState(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,autoTEST_ATTR_STATE,(void*) (buf),(error))
#define autoTestReadSubstate(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,autoTEST_ATTR_SUBSTATE,(buf),(error))
#define autoTestWriteSubstate(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,autoTEST_ATTR_SUBSTATE,(void*) (buf),(error))
#define autoTestReadError(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,autoTEST_ATTR_ERROR,(buf),(error))
#define autoTestWriteError(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,autoTEST_ATTR_ERROR,(void*) (buf),(error))
#define autoTestGetAuto(obj,attrPtr,error) \
	SUCCESS; \
	memcpy((attrPtr), &(obj)->objs[autoTEST_AUTOMATA], sizeof(egenOBJ)); \
	(attrPtr)->ldata = (obj)->ldata;


/*
 * class functions
 */

ccsCOMPL_STAT autoTestTest1(
    INOUT egenOBJ*	obj,
    IN    vltINT32	delay,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT autoTestTest2(
    INOUT egenOBJ*	obj,
    IN    vltINT32	delay,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT autoTestTest3(
    INOUT egenOBJ*	obj,
    IN    vltINT32	delay,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT autoTestTest4(
    INOUT egenOBJ*	obj,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT autoTestTest42(
    INOUT egenOBJ*	obj,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT autoTestTest43(
    INOUT egenOBJ*	obj,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT autoTestTest44(
    INOUT egenOBJ*	obj,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT autoTestTest4S(
    INOUT egenOBJ*	obj,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT autoTestTest5(
    INOUT egenOBJ*	obj,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT autoTestTest6(
    INOUT egenOBJ*	obj,
    IN    vltINT32	delay,
    OUT   ccsERROR*	error);


/*
 * virtual functions
 */
#define autoTestVTest1(obj,delay,error) \
	(*((autoTEST_FCTPTR_TEST1)((obj)->fcts[autoTEST_FCT_TEST1]))) \
	 ((obj),(delay),(error))
#define autoTestVTest2(obj,delay,error) \
	(*((autoTEST_FCTPTR_TEST2)((obj)->fcts[autoTEST_FCT_TEST2]))) \
	 ((obj),(delay),(error))
#define autoTestVTest3(obj,delay,error) \
	(*((autoTEST_FCTPTR_TEST3)((obj)->fcts[autoTEST_FCT_TEST3]))) \
	 ((obj),(delay),(error))
#define autoTestVTest4(obj,error) \
	(*((autoTEST_FCTPTR_TEST4)((obj)->fcts[autoTEST_FCT_TEST4]))) \
	 ((obj),(error))
#define autoTestVTest42(obj,error) \
	(*((autoTEST_FCTPTR_TEST42)((obj)->fcts[autoTEST_FCT_TEST42]))) \
	 ((obj),(error))
#define autoTestVTest43(obj,error) \
	(*((autoTEST_FCTPTR_TEST43)((obj)->fcts[autoTEST_FCT_TEST43]))) \
	 ((obj),(error))
#define autoTestVTest44(obj,error) \
	(*((autoTEST_FCTPTR_TEST44)((obj)->fcts[autoTEST_FCT_TEST44]))) \
	 ((obj),(error))
#define autoTestVTest4S(obj,error) \
	(*((autoTEST_FCTPTR_TEST4_S)((obj)->fcts[autoTEST_FCT_TEST4_S]))) \
	 ((obj),(error))
#define autoTestVTest5(obj,error) \
	(*((autoTEST_FCTPTR_TEST5)((obj)->fcts[autoTEST_FCT_TEST5]))) \
	 ((obj),(error))
#define autoTestVTest6(obj,delay,error) \
	(*((autoTEST_FCTPTR_TEST6)((obj)->fcts[autoTEST_FCT_TEST6]))) \
	 ((obj),(delay),(error))


ccsCOMPL_STAT autoTestNewObj(
    IN    dbSYMADDRESS	point,
    IN    egenOBJ*	owner,
    OUT   egenOBJ*	obj,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT autoTestDeleteObj(
    INOUT egenOBJ*	obj,
    OUT   ccsERROR*	error);


#endif // !AUTO_TEST_H

/************************************************************************/
/* ___oOo___ */
