/************************************************************************
*
* E.S.O. - VLT project
*
* "@(#) $Id: bab.h,v 1.30 2004/11/19 13:26:38 vltsccm Exp $"
*
* who       when      what
* --------  --------  ---------------------------------------------------
* ahuxley   07/11/01  created (for later history see ChangeLog)
* ahuxley   25/03/02  added 'utils' branch to global data extension to
*		      facilitate per-server (rather than per LCU) debugging
* ahuxley   12/02/03  rationalised includes, moved types elsewhere
* -----------------------------------------------------------------------
************************************************************************/

/************************************************************************
*
*   NAME
*   	bab.h
* 
*   DESCRIPTION
*   	This file defines the types for the bab global data branches
*
*   FILES
*       none
*
*   ENVIRONMENT
*	none
*
*   COMMANDS
*	none
*
*   CAUTIONS 
*	none
*   BUGS   
* 
*------------------------------------------------------------------------
************************************************************************/

#ifndef BAB_H
#define BAB_H

/*
 *  Includes
 */

#include "ccs.h"                                /* for ccsCOMPL_STAT, types ... */
#include "lcc.h"                                /* for stuff required by lccLCC.h */
#include "too.h"                                /* for ccsCOMPL_STAT and as prerequisite for lsfServer.h */
#include "lsf.h"                          	/* for lsfSERVER_DATA */
#include "babTypes.h"				/* for babDATA */

/*
 *  More includes - these ones are *not* needed by *this* file, but are there
 *  to make users of bab lives easier, by allowing them to only include 'bab.h'.
 */

#include "babLib.h"				/* for library function fwd decs */
#include "babInterface.h"			/* for interface function fwd decs */
#include "babDebug.h"				/* for debug macro and symbols */
#include "babSerial.h"				/* for serial constructor and destructor and serial command fwd decs */
#include "babMotor.h"				/* for motor constructor and destructor fwd decs */
#include "babDefines.h"				/* for debug symbols */
#include "babErrors.h"				/* for bab errors */

/*
 *  Macros
 */

/*
 *  Typedefs and structs
 */

/*
 *  Typedefs and structs
 */


/*
 *  Foward declarations for global data 
 */

/*
 *  Foward declarations for global functions
 */

extern ccsCOMPL_STAT babConstructor(OUT babDATA **appBabData, IN lsfSERVER_DATA **appLsfData, IN ccsERROR *error);
extern ccsCOMPL_STAT babDestructor(IN OUT babDATA **appBabData, IN ccsERROR *error);

/*
 *  Standard VLT-ish epilogue
 */

/*
 *  Reinclusion protection epilogue
 */

#endif
