/************************************************************************
*
* E.S.O. - VLT project
*
* "@(#) $Id: babDebug.h,v 1.30 2004/11/19 13:26:39 vltsccm Exp $"
*
* who       when      what
* --------  --------  ---------------------------------------------------
* ahuxley   17/01/03  created 
* -----------------------------------------------------------------------
************************************************************************/

#ifndef BAB_DEBUG_H
#define BAB_DEBUG_H

#include "lcc.h"				/* for ccsCOMPL_STAT, vltINT32, ... */
#include "too.h"				/* for IN and OUT */
#include "babTypes.h"				/* for babDATA type */

/*
 *  Macros
 */

#ifndef babDEBUG_COMPILE_WITHOUT_DEBUG 	/* debugging function definition */
#define babDebug(ptr,level,message...) babDebugReal(ptr,level, ##message) /* what to call if debugging required */
#else
#define babDebug(ptr,level,message...)	/* what to call if debugging not required; nothing! */
#endif

extern ccsCOMPL_STAT babDebugConstructor(IN babDATA *appBabData, OUT ccsERROR *error);
extern ccsCOMPL_STAT babDebugDestructor(IN babDATA *appBabData, OUT ccsERROR *error);
extern ccsCOMPL_STAT babDebugSet(IN babDATA *appBabData, IN vltUINT32 *oldMask, IN char **oldRegex, IN vltINT32 *oldMethods, OUT vltUINT32 *newMask, OUT char **newRegex, OUT vltINT32 *newMethods, OUT ccsERROR *error);
extern void          babDebugReal(IN babDATA *appBabData, IN vltUINT32 bits, IN char *fmt, ...);

#endif
