/************************************************************************
*
* E.S.O. - VLT project
*
* "@(#) $Id: babDefines.h,v 1.30 2004/11/19 13:26:39 vltsccm Exp $"
*
* who       when      what
* --------  --------  ---------------------------------------------------
* ahuxley   07/11/01  created (for later history see ChangeLog)
* ahuxley   28/03/02  m16/MAR2002 porting: moved debug macro symbols
*                     here so can be safely redefined in bab clients'
*                     own <mod>Defines.h without dbl problems
* ahuxley   26/11/02  cosmetic changes to make clear debug flags are
*                     31 bit 
* ahuxley   12/02/03  tidied debug define names and values
* -----------------------------------------------------------------------
************************************************************************/

/************************************************************************
*
*   NAME
*       babDefines.h
* 
*   DESCRIPTION
*       This file contains *only* macro definitions.
*
*   FILES
*       none
*
*   ENVIRONMENT
*       none
*
*   COMMANDS
*       none
*
*   CAUTIONS 
*       Do not put any C code in here - it will break inclusion by 
*       dbl files.
*
*   BUGS   
* 
*------------------------------------------------------------------------
************************************************************************/

/*
 *  Avoid reinclusion
 */

#ifndef BAB_DEFINES_H
#define BAB_DEFINES_H

/*
 *  System includes needed by this include file
 */


/*
 *  Application includes needed by this include file
 */

/*
 *  Macros 
 */

#define babMODULE_ID              "bab"
#define babMODULE_NAME            babMODULE_ID
#define babMODULE_TITLE           "Basic Application Blocks"
#define babLOG_ID                 101             

#define babDEBUG_METHOD_PRINTF    0x00000001    /* display with printf */
#define babDEBUG_METHOD_LOGDATA   0x00000002    /* display with logdata */

/*
 *  Function types
 */

#define babDEBUG_COMMAND          0x00000001    /* command handlers */
#define babDEBUG_INTERFACE        0x00000002    /* interface functions */
#define babDEBUG_CONDE            0x00000004    /* constructor, destructors */
#define babDEBUG_HOOK             0x00000008    /* LSF hooks */
#define babDEBUG_MISC             0x00000010    /* miscellaneous functions */
#define babDEBUG_RESERVED2        0x00000020    /* RESERVED FOR FUTURE USE */
#define babDEBUG_RESERVED3        0x00000040    /* RESERVED FOR FUTURE USE */
#define babDEBUG_RESERVED4        0x00000080    /* RESERVED FOR FUTURE USE */

/*
 *  LSF devices
 */

#define babDEBUG_SERIAL           0x00000100    /* serial ports */
#define babDEBUG_TASKDEV          0x00000200    /* LSF task devices */
#define babDEBUG_MOTOR            0x00000400    /* motors */
#define babDEBUG_SOFTDEV          0x00000800    /* soft devices */
#define babDEBUG_RESERVED5        0x00001000    /* RESERVED FOR FUTURE USE */
#define babDEBUG_RESERVED6        0x00002000    /* RESERVED FOR FUTURE USE */
#define babDEBUG_RESERVED7        0x00004000    /* RESERVED FOR FUTURE USE */
#define babDEBUG_RESERVED8        0x00008000    /* RESERVED FOR FUTURE USE */

/*
 *  Programming resources
 */

#define babDEBUG_LOCK             0x00010000    /* to locking */
#define babDEBUG_DB               0x00020000    /* db access */
#define babDEBUG_SEM              0x00040000    /* semaphores */
#define babDEBUG_MSGQ             0x00080000    /* message queues */
#define babDEBUG_SHM              0x00100000    /* shared memory */
#define babDEBUG_RESERVED9        0x00200000    /* RESERVED FOR FUTURE USE */
#define babDEBUG_RESERVED10       0x00400000    /* RESERVED FOR FUTURE USE */
#define babDEBUG_RESERVED11       0x00800000    /* RESERVED FOR FUTURE USE */

/*
 *  Application-specific (for remapping by application's headers)
 */

#define babDEBUG_APPLICATION1     0x01000000    /* for applications */
#define babDEBUG_APPLICATION2     0x02000000    /* for applications */
#define babDEBUG_APPLICATION3     0x04000000    /* for applications */
#define babDEBUG_APPLICATION4     0x08000000    /* for applications */

/*
 *  Module-specific
 */

#define babDEBUG_BAB              0x10000000    /* 'bab' only - do not use */
#define babDEBUG_RESERVED12       0x20000000    /* RESERVED FOR FUTURE USE */
#define babDEBUG_RESERVED13       0x40000000    /* RESERVED FOR FUTURE USE */
#define babDEBUG_RESERVED14       0x80000000    /* RESERVED FOR FUTURE USE */

/*
 *  Typedefs and structs
 */

/*
 *  Forward declarations for global data 
 */

/*
 *  Forward declarations for global functions
 */

/*
 *  (End of) avoid reinclusion
 */

#endif
