#ifndef BAB_INTERFACE_H
#define BAB_INTERFACE_H

/***************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: babInterface.h,v 1.30 2004/11/19 13:26:39 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* ahuxley   14/01/03  created
*---------------------------------------------------------------------------
***************************************************************************/

#ifdef __cplusplus
extern "C" {
#endif

#include "lcc.h"				/* for ccsCOMPL_STAT */
#include "too.h"				/* for IN and OUT */
#include "bab.h"				/* for babDATA */
#include "lsf.h"				/* for lsfSTD_REPLY */

/*
 *  Macros
 */

						/* appDebugSet() calls babDebugSet(appBabData,...) */
#define babSTD_COMMAND(mod,fct,cmd)                     \
    babACI_FUNCTION(mod,fct)                            \
    {                                                   \
        return(Ibab ## fct (mod ## BabData,parameters,msg,replyBuffer,replyBufferSize,error));         \
    }

						/* prototype for Ibab*() */
#define babACI_FUNCTION(mod,fct) \
    ccsCOMPL_STAT I ## mod ## fct ( \
    IN  const char      *parameters,       	/* Formatted input parameters   */ \
    IN  msgMSG          *msg,              	/* Message body used for reply  */ \
    OUT char           **replyBuffer,     	/* Output buffer                */ \
    OUT msgLENGTH       *replyBufferSize,  	/* Output buffer size           */ \
    OUT ccsERROR        *error )           	/* Returned error structure     */

/*
 * Prototypes
 */

extern ccsCOMPL_STAT IbabDebugSet(IN babDATA *appBabData, IN const char *parameters, IN msgMSG *msg, OUT char **replyBuffer, OUT msgLENGTH *replyBufferSize, OUT ccsERROR *error);
extern ccsCOMPL_STAT IbabSerialSendText(IN babDATA *appBabData, IN const char *parameters, IN msgMSG *msg, OUT char **replyBuffer, OUT msgLENGTH *replyBufferSize, OUT ccsERROR *error);
extern ccsCOMPL_STAT IbabSerialStartMonitor(IN babDATA *appBabData, IN const char *parameters, IN msgMSG *msg, OUT char **replyBuffer, OUT msgLENGTH *replyBufferSize, OUT ccsERROR *error);
extern ccsCOMPL_STAT IbabSerialStopMonitor(IN babDATA *appBabData, IN const char *parameters, IN msgMSG *msg, OUT char **replyBuffer, OUT msgLENGTH *replyBufferSize, OUT ccsERROR *error);
extern ccsCOMPL_STAT IbabSerialTestChat(IN babDATA *appBabData, IN const char *parameters, IN msgMSG *msg, OUT char **replyBuffer, OUT msgLENGTH *replyBufferSize, OUT ccsERROR *error);
extern ccsCOMPL_STAT IbabSerialSetExternalDeviceSimulation(IN babDATA *appBabData, IN const char *parameters, IN msgMSG *msg, OUT char **replyBuffer, OUT msgLENGTH *replyBufferSize, OUT ccsERROR *error);
extern ccsCOMPL_STAT IbabSerialGetExternalDeviceSimulation(IN babDATA *appBabData, IN const char *parameters, IN msgMSG *msg, OUT char **replyBuffer, OUT msgLENGTH *replyBufferSize, OUT ccsERROR *error);

#ifdef __cplusplus
}
#endif

#endif 
