/************************************************************************
*
* E.S.O. - VLT project
*
* "@(#) $Id: babLib.h,v 1.30 2004/11/19 13:26:37 vltsccm Exp $"
*
* who       when      what
* --------  --------  ---------------------------------------------------
* ahuxley   17/01/03  created 
* -----------------------------------------------------------------------
************************************************************************/

#ifndef BAB_LIB_H
#define BAB_LIB_H

#include "lcc.h"					/* for ccsCOMPL_STAT */
#include "too.h"					/* for IN, OUT */
#include "babTypes.h"					/* for babDATA */
#include "babLibRegex.h"				/* for re_pattern_buffer, regex_t, reg_syntax_t */

extern ccsCOMPL_STAT babStrCaseCmp(IN babDATA *appBabData, IN const char *s1, IN const char *s2, OUT vltINT32 *strcmprc, IN ccsERROR *error);
extern ccsCOMPL_STAT  babChecksumBuf(IN babDATA *appBabData, IN char *buf, IN vltINT32 buflen, OUT unsigned long *crc, IN ccsERROR *error);
extern ccsCOMPL_STAT  babStrHexInt2UnsignedLong(IN babDATA *appBabData, IN char *string, OUT unsigned long *ul_in_caller, IN ccsERROR *error);
extern ccsCOMPL_STAT  babStrDecInt2UnsignedLong(IN babDATA *appBabData, IN char *string, OUT unsigned long *ul_in_caller, IN ccsERROR *error);
extern ccsCOMPL_STAT  babStrDecInt2Vltint32(IN babDATA *appBabData, IN char *string, OUT vltINT32 *vltint32_in_caller, IN ccsERROR *error);
extern ccsCOMPL_STAT  babStrDecDbl2Double(IN babDATA *appBabData, IN char *string, OUT double *d_in_caller, IN ccsERROR *error);
extern ccsCOMPL_STAT  babIsAFile(IN babDATA *appBabData, IN char *filename, OUT vltLOGICAL *isafilep, OUT ccsERROR *error);
extern ccsCOMPL_STAT  babSleepMS(IN babDATA *appBabData, IN vltINT32 period, IN ccsERROR *error);
extern ccsCOMPL_STAT  babErrPrint(IN babDATA *appBabData, IN ccsERROR *error);
extern ccsCOMPL_STAT  babStrEscape(IN babDATA *appBabData, IN char *src, IN char *dst, IN int sizeof_dst, OUT ccsERROR *error);
extern ccsCOMPL_STAT  babSerialSetSubstate(IN babDATA *appBabData, IN char *logicalName, IN vltINT32 substate, OUT ccsERROR *error);
extern ccsCOMPL_STAT  babSerialLkupLogicalName(IN babDATA *appBabData, IN char *logicalName, OUT char **real_device_name, OUT vltINT32 *real_device_index, OUT ccsERROR *error);
extern ccsCOMPL_STAT babMotorLkupLogicalName(IN babDATA *appBabData, IN char *logicalName, OUT motHANDLE *real_device_handle, OUT vltINT32 *real_device_index, OUT ccsERROR *error);
extern ccsCOMPL_STAT  babSerialChat(IN babDATA *appBabData, IN char *logicalName, IN char *sendstr, IN char *respstr, OUT vltLOGICAL *got_match_in_caller, OUT char *caughtbuf, IN vltINT32 sizeof_caughtbuf, IN vltINT32 timeout, OUT ccsERROR *error);
/* don't be tempted to move these lines to babRegex.h because it won't work! */
extern ccsCOMPL_STAT  babRegInit(IN babDATA *appBabData, babRegex *context, ccsERROR *error);
extern ccsCOMPL_STAT  babRegComp(IN babDATA *appBabData, IN const char *pattern, IN int cflags, IN babRegex *context, OUT ccsERROR *error);
extern ccsCOMPL_STAT  babRegExec(IN babDATA *appBabData, const char *string, size_t nmatch, regmatch_t pmatch[], int eflags, OUT vltLOGICAL *got_match, babRegex *context, OUT ccsERROR *error);
extern ccsCOMPL_STAT  babRegFree(IN babDATA *appBabData, babRegex *context, OUT ccsERROR *error);
extern ccsCOMPL_STAT babSerialGetSimulation(IN babDATA *appBabData, IN char *logicalName, OUT vltLOGICAL *deviceIsSimulated, OUT ccsERROR *error);


#endif
