/************************************************************************
*
* E.S.O. - VLT project
*
* "@(#) $Id: babTypes.h,v 1.30 2004/11/19 13:26:38 vltsccm Exp $"
*
* who       when      what
* --------  --------  ---------------------------------------------------
* ahuxley   17/01/03  created 
* -----------------------------------------------------------------------
************************************************************************/

#ifndef BAB_TYPES_H
#define BAB_TYPES_H

#include <semLib.h>				/* for SEM_ID */

#include "lcc.h"                                /* for stuff required by lccLCC.h */
#include "lsf.h"				/* for lsfSERVER_DATA */
#include "babLibRegex.h"                        /* for ccsCOMPL_STAT and as prerequisite for lsfServer.h */

#define babMAX_SERIAL	12			/* 
                                                 *  lsfNUM_SERIAL is module dependent - or rather,
				   		 *  the name of the include file defining it is, so
				   		 *  we don't know what to define here, so we use
				   		 *  a fixed number 
                                                 */


typedef struct {
    SEM_ID portlock;
    vltLOGICAL extdevsim;
} babSERIAL_ENTRY;

typedef struct {
    babSERIAL_ENTRY entries[babMAX_SERIAL];
} babSERIAL_DATA;

typedef struct {
    vltUINT32        mask;	
    vltINT32         methods;
    babRegex        *context;
} babDEBUG_DATA;

typedef struct {
    babSERIAL_DATA serial;
    babDEBUG_DATA  debug;
    lsfSERVER_DATA **lsf;			/* pointer to app's var so we know if it changes */
} babDATA;

#endif
