#ifndef CANSTACKERRORS_H
#define CANSTACKERRORS_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: canstackErrors.h,v 0.12 2005/10/10 13:09:50 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* vltuser5 2005-02-03 added error codes of CANopen slave and manager 
*                     library
* vltuser5  11/01/02  created
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */
/* Errors returned by the OALopen libraries OALopen-Slave and
   OALopen-Manager: */ 
#define canstackERROR_NO_NET                 (-152)  
#define canstackERROR_WRONG_NODE_STATE       (-153)  
#define canstackERROR_NODE_NOT_EXISTEND      (-154)  
#define canstackERROR_ABORT_DOMAIN           (-155)  
#define canstackERROR_PARA_ERROR             (-156)  
#define canstackERRORR_TOGGLE_ERROR          (-157)  
#define canstackERROR_INVALID_COMMAND        (-158)  
#define canstackERROR_BUFFER_OVERFLOW        (-159)  
#define canstackERROR_TX_TIMEOUT             (-161)
#define canstackERROR_SYS                    (-162)
#define canstackERROR_NETWORK                (-163)
#define canstackERROR_NOT_OPERATIONAL        (-164)
#define canstackERROR_RX_TIMEOUT             (-165)
#define canstackERROR_CHECKSUM               (-166)
#define canstackERROR_VERIFY                 (-167)
#define canstackERROR_COB                    (-168)
#define canstackERROR_OBJ_EXISTS             (-169)
#define canstackERROR_DATATYPE_TOO_LONG      (-170)
#define canstackERROR_NO_MEMORY              (-171)
#define canstackERROR_DOWNLOAD               (-172)
#define canstackERROR_KOMMUNICATION          (-173)
#define canstackERROR_USER                   (-174)
#define canstackERROR_INDEX                  (-175)
#define canstackERROR_OUT_OF_MEMORY          (-176)
#define canstackERROR_PARAMETER              (-177)
#define canstackERROR_OBJECT_TYPE            (-178)
#define canstackERROR_TOO_MANY_OBJECTS       (-179)
#define canstackERROR_LENGTH_MISMATCH        (-180)
#define canstackERROR_INITIALISATION         (-181)
#define canstackERROR_INVALID_HANDLE         (-182)
#define canstackERROR_ACCESS                 (-183)
#define canstackERROR_HARDWARE               (-184)
#define canstackERROR_DATA_STORE             (-185)
#define canstackERROR_NCOMPATIBILITY         (-186)
#define canstackERROR_PDO_INHIBITED          (-187)
#define canstackERROR_PDO                    (-188)
#define canstackERROR_UNKNOWN                (-189)
#define canstackERROR_FILE                   (-190)
#define canstackERROR_EVENT                  (-191)
#define canstackERROR_CONSISTENCYT           (-192)
#define canstackERROR_CAN_CONTR              (-193)
#define canstackERROR_ID                     (-194)
       
/* SDO abort codes, see DS301  */

/* 0604 0047h General internal incompatibility in the device.  */
#define canstackERROR_INTERNAL_FAILURE            (-100)

/* 0606 0000h Access failed due to an hardware error. */
#define canstackERROR_HARDWARE_FAILURE            (-101)

/* 0604 0041h Object cannot be mapped to the PDO.  */
/* 0604 0042h The number and length of the objects to be mapped would 
   exceed PDO length.  */
/* 0604 0043h General parameter incompatibility reason.  */
#define canstackERROR_INVALID_OBJECT              (-102)

/* 0607 0010h Data type does not match, length of service parameter does
   not match  */
/* 0607 0012h Data type does not match, length of service parameter too
   high  */
/* 0607 0013h Data type does not match, length of service parameter too
   low  */
#define canstackERROR_INVALID_PARAMETER           (-103)

/* 0609 0031h Value of parameter written too high.  */
/* 0609 0032h Value of parameter written too low.   */
#define canstackERROR_PARAMETER_OUT_OF_RANGE      (-104)

/* 0602 0000h Object does not exist in the object dictionary. */
#define canstackERROR_OBJECT_NOT_FOUND            (-105)

/* 0601 0002h Attempt to write a read only object.   */
#define canstackERROR_WRITE_NOT_ALLOWED           (-106)

/* 0503 0000h Toggle bit not alternated.  */
#define canstackERROR_TOGGLE_BIT_UNCHANGED        (-107)


#define canstackERROR_UNKNOWN_CODE                (-108)

/* legacy error codes */ 
#define canstackERROR_COMMUNICATION_FAILURE       (-109)
#define canstackERROR_COMMUNICATION_TIMEOUT       (-110)
#define canstackERROR_ROUTING_FAILURE             (-111)
#define canstackERROR_INVALID_REGISTER            (-112)
#define canstackERROR_REGISTER_ACCESS_FAILURE     (-113)
#define canstackERROR_UNKNOWN_COMMAND             (-114)
#define canstackERROR_UNKNOWN_RESPONSE            (-115)
#define canstackERROR_DEVICE_FAILURE              (-116)
#define canstackERROR_RESET                       (-117)

                                                 
/* Additional SDO eror codes, 
   but still not used to be compatible with previous canio library: */

/* 0504 0000h SDO protocol timed out. */
#define canstackERROR_TIMEOUT                     (-120)

/* 0504 0001h Client/server command specifier not valid or unknown. */
#define canstackERROR_COMMAND_SPECIFIER           (-121)

/* 0504 0002h Invalid block size (block mode only). */
#define canstackERROR_BLOCK_SIZE                  (-122)

/* 0504 0003h Invalid sequence number (block mode only). */
#define canstackERROR_SEQUENCE_NUMBER             (-123)

/* 0504 0004h CRC error (block mode only).  */
#define canstackERROR_CRC                         (-124)

/* 0504 0005h Out of memory. */
#define canstackERROR_MEMORY                      (-125)

/* 0601 0000h Unsupported access to an object.  */
#define canstackERROR_OBJECT_ACCESS               (-126)

/* 0601 0001h Attempt to read a write only object.  */
#define canstackERROR_WRITE_ONLY                  (-127)

/* 0601 0002h Attempt to write a read only object.  */
#define canstackERROR_READ_ONLY                   (-128)

/* 0602 0000h Object does not exist in the object dictionary.  */
#define canstackERROR_OBJECT_NOT_EXIST            (-129)

/* 0609 0011h Sub-index does not exist.   */
#define canstackERROR_SUBOBKJECT_NOT_EXIST        (-130)

/* 0609 0030h Value range of parameter exceeded (only for write access). */
#define canstackERROR_OUT_OF_RANGE_WRITE          (-131)

/* 0609 0036h Maximum value is less than minimum value. */
#define canstackERROR_WRONG_MAX_VALUE             (-132)

/* 0800 0000h general error */
#define canstackERROR_GENERAL                     (-133)

/* 0800 0020h Data cannot be transferred or stored to the application.  */
#define canstackERROR_DATA_TRANSFER               (-134)

/* 0800 0021h Data cannot be transferred or stored to the application   
   because of local control. */
#define canstackERROR_DATA_TRANSFER_LOCAL         (-135)

/* 0800 0022h Data cannot be transferred or stored to the application
   because of the present device state. */
#define canstackERROR_DATA_TRANSFER_DEVICE_STATE  (-136)

/* 0800 0023h Object dictionary dynamic generation fails or no object
   dictionary is present (e.g. object dictionary is generated from file
   and generation fails because of an file error). */
#define canstackERROR_DYNAMIC_DICTIONARY          (-137)

#endif /*!CANSTACKERRORS_H*/
