/*****************************************************************************
 * E.S.O. - VLT Project
 *
 * "@(#) $Id: ccdLcuPriority.h,v 4.11 2005/06/22 10:57:49 vltsccm Exp $"
 *
 * who         when     what
 * --------- -------- ---------------------------------------------------
 * alongino  09/05/98 priorities moved from ccdLcuInternal.h
 * pduhoux   25/05/98 improved priorities as of SPR980215
 */
 
/*
 ****************************************************************************
 * This header file belongs to the CCD LCU software. It contains global data
 * which is needed commonly by all CCD LCU modules.
 ****************************************************************************
 */

#ifndef CCDLCUPRIORITY_H
#define CCDLCUPRIORITY_H

#ifdef __cplusplus
extern "C" {
#endif

/*
 ****************************************************************************
 * Includes
 ****************************************************************************
 */
 
/* 
 * System Includes 
 */
/* 
 * CCD include files 
 */
/*
 ****************************************************************************
 * Data Types and Literals
 ****************************************************************************
 */
/* task priorities */
/* They have been moved from ccdLcuInternal.h in order to avoid to
   have to recompile the whole CCD LCU sw whenever one wants to reshuffle 
   priorities */
#define ccdTASK_PRIO_BASE  15
    /*
     *# Command Interpreters' priorities
     */
#define ccdTASK_PRIO_SRV_CON (ccdTASK_PRIO_BASE + 20)          /* = 35 */
#define ccdTASK_PRIO_SRV_RDT (ccdTASK_PRIO_BASE + 21)          /* = 36 */
#define ccdTASK_PRIO_SRV_SHT (ccdTASK_PRIO_BASE + 21)          /* = 36 */
#define ccdTASK_PRIO_SRV_IP  (ccdTASK_PRIO_BASE + 22)          /* = 37 */
#define ccdTASK_PRIO_SRV_IT  (ccdTASK_PRIO_BASE + 23)          /* = 38 */
#define ccdTASK_PRIO_SRV_TEL (ccdTASK_PRIO_BASE + 24)          /* = 39 */
#define ccdTASK_PRIO_SRV_TMP (ccdTASK_PRIO_BASE + 24)          /* = 39 */
#define ccdTASK_PRIO_SRV_AUX (ccdTASK_PRIO_BASE + 24)          /* = 39 */

    /*
     *# Time Critical tasks' priorities
     */
#define ccdTASK_PRIO_READ    (ccdTASK_PRIO_BASE)               /* = 15 */
#define ccdTASK_PRIO_SHUT    (ccdTASK_PRIO_BASE)               /* = 15 */
#define ccdTASK_PRIO_WIPE    (ccdTASK_PRIO_BASE + 1)           /* = 16 */
#define ccdTASK_PRIO_POLL    (ccdTASK_PRIO_BASE + 1)           /* = 16 */
#define ccdTASK_PRIO_TIME    (ccdTASK_PRIO_BASE + 2)           /* = 17 */
/* It is not nice (fishy ?) that an action task must have lower priority
 * than the server, As a matter of fact test 22 would fail on wait if
 * ccdTASK_PRIO_CTRL would be less than ccdTASK_PRIO_SRV_CON
 * Maybe simply a different priority to ccdWAIT would solve the problem
 * For the lines below SPR 980215 cannot be fulfilled
 */
    /*
     *# Time Not Critical tasks' priorities
     */
#define ccdTASK_PRIO_CTRL    (ccdTASK_PRIO_SRV_CON + 10)       /* = 45 */ 
#define ccdTASK_PRIO_WAIT    (ccdTASK_PRIO_CTRL    -  1)       /* = 44 */ 
#define ccdTASK_PRIO_PROC    (ccdTASK_PRIO_SRV_IP  + 10)       /* = 47 */ 
#define ccdTASK_PRIO_TRAN    (ccdTASK_PRIO_SRV_IT  + 10)       /* = 48 */ 

    /*
     *# Tool tasks' priorities (LOADIMG/DUMPIMG)
     */
#define ccdTASK_PRIO_TOOL    100

#ifdef __cplusplus
}
#endif

#endif  /* ! CCDLCUPRIORITY_H */

/************************************************************************/

/*___o0o___*/
