/*****************************************************************************
 * E.S.O. - VLT Project
 *
 * "@(#) $Id: ccdcon.h,v 4.7 2005/06/16 14:47:40 vltsccm Exp $"
 *
 * who            when     what
 * -------------- -------- ---------------------------------------------------
 * N.Fiebig      08/06/94 first implementation
 * N.Fiebig      22/03/95 global data address removed
 * C.Cumani      10/05/95 shAvail added in ccdconGLOBALS structure
 * C.Cumani      27/06/95 ccdconSETUP.expType: vltUINT8 -> vltINT32
 *                        ccdconSETUP.repeatDef: vltUINT16 -> vltINT32
 * C.Cumani      28/06/95 expStatus: vltUINT32 -> vltINT32
 *                        ccdconIMAGELIST.xSize: vltUINT16 -> vltINT32 
 *                        ccdconIMAGELIST.ySize: vltUINT16 -> vltINT32 
 *                        ccdconIMAGELIST.expId: vltBYTES32 -> vltINT32
 *                        ccdconIMAGELIST.expRepeat: vltUINT16 -> vltINT32
 *                        ccdconIMAGELIST.acquisitionType: vltUINT16 ->
 *                                                               -> vltINT32
 *                        ccdconIMAGELIST.storageType: vltUINT16 -> vltINT32
 *                        ccdconWINDOW.enabled: vltUINT16 -> vltLOGICAL
 *                        ccdconWINDOW.xBinning: vltUINT16 -> vltINT32
 *                        ccdconWINDOW.yBinning: vltUINT16 -> vltINT32
 *                        ccdconWINDOW.xFirst: vltUINT16 -> vltINT32 
 *                        ccdconWINDOW.xLast: vltUINT16 -> vltINT32  
 *                        ccdconWINDOW.yFirst: vltUINT16 -> vltINT32
 *                        ccdconWINDOW.yLast: vltUINT16 -> vltINT32
 * C.Cumani      12/07/95 ccdconGLOBALS.expId added
 *                        ccdconGLOBALS.imageId: vltUINT32 -> vltINT32
 * C.Cumani      14/07/95 database exposure points and setup attributes added
 *                        ccdconGLOBALS: attrTables element added
 * C.Cumani      17/07/95 - fileNameUnComp,fileNameComp,readPixelN,mpp,
 *                          clockIndex,gainIndex elements added in ccdconSETUP
 *                          structure
 *                        - window element in ccdconSETUP structure changed
 *                          from scalar into vector
 *                        - comment in ccdconGLOBALS added, for next release
 *                        - ccdconSetIndexAttr() func. prot. added
 *                        - ccdconSetIndexFromId() func. prot. added
 *                        - ccdconSetExpValues() func. prot. added
 * C.Cumani      18/07/95 - ccdconFinishTimes() func. prototype modified
 *                        - ccdconReadSetup() func. prototype modified
 *                        - ccdconSendCmdAll() func. prototype modified
 *                        - ccdconUpdateTimes() func. prototype modified
 *                        - ccdconMonitorIntegration() func. prot. modified
 * C.Cumani      21/07/95 - ccdconWINDOW.xLast -> ccdconWINDOW.xDim
 *                        - ccdconWINDOW.yLast -> ccdconWINDOW.yDim
 *                        - ccdconNumPixels() function prototype modified
 *                        - ccdconGetAddr() function prototype added
 *                        - ccdconEXP_PTS definition added
 *                        - attrTables[] added in ccdconGlobals
 * C.Cumani      04/08/95 - ccdconAllocImBuf() func. prototype modified
 * C.Cumani      21/08/95 - ccdconGetIndexFromId() func. prototype deleted
 *                          (moved in ccdcon/ws/include/ccdInternal.h)
 *                        - ccdconSetIndexAttr() func. prototype deleted
 *                          (moved in ccdcon/ws/include/ccdInternal.h as
 *                          ccdSetIndexAttr)
 * C.Cumani      22/08/95 - ccdconSYSSTATUS -> ccdconSTATE
 *                        - ccdconINITIALISED added in ccdconSTATE
 *                        - ccdconGLOBALS.sysStatus -> ccdconGLOBALS.state
 * A.Longinotti  24/08/95 - ccdconWINDOW moved to ccd.h as ccdWINDOW
 * C.Cumani      24/08/95 - ccdconSETUP.window: ccdconWINDOW -> ccdWINDOW
 *                        - ccdconAllocImBuf func. pr. corrected:
 *                          window:  ccdconWINDOW -> ccdWINDOW
 * A.Longinotti  04/09/95 ccdconNumPixels changed to ccdNumPixels and moved
 *                        to ccd.h
 * C.Cumani      19/09/95 - ccdconTransValue() func. prototype added
 *                        - ccdconHandleOff() func. prototype added
 *                        - ccdconHandleOnline() func. prototype added
 *                        - ccdconHandleStandby() func. prototype added
 *                        - ccdconHandleCont() func. prototype added
 *                        - ccdconHandleDump() func. prototype added
 *                        - ccdconHandleEnd() func. prototype added
 *                        - ccdconHandleExit() func. prototype added
 *                        - ccdconHandleInit() func. prototype added
 *                        - ccdconHandlePause() func. prototype added
 *                        - ccdconHandleSet() func. prototype added
 *                        - ccdconHandleStart() func. prototype added
 *                        - ccdconHandleStartWp() func. prototype added
 *                        - ccdconHandleStatus() func. prototype added
 *                        - ccdconHandleStopWp() func. prototype added
 *                        - ccdconHandleVersion() func. prototype added
 * C.Cumani      25/09/95 - ccdconInitDb() func. prototype added
 *                        - ccdSwitchAce() func. prototype added
 * P.Duhoux      27/09/95 - Added ccdconVERSION & ccdconVERSION_DATE
 * C.Cumani      10/10/95 - ccdconStartupCamera() func. prototype modified
 * C.Cumani      17/10/95 - ccdTestAce() func. prototype added
 * C.Cumani      18/10/95 - ccdKill() func. prototype added
 * P.Duhoux      14/11/95 - Added sysTimeout & devTimeout in ccdconGLOBALS
 *                          Added telAvail & tmpAvail in ccdconGLOBALS
 * P.Duhoux      15/11/95 Extension to support TEL & TMP subsystems
 *                        - define process priorities
 *
 *************************************************************************
 * P.Duhoux        JAN/96 Redesign similar for CCD subsystem modules
 *                        New CCD include scheme 
 *                        New signal handler interfaces for ccsInit
 *                        New design of CCD data structures          
 * P.Duhoux      08/02/96 added ccdconHandleStop() function prototype
 * P.Duhoux      16/02/96 removed parts which were common to all sub-systems
 *                        added into ccdLcuInternal.h
 * P.Duhoux      04/03/96 modified interface ccdconAllocImBuf()
 * P.Duhoux      19/04/96 Added function prototypes for Timer Handler
 * P.Duhoux      24/05/96 Added function ccdconHandleWait
 * P.Duhoux      25/07/96 Added macros for ccdconSendCmd wait mode
 * P.Duhoux      07/08/96 Moved ccdconDB_RETRY_* to ccdLcuInternal.h
 *                        Moved ccdconReadAttr,ccdconWriteAttr to ccd/lcu
 *                        Moved ccdconInitDb to ccd/lcu
 *                        Moved ccdconStartupSubsystem to ccd/lcu
 * P.Duhoux      07/08/96 Moved ccdconCMD_WAIT_* to ccdLcuInternal.h
 *                        Moved ccd*Ace.c, ccdKill.c to ccd/lcu
 *                        Moved ccdconSendCmd*.c, ccdconWaitReply.c to ccd/lcu
 * P.Duhoux      21/08/96 Moved cai entry ccdDB_STA_IMAGELST to ccdDesc
 *                        Moved ccdconDB_IMG_LST to ccdLcuInternal.h
 * P.Duhoux      14/01/97 Defined ccdconVERSION_DATE = ccdVERSION_DATE
 * P.Duhoux      03/02/97 Removed Timer function prototypes (ccdLcuInternal.h)
 * P.Duhoux      27/02/97 Updated Number of Setup Attributes
 * P.Duhoux      15/05/97 added more attributes in caiTable
 * P.Duhoux      20/05/97 added fct prototype ccdconUpdateSetup()
 * P.Duhoux      10/06/97 split into ccdcon.h & ccdconInternal.h  
 */
 
/*
 ****************************************************************************
 *
 * ccdcon.h - Exposure Server Interface File
 *
 ****************************************************************************
 */

#ifndef CCDCON_H
#define CCDCON_H

#ifdef __cplusplus
extern "C" {
#endif

/*
 ****************************************************************************
 * Includes
 ****************************************************************************
 */
 
/* 
 * CCD include files 
 */
#include "ccdLcuInternal.h"

/*
 * CCDCON include files
 */
#include "ccdconDefines.h"

/*
 ****************************************************************************
 * Data Types and Literals
 ****************************************************************************
 */
/* CCDCON module name */
#define ccdconMODULE       "ccdcon"
#define ccdconMODULE_NAME  "Exposure Control Module"
 
/* CCDCON module version */
#define ccdconVERSION      "$Revision: 4.7 $"
#define ccdconVERSION_DATE ccdVERSION_DATE

/*
 ******************************************************************************
 * Function Prototypes
 ******************************************************************************
 */
ccsCOMPL_STAT ccdconStartupCamera ( char *runStr );

/*
 ******************************************************************************
 * API Function Prototypes
 ******************************************************************************
 */
ccsCOMPL_STAT ccdconAbort       ( ccdDESCRIPTION *ccdDesc, ccsERROR *error );
ccsCOMPL_STAT ccdconCont        ( ccdDESCRIPTION *ccdDesc, ccsTIMEVAL *utc,
				  ccsERROR *error );
ccsCOMPL_STAT ccdconDump        ( ccdDESCRIPTION *ccdDesc, vltINT32 index,
				  ccsERROR *error );
ccsCOMPL_STAT ccdconEnd         ( ccdDESCRIPTION *ccdDesc, ccsERROR *error );
ccsCOMPL_STAT ccdconExit        ( ccdDESCRIPTION *ccdDesc, ccsERROR *error );
ccsCOMPL_STAT ccdconInit        ( ccdDESCRIPTION *ccdDesc, ccsERROR *error );
ccsCOMPL_STAT ccdconOff         ( ccdDESCRIPTION *ccdDesc, ccsERROR *error );
ccsCOMPL_STAT ccdconOnline      ( ccdDESCRIPTION *ccdDesc, vltINT32 expId,
				  ccsERROR *error );
ccsCOMPL_STAT ccdconStandby     ( ccdDESCRIPTION *ccdDesc, ccsERROR *error );
ccsCOMPL_STAT ccdconPause       ( ccdDESCRIPTION *ccdDesc, ccsTIMEVAL *utc,
				  ccsERROR *error );
ccsCOMPL_STAT ccdconSet         ( ccdDESCRIPTION *ccdDesc, 
				  dbSYMADDRESS attrName, 
				  vltINT32 attrIndex, char *valueStr,
				  ccsERROR *error );
ccsCOMPL_STAT ccdconSetRefPoint ( ccdDESCRIPTION *ccdDesc, 
				  vltINT32 winIdx, vltDOUBLE xRef[], 
				  vltDOUBLE yRef[], ccsERROR *error );
ccsCOMPL_STAT ccdconStart       ( ccdDESCRIPTION *ccdDesc, ccsTIMEVAL *utc,
				  vltINT32 expId, ccsERROR *error );
ccsCOMPL_STAT ccdconStartWipe   ( ccdDESCRIPTION *ccdDesc, vltINT32 periodic,
				  ccsERROR *error );
ccsCOMPL_STAT ccdconStartTele   ( ccdDESCRIPTION *ccdDesc, vltINT32 period,
				  ccsERROR *error );
ccsCOMPL_STAT ccdconStartTemp   ( ccdDESCRIPTION *ccdDesc, vltINT32 period,
				  ccsERROR *error );
ccsCOMPL_STAT ccdconStatus      ( ccdDESCRIPTION *ccdDesc, ccsERROR *error );
ccsCOMPL_STAT ccdconStop        ( ccdDESCRIPTION *ccdDesc, ccsERROR *error );
ccsCOMPL_STAT ccdconStopWait    ( ccdDESCRIPTION *ccdDesc, ccsERROR *error );
ccsCOMPL_STAT ccdconStopWipe    ( ccdDESCRIPTION *ccdDesc, ccsERROR *error );
ccsCOMPL_STAT ccdconStopTele    ( ccdDESCRIPTION *ccdDesc, ccsERROR *error );
ccsCOMPL_STAT ccdconStopTemp    ( ccdDESCRIPTION *ccdDesc, ccsERROR *error );
void          ccdconVersion     ( char *version );
ccsCOMPL_STAT ccdconWait        ( ccdDESCRIPTION *ccdDesc, msgMSG *msg,
				  vltINT32 expId, vltINT32 waitMode,  
				  vltUINT32 *expStatus, ccsERROR *error );
ccsCOMPL_STAT ccdconStopAbortWait ( ccdDESCRIPTION *ccdDesc, 
				  vltUINT32 *pExpStatus, ccsERROR *error );
/*
 ******************************************************************************
 * Signal Handlers
 ******************************************************************************
 */
void          ccdconHandleBreak ( void );
void          ccdconHandleKill  ( void );

#ifdef __cplusplus
}
#endif

#endif  /* ! CCDCON_H */

/************************************************************************/

/*___o0o___*/
