/************************************************************************
* E.S.O. - VLT project							
*									
* "@(#) $Id: ccdconDefines.h,v 4.7 2005/06/16 14:47:41 vltsccm Exp $"
*
* who           when      what
* ------------  --------  -----------------------------------------------
* P.Duhoux      10/06/97  Created
*/
/************************************************************************
*  ccdconDefines.h - Exposure Control macro definition file
*************************************************************************
*/

#ifndef CCDCON_DEFINES_H
#define CCDCON_DEFINES_H

#define ccdconMAX_SETUP_ATTR 80

#define ccdconREAD_TIMEOUT_FACTOR 5

#define ccdconEXP_INTE (ccdEXP_PENDING | ccdEXP_INTEGRATING | ccdEXP_PAUSED)
#define ccdconEXP_LOOP (ccdEXP_LOOP_FINITE | ccdEXP_LOOP_INFINITE)

/* database exposure points and setup attributes */
#define ccdconEXP_NUM_ATTR  64            /* # setup attributes            */
#define ccdconEXP_NUM_PTS  (ccdMAXEXP+1)  /* # exposures_exposure<> points */

#define ccdconEXP_SET_GEN_expType         0
#define ccdconEXP_SET_GEN_expStepsDef     1
#define ccdconEXP_SET_GEN_expRepeatDef    2
#define ccdconEXP_SET_GEN_expWipeTime     3
#define ccdconEXP_SET_GEN_frameType       4
#define ccdconEXP_SET_GEN_timeDefIdem     5 
#define ccdconEXP_SET_GEN_timeDef         6
#define ccdconEXP_SET_GEN_timeDefMulti    7
#define ccdconEXP_SET_GEN_timeRepeat      8
#define ccdconEXP_SET_GEN_fitsInfoCollect 9
#define ccdconEXP_SET_GEN_N               10

#define ccdconEXP_SET_XFR_diskSaveMethod  (ccdconEXP_SET_GEN_N+0)
#define ccdconEXP_SET_XFR_fileNameUnComp  (ccdconEXP_SET_GEN_N+1)
#define ccdconEXP_SET_XFR_fileNameComp    (ccdconEXP_SET_GEN_N+2)
#define ccdconEXP_SET_XFR_itPixRepr       (ccdconEXP_SET_GEN_N+3)
#define ccdconEXP_SET_XFR_itBitShift      (ccdconEXP_SET_GEN_N+4)
#define ccdconEXP_SET_XFR_itCompression   (ccdconEXP_SET_GEN_N+5)
#define ccdconEXP_SET_XFR_itSampling      (ccdconEXP_SET_GEN_N+6)
#define ccdconEXP_SET_XFR_itSync          (ccdconEXP_SET_GEN_N+7)
#define ccdconEXP_SET_XFR_N               (ccdconEXP_SET_GEN_N+8)

#define ccdconEXP_SET_RTD_frameId         (ccdconEXP_SET_XFR_N+0)
#define ccdconEXP_SET_RTD_N               (ccdconEXP_SET_XFR_N+1)

#define ccdconEXP_SET_RDT_linesToShiftType (ccdconEXP_SET_RTD_N+0)
#define ccdconEXP_SET_RDT_linesToShift    (ccdconEXP_SET_RTD_N+1)
#define ccdconEXP_SET_RDT_linesToShiftMulti (ccdconEXP_SET_RTD_N+2)
#define ccdconEXP_SET_RDT_readPixelN      (ccdconEXP_SET_RTD_N+3)
#define ccdconEXP_SET_RDT_mpp             (ccdconEXP_SET_RTD_N+4)
#define ccdconEXP_SET_RDT_clockIndex      (ccdconEXP_SET_RTD_N+5)
#define ccdconEXP_SET_RDT_gainIndex       (ccdconEXP_SET_RTD_N+6)
#define ccdconEXP_SET_RDT_fileNameSimu    (ccdconEXP_SET_RTD_N+7)
#define ccdconEXP_SET_RDT_N               (ccdconEXP_SET_RTD_N+8)

#define ccdconEXP_SET_WIN_N                 8
#define ccdconEXP_SET_PRC_N                16
#define ccdconEXP_SET_WINPRC_N            (ccdconEXP_SET_WIN_N + ccdconEXP_SET_PRC_N)
#define ccdconEXP_SET_WINPRC_BASE(w)      (ccdconEXP_SET_RDT_N + (w)*ccdconEXP_SET_WINPRC_N)

#define ccdconEXP_SET_WIN_enabled(w)      (ccdconEXP_SET_WINPRC_BASE(w) + 0)
#define ccdconEXP_SET_WIN_idem(w)         (ccdconEXP_SET_WINPRC_BASE(w) + 1)
#define ccdconEXP_SET_WIN_xBinning(w)     (ccdconEXP_SET_WINPRC_BASE(w) + 2)
#define ccdconEXP_SET_WIN_yBinning(w)     (ccdconEXP_SET_WINPRC_BASE(w) + 3)
#define ccdconEXP_SET_WIN_xFirst(w)       (ccdconEXP_SET_WINPRC_BASE(w) + 4)
#define ccdconEXP_SET_WIN_xDim(w)         (ccdconEXP_SET_WINPRC_BASE(w) + 5)
#define ccdconEXP_SET_WIN_yFirst(w)       (ccdconEXP_SET_WINPRC_BASE(w) + 6)
#define ccdconEXP_SET_WIN_yDim(w)         (ccdconEXP_SET_WINPRC_BASE(w) + 7)

#define ccdconEXP_SET_PRC_ipMinMax(w)         (ccdconEXP_SET_WINPRC_BASE(w) + 8)
#define ccdconEXP_SET_PRC_ipBias(w)           (ccdconEXP_SET_WINPRC_BASE(w) + 9)
#define ccdconEXP_SET_PRC_ipFlatField(w)      (ccdconEXP_SET_WINPRC_BASE(w) + 10)
#define ccdconEXP_SET_PRC_ipAverageN(w)       (ccdconEXP_SET_WINPRC_BASE(w) + 11)
#define ccdconEXP_SET_PRC_ipCentroiding(w)    (ccdconEXP_SET_WINPRC_BASE(w) + 12)
#define ccdconEXP_SET_PRC_ipCentrRefX(w)      (ccdconEXP_SET_WINPRC_BASE(w) + 13)
#define ccdconEXP_SET_PRC_ipCentrRefY(w)      (ccdconEXP_SET_WINPRC_BASE(w) + 14)
#define ccdconEXP_SET_PRC_ipCentrThreshMin(w) (ccdconEXP_SET_WINPRC_BASE(w) + 15)
#define ccdconEXP_SET_PRC_ipCentrThreshMax(w) (ccdconEXP_SET_WINPRC_BASE(w) + 16)
#define ccdconEXP_SET_PRC_ipBackGround(w)     (ccdconEXP_SET_WINPRC_BASE(w) + 17)
#define ccdconEXP_SET_PRC_ipUserFuncName(w)   (ccdconEXP_SET_WINPRC_BASE(w) + 18)
#define ccdconEXP_SET_PRC_ipUserBuffName(w)   (ccdconEXP_SET_WINPRC_BASE(w) + 19)
#define ccdconEXP_SET_PRC_ipLLX(w)            (ccdconEXP_SET_WINPRC_BASE(w) + 20)
#define ccdconEXP_SET_PRC_ipLLY(w)            (ccdconEXP_SET_WINPRC_BASE(w) + 21)
#define ccdconEXP_SET_PRC_ipURX(w)            (ccdconEXP_SET_WINPRC_BASE(w) + 22)
#define ccdconEXP_SET_PRC_ipURY(w)            (ccdconEXP_SET_WINPRC_BASE(w) + 23)



#endif  /* ! CCDCON_DEFINES_H */

/************************************************************************/

/*___o0o___*/
