/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: ccdipCV.h,v 1.68 2005/06/28 09:04:03 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* pduhoux   17/09/98  created
*/

/*
 ***********************************************************************
 * Centroid Validation : data structure & function prototype
 *----------------------------------------------------------------------
 */

#ifndef CCDIP_CV_H
#define CCDIP_CV_H

#ifdef __cplusplus
extern "C" {
#endif

typedef struct
    {
    /*
     * IN : Validation Criteria
     */
    vltINT32   minNumPix;
    vltINT32   maxSpot;
    vltDOUBLE  minSNR;
    vltDOUBLE  maxFWHM;
    vltDOUBLE  maxElongation;
    vltDOUBLE  maxOffset;
    vltDOUBLE  maxSaturation;
    vltDOUBLE  minStdDevRatio;
    vltDOUBLE  minStdDevDelta;
    /*
     * OUT : Rejection Confidence
     */
    vltINT32   rejectionConfidence;
    } ccdipCVBUF;

extern ccdipCVBUF ccdipCvBuf;

ccsCOMPL_STAT ccdipCV (ccdIPIMAGE *img, ccdipCVBUF *cvb, ccsERROR *err);

#ifdef __cplusplus
}
#endif

#endif /*!CCDIP_CV_H*/
