/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: ccdipIQE.h,v 1.68 2005/06/28 09:04:02 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* pduhoux  27/05/98  created
*/

/*
 ***********************************************************************
 * Image Quality Estimation : data structure & function prototype
 *----------------------------------------------------------------------
 */

#ifndef CCDIP_IQE_H
#define CCDIP_IQE_H

#ifdef __cplusplus
extern "C" {
#endif

typedef struct
    {
    vltDOUBLE xMPos,xMPos_SD;                /* mean X position       */
    vltDOUBLE yMPos,yMPos_SD;                /* mean Y position       */
    vltDOUBLE xFWHM,xFWHM_SD;                /* gauss fit X FWHM      */
    vltDOUBLE yFWHM,yFWHM_SD;                /* gauss fit Y FWHM      */
    vltDOUBLE ObjAngle,ObjAngle_SD;          /* orientation [degrees] */
    vltDOUBLE ObjPeak,ObjPeak_SD;            /* peak intensity        */
    vltDOUBLE BGnd,BGnd_SD;                  /* back ground level     */
    } ccdipIQEBUF;

extern ccdipIQEBUF ccdipIqeBuf;

ccsCOMPL_STAT ccdipIQE  (ccdIPIMAGE *img, ccdipIQEBUF *iqeb, ccsERROR *err);

#ifdef __cplusplus
}
#endif

#endif /*!CCDIP_IQE_H*/
