/*
****************************************************************************
* E.S.O. - VLT Project
*
* "@(#) $Id: ccdit.h,v 2.23 2005/05/10 18:17:11 vltsccm Exp $"
*
* who            when     what
* -------------- -------- ---------------------------------------------------
* N.Fiebig      08/06/94 first implementation
* A.Longinotti  24/11/94 ccditCOMPSTATUS brought to ccdInternal.h
* C.Cumani      03/05/95 ccditTrDxf and ccditTrNfs definitions added
* C.Cumani      02/08/95 transMethod element moved from ccditSETUP
*                        to ccditGLOBALS
* C.Cumani      03/08/95 ccditReadSetup function prototype modified
* C.Cumani      22/08/95 - ccditSTATUS -> ccditSTATE
*                        - ccditINITIALISED added in ccditSTATE
* C.Cumani      19/09/95 - ccditHandleOff() func. prot. added
*                        - ccditHandleOnline() func. prot. added
*                        - ccditHandleStandby() func. prot. added
* C.Cumani      05/10/95 - ccditHandleReady() func. prot. modified
*                          (parbuf parameter added)
*                        - ccditExitTransferTask -> ccditExitSendImage
* C.Cumani      11/10/95 - ccditHandleInit() func. prot. modified
*                          (globals parameter added)
* C.Cumani      18/10/95 made compatible with CMM
* C.Cumani      19/10/95 - ccditMODULE, ccditMODULE_NAME, ccditVERSION, 
*                          and ccditVERSION_DATE introduced
*                        - ccditVersion() func. prot. added
* P.Duhoux         JAN/96 Redesign similar for CCD subsystem modules
*                         New CCD include scheme 
*                         New ACI/API function interfaces
*                         New signal handler interfaces for ccsInit
* P.Duhoux       08/02/96 added ccditHandleStop() function prototype
* A.LOnginotti   12/07/96 ccditMODULE moved to ccdInternal.h
* P.Duhoux       14/01/97 Defined ccditVERSION_DATE = ccdVERSION_DATE
*/
/************************************************************************
*  ccdit.h - Server Image Transfer Interface File. 
*************************************************************************
*/
#ifndef CCDIT_H
#define CCDIT_H

#ifdef __cplusplus
extern "C" {
#endif

/* 
 * CCD include files 
 */
#include "ccdLcuInternal.h"

/*
 * CCDIT include files
 */
#include "ccditDefines.h"

/* module name */
/* AL960712 moved to ccdInternal.h: needed ny ccditWs for dxf JUN96
#define ccditMODULE       "ccdit"
*/
#define ccditMODULE_NAME  "Image Transfer Module"
 
/* module version */
#define ccditVERSION      "$Revision: 2.23 $"   
#define ccditVERSION_DATE ccdVERSION_DATE

/* transfer status */
typedef enum
    {
    ccditOFF         = ccdOFF,
    ccditLOADED      = ccdLOADED,
    ccditSTANDBY     = ccdSTANDBY,
    ccditONLINE_IDLE = ccdONLINE,     /* on-line but nothing to do */
    ccditONLINE_READY,                /* receiver ready for transfer */
    ccditONLINE_ACTIVE                /* transfer active*/
    } ccditSTATE;

typedef ccditCOMPSTATUS ccditSTATUS;

/*
 ******************************************************************************
 * CI Function Prototypes
 ******************************************************************************
 */
ccsCOMPL_STAT ccditMainTask       ( ccdDESCRIPTION *ccdDesc, ccdFIS *fis );

/*
 ******************************************************************************
 * Signal Handlers
 ******************************************************************************
 */
void          ccditHandleBreak    ( int signal );
void          ccditHandleKill     ( int signal );

/*
 ******************************************************************************
 * API Function Prototypes
 ******************************************************************************
 */
/* Standard Commands for all Sub-Systems */
ccsCOMPL_STAT ccditHandleExit     ( ccdDESCRIPTION *ccdDesc, ccsERROR *error );
ccsCOMPL_STAT ccditHandleStatus   ( ccdDESCRIPTION *ccdDesc, ccsERROR *error );
ccsCOMPL_STAT ccditHandleInit     ( ccdDESCRIPTION *ccdDesc, ccsERROR *error );
ccsCOMPL_STAT ccditHandleOff      ( ccdDESCRIPTION *ccdDesc, ccsERROR *error );
ccsCOMPL_STAT ccditHandleOnline   ( ccdDESCRIPTION *ccdDesc, ccsERROR *error );
ccsCOMPL_STAT ccditHandleReset    ( ccdDESCRIPTION *ccdDesc, ccsERROR *error );
ccsCOMPL_STAT ccditHandleStandby  ( ccdDESCRIPTION *ccdDesc, ccsERROR *error );
ccsCOMPL_STAT ccditHandleStop     ( ccdDESCRIPTION *ccdDesc, ccsERROR *error );
void          ccditVersion        ( char *version );

/* Specific Commands for IT Sub-System */
ccsCOMPL_STAT ccditHandleReady    ( ccdDESCRIPTION *ccdDesc, msgMSG *message,
				    char *parbuf, ccsERROR *error );
ccsCOMPL_STAT ccditHandleSendImage( ccdDESCRIPTION *ccdDesc, msgMSG *message,
				    char *parbuf, ccsERROR *error );

#ifdef __cplusplus
}
#endif

#endif  /* ! CCDIT_H */

/************************************************************************/

/*___o0o___*/
