/****************************************************************************
* E.S.O. - VLT Project
*
* "@(#) $Id: ccdrda.h,v 1.56 2005/05/04 14:53:47 vltsccm Exp $"
*
* who            when     what
* -------------- -------- ---------------------------------------------------
* N. Fiebig      xx/xx/94 created
* C. Cumani      28/06/94 header added
* C.Cumani      19/10/95 - ccdrdaMODULE, ccdrdaMODULE_NAME, ccdrdaVERSION, 
*                          and ccdrdaVERSION_DATE introduced
*                        - ccdrdaVersion() func. prot. added
* P.Duhoux      09/11/95  add setup to prototype ccdrdaInit
* P.Duhoux      13/11/95  modified ccdrdaDSP_PACKETSIZE to 512
* P.Duhoux      14/01/97  Defined ccdrdaVERSION_DATE = ccdVERSION_DATE
* P.Duhoux      03/02/97  Added ccdrdaSleep() func. prot.
*/
/************************************************************************
*  ccdrda.h - DCL Read-Out Control interface file
*************************************************************************
*/
#ifndef CCDRDA_H
#define CCDRDA_H

#ifdef __cplusplus
extern "C" {
#endif

/*
 * CCDRDT Public include file
 */
#include "ccdrdtPublic.h"

/*
 * DCL Common Public include file
 */
#include "ccddcl.h"

/*
 * CCDRDA include files
 */
#include "ccdrdaDefines.h"

/*
 * Constants
 */

/* module name */
#define ccdrdaMODULE       "ccdrda"
#define ccdrdaMODULE_NAME  "Readout Control DCL-ACE Module"
 
/* module version */
#define ccdrdaVERSION      "$Revision: 1.56 $"
#define ccdrdaVERSION_DATE ccdVERSION_DATE

/*
 * Function Prototypes
 */
ccsCOMPL_STAT ccdrdaInstall   ( ccdrdtDESCRIPTION *rdtDesc, ccsERROR *error );
ccsCOMPL_STAT ccdrdaDeinstall ( ccdrdtDESCRIPTION *rdtDesc, ccsERROR *error );
    
ccsCOMPL_STAT ccdrdaAttach    ( ccdrdtDESCRIPTION *rdtDesc, ccsERROR *error );
ccsCOMPL_STAT ccdrdaBreak     ( ccdrdtDESCRIPTION *rdtDesc, ccsERROR *error );
ccsCOMPL_STAT ccdrdaDetach    ( ccdrdtDESCRIPTION *rdtDesc, ccsERROR *error );
ccsCOMPL_STAT ccdrdaInit      ( ccdrdtDESCRIPTION *rdtDesc, ccsERROR *error );
ccsCOMPL_STAT ccdrdaOff       ( ccdrdtDESCRIPTION *rdtDesc, ccsERROR *error );
ccsCOMPL_STAT ccdrdaOnLine    ( ccdrdtDESCRIPTION *rdtDesc, ccsERROR *error );
ccsCOMPL_STAT ccdrdaReset     ( ccdrdtDESCRIPTION *rdtDesc, ccsERROR *error );
ccsCOMPL_STAT ccdrdaStandBy   ( ccdrdtDESCRIPTION *rdtDesc, ccsERROR *error );
ccsCOMPL_STAT ccdrdaStatus    ( ccdrdtDESCRIPTION *rdtDesc, ccsERROR *error );
void          ccdrdaVersion   ( char *version );

ccsCOMPL_STAT ccdrdaCoherence ( ccdrdtDESCRIPTION *rdtDesc, 
				vltINT16 nStp, vltINT16 nLin,
				vltINT16 tExp, vltINT16 yRef,
				ccsERROR *error );
ccsCOMPL_STAT ccdrdaLoadDsp   ( ccdrdtDESCRIPTION *rdtDesc, 
				vltBYTES32 filename, ccsERROR *error );
ccsCOMPL_STAT ccdrdaPrepare   ( ccdrdtDESCRIPTION *rdtDesc, ccsERROR *error );
ccsCOMPL_STAT ccdrdaReadImage ( ccdrdtDESCRIPTION *rdtDesc, 
				vltLOGICAL fullRead, ccsERROR *error );
ccsCOMPL_STAT ccdrdaReadRow   ( ccdrdtDESCRIPTION *rdtDesc, 
				vltLOGICAL fullRead, vltINT16 numRows, 
				ccsERROR *error );
ccsCOMPL_STAT ccdrdaShiftRow  ( ccdrdtDESCRIPTION *rdtDesc, 
				vltINT16 numRows, ccsERROR *error );
ccsCOMPL_STAT ccdrdaSkipRow   ( ccdrdtDESCRIPTION *rdtDesc, 
				vltINT16 numRows, ccsERROR *error );
ccsCOMPL_STAT ccdrdaSleep     ( ccdrdtDESCRIPTION *rdtDesc, 
				vltINT32 delay, ccsERROR *error);
ccsCOMPL_STAT ccdrdaWipe      ( ccdrdtDESCRIPTION *rdtDesc, 
				vltINT16 count, ccsERROR *error);

#ifdef __cplusplus
}
#endif

#endif   /* ! CCDRDA_H */

/************************************************************************/

/*___o0o___*/
   
