/****************************************************************************
* E.S.O. - VLT Project
*
* "@(#) $Id: ccdrdb.h,v 1.4 2005/07/28 13:47:15 vltsccm Exp $"
*
* who       when      what
* --------  --------  ------------------------------------------------------
* P.Duhoux  2003-FEB  Created
*/
/************************************************************************
*  ccdrdb.h - DCL Read-Out Control interface file for ARC Controller
*************************************************************************
*/
#ifndef CCDRDB_H
#define CCDRDB_H

#ifdef __cplusplus
extern "C" {
#endif

/*
 * CCDRDT Public include file
 */
#include "ccdrdtPublic.h"

/*
 * DCL Common Public include file
 */
#include "ccddcl.h"

/*
 * CCDRDB include files
 */
#include "ccdrdbDefines.h"

/*
 * Constants
 */

/* module name */
#define ccdrdbMODULE       "ccdrdb"
#define ccdrdbMODULE_NAME  "Readout Control DCL-ARC Module"
 
/* module version */
#define ccdrdbVERSION      "$Revision: 1.4 $"
#define ccdrdbVERSION_DATE ccdVERSION_DATE

/*
 * Function Prototypes
 */
ccsCOMPL_STAT ccdrdbInstall   ( ccdrdtDESCRIPTION *rdtDesc, ccsERROR *error );
ccsCOMPL_STAT ccdrdbDeinstall ( ccdrdtDESCRIPTION *rdtDesc, ccsERROR *error );
    
ccsCOMPL_STAT ccdrdbAttach    ( ccdrdtDESCRIPTION *rdtDesc, ccsERROR *error );
ccsCOMPL_STAT ccdrdbBreak     ( ccdrdtDESCRIPTION *rdtDesc, ccsERROR *error );
ccsCOMPL_STAT ccdrdbDetach    ( ccdrdtDESCRIPTION *rdtDesc, ccsERROR *error );
ccsCOMPL_STAT ccdrdbInit      ( ccdrdtDESCRIPTION *rdtDesc, ccsERROR *error );
ccsCOMPL_STAT ccdrdbOff       ( ccdrdtDESCRIPTION *rdtDesc, ccsERROR *error );
ccsCOMPL_STAT ccdrdbOnLine    ( ccdrdtDESCRIPTION *rdtDesc, ccsERROR *error );
ccsCOMPL_STAT ccdrdbReset     ( ccdrdtDESCRIPTION *rdtDesc, ccsERROR *error );
ccsCOMPL_STAT ccdrdbStandBy   ( ccdrdtDESCRIPTION *rdtDesc, ccsERROR *error );
ccsCOMPL_STAT ccdrdbStatus    ( ccdrdtDESCRIPTION *rdtDesc, ccsERROR *error );
void          ccdrdbVersion   ( char *version );

ccsCOMPL_STAT ccdrdbCoherence ( ccdrdtDESCRIPTION *rdtDesc, 
				vltINT32 nStp, vltINT32 nLin,
				vltINT32 tExp, vltINT32 yRef,
				ccsERROR *error );
ccsCOMPL_STAT ccdrdbLoadDsp   ( ccdrdtDESCRIPTION *rdtDesc, 
				vltBYTES32 filename, ccsERROR *error );
ccsCOMPL_STAT ccdrdbPrepare   ( ccdrdtDESCRIPTION *rdtDesc, ccsERROR *error );
ccsCOMPL_STAT ccdrdbReadImage ( ccdrdtDESCRIPTION *rdtDesc, vltLOGICAL fullRead, 
				ccsERROR *error );
ccsCOMPL_STAT ccdrdbReadRow   ( ccdrdtDESCRIPTION *rdtDesc, vltLOGICAL fullRead, 
				vltINT32 numRows, ccsERROR *error );
ccsCOMPL_STAT ccdrdbShiftRow  ( ccdrdtDESCRIPTION *rdtDesc, 
				vltINT32 numRows, ccsERROR *error );
ccsCOMPL_STAT ccdrdbSkipRow   ( ccdrdtDESCRIPTION *rdtDesc, 
				vltINT32 numRows, ccsERROR *error );
ccsCOMPL_STAT ccdrdbSleep     ( ccdrdtDESCRIPTION *rdtDesc, 
				vltINT32 delay, ccsERROR *error);
ccsCOMPL_STAT ccdrdbWipe      ( ccdrdtDESCRIPTION *rdtDesc, 
				vltINT32 count, ccsERROR *error);

#ifdef __cplusplus
}
#endif

#endif   /* ! CCDRDB_H */

/************************************************************************/

/*___o0o___*/
   
