/************************************************************************
* E.S.O. - VLT project							
*									
* "@(#) $Id: ccdsha.h,v 1.27 2005/06/22 12:49:18 vltsccm Exp $"
*
* who           when      what
* ------------  --------  -----------------------------------------------
* A.Longinotti  04/01/94  design 
* P.Duhoux      13/10/94  Implementation for Release 1.1
* C.Cumani      10/08/95  ccdshaDBPOINT definition deleted
*                         ccdshaDB_ATTR definition deleted
*                         ccdshaNUM_ATTR definition deleted
* C.Cumani      29/08/95  ccdshaAttach interface changed (opMode deleted)
* P.Duhoux      18/09/95  New include scheme
* P.Duhoux      14/01/97  Defined ccdshaVERSION_DATE = ccdVERSION_DATE
* P.Duhoux      03/02/97  Added ccdshaSleep() func. prot.
*
*/
/************************************************************************
*  ccdsha.h - DCL Shutter Control interface file
*************************************************************************
*/

#ifndef CCDSHA_H
#define CCDSHA_H

#ifdef __cplusplus
extern "C" {
#endif

/*
 * CCDSHT Public include file
 */
#include "ccdshtPublic.h"

/*
 * DCL Common Public include file
 */
#include "ccddcl.h"

/*
 * CCDSHA include files
 */
#include "ccdshaDefines.h"

/* CCDSHA module name */
#define ccdshaMODULE       "ccdsha"
#define ccdshaMODULE_NAME  "Shutter Control DCL-ACE Module"
 
/* CCDSHA module version */
#define ccdshaVERSION      "$Revision: 1.27 $"
#define ccdshaVERSION_DATE ccdVERSION_DATE

/*
 * prototypes of CCD shutter control DCL functions
 */
ccsCOMPL_STAT ccdshaInstall   ( ccdshtDESCRIPTION *shtDesc, ccsERROR *error );
ccsCOMPL_STAT ccdshaDeinstall ( ccdshtDESCRIPTION *shtDesc, ccsERROR *error );
    
ccsCOMPL_STAT ccdshaAttach    ( ccdshtDESCRIPTION *shtDesc, ccsERROR *error );
ccsCOMPL_STAT ccdshaBreak     ( ccdshtDESCRIPTION *shtDesc, ccsERROR *error );
ccsCOMPL_STAT ccdshaDetach    ( ccdshtDESCRIPTION *shtDesc, ccsERROR *error );
ccsCOMPL_STAT ccdshaGetStatus ( ccdshtDESCRIPTION *shtDesc, ccsERROR *error );
ccsCOMPL_STAT ccdshaInit      ( ccdshtDESCRIPTION *shtDesc, ccsERROR *error );
ccsCOMPL_STAT ccdshaOff       ( ccdshtDESCRIPTION *shtDesc, ccsERROR *error );
ccsCOMPL_STAT ccdshaOnLine    ( ccdshtDESCRIPTION *shtDesc, ccsERROR *error );
ccsCOMPL_STAT ccdshaReset     ( ccdshtDESCRIPTION *shtDesc, ccsERROR *error );
ccsCOMPL_STAT ccdshaStandBy   ( ccdshtDESCRIPTION *shtDesc, ccsERROR *error );
void          ccdshaVersion   ( char *version );

ccsCOMPL_STAT ccdshaSleep     ( ccdshtDESCRIPTION *shtDesc, 
				vltINT32 delay, ccsERROR *error);
ccsCOMPL_STAT ccdshaClose     ( ccdshtDESCRIPTION *shtDesc, ccsERROR *error );
ccsCOMPL_STAT ccdshaOpen      ( ccdshtDESCRIPTION *shtDesc,  
				vltINT32 expTime, ccsERROR *error );

#ifdef __cplusplus
}
#endif

#endif  /* ! CCDSHA_H */

/************************************************************************/

/*___o0o___*/
