/************************************************************************
* E.S.O. - VLT project							
*									
* "@(#) $Id: ccdsht.h,v 1.43 2003/10/17 10:43:39 vltsccm Exp $"
*
* who           when      what
* ------------  --------  -----------------------------------------------
* A.Longinotti  04/01/94  design 
* P.Duhoux      15/09/94  Preparation of Prototype 1.0
* C.Cumani      22/08/95  - ccdshtSTATUS renamed as ccdshtSTATUSDESC
*                         - ccdshtSTATE renamed as ccdshtSTATUS
*                         - new ccdshtSTATE created
*                         - ccdshtSTATUSDESC.opState: lccMODE -> ccdshtSTATE
* C.Cumani      29/08/95  ccdshtAttach interface changed (dbRoot parameter
*                         deleted)
* P.Duhoux      18/09/95  New include scheme
* C.Cumani      20/09/95  - ccdshtOnline() func. prot. added
*                         - ccdshtOff() func. prot. added
*
*************************************************************************
* P.Duhoux         JAN/96 Redesign similar for CCD subsystem modules
*                         New CCD include scheme 
*                         New ACI/API function interfaces
*                         New signal handler interfaces for ccsInit
* P.Duhoux       14/01/97 Defined ccdshtVERSION_DATE = ccdVERSION_DATE
*/
/************************************************************************
*  ccdsht.h - Server Shutter Control Interface File. 
*************************************************************************
*/
#ifndef CCDSHT_H
#define CCDSHT_H

#ifdef __cplusplus
extern "C" {
#endif

/*
 * CCD include file
 */
#include "ccdLcuInternal.h"

/*
 * CCDSHT include files
 */
#include "ccdshtDefines.h"

/* CCDSHT module name */
#define ccdshtMODULE       "ccdsht"
#define ccdshtMODULE_NAME  "Shutter Control Module"
 
/* CCDSHT module version */
#define ccdshtVERSION      "$Revision: 1.43 $"   
#define ccdshtVERSION_DATE ccdVERSION_DATE

/*
 ******************************************************************************
 * Literals
 ******************************************************************************
 */
/*
 * shutter state definition
 */
typedef enum
    {
    ccdshtOFF         = ccdOFF,
    ccdshtLOADED      = ccdLOADED,
    ccdshtSTANDBY     = ccdSTANDBY,
    ccdshtONLINE_IDLE = ccdONLINE,      /* on-line but nothing to do */
    ccdshtONLINE_ACTIVE,                /* shutter in action      */
    ccdshtONLINE_PENDING                /* shutter action pending */
    } ccdshtSTATE;

/*
 * shutter status definition
 */
typedef enum
    {
    ccdshtERROR = ccdSHT_ERROR,
    ccdshtCLOSED,
    ccdshtOPENED,
    ccdshtCLOSING,
    ccdshtOPENING
    } ccdshtSTATUS;

/*
 ******************************************************************************
 * CI Function Prototypes
 ******************************************************************************
 */
ccsCOMPL_STAT ccdshtStartServer ( ccdDESCRIPTION *ccdDesc, ccsERROR *error );

/*
 ******************************************************************************
 * Signal Handlers
 ******************************************************************************
 */
void ccdshtBreakHandler ( int signal );
void ccdshtKillHandler  ( int signal );

/*
 ******************************************************************************
 * API Function Prototypes
 ******************************************************************************
 */
/* Standard Commands for all Sub-Systems */
ccsCOMPL_STAT ccdshtExit      ( ccdDESCRIPTION *ccdDesc, ccsERROR *error );
ccsCOMPL_STAT ccdshtInit      ( ccdDESCRIPTION *ccdDesc, ccsERROR *error );
ccsCOMPL_STAT ccdshtOff       ( ccdDESCRIPTION *ccdDesc, ccsERROR *error);
ccsCOMPL_STAT ccdshtOnLine    ( ccdDESCRIPTION *ccdDesc, ccsERROR *error);
ccsCOMPL_STAT ccdshtReset     ( ccdDESCRIPTION *ccdDesc, ccsERROR *error );
ccsCOMPL_STAT ccdshtStandBy   ( ccdDESCRIPTION *ccdDesc, ccsERROR *error );
ccsCOMPL_STAT ccdshtStatus    ( ccdDESCRIPTION *ccdDesc, ccsERROR *error );
void          ccdshtVersion   ( char *version );

/* Specific Commands for SHT Sub-System */
ccsCOMPL_STAT ccdshtClose     ( ccdDESCRIPTION *ccdDesc, ccsTIMEVAL *closeTime,
				ccsERROR *error );
ccsCOMPL_STAT ccdshtOpen      ( ccdDESCRIPTION *ccdDesc, ccsTIMEVAL *openTime,
				ccsTIMEVAL *duration, ccsERROR *error );
#ifdef __cplusplus
}
#endif

#endif  /* ! CCDSHT_H */

/************************************************************************/

/*___o0o___*/


