/************************************************************************
* E.S.O. - VLT project							
*									
* "@(#) $Id: ccdshtPublic.h,v 1.43 2003/10/17 10:43:39 vltsccm Exp $"
*
* who           when      what
* ------------  --------  -----------------------------------------------
* P.Duhoux      18/09/95  New include scheme
*
*************************************************************************
* P.Duhoux         JAN/96 Redesign similar for CCD subsystem modules
*                         New CCD include scheme 
*                         New CCDSHT subsystem descriptor
*/
/************************************************************************
*  ccdshtPublic.h - This file contains all public definitions used 
*                   by the CCD DCL shutter control modules
*************************************************************************
*/

#ifndef CCDSHT_PUBLIC_H
#define CCDSHT_PUBLIC_H

#ifdef __cplusplus
extern "C" {
#endif

/*
 * CCDSHT include file
 */
#include "ccdsht.h"

/* 
 * name of shutter point in database
 */
#define ccdshtDB_SHT_POINT      "shutter" 

/*
 * definition of index for database attribute direct access
 */
typedef enum
    {
    /* DCL common part */
    ccdshtDB_PREFIX = 0,
    ccdshtDB_OPSTATE,
    ccdshtDB_STATUS,
    ccdshtDB_INITDONE,
    /* shutter specific part */
    ccdshtDB_TIMEOUT,
    ccdshtDB_TYPE,
    ccdshtDB_DESCRIPTION,
    ccdshtDB_OPEN_START_TIME,
    ccdshtDB_OPEN_DURATION,
    ccdshtDB_CLOSE_START_TIME,
    ccdshtDB_CLOSE_DURATION,
    ccdshtNUM_ATTR
    } ccdshtDB_ATTR;

/* 
 * definition of Shutter Descriptor data structure
 */
typedef struct 
    {
        /* general section */
    ccdDESCRIPTION *ccdDesc;    /* ptr to camera descriptor                  */
    ccdshtSTATE     opState;    /* operational state                         */
    ccdshtSTATUS    status;     /* shutter status                            */
    vltLOGICAL      initDone;   /* sub-system initialized flag               */
        /* shutter control section*/
    SEM_ID          breakSem;   /* break semaphore                           */
        /* time section */
    ccsTIMEVAL      openStartTime;    /* start time of OPEN  in UTC          */
    vltDOUBLE       openDuration;     /* Duration of OPEN  (in seconds)      */
    ccsTIMEVAL      closeStartTime;   /* start time of CLOSE in UTC          */
    vltDOUBLE       closeDuration;    /* Duration of CLOSE (in seconds)      */
        /* database access section */
    char           *shtAttr;    /* table of SHT attr direct addr             */
        /* IPC synchronization */
    int             openTid;    /* TID od Open  Task                         */
    int             closeTid;   /* TID od Close Task                         */
    ccdFIS          ipcOpen;    /* Open  task IPC FIS data structure         */
    ccdFIS          ipcClose;   /* Close task IPC FIS data structure         */
        /* DCL section */
    vltINT16        shxStatus;  /* shutter DCL status                        */
    char           *shxFunc;    /* table of SHX functions addr               */
    char           *shxDesc;    /* SHX Descriptor                            */
    } ccdshtDESCRIPTION;

#ifdef __cplusplus
}
#endif

#endif  /* ! CCDSHT_PUBLIC_H */

/************************************************************************/

/*___o0o___*/
