/************************************************************************
* E.S.O. - VLT project							
*									
* "@(#) $Id: ccdtelPublic.h,v 1.40 2005/06/21 08:03:19 vltsccm Exp $"
*
* who           when      what
* ------------  --------  -----------------------------------------------
* P.Duhoux      15/11/95  First version
*
*************************************************************************
* P.Duhoux         JAN/96 Redesign similar for CCD subsystem modules
*                         New CCD include scheme 
*                         New CCDTEL subsystem descriptor
*/
/************************************************************************
*  ccdtelPublic.h - This file contains all public definitions used 
*                   by the CCD DCL telemetry control modules
*************************************************************************
*/

#ifndef CCDTEL_PUBLIC_H
#define CCDTEL_PUBLIC_H

#ifdef __cplusplus
extern "C" {
#endif

/*
 * CCDTEL include file
 */
#include "ccdtel.h"

/* 
 * name of telemetry point in database
 */
#define ccdtelDB_TEL_POINT      "telemetry" 

/*
 * definition of index for database attribute direct access
 */
typedef enum
    {
    /* DCL common part */
    ccdtelDB_PREFIX = 0,
    ccdtelDB_OPSTATE,
    ccdtelDB_STATUS,
    ccdtelDB_INITDONE,
    /* telemetry specific part */
    ccdtelDB_PERIOD,
    ccdtelDB_LASTREAD,
    ccdtelDB_SENSOR,
    ccdtelDB_CURRENT,
    ccdtelDB_MESSAGE,
    ccdtelNUM_ATTR
    } ccdtelDB_ATTR;

/* 
 * definition of Telemetry Descriptor data structure
 */
typedef struct 
    {
        /* general section */
    ccdDESCRIPTION *ccdDesc;    /* ptr to camera descriptor                  */
    ccdtelSTATE     opState;    /* operational state                         */
    ccdtelSTATUS    status;     /* telemetry status                          */
    vltLOGICAL      initDone;   /* sub-system initialized flag               */
        /* database access section */
    char           *telAttr;    /* table of TEL attr direct addr             */
        /* TEL current values */
    vltDOUBLE       telValues[ccdMAXTELSRC];
    vltDOUBLE       logValues[ccdMAXTELSRC];
        /* IPC synchronization */
    ccdFIS          ipcMon;     /* Monitor task IPC FIS data structure       */
        /* Monitor Task control section */
    int             tcbMon;     /* Monitor task TCB                          */
        /* DCL section */
    vltINT16        tlxStatus;  /* telemetry DCL status                      */
    char           *tlxFunc;    /* table of TLX functions addr               */
    char           *tlxDesc;    /* TLX Descriptor                            */
    } ccdtelDESCRIPTION;

#ifdef __cplusplus
}
#endif

#endif  /* ! CCDTEL_PUBLIC_H */

/************************************************************************/

/*___o0o___*/
