/************************************************************************
* E.S.O. - VLT project							
*									
* "@(#) $Id: ccdtla.h,v 1.28 2005/03/10 08:52:59 vltsccm Exp $"
*
* who           when      what
* ------------  --------  -----------------------------------------------
* P.Duhoux      15/11/95  First version
* P.Duhoux      14/01/97  Defined ccdtlaVERSION_DATE = ccdVERSION_DATE
*/
/************************************************************************
*  ccdtla.h - DCL Telemetry Control interface file
*************************************************************************
*/

#ifndef CCDTLA_H
#define CCDTLA_H

#ifdef __cplusplus
extern "C" {
#endif

/*
 * CCDTEL Public include file
 */
#include "ccdtelPublic.h"

/*
 * DCL Common Public include file
 */
#include "ccddcl.h"

/*
 * CCDTLA include files
 */
#include "ccdtlaDefines.h"

/* CCDTLA module name */
#define ccdtlaMODULE       "ccdtla"
#define ccdtlaMODULE_NAME  "Telemetry Control DCL-ACE Module"
 
/* CCDTLA module version */
#define ccdtlaVERSION      "$Revision: 1.28 $"
#define ccdtlaVERSION_DATE ccdVERSION_DATE


/*
 * prototypes of CCD telemetry control DCL functions
 */
ccsCOMPL_STAT ccdtlaInstall   ( ccdtelDESCRIPTION *telDesc, ccsERROR *error );
ccsCOMPL_STAT ccdtlaDeinstall ( ccdtelDESCRIPTION *telDesc, ccsERROR *error );
    
ccsCOMPL_STAT ccdtlaAttach    ( ccdtelDESCRIPTION *telDesc, ccsERROR *error );
ccsCOMPL_STAT ccdtlaBreak     ( ccdtelDESCRIPTION *telDesc, ccsERROR *error );
ccsCOMPL_STAT ccdtlaDetach    ( ccdtelDESCRIPTION *telDesc, ccsERROR *error );
ccsCOMPL_STAT ccdtlaGetStatus ( ccdtelDESCRIPTION *telDesc, ccsERROR *error );
ccsCOMPL_STAT ccdtlaInit      ( ccdtelDESCRIPTION *telDesc, ccsERROR *error );
ccsCOMPL_STAT ccdtlaOff       ( ccdtelDESCRIPTION *telDesc, ccsERROR *error );
ccsCOMPL_STAT ccdtlaOnLine    ( ccdtelDESCRIPTION *telDesc, ccsERROR *error );
ccsCOMPL_STAT ccdtlaReset     ( ccdtelDESCRIPTION *telDesc, ccsERROR *error );
ccsCOMPL_STAT ccdtlaStandBy   ( ccdtelDESCRIPTION *telDesc, ccsERROR *error );
void          ccdtlaVersion   ( char *version );

ccsCOMPL_STAT ccdtlaGetParam  ( ccdtelDESCRIPTION *telDesc, ccsERROR *error );
ccsCOMPL_STAT ccdtlaSetParam  ( ccdtelDESCRIPTION *telDesc, ccsERROR *error );

#ifdef __cplusplus
}
#endif

#endif  /* ! CCDTLA_H */

/************************************************************************/

/*___o0o___*/
