/************************************************************************
* E.S.O. - VLT project							
*									
* "@(#) $Id: ccdtma.h,v 1.27 2005/03/10 08:53:19 vltsccm Exp $"
*
* who           when      what
* ------------  --------  -----------------------------------------------
* P.Duhoux      15/11/95  First version
* P.Duhoux      14/01/97  Defined ccdtmaVERSION_DATE = ccdVERSION_DATE
*/
/************************************************************************
*  ccdtma.h - DCL Temperature Control interface file
*************************************************************************
*/

#ifndef CCDTMA_H
#define CCDTMA_H

#ifdef __cplusplus
extern "C" {
#endif

/*
 * CCDTMP Public include file
 */
#include "ccdtmpPublic.h"

/*
 * DCL Common Public include file
 */
#include "ccddcl.h"

/*
 * CCDTMA include files
 */
#include "ccdtmaDefines.h"

/* CCDTMA module name */
#define ccdtmaMODULE       "ccdtma"
#define ccdtmaMODULE_NAME  "Temperature Control DCL-ACE Module"
 
/* CCDTMA module version */
#define ccdtmaVERSION      "$Revision: 1.27 $"
#define ccdtmaVERSION_DATE ccdVERSION_DATE

/*
 * prototypes of CCD temperature control DCL functions
 */
ccsCOMPL_STAT ccdtmaInstall   ( ccdtmpDESCRIPTION *tmpDesc, ccsERROR *error );
ccsCOMPL_STAT ccdtmaDeinstall ( ccdtmpDESCRIPTION *tmpDesc, ccsERROR *error );
    
ccsCOMPL_STAT ccdtmaAttach    ( ccdtmpDESCRIPTION *tmpDesc, ccsERROR *error );
ccsCOMPL_STAT ccdtmaBreak     ( ccdtmpDESCRIPTION *tmpDesc, ccsERROR *error );
ccsCOMPL_STAT ccdtmaDetach    ( ccdtmpDESCRIPTION *tmpDesc, ccsERROR *error );
ccsCOMPL_STAT ccdtmaGetStatus ( ccdtmpDESCRIPTION *tmpDesc, ccsERROR *error );
ccsCOMPL_STAT ccdtmaInit      ( ccdtmpDESCRIPTION *tmpDesc, ccsERROR *error );
ccsCOMPL_STAT ccdtmaOff       ( ccdtmpDESCRIPTION *tmpDesc, ccsERROR *error );
ccsCOMPL_STAT ccdtmaOnLine    ( ccdtmpDESCRIPTION *tmpDesc, ccsERROR *error );
ccsCOMPL_STAT ccdtmaReset     ( ccdtmpDESCRIPTION *tmpDesc, ccsERROR *error );
ccsCOMPL_STAT ccdtmaStandBy   ( ccdtmpDESCRIPTION *tmpDesc, ccsERROR *error );
void          ccdtmaVersion   ( char *version );

ccsCOMPL_STAT ccdtmaGetParam  ( ccdtmpDESCRIPTION *tmpDesc, ccsERROR *error );
ccsCOMPL_STAT ccdtmaSetParam  ( ccdtmpDESCRIPTION *tmpDesc, ccsERROR *error );

#ifdef __cplusplus
}
#endif

#endif  /* ! CCDTMA_H */

/************************************************************************/

/*___o0o___*/
