/************************************************************************
* E.S.O. - VLT project							
*									
* "@(#) $Id: ccdtmpDefines.h,v 1.43 2005/06/21 08:07:54 vltsccm Exp $"
*
* who           when      what
* ------------  --------  -----------------------------------------------
* P.Duhoux      15/11/95  First version
* P.Duhoux      04/11/97  added ccdtmpINVALID_TEMPERATURE_VALUE = -99.9
*
*/
/************************************************************************
*  ccdtmpDefines.h - Temperature Control macro definition file
*************************************************************************
*/

#ifndef CCDTMP_DEFINES_H
#define CCDTMP_DEFINES_H

#define ccdtmpMESSAGE_NOTAVAIL  "Temperature monitoring system not available"
#define ccdtmpMESSAGE_DISABLED  "Temperature monitoring system disabled"
#define ccdtmpMESSAGE_HWFAILURE "Hardware Failure : Check connections to CCD head"
#define ccdtmpMESSAGE_COOLING   "Chip is cooling down ... Please wait (60s)"
#define ccdtmpMESSAGE_IDLE      "Temperature monitoring system not active"
#define ccdtmpMESSAGE_OK        "All temperature values OK"

#define ccdtmpMESSAGE_FMT1 \
    "TMP%i (%s %s) : %.1f %s - Out of range %.1f to %.1f %s"
#define ccdtmpMESSAGE_FMTN \
	"%d temperature values are out of range - See logs"

    /*
     * max abs difference to previous measure for issuing the FITS ops-log :
     * DET TMPi PARM = <val>
     */
#define ccdtmpDELTA        0.5  

    /*
     * preset values
     */
#define ccdtmpINVALID_TEMPERATURE_VALUE -99.9

    /*
     * Delay [sec] necessary for temp values to stabilize after INIT
     */
#define ccdtmpIGNORE_DELAY 60

#endif  /* ! CCDTMP_DEFINES_H */

/************************************************************************/

/*___o0o___*/
