/************************************************************************
* E.S.O. - VLT project							
*									
* "@(#) $Id: ccdtmpPublic.h,v 1.43 2005/06/21 08:07:54 vltsccm Exp $"
*
* who           when      what
* ------------  --------  -----------------------------------------------
* P.Duhoux      15/11/95  First version
*
*************************************************************************
* P.Duhoux         JAN/96 Redesign similar for CCD subsystem modules
*                         New CCD include scheme 
*                         New CCDTMP subsystem descriptor
*/
/************************************************************************
*  ccdtmpPublic.h - This file contains all public definitions used 
*                   by the CCD DCL temperature control modules
*************************************************************************
*/

#ifndef CCDTMP_PUBLIC_H
#define CCDTMP_PUBLIC_H

#ifdef __cplusplus
extern "C" {
#endif

/*
 * CCDTMP include file
 */
#include "ccdtmp.h"

/* 
 * name of temperature point in database
 */
#define ccdtmpDB_TMP_POINT      "temperature" 

/*
 * definition of index for database attribute direct access
 */
typedef enum
    {
    /* DCL common part */
    ccdtmpDB_PREFIX = 0,
    ccdtmpDB_OPSTATE,
    ccdtmpDB_STATUS,
    ccdtmpDB_INITDONE,
    /* temperature specific part */
    ccdtmpDB_PERIOD,
    ccdtmpDB_LASTREAD,
    ccdtmpDB_SENSOR,
    ccdtmpDB_CURRENT,
    ccdtmpDB_MESSAGE,
    ccdtmpNUM_ATTR
    } ccdtmpDB_ATTR;

/* 
 * definition of Temperature Descriptor data structure
 */
typedef struct
    {
        /* general section */
    ccdDESCRIPTION *ccdDesc;    /* ptr to camera descriptor                  */
    ccdtmpSTATE     opState;    /* operational state                         */
    ccdtmpSTATUS    status;     /* temperature status                        */
    vltLOGICAL      initDone;   /* sub-system initialized flag               */
    ccsTIMEVAL      initUTC;    /* UTC Init Time                             */
        /* database access section */
    char           *tmpAttr;    /* table of TMP attr direct addr             */
        /* TMP current values */
    vltDOUBLE       tmpValues[ccdMAXTMPSRC];
    vltDOUBLE       logValues[ccdMAXTMPSRC];
        /* IPC synchronization */
    ccdFIS          ipcMon;     /* Monitor task IPC FIS data structure       */
        /* Monitor Task control section */
    int             tcbMon;     /* Monitor task TCB                          */
        /* DCL section */
    vltINT16        tmxStatus;  /* temperature DCL status                    */
    char           *tmxFunc;    /* table of TMX functions addr               */
    char           *tmxDesc;    /* TMX Descriptor                            */
    } ccdtmpDESCRIPTION;

#ifdef __cplusplus
}
#endif

#endif  /* ! CCDTMP_PUBLIC_H */

/************************************************************************/

/*___o0o___*/
