/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: cmdLCC.h,v 4.97.1.1 2005/10/24 13:55:43 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* bgustafs 2003-09-05 added obituary handler
* bgustafs 2003-09-04 added cmdInitObi for obituary support, SPR20030314
* gfilippi  27/09/95  created from $VLTSCCM/VLTSW/LCC/2.2.4/lcc
*
*/

/*-----------------------------------------------------------------------------
*  ESO VLT              LCU Common Software              SPACEBEL Informatique
*------------------------------------------------------------------------------
*  Version      Date            Author          Comment
*------------------------------------------------------------------------------
*  1.1          18/12/93        lccteam         First version
*  2.1          31/01/95        P.Rochez        Created LCC specific include
*                                               file
*                                               Changed type of argument param
*                                               and cmdGetArgument() function
*                                               Removed cmdSetTestError()
*  2.2		31/05/95	P.Rochez	SPR 950111: added cmdTerminate()
*------------------------------------------------------------------------------
*  SCCS Id:  cmdLCC.h  2.2  13 Jun 1995
*----------------------------------------------------------------------------*/

/*
 * <cmdLCC.h> - LCU / COMMAND INTERPRETER Interface File
 */

/************************************************************************
 *                      LCU Specific Definitions                        *
 ************************************************************************/

/*
 * Constants
 */

#define cmdPARAM_DELIM   ","

/*
 * Data types
 */

/*none*/


/*
 * Functions prototypes
 */

ccsCOMPL_STAT cmdInit(                  /* Start command interpreter    */
    const ccsPROCNAME procName,         /* Command interpreter name     */ 
    const char        *defFile,         /* Definition table filename    */
    const char        *interpretFile,   /* Interpreter table filename   */
    void             (*breakHandler)(), /* Break handler, NULL=no handler */
    void             (*killHandler)(),  /* Kill handler, NULL=default handler */
    void              *argument,        /* User provided argument       */
    ccsERROR          *error            /* Returned error structure     */
    );

ccsCOMPL_STAT cmdInitObi(               /* Start command interpreter    */
    const ccsPROCNAME procName,         /* Command interpreter name     */ 
    const char        *defFile,         /* Definition table filename    */
    const char        *interpretFile,   /* Interpreter table filename   */
    vltUINT32         obituary,         /* Flag for obituary handling   */
    FUNCPTR           obiHandler,       /* Obituary handler             */
    void             (*breakHandler)(), /* Break handler, NULL=no handler */
    void             (*killHandler)(),  /* Kill handler, NULL=default handler */
    void              *argument,        /* User provided argument       */
    ccsERROR          *error            /* Returned error structure     */
    );

void *cmdGetArgument(void);             /* Retrieve argument given to cmdInit */

void cmdTerminate(void);                /* Trigger the termination of a */
                                        /* Command Interpreter          */

