/******************************************************************************
*  E.S.O. - VLT project
* 
*  "@(#) $Id: ic0devDefines.h,v 1.93 2005/08/14 18:41:10 vltsccm Exp $"
* 
*  who       when      what
*  --------  --------  ----------------------------------------------
*  rschmutz  07/07/99  ic0devMOT_ACTION_SAMPLE, CNCT added.
*  rschmutz  17/08/98  ic0devSTATUS_* added.
*  rschmutz  19/06/98  ic0devLOG_MAX_LEN added.
*  rschmutz  29/03/98  ic0devMOT_SET_JOG added.
*  rschmutz  22/10/97  ic0devMOT_SET_LIMIT and ic0devMOT_SET_TURN added.
*  rschmutz  24/07/97  ic0devMOT_GET_POS_ENCREL added.
*  rschmutz  17/06/97  ic0devSET_NONE added
*  rschmutz  26/10/95  Created
*
*/

/*************************************************************************
*    NAME
*	ic0devDefines.h - module header file, define part
* 
* 
*    DESCRIPTION
*	This is a header file of the module ic0dev.
* 
* 
*-------------------------------------------------------------------------
*/

#ifndef IC0DEV_DEFINES_H
#define IC0DEV_DEFINES_H

#include "lccdevDefines.h"


#define ic0devMODULE	"ic0dev"


/*
 * manager restriction types
 */
#define ic0devREST_END			 0
#define ic0devREST_ONLINE		 1
#define ic0devREST_SIMULATION		 2
#define ic0devREST_SEMAPHORE		 3
#define ic0devREST_STATUS		 4
#define ic0devREST_GETVAL		 5
#define ic0devREST_BEGIN_VAR_SET	 6
#define ic0devREST_BEGIN_VAR_WAIT	 7
#define ic0devREST_END_VAR_SET 		 8
#define ic0devREST_END_VAR_WAIT		 9
#define ic0devREST_USER_FUNCTION	10

#define ic0devOP_EQUAL			 1
#define ic0devOP_NOT_EQUAL		 2
#define ic0devOP_GREATER		 3
#define ic0devOP_LESS			 4
#define ic0devOP_GREATER_EQUAL		 5
#define ic0devOP_LESS_EQUAL		 6
#define ic0devOP_BIT_SET		 7
#define ic0devOP_BIT_CLEAR		 8
					 
#define ic0devREST_AND			 0
#define ic0devREST_OR			 1

/*
 * parameter sets position, speed or timeout
 */
#define ic0devMOT_SET_NONE		 0
#define ic0devMOT_SET_POS_VALUE		 1
#define ic0devMOT_SET_POS_OFFSET	 2
#define ic0devMOT_SET_POS_INDEX		 3
#define ic0devMOT_SET_POS_OBSERVATION	 4
#define ic0devMOT_SET_POS_MAINTENANCE	 5
#define ic0devMOT_SET_POS_USER_DEFINED	 6
#define ic0devMOT_SET_POS_ID		 7
#define ic0devMOT_SET_POS_NAME		 8
#define ic0devMOT_SET_POS_TYPE		 9
#define ic0devMOT_SET_POS_ANY		10
#define ic0devMOT_SET_SPEED		11
#define ic0devMOT_SET_SPEED_NAME	12
#define ic0devMOT_SET_SPEED_INDEX	13
#define ic0devMOT_SET_WAIT_TIME	 	14
#define ic0devMOT_SET_POS2_VALUE 	15
#define ic0devMOT_SET_LIMIT		16
#define ic0devMOT_SET_TURN		17
#define ic0devMOT_SET_MOVE_ST		18
#define ic0devMOT_SET_MOVE_MODE		19
#define ic0devMOT_SET_JOG		20

/*
 * parameter get status value
 */
#define ic0devGET_FIRST			1    /* lcctooGET_FIRST	          */

#define ic0devMOT_GET_FIRST		15  /* (lccdevGET_LAST + 1)	  */
#define ic0devMOT_GET_OPMODE		15  /* (ic0devMOT_GET_FIRST +  0) */
#define ic0devMOT_GET_MOTIONMODE	16  /* (ic0devMOT_GET_FIRST +  1) */
#define ic0devMOT_GET_MOTIONSTATUS	17  /* (ic0devMOT_GET_FIRST +  2) */
#define ic0devMOT_GET_MOTIONSTEP	18  /* (ic0devMOT_GET_FIRST +  3) */
#define ic0devMOT_GET_INITSTATUS	19  /* (ic0devMOT_GET_FIRST +  4) */
#define ic0devMOT_GET_INITSTEP		20  /* (ic0devMOT_GET_FIRST +  5) */
#define ic0devMOT_GET_BRAKE		21  /* (ic0devMOT_GET_FIRST +  6) */
#define ic0devMOT_GET_AXIS		22  /* (ic0devMOT_GET_FIRST +  7) */
#define ic0devMOT_GET_EVENTMASK		23  /* (ic0devMOT_GET_FIRST +  8) */
#define ic0devMOT_GET_AMPLIFIER		24  /* (ic0devMOT_GET_FIRST +  9) */
#define ic0devMOT_GET_POWER		25  /* (ic0devMOT_GET_FIRST + 10) */
#define ic0devMOT_GET_CONTROLLER	26  /* (ic0devMOT_GET_FIRST + 11) */
#define ic0devMOT_GET_INPOSITION	27  /* (ic0devMOT_GET_FIRST + 12) */
#define ic0devMOT_GET_INTERLOCK		28  /* (ic0devMOT_GET_FIRST + 13) */
#define ic0devMOT_GET_SPEED		29  /* (ic0devMOT_GET_FIRST + 14) */
#define ic0devMOT_GET_CURRENT		30  /* (ic0devMOT_GET_FIRST + 15) */
#define ic0devMOT_GET_POSENC		31  /* (ic0devMOT_GET_FIRST + 16) */
#define ic0devMOT_GET_POSUSER		32  /* (ic0devMOT_GET_FIRST + 17) */
#define ic0devMOT_GET_POSNAME		33  /* (ic0devMOT_GET_FIRST + 18) */
#define ic0devMOT_GET_NEXTPOSENC	34  /* (ic0devMOT_GET_FIRST + 19) */
#define ic0devMOT_GET_NEXTPOSUSER	35  /* (ic0devMOT_GET_FIRST + 20) */
#define ic0devMOT_GET_NEXTPOSNAME	36  /* (ic0devMOT_GET_FIRST + 21) */
#define ic0devMOT_GET_FOLLOWINGERR	37  /* (ic0devMOT_GET_FIRST + 22) */
#define ic0devMOT_GET_STARTTIME		38  /* (ic0devMOT_GET_FIRST + 23) */
#define ic0devMOT_GET_ENDTIME		39  /* (ic0devMOT_GET_FIRST + 24) */
#define ic0devMOT_GET_AMPLLIMIT		40  /* (ic0devMOT_GET_FIRST + 25) */
#define ic0devMOT_GET_MCONLIMIT		41  /* (ic0devMOT_GET_FIRST + 26) */
#define ic0devMOT_GET_POS_OFFSET	42  /* (ic0devMOT_GET_FIRST + 27) */
#define ic0devMOT_GET_NEXTPOS_OFFSET	43  /* (ic0devMOT_GET_FIRST + 28) */
#define ic0devMOT_GET_POS_ENCREL	44  /* (ic0devMOT_GET_FIRST + 29) */

#define ic0devMOT_GET_OPMODE1		45  /* (ic0devMOT_GET_FIRST + 30) */
#define ic0devMOT_GET_MOTIONMODE1	46  /* (ic0devMOT_GET_FIRST + 31) */
#define ic0devMOT_GET_MOTIONSTATUS1	47  /* (ic0devMOT_GET_FIRST + 32) */
#define ic0devMOT_GET_MOTIONSTEP1	48  /* (ic0devMOT_GET_FIRST + 33) */
#define ic0devMOT_GET_INITSTATUS1	49  /* (ic0devMOT_GET_FIRST + 34) */
#define ic0devMOT_GET_INITSTEP1		50  /* (ic0devMOT_GET_FIRST + 35) */
#define ic0devMOT_GET_BRAKE1		51  /* (ic0devMOT_GET_FIRST + 36) */
#define ic0devMOT_GET_AXIS1		52  /* (ic0devMOT_GET_FIRST + 37) */
#define ic0devMOT_GET_EVENTMASK1	53  /* (ic0devMOT_GET_FIRST + 38) */
#define ic0devMOT_GET_AMPLIFIER1	54  /* (ic0devMOT_GET_FIRST + 39) */
#define ic0devMOT_GET_POWER1		55  /* (ic0devMOT_GET_FIRST + 40) */
#define ic0devMOT_GET_CONTROLLER1	56  /* (ic0devMOT_GET_FIRST + 41) */
#define ic0devMOT_GET_INPOSITION1	57  /* (ic0devMOT_GET_FIRST + 42) */
#define ic0devMOT_GET_INTERLOCK1	58  /* (ic0devMOT_GET_FIRST + 43) */
#define ic0devMOT_GET_SPEED1		59  /* (ic0devMOT_GET_FIRST + 44) */
#define ic0devMOT_GET_CURRENT1		60  /* (ic0devMOT_GET_FIRST + 45) */
#define ic0devMOT_GET_POSENC1		61  /* (ic0devMOT_GET_FIRST + 46) */
#define ic0devMOT_GET_POSUSER1		62  /* (ic0devMOT_GET_FIRST + 47) */
#define ic0devMOT_GET_POSNAME1		63  /* (ic0devMOT_GET_FIRST + 48) */
#define ic0devMOT_GET_NEXTPOSENC1	64  /* (ic0devMOT_GET_FIRST + 49) */
#define ic0devMOT_GET_NEXTPOSUSER1	65  /* (ic0devMOT_GET_FIRST + 50) */
#define ic0devMOT_GET_NEXTPOSNAME1	66  /* (ic0devMOT_GET_FIRST + 51) */
#define ic0devMOT_GET_FOLLOWINGERR1	67  /* (ic0devMOT_GET_FIRST + 52) */
#define ic0devMOT_GET_STARTTIME1	68  /* (ic0devMOT_GET_FIRST + 53) */
#define ic0devMOT_GET_ENDTIME1		69  /* (ic0devMOT_GET_FIRST + 54) */
#define ic0devMOT_GET_AMPLLIMIT1	70  /* (ic0devMOT_GET_FIRST + 55) */
#define ic0devMOT_GET_MCONLIMIT1	71  /* (ic0devMOT_GET_FIRST + 56) */
#define ic0devMOT_GET_POS_OFFSET1	72  /* (ic0devMOT_GET_FIRST + 57) */
#define ic0devMOT_GET_NEXTPOS_OFFSET1	73  /* (ic0devMOT_GET_FIRST + 58) */
#define ic0devMOT_GET_POS_ENCREL1	74  /* (ic0devMOT_GET_FIRST + 59) */

#define ic0devMOT_GET_OPMODE2		75  /* (ic0devMOT_GET_FIRST + 60) */
#define ic0devMOT_GET_MOTIONMODE2	76  /* (ic0devMOT_GET_FIRST + 61) */
#define ic0devMOT_GET_MOTIONSTATUS2	77  /* (ic0devMOT_GET_FIRST + 62) */
#define ic0devMOT_GET_MOTIONSTEP2	78  /* (ic0devMOT_GET_FIRST + 63) */
#define ic0devMOT_GET_INITSTATUS2	79  /* (ic0devMOT_GET_FIRST + 64) */
#define ic0devMOT_GET_INITSTEP2		80  /* (ic0devMOT_GET_FIRST + 65) */
#define ic0devMOT_GET_BRAKE2		81  /* (ic0devMOT_GET_FIRST + 66) */
#define ic0devMOT_GET_AXIS2		82  /* (ic0devMOT_GET_FIRST + 67) */
#define ic0devMOT_GET_EVENTMASK2	83  /* (ic0devMOT_GET_FIRST + 68) */
#define ic0devMOT_GET_AMPLIFIER2	84  /* (ic0devMOT_GET_FIRST + 69) */
#define ic0devMOT_GET_POWER2		85  /* (ic0devMOT_GET_FIRST + 70) */
#define ic0devMOT_GET_CONTROLLER2	86  /* (ic0devMOT_GET_FIRST + 71) */
#define ic0devMOT_GET_INPOSITION2	87  /* (ic0devMOT_GET_FIRST + 72) */
#define ic0devMOT_GET_INTERLOCK2	88  /* (ic0devMOT_GET_FIRST + 73) */
#define ic0devMOT_GET_SPEED2		89  /* (ic0devMOT_GET_FIRST + 74) */
#define ic0devMOT_GET_CURRENT2		90  /* (ic0devMOT_GET_FIRST + 75) */
#define ic0devMOT_GET_POSENC2		91  /* (ic0devMOT_GET_FIRST + 76) */
#define ic0devMOT_GET_POSUSER2		92  /* (ic0devMOT_GET_FIRST + 77) */
#define ic0devMOT_GET_POSNAME2		93  /* (ic0devMOT_GET_FIRST + 78) */
#define ic0devMOT_GET_NEXTPOSENC2	94  /* (ic0devMOT_GET_FIRST + 79) */
#define ic0devMOT_GET_NEXTPOSUSER2	95  /* (ic0devMOT_GET_FIRST + 80) */
#define ic0devMOT_GET_NEXTPOSNAME2	96  /* (ic0devMOT_GET_FIRST + 81) */
#define ic0devMOT_GET_FOLLOWINGERR2	97  /* (ic0devMOT_GET_FIRST + 82) */
#define ic0devMOT_GET_STARTTIME2	98  /* (ic0devMOT_GET_FIRST + 83) */
#define ic0devMOT_GET_ENDTIME2		99  /* (ic0devMOT_GET_FIRST + 84) */
#define ic0devMOT_GET_AMPLLIMIT2	100 /* (ic0devMOT_GET_FIRST + 85) */
#define ic0devMOT_GET_MCONLIMIT2	101 /* (ic0devMOT_GET_FIRST + 86) */
#define ic0devMOT_GET_POS_OFFSET2	102 /* (ic0devMOT_GET_FIRST + 87) */
#define ic0devMOT_GET_NEXTPOS_OFFSET2	103 /* (ic0devMOT_GET_FIRST + 88) */
#define ic0devMOT_GET_POS_ENCREL2	104 /* (ic0devMOT_GET_FIRST + 89) */

#define ic0devMOT_GET_INSTALLED		105 /* (ic0devMOT_GET_FIRST + 90) */
#define ic0devMOT_GET_ATTACHED		106 /* (ic0devMOT_GET_FIRST + 91) */
#define ic0devMOT_GET_PARKED		107 /* (ic0devMOT_GET_FIRST + 92) */
#define ic0devMOT_GET_INIT_TIMEOUT	108 /* (ic0devMOT_GET_FIRST + 93) */
#define ic0devMOT_GET_MOVE_TIMEOUT	109 /* (ic0devMOT_GET_FIRST + 94) */
#define ic0devMOT_GET_POS_INDEX		110 /* (ic0devMOT_GET_FIRST + 95) */
#define ic0devMOT_GET_POS_OBSERVATION	111 /* (ic0devMOT_GET_FIRST + 96) */
#define ic0devMOT_GET_POS_MAINTENANCE	112 /* (ic0devMOT_GET_FIRST + 97) */
#define ic0devMOT_GET_POS_USER_DEFINED	113 /* (ic0devMOT_GET_FIRST + 98) */
#define ic0devMOT_GET_POS_ID		114 /* (ic0devMOT_GET_FIRST + 99) */
#define ic0devMOT_GET_POS_NAME		115 /* (ic0devMOT_GET_FIRST +100) */
#define ic0devMOT_GET_POS_TYPE		116 /* (ic0devMOT_GET_FIRST +101) */
#define ic0devMOT_GET_POS_LOGICAL	117 /* (ic0devMOT_GET_FIRST +102) */
#define ic0devMOT_GET_POS2_USER		118 /* (ic0devMOT_GET_FIRST +103) */
#define ic0devMOT_GET_NEXTPOS2_USER	119 /* (ic0devMOT_GET_FIRST +104) */
#define ic0devMOT_GET_MOVE_ST		120 /* (ic0devMOT_GET_FIRST +105) */
#define ic0devMOT_GET_MOVE_MODE		121 /* (ic0devMOT_GET_FIRST +106) */

#define ic0devMOT_GET_LAST		121 /* (ic0devMOT_GET_FIRST +106) */


/*
 * lamp
 */
#define ic0devLAMP_SET_ST		3

#define ic0devLAMP_GET_FIRST		15  /* (lccdevGET_LAST + 1)	  */
#define ic0devLAMP_GET_ID		15  /* (ic0devLAMP_GET_FIRST + 0) */
#define ic0devLAMP_GET_NAME		16  /* (ic0devLAMP_GET_FIRST + 1) */
#define ic0devLAMP_GET_LAST		16  /* (ic0devLAMP_GET_FIRST + 1) */


/*
 * temperature
 */
#define ic0devTEMP_GET_FIRST		15  /* (lccdevGET_LAST + 1)	  */
#define ic0devTEMP_GET_ID		15  /* (ic0devTEMP_GET_FIRST + 0) */
#define ic0devTEMP_GET_VALUE		16  /* (ic0devTEMP_GET_FIRST + 1) */
#define ic0devTEMP_GET_LAST		16  /* (ic0devTEMP_GET_FIRST + 1) */


/*
 * status strings
 */
#define ic0devMOT_AMPLLIMIT_STRING	"AmplifierLimit"
#define ic0devMOT_MCONLIMIT_STRING	"ControllerLimit"
#define ic0devMOT_POS_OFFSET_STRING	"Offset"
#define ic0devMOT_NEXTPOS_OFFSET_STRING	"NextOffset"
#define ic0devMOT_POS_ENCREL_STRING	"EncRel"
#define ic0devMOT_INSTALLED_STRING	"Installed"
#define ic0devMOT_ATTACHED_STRING	"Attached"
#define ic0devMOT_PARKED_STRING		"Parked"
#define ic0devMOT_INIT_TIMEOUT_STRING	"InitTimeout"
#define ic0devMOT_MOVE_TIMEOUT_STRING	"MoveTimeout"
#define ic0devMOT_POS_INDEX_STRING	"No"
#define ic0devMOT_POS_OBSERVATION_STRING  "Observation"
#define ic0devMOT_POS_MAINTENANCE_STRING  "Maintenance"
#define ic0devMOT_POS_USER_DEFINED_STRING "UserDefined"
#define ic0devMOT_POS_ID_STRING		"Id"
#define ic0devMOT_POS_NAME_STRING	"Name"
#define ic0devMOT_POS_TYPE_STRING	"Type"
#define ic0devMOT_POS_LOGICAL_STRING	"PosLogical"
#define ic0devMOT_POS2_USER_STRING	"Position"
#define ic0devMOT_NEXTPOS2_USER_STRING	"NextPosition"
#define ic0devMOT_MOVE_ST_STRING	"St"
#define ic0devMOT_MOVE_MODE_STRING	"Mode"

#define ic0devLAMP_ID_STRING		"Id"
#define ic0devLAMP_NAME_STRING		"Name"

#define ic0devTEMP_ID_STRING		"Id"
#define ic0devTEMP_VALUE_STRING		"Value"

#define ic0devMOT_MOVE_MODE_ON_STRING	"ON"
#define ic0devMOT_MOVE_MODE_OFF_STRING	"OFF"

/*
 * parameter steps
 */
#define ic0devSTEP_NONE		 	 0
#define ic0devSTEP_STORED		 1
#define ic0devSTEP_EXECUTING	 	 2
#define ic0devSTEP_USED			 3

/*
 * actions
 */
#define ic0devMOT_ACTION_ADD_PARAM	 1
#define ic0devMOT_ACTION_ADD_VALUE	 2
#define ic0devMOT_ACTION_CLAMP_BRAKE	 3
#define ic0devMOT_ACTION_DISCONNECT	 4
#define ic0devMOT_ACTION_END		 5
#define ic0devMOT_ACTION_ERROR		 6
#define ic0devMOT_ACTION_IF		 7
#define ic0devMOT_ACTION_INCR_VALUE	 8
#define ic0devMOT_ACTION_MOVE		 9
#define ic0devMOT_ACTION_NEW_MOVE	10
#define ic0devMOT_ACTION_PARAM		11
#define ic0devMOT_ACTION_RETRY		12
#define ic0devMOT_ACTION_SLEEP		13
#define ic0devMOT_ACTION_STOP		14
#define ic0devMOT_ACTION_USER_FUNCTION	15
#define ic0devMOT_ACTION_VALUE	 	16
#define ic0devMOT_ACTION_WAIT_MOVE	17
#define ic0devMOT_ACTION_SPEED_MOVE	18
#define ic0devMOT_ACTION_SAMPLE		19
#define ic0devMOT_ACTION_CNCT		20
#define ic0devMOT_ACTION_LASTACTION	20

/*
 * conditions
 */
#define ic0devMOT_COND_NOCOND		""
#define ic0devMOT_COND_MOVE_OK		"MOVE_OK"
#define ic0devMOT_COND_NO_RETRY		"NO_RETRY"
#define ic0devMOT_COND_RETRY		"RETRY"

#define ic0devIF_EQUAL			1
#define ic0devIF_NOT_EQUAL		2
#define ic0devIF_GREATER		3
#define ic0devIF_LESS			4
#define ic0devIF_GREATER_EQUAL		5
#define ic0devIF_LESS_EQUAL		6

/*
 * aligned warning and error
 */
#define ic0devMOT_ALIGNED_WARNING	-1
#define ic0devMOT_ALIGNED_ERROR		-2

/*
 * logging actions and types
 */
#define ic0devLOG_OPEN			1
#define ic0devLOG_CLOSE			2
#define ic0devLOG_MOVE			3
#define ic0devLOG_CHANGE		4
#define ic0devLOG_START			5
#define ic0devLOG_STOP			6
#define ic0devLOG_READ			7
#define ic0devLOG_WRITE			8
#define ic0devLOG_INIT			9
#define ic0devLOG_LAST			9

#define ic0devLOG_OPEN_STRING		"OPEN"
#define ic0devLOG_CLOSE_STRING		"CLOSE"
#define ic0devLOG_MOVE_STRING		"MOVE"
#define ic0devLOG_CHANGE_STRING		"CHANGE"
#define ic0devLOG_START_STRING		"START"
#define ic0devLOG_STOP_STRING		"STOP"
#define ic0devLOG_READ_STRING		"READ"
#define ic0devLOG_WRITE_STRING		"WRITE"
#define ic0devLOG_INIT_STRING		"INIT"

#define ic0devLOG_STRING		lcctooVALUE_STRING
#define ic0devLOG_LOGICAL		lcctooVALUE_LOGICAL
#define ic0devLOG_INTEGER		lcctooVALUE_INTEGER
#define ic0devLOG_DOUBLE		lcctooVALUE_DOUBLE

/*
 * status 0 special strings
 */
#define ic0devSTATUS_INIT_STRING	"INIT"
#define ic0devSTATUS_MOVE_STRING	"MOVING"
#define ic0devSTATUS_STOP_STRING	"STOP"
#define ic0devSTATUS_FAILURE_STRING	"FAILED"

/*
 * misc.
 */
#define ic0devVALUE_LENGTH	10
#define ic0devGET_NONE	 	 0 
#define ic0devSET_NONE	 	 0 
#define ic0devPOS_FILLER 0,0,0,0,0,0,0
#define ic0devPOS_SLITS_FILLER 0,0,0,0
#define ic0devDUMMY_POSITION    ("#DUMMY#","","",0,0,0,0,0,0,0)

#define ic0devMOT_INDEX_NONE	-1
#define ic0devMOT_INDEX_NEXT	-2
#define ic0devMOT_TIMEOUT	-1
#define ic0devMOT_STATUS_SIZE	10

#define ic0devLOG_MAX_LEN	34

/*
 * generic servers
 */
#define ic0devDEVICES_MAX	200
#define ic0devDB_INS_ID		":Appl_data.insId"
#define ic0devDB_INS_LCU_ID	":Appl_data.insLcuId"


#endif // !IC0DEV_DEFINES_H

/************************************************************************/
/* ___oOo___ */
