/******************************************************************************
*  E.S.O. - VLT project
* 
*  "@(#) $Id: ic0devManagerInterface.h,v 1.93 2005/08/14 18:41:11 vltsccm Exp $"
* 
*  who        when      what
*  ---------- --------  ----------------------------------------------
*  rschmutzer 30/03/96  Created
*
*/

/*************************************************************************
*   NAME
*	ic0devManagerInterface - interface to class ic0devMANAGER
*
*   SYNOPSIS
*	#include "ic0devManagerInterface.h"
*
*	ccsCOMPL_STAT ic0devManagerDevObjCall(
*	    INOUT egenOBJ*	obj,
*	    IN    const ccsENVNAME  destenv,
*	    IN    const ccsPROCNAME destproc,
*	    IN    msgCMDID	cmdId,
*	    IN    const char*	devName,
*	    OUT   egenOBJ**	devObj,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0devManagerStatusSend(
*	    INOUT egenOBJ*	obj,
*	    IN    const ccsENVNAME  destenv,
*	    IN    const ccsPROCNAME destproc,
*	    IN    msgCMDID	cmdId,
*	    IN    const char*	devName,
*	    IN    const char*	function[],	** max. vltBYTES32[999]
*	    IN    vltINT16	functionNum,
*	    IN    vltLOGICAL	flag,
*	    IN    vltLOGICAL	header,
*	    IN    vltLOGICAL	conflog,
*	    IN    vltLOGICAL	opslog,
*	    IN    vltLOGICAL	condlog,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0devManagerDisableSend(
*	    INOUT egenOBJ*	obj,
*	    IN    const ccsENVNAME  destenv,
*	    IN    const ccsPROCNAME destproc,
*	    IN    msgCMDID	cmdId,
*	    IN    const char*	devName,
*	    IN    const char*	access,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0devManagerEnableSend(
*	    INOUT egenOBJ*	obj,
*	    IN    const ccsENVNAME  destenv,
*	    IN    const ccsPROCNAME destproc,
*	    IN    msgCMDID	cmdId,
*	    IN    const char*	devName,
*	    IN    const char*	access,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0devManagerLogConfSend(
*	    INOUT egenOBJ*	obj,
*	    IN    const ccsENVNAME  destenv,
*	    IN    const ccsPROCNAME destproc,
*	    IN    msgCMDID	cmdId,
*	    IN    const char*	devName,
*	    IN    vltLOGICAL	allElements,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0devManagerGetConfSend(
*	    INOUT egenOBJ*	obj,
*	    IN    const ccsENVNAME  destenv,
*	    IN    const ccsPROCNAME destproc,
*	    IN    msgCMDID	cmdId,
*	    IN    const char*	devName,
*	    IN    vltLOGICAL	allElements,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0devManagerFixPosSend(
*	    INOUT egenOBJ*	obj,
*	    IN    const ccsENVNAME  destenv,
*	    IN    const ccsPROCNAME destproc,
*	    IN    msgCMDID	cmdId,
*	    IN    const char*	devName,
*	    IN    const char*	position[],	** max. vltBYTES32[999]
*	    IN    vltINT16	positionNum,
*	    IN    vltLOGICAL	reset,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0devManagerMoveSend(
*	    INOUT egenOBJ*	obj,
*	    IN    const ccsENVNAME  destenv,
*	    IN    const ccsPROCNAME destproc,
*	    IN    msgCMDID	cmdId,
*	    IN    const char*	devName,
*	    IN    const char*	position[],	** max. vltBYTES32[999]
*	    IN    vltINT16	positionNum,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0devManagerMoveRelSend(
*	    INOUT egenOBJ*	obj,
*	    IN    const ccsENVNAME  destenv,
*	    IN    const ccsPROCNAME destproc,
*	    IN    msgCMDID	cmdId,
*	    IN    const char*	devName,
*	    IN    const char*	position[],	** max. vltBYTES32[999]
*	    IN    vltINT16	positionNum,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0devManagerSetSend(
*	    INOUT egenOBJ*	obj,
*	    IN    const ccsENVNAME  destenv,
*	    IN    const ccsPROCNAME destproc,
*	    IN    msgCMDID	cmdId,
*	    IN    const char*	devName,
*	    IN    const char*	position[],	** max. vltBYTES32[999]
*	    IN    vltINT16	positionNum,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0devManagerWaitSend(
*	    INOUT egenOBJ*	obj,
*	    IN    const ccsENVNAME  destenv,
*	    IN    const ccsPROCNAME destproc,
*	    IN    msgCMDID	cmdId,
*	    IN    const char*	devName,
*	    IN    vltINT32	timeout,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0devManagerSetupSend(
*	    INOUT egenOBJ*	obj,
*	    IN    const ccsENVNAME  destenv,
*	    IN    const ccsPROCNAME destproc,
*	    IN    msgCMDID	cmdId,
*	    IN    const char*	devName,
*	    IN    const char*	function[],	** max. vltBYTES32[999]
*	    IN    vltINT16	functionNum,
*	    IN    vltLOGICAL	noMove,
*	    IN    vltLOGICAL	check,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0devManagerCfgElemSend(
*	    INOUT egenOBJ*	obj,
*	    IN    const ccsENVNAME  destenv,
*	    IN    const ccsPROCNAME destproc,
*	    IN    msgCMDID	cmdId,
*	    IN    const char*	devName,
*	    IN    vltINT32	position,
*	    IN    const char*	id,
*	    IN    const char*	values[],	** max. vltBYTES16[10]
*	    IN    vltINT16	valuesNum,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0devManagerGetValSend(
*	    INOUT egenOBJ*	obj,
*	    IN    const ccsENVNAME  destenv,
*	    IN    const ccsPROCNAME destproc,
*	    IN    msgCMDID	cmdId,
*	    IN    const char*	devName,
*	    IN    const char*	name[],		** max. vltBYTES32[2]
*	    IN    vltINT16	nameNum,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0devManagerSetValSend(
*	    INOUT egenOBJ*	obj,
*	    IN    const ccsENVNAME  destenv,
*	    IN    const ccsPROCNAME destproc,
*	    IN    msgCMDID	cmdId,
*	    IN    const char*	devName,
*	    IN    const char*	name[],		** max. vltBYTES32[2]
*	    IN    vltINT16	nameNum,
*	    IN    const char*	value[],	** max. vltBYTES32[10]
*	    IN    vltINT16	valueNum,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0devManager*Pack(
*	    INOUT egenOBJ*	obj,
*	    IN    char*		msgbuf,
*	    IN    ... 		<args>
*	    OUT   ccsERROR*	error)
*
*   DESCRIPTION
*	Instances of the class ic0devMANAGER can be accessed with the 
*	LCC Message System using the functions msgSendCommand() and
*	lcctooRecvMsg().
*	Some functions receive several arguments that have to be packed
*	into the message buffer. This interface supplies such functions.
*	
*	ic0devManager*Send(obj, destenv, destproc, cmdId, <args>, ..., error)
*	   These functions may be used instead of msgSendCommand()
*	   to send a specific command to a ic0devMANAGER instance.
*	   The following commands are implemented:
*	      ic0devManagerStatusSend()
*	      ic0devManagerDisableSend()
*	      ic0devManagerEnableSend()
*	      ic0devManagerLogConfSend()
*	      ic0devManagerGetConfSend()
*	      ic0devManagerFixPosSend()
*	      ic0devManagerMoveSend()
*	      ic0devManagerMoveRelSend()
*	      ic0devManagerSetSend()
*	      ic0devManagerWaitSend()
*	      ic0devManagerSetupSend()
*	      ic0devManagerCfgElemSend()
*	      ic0devManagerGetValSend()
*	      ic0devManagerSetValSend()
*
*	ic0devManager*Pack(obj, buf, <args>, ..., error)
*	   These functions pack arguments into a message buffer.
*	   The buffer must be allocated by the caller.
*	   The following functions are implemented:
*	      ic0devManagerStatusPack()
*	      ic0devManagerDisablePack()
*	      ic0devManagerEnablePack()
*	      ic0devManagerLogConfPack()
*	      ic0devManagerGetConfPack()
*	      ic0devManagerFixPosPack()
*	      ic0devManagerMovePack()
*	      ic0devManagerMoveRelPack()
*	      ic0devManagerSetPack()
*	      ic0devManagerWaitPack()
*	      ic0devManagerSetupPack()
*	      ic0devManagerCfgElemPack()
*	      ic0devManagerGetValPack()
*	      ic0devManagerSetValPack()
*
*   DEFINES
*
*   FILES
*   ENVIRONMENT
*
*   RETURN VALUES
*	If the function prototype allows, methods return ccsCOMPL_STAT.
*
*   CAUTIONS
*
*   EXAMPLES
*
*   SEE ALSO
*
*   BUGS
* 
*-------------------------------------------------------------------------
*/

#ifndef IC0DEV_MANAGER_INTERFACE_H
#define IC0DEV_MANAGER_INTERFACE_H

#include "ic0devManager.h"


/*
 * error functions
 */
#define ic0devErrDeviceTable(p1) \
	{ \
	lcctooLOG_0("ic0devERR_DEVICE_TABLE: Device table full (size: %d)",(p1)); \
	errAdd(error,"ic0dev",ic0devERR_DEVICE_TABLE,__FILE_LINE__,"%d",(p1)); \
	}


/*
 * send functions
 */

ccsCOMPL_STAT ic0devManagerDevObjCall(
    INOUT egenOBJ*	obj,
    IN    const ccsENVNAME  destenv,
    IN    const ccsPROCNAME destproc,
    IN    msgCMDID	cmdId,
    IN    const char*	devName,
    OUT   egenOBJ**	devObj,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devManagerStatusSend(
    INOUT egenOBJ*	obj,
    IN    const ccsENVNAME  destenv,
    IN    const ccsPROCNAME destproc,
    IN    msgCMDID	cmdId,
    IN    const char*	devName,
    IN    const char*	function[],	/* max. vltBYTES32[999] */
    IN    vltINT16	functionNum,
    IN    vltLOGICAL	flag,
    IN    vltLOGICAL	header,
    IN    vltLOGICAL	conflog,
    IN    vltLOGICAL	opslog,
    IN    vltLOGICAL	condlog,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devManagerDisableSend(
    INOUT egenOBJ*	obj,
    IN    const ccsENVNAME  destenv,
    IN    const ccsPROCNAME destproc,
    IN    msgCMDID	cmdId,
    IN    const char*	devName,
    IN    const char*	access,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devManagerEnableSend(
    INOUT egenOBJ*	obj,
    IN    const ccsENVNAME  destenv,
    IN    const ccsPROCNAME destproc,
    IN    msgCMDID	cmdId,
    IN    const char*	devName,
    IN    const char*	access,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devManagerLogConfSend(
    INOUT egenOBJ*	obj,
    IN    const ccsENVNAME  destenv,
    IN    const ccsPROCNAME destproc,
    IN    msgCMDID	cmdId,
    IN    const char*	devName,
    IN    vltLOGICAL	allElements,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devManagerGetConfSend(
    INOUT egenOBJ*	obj,
    IN    const ccsENVNAME  destenv,
    IN    const ccsPROCNAME destproc,
    IN    msgCMDID	cmdId,
    IN    const char*	devName,
    IN    vltLOGICAL	allElements,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devManagerFixPosSend(
    INOUT egenOBJ*	obj,
    IN    const ccsENVNAME  destenv,
    IN    const ccsPROCNAME destproc,
    IN    msgCMDID	cmdId,
    IN    const char*	devName,
    IN    const char*	position[],	/* max. vltBYTES32[999] */
    IN    vltINT16	positionNum,
    IN    vltLOGICAL	reset,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devManagerMoveSend(
    INOUT egenOBJ*	obj,
    IN    const ccsENVNAME  destenv,
    IN    const ccsPROCNAME destproc,
    IN    msgCMDID	cmdId,
    IN    const char*	devName,
    IN    const char*	position[],	/* max. vltBYTES32[999] */
    IN    vltINT16	positionNum,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devManagerMoveRelSend(
    INOUT egenOBJ*	obj,
    IN    const ccsENVNAME  destenv,
    IN    const ccsPROCNAME destproc,
    IN    msgCMDID	cmdId,
    IN    const char*	devName,
    IN    const char*	position[],	/* max. vltBYTES32[999] */
    IN    vltINT16	positionNum,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devManagerSetSend(
    INOUT egenOBJ*	obj,
    IN    const ccsENVNAME  destenv,
    IN    const ccsPROCNAME destproc,
    IN    msgCMDID	cmdId,
    IN    const char*	devName,
    IN    const char*	position[],	/* max. vltBYTES32[999] */
    IN    vltINT16	positionNum,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devManagerWaitSend(
    INOUT egenOBJ*	obj,
    IN    const ccsENVNAME  destenv,
    IN    const ccsPROCNAME destproc,
    IN    msgCMDID	cmdId,
    IN    const char*	devName,
    IN    vltINT32	timeout,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devManagerSetupSend(
    INOUT egenOBJ*	obj,
    IN    const ccsENVNAME  destenv,
    IN    const ccsPROCNAME destproc,
    IN    msgCMDID	cmdId,
    IN    const char*	devName,
    IN    const char*	function[],	/* max. vltBYTES32[999] */
    IN    vltINT16	functionNum,
    IN    vltLOGICAL	noMove,
    IN    vltLOGICAL	check,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devManagerCfgElemSend(
    INOUT egenOBJ*	obj,
    IN    const ccsENVNAME  destenv,
    IN    const ccsPROCNAME destproc,
    IN    msgCMDID	cmdId,
    IN    const char*	devName,
    IN    vltINT32	position,
    IN    const char*	id,
    IN    const char*	values[],	/* max. vltBYTES16[10] */
    IN    vltINT16	valuesNum,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devManagerGetValSend(
    INOUT egenOBJ*	obj,
    IN    const ccsENVNAME  destenv,
    IN    const ccsPROCNAME destproc,
    IN    msgCMDID	cmdId,
    IN    const char*	devName,
    IN    const char*	name[],	/* max. vltBYTES32[2] */
    IN    vltINT16	nameNum,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devManagerSetValSend(
    INOUT egenOBJ*	obj,
    IN    const ccsENVNAME  destenv,
    IN    const ccsPROCNAME destproc,
    IN    msgCMDID	cmdId,
    IN    const char*	devName,
    IN    const char*	name[],	/* max. vltBYTES32[2] */
    IN    vltINT16	nameNum,
    IN    const char*	value[],	/* max. vltBYTES32[10] */
    IN    vltINT16	valueNum,
    OUT   ccsERROR*	error);


/*
 * pack functions
 */

ccsCOMPL_STAT ic0devManagerStatusPack(
    INOUT egenOBJ*	obj,
    IN    char*		msgbuf,
    IN    const char*	devName,
    IN    const char*	function[],	/* max. vltBYTES32[999] */
    IN    vltINT16	functionNum,
    IN    vltLOGICAL	flag,
    IN    vltLOGICAL	header,
    IN    vltLOGICAL	conflog,
    IN    vltLOGICAL	opslog,
    IN    vltLOGICAL	condlog,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devManagerDisablePack(
    INOUT egenOBJ*	obj,
    IN    char*		msgbuf,
    IN    const char*	devName,
    IN    const char*	access,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devManagerEnablePack(
    INOUT egenOBJ*	obj,
    IN    char*		msgbuf,
    IN    const char*	devName,
    IN    const char*	access,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devManagerLogConfPack(
    INOUT egenOBJ*	obj,
    IN    char*		msgbuf,
    IN    const char*	devName,
    IN    vltLOGICAL	allElements,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devManagerGetConfPack(
    INOUT egenOBJ*	obj,
    IN    char*		msgbuf,
    IN    const char*	devName,
    IN    vltLOGICAL	allElements,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devManagerFixPosPack(
    INOUT egenOBJ*	obj,
    IN    char*		msgbuf,
    IN    const char*	devName,
    IN    const char*	position[],	/* max. vltBYTES32[999] */
    IN    vltINT16	positionNum,
    IN    vltLOGICAL	reset,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devManagerMovePack(
    INOUT egenOBJ*	obj,
    IN    char*		msgbuf,
    IN    const char*	devName,
    IN    const char*	position[],	/* max. vltBYTES32[999] */
    IN    vltINT16	positionNum,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devManagerMoveRelPack(
    INOUT egenOBJ*	obj,
    IN    char*		msgbuf,
    IN    const char*	devName,
    IN    const char*	position[],	/* max. vltBYTES32[999] */
    IN    vltINT16	positionNum,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devManagerSetPack(
    INOUT egenOBJ*	obj,
    IN    char*		msgbuf,
    IN    const char*	devName,
    IN    const char*	position[],	/* max. vltBYTES32[999] */
    IN    vltINT16	positionNum,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devManagerWaitPack(
    INOUT egenOBJ*	obj,
    IN    char*		msgbuf,
    IN    const char*	devName,
    IN    vltINT32	timeout,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devManagerSetupPack(
    INOUT egenOBJ*	obj,
    IN    char*		msgbuf,
    IN    const char*	devName,
    IN    const char*	function[],	/* max. vltBYTES32[999] */
    IN    vltINT16	functionNum,
    IN    vltLOGICAL	noMove,
    IN    vltLOGICAL	check,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devManagerCfgElemPack(
    INOUT egenOBJ*	obj,
    IN    char*		msgbuf,
    IN    const char*	devName,
    IN    vltINT32	position,
    IN    const char*	id,
    IN    const char*	values[],	/* max. vltBYTES16[10] */
    IN    vltINT16	valuesNum,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devManagerGetValPack(
    INOUT egenOBJ*	obj,
    IN    char*		msgbuf,
    IN    const char*	devName,
    IN    const char*	name[],	/* max. vltBYTES32[2] */
    IN    vltINT16	nameNum,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devManagerSetValPack(
    INOUT egenOBJ*	obj,
    IN    char*		msgbuf,
    IN    const char*	devName,
    IN    const char*	name[],	/* max. vltBYTES32[2] */
    IN    vltINT16	nameNum,
    IN    const char*	value[],	/* max. vltBYTES32[10] */
    IN    vltINT16	valueNum,
    OUT   ccsERROR*	error);


#endif // !IC0DEV_MANAGER_INTERFACE_H

/************************************************************************/
/* ___oOo___ */
