/******************************************************************************
*  E.S.O. - VLT project
* 
*  "@(#) $Id: ic0devMot.h,v 1.93 2005/08/14 18:41:11 vltsccm Exp $"
* 
*  who        when      what
*  ---------- --------  ----------------------------------------------
*  rschmutz   05/08/99  read ic0devMOT_ACTION tables with lcctooCaiRWTableAdj.
*  rschmutz   07/07/99  ic0devMotActionSample, ic0devMotActionCnct added.
*  rschmutz   22/10/97  missing moveAction defines added.
*  rschmutzer 11/10/95  Created by eccsgen V0.53 (October 1995)
*
*
*    !!!!!!!!!  CAUTION: THIS FILE IS UPDATED BY ECCSGEN  !!!!!!!!!
*/

/*************************************************************************
*   NAME
*	ic0devMot - class
*
*   SYNOPSIS
*	#include "ic0devMot.h"
*
*	ccsCOMPL_STAT ic0devMotNewObj(
*	    IN    dbSYMADDRESS	point,
*	    IN    egenOBJ*	owner,
*	    OUT   egenOBJ*	obj,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0devMotDeleteObj(
*	    INOUT egenOBJ*	obj,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0devMotVarSet(
*	    INOUT ic0devMOT_SYNC_VAR_PARLIST* parList,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0devMotVarWait(
*	    INOUT ic0devMOT_SYNC_VAR_PARLIST* parList,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0devMotGetHandles(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    OUT   motHANDLE*	motors,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0devMotPark(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0devMotGetAction(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    vltINT32	actionStep,
*	    OUT   ic0devMOT_ACTION*	action,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0devMotExecAction(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    ic0devMOT_ACTION*	action,
*	    OUT   vltLOGICAL*	end,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0devMotActionGetHandles(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    vltINT32	index,
*	    OUT   motHANDLE*	motors,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0devMotAction<actionName>(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    ic0devMOT_ACTION*	action,
*	    OUT   vltLOGICAL*	end,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0devMotSetParListAddress(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    motHANDLE*	motor,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0devMotGetArg(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    vltINT32	code,
*	    OUT   lcctooVALUE*	value,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0devMotWlen2Enc(
*	    IN    motMETRIC*	from,
*	    OUT   motMETRIC*	to,
*	    IN    egenOBJ*	parList,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0devMotTemp2Focus(
*	    IN    motMETRIC*	from,
*	    OUT   motMETRIC*	to,
*	    IN    egenOBJ*	parList,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0devMotSlit2Enc1(
*	    IN    motMETRIC*	from,
*	    OUT   motMETRIC*	to,
*	    IN    egenOBJ*	parList,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0devMotSlit2Enc2(
*	    IN    motMETRIC*	from,
*	    OUT   motMETRIC*	to,
*	    IN    egenOBJ*	parList,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0devMotSlit2Enc(
*	    INOUT egenOBJ*	obj,
*	    IN    vltINT32	motorIndex,
*	    IN    motMETRIC*	from,
*	    OUT   motMETRIC*	to,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0devMotWlenTeta2Enc(
*	    IN    motMETRIC*	from,
*	    OUT   motMETRIC*	to,
*	    IN    egenOBJ*	parList,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0devMotTilt2Enc(
*	    IN    motMETRIC*	from,
*	    OUT   motMETRIC*	to,
*	    IN    egenOBJ*	parList,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0devMotPos2Enc(
*	    IN    motMETRIC*	from,
*	    OUT   motMETRIC*	to,
*	    IN    egenOBJ*	parList,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0devMotRead<scalarAttr>(
*	    INOUT egenOBJ*	obj,
*	    OUT   void*		buf,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0devMotWrite<scalarAttr>(
*	    INOUT egenOBJ*	obj,
*	    IN    void*		buf,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0devMotRead<vectorAttr>(
*	    INOUT egenOBJ*	obj,
*	    OUT   void*		buf,
*	    IN    vltINT32	first,
*	    IN    vltINT32	last,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0devMotWrite<vectorAttr>(
*	    INOUT egenOBJ*	obj,
*	    IN    void*		buf,
*	    IN    vltINT32	first,
*	    IN    vltINT32	last,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0devMotRead<tableAttr>(
*	    INOUT egenOBJ*	obj,
*	    OUT   void*		buf,
*	    IN    vltINT32	firstRec,
*	    IN    vltINT32	lastRec,
*	    IN    vltINT32	firstFld,
*	    IN    vltINT32	lastFld,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0devMotWrite<tableAttr>(
*	    INOUT egenOBJ*	obj,
*	    IN    void*		buf,
*	    IN    vltINT32	firstRec,
*	    IN    vltINT32	lastRec,
*	    IN    vltINT32	firstFld,
*	    IN    vltINT32	lastFld,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0devMotErr<error>(...)
*
*   PARENT CLASS
*	public ic0devSOFT
*
*   DESCRIPTION
*       The class ic0devMOT implements an ICS function that
*       is implemented via the Motor Library. The public
*       interface is inherited from ic0devSOFT.
*
*       The online database contains attributes to configure the
*       ICS device. The following items have to be configured:
*
*       - Motors managed by the ICS function (normally one motor,
*	  but up to two motors may be managed by the same device).
*       - FITS and other parameters accepted by the SETUP, MOVE,
*	  MOVEREL and SET commands.
*       - Configuration or alignment values needed by the ICS device.
*       - Actions to be performed by the SETUP, MOVE, MOVEREL, SET
*	  and TEST commands; actions performed to park the function.
*       - Configuration of special user unit conversions (e.g. for
*	  gratings and focus functions).
*
*   PUBLIC METHODS
*	ic0devMotNewObj(point,owner,obj,error)
*	    Initialises an instance of the class type ic0devMOT.
*
*	    point	<IN>	OLDB point where the owned attributes are
*				located.
*	    owner	<IN>	Pointer to the owner of the new instance.
*	    obj		<OUT>	Handle for the new instance (the handle
*				must be allocated by the caller).
*
*	ic0devMotDeleteObj(obj,error)
*	    The function lcctooDeleteObj deletes an
*	    instance of the class type ic0devMOT
*
*	ic0devMotVarSet(parList,error)
*	   This function may be called from the HW Initialisation
*	   table of a motor.  It assigns a value to a syncronization
*	   variable.
*	   The syncVar index is stored in the initCode field,
*	   the value is stored in the motionMode field of the
*	   corresponding motACTION structure.
*
*	ic0devMotVarWait(parList,error)
*	   This function may be called from the HW Initialisation
*	   table of a motor. VarWait() waits until a syncronization
*	   variable has the requested value. VarWait() returns an
*	   error if:
*	   a) the value is not assigned to the variable within
*	      timeout seconds.
*	   b) the requested value is different to 0 and 0 is
*	      assigned to the syncronization variable.
*
*	   The syncVar index is stored in the initCode field,
*	   the value is stored in the motionMode field and the
*	   timeout is stored in the posHow field of the
*	   corresponding motACTION structure.
*
*	ic0devMotWlen2Enc(from,to,parList,error)
*	   This is a user unit conversion function for the
*	   Motor Library. It is intended to be used to
*	   convert the wavelength setting of a grating to
*	   the proper encoder units (WLen(nm) to Pos(Enc)).
*
*	   Pos = K0 + K1 + K2 + K3 * arcsin(WLen * K4 / K5)
*
*	   The arguments Kx may be parameters or values.
*	   They are retrieved with the GetArg method, using
*	   x as the index into the userUnitArgs vector.
*
*	ic0devMotTemp2Focus(from,to,parList,error)
*	   This is a user unit conversion function for the
*	   Motor Library. It is intended to be used to
*	   convert a temperature value into the related focus
*	   position in encoder units (T(K) to Pos(Enc)).
*
*	   Pos = K0 + K1 + K2 * T + K3 * cos((K4 - K5) / K6)
*
*	   The arguments Kx may be parameters or values.
*	   They are retrieved with the GetArg method, using
*	   x as the index into the userUnitArgs vector.
*
*	ic0devMotSlit2Enc1(obj,from,to,parList,error)
*	   This is a user unit conversion function for the
*	   Motor Library. It is intended to be used to
*	   convert arcsec into encoder units in two steps:
*	   
*	   1. An adjusted user value is obtained calling
*	      motPosToEnc() with the handle of the 1. motor
*	      associated to the device and asking for unit
*	      "ADJ".  The result is divided by 1000.
*	      If motPosToEnc() returns an error, then the
*	      supplied user value is used.
*
*	   2. The position in [Enc] is obtained from the
*	      formula:
*
*	   Pos = K0 + K1 + K2 * arccos((Width - (K4 + K3)) / (K4 - K3))
*
*	   The encoder value is converted back with:
*
*	   Width = (K4 + K3) + (K4 - K3) * cos((Pos - K0 - K1) / K2)
*
*	   The arguments Kx may be parameters or values.
*	   They are retrieved with the GetArg method, using
*	   x as the index into the userUnitArgs vector.
*
*	   The ADJtoEnc unit conversion is usually a
*	   lookup table taking into account calibration
*	   errors.
*
*	ic0devMotSlit2Enc2(obj,from,to,parList,error)
*	   This is a user unit conversion function for the
*	   Motor Library. It is intended to be used to
*	   convert arcsec into encoder units the same way
*	   as with function ic0devMotSlit2Enc1().
*
*	   This function however, calls the motPosToEnc()
*	   function related with the 2. motor associated
*	   to the device.
*
*	ic0devMotSlit2Enc(obj,motorIndex,from,to,error)
*	   Function used by Slit2Enc1 and Slit2Enc2.
*
*	ic0devMotWlenTeta2Enc(obj,from,to,parList,error)
*	   This is a user unit conversion function for the
*	   Motor Library. It is intended to be used to
*	   convert the wavelength setting of a grating to
*	   the proper encoder units (WLen [nm] to Pos [Enc]).
*
*	   Pos = K0 + K1 + K2 + K3 * arcsin(WLen * K4 / (2 * cos(K5)))
*
*	   The arguments Kx may be parameters or values.
*	   They are retrieved with the GetArg method, using
*	   x as the index into the userUnitArgs vector.
*
*	ic0devMotTilt2Enc(obj,from,to,parList,error)
*	   This is a user unit conversion function for the
*	   Motor Library. It is intended to be used to
*	   convert a tilt setting to the proper encoder
*	   units (Tilt [pix] to Pos [Enc]).
*
*	   Pos = K0 + K1 + K2 * arcsin((2 * Tilt - (K4 + K3)) / (K4 - K3))
*
*	   The arguments Kx may be parameters or values.
*	   They are retrieved with the GetArg method, using
*	   x as the index into the userUnitArgs vector.
*
*     ic0devMotPos2Enc(obj,from,to,parList,error)
*          This is a user unit conversion function for the
*          Motor Library. It is intended to be used to
*          convert a user unit position to encoder units
*          (Pos [<user unit>] to Enc [Enc]).
*
*          Enc = K0 + K1 + K2 * Pos
*
*          The arguments Kx may be parameters or values.
*          They are retrieved with the GetArg method, using
*          x as the index into the userUnitArgs vector.
*
*
*   PRIVATE METHODS
*	ic0devMotGetHandles(obj,devName,motors,error)
*	   Returns the Motor Library handles managed by the device.
*
*	ic0devMotPark(obj,devName,error)
*	   Parks the instrument function.
*
*	ic0devMotGetAction(obj,devName,actionStep,action,error)
*	   Returns an action entry from the actions tables.
*
*	   actionStep	<IN>	index into the action table;
*			      	(if the index is greater 100:
*			      	retrieve from the user table)
*	   action	<OUT> 	returned action entry
*
*	ic0devMotExecAction(obj,devName,action,end,error)
*	   Executes the action specified by the action entry.
*
*	   action	<IN>	action entry
*	   end		<OUT>	TRUE specifies that the action
*			   	sequence should end.
*
*	ic0devMotActionGetHandles(obj,devName,index,motors,error)
*	   Returns the Motor Library handles requested by index.
*	   
*	   index	<IN>	1, 2 or 3 to retrieve the handle(s) for
*			   	the 1., 2. or both motors managed by the
*			   	device.
*	   motors	<OUT>	returned motor handles.
*
*	ic0devMotActionNewMove(obj,devName,action,end,error)
*	   Action ic0devMOT_ACTION_NEW_MOVE:
*	   Begin a new movement. The action parameters are copied
*	   to the actionMove table of the OLDB.
*
*	ic0devMotActionIf(obj,devName,action,end,error)
*	   Action ic0devMOT_ACTION_IF:
*	   The text stored in the field userText is compared
*	   with the parameter status (userValue >= 0) or
*	   configuration value (userValue < 0) specified by
*	   the field userValue of the action field.
*
*	   Both values are compared according to the mode (in the
*	   motorIndex fiels) and the action execution continues
*	   with the specified actionStep (in the motionMode field)
*	   if the right condition is met.  Otherwise this action
*	   is ignored.
*
*	   modes: ic0devIF_EQUAL ic0devIF_NOT_EQUAL
*		  ic0devIF_GREATER ic0devIF_LESS
*		  ic0devIF_GREATER_EQUAL ic0devIF_LESS_EQUAL
*
*	ic0devMotActionParam(obj,devName,action,end,error)
*	   Action ic0devMOT_ACTION_PARAM:
*	   Retrieves the set value of a parameter in the parameters
*	   table.  The userValue field is used as an index into the
*	   parameters table.
*	   The setValue and the setCode fields are retrieved from the
*	   parameters table. The setValue is stored in the actionMove
*	   table of the OLDB as specified by the setCode.
*	   If the parameter has not been specified in the current command
*	   (i.e. the set value is not valid), then this action is ignored
*	   if the textValue field is empty. If the textValue contains an
*	   "R" (Required), then the action sequence is aborted with an
*	   error.
*
*	ic0devMotActionAddParam(obj,devName,action,end,error)
*	   Action ic0devMOT_ACTION_ADD_PARAM:
*	   Retrieves the set value of a parameter in the parameters
*	   table.  The userValue field is used as an index into the
*	   parameters table.
*	   The setValue and the setCode fields are retrieved from the
*	   parameters table. The setValue is added to the value in the
*	   actionMove table of the OLDB as specified by the setCode.
*	   If the parameter has not been specified in the current command
*	   (i.e. the set value is not valid), then this action is ignored
*	   if the textValue field is empty. If the textValue contains an
*	   "R" (Required), then the action sequence is aborted with an
*	   error.
*
*	ic0devMotActionValue(obj,devName,action,end,error)
*	   Action ic0devMOT_ACTION_VALUE:
*	   Retrieves a configuration or alignment value from the
*	   values table. The userValue field is used as an index
*	   into the values table. The retrieved value is stored
*	   in the actionMove table of the OLDB as specified by
*	   the setCode stored in the motionMode field of the
*	   action entry.
*
*	ic0devMotActionAddValue(obj,devName,action,end,error)
*	   Action ic0devMOT_ACTION_ADD_VALUE:
*	   Retrieves a configuration or alignment value from the
*	   values table. The userValue field is used as an index
*	   into the values table. The retrieved value is added
*	   to the value in the actionMove table of the OLDB
*	   specified by the setCode stored in the motionMode
*	   field of the action entry.
*
*	ic0devMotActionMove(obj,devName,action,end,error)
*	   Action ic0devMOT_ACTION_MOVE:
*	   Performs a motor movement.
*	   If ACTION_NEW_MOVE was called previous to ACTION_MOVE,
*	   then the parameters are retrieved from the actionMove
*	   table of the OLDB.  Otherwise, the movement parameters
*	   are retrieved directly from the action parameters.
*	   If the check attribute is set, then motCheckMove is called
*	   instead of motMove. motWaitMove is called only if the
*	   waitTime parameter is greater 0.
*	   The actionMove table is cleared after the movement.
*
*	ic0devMotActionSpeedMove(obj,devName,action,end,error)
*	   Action ic0devMOT_ACTION_SPEED_MOVE:
*
*	   Performs a motor movement or stops the motor.
*	   The moveMode attribute is checked. If moveMode is 0,
*	   then the motor is stopped, otherwise the motor is
*	   moved as described in the ic0devMOT_ACTION_MOVE
*	   action. This action is usually used to perform
*	   movements by speed.
*
*	ic0devMotActionWaitMove(obj,devName,action,end,error)
*	   Action ic0devMOT_ACTION_WAIT_MOVE:
*	   Call motWaitMove for the motors indicated by the motorIndex
*	   field with the timeout specified by the waitTime field.
*
*	ic0devMotActionClampBrake(obj,devName,action,end,error)
*	   Action ic0devMOT_ACTION_CLAMP_BRAKE:
*	   Clamps the brake of the motors indicated by motorIndex.
*
*	ic0devMotActionDisconnect(obj,devName,action,end,error)
*	   Action ic0devMOT_ACTION_DISCONNECT:
*	   Disconnects the motors indicated by motorIndex.
*
*	ic0devMotActionStop(obj,devName,action,end,error)
*	   Action ic0devMOT_ACTION_STOP:
*	   Stop the movement of the motors indicated by the motorIndex
*	   field.
*
*	ic0devMotActionUserFunction(obj,devName,action,end,error)
*	   Action ic0devMOT_ACTION_USER_FUNCTION:
*	   Execute the user function specified by userText. The user
*	   function is called with the following parameters:
*	     <userText>(
*	       egenOBJ*          obj,
*	       const char*       devName,
*	       ic0devMOT_ACTION* action,
*	       vltLOGICAL*       end,
*	       ccsERROR*         error)
*
*	ic0devMotActionRetry(obj,devName,action,end,error)
*	   Action ic0devMOT_ACTION_RETRY:
*	   Retry a motor movement the number of times indicated by the
*	   "motionMode" field. If the last motor movement of the motors
*	   indicated by the motorIndex field failed and it is posible
*	   to retry it, then userValue field is used as an index into
*	   the actions table. Execution is continued by the action
*	   pointed by userValue.
*
*	ic0devMotActionEnd(obj,devName,action,end,error)
*	   Action ic0devMOT_ACTION_END:
*	   Ends the action sequence.
*	   userText may be left empty (""), or the following
*	   conditions may be used:
*
*	   ic0devMOT_COND_NOCOND
*	     Unconditional end (equivalent to "").
*
*	   ic0devMOT_COND_MOVE_OK
*	     End, if the last motor movement of the motor(s)
*	     indicated by the motorIndex field was successful.
*
*	   ic0devMOT_COND_NO_RETRY
*	     End, if it is not necessary (or possible) to retry the
*	     last movement. If the movement was sucessful, then
*	     SUCCESS is returned. If the movement failed and it is
*	     not possible to retry the movement, then FAILURE is
*	     returned.
*
*	   ic0devMOT_COND_RETRY
*	     As above, but end if the movement has failed and can
*	     be retried.
*
*	ic0devMotActionError(obj,devName,action,end,error)
*	   Action ic0devMOT_ACTION_ERROR:
*	   Ends the action sequence with the error:
*	   Command not supported.
*
*	ic0devMotActionSleep(obj,devName,action,end,error)
*	   Action ic0devMOT_ACTION_SLEEP:
*	   Sleep userValue mseconds.
*
*	ic0devMotActionIncrValue(obj,devName,action,end,error)
*	   Action ic0devMOT_ACTION_INCR_VALUE:
*	   Increments the value userValue by 1.
*
*	ic0devMotSetParListAddress(obj,devName,motor,error)
*	   Initialise the parameter list address of the special
*	   user unit conversion functions supplied by ic0devMOT
*	   with a pointer to the device object.
*
*	   motor	<IN>	motor handle
*
*	ic0devMotErr<error>(...)
*	    The macros ic0devMotErr*() log an error with lcctooLOG_0 and
*	    call errAdd with the corresponding error parameters.
*
*	ic0devMotRead<attr>(...)
*	ic0devMotWrite<attr>(...)
*	    The above macros read from/write to the data attributes
*	    of the class. 
*	    The attributes are described in ic0devMotDb(5).
*
*	The following methods are overloaded by ic0devMOT
*	(prefix ic0devMot is omitted):
*	    UsrInit, UsrLoaded2Standby, UsrStandby2Online,
*	    UsrOnline2Standby, UsrStandby2Loaded, UsrStop,
*	    UsrStatusCode, UsrStatusValue, UsrStatusLast,
*	    UsrSetMode, UsrSelfTest, UsrTest, UsrExecAction,
*	    UsrSetParameter, UsrGetValue, UsrSetValue
*
*   RETURN VALUES
*	If the function prototype allows, methods return ccsCOMPL_STAT.
*
*	The names of the defined errors begin as follows:
*	ic0devERR_<error>
*
*   SEE ALSO
*	ic0devMOT(5) ic0devMotCodes(5) ic0devSoft(3) ic0devManager(3)
*
*-------------------------------------------------------------------------
*/

#ifndef IC0DEV_MOT_H
#define IC0DEV_MOT_H

#include "egen.h"
#include "mot.h"
#include "motci.h"
#include "ic0devErrors.h"
#include "ic0devSoft.h"
#include "ic0devDefines.h"

/*
 * class type identifier
 */
#define ic0devMOT_ID	123


/*
 * attribute table
 */
#define ic0devMOT_ATTR_STATE	0
#define ic0devMOT_ATTR_SUBSTATE	1
#define ic0devMOT_ATTR_ERROR	2
#define ic0devMOT_ATTR_INITIALISED	3
#define ic0devMOT_ATTR_SIMULATION	4
#define ic0devMOT_ATTR_DEVICE	5
#define ic0devMOT_ATTR_AVAILABLE	6
#define ic0devMOT_ATTR_ENABLED	7
#define ic0devMOT_ATTR_LOCKED	8
#define ic0devMOT_ATTR_HANDSET	9
#define ic0devMOT_ATTR_FIXED	10
#define ic0devMOT_ATTR_FIX_POS_SET	11
#define ic0devMOT_ATTR_FIXED_POSITION	12
#define ic0devMOT_ATTR_FIXED_SIMULATION	13
#define ic0devMOT_ATTR_FIXED_LOCKED	14
#define ic0devMOT_ATTR_PREFIX	15
#define ic0devMOT_ATTR_PARAMETERS_SIZE	16
#define ic0devMOT_ATTR_PARAMETERS	17
#define ic0devMOT_ATTR_STATUS	18
#define ic0devMOT_ATTR_STATUS_INDEX	19
#define ic0devMOT_ATTR_VALUES_SIZE	20
#define ic0devMOT_ATTR_VALUES	21
#define ic0devMOT_ATTR_INIT_RESTRICTION	22
#define ic0devMOT_ATTR_MOVE_RESTRICTION	23
#define ic0devMOT_ATTR_STOP_TIMEOUT	24
#define ic0devMOT_ATTR_SET_VAL_FCT	25
#define ic0devMOT_ATTR_HELP_TEXT	26
#define ic0devMOT_ATTR_PARAM_STEP	27
#define ic0devMOT_ATTR_ACTION_COMMAND	28
#define ic0devMOT_ATTR_ACTION_STOP_REQ	29
#define ic0devMOT_ATTR_ACTION_NO_MOVE	30
#define ic0devMOT_ATTR_ACTION_CHECK	31
#define ic0devMOT_ATTR_RESET_SETUP_CMD	32
#define ic0devMOT_ATTR_MOTORS	33
#define ic0devMOT_ATTR_POSITIONS_SIZE	34
#define ic0devMOT_ATTR_POSITIONS	35
#define ic0devMOT_ATTR_ACTIONS	36
#define ic0devMOT_ATTR_USR_ACTIONS	37
#define ic0devMOT_ATTR_USER_UNIT_FCT	38
#define ic0devMOT_ATTR_USER_UNIT_FCT2	39
#define ic0devMOT_ATTR_USER_UNIT_ARGS	40
#define ic0devMOT_ATTR_INIT_TIMEOUT	41
#define ic0devMOT_ATTR_MOVE_TIMEOUT	42
#define ic0devMOT_ATTR_DISCONNECT	43
#define ic0devMOT_ATTR_USE_CFG_ELEM	44
#define ic0devMOT_ATTR_PARK_ACTION	45
#define ic0devMOT_ATTR_TEST_ACTION	46
#define ic0devMOT_ATTR_TEST	47
#define ic0devMOT_ATTR_INSTALLED	48
#define ic0devMOT_ATTR_ATTACHED	49
#define ic0devMOT_ATTR_PARKED	50
#define ic0devMOT_ATTR_ACTION_STEP	51
#define ic0devMOT_ATTR_ACTION_RETRY	52
#define ic0devMOT_ATTR_ACTION_MOVE_VALID	53
#define ic0devMOT_ATTR_ACTION_MOVE	54
#define ic0devMOT_ATTR_PARSE_POS_INDEX	55
#define ic0devMOT_ATTR_FIRST_POS_INDEX	56
#define ic0devMOT_ATTR_MOVE_MODE	57

#define ic0devMOT_AUTOMATA	0


/*
 * table attribute elements
 */
#define ic0devMOT_ELEM_MOTORS_NAME		  0
#define ic0devMOT_ELEM_MOTORS_MOT_HANDLE	  1
#define ic0devMOT_ELEM_MOTORS_POS_INDEX		  2

#define ic0devMOT_ELEM_POSITIONS_ID		  0
#define ic0devMOT_ELEM_POSITIONS_NAME		  1
#define ic0devMOT_ELEM_POSITIONS_TYPE		  2
#define ic0devMOT_ELEM_POSITIONS_ALIGNED	  3
#define ic0devMOT_ELEM_POSITIONS_VALUE4		  4
#define ic0devMOT_ELEM_POSITIONS_VALUE5		  5
#define ic0devMOT_ELEM_POSITIONS_VALUE6		  6
#define ic0devMOT_ELEM_POSITIONS_VALUE7		  7
#define ic0devMOT_ELEM_POSITIONS_VALUE8		  8
#define ic0devMOT_ELEM_POSITIONS_VALUE9		  9
#define ic0devMOT_ELEM_POSITIONS		 10

#define ic0devMOT_ELEM_ACTION_ACTION_TYPE	  0
#define ic0devMOT_ELEM_ACTION_USER_TEXT		  1
#define ic0devMOT_ELEM_ACTION_USER_VALUE	  2
#define ic0devMOT_ELEM_ACTION_MOTOR_INDEX	  3
#define ic0devMOT_ELEM_ACTION_MOTION_MODE	  4
#define ic0devMOT_ELEM_ACTION_POS_HOW		  5
#define ic0devMOT_ELEM_ACTION_POS_VALUE		  6
#define ic0devMOT_ELEM_ACTION_POS_UNIT		  7
#define ic0devMOT_ELEM_ACTION_POS_NAME		  8
#define ic0devMOT_ELEM_ACTION_POS_SECTION	  9
#define ic0devMOT_ELEM_ACTION_POS_INDEX		 10
#define ic0devMOT_ELEM_ACTION_POS_TYPE		 11
#define ic0devMOT_ELEM_ACTION_SPEED_HOW		 12
#define ic0devMOT_ELEM_ACTION_SPEED_VALUE	 13
#define ic0devMOT_ELEM_ACTION_SPEED_UNIT 	 14
#define ic0devMOT_ELEM_ACTION_SPEED_NAME	 15
#define ic0devMOT_ELEM_ACTION_SPEED_INDEX	 16
#define ic0devMOT_ELEM_ACTION_POLL_INT		 17
#define ic0devMOT_ELEM_ACTION_END_POLL_INT	 18
#define ic0devMOT_ELEM_ACTION_IN_POS_TIME	 19
#define ic0devMOT_ELEM_ACTION_WAIT_TIME		 20


/*
 * function table
 */
#define ic0devMOT_FCT_DELETE_OBJ	0
#define ic0devMOT_FCT_STANDBY	1
#define ic0devMOT_FCT_ONLINE	2
#define ic0devMOT_FCT_OFF	3
#define ic0devMOT_FCT_EXIT	4
#define ic0devMOT_FCT_STATE	5
#define ic0devMOT_FCT_SIMULAT	6
#define ic0devMOT_FCT_STOP_SIM	7
#define ic0devMOT_FCT_STATUS	8
#define ic0devMOT_FCT_INIT	9
#define ic0devMOT_FCT_STOP	10
#define ic0devMOT_FCT_TEST	11
#define ic0devMOT_FCT_SELFTST	12
#define ic0devMOT_FCT_AUTO_TBL	13
#define ic0devMOT_FCT_AUTO_RST	14
#define ic0devMOT_FCT_INIT_OBJ	15
#define ic0devMOT_FCT_EXIT_OBJ	16
#define ic0devMOT_FCT_LOADED2STBY	17
#define ic0devMOT_FCT_ONLINE2STBY	18
#define ic0devMOT_FCT_EXIT1	19
#define ic0devMOT_FCT_CHECK_DEVICE_NAME	20
#define ic0devMOT_FCT_BREAK	21
#define ic0devMOT_FCT_USR_INIT	22
#define ic0devMOT_FCT_USR_LOADED2STANDBY	23
#define ic0devMOT_FCT_USR_STANDBY2ONLINE	24
#define ic0devMOT_FCT_USR_ONLINE2STANDBY	25
#define ic0devMOT_FCT_USR_STANDBY2LOADED	26
#define ic0devMOT_FCT_USR_STOP	27
#define ic0devMOT_FCT_USR_SIMULAT	28
#define ic0devMOT_FCT_USR_STOP_SIM	29
#define ic0devMOT_FCT_USR_STATUS_CODE	30
#define ic0devMOT_FCT_USR_STATUS_LAST	31
#define ic0devMOT_FCT_USR_STATUS_VALUE	32
#define ic0devMOT_FCT_USR_TEST	33
#define ic0devMOT_FCT_USR_SELF_TEST	34
#define ic0devMOT_FCT_USR_ERROR	35
#define ic0devMOT_FCT_AVAIL	36
#define ic0devMOT_FCT_UNAVAIL	37
#define ic0devMOT_FCT_DISABLE	38
#define ic0devMOT_FCT_ENABLE	39
#define ic0devMOT_FCT_LOCK	40
#define ic0devMOT_FCT_UNLOCK	41
#define ic0devMOT_FCT_HANDSET	42
#define ic0devMOT_FCT_HSET_OFF	43
#define ic0devMOT_FCT_FIX_POS	44
#define ic0devMOT_FCT_MOVE	45
#define ic0devMOT_FCT_MOVE_REL	46
#define ic0devMOT_FCT_SET	47
#define ic0devMOT_FCT_CHECK	48
#define ic0devMOT_FCT_WAIT	49
#define ic0devMOT_FCT_USR_SET_MODE	50
#define ic0devMOT_FCT_SETUP	51
#define ic0devMOT_FCT_GET_VAL	52
#define ic0devMOT_FCT_SET_VAL	53
#define ic0devMOT_FCT_CFG_ELEM	54
#define ic0devMOT_FCT_LOG_CONF	55
#define ic0devMOT_FCT_GET_CONF	56
#define ic0devMOT_FCT_RESET_PARAMETERS	57
#define ic0devMOT_FCT_PARSE_PARAMETERS	58
#define ic0devMOT_FCT_COMPARE_PARAMETERS	59
#define ic0devMOT_FCT_COPY_PARAMETERS	60
#define ic0devMOT_FCT_EXEC_PARAMETERS	61
#define ic0devMOT_FCT_UPDATE_PARAMETERS	62
#define ic0devMOT_FCT_GET_PARAM_SET_VALUE	63
#define ic0devMOT_FCT_GET_PARAM_STATUS	64
#define ic0devMOT_FCT_SET_PARAM	65
#define ic0devMOT_FCT_SET_PARAM_STEP	66
#define ic0devMOT_FCT_USR_EXEC_ACTION	67
#define ic0devMOT_FCT_USR_SET_PARAMETER	68
#define ic0devMOT_FCT_GET_VALUE_CODE	69
#define ic0devMOT_FCT_GET_VALUE	70
#define ic0devMOT_FCT_USR_GET_VALUE	71
#define ic0devMOT_FCT_SET_VALUE	72
#define ic0devMOT_FCT_USR_SET_VALUE	73
#define ic0devMOT_FCT_GET_ARG	74
#define ic0devMOT_FCT_MONITOR	75
#define ic0devMOT_FCT_USR_MONITOR	76
#define ic0devMOT_FCT_LOG_ACTION	77
#define ic0devMOT_FCT_LOG_COMMENT	78
#define ic0devMOT_FCT_LOG_PARAMETER	79
#define ic0devMOT_FCT_LOG_RECOVERY	80
#define ic0devMOT_FCT_LOG_TBL_PARAM	81
#define ic0devMOT_FCT_LOG_UNFORSEEN	82
#define ic0devMOT_FCT_VAR_SET	83
#define ic0devMOT_FCT_VAR_WAIT	84
#define ic0devMOT_FCT_GET_HANDLES	85
#define ic0devMOT_FCT_PARK	86
#define ic0devMOT_FCT_GET_ACTION	87
#define ic0devMOT_FCT_EXEC_ACTION	88
#define ic0devMOT_FCT_ACTION_GET_HANDLES	89
#define ic0devMOT_FCT_ACTION_NEW_MOVE	90
#define ic0devMOT_FCT_ACTION_IF	91
#define ic0devMOT_FCT_ACTION_PARAM	92
#define ic0devMOT_FCT_ACTION_ADD_PARAM	93
#define ic0devMOT_FCT_ACTION_VALUE	94
#define ic0devMOT_FCT_ACTION_ADD_VALUE	95
#define ic0devMOT_FCT_ACTION_MOVE	96
#define ic0devMOT_FCT_ACTION_SPEED_MOVE	97
#define ic0devMOT_FCT_ACTION_WAIT_MOVE	98
#define ic0devMOT_FCT_ACTION_CLAMP_BRAKE	99
#define ic0devMOT_FCT_ACTION_DISCONNECT	100
#define ic0devMOT_FCT_ACTION_STOP	101
#define ic0devMOT_FCT_ACTION_USER_FUNCTION	102
#define ic0devMOT_FCT_ACTION_RETRY	103
#define ic0devMOT_FCT_ACTION_END	104
#define ic0devMOT_FCT_ACTION_ERROR	105
#define ic0devMOT_FCT_ACTION_SLEEP	106
#define ic0devMOT_FCT_ACTION_INCR_VALUE	107
#define ic0devMOT_FCT_SET_PAR_LIST_ADDRESS	108
#define ic0devMOT_FCT_WLEN2ENC	109
#define ic0devMOT_FCT_TEMP2FOCUS	110
#define ic0devMOT_FCT_SLIT2ENC1	111
#define ic0devMOT_FCT_SLIT2ENC2	112
#define ic0devMOT_FCT_SLIT2ENC	113
#define ic0devMOT_FCT_WLEN_TETA2ENC	114
#define ic0devMOT_FCT_TILT2ENC	115

/*
 * automata states
 */
#define ic0devMOT_STATE_NOSTATE	-1
#define ic0devMOT_STATE_OFF	0
#define ic0devMOT_STATE_LOADED	1
#define ic0devMOT_STATE_STANDBY	2
#define ic0devMOT_STATE_ONLINE	3

/*
 * automata substates
 */
#define ic0devMOT_SUBSTATE_ERROR	0
#define ic0devMOT_SUBSTATE_IDLE	1
#define ic0devMOT_SUBSTATE_BUSY	2
#define ic0devMOT_SUBSTATE_INITIALISING	3
#define ic0devMOT_SUBSTATE_SHUTTING_DOWN	4
#define ic0devMOT_SUBSTATE_STOPPING	5
#define ic0devMOT_SUBSTATE_COLD_STARTING	6
#define ic0devMOT_SUBSTATE_STARTING	7
#define ic0devMOT_SUBSTATE_STOP	8

/*
 * automata events
 */
#define ic0devMOT_EVENT_INIT	0
#define ic0devMOT_EVENT_STANDBY	1
#define ic0devMOT_EVENT_ONLINE	2
#define ic0devMOT_EVENT_STOP	3
#define ic0devMOT_EVENT_OFF	4
#define ic0devMOT_EVENT_EXIT	5
#define ic0devMOT_EVENT_STATE	6
#define ic0devMOT_EVENT_STOP_SIM	7
#define ic0devMOT_EVENT_STATUS	8
#define ic0devMOT_EVENT_SIMULAT	9
#define ic0devMOT_EVENT_TEST	10
#define ic0devMOT_EVENT_SELFTST	11
#define ic0devMOT_EVENT_AUTO_TBL	12
#define ic0devMOT_EVENT_AUTO_RST	13
#define ic0devMOT_EVENT_DISABLE	14
#define ic0devMOT_EVENT_ENABLE	15
#define ic0devMOT_EVENT_LOCK	16
#define ic0devMOT_EVENT_UNLOCK	17
#define ic0devMOT_EVENT_HANDSET	18
#define ic0devMOT_EVENT_HSET_OFF	19
#define ic0devMOT_EVENT_AVAIL	20
#define ic0devMOT_EVENT_UNAVAIL	21
#define ic0devMOT_EVENT_MOVE	22
#define ic0devMOT_EVENT_MOVE_REL	23
#define ic0devMOT_EVENT_SET	24
#define ic0devMOT_EVENT_CHECK	25
#define ic0devMOT_EVENT_WAIT	26
#define ic0devMOT_EVENT_SETUP	27
#define ic0devMOT_EVENT_CFG_ELEM	28
#define ic0devMOT_EVENT_GET_VAL	29
#define ic0devMOT_EVENT_SET_VAL	30
#define ic0devMOT_EVENT_LOG_CONF	31
#define ic0devMOT_EVENT_GET_CONF	32
#define ic0devMOT_EVENT_MONITOR	33


/*
 * table types
 */
typedef struct
    {
    vltBYTES16	id;
    vltBYTES16	name;
    vltBYTES16	type;
    } ic0devMOT_POSITION_HEADER;

typedef struct
    {
    vltBYTES16	id;
    vltBYTES16	name;
    vltBYTES16	type;
    vltINT32	aligned;  /* can't be vltLOGICAL due to alignment problems with OLDB */
    vltDOUBLE	value4;
    vltDOUBLE	value5;
    vltDOUBLE	value6;
    vltDOUBLE	value7;
    vltDOUBLE	value8;
    vltDOUBLE	value9;
    } ic0devMOT_POSITION;

typedef struct 
    {
    vltINT32	  actionType;
    vltBYTES32	  userText;
    vltINT32	  userValue;
    vltUINT32	  motorIndex;
    motMOTIONMODE motionMode;
    motPOSITION	  position;
    motPOS_TYPE	  posType;
    motSPEED	  speed;
    vltUINT32	  waitTime;
    } ic0devMOT_ACTION;

/*
 * user variables
 */
typedef struct
    {
    egenOBJ	obj;
    motHANDLE	motor;
    } ic0devMOT_SYNC_VAR_PARLIST;

typedef struct
    {
    SEM_ID	actionSequence;
    SEM_ID	actionSetup;
    ic0devMOT_SYNC_VAR_PARLIST*	syncVarParList[2];
    egenOBJ*	objParList[2];
    vltINT32	dummy[4];
    } ic0devMOT_USERVAR;


/*
 * function pointer types
 */
typedef ccsCOMPL_STAT (*ic0devMOT_FCTPTR_CHECK)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   char**	status,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devMOT_FCTPTR_WAIT)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltINT32	timeout,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devMOT_FCTPTR_CFG_ELEM)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltINT32	position,
    IN    const char*	id,
    IN    const char*	values[],	/* max. vltBYTES16[10] */
    IN    vltINT16	valuesNum,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devMOT_FCTPTR_LOG_CONF)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltLOGICAL	allElements,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devMOT_FCTPTR_GET_CONF)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltLOGICAL	allElements,
    OUT   char**	text,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devMOT_FCTPTR_VAR_SET)(
    INOUT egenOBJ*	obj,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devMOT_FCTPTR_VAR_WAIT)(
    INOUT egenOBJ*	obj,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devMOT_FCTPTR_INIT_OBJ)(
    INOUT egenOBJ*	obj,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devMOT_FCTPTR_EXIT_OBJ)(
    INOUT egenOBJ*	obj,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devMOT_FCTPTR_USR_INIT)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devMOT_FCTPTR_USR_LOADED2STANDBY)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devMOT_FCTPTR_USR_STANDBY2ONLINE)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devMOT_FCTPTR_USR_ONLINE2STANDBY)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devMOT_FCTPTR_USR_STANDBY2LOADED)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devMOT_FCTPTR_USR_STOP)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltLOGICAL	req,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devMOT_FCTPTR_USR_SET_MODE)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltINT32	cmd,
    IN    vltLOGICAL	available,
    IN    vltLOGICAL	enabled,
    IN    vltLOGICAL	simulation,
    IN    vltLOGICAL	handset,
    IN    vltLOGICAL	locked,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devMOT_FCTPTR_USR_SELF_TEST)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devMOT_FCTPTR_USR_TEST)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devMOT_FCTPTR_USR_EXEC_ACTION)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltINT32	index,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devMOT_FCTPTR_USR_SET_PARAMETER)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltINT32	cmd,
    IN    vltINT32	param1,
    IN    vltINT32	param1SetCode,
    IN    vltINT32	param2,
    IN    vltINT32	param2SetCode,
    INOUT lcctooVALUE*	value,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devMOT_FCTPTR_USR_GET_VALUE)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    const ic0devSOFT_VALUE	valuesTable[],	/* max. ic0devSOFT_VALUE[99] */
    IN    vltINT16	valuesTableNum,
    IN    vltINT32	code,
    IN    vltINT32	index,
    OUT   lcctooVALUE	value[],	/* max. lcctooVALUE[10] */
    OUT   vltINT16*	valueNum,
    OUT   vltLOGICAL*	done,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devMOT_FCTPTR_USR_SET_VALUE)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    INOUT ic0devSOFT_VALUE	valuesTable[],	/* max. ic0devSOFT_VALUE[99] */
    INOUT vltINT16*	valuesTableNum,
    IN    vltINT32	code,
    IN    vltINT32	index,
    IN    const lcctooVALUE	value[],	/* max. lcctooVALUE[10] */
    IN    vltINT16	valueNum,
    OUT   vltLOGICAL*	done,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devMOT_FCTPTR_GET_ARG)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltINT32	code,
    IN    vltINT32	index,
    OUT   lcctooVALUE*	value,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devMOT_FCTPTR_GET_HANDLES)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   motHANDLE*	motors,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devMOT_FCTPTR_PARK)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devMOT_FCTPTR_GET_ACTION)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltINT32	actionStep,
    OUT   ic0devMOT_ACTION*	action,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devMOT_FCTPTR_EXEC_ACTION)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    ic0devMOT_ACTION*	action,
    OUT   vltLOGICAL*	end,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devMOT_FCTPTR_ACTION_GET_HANDLES)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltINT32	index,
    OUT   motHANDLE*	motors,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devMOT_FCTPTR_ACTION_NEW_MOVE)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    ic0devMOT_ACTION*	action,
    OUT   vltLOGICAL*	end,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devMOT_FCTPTR_ACTION_IF)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    ic0devMOT_ACTION*	action,
    OUT   vltLOGICAL*	end,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devMOT_FCTPTR_ACTION_PARAM)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    ic0devMOT_ACTION*	action,
    OUT   vltLOGICAL*	end,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devMOT_FCTPTR_ACTION_ADD_PARAM)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    ic0devMOT_ACTION*	action,
    OUT   vltLOGICAL*	end,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devMOT_FCTPTR_ACTION_VALUE)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    ic0devMOT_ACTION*	action,
    OUT   vltLOGICAL*	end,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devMOT_FCTPTR_ACTION_ADD_VALUE)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    ic0devMOT_ACTION*	action,
    OUT   vltLOGICAL*	end,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devMOT_FCTPTR_ACTION_MOVE)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    ic0devMOT_ACTION*	action,
    OUT   vltLOGICAL*	end,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devMOT_FCTPTR_ACTION_SPEED_MOVE)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    ic0devMOT_ACTION*	action,
    OUT   vltLOGICAL*	end,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devMOT_FCTPTR_ACTION_WAIT_MOVE)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    ic0devMOT_ACTION*	action,
    OUT   vltLOGICAL*	end,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devMOT_FCTPTR_ACTION_CLAMP_BRAKE)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    ic0devMOT_ACTION*	action,
    OUT   vltLOGICAL*	end,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devMOT_FCTPTR_ACTION_DISCONNECT)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    ic0devMOT_ACTION*	action,
    OUT   vltLOGICAL*	end,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devMOT_FCTPTR_ACTION_STOP)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    ic0devMOT_ACTION*	action,
    OUT   vltLOGICAL*	end,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devMOT_FCTPTR_ACTION_USER_FUNCTION)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    ic0devMOT_ACTION*	action,
    OUT   vltLOGICAL*	end,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devMOT_FCTPTR_ACTION_RETRY)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    ic0devMOT_ACTION*	action,
    OUT   vltLOGICAL*	end,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devMOT_FCTPTR_ACTION_END)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    ic0devMOT_ACTION*	action,
    OUT   vltLOGICAL*	end,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devMOT_FCTPTR_ACTION_ERROR)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    ic0devMOT_ACTION*	action,
    OUT   vltLOGICAL*	end,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devMOT_FCTPTR_ACTION_SLEEP)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    ic0devMOT_ACTION*	action,
    OUT   vltLOGICAL*	end,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devMOT_FCTPTR_ACTION_INCR_VALUE)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    ic0devMOT_ACTION*	action,
    OUT   vltLOGICAL*	end,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devMOT_FCTPTR_SET_PAR_LIST_ADDRESS)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    motHANDLE*	motor,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devMOT_FCTPTR_WLEN2ENC)(
    INOUT egenOBJ*	obj,
    IN    motMETRIC*	from,
    OUT   motMETRIC*	to,
    IN    egenOBJ*	parList,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devMOT_FCTPTR_TEMP2FOCUS)(
    INOUT egenOBJ*	obj,
    IN    motMETRIC*	from,
    OUT   motMETRIC*	to,
    IN    egenOBJ*	parList,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devMOT_FCTPTR_SLIT2ENC1)(
    INOUT egenOBJ*	obj,
    IN    motMETRIC*	from,
    OUT   motMETRIC*	to,
    IN    egenOBJ*	parList,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devMOT_FCTPTR_SLIT2ENC2)(
    INOUT egenOBJ*	obj,
    IN    motMETRIC*	from,
    OUT   motMETRIC*	to,
    IN    egenOBJ*	parList,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devMOT_FCTPTR_SLIT2ENC)(
    INOUT egenOBJ*	obj,
    IN    vltINT32	motorIndex,
    IN    motMETRIC*	from,
    OUT   motMETRIC*	to,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devMOT_FCTPTR_WLEN_TETA2ENC)(
    INOUT egenOBJ*	obj,
    IN    motMETRIC*	from,
    OUT   motMETRIC*	to,
    IN    egenOBJ*	parList,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devMOT_FCTPTR_TILT2ENC)(
    INOUT egenOBJ*	obj,
    IN    motMETRIC*	from,
    OUT   motMETRIC*	to,
    IN    egenOBJ*	parList,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devMOT_FCTPTR_USR_STATUS_CODE)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    const char*	text,
    IN    vltINT32	flags,
    OUT   vltINT32*	code,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devMOT_FCTPTR_USR_STATUS_VALUE)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltINT32	code,
    OUT   lcctooVALUE*	value,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devMOT_FCTPTR_USR_STATUS_LAST)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   vltINT16*	last,
    OUT   ccsERROR*	error);


/*
 * log function
 */
#define ic0devMotLogData(obj, format, arg...) \
	{ \
	char tmpLogBuf[lcctooTMP_BUFFER_SIZE]; \
	\
	sprintf(tmpLogBuf, (format), ##arg); \
	logData("ic0dev", (obj)->id, tmpLogBuf); \
	}


/*
 * error functions
 */
#define ic0devErrActionMoveNotValid(p1) \
	{ \
	lcctooLOG_0("ic0devERR_ACTION_MOVE_NOT_VALID: Device %s: Movement not valid.",(p1)); \
	errAdd(error,"ic0dev",ic0devERR_ACTION_MOVE_NOT_VALID,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0devErrActionSleep(p1,p2) \
	{ \
	lcctooLOG_0("ic0devERR_ACTION_SLEEP: Device %s: Unable to sleep %d msecs.",(p1),(p2)); \
	errAdd(error,"ic0dev",ic0devERR_ACTION_SLEEP,__FILE_LINE__,"%s,%d",(p1),(p2)); \
	}
#define ic0devErrGetArg(p1,p2) \
	{ \
	lcctooLOG_0("ic0devERR_GET_ARG: UnitConvFct %s: Error obtaining the %d. argument.",(p1),(p2)); \
	errAdd(error,"ic0dev",ic0devERR_GET_ARG,__FILE_LINE__,"%s,%d",(p1),(p2)); \
	}
#define ic0devErrGetActionsSize(p1) \
	{ \
	lcctooLOG_0("ic0devERR_GET_ACTIONS_SIZE: Device %s: Unable to get the size of the actions table.",(p1)); \
	errAdd(error,"ic0dev",ic0devERR_GET_ACTIONS_SIZE,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0devErrGetPositionsSize(p1) \
	{ \
	lcctooLOG_0("ic0devERR_GET_POSITIONS_SIZE: Device %s: Unable to get the size of the positions table.",(p1)); \
	errAdd(error,"ic0dev",ic0devERR_GET_POSITIONS_SIZE,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0devErrGetUsrActionsSize(p1) \
	{ \
	lcctooLOG_0("ic0devERR_GET_USR_ACTIONS_SIZE: Device %s: Unable to get the size of the user actions table.",(p1)); \
	errAdd(error,"ic0dev",ic0devERR_GET_USR_ACTIONS_SIZE,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0devErrMotAttach(p1,p2) \
	{ \
	lcctooLOG_0("ic0devERR_MOT_ATTACH: Device %s: Unable to attach motor %s.",(p1),(p2)); \
	errAdd(error,"ic0dev",ic0devERR_MOT_ATTACH,__FILE_LINE__,"%s,%s",(p1),(p2)); \
	}
#define ic0devErrMotClampBrake(p1,p2) \
	{ \
	lcctooLOG_0("ic0devERR_MOT_CLAMP_BRAKE: Device %s: Unable to clamp brake of motor %d.",(p1),(p2)); \
	errAdd(error,"ic0dev",ic0devERR_MOT_CLAMP_BRAKE,__FILE_LINE__,"%s,%d",(p1),(p2)); \
	}
#define ic0devErrMotConnect(p1) \
	{ \
	lcctooLOG_0("ic0devERR_MOT_CONNECT: Device %s: Unable to electrically connect the motors.",(p1)); \
	errAdd(error,"ic0dev",ic0devERR_MOT_CONNECT,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0devErrMotDetach(p1) \
	{ \
	lcctooLOG_0("ic0devERR_MOT_DETACH: Device %s: Unable to detach motor(s).",(p1)); \
	errAdd(error,"ic0dev",ic0devERR_MOT_DETACH,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0devErrMotDisconnect(p1) \
	{ \
	lcctooLOG_0("ic0devERR_MOT_DISCONNECT: Device %s: Unable to electrically disconnect the motors.",(p1)); \
	errAdd(error,"ic0dev",ic0devERR_MOT_DISCONNECT,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0devErrMotEnable(p1) \
	{ \
	lcctooLOG_0("ic0devERR_MOT_ENABLE: Device %s: Unable to enable the motor axis.",(p1)); \
	errAdd(error,"ic0dev",ic0devERR_MOT_ENABLE,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0devErrMotEncToName(p1,p2) \
	{ \
	lcctooLOG_0("ic0devERR_MOT_ENC_TO_NAME: Unable to retrieve name of position %dEnc (Section %d).",(p1),(p2)); \
	errAdd(error,"ic0dev",ic0devERR_MOT_ENC_TO_NAME,__FILE_LINE__,"%d,%d",(p1),(p2)); \
	}
#define ic0devErrMotGetOpMode(p1) \
	{ \
	lcctooLOG_0("ic0devERR_MOT_GET_OP_MODE: Device %s: Unable to get the motor status.",(p1)); \
	errAdd(error,"ic0dev",ic0devERR_MOT_GET_OP_MODE,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0devErrMotGetStatus(p1) \
	{ \
	lcctooLOG_0("ic0devERR_MOT_GET_STATUS: Device %s: Unable to get the motor status.",(p1)); \
	errAdd(error,"ic0dev",ic0devERR_MOT_GET_STATUS,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0devErrMotInitHw(p1) \
	{ \
	lcctooLOG_0("ic0devERR_MOT_INIT_HW: Device %s: Error performing the hardware initialisation of the motor(s).",(p1)); \
	errAdd(error,"ic0dev",ic0devERR_MOT_INIT_HW,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0devErrMotInitSw(p1) \
	{ \
	lcctooLOG_0("ic0devERR_MOT_INIT_SW: Device %s: Error performing the software initialisation of the motor(s).",(p1)); \
	errAdd(error,"ic0dev",ic0devERR_MOT_INIT_SW,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0devErrMotInstall(p1,p2) \
	{ \
	lcctooLOG_0("ic0devERR_MOT_INSTALL: Device %s: Unable to install motor %s.",(p1),(p2)); \
	errAdd(error,"ic0dev",ic0devERR_MOT_INSTALL,__FILE_LINE__,"%s,%s",(p1),(p2)); \
	}
#define ic0devErrMotMove(p1,p2) \
	{ \
	lcctooLOG_0("ic0devERR_MOT_MOVE: Device %s: Error in motor movement (motor %d).",(p1),(p2)); \
	errAdd(error,"ic0dev",ic0devERR_MOT_MOVE,__FILE_LINE__,"%s,%d",(p1),(p2)); \
	}
#define ic0devErrMotSetMotionMode(p1,p2,p3) \
	{ \
	lcctooLOG_0("ic0devERR_MOT_SET_MOTION_MODE: Device %s: Error setting motion mode (motor %d, mode %d).",(p1),(p2),(p3)); \
	errAdd(error,"ic0dev",ic0devERR_MOT_SET_MOTION_MODE,__FILE_LINE__,"%s,%d,%d",(p1),(p2),(p3)); \
	}
#define ic0devErrMotSetOpMode(p1,p2) \
	{ \
	lcctooLOG_0("ic0devERR_MOT_SET_OP_MODE: Device %s: Unable to set the motor(s) to operation mode %s.",(p1),(p2)); \
	errAdd(error,"ic0dev",ic0devERR_MOT_SET_OP_MODE,__FILE_LINE__,"%s,%s",(p1),(p2)); \
	}
#define ic0devErrMotStop(p1) \
	{ \
	lcctooLOG_0("ic0devERR_MOT_STOP: Device %s: Unable to stop the motor(s).",(p1)); \
	errAdd(error,"ic0dev",ic0devERR_MOT_STOP,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0devErrMotStopSampling(p1) \
	{ \
	lcctooLOG_0("ic0devERR_MOT_STOP_SAMPLING: Device %s: Error while stopping the motor sampling task.",(p1)); \
	errAdd(error,"ic0dev",ic0devERR_MOT_STOP_SAMPLING,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0devErrMotWaitInit(p1) \
	{ \
	lcctooLOG_0("ic0devERR_MOT_WAIT_INIT: Device %s: Error while waiting for the hardware initialisation of the motor(s).",(p1)); \
	errAdd(error,"ic0dev",ic0devERR_MOT_WAIT_INIT,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0devErrMotWaitMove(p1,p2,p3) \
	{ \
	lcctooLOG_0("ic0devERR_MOT_WAIT_MOVE: Device %s: Error while waiting for the end of movement of the motor (motor %d, timeout %d).",(p1),(p2),(p3)); \
	errAdd(error,"ic0dev",ic0devERR_MOT_WAIT_MOVE,__FILE_LINE__,"%s,%d,%d",(p1),(p2),(p3)); \
	}
#define ic0devErrMotorNotInPosition(p1,p2) \
	{ \
	lcctooLOG_0("ic0devERR_MOTOR_NOT_IN_POSITION: Device %s: Motor %d not in position after movement.",(p1),(p2)); \
	errAdd(error,"ic0dev",ic0devERR_MOTOR_NOT_IN_POSITION,__FILE_LINE__,"%s,%d",(p1),(p2)); \
	}
#define ic0devErrMotorNotStanding(p1,p2) \
	{ \
	lcctooLOG_0("ic0devERR_MOTOR_NOT_STANDING: Device %s: Motor %d not standing after movement. Stopped.",(p1),(p2)); \
	errAdd(error,"ic0dev",ic0devERR_MOTOR_NOT_STANDING,__FILE_LINE__,"%s,%d",(p1),(p2)); \
	}
#define ic0devErrNoHwInit(p1) \
	{ \
	lcctooLOG_0("ic0devERR_NO_HW_INIT: Device %s: Error performing the hardware initialisation.",(p1)); \
	errAdd(error,"ic0dev",ic0devERR_NO_HW_INIT,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0devErrNoMotors(p1) \
	{ \
	lcctooLOG_0("ic0devERR_NO_MOTORS: Device %s: Registered motor(s) not found.",(p1)); \
	errAdd(error,"ic0dev",ic0devERR_NO_MOTORS,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0devErrNoMotor2(p1) \
	{ \
	lcctooLOG_0("ic0devERR_NO_MOTOR2: Device %s: Device has no 2. motor.",(p1)); \
	errAdd(error,"ic0dev",ic0devERR_NO_MOTOR2,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0devErrNoPosIndex(p1) \
	{ \
	lcctooLOG_0("ic0devERR_NO_POS_INDEX: Device %s: No position index available to retrieve offset.",(p1)); \
	errAdd(error,"ic0dev",ic0devERR_NO_POS_INDEX,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0devErrNoUserFunction(p1) \
	{ \
	lcctooLOG_0("ic0devERR_NO_USER_FUNCTION: Device %s: No user function registered in action USER_FUNCTION.",(p1)); \
	errAdd(error,"ic0dev",ic0devERR_NO_USER_FUNCTION,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0devErrNotAttached(p1) \
	{ \
	lcctooLOG_0("ic0devERR_NOT_ATTACHED: Device %s: Motors not attached.",(p1)); \
	errAdd(error,"ic0dev",ic0devERR_NOT_ATTACHED,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0devErrParamMissing(p1,p2) \
	{ \
	lcctooLOG_0("ic0devERR_PARAM_MISSING: Device %s: Parameter %s missing.",(p1),(p2)); \
	errAdd(error,"ic0dev",ic0devERR_PARAM_MISSING,__FILE_LINE__,"%s,%s",(p1),(p2)); \
	}
#define ic0devErrParamLogical(p1,p2) \
	{ \
	lcctooLOG_0("ic0devERR_PARAM_LOGICAL: Device %s: Expecting a logical value instead of '%s'.",(p1),(p2)); \
	errAdd(error,"ic0dev",ic0devERR_PARAM_LOGICAL,__FILE_LINE__,"%s,%s",(p1),(p2)); \
	}
#define ic0devErrParamNumber(p1,p2) \
	{ \
	lcctooLOG_0("ic0devERR_PARAM_NUMBER: Device %s: Expecting a number instead of '%s'.",(p1),(p2)); \
	errAdd(error,"ic0dev",ic0devERR_PARAM_NUMBER,__FILE_LINE__,"%s,%s",(p1),(p2)); \
	}
#define ic0devErrParamString(p1,p2) \
	{ \
	lcctooLOG_0("ic0devERR_PARAM_STRING: Device %s: Expecting a string instead of '%s'.",(p1),(p2)); \
	errAdd(error,"ic0dev",ic0devERR_PARAM_STRING,__FILE_LINE__,"%s,%s",(p1),(p2)); \
	}
#define ic0devErrParamTime(p1,p2) \
	{ \
	lcctooLOG_0("ic0devERR_PARAM_TIME: Device %s: Expecting a time value instead of '%s'.",(p1),(p2)); \
	errAdd(error,"ic0dev",ic0devERR_PARAM_TIME,__FILE_LINE__,"%s,%s",(p1),(p2)); \
	}
#define ic0devErrPark(p1) \
	{ \
	lcctooLOG_0("ic0devERR_PARK: Device %s: Error while parking the motor(s).",(p1)); \
	errAdd(error,"ic0dev",ic0devERR_PARK,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0devErrParseNumber(p1,p2) \
	{ \
	lcctooLOG_0("ic0devERR_PARSE_NUMBER: Device %s: Value %s is not a number.",(p1),(p2)); \
	errAdd(error,"ic0dev",ic0devERR_PARSE_NUMBER,__FILE_LINE__,"%s,%s",(p1),(p2)); \
	}
#define ic0devErrPosTooLong(p1,p2) \
	{ \
	lcctooLOG_0("ic0devERR_POS_TOO_LONG: Device %s: Text %d too long.",(p1),(p2)); \
	errAdd(error,"ic0dev",ic0devERR_POS_TOO_LONG,__FILE_LINE__,"%s,%d",(p1),(p2)); \
	}
#define ic0devErrPositionNum(p1,p2) \
	{ \
	lcctooLOG_0("ic0devERR_POSITION_NUM: Device %s: Position %d out of range.",(p1),(p2)); \
	errAdd(error,"ic0dev",ic0devERR_POSITION_NUM,__FILE_LINE__,"%s,%d",(p1),(p2)); \
	}
#define ic0devErrPosToEnc(p1,p2,p3) \
	{ \
	lcctooLOG_0("ic0devERR_POS_TO_ENC: Device %s: Unable to convert value %g%s to encoder units.",(p1),(p2),(p3)); \
	errAdd(error,"ic0dev",ic0devERR_POS_TO_ENC,__FILE_LINE__,"%s,%g,%s",(p1),(p2),(p3)); \
	}
#define ic0devErrReadActionMove(p1,p2) \
	{ \
	lcctooLOG_0("ic0devERR_READ_ACTION_MOVE: Device %s: Unable to read attribute 'actionMove' from OLDB (%s).",(p1),(p2)); \
	errAdd(error,"ic0dev",ic0devERR_READ_ACTION_MOVE,__FILE_LINE__,"%s,%s",(p1),(p2)); \
	}
#define ic0devErrReadActionMoveValid(p1) \
	{ \
	lcctooLOG_0("ic0devERR_READ_ACTION_MOVE_VALID: Device %s: Unable to read attribute 'actionMoveValid' from OLDB.",(p1)); \
	errAdd(error,"ic0dev",ic0devERR_READ_ACTION_MOVE_VALID,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0devErrReadActionRetry(p1) \
	{ \
	lcctooLOG_0("ic0devERR_READ_ACTION_RETRY: Device %s: Unable to read attribute 'actionRetry' from OLDB.",(p1)); \
	errAdd(error,"ic0dev",ic0devERR_READ_ACTION_RETRY,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0devErrReadActionStep(p1) \
	{ \
	lcctooLOG_0("ic0devERR_READ_ACTION_STEP: Device %s: Unable to read attribute 'actionStep' from OLDB.",(p1)); \
	errAdd(error,"ic0dev",ic0devERR_READ_ACTION_STEP,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0devErrReadActions(p1,p2) \
	{ \
	lcctooLOG_0("ic0devERR_READ_ACTIONS: Device %s: Unable to read actions (%s) from OLDB.",(p1),(p2)); \
	errAdd(error,"ic0dev",ic0devERR_READ_ACTIONS,__FILE_LINE__,"%s,%s",(p1),(p2)); \
	}
#define ic0devErrReadAttached(p1) \
	{ \
	lcctooLOG_0("ic0devERR_READ_ATTACHED: Device %s: Unable to read attribute 'attached' from OLDB.",(p1)); \
	errAdd(error,"ic0dev",ic0devERR_READ_ATTACHED,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0devErrReadDisconnect(p1) \
	{ \
	lcctooLOG_0("ic0devERR_READ_DISCONNECT: Device %s: Unable to read attribute 'disconnect' from OLDB.",(p1)); \
	errAdd(error,"ic0dev",ic0devERR_READ_DISCONNECT,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0devErrReadFirstPosIndex(p1) \
	{ \
	lcctooLOG_0("ic0devERR_READ_FIRST_POS_INDEX: Device %s: Unable to read attribute 'firstPosIndex' from OLDB.",(p1)); \
	errAdd(error,"ic0dev",ic0devERR_READ_FIRST_POS_INDEX,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0devErrReadInitTimeout(p1) \
	{ \
	lcctooLOG_0("ic0devERR_READ_INIT_TIMEOUT: Device %s: Unable to read initialisation timeout from OLDB.",(p1)); \
	errAdd(error,"ic0dev",ic0devERR_READ_INIT_TIMEOUT,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0devErrReadInstalled(p1) \
	{ \
	lcctooLOG_0("ic0devERR_READ_INSTALLED: Device %s: Unable to read attribute 'installed' from OLDB.",(p1)); \
	errAdd(error,"ic0dev",ic0devERR_READ_INSTALLED,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0devErrReadMotors(p1,p2) \
	{ \
	lcctooLOG_0("ic0devERR_READ_MOTORS: Device %s: Unable to read motor configuration (%s) from OLDB.",(p1),(p2)); \
	errAdd(error,"ic0dev",ic0devERR_READ_MOTORS,__FILE_LINE__,"%s,%s",(p1),(p2)); \
	}
#define ic0devErrReadMotStatus(p1) \
	{ \
	lcctooLOG_0("ic0devERR_READ_MOT_STATUS: Unable to read motor status OLDB database (attribute %s).",(p1)); \
	errAdd(error,"ic0dev",ic0devERR_READ_MOT_STATUS,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0devErrReadMoveTimeout(p1) \
	{ \
	lcctooLOG_0("ic0devERR_READ_MOVE_TIMEOUT: Device %s: Unable to read movement timeout from OLDB.",(p1)); \
	errAdd(error,"ic0dev",ic0devERR_READ_MOVE_TIMEOUT,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0devErrReadParkAction(p1) \
	{ \
	lcctooLOG_0("ic0devERR_READ_PARK_ACTION: Device %s: Unable to read park action from OLDB.",(p1)); \
	errAdd(error,"ic0dev",ic0devERR_READ_PARK_ACTION,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0devErrReadParked(p1) \
	{ \
	lcctooLOG_0("ic0devERR_READ_PARKED: Device %s: Unable to read attribute 'parked' from OLDB.",(p1)); \
	errAdd(error,"ic0dev",ic0devERR_READ_PARKED,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0devErrReadParsePosIndex(p1) \
	{ \
	lcctooLOG_0("ic0devERR_READ_PARSE_POS_INDEX: Device %s: Unable to read attribute 'parsePosIndex' from OLDB.",(p1)); \
	errAdd(error,"ic0dev",ic0devERR_READ_PARSE_POS_INDEX,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0devErrReadPositions(p1,p2) \
	{ \
	lcctooLOG_0("ic0devERR_READ_POSITIONS: Device %s: Unable to read positions (%s) from OLDB.",(p1),(p2)); \
	errAdd(error,"ic0dev",ic0devERR_READ_POSITIONS,__FILE_LINE__,"%s,%s",(p1),(p2)); \
	}
#define ic0devErrReadTestAction(p1) \
	{ \
	lcctooLOG_0("ic0devERR_READ_TEST_ACTION: Device %s: Unable to read test action from OLDB.",(p1)); \
	errAdd(error,"ic0dev",ic0devERR_READ_TEST_ACTION,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0devErrReadUseCfgElem(p1) \
	{ \
	lcctooLOG_0("ic0devERR_READ_USE_CFG_ELEM: Device %s: Unable to read attribute 'useCfgElem' from OLDB.",(p1)); \
	errAdd(error,"ic0dev",ic0devERR_READ_USE_CFG_ELEM,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0devErrReadUserUnitArgs(p1) \
	{ \
	lcctooLOG_0("ic0devERR_READ_USER_UNIT_ARGS: Device %s: Unable to read attribute 'userUnitArgs' from OLDB.",(p1)); \
	errAdd(error,"ic0dev",ic0devERR_READ_USER_UNIT_ARGS,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0devErrReadUserUnitFct(p1) \
	{ \
	lcctooLOG_0("ic0devERR_READ_USER_UNIT_FCT: Device %s: Unable to read attribute 'userUnitFct' from OLDB.",(p1)); \
	errAdd(error,"ic0dev",ic0devERR_READ_USER_UNIT_FCT,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0devErrReadUsrActions(p1,p2) \
	{ \
	lcctooLOG_0("ic0devERR_READ_USR_ACTIONS: Device %s: Unable to read user actions (%s) from OLDB.",(p1),(p2)); \
	errAdd(error,"ic0dev",ic0devERR_READ_USR_ACTIONS,__FILE_LINE__,"%s,%s",(p1),(p2)); \
	}
#define ic0devErrSetParListAddress(p1,p2) \
	{ \
	lcctooLOG_0("ic0devERR_SET_PAR_LIST_ADDRESS: Device %s: Error setting the parameter list addresses for motor %s.",(p1),(p2)); \
	errAdd(error,"ic0dev",ic0devERR_SET_PAR_LIST_ADDRESS,__FILE_LINE__,"%s,%s",(p1),(p2)); \
	}
#define ic0devErrTest(p1) \
	{ \
	lcctooLOG_0("ic0devERR_TEST: Device %s: Error while testing the device.",(p1)); \
	errAdd(error,"ic0dev",ic0devERR_TEST,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0devErrValueNotFound(p1,p2) \
	{ \
	lcctooLOG_0("ic0devERR_VALUE_NOT_FOUND: Device %s: Value %s not found.",(p1),(p2)); \
	errAdd(error,"ic0dev",ic0devERR_VALUE_NOT_FOUND,__FILE_LINE__,"%s,%s",(p1),(p2)); \
	}
#define ic0devErrWriteActionMove(p1,p2) \
	{ \
	lcctooLOG_0("ic0devERR_WRITE_ACTION_MOVE: Device %s: Unable to write attribute 'actionMove' (%s).",(p1),(p2)); \
	errAdd(error,"ic0dev",ic0devERR_WRITE_ACTION_MOVE,__FILE_LINE__,"%s,%s",(p1),(p2)); \
	}
#define ic0devErrWriteActionMoveValid(p1,p2) \
	{ \
	lcctooLOG_0("ic0devERR_WRITE_ACTION_MOVE_VALID: Device %s: Unable to write attribute 'actionMoveValid' (value %d).",(p1),(p2)); \
	errAdd(error,"ic0dev",ic0devERR_WRITE_ACTION_MOVE_VALID,__FILE_LINE__,"%s,%d",(p1),(p2)); \
	}
#define ic0devErrWriteActionRetry(p1,p2) \
	{ \
	lcctooLOG_0("ic0devERR_WRITE_ACTION_RETRY: Device %s: Unable to write attribute 'actionRetry' (value %d).",(p1),(p2)); \
	errAdd(error,"ic0dev",ic0devERR_WRITE_ACTION_RETRY,__FILE_LINE__,"%s,%d",(p1),(p2)); \
	}
#define ic0devErrWriteActionStep(p1,p2) \
	{ \
	lcctooLOG_0("ic0devERR_WRITE_ACTION_STEP: Device %s: Unable to write attribute 'actionStep' (value %d).",(p1),(p2)); \
	errAdd(error,"ic0dev",ic0devERR_WRITE_ACTION_STEP,__FILE_LINE__,"%s,%d",(p1),(p2)); \
	}
#define ic0devErrWriteAttached(p1,p2) \
	{ \
	lcctooLOG_0("ic0devERR_WRITE_ATTACHED: Device %s: Unable to write attribute 'attached' (value %d).",(p1),(p2)); \
	errAdd(error,"ic0dev",ic0devERR_WRITE_ATTACHED,__FILE_LINE__,"%s,%d",(p1),(p2)); \
	}
#define ic0devErrWriteFirstPosIndex(p1,p2) \
	{ \
	lcctooLOG_0("ic0devERR_WRITE_FIRST_POS_INDEX: Device %s: Unable to write attribute 'firstPosIndex' (value %d).",(p1),(p2)); \
	errAdd(error,"ic0dev",ic0devERR_WRITE_FIRST_POS_INDEX,__FILE_LINE__,"%s,%d",(p1),(p2)); \
	}
#define ic0devErrWriteInstalled(p1,p2) \
	{ \
	lcctooLOG_0("ic0devERR_WRITE_INSTALLED: Device %s: Unable to write attribute 'installed' (value %d).",(p1),(p2)); \
	errAdd(error,"ic0dev",ic0devERR_WRITE_INSTALLED,__FILE_LINE__,"%s,%d",(p1),(p2)); \
	}
#define ic0devErrWriteMotors(p1,p2) \
	{ \
	lcctooLOG_0("ic0devERR_WRITE_MOTORS: Device %s: Unable to write motor configuration (%s).",(p1),(p2)); \
	errAdd(error,"ic0dev",ic0devERR_WRITE_MOTORS,__FILE_LINE__,"%s,%s",(p1),(p2)); \
	}
#define ic0devErrWriteParked(p1,p2) \
	{ \
	lcctooLOG_0("ic0devERR_WRITE_PARKED: Device %s: Unable to write attribute 'parked' (value %d).",(p1),(p2)); \
	errAdd(error,"ic0dev",ic0devERR_WRITE_PARKED,__FILE_LINE__,"%s,%d",(p1),(p2)); \
	}
#define ic0devErrWriteParsePosIndex(p1,p2) \
	{ \
	lcctooLOG_0("ic0devERR_WRITE_PARSE_POS_INDEX: Device %s: Unable to write attribute 'parsePosIndex' (value %d).",(p1),(p2)); \
	errAdd(error,"ic0dev",ic0devERR_WRITE_PARSE_POS_INDEX,__FILE_LINE__,"%s,%d",(p1),(p2)); \
	}
#define ic0devErrWritePositions(p1,p2) \
	{ \
	lcctooLOG_0("ic0devERR_WRITE_POSITIONS: Device %s: Unable to write positions (%s) to OLDB.",(p1),(p2)); \
	errAdd(error,"ic0dev",ic0devERR_WRITE_POSITIONS,__FILE_LINE__,"%s,%s",(p1),(p2)); \
	}
#define ic0devErrWrongAction(p1,p2) \
	{ \
	lcctooLOG_0("ic0devERR_WRONG_ACTION: Device %s: Unknown movement action %d.",(p1),(p2)); \
	errAdd(error,"ic0dev",ic0devERR_WRONG_ACTION,__FILE_LINE__,"%s,%d",(p1),(p2)); \
	}
#define ic0devErrWrongActionStep(p1,p2) \
	{ \
	lcctooLOG_0("ic0devERR_WRONG_ACTION_STEP: Device %s: Wrong action step %d ignored.",(p1),(p2)); \
	errAdd(error,"ic0dev",ic0devERR_WRONG_ACTION_STEP,__FILE_LINE__,"%s,%d",(p1),(p2)); \
	}
#define ic0devErrWrongCondition(p1,p2) \
	{ \
	lcctooLOG_0("ic0devERR_WRONG_CONDITION: Device %s: Wrong condition %s in action GOTO.",(p1),(p2)); \
	errAdd(error,"ic0dev",ic0devERR_WRONG_CONDITION,__FILE_LINE__,"%s,%s",(p1),(p2)); \
	}
#define ic0devErrWrongIfMode(p1,p2) \
	{ \
	lcctooLOG_0("ic0devERR_WRONG_IF_MODE: Device %s: Wrong IF mode %d.",(p1),(p2)); \
	errAdd(error,"ic0dev",ic0devERR_WRONG_IF_MODE,__FILE_LINE__,"%s,%d",(p1),(p2)); \
	}
#define ic0devErrWrongMotionMode(p1,p2) \
	{ \
	lcctooLOG_0("ic0devERR_WRONG_MOTION_MODE: Device %s: Wrong motion mode %d. Only motPOSITION_MODE is supported.",(p1),(p2)); \
	errAdd(error,"ic0dev",ic0devERR_WRONG_MOTION_MODE,__FILE_LINE__,"%s,%d",(p1),(p2)); \
	}
#define ic0devErrWrongMotorIndex(p1,p2) \
	{ \
	lcctooLOG_0("ic0devERR_WRONG_MOTOR_INDEX: Device %s: Unknown motor in action (index %d).",(p1),(p2)); \
	errAdd(error,"ic0dev",ic0devERR_WRONG_MOTOR_INDEX,__FILE_LINE__,"%s,%d",(p1),(p2)); \
	}
#define ic0devErrWrongOpMode(p1) \
	{ \
	lcctooLOG_0("ic0devERR_WRONG_OP_MODE: Device %s: Wrong operational mode for setting the device ONLINE (must be motNORMAL or motSIMULATION).",(p1)); \
	errAdd(error,"ic0dev",ic0devERR_WRONG_OP_MODE,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0devErrWrongParamOption(p1,p2) \
	{ \
	lcctooLOG_0("ic0devERR_WRONG_PARAM_OPTION: Device %s: Wrong option '%s' for parameter action.",(p1),(p2)); \
	errAdd(error,"ic0dev",ic0devERR_WRONG_PARAM_OPTION,__FILE_LINE__,"%s,%s",(p1),(p2)); \
	}
#define ic0devErrWrongSetCode(p1,p2,p3) \
	{ \
	lcctooLOG_0("ic0devERR_WRONG_SET_CODE: Device %s: Wrong set code %d in parameter %d.",(p1),(p2),(p3)); \
	errAdd(error,"ic0dev",ic0devERR_WRONG_SET_CODE,__FILE_LINE__,"%s,%d,%d",(p1),(p2),(p3)); \
	}
#define ic0devErrWrongSetCode2(p1,p2,p3) \
	{ \
	lcctooLOG_0("ic0devERR_WRONG_SET_CODE2: Device %s: Wrong set code %d in %s action.",(p1),(p2),(p3)); \
	errAdd(error,"ic0dev",ic0devERR_WRONG_SET_CODE2,__FILE_LINE__,"%s,%d,%s",(p1),(p2),(p3)); \
	}
#define ic0devErrWrongFromUnit(p1,p2) \
	{ \
	lcctooLOG_0("ic0devERR_WRONG_FROM_UNIT: UnitConvFct %s: Wrong FROM unit '%s'.",(p1),(p2)); \
	errAdd(error,"ic0dev",ic0devERR_WRONG_FROM_UNIT,__FILE_LINE__,"%s,%s",(p1),(p2)); \
	}
#define ic0devErrWrongToUnit(p1,p2) \
	{ \
	lcctooLOG_0("ic0devERR_WRONG_TO_UNIT: UnitConvFct %s: Wrong TO unit '%s'.",(p1),(p2)); \
	errAdd(error,"ic0dev",ic0devERR_WRONG_TO_UNIT,__FILE_LINE__,"%s,%s",(p1),(p2)); \
	}
#define ic0devErrWrongType(p1,p2) \
	{ \
	lcctooLOG_0("ic0devERR_WRONG_TYPE: UnitConvFct %s: %d. argument is of the wrong type.",(p1),(p2)); \
	errAdd(error,"ic0dev",ic0devERR_WRONG_TYPE,__FILE_LINE__,"%s,%d",(p1),(p2)); \
	}
#define ic0devErrWrongUnit(p1,p2) \
	{ \
	lcctooLOG_0("ic0devERR_WRONG_UNIT: Device %s: Wrong unit %s.",(p1),(p2)); \
	errAdd(error,"ic0dev",ic0devERR_WRONG_UNIT,__FILE_LINE__,"%s,%s",(p1),(p2)); \
	}
#define ic0devErrWrongValue(p1,p2) \
	{ \
	lcctooLOG_0("ic0devERR_WRONG_VALUE: Device %s: Wrong value %s.",(p1),(p2)); \
	errAdd(error,"ic0dev",ic0devERR_WRONG_VALUE,__FILE_LINE__,"%s,%s",(p1),(p2)); \
	}

/*
 * get object owner
 */
#define ic0devMotGetOwner(obj) ((obj)->owner)


/*
 * attribute access functions
 */
#define ic0devMotReadState(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0devMOT_ATTR_STATE,(buf),(error))
#define ic0devMotWriteState(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0devMOT_ATTR_STATE,(void*) (buf),(error))
#define ic0devMotReadSubstate(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0devMOT_ATTR_SUBSTATE,(buf),(error))
#define ic0devMotWriteSubstate(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0devMOT_ATTR_SUBSTATE,(void*) (buf),(error))
#define ic0devMotReadError(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0devMOT_ATTR_ERROR,(buf),(error))
#define ic0devMotWriteError(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0devMOT_ATTR_ERROR,(void*) (buf),(error))
#define ic0devMotReadInitialised(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0devMOT_ATTR_INITIALISED,(buf),(error))
#define ic0devMotWriteInitialised(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0devMOT_ATTR_INITIALISED,(void*) (buf),(error))
#define ic0devMotReadSimulation(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0devMOT_ATTR_SIMULATION,(buf),(error))
#define ic0devMotWriteSimulation(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0devMOT_ATTR_SIMULATION,(void*) (buf),(error))
#define ic0devMotReadDevice(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0devMOT_ATTR_DEVICE,(buf),(error))
#define ic0devMotWriteDevice(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0devMOT_ATTR_DEVICE,(void*) (buf),(error))
#define ic0devMotReadAvailable(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0devMOT_ATTR_AVAILABLE,(buf),(error))
#define ic0devMotWriteAvailable(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0devMOT_ATTR_AVAILABLE,(void*) (buf),(error))
#define ic0devMotReadEnabled(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0devMOT_ATTR_ENABLED,(buf),(error))
#define ic0devMotWriteEnabled(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0devMOT_ATTR_ENABLED,(void*) (buf),(error))
#define ic0devMotReadLocked(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0devMOT_ATTR_LOCKED,(buf),(error))
#define ic0devMotWriteLocked(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0devMOT_ATTR_LOCKED,(void*) (buf),(error))
#define ic0devMotReadHandset(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0devMOT_ATTR_HANDSET,(buf),(error))
#define ic0devMotWriteHandset(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0devMOT_ATTR_HANDSET,(void*) (buf),(error))
#define ic0devMotReadFixed(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0devMOT_ATTR_FIXED,(buf),(error))
#define ic0devMotWriteFixed(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0devMOT_ATTR_FIXED,(void*) (buf),(error))
#define ic0devMotReadFixPosSet(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0devMOT_ATTR_FIX_POS_SET,(buf),(error))
#define ic0devMotWriteFixPosSet(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0devMOT_ATTR_FIX_POS_SET,(void*) (buf),(error))
#define ic0devMotReadFixedPosition(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0devMOT_ATTR_FIXED_POSITION,(buf),(error))
#define ic0devMotWriteFixedPosition(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0devMOT_ATTR_FIXED_POSITION,(void*) (buf),(error))
#define ic0devMotReadFixedSimulation(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0devMOT_ATTR_FIXED_SIMULATION,(buf),(error))
#define ic0devMotWriteFixedSimulation(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0devMOT_ATTR_FIXED_SIMULATION,(void*) (buf),(error))
#define ic0devMotReadFixedLocked(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0devMOT_ATTR_FIXED_LOCKED,(buf),(error))
#define ic0devMotWriteFixedLocked(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0devMOT_ATTR_FIXED_LOCKED,(void*) (buf),(error))
#define ic0devMotReadPrefix(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0devMOT_ATTR_PREFIX,(buf),(error))
#define ic0devMotWritePrefix(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0devMOT_ATTR_PREFIX,(void*) (buf),(error))
#define ic0devMotReadParametersSize(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0devMOT_ATTR_PARAMETERS_SIZE,(buf),(error))
#define ic0devMotWriteParametersSize(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0devMOT_ATTR_PARAMETERS_SIZE,(void*) (buf),(error))
#define ic0devMotGetParametersSize(obj,num,error) \
	caiGetAttrInfo((obj)->attrs,ic0devMOT_ATTR_PARAMETERS,NULL,NULL,(num),NULL, NULL,NULL,(error))
#define ic0devMotReadParameters(obj,buf,firstRec,lastRec,firstFld,lastFld,error) \
	lcctooCaiRWTable((obj)->attrs,0,ic0devMOT_ATTR_PARAMETERS,(buf),(firstRec),(lastRec),(firstFld),(lastFld),(error))
#define ic0devMotWriteParameters(obj,buf,firstRec,lastRec,firstFld,lastFld,error) \
	lcctooCaiRWTable((obj)->attrs,1,ic0devMOT_ATTR_PARAMETERS,(void*) (buf),(firstRec),(lastRec),(firstFld),(lastFld),(error))
#define ic0devMotGetStatusSize(obj,num,error) \
	caiGetAttrInfo((obj)->attrs,ic0devMOT_ATTR_STATUS,NULL,NULL,(num),NULL, NULL,NULL,(error))
#define ic0devMotReadStatus(obj,buf,firstElt,lastElt,error) \
	caiRWVector((obj)->attrs,0,ic0devMOT_ATTR_STATUS,(buf),(firstElt),(lastElt),(error))
#define ic0devMotWriteStatus(obj,buf,firstElt,lastElt,error) \
	caiRWVector((obj)->attrs,1,ic0devMOT_ATTR_STATUS,(void*) (buf),(firstElt),(lastElt),(error))
#define ic0devMotGetStatusIndexSize(obj,num,error) \
	caiGetAttrInfo((obj)->attrs,ic0devMOT_ATTR_STATUS_INDEX,NULL,NULL,(num),NULL, NULL,NULL,(error))
#define ic0devMotReadStatusIndex(obj,buf,firstElt,lastElt,error) \
	caiRWVector((obj)->attrs,0,ic0devMOT_ATTR_STATUS_INDEX,(buf),(firstElt),(lastElt),(error))
#define ic0devMotWriteStatusIndex(obj,buf,firstElt,lastElt,error) \
	caiRWVector((obj)->attrs,1,ic0devMOT_ATTR_STATUS_INDEX,(void*) (buf),(firstElt),(lastElt),(error))
#define ic0devMotReadValuesSize(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0devMOT_ATTR_VALUES_SIZE,(buf),(error))
#define ic0devMotWriteValuesSize(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0devMOT_ATTR_VALUES_SIZE,(void*) (buf),(error))
#define ic0devMotGetValuesSize(obj,num,error) \
	caiGetAttrInfo((obj)->attrs,ic0devMOT_ATTR_VALUES,NULL,NULL,(num),NULL, NULL,NULL,(error))
#define ic0devMotReadValues(obj,buf,firstRec,lastRec,firstFld,lastFld,error) \
	lcctooCaiRWTable((obj)->attrs,0,ic0devMOT_ATTR_VALUES,(buf),(firstRec),(lastRec),(firstFld),(lastFld),(error))
#define ic0devMotWriteValues(obj,buf,firstRec,lastRec,firstFld,lastFld,error) \
	lcctooCaiRWTable((obj)->attrs,1,ic0devMOT_ATTR_VALUES,(void*) (buf),(firstRec),(lastRec),(firstFld),(lastFld),(error))
#define ic0devMotReadInitRestriction(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0devMOT_ATTR_INIT_RESTRICTION,(buf),(error))
#define ic0devMotWriteInitRestriction(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0devMOT_ATTR_INIT_RESTRICTION,(void*) (buf),(error))
#define ic0devMotReadMoveRestriction(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0devMOT_ATTR_MOVE_RESTRICTION,(buf),(error))
#define ic0devMotWriteMoveRestriction(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0devMOT_ATTR_MOVE_RESTRICTION,(void*) (buf),(error))
#define ic0devMotReadStopTimeout(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0devMOT_ATTR_STOP_TIMEOUT,(buf),(error))
#define ic0devMotWriteStopTimeout(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0devMOT_ATTR_STOP_TIMEOUT,(void*) (buf),(error))
#define ic0devMotReadSetValFct(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0devMOT_ATTR_SET_VAL_FCT,(buf),(error))
#define ic0devMotWriteSetValFct(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0devMOT_ATTR_SET_VAL_FCT,(void*) (buf),(error))
#define ic0devMotGetHelpTextSize(obj,num,error) \
	caiGetAttrInfo((obj)->attrs,ic0devMOT_ATTR_HELP_TEXT,NULL,NULL,(num),NULL, NULL,NULL,(error))
#define ic0devMotReadHelpText(obj,buf,firstElt,lastElt,error) \
	caiRWVector((obj)->attrs,0,ic0devMOT_ATTR_HELP_TEXT,(buf),(firstElt),(lastElt),(error))
#define ic0devMotWriteHelpText(obj,buf,firstElt,lastElt,error) \
	caiRWVector((obj)->attrs,1,ic0devMOT_ATTR_HELP_TEXT,(void*) (buf),(firstElt),(lastElt),(error))
#define ic0devMotReadParamStep(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0devMOT_ATTR_PARAM_STEP,(buf),(error))
#define ic0devMotWriteParamStep(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0devMOT_ATTR_PARAM_STEP,(void*) (buf),(error))
#define ic0devMotReadActionCommand(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0devMOT_ATTR_ACTION_COMMAND,(buf),(error))
#define ic0devMotWriteActionCommand(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0devMOT_ATTR_ACTION_COMMAND,(void*) (buf),(error))
#define ic0devMotReadActionStopReq(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0devMOT_ATTR_ACTION_STOP_REQ,(buf),(error))
#define ic0devMotWriteActionStopReq(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0devMOT_ATTR_ACTION_STOP_REQ,(void*) (buf),(error))
#define ic0devMotReadActionNoMove(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0devMOT_ATTR_ACTION_NO_MOVE,(buf),(error))
#define ic0devMotWriteActionNoMove(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0devMOT_ATTR_ACTION_NO_MOVE,(void*) (buf),(error))
#define ic0devMotReadActionCheck(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0devMOT_ATTR_ACTION_CHECK,(buf),(error))
#define ic0devMotWriteActionCheck(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0devMOT_ATTR_ACTION_CHECK,(void*) (buf),(error))
#define ic0devMotReadResetSetupCmd(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0devMOT_ATTR_RESET_SETUP_CMD,(buf),(error))
#define ic0devMotWriteResetSetupCmd(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0devMOT_ATTR_RESET_SETUP_CMD,(void*) (buf),(error))
#define ic0devMotGetMotorsSize(obj,num,error) \
	caiGetAttrInfo((obj)->attrs,ic0devMOT_ATTR_MOTORS,NULL,NULL,(num),NULL, NULL,NULL,(error))
#define ic0devMotReadMotors(obj,buf,firstRec,lastRec,firstFld,lastFld,error) \
	lcctooCaiRWTable((obj)->attrs,0,ic0devMOT_ATTR_MOTORS,(buf),(firstRec),(lastRec),(firstFld),(lastFld),(error))
#define ic0devMotWriteMotors(obj,buf,firstRec,lastRec,firstFld,lastFld,error) \
	lcctooCaiRWTable((obj)->attrs,1,ic0devMOT_ATTR_MOTORS,(void*) (buf),(firstRec),(lastRec),(firstFld),(lastFld),(error))
#define ic0devMotReadPositionsSize(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0devMOT_ATTR_POSITIONS_SIZE,(buf),(error))
#define ic0devMotWritePositionsSize(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0devMOT_ATTR_POSITIONS_SIZE,(void*) (buf),(error))
#define ic0devMotGetPositionsSize(obj,num,error) \
	caiGetAttrInfo((obj)->attrs,ic0devMOT_ATTR_POSITIONS,NULL,NULL,(num),NULL, NULL,NULL,(error))
#define ic0devMotReadPositions(obj,buf,firstRec,lastRec,firstFld,lastFld,error) \
	lcctooCaiRWTable((obj)->attrs,0,ic0devMOT_ATTR_POSITIONS,(buf),(firstRec),(lastRec),(firstFld),(lastFld),(error))
#define ic0devMotWritePositions(obj,buf,firstRec,lastRec,firstFld,lastFld,error) \
	lcctooCaiRWTable((obj)->attrs,1,ic0devMOT_ATTR_POSITIONS,(void*) (buf),(firstRec),(lastRec),(firstFld),(lastFld),(error))
#define ic0devMotGetActionsSize(obj,num,error) \
	caiGetAttrInfo((obj)->attrs,ic0devMOT_ATTR_ACTIONS,NULL,NULL,(num),NULL, NULL,NULL,(error))
#define ic0devMotReadActions(obj,buf,firstRec,lastRec,firstFld,lastFld,error) \
	lcctooCaiRWTableAdj((obj)->attrs,0,ic0devMOT_ATTR_ACTIONS,(buf),(firstRec),(lastRec),(firstFld),(lastFld),ic0devMotActionsAdj,(error))
#define ic0devMotWriteActions(obj,buf,firstRec,lastRec,firstFld,lastFld,error) \
	lcctooCaiRWTableAdj((obj)->attrs,1,ic0devMOT_ATTR_ACTIONS,(void*) (buf),(firstRec),(lastRec),(firstFld),(lastFld),ic0devMotActionsAdj,(error))
#define ic0devMotGetUsrActionsSize(obj,num,error) \
	caiGetAttrInfo((obj)->attrs,ic0devMOT_ATTR_USR_ACTIONS,NULL,NULL,(num),NULL, NULL,NULL,(error))
#define ic0devMotReadUsrActions(obj,buf,firstRec,lastRec,firstFld,lastFld,error) \
	lcctooCaiRWTableAdj((obj)->attrs,0,ic0devMOT_ATTR_USR_ACTIONS,(buf),(firstRec),(lastRec),(firstFld),(lastFld),ic0devMotActionsAdj,(error))
#define ic0devMotWriteUsrActions(obj,buf,firstRec,lastRec,firstFld,lastFld,error) \
	lcctooCaiRWTableAdj((obj)->attrs,1,ic0devMOT_ATTR_USR_ACTIONS,(void*) (buf),(firstRec),(lastRec),(firstFld),(lastFld),ic0devMotActionsAdj,(error))
#define ic0devMotReadUserUnitFct(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0devMOT_ATTR_USER_UNIT_FCT,(buf),(error))
#define ic0devMotWriteUserUnitFct(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0devMOT_ATTR_USER_UNIT_FCT,(void*) (buf),(error))
#define ic0devMotReadUserUnitFct2(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0devMOT_ATTR_USER_UNIT_FCT2,(buf),(error))
#define ic0devMotWriteUserUnitFct2(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0devMOT_ATTR_USER_UNIT_FCT2,(void*) (buf),(error))
#define ic0devMotGetUserUnitArgsSize(obj,num,error) \
	caiGetAttrInfo((obj)->attrs,ic0devMOT_ATTR_USER_UNIT_ARGS,NULL,NULL,(num),NULL, NULL,NULL,(error))
#define ic0devMotReadUserUnitArgs(obj,buf,firstElt,lastElt,error) \
	caiRWVector((obj)->attrs,0,ic0devMOT_ATTR_USER_UNIT_ARGS,(buf),(firstElt),(lastElt),(error))
#define ic0devMotWriteUserUnitArgs(obj,buf,firstElt,lastElt,error) \
	caiRWVector((obj)->attrs,1,ic0devMOT_ATTR_USER_UNIT_ARGS,(void*) (buf),(firstElt),(lastElt),(error))
#define ic0devMotReadInitTimeout(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0devMOT_ATTR_INIT_TIMEOUT,(buf),(error))
#define ic0devMotWriteInitTimeout(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0devMOT_ATTR_INIT_TIMEOUT,(void*) (buf),(error))
#define ic0devMotReadMoveTimeout(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0devMOT_ATTR_MOVE_TIMEOUT,(buf),(error))
#define ic0devMotWriteMoveTimeout(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0devMOT_ATTR_MOVE_TIMEOUT,(void*) (buf),(error))
#define ic0devMotReadDisconnect(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0devMOT_ATTR_DISCONNECT,(buf),(error))
#define ic0devMotWriteDisconnect(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0devMOT_ATTR_DISCONNECT,(void*) (buf),(error))
#define ic0devMotReadUseCfgElem(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0devMOT_ATTR_USE_CFG_ELEM,(buf),(error))
#define ic0devMotWriteUseCfgElem(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0devMOT_ATTR_USE_CFG_ELEM,(void*) (buf),(error))
#define ic0devMotReadParkAction(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0devMOT_ATTR_PARK_ACTION,(buf),(error))
#define ic0devMotWriteParkAction(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0devMOT_ATTR_PARK_ACTION,(void*) (buf),(error))
#define ic0devMotReadTestAction(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0devMOT_ATTR_TEST_ACTION,(buf),(error))
#define ic0devMotWriteTestAction(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0devMOT_ATTR_TEST_ACTION,(void*) (buf),(error))
#define ic0devMotReadTest(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0devMOT_ATTR_TEST,(buf),(error))
#define ic0devMotWriteTest(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0devMOT_ATTR_TEST,(void*) (buf),(error))
#define ic0devMotReadInstalled(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0devMOT_ATTR_INSTALLED,(buf),(error))
#define ic0devMotWriteInstalled(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0devMOT_ATTR_INSTALLED,(void*) (buf),(error))
#define ic0devMotReadAttached(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0devMOT_ATTR_ATTACHED,(buf),(error))
#define ic0devMotWriteAttached(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0devMOT_ATTR_ATTACHED,(void*) (buf),(error))
#define ic0devMotReadParked(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0devMOT_ATTR_PARKED,(buf),(error))
#define ic0devMotWriteParked(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0devMOT_ATTR_PARKED,(void*) (buf),(error))
#define ic0devMotReadActionStep(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0devMOT_ATTR_ACTION_STEP,(buf),(error))
#define ic0devMotWriteActionStep(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0devMOT_ATTR_ACTION_STEP,(void*) (buf),(error))
#define ic0devMotReadActionRetry(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0devMOT_ATTR_ACTION_RETRY,(buf),(error))
#define ic0devMotWriteActionRetry(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0devMOT_ATTR_ACTION_RETRY,(void*) (buf),(error))
#define ic0devMotReadActionMoveValid(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0devMOT_ATTR_ACTION_MOVE_VALID,(buf),(error))
#define ic0devMotWriteActionMoveValid(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0devMOT_ATTR_ACTION_MOVE_VALID,(void*) (buf),(error))
#define ic0devMotGetActionMoveSize(obj,num,error) \
	caiGetAttrInfo((obj)->attrs,ic0devMOT_ATTR_ACTION_MOVE,NULL,NULL,(num),NULL, NULL,NULL,(error))
#define ic0devMotReadActionMove(obj,buf,firstRec,lastRec,firstFld,lastFld,error) \
	lcctooCaiRWTableAdj((obj)->attrs,0,ic0devMOT_ATTR_ACTION_MOVE,(buf),(firstRec),(lastRec),(firstFld),(lastFld),ic0devMotActionsAdj,(error))
#define ic0devMotWriteActionMove(obj,buf,firstRec,lastRec,firstFld,lastFld,error) \
	lcctooCaiRWTableAdj((obj)->attrs,1,ic0devMOT_ATTR_ACTION_MOVE,(void*) (buf),(firstRec),(lastRec),(firstFld),(lastFld),ic0devMotActionsAdj,(error))
#define ic0devMotReadParsePosIndex(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0devMOT_ATTR_PARSE_POS_INDEX,(buf),(error))
#define ic0devMotWriteParsePosIndex(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0devMOT_ATTR_PARSE_POS_INDEX,(void*) (buf),(error))
#define ic0devMotReadFirstPosIndex(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0devMOT_ATTR_FIRST_POS_INDEX,(buf),(error))
#define ic0devMotWriteFirstPosIndex(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0devMOT_ATTR_FIRST_POS_INDEX,(void*) (buf),(error))
#define ic0devMotReadMoveMode(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0devMOT_ATTR_MOVE_MODE,(buf),(error))
#define ic0devMotWriteMoveMode(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0devMOT_ATTR_MOVE_MODE,(void*) (buf),(error))
#define ic0devMotGetAuto(obj,attrPtr,error) \
	SUCCESS; \
	memcpy((attrPtr), &(obj)->objs[ic0devMOT_AUTOMATA], sizeof(egenOBJ)); \
	(attrPtr)->ldata = (obj)->ldata;


/*
 * class functions
 */
#define ic0devMotSetup(obj,devName,function,functionNum,noMove,check,error) \
	ic0devSoftSetup((obj),(devName),(function),(functionNum),(noMove),(check),(error))
#define ic0devMotGetVal(obj,devName,name,nameNum,status,error) \
	ic0devSoftGetVal((obj),(devName),(name),(nameNum),(status),(error))
#define ic0devMotSetVal(obj,devName,name,nameNum,value,valueNum,error) \
	ic0devSoftSetVal((obj),(devName),(name),(nameNum),(value),(valueNum),(error))
#define ic0devMotStatus(obj,devName,function,functionNum,flag,header,conflog,opslog,condlog,status,error) \
	ic0devSoftStatus((obj),(devName),(function),(functionNum),(flag),(header),(conflog),(opslog),(condlog),(status),(error))
#define ic0devMotMove(obj,devName,position,positionNum,error) \
	ic0devSoftMove((obj),(devName),(position),(positionNum),(error))
#define ic0devMotMoveRel(obj,devName,position,positionNum,error) \
	ic0devSoftMoveRel((obj),(devName),(position),(positionNum),(error))
#define ic0devMotSet(obj,devName,position,positionNum,error) \
	ic0devSoftSet((obj),(devName),(position),(positionNum),(error))
#define ic0devMotResetParameters(obj,devName,cmd,error) \
	ic0devSoftResetParameters((obj),(devName),(cmd),(error))
#define ic0devMotParseParameters(obj,devName,cmd,params,paramsNum,noMove,check,error) \
	ic0devSoftParseParameters((obj),(devName),(cmd),(params),(paramsNum),(noMove),(check),(error))
#define ic0devMotCompareParameters(obj,devName,cmd,equal,error) \
	ic0devSoftCompareParameters((obj),(devName),(cmd),(equal),(error))
#define ic0devMotCopyParameters(obj,devName,error) \
	ic0devSoftCopyParameters((obj),(devName),(error))
#define ic0devMotExecParameters(obj,devName,error) \
	ic0devSoftExecParameters((obj),(devName),(error))
#define ic0devMotUpdateParameters(obj,devName,cache,error) \
	ic0devSoftUpdateParameters((obj),(devName),(cache),(error))
#define ic0devMotGetParamSetValue(obj,devName,index,value,setCode,error) \
	ic0devSoftGetParamSetValue((obj),(devName),(index),(value),(setCode),(error))
#define ic0devMotGetParamStatus(obj,devName,index,flags,status,error) \
	ic0devSoftGetParamStatus((obj),(devName),(index),(flags),(status),(error))
#define ic0devMotSetParam(obj,devName,index,cmd,value,step,error) \
	ic0devSoftSetParam((obj),(devName),(index),(cmd),(value),(step),(error))
#define ic0devMotSetParamStep(obj,devName,index,cmd,step,error) \
	ic0devSoftSetParamStep((obj),(devName),(index),(cmd),(step),(error))
#define ic0devMotGetValueCode(obj,devName,name,code,error) \
	ic0devSoftGetValueCode((obj),(devName),(name),(code),(error))
#define ic0devMotGetValue(obj,devName,code,index,value,valueNum,error) \
	ic0devSoftGetValue((obj),(devName),(code),(index),(value),(valueNum),(error))
#define ic0devMotSetValue(obj,devName,code,index,value,valueNum,error) \
	ic0devSoftSetValue((obj),(devName),(code),(index),(value),(valueNum),(error))
#define ic0devMotMonitor(obj,devName,error) \
	ic0devSoftMonitor((obj),(devName),(error))
#define ic0devMotUsrMonitor(obj,devName,state,error) \
	ic0devSoftUsrMonitor((obj),(devName),(state),(error))
#define ic0devMotLogAction(obj,devName,action,comment,error) \
	ic0devSoftLogAction((obj),(devName),(action),(comment),(error))
#define ic0devMotLogComment(obj,devName,comment,error) \
	ic0devSoftLogComment((obj),(devName),(comment),(error))
#define ic0devMotLogParameter(obj,devName,parameter,index,value,comment,error) \
	ic0devSoftLogParameter((obj),(devName),(parameter),(index),(value),(comment),(error))
#define ic0devMotLogRecovery(obj,devName,comment,error) \
	ic0devSoftLogRecovery((obj),(devName),(comment),(error))
#define ic0devMotLogTblParam(obj,devName,paramIndex,flags,comment,error) \
	ic0devSoftLogTblParam((obj),(devName),(paramIndex),(flags),(comment),(error))
#define ic0devMotLogUnforseen(obj,devName,comment,error) \
	ic0devSoftLogUnforseen((obj),(devName),(comment),(error))
#define ic0devMotAvail(obj,devName,error) \
	lccdevCmdAvail((obj),(devName),(error))
#define ic0devMotUnavail(obj,devName,error) \
	lccdevCmdUnavail((obj),(devName),(error))
#define ic0devMotDisable(obj,devName,access,error) \
	lccdevCmdDisable((obj),(devName),(access),(error))
#define ic0devMotEnable(obj,devName,access,error) \
	lccdevCmdEnable((obj),(devName),(access),(error))
#define ic0devMotLock(obj,devName,error) \
	lccdevCmdLock((obj),(devName),(error))
#define ic0devMotUnlock(obj,devName,error) \
	lccdevCmdUnlock((obj),(devName),(error))
#define ic0devMotHandset(obj,devName,error) \
	lccdevCmdHandset((obj),(devName),(error))
#define ic0devMotHsetOff(obj,devName,error) \
	lccdevCmdHsetOff((obj),(devName),(error))
#define ic0devMotFixPos(obj,devName,position,positionNum,reset,error) \
	lccdevCmdFixPos((obj),(devName),(position),(positionNum),(reset),(error))
#define ic0devMotUsrSimulat(obj,devName,error) \
	lccdevCmdUsrSimulat((obj),(devName),(error))
#define ic0devMotUsrStopSim(obj,devName,error) \
	lccdevCmdUsrStopSim((obj),(devName),(error))
#define ic0devMotStandby(obj,devName,error) \
	lccdevStdStandby((obj),(devName),(error))
#define ic0devMotOnline(obj,devName,error) \
	lccdevStdOnline((obj),(devName),(error))
#define ic0devMotOff(obj,devName,error) \
	lccdevStdOff((obj),(devName),(error))
#define ic0devMotExit(obj,devName,error) \
	lccdevStdExit((obj),(devName),(error))
#define ic0devMotState(obj,devName,state,error) \
	lccdevStdState((obj),(devName),(state),(error))
#define ic0devMotSimulat(obj,devName,error) \
	lccdevStdSimulat((obj),(devName),(error))
#define ic0devMotStopSim(obj,devName,error) \
	lccdevStdStopSim((obj),(devName),(error))
#define ic0devMotInit(obj,devName,error) \
	lccdevStdInit((obj),(devName),(error))
#define ic0devMotStop(obj,devName,error) \
	lccdevStdStop((obj),(devName),(error))
#define ic0devMotTest(obj,devName,error) \
	lccdevStdTest((obj),(devName),(error))
#define ic0devMotSelftst(obj,devName,error) \
	lccdevStdSelftst((obj),(devName),(error))
#define ic0devMotAutoTbl(obj,devName,table,text,error) \
	lccdevStdAutoTbl((obj),(devName),(table),(text),(error))
#define ic0devMotAutoRst(obj,devName,error) \
	lccdevStdAutoRst((obj),(devName),(error))
#define ic0devMotLoaded2Stby(obj,devName,error) \
	lccdevStdLoaded2Stby((obj),(devName),(error))
#define ic0devMotOnline2Stby(obj,devName,error) \
	lccdevStdOnline2Stby((obj),(devName),(error))
#define ic0devMotExit1(obj,devName,error) \
	lccdevStdExit1((obj),(devName),(error))
#define ic0devMotCheckDeviceName(obj,devName,error) \
	lccdevStdCheckDeviceName((obj),(devName),(error))
#define ic0devMotBreak(obj,error) \
	lccdevStdBreak((obj),(error))
#define ic0devMotUsrError(obj,devName,error) \
	lccdevStdUsrError((obj),(devName),(error))

ccsCOMPL_STAT ic0devMotCheck(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   char**	status,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devMotWait(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltINT32	timeout,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devMotCfgElem(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltINT32	position,
    IN    const char*	id,
    IN    const char*	values[],	/* max. vltBYTES16[10] */
    IN    vltINT16	valuesNum,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devMotLogConf(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltLOGICAL	allElements,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devMotGetConf(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltLOGICAL	allElements,
    OUT   char**	text,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devMotVarSet(
    INOUT ic0devMOT_SYNC_VAR_PARLIST* parList,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devMotVarWait(
    INOUT ic0devMOT_SYNC_VAR_PARLIST* parList,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devMotInitObj(
    INOUT egenOBJ*	obj,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devMotExitObj(
    INOUT egenOBJ*	obj,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devMotUsrInit(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devMotUsrLoaded2Standby(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devMotUsrStandby2Online(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devMotUsrOnline2Standby(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devMotUsrStandby2Loaded(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devMotUsrStop(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltLOGICAL	req,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devMotUsrSetMode(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltINT32	cmd,
    IN    vltLOGICAL	available,
    IN    vltLOGICAL	enabled,
    IN    vltLOGICAL	simulation,
    IN    vltLOGICAL	handset,
    IN    vltLOGICAL	locked,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devMotUsrSelfTest(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devMotUsrTest(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devMotUsrExecAction(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltINT32	index,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devMotUsrSetParameter(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltINT32	cmd,
    IN    vltINT32	param1,
    IN    vltINT32	param1SetCode,
    IN    vltINT32	param2,
    IN    vltINT32	param2SetCode,
    INOUT lcctooVALUE*	value,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devMotUsrGetValue(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    const ic0devSOFT_VALUE	valuesTable[],	/* max. ic0devSOFT_VALUE[99] */
    IN    vltINT16	valuesTableNum,
    IN    vltINT32	code,
    IN    vltINT32	index,
    OUT   lcctooVALUE	value[],	/* max. lcctooVALUE[10] */
    OUT   vltINT16*	valueNum,
    OUT   vltLOGICAL*	done,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devMotUsrSetValue(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    INOUT ic0devSOFT_VALUE	valuesTable[],	/* max. ic0devSOFT_VALUE[99] */
    INOUT vltINT16*	valuesTableNum,
    IN    vltINT32	code,
    IN    vltINT32	index,
    IN    const lcctooVALUE	value[],	/* max. lcctooVALUE[10] */
    IN    vltINT16	valueNum,
    OUT   vltLOGICAL*	done,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devMotGetArg(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltINT32	code,
    IN    vltINT32	index,
    OUT   lcctooVALUE*	value,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devMotGetHandles(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   motHANDLE*	motors,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devMotPark(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devMotGetAction(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltINT32	actionStep,
    OUT   ic0devMOT_ACTION*	action,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devMotExecAction(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    ic0devMOT_ACTION*	action,
    OUT   vltLOGICAL*	end,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devMotActionGetHandles(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltINT32	index,
    OUT   motHANDLE*	motors,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devMotActionNewMove(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    ic0devMOT_ACTION*	action,
    OUT   vltLOGICAL*	end,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devMotActionIf(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    ic0devMOT_ACTION*	action,
    OUT   vltLOGICAL*	end,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devMotActionParam(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    ic0devMOT_ACTION*	action,
    OUT   vltLOGICAL*	end,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devMotActionAddParam(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    ic0devMOT_ACTION*	action,
    OUT   vltLOGICAL*	end,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devMotActionValue(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    ic0devMOT_ACTION*	action,
    OUT   vltLOGICAL*	end,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devMotActionAddValue(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    ic0devMOT_ACTION*	action,
    OUT   vltLOGICAL*	end,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devMotActionMove(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    ic0devMOT_ACTION*	action,
    OUT   vltLOGICAL*	end,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devMotActionSpeedMove(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    ic0devMOT_ACTION*	action,
    OUT   vltLOGICAL*	end,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devMotActionWaitMove(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    ic0devMOT_ACTION*	action,
    OUT   vltLOGICAL*	end,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devMotActionClampBrake(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    ic0devMOT_ACTION*	action,
    OUT   vltLOGICAL*	end,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devMotActionDisconnect(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    ic0devMOT_ACTION*	action,
    OUT   vltLOGICAL*	end,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devMotActionStop(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    ic0devMOT_ACTION*	action,
    OUT   vltLOGICAL*	end,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devMotActionUserFunction(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    ic0devMOT_ACTION*	action,
    OUT   vltLOGICAL*	end,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devMotActionRetry(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    ic0devMOT_ACTION*	action,
    OUT   vltLOGICAL*	end,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devMotActionEnd(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    ic0devMOT_ACTION*	action,
    OUT   vltLOGICAL*	end,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devMotActionError(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    ic0devMOT_ACTION*	action,
    OUT   vltLOGICAL*	end,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devMotActionSleep(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    ic0devMOT_ACTION*	action,
    OUT   vltLOGICAL*	end,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devMotActionIncrValue(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    ic0devMOT_ACTION*	action,
    OUT   vltLOGICAL*	end,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devMotSetParListAddress(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    motHANDLE*	motor,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devMotWlen2Enc(
    IN    motMETRIC*	from,
    OUT   motMETRIC*	to,
    IN    egenOBJ*	obj,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devMotTemp2Focus(
    IN    motMETRIC*	from,
    OUT   motMETRIC*	to,
    IN    egenOBJ*	obj,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devMotSlit2Enc1(
    IN    motMETRIC*	from,
    OUT   motMETRIC*	to,
    IN    egenOBJ*	obj,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devMotSlit2Enc2(
    IN    motMETRIC*	from,
    OUT   motMETRIC*	to,
    IN    egenOBJ*	obj,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devMotSlit2Enc(
    INOUT egenOBJ*	obj,
    IN    vltINT32	motorIndex,
    IN    motMETRIC*	from,
    OUT   motMETRIC*	to,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devMotWlenTeta2Enc(
    IN    motMETRIC*	from,
    OUT   motMETRIC*	to,
    IN    egenOBJ*	parList,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devMotTilt2Enc(
    IN    motMETRIC*	from,
    OUT   motMETRIC*	to,
    IN    egenOBJ*	parList,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devMotPos2Enc(
    IN    motMETRIC*	from,
    OUT   motMETRIC*	to,
    IN    egenOBJ*	parList,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devMotUsrStatusCode(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    const char*	text,
    IN    vltINT32	flags,
    OUT   vltINT32*	code,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devMotUsrStatusValue(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltINT32	code,
    OUT   lcctooVALUE*	value,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devMotUsrStatusLast(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   vltINT16*	last,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devMotUsr2Enc(
    IN    motMETRIC*	from,
    OUT   motMETRIC*	to,
    IN    egenOBJ*	parList,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devMotUsr2EncSample(
    IN    motMETRIC*	from,
    IN    dbSYMADDRESS  point,
    IN    vltINT16	argSize,
    IN    vltDOUBLE*	arg,
    OUT   motMETRIC*	to,
    OUT   ccsERROR*	error);

/*
 * virtual functions
 */
#define ic0devMotVStandby(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_STANDBY)((obj)->fcts[ic0devMOT_FCT_STANDBY]))) \
	 ((obj),(devName),(error))
#define ic0devMotVOnline(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_ONLINE)((obj)->fcts[ic0devMOT_FCT_ONLINE]))) \
	 ((obj),(devName),(error))
#define ic0devMotVOff(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_OFF)((obj)->fcts[ic0devMOT_FCT_OFF]))) \
	 ((obj),(devName),(error))
#define ic0devMotVExit(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_EXIT)((obj)->fcts[ic0devMOT_FCT_EXIT]))) \
	 ((obj),(devName),(error))
#define ic0devMotVState(obj,devName,state,error) \
	(*((lccdevSTD_FCTPTR_STATE)((obj)->fcts[ic0devMOT_FCT_STATE]))) \
	 ((obj),(devName),(state),(error))
#define ic0devMotVSimulat(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_SIMULAT)((obj)->fcts[ic0devMOT_FCT_SIMULAT]))) \
	 ((obj),(devName),(error))
#define ic0devMotVStopSim(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_STOP_SIM)((obj)->fcts[ic0devMOT_FCT_STOP_SIM]))) \
	 ((obj),(devName),(error))
#define ic0devMotVStatus(obj,devName,function,functionNum,flag,header,conflog,opslog,condlog,status,error) \
	(*((ic0devSOFT_FCTPTR_STATUS)((obj)->fcts[ic0devMOT_FCT_STATUS]))) \
	 ((obj),(devName),(function),(functionNum),(flag),(header),(conflog),(opslog),(condlog),(status),(error))
#define ic0devMotVInit(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_INIT)((obj)->fcts[ic0devMOT_FCT_INIT]))) \
	 ((obj),(devName),(error))
#define ic0devMotVStop(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_STOP)((obj)->fcts[ic0devMOT_FCT_STOP]))) \
	 ((obj),(devName),(error))
#define ic0devMotVTest(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_TEST)((obj)->fcts[ic0devMOT_FCT_TEST]))) \
	 ((obj),(devName),(error))
#define ic0devMotVSelftst(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_SELFTST)((obj)->fcts[ic0devMOT_FCT_SELFTST]))) \
	 ((obj),(devName),(error))
#define ic0devMotVAutoTbl(obj,devName,table,text,error) \
	(*((lccdevSTD_FCTPTR_AUTO_TBL)((obj)->fcts[ic0devMOT_FCT_AUTO_TBL]))) \
	 ((obj),(devName),(table),(text),(error))
#define ic0devMotVAutoRst(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_AUTO_RST)((obj)->fcts[ic0devMOT_FCT_AUTO_RST]))) \
	 ((obj),(devName),(error))
#define ic0devMotVInitObj(obj,error) \
	(*((ic0devMOT_FCTPTR_INIT_OBJ)((obj)->fcts[ic0devMOT_FCT_INIT_OBJ]))) \
	 ((obj),(error))
#define ic0devMotVExitObj(obj,error) \
	(*((ic0devMOT_FCTPTR_EXIT_OBJ)((obj)->fcts[ic0devMOT_FCT_EXIT_OBJ]))) \
	 ((obj),(error))
#define ic0devMotVLoaded2Stby(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_LOADED2STBY)((obj)->fcts[ic0devMOT_FCT_LOADED2STBY]))) \
	 ((obj),(devName),(error))
#define ic0devMotVOnline2Stby(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_ONLINE2STBY)((obj)->fcts[ic0devMOT_FCT_ONLINE2STBY]))) \
	 ((obj),(devName),(error))
#define ic0devMotVExit1(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_EXIT1)((obj)->fcts[ic0devMOT_FCT_EXIT1]))) \
	 ((obj),(devName),(error))
#define ic0devMotVCheckDeviceName(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_CHECK_DEVICE_NAME)((obj)->fcts[ic0devMOT_FCT_CHECK_DEVICE_NAME]))) \
	 ((obj),(devName),(error))
#define ic0devMotVBreak(obj,error) \
	(*((lccdevSTD_FCTPTR_BREAK)((obj)->fcts[ic0devMOT_FCT_BREAK]))) \
	 ((obj),(error))
#define ic0devMotVUsrInit(obj,devName,error) \
	(*((ic0devMOT_FCTPTR_USR_INIT)((obj)->fcts[ic0devMOT_FCT_USR_INIT]))) \
	 ((obj),(devName),(error))
#define ic0devMotVUsrLoaded2Standby(obj,devName,error) \
	(*((ic0devMOT_FCTPTR_USR_LOADED2STANDBY)((obj)->fcts[ic0devMOT_FCT_USR_LOADED2STANDBY]))) \
	 ((obj),(devName),(error))
#define ic0devMotVUsrStandby2Online(obj,devName,error) \
	(*((ic0devMOT_FCTPTR_USR_STANDBY2ONLINE)((obj)->fcts[ic0devMOT_FCT_USR_STANDBY2ONLINE]))) \
	 ((obj),(devName),(error))
#define ic0devMotVUsrOnline2Standby(obj,devName,error) \
	(*((ic0devMOT_FCTPTR_USR_ONLINE2STANDBY)((obj)->fcts[ic0devMOT_FCT_USR_ONLINE2STANDBY]))) \
	 ((obj),(devName),(error))
#define ic0devMotVUsrStandby2Loaded(obj,devName,error) \
	(*((ic0devMOT_FCTPTR_USR_STANDBY2LOADED)((obj)->fcts[ic0devMOT_FCT_USR_STANDBY2LOADED]))) \
	 ((obj),(devName),(error))
#define ic0devMotVUsrStop(obj,devName,req,error) \
	(*((ic0devMOT_FCTPTR_USR_STOP)((obj)->fcts[ic0devMOT_FCT_USR_STOP]))) \
	 ((obj),(devName),(req),(error))
#define ic0devMotVUsrSimulat(obj,devName,error) \
	(*((lccdevCMD_FCTPTR_USR_SIMULAT)((obj)->fcts[ic0devMOT_FCT_USR_SIMULAT]))) \
	 ((obj),(devName),(error))
#define ic0devMotVUsrStopSim(obj,devName,error) \
	(*((lccdevCMD_FCTPTR_USR_STOP_SIM)((obj)->fcts[ic0devMOT_FCT_USR_STOP_SIM]))) \
	 ((obj),(devName),(error))
#define ic0devMotVUsrStatusCode(obj,devName,text,flags,code,error) \
	(*((ic0devMOT_FCTPTR_USR_STATUS_CODE)((obj)->fcts[ic0devMOT_FCT_USR_STATUS_CODE]))) \
	 ((obj),(devName),(text),(flags),(code),(error))
#define ic0devMotVUsrStatusLast(obj,devName,last,error) \
	(*((ic0devMOT_FCTPTR_USR_STATUS_LAST)((obj)->fcts[ic0devMOT_FCT_USR_STATUS_LAST]))) \
	 ((obj),(devName),(last),(error))
#define ic0devMotVUsrStatusValue(obj,devName,code,value,error) \
	(*((ic0devMOT_FCTPTR_USR_STATUS_VALUE)((obj)->fcts[ic0devMOT_FCT_USR_STATUS_VALUE]))) \
	 ((obj),(devName),(code),(value),(error))
#define ic0devMotVUsrTest(obj,devName,error) \
	(*((ic0devMOT_FCTPTR_USR_TEST)((obj)->fcts[ic0devMOT_FCT_USR_TEST]))) \
	 ((obj),(devName),(error))
#define ic0devMotVUsrSelfTest(obj,devName,error) \
	(*((ic0devMOT_FCTPTR_USR_SELF_TEST)((obj)->fcts[ic0devMOT_FCT_USR_SELF_TEST]))) \
	 ((obj),(devName),(error))
#define ic0devMotVUsrError(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_USR_ERROR)((obj)->fcts[ic0devMOT_FCT_USR_ERROR]))) \
	 ((obj),(devName),(error))
#define ic0devMotVAvail(obj,devName,error) \
	(*((lccdevCMD_FCTPTR_AVAIL)((obj)->fcts[ic0devMOT_FCT_AVAIL]))) \
	 ((obj),(devName),(error))
#define ic0devMotVUnavail(obj,devName,error) \
	(*((lccdevCMD_FCTPTR_UNAVAIL)((obj)->fcts[ic0devMOT_FCT_UNAVAIL]))) \
	 ((obj),(devName),(error))
#define ic0devMotVDisable(obj,devName,access,error) \
	(*((lccdevCMD_FCTPTR_DISABLE)((obj)->fcts[ic0devMOT_FCT_DISABLE]))) \
	 ((obj),(devName),(access),(error))
#define ic0devMotVEnable(obj,devName,access,error) \
	(*((lccdevCMD_FCTPTR_ENABLE)((obj)->fcts[ic0devMOT_FCT_ENABLE]))) \
	 ((obj),(devName),(access),(error))
#define ic0devMotVLock(obj,devName,error) \
	(*((lccdevCMD_FCTPTR_LOCK)((obj)->fcts[ic0devMOT_FCT_LOCK]))) \
	 ((obj),(devName),(error))
#define ic0devMotVUnlock(obj,devName,error) \
	(*((lccdevCMD_FCTPTR_UNLOCK)((obj)->fcts[ic0devMOT_FCT_UNLOCK]))) \
	 ((obj),(devName),(error))
#define ic0devMotVHandset(obj,devName,error) \
	(*((lccdevCMD_FCTPTR_HANDSET)((obj)->fcts[ic0devMOT_FCT_HANDSET]))) \
	 ((obj),(devName),(error))
#define ic0devMotVHsetOff(obj,devName,error) \
	(*((lccdevCMD_FCTPTR_HSET_OFF)((obj)->fcts[ic0devMOT_FCT_HSET_OFF]))) \
	 ((obj),(devName),(error))
#define ic0devMotVFixPos(obj,devName,position,positionNum,reset,error) \
	(*((lccdevCMD_FCTPTR_FIX_POS)((obj)->fcts[ic0devMOT_FCT_FIX_POS]))) \
	 ((obj),(devName),(position),(positionNum),(reset),(error))
#define ic0devMotVMove(obj,devName,position,positionNum,error) \
	(*((ic0devSOFT_FCTPTR_MOVE)((obj)->fcts[ic0devMOT_FCT_MOVE]))) \
	 ((obj),(devName),(position),(positionNum),(error))
#define ic0devMotVMoveRel(obj,devName,position,positionNum,error) \
	(*((ic0devSOFT_FCTPTR_MOVE_REL)((obj)->fcts[ic0devMOT_FCT_MOVE_REL]))) \
	 ((obj),(devName),(position),(positionNum),(error))
#define ic0devMotVSet(obj,devName,position,positionNum,error) \
	(*((ic0devSOFT_FCTPTR_SET)((obj)->fcts[ic0devMOT_FCT_SET]))) \
	 ((obj),(devName),(position),(positionNum),(error))
#define ic0devMotVCheck(obj,devName,status,error) \
	(*((ic0devMOT_FCTPTR_CHECK)((obj)->fcts[ic0devMOT_FCT_CHECK]))) \
	 ((obj),(devName),(status),(error))
#define ic0devMotVWait(obj,devName,timeout,error) \
	(*((ic0devMOT_FCTPTR_WAIT)((obj)->fcts[ic0devMOT_FCT_WAIT]))) \
	 ((obj),(devName),(timeout),(error))
#define ic0devMotVUsrSetMode(obj,devName,cmd,available,enabled,simulation,handset,locked,error) \
	(*((ic0devMOT_FCTPTR_USR_SET_MODE)((obj)->fcts[ic0devMOT_FCT_USR_SET_MODE]))) \
	 ((obj),(devName),(cmd),(available),(enabled),(simulation),(handset),(locked),(error))
#define ic0devMotVSetup(obj,devName,function,functionNum,noMove,check,error) \
	(*((ic0devSOFT_FCTPTR_SETUP)((obj)->fcts[ic0devMOT_FCT_SETUP]))) \
	 ((obj),(devName),(function),(functionNum),(noMove),(check),(error))
#define ic0devMotVGetVal(obj,devName,name,nameNum,status,error) \
	(*((ic0devSOFT_FCTPTR_GET_VAL)((obj)->fcts[ic0devMOT_FCT_GET_VAL]))) \
	 ((obj),(devName),(name),(nameNum),(status),(error))
#define ic0devMotVSetVal(obj,devName,name,nameNum,value,valueNum,error) \
	(*((ic0devSOFT_FCTPTR_SET_VAL)((obj)->fcts[ic0devMOT_FCT_SET_VAL]))) \
	 ((obj),(devName),(name),(nameNum),(value),(valueNum),(error))
#define ic0devMotVCfgElem(obj,devName,position,id,values,valuesNum,error) \
	(*((ic0devMOT_FCTPTR_CFG_ELEM)((obj)->fcts[ic0devMOT_FCT_CFG_ELEM]))) \
	 ((obj),(devName),(position),(id),(values),(valuesNum),(error))
#define ic0devMotVLogConf(obj,devName,allElements,error) \
	(*((ic0devMOT_FCTPTR_LOG_CONF)((obj)->fcts[ic0devMOT_FCT_LOG_CONF]))) \
	 ((obj),(devName),(allElements),(error))
#define ic0devMotVGetConf(obj,devName,allElements,text,error) \
	(*((ic0devMOT_FCTPTR_GET_CONF)((obj)->fcts[ic0devMOT_FCT_GET_CONF]))) \
	 ((obj),(devName),(allElements),(text),(error))
#define ic0devMotVResetParameters(obj,devName,cmd,error) \
	(*((ic0devSOFT_FCTPTR_RESET_PARAMETERS)((obj)->fcts[ic0devMOT_FCT_RESET_PARAMETERS]))) \
	 ((obj),(devName),(cmd),(error))
#define ic0devMotVParseParameters(obj,devName,cmd,params,paramsNum,noMove,check,error) \
	(*((ic0devSOFT_FCTPTR_PARSE_PARAMETERS)((obj)->fcts[ic0devMOT_FCT_PARSE_PARAMETERS]))) \
	 ((obj),(devName),(cmd),(params),(paramsNum),(noMove),(check),(error))
#define ic0devMotVCompareParameters(obj,devName,cmd,equal,error) \
	(*((ic0devSOFT_FCTPTR_COMPARE_PARAMETERS)((obj)->fcts[ic0devMOT_FCT_COMPARE_PARAMETERS]))) \
	 ((obj),(devName),(cmd),(equal),(error))
#define ic0devMotVCopyParameters(obj,devName,error) \
	(*((ic0devSOFT_FCTPTR_COPY_PARAMETERS)((obj)->fcts[ic0devMOT_FCT_COPY_PARAMETERS]))) \
	 ((obj),(devName),(error))
#define ic0devMotVExecParameters(obj,devName,error) \
	(*((ic0devSOFT_FCTPTR_EXEC_PARAMETERS)((obj)->fcts[ic0devMOT_FCT_EXEC_PARAMETERS]))) \
	 ((obj),(devName),(error))
#define ic0devMotVUpdateParameters(obj,devName,cache,error) \
	(*((ic0devSOFT_FCTPTR_UPDATE_PARAMETERS)((obj)->fcts[ic0devMOT_FCT_UPDATE_PARAMETERS]))) \
	 ((obj),(devName),(cache),(error))
#define ic0devMotVGetParamSetValue(obj,devName,index,value,setCode,error) \
	(*((ic0devSOFT_FCTPTR_GET_PARAM_SET_VALUE)((obj)->fcts[ic0devMOT_FCT_GET_PARAM_SET_VALUE]))) \
	 ((obj),(devName),(index),(value),(setCode),(error))
#define ic0devMotVGetParamStatus(obj,devName,index,flags,status,error) \
	(*((ic0devSOFT_FCTPTR_GET_PARAM_STATUS)((obj)->fcts[ic0devMOT_FCT_GET_PARAM_STATUS]))) \
	 ((obj),(devName),(index),(flags),(status),(error))
#define ic0devMotVSetParam(obj,devName,index,cmd,value,step,error) \
	(*((ic0devSOFT_FCTPTR_SET_PARAM)((obj)->fcts[ic0devMOT_FCT_SET_PARAM]))) \
	 ((obj),(devName),(index),(cmd),(value),(step),(error))
#define ic0devMotVSetParamStep(obj,devName,index,cmd,step,error) \
	(*((ic0devSOFT_FCTPTR_SET_PARAM_STEP)((obj)->fcts[ic0devMOT_FCT_SET_PARAM_STEP]))) \
	 ((obj),(devName),(index),(cmd),(step),(error))
#define ic0devMotVUsrExecAction(obj,devName,index,error) \
	(*((ic0devMOT_FCTPTR_USR_EXEC_ACTION)((obj)->fcts[ic0devMOT_FCT_USR_EXEC_ACTION]))) \
	 ((obj),(devName),(index),(error))
#define ic0devMotVUsrSetParameter(obj,devName,cmd,param1,param1SetCode,param2,param2SetCode,value,error) \
	(*((ic0devMOT_FCTPTR_USR_SET_PARAMETER)((obj)->fcts[ic0devMOT_FCT_USR_SET_PARAMETER]))) \
	 ((obj),(devName),(cmd),(param1),(param1SetCode),(param2),(param2SetCode),(value),(error))
#define ic0devMotVGetValueCode(obj,devName,name,code,error) \
	(*((ic0devSOFT_FCTPTR_GET_VALUE_CODE)((obj)->fcts[ic0devMOT_FCT_GET_VALUE_CODE]))) \
	 ((obj),(devName),(name),(code),(error))
#define ic0devMotVGetValue(obj,devName,code,index,value,valueNum,error) \
	(*((ic0devSOFT_FCTPTR_GET_VALUE)((obj)->fcts[ic0devMOT_FCT_GET_VALUE]))) \
	 ((obj),(devName),(code),(index),(value),(valueNum),(error))
#define ic0devMotVUsrGetValue(obj,devName,valuesTable,valuesTableNum,code,index,value,valueNum,done,error) \
	(*((ic0devMOT_FCTPTR_USR_GET_VALUE)((obj)->fcts[ic0devMOT_FCT_USR_GET_VALUE]))) \
	 ((obj),(devName),(valuesTable),(valuesTableNum),(code),(index),(value),(valueNum),(done),(error))
#define ic0devMotVSetValue(obj,devName,code,index,value,valueNum,error) \
	(*((ic0devSOFT_FCTPTR_SET_VALUE)((obj)->fcts[ic0devMOT_FCT_SET_VALUE]))) \
	 ((obj),(devName),(code),(index),(value),(valueNum),(error))
#define ic0devMotVUsrSetValue(obj,devName,valuesTable,valuesTableNum,code,index,value,valueNum,done,error) \
	(*((ic0devMOT_FCTPTR_USR_SET_VALUE)((obj)->fcts[ic0devMOT_FCT_USR_SET_VALUE]))) \
	 ((obj),(devName),(valuesTable),(valuesTableNum),(code),(index),(value),(valueNum),(done),(error))
#define ic0devMotVGetArg(obj,devName,code,index,value,error) \
	(*((ic0devMOT_FCTPTR_GET_ARG)((obj)->fcts[ic0devMOT_FCT_GET_ARG]))) \
	 ((obj),(devName),(code),(index),(value),(error))
#define ic0devMotVMonitor(obj,devName,error) \
	(*((ic0devSOFT_FCTPTR_MONITOR)((obj)->fcts[ic0devMOT_FCT_MONITOR]))) \
	 ((obj),(devName),(error))
#define ic0devMotVUsrMonitor(obj,devName,state,error) \
	(*((ic0devSOFT_FCTPTR_USR_MONITOR)((obj)->fcts[ic0devMOT_FCT_USR_MONITOR]))) \
	 ((obj),(devName),(state),(error))
#define ic0devMotVLogAction(obj,devName,action,comment,error) \
	(*((ic0devSOFT_FCTPTR_LOG_ACTION)((obj)->fcts[ic0devMOT_FCT_LOG_ACTION]))) \
	 ((obj),(devName),(action),(comment),(error))
#define ic0devMotVLogComment(obj,devName,comment,error) \
	(*((ic0devSOFT_FCTPTR_LOG_COMMENT)((obj)->fcts[ic0devMOT_FCT_LOG_COMMENT]))) \
	 ((obj),(devName),(comment),(error))
#define ic0devMotVLogParameter(obj,devName,parameter,index,value,comment,error) \
	(*((ic0devSOFT_FCTPTR_LOG_PARAMETER)((obj)->fcts[ic0devMOT_FCT_LOG_PARAMETER]))) \
	 ((obj),(devName),(parameter),(index),(value),(comment),(error))
#define ic0devMotVLogRecovery(obj,devName,comment,error) \
	(*((ic0devSOFT_FCTPTR_LOG_RECOVERY)((obj)->fcts[ic0devMOT_FCT_LOG_RECOVERY]))) \
	 ((obj),(devName),(comment),(error))
#define ic0devMotVLogTblParam(obj,devName,paramIndex,flags,comment,error) \
	(*((ic0devSOFT_FCTPTR_LOG_TBL_PARAM)((obj)->fcts[ic0devMOT_FCT_LOG_TBL_PARAM]))) \
	 ((obj),(devName),(paramIndex),(flags),(comment),(error))
#define ic0devMotVLogUnforseen(obj,devName,comment,error) \
	(*((ic0devSOFT_FCTPTR_LOG_UNFORSEEN)((obj)->fcts[ic0devMOT_FCT_LOG_UNFORSEEN]))) \
	 ((obj),(devName),(comment),(error))
#define ic0devMotVVarSet(obj,error) \
	(*((ic0devMOT_FCTPTR_VAR_SET)((obj)->fcts[ic0devMOT_FCT_VAR_SET]))) \
	 ((obj),(error))
#define ic0devMotVVarWait(obj,error) \
	(*((ic0devMOT_FCTPTR_VAR_WAIT)((obj)->fcts[ic0devMOT_FCT_VAR_WAIT]))) \
	 ((obj),(error))
#define ic0devMotVGetHandles(obj,devName,motors,error) \
	(*((ic0devMOT_FCTPTR_GET_HANDLES)((obj)->fcts[ic0devMOT_FCT_GET_HANDLES]))) \
	 ((obj),(devName),(motors),(error))
#define ic0devMotVPark(obj,devName,error) \
	(*((ic0devMOT_FCTPTR_PARK)((obj)->fcts[ic0devMOT_FCT_PARK]))) \
	 ((obj),(devName),(error))
#define ic0devMotVGetAction(obj,devName,actionStep,action,error) \
	(*((ic0devMOT_FCTPTR_GET_ACTION)((obj)->fcts[ic0devMOT_FCT_GET_ACTION]))) \
	 ((obj),(devName),(actionStep),(action),(error))
#define ic0devMotVExecAction(obj,devName,action,end,error) \
	(*((ic0devMOT_FCTPTR_EXEC_ACTION)((obj)->fcts[ic0devMOT_FCT_EXEC_ACTION]))) \
	 ((obj),(devName),(action),(end),(error))
#define ic0devMotVActionGetHandles(obj,devName,index,motors,error) \
	(*((ic0devMOT_FCTPTR_ACTION_GET_HANDLES)((obj)->fcts[ic0devMOT_FCT_ACTION_GET_HANDLES]))) \
	 ((obj),(devName),(index),(motors),(error))
#define ic0devMotVActionNewMove(obj,devName,action,end,error) \
	(*((ic0devMOT_FCTPTR_ACTION_NEW_MOVE)((obj)->fcts[ic0devMOT_FCT_ACTION_NEW_MOVE]))) \
	 ((obj),(devName),(action),(end),(error))
#define ic0devMotVActionIf(obj,devName,action,end,error) \
	(*((ic0devMOT_FCTPTR_ACTION_IF)((obj)->fcts[ic0devMOT_FCT_ACTION_IF]))) \
	 ((obj),(devName),(action),(end),(error))
#define ic0devMotVActionParam(obj,devName,action,end,error) \
	(*((ic0devMOT_FCTPTR_ACTION_PARAM)((obj)->fcts[ic0devMOT_FCT_ACTION_PARAM]))) \
	 ((obj),(devName),(action),(end),(error))
#define ic0devMotVActionAddParam(obj,devName,action,end,error) \
	(*((ic0devMOT_FCTPTR_ACTION_ADD_PARAM)((obj)->fcts[ic0devMOT_FCT_ACTION_ADD_PARAM]))) \
	 ((obj),(devName),(action),(end),(error))
#define ic0devMotVActionValue(obj,devName,action,end,error) \
	(*((ic0devMOT_FCTPTR_ACTION_VALUE)((obj)->fcts[ic0devMOT_FCT_ACTION_VALUE]))) \
	 ((obj),(devName),(action),(end),(error))
#define ic0devMotVActionAddValue(obj,devName,action,end,error) \
	(*((ic0devMOT_FCTPTR_ACTION_ADD_VALUE)((obj)->fcts[ic0devMOT_FCT_ACTION_ADD_VALUE]))) \
	 ((obj),(devName),(action),(end),(error))
#define ic0devMotVActionMove(obj,devName,action,end,error) \
	(*((ic0devMOT_FCTPTR_ACTION_MOVE)((obj)->fcts[ic0devMOT_FCT_ACTION_MOVE]))) \
	 ((obj),(devName),(action),(end),(error))
#define ic0devMotVActionSpeedMove(obj,devName,action,end,error) \
	(*((ic0devMOT_FCTPTR_ACTION_SPEED_MOVE)((obj)->fcts[ic0devMOT_FCT_ACTION_SPEED_MOVE]))) \
	 ((obj),(devName),(action),(end),(error))
#define ic0devMotVActionWaitMove(obj,devName,action,end,error) \
	(*((ic0devMOT_FCTPTR_ACTION_WAIT_MOVE)((obj)->fcts[ic0devMOT_FCT_ACTION_WAIT_MOVE]))) \
	 ((obj),(devName),(action),(end),(error))
#define ic0devMotVActionClampBrake(obj,devName,action,end,error) \
	(*((ic0devMOT_FCTPTR_ACTION_CLAMP_BRAKE)((obj)->fcts[ic0devMOT_FCT_ACTION_CLAMP_BRAKE]))) \
	 ((obj),(devName),(action),(end),(error))
#define ic0devMotVActionDisconnect(obj,devName,action,end,error) \
	(*((ic0devMOT_FCTPTR_ACTION_DISCONNECT)((obj)->fcts[ic0devMOT_FCT_ACTION_DISCONNECT]))) \
	 ((obj),(devName),(action),(end),(error))
#define ic0devMotVActionStop(obj,devName,action,end,error) \
	(*((ic0devMOT_FCTPTR_ACTION_STOP)((obj)->fcts[ic0devMOT_FCT_ACTION_STOP]))) \
	 ((obj),(devName),(action),(end),(error))
#define ic0devMotVActionUserFunction(obj,devName,action,end,error) \
	(*((ic0devMOT_FCTPTR_ACTION_USER_FUNCTION)((obj)->fcts[ic0devMOT_FCT_ACTION_USER_FUNCTION]))) \
	 ((obj),(devName),(action),(end),(error))
#define ic0devMotVActionRetry(obj,devName,action,end,error) \
	(*((ic0devMOT_FCTPTR_ACTION_RETRY)((obj)->fcts[ic0devMOT_FCT_ACTION_RETRY]))) \
	 ((obj),(devName),(action),(end),(error))
#define ic0devMotVActionEnd(obj,devName,action,end,error) \
	(*((ic0devMOT_FCTPTR_ACTION_END)((obj)->fcts[ic0devMOT_FCT_ACTION_END]))) \
	 ((obj),(devName),(action),(end),(error))
#define ic0devMotVActionError(obj,devName,action,end,error) \
	(*((ic0devMOT_FCTPTR_ACTION_ERROR)((obj)->fcts[ic0devMOT_FCT_ACTION_ERROR]))) \
	 ((obj),(devName),(action),(end),(error))
#define ic0devMotVActionSleep(obj,devName,action,end,error) \
	(*((ic0devMOT_FCTPTR_ACTION_SLEEP)((obj)->fcts[ic0devMOT_FCT_ACTION_SLEEP]))) \
	 ((obj),(devName),(action),(end),(error))
#define ic0devMotVActionIncrValue(obj,devName,action,end,error) \
	(*((ic0devMOT_FCTPTR_ACTION_INCR_VALUE)((obj)->fcts[ic0devMOT_FCT_ACTION_INCR_VALUE]))) \
	 ((obj),(devName),(action),(end),(error))
#define ic0devMotVSetParListAddress(obj,devName,motor,error) \
	(*((ic0devMOT_FCTPTR_SET_PAR_LIST_ADDRESS)((obj)->fcts[ic0devMOT_FCT_SET_PAR_LIST_ADDRESS]))) \
	 ((obj),(devName),(motor),(error))
#define ic0devMotVWlen2Enc(from,to,obj,error) \
	(*((ic0devMOT_FCTPTR_WLEN2ENC)((obj)->fcts[ic0devMOT_FCT_WLEN2ENC]))) \
	 ((from),(to),(obj),(error))
#define ic0devMotVTemp2Focus(from,to,obj,error) \
	(*((ic0devMOT_FCTPTR_TEMP2FOCUS)((obj)->fcts[ic0devMOT_FCT_TEMP2FOCUS]))) \
	 ((from),(to),(obj),(error))
#define ic0devMotVSlit2Enc1(from,to,obj,error) \
	(*((ic0devMOT_FCTPTR_SLIT2ENC1)((obj)->fcts[ic0devMOT_FCT_SLIT2ENC1]))) \
	 ((from),(to),(obj),(error))
#define ic0devMotVSlit2Enc2(from,to,obj,error) \
	(*((ic0devMOT_FCTPTR_SLIT2ENC2)((obj)->fcts[ic0devMOT_FCT_SLIT2ENC2]))) \
	 ((from),(to),(obj),(error))
#define ic0devMotVSlit2Enc(obj,motorIndex,from,to,error) \
	(*((ic0devMOT_FCTPTR_SLIT2ENC)((obj)->fcts[ic0devMOT_FCT_SLIT2ENC]))) \
	 ((obj),(motorIndex),(from),(to),(error))
#define ic0devMotVWlenTeta2Enc(from,to,obj,error) \
	(*((ic0devMOT_FCTPTR_WLEN_TETA2ENC)((obj)->fcts[ic0devMOT_FCT_WLEN_TETA2ENC]))) \
	 ((from),(to),(obj),(error))
#define ic0devMotVTilt2Enc(from,to,obj,error) \
	(*((ic0devMOT_FCTPTR_TILT2ENC)((obj)->fcts[ic0devMOT_FCT_TILT2ENC]))) \
	 ((from),(to),(obj),(error))
#define ic0devMotVPos2Enc(obj,from,to,parList,error) \
        (*((ic0devMOT_FCTPTR_POS2ENC)((obj)->fcts[ic0devMOT_FCT_POS2ENC]))) \
         ((obj),(from),(to),(parList),(error))


ccsCOMPL_STAT ic0devMotNewObj(
    IN    dbSYMADDRESS	point,
    IN    egenOBJ*	owner,
    OUT   egenOBJ*	obj,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devMotDeleteObj(
    INOUT egenOBJ*	obj,
    OUT   ccsERROR*	error);


ccsCOMPL_STAT ic0devMotGetPositionsUsedSize(
    INOUT egenOBJ*	obj,
    OUT   vltINT16*	num,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devMotActionSample(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    ic0devMOT_ACTION*	action,
    OUT   vltLOGICAL*	end,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devMotActionCnct(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    ic0devMOT_ACTION*	action,
    OUT   vltLOGICAL*	end,
    OUT   ccsERROR*	error);


/* needed by lcctooCaiRWTableAdj */
extern int ic0devMotActionsAdj[];


/* #endif // !IC0DEV_MOT_H */

/************************************************************************/
/* ___oOo___ */


/* temporary, while MCM does not define motGetConfig() */

/*
 * motor server conf database attributes 
typedef enum
    {
    motsrvDB_CONF_MOTOR = 0,
    motsrvDB_CONF_BOARDS,
    motsrvDB_CONF_EVENTS,
    motsrvDB_CONF_SIGNALS,
    motsrvDB_CONF_AXIS,
    motsrvDB_CONF_ENCODER,
    motsrvDB_CONF_OFFSETS,
    motsrvDB_CONF_SPECIAL_POS,
    motsrvDB_CONF_NAMED_POSITIONS,
    motsrvDB_CONF_NAMED_SPEEDS,
    motsrvDB_CONF_TWO_STEP_OFFSET,
    motsrvDB_CONF_INDEX_PULSE_SPEED,
    motsrvDB_CONF_DEFAULT_SPEED,
    motsrvDB_INIT_ACTIONS,
    motsrvDB_UNIT_DEFAULT,
    motsrvDB_UNIT_METHODS,
    motsrvDB_INTERN_SPECIAL_POS
    } motsrvDB_SERVER;
 */

#endif /* !IC0DEV_MOT_H */
