/******************************************************************************L
*  E.S.O. - VLT project
* 
*  "@(#) $Id: ic0devSoft.h,v 1.93 2005/08/14 18:41:12 vltsccm Exp $"
* 
*  who        when      what
*  ---------- --------  ----------------------------------------------
*  rschmutzer 29/09/95  Created by eccsgen V0.52 (September 1995)
*
*
*    !!!!!!!!!  CAUTION: THIS FILE IS UPDATED BY ECCSGEN  !!!!!!!!!
*/

/*************************************************************************
*   NAME
*	ic0devSoft - class
*
*   SYNOPSIS
*	#include "ic0devSoft.h"
*
*	ccsCOMPL_STAT ic0devSoftNewObj(
*	    IN    dbSYMADDRESS	point,
*	    IN    egenOBJ*	owner,
*	    OUT   egenOBJ*	obj,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0devSoftDeleteObj(
*	    INOUT egenOBJ*	obj,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0devSoftSetup(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    const char*	function[],	** max. vltBYTES32[999]
*	    IN    vltINT16	functionNum,
*	    IN    vltLOGICAL	noMove,
*	    IN    vltLOGICAL	check,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0devSoftGetVal(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    const char*	name[],		** max. vltBYTES32[2]
*	    IN    vltINT16	nameNum,
*	    OUT   char**	status,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0devSoftSetVal(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    const char*	name[],		** max. vltBYTES32[2]
*	    IN    vltINT16	nameNum,
*	    IN    const char*	value[],	** max. vltBYTES32[10]
*	    IN    vltINT16	valueNum,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0devSoftCfgElem(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    vltINT32	position,
*	    IN    const char*	id,
*	    IN    const char*	values[],	** max. vltBYTES16[10]
*	    IN    vltINT16	valuesNum,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0devSoftLogConf(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    vltLOGICAL	allElements,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0devSoftGetConf(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    vltLOGICAL	allElements,
*	    OUT   char**	text,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0devSoftResetParameters(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    vltINT32	cmd,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0devSoftParseParameters(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    vltINT32	cmd,
*	    IN    const char*	params[],	** max. vltBYTES32[999]
*	    IN    vltINT16	paramsNum,
*	    IN    vltLOGICAL	noMove,
*	    IN    vltLOGICAL	check,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0devSoftCompareParameters(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    vltINT32	cmd,
*	    OUT   vltLOGICAL*	equal,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0devSoftCopyParameters(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0devSoftExecParameters(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0devSoftUpdateParameters(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    vltLOGICAL	cache,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0devSoftGetParamSetValue(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    vltINT32	index,
*	    OUT   lcctooVALUE*	value,
*	    OUT   vltINT32*	setCode,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0devSoftGetParamStatus(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    vltINT32	index,
*	    IN    vltINT32	flags,
*	    OUT   lcctooVALUE*	status,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0devSoftSetParam(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    vltINT32	index,
*	    IN    vltINT32	cmd,
*	    IN    lcctooVALUE*	value,
*	    IN    vltINT32	step,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0devSoftSetParamStep(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    vltINT32	index,
*	    IN    vltINT32	cmd,
*	    IN    vltINT32	step,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0devSoftUsrExecAction(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    vltINT32	index,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0devSoftUsrSetParameter(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    vltINT32	cmd,
*	    IN    vltINT32	param1,
*	    IN    vltINT32	param1SetCode,
*	    IN    vltINT32	param2,
*	    IN    vltINT32	param2SetCode,
*	    INOUT lcctooVALUE*	value,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0devSoftGetValueCode(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    const char*	name,
*	    OUT   vltINT32*	code,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0devSoftGetValue(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    vltINT32	code,
*	    IN    vltINT32	index,
*	    OUT   lcctooVALUE	value[],	** max. lcctooVALUE[10]
*	    OUT   vltINT16*	valueNum,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0devSoftUsrGetValue(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    const ic0devSOFT_VALUE valuesTable[],
*						** max. ic0devSOFT_VALUE[99]
*	    IN    vltINT16	valuesTableNum,
*	    IN    vltINT32	code,
*	    IN    vltINT32	index,
*	    OUT   lcctooVALUE	value[],	** max. lcctooVALUE[10]
*	    OUT   vltINT16*	valueNum,
*	    OUT   vltLOGICAL*	done,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0devSoftSetValue(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    vltINT32	code,
*	    IN    vltINT32	index,
*	    INOUT lcctooVALUE value[],	** max. lcctooVALUE[10]
*	    IN    vltINT16	valueNum,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0devSoftUsrSetValue(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    INOUT ic0devSOFT_VALUE valuesTable[],	
*						** max. ic0devSOFT_VALUE[99]
*	    INOUT vltINT16*	valuesTableNum,
*	    IN    vltINT32	code,
*	    IN    vltINT32	index,
*	    IN    const lcctooVALUE value[],	** max. lcctooVALUE[10]
*	    IN    vltINT16	valueNum,
*	    OUT   vltLOGICAL*	done,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0devSoftGetArg(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    vltINT32	code,
*	    IN    vltINT32	index,
*	    OUT   lcctooVALUE*	value,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0devSoftMonitor(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0devSoftUsrMonitor(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    vltINT32	state,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0devSoftLogAction(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    vltINT32	action,
*
*	ccsCOMPL_STAT ic0devSoftLogComment(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    const char*	comment,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0devSoftLogParameter(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    const char*	parameter,
*	    IN    vltINT32	type,
*	    IN    const char*	value,
*	    IN    const char*	comment,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0devSoftLogRecovery(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    const char*	comment,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0devSoftLogTblParam(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    vltINT32	paramIndex,
*	    IN    vltINT32	flags,
*	    IN    const char*	comment,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0devSoftLogUnforseen(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    const char*	comment,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0devSoftLogRecovery(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    const char*	comment,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0devSoftRead<scalarAttr>(
*	    INOUT egenOBJ*	obj,
*	    OUT   void*		buf,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0devSoftWrite<scalarAttr>(
*	    INOUT egenOBJ*	obj,
*	    IN    void*		buf,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0devSoftRead<vectorAttr>(
*	    INOUT egenOBJ*	obj,
*	    OUT   void*		buf,
*	    IN    vltINT32	first,
*	    IN    vltINT32	last,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0devSoftWrite<vectorAttr>(
*	    INOUT egenOBJ*	obj,
*	    IN    void*		buf,
*	    IN    vltINT32	first,
*	    IN    vltINT32	last,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0devSoftRead<tableAttr>(
*	    INOUT egenOBJ*	obj,
*	    OUT   void*		buf,
*	    IN    vltINT32	firstRec,
*	    IN    vltINT32	lastRec,
*	    IN    vltINT32	firstFld,
*	    IN    vltINT32	lastFld,
*	    OUT   ccsERROR*	error)
*	
*	ccsCOMPL_STAT ic0devSoftWrite<tableAttr>(
*	    INOUT egenOBJ*	obj,
*	    IN    void*		buf,
*	    IN    vltINT32	firstRec,
*	    IN    vltINT32	lastRec,
*	    IN    vltINT32	firstFld,
*	    IN    vltINT32	lastFld,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0devSoftErr<error>(...)
*
*   PARENT CLASS
*	public lccdevCMD
*
*   DESCRIPTION
*       The class ic0devSOFT provides the public interface
*       of an ICS function as a LCC Software Device.
*
*       The class implements the following new commands:
*
*       . SETUP GETVAL SETVAL CFGELEM LOGCONF GETCONF
*
*       The following main items have to be configured in the
*       database:
*       - FITS and other parameters accepted by the SETUP, MOVE,
*	  MOVEREL and SET commands.
*       - Configuration or alignment values needed by the ICS function.
*	  MOVEREL and SET commands.
*       - Actions to be performed by the SETUP, MOVE, MOVEREL and SET
*	  commands.
*
*       No specific actions are performed by this class. Classes
*       derived from ic0devSOFT may normally override the following
*       methods (the ic0devSoft prefix is omited from the names):
*       - Public methods: Setup, Move, MoveRel, Set, Stop, Check, Wait.
*       - Protected methods: Usr* methods
*       - Protected methods of the parent class.
*
*       The following sets of methods are supplied to assist in
*       the implementation of derived classes:
*
*       1. Methods related with the parameters table:
*	   UsrExecAction UsrSetParameter
*	   GetParamSetValue GetParamStatus SetParam SetParamStep
*	   See also:
*	   ResetParameters ParseParameters CompareParameters
*	   CopyParameters ExecParameters UpdateParameters
*
*       2. Methods related with the values table:
*	   UsrGetValue UsrSetValue
*	   GetValueCode GetValue SetValue
*
*       3. Methods used by user unit conversion functions:
*	   GetArg
*
*       4. Methods used to monitor device activities:
*	   UsrMonitor, see also: Monitor
*
*       5. Methods for logging:
*	   LogAction LogComment LogParameter LogRecovery
*	   LogTblParam LogUnforseen
*
*   PUBLIC METHODS
*	ic0devSoftNewObj(point,owner,obj,error)
*	    Initialises an instance of the class type ic0devSOFT.
*
*	    point	<IN>	OLDB point where the owned attributes are
*				located.
*	    owner	<IN>	Pointer to the owner of the new instance.
*	    obj		<OUT>	Handle for the new instance (the handle
*				must be allocated by the caller).
*
*	ic0devSoftDeleteObj(obj,error)
*	    The function lcctooDeleteObj deletes an
*	    instance of the class type ic0devSOFT
*
*	ic0devSoftSetup(obj,devName,function,functionNum,noMove,check,error)
*	   Setups the function. The keys are the last component
*	   of the FITS keywords related with the function.
*	   E.g.:
*	     If the FITS keyword is: INS.OPTI-3.ID #11
*	     then the key is: ID, the value '#11'.
*
*	   If the noMove flag is used, then the setup parameters
*	   are stored, but not executed until a setup command
*	   without the noMove flag is received.
*
*	   If the check flag is used, then only the parameters
*	   are checked. No setup is performed.
*
*	   Aliases are not accepted (The ICS Frontend at the
*	   workstation recognizes the aliases).
*
*	ic0devSoftGetVal(obj,devName,name,nameNum,status,error)
*	   Get device values.
*
*	ic0devSoftSetVal(obj,devName,name,nameNum,value,valueNum,error)
*	   Set device values (reserved for Operations).
*
*	ic0devSoftCfgElem(obj,devName,position,id,values,valuesNum,error)
*	   Configures a hardware device.
*
*	   The given id is associated with the given
*	   position. The id is usually the id of the
*	   element mounted at the given position of the
*	   hardware device (e.g. a specific filter in
*	   a filter wheel).
*
*	ic0devSoftLogConf(obj,devName,allElements,error)
*	   Sends logs describing the current configuration of
*	   the device.
*
*	   If the allElements flag is given, then the elements
*	   of all wheel positions are reported; otherwise
*	   only the element in the lightpath is described.
*
*	ic0devSoftGetConf(obj,devName,allElements,text,error)
*	   Returns the current configuration of the device.
*
*	   If the allElements flag is given, then the elements
*	   of all wheel positions are reported; otherwise
*	   only the element in the lightpath is described.
*
*   PROTECTED METHODS
*	ic0devSoftResetParameters(obj,devName,cmd,error)
*	   Reset the parameters received by the specified command
*	   (Setup, Move, MoveRel or Set).
*
*	ic0devSoftParseParameters(obj,devName,cmd,params,paramsNum,
*				  noMove,check,error)
*	   Parse the parameters for the specified command and
*	   store them in the parameters table.
*
*	   cmd		<IN>	command code (Setup, Move, MoveRel or Set)
*	   params	<IN>	parameter list
*	   noMove	<IN>	noMove flag (Setup command only)
*	   check	<IN>	check flag (Setup command only)
*
*	ic0devSoftCompareParameters(obj,devName,cmd,equal,error)
*	   Compare the setup or  actual parameters in the parameters
*	   table with the current status.
*
*	   cmd		<IN>	command code (Setup, Move, MoveRel or Set).
*	   equal	<OUT>	TRUE, if all parameters are equal to the
*			        current status.
*
*	ic0devSoftCopyParameters(obj,devName,error)
*	   Copy the Setup parameters to the actual parameters
*	   list in the parameters table.
*
*	ic0devSoftExecParameters(obj,devName,error)
*	   Execute the actions related to the actual parameters in
*	   the parameters table (calling UsrExecAction).
*
*	ic0devSoftUpdateParameters(obj,devName,cache,error)
*	   Update the status vector with the parameters in
*	   the parameters table.
*
*	   cache	<IN>	TRUE, if lcctooVALUE_CACHE flag has
*			   to be set when retrieving the status.
*
*	ic0devSoftGetParamSetValue(obj,devName,index,value,setCode,error)
*	   Return the value of the actual parameter at the specified
*	   index of the parameters table.
*
*	   index	<IN>	index to the parameters table
*	   value	<OUT>	value of the parameter
*	   setCode	<OUT>	setCode of the parameter
*
*	ic0devSoftGetParamStatus(obj,devName,index,flags,status,error)
*	   Returns the current status related with the parameter
*	   at the specified index of the parameters table.
*
*	   index	<IN>	index to the parameters table
*	   flags	<IN>	status class
*	   status	<OUT>	status value
*
*	ic0devSoftSetParam(obj,devName,index,cmd,value,step,error)
*	   Stores a parameter value and step in the parameters table.
*
*	   index	<IN>	index to the parameters table
*	   cmd		<IN>	command code (SETUP, MOVE, MOVEREL, SET)
*	   value	<IN>	value of the parameter
*	   step		<IN>	parameter step
*
*	ic0devSoftSetParamStep(obj,devName,index,cmd,step,error)
*	   Stores a parameter step in the parameters table.
*
*	   index	<IN>	index to the parameters table
*	   cmd		<IN>	command code (SETUP, MOVE, MOVEREL, SET)
*	   step		<IN>	parameter step
*
*	   The parameter step is one of the following constants:
*	     ic0devSTEP_NONE	  - no parameter value available.
*	     ic0devSTEP_STORED	  - parameter value stored.
*	     ic0devSTEP_EXECUTING - UsrExecAction is executing
*				    the action specified by this
*				    parameter.
*	     ic0devSTEP_USED	  - the parameter value has been used.
*
*	ic0devSoftUsrExecAction(obj,devName,index,error)
*	   This function can be overloaded if new action codes
*	   are introduced. The function performs the actions
*	   related with the specified code.
*
*	   index	<IN>	action code
*
*	ic0devSoftUsrSetParameter(obj,devName,cmd,param1,param1SetCode,
*				  param2,param2SetCode,value,error)
*	   This function should be overloaded if the 2.parameter
*	   setCode is supported. This function should set the
*	   value of the second parameter according to the value
*	   of the first parameter.
*
*	ic0devSoftGetValueCode(obj,devName,name,code,error)
*	   Returns an index into the values table, if the
*	   corresponding name is found in the table.
*
*	   name		<IN>	value name
*	   code		<OUT>	value code
*
*	ic0devSoftGetValue(obj,devName,code,index,value,valueNum,error)
*	   Returns the value(s) related with the specified
*	   value code and index. The index may be -1.
*
*	   code		<IN>	value code.
*	   index	<IN>	array index or
*			        index into the position table.
*	   value	<OUT>	returned values.
*
*	ic0devSoftUsrGetValue(obj,devName,valuesTable,valuesTableNum,
*				code,index,value,valueNum,done,error)
*	   Returns the value(s) related with the specified
*	   value code and index. The index may be -1.
*	   This function may be overloaded to access new
*	   values.
*
*	   valuesTable <IN>  values table
*	   code        <IN>  value code.
*	   index       <IN>  array index or
*			     index into the position table.
*	   value       <IN>  returned values.
*	   done        <OUT> flag indicating if value read.
*
*	ic0devSoftSetValue(obj,devName,code,index,value,valueNum,error)
*	   Returns the value(s) related with the specified
*	   value code and index. The index may be -1.
*
*	   code		<IN>	value code.
*	   index	<IN>	array index or
*			        index into the position table.
*	   value	<IN>	values.
*
*	ic0devSoftUsrSetValue(obj,devName,valuesTable,valuesTableNum,
*				code,index,value,valueNum,done,error)
*	   Returns the value(s) related with the specified
*	   value code and index. The index may be -1.
*	   This function may be overloaded to access new
*	   values.
*
*	   valuesTable <IN>  values table.
*	   code        <IN>  value code.
*	   index       <IN>  array index or
*			     index into the position table.
*	   value       <IN>  values.
*	   done        <OUT> flag indicating if value was set.
*
*	ic0devSoftGetArg(obj,devName,code,index,value,error)
*	   Returns a parameter value from the parameters table
*	   (if code >= 0 && code < 100) or a value from the
*	   values table (if code >= 100, index = code - 100).
*
*	   code    <IN>    index into the parameters or values table.
*	   index   <IN>    index into the positions table (for values)
*			   (-1 = current position, -2 = next position)
*	   value   <OUT>   returned value.
*
*	ic0devSoftMonitor(obj,devName,error)
*	   This function is periodically called by the device
*	   manager. It updates the status if the device is in
*	   the Standby or Online state. It calls the UsrMonitor.
*
*	ic0devSoftUsrMonitor(obj,devName,state,error)
*	   This function is periodically called by the device
*	   manager. This function may be overloaded to monitor
*	   the device.
*
*	ic0devSoftLogAction(obj,devName,action,comment,error)
*	   Logs the specified action with logData() as specified
*	   by the VLT standard. The following action codes are
*	   supported:
*
*	   ic0devLOG_OPEN_STRING	- Open
*	   ic0devLOG_CLOSE_STRING	- Close
*	   ic0devLOG_MOVE_STRING	- Move
*	   ic0devLOG_CHANGE_STRING	- Change
*	   ic0devLOG_START_STRING	- Start
*	   ic0devLOG_STOP_STRING	- Stop
*	   ic0devLOG_READ_STRING	- Read
*	   ic0devLOG_WRITE_STRING	- Write
*	   ic0devLOG_INIT_STRING	- Init
*
*	   action	<IN>	action code (see above)
*	   comment	<IN>	comment string
*
*	ic0devSoftLogComment(obj,devName,comment,error)
*	   Log a comment as specified by the VLT standard.
*
*	   comment	<IN>	comment string
*
*	ic0devSoftLogParameter(obj,devName,parameter,type,value,comment,error)
*	   Logs the specified parameter value with logData() as
*	   specified by the VLT standard.
*
*	   parameter	<IN>	parameter name
*	   type 	<IN>	parameter type
*	   value	<IN>	parameter value
*	   comment	<IN>	comment string
*
*	   The types are: ic0devLOG_STRING, ic0devLOG_INT32, ic0devLOG_DOUBLE.
*
*	ic0devSoftLogRecovery(obj,devName,comment,error)
*	   Log a recovery action as specified by the VLT standard.
*
*	   comment	<IN>	comment string
*
*	ic0devSoftLogTblParam(obj,devName,paramIndex,flags,comment,error)
*	   Logs the parameter at the specified index of the
*	   parameter table with logData() as specified by the
*	   VLT standard.
*
*	   paramIndex	<IN>	parameter index
*	   flags	<IN>	status class to be logged
*	   comment	<IN>	comment string
*
*	ic0devSoftLogUnforseen(obj,devName,comment,error)
*	   Log an unforseen event as specified by the VLT standard.
*
*	   comment	<IN>	comment string
*
*   PRIVATE METHODS
*	ic0devSoftInitObj(obj,error)
*	   This function is called when the object is initialised.
*	   It registers the object with the ICS function manager.
*
*	ic0devSoftExitObj(obj,error)
*	   This function is called when the object is deleted.
*	   It unregisters the object from the ICS function manager.
*
*   RETURN VALUES
*	If the function prototype allows, methods return ccsCOMPL_STAT.
*
*	The names of the defined errors begin as follows:
*	ic0devERR_<error>
*
*   SEE ALSO
*	ic0devSOFT(5) ic0devManager(3) ic0devMot(3) lccdevCmd(3) 
*       lccdevStd(3)
* 
*-------------------------------------------------------------------------
*/

#ifndef IC0DEV_SOFT_H
#define IC0DEV_SOFT_H

#include "egen.h"
#include "ic0devErrors.h"
#include "ic0devDefines.h"
#include "lccdevCmd.h"

/*
 * class type identifier
 */
#define ic0devSOFT_ID	120

/*
 * attribute table
 */
#define ic0devSOFT_ATTR_STATE	0
#define ic0devSOFT_ATTR_SUBSTATE	1
#define ic0devSOFT_ATTR_ERROR	2
#define ic0devSOFT_ATTR_INITIALISED	3
#define ic0devSOFT_ATTR_SIMULATION	4
#define ic0devSOFT_ATTR_DEVICE	5
#define ic0devSOFT_ATTR_AVAILABLE	6
#define ic0devSOFT_ATTR_ENABLED	7
#define ic0devSOFT_ATTR_LOCKED	8
#define ic0devSOFT_ATTR_HANDSET	9
#define ic0devSOFT_ATTR_FIXED	10
#define ic0devSOFT_ATTR_FIX_POS_SET	11
#define ic0devSOFT_ATTR_FIXED_POSITION	12
#define ic0devSOFT_ATTR_FIXED_SIMULATION	13
#define ic0devSOFT_ATTR_FIXED_LOCKED	14
#define ic0devSOFT_ATTR_PREFIX	15
#define ic0devSOFT_ATTR_PARAMETERS_SIZE	16
#define ic0devSOFT_ATTR_PARAMETERS	17
#define ic0devSOFT_ATTR_STATUS	18
#define ic0devSOFT_ATTR_STATUS_INDEX	19
#define ic0devSOFT_ATTR_VALUES_SIZE	20
#define ic0devSOFT_ATTR_VALUES	21
#define ic0devSOFT_ATTR_INIT_RESTRICTION	22
#define ic0devSOFT_ATTR_MOVE_RESTRICTION	23
#define ic0devSOFT_ATTR_STOP_TIMEOUT	24
#define ic0devSOFT_ATTR_SET_VAL_FCT	25
#define ic0devSOFT_ATTR_HELP_TEXT	26
#define ic0devSOFT_ATTR_PARAM_STEP	27
#define ic0devSOFT_ATTR_ACTION_COMMAND	28
#define ic0devSOFT_ATTR_ACTION_STOP_REQ	29
#define ic0devSOFT_ATTR_ACTION_NO_MOVE	30
#define ic0devSOFT_ATTR_ACTION_CHECK	31
#define ic0devSOFT_ATTR_RESET_SETUP_CMD	32

#define ic0devSOFT_AUTOMATA	0

#define ic0devSOFT_ELEM_PARAMETERS_PREFIX	   0
#define ic0devSOFT_ELEM_PARAMETERS_NAME		   1
#define ic0devSOFT_ELEM_PARAMETERS_CLASS	   2
#define ic0devSOFT_ELEM_PARAMETERS_TYPE		   3
#define ic0devSOFT_ELEM_PARAMETERS_FORMAT	   4
#define ic0devSOFT_ELEM_PARAMETERS_UNIT		   5
#define ic0devSOFT_ELEM_PARAMETERS_MAX		   6
#define ic0devSOFT_ELEM_PARAMETERS_SET_CODE	   7
#define ic0devSOFT_ELEM_PARAMETERS_SET_PARAM	   8
#define ic0devSOFT_ELEM_PARAMETERS_GET_CODE	   9
#define ic0devSOFT_ELEM_PARAMETERS_SETUP_ACTION	  10
#define ic0devSOFT_ELEM_PARAMETERS_MOVE_ACTION	  11
#define ic0devSOFT_ELEM_PARAMETERS_MOVE_REL_ACTION 12
#define ic0devSOFT_ELEM_PARAMETERS_SET_ACTION	  13
#define ic0devSOFT_ELEM_PARAMETERS_SETUP_VALUE	  14
#define ic0devSOFT_ELEM_PARAMETERS_SETUP_STEP	  15
#define ic0devSOFT_ELEM_PARAMETERS_SET_VALUE	  16
#define ic0devSOFT_ELEM_PARAMETERS_STEP		  17

#define ic0devSOFT_ELEM_VALUE_NAME		   0
#define ic0devSOFT_ELEM_VALUE_INDEX		   1
#define ic0devSOFT_ELEM_VALUE_LENGTH		   2
#define ic0devSOFT_ELEM_VALUE_SETVAL		   3
#define ic0devSOFT_ELEM_VALUE_VALUE		   4
#define ic0devSOFT_ELEM_VALUE_UNIT		   5


/*
 * function table
 */
#define ic0devSOFT_FCT_DELETE_OBJ	0
#define ic0devSOFT_FCT_STANDBY	1
#define ic0devSOFT_FCT_ONLINE	2
#define ic0devSOFT_FCT_OFF	3
#define ic0devSOFT_FCT_EXIT	4
#define ic0devSOFT_FCT_STATE	5
#define ic0devSOFT_FCT_SIMULAT	6
#define ic0devSOFT_FCT_STOP_SIM	7
#define ic0devSOFT_FCT_STATUS	8
#define ic0devSOFT_FCT_INIT	9
#define ic0devSOFT_FCT_STOP	10
#define ic0devSOFT_FCT_TEST	11
#define ic0devSOFT_FCT_SELFTST	12
#define ic0devSOFT_FCT_AUTO_TBL	13
#define ic0devSOFT_FCT_AUTO_RST	14
#define ic0devSOFT_FCT_INIT_OBJ	15
#define ic0devSOFT_FCT_EXIT_OBJ	16
#define ic0devSOFT_FCT_LOADED2STBY	17
#define ic0devSOFT_FCT_ONLINE2STBY	18
#define ic0devSOFT_FCT_EXIT1	19
#define ic0devSOFT_FCT_CHECK_DEVICE_NAME	20
#define ic0devSOFT_FCT_BREAK	21
#define ic0devSOFT_FCT_USR_INIT	22
#define ic0devSOFT_FCT_USR_LOADED2STANDBY	23
#define ic0devSOFT_FCT_USR_STANDBY2ONLINE	24
#define ic0devSOFT_FCT_USR_ONLINE2STANDBY	25
#define ic0devSOFT_FCT_USR_STANDBY2LOADED	26
#define ic0devSOFT_FCT_USR_STOP	27
#define ic0devSOFT_FCT_USR_SIMULAT	28
#define ic0devSOFT_FCT_USR_STOP_SIM	29
#define ic0devSOFT_FCT_USR_STATUS_CODE	30
#define ic0devSOFT_FCT_USR_STATUS_LAST	31
#define ic0devSOFT_FCT_USR_STATUS_VALUE	32
#define ic0devSOFT_FCT_USR_TEST	33
#define ic0devSOFT_FCT_USR_SELF_TEST	34
#define ic0devSOFT_FCT_USR_ERROR	35
#define ic0devSOFT_FCT_AVAIL	36
#define ic0devSOFT_FCT_UNAVAIL	37
#define ic0devSOFT_FCT_DISABLE	38
#define ic0devSOFT_FCT_ENABLE	39
#define ic0devSOFT_FCT_LOCK	40
#define ic0devSOFT_FCT_UNLOCK	41
#define ic0devSOFT_FCT_HANDSET	42
#define ic0devSOFT_FCT_HSET_OFF	43
#define ic0devSOFT_FCT_FIX_POS	44
#define ic0devSOFT_FCT_MOVE	45
#define ic0devSOFT_FCT_MOVE_REL	46
#define ic0devSOFT_FCT_SET	47
#define ic0devSOFT_FCT_CHECK	48
#define ic0devSOFT_FCT_WAIT	49
#define ic0devSOFT_FCT_USR_SET_MODE	50
#define ic0devSOFT_FCT_SETUP	51
#define ic0devSOFT_FCT_GET_VAL	52
#define ic0devSOFT_FCT_SET_VAL	53
#define ic0devSOFT_FCT_CFG_ELEM	54
#define ic0devSOFT_FCT_LOG_CONF	55
#define ic0devSOFT_FCT_GET_CONF	56
#define ic0devSOFT_FCT_RESET_PARAMETERS	57
#define ic0devSOFT_FCT_PARSE_PARAMETERS	58
#define ic0devSOFT_FCT_COMPARE_PARAMETERS	59
#define ic0devSOFT_FCT_COPY_PARAMETERS	60
#define ic0devSOFT_FCT_EXEC_PARAMETERS	61
#define ic0devSOFT_FCT_UPDATE_PARAMETERS	62
#define ic0devSOFT_FCT_GET_PARAM_SET_VALUE	63
#define ic0devSOFT_FCT_GET_PARAM_STATUS	64
#define ic0devSOFT_FCT_SET_PARAM	65
#define ic0devSOFT_FCT_SET_PARAM_STEP	66
#define ic0devSOFT_FCT_USR_EXEC_ACTION	67
#define ic0devSOFT_FCT_USR_SET_PARAMETER	68
#define ic0devSOFT_FCT_GET_VALUE_CODE	69
#define ic0devSOFT_FCT_GET_VALUE	70
#define ic0devSOFT_FCT_USR_GET_VALUE	71
#define ic0devSOFT_FCT_SET_VALUE	72
#define ic0devSOFT_FCT_USR_SET_VALUE	73
#define ic0devSOFT_FCT_GET_ARG	74
#define ic0devSOFT_FCT_MONITOR	75
#define ic0devSOFT_FCT_USR_MONITOR	76
#define ic0devSOFT_FCT_LOG_ACTION	77
#define ic0devSOFT_FCT_LOG_COMMENT	78
#define ic0devSOFT_FCT_LOG_PARAMETER	79
#define ic0devSOFT_FCT_LOG_RECOVERY	80
#define ic0devSOFT_FCT_LOG_TBL_PARAM	81
#define ic0devSOFT_FCT_LOG_UNFORSEEN	82

/*
 * automata states
 */
#define ic0devSOFT_STATE_NOSTATE	-1
#define ic0devSOFT_STATE_OFF	0
#define ic0devSOFT_STATE_LOADED	1
#define ic0devSOFT_STATE_STANDBY	2
#define ic0devSOFT_STATE_ONLINE	3

/*
 * automata substates
 */
#define ic0devSOFT_SUBSTATE_ERROR	0
#define ic0devSOFT_SUBSTATE_IDLE	1
#define ic0devSOFT_SUBSTATE_BUSY	2
#define ic0devSOFT_SUBSTATE_INITIALISING	3
#define ic0devSOFT_SUBSTATE_SHUTTING_DOWN	4
#define ic0devSOFT_SUBSTATE_STOPPING	5
#define ic0devSOFT_SUBSTATE_COLD_STARTING	6
#define ic0devSOFT_SUBSTATE_STARTING	7
#define ic0devSOFT_SUBSTATE_STOP	8

/*
 * automata events
 */
#define ic0devSOFT_EVENT_INIT	0
#define ic0devSOFT_EVENT_STANDBY	1
#define ic0devSOFT_EVENT_ONLINE	2
#define ic0devSOFT_EVENT_STOP	3
#define ic0devSOFT_EVENT_OFF	4
#define ic0devSOFT_EVENT_EXIT	5
#define ic0devSOFT_EVENT_STATE	6
#define ic0devSOFT_EVENT_STOP_SIM	7
#define ic0devSOFT_EVENT_STATUS	8
#define ic0devSOFT_EVENT_SIMULAT	9
#define ic0devSOFT_EVENT_TEST	10
#define ic0devSOFT_EVENT_SELFTST	11
#define ic0devSOFT_EVENT_AUTO_TBL	12
#define ic0devSOFT_EVENT_AUTO_RST	13
#define ic0devSOFT_EVENT_DISABLE	14
#define ic0devSOFT_EVENT_ENABLE	15
#define ic0devSOFT_EVENT_LOCK	16
#define ic0devSOFT_EVENT_UNLOCK	17
#define ic0devSOFT_EVENT_HANDSET	18
#define ic0devSOFT_EVENT_HSET_OFF	19
#define ic0devSOFT_EVENT_AVAIL	20
#define ic0devSOFT_EVENT_UNAVAIL	21
#define ic0devSOFT_EVENT_MOVE	22
#define ic0devSOFT_EVENT_MOVE_REL	23
#define ic0devSOFT_EVENT_SET	24
#define ic0devSOFT_EVENT_CHECK	25
#define ic0devSOFT_EVENT_WAIT	26
#define ic0devSOFT_EVENT_SETUP	27
#define ic0devSOFT_EVENT_CFG_ELEM	28
#define ic0devSOFT_EVENT_GET_VAL	29
#define ic0devSOFT_EVENT_SET_VAL	30
#define ic0devSOFT_EVENT_LOG_CONF	31
#define ic0devSOFT_EVENT_GET_CONF	32
#define ic0devSOFT_EVENT_MONITOR	33


/*
 * table types
 */
typedef struct
    {
    vltBYTES16	prefix;
    vltBYTES16	name;
    vltINT32	class;
    vltINT32	type;
    vltBYTES8	format;
    vltBYTES8	unit;
    vltINT32	range;
    vltINT32	setCode;
    vltINT32	setParam;
    vltINT32	getCode;
    vltINT32	setupAction;
    vltINT32	moveAction;
    vltINT32	moveRelAction;
    vltINT32	setAction;
    vltBYTES20	setupValue;
    vltINT32	setupStep;
    vltBYTES20	setValue;
    vltINT32	step;
    } ic0devSOFT_PARAMETER;

typedef struct
    {
    vltBYTES16	prefix;
    vltBYTES16	name;
    vltINT32	class;
    vltINT32	type;
    vltBYTES8	format;
    vltBYTES8	unit;
    vltINT32	range;
    vltINT32	setCode;
    vltINT32	setParam;
    vltINT32	getCode;
    vltINT32	setupAction;
    vltINT32	moveAction;
    vltINT32	moveRelAction;
    vltINT32	setAction;
    } ic0devSOFT_PARAMETER_HEADER;

typedef struct
    {
    vltBYTES20	value;
    vltINT32	step;
    } ic0devSOFT_PARAMETER_VALUE;

typedef struct
    {
    vltBYTES16	name;
    vltINT32	index;
    vltINT32	length;
    vltINT32	setval;
    vltDOUBLE	value;
    vltBYTES8	unit;
    vltINT32	range;
    } ic0devSOFT_VALUE;

typedef struct
    {
    vltDOUBLE	value;
    vltBYTES8	unit;
    } ic0devSOFT_VALUE_VALUE;


/*
 * user variables
 */
typedef struct
    {
    SEM_ID	actionSequence;
    SEM_ID	actionSetup;
    vltINT32	dummy[8];
    } ic0devSOFT_USERVAR;

#define ic0devSoftSemActionSequence(obj)	\
	(((ic0devSOFT_USERVAR *)(obj)->user)->actionSequence)
#define ic0devSoftSemActionSetup(obj)	\
	(((ic0devSOFT_USERVAR *)(obj)->user)->actionSetup)


/*
 * function pointer types
 */
typedef ccsCOMPL_STAT (*ic0devSOFT_FCTPTR_SETUP)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    const char*	function[],	/* max. vltBYTES32[999] */
    IN    vltINT16	functionNum,
    IN    vltLOGICAL	noMove,
    IN    vltLOGICAL	check,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devSOFT_FCTPTR_GET_VAL)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    const char*	name[],	/* max. vltBYTES32[2] */
    IN    vltINT16	nameNum,
    OUT   char**	status,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devSOFT_FCTPTR_SET_VAL)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    const char*	name[],	/* max. vltBYTES32[2] */
    IN    vltINT16	nameNum,
    IN    const char*	value[],	/* max. vltBYTES32[10] */
    IN    vltINT16	valueNum,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devSOFT_FCTPTR_CFG_ELEM)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltINT32	position,
    IN    const char*	id,
    IN    const char*	values[],	/* max. vltBYTES16[10] */
    IN    vltINT16	valuesNum,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devSOFT_FCTPTR_LOG_CONF)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltLOGICAL	allElements,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devSOFT_FCTPTR_GET_CONF)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltLOGICAL	allElements,
    OUT   char**	text,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devSOFT_FCTPTR_STATUS)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    const char*	function[],	/* max. vltBYTES32[999] */
    IN    vltINT16	functionNum,
    IN    vltLOGICAL	flag,
    IN    vltLOGICAL	header,
    IN    vltLOGICAL	conflog,
    IN    vltLOGICAL	opslog,
    IN    vltLOGICAL	condlog,
    OUT   char**	status,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devSOFT_FCTPTR_MOVE)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    const char*	position[],	/* max. vltBYTES32[999] */
    IN    vltINT16	positionNum,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devSOFT_FCTPTR_MOVE_REL)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    const char*	position[],	/* max. vltBYTES32[999] */
    IN    vltINT16	positionNum,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devSOFT_FCTPTR_SET)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    const char*	position[],	/* max. vltBYTES32[999] */
    IN    vltINT16	positionNum,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devSOFT_FCTPTR_RESET_PARAMETERS)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltINT32	cmd,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devSOFT_FCTPTR_PARSE_PARAMETERS)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltINT32	cmd,
    IN    const char*	params[],	/* max. vltBYTES32[999] */
    IN    vltINT16	paramsNum,
    IN    vltLOGICAL	noMove,
    IN    vltLOGICAL	check,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devSOFT_FCTPTR_COMPARE_PARAMETERS)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltINT32	cmd,
    OUT   vltLOGICAL*	equal,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devSOFT_FCTPTR_COPY_PARAMETERS)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devSOFT_FCTPTR_EXEC_PARAMETERS)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devSOFT_FCTPTR_UPDATE_PARAMETERS)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltLOGICAL	cache,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devSOFT_FCTPTR_GET_PARAM_SET_VALUE)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltINT32	index,
    OUT   lcctooVALUE*	value,
    OUT   vltINT32*	setCode,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devSOFT_FCTPTR_GET_PARAM_STATUS)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltINT32	index,
    IN    vltINT32	flags,
    OUT   lcctooVALUE*	status,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devSOFT_FCTPTR_SET_PARAM)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltINT32	index,
    IN    vltINT32	cmd,
    IN    lcctooVALUE*	value,
    IN    vltINT32	step,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devSOFT_FCTPTR_SET_PARAM_STEP)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltINT32	index,
    IN    vltINT32	cmd,
    IN    vltINT32	step,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devSOFT_FCTPTR_USR_EXEC_ACTION)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltINT32	index,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devSOFT_FCTPTR_USR_SET_PARAMETER)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltINT32	cmd,
    IN    vltINT32	param1,
    IN    vltINT32	param1SetCode,
    IN    vltINT32	param2,
    IN    vltINT32	param2SetCode,
    INOUT lcctooVALUE*	value,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devSOFT_FCTPTR_GET_VALUE_CODE)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    const char*	name,
    OUT   vltINT32*	code,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devSOFT_FCTPTR_GET_VALUE)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltINT32	code,
    IN    vltINT32	index,
    OUT   lcctooVALUE	value[],	/* max. lcctooVALUE[10] */
    OUT   vltINT16*	valueNum,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devSOFT_FCTPTR_USR_GET_VALUE)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    const ic0devSOFT_VALUE	valuesTable[],	/* max. ic0devSOFT_VALUE[99] */
    IN    vltINT16	valuesTableNum,
    IN    vltINT32	code,
    IN    vltINT32	index,
    OUT   lcctooVALUE	value[],	/* max. lcctooVALUE[10] */
    OUT   vltINT16*	valueNum,
    OUT   vltLOGICAL*	done,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devSOFT_FCTPTR_SET_VALUE)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltINT32	code,
    IN    vltINT32	index,
    IN    const lcctooVALUE	value[],	/* max. lcctooVALUE[10] */
    IN    vltINT16	valueNum,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devSOFT_FCTPTR_USR_SET_VALUE)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    INOUT ic0devSOFT_VALUE	valuesTable[],	/* max. ic0devSOFT_VALUE[99] */
    INOUT vltINT16*	valuesTableNum,
    IN    vltINT32	code,
    IN    vltINT32	index,
    IN    const lcctooVALUE	value[],	/* max. lcctooVALUE[10] */
    IN    vltINT16	valueNum,
    OUT   vltLOGICAL*	done,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devSOFT_FCTPTR_GET_ARG)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltINT32	code,
    IN    vltINT32	index,
    OUT   lcctooVALUE*	value,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devSOFT_FCTPTR_MONITOR)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devSOFT_FCTPTR_USR_MONITOR)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltINT32	state,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devSOFT_FCTPTR_LOG_ACTION)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltINT32	action,
    IN    const char*	comment,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devSOFT_FCTPTR_LOG_COMMENT)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    const char*	comment,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devSOFT_FCTPTR_LOG_PARAMETER)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    const char*	parameter,
    IN    vltINT32	index,
    IN    const char*	value,
    IN    const char*	comment,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devSOFT_FCTPTR_LOG_RECOVERY)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    const char*	comment,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devSOFT_FCTPTR_LOG_TBL_PARAM)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltINT32	paramIndex,
    IN    vltINT32	flags,
    IN    const char*	comment,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devSOFT_FCTPTR_LOG_UNFORSEEN)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    const char*	comment,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devSOFT_FCTPTR_USR_INIT)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devSOFT_FCTPTR_USR_STOP)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltLOGICAL	req,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devSOFT_FCTPTR_INIT_OBJ)(
    INOUT egenOBJ*	obj,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0devSOFT_FCTPTR_EXIT_OBJ)(
    INOUT egenOBJ*	obj,
    OUT   ccsERROR*	error);


/*
 * log function
 */
#define ic0devSoftLogData(obj, format, arg...) \
	{ \
	char tmpLogBuf[lcctooTMP_BUFFER_SIZE]; \
	\
	sprintf(tmpLogBuf, (format), ##arg); \
	logData("ic0dev", (obj)->id, tmpLogBuf); \
	}


/*
 * error functions
 */
#define ic0devErrActionStopReq(p1) \
	{ \
	lcctooLOG_0("ic0devERR_ACTION_STOP_REQ: Device %s: Movement aborted by another command.",(p1)); \
	errAdd(error,"ic0dev",ic0devERR_ACTION_STOP_REQ,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0devErrCompareSetup(p1) \
	{ \
	lcctooLOG_0("ic0devERR_COMPARE_SETUP: Device %s: Error comparing the parameters of command setup.",(p1)); \
	errAdd(error,"ic0dev",ic0devERR_COMPARE_SETUP,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0devErrConfTooLong(p1) \
	{ \
	lcctooLOG_0("ic0devERR_CONF_TOO_LONG: Device %s: Configuration too long.",(p1)); \
	errAdd(error,"ic0dev",ic0devERR_CONF_TOO_LONG,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0devErrCopySetup(p1) \
	{ \
	lcctooLOG_0("ic0devERR_COPY_SETUP: Device %s: Error copying the parameters of command setup.",(p1)); \
	errAdd(error,"ic0dev",ic0devERR_COPY_SETUP,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0devErrExecMove(p1) \
	{ \
	lcctooLOG_0("ic0devERR_EXEC_MOVE: Device %s: Error during device movement (command move).",(p1)); \
	errAdd(error,"ic0dev",ic0devERR_EXEC_MOVE,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0devErrExecMoveRel(p1) \
	{ \
	lcctooLOG_0("ic0devERR_EXEC_MOVE_REL: Device %s: Error during device movement (command moverel).",(p1)); \
	errAdd(error,"ic0dev",ic0devERR_EXEC_MOVE_REL,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0devErrExecSet(p1) \
	{ \
	lcctooLOG_0("ic0devERR_EXEC_SET: Device %s: Error during device movement (command set).",(p1)); \
	errAdd(error,"ic0dev",ic0devERR_EXEC_SET,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0devErrExecSetup(p1) \
	{ \
	lcctooLOG_0("ic0devERR_EXEC_SETUP: Device %s: Error during device setup.",(p1)); \
	errAdd(error,"ic0dev",ic0devERR_EXEC_SETUP,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0devErrFindSymbol(p1,p2) \
	{ \
	lcctooLOG_0("ic0devERR_FIND_SYMBOL: Device %s: User function %s not found.",(p1),(p2)); \
	errAdd(error,"ic0dev",ic0devERR_FIND_SYMBOL,__FILE_LINE__,"%s,%s",(p1),(p2)); \
	}
#define ic0devErrGetArgCode(p1,p2) \
	{ \
	lcctooLOG_0("ic0devERR_GET_ARG_CODE: Device %s: Wrong argument code %d.",(p1),(p2)); \
	errAdd(error,"ic0dev",ic0devERR_GET_ARG_CODE,__FILE_LINE__,"%s,%d",(p1),(p2)); \
	}
#define ic0devErrGetParametersSize(p1) \
	{ \
	lcctooLOG_0("ic0devERR_GET_PARAMETERS_SIZE: Device %s: Unable to get the size of the parameters table.",(p1)); \
	errAdd(error,"ic0dev",ic0devERR_GET_PARAMETERS_SIZE,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0devErrGetVal(p1) \
	{ \
	lcctooLOG_0("ic0devERR_GET_VAL: Device %s: Wrong value name.",(p1)); \
	errAdd(error,"ic0dev",ic0devERR_GET_VAL,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0devErrGetValuesSize(p1) \
	{ \
	lcctooLOG_0("ic0devERR_GET_VALUES_SIZE: Device %s: Unable to get the size of the 'values' table.",(p1)); \
	errAdd(error,"ic0dev",ic0devERR_GET_VALUES_SIZE,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0devErrInHandset(p1) \
	{ \
	lcctooLOG_0("ic0devERR_IN_HANDSET: Device %s: Device in Handset mode.",(p1)); \
	errAdd(error,"ic0dev",ic0devERR_IN_HANDSET,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0devErrLocked(p1) \
	{ \
	lcctooLOG_0("ic0devERR_LOCKED: Device %s: Device locked.",(p1)); \
	errAdd(error,"ic0dev",ic0devERR_LOCKED,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0devErrLog(p1) \
	{ \
	lcctooLOG_0("ic0devERR_LOG: Device %s: Error making a log entry.",(p1)); \
	errAdd(error,"ic0dev",ic0devERR_LOG,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0devErrLogCommentTooLong(p1,p2) \
	{ \
	lcctooLOG_0("ic0devERR_LOG_COMMENT_TOO_LONG: Device %s: Log comment '%s' is too long.",(p1),(p2)); \
	errAdd(error,"ic0dev",ic0devERR_LOG_COMMENT_TOO_LONG,__FILE_LINE__,"%s,%s",(p1),(p2)); \
	}
#define ic0devErrMsgTooLong() \
	{ \
	lcctooLOG_0("ic0devERR_MSG_TOO_LONG: Too many message arguments."); \
	errAdd(error,"ic0dev",ic0devERR_MSG_TOO_LONG,__FILE_LINE__,""); \
	}
#define ic0devErrNameNum(p1,p2) \
	{ \
	lcctooLOG_0("ic0devERR_NAME_NUM: Device %s: Invalid number of names (%d).",(p1),(p2)); \
	errAdd(error,"ic0dev",ic0devERR_NAME_NUM,__FILE_LINE__,"%s,%d",(p1),(p2)); \
	}
#define ic0devErrNotAllowed(p1,p2) \
	{ \
	lcctooLOG_0("ic0devERR_NOT_ALLOWED: Device %s: Not allowed %s.",(p1),(p2)); \
	errAdd(error,"ic0dev",ic0devERR_NOT_ALLOWED,__FILE_LINE__,"%s,%s",(p1),(p2)); \
	}
#define ic0devErrNotAvailable(p1) \
	{ \
	lcctooLOG_0("ic0devERR_NOT_AVAILABLE: Device %s: Device not available.",(p1)); \
	errAdd(error,"ic0dev",ic0devERR_NOT_AVAILABLE,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0devErrNotEnabled(p1) \
	{ \
	lcctooLOG_0("ic0devERR_NOT_ENABLED: Device %s: Device not enabled.",(p1)); \
	errAdd(error,"ic0dev",ic0devERR_NOT_ENABLED,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0devErrParamOutOfRange(p1,p2,p3,p4) \
	{ \
	lcctooLOG_0("ic0devERR_PARAM_OUT_OF_RANGE: Device %s: Parameter %g out of range (%g - %g).",(p1),(p2),(p3),(p4)); \
	errAdd(error,"ic0dev",ic0devERR_PARAM_OUT_OF_RANGE,__FILE_LINE__,"%s,%g,%g,%g",(p1),(p2),(p3),(p4)); \
	}
#define ic0devErrParameterNotAccepted(p1,p2) \
	{ \
	lcctooLOG_0("ic0devERR_PARAMETER_NOT_ACCEPTED: Device %s: Parameter %s not accepted or command not applicable to device.",(p1),(p2)); \
	errAdd(error,"ic0dev",ic0devERR_PARAMETER_NOT_ACCEPTED,__FILE_LINE__,"%s,%s",(p1),(p2)); \
	}
#define ic0devErrParseMove(p1) \
	{ \
	lcctooLOG_0("ic0devERR_PARSE_MOVE: Device %s: Error parsing the parameters of command move or command not applicable to device.",(p1)); \
	errAdd(error,"ic0dev",ic0devERR_PARSE_MOVE,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0devErrParseMoveRel(p1) \
	{ \
	lcctooLOG_0("ic0devERR_PARSE_MOVE_REL: Device %s: Error parsing the parameters of command moverel or command not applicable to device.",(p1)); \
	errAdd(error,"ic0dev",ic0devERR_PARSE_MOVE_REL,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0devErrParseSet(p1) \
	{ \
	lcctooLOG_0("ic0devERR_PARSE_SET: Device %s: Error parsing the parameters of command set or command not applicable to device.",(p1)); \
	errAdd(error,"ic0dev",ic0devERR_PARSE_SET,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0devErrParseSetup(p1) \
	{ \
	lcctooLOG_0("ic0devERR_PARSE_SETUP: Device %s: Error parsing the parameters of command setup.",(p1)); \
	errAdd(error,"ic0dev",ic0devERR_PARSE_SETUP,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0devErrReadActionCommand(p1) \
	{ \
	lcctooLOG_0("ic0devERR_READ_ACTION_COMMAND: Device %s: Unable to read attribute 'actionCommand' from OLDB.",(p1)); \
	errAdd(error,"ic0dev",ic0devERR_READ_ACTION_COMMAND,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0devErrReadOnly(p1) \
	{ \
	lcctooLOG_0("ic0devERR_READ_ONLY: Device %s: Value is readonly. Not modified.",(p1)); \
	errAdd(error,"ic0dev",ic0devERR_READ_ONLY,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0devErrReadActionStopReq(p1) \
	{ \
	lcctooLOG_0("ic0devERR_READ_ACTION_STOP_REQ: Device %s: Unable to read attribute 'actionStopReq' from OLDB.",(p1)); \
	errAdd(error,"ic0dev",ic0devERR_READ_ACTION_STOP_REQ,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0devErrReadActionCheck(p1) \
	{ \
	lcctooLOG_0("ic0devERR_READ_ACTION_CHECK: Device %s: Unable to read attribute 'actionCheck' from OLDB.",(p1)); \
	errAdd(error,"ic0dev",ic0devERR_READ_ACTION_CHECK,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0devErrReadActionNoMove(p1) \
	{ \
	lcctooLOG_0("ic0devERR_READ_ACTION_NO_MOVE: Device %s: Unable to read attribute 'actionNoMove' from OLDB.",(p1)); \
	errAdd(error,"ic0dev",ic0devERR_READ_ACTION_NO_MOVE,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0devErrReadInitRestriction(p1) \
	{ \
	lcctooLOG_0("ic0devERR_READ_INIT_RESTRICTION: Device %s: Unable to read attribute 'initRestriction' from OLDB.",(p1)); \
	errAdd(error,"ic0dev",ic0devERR_READ_INIT_RESTRICTION,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0devErrReadMoveRestriction(p1) \
	{ \
	lcctooLOG_0("ic0devERR_READ_MOVE_RESTRICTION: Device %s: Unable to read attribute 'moveRestriction' from OLDB.",(p1)); \
	errAdd(error,"ic0dev",ic0devERR_READ_MOVE_RESTRICTION,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0devErrReadParameters(p1,p2) \
	{ \
	lcctooLOG_0("ic0devERR_READ_PARAMETERS: Device %s: Unable to read parameters (%s) from OLDB.",(p1),(p2)); \
	errAdd(error,"ic0dev",ic0devERR_READ_PARAMETERS,__FILE_LINE__,"%s,%s",(p1),(p2)); \
	}
#define ic0devErrReadPrefix(p1) \
	{ \
	lcctooLOG_0("ic0devERR_READ_PREFIX: Device %s: Unable to read attribute 'prefix' from OLDB.",(p1)); \
	errAdd(error,"ic0dev",ic0devERR_READ_PREFIX,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0devErrReadResetSetupCmd(p1) \
	{ \
	lcctooLOG_0("ic0devERR_READ_RESET_SETUP_CMD: Device %s: Unable to read attribute 'resetSetupCmd' from OLDB.",(p1)); \
	errAdd(error,"ic0dev",ic0devERR_READ_RESET_SETUP_CMD,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0devErrReadSetValFct(p1) \
	{ \
	lcctooLOG_0("ic0devERR_READ_SET_VAL_FCT: Device %s: Unable to read SETVAL user function name from OLDB.",(p1)); \
	errAdd(error,"ic0dev",ic0devERR_READ_SET_VAL_FCT,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0devErrReadStopTimeout(p1) \
	{ \
	lcctooLOG_0("ic0devERR_READ_STOP_TIMEOUT: Device %s: Unable to read stop timeout from OLDB.",(p1)); \
	errAdd(error,"ic0dev",ic0devERR_READ_STOP_TIMEOUT,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0devErrReadValues(p1,p2) \
	{ \
	lcctooLOG_0("ic0devERR_READ_VALUES: Device %s: Unable to read values table (%s) from OLDB.",(p1),(p2)); \
	errAdd(error,"ic0dev",ic0devERR_READ_VALUES,__FILE_LINE__,"%s,%s",(p1),(p2)); \
	}
#define ic0devErrResetParameters(p1) \
	{ \
	lcctooLOG_0("ic0devERR_RESET_PARAMETERS: Device %s: Unable to reset OLDB parameters table.",(p1)); \
	errAdd(error,"ic0dev",ic0devERR_RESET_PARAMETERS,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0devErrResetSetup(p1) \
	{ \
	lcctooLOG_0("ic0devERR_RESET_SETUP: Device %s: Error reseting the parameters of command setup.",(p1)); \
	errAdd(error,"ic0dev",ic0devERR_RESET_SETUP,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0devErrSetVal(p1) \
	{ \
	lcctooLOG_0("ic0devERR_SET_VAL: Device %s: Wrong value name or value format.",(p1)); \
	errAdd(error,"ic0dev",ic0devERR_SET_VAL,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0devErrStatusTooLong(p1,p2) \
	{ \
	lcctooLOG_0("ic0devERR_STATUS_TOO_LONG: Device %s: Status too long after reading %d. parameter.",(p1),(p2)); \
	errAdd(error,"ic0dev",ic0devERR_STATUS_TOO_LONG,__FILE_LINE__,"%s,%d",(p1),(p2)); \
	}
#define ic0devErrUtc(p1) \
	{ \
	lcctooLOG_0("ic0devERR_UTC: Device %s: Unable to obtain UTC time.",(p1)); \
	errAdd(error,"ic0dev",ic0devERR_UTC,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0devErrValueOutOfRange(p1,p2,p3,p4) \
	{ \
	lcctooLOG_0("ic0devERR_VALUE_OUT_OF_RANGE: Device %s: Value %g out of range (%g - %g).",(p1),(p2),(p3),(p4)); \
	errAdd(error,"ic0dev",ic0devERR_VALUE_OUT_OF_RANGE,__FILE_LINE__,"%s,%g,%g,%g",(p1),(p2),(p3),(p4)); \
	}
#define ic0devErrValueTooLong(p1,p2) \
	{ \
	lcctooLOG_0("ic0devERR_VALUE_TOO_LONG: Device %s: Value %s too long.",(p1),(p2)); \
	errAdd(error,"ic0dev",ic0devERR_VALUE_TOO_LONG,__FILE_LINE__,"%s,%s",(p1),(p2)); \
	}
#define ic0devErrValueNotOneDouble(p1,p2) \
	{ \
	lcctooLOG_0("ic0devERR_VALUE_NOT_ONE_DOUBLE: Device %s: Value %s is not a single double.",(p1),(p2)); \
	errAdd(error,"ic0dev",ic0devERR_VALUE_NOT_ONE_DOUBLE,__FILE_LINE__,"%s,%s",(p1),(p2)); \
	}
#define ic0devErrVerbose(p1) \
	{ \
	lcctooLOG_0("ic0devERR_VERBOSE: Device %s: Error returing a verbose reply.",(p1)); \
	errAdd(error,"ic0dev",ic0devERR_VERBOSE,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0devErrWriteActionCheck(p1,p2) \
	{ \
	lcctooLOG_0("ic0devERR_WRITE_ACTION_CHECK: Device %s: Unable to write attribute 'actionCheck' (value %d).",(p1),(p2)); \
	errAdd(error,"ic0dev",ic0devERR_WRITE_ACTION_CHECK,__FILE_LINE__,"%s,%d",(p1),(p2)); \
	}
#define ic0devErrWriteActionCommand(p1,p2) \
	{ \
	lcctooLOG_0("ic0devERR_WRITE_ACTION_COMMAND: Device %s: Unable to write attribute 'actionCommand' (value %d).",(p1),(p2)); \
	errAdd(error,"ic0dev",ic0devERR_WRITE_ACTION_COMMAND,__FILE_LINE__,"%s,%d",(p1),(p2)); \
	}
#define ic0devErrWriteActionNoMove(p1,p2) \
	{ \
	lcctooLOG_0("ic0devERR_WRITE_ACTION_NO_MOVE: Device %s: Unable to write attribute 'actionNoMove' (value %d).",(p1),(p2)); \
	errAdd(error,"ic0dev",ic0devERR_WRITE_ACTION_NO_MOVE,__FILE_LINE__,"%s,%d",(p1),(p2)); \
	}
#define ic0devErrWriteActionStopReq(p1,p2) \
	{ \
	lcctooLOG_0("ic0devERR_WRITE_ACTION_STOP_REQ: Device %s: Unable to write attribute 'actionStopReq' (value %d).",(p1),(p2)); \
	errAdd(error,"ic0dev",ic0devERR_WRITE_ACTION_STOP_REQ,__FILE_LINE__,"%s,%d",(p1),(p2)); \
	}
#define ic0devErrWriteParamStep(p1,p2) \
	{ \
	lcctooLOG_0("ic0devERR_WRITE_PARAM_STEP: Device %s: Unable to write attribute 'paramStep' (value %d).",(p1),(p2)); \
	errAdd(error,"ic0dev",ic0devERR_WRITE_PARAM_STEP,__FILE_LINE__,"%s,%d",(p1),(p2)); \
	}
#define ic0devErrWriteParameters(p1,p2) \
	{ \
	lcctooLOG_0("ic0devERR_WRITE_PARAMETERS: Device %s: Unable to write to parameters table (%s).",(p1),(p2)); \
	errAdd(error,"ic0dev",ic0devERR_WRITE_PARAMETERS,__FILE_LINE__,"%s,%s",(p1),(p2)); \
	}
#define ic0devErrWriteResetSetupCmd(p1,p2) \
	{ \
	lcctooLOG_0("ic0devERR_WRITE_RESET_SETUP_CMD: Device %s: Unable to write attribute 'resetSetupCmd' (value %d).",(p1),(p2)); \
	errAdd(error,"ic0dev",ic0devERR_WRITE_RESET_SETUP_CMD,__FILE_LINE__,"%s,%d",(p1),(p2)); \
	}
#define ic0devErrWriteStatus(p1) \
	{ \
	lcctooLOG_0("ic0devERR_WRITE_STATUS: Device %s: Unable to write to status vector.",(p1)); \
	errAdd(error,"ic0dev",ic0devERR_WRITE_STATUS,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0devErrWriteValues(p1,p2) \
	{ \
	lcctooLOG_0("ic0devERR_WRITE_VALUES: Device %s: Unable to write to values table (%s).",(p1),(p2)); \
	errAdd(error,"ic0dev",ic0devERR_WRITE_VALUES,__FILE_LINE__,"%s,%s",(p1),(p2)); \
	}
#define ic0devErrWrongCommand(p1,p2) \
	{ \
	lcctooLOG_0("ic0devERR_WRONG_COMMAND: Device %s: Unknown command %d.",(p1),(p2)); \
	errAdd(error,"ic0dev",ic0devERR_WRONG_COMMAND,__FILE_LINE__,"%s,%d",(p1),(p2)); \
	}
#define ic0devErrWrongIndex(p1,p2) \
	{ \
	lcctooLOG_0("ic0devERR_WRONG_INDEX: Device %s: Wrong index value %d.",(p1),(p2)); \
	errAdd(error,"ic0dev",ic0devERR_WRONG_INDEX,__FILE_LINE__,"%s,%d",(p1),(p2)); \
	}
#define ic0devErrWrongLogAction(p1,p2) \
	{ \
	lcctooLOG_0("ic0devERR_WRONG_LOG_ACTION: Device %s: Wrong log action %d.",(p1),(p2)); \
	errAdd(error,"ic0dev",ic0devERR_WRONG_LOG_ACTION,__FILE_LINE__,"%s,%d",(p1),(p2)); \
	}
#define ic0devErrWrongParameter(p1,p2) \
	{ \
	lcctooLOG_0("ic0devERR_WRONG_PARAMETER: Device %s: Unknown parameter %s.",(p1),(p2)); \
	errAdd(error,"ic0dev",ic0devERR_WRONG_PARAMETER,__FILE_LINE__,"%s,%s",(p1),(p2)); \
	}
#define ic0devErrWrongParameterOption(p1) \
	{ \
	lcctooLOG_0("ic0devERR_WRONG_PARAMETER_OPTION: Device %s: Second parameter option not supported.",(p1)); \
	errAdd(error,"ic0dev",ic0devERR_WRONG_PARAMETER_OPTION,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0devErrWrongValueCode(p1,p2) \
	{ \
	lcctooLOG_0("ic0devERR_WRONG_VALUE_CODE: Device %s: Wrong value name %s.",(p1),(p2)); \
	errAdd(error,"ic0dev",ic0devERR_WRONG_VALUE_CODE,__FILE_LINE__,"%s,%s",(p1),(p2)); \
	}
#define ic0devErrWrongValueIndex(p1,p2) \
	{ \
	lcctooLOG_0("ic0devERR_WRONG_VALUE_INDEX: Device %s: Wrong index value %d in values table.",(p1),(p2)); \
	errAdd(error,"ic0dev",ic0devERR_WRONG_VALUE_INDEX,__FILE_LINE__,"%s,%d",(p1),(p2)); \
	}
#define ic0devErrWrongValueLength(p1,p2) \
	{ \
	lcctooLOG_0("ic0devERR_WRONG_VALUE_LENGTH: Device %s: Value length %d out of range (1-10).",(p1),(p2)); \
	errAdd(error,"ic0dev",ic0devERR_WRONG_VALUE_LENGTH,__FILE_LINE__,"%s,%d",(p1),(p2)); \
	}
#define ic0devErrWrongValueNum(p1,p2) \
	{ \
	lcctooLOG_0("ic0devERR_WRONG_VALUE_NUM: Device %s: Wrong number of values %d.",(p1),(p2)); \
	errAdd(error,"ic0dev",ic0devERR_WRONG_VALUE_NUM,__FILE_LINE__,"%s,%d",(p1),(p2)); \
	}

/*
 * get object owner
 */
#define ic0devSoftGetOwner(obj) ((obj)->owner)


/*
 * attribute access functions
 */
#define ic0devSoftReadState(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0devSOFT_ATTR_STATE,(buf),(error))
#define ic0devSoftWriteState(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0devSOFT_ATTR_STATE,(void*) (buf),(error))
#define ic0devSoftReadSubstate(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0devSOFT_ATTR_SUBSTATE,(buf),(error))
#define ic0devSoftWriteSubstate(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0devSOFT_ATTR_SUBSTATE,(void*) (buf),(error))
#define ic0devSoftReadError(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0devSOFT_ATTR_ERROR,(buf),(error))
#define ic0devSoftWriteError(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0devSOFT_ATTR_ERROR,(void*) (buf),(error))
#define ic0devSoftReadInitialised(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0devSOFT_ATTR_INITIALISED,(buf),(error))
#define ic0devSoftWriteInitialised(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0devSOFT_ATTR_INITIALISED,(void*) (buf),(error))
#define ic0devSoftReadSimulation(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0devSOFT_ATTR_SIMULATION,(buf),(error))
#define ic0devSoftWriteSimulation(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0devSOFT_ATTR_SIMULATION,(void*) (buf),(error))
#define ic0devSoftReadDevice(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0devSOFT_ATTR_DEVICE,(buf),(error))
#define ic0devSoftWriteDevice(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0devSOFT_ATTR_DEVICE,(void*) (buf),(error))
#define ic0devSoftReadAvailable(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0devSOFT_ATTR_AVAILABLE,(buf),(error))
#define ic0devSoftWriteAvailable(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0devSOFT_ATTR_AVAILABLE,(void*) (buf),(error))
#define ic0devSoftReadEnabled(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0devSOFT_ATTR_ENABLED,(buf),(error))
#define ic0devSoftWriteEnabled(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0devSOFT_ATTR_ENABLED,(void*) (buf),(error))
#define ic0devSoftReadLocked(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0devSOFT_ATTR_LOCKED,(buf),(error))
#define ic0devSoftWriteLocked(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0devSOFT_ATTR_LOCKED,(void*) (buf),(error))
#define ic0devSoftReadHandset(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0devSOFT_ATTR_HANDSET,(buf),(error))
#define ic0devSoftWriteHandset(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0devSOFT_ATTR_HANDSET,(void*) (buf),(error))
#define ic0devSoftReadFixed(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0devSOFT_ATTR_FIXED,(buf),(error))
#define ic0devSoftWriteFixed(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0devSOFT_ATTR_FIXED,(void*) (buf),(error))
#define ic0devSoftReadFixPosSet(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0devSOFT_ATTR_FIX_POS_SET,(buf),(error))
#define ic0devSoftWriteFixPosSet(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0devSOFT_ATTR_FIX_POS_SET,(void*) (buf),(error))
#define ic0devSoftReadFixedPosition(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0devSOFT_ATTR_FIXED_POSITION,(buf),(error))
#define ic0devSoftWriteFixedPosition(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0devSOFT_ATTR_FIXED_POSITION,(void*) (buf),(error))
#define ic0devSoftReadFixedSimulation(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0devSOFT_ATTR_FIXED_SIMULATION,(buf),(error))
#define ic0devSoftWriteFixedSimulation(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0devSOFT_ATTR_FIXED_SIMULATION,(void*) (buf),(error))
#define ic0devSoftReadFixedLocked(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0devSOFT_ATTR_FIXED_LOCKED,(buf),(error))
#define ic0devSoftWriteFixedLocked(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0devSOFT_ATTR_FIXED_LOCKED,(void*) (buf),(error))
#define ic0devSoftReadPrefix(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0devSOFT_ATTR_PREFIX,(buf),(error))
#define ic0devSoftWritePrefix(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0devSOFT_ATTR_PREFIX,(void*) (buf),(error))
#define ic0devSoftReadParametersSize(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0devSOFT_ATTR_PARAMETERS_SIZE,(buf),(error))
#define ic0devSoftWriteParametersSize(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0devSOFT_ATTR_PARAMETERS_SIZE,(void*) (buf),(error))
#define ic0devSoftGetParametersSize(obj,num,error) \
	caiGetAttrInfo((obj)->attrs,ic0devSOFT_ATTR_PARAMETERS,NULL,NULL,(num),NULL, NULL,NULL,(error))
#define ic0devSoftReadParameters(obj,buf,firstRec,lastRec,firstFld,lastFld,error) \
	lcctooCaiRWTable((obj)->attrs,0,ic0devSOFT_ATTR_PARAMETERS,(buf),(firstRec),(lastRec),(firstFld),(lastFld),(error))
#define ic0devSoftWriteParameters(obj,buf,firstRec,lastRec,firstFld,lastFld,error) \
	lcctooCaiRWTable((obj)->attrs,1,ic0devSOFT_ATTR_PARAMETERS,(void*) (buf),(firstRec),(lastRec),(firstFld),(lastFld),(error))
#define ic0devSoftGetStatusSize(obj,num,error) \
	caiGetAttrInfo((obj)->attrs,ic0devSOFT_ATTR_STATUS,NULL,NULL,(num),NULL, NULL,NULL,(error))
#define ic0devSoftReadStatus(obj,buf,firstElt,lastElt,error) \
	caiRWVector((obj)->attrs,0,ic0devSOFT_ATTR_STATUS,(buf),(firstElt),(lastElt),(error))
#define ic0devSoftWriteStatus(obj,buf,firstElt,lastElt,error) \
	caiRWVector((obj)->attrs,1,ic0devSOFT_ATTR_STATUS,(void*) (buf),(firstElt),(lastElt),(error))
#define ic0devSoftGetStatusIndexSize(obj,num,error) \
	caiGetAttrInfo((obj)->attrs,ic0devSOFT_ATTR_STATUS_INDEX,NULL,NULL,(num),NULL, NULL,NULL,(error))
#define ic0devSoftReadStatusIndex(obj,buf,firstElt,lastElt,error) \
	caiRWVector((obj)->attrs,0,ic0devSOFT_ATTR_STATUS_INDEX,(buf),(firstElt),(lastElt),(error))
#define ic0devSoftWriteStatusIndex(obj,buf,firstElt,lastElt,error) \
	caiRWVector((obj)->attrs,1,ic0devSOFT_ATTR_STATUS_INDEX,(void*) (buf),(firstElt),(lastElt),(error))
#define ic0devSoftReadValuesSize(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0devSOFT_ATTR_VALUES_SIZE,(buf),(error))
#define ic0devSoftWriteValuesSize(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0devSOFT_ATTR_VALUES_SIZE,(void*) (buf),(error))
#define ic0devSoftGetValuesSize(obj,num,error) \
	caiGetAttrInfo((obj)->attrs,ic0devSOFT_ATTR_VALUES,NULL,NULL,(num),NULL, NULL,NULL,(error))
#define ic0devSoftReadValues(obj,buf,firstRec,lastRec,firstFld,lastFld,error) \
	lcctooCaiRWTable((obj)->attrs,0,ic0devSOFT_ATTR_VALUES,(buf),(firstRec),(lastRec),(firstFld),(lastFld),(error))
#define ic0devSoftWriteValues(obj,buf,firstRec,lastRec,firstFld,lastFld,error) \
	lcctooCaiRWTable((obj)->attrs,1,ic0devSOFT_ATTR_VALUES,(void*) (buf),(firstRec),(lastRec),(firstFld),(lastFld),(error))
#define ic0devSoftReadInitRestriction(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0devSOFT_ATTR_INIT_RESTRICTION,(buf),(error))
#define ic0devSoftWriteInitRestriction(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0devSOFT_ATTR_INIT_RESTRICTION,(void*) (buf),(error))
#define ic0devSoftReadMoveRestriction(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0devSOFT_ATTR_MOVE_RESTRICTION,(buf),(error))
#define ic0devSoftWriteMoveRestriction(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0devSOFT_ATTR_MOVE_RESTRICTION,(void*) (buf),(error))
#define ic0devSoftReadStopTimeout(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0devSOFT_ATTR_STOP_TIMEOUT,(buf),(error))
#define ic0devSoftWriteStopTimeout(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0devSOFT_ATTR_STOP_TIMEOUT,(void*) (buf),(error))
#define ic0devSoftReadSetValFct(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0devSOFT_ATTR_SET_VAL_FCT,(buf),(error))
#define ic0devSoftWriteSetValFct(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0devSOFT_ATTR_SET_VAL_FCT,(void*) (buf),(error))
#define ic0devSoftGetHelpTextSize(obj,num,error) \
	caiGetAttrInfo((obj)->attrs,ic0devSOFT_ATTR_HELP_TEXT,NULL,NULL,(num),NULL, NULL,NULL,(error))
#define ic0devSoftReadHelpText(obj,buf,firstElt,lastElt,error) \
	caiRWVector((obj)->attrs,0,ic0devSOFT_ATTR_HELP_TEXT,(buf),(firstElt),(lastElt),(error))
#define ic0devSoftWriteHelpText(obj,buf,firstElt,lastElt,error) \
	caiRWVector((obj)->attrs,1,ic0devSOFT_ATTR_HELP_TEXT,(void*) (buf),(firstElt),(lastElt),(error))
#define ic0devSoftReadParamStep(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0devSOFT_ATTR_PARAM_STEP,(buf),(error))
#define ic0devSoftWriteParamStep(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0devSOFT_ATTR_PARAM_STEP,(void*) (buf),(error))
#define ic0devSoftReadActionCommand(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0devSOFT_ATTR_ACTION_COMMAND,(buf),(error))
#define ic0devSoftWriteActionCommand(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0devSOFT_ATTR_ACTION_COMMAND,(void*) (buf),(error))
#define ic0devSoftReadActionStopReq(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0devSOFT_ATTR_ACTION_STOP_REQ,(buf),(error))
#define ic0devSoftWriteActionStopReq(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0devSOFT_ATTR_ACTION_STOP_REQ,(void*) (buf),(error))
#define ic0devSoftReadActionNoMove(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0devSOFT_ATTR_ACTION_NO_MOVE,(buf),(error))
#define ic0devSoftWriteActionNoMove(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0devSOFT_ATTR_ACTION_NO_MOVE,(void*) (buf),(error))
#define ic0devSoftReadActionCheck(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0devSOFT_ATTR_ACTION_CHECK,(buf),(error))
#define ic0devSoftWriteActionCheck(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0devSOFT_ATTR_ACTION_CHECK,(void*) (buf),(error))
#define ic0devSoftReadResetSetupCmd(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0devSOFT_ATTR_RESET_SETUP_CMD,(buf),(error))
#define ic0devSoftWriteResetSetupCmd(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0devSOFT_ATTR_RESET_SETUP_CMD,(void*) (buf),(error))
#define ic0devSoftGetAuto(obj,attrPtr,error) \
	SUCCESS; \
	memcpy((attrPtr), &(obj)->objs[ic0devSOFT_AUTOMATA], sizeof(egenOBJ)); \
	(attrPtr)->ldata = (obj)->ldata;


/*
 * class functions
 */
#define ic0devSoftAvail(obj,devName,error) \
	lccdevCmdAvail((obj),(devName),(error))
#define ic0devSoftUnavail(obj,devName,error) \
	lccdevCmdUnavail((obj),(devName),(error))
#define ic0devSoftDisable(obj,devName,access,error) \
	lccdevCmdDisable((obj),(devName),(access),(error))
#define ic0devSoftEnable(obj,devName,access,error) \
	lccdevCmdEnable((obj),(devName),(access),(error))
#define ic0devSoftLock(obj,devName,error) \
	lccdevCmdLock((obj),(devName),(error))
#define ic0devSoftUnlock(obj,devName,error) \
	lccdevCmdUnlock((obj),(devName),(error))
#define ic0devSoftHandset(obj,devName,error) \
	lccdevCmdHandset((obj),(devName),(error))
#define ic0devSoftHsetOff(obj,devName,error) \
	lccdevCmdHsetOff((obj),(devName),(error))
#define ic0devSoftFixPos(obj,devName,position,positionNum,reset,error) \
	lccdevCmdFixPos((obj),(devName),(position),(positionNum),(reset),(error))
#define ic0devSoftCheck(obj,devName,status,error) \
	lccdevCmdCheck((obj),(devName),(status),(error))
#define ic0devSoftWait(obj,devName,timeout,error) \
	lccdevCmdWait((obj),(devName),(timeout),(error))
#define ic0devSoftUsrSetMode(obj,devName,cmd,available,enabled,simulation,handset,locked,error) \
	lccdevCmdUsrSetMode((obj),(devName),(cmd),(available),(enabled),(simulation),(handset),(locked),(error))
#define ic0devSoftUsrStatusCode(obj,devName,text,flags,code,error) \
	lccdevCmdUsrStatusCode((obj),(devName),(text),(flags),(code),(error))
#define ic0devSoftUsrStatusValue(obj,devName,code,value,error) \
	lccdevCmdUsrStatusValue((obj),(devName),(code),(value),(error))
#define ic0devSoftUsrStatusLast(obj,devName,last,error) \
	lccdevCmdUsrStatusLast((obj),(devName),(last),(error))
#define ic0devSoftUsrSimulat(obj,devName,error) \
	lccdevCmdUsrSimulat((obj),(devName),(error))
#define ic0devSoftUsrStopSim(obj,devName,error) \
	lccdevCmdUsrStopSim((obj),(devName),(error))
#define ic0devSoftUsrLoaded2Standby(obj,devName,error) \
	lccdevCmdUsrLoaded2Standby((obj),(devName),(error))
#define ic0devSoftUsrStandby2Online(obj,devName,error) \
	lccdevCmdUsrStandby2Online((obj),(devName),(error))
#define ic0devSoftStandby(obj,devName,error) \
	lccdevStdStandby((obj),(devName),(error))
#define ic0devSoftOnline(obj,devName,error) \
	lccdevStdOnline((obj),(devName),(error))
#define ic0devSoftOff(obj,devName,error) \
	lccdevStdOff((obj),(devName),(error))
#define ic0devSoftExit(obj,devName,error) \
	lccdevStdExit((obj),(devName),(error))
#define ic0devSoftState(obj,devName,state,error) \
	lccdevStdState((obj),(devName),(state),(error))
#define ic0devSoftSimulat(obj,devName,error) \
	lccdevStdSimulat((obj),(devName),(error))
#define ic0devSoftStopSim(obj,devName,error) \
	lccdevStdStopSim((obj),(devName),(error))
#define ic0devSoftInit(obj,devName,error) \
	lccdevStdInit((obj),(devName),(error))
#define ic0devSoftStop(obj,devName,error) \
	lccdevStdStop((obj),(devName),(error))
#define ic0devSoftTest(obj,devName,error) \
	lccdevStdTest((obj),(devName),(error))
#define ic0devSoftSelftst(obj,devName,error) \
	lccdevStdSelftst((obj),(devName),(error))
#define ic0devSoftAutoTbl(obj,devName,table,text,error) \
	lccdevStdAutoTbl((obj),(devName),(table),(text),(error))
#define ic0devSoftAutoRst(obj,devName,error) \
	lccdevStdAutoRst((obj),(devName),(error))
#define ic0devSoftLoaded2Stby(obj,devName,error) \
	lccdevStdLoaded2Stby((obj),(devName),(error))
#define ic0devSoftOnline2Stby(obj,devName,error) \
	lccdevStdOnline2Stby((obj),(devName),(error))
#define ic0devSoftExit1(obj,devName,error) \
	lccdevStdExit1((obj),(devName),(error))
#define ic0devSoftCheckDeviceName(obj,devName,error) \
	lccdevStdCheckDeviceName((obj),(devName),(error))
#define ic0devSoftBreak(obj,error) \
	lccdevStdBreak((obj),(error))
#define ic0devSoftUsrOnline2Standby(obj,devName,error) \
	lccdevStdUsrOnline2Standby((obj),(devName),(error))
#define ic0devSoftUsrStandby2Loaded(obj,devName,error) \
	lccdevStdUsrStandby2Loaded((obj),(devName),(error))
#define ic0devSoftUsrTest(obj,devName,error) \
	lccdevStdUsrTest((obj),(devName),(error))
#define ic0devSoftUsrSelfTest(obj,devName,error) \
	lccdevStdUsrSelfTest((obj),(devName),(error))
#define ic0devSoftUsrError(obj,devName,error) \
	lccdevStdUsrError((obj),(devName),(error))

ccsCOMPL_STAT ic0devSoftSetup(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    const char*	function[],	/* max. vltBYTES32[999] */
    IN    vltINT16	functionNum,
    IN    vltLOGICAL	noMove,
    IN    vltLOGICAL	check,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devSoftGetVal(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    const char*	name[],	/* max. vltBYTES32[2] */
    IN    vltINT16	nameNum,
    OUT   char**	status,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devSoftSetVal(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    const char*	name[],	/* max. vltBYTES32[2] */
    IN    vltINT16	nameNum,
    IN    const char*	value[],	/* max. vltBYTES32[10] */
    IN    vltINT16	valueNum,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devSoftCfgElem(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltINT32	position,
    IN    const char*	id,
    IN    const char*	values[],	/* max. vltBYTES16[10] */
    IN    vltINT16	valuesNum,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devSoftLogConf(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltLOGICAL	allElements,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devSoftGetConf(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltLOGICAL	allElements,
    OUT   char**	text,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devSoftStatus(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    const char*	function[],	/* max. vltBYTES32[999] */
    IN    vltINT16	functionNum,
    IN    vltLOGICAL	flag,
    IN    vltLOGICAL	header,
    IN    vltLOGICAL	conflog,
    IN    vltLOGICAL	opslog,
    IN    vltLOGICAL	condlog,
    OUT   char**	status,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devSoftMove(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    const char*	position[],	/* max. vltBYTES32[999] */
    IN    vltINT16	positionNum,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devSoftMoveRel(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    const char*	position[],	/* max. vltBYTES32[999] */
    IN    vltINT16	positionNum,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devSoftSet(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    const char*	position[],	/* max. vltBYTES32[999] */
    IN    vltINT16	positionNum,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devSoftResetParameters(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltINT32	cmd,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devSoftParseParameters(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltINT32	cmd,
    IN    const char*	params[],	/* max. vltBYTES32[999] */
    IN    vltINT16	paramsNum,
    IN    vltLOGICAL	noMove,
    IN    vltLOGICAL	check,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devSoftCompareParameters(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltINT32	cmd,
    OUT   vltLOGICAL*	equal,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devSoftCopyParameters(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devSoftExecParameters(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devSoftUpdateParameters(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltLOGICAL	cache,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devSoftGetParamSetValue(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltINT32	index,
    OUT   lcctooVALUE*	value,
    OUT   vltINT32*	setCode,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devSoftGetParamStatus(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltINT32	index,
    IN    vltINT32	flags,
    OUT   lcctooVALUE*	status,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devSoftSetParam(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltINT32	index,
    IN    vltINT32	cmd,
    IN    lcctooVALUE*	value,
    IN    vltINT32	step,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devSoftSetParamStep(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltINT32	index,
    IN    vltINT32	cmd,
    IN    vltINT32	step,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devSoftUsrExecAction(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltINT32	index,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devSoftUsrSetParameter(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltINT32	cmd,
    IN    vltINT32	param1,
    IN    vltINT32	param1SetCode,
    IN    vltINT32	param2,
    IN    vltINT32	param2SetCode,
    INOUT lcctooVALUE*	value,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devSoftGetValueCode(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    const char*	name,
    OUT   vltINT32*	code,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devSoftGetValue(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltINT32	code,
    IN    vltINT32	index,
    OUT   lcctooVALUE	value[],	/* max. lcctooVALUE[10] */
    OUT   vltINT16*	valueNum,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devSoftUsrGetValue(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    const ic0devSOFT_VALUE	valuesTable[],	/* max. ic0devSOFT_VALUE[99] */
    IN    vltINT16	valuesTableNum,
    IN    vltINT32	code,
    IN    vltINT32	index,
    OUT   lcctooVALUE	value[],	/* max. lcctooVALUE[10] */
    OUT   vltINT16*	valueNum,
    OUT   vltLOGICAL*	done,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devSoftSetValue(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltINT32	code,
    IN    vltINT32	index,
    INOUT lcctooVALUE	value[],	/* max. lcctooVALUE[10] */
    IN    vltINT16	valueNum,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devSoftUsrSetValue(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    INOUT ic0devSOFT_VALUE	valuesTable[],	/* max. ic0devSOFT_VALUE[99] */
    INOUT vltINT16*	valuesTableNum,
    IN    vltINT32	code,
    IN    vltINT32	index,
    IN    const lcctooVALUE	value[],	/* max. lcctooVALUE[10] */
    IN    vltINT16	valueNum,
    OUT   vltLOGICAL*	done,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devSoftGetArg(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltINT32	code,
    IN    vltINT32	index,
    OUT   lcctooVALUE*	value,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devSoftMonitor(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devSoftUsrMonitor(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltINT32	state,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devSoftLogAction(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltINT32	action,
    IN    const char*	comment,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devSoftLogComment(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    const char*	comment,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devSoftLogParameter(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    const char*	parameter,
    IN    vltINT32	index,
    IN    const char*	value,
    IN    const char*	comment,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devSoftLogRecovery(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    const char*	comment,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devSoftLogTblParam(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltINT32	paramIndex,
    IN    vltINT32	flags,
    IN    const char*	comment,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devSoftLogUnforseen(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    const char*	comment,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devSoftUsrInit(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devSoftUsrStop(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltLOGICAL	req,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devSoftInitObj(
    INOUT egenOBJ*	obj,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devSoftExitObj(
    INOUT egenOBJ*	obj,
    OUT   ccsERROR*	error);


/*
 * virtual functions
 */
#define ic0devSoftVStandby(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_STANDBY)((obj)->fcts[ic0devSOFT_FCT_STANDBY]))) \
	 ((obj),(devName),(error))
#define ic0devSoftVOnline(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_ONLINE)((obj)->fcts[ic0devSOFT_FCT_ONLINE]))) \
	 ((obj),(devName),(error))
#define ic0devSoftVOff(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_OFF)((obj)->fcts[ic0devSOFT_FCT_OFF]))) \
	 ((obj),(devName),(error))
#define ic0devSoftVExit(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_EXIT)((obj)->fcts[ic0devSOFT_FCT_EXIT]))) \
	 ((obj),(devName),(error))
#define ic0devSoftVState(obj,devName,state,error) \
	(*((lccdevSTD_FCTPTR_STATE)((obj)->fcts[ic0devSOFT_FCT_STATE]))) \
	 ((obj),(devName),(state),(error))
#define ic0devSoftVSimulat(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_SIMULAT)((obj)->fcts[ic0devSOFT_FCT_SIMULAT]))) \
	 ((obj),(devName),(error))
#define ic0devSoftVStopSim(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_STOP_SIM)((obj)->fcts[ic0devSOFT_FCT_STOP_SIM]))) \
	 ((obj),(devName),(error))
#define ic0devSoftVStatus(obj,devName,function,functionNum,flag,header,conflog,opslog,condlog,status,error) \
	(*((ic0devSOFT_FCTPTR_STATUS)((obj)->fcts[ic0devSOFT_FCT_STATUS]))) \
	 ((obj),(devName),(function),(functionNum),(flag),(header),(conflog),(opslog),(condlog),(status),(error))
#define ic0devSoftVInit(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_INIT)((obj)->fcts[ic0devSOFT_FCT_INIT]))) \
	 ((obj),(devName),(error))
#define ic0devSoftVStop(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_STOP)((obj)->fcts[ic0devSOFT_FCT_STOP]))) \
	 ((obj),(devName),(error))
#define ic0devSoftVTest(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_TEST)((obj)->fcts[ic0devSOFT_FCT_TEST]))) \
	 ((obj),(devName),(error))
#define ic0devSoftVSelftst(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_SELFTST)((obj)->fcts[ic0devSOFT_FCT_SELFTST]))) \
	 ((obj),(devName),(error))
#define ic0devSoftVAutoTbl(obj,devName,table,text,error) \
	(*((lccdevSTD_FCTPTR_AUTO_TBL)((obj)->fcts[ic0devSOFT_FCT_AUTO_TBL]))) \
	 ((obj),(devName),(table),(text),(error))
#define ic0devSoftVAutoRst(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_AUTO_RST)((obj)->fcts[ic0devSOFT_FCT_AUTO_RST]))) \
	 ((obj),(devName),(error))
#define ic0devSoftVInitObj(obj,error) \
	(*((ic0devSOFT_FCTPTR_INIT_OBJ)((obj)->fcts[ic0devSOFT_FCT_INIT_OBJ]))) \
	 ((obj),(error))
#define ic0devSoftVExitObj(obj,error) \
	(*((ic0devSOFT_FCTPTR_EXIT_OBJ)((obj)->fcts[ic0devSOFT_FCT_EXIT_OBJ]))) \
	 ((obj),(error))
#define ic0devSoftVLoaded2Stby(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_LOADED2STBY)((obj)->fcts[ic0devSOFT_FCT_LOADED2STBY]))) \
	 ((obj),(devName),(error))
#define ic0devSoftVOnline2Stby(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_ONLINE2STBY)((obj)->fcts[ic0devSOFT_FCT_ONLINE2STBY]))) \
	 ((obj),(devName),(error))
#define ic0devSoftVExit1(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_EXIT1)((obj)->fcts[ic0devSOFT_FCT_EXIT1]))) \
	 ((obj),(devName),(error))
#define ic0devSoftVCheckDeviceName(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_CHECK_DEVICE_NAME)((obj)->fcts[ic0devSOFT_FCT_CHECK_DEVICE_NAME]))) \
	 ((obj),(devName),(error))
#define ic0devSoftVBreak(obj,error) \
	(*((lccdevSTD_FCTPTR_BREAK)((obj)->fcts[ic0devSOFT_FCT_BREAK]))) \
	 ((obj),(error))
#define ic0devSoftVUsrInit(obj,devName,error) \
	(*((ic0devSOFT_FCTPTR_USR_INIT)((obj)->fcts[ic0devSOFT_FCT_USR_INIT]))) \
	 ((obj),(devName),(error))
#define ic0devSoftVUsrLoaded2Standby(obj,devName,error) \
	(*((lccdevCMD_FCTPTR_USR_LOADED2STANDBY)((obj)->fcts[ic0devSOFT_FCT_USR_LOADED2STANDBY]))) \
	 ((obj),(devName),(error))
#define ic0devSoftVUsrStandby2Online(obj,devName,error) \
	(*((lccdevCMD_FCTPTR_USR_STANDBY2ONLINE)((obj)->fcts[ic0devSOFT_FCT_USR_STANDBY2ONLINE]))) \
	 ((obj),(devName),(error))
#define ic0devSoftVUsrOnline2Standby(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_USR_ONLINE2STANDBY)((obj)->fcts[ic0devSOFT_FCT_USR_ONLINE2STANDBY]))) \
	 ((obj),(devName),(error))
#define ic0devSoftVUsrStandby2Loaded(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_USR_STANDBY2LOADED)((obj)->fcts[ic0devSOFT_FCT_USR_STANDBY2LOADED]))) \
	 ((obj),(devName),(error))
#define ic0devSoftVUsrStop(obj,devName,req,error) \
	(*((ic0devSOFT_FCTPTR_USR_STOP)((obj)->fcts[ic0devSOFT_FCT_USR_STOP]))) \
	 ((obj),(devName),(req),(error))
#define ic0devSoftVUsrSimulat(obj,devName,error) \
	(*((lccdevCMD_FCTPTR_USR_SIMULAT)((obj)->fcts[ic0devSOFT_FCT_USR_SIMULAT]))) \
	 ((obj),(devName),(error))
#define ic0devSoftVUsrStopSim(obj,devName,error) \
	(*((lccdevCMD_FCTPTR_USR_STOP_SIM)((obj)->fcts[ic0devSOFT_FCT_USR_STOP_SIM]))) \
	 ((obj),(devName),(error))
#define ic0devSoftVUsrStatusCode(obj,devName,text,flags,code,error) \
	(*((lccdevCMD_FCTPTR_USR_STATUS_CODE)((obj)->fcts[ic0devSOFT_FCT_USR_STATUS_CODE]))) \
	 ((obj),(devName),(text),(flags),(code),(error))
#define ic0devSoftVUsrStatusLast(obj,devName,last,error) \
	(*((lccdevCMD_FCTPTR_USR_STATUS_LAST)((obj)->fcts[ic0devSOFT_FCT_USR_STATUS_LAST]))) \
	 ((obj),(devName),(last),(error))
#define ic0devSoftVUsrStatusValue(obj,devName,code,value,error) \
	(*((lccdevCMD_FCTPTR_USR_STATUS_VALUE)((obj)->fcts[ic0devSOFT_FCT_USR_STATUS_VALUE]))) \
	 ((obj),(devName),(code),(value),(error))
#define ic0devSoftVUsrTest(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_USR_TEST)((obj)->fcts[ic0devSOFT_FCT_USR_TEST]))) \
	 ((obj),(devName),(error))
#define ic0devSoftVUsrSelfTest(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_USR_SELF_TEST)((obj)->fcts[ic0devSOFT_FCT_USR_SELF_TEST]))) \
	 ((obj),(devName),(error))
#define ic0devSoftVUsrError(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_USR_ERROR)((obj)->fcts[ic0devSOFT_FCT_USR_ERROR]))) \
	 ((obj),(devName),(error))
#define ic0devSoftVAvail(obj,devName,error) \
	(*((lccdevCMD_FCTPTR_AVAIL)((obj)->fcts[ic0devSOFT_FCT_AVAIL]))) \
	 ((obj),(devName),(error))
#define ic0devSoftVUnavail(obj,devName,error) \
	(*((lccdevCMD_FCTPTR_UNAVAIL)((obj)->fcts[ic0devSOFT_FCT_UNAVAIL]))) \
	 ((obj),(devName),(error))
#define ic0devSoftVDisable(obj,devName,access,error) \
	(*((lccdevCMD_FCTPTR_DISABLE)((obj)->fcts[ic0devSOFT_FCT_DISABLE]))) \
	 ((obj),(devName),(access),(error))
#define ic0devSoftVEnable(obj,devName,access,error) \
	(*((lccdevCMD_FCTPTR_ENABLE)((obj)->fcts[ic0devSOFT_FCT_ENABLE]))) \
	 ((obj),(devName),(access),(error))
#define ic0devSoftVLock(obj,devName,error) \
	(*((lccdevCMD_FCTPTR_LOCK)((obj)->fcts[ic0devSOFT_FCT_LOCK]))) \
	 ((obj),(devName),(error))
#define ic0devSoftVUnlock(obj,devName,error) \
	(*((lccdevCMD_FCTPTR_UNLOCK)((obj)->fcts[ic0devSOFT_FCT_UNLOCK]))) \
	 ((obj),(devName),(error))
#define ic0devSoftVHandset(obj,devName,error) \
	(*((lccdevCMD_FCTPTR_HANDSET)((obj)->fcts[ic0devSOFT_FCT_HANDSET]))) \
	 ((obj),(devName),(error))
#define ic0devSoftVHsetOff(obj,devName,error) \
	(*((lccdevCMD_FCTPTR_HSET_OFF)((obj)->fcts[ic0devSOFT_FCT_HSET_OFF]))) \
	 ((obj),(devName),(error))
#define ic0devSoftVFixPos(obj,devName,position,positionNum,reset,error) \
	(*((lccdevCMD_FCTPTR_FIX_POS)((obj)->fcts[ic0devSOFT_FCT_FIX_POS]))) \
	 ((obj),(devName),(position),(positionNum),(reset),(error))
#define ic0devSoftVMove(obj,devName,position,positionNum,error) \
	(*((ic0devSOFT_FCTPTR_MOVE)((obj)->fcts[ic0devSOFT_FCT_MOVE]))) \
	 ((obj),(devName),(position),(positionNum),(error))
#define ic0devSoftVMoveRel(obj,devName,position,positionNum,error) \
	(*((ic0devSOFT_FCTPTR_MOVE_REL)((obj)->fcts[ic0devSOFT_FCT_MOVE_REL]))) \
	 ((obj),(devName),(position),(positionNum),(error))
#define ic0devSoftVSet(obj,devName,position,positionNum,error) \
	(*((ic0devSOFT_FCTPTR_SET)((obj)->fcts[ic0devSOFT_FCT_SET]))) \
	 ((obj),(devName),(position),(positionNum),(error))
#define ic0devSoftVCheck(obj,devName,status,error) \
	(*((lccdevCMD_FCTPTR_CHECK)((obj)->fcts[ic0devSOFT_FCT_CHECK]))) \
	 ((obj),(devName),(status),(error))
#define ic0devSoftVWait(obj,devName,timeout,error) \
	(*((lccdevCMD_FCTPTR_WAIT)((obj)->fcts[ic0devSOFT_FCT_WAIT]))) \
	 ((obj),(devName),(timeout),(error))
#define ic0devSoftVUsrSetMode(obj,devName,cmd,available,enabled,simulation,handset,locked,error) \
	(*((lccdevCMD_FCTPTR_USR_SET_MODE)((obj)->fcts[ic0devSOFT_FCT_USR_SET_MODE]))) \
	 ((obj),(devName),(cmd),(available),(enabled),(simulation),(handset),(locked),(error))
#define ic0devSoftVSetup(obj,devName,function,functionNum,noMove,check,error) \
	(*((ic0devSOFT_FCTPTR_SETUP)((obj)->fcts[ic0devSOFT_FCT_SETUP]))) \
	 ((obj),(devName),(function),(functionNum),(noMove),(check),(error))
#define ic0devSoftVGetVal(obj,devName,name,nameNum,status,error) \
	(*((ic0devSOFT_FCTPTR_GET_VAL)((obj)->fcts[ic0devSOFT_FCT_GET_VAL]))) \
	 ((obj),(devName),(name),(nameNum),(status),(error))
#define ic0devSoftVSetVal(obj,devName,name,nameNum,value,valueNum,error) \
	(*((ic0devSOFT_FCTPTR_SET_VAL)((obj)->fcts[ic0devSOFT_FCT_SET_VAL]))) \
	 ((obj),(devName),(name),(nameNum),(value),(valueNum),(error))
#define ic0devSoftVCfgElem(obj,devName,position,id,values,valuesNum,error) \
	(*((ic0devSOFT_FCTPTR_CFG_ELEM)((obj)->fcts[ic0devSOFT_FCT_CFG_ELEM]))) \
	 ((obj),(devName),(position),(id),(values),(valuesNum),(error))
#define ic0devSoftVLogConf(obj,devName,allElements,error) \
	(*((ic0devSOFT_FCTPTR_LOG_CONF)((obj)->fcts[ic0devSOFT_FCT_LOG_CONF]))) \
	 ((obj),(devName),(allElements),(error))
#define ic0devSoftVGetConf(obj,devName,allElements,text,error) \
	(*((ic0devSOFT_FCTPTR_GET_CONF)((obj)->fcts[ic0devSOFT_FCT_GET_CONF]))) \
	 ((obj),(devName),(allElements),(text),(error))
#define ic0devSoftVResetParameters(obj,devName,cmd,error) \
	(*((ic0devSOFT_FCTPTR_RESET_PARAMETERS)((obj)->fcts[ic0devSOFT_FCT_RESET_PARAMETERS]))) \
	 ((obj),(devName),(cmd),(error))
#define ic0devSoftVParseParameters(obj,devName,cmd,params,paramsNum,noMove,check,error) \
	(*((ic0devSOFT_FCTPTR_PARSE_PARAMETERS)((obj)->fcts[ic0devSOFT_FCT_PARSE_PARAMETERS]))) \
	 ((obj),(devName),(cmd),(params),(paramsNum),(noMove),(check),(error))
#define ic0devSoftVCompareParameters(obj,devName,cmd,equal,error) \
	(*((ic0devSOFT_FCTPTR_COMPARE_PARAMETERS)((obj)->fcts[ic0devSOFT_FCT_COMPARE_PARAMETERS]))) \
	 ((obj),(devName),(cmd),(equal),(error))
#define ic0devSoftVCopyParameters(obj,devName,error) \
	(*((ic0devSOFT_FCTPTR_COPY_PARAMETERS)((obj)->fcts[ic0devSOFT_FCT_COPY_PARAMETERS]))) \
	 ((obj),(devName),(error))
#define ic0devSoftVExecParameters(obj,devName,error) \
	(*((ic0devSOFT_FCTPTR_EXEC_PARAMETERS)((obj)->fcts[ic0devSOFT_FCT_EXEC_PARAMETERS]))) \
	 ((obj),(devName),(error))
#define ic0devSoftVUpdateParameters(obj,devName,cache,error) \
	(*((ic0devSOFT_FCTPTR_UPDATE_PARAMETERS)((obj)->fcts[ic0devSOFT_FCT_UPDATE_PARAMETERS]))) \
	 ((obj),(devName),(cache),(error))
#define ic0devSoftVGetParamSetValue(obj,devName,index,value,setCode,error) \
	(*((ic0devSOFT_FCTPTR_GET_PARAM_SET_VALUE)((obj)->fcts[ic0devSOFT_FCT_GET_PARAM_SET_VALUE]))) \
	 ((obj),(devName),(index),(value),(setCode),(error))
#define ic0devSoftVGetParamStatus(obj,devName,index,flags,status,error) \
	(*((ic0devSOFT_FCTPTR_GET_PARAM_STATUS)((obj)->fcts[ic0devSOFT_FCT_GET_PARAM_STATUS]))) \
	 ((obj),(devName),(index),(flags),(status),(error))
#define ic0devSoftVSetParam(obj,devName,index,cmd,value,step,error) \
	(*((ic0devSOFT_FCTPTR_SET_PARAM)((obj)->fcts[ic0devSOFT_FCT_SET_PARAM]))) \
	 ((obj),(devName),(index),(cmd),(value),(step),(error))
#define ic0devSoftVSetParamStep(obj,devName,index,cmd,step,error) \
	(*((ic0devSOFT_FCTPTR_SET_PARAM_STEP)((obj)->fcts[ic0devSOFT_FCT_SET_PARAM_STEP]))) \
	 ((obj),(devName),(index),(cmd),(step),(error))
#define ic0devSoftVUsrExecAction(obj,devName,index,error) \
	(*((ic0devSOFT_FCTPTR_USR_EXEC_ACTION)((obj)->fcts[ic0devSOFT_FCT_USR_EXEC_ACTION]))) \
	 ((obj),(devName),(index),(error))
#define ic0devSoftVUsrSetParameter(obj,devName,cmd,param1,param1SetCode,param2,param2SetCode,value,error) \
	(*((ic0devSOFT_FCTPTR_USR_SET_PARAMETER)((obj)->fcts[ic0devSOFT_FCT_USR_SET_PARAMETER]))) \
	 ((obj),(devName),(cmd),(param1),(param1SetCode),(param2),(param2SetCode),(value),(error))
#define ic0devSoftVGetValueCode(obj,devName,name,code,error) \
	(*((ic0devSOFT_FCTPTR_GET_VALUE_CODE)((obj)->fcts[ic0devSOFT_FCT_GET_VALUE_CODE]))) \
	 ((obj),(devName),(name),(code),(error))
#define ic0devSoftVGetValue(obj,devName,code,index,value,valueNum,error) \
	(*((ic0devSOFT_FCTPTR_GET_VALUE)((obj)->fcts[ic0devSOFT_FCT_GET_VALUE]))) \
	 ((obj),(devName),(code),(index),(value),(valueNum),(error))
#define ic0devSoftVUsrGetValue(obj,devName,valuesTable,valuesTableNum,code,index,value,valueNum,done,error) \
	(*((ic0devSOFT_FCTPTR_USR_GET_VALUE)((obj)->fcts[ic0devSOFT_FCT_USR_GET_VALUE]))) \
	 ((obj),(devName),(valuesTable),(valuesTableNum),(code),(index),(value),(valueNum),(done),(error))
#define ic0devSoftVSetValue(obj,devName,code,index,value,valueNum,error) \
	(*((ic0devSOFT_FCTPTR_SET_VALUE)((obj)->fcts[ic0devSOFT_FCT_SET_VALUE]))) \
	 ((obj),(devName),(code),(index),(value),(valueNum),(error))
#define ic0devSoftVUsrSetValue(obj,devName,valuesTable,valuesTableNum,code,index,value,valueNum,done,error) \
	(*((ic0devSOFT_FCTPTR_USR_SET_VALUE)((obj)->fcts[ic0devSOFT_FCT_USR_SET_VALUE]))) \
	 ((obj),(devName),(valuesTable),(valuesTableNum),(code),(index),(value),(valueNum),(done),(error))
#define ic0devSoftVGetArg(obj,devName,code,index,value,error) \
	(*((ic0devSOFT_FCTPTR_GET_ARG)((obj)->fcts[ic0devSOFT_FCT_GET_ARG]))) \
	 ((obj),(devName),(code),(index),(value),(error))
#define ic0devSoftVMonitor(obj,devName,error) \
	(*((ic0devSOFT_FCTPTR_MONITOR)((obj)->fcts[ic0devSOFT_FCT_MONITOR]))) \
	 ((obj),(devName),(error))
#define ic0devSoftVUsrMonitor(obj,devName,state,error) \
	(*((ic0devSOFT_FCTPTR_USR_MONITOR)((obj)->fcts[ic0devSOFT_FCT_USR_MONITOR]))) \
	 ((obj),(devName),(state),(error))
#define ic0devSoftVLogAction(obj,devName,action,comment,error) \
	(*((ic0devSOFT_FCTPTR_LOG_ACTION)((obj)->fcts[ic0devSOFT_FCT_LOG_ACTION]))) \
	 ((obj),(devName),(action),(comment),(error))
#define ic0devSoftVLogComment(obj,devName,comment,error) \
	(*((ic0devSOFT_FCTPTR_LOG_COMMENT)((obj)->fcts[ic0devSOFT_FCT_LOG_COMMENT]))) \
	 ((obj),(devName),(comment),(error))
#define ic0devSoftVLogParameter(obj,devName,parameter,index,value,comment,error) \
	(*((ic0devSOFT_FCTPTR_LOG_PARAMETER)((obj)->fcts[ic0devSOFT_FCT_LOG_PARAMETER]))) \
	 ((obj),(devName),(parameter),(index),(value),(comment),(error))
#define ic0devSoftVLogRecovery(obj,devName,comment,error) \
	(*((ic0devSOFT_FCTPTR_LOG_RECOVERY)((obj)->fcts[ic0devSOFT_FCT_LOG_RECOVERY]))) \
	 ((obj),(devName),(comment),(error))
#define ic0devSoftVLogTblParam(obj,devName,paramIndex,flags,comment,error) \
	(*((ic0devSOFT_FCTPTR_LOG_TBL_PARAM)((obj)->fcts[ic0devSOFT_FCT_LOG_TBL_PARAM]))) \
	 ((obj),(devName),(paramIndex),(flags),(comment),(error))
#define ic0devSoftVLogUnforseen(obj,devName,comment,error) \
	(*((ic0devSOFT_FCTPTR_LOG_UNFORSEEN)((obj)->fcts[ic0devSOFT_FCT_LOG_UNFORSEEN]))) \
	 ((obj),(devName),(comment),(error))


ccsCOMPL_STAT ic0devSoftNewObj(
    IN    dbSYMADDRESS	point,
    IN    egenOBJ*	owner,
    OUT   egenOBJ*	obj,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devSoftDeleteObj(
    INOUT egenOBJ*	obj,
    OUT   ccsERROR*	error);


ccsCOMPL_STAT ic0devSoftGetParametersUsedSize(
    INOUT egenOBJ*	obj,
    OUT   vltINT16*	num,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0devSoftGetValuesUsedSize(
    INOUT egenOBJ*	obj,
    OUT   vltINT16*	num,
    OUT   ccsERROR*	error);


/*
 * local variables
 */
extern vltBYTES16 ic0devFitsDict;
extern vltBYTES16 ic0devFitsMask;


#endif // !IC0DEV_SOFT_H

/************************************************************************/
/* ___oOo___ */
