/******************************************************************************
*  E.S.O. - VLT project
* 
*  "@(#) $Id: ic0digDefines.h,v 1.35 2005/09/09 18:58:44 vltsccm Exp $"
* 
*  who       when      what
*  --------  --------  ----------------------------------------------
*  rschmutz  12/05/99  added ic0digLAMP_SIGNAL_NO_OFF_FAULT.
*  rschmutz  18/08/98  WARMING-UP -> WARMUP.
*  rschmutz  24/06/97  defines for config. added
*  rschmutz  04/06/97  Created
*
*/

/*************************************************************************
*    NAME
*	ic0digDefines.h - module header file, define part
* 
* 
*    DESCRIPTION
*	This is a header file of the module ic0dig.
* 
* 
*-------------------------------------------------------------------------
*/

#ifndef IC0DIG_DEFINES_H
#define IC0DIG_DEFINES_H

#include "ic0devDefines.h"


/*
 * lamp parameter get status value
 */
#define ic0digGET_FIRST			1   /* lcctooGET_FIRST	          */

#define ic0digLAMP_GET_FIRST		15  /* (lccdevGET_LAST + 1)	  */
#define ic0digLAMP_GET_ID		15  /* (ic0digLAMP_GET_FIRST + 0) */
#define ic0digLAMP_GET_NAME		16  /* (ic0digLAMP_GET_FIRST + 1) */
#define ic0digLAMP_GET_ST		17  /* (ic0digLAMP_GET_FIRST + 2) */
#define ic0digLAMP_GET_STAT		18  /* (ic0digLAMP_GET_FIRST + 3) */
#define ic0digLAMP_GET_VALUE		19  /* (ic0digLAMP_GET_FIRST + 4) */
#define ic0digLAMP_GET_TIME		20  /* (ic0digLAMP_GET_FIRST + 5) */
#define ic0digLAMP_GET_STIME		21  /* (ic0digLAMP_GET_FIRST + 6) */
#define ic0digLAMP_GET_TOTAL		22  /* (ic0digLAMP_GET_FIRST + 7) */
#define ic0digLAMP_GET_LAMP_OK		23  /* (ic0digLAMP_GET_FIRST + 8) */
#define ic0digLAMP_GET_LAST		23  /* (ic0digLAMP_GET_FIRST + 8) */


/*
 * lamp status strings
 */
#define ic0digLAMP_ID_STRING		"Id"
#define ic0digLAMP_NAME_STRING		"Name"
#define ic0digLAMP_ST_STRING		"ST"
#define ic0digLAMP_STAT_STRING		"STAT"
#define ic0digLAMP_VALUE_STRING		"VALUE"
#define ic0digLAMP_TIME_STRING		"Time"
#define ic0digLAMP_STIME_STRING		"STime"
#define ic0digLAMP_TOTAL_STRING		"Total"

#define ic0digLAMP_ON_STRING		"ON"
#define ic0digLAMP_OFF_STRING		"OFF"
#define ic0digLAMP_WARMING_UP_STRING	"WARMUP"
#define ic0digLAMP_COOLING_DOWN_STRING	"COOLDN"

/*
 * lamp used signals
 */
#define ic0digLAMP_SIGNAL_SWITCH	 1
#define ic0digLAMP_SIGNAL_STANDBY 	 2
#define ic0digLAMP_SIGNAL_LOCAL		 4
#define ic0digLAMP_SIGNAL_ON		 8  /* signal used if SWITCH used    */
#define ic0digLAMP_SIGNAL_STANDBYI	16
#define ic0digLAMP_SIGNAL_FAULT 	32
#define ic0digLAMP_SIGNAL_LAMP_OK      128
#define ic0digLAMP_SIGNAL_VALUE	       256  /* used only by TAL lamps	     */
#define ic0digLAMP_SIGNAL_VALUEI       512  /* used only by TAL lamps	     */

#define ic0digLAMP_SIGNAL_DEFAULT	45  /* all, except standby support   */
#define ic0digLAMP_SIGNAL_ALL		63  /* all, except lampOkI signal    */
#define ic0digLAMP_SIGNAL_STANDBY2	66  /* switch standby on in the
					       LOADED to STANDBY transition  */
#define ic0digLAMP_SIGNAL_TAL	       815  /* all signals used by TAL lamps
					       Switch+Standby+Local+On+Fault
					       +Value+ValueI		     */
#define ic0digLAMP_SIGNAL_IGNORE_FAULT 1024 /* report fault, but ignore it   */
#define ic0digLAMP_SIGNAL_NO_OFF_FAULT 2048 /* do not report fault, when off */

/*
 * shutter parameter get status value
 */
#define ic0digSHUTTER_GET_FIRST		15  /* (lccdevGET_LAST + 1)	     */
#define ic0digSHUTTER_GET_ID		15  /* (ic0digSHUTTER_GET_FIRST + 0) */
#define ic0digSHUTTER_GET_NAME		16  /* (ic0digSHUTTER_GET_FIRST + 1) */
#define ic0digSHUTTER_GET_ST		17  /* (ic0digSHUTTER_GET_FIRST + 2) */
#define ic0digSHUTTER_GET_STAT		18  /* (ic0digSHUTTER_GET_FIRST + 3) */
#define ic0digSHUTTER_GET_TIME		19  /* (ic0digSHUTTER_GET_FIRST + 4) */
#define ic0digSHUTTER_GET_LAST		19  /* (ic0digSHUTTER_GET_FIRST + 4) */


/*
 * shutter status strings
 */
#define ic0digSHUTTER_ID_STRING		"Id"
#define ic0digSHUTTER_NAME_STRING 	"Name"
#define ic0digSHUTTER_ST_STRING		"ST"
#define ic0digSHUTTER_STAT_STRING	"STAT"
#define ic0digSHUTTER_TIME_STRING 	"Time"

#define ic0digSHUTTER_OPEN_STRING	"OPEN"
#define ic0digSHUTTER_CLOSED_STRING	"CLOSED"



/*
 * shutter used signals
 */
#define ic0digSHUTTER_SIGNAL_SWITCH	 1  /* signal always used */
#define ic0digSHUTTER_SIGNAL_OPEN	 2  /* signal always used */
#define ic0digSHUTTER_SIGNAL_CLOSED	 4
#define ic0digSHUTTER_SIGNAL_LOCAL	 8
#define ic0digSHUTTER_SIGNAL_FAULT	16

#define ic0digSHUTTER_SIGNAL_ALL 	31
#define ic0digSHUTTER_SIGNAL_DEFAULT	27  /* all, except shutClosedI */
#define ic0digSHUTTER_SIGNAL_IGNORE_FAULT 1024


/*
 * signal parameter get status value
 */
#define ic0digSIGNAL_GET_FIRST		15  /* (lccdevGET_LAST + 1)	    */
#define ic0digSIGNAL_GET_ID		15  /* (ic0digSIGNAL_GET_FIRST + 0) */
#define ic0digSIGNAL_GET_NAME		16  /* (ic0digSIGNAL_GET_FIRST + 1) */
#define ic0digSIGNAL_GET_ST		17  /* (ic0digSIGNAL_GET_FIRST + 2) */
#define ic0digSIGNAL_GET_LAST		17  /* (ic0digSIGNAL_GET_FIRST + 2) */


/*
 * signal status strings
 */
#define ic0digSIGNAL_ID_STRING		"Id"
#define ic0digSIGNAL_NAME_STRING 	"Name"
#define ic0digSIGNAL_ST_STRING		"ST"


/*
 * defines for config.
 */
#define ic0digHIGH	0
#define ic0digLOW	1
#define ic0digINPUT	0
#define ic0digOUTPUT	1


#endif // !IC0DIG_DEFINES_H

/************************************************************************/
/* ___oOo___ */
