/******************************************************************************
*  E.S.O. - VLT project
* 
*  "@(#) $Id: ic0digLamp.h,v 1.35 2005/09/09 18:58:43 vltsccm Exp $"
* 
*  who        when      what
*  ---------- --------  ----------------------------------------------
*  rschmutz   22/05/97  Created by eccsgen  Revision: 1.15
*
*
*    !!!!!!!!!  CAUTION: THIS FILE IS UPDATED BY ECCSGEN  !!!!!!!!!
*/

/*************************************************************************
*   NAME
*	ic0digLamp - class
*
*   SYNOPSIS
*	#include "ic0digLamp.h"
*
*	ccsCOMPL_STAT ic0digLampNewObj(
*	    IN    dbSYMADDRESS	point,
*	    IN    egenOBJ*	owner,
*	    OUT   egenOBJ*	obj,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0digLampDeleteObj(
*	    INOUT egenOBJ*	obj,
*	    OUT   ccsERROR*	error)
*
*	egenOBJ* ic0digLampGetOwner(
*	    IN const egenOBJ* obj)
*
*	egenOBJ* ic0digLampLogData(
*	    IN const egenOBJ*	obj,
*	    IN const char*	format,
*	    IN 			...)
*
*	ccsCOMPL_STAT ic0digLampSetup(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    const char*	function[],	** max. vltBYTES32[999]
*	    IN    vltINT16	functionNum,
*	    IN    vltLOGICAL	noMove,
*	    IN    vltLOGICAL	check,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0digLampSet(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    const char*	position[],	** max. vltBYTES32[999]
*	    IN    vltINT16	positionNum,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0digLampStatus(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    const char*	function[],	** max. vltBYTES32[999]
*	    IN    vltINT16	functionNum,
*	    IN    vltLOGICAL	flag,
*	    IN    vltLOGICAL	header,
*	    IN    vltLOGICAL	conflog,
*	    IN    vltLOGICAL	opslog,
*	    IN    vltLOGICAL	condlog,
*	    OUT   char**	status,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0digLampCheck(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    OUT   char**	status,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0digLampWait(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    vltINT32	timeout,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0digLampCfgElem(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    vltINT32	position,
*	    IN    const char*	id,
*	    IN    const char*	values[],	** max. vltBYTES16[10]
*	    IN    vltINT16	valuesNum,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0digLampUsrInit(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0digLampUsrLoaded2Standby(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0digLampUsrStandby2Online(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0digLampUsrOnline2Standby(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0digLampUsrStandby2Loaded(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0digLampUsrSetMode(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    vltINT32	cmd,
*	    IN    vltLOGICAL	available,
*	    IN    vltLOGICAL	enabled,
*	    IN    vltLOGICAL	simulation,
*	    IN    vltLOGICAL	handset,
*	    IN    vltLOGICAL	locked,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0digLampUsrMonitor(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    vltINT32	state,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0digLampUsrSelfTest(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0digLampUsrTest(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0digLampStandbyOn(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0digLampStandbyOff(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0digLampUsrStatusCode(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    const char*	text,
*	    IN    vltINT32	flags,
*	    OUT   vltINT32*	code,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0digLampUsrStatusValue(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    vltINT32	code,
*	    OUT   lcctooVALUE*	value,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0digLampUsrStatusLast(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    OUT   vltINT16*	last,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0digLampRead<scalarAttr>(
*	    INOUT egenOBJ*	obj,
*	    OUT   void*		buf,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0digLampWrite<scalarAttr>(
*	    INOUT egenOBJ*	obj,
*	    IN    void*		buf,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0digLampRead<vectorAttr>(
*	    INOUT egenOBJ*	obj,
*	    OUT   void*		buf,
*	    IN    vltINT32	first,
*	    IN    vltINT32	last,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0digLampWrite<vectorAttr>(
*	    INOUT egenOBJ*	obj,
*	    IN    void*		buf,
*	    IN    vltINT32	first,
*	    IN    vltINT32	last,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0digLampRead<tableAttr>(
*	    INOUT egenOBJ*	obj,
*	    OUT   void*		buf,
*	    IN    vltINT32	firstRec,
*	    IN    vltINT32	lastRec,
*	    IN    vltINT32	firstFld,
*	    IN    vltINT32	lastFld,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0digLampWrite<tableAttr>(
*	    INOUT egenOBJ*	obj,
*	    IN    void*		buf,
*	    IN    vltINT32	firstRec,
*	    IN    vltINT32	lastRec,
*	    IN    vltINT32	firstFld,
*	    IN    vltINT32	lastFld,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0digErrSwitchOn(p1,p2)
*	ccsCOMPL_STAT ic0digErrSwitchOff(p1,p2)
*	ccsCOMPL_STAT ic0digErrStandbyOn(p1,p2)
*	ccsCOMPL_STAT ic0digErrStandbyOff(p1,p2)
*	ccsCOMPL_STAT ic0digErrWaitTimeout(p1,p2,p3)
*	ccsCOMPL_STAT ic0digErrWaitStopped(p1)
*
*   PARENT CLASS
*	public ic0digSOFT
*
*   DESCRIPTION
*       The class ic0digLAMP provides the software device
*       for a calibration lamp
*
*	ic0digLampNewObj(point,owner,obj,error)
*	    Initialises an instance of the class type ic0digLAMP.
*
*	    point	<IN>	OLDB point where the owned attributes are
*				located.
*	    owner	<IN>	Pointer to the owner of the new instance.
*	    obj		<OUT>	Handle for the new instance (the handle
*				must be allocated by the caller).
*
*	ic0digLampDeleteObj(obj,error)
*	    The function lcctooDeleteObj deletes an
*	    instance of the class type ic0digLAMP
*
*	ic0digLampSetup(obj,devName,function,functionNum,noMove,check,error)
*	   Setups the function. The keys are the last component
*	   of the FITS keywords related with the function.
*	   E.g.:
*	     If the FITS keyword is: INS.OPTI-3.ID #11
*	     then the key is: ID, the value '#11'.
*
*	   If the noMove flag is used, then the setup parameters
*	   are stored, but not executed until a setup command
*	   without the noMove flag is received.
*
*	   If the check flag is used, then only the parameters
*	   are checked. No setup is performed.
*
*	   Aliases are not accepted (The ICS Frontend at the
*	   workstation recognizes the aliases).
*
*	ic0digLampSet(obj,devName,position,positionNum,error)
*	   Set a hardware device in a specified state
*	   (e.g. set lamp on, set shutter open).
*
*	ic0digLampStatus(obj,devName,function,functionNum,flag,header,conflog,opslog,condlog,status,error)
*	   Updates the complete status in the local database
*	   and returns the relevant status of the software
*	   device.
*
*	   The status is given as lines containing two words
*	   each:
*	     key1  value1,
*	     [key2 value2,
*	     [...]]
*
*	   The value usually begins after the 18th character
*	   of each line. If the flag option is set, then the
*	   values are returned as numbers (by default values
*	   are returned as literals).
*
*	ic0digLampCheck(obj,devName,status,error)
*	   Checks if the last action of the hardware device
*	   has finished.
*
*	ic0digLampWait(obj,devName,timeout,error)
*	   Wait for the last action of the hardware device
*	   to finish.
*
*	ic0digLampCfgElem(obj,devName,position,id,values,valuesNum,error)
*	   Configures a hardware device.
*
*	   The given id is associated with the given
*	   position. The id is usually the id of the
*	   element mounted at the given position of the
*	   hardware device (e.g. a specific filter in
*	   a filter wheel).
*
*
*	ic0digLampErr<error>(...)
*	    The macros ic0digLampErr*() log an error with lcctooLOG_0 and
*	    call errAdd with the corresponding error parameters.
*
*	ic0digLampRead<attr>(...)
*	ic0digLampWrite<attr>(...)
*	    The above macros read from/write to the data attributes
*	    of the class.
*	    The attributes are described in ic0digLampDb(5).
*
*   PROTECTED METHODS
*   PRIVATE METHODS
*	ic0digLampUsrInit(obj,devName,error)
*	   This function should be overloaded to perform the
*	   device initialisation (without hardware movements).
*
*	ic0digLampUsrLoaded2Standby(obj,devName,error)
*	   This function should be overloaded to perform the
*	   actions necessary to change from the LOADED to the
*	   STANDBY state. The overloaded function should call
*	   lccdevCmdUsrLoaded2Standby() (to set the fixed
*	   position, if necessary).
*
*	ic0digLampUsrStandby2Online(obj,devName,error)
*	   This function should be overloaded to perform the
*	   actions necessary to change from the STANDBY to the
*	   ONLINE state. The overloaded function should first
*	   call lccdevCmdUsrStandby2Online() or check if the
*	   device is available and enabled before going ONLINE.
*
*	ic0digLampUsrOnline2Standby(obj,devName,error)
*	   This function should be overloaded to perform the
*	   actions necessary to change from the ONLINE to the
*	   STANDBY state.
*
*	ic0digLampUsrStandby2Loaded(obj,devName,error)
*	   This function should be overloaded to perform the
*	   actions necessary to change from the STANDBY to the
*	   LOADED state.
*
*	ic0digLampUsrSetMode(obj,devName,cmd,available,enabled,simulation,handset,locked,error)
*	   This function should be overloaded to perform the
*	   actions necessary to change the mode of the hardware
*	   device.
*
*	   cmd	<IN>	code indicating the command that
*			   calls UsrSetMode() (lccdevCMD_*).
*	   logical	<IN>	state of the available, enabled,
*			   simulation, handset and locked
*			   modes.
*
*	ic0digLampUsrMonitor(obj,devName,state,error)
*	   This function is periodically called by the device
*	   manager. This function may be overloaded to monitor
*	   the device.
*
*	ic0digLampUsrSelfTest(obj,devName,error)
*	   This function should be overloaded to perform a
*	   selftest of the device.  No movements are allowed
*	   (it must be possible to execute this function in
*	   the state LOADED).
*
*	ic0digLampUsrTest(obj,devName,error)
*	   This function should be overloaded to perform the
*	   actions necessary to test the software device
*	   (eventually with hardware movements).
*
*	ic0digLampStandbyOn(obj,devName,error)
*	   Turns on the standby signal.
*
*	ic0digLampStandbyOff(obj,devName,error)
*	   Turns off the standby signal.
*
*	ic0digLampUsrStatusCode(obj,devName,text,flags,code,error)
*	   This function receives the name of a status value
*	   and returns the corresponding code. This function
*	   should be overloaded if the new class declares new
*	   status values. The overloaded function should check
*	   first if the name corresponds to one of its own
*	   status values. If not, then it should call the
*	   function UsrStatusCode() of its parent class to be
*	   able to retrieve the codes of the parent status
*	   values.
*
*	   text	<IN>	Name of the status value.
*	   flags	<IN>	expected status type (lcctooSTATUS_*).
*	   code	<OUT>	Code of the status value (lccdevGET_*).
*
*	   lccdevGET_DEVICE        "Device"
*	   lccdevGET_STATE         "State"
*	   lccdevGET_TRANSTATE     "TranState"
*	   lccdevGET_ERROR         "Error"
*	   lccdevGET_INITIALISED   "Initialised"
*	   lccdevGET_SIMULATION    "Simulation"
*
*	ic0digLampUsrStatusValue(obj,devName,code,value,error)
*	   This function receives the code of a status variable
*	   and returns its related value. This function should
*	   be overloaded if the new class declares new status
*	   values. The overloaded function should check first
*	   if the code corresponds to one of its own status
*	   values. If not, then it should call the function
*	   UsrStatusValue() of its parent class to be able to
*	   retrieve the status values of the parent.
*
*	   code	<OUT>	Code of the status value (lccdevGET_*).
*	   value	<OUT>	Handle of the value object
*			   (allocated by the caller).
*
*	ic0digLampUsrStatusLast(obj,devName,last,error)
*	   This function returns the highest status code that
*	   the class knows. This function should be overloaded
*	   if the new class declares new status values, as new
*	   status codes have to be assigned to the new values.
*
*	   This function is used by the Status command when it
*	   has to return all status values. In this case it
*	   performs a loop from code 1 to the value returned
*	   by this function.
*
*
*   DEFINES
*
*   FILES
*
*   ENVIRONMENT
*
*   RETURN VALUES
*	If the function prototype allows, methods return ccsCOMPL_STAT.
*
*	Methods can generate the following errors:
*	    ic0digERR_SWITCH_ON
*	    ic0digERR_SWITCH_OFF
*	    ic0digERR_STANDBY_ON
*	    ic0digERR_STANDBY_OFF
*	    ic0digERR_WAIT_TIMEOUT
*	    ic0digERR_WAIT_STOPPED
*
*   CAUTIONS
*
*   EXAMPLES
*
*   SEE ALSO
*
*   BUGS
*
* 
*-------------------------------------------------------------------------
*/

#ifndef IC0DIG_LAMP_H
#define IC0DIG_LAMP_H

#include "egen.h"
#include "ic0digDefines.h"
#include "ic0digErrors.h"
#include "ic0digSoft.h"

/*
 * class type identifier
 */
#define ic0digLAMP_ID	182

/*
 * attribute table
 */
#define ic0digLAMP_ATTR_STATE	0
#define ic0digLAMP_ATTR_SUBSTATE	1
#define ic0digLAMP_ATTR_ERROR	2
#define ic0digLAMP_ATTR_INITIALISED	3
#define ic0digLAMP_ATTR_SIMULATION	4
#define ic0digLAMP_ATTR_DEVICE	5
#define ic0digLAMP_ATTR_AVAILABLE	6
#define ic0digLAMP_ATTR_ENABLED	7
#define ic0digLAMP_ATTR_LOCKED	8
#define ic0digLAMP_ATTR_HANDSET	9
#define ic0digLAMP_ATTR_FIXED	10
#define ic0digLAMP_ATTR_FIX_POS_SET	11
#define ic0digLAMP_ATTR_FIXED_POSITION	12
#define ic0digLAMP_ATTR_FIXED_SIMULATION	13
#define ic0digLAMP_ATTR_FIXED_LOCKED	14
#define ic0digLAMP_ATTR_PREFIX	15
#define ic0digLAMP_ATTR_PARAMETERS_SIZE	16
#define ic0digLAMP_ATTR_PARAMETERS	17
#define ic0digLAMP_ATTR_STATUS	18
#define ic0digLAMP_ATTR_STATUS_INDEX	19
#define ic0digLAMP_ATTR_VALUES_SIZE	20
#define ic0digLAMP_ATTR_VALUES	21
#define ic0digLAMP_ATTR_INIT_RESTRICTION	22
#define ic0digLAMP_ATTR_MOVE_RESTRICTION	23
#define ic0digLAMP_ATTR_STOP_TIMEOUT	24
#define ic0digLAMP_ATTR_SET_VAL_FCT	25
#define ic0digLAMP_ATTR_HELP_TEXT	26
#define ic0digLAMP_ATTR_PARAM_STEP	27
#define ic0digLAMP_ATTR_ACTION_COMMAND	28
#define ic0digLAMP_ATTR_ACTION_STOP_REQ	29
#define ic0digLAMP_ATTR_ACTION_NO_MOVE	30
#define ic0digLAMP_ATTR_ACTION_CHECK	31
#define ic0digLAMP_ATTR_RESET_SETUP_CMD	32
#define ic0digLAMP_ATTR_ID	33
#define ic0digLAMP_ATTR_NAME	34
#define ic0digLAMP_ATTR_SIGNALS	35
#define ic0digLAMP_ATTR_CONFIGURED	36
#define ic0digLAMP_ATTR_HW_ACCESS	37
#define ic0digLAMP_ATTR_TIME_STBY_ACCESS	38
#define ic0digLAMP_ATTR_TIME_STANDBY	39
#define ic0digLAMP_ATTR_TIME_ACCESS	40
#define ic0digLAMP_ATTR_TIME_ON	41
#define ic0digLAMP_ATTR_TIME_LIFE	42
#define ic0digLAMP_ATTR_TIME_SETUP	43
#define ic0digLAMP_ATTR_LAMP_OK	44
#define ic0digLAMP_ATTR_TIME_OFF_ACCESS	45
#define ic0digLAMP_ATTR_OFF_ALARM	46
#define ic0digLAMP_ATTR_LAMP_SWITCH_O	47
#define ic0digLAMP_ATTR_LAMP_SWITCH_O_STATUS	48
#define ic0digLAMP_ATTR_STANDBY_O	49
#define ic0digLAMP_ATTR_STANDBY_O_STATUS	50
#define ic0digLAMP_ATTR_VALUE_O	51
#define ic0digLAMP_ATTR_VALUE_O_STATUS	52
#define ic0digLAMP_ATTR_LOCAL_I	53
#define ic0digLAMP_ATTR_LOCAL_I_SIM	54
#define ic0digLAMP_ATTR_LOCAL_I_STATUS	55
#define ic0digLAMP_ATTR_LAMP_ON_I	56
#define ic0digLAMP_ATTR_LAMP_ON_I_SIM	57
#define ic0digLAMP_ATTR_LAMP_ON_I_STATUS	58
#define ic0digLAMP_ATTR_STANDBY_I	59
#define ic0digLAMP_ATTR_STANDBY_I_SIM	60
#define ic0digLAMP_ATTR_STANDBY_I_STATUS	61
#define ic0digLAMP_ATTR_FAULT_I	62
#define ic0digLAMP_ATTR_FAULT_I_SIM	63
#define ic0digLAMP_ATTR_FAULT_I_STATUS	64
#define ic0digLAMP_ATTR_LAMP_OK_I	65
#define ic0digLAMP_ATTR_LAMP_OK_I_SIM	66
#define ic0digLAMP_ATTR_LAMP_OK_I_STATUS	67
#define ic0digLAMP_ATTR_VALUE_I	68
#define ic0digLAMP_ATTR_VALUE_I_SIM	69
#define ic0digLAMP_ATTR_VALUE_I_STATUS	70
#define ic0digLAMP_ATTR_IO_USED	71
#define ic0digLAMP_ATTR_USE_CFG_ELEM	72
#define ic0digLAMP_ATTR_DELAY	73
#define ic0digLAMP_ATTR_TID	74

#define ic0digLAMP_AUTOMATA	0

/*
 * function table
 */
#define ic0digLAMP_FCT_DELETE_OBJ	0
#define ic0digLAMP_FCT_STANDBY	1
#define ic0digLAMP_FCT_ONLINE	2
#define ic0digLAMP_FCT_OFF	3
#define ic0digLAMP_FCT_EXIT	4
#define ic0digLAMP_FCT_STATE	5
#define ic0digLAMP_FCT_SIMULAT	6
#define ic0digLAMP_FCT_STOP_SIM	7
#define ic0digLAMP_FCT_STATUS	8
#define ic0digLAMP_FCT_INIT	9
#define ic0digLAMP_FCT_STOP	10
#define ic0digLAMP_FCT_TEST	11
#define ic0digLAMP_FCT_SELFTST	12
#define ic0digLAMP_FCT_AUTO_TBL	13
#define ic0digLAMP_FCT_AUTO_RST	14
#define ic0digLAMP_FCT_INIT_OBJ	15
#define ic0digLAMP_FCT_EXIT_OBJ	16
#define ic0digLAMP_FCT_LOADED2STBY	17
#define ic0digLAMP_FCT_ONLINE2STBY	18
#define ic0digLAMP_FCT_EXIT1	19
#define ic0digLAMP_FCT_CHECK_DEVICE_NAME	20
#define ic0digLAMP_FCT_BREAK	21
#define ic0digLAMP_FCT_USR_INIT	22
#define ic0digLAMP_FCT_USR_LOADED2STANDBY	23
#define ic0digLAMP_FCT_USR_STANDBY2ONLINE	24
#define ic0digLAMP_FCT_USR_ONLINE2STANDBY	25
#define ic0digLAMP_FCT_USR_STANDBY2LOADED	26
#define ic0digLAMP_FCT_USR_STOP	27
#define ic0digLAMP_FCT_USR_SIMULAT	28
#define ic0digLAMP_FCT_USR_STOP_SIM	29
#define ic0digLAMP_FCT_USR_STATUS_CODE	30
#define ic0digLAMP_FCT_USR_STATUS_LAST	31
#define ic0digLAMP_FCT_USR_STATUS_VALUE	32
#define ic0digLAMP_FCT_USR_TEST	33
#define ic0digLAMP_FCT_USR_SELF_TEST	34
#define ic0digLAMP_FCT_USR_ERROR	35
#define ic0digLAMP_FCT_AVAIL	36
#define ic0digLAMP_FCT_UNAVAIL	37
#define ic0digLAMP_FCT_DISABLE	38
#define ic0digLAMP_FCT_ENABLE	39
#define ic0digLAMP_FCT_LOCK	40
#define ic0digLAMP_FCT_UNLOCK	41
#define ic0digLAMP_FCT_HANDSET	42
#define ic0digLAMP_FCT_HSET_OFF	43
#define ic0digLAMP_FCT_FIX_POS	44
#define ic0digLAMP_FCT_MOVE	45
#define ic0digLAMP_FCT_MOVE_REL	46
#define ic0digLAMP_FCT_SET	47
#define ic0digLAMP_FCT_CHECK	48
#define ic0digLAMP_FCT_WAIT	49
#define ic0digLAMP_FCT_USR_SET_MODE	50
#define ic0digLAMP_FCT_SETUP	51
#define ic0digLAMP_FCT_GET_VAL	52
#define ic0digLAMP_FCT_SET_VAL	53
#define ic0digLAMP_FCT_CFG_ELEM	54
#define ic0digLAMP_FCT_LOG_CONF	55
#define ic0digLAMP_FCT_GET_CONF	56
#define ic0digLAMP_FCT_RESET_PARAMETERS	57
#define ic0digLAMP_FCT_PARSE_PARAMETERS	58
#define ic0digLAMP_FCT_COMPARE_PARAMETERS	59
#define ic0digLAMP_FCT_COPY_PARAMETERS	60
#define ic0digLAMP_FCT_EXEC_PARAMETERS	61
#define ic0digLAMP_FCT_UPDATE_PARAMETERS	62
#define ic0digLAMP_FCT_GET_PARAM_SET_VALUE	63
#define ic0digLAMP_FCT_GET_PARAM_STATUS	64
#define ic0digLAMP_FCT_SET_PARAM	65
#define ic0digLAMP_FCT_SET_PARAM_STEP	66
#define ic0digLAMP_FCT_USR_EXEC_ACTION	67
#define ic0digLAMP_FCT_USR_SET_PARAMETER	68
#define ic0digLAMP_FCT_GET_VALUE_CODE	69
#define ic0digLAMP_FCT_GET_VALUE	70
#define ic0digLAMP_FCT_USR_GET_VALUE	71
#define ic0digLAMP_FCT_SET_VALUE	72
#define ic0digLAMP_FCT_USR_SET_VALUE	73
#define ic0digLAMP_FCT_GET_ARG	74
#define ic0digLAMP_FCT_MONITOR	75
#define ic0digLAMP_FCT_USR_MONITOR	76
#define ic0digLAMP_FCT_LOG_ACTION	77
#define ic0digLAMP_FCT_LOG_COMMENT	78
#define ic0digLAMP_FCT_LOG_PARAMETER	79
#define ic0digLAMP_FCT_LOG_RECOVERY	80
#define ic0digLAMP_FCT_LOG_TBL_PARAM	81
#define ic0digLAMP_FCT_LOG_UNFORSEEN	82
#define ic0digLAMP_FCT_STANDBY_ON	83
#define ic0digLAMP_FCT_STANDBY_OFF	84

/*
 * automata states
 */
#define ic0digLAMP_STATE_NOSTATE	-1
#define ic0digLAMP_STATE_OFF	0
#define ic0digLAMP_STATE_LOADED	1
#define ic0digLAMP_STATE_STANDBY	2
#define ic0digLAMP_STATE_ONLINE	3

/*
 * automata substates
 */
#define ic0digLAMP_SUBSTATE_ERROR	0
#define ic0digLAMP_SUBSTATE_IDLE	1
#define ic0digLAMP_SUBSTATE_BUSY	2
#define ic0digLAMP_SUBSTATE_INITIALISING	3
#define ic0digLAMP_SUBSTATE_SHUTTING_DOWN	4
#define ic0digLAMP_SUBSTATE_STOPPING	5
#define ic0digLAMP_SUBSTATE_COLD_STARTING	6
#define ic0digLAMP_SUBSTATE_STARTING	7
#define ic0digLAMP_SUBSTATE_STOP	8

/*
 * automata events
 */
#define ic0digLAMP_EVENT_INIT	0
#define ic0digLAMP_EVENT_STANDBY	1
#define ic0digLAMP_EVENT_ONLINE	2
#define ic0digLAMP_EVENT_STOP	3
#define ic0digLAMP_EVENT_OFF	4
#define ic0digLAMP_EVENT_EXIT	5
#define ic0digLAMP_EVENT_STATE	6
#define ic0digLAMP_EVENT_STOP_SIM	7
#define ic0digLAMP_EVENT_STATUS	8
#define ic0digLAMP_EVENT_SIMULAT	9
#define ic0digLAMP_EVENT_TEST	10
#define ic0digLAMP_EVENT_SELFTST	11
#define ic0digLAMP_EVENT_AUTO_TBL	12
#define ic0digLAMP_EVENT_AUTO_RST	13
#define ic0digLAMP_EVENT_DISABLE	14
#define ic0digLAMP_EVENT_ENABLE	15
#define ic0digLAMP_EVENT_LOCK	16
#define ic0digLAMP_EVENT_UNLOCK	17
#define ic0digLAMP_EVENT_HANDSET	18
#define ic0digLAMP_EVENT_HSET_OFF	19
#define ic0digLAMP_EVENT_AVAIL	20
#define ic0digLAMP_EVENT_UNAVAIL	21
#define ic0digLAMP_EVENT_MOVE	22
#define ic0digLAMP_EVENT_MOVE_REL	23
#define ic0digLAMP_EVENT_SET	24
#define ic0digLAMP_EVENT_CHECK	25
#define ic0digLAMP_EVENT_WAIT	26
#define ic0digLAMP_EVENT_SETUP	27
#define ic0digLAMP_EVENT_CFG_ELEM	28
#define ic0digLAMP_EVENT_GET_VAL	29
#define ic0digLAMP_EVENT_SET_VAL	30
#define ic0digLAMP_EVENT_LOG_CONF	31
#define ic0digLAMP_EVENT_GET_CONF	32
#define ic0digLAMP_EVENT_MONITOR	33


/*
 * values table
 */
#define ic0digLAMP_VALUE_TIME_OK	0
#define ic0digLAMP_VALUE_WAIT_TIME	3
#define ic0digLAMP_VALUE_DEFAULT_VALUE	4
#define ic0digLAMP_VALUE_MAX_ON_TIME	5
#define ic0digLAMP_VALUE_COOLDOWN_TIME	6


/*
 * function pointer types
 */
typedef ccsCOMPL_STAT (*ic0digLAMP_FCTPTR_SETUP)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    const char*	function[],	/* max. vltBYTES32[999] */
    IN    vltINT16	functionNum,
    IN    vltLOGICAL	noMove,
    IN    vltLOGICAL	check,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0digLAMP_FCTPTR_SET)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    const char*	position[],	/* max. vltBYTES32[999] */
    IN    vltINT16	positionNum,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0digLAMP_FCTPTR_STATUS)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    const char*	function[],	/* max. vltBYTES32[999] */
    IN    vltINT16	functionNum,
    IN    vltLOGICAL	flag,
    IN    vltLOGICAL	header,
    IN    vltLOGICAL	conflog,
    IN    vltLOGICAL	opslog,
    IN    vltLOGICAL	condlog,
    OUT   char**	status,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0digLAMP_FCTPTR_CHECK)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   char**	status,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0digLAMP_FCTPTR_WAIT)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltINT32	timeout,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0digLAMP_FCTPTR_CFG_ELEM)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltINT32	position,
    IN    const char*	id,
    IN    const char*	values[],	/* max. vltBYTES16[10] */
    IN    vltINT16	valuesNum,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0digLAMP_FCTPTR_USR_INIT)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0digLAMP_FCTPTR_USR_LOADED2STANDBY)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0digLAMP_FCTPTR_USR_STANDBY2ONLINE)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0digLAMP_FCTPTR_USR_ONLINE2STANDBY)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0digLAMP_FCTPTR_USR_STANDBY2LOADED)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0digLAMP_FCTPTR_USR_SET_MODE)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltINT32	cmd,
    IN    vltLOGICAL	available,
    IN    vltLOGICAL	enabled,
    IN    vltLOGICAL	simulation,
    IN    vltLOGICAL	handset,
    IN    vltLOGICAL	locked,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0digLAMP_FCTPTR_USR_MONITOR)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltINT32	state,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0digLAMP_FCTPTR_USR_SELF_TEST)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0digLAMP_FCTPTR_USR_TEST)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0digLAMP_FCTPTR_STANDBY_ON)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0digLAMP_FCTPTR_STANDBY_OFF)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0digLAMP_FCTPTR_USR_STATUS_CODE)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    const char*	text,
    IN    vltINT32	flags,
    OUT   vltINT32*	code,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0digLAMP_FCTPTR_USR_STATUS_VALUE)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltINT32	code,
    OUT   lcctooVALUE*	value,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0digLAMP_FCTPTR_USR_STATUS_LAST)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   vltINT16*	last,
    OUT   ccsERROR*	error);


/*
 * log function
 */
#define ic0digLampLogData(obj, format, arg...) \
	{ \
	char tmpLogBuf[lcctooTMP_BUFFER_SIZE]; \
	\
	sprintf(tmpLogBuf, (format), ##arg); \
	logData("ic0dig", (obj)->id, tmpLogBuf); \
	}


/*
 * error functions
 */
#define ic0digErrSwitchOn(p1,p2) \
	{ \
	lcctooLOG_0("ic0digERR_SWITCH_ON: Device %s: Error switching the lamp on (%s).",(p1),(p2)); \
	errAdd(error,"ic0dig",ic0digERR_SWITCH_ON,__FILE_LINE__,"%s,%s",(p1),(p2)); \
	}
#define ic0digErrSwitchOff(p1,p2) \
	{ \
	lcctooLOG_0("ic0digERR_SWITCH_OFF: Device %s: Error switching the lamp off (%s).",(p1),(p2)); \
	errAdd(error,"ic0dig",ic0digERR_SWITCH_OFF,__FILE_LINE__,"%s,%s",(p1),(p2)); \
	}
#define ic0digErrStandbyOn(p1,p2) \
	{ \
	lcctooLOG_0("ic0digERR_STANDBY_ON: Device %s: Error switching the lamp to standby mode (%s).",(p1),(p2)); \
	errAdd(error,"ic0dig",ic0digERR_STANDBY_ON,__FILE_LINE__,"%s,%s",(p1),(p2)); \
	}
#define ic0digErrStandbyOff(p1,p2) \
	{ \
	lcctooLOG_0("ic0digERR_STANDBY_OFF: Device %s: Error switching off the standby mode of the lamp (%s).",(p1),(p2)); \
	errAdd(error,"ic0dig",ic0digERR_STANDBY_OFF,__FILE_LINE__,"%s,%s",(p1),(p2)); \
	}
#define ic0digErrWaitTimeout(p1,p2,p3) \
	{ \
	lcctooLOG_0("ic0digERR_WAIT_TIMEOUT: Device %s: Lamp needs still %d secs. warm up time (timeout=%d).",(p1),(p2),(p3)); \
	errAdd(error,"ic0dig",ic0digERR_WAIT_TIMEOUT,__FILE_LINE__,"%s,%d,%d",(p1),(p2),(p3)); \
	}
#define ic0digErrWaitStopped(p1) \
	{ \
	lcctooLOG_0("ic0digERR_WAIT_STOPPED: Device %s: WAIT interrupted by STOP command.",(p1)); \
	errAdd(error,"ic0dig",ic0digERR_WAIT_STOPPED,__FILE_LINE__,"%s",(p1)); \
	}

/*
 * get object owner
 */
#define ic0digLampGetOwner(obj) ((obj)->owner)


/*
 * attribute access functions
 */
#define ic0digLampReadState(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digLAMP_ATTR_STATE,(buf),(error))
#define ic0digLampWriteState(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digLAMP_ATTR_STATE,(void*) (buf),(error))
#define ic0digLampReadSubstate(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digLAMP_ATTR_SUBSTATE,(buf),(error))
#define ic0digLampWriteSubstate(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digLAMP_ATTR_SUBSTATE,(void*) (buf),(error))
#define ic0digLampReadError(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digLAMP_ATTR_ERROR,(buf),(error))
#define ic0digLampWriteError(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digLAMP_ATTR_ERROR,(void*) (buf),(error))
#define ic0digLampReadInitialised(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digLAMP_ATTR_INITIALISED,(buf),(error))
#define ic0digLampWriteInitialised(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digLAMP_ATTR_INITIALISED,(void*) (buf),(error))
#define ic0digLampReadSimulation(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digLAMP_ATTR_SIMULATION,(buf),(error))
#define ic0digLampWriteSimulation(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digLAMP_ATTR_SIMULATION,(void*) (buf),(error))
#define ic0digLampReadDevice(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digLAMP_ATTR_DEVICE,(buf),(error))
#define ic0digLampWriteDevice(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digLAMP_ATTR_DEVICE,(void*) (buf),(error))
#define ic0digLampReadAvailable(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digLAMP_ATTR_AVAILABLE,(buf),(error))
#define ic0digLampWriteAvailable(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digLAMP_ATTR_AVAILABLE,(void*) (buf),(error))
#define ic0digLampReadEnabled(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digLAMP_ATTR_ENABLED,(buf),(error))
#define ic0digLampWriteEnabled(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digLAMP_ATTR_ENABLED,(void*) (buf),(error))
#define ic0digLampReadLocked(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digLAMP_ATTR_LOCKED,(buf),(error))
#define ic0digLampWriteLocked(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digLAMP_ATTR_LOCKED,(void*) (buf),(error))
#define ic0digLampReadHandset(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digLAMP_ATTR_HANDSET,(buf),(error))
#define ic0digLampWriteHandset(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digLAMP_ATTR_HANDSET,(void*) (buf),(error))
#define ic0digLampReadFixed(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digLAMP_ATTR_FIXED,(buf),(error))
#define ic0digLampWriteFixed(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digLAMP_ATTR_FIXED,(void*) (buf),(error))
#define ic0digLampReadFixPosSet(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digLAMP_ATTR_FIX_POS_SET,(buf),(error))
#define ic0digLampWriteFixPosSet(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digLAMP_ATTR_FIX_POS_SET,(void*) (buf),(error))
#define ic0digLampReadFixedPosition(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digLAMP_ATTR_FIXED_POSITION,(buf),(error))
#define ic0digLampWriteFixedPosition(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digLAMP_ATTR_FIXED_POSITION,(void*) (buf),(error))
#define ic0digLampReadFixedSimulation(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digLAMP_ATTR_FIXED_SIMULATION,(buf),(error))
#define ic0digLampWriteFixedSimulation(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digLAMP_ATTR_FIXED_SIMULATION,(void*) (buf),(error))
#define ic0digLampReadFixedLocked(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digLAMP_ATTR_FIXED_LOCKED,(buf),(error))
#define ic0digLampWriteFixedLocked(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digLAMP_ATTR_FIXED_LOCKED,(void*) (buf),(error))
#define ic0digLampReadPrefix(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digLAMP_ATTR_PREFIX,(buf),(error))
#define ic0digLampWritePrefix(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digLAMP_ATTR_PREFIX,(void*) (buf),(error))
#define ic0digLampReadParametersSize(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digLAMP_ATTR_PARAMETERS_SIZE,(buf),(error))
#define ic0digLampWriteParametersSize(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digLAMP_ATTR_PARAMETERS_SIZE,(void*) (buf),(error))
#define ic0digLampGetParametersSize(obj,num,error) \
	caiGetAttrInfo((obj)->attrs,ic0digLAMP_ATTR_PARAMETERS,NULL,NULL,(num),NULL, NULL,NULL,(error))
#define ic0digLampReadParameters(obj,buf,firstRec,lastRec,firstFld,lastFld,error) \
	lcctooCaiRWTable((obj)->attrs,0,ic0digLAMP_ATTR_PARAMETERS,(buf),(firstRec),(lastRec),(firstFld),(lastFld),(error))
#define ic0digLampWriteParameters(obj,buf,firstRec,lastRec,firstFld,lastFld,error) \
	lcctooCaiRWTable((obj)->attrs,1,ic0digLAMP_ATTR_PARAMETERS,(void*) (buf),(firstRec),(lastRec),(firstFld),(lastFld),(error))
#define ic0digLampGetStatusSize(obj,num,error) \
	caiGetAttrInfo((obj)->attrs,ic0digLAMP_ATTR_STATUS,NULL,NULL,(num),NULL, NULL,NULL,(error))
#define ic0digLampReadStatus(obj,buf,firstElt,lastElt,error) \
	caiRWVector((obj)->attrs,0,ic0digLAMP_ATTR_STATUS,(buf),(firstElt),(lastElt),(error))
#define ic0digLampWriteStatus(obj,buf,firstElt,lastElt,error) \
	caiRWVector((obj)->attrs,1,ic0digLAMP_ATTR_STATUS,(void*) (buf),(firstElt),(lastElt),(error))
#define ic0digLampGetStatusIndexSize(obj,num,error) \
	caiGetAttrInfo((obj)->attrs,ic0digLAMP_ATTR_STATUS_INDEX,NULL,NULL,(num),NULL, NULL,NULL,(error))
#define ic0digLampReadStatusIndex(obj,buf,firstElt,lastElt,error) \
	caiRWVector((obj)->attrs,0,ic0digLAMP_ATTR_STATUS_INDEX,(buf),(firstElt),(lastElt),(error))
#define ic0digLampWriteStatusIndex(obj,buf,firstElt,lastElt,error) \
	caiRWVector((obj)->attrs,1,ic0digLAMP_ATTR_STATUS_INDEX,(void*) (buf),(firstElt),(lastElt),(error))
#define ic0digLampReadValuesSize(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digLAMP_ATTR_VALUES_SIZE,(buf),(error))
#define ic0digLampWriteValuesSize(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digLAMP_ATTR_VALUES_SIZE,(void*) (buf),(error))
#define ic0digLampGetValuesSize(obj,num,error) \
	caiGetAttrInfo((obj)->attrs,ic0digLAMP_ATTR_VALUES,NULL,NULL,(num),NULL, NULL,NULL,(error))
#define ic0digLampReadValues(obj,buf,firstRec,lastRec,firstFld,lastFld,error) \
	lcctooCaiRWTable((obj)->attrs,0,ic0digLAMP_ATTR_VALUES,(buf),(firstRec),(lastRec),(firstFld),(lastFld),(error))
#define ic0digLampWriteValues(obj,buf,firstRec,lastRec,firstFld,lastFld,error) \
	lcctooCaiRWTable((obj)->attrs,1,ic0digLAMP_ATTR_VALUES,(void*) (buf),(firstRec),(lastRec),(firstFld),(lastFld),(error))
#define ic0digLampReadInitRestriction(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digLAMP_ATTR_INIT_RESTRICTION,(buf),(error))
#define ic0digLampWriteInitRestriction(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digLAMP_ATTR_INIT_RESTRICTION,(void*) (buf),(error))
#define ic0digLampReadMoveRestriction(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digLAMP_ATTR_MOVE_RESTRICTION,(buf),(error))
#define ic0digLampWriteMoveRestriction(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digLAMP_ATTR_MOVE_RESTRICTION,(void*) (buf),(error))
#define ic0digLampReadStopTimeout(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digLAMP_ATTR_STOP_TIMEOUT,(buf),(error))
#define ic0digLampWriteStopTimeout(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digLAMP_ATTR_STOP_TIMEOUT,(void*) (buf),(error))
#define ic0digLampReadSetValFct(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digLAMP_ATTR_SET_VAL_FCT,(buf),(error))
#define ic0digLampWriteSetValFct(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digLAMP_ATTR_SET_VAL_FCT,(void*) (buf),(error))
#define ic0digLampGetHelpTextSize(obj,num,error) \
	caiGetAttrInfo((obj)->attrs,ic0digLAMP_ATTR_HELP_TEXT,NULL,NULL,(num),NULL, NULL,NULL,(error))
#define ic0digLampReadHelpText(obj,buf,firstElt,lastElt,error) \
	caiRWVector((obj)->attrs,0,ic0digLAMP_ATTR_HELP_TEXT,(buf),(firstElt),(lastElt),(error))
#define ic0digLampWriteHelpText(obj,buf,firstElt,lastElt,error) \
	caiRWVector((obj)->attrs,1,ic0digLAMP_ATTR_HELP_TEXT,(void*) (buf),(firstElt),(lastElt),(error))
#define ic0digLampReadParamStep(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digLAMP_ATTR_PARAM_STEP,(buf),(error))
#define ic0digLampWriteParamStep(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digLAMP_ATTR_PARAM_STEP,(void*) (buf),(error))
#define ic0digLampReadActionCommand(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digLAMP_ATTR_ACTION_COMMAND,(buf),(error))
#define ic0digLampWriteActionCommand(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digLAMP_ATTR_ACTION_COMMAND,(void*) (buf),(error))
#define ic0digLampReadActionStopReq(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digLAMP_ATTR_ACTION_STOP_REQ,(buf),(error))
#define ic0digLampWriteActionStopReq(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digLAMP_ATTR_ACTION_STOP_REQ,(void*) (buf),(error))
#define ic0digLampReadActionNoMove(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digLAMP_ATTR_ACTION_NO_MOVE,(buf),(error))
#define ic0digLampWriteActionNoMove(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digLAMP_ATTR_ACTION_NO_MOVE,(void*) (buf),(error))
#define ic0digLampReadActionCheck(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digLAMP_ATTR_ACTION_CHECK,(buf),(error))
#define ic0digLampWriteActionCheck(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digLAMP_ATTR_ACTION_CHECK,(void*) (buf),(error))
#define ic0digLampReadResetSetupCmd(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digLAMP_ATTR_RESET_SETUP_CMD,(buf),(error))
#define ic0digLampWriteResetSetupCmd(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digLAMP_ATTR_RESET_SETUP_CMD,(void*) (buf),(error))
#define ic0digLampReadId(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digLAMP_ATTR_ID,(buf),(error))
#define ic0digLampWriteId(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digLAMP_ATTR_ID,(void*) (buf),(error))
#define ic0digLampReadName(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digLAMP_ATTR_NAME,(buf),(error))
#define ic0digLampWriteName(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digLAMP_ATTR_NAME,(void*) (buf),(error))
#define ic0digLampGetSignalsSize(obj,num,error) \
	caiGetAttrInfo((obj)->attrs,ic0digLAMP_ATTR_SIGNALS,NULL,NULL,(num),NULL, NULL,NULL,(error))
#define ic0digLampReadSignals(obj,buf,firstRec,lastRec,firstFld,lastFld,error) \
	lcctooCaiRWTable((obj)->attrs,0,ic0digLAMP_ATTR_SIGNALS,(buf),(firstRec),(lastRec),(firstFld),(lastFld),(error))
#define ic0digLampWriteSignals(obj,buf,firstRec,lastRec,firstFld,lastFld,error) \
	lcctooCaiRWTable((obj)->attrs,1,ic0digLAMP_ATTR_SIGNALS,(void*) (buf),(firstRec),(lastRec),(firstFld),(lastFld),(error))
#define ic0digLampReadConfigured(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digLAMP_ATTR_CONFIGURED,(buf),(error))
#define ic0digLampWriteConfigured(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digLAMP_ATTR_CONFIGURED,(void*) (buf),(error))
#define ic0digLampReadHwAccess(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digLAMP_ATTR_HW_ACCESS,(buf),(error))
#define ic0digLampWriteHwAccess(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digLAMP_ATTR_HW_ACCESS,(void*) (buf),(error))
#define ic0digLampReadTimeStbyAccess(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digLAMP_ATTR_TIME_STBY_ACCESS,(buf),(error))
#define ic0digLampWriteTimeStbyAccess(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digLAMP_ATTR_TIME_STBY_ACCESS,(void*) (buf),(error))
#define ic0digLampReadTimeStandby(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digLAMP_ATTR_TIME_STANDBY,(buf),(error))
#define ic0digLampWriteTimeStandby(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digLAMP_ATTR_TIME_STANDBY,(void*) (buf),(error))
#define ic0digLampReadTimeAccess(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digLAMP_ATTR_TIME_ACCESS,(buf),(error))
#define ic0digLampWriteTimeAccess(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digLAMP_ATTR_TIME_ACCESS,(void*) (buf),(error))
#define ic0digLampReadTimeOn(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digLAMP_ATTR_TIME_ON,(buf),(error))
#define ic0digLampWriteTimeOn(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digLAMP_ATTR_TIME_ON,(void*) (buf),(error))
#define ic0digLampReadTimeLife(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digLAMP_ATTR_TIME_LIFE,(buf),(error))
#define ic0digLampWriteTimeLife(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digLAMP_ATTR_TIME_LIFE,(void*) (buf),(error))
#define ic0digLampReadTimeSetup(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digLAMP_ATTR_TIME_SETUP,(buf),(error))
#define ic0digLampWriteTimeSetup(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digLAMP_ATTR_TIME_SETUP,(void*) (buf),(error))
#define ic0digLampReadLampOk(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digLAMP_ATTR_LAMP_OK,(buf),(error))
#define ic0digLampWriteLampOk(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digLAMP_ATTR_LAMP_OK,(void*) (buf),(error))
#define ic0digLampReadTimeOffAccess(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digLAMP_ATTR_TIME_OFF_ACCESS,(buf),(error))
#define ic0digLampWriteTimeOffAccess(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digLAMP_ATTR_TIME_OFF_ACCESS,(void*) (buf),(error))
#define ic0digLampReadOffAlarm(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digLAMP_ATTR_OFF_ALARM,(buf),(error))
#define ic0digLampWriteOffAlarm(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digLAMP_ATTR_OFF_ALARM,(void*) (buf),(error))
#define ic0digLampReadLampSwitchO(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digLAMP_ATTR_LAMP_SWITCH_O,(buf),(error))
#define ic0digLampWriteLampSwitchO(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digLAMP_ATTR_LAMP_SWITCH_O,(void*) (buf),(error))
#define ic0digLampReadLampSwitchOStatus(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digLAMP_ATTR_LAMP_SWITCH_O_STATUS,(buf),(error))
#define ic0digLampWriteLampSwitchOStatus(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digLAMP_ATTR_LAMP_SWITCH_O_STATUS,(void*) (buf),(error))
#define ic0digLampReadStandbyO(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digLAMP_ATTR_STANDBY_O,(buf),(error))
#define ic0digLampWriteStandbyO(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digLAMP_ATTR_STANDBY_O,(void*) (buf),(error))
#define ic0digLampReadStandbyOStatus(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digLAMP_ATTR_STANDBY_O_STATUS,(buf),(error))
#define ic0digLampWriteStandbyOStatus(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digLAMP_ATTR_STANDBY_O_STATUS,(void*) (buf),(error))
#define ic0digLampReadValueO(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digLAMP_ATTR_VALUE_O,(buf),(error))
#define ic0digLampWriteValueO(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digLAMP_ATTR_VALUE_O,(void*) (buf),(error))
#define ic0digLampReadValueOStatus(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digLAMP_ATTR_VALUE_O_STATUS,(buf),(error))
#define ic0digLampWriteValueOStatus(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digLAMP_ATTR_VALUE_O_STATUS,(void*) (buf),(error))
#define ic0digLampReadLocalI(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digLAMP_ATTR_LOCAL_I,(buf),(error))
#define ic0digLampWriteLocalI(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digLAMP_ATTR_LOCAL_I,(void*) (buf),(error))
#define ic0digLampReadLocalISim(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digLAMP_ATTR_LOCAL_I_SIM,(buf),(error))
#define ic0digLampWriteLocalISim(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digLAMP_ATTR_LOCAL_I_SIM,(void*) (buf),(error))
#define ic0digLampReadLocalIStatus(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digLAMP_ATTR_LOCAL_I_STATUS,(buf),(error))
#define ic0digLampWriteLocalIStatus(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digLAMP_ATTR_LOCAL_I_STATUS,(void*) (buf),(error))
#define ic0digLampReadLampOnI(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digLAMP_ATTR_LAMP_ON_I,(buf),(error))
#define ic0digLampWriteLampOnI(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digLAMP_ATTR_LAMP_ON_I,(void*) (buf),(error))
#define ic0digLampReadLampOnISim(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digLAMP_ATTR_LAMP_ON_I_SIM,(buf),(error))
#define ic0digLampWriteLampOnISim(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digLAMP_ATTR_LAMP_ON_I_SIM,(void*) (buf),(error))
#define ic0digLampReadLampOnIStatus(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digLAMP_ATTR_LAMP_ON_I_STATUS,(buf),(error))
#define ic0digLampWriteLampOnIStatus(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digLAMP_ATTR_LAMP_ON_I_STATUS,(void*) (buf),(error))
#define ic0digLampReadStandbyI(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digLAMP_ATTR_STANDBY_I,(buf),(error))
#define ic0digLampWriteStandbyI(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digLAMP_ATTR_STANDBY_I,(void*) (buf),(error))
#define ic0digLampReadStandbyISim(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digLAMP_ATTR_STANDBY_I_SIM,(buf),(error))
#define ic0digLampWriteStandbyISim(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digLAMP_ATTR_STANDBY_I_SIM,(void*) (buf),(error))
#define ic0digLampReadStandbyIStatus(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digLAMP_ATTR_STANDBY_I_STATUS,(buf),(error))
#define ic0digLampWriteStandbyIStatus(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digLAMP_ATTR_STANDBY_I_STATUS,(void*) (buf),(error))
#define ic0digLampReadFaultI(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digLAMP_ATTR_FAULT_I,(buf),(error))
#define ic0digLampWriteFaultI(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digLAMP_ATTR_FAULT_I,(void*) (buf),(error))
#define ic0digLampReadFaultISim(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digLAMP_ATTR_FAULT_I_SIM,(buf),(error))
#define ic0digLampWriteFaultISim(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digLAMP_ATTR_FAULT_I_SIM,(void*) (buf),(error))
#define ic0digLampReadFaultIStatus(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digLAMP_ATTR_FAULT_I_STATUS,(buf),(error))
#define ic0digLampWriteFaultIStatus(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digLAMP_ATTR_FAULT_I_STATUS,(void*) (buf),(error))
#define ic0digLampReadLampOkI(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digLAMP_ATTR_LAMP_OK_I,(buf),(error))
#define ic0digLampWriteLampOkI(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digLAMP_ATTR_LAMP_OK_I,(void*) (buf),(error))
#define ic0digLampReadLampOkISim(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digLAMP_ATTR_LAMP_OK_I_SIM,(buf),(error))
#define ic0digLampWriteLampOkISim(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digLAMP_ATTR_LAMP_OK_I_SIM,(void*) (buf),(error))
#define ic0digLampReadLampOkIStatus(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digLAMP_ATTR_LAMP_OK_I_STATUS,(buf),(error))
#define ic0digLampWriteLampOkIStatus(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digLAMP_ATTR_LAMP_OK_I_STATUS,(void*) (buf),(error))
#define ic0digLampReadValueI(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digLAMP_ATTR_VALUE_I,(buf),(error))
#define ic0digLampWriteValueI(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digLAMP_ATTR_VALUE_I,(void*) (buf),(error))
#define ic0digLampReadValueISim(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digLAMP_ATTR_VALUE_I_SIM,(buf),(error))
#define ic0digLampWriteValueISim(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digLAMP_ATTR_VALUE_I_SIM,(void*) (buf),(error))
#define ic0digLampReadValueIStatus(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digLAMP_ATTR_VALUE_I_STATUS,(buf),(error))
#define ic0digLampWriteValueIStatus(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digLAMP_ATTR_VALUE_I_STATUS,(void*) (buf),(error))
#define ic0digLampReadIoUsed(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digLAMP_ATTR_IO_USED,(buf),(error))
#define ic0digLampWriteIoUsed(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digLAMP_ATTR_IO_USED,(void*) (buf),(error))
#define ic0digLampReadUseCfgElem(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digLAMP_ATTR_USE_CFG_ELEM,(buf),(error))
#define ic0digLampWriteUseCfgElem(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digLAMP_ATTR_USE_CFG_ELEM,(void*) (buf),(error))
#define ic0digLampReadDelay(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digLAMP_ATTR_DELAY,(buf),(error))
#define ic0digLampWriteDelay(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digLAMP_ATTR_DELAY,(void*) (buf),(error))
#define ic0digLampReadTid(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digLAMP_ATTR_TID,(buf),(error))
#define ic0digLampWriteTid(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digLAMP_ATTR_TID,(void*) (buf),(error))
#define ic0digLampGetAuto(obj,attrPtr,error) \
	SUCCESS; \
	memcpy((attrPtr), &(obj)->objs[ic0digLAMP_AUTOMATA], sizeof(egenOBJ)); \
	(attrPtr)->ldata = (obj)->ldata;


/*
 * class functions
 */
#define ic0digLampMove(obj,devName,position,positionNum,error) \
	ic0digSoftMove((obj),(devName),(position),(positionNum),(error))
#define ic0digLampMoveRel(obj,devName,position,positionNum,error) \
	ic0digSoftMoveRel((obj),(devName),(position),(positionNum),(error))
#define ic0digLampGetConf(obj,devName,allElements,text,error) \
	ic0digSoftGetConf((obj),(devName),(allElements),(text),(error))
#define ic0digLampGetVal(obj,devName,name,nameNum,status,error) \
	ic0devSoftGetVal((obj),(devName),(name),(nameNum),(status),(error))
#define ic0digLampSetVal(obj,devName,name,nameNum,value,valueNum,error) \
	ic0devSoftSetVal((obj),(devName),(name),(nameNum),(value),(valueNum),(error))
#define ic0digLampLogConf(obj,devName,allElements,error) \
	ic0devSoftLogConf((obj),(devName),(allElements),(error))
#define ic0digLampResetParameters(obj,devName,cmd,error) \
	ic0devSoftResetParameters((obj),(devName),(cmd),(error))
#define ic0digLampParseParameters(obj,devName,cmd,params,paramsNum,noMove,check,error) \
	ic0devSoftParseParameters((obj),(devName),(cmd),(params),(paramsNum),(noMove),(check),(error))
#define ic0digLampCompareParameters(obj,devName,cmd,equal,error) \
	ic0devSoftCompareParameters((obj),(devName),(cmd),(equal),(error))
#define ic0digLampCopyParameters(obj,devName,error) \
	ic0devSoftCopyParameters((obj),(devName),(error))
#define ic0digLampExecParameters(obj,devName,error) \
	ic0devSoftExecParameters((obj),(devName),(error))
#define ic0digLampUpdateParameters(obj,devName,cache,error) \
	ic0devSoftUpdateParameters((obj),(devName),(cache),(error))
#define ic0digLampGetParamSetValue(obj,devName,index,value,setCode,error) \
	ic0devSoftGetParamSetValue((obj),(devName),(index),(value),(setCode),(error))
#define ic0digLampGetParamStatus(obj,devName,index,flags,status,error) \
	ic0devSoftGetParamStatus((obj),(devName),(index),(flags),(status),(error))
#define ic0digLampSetParam(obj,devName,index,cmd,value,step,error) \
	ic0devSoftSetParam((obj),(devName),(index),(cmd),(value),(step),(error))
#define ic0digLampSetParamStep(obj,devName,index,cmd,step,error) \
	ic0devSoftSetParamStep((obj),(devName),(index),(cmd),(step),(error))
#define ic0digLampUsrExecAction(obj,devName,index,error) \
	ic0devSoftUsrExecAction((obj),(devName),(index),(error))
#define ic0digLampUsrSetParameter(obj,devName,cmd,param1,param1SetCode,param2,param2SetCode,value,error) \
	ic0devSoftUsrSetParameter((obj),(devName),(cmd),(param1),(param1SetCode),(param2),(param2SetCode),(value),(error))
#define ic0digLampGetValueCode(obj,devName,name,code,error) \
	ic0devSoftGetValueCode((obj),(devName),(name),(code),(error))
#define ic0digLampGetValue(obj,devName,code,index,value,valueNum,error) \
	ic0devSoftGetValue((obj),(devName),(code),(index),(value),(valueNum),(error))
#define ic0digLampUsrGetValue(obj,devName,valuesTable,valuesTableNum,code,index,value,valueNum,done,error) \
	ic0devSoftUsrGetValue((obj),(devName),(valuesTable),(valuesTableNum),(code),(index),(value),(valueNum),(done),(error))
#define ic0digLampSetValue(obj,devName,code,index,value,valueNum,error) \
	ic0devSoftSetValue((obj),(devName),(code),(index),(value),(valueNum),(error))
#define ic0digLampUsrSetValue(obj,devName,valuesTable,valuesTableNum,code,index,value,valueNum,done,error) \
	ic0devSoftUsrSetValue((obj),(devName),(valuesTable),(valuesTableNum),(code),(index),(value),(valueNum),(done),(error))
#define ic0digLampGetArg(obj,devName,code,index,value,error) \
	ic0devSoftGetArg((obj),(devName),(code),(index),(value),(error))
#define ic0digLampMonitor(obj,devName,error) \
	ic0devSoftMonitor((obj),(devName),(error))
#define ic0digLampLogAction(obj,devName,action,comment,error) \
	ic0devSoftLogAction((obj),(devName),(action),(comment),(error))
#define ic0digLampLogComment(obj,devName,comment,error) \
	ic0devSoftLogComment((obj),(devName),(comment),(error))
#define ic0digLampLogParameter(obj,devName,parameter,index,value,comment,error) \
	ic0devSoftLogParameter((obj),(devName),(parameter),(index),(value),(comment),(error))
#define ic0digLampLogRecovery(obj,devName,comment,error) \
	ic0devSoftLogRecovery((obj),(devName),(comment),(error))
#define ic0digLampLogTblParam(obj,devName,paramIndex,flags,comment,error) \
	ic0devSoftLogTblParam((obj),(devName),(paramIndex),(flags),(comment),(error))
#define ic0digLampLogUnforseen(obj,devName,comment,error) \
	ic0devSoftLogUnforseen((obj),(devName),(comment),(error))
#define ic0digLampUsrStop(obj,devName,req,error) \
	ic0devSoftUsrStop((obj),(devName),(req),(error))
#define ic0digLampInitObj(obj,error) \
	ic0devSoftInitObj((obj),(error))
#define ic0digLampExitObj(obj,error) \
	ic0devSoftExitObj((obj),(error))
#define ic0digLampAvail(obj,devName,error) \
	lccdevCmdAvail((obj),(devName),(error))
#define ic0digLampUnavail(obj,devName,error) \
	lccdevCmdUnavail((obj),(devName),(error))
#define ic0digLampDisable(obj,devName,access,error) \
	lccdevCmdDisable((obj),(devName),(access),(error))
#define ic0digLampEnable(obj,devName,access,error) \
	lccdevCmdEnable((obj),(devName),(access),(error))
#define ic0digLampLock(obj,devName,error) \
	lccdevCmdLock((obj),(devName),(error))
#define ic0digLampUnlock(obj,devName,error) \
	lccdevCmdUnlock((obj),(devName),(error))
#define ic0digLampHandset(obj,devName,error) \
	lccdevCmdHandset((obj),(devName),(error))
#define ic0digLampHsetOff(obj,devName,error) \
	lccdevCmdHsetOff((obj),(devName),(error))
#define ic0digLampFixPos(obj,devName,position,positionNum,reset,error) \
	lccdevCmdFixPos((obj),(devName),(position),(positionNum),(reset),(error))
#define ic0digLampUsrSimulat(obj,devName,error) \
	lccdevCmdUsrSimulat((obj),(devName),(error))
#define ic0digLampUsrStopSim(obj,devName,error) \
	lccdevCmdUsrStopSim((obj),(devName),(error))
#define ic0digLampStandby(obj,devName,error) \
	lccdevStdStandby((obj),(devName),(error))
#define ic0digLampOnline(obj,devName,error) \
	lccdevStdOnline((obj),(devName),(error))
#define ic0digLampOff(obj,devName,error) \
	lccdevStdOff((obj),(devName),(error))
#define ic0digLampExit(obj,devName,error) \
	lccdevStdExit((obj),(devName),(error))
#define ic0digLampState(obj,devName,state,error) \
	lccdevStdState((obj),(devName),(state),(error))
#define ic0digLampSimulat(obj,devName,error) \
	lccdevStdSimulat((obj),(devName),(error))
#define ic0digLampStopSim(obj,devName,error) \
	lccdevStdStopSim((obj),(devName),(error))
#define ic0digLampInit(obj,devName,error) \
	lccdevStdInit((obj),(devName),(error))
#define ic0digLampStop(obj,devName,error) \
	lccdevStdStop((obj),(devName),(error))
#define ic0digLampTest(obj,devName,error) \
	lccdevStdTest((obj),(devName),(error))
#define ic0digLampSelftst(obj,devName,error) \
	lccdevStdSelftst((obj),(devName),(error))
#define ic0digLampAutoTbl(obj,devName,table,text,error) \
	lccdevStdAutoTbl((obj),(devName),(table),(text),(error))
#define ic0digLampAutoRst(obj,devName,error) \
	lccdevStdAutoRst((obj),(devName),(error))
#define ic0digLampLoaded2Stby(obj,devName,error) \
	lccdevStdLoaded2Stby((obj),(devName),(error))
#define ic0digLampOnline2Stby(obj,devName,error) \
	lccdevStdOnline2Stby((obj),(devName),(error))
#define ic0digLampExit1(obj,devName,error) \
	lccdevStdExit1((obj),(devName),(error))
#define ic0digLampCheckDeviceName(obj,devName,error) \
	lccdevStdCheckDeviceName((obj),(devName),(error))
#define ic0digLampBreak(obj,error) \
	lccdevStdBreak((obj),(error))
#define ic0digLampUsrError(obj,devName,error) \
	lccdevStdUsrError((obj),(devName),(error))

ccsCOMPL_STAT ic0digLampSetup(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    const char*	function[],	/* max. vltBYTES32[999] */
    IN    vltINT16	functionNum,
    IN    vltLOGICAL	noMove,
    IN    vltLOGICAL	check,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0digLampSet(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    const char*	position[],	/* max. vltBYTES32[999] */
    IN    vltINT16	positionNum,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0digLampStatus(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    const char*	function[],	/* max. vltBYTES32[999] */
    IN    vltINT16	functionNum,
    IN    vltLOGICAL	flag,
    IN    vltLOGICAL	header,
    IN    vltLOGICAL	conflog,
    IN    vltLOGICAL	opslog,
    IN    vltLOGICAL	condlog,
    OUT   char**	status,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0digLampCheck(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   char**	status,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0digLampWait(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltINT32	timeout,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0digLampCfgElem(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltINT32	position,
    IN    const char*	id,
    IN    const char*	values[],	/* max. vltBYTES16[10] */
    IN    vltINT16	valuesNum,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0digLampUsrInit(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0digLampUsrLoaded2Standby(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0digLampUsrStandby2Online(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0digLampUsrOnline2Standby(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0digLampUsrStandby2Loaded(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0digLampUsrSetMode(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltINT32	cmd,
    IN    vltLOGICAL	available,
    IN    vltLOGICAL	enabled,
    IN    vltLOGICAL	simulation,
    IN    vltLOGICAL	handset,
    IN    vltLOGICAL	locked,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0digLampUsrMonitor(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltINT32	state,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0digLampUsrSelfTest(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0digLampUsrTest(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0digLampStandbyOn(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0digLampStandbyOff(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0digLampUsrStatusCode(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    const char*	text,
    IN    vltINT32	flags,
    OUT   vltINT32*	code,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0digLampUsrStatusValue(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltINT32	code,
    OUT   lcctooVALUE*	value,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0digLampUsrStatusLast(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   vltINT16*	last,
    OUT   ccsERROR*	error);


/*
 * virtual functions
 */
#define ic0digLampVStandby(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_STANDBY)((obj)->fcts[ic0digLAMP_FCT_STANDBY]))) \
	 ((obj),(devName),(error))
#define ic0digLampVOnline(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_ONLINE)((obj)->fcts[ic0digLAMP_FCT_ONLINE]))) \
	 ((obj),(devName),(error))
#define ic0digLampVOff(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_OFF)((obj)->fcts[ic0digLAMP_FCT_OFF]))) \
	 ((obj),(devName),(error))
#define ic0digLampVExit(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_EXIT)((obj)->fcts[ic0digLAMP_FCT_EXIT]))) \
	 ((obj),(devName),(error))
#define ic0digLampVState(obj,devName,state,error) \
	(*((lccdevSTD_FCTPTR_STATE)((obj)->fcts[ic0digLAMP_FCT_STATE]))) \
	 ((obj),(devName),(state),(error))
#define ic0digLampVSimulat(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_SIMULAT)((obj)->fcts[ic0digLAMP_FCT_SIMULAT]))) \
	 ((obj),(devName),(error))
#define ic0digLampVStopSim(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_STOP_SIM)((obj)->fcts[ic0digLAMP_FCT_STOP_SIM]))) \
	 ((obj),(devName),(error))
#define ic0digLampVStatus(obj,devName,function,functionNum,flag,header,conflog,opslog,condlog,status,error) \
	(*((ic0digLAMP_FCTPTR_STATUS)((obj)->fcts[ic0digLAMP_FCT_STATUS]))) \
	 ((obj),(devName),(function),(functionNum),(flag),(header),(conflog),(opslog),(condlog),(status),(error))
#define ic0digLampVInit(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_INIT)((obj)->fcts[ic0digLAMP_FCT_INIT]))) \
	 ((obj),(devName),(error))
#define ic0digLampVStop(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_STOP)((obj)->fcts[ic0digLAMP_FCT_STOP]))) \
	 ((obj),(devName),(error))
#define ic0digLampVTest(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_TEST)((obj)->fcts[ic0digLAMP_FCT_TEST]))) \
	 ((obj),(devName),(error))
#define ic0digLampVSelftst(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_SELFTST)((obj)->fcts[ic0digLAMP_FCT_SELFTST]))) \
	 ((obj),(devName),(error))
#define ic0digLampVAutoTbl(obj,devName,table,text,error) \
	(*((lccdevSTD_FCTPTR_AUTO_TBL)((obj)->fcts[ic0digLAMP_FCT_AUTO_TBL]))) \
	 ((obj),(devName),(table),(text),(error))
#define ic0digLampVAutoRst(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_AUTO_RST)((obj)->fcts[ic0digLAMP_FCT_AUTO_RST]))) \
	 ((obj),(devName),(error))
#define ic0digLampVInitObj(obj,error) \
	(*((ic0devSOFT_FCTPTR_INIT_OBJ)((obj)->fcts[ic0digLAMP_FCT_INIT_OBJ]))) \
	 ((obj),(error))
#define ic0digLampVExitObj(obj,error) \
	(*((ic0devSOFT_FCTPTR_EXIT_OBJ)((obj)->fcts[ic0digLAMP_FCT_EXIT_OBJ]))) \
	 ((obj),(error))
#define ic0digLampVLoaded2Stby(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_LOADED2STBY)((obj)->fcts[ic0digLAMP_FCT_LOADED2STBY]))) \
	 ((obj),(devName),(error))
#define ic0digLampVOnline2Stby(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_ONLINE2STBY)((obj)->fcts[ic0digLAMP_FCT_ONLINE2STBY]))) \
	 ((obj),(devName),(error))
#define ic0digLampVExit1(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_EXIT1)((obj)->fcts[ic0digLAMP_FCT_EXIT1]))) \
	 ((obj),(devName),(error))
#define ic0digLampVCheckDeviceName(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_CHECK_DEVICE_NAME)((obj)->fcts[ic0digLAMP_FCT_CHECK_DEVICE_NAME]))) \
	 ((obj),(devName),(error))
#define ic0digLampVBreak(obj,error) \
	(*((lccdevSTD_FCTPTR_BREAK)((obj)->fcts[ic0digLAMP_FCT_BREAK]))) \
	 ((obj),(error))
#define ic0digLampVUsrInit(obj,devName,error) \
	(*((ic0digLAMP_FCTPTR_USR_INIT)((obj)->fcts[ic0digLAMP_FCT_USR_INIT]))) \
	 ((obj),(devName),(error))
#define ic0digLampVUsrLoaded2Standby(obj,devName,error) \
	(*((ic0digLAMP_FCTPTR_USR_LOADED2STANDBY)((obj)->fcts[ic0digLAMP_FCT_USR_LOADED2STANDBY]))) \
	 ((obj),(devName),(error))
#define ic0digLampVUsrStandby2Online(obj,devName,error) \
	(*((ic0digLAMP_FCTPTR_USR_STANDBY2ONLINE)((obj)->fcts[ic0digLAMP_FCT_USR_STANDBY2ONLINE]))) \
	 ((obj),(devName),(error))
#define ic0digLampVUsrOnline2Standby(obj,devName,error) \
	(*((ic0digLAMP_FCTPTR_USR_ONLINE2STANDBY)((obj)->fcts[ic0digLAMP_FCT_USR_ONLINE2STANDBY]))) \
	 ((obj),(devName),(error))
#define ic0digLampVUsrStandby2Loaded(obj,devName,error) \
	(*((ic0digLAMP_FCTPTR_USR_STANDBY2LOADED)((obj)->fcts[ic0digLAMP_FCT_USR_STANDBY2LOADED]))) \
	 ((obj),(devName),(error))
#define ic0digLampVUsrStop(obj,devName,req,error) \
	(*((ic0devSOFT_FCTPTR_USR_STOP)((obj)->fcts[ic0digLAMP_FCT_USR_STOP]))) \
	 ((obj),(devName),(req),(error))
#define ic0digLampVUsrSimulat(obj,devName,error) \
	(*((lccdevCMD_FCTPTR_USR_SIMULAT)((obj)->fcts[ic0digLAMP_FCT_USR_SIMULAT]))) \
	 ((obj),(devName),(error))
#define ic0digLampVUsrStopSim(obj,devName,error) \
	(*((lccdevCMD_FCTPTR_USR_STOP_SIM)((obj)->fcts[ic0digLAMP_FCT_USR_STOP_SIM]))) \
	 ((obj),(devName),(error))
#define ic0digLampVUsrStatusCode(obj,devName,text,flags,code,error) \
	(*((ic0digLAMP_FCTPTR_USR_STATUS_CODE)((obj)->fcts[ic0digLAMP_FCT_USR_STATUS_CODE]))) \
	 ((obj),(devName),(text),(flags),(code),(error))
#define ic0digLampVUsrStatusLast(obj,devName,last,error) \
	(*((ic0digLAMP_FCTPTR_USR_STATUS_LAST)((obj)->fcts[ic0digLAMP_FCT_USR_STATUS_LAST]))) \
	 ((obj),(devName),(last),(error))
#define ic0digLampVUsrStatusValue(obj,devName,code,value,error) \
	(*((ic0digLAMP_FCTPTR_USR_STATUS_VALUE)((obj)->fcts[ic0digLAMP_FCT_USR_STATUS_VALUE]))) \
	 ((obj),(devName),(code),(value),(error))
#define ic0digLampVUsrTest(obj,devName,error) \
	(*((ic0digLAMP_FCTPTR_USR_TEST)((obj)->fcts[ic0digLAMP_FCT_USR_TEST]))) \
	 ((obj),(devName),(error))
#define ic0digLampVUsrSelfTest(obj,devName,error) \
	(*((ic0digLAMP_FCTPTR_USR_SELF_TEST)((obj)->fcts[ic0digLAMP_FCT_USR_SELF_TEST]))) \
	 ((obj),(devName),(error))
#define ic0digLampVUsrError(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_USR_ERROR)((obj)->fcts[ic0digLAMP_FCT_USR_ERROR]))) \
	 ((obj),(devName),(error))
#define ic0digLampVAvail(obj,devName,error) \
	(*((lccdevCMD_FCTPTR_AVAIL)((obj)->fcts[ic0digLAMP_FCT_AVAIL]))) \
	 ((obj),(devName),(error))
#define ic0digLampVUnavail(obj,devName,error) \
	(*((lccdevCMD_FCTPTR_UNAVAIL)((obj)->fcts[ic0digLAMP_FCT_UNAVAIL]))) \
	 ((obj),(devName),(error))
#define ic0digLampVDisable(obj,devName,access,error) \
	(*((lccdevCMD_FCTPTR_DISABLE)((obj)->fcts[ic0digLAMP_FCT_DISABLE]))) \
	 ((obj),(devName),(access),(error))
#define ic0digLampVEnable(obj,devName,access,error) \
	(*((lccdevCMD_FCTPTR_ENABLE)((obj)->fcts[ic0digLAMP_FCT_ENABLE]))) \
	 ((obj),(devName),(access),(error))
#define ic0digLampVLock(obj,devName,error) \
	(*((lccdevCMD_FCTPTR_LOCK)((obj)->fcts[ic0digLAMP_FCT_LOCK]))) \
	 ((obj),(devName),(error))
#define ic0digLampVUnlock(obj,devName,error) \
	(*((lccdevCMD_FCTPTR_UNLOCK)((obj)->fcts[ic0digLAMP_FCT_UNLOCK]))) \
	 ((obj),(devName),(error))
#define ic0digLampVHandset(obj,devName,error) \
	(*((lccdevCMD_FCTPTR_HANDSET)((obj)->fcts[ic0digLAMP_FCT_HANDSET]))) \
	 ((obj),(devName),(error))
#define ic0digLampVHsetOff(obj,devName,error) \
	(*((lccdevCMD_FCTPTR_HSET_OFF)((obj)->fcts[ic0digLAMP_FCT_HSET_OFF]))) \
	 ((obj),(devName),(error))
#define ic0digLampVFixPos(obj,devName,position,positionNum,reset,error) \
	(*((lccdevCMD_FCTPTR_FIX_POS)((obj)->fcts[ic0digLAMP_FCT_FIX_POS]))) \
	 ((obj),(devName),(position),(positionNum),(reset),(error))
#define ic0digLampVMove(obj,devName,position,positionNum,error) \
	(*((ic0digSOFT_FCTPTR_MOVE)((obj)->fcts[ic0digLAMP_FCT_MOVE]))) \
	 ((obj),(devName),(position),(positionNum),(error))
#define ic0digLampVMoveRel(obj,devName,position,positionNum,error) \
	(*((ic0digSOFT_FCTPTR_MOVE_REL)((obj)->fcts[ic0digLAMP_FCT_MOVE_REL]))) \
	 ((obj),(devName),(position),(positionNum),(error))
#define ic0digLampVSet(obj,devName,position,positionNum,error) \
	(*((ic0digLAMP_FCTPTR_SET)((obj)->fcts[ic0digLAMP_FCT_SET]))) \
	 ((obj),(devName),(position),(positionNum),(error))
#define ic0digLampVCheck(obj,devName,status,error) \
	(*((ic0digLAMP_FCTPTR_CHECK)((obj)->fcts[ic0digLAMP_FCT_CHECK]))) \
	 ((obj),(devName),(status),(error))
#define ic0digLampVWait(obj,devName,timeout,error) \
	(*((ic0digLAMP_FCTPTR_WAIT)((obj)->fcts[ic0digLAMP_FCT_WAIT]))) \
	 ((obj),(devName),(timeout),(error))
#define ic0digLampVUsrSetMode(obj,devName,cmd,available,enabled,simulation,handset,locked,error) \
	(*((ic0digLAMP_FCTPTR_USR_SET_MODE)((obj)->fcts[ic0digLAMP_FCT_USR_SET_MODE]))) \
	 ((obj),(devName),(cmd),(available),(enabled),(simulation),(handset),(locked),(error))
#define ic0digLampVSetup(obj,devName,function,functionNum,noMove,check,error) \
	(*((ic0digLAMP_FCTPTR_SETUP)((obj)->fcts[ic0digLAMP_FCT_SETUP]))) \
	 ((obj),(devName),(function),(functionNum),(noMove),(check),(error))
#define ic0digLampVGetVal(obj,devName,name,nameNum,status,error) \
	(*((ic0devSOFT_FCTPTR_GET_VAL)((obj)->fcts[ic0digLAMP_FCT_GET_VAL]))) \
	 ((obj),(devName),(name),(nameNum),(status),(error))
#define ic0digLampVSetVal(obj,devName,name,nameNum,value,valueNum,error) \
	(*((ic0devSOFT_FCTPTR_SET_VAL)((obj)->fcts[ic0digLAMP_FCT_SET_VAL]))) \
	 ((obj),(devName),(name),(nameNum),(value),(valueNum),(error))
#define ic0digLampVCfgElem(obj,devName,position,id,values,valuesNum,error) \
	(*((ic0digLAMP_FCTPTR_CFG_ELEM)((obj)->fcts[ic0digLAMP_FCT_CFG_ELEM]))) \
	 ((obj),(devName),(position),(id),(values),(valuesNum),(error))
#define ic0digLampVLogConf(obj,devName,allElements,error) \
	(*((ic0devSOFT_FCTPTR_LOG_CONF)((obj)->fcts[ic0digLAMP_FCT_LOG_CONF]))) \
	 ((obj),(devName),(allElements),(error))
#define ic0digLampVGetConf(obj,devName,allElements,text,error) \
	(*((ic0digSOFT_FCTPTR_GET_CONF)((obj)->fcts[ic0digLAMP_FCT_GET_CONF]))) \
	 ((obj),(devName),(allElements),(text),(error))
#define ic0digLampVResetParameters(obj,devName,cmd,error) \
	(*((ic0devSOFT_FCTPTR_RESET_PARAMETERS)((obj)->fcts[ic0digLAMP_FCT_RESET_PARAMETERS]))) \
	 ((obj),(devName),(cmd),(error))
#define ic0digLampVParseParameters(obj,devName,cmd,params,paramsNum,noMove,check,error) \
	(*((ic0devSOFT_FCTPTR_PARSE_PARAMETERS)((obj)->fcts[ic0digLAMP_FCT_PARSE_PARAMETERS]))) \
	 ((obj),(devName),(cmd),(params),(paramsNum),(noMove),(check),(error))
#define ic0digLampVCompareParameters(obj,devName,cmd,equal,error) \
	(*((ic0devSOFT_FCTPTR_COMPARE_PARAMETERS)((obj)->fcts[ic0digLAMP_FCT_COMPARE_PARAMETERS]))) \
	 ((obj),(devName),(cmd),(equal),(error))
#define ic0digLampVCopyParameters(obj,devName,error) \
	(*((ic0devSOFT_FCTPTR_COPY_PARAMETERS)((obj)->fcts[ic0digLAMP_FCT_COPY_PARAMETERS]))) \
	 ((obj),(devName),(error))
#define ic0digLampVExecParameters(obj,devName,error) \
	(*((ic0devSOFT_FCTPTR_EXEC_PARAMETERS)((obj)->fcts[ic0digLAMP_FCT_EXEC_PARAMETERS]))) \
	 ((obj),(devName),(error))
#define ic0digLampVUpdateParameters(obj,devName,cache,error) \
	(*((ic0devSOFT_FCTPTR_UPDATE_PARAMETERS)((obj)->fcts[ic0digLAMP_FCT_UPDATE_PARAMETERS]))) \
	 ((obj),(devName),(cache),(error))
#define ic0digLampVGetParamSetValue(obj,devName,index,value,setCode,error) \
	(*((ic0devSOFT_FCTPTR_GET_PARAM_SET_VALUE)((obj)->fcts[ic0digLAMP_FCT_GET_PARAM_SET_VALUE]))) \
	 ((obj),(devName),(index),(value),(setCode),(error))
#define ic0digLampVGetParamStatus(obj,devName,index,flags,status,error) \
	(*((ic0devSOFT_FCTPTR_GET_PARAM_STATUS)((obj)->fcts[ic0digLAMP_FCT_GET_PARAM_STATUS]))) \
	 ((obj),(devName),(index),(flags),(status),(error))
#define ic0digLampVSetParam(obj,devName,index,cmd,value,step,error) \
	(*((ic0devSOFT_FCTPTR_SET_PARAM)((obj)->fcts[ic0digLAMP_FCT_SET_PARAM]))) \
	 ((obj),(devName),(index),(cmd),(value),(step),(error))
#define ic0digLampVSetParamStep(obj,devName,index,cmd,step,error) \
	(*((ic0devSOFT_FCTPTR_SET_PARAM_STEP)((obj)->fcts[ic0digLAMP_FCT_SET_PARAM_STEP]))) \
	 ((obj),(devName),(index),(cmd),(step),(error))
#define ic0digLampVUsrExecAction(obj,devName,index,error) \
	(*((ic0devSOFT_FCTPTR_USR_EXEC_ACTION)((obj)->fcts[ic0digLAMP_FCT_USR_EXEC_ACTION]))) \
	 ((obj),(devName),(index),(error))
#define ic0digLampVUsrSetParameter(obj,devName,cmd,param1,param1SetCode,param2,param2SetCode,value,error) \
	(*((ic0devSOFT_FCTPTR_USR_SET_PARAMETER)((obj)->fcts[ic0digLAMP_FCT_USR_SET_PARAMETER]))) \
	 ((obj),(devName),(cmd),(param1),(param1SetCode),(param2),(param2SetCode),(value),(error))
#define ic0digLampVGetValueCode(obj,devName,name,code,error) \
	(*((ic0devSOFT_FCTPTR_GET_VALUE_CODE)((obj)->fcts[ic0digLAMP_FCT_GET_VALUE_CODE]))) \
	 ((obj),(devName),(name),(code),(error))
#define ic0digLampVGetValue(obj,devName,code,index,value,valueNum,error) \
	(*((ic0devSOFT_FCTPTR_GET_VALUE)((obj)->fcts[ic0digLAMP_FCT_GET_VALUE]))) \
	 ((obj),(devName),(code),(index),(value),(valueNum),(error))
#define ic0digLampVUsrGetValue(obj,devName,valuesTable,valuesTableNum,code,index,value,valueNum,done,error) \
	(*((ic0devSOFT_FCTPTR_USR_GET_VALUE)((obj)->fcts[ic0digLAMP_FCT_USR_GET_VALUE]))) \
	 ((obj),(devName),(valuesTable),(valuesTableNum),(code),(index),(value),(valueNum),(done),(error))
#define ic0digLampVSetValue(obj,devName,code,index,value,valueNum,error) \
	(*((ic0devSOFT_FCTPTR_SET_VALUE)((obj)->fcts[ic0digLAMP_FCT_SET_VALUE]))) \
	 ((obj),(devName),(code),(index),(value),(valueNum),(error))
#define ic0digLampVUsrSetValue(obj,devName,valuesTable,valuesTableNum,code,index,value,valueNum,done,error) \
	(*((ic0devSOFT_FCTPTR_USR_SET_VALUE)((obj)->fcts[ic0digLAMP_FCT_USR_SET_VALUE]))) \
	 ((obj),(devName),(valuesTable),(valuesTableNum),(code),(index),(value),(valueNum),(done),(error))
#define ic0digLampVGetArg(obj,devName,code,index,value,error) \
	(*((ic0devSOFT_FCTPTR_GET_ARG)((obj)->fcts[ic0digLAMP_FCT_GET_ARG]))) \
	 ((obj),(devName),(code),(index),(value),(error))
#define ic0digLampVMonitor(obj,devName,error) \
	(*((ic0devSOFT_FCTPTR_MONITOR)((obj)->fcts[ic0digLAMP_FCT_MONITOR]))) \
	 ((obj),(devName),(error))
#define ic0digLampVUsrMonitor(obj,devName,state,error) \
	(*((ic0digLAMP_FCTPTR_USR_MONITOR)((obj)->fcts[ic0digLAMP_FCT_USR_MONITOR]))) \
	 ((obj),(devName),(state),(error))
#define ic0digLampVLogAction(obj,devName,action,comment,error) \
	(*((ic0devSOFT_FCTPTR_LOG_ACTION)((obj)->fcts[ic0digLAMP_FCT_LOG_ACTION]))) \
	 ((obj),(devName),(action),(comment),(error))
#define ic0digLampVLogComment(obj,devName,comment,error) \
	(*((ic0devSOFT_FCTPTR_LOG_COMMENT)((obj)->fcts[ic0digLAMP_FCT_LOG_COMMENT]))) \
	 ((obj),(devName),(comment),(error))
#define ic0digLampVLogParameter(obj,devName,parameter,index,value,comment,error) \
	(*((ic0devSOFT_FCTPTR_LOG_PARAMETER)((obj)->fcts[ic0digLAMP_FCT_LOG_PARAMETER]))) \
	 ((obj),(devName),(parameter),(index),(value),(comment),(error))
#define ic0digLampVLogRecovery(obj,devName,comment,error) \
	(*((ic0devSOFT_FCTPTR_LOG_RECOVERY)((obj)->fcts[ic0digLAMP_FCT_LOG_RECOVERY]))) \
	 ((obj),(devName),(comment),(error))
#define ic0digLampVLogTblParam(obj,devName,paramIndex,flags,comment,error) \
	(*((ic0devSOFT_FCTPTR_LOG_TBL_PARAM)((obj)->fcts[ic0digLAMP_FCT_LOG_TBL_PARAM]))) \
	 ((obj),(devName),(paramIndex),(flags),(comment),(error))
#define ic0digLampVLogUnforseen(obj,devName,comment,error) \
	(*((ic0devSOFT_FCTPTR_LOG_UNFORSEEN)((obj)->fcts[ic0digLAMP_FCT_LOG_UNFORSEEN]))) \
	 ((obj),(devName),(comment),(error))
#define ic0digLampVStandbyOn(obj,devName,error) \
	(*((ic0digLAMP_FCTPTR_STANDBY_ON)((obj)->fcts[ic0digLAMP_FCT_STANDBY_ON]))) \
	 ((obj),(devName),(error))
#define ic0digLampVStandbyOff(obj,devName,error) \
	(*((ic0digLAMP_FCTPTR_STANDBY_OFF)((obj)->fcts[ic0digLAMP_FCT_STANDBY_OFF]))) \
	 ((obj),(devName),(error))


ccsCOMPL_STAT ic0digLampNewObj(
    IN    dbSYMADDRESS	point,
    IN    egenOBJ*	owner,
    OUT   egenOBJ*	obj,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0digLampDeleteObj(
    INOUT egenOBJ*	obj,
    OUT   ccsERROR*	error);


ccsCOMPL_STAT ic0digLampWaitCmd(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltINT32	timeout,
    OUT   ccsERROR*	error);


#endif // !IC0DIG_LAMP_H

/************************************************************************/
/* ___oOo___ */
