/******************************************************************************
*  E.S.O. - VLT project
* 
*  "@(#) $Id: ic0digShutter.h,v 1.35 2005/09/09 18:58:44 vltsccm Exp $"
* 
*  who        when      what
*  ---------- --------  ----------------------------------------------
*  rschmutz   22/05/97  Created by eccsgen  Revision: 1.15
*
*
*    !!!!!!!!!  CAUTION: THIS FILE IS UPDATED BY ECCSGEN  !!!!!!!!!
*/

/*************************************************************************
*   NAME
*	ic0digShutter - class
*
*   SYNOPSIS
*	#include "ic0digShutter.h"
*
*	ccsCOMPL_STAT ic0digShutterNewObj(
*	    IN    dbSYMADDRESS	point,
*	    IN    egenOBJ*	owner,
*	    OUT   egenOBJ*	obj,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0digShutterDeleteObj(
*	    INOUT egenOBJ*	obj,
*	    OUT   ccsERROR*	error)
*
*	egenOBJ* ic0digShutterGetOwner(
*	    IN const egenOBJ* obj)
*
*	egenOBJ* ic0digShutterLogData(
*	    IN const egenOBJ*	obj,
*	    IN const char*	format,
*	    IN 			...)
*
*	ccsCOMPL_STAT ic0digShutterSetup(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    const char*	function[],	** max. vltBYTES32[999]
*	    IN    vltINT16	functionNum,
*	    IN    vltLOGICAL	noMove,
*	    IN    vltLOGICAL	check,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0digShutterSet(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    const char*	position[],	** max. vltBYTES32[999]
*	    IN    vltINT16	positionNum,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0digShutterStatus(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    const char*	function[],	** max. vltBYTES32[999]
*	    IN    vltINT16	functionNum,
*	    IN    vltLOGICAL	flag,
*	    IN    vltLOGICAL	header,
*	    IN    vltLOGICAL	conflog,
*	    IN    vltLOGICAL	opslog,
*	    IN    vltLOGICAL	condlog,
*	    OUT   char**	status,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0digShutterCheck(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    OUT   char**	status,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0digShutterWait(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    vltINT32	timeout,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0digShutterUsrInit(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0digShutterUsrStandby2Online(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0digShutterUsrOnline2Standby(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0digShutterUsrMonitor(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    vltINT32	state,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0digShutterUsrSelfTest(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0digShutterUsrTest(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0digShutterUsrStatusCode(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    const char*	text,
*	    IN    vltINT32	flags,
*	    OUT   vltINT32*	code,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0digShutterUsrStatusValue(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    vltINT32	code,
*	    OUT   lcctooVALUE*	value,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0digShutterUsrStatusLast(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    OUT   vltINT16*	last,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0digShutterRead<scalarAttr>(
*	    INOUT egenOBJ*	obj,
*	    OUT   void*		buf,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0digShutterWrite<scalarAttr>(
*	    INOUT egenOBJ*	obj,
*	    IN    void*		buf,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0digShutterRead<vectorAttr>(
*	    INOUT egenOBJ*	obj,
*	    OUT   void*		buf,
*	    IN    vltINT32	first,
*	    IN    vltINT32	last,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0digShutterWrite<vectorAttr>(
*	    INOUT egenOBJ*	obj,
*	    IN    void*		buf,
*	    IN    vltINT32	first,
*	    IN    vltINT32	last,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0digShutterRead<tableAttr>(
*	    INOUT egenOBJ*	obj,
*	    OUT   void*		buf,
*	    IN    vltINT32	firstRec,
*	    IN    vltINT32	lastRec,
*	    IN    vltINT32	firstFld,
*	    IN    vltINT32	lastFld,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0digShutterWrite<tableAttr>(
*	    INOUT egenOBJ*	obj,
*	    IN    void*		buf,
*	    IN    vltINT32	firstRec,
*	    IN    vltINT32	lastRec,
*	    IN    vltINT32	firstFld,
*	    IN    vltINT32	lastFld,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0digErrActivate(p1,p2)
*	ccsCOMPL_STAT ic0digErrShutterFault(p1)
*
*   PARENT CLASS
*	public ic0digSOFT
*
*   DESCRIPTION
*       The class ic0digSHUTTER provides the software device
*       for a calibration shutter.
*
*	ic0digShutterNewObj(point,owner,obj,error)
*	    Initialises an instance of the class type ic0digSHUTTER.
*
*	    point	<IN>	OLDB point where the owned attributes are
*				located.
*	    owner	<IN>	Pointer to the owner of the new instance.
*	    obj		<OUT>	Handle for the new instance (the handle
*				must be allocated by the caller).
*
*	ic0digShutterDeleteObj(obj,error)
*	    The function lcctooDeleteObj deletes an
*	    instance of the class type ic0digSHUTTER
*
*	ic0digShutterSetup(obj,devName,function,functionNum,noMove,check,error)
*	   Setups the function. The keys are the last component
*	   of the FITS keywords related with the function.
*	   E.g.:
*	     If the FITS keyword is: INS.OPTI-3.ID #11
*	     then the key is: ID, the value '#11'.
*
*	   If the noMove flag is used, then the setup parameters
*	   are stored, but not executed until a setup command
*	   without the noMove flag is received.
*
*	   If the check flag is used, then only the parameters
*	   are checked. No setup is performed.
*
*	   Aliases are not accepted (The ICS Frontend at the
*	   workstation recognizes the aliases).
*
*	ic0digShutterSet(obj,devName,position,positionNum,error)
*	   Set a hardware device in a specified state
*	   (e.g. set lamp on, set shutter open).
*
*	ic0digShutterStatus(obj,devName,function,functionNum,flag,header,conflog,opslog,condlog,status,error)
*	   Updates the complete status in the local database
*	   and returns the relevant status of the software
*	   device.
*
*	   The status is given as lines containing two words
*	   each:
*	     key1  value1,
*	     [key2 value2,
*	     [...]]
*
*	   The value usually begins after the 18th character
*	   of each line. If the flag option is set, then the
*	   values are returned as numbers (by default values
*	   are returned as literals).
*
*	ic0digShutterCheck(obj,devName,status,error)
*	   Checks if the last action of the hardware device
*	   has finished.
*
*	ic0digShutterWait(obj,devName,timeout,error)
*	   Wait for the last action of the hardware device
*	   to finish.
*
*
*	ic0digShutterErr<error>(...)
*	    The macros ic0digShutterErr*() log an error with lcctooLOG_0 and
*	    call errAdd with the corresponding error parameters.
*
*	ic0digShutterRead<attr>(...)
*	ic0digShutterWrite<attr>(...)
*	    The above macros read from/write to the data attributes
*	    of the class.
*	    The attributes are described in ic0digShutterDb(5).
*
*   PROTECTED METHODS
*   PRIVATE METHODS
*	ic0digShutterUsrInit(obj,devName,error)
*	   This function should be overloaded to perform the
*	   device initialisation (without hardware movements).
*
*	ic0digShutterUsrStandby2Online(obj,devName,error)
*	   This function should be overloaded to perform the
*	   actions necessary to change from the STANDBY to the
*	   ONLINE state. The overloaded function should first
*	   call lccdevCmdUsrStandby2Online() or check if the
*	   device is available and enabled before going ONLINE.
*
*	ic0digShutterUsrOnline2Standby(obj,devName,error)
*	   This function should be overloaded to perform the
*	   actions necessary to change from the ONLINE to the
*	   STANDBY state.
*
*	ic0digShutterUsrMonitor(obj,devName,state,error)
*	   This function is periodically called by the device
*	   manager. This function may be overloaded to monitor
*	   the device.
*
*	ic0digShutterUsrSelfTest(obj,devName,error)
*	   This function should be overloaded to perform a
*	   selftest of the device.  No movements are allowed
*	   (it must be possible to execute this function in
*	   the state LOADED).
*
*	ic0digShutterUsrTest(obj,devName,error)
*	   This function should be overloaded to perform the
*	   actions necessary to test the software device
*	   (eventually with hardware movements).
*
*	ic0digShutterUsrStatusCode(obj,devName,text,flags,code,error)
*	   This function receives the name of a status value
*	   and returns the corresponding code. This function
*	   should be overloaded if the new class declares new
*	   status values. The overloaded function should check
*	   first if the name corresponds to one of its own
*	   status values. If not, then it should call the
*	   function UsrStatusCode() of its parent class to be
*	   able to retrieve the codes of the parent status
*	   values.
*
*	   text	<IN>	Name of the status value.
*	   flags	<IN>	expected status type (lcctooSTATUS_*).
*	   code	<OUT>	Code of the status value (lccdevGET_*).
*
*	   lccdevGET_DEVICE        "Device"
*	   lccdevGET_STATE         "State"
*	   lccdevGET_TRANSTATE     "TranState"
*	   lccdevGET_ERROR         "Error"
*	   lccdevGET_INITIALISED   "Initialised"
*	   lccdevGET_SIMULATION    "Simulation"
*
*	ic0digShutterUsrStatusValue(obj,devName,code,value,error)
*	   This function receives the code of a status variable
*	   and returns its related value. This function should
*	   be overloaded if the new class declares new status
*	   values. The overloaded function should check first
*	   if the code corresponds to one of its own status
*	   values. If not, then it should call the function
*	   UsrStatusValue() of its parent class to be able to
*	   retrieve the status values of the parent.
*
*	   code	<OUT>	Code of the status value (lccdevGET_*).
*	   value	<OUT>	Handle of the value object
*			   (allocated by the caller).
*
*	ic0digShutterUsrStatusLast(obj,devName,last,error)
*	   This function returns the highest status code that
*	   the class knows. This function should be overloaded
*	   if the new class declares new status values, as new
*	   status codes have to be assigned to the new values.
*
*	   This function is used by the Status command when it
*	   has to return all status values. In this case it
*	   performs a loop from code 1 to the value returned
*	   by this function.
*
*
*   DEFINES
*
*   FILES
*
*   ENVIRONMENT
*
*   RETURN VALUES
*	If the function prototype allows, methods return ccsCOMPL_STAT.
*
*	Methods can generate the following errors:
*	    ic0digERR_ACTIVATE
*	    ic0digERR_SHUTTER_FAULT
*
*   CAUTIONS
*
*   EXAMPLES
*
*   SEE ALSO
*
*   BUGS
*
* 
*-------------------------------------------------------------------------
*/

#ifndef IC0DIG_SHUTTER_H
#define IC0DIG_SHUTTER_H

#include "egen.h"
#include "ic0digDefines.h"
#include "ic0digErrors.h"
#include "ic0digSoft.h"

/*
 * class type identifier
 */
#define ic0digSHUTTER_ID	183

/*
 * attribute table
 */
#define ic0digSHUTTER_ATTR_STATE	0
#define ic0digSHUTTER_ATTR_SUBSTATE	1
#define ic0digSHUTTER_ATTR_ERROR	2
#define ic0digSHUTTER_ATTR_INITIALISED	3
#define ic0digSHUTTER_ATTR_SIMULATION	4
#define ic0digSHUTTER_ATTR_DEVICE	5
#define ic0digSHUTTER_ATTR_AVAILABLE	6
#define ic0digSHUTTER_ATTR_ENABLED	7
#define ic0digSHUTTER_ATTR_LOCKED	8
#define ic0digSHUTTER_ATTR_HANDSET	9
#define ic0digSHUTTER_ATTR_FIXED	10
#define ic0digSHUTTER_ATTR_FIX_POS_SET	11
#define ic0digSHUTTER_ATTR_FIXED_POSITION	12
#define ic0digSHUTTER_ATTR_FIXED_SIMULATION	13
#define ic0digSHUTTER_ATTR_FIXED_LOCKED	14
#define ic0digSHUTTER_ATTR_PREFIX	15
#define ic0digSHUTTER_ATTR_PARAMETERS_SIZE	16
#define ic0digSHUTTER_ATTR_PARAMETERS	17
#define ic0digSHUTTER_ATTR_STATUS	18
#define ic0digSHUTTER_ATTR_STATUS_INDEX	19
#define ic0digSHUTTER_ATTR_VALUES_SIZE	20
#define ic0digSHUTTER_ATTR_VALUES	21
#define ic0digSHUTTER_ATTR_INIT_RESTRICTION	22
#define ic0digSHUTTER_ATTR_MOVE_RESTRICTION	23
#define ic0digSHUTTER_ATTR_STOP_TIMEOUT	24
#define ic0digSHUTTER_ATTR_SET_VAL_FCT	25
#define ic0digSHUTTER_ATTR_HELP_TEXT	26
#define ic0digSHUTTER_ATTR_PARAM_STEP	27
#define ic0digSHUTTER_ATTR_ACTION_COMMAND	28
#define ic0digSHUTTER_ATTR_ACTION_STOP_REQ	29
#define ic0digSHUTTER_ATTR_ACTION_NO_MOVE	30
#define ic0digSHUTTER_ATTR_ACTION_CHECK	31
#define ic0digSHUTTER_ATTR_RESET_SETUP_CMD	32
#define ic0digSHUTTER_ATTR_ID	33
#define ic0digSHUTTER_ATTR_NAME	34
#define ic0digSHUTTER_ATTR_SIGNALS	35
#define ic0digSHUTTER_ATTR_CONFIGURED	36
#define ic0digSHUTTER_ATTR_HW_ACCESS	37
#define ic0digSHUTTER_ATTR_TIME_ACCESS	38
#define ic0digSHUTTER_ATTR_TIME_OPEN	39
#define ic0digSHUTTER_ATTR_SHUT_SWITCH_O	40
#define ic0digSHUTTER_ATTR_SHUT_SWITCH_O_STATUS	41
#define ic0digSHUTTER_ATTR_SHUT_OPEN_I	42
#define ic0digSHUTTER_ATTR_SHUT_OPEN_I_SIM	43
#define ic0digSHUTTER_ATTR_SHUT_OPEN_I_STATUS	44
#define ic0digSHUTTER_ATTR_SHUT_CLOSED_I	45
#define ic0digSHUTTER_ATTR_SHUT_CLOSED_I_SIM	46
#define ic0digSHUTTER_ATTR_SHUT_CLOSED_I_STATUS	47
#define ic0digSHUTTER_ATTR_LOCAL_I	48
#define ic0digSHUTTER_ATTR_LOCAL_I_SIM	49
#define ic0digSHUTTER_ATTR_LOCAL_I_STATUS	50
#define ic0digSHUTTER_ATTR_FAULT_I	51
#define ic0digSHUTTER_ATTR_FAULT_I_SIM	52
#define ic0digSHUTTER_ATTR_FAULT_I_STATUS	53
#define ic0digSHUTTER_ATTR_IO_USED	54
#define ic0digSHUTTER_ATTR_DELAY	55
#define ic0digSHUTTER_ATTR_ST_CLOSED	56
#define ic0digSHUTTER_ATTR_ST_OPEN	57
#define ic0digSHUTTER_ATTR_TID	58

#define ic0digSHUTTER_AUTOMATA	0

/*
 * function table
 */
#define ic0digSHUTTER_FCT_DELETE_OBJ	0
#define ic0digSHUTTER_FCT_STANDBY	1
#define ic0digSHUTTER_FCT_ONLINE	2
#define ic0digSHUTTER_FCT_OFF	3
#define ic0digSHUTTER_FCT_EXIT	4
#define ic0digSHUTTER_FCT_STATE	5
#define ic0digSHUTTER_FCT_SIMULAT	6
#define ic0digSHUTTER_FCT_STOP_SIM	7
#define ic0digSHUTTER_FCT_STATUS	8
#define ic0digSHUTTER_FCT_INIT	9
#define ic0digSHUTTER_FCT_STOP	10
#define ic0digSHUTTER_FCT_TEST	11
#define ic0digSHUTTER_FCT_SELFTST	12
#define ic0digSHUTTER_FCT_AUTO_TBL	13
#define ic0digSHUTTER_FCT_AUTO_RST	14
#define ic0digSHUTTER_FCT_INIT_OBJ	15
#define ic0digSHUTTER_FCT_EXIT_OBJ	16
#define ic0digSHUTTER_FCT_LOADED2STBY	17
#define ic0digSHUTTER_FCT_ONLINE2STBY	18
#define ic0digSHUTTER_FCT_EXIT1	19
#define ic0digSHUTTER_FCT_CHECK_DEVICE_NAME	20
#define ic0digSHUTTER_FCT_BREAK	21
#define ic0digSHUTTER_FCT_USR_INIT	22
#define ic0digSHUTTER_FCT_USR_LOADED2STANDBY	23
#define ic0digSHUTTER_FCT_USR_STANDBY2ONLINE	24
#define ic0digSHUTTER_FCT_USR_ONLINE2STANDBY	25
#define ic0digSHUTTER_FCT_USR_STANDBY2LOADED	26
#define ic0digSHUTTER_FCT_USR_STOP	27
#define ic0digSHUTTER_FCT_USR_SIMULAT	28
#define ic0digSHUTTER_FCT_USR_STOP_SIM	29
#define ic0digSHUTTER_FCT_USR_STATUS_CODE	30
#define ic0digSHUTTER_FCT_USR_STATUS_LAST	31
#define ic0digSHUTTER_FCT_USR_STATUS_VALUE	32
#define ic0digSHUTTER_FCT_USR_TEST	33
#define ic0digSHUTTER_FCT_USR_SELF_TEST	34
#define ic0digSHUTTER_FCT_USR_ERROR	35
#define ic0digSHUTTER_FCT_AVAIL	36
#define ic0digSHUTTER_FCT_UNAVAIL	37
#define ic0digSHUTTER_FCT_DISABLE	38
#define ic0digSHUTTER_FCT_ENABLE	39
#define ic0digSHUTTER_FCT_LOCK	40
#define ic0digSHUTTER_FCT_UNLOCK	41
#define ic0digSHUTTER_FCT_HANDSET	42
#define ic0digSHUTTER_FCT_HSET_OFF	43
#define ic0digSHUTTER_FCT_FIX_POS	44
#define ic0digSHUTTER_FCT_MOVE	45
#define ic0digSHUTTER_FCT_MOVE_REL	46
#define ic0digSHUTTER_FCT_SET	47
#define ic0digSHUTTER_FCT_CHECK	48
#define ic0digSHUTTER_FCT_WAIT	49
#define ic0digSHUTTER_FCT_USR_SET_MODE	50
#define ic0digSHUTTER_FCT_SETUP	51
#define ic0digSHUTTER_FCT_GET_VAL	52
#define ic0digSHUTTER_FCT_SET_VAL	53
#define ic0digSHUTTER_FCT_CFG_ELEM	54
#define ic0digSHUTTER_FCT_LOG_CONF	55
#define ic0digSHUTTER_FCT_GET_CONF	56
#define ic0digSHUTTER_FCT_RESET_PARAMETERS	57
#define ic0digSHUTTER_FCT_PARSE_PARAMETERS	58
#define ic0digSHUTTER_FCT_COMPARE_PARAMETERS	59
#define ic0digSHUTTER_FCT_COPY_PARAMETERS	60
#define ic0digSHUTTER_FCT_EXEC_PARAMETERS	61
#define ic0digSHUTTER_FCT_UPDATE_PARAMETERS	62
#define ic0digSHUTTER_FCT_GET_PARAM_SET_VALUE	63
#define ic0digSHUTTER_FCT_GET_PARAM_STATUS	64
#define ic0digSHUTTER_FCT_SET_PARAM	65
#define ic0digSHUTTER_FCT_SET_PARAM_STEP	66
#define ic0digSHUTTER_FCT_USR_EXEC_ACTION	67
#define ic0digSHUTTER_FCT_USR_SET_PARAMETER	68
#define ic0digSHUTTER_FCT_GET_VALUE_CODE	69
#define ic0digSHUTTER_FCT_GET_VALUE	70
#define ic0digSHUTTER_FCT_USR_GET_VALUE	71
#define ic0digSHUTTER_FCT_SET_VALUE	72
#define ic0digSHUTTER_FCT_USR_SET_VALUE	73
#define ic0digSHUTTER_FCT_GET_ARG	74
#define ic0digSHUTTER_FCT_MONITOR	75
#define ic0digSHUTTER_FCT_USR_MONITOR	76
#define ic0digSHUTTER_FCT_LOG_ACTION	77
#define ic0digSHUTTER_FCT_LOG_COMMENT	78
#define ic0digSHUTTER_FCT_LOG_PARAMETER	79
#define ic0digSHUTTER_FCT_LOG_RECOVERY	80
#define ic0digSHUTTER_FCT_LOG_TBL_PARAM	81
#define ic0digSHUTTER_FCT_LOG_UNFORSEEN	82

/*
 * automata states
 */
#define ic0digSHUTTER_STATE_NOSTATE	-1
#define ic0digSHUTTER_STATE_OFF	0
#define ic0digSHUTTER_STATE_LOADED	1
#define ic0digSHUTTER_STATE_STANDBY	2
#define ic0digSHUTTER_STATE_ONLINE	3

/*
 * automata substates
 */
#define ic0digSHUTTER_SUBSTATE_ERROR	0
#define ic0digSHUTTER_SUBSTATE_IDLE	1
#define ic0digSHUTTER_SUBSTATE_BUSY	2
#define ic0digSHUTTER_SUBSTATE_INITIALISING	3
#define ic0digSHUTTER_SUBSTATE_SHUTTING_DOWN	4
#define ic0digSHUTTER_SUBSTATE_STOPPING	5
#define ic0digSHUTTER_SUBSTATE_COLD_STARTING	6
#define ic0digSHUTTER_SUBSTATE_STARTING	7
#define ic0digSHUTTER_SUBSTATE_STOP	8

/*
 * automata events
 */
#define ic0digSHUTTER_EVENT_INIT	0
#define ic0digSHUTTER_EVENT_STANDBY	1
#define ic0digSHUTTER_EVENT_ONLINE	2
#define ic0digSHUTTER_EVENT_STOP	3
#define ic0digSHUTTER_EVENT_OFF	4
#define ic0digSHUTTER_EVENT_EXIT	5
#define ic0digSHUTTER_EVENT_STATE	6
#define ic0digSHUTTER_EVENT_STOP_SIM	7
#define ic0digSHUTTER_EVENT_STATUS	8
#define ic0digSHUTTER_EVENT_SIMULAT	9
#define ic0digSHUTTER_EVENT_TEST	10
#define ic0digSHUTTER_EVENT_SELFTST	11
#define ic0digSHUTTER_EVENT_AUTO_TBL	12
#define ic0digSHUTTER_EVENT_AUTO_RST	13
#define ic0digSHUTTER_EVENT_DISABLE	14
#define ic0digSHUTTER_EVENT_ENABLE	15
#define ic0digSHUTTER_EVENT_LOCK	16
#define ic0digSHUTTER_EVENT_UNLOCK	17
#define ic0digSHUTTER_EVENT_HANDSET	18
#define ic0digSHUTTER_EVENT_HSET_OFF	19
#define ic0digSHUTTER_EVENT_AVAIL	20
#define ic0digSHUTTER_EVENT_UNAVAIL	21
#define ic0digSHUTTER_EVENT_MOVE	22
#define ic0digSHUTTER_EVENT_MOVE_REL	23
#define ic0digSHUTTER_EVENT_SET	24
#define ic0digSHUTTER_EVENT_CHECK	25
#define ic0digSHUTTER_EVENT_WAIT	26
#define ic0digSHUTTER_EVENT_SETUP	27
#define ic0digSHUTTER_EVENT_CFG_ELEM	28
#define ic0digSHUTTER_EVENT_GET_VAL	29
#define ic0digSHUTTER_EVENT_SET_VAL	30
#define ic0digSHUTTER_EVENT_LOG_CONF	31
#define ic0digSHUTTER_EVENT_GET_CONF	32
#define ic0digSHUTTER_EVENT_MONITOR	33


/*
 * values table
 */
#define ic0digSHUTTER_VALUE_ACTIVATED	0       


/*
 * function pointer types
 */
typedef ccsCOMPL_STAT (*ic0digSHUTTER_FCTPTR_SETUP)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    const char*	function[],	/* max. vltBYTES32[999] */
    IN    vltINT16	functionNum,
    IN    vltLOGICAL	noMove,
    IN    vltLOGICAL	check,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0digSHUTTER_FCTPTR_SET)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    const char*	position[],	/* max. vltBYTES32[999] */
    IN    vltINT16	positionNum,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0digSHUTTER_FCTPTR_STATUS)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    const char*	function[],	/* max. vltBYTES32[999] */
    IN    vltINT16	functionNum,
    IN    vltLOGICAL	flag,
    IN    vltLOGICAL	header,
    IN    vltLOGICAL	conflog,
    IN    vltLOGICAL	opslog,
    IN    vltLOGICAL	condlog,
    OUT   char**	status,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0digSHUTTER_FCTPTR_CHECK)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   char**	status,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0digSHUTTER_FCTPTR_WAIT)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltINT32	timeout,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0digSHUTTER_FCTPTR_USR_INIT)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0digSHUTTER_FCTPTR_USR_STANDBY2ONLINE)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0digSHUTTER_FCTPTR_USR_ONLINE2STANDBY)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0digSHUTTER_FCTPTR_USR_MONITOR)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltINT32	state,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0digSHUTTER_FCTPTR_USR_SELF_TEST)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0digSHUTTER_FCTPTR_USR_TEST)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0digSHUTTER_FCTPTR_USR_STATUS_CODE)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    const char*	text,
    IN    vltINT32	flags,
    OUT   vltINT32*	code,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0digSHUTTER_FCTPTR_USR_STATUS_VALUE)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltINT32	code,
    OUT   lcctooVALUE*	value,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0digSHUTTER_FCTPTR_USR_STATUS_LAST)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   vltINT16*	last,
    OUT   ccsERROR*	error);


/*
 * log function
 */
#define ic0digShutterLogData(obj, format, arg...) \
	{ \
	char tmpLogBuf[lcctooTMP_BUFFER_SIZE]; \
	\
	sprintf(tmpLogBuf, (format), ##arg); \
	logData("ic0dig", (obj)->id, tmpLogBuf); \
	}


/*
 * error functions
 */
#define ic0digErrActivate(p1,p2) \
	{ \
	lcctooLOG_0("ic0digERR_ACTIVATE: Device %s: Error activating the shutter (%s).",(p1),(p2)); \
	errAdd(error,"ic0dig",ic0digERR_ACTIVATE,__FILE_LINE__,"%s,%s",(p1),(p2)); \
	}
#define ic0digErrShutterFault(p1) \
	{ \
	lcctooLOG_0("ic0digERR_SHUTTER_FAULT: Device %s: FAULT: Switches report shutter to be open and closed.",(p1)); \
	errAdd(error,"ic0dig",ic0digERR_SHUTTER_FAULT,__FILE_LINE__,"%s",(p1)); \
	}

/*
 * get object owner
 */
#define ic0digShutterGetOwner(obj) ((obj)->owner)


/*
 * attribute access functions
 */
#define ic0digShutterReadState(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digSHUTTER_ATTR_STATE,(buf),(error))
#define ic0digShutterWriteState(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digSHUTTER_ATTR_STATE,(void*) (buf),(error))
#define ic0digShutterReadSubstate(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digSHUTTER_ATTR_SUBSTATE,(buf),(error))
#define ic0digShutterWriteSubstate(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digSHUTTER_ATTR_SUBSTATE,(void*) (buf),(error))
#define ic0digShutterReadError(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digSHUTTER_ATTR_ERROR,(buf),(error))
#define ic0digShutterWriteError(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digSHUTTER_ATTR_ERROR,(void*) (buf),(error))
#define ic0digShutterReadInitialised(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digSHUTTER_ATTR_INITIALISED,(buf),(error))
#define ic0digShutterWriteInitialised(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digSHUTTER_ATTR_INITIALISED,(void*) (buf),(error))
#define ic0digShutterReadSimulation(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digSHUTTER_ATTR_SIMULATION,(buf),(error))
#define ic0digShutterWriteSimulation(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digSHUTTER_ATTR_SIMULATION,(void*) (buf),(error))
#define ic0digShutterReadDevice(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digSHUTTER_ATTR_DEVICE,(buf),(error))
#define ic0digShutterWriteDevice(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digSHUTTER_ATTR_DEVICE,(void*) (buf),(error))
#define ic0digShutterReadAvailable(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digSHUTTER_ATTR_AVAILABLE,(buf),(error))
#define ic0digShutterWriteAvailable(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digSHUTTER_ATTR_AVAILABLE,(void*) (buf),(error))
#define ic0digShutterReadEnabled(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digSHUTTER_ATTR_ENABLED,(buf),(error))
#define ic0digShutterWriteEnabled(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digSHUTTER_ATTR_ENABLED,(void*) (buf),(error))
#define ic0digShutterReadLocked(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digSHUTTER_ATTR_LOCKED,(buf),(error))
#define ic0digShutterWriteLocked(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digSHUTTER_ATTR_LOCKED,(void*) (buf),(error))
#define ic0digShutterReadHandset(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digSHUTTER_ATTR_HANDSET,(buf),(error))
#define ic0digShutterWriteHandset(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digSHUTTER_ATTR_HANDSET,(void*) (buf),(error))
#define ic0digShutterReadFixed(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digSHUTTER_ATTR_FIXED,(buf),(error))
#define ic0digShutterWriteFixed(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digSHUTTER_ATTR_FIXED,(void*) (buf),(error))
#define ic0digShutterReadFixPosSet(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digSHUTTER_ATTR_FIX_POS_SET,(buf),(error))
#define ic0digShutterWriteFixPosSet(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digSHUTTER_ATTR_FIX_POS_SET,(void*) (buf),(error))
#define ic0digShutterReadFixedPosition(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digSHUTTER_ATTR_FIXED_POSITION,(buf),(error))
#define ic0digShutterWriteFixedPosition(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digSHUTTER_ATTR_FIXED_POSITION,(void*) (buf),(error))
#define ic0digShutterReadFixedSimulation(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digSHUTTER_ATTR_FIXED_SIMULATION,(buf),(error))
#define ic0digShutterWriteFixedSimulation(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digSHUTTER_ATTR_FIXED_SIMULATION,(void*) (buf),(error))
#define ic0digShutterReadFixedLocked(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digSHUTTER_ATTR_FIXED_LOCKED,(buf),(error))
#define ic0digShutterWriteFixedLocked(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digSHUTTER_ATTR_FIXED_LOCKED,(void*) (buf),(error))
#define ic0digShutterReadPrefix(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digSHUTTER_ATTR_PREFIX,(buf),(error))
#define ic0digShutterWritePrefix(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digSHUTTER_ATTR_PREFIX,(void*) (buf),(error))
#define ic0digShutterReadParametersSize(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digSHUTTER_ATTR_PARAMETERS_SIZE,(buf),(error))
#define ic0digShutterWriteParametersSize(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digSHUTTER_ATTR_PARAMETERS_SIZE,(void*) (buf),(error))
#define ic0digShutterGetParametersSize(obj,num,error) \
	caiGetAttrInfo((obj)->attrs,ic0digSHUTTER_ATTR_PARAMETERS,NULL,NULL,(num),NULL, NULL,NULL,(error))
#define ic0digShutterReadParameters(obj,buf,firstRec,lastRec,firstFld,lastFld,error) \
	lcctooCaiRWTable((obj)->attrs,0,ic0digSHUTTER_ATTR_PARAMETERS,(buf),(firstRec),(lastRec),(firstFld),(lastFld),(error))
#define ic0digShutterWriteParameters(obj,buf,firstRec,lastRec,firstFld,lastFld,error) \
	lcctooCaiRWTable((obj)->attrs,1,ic0digSHUTTER_ATTR_PARAMETERS,(void*) (buf),(firstRec),(lastRec),(firstFld),(lastFld),(error))
#define ic0digShutterGetStatusSize(obj,num,error) \
	caiGetAttrInfo((obj)->attrs,ic0digSHUTTER_ATTR_STATUS,NULL,NULL,(num),NULL, NULL,NULL,(error))
#define ic0digShutterReadStatus(obj,buf,firstElt,lastElt,error) \
	caiRWVector((obj)->attrs,0,ic0digSHUTTER_ATTR_STATUS,(buf),(firstElt),(lastElt),(error))
#define ic0digShutterWriteStatus(obj,buf,firstElt,lastElt,error) \
	caiRWVector((obj)->attrs,1,ic0digSHUTTER_ATTR_STATUS,(void*) (buf),(firstElt),(lastElt),(error))
#define ic0digShutterGetStatusIndexSize(obj,num,error) \
	caiGetAttrInfo((obj)->attrs,ic0digSHUTTER_ATTR_STATUS_INDEX,NULL,NULL,(num),NULL, NULL,NULL,(error))
#define ic0digShutterReadStatusIndex(obj,buf,firstElt,lastElt,error) \
	caiRWVector((obj)->attrs,0,ic0digSHUTTER_ATTR_STATUS_INDEX,(buf),(firstElt),(lastElt),(error))
#define ic0digShutterWriteStatusIndex(obj,buf,firstElt,lastElt,error) \
	caiRWVector((obj)->attrs,1,ic0digSHUTTER_ATTR_STATUS_INDEX,(void*) (buf),(firstElt),(lastElt),(error))
#define ic0digShutterReadValuesSize(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digSHUTTER_ATTR_VALUES_SIZE,(buf),(error))
#define ic0digShutterWriteValuesSize(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digSHUTTER_ATTR_VALUES_SIZE,(void*) (buf),(error))
#define ic0digShutterGetValuesSize(obj,num,error) \
	caiGetAttrInfo((obj)->attrs,ic0digSHUTTER_ATTR_VALUES,NULL,NULL,(num),NULL, NULL,NULL,(error))
#define ic0digShutterReadValues(obj,buf,firstRec,lastRec,firstFld,lastFld,error) \
	lcctooCaiRWTable((obj)->attrs,0,ic0digSHUTTER_ATTR_VALUES,(buf),(firstRec),(lastRec),(firstFld),(lastFld),(error))
#define ic0digShutterWriteValues(obj,buf,firstRec,lastRec,firstFld,lastFld,error) \
	lcctooCaiRWTable((obj)->attrs,1,ic0digSHUTTER_ATTR_VALUES,(void*) (buf),(firstRec),(lastRec),(firstFld),(lastFld),(error))
#define ic0digShutterReadInitRestriction(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digSHUTTER_ATTR_INIT_RESTRICTION,(buf),(error))
#define ic0digShutterWriteInitRestriction(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digSHUTTER_ATTR_INIT_RESTRICTION,(void*) (buf),(error))
#define ic0digShutterReadMoveRestriction(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digSHUTTER_ATTR_MOVE_RESTRICTION,(buf),(error))
#define ic0digShutterWriteMoveRestriction(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digSHUTTER_ATTR_MOVE_RESTRICTION,(void*) (buf),(error))
#define ic0digShutterReadStopTimeout(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digSHUTTER_ATTR_STOP_TIMEOUT,(buf),(error))
#define ic0digShutterWriteStopTimeout(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digSHUTTER_ATTR_STOP_TIMEOUT,(void*) (buf),(error))
#define ic0digShutterReadSetValFct(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digSHUTTER_ATTR_SET_VAL_FCT,(buf),(error))
#define ic0digShutterWriteSetValFct(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digSHUTTER_ATTR_SET_VAL_FCT,(void*) (buf),(error))
#define ic0digShutterGetHelpTextSize(obj,num,error) \
	caiGetAttrInfo((obj)->attrs,ic0digSHUTTER_ATTR_HELP_TEXT,NULL,NULL,(num),NULL, NULL,NULL,(error))
#define ic0digShutterReadHelpText(obj,buf,firstElt,lastElt,error) \
	caiRWVector((obj)->attrs,0,ic0digSHUTTER_ATTR_HELP_TEXT,(buf),(firstElt),(lastElt),(error))
#define ic0digShutterWriteHelpText(obj,buf,firstElt,lastElt,error) \
	caiRWVector((obj)->attrs,1,ic0digSHUTTER_ATTR_HELP_TEXT,(void*) (buf),(firstElt),(lastElt),(error))
#define ic0digShutterReadParamStep(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digSHUTTER_ATTR_PARAM_STEP,(buf),(error))
#define ic0digShutterWriteParamStep(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digSHUTTER_ATTR_PARAM_STEP,(void*) (buf),(error))
#define ic0digShutterReadActionCommand(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digSHUTTER_ATTR_ACTION_COMMAND,(buf),(error))
#define ic0digShutterWriteActionCommand(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digSHUTTER_ATTR_ACTION_COMMAND,(void*) (buf),(error))
#define ic0digShutterReadActionStopReq(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digSHUTTER_ATTR_ACTION_STOP_REQ,(buf),(error))
#define ic0digShutterWriteActionStopReq(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digSHUTTER_ATTR_ACTION_STOP_REQ,(void*) (buf),(error))
#define ic0digShutterReadActionNoMove(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digSHUTTER_ATTR_ACTION_NO_MOVE,(buf),(error))
#define ic0digShutterWriteActionNoMove(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digSHUTTER_ATTR_ACTION_NO_MOVE,(void*) (buf),(error))
#define ic0digShutterReadActionCheck(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digSHUTTER_ATTR_ACTION_CHECK,(buf),(error))
#define ic0digShutterWriteActionCheck(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digSHUTTER_ATTR_ACTION_CHECK,(void*) (buf),(error))
#define ic0digShutterReadResetSetupCmd(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digSHUTTER_ATTR_RESET_SETUP_CMD,(buf),(error))
#define ic0digShutterWriteResetSetupCmd(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digSHUTTER_ATTR_RESET_SETUP_CMD,(void*) (buf),(error))
#define ic0digShutterReadId(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digSHUTTER_ATTR_ID,(buf),(error))
#define ic0digShutterWriteId(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digSHUTTER_ATTR_ID,(void*) (buf),(error))
#define ic0digShutterReadName(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digSHUTTER_ATTR_NAME,(buf),(error))
#define ic0digShutterWriteName(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digSHUTTER_ATTR_NAME,(void*) (buf),(error))
#define ic0digShutterGetSignalsSize(obj,num,error) \
	caiGetAttrInfo((obj)->attrs,ic0digSHUTTER_ATTR_SIGNALS,NULL,NULL,(num),NULL, NULL,NULL,(error))
#define ic0digShutterReadSignals(obj,buf,firstRec,lastRec,firstFld,lastFld,error) \
	lcctooCaiRWTable((obj)->attrs,0,ic0digSHUTTER_ATTR_SIGNALS,(buf),(firstRec),(lastRec),(firstFld),(lastFld),(error))
#define ic0digShutterWriteSignals(obj,buf,firstRec,lastRec,firstFld,lastFld,error) \
	lcctooCaiRWTable((obj)->attrs,1,ic0digSHUTTER_ATTR_SIGNALS,(void*) (buf),(firstRec),(lastRec),(firstFld),(lastFld),(error))
#define ic0digShutterReadConfigured(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digSHUTTER_ATTR_CONFIGURED,(buf),(error))
#define ic0digShutterWriteConfigured(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digSHUTTER_ATTR_CONFIGURED,(void*) (buf),(error))
#define ic0digShutterReadHwAccess(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digSHUTTER_ATTR_HW_ACCESS,(buf),(error))
#define ic0digShutterWriteHwAccess(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digSHUTTER_ATTR_HW_ACCESS,(void*) (buf),(error))
#define ic0digShutterReadTimeAccess(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digSHUTTER_ATTR_TIME_ACCESS,(buf),(error))
#define ic0digShutterWriteTimeAccess(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digSHUTTER_ATTR_TIME_ACCESS,(void*) (buf),(error))
#define ic0digShutterReadTimeOpen(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digSHUTTER_ATTR_TIME_OPEN,(buf),(error))
#define ic0digShutterWriteTimeOpen(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digSHUTTER_ATTR_TIME_OPEN,(void*) (buf),(error))
#define ic0digShutterReadShutSwitchO(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digSHUTTER_ATTR_SHUT_SWITCH_O,(buf),(error))
#define ic0digShutterWriteShutSwitchO(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digSHUTTER_ATTR_SHUT_SWITCH_O,(void*) (buf),(error))
#define ic0digShutterReadShutSwitchOStatus(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digSHUTTER_ATTR_SHUT_SWITCH_O_STATUS,(buf),(error))
#define ic0digShutterWriteShutSwitchOStatus(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digSHUTTER_ATTR_SHUT_SWITCH_O_STATUS,(void*) (buf),(error))
#define ic0digShutterReadShutOpenI(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digSHUTTER_ATTR_SHUT_OPEN_I,(buf),(error))
#define ic0digShutterWriteShutOpenI(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digSHUTTER_ATTR_SHUT_OPEN_I,(void*) (buf),(error))
#define ic0digShutterReadShutOpenISim(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digSHUTTER_ATTR_SHUT_OPEN_I_SIM,(buf),(error))
#define ic0digShutterWriteShutOpenISim(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digSHUTTER_ATTR_SHUT_OPEN_I_SIM,(void*) (buf),(error))
#define ic0digShutterReadShutOpenIStatus(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digSHUTTER_ATTR_SHUT_OPEN_I_STATUS,(buf),(error))
#define ic0digShutterWriteShutOpenIStatus(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digSHUTTER_ATTR_SHUT_OPEN_I_STATUS,(void*) (buf),(error))
#define ic0digShutterReadShutClosedI(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digSHUTTER_ATTR_SHUT_CLOSED_I,(buf),(error))
#define ic0digShutterWriteShutClosedI(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digSHUTTER_ATTR_SHUT_CLOSED_I,(void*) (buf),(error))
#define ic0digShutterReadShutClosedISim(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digSHUTTER_ATTR_SHUT_CLOSED_I_SIM,(buf),(error))
#define ic0digShutterWriteShutClosedISim(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digSHUTTER_ATTR_SHUT_CLOSED_I_SIM,(void*) (buf),(error))
#define ic0digShutterReadShutClosedIStatus(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digSHUTTER_ATTR_SHUT_CLOSED_I_STATUS,(buf),(error))
#define ic0digShutterWriteShutClosedIStatus(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digSHUTTER_ATTR_SHUT_CLOSED_I_STATUS,(void*) (buf),(error))
#define ic0digShutterReadLocalI(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digSHUTTER_ATTR_LOCAL_I,(buf),(error))
#define ic0digShutterWriteLocalI(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digSHUTTER_ATTR_LOCAL_I,(void*) (buf),(error))
#define ic0digShutterReadLocalISim(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digSHUTTER_ATTR_LOCAL_I_SIM,(buf),(error))
#define ic0digShutterWriteLocalISim(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digSHUTTER_ATTR_LOCAL_I_SIM,(void*) (buf),(error))
#define ic0digShutterReadLocalIStatus(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digSHUTTER_ATTR_LOCAL_I_STATUS,(buf),(error))
#define ic0digShutterWriteLocalIStatus(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digSHUTTER_ATTR_LOCAL_I_STATUS,(void*) (buf),(error))
#define ic0digShutterReadFaultI(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digSHUTTER_ATTR_FAULT_I,(buf),(error))
#define ic0digShutterWriteFaultI(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digSHUTTER_ATTR_FAULT_I,(void*) (buf),(error))
#define ic0digShutterReadFaultISim(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digSHUTTER_ATTR_FAULT_I_SIM,(buf),(error))
#define ic0digShutterWriteFaultISim(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digSHUTTER_ATTR_FAULT_I_SIM,(void*) (buf),(error))
#define ic0digShutterReadFaultIStatus(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digSHUTTER_ATTR_FAULT_I_STATUS,(buf),(error))
#define ic0digShutterWriteFaultIStatus(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digSHUTTER_ATTR_FAULT_I_STATUS,(void*) (buf),(error))
#define ic0digShutterReadIoUsed(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digSHUTTER_ATTR_IO_USED,(buf),(error))
#define ic0digShutterWriteIoUsed(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digSHUTTER_ATTR_IO_USED,(void*) (buf),(error))
#define ic0digShutterReadDelay(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digSHUTTER_ATTR_DELAY,(buf),(error))
#define ic0digShutterWriteDelay(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digSHUTTER_ATTR_DELAY,(void*) (buf),(error))
#define ic0digShutterReadStClosed(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digSHUTTER_ATTR_ST_CLOSED,(buf),(error))
#define ic0digShutterWriteStClosed(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digSHUTTER_ATTR_ST_CLOSED,(void*) (buf),(error))
#define ic0digShutterReadStOpen(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digSHUTTER_ATTR_ST_OPEN,(buf),(error))
#define ic0digShutterWriteStOpen(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digSHUTTER_ATTR_ST_OPEN,(void*) (buf),(error))
#define ic0digShutterReadTid(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0digSHUTTER_ATTR_TID,(buf),(error))
#define ic0digShutterWriteTid(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0digSHUTTER_ATTR_TID,(void*) (buf),(error))
#define ic0digShutterGetAuto(obj,attrPtr,error) \
	SUCCESS; \
	memcpy((attrPtr), &(obj)->objs[ic0digSHUTTER_AUTOMATA], sizeof(egenOBJ)); \
	(attrPtr)->ldata = (obj)->ldata;


/*
 * class functions
 */
#define ic0digShutterMove(obj,devName,position,positionNum,error) \
	ic0digSoftMove((obj),(devName),(position),(positionNum),(error))
#define ic0digShutterMoveRel(obj,devName,position,positionNum,error) \
	ic0digSoftMoveRel((obj),(devName),(position),(positionNum),(error))
#define ic0digShutterGetConf(obj,devName,allElements,text,error) \
	ic0digSoftGetConf((obj),(devName),(allElements),(text),(error))
#define ic0digShutterUsrSetMode(obj,devName,cmd,available,enabled,simulation,handset,locked,error) \
	ic0digSoftUsrSetMode((obj),(devName),(cmd),(available),(enabled),(simulation),(handset),(locked),(error))
#define ic0digShutterGetVal(obj,devName,name,nameNum,status,error) \
	ic0devSoftGetVal((obj),(devName),(name),(nameNum),(status),(error))
#define ic0digShutterSetVal(obj,devName,name,nameNum,value,valueNum,error) \
	ic0devSoftSetVal((obj),(devName),(name),(nameNum),(value),(valueNum),(error))
#define ic0digShutterCfgElem(obj,devName,position,id,values,valuesNum,error) \
	ic0devSoftCfgElem((obj),(devName),(position),(id),(values),(valuesNum),(error))
#define ic0digShutterLogConf(obj,devName,allElements,error) \
	ic0devSoftLogConf((obj),(devName),(allElements),(error))
#define ic0digShutterResetParameters(obj,devName,cmd,error) \
	ic0devSoftResetParameters((obj),(devName),(cmd),(error))
#define ic0digShutterParseParameters(obj,devName,cmd,params,paramsNum,noMove,check,error) \
	ic0devSoftParseParameters((obj),(devName),(cmd),(params),(paramsNum),(noMove),(check),(error))
#define ic0digShutterCompareParameters(obj,devName,cmd,equal,error) \
	ic0devSoftCompareParameters((obj),(devName),(cmd),(equal),(error))
#define ic0digShutterCopyParameters(obj,devName,error) \
	ic0devSoftCopyParameters((obj),(devName),(error))
#define ic0digShutterExecParameters(obj,devName,error) \
	ic0devSoftExecParameters((obj),(devName),(error))
#define ic0digShutterUpdateParameters(obj,devName,cache,error) \
	ic0devSoftUpdateParameters((obj),(devName),(cache),(error))
#define ic0digShutterGetParamSetValue(obj,devName,index,value,setCode,error) \
	ic0devSoftGetParamSetValue((obj),(devName),(index),(value),(setCode),(error))
#define ic0digShutterGetParamStatus(obj,devName,index,flags,status,error) \
	ic0devSoftGetParamStatus((obj),(devName),(index),(flags),(status),(error))
#define ic0digShutterSetParam(obj,devName,index,cmd,value,step,error) \
	ic0devSoftSetParam((obj),(devName),(index),(cmd),(value),(step),(error))
#define ic0digShutterSetParamStep(obj,devName,index,cmd,step,error) \
	ic0devSoftSetParamStep((obj),(devName),(index),(cmd),(step),(error))
#define ic0digShutterUsrExecAction(obj,devName,index,error) \
	ic0devSoftUsrExecAction((obj),(devName),(index),(error))
#define ic0digShutterUsrSetParameter(obj,devName,cmd,param1,param1SetCode,param2,param2SetCode,value,error) \
	ic0devSoftUsrSetParameter((obj),(devName),(cmd),(param1),(param1SetCode),(param2),(param2SetCode),(value),(error))
#define ic0digShutterGetValueCode(obj,devName,name,code,error) \
	ic0devSoftGetValueCode((obj),(devName),(name),(code),(error))
#define ic0digShutterGetValue(obj,devName,code,index,value,valueNum,error) \
	ic0devSoftGetValue((obj),(devName),(code),(index),(value),(valueNum),(error))
#define ic0digShutterUsrGetValue(obj,devName,valuesTable,valuesTableNum,code,index,value,valueNum,done,error) \
	ic0devSoftUsrGetValue((obj),(devName),(valuesTable),(valuesTableNum),(code),(index),(value),(valueNum),(done),(error))
#define ic0digShutterSetValue(obj,devName,code,index,value,valueNum,error) \
	ic0devSoftSetValue((obj),(devName),(code),(index),(value),(valueNum),(error))
#define ic0digShutterUsrSetValue(obj,devName,valuesTable,valuesTableNum,code,index,value,valueNum,done,error) \
	ic0devSoftUsrSetValue((obj),(devName),(valuesTable),(valuesTableNum),(code),(index),(value),(valueNum),(done),(error))
#define ic0digShutterGetArg(obj,devName,code,index,value,error) \
	ic0devSoftGetArg((obj),(devName),(code),(index),(value),(error))
#define ic0digShutterMonitor(obj,devName,error) \
	ic0devSoftMonitor((obj),(devName),(error))
#define ic0digShutterLogAction(obj,devName,action,comment,error) \
	ic0devSoftLogAction((obj),(devName),(action),(comment),(error))
#define ic0digShutterLogComment(obj,devName,comment,error) \
	ic0devSoftLogComment((obj),(devName),(comment),(error))
#define ic0digShutterLogParameter(obj,devName,parameter,index,value,comment,error) \
	ic0devSoftLogParameter((obj),(devName),(parameter),(index),(value),(comment),(error))
#define ic0digShutterLogRecovery(obj,devName,comment,error) \
	ic0devSoftLogRecovery((obj),(devName),(comment),(error))
#define ic0digShutterLogTblParam(obj,devName,paramIndex,flags,comment,error) \
	ic0devSoftLogTblParam((obj),(devName),(paramIndex),(flags),(comment),(error))
#define ic0digShutterLogUnforseen(obj,devName,comment,error) \
	ic0devSoftLogUnforseen((obj),(devName),(comment),(error))
#define ic0digShutterUsrStop(obj,devName,req,error) \
	ic0devSoftUsrStop((obj),(devName),(req),(error))
#define ic0digShutterInitObj(obj,error) \
	ic0devSoftInitObj((obj),(error))
#define ic0digShutterExitObj(obj,error) \
	ic0devSoftExitObj((obj),(error))
#define ic0digShutterAvail(obj,devName,error) \
	lccdevCmdAvail((obj),(devName),(error))
#define ic0digShutterUnavail(obj,devName,error) \
	lccdevCmdUnavail((obj),(devName),(error))
#define ic0digShutterDisable(obj,devName,access,error) \
	lccdevCmdDisable((obj),(devName),(access),(error))
#define ic0digShutterEnable(obj,devName,access,error) \
	lccdevCmdEnable((obj),(devName),(access),(error))
#define ic0digShutterLock(obj,devName,error) \
	lccdevCmdLock((obj),(devName),(error))
#define ic0digShutterUnlock(obj,devName,error) \
	lccdevCmdUnlock((obj),(devName),(error))
#define ic0digShutterHandset(obj,devName,error) \
	lccdevCmdHandset((obj),(devName),(error))
#define ic0digShutterHsetOff(obj,devName,error) \
	lccdevCmdHsetOff((obj),(devName),(error))
#define ic0digShutterFixPos(obj,devName,position,positionNum,reset,error) \
	lccdevCmdFixPos((obj),(devName),(position),(positionNum),(reset),(error))
#define ic0digShutterUsrSimulat(obj,devName,error) \
	lccdevCmdUsrSimulat((obj),(devName),(error))
#define ic0digShutterUsrStopSim(obj,devName,error) \
	lccdevCmdUsrStopSim((obj),(devName),(error))
#define ic0digShutterUsrLoaded2Standby(obj,devName,error) \
	lccdevCmdUsrLoaded2Standby((obj),(devName),(error))
#define ic0digShutterStandby(obj,devName,error) \
	lccdevStdStandby((obj),(devName),(error))
#define ic0digShutterOnline(obj,devName,error) \
	lccdevStdOnline((obj),(devName),(error))
#define ic0digShutterOff(obj,devName,error) \
	lccdevStdOff((obj),(devName),(error))
#define ic0digShutterExit(obj,devName,error) \
	lccdevStdExit((obj),(devName),(error))
#define ic0digShutterState(obj,devName,state,error) \
	lccdevStdState((obj),(devName),(state),(error))
#define ic0digShutterSimulat(obj,devName,error) \
	lccdevStdSimulat((obj),(devName),(error))
#define ic0digShutterStopSim(obj,devName,error) \
	lccdevStdStopSim((obj),(devName),(error))
#define ic0digShutterInit(obj,devName,error) \
	lccdevStdInit((obj),(devName),(error))
#define ic0digShutterStop(obj,devName,error) \
	lccdevStdStop((obj),(devName),(error))
#define ic0digShutterTest(obj,devName,error) \
	lccdevStdTest((obj),(devName),(error))
#define ic0digShutterSelftst(obj,devName,error) \
	lccdevStdSelftst((obj),(devName),(error))
#define ic0digShutterAutoTbl(obj,devName,table,text,error) \
	lccdevStdAutoTbl((obj),(devName),(table),(text),(error))
#define ic0digShutterAutoRst(obj,devName,error) \
	lccdevStdAutoRst((obj),(devName),(error))
#define ic0digShutterLoaded2Stby(obj,devName,error) \
	lccdevStdLoaded2Stby((obj),(devName),(error))
#define ic0digShutterOnline2Stby(obj,devName,error) \
	lccdevStdOnline2Stby((obj),(devName),(error))
#define ic0digShutterExit1(obj,devName,error) \
	lccdevStdExit1((obj),(devName),(error))
#define ic0digShutterCheckDeviceName(obj,devName,error) \
	lccdevStdCheckDeviceName((obj),(devName),(error))
#define ic0digShutterBreak(obj,error) \
	lccdevStdBreak((obj),(error))
#define ic0digShutterUsrStandby2Loaded(obj,devName,error) \
	lccdevStdUsrStandby2Loaded((obj),(devName),(error))
#define ic0digShutterUsrError(obj,devName,error) \
	lccdevStdUsrError((obj),(devName),(error))

ccsCOMPL_STAT ic0digShutterSetup(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    const char*	function[],	/* max. vltBYTES32[999] */
    IN    vltINT16	functionNum,
    IN    vltLOGICAL	noMove,
    IN    vltLOGICAL	check,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0digShutterSet(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    const char*	position[],	/* max. vltBYTES32[999] */
    IN    vltINT16	positionNum,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0digShutterStatus(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    const char*	function[],	/* max. vltBYTES32[999] */
    IN    vltINT16	functionNum,
    IN    vltLOGICAL	flag,
    IN    vltLOGICAL	header,
    IN    vltLOGICAL	conflog,
    IN    vltLOGICAL	opslog,
    IN    vltLOGICAL	condlog,
    OUT   char**	status,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0digShutterCheck(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   char**	status,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0digShutterWait(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltINT32	timeout,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0digShutterUsrInit(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0digShutterUsrStandby2Online(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0digShutterUsrOnline2Standby(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0digShutterUsrMonitor(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltINT32	state,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0digShutterUsrSelfTest(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0digShutterUsrTest(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0digShutterUsrStatusCode(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    const char*	text,
    IN    vltINT32	flags,
    OUT   vltINT32*	code,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0digShutterUsrStatusValue(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltINT32	code,
    OUT   lcctooVALUE*	value,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0digShutterUsrStatusLast(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   vltINT16*	last,
    OUT   ccsERROR*	error);


/*
 * virtual functions
 */
#define ic0digShutterVStandby(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_STANDBY)((obj)->fcts[ic0digSHUTTER_FCT_STANDBY]))) \
	 ((obj),(devName),(error))
#define ic0digShutterVOnline(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_ONLINE)((obj)->fcts[ic0digSHUTTER_FCT_ONLINE]))) \
	 ((obj),(devName),(error))
#define ic0digShutterVOff(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_OFF)((obj)->fcts[ic0digSHUTTER_FCT_OFF]))) \
	 ((obj),(devName),(error))
#define ic0digShutterVExit(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_EXIT)((obj)->fcts[ic0digSHUTTER_FCT_EXIT]))) \
	 ((obj),(devName),(error))
#define ic0digShutterVState(obj,devName,state,error) \
	(*((lccdevSTD_FCTPTR_STATE)((obj)->fcts[ic0digSHUTTER_FCT_STATE]))) \
	 ((obj),(devName),(state),(error))
#define ic0digShutterVSimulat(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_SIMULAT)((obj)->fcts[ic0digSHUTTER_FCT_SIMULAT]))) \
	 ((obj),(devName),(error))
#define ic0digShutterVStopSim(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_STOP_SIM)((obj)->fcts[ic0digSHUTTER_FCT_STOP_SIM]))) \
	 ((obj),(devName),(error))
#define ic0digShutterVStatus(obj,devName,function,functionNum,flag,header,conflog,opslog,condlog,status,error) \
	(*((ic0digSHUTTER_FCTPTR_STATUS)((obj)->fcts[ic0digSHUTTER_FCT_STATUS]))) \
	 ((obj),(devName),(function),(functionNum),(flag),(header),(conflog),(opslog),(condlog),(status),(error))
#define ic0digShutterVInit(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_INIT)((obj)->fcts[ic0digSHUTTER_FCT_INIT]))) \
	 ((obj),(devName),(error))
#define ic0digShutterVStop(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_STOP)((obj)->fcts[ic0digSHUTTER_FCT_STOP]))) \
	 ((obj),(devName),(error))
#define ic0digShutterVTest(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_TEST)((obj)->fcts[ic0digSHUTTER_FCT_TEST]))) \
	 ((obj),(devName),(error))
#define ic0digShutterVSelftst(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_SELFTST)((obj)->fcts[ic0digSHUTTER_FCT_SELFTST]))) \
	 ((obj),(devName),(error))
#define ic0digShutterVAutoTbl(obj,devName,table,text,error) \
	(*((lccdevSTD_FCTPTR_AUTO_TBL)((obj)->fcts[ic0digSHUTTER_FCT_AUTO_TBL]))) \
	 ((obj),(devName),(table),(text),(error))
#define ic0digShutterVAutoRst(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_AUTO_RST)((obj)->fcts[ic0digSHUTTER_FCT_AUTO_RST]))) \
	 ((obj),(devName),(error))
#define ic0digShutterVInitObj(obj,error) \
	(*((ic0devSOFT_FCTPTR_INIT_OBJ)((obj)->fcts[ic0digSHUTTER_FCT_INIT_OBJ]))) \
	 ((obj),(error))
#define ic0digShutterVExitObj(obj,error) \
	(*((ic0devSOFT_FCTPTR_EXIT_OBJ)((obj)->fcts[ic0digSHUTTER_FCT_EXIT_OBJ]))) \
	 ((obj),(error))
#define ic0digShutterVLoaded2Stby(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_LOADED2STBY)((obj)->fcts[ic0digSHUTTER_FCT_LOADED2STBY]))) \
	 ((obj),(devName),(error))
#define ic0digShutterVOnline2Stby(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_ONLINE2STBY)((obj)->fcts[ic0digSHUTTER_FCT_ONLINE2STBY]))) \
	 ((obj),(devName),(error))
#define ic0digShutterVExit1(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_EXIT1)((obj)->fcts[ic0digSHUTTER_FCT_EXIT1]))) \
	 ((obj),(devName),(error))
#define ic0digShutterVCheckDeviceName(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_CHECK_DEVICE_NAME)((obj)->fcts[ic0digSHUTTER_FCT_CHECK_DEVICE_NAME]))) \
	 ((obj),(devName),(error))
#define ic0digShutterVBreak(obj,error) \
	(*((lccdevSTD_FCTPTR_BREAK)((obj)->fcts[ic0digSHUTTER_FCT_BREAK]))) \
	 ((obj),(error))
#define ic0digShutterVUsrInit(obj,devName,error) \
	(*((ic0digSHUTTER_FCTPTR_USR_INIT)((obj)->fcts[ic0digSHUTTER_FCT_USR_INIT]))) \
	 ((obj),(devName),(error))
#define ic0digShutterVUsrLoaded2Standby(obj,devName,error) \
	(*((lccdevCMD_FCTPTR_USR_LOADED2STANDBY)((obj)->fcts[ic0digSHUTTER_FCT_USR_LOADED2STANDBY]))) \
	 ((obj),(devName),(error))
#define ic0digShutterVUsrStandby2Online(obj,devName,error) \
	(*((ic0digSHUTTER_FCTPTR_USR_STANDBY2ONLINE)((obj)->fcts[ic0digSHUTTER_FCT_USR_STANDBY2ONLINE]))) \
	 ((obj),(devName),(error))
#define ic0digShutterVUsrOnline2Standby(obj,devName,error) \
	(*((ic0digSHUTTER_FCTPTR_USR_ONLINE2STANDBY)((obj)->fcts[ic0digSHUTTER_FCT_USR_ONLINE2STANDBY]))) \
	 ((obj),(devName),(error))
#define ic0digShutterVUsrStandby2Loaded(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_USR_STANDBY2LOADED)((obj)->fcts[ic0digSHUTTER_FCT_USR_STANDBY2LOADED]))) \
	 ((obj),(devName),(error))
#define ic0digShutterVUsrStop(obj,devName,req,error) \
	(*((ic0devSOFT_FCTPTR_USR_STOP)((obj)->fcts[ic0digSHUTTER_FCT_USR_STOP]))) \
	 ((obj),(devName),(req),(error))
#define ic0digShutterVUsrSimulat(obj,devName,error) \
	(*((lccdevCMD_FCTPTR_USR_SIMULAT)((obj)->fcts[ic0digSHUTTER_FCT_USR_SIMULAT]))) \
	 ((obj),(devName),(error))
#define ic0digShutterVUsrStopSim(obj,devName,error) \
	(*((lccdevCMD_FCTPTR_USR_STOP_SIM)((obj)->fcts[ic0digSHUTTER_FCT_USR_STOP_SIM]))) \
	 ((obj),(devName),(error))
#define ic0digShutterVUsrStatusCode(obj,devName,text,flags,code,error) \
	(*((ic0digSHUTTER_FCTPTR_USR_STATUS_CODE)((obj)->fcts[ic0digSHUTTER_FCT_USR_STATUS_CODE]))) \
	 ((obj),(devName),(text),(flags),(code),(error))
#define ic0digShutterVUsrStatusLast(obj,devName,last,error) \
	(*((ic0digSHUTTER_FCTPTR_USR_STATUS_LAST)((obj)->fcts[ic0digSHUTTER_FCT_USR_STATUS_LAST]))) \
	 ((obj),(devName),(last),(error))
#define ic0digShutterVUsrStatusValue(obj,devName,code,value,error) \
	(*((ic0digSHUTTER_FCTPTR_USR_STATUS_VALUE)((obj)->fcts[ic0digSHUTTER_FCT_USR_STATUS_VALUE]))) \
	 ((obj),(devName),(code),(value),(error))
#define ic0digShutterVUsrTest(obj,devName,error) \
	(*((ic0digSHUTTER_FCTPTR_USR_TEST)((obj)->fcts[ic0digSHUTTER_FCT_USR_TEST]))) \
	 ((obj),(devName),(error))
#define ic0digShutterVUsrSelfTest(obj,devName,error) \
	(*((ic0digSHUTTER_FCTPTR_USR_SELF_TEST)((obj)->fcts[ic0digSHUTTER_FCT_USR_SELF_TEST]))) \
	 ((obj),(devName),(error))
#define ic0digShutterVUsrError(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_USR_ERROR)((obj)->fcts[ic0digSHUTTER_FCT_USR_ERROR]))) \
	 ((obj),(devName),(error))
#define ic0digShutterVAvail(obj,devName,error) \
	(*((lccdevCMD_FCTPTR_AVAIL)((obj)->fcts[ic0digSHUTTER_FCT_AVAIL]))) \
	 ((obj),(devName),(error))
#define ic0digShutterVUnavail(obj,devName,error) \
	(*((lccdevCMD_FCTPTR_UNAVAIL)((obj)->fcts[ic0digSHUTTER_FCT_UNAVAIL]))) \
	 ((obj),(devName),(error))
#define ic0digShutterVDisable(obj,devName,access,error) \
	(*((lccdevCMD_FCTPTR_DISABLE)((obj)->fcts[ic0digSHUTTER_FCT_DISABLE]))) \
	 ((obj),(devName),(access),(error))
#define ic0digShutterVEnable(obj,devName,access,error) \
	(*((lccdevCMD_FCTPTR_ENABLE)((obj)->fcts[ic0digSHUTTER_FCT_ENABLE]))) \
	 ((obj),(devName),(access),(error))
#define ic0digShutterVLock(obj,devName,error) \
	(*((lccdevCMD_FCTPTR_LOCK)((obj)->fcts[ic0digSHUTTER_FCT_LOCK]))) \
	 ((obj),(devName),(error))
#define ic0digShutterVUnlock(obj,devName,error) \
	(*((lccdevCMD_FCTPTR_UNLOCK)((obj)->fcts[ic0digSHUTTER_FCT_UNLOCK]))) \
	 ((obj),(devName),(error))
#define ic0digShutterVHandset(obj,devName,error) \
	(*((lccdevCMD_FCTPTR_HANDSET)((obj)->fcts[ic0digSHUTTER_FCT_HANDSET]))) \
	 ((obj),(devName),(error))
#define ic0digShutterVHsetOff(obj,devName,error) \
	(*((lccdevCMD_FCTPTR_HSET_OFF)((obj)->fcts[ic0digSHUTTER_FCT_HSET_OFF]))) \
	 ((obj),(devName),(error))
#define ic0digShutterVFixPos(obj,devName,position,positionNum,reset,error) \
	(*((lccdevCMD_FCTPTR_FIX_POS)((obj)->fcts[ic0digSHUTTER_FCT_FIX_POS]))) \
	 ((obj),(devName),(position),(positionNum),(reset),(error))
#define ic0digShutterVMove(obj,devName,position,positionNum,error) \
	(*((ic0digSOFT_FCTPTR_MOVE)((obj)->fcts[ic0digSHUTTER_FCT_MOVE]))) \
	 ((obj),(devName),(position),(positionNum),(error))
#define ic0digShutterVMoveRel(obj,devName,position,positionNum,error) \
	(*((ic0digSOFT_FCTPTR_MOVE_REL)((obj)->fcts[ic0digSHUTTER_FCT_MOVE_REL]))) \
	 ((obj),(devName),(position),(positionNum),(error))
#define ic0digShutterVSet(obj,devName,position,positionNum,error) \
	(*((ic0digSHUTTER_FCTPTR_SET)((obj)->fcts[ic0digSHUTTER_FCT_SET]))) \
	 ((obj),(devName),(position),(positionNum),(error))
#define ic0digShutterVCheck(obj,devName,status,error) \
	(*((ic0digSHUTTER_FCTPTR_CHECK)((obj)->fcts[ic0digSHUTTER_FCT_CHECK]))) \
	 ((obj),(devName),(status),(error))
#define ic0digShutterVWait(obj,devName,timeout,error) \
	(*((ic0digSHUTTER_FCTPTR_WAIT)((obj)->fcts[ic0digSHUTTER_FCT_WAIT]))) \
	 ((obj),(devName),(timeout),(error))
#define ic0digShutterVUsrSetMode(obj,devName,cmd,available,enabled,simulation,handset,locked,error) \
	(*((ic0digSOFT_FCTPTR_USR_SET_MODE)((obj)->fcts[ic0digSHUTTER_FCT_USR_SET_MODE]))) \
	 ((obj),(devName),(cmd),(available),(enabled),(simulation),(handset),(locked),(error))
#define ic0digShutterVSetup(obj,devName,function,functionNum,noMove,check,error) \
	(*((ic0digSHUTTER_FCTPTR_SETUP)((obj)->fcts[ic0digSHUTTER_FCT_SETUP]))) \
	 ((obj),(devName),(function),(functionNum),(noMove),(check),(error))
#define ic0digShutterVGetVal(obj,devName,name,nameNum,status,error) \
	(*((ic0devSOFT_FCTPTR_GET_VAL)((obj)->fcts[ic0digSHUTTER_FCT_GET_VAL]))) \
	 ((obj),(devName),(name),(nameNum),(status),(error))
#define ic0digShutterVSetVal(obj,devName,name,nameNum,value,valueNum,error) \
	(*((ic0devSOFT_FCTPTR_SET_VAL)((obj)->fcts[ic0digSHUTTER_FCT_SET_VAL]))) \
	 ((obj),(devName),(name),(nameNum),(value),(valueNum),(error))
#define ic0digShutterVCfgElem(obj,devName,position,id,values,valuesNum,error) \
	(*((ic0devSOFT_FCTPTR_CFG_ELEM)((obj)->fcts[ic0digSHUTTER_FCT_CFG_ELEM]))) \
	 ((obj),(devName),(position),(id),(values),(valuesNum),(error))
#define ic0digShutterVLogConf(obj,devName,allElements,error) \
	(*((ic0devSOFT_FCTPTR_LOG_CONF)((obj)->fcts[ic0digSHUTTER_FCT_LOG_CONF]))) \
	 ((obj),(devName),(allElements),(error))
#define ic0digShutterVGetConf(obj,devName,allElements,text,error) \
	(*((ic0digSOFT_FCTPTR_GET_CONF)((obj)->fcts[ic0digSHUTTER_FCT_GET_CONF]))) \
	 ((obj),(devName),(allElements),(text),(error))
#define ic0digShutterVResetParameters(obj,devName,cmd,error) \
	(*((ic0devSOFT_FCTPTR_RESET_PARAMETERS)((obj)->fcts[ic0digSHUTTER_FCT_RESET_PARAMETERS]))) \
	 ((obj),(devName),(cmd),(error))
#define ic0digShutterVParseParameters(obj,devName,cmd,params,paramsNum,noMove,check,error) \
	(*((ic0devSOFT_FCTPTR_PARSE_PARAMETERS)((obj)->fcts[ic0digSHUTTER_FCT_PARSE_PARAMETERS]))) \
	 ((obj),(devName),(cmd),(params),(paramsNum),(noMove),(check),(error))
#define ic0digShutterVCompareParameters(obj,devName,cmd,equal,error) \
	(*((ic0devSOFT_FCTPTR_COMPARE_PARAMETERS)((obj)->fcts[ic0digSHUTTER_FCT_COMPARE_PARAMETERS]))) \
	 ((obj),(devName),(cmd),(equal),(error))
#define ic0digShutterVCopyParameters(obj,devName,error) \
	(*((ic0devSOFT_FCTPTR_COPY_PARAMETERS)((obj)->fcts[ic0digSHUTTER_FCT_COPY_PARAMETERS]))) \
	 ((obj),(devName),(error))
#define ic0digShutterVExecParameters(obj,devName,error) \
	(*((ic0devSOFT_FCTPTR_EXEC_PARAMETERS)((obj)->fcts[ic0digSHUTTER_FCT_EXEC_PARAMETERS]))) \
	 ((obj),(devName),(error))
#define ic0digShutterVUpdateParameters(obj,devName,cache,error) \
	(*((ic0devSOFT_FCTPTR_UPDATE_PARAMETERS)((obj)->fcts[ic0digSHUTTER_FCT_UPDATE_PARAMETERS]))) \
	 ((obj),(devName),(cache),(error))
#define ic0digShutterVGetParamSetValue(obj,devName,index,value,setCode,error) \
	(*((ic0devSOFT_FCTPTR_GET_PARAM_SET_VALUE)((obj)->fcts[ic0digSHUTTER_FCT_GET_PARAM_SET_VALUE]))) \
	 ((obj),(devName),(index),(value),(setCode),(error))
#define ic0digShutterVGetParamStatus(obj,devName,index,flags,status,error) \
	(*((ic0devSOFT_FCTPTR_GET_PARAM_STATUS)((obj)->fcts[ic0digSHUTTER_FCT_GET_PARAM_STATUS]))) \
	 ((obj),(devName),(index),(flags),(status),(error))
#define ic0digShutterVSetParam(obj,devName,index,cmd,value,step,error) \
	(*((ic0devSOFT_FCTPTR_SET_PARAM)((obj)->fcts[ic0digSHUTTER_FCT_SET_PARAM]))) \
	 ((obj),(devName),(index),(cmd),(value),(step),(error))
#define ic0digShutterVSetParamStep(obj,devName,index,cmd,step,error) \
	(*((ic0devSOFT_FCTPTR_SET_PARAM_STEP)((obj)->fcts[ic0digSHUTTER_FCT_SET_PARAM_STEP]))) \
	 ((obj),(devName),(index),(cmd),(step),(error))
#define ic0digShutterVUsrExecAction(obj,devName,index,error) \
	(*((ic0devSOFT_FCTPTR_USR_EXEC_ACTION)((obj)->fcts[ic0digSHUTTER_FCT_USR_EXEC_ACTION]))) \
	 ((obj),(devName),(index),(error))
#define ic0digShutterVUsrSetParameter(obj,devName,cmd,param1,param1SetCode,param2,param2SetCode,value,error) \
	(*((ic0devSOFT_FCTPTR_USR_SET_PARAMETER)((obj)->fcts[ic0digSHUTTER_FCT_USR_SET_PARAMETER]))) \
	 ((obj),(devName),(cmd),(param1),(param1SetCode),(param2),(param2SetCode),(value),(error))
#define ic0digShutterVGetValueCode(obj,devName,name,code,error) \
	(*((ic0devSOFT_FCTPTR_GET_VALUE_CODE)((obj)->fcts[ic0digSHUTTER_FCT_GET_VALUE_CODE]))) \
	 ((obj),(devName),(name),(code),(error))
#define ic0digShutterVGetValue(obj,devName,code,index,value,valueNum,error) \
	(*((ic0devSOFT_FCTPTR_GET_VALUE)((obj)->fcts[ic0digSHUTTER_FCT_GET_VALUE]))) \
	 ((obj),(devName),(code),(index),(value),(valueNum),(error))
#define ic0digShutterVUsrGetValue(obj,devName,valuesTable,valuesTableNum,code,index,value,valueNum,done,error) \
	(*((ic0devSOFT_FCTPTR_USR_GET_VALUE)((obj)->fcts[ic0digSHUTTER_FCT_USR_GET_VALUE]))) \
	 ((obj),(devName),(valuesTable),(valuesTableNum),(code),(index),(value),(valueNum),(done),(error))
#define ic0digShutterVSetValue(obj,devName,code,index,value,valueNum,error) \
	(*((ic0devSOFT_FCTPTR_SET_VALUE)((obj)->fcts[ic0digSHUTTER_FCT_SET_VALUE]))) \
	 ((obj),(devName),(code),(index),(value),(valueNum),(error))
#define ic0digShutterVUsrSetValue(obj,devName,valuesTable,valuesTableNum,code,index,value,valueNum,done,error) \
	(*((ic0devSOFT_FCTPTR_USR_SET_VALUE)((obj)->fcts[ic0digSHUTTER_FCT_USR_SET_VALUE]))) \
	 ((obj),(devName),(valuesTable),(valuesTableNum),(code),(index),(value),(valueNum),(done),(error))
#define ic0digShutterVGetArg(obj,devName,code,index,value,error) \
	(*((ic0devSOFT_FCTPTR_GET_ARG)((obj)->fcts[ic0digSHUTTER_FCT_GET_ARG]))) \
	 ((obj),(devName),(code),(index),(value),(error))
#define ic0digShutterVMonitor(obj,devName,error) \
	(*((ic0devSOFT_FCTPTR_MONITOR)((obj)->fcts[ic0digSHUTTER_FCT_MONITOR]))) \
	 ((obj),(devName),(error))
#define ic0digShutterVUsrMonitor(obj,devName,state,error) \
	(*((ic0digSHUTTER_FCTPTR_USR_MONITOR)((obj)->fcts[ic0digSHUTTER_FCT_USR_MONITOR]))) \
	 ((obj),(devName),(state),(error))
#define ic0digShutterVLogAction(obj,devName,action,comment,error) \
	(*((ic0devSOFT_FCTPTR_LOG_ACTION)((obj)->fcts[ic0digSHUTTER_FCT_LOG_ACTION]))) \
	 ((obj),(devName),(action),(comment),(error))
#define ic0digShutterVLogComment(obj,devName,comment,error) \
	(*((ic0devSOFT_FCTPTR_LOG_COMMENT)((obj)->fcts[ic0digSHUTTER_FCT_LOG_COMMENT]))) \
	 ((obj),(devName),(comment),(error))
#define ic0digShutterVLogParameter(obj,devName,parameter,index,value,comment,error) \
	(*((ic0devSOFT_FCTPTR_LOG_PARAMETER)((obj)->fcts[ic0digSHUTTER_FCT_LOG_PARAMETER]))) \
	 ((obj),(devName),(parameter),(index),(value),(comment),(error))
#define ic0digShutterVLogRecovery(obj,devName,comment,error) \
	(*((ic0devSOFT_FCTPTR_LOG_RECOVERY)((obj)->fcts[ic0digSHUTTER_FCT_LOG_RECOVERY]))) \
	 ((obj),(devName),(comment),(error))
#define ic0digShutterVLogTblParam(obj,devName,paramIndex,flags,comment,error) \
	(*((ic0devSOFT_FCTPTR_LOG_TBL_PARAM)((obj)->fcts[ic0digSHUTTER_FCT_LOG_TBL_PARAM]))) \
	 ((obj),(devName),(paramIndex),(flags),(comment),(error))
#define ic0digShutterVLogUnforseen(obj,devName,comment,error) \
	(*((ic0devSOFT_FCTPTR_LOG_UNFORSEEN)((obj)->fcts[ic0digSHUTTER_FCT_LOG_UNFORSEEN]))) \
	 ((obj),(devName),(comment),(error))


ccsCOMPL_STAT ic0digShutterNewObj(
    IN    dbSYMADDRESS	point,
    IN    egenOBJ*	owner,
    OUT   egenOBJ*	obj,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0digShutterDeleteObj(
    INOUT egenOBJ*	obj,
    OUT   ccsERROR*	error);


#endif // !IC0DIG_SHUTTER_H

/************************************************************************/
/* ___oOo___ */
