/******************************************************************************
*  E.S.O. - VLT project
* 
*  "@(#) $Id: ic0lcuCmd.h,v 1.56 2003/03/18 16:19:20 vltsccm Exp $"
* 
*  who        when      what
*  ---------- --------  ----------------------------------------------
*  rschmutzer 17/03/96  Created by eccsgen V0.56 (December 1995)
*
*
*    !!!!!!!!!  CAUTION: THIS FILE IS UPDATED BY ECCSGEN  !!!!!!!!!
*/

/*************************************************************************
*   NAME
*	ic0lcuCmd - class
*
*   SYNOPSIS
*	#include "ic0lcuCmd.h"
*
*	ccsCOMPL_STAT ic0lcuCmdNewObj(
*	    IN    dbSYMADDRESS	point,
*	    IN    egenOBJ*	owner,
*	    OUT   egenOBJ*	obj,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0lcuCmdDeleteObj(
*	    INOUT egenOBJ*	obj,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0lcuCmd<cmd>(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	function[],	** max. vltBYTES32[50]
*	    IN    vltINT16	functionNum,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0lcuCmdStatus(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	function[],	** max. vltBYTES32[999]
*	    IN    vltINT16	functionNum,
*	    IN    vltLOGICAL	flag,
*	    IN    vltLOGICAL	header,
*	    IN    vltLOGICAL	conflog,
*	    IN    vltLOGICAL	opslog,
*	    IN    vltLOGICAL	condlog,
*	    OUT   char**	status,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0lcuCmdMove(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    const char*	position[],	** max. vltBYTES32[999]
*	    IN    vltINT16	positionNum,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0lcuCmdMoveRel(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    const char*	position[],	** max. vltBYTES32[999]
*	    IN    vltINT16	positionNum,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0lcuCmdSet(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    const char*	position[],	** max. vltBYTES32[999]
*	    IN    vltINT16	positionNum,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0lcuCmdCheck(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	function[],	** max. vltBYTES32[100]
*	    IN    vltINT16	functionNum,
*	    OUT   char**	status,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0lcuCmdWait(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	function[],	** max. vltBYTES32[100]
*	    IN    vltINT16	functionNum,
*	    IN    vltINT32	timeout,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0lcuCmdSetup(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	function[],	** max. vltBYTES32[999]
*	    IN    vltINT16	functionNum,
*	    IN    vltLOGICAL	noMove,
*	    IN    vltLOGICAL	check,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0lcuCmdGetVal(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	function,
*	    IN    const char*	name[],		** max. vltBYTES32[2]
*	    IN    vltINT16	nameNum,
*	    OUT   char**	status,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0lcuCmdSetVal(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	function,
*	    IN    const char*	name[],		** max. vltBYTES32[2]
*	    IN    vltINT16	nameNum,
*	    IN    const char*	value[],	** max. vltBYTES32[10]
*	    IN    vltINT16	valueNum,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0lcuCmdCfgElem(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	function,
*	    IN    vltINT32	position,
*	    IN    const char*	id,
*	    IN    const char*	values[],	** max. vltBYTES16[10]
*	    IN    vltINT16	valuesNum,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0lcuCmdLogConf(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	function[],	** max. vltBYTES32[100]
*	    IN    vltINT16	functionNum,
*	    IN    vltLOGICAL	allElements,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0lcuCmdGetConf(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	function[],	** max. vltBYTES32[100]
*	    IN    vltINT16	functionNum,
*	    IN    vltLOGICAL	allElements,
*	    OUT   char**	text,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0lcuCmdUsrGetRevision(
*	    INOUT egenOBJ*	obj,
*	    OUT   char**	revision,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0lcuCmdInitObj(
*	    INOUT egenOBJ*	obj,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0lcuCmdExitObj(
*	    INOUT egenOBJ*	obj,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0lcuCmdFctProcess(
*	    INOUT egenOBJ*	obj,
*	    IN    vltINT32	command,
*	    IN    const char*	function[],	** max. vltBYTES32[100]
*	    IN    vltINT16	functionNum,
*	    IN    vltINT32	status,
*	    IN    vltINT32	arg1,
*	    IN    const char*	arg2,
*	    IN    vltLOGICAL	arg3,
*	    OUT   char**	arg4,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0lcuCmdFctIsAll(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	name,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0lcuCmdFctIsDup(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	name,
*	    OUT   vltLOGICAL*	dup,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0lcuCmdFctGetByName(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	name,
*	    OUT   ic0lcuCMD_FCT**	fct,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0lcuCmdFctGetByIndex(
*	    INOUT egenOBJ*	obj,
*	    IN    vltINT32	index,
*	    OUT   ic0lcuCMD_FCT**	fct,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0lcuCmdFctGetByStatus(
*	    INOUT egenOBJ*	obj,
*	    IN    vltINT32	status,
*	    OUT   vltLOGICAL	fctFlags[],	** max. vltLOGICAL[100]
*	    OUT   vltINT16*	fctFlagsNum,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0lcuCmdKeyGetByName(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	name,
*	    OUT   ic0lcuCMD_KEY**	key,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0lcuCmdKeyIsSpecial(
*	    INOUT egenOBJ*	obj,
*	    IN    ic0lcuCMD_KEY*	key,
*	    INOUT char**	value,
*	    OUT   vltINT32*	keyType,
*	    OUT   vltINT32*	mode,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0lcuCmdExecMode(
*	    INOUT egenOBJ*	obj,
*	    IN    vltINT32	mode,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0lcuCmdExecAction(
*	    INOUT egenOBJ*	obj,
*	    IN    vltINT32	index,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0lcuCmdActions(
*	    INOUT egenOBJ*	obj,
*	    IN    ic0lcuCMD_ACTION*	action,
*	    OUT   vltLOGICAL*	end,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0lcuCmdSetState(
*	    INOUT egenOBJ*	obj,
*	    OUT   char**	state,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0lcuCmdUsrStatus(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    vltLOGICAL	flag,
*	    IN    vltLOGICAL	header,
*	    IN    vltLOGICAL	conflog,
*	    IN    vltLOGICAL	opslog,
*	    IN    vltLOGICAL	condlog,
*	    OUT   char**	status,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0lcuCmdErr<error>(...)
*
*   PARENT CLASS
*	-
*
*   DESCRIPTION
*       The class ic0lcuCMD implements the public interface
*       of ICS at the LCU. The process normally forwards the
*       received commands to the ICS device manager.
*       An instrument mode change and a reconfiguration of
*       the instrument trigger a series of actions that are
*       user defined.
*
*       The following items have to be configured in the database:
*       - Name of the instrument
*       - Devices managed by ICS
*       - Keywords accepted by the SETUP and STATUS command.
*       - Actions to be performed when the instrument mode is
*	  changed (SETUP ins.mode) and when the instrument is
*	  reconfigured (with commands SETVAL, CFGELEM).
*
*   PUBLIC METHODS (COMMANDS)
*	ic0lcuCmdNewObj(point,owner,obj,error)
*	    Initialises an instance of the class type ic0lcuCMD.
*
*	    point	<IN>	OLDB point where the owned attributes are
*				located.
*	    owner	<IN>	Pointer to the owner of the new instance.
*	    obj		<OUT>	Handle for the new instance (the handle
*				must be allocated by the caller).
*
*	ic0lcuCmdDeleteObj(obj,error)
*	    The function lcctooDeleteObj deletes an
*	    instance of the class type ic0lcuCMD
*
*	ic0lcuCmdVerbose(obj,status,error) (VERBOSE)
*	   Switch on or off verbose mode. Verbose On gives
*	   multiple replies to commands which take a long
*	   time to execute. Verbose Off gives always only
*	   one reply on completion.
*
*	   status	<IN>		New value for the verbose flag.
*
*	ic0lcuCmdStandby(obj,function,functionNum,error) (STANDBY)
*	ic0lcuCmdOnline(obj,function,functionNum,error) (ONLINE)
*	ic0lcuCmdOff(obj,function,functionNum,error) (OFF)
*	ic0lcuCmdExit(obj,function,functionNum,error) (EXIT)
*	ic0lcuCmdState(obj,function,functionNum,global,state,error) (STATE)
*	ic0lcuCmdSimulat(obj,function,functionNum,error) (SIMULAT)
*	ic0lcuCmdStopSim(obj,function,functionNum,error) (STOPSIM)
*	ic0lcuCmdStatus(obj,function,functionNum,flag,header,conflog,
*			opslog,condlog,status,error) (STATUS)
*	ic0lcuCmdInit(obj,function,functionNum,error) (INIT)
*	ic0lcuCmdStop(obj,function,functionNum,error) (STOP)
*	ic0lcuCmdTest(obj,function,functionNum,error) (TEST)
*	ic0lcuCmdSelftst(obj,function,functionNum,error) (SELFTST)
*	ic0lcuCmdDisable(obj,function,functionNum,access,error) (DISABLE)
*	ic0lcuCmdEnable(obj,function,functionNum,access,error) (ENABLE)
*	ic0lcuCmdLock(obj,function,functionNum,error) (LOCK)
*	ic0lcuCmdUnlock(obj,function,functionNum,error) (UNLOCK)
*	ic0lcuCmdHandset(obj,function,functionNum,error) (HANDSET)
*	ic0lcuCmdHsetOff(obj,function,functionNum,error) (HSETOFF)
*	ic0lcuCmdFixPos(obj,devName,position,positionNum,reset,error) (FIXPOS)
*	ic0lcuCmdMove(obj,devName,position,positionNum,error) (MOVE)
*	ic0lcuCmdMoveRel(obj,devName,position,positionNum,error) (MOVEREL)
*	ic0lcuCmdSet(obj,devName,position,positionNum,error) (SET)
*	ic0lcuCmdCheck(obj,function,functionNum,status,error) (CHECK)
*	ic0lcuCmdWait(obj,function,functionNum,timeout,error) (WAIT)
*	ic0lcuCmdSetup(obj,function,functionNum,noMove,check,error) (SETUP)
*	ic0lcuCmdGetVal(obj,function,name,nameNum,status,error) (GETVAL)
*	ic0lcuCmdSetVal(obj,function,name,nameNum,value,valueNum,error) (SETVAL)
*	ic0lcuCmdCfgElem(obj,function,position,id,values,valuesNum,error) (CFGELEM)
*	ic0lcuCmdLogConf(obj,function,functionNum,allElements,error) (LOGCONF)
*	ic0lcuCmdGetConf(obj,function,functionNum,allElements,text,error) (GETCONF)
*	    These methods forward the request to the specified devices.
*	    See ic0devManager(3) or ic0devSoft(3) for a description of 
*	    each method.
*
*	ic0lcuCmdErr<error>(...)
*	    The macros ic0lcuCmdErr*() log an error with lcctooLOG_0 and
*	    call errAdd with the corresponding error parameters.
*
*	ic0lcuCmdRead<attr>(...)
*	ic0lcuCmdWrite<attr>(...)
*	    The above macros read from/write to the data attributes
*	    of the class.
*	    The attributes are described in ic0lcuCmdDb(5).
*
*   PROTECTED METHODS
*	ic0lcuCmdUsrGetRevision(obj,revision,error)
*	   Gets the revision of the software.
*
*	   The revision number is usually the revision of
*	   the integration module of the instrumentation
*	   software.
*
*   PRIVATE METHODS
*	ic0lcuCmdFctProcess(obj,command,function,functionNum,status,
*			    arg1,arg2,arg3,arg4,error)
*	   Sends the command to each ICS device listed in
*	   function with the specified arguments.
*
*	ic0lcuCmdFctIsAll(obj,name,error)
*	   Returns SUCCESS, if the device name is used to
*	   identify all ICS devices.
*
*	ic0lcuCmdFctIsDup(obj,name,dup,error)
*	   Checks if the device (name) has the same manager
*	   as any of the previous devices in the ICS device
*	   list.
*
*	ic0lcuCmdFctGetByName(obj,name,fct,error)
*	   Returns the ICS device specified by name.
*
*	ic0lcuCmdFctGetByIndex(obj,index,fct,error)
*	   Returns the ICS device specified by index.
*
*	ic0lcuCmdFctGetByStatus(obj,status,fctFlags,fctFlagsNum,error)
*	   Returns the ICS devices that have a specific status.
*	   ic0lcuSTATUS_ALL:      all devices.
*	   ic0lcuSTATUS_LOADED_STANDBY:
*				  devices in state LOADED or STANDBY.
*	   ic0lcuSTATUS_ONLINE:   devices in state ONLINE.
*	   ic0lcuSTATUS_STANDBY_ONLINE: 
*				  devices in state STANDBY or ONLINE.
*	   ic0lcuSTATUS_STATUS:	  devices accepting the STATUS command.
*	   ic0lcuSTATUS_READY:    devices accepting the ONLINE command.
*	   ic0lcuSTATUS_STOP:     devices accepting the STOP command.
*	   ic0lcuSTATUS_MANAGERS: returns first device of each manager.
*	   ic0lcuSTATUS_NORMAL:	  all, except autoOnline devices.
*	   ic0lcuSTATUS_NORMAL_STANDBY:  all, except autoOnline devices
*				  that are in state ONLINE.
*	   ic0lcuSTATUS_AUTO_ONLINE: autoOnline devices.
*
*	   Each flag in the fctFlags array corresponds to
*	   the function with the corresponding index.
*
*	ic0lcuCmdKeyGetByName(obj,name,key,error)
*	   Returns the FITS key specified by name.
*
*	ic0lcuCmdKeyIsSpecial(obj,key,value,keyType,mode,error)
*	   Checks if the FITS key is a key that needs special
*	   handling, e.g. INS.MODE.  If the value is given,
*	   then it is compared against the current value.
*	   If value is empty (""), then the current value
*	   is returned. If the value is NULL, then only
*	   the keyType is returned.
*	   If the keyType is ic0lcuCMD_KEY_MODE and a value
*	   is given, then the corresponding mode index is
*	   returned in mode.
*
*	ic0lcuCmdExecMode(obj,mode,error)
*	   Executes the actions necessary to change the
*	   instrument to the specified mode.
*
*	ic0lcuCmdExecAction(obj,index,error)
*	   Executes an action sequence beginning with the
*	   action specified by index.
*
*	ic0lcuCmdActions(obj,action,end,error)
*	   Executes an action. An action is specified in the
*	   actions table with the following entries:
*	     actionType, command, destination, arguments, timeout
*
*	   The following action types are recognized:
*
*	   ic0lcuCMD_ACTION_ARGS:
*	       Adds arguments to the message buffer.
*	   ic0lcuCMD_ACTION_CALL:
*	       Sends a command to the specified destination and waits
*	       for the last message reply.
*	   ic0lcuCMD_ACTION_END:
*	       Ends the action sequence.
*	   ic0lcuCMD_ACTION_SEND:
*	       Sends a command to the specified destination.
*	       The execution of the action sequence continues
*	       without waiting for message replies.
*	   ic0lcuCMD_ACTION_SET_MODE:
*	       Sets value = current instrument mode index.
*	   ic0lcuCMD_ACTION_SET_NEXT_MODE:
*	       Sets value = next instrument mode index.
*	   ic0lcuCMD_ACTION_SETUP:
*	       This action interprets the table as follows:
*		   command     	=> device
*		   destination	=> FITS keyword (short FITS)
*		   arguments	=> keyword value
*	       The action sends a SETUP command to the specified
*	       device to set the keyword to the specified value
*	       ("SETUP <keyword> <value>"). If the device is not
*	       available, then no command is send (the action is ignored).
*	       If the device is disabled, then the action is ignored,
*	       but an error is returned if the keyword is not already
*	       set to the requested value.  Execution of the action
*	       sequence continues without waiting for message replies.
*	   ic0lcuCMD_ACTION_SLEEP:
*	       Sleeps for timeout msecs.
*	   ic0lcuCMD_ACTION_VALUE_CLEAR:
*	       Sets value = 0.
*	   ic0lcuCMD_ACTION_VALUE_ADD:
*	       Sends a command to the specified destination and waits
*	       for the last message reply.  The first number in the
*	       last reply is added to value.
*	   ic0lcuCMD_ACTION_VALUE_PUT:
*	       Replaces the string "$1" in the message buffer with
*	       value and sends a command to the specified destination.
*	       The action waits for the last message reply.
*	   ic0lcuCMD_ACTION_WAIT:
*	       Waits for all pending replies of all the commands
*	       sent during the current action sequence.
*
*   PRIVATE METHODS
*	ic0lcuCmdInitObj(obj,error)
*	ic0lcuCmdExitObj(obj,error)
*
*	ic0lcuCmdSetState(obj,state,error)
*	   Sets (and returns) the global state of the LCU part of ICS.
*
*	ic0lcuCmdUsrStatus(obj,devName,flag,header,conflog,opslog,condlog,status,error)
*	   Hook to report additional status about a device.
*
*   RETURN VALUES
*	If the function prototype allows, methods return ccsCOMPL_STAT.
*
*	The names of the defined errors begin as follows:
*	ic0lcuERR_<error>
*
*   SEE ALSO
*	ic0lcuCMD(5) ic0lcuManager(3) ic0lcuSoft(3)
* 
*-------------------------------------------------------------------------
*/

#ifndef IC0LCU_CMD_H
#define IC0LCU_CMD_H

#include "egen.h"
#include "ic0lcuErrors.h"
#include "ic0lcuDefines.h"

/*
 * class type identifier
 */
#define ic0lcuCMD_ID	130

/*
 * attribute table
 */
#define ic0lcuCMD_ATTR_STATE	0
#define ic0lcuCMD_ATTR_MODE	1
#define ic0lcuCMD_ATTR_NEXT_MODE	2
#define ic0lcuCMD_ATTR_ACTION_REPLIES	3
#define ic0lcuCMD_ATTR_ACTION_STEP	4
#define ic0lcuCMD_ATTR_ACTION_VALUE	5
#define ic0lcuCMD_ATTR_ACTION_STOP_REQ	6
#define ic0lcuCMD_ATTR_MOVE_STOP_REQ	7
#define ic0lcuCMD_ATTR_INSTRUMENT_NAME	8
#define ic0lcuCMD_ATTR_PREFIX	9
#define ic0lcuCMD_ATTR_FUNCTIONS_SIZE	10
#define ic0lcuCMD_ATTR_FUNCTIONS	11
#define ic0lcuCMD_ATTR_MODE_CONFIG_ORDER	12
#define ic0lcuCMD_ATTR_KEYWORDS_SIZE	13
#define ic0lcuCMD_ATTR_KEYWORDS	14
#define ic0lcuCMD_ATTR_MODES_SIZE	15
#define ic0lcuCMD_ATTR_MODES	16
#define ic0lcuCMD_ATTR_ACTIONS	17
#define ic0lcuCMD_ATTR_TIMEOUT1	18
#define ic0lcuCMD_ATTR_TIMEOUT2	19
#define ic0lcuCMD_ATTR_MOT_TIMEOUT	20
#define ic0lcuCMD_ATTR_INTERVAL	21
#define ic0lcuCMD_ATTR_MAX_PARALLEL	22
#define ic0lcuCMD_ATTR_DB_BACKUP_FILE	23
#define ic0lcuCMD_ATTR_MODE_SET	24
#define ic0lcuCMD_ATTR_ACTION_ARGS	25


/*
 * function table
 */
#define ic0lcuCMD_FCT_DELETE_OBJ	0
#define ic0lcuCMD_FCT_VERBOSE	1
#define ic0lcuCMD_FCT_STANDBY	2
#define ic0lcuCMD_FCT_ONLINE	3
#define ic0lcuCMD_FCT_OFF	4
#define ic0lcuCMD_FCT_EXIT	5
#define ic0lcuCMD_FCT_STATE	6
#define ic0lcuCMD_FCT_SIMULAT	7
#define ic0lcuCMD_FCT_STOP_SIM	8
#define ic0lcuCMD_FCT_STATUS	9
#define ic0lcuCMD_FCT_INIT	10
#define ic0lcuCMD_FCT_STOP	11
#define ic0lcuCMD_FCT_TEST	12
#define ic0lcuCMD_FCT_SELFTST	13
#define ic0lcuCMD_FCT_DISABLE	14
#define ic0lcuCMD_FCT_ENABLE	15
#define ic0lcuCMD_FCT_LOCK	16
#define ic0lcuCMD_FCT_UNLOCK	17
#define ic0lcuCMD_FCT_HANDSET	18
#define ic0lcuCMD_FCT_HSET_OFF	19
#define ic0lcuCMD_FCT_FIX_POS	20
#define ic0lcuCMD_FCT_MOVE	21
#define ic0lcuCMD_FCT_MOVE_REL	22
#define ic0lcuCMD_FCT_SET	23
#define ic0lcuCMD_FCT_CHECK	24
#define ic0lcuCMD_FCT_WAIT	25
#define ic0lcuCMD_FCT_SETUP	26
#define ic0lcuCMD_FCT_GET_VAL	27
#define ic0lcuCMD_FCT_SET_VAL	28
#define ic0lcuCMD_FCT_CFG_ELEM	29
#define ic0lcuCMD_FCT_LOG_CONF	30
#define ic0lcuCMD_FCT_GET_CONF	31
#define ic0lcuCMD_FCT_USR_GET_REVISION	32
#define ic0lcuCMD_FCT_INIT_OBJ	33
#define ic0lcuCMD_FCT_EXIT_OBJ	34
#define ic0lcuCMD_FCT_FCT_PROCESS	35
#define ic0lcuCMD_FCT_FCT_IS_ALL	36
#define ic0lcuCMD_FCT_FCT_IS_DUP	37
#define ic0lcuCMD_FCT_FCT_GET_BY_NAME	38
#define ic0lcuCMD_FCT_FCT_GET_BY_INDEX	39
#define ic0lcuCMD_FCT_FCT_GET_BY_STATUS	40
#define ic0lcuCMD_FCT_KEY_GET_BY_NAME	41
#define ic0lcuCMD_FCT_KEY_IS_SPECIAL	42
#define ic0lcuCMD_FCT_EXEC_MODE	43
#define ic0lcuCMD_FCT_EXEC_ACTION	44
#define ic0lcuCMD_FCT_ACTIONS	45
#define ic0lcuCMD_FCT_SET_STATE	46
#define ic0lcuCMD_FCT_USR_STATUS	47

/*
 * table types
 */
typedef struct
    {
    vltBYTES32	name;
    vltBYTES32	device;
    vltBYTES32	manager;
    vltINT32	order;
    vltINT32	initParallel;
    vltINT32	setupParallel;
    } ic0lcuCMD_FUNCTION;

typedef struct
    {
    vltBYTES32	name;
    vltBYTES32	device;
    vltBYTES32	manager;
    vltINT32	orderIndex;
    vltINT32	initParallel;
    vltINT32	setupParallel;
    egenOBJ*	obj;
    vltINT16	tableIndex;
    vltLOGICAL	autoOnline;
    } ic0lcuCMD_FCT;

typedef struct
    {
    vltBYTES32	keyword;
    vltBYTES32	device;
    vltINT32	strip;
    vltINT32	modeConfig;
    } ic0lcuCMD_KEYWORD;

typedef struct
    {
    vltBYTES32	keyword;
    vltBYTES32	devName;
    vltINT32	strip;
    vltINT32	step;
    vltINT32	modeConfig;
    vltINT16	fctIndex;
    } ic0lcuCMD_KEY;

typedef struct
    {
    vltBYTES32	mode;
    vltINT32	changeAction;
    vltINT32	configAction;
    } ic0lcuCMD_MODE;    

typedef struct
    {
    vltINT32	actionType;
    vltBYTES32	destination;
    vltBYTES32	command;
    vltINT32	cmdId;
    vltBYTES32	arguments;
    vltINT32	timeout;
    } ic0lcuCMD_ACTION;

typedef struct
    {
    vltLOGICAL	sendFlag;
    vltINT32	keysMax;
    const char** keys;
    vltINT32	keysNum;
    } ic0lcuCMD_KEY_TBL;

/*
 * user variables
 */
typedef struct
    {
    vltBYTES32		prefix;
    vltINT32		prefixLen;
    ic0lcuCMD_FCT*	fctTable;
    char**		fctNames;
    char**		devNames;
    ic0lcuCMD_KEY*	keyTable;
    char**		keyNames;
    ic0lcuCMD_MODE*	modeTable;
    char**		modeNames;
    SEM_ID		cmdSem;
    SEM_ID		sendSem;
    SEM_ID		actionSem;
    vltINT16		fctNum;
    vltINT16		keyNum;
    vltINT16		modeNum;
    } ic0lcuCMD_USERVAR;

#define ic0lcuCmdSemCmd(obj) \
	(((ic0lcuCMD_USERVAR *) (obj)->user)->cmdSem)
#define ic0lcuCmdSemSend(obj) \
	(((ic0lcuCMD_USERVAR *) (obj)->user)->sendSem)
#define ic0lcuCmdSemAction(obj) \
	(((ic0lcuCMD_USERVAR *) (obj)->user)->actionSem)
#define ic0lcuCmdFctNum(obj) \
	(((ic0lcuCMD_USERVAR *) (obj)->user)->fctNum)


/*
 * function pointer types
 */
typedef ccsCOMPL_STAT (*ic0lcuCMD_FCTPTR_VERBOSE)(
    INOUT egenOBJ*	obj,
    IN    const char*	status,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0lcuCMD_FCTPTR_STANDBY)(
    INOUT egenOBJ*	obj,
    IN    const char*	function[],	/* max. vltBYTES32[100] */
    IN    vltINT16	functionNum,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0lcuCMD_FCTPTR_ONLINE)(
    INOUT egenOBJ*	obj,
    IN    const char*	function[],	/* max. vltBYTES32[100] */
    IN    vltINT16	functionNum,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0lcuCMD_FCTPTR_OFF)(
    INOUT egenOBJ*	obj,
    IN    const char*	function[],	/* max. vltBYTES32[100] */
    IN    vltINT16	functionNum,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0lcuCMD_FCTPTR_EXIT)(
    INOUT egenOBJ*	obj,
    IN    const char*	function[],	/* max. vltBYTES32[100] */
    IN    vltINT16	functionNum,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0lcuCMD_FCTPTR_STATE)(
    INOUT egenOBJ*	obj,
    IN    const char*	function[],	/* max. vltBYTES32[100] */
    IN    vltINT16	functionNum,
    IN    vltLOGICAL	global,
    OUT   char**	state,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0lcuCMD_FCTPTR_SIMULAT)(
    INOUT egenOBJ*	obj,
    IN    const char*	function[],	/* max. vltBYTES32[100] */
    IN    vltINT16	functionNum,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0lcuCMD_FCTPTR_STOP_SIM)(
    INOUT egenOBJ*	obj,
    IN    const char*	function[],	/* max. vltBYTES32[100] */
    IN    vltINT16	functionNum,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0lcuCMD_FCTPTR_STATUS)(
    INOUT egenOBJ*	obj,
    IN    const char*	function[],	/* max. vltBYTES32[999] */
    IN    vltINT16	functionNum,
    IN    vltLOGICAL	flag,
    IN    vltLOGICAL	header,
    IN    vltLOGICAL	conflog,
    IN    vltLOGICAL	opslog,
    IN    vltLOGICAL	condlog,
    OUT   char**	status,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0lcuCMD_FCTPTR_INIT)(
    INOUT egenOBJ*	obj,
    IN    const char*	function[],	/* max. vltBYTES32[100] */
    IN    vltINT16	functionNum,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0lcuCMD_FCTPTR_STOP)(
    INOUT egenOBJ*	obj,
    IN    const char*	function[],	/* max. vltBYTES32[100] */
    IN    vltINT16	functionNum,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0lcuCMD_FCTPTR_TEST)(
    INOUT egenOBJ*	obj,
    IN    const char*	function[],	/* max. vltBYTES32[100] */
    IN    vltINT16	functionNum,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0lcuCMD_FCTPTR_SELFTST)(
    INOUT egenOBJ*	obj,
    IN    const char*	function[],	/* max. vltBYTES32[100] */
    IN    vltINT16	functionNum,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0lcuCMD_FCTPTR_DISABLE)(
    INOUT egenOBJ*	obj,
    IN    const char*	function[],	/* max. vltBYTES32[100] */
    IN    vltINT16	functionNum,
    IN    const char*	access,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0lcuCMD_FCTPTR_ENABLE)(
    INOUT egenOBJ*	obj,
    IN    const char*	function[],	/* max. vltBYTES32[100] */
    IN    vltINT16	functionNum,
    IN    const char*	access,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0lcuCMD_FCTPTR_LOCK)(
    INOUT egenOBJ*	obj,
    IN    const char*	function[],	/* max. vltBYTES32[100] */
    IN    vltINT16	functionNum,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0lcuCMD_FCTPTR_UNLOCK)(
    INOUT egenOBJ*	obj,
    IN    const char*	function[],	/* max. vltBYTES32[100] */
    IN    vltINT16	functionNum,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0lcuCMD_FCTPTR_HANDSET)(
    INOUT egenOBJ*	obj,
    IN    const char*	function[],	/* max. vltBYTES32[100] */
    IN    vltINT16	functionNum,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0lcuCMD_FCTPTR_HSET_OFF)(
    INOUT egenOBJ*	obj,
    IN    const char*	function[],	/* max. vltBYTES32[100] */
    IN    vltINT16	functionNum,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0lcuCMD_FCTPTR_FIX_POS)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    const char*	position[],	/* max. vltBYTES32[999] */
    IN    vltINT16	positionNum,
    IN    vltLOGICAL	reset,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0lcuCMD_FCTPTR_MOVE)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    const char*	position[],	/* max. vltBYTES32[999] */
    IN    vltINT16	positionNum,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0lcuCMD_FCTPTR_MOVE_REL)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    const char*	position[],	/* max. vltBYTES32[999] */
    IN    vltINT16	positionNum,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0lcuCMD_FCTPTR_SET)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    const char*	position[],	/* max. vltBYTES32[999] */
    IN    vltINT16	positionNum,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0lcuCMD_FCTPTR_CHECK)(
    INOUT egenOBJ*	obj,
    IN    const char*	function[],	/* max. vltBYTES32[100] */
    IN    vltINT16	functionNum,
    OUT   char**	status,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0lcuCMD_FCTPTR_WAIT)(
    INOUT egenOBJ*	obj,
    IN    const char*	function[],	/* max. vltBYTES32[100] */
    IN    vltINT16	functionNum,
    IN    vltINT32	timeout,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0lcuCMD_FCTPTR_SETUP)(
    INOUT egenOBJ*	obj,
    IN    const char*	function[],	/* max. vltBYTES32[999] */
    IN    vltINT16	functionNum,
    IN    vltLOGICAL	noMove,
    IN    vltLOGICAL	check,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0lcuCMD_FCTPTR_GET_VAL)(
    INOUT egenOBJ*	obj,
    IN    const char*	function,
    IN    const char*	name[],	/* max. vltBYTES32[2] */
    IN    vltINT16	nameNum,
    OUT   char**	status,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0lcuCMD_FCTPTR_SET_VAL)(
    INOUT egenOBJ*	obj,
    IN    const char*	function,
    IN    const char*	name[],	/* max. vltBYTES32[2] */
    IN    vltINT16	nameNum,
    IN    const char*	value[],	/* max. vltBYTES32[10] */
    IN    vltINT16	valueNum,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0lcuCMD_FCTPTR_CFG_ELEM)(
    INOUT egenOBJ*	obj,
    IN    const char*	function,
    IN    vltINT32	position,
    IN    const char*	id,
    IN    const char*	values[],	/* max. vltBYTES16[10] */
    IN    vltINT16	valuesNum,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0lcuCMD_FCTPTR_LOG_CONF)(
    INOUT egenOBJ*	obj,
    IN    const char*	function[],	/* max. vltBYTES32[100] */
    IN    vltINT16	functionNum,
    IN    vltLOGICAL	allElements,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0lcuCMD_FCTPTR_GET_CONF)(
    INOUT egenOBJ*	obj,
    IN    const char*	function[],	/* max. vltBYTES32[100] */
    IN    vltINT16	functionNum,
    IN    vltLOGICAL	allElements,
    OUT   char**	text,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0lcuCMD_FCTPTR_USR_GET_REVISION)(
    INOUT egenOBJ*	obj,
    OUT   char**	revision,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0lcuCMD_FCTPTR_INIT_OBJ)(
    INOUT egenOBJ*	obj,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0lcuCMD_FCTPTR_EXIT_OBJ)(
    INOUT egenOBJ*	obj,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0lcuCMD_FCTPTR_FCT_PROCESS)(
    INOUT egenOBJ*	obj,
    IN    vltINT32	command,
    IN    const char*	function[],	/* max. vltBYTES32[100] */
    IN    vltINT16	functionNum,
    IN    vltINT32	status,
    IN    vltINT32	arg1,
    IN    const char*	arg2,
    IN    vltLOGICAL	arg3,
    OUT   char**	arg4,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0lcuCMD_FCTPTR_FCT_IS_ALL)(
    INOUT egenOBJ*	obj,
    IN    const char*	name,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0lcuCMD_FCTPTR_FCT_IS_DUP)(
    INOUT egenOBJ*	obj,
    IN    const char*	name,
    OUT   vltLOGICAL*	dup,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0lcuCMD_FCTPTR_FCT_GET_BY_NAME)(
    INOUT egenOBJ*	obj,
    IN    const char*	name,
    OUT   ic0lcuCMD_FCT**	fct,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0lcuCMD_FCTPTR_FCT_GET_BY_INDEX)(
    INOUT egenOBJ*	obj,
    IN    vltINT32	index,
    OUT   ic0lcuCMD_FCT**	fct,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0lcuCMD_FCTPTR_FCT_GET_BY_STATUS)(
    INOUT egenOBJ*	obj,
    IN    vltINT32	status,
    OUT   vltLOGICAL	fctFlags[],	/* max. vltLOGICAL[100] */
    OUT   vltINT16*	fctFlagsNum,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0lcuCMD_FCTPTR_KEY_GET_BY_NAME)(
    INOUT egenOBJ*	obj,
    IN    const char*	name,
    OUT   ic0lcuCMD_KEY**	key,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0lcuCMD_FCTPTR_KEY_IS_SPECIAL)(
    INOUT egenOBJ*	obj,
    IN    ic0lcuCMD_KEY*	key,
    INOUT char**	value,
    OUT   vltINT32*	keyType,
    OUT   vltINT32*	mode,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0lcuCMD_FCTPTR_EXEC_MODE)(
    INOUT egenOBJ*	obj,
    IN    vltINT32	mode,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0lcuCMD_FCTPTR_EXEC_ACTION)(
    INOUT egenOBJ*	obj,
    IN    vltINT32	index,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0lcuCMD_FCTPTR_ACTIONS)(
    INOUT egenOBJ*	obj,
    IN    ic0lcuCMD_ACTION*	action,
    OUT   vltLOGICAL*	end,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0lcuCMD_FCTPTR_SET_STATE)(
    INOUT egenOBJ*	obj,
    OUT   char**	state,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0lcuCMD_FCTPTR_USR_STATUS)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltLOGICAL	flag,
    IN    vltLOGICAL	header,
    IN    vltLOGICAL	conflog,
    IN    vltLOGICAL	opslog,
    IN    vltLOGICAL	condlog,
    OUT   char**	status,
    OUT   ccsERROR*	error);


/*
 * log function
 */
#define ic0lcuCmdLogData(obj, format, arg...) \
	{ \
	char tmpLogBuf[lcctooTMP_BUFFER_SIZE]; \
	\
	sprintf(tmpLogBuf, (format), ##arg); \
	logData("ic0lcu", (obj)->id, tmpLogBuf); \
	}


/*
 * error functions
 */
#define ic0lcuErrActionRecv(p1,p2,p3) \
	{ \
	lcctooLOG_0("ic0lcuERR_ACTION_RECV: Error reply from %s (command: %s %s).",(p1),(p2),(p3)); \
	errAdd(error,"ic0lcu",ic0lcuERR_ACTION_RECV,__FILE_LINE__,"%s,%s,%s",(p1),(p2),(p3)); \
	}
#define ic0lcuErrActionSend(p1,p2,p3) \
	{ \
	lcctooLOG_0("ic0lcuERR_ACTION_SEND: Error sending to destination %s (command: %s %s).",(p1),(p2),(p3)); \
	errAdd(error,"ic0lcu",ic0lcuERR_ACTION_SEND,__FILE_LINE__,"%s,%s,%s",(p1),(p2),(p3)); \
	}
#define ic0lcuErrActionSetup1(p1) \
	{ \
	lcctooLOG_0("ic0lcuERR_ACTION_SETUP1: Error: Function %s is not ONLINE. Unable to move it.",(p1)); \
	errAdd(error,"ic0lcu",ic0lcuERR_ACTION_SETUP1,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0lcuErrActionSetup2(p1,p2,p3,p4) \
	{ \
	lcctooLOG_0("ic0lcuERR_ACTION_SETUP2: Error: Function %s is disabled. Keyword %s should have value %s, but has value %s.",(p1),(p2),(p3),(p4)); \
	errAdd(error,"ic0lcu",ic0lcuERR_ACTION_SETUP2,__FILE_LINE__,"%s,%s,%s,%s",(p1),(p2),(p3),(p4)); \
	}
#define ic0lcuErrActionSleep(p1) \
	{ \
	lcctooLOG_0("ic0lcuERR_ACTION_SLEEP: Error while sleeping for %d msecs.",(p1)); \
	errAdd(error,"ic0lcu",ic0lcuERR_ACTION_SLEEP,__FILE_LINE__,"%d",(p1)); \
	}
#define ic0lcuErrActionStopReq() \
	{ \
	lcctooLOG_0("ic0lcuERR_ACTION_STOP_REQ: Stop received: Instrument mode change or update interrupted."); \
	errAdd(error,"ic0lcu",ic0lcuERR_ACTION_STOP_REQ,__FILE_LINE__,""); \
	}
#define ic0lcuErrActionWait(p1) \
	{ \
	lcctooLOG_0("ic0lcuERR_ACTION_WAIT: Error receiving a reply (%s).",(p1)); \
	errAdd(error,"ic0lcu",ic0lcuERR_ACTION_WAIT,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0lcuErrGetActionsSize() \
	{ \
	lcctooLOG_0("ic0lcuERR_GET_ACTIONS_SIZE: Error reading the size of the actions table."); \
	errAdd(error,"ic0lcu",ic0lcuERR_GET_ACTIONS_SIZE,__FILE_LINE__,""); \
	}
#define ic0lcuErrGetFunctionsSize() \
	{ \
	lcctooLOG_0("ic0lcuERR_GET_FUNCTIONS_SIZE: Error reading the size of the functions table."); \
	errAdd(error,"ic0lcu",ic0lcuERR_GET_FUNCTIONS_SIZE,__FILE_LINE__,""); \
	}
#define ic0lcuErrGetKeywordsSize() \
	{ \
	lcctooLOG_0("ic0lcuERR_GET_KEYWORDS_SIZE: Error reading the size of the keywords table."); \
	errAdd(error,"ic0lcu",ic0lcuERR_GET_KEYWORDS_SIZE,__FILE_LINE__,""); \
	}
#define ic0lcuErrGetModesSize() \
	{ \
	lcctooLOG_0("ic0lcuERR_GET_MODES_SIZE: Error reading the size of the keywords table."); \
	errAdd(error,"ic0lcu",ic0lcuERR_GET_MODES_SIZE,__FILE_LINE__,""); \
	}
#define ic0lcuErrLoadDbBackupFile(p1) \
	{ \
	lcctooLOG_0("ic0lcuERR_LOAD_DB_BACKUP_FILE: Error loading the OLDB backup from file %s.",(p1)); \
	errAdd(error,"ic0lcu",ic0lcuERR_LOAD_DB_BACKUP_FILE,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0lcuErrModeChange() \
	{ \
	lcctooLOG_0("ic0lcuERR_MODE_CHANGE: Error changing the instrument mode."); \
	errAdd(error,"ic0lcu",ic0lcuERR_MODE_CHANGE,__FILE_LINE__,""); \
	}
#define ic0lcuErrModeConfig() \
	{ \
	lcctooLOG_0("ic0lcuERR_MODE_CONFIG: Error updating the instrument mode configuration."); \
	errAdd(error,"ic0lcu",ic0lcuERR_MODE_CONFIG,__FILE_LINE__,""); \
	}
#define ic0lcuErrMoveStopReq() \
	{ \
	lcctooLOG_0("ic0lcuERR_MOVE_STOP_REQ: Stop received: Movement interrupted."); \
	errAdd(error,"ic0lcu",ic0lcuERR_MOVE_STOP_REQ,__FILE_LINE__,""); \
	}
#define ic0lcuErrNoValue(p1) \
	{ \
	lcctooLOG_0("ic0lcuERR_NO_VALUE: STATUS command did not return any value (%s).",(p1)); \
	errAdd(error,"ic0lcu",ic0lcuERR_NO_VALUE,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0lcuErrReadActionArgs() \
	{ \
	lcctooLOG_0("ic0lcuERR_READ_ACTION_ARGS: Error reading OLDB attribute actionArgs."); \
	errAdd(error,"ic0lcu",ic0lcuERR_READ_ACTION_ARGS,__FILE_LINE__,""); \
	}
#define ic0lcuErrReadActionReplies() \
	{ \
	lcctooLOG_0("ic0lcuERR_READ_ACTION_REPLIES: Error reading OLDB attribute actionReplies."); \
	errAdd(error,"ic0lcu",ic0lcuERR_READ_ACTION_REPLIES,__FILE_LINE__,""); \
	}
#define ic0lcuErrReadActionStep() \
	{ \
	lcctooLOG_0("ic0lcuERR_READ_ACTION_STEP: Error reading OLDB attribute actionStep."); \
	errAdd(error,"ic0lcu",ic0lcuERR_READ_ACTION_STEP,__FILE_LINE__,""); \
	}
#define ic0lcuErrReadActionStopReq() \
	{ \
	lcctooLOG_0("ic0lcuERR_READ_ACTION_STOP_REQ: Error reading OLDB attribute actionStopReq."); \
	errAdd(error,"ic0lcu",ic0lcuERR_READ_ACTION_STOP_REQ,__FILE_LINE__,""); \
	}
#define ic0lcuErrReadActionValue() \
	{ \
	lcctooLOG_0("ic0lcuERR_READ_ACTION_VALUE: Error reading OLDB attribute actionValue."); \
	errAdd(error,"ic0lcu",ic0lcuERR_READ_ACTION_VALUE,__FILE_LINE__,""); \
	}
#define ic0lcuErrReadActions(p1) \
	{ \
	lcctooLOG_0("ic0lcuERR_READ_ACTIONS: Error reading OLDB table actions (%s).",(p1)); \
	errAdd(error,"ic0lcu",ic0lcuERR_READ_ACTIONS,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0lcuErrReadDbBackupFile() \
	{ \
	lcctooLOG_0("ic0lcuERR_READ_DB_BACKUP_FILE: Unable to read attribute 'dbBackupFile' from OLDB."); \
	errAdd(error,"ic0lcu",ic0lcuERR_READ_DB_BACKUP_FILE,__FILE_LINE__,""); \
	}
#define ic0lcuErrReadFunctions(p1) \
	{ \
	lcctooLOG_0("ic0lcuERR_READ_FUNCTIONS: Error reading OLDB table functions (%s).",(p1)); \
	errAdd(error,"ic0lcu",ic0lcuERR_READ_FUNCTIONS,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0lcuErrReadInstrumentName() \
	{ \
	lcctooLOG_0("ic0lcuERR_READ_INSTRUMENT_NAME: Error reading OLDB attribute instrumentName."); \
	errAdd(error,"ic0lcu",ic0lcuERR_READ_INSTRUMENT_NAME,__FILE_LINE__,""); \
	}
#define ic0lcuErrReadInterval() \
	{ \
	lcctooLOG_0("ic0lcuERR_READ_INTERVAL: Error reading OLDB attribute interval."); \
	errAdd(error,"ic0lcu",ic0lcuERR_READ_INTERVAL,__FILE_LINE__,""); \
	}
#define ic0lcuErrReadKeywords(p1) \
	{ \
	lcctooLOG_0("ic0lcuERR_READ_KEYWORDS: Error reading OLDB table keywords (%s).",(p1)); \
	errAdd(error,"ic0lcu",ic0lcuERR_READ_KEYWORDS,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0lcuErrReadMaxParallel() \
	{ \
	lcctooLOG_0("ic0lcuERR_READ_MAX_PARALLEL: Error reading OLDB attribute maxParallel."); \
	errAdd(error,"ic0lcu",ic0lcuERR_READ_MAX_PARALLEL,__FILE_LINE__,""); \
	}
#define ic0lcuErrReadModeConfigOrder() \
	{ \
	lcctooLOG_0("ic0lcuERR_READ_MODE_CONFIG_ORDER: Error reading OLDB attribute modeConfigOrder."); \
	errAdd(error,"ic0lcu",ic0lcuERR_READ_MODE_CONFIG_ORDER,__FILE_LINE__,""); \
	}
#define ic0lcuErrReadModeSet() \
	{ \
	lcctooLOG_0("ic0lcuERR_READ_MODE_SET: Error reading OLDB attribute modeSet."); \
	errAdd(error,"ic0lcu",ic0lcuERR_READ_MODE_SET,__FILE_LINE__,""); \
	}
#define ic0lcuErrReadMode() \
	{ \
	lcctooLOG_0("ic0lcuERR_READ_MODE: Error reading OLDB attribute mode."); \
	errAdd(error,"ic0lcu",ic0lcuERR_READ_MODE,__FILE_LINE__,""); \
	}
#define ic0lcuErrReadModes(p1) \
	{ \
	lcctooLOG_0("ic0lcuERR_READ_MODES: Error reading OLDB table modes (%s).",(p1)); \
	errAdd(error,"ic0lcu",ic0lcuERR_READ_MODES,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0lcuErrReadMoveStopReq() \
	{ \
	lcctooLOG_0("ic0lcuERR_READ_MOVE_STOP_REQ: Error reading OLDB attribute moveStopReq."); \
	errAdd(error,"ic0lcu",ic0lcuERR_READ_MOVE_STOP_REQ,__FILE_LINE__,""); \
	}
#define ic0lcuErrReadNextMode() \
	{ \
	lcctooLOG_0("ic0lcuERR_READ_NEXT_MODE: Error reading OLDB attribute nextMode."); \
	errAdd(error,"ic0lcu",ic0lcuERR_READ_NEXT_MODE,__FILE_LINE__,""); \
	}
#define ic0lcuErrReadPrefix() \
	{ \
	lcctooLOG_0("ic0lcuERR_READ_PREFIX: Error reading OLDB attribute prefix."); \
	errAdd(error,"ic0lcu",ic0lcuERR_READ_PREFIX,__FILE_LINE__,""); \
	}
#define ic0lcuErrReadState() \
	{ \
	lcctooLOG_0("ic0lcuERR_READ_STATE: Error reading OLDB attribute state."); \
	errAdd(error,"ic0lcu",ic0lcuERR_READ_STATE,__FILE_LINE__,""); \
	}
#define ic0lcuErrReadTimeout1() \
	{ \
	lcctooLOG_0("ic0lcuERR_READ_TIMEOUT1: Error reading OLDB attribute timeout1."); \
	errAdd(error,"ic0lcu",ic0lcuERR_READ_TIMEOUT1,__FILE_LINE__,""); \
	}
#define ic0lcuErrReadTimeout2() \
	{ \
	lcctooLOG_0("ic0lcuERR_READ_TIMEOUT2: Error reading OLDB attribute timeout2."); \
	errAdd(error,"ic0lcu",ic0lcuERR_READ_TIMEOUT2,__FILE_LINE__,""); \
	}
#define ic0lcuErrRecv(p1,p2) \
	{ \
	if (lcctooDebugLevel > 1) \
	    { \
	    lcctooLOG_0("ic0lcuERR_RECV: Error receiving reply from device %s (command %s).",(p1),(p2)); \
	    errAdd(error,"ic0lcu",ic0lcuERR_RECV,__FILE_LINE__,"%s,%s",(p1),(p2)); \
	    } \
	}
#define ic0lcuErrSemCmdLocked() \
	{ \
	lcctooLOG_0("ic0lcuERR_SEM_CMD_LOCKED: Command semaphore locked. Probably another command is executing."); \
	errAdd(error,"ic0lcu",ic0lcuERR_SEM_CMD_LOCKED,__FILE_LINE__,""); \
	}
#define ic0lcuErrSemActionLocked() \
	{ \
	lcctooLOG_0("ic0lcuERR_SEM_ACTION_LOCKED: Action semaphore locked. Probably another command is executing."); \
	errAdd(error,"ic0lcu",ic0lcuERR_SEM_ACTION_LOCKED,__FILE_LINE__,""); \
	}
#define ic0lcuErrSemSendLocked() \
	{ \
	lcctooLOG_0("ic0lcuERR_SEM_SEND_LOCKED: Move semaphore locked. Probably another command is executing."); \
	errAdd(error,"ic0lcu",ic0lcuERR_SEM_SEND_LOCKED,__FILE_LINE__,""); \
	}
#define ic0lcuErrSend(p1,p2) \
	{ \
	lcctooLOG_0("ic0lcuERR_SEND: Error sending to device %s command %s.",(p1),(p2)); \
	errAdd(error,"ic0lcu",ic0lcuERR_SEND,__FILE_LINE__,"%s,%s",(p1),(p2)); \
	}
#define ic0lcuErrStatus(p1) \
	{ \
	lcctooLOG_0("ic0lcuERR_STATUS: Unable to get keyword '%s'. Device is not in STANDBY or ONLINE state, or not available.",(p1)); \
	errAdd(error,"ic0lcu",ic0lcuERR_STATUS,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0lcuErrSetState() \
	{ \
	lcctooLOG_0("ic0lcuERR_SET_STATE: Error setting the global state of the LCU part of ICS."); \
	errAdd(error,"ic0lcu",ic0lcuERR_SET_STATE,__FILE_LINE__,""); \
	}
#define ic0lcuErrWriteActionArgs(p1) \
	{ \
	lcctooLOG_0("ic0lcuERR_WRITE_ACTION_ARGS: Error writing to OLDB attribute actionArgs (value '%s').",(p1)); \
	errAdd(error,"ic0lcu",ic0lcuERR_WRITE_ACTION_ARGS,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0lcuErrWriteActionReplies(p1) \
	{ \
	lcctooLOG_0("ic0lcuERR_WRITE_ACTION_REPLIES: Error writing to OLDB attribute actionReplies (value %d).",(p1)); \
	errAdd(error,"ic0lcu",ic0lcuERR_WRITE_ACTION_REPLIES,__FILE_LINE__,"%d",(p1)); \
	}
#define ic0lcuErrWriteActionStep(p1) \
	{ \
	lcctooLOG_0("ic0lcuERR_WRITE_ACTION_STEP: Error writing to OLDB attribute actionStep (value %d).",(p1)); \
	errAdd(error,"ic0lcu",ic0lcuERR_WRITE_ACTION_STEP,__FILE_LINE__,"%d",(p1)); \
	}
#define ic0lcuErrWriteActionStopReq(p1) \
	{ \
	lcctooLOG_0("ic0lcuERR_WRITE_ACTION_STOP_REQ: Error writing to OLDB attribute actionStopReq (value %d).",(p1)); \
	errAdd(error,"ic0lcu",ic0lcuERR_WRITE_ACTION_STOP_REQ,__FILE_LINE__,"%d",(p1)); \
	}
#define ic0lcuErrWriteActionValue(p1) \
	{ \
	lcctooLOG_0("ic0lcuERR_WRITE_ACTION_VALUE: Error writing to OLDB attribute actionValue (value %f).",(p1)); \
	errAdd(error,"ic0lcu",ic0lcuERR_WRITE_ACTION_VALUE,__FILE_LINE__,"%f",(p1)); \
	}
#define ic0lcuErrWriteFunctions(p1) \
	{ \
	lcctooLOG_0("ic0lcuERR_WRITE_FUNCTIONS: Error writing to OLDB table functions (%s).",(p1)); \
	errAdd(error,"ic0lcu",ic0lcuERR_WRITE_FUNCTIONS,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0lcuErrWriteMode(p1) \
	{ \
	lcctooLOG_0("ic0lcuERR_WRITE_MODE: Error writing to OLDB attribute mode (value %s).",(p1)); \
	errAdd(error,"ic0lcu",ic0lcuERR_WRITE_MODE,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0lcuErrWriteModeSet(p1) \
	{ \
	lcctooLOG_0("ic0lcuERR_WRITE_MODE_SET: Error writing to OLDB attribute modeSet (value %d).",(p1)); \
	errAdd(error,"ic0lcu",ic0lcuERR_WRITE_MODE_SET,__FILE_LINE__,"%d",(p1)); \
	}
#define ic0lcuErrWriteMoveStopReq(p1) \
	{ \
	lcctooLOG_0("ic0lcuERR_WRITE_MOVE_STOP_REQ: Error writing to OLDB attribute moveStopReq (value %d).",(p1)); \
	errAdd(error,"ic0lcu",ic0lcuERR_WRITE_MOVE_STOP_REQ,__FILE_LINE__,"%d",(p1)); \
	}
#define ic0lcuErrWriteNextMode(p1) \
	{ \
	lcctooLOG_0("ic0lcuERR_WRITE_NEXT_MODE: Error writing to OLDB attribute nextMode (value %s).",(p1)); \
	errAdd(error,"ic0lcu",ic0lcuERR_WRITE_NEXT_MODE,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0lcuErrWriteState(p1) \
	{ \
	lcctooLOG_0("ic0lcuERR_WRITE_STATE: Error writing to OLDB attribute state (value %s).",(p1)); \
	errAdd(error,"ic0lcu",ic0lcuERR_WRITE_STATE,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0lcuErrWrongAction(p1) \
	{ \
	lcctooLOG_0("ic0lcuERR_WRONG_ACTION: Unknown action type %d.",(p1)); \
	errAdd(error,"ic0lcu",ic0lcuERR_WRONG_ACTION,__FILE_LINE__,"%d",(p1)); \
	}
#define ic0lcuErrWrongActionStep(p1) \
	{ \
	lcctooLOG_0("ic0lcuERR_WRONG_ACTION_STEP: Wrong action step %d.",(p1)); \
	errAdd(error,"ic0lcu",ic0lcuERR_WRONG_ACTION_STEP,__FILE_LINE__,"%d",(p1)); \
	}
#define ic0lcuErrWrongCommand(p1) \
	{ \
	lcctooLOG_0("ic0lcuERR_WRONG_COMMAND: Unknown command (index %d).",(p1)); \
	errAdd(error,"ic0lcu",ic0lcuERR_WRONG_COMMAND,__FILE_LINE__,"%d",(p1)); \
	}
#define ic0lcuErrWrongFunction(p1) \
	{ \
	lcctooLOG_0("ic0lcuERR_WRONG_FUNCTION: Function %s unknown.",(p1)); \
	errAdd(error,"ic0lcu",ic0lcuERR_WRONG_FUNCTION,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0lcuErrWrongIndex(p1) \
	{ \
	lcctooLOG_0("ic0lcuERR_WRONG_INDEX: Function index %d unknown.",(p1)); \
	errAdd(error,"ic0lcu",ic0lcuERR_WRONG_INDEX,__FILE_LINE__,"%d",(p1)); \
	}
#define ic0lcuErrWrongInstrumentName(p1) \
	{ \
	lcctooLOG_0("ic0lcuERR_WRONG_INSTRUMENT_NAME: Wrong instrument name %s.",(p1)); \
	errAdd(error,"ic0lcu",ic0lcuERR_WRONG_INSTRUMENT_NAME,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0lcuErrWrongKeyword(p1) \
	{ \
	lcctooLOG_0("ic0lcuERR_WRONG_KEYWORD: Keyword %s unknown.",(p1)); \
	errAdd(error,"ic0lcu",ic0lcuERR_WRONG_KEYWORD,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0lcuErrWrongKeywordIndex(p1,p2) \
	{ \
	lcctooLOG_0("ic0lcuERR_WRONG_KEYWORD_INDEX: Keyword %s can not be forwarded to any device (index %d).",(p1),(p2)); \
	errAdd(error,"ic0lcu",ic0lcuERR_WRONG_KEYWORD_INDEX,__FILE_LINE__,"%s,%d",(p1),(p2)); \
	}
#define ic0lcuErrWrongMode(p1) \
	{ \
	lcctooLOG_0("ic0lcuERR_WRONG_MODE: Unknown instrument mode %s.",(p1)); \
	errAdd(error,"ic0lcu",ic0lcuERR_WRONG_MODE,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0lcuErrWrongModeIndex(p1) \
	{ \
	lcctooLOG_0("ic0lcuERR_WRONG_MODE_INDEX: Unknown instrument mode (index %d).",(p1)); \
	errAdd(error,"ic0lcu",ic0lcuERR_WRONG_MODE_INDEX,__FILE_LINE__,"%d",(p1)); \
	}
#define ic0lcuErrWrongOrder(p1) \
	{ \
	lcctooLOG_0("ic0lcuERR_WRONG_ORDER: Wrong order entry %d in function table.",(p1)); \
	errAdd(error,"ic0lcu",ic0lcuERR_WRONG_ORDER,__FILE_LINE__,"%d",(p1)); \
	}
#define ic0lcuErrWrongSetup(p1) \
	{ \
	lcctooLOG_0("ic0lcuERR_WRONG_SETUP: Wrong number of parameters %d (should be multiple of two).",(p1)); \
	errAdd(error,"ic0lcu",ic0lcuERR_WRONG_SETUP,__FILE_LINE__,"%d",(p1)); \
	}
#define ic0lcuErrWrongStatus(p1) \
	{ \
	lcctooLOG_0("ic0lcuERR_WRONG_STATUS: Unknown status code %d.",(p1)); \
	errAdd(error,"ic0lcu",ic0lcuERR_WRONG_STATUS,__FILE_LINE__,"%d",(p1)); \
	}

/*
 * get object owner
 */
#define ic0lcuCmdGetOwner(obj) ((obj)->owner)


/*
 * attribute access functions
 */
#define ic0lcuCmdReadState(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0lcuCMD_ATTR_STATE,(buf),(error))
#define ic0lcuCmdWriteState(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0lcuCMD_ATTR_STATE,(void*) (buf),(error))
#define ic0lcuCmdReadMode(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0lcuCMD_ATTR_MODE,(buf),(error))
#define ic0lcuCmdWriteMode(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0lcuCMD_ATTR_MODE,(void*) (buf),(error))
#define ic0lcuCmdReadNextMode(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0lcuCMD_ATTR_NEXT_MODE,(buf),(error))
#define ic0lcuCmdWriteNextMode(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0lcuCMD_ATTR_NEXT_MODE,(void*) (buf),(error))
#define ic0lcuCmdReadActionReplies(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0lcuCMD_ATTR_ACTION_REPLIES,(buf),(error))
#define ic0lcuCmdWriteActionReplies(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0lcuCMD_ATTR_ACTION_REPLIES,(void*) (buf),(error))
#define ic0lcuCmdReadActionStep(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0lcuCMD_ATTR_ACTION_STEP,(buf),(error))
#define ic0lcuCmdWriteActionStep(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0lcuCMD_ATTR_ACTION_STEP,(void*) (buf),(error))
#define ic0lcuCmdReadActionValue(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0lcuCMD_ATTR_ACTION_VALUE,(buf),(error))
#define ic0lcuCmdWriteActionValue(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0lcuCMD_ATTR_ACTION_VALUE,(void*) (buf),(error))
#define ic0lcuCmdReadActionStopReq(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0lcuCMD_ATTR_ACTION_STOP_REQ,(buf),(error))
#define ic0lcuCmdWriteActionStopReq(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0lcuCMD_ATTR_ACTION_STOP_REQ,(void*) (buf),(error))
#define ic0lcuCmdReadMoveStopReq(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0lcuCMD_ATTR_MOVE_STOP_REQ,(buf),(error))
#define ic0lcuCmdWriteMoveStopReq(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0lcuCMD_ATTR_MOVE_STOP_REQ,(void*) (buf),(error))
#define ic0lcuCmdReadInstrumentName(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0lcuCMD_ATTR_INSTRUMENT_NAME,(buf),(error))
#define ic0lcuCmdWriteInstrumentName(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0lcuCMD_ATTR_INSTRUMENT_NAME,(void*) (buf),(error))
#define ic0lcuCmdReadPrefix(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0lcuCMD_ATTR_PREFIX,(buf),(error))
#define ic0lcuCmdWritePrefix(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0lcuCMD_ATTR_PREFIX,(void*) (buf),(error))
#define ic0lcuCmdReadFunctionsSize(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0lcuCMD_ATTR_FUNCTIONS_SIZE,(buf),(error))
#define ic0lcuCmdWriteFunctionsSize(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0lcuCMD_ATTR_FUNCTIONS_SIZE,(void*) (buf),(error))
#define ic0lcuCmdGetFunctionsSize(obj,num,error) \
	caiGetAttrInfo((obj)->attrs,ic0lcuCMD_ATTR_FUNCTIONS,NULL,NULL,(num),NULL, NULL,NULL,(error))
#define ic0lcuCmdReadFunctions(obj,buf,firstRec,lastRec,firstFld,lastFld,error) \
	lcctooCaiRWTable((obj)->attrs,0,ic0lcuCMD_ATTR_FUNCTIONS,(buf),(firstRec),(lastRec),(firstFld),(lastFld),(error))
#define ic0lcuCmdWriteFunctions(obj,buf,firstRec,lastRec,firstFld,lastFld,error) \
	lcctooCaiRWTable((obj)->attrs,1,ic0lcuCMD_ATTR_FUNCTIONS,(void*) (buf),(firstRec),(lastRec),(firstFld),(lastFld),(error))
#define ic0lcuCmdReadModeConfigOrder(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0lcuCMD_ATTR_MODE_CONFIG_ORDER,(buf),(error))
#define ic0lcuCmdWriteModeConfigOrder(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0lcuCMD_ATTR_MODE_CONFIG_ORDER,(void*) (buf),(error))
#define ic0lcuCmdReadKeywordsSize(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0lcuCMD_ATTR_KEYWORDS_SIZE,(buf),(error))
#define ic0lcuCmdWriteKeywordsSize(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0lcuCMD_ATTR_KEYWORDS_SIZE,(void*) (buf),(error))
#define ic0lcuCmdGetKeywordsSize(obj,num,error) \
	caiGetAttrInfo((obj)->attrs,ic0lcuCMD_ATTR_KEYWORDS,NULL,NULL,(num),NULL, NULL,NULL,(error))
#define ic0lcuCmdReadKeywords(obj,buf,firstRec,lastRec,firstFld,lastFld,error) \
	lcctooCaiRWTable((obj)->attrs,0,ic0lcuCMD_ATTR_KEYWORDS,(buf),(firstRec),(lastRec),(firstFld),(lastFld),(error))
#define ic0lcuCmdWriteKeywords(obj,buf,firstRec,lastRec,firstFld,lastFld,error) \
	lcctooCaiRWTable((obj)->attrs,1,ic0lcuCMD_ATTR_KEYWORDS,(void*) (buf),(firstRec),(lastRec),(firstFld),(lastFld),(error))
#define ic0lcuCmdReadModesSize(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0lcuCMD_ATTR_MODES_SIZE,(buf),(error))
#define ic0lcuCmdWriteModesSize(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0lcuCMD_ATTR_MODES_SIZE,(void*) (buf),(error))
#define ic0lcuCmdGetModesSize(obj,num,error) \
	caiGetAttrInfo((obj)->attrs,ic0lcuCMD_ATTR_MODES,NULL,NULL,(num),NULL, NULL,NULL,(error))
#define ic0lcuCmdReadModes(obj,buf,firstRec,lastRec,firstFld,lastFld,error) \
	lcctooCaiRWTable((obj)->attrs,0,ic0lcuCMD_ATTR_MODES,(buf),(firstRec),(lastRec),(firstFld),(lastFld),(error))
#define ic0lcuCmdWriteModes(obj,buf,firstRec,lastRec,firstFld,lastFld,error) \
	lcctooCaiRWTable((obj)->attrs,1,ic0lcuCMD_ATTR_MODES,(void*) (buf),(firstRec),(lastRec),(firstFld),(lastFld),(error))
#define ic0lcuCmdGetActionsSize(obj,num,error) \
	caiGetAttrInfo((obj)->attrs,ic0lcuCMD_ATTR_ACTIONS,NULL,NULL,(num),NULL, NULL,NULL,(error))
#define ic0lcuCmdReadActions(obj,buf,firstRec,lastRec,firstFld,lastFld,error) \
	lcctooCaiRWTable((obj)->attrs,0,ic0lcuCMD_ATTR_ACTIONS,(buf),(firstRec),(lastRec),(firstFld),(lastFld),(error))
#define ic0lcuCmdWriteActions(obj,buf,firstRec,lastRec,firstFld,lastFld,error) \
	lcctooCaiRWTable((obj)->attrs,1,ic0lcuCMD_ATTR_ACTIONS,(void*) (buf),(firstRec),(lastRec),(firstFld),(lastFld),(error))
#define ic0lcuCmdReadTimeout1(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0lcuCMD_ATTR_TIMEOUT1,(buf),(error))
#define ic0lcuCmdWriteTimeout1(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0lcuCMD_ATTR_TIMEOUT1,(void*) (buf),(error))
#define ic0lcuCmdReadTimeout2(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0lcuCMD_ATTR_TIMEOUT2,(buf),(error))
#define ic0lcuCmdWriteTimeout2(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0lcuCMD_ATTR_TIMEOUT2,(void*) (buf),(error))
#define ic0lcuCmdReadMotTimeout(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0lcuCMD_ATTR_MOT_TIMEOUT,(buf),(error))
#define ic0lcuCmdWriteMotTimeout(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0lcuCMD_ATTR_MOT_TIMEOUT,(void*) (buf),(error))
#define ic0lcuCmdReadInterval(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0lcuCMD_ATTR_INTERVAL,(buf),(error))
#define ic0lcuCmdWriteInterval(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0lcuCMD_ATTR_INTERVAL,(void*) (buf),(error))
#define ic0lcuCmdReadMaxParallel(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0lcuCMD_ATTR_MAX_PARALLEL,(buf),(error))
#define ic0lcuCmdWriteMaxParallel(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0lcuCMD_ATTR_MAX_PARALLEL,(void*) (buf),(error))
#define ic0lcuCmdReadDbBackupFile(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0lcuCMD_ATTR_DB_BACKUP_FILE,(buf),(error))
#define ic0lcuCmdWriteDbBackupFile(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0lcuCMD_ATTR_DB_BACKUP_FILE,(void*) (buf),(error))
#define ic0lcuCmdReadModeSet(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0lcuCMD_ATTR_MODE_SET,(buf),(error))
#define ic0lcuCmdWriteModeSet(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0lcuCMD_ATTR_MODE_SET,(void*) (buf),(error))
#define ic0lcuCmdReadActionArgs(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0lcuCMD_ATTR_ACTION_ARGS,(buf),(error))
#define ic0lcuCmdWriteActionArgs(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0lcuCMD_ATTR_ACTION_ARGS,(void*) (buf),(error))


/*
 * class functions
 */

ccsCOMPL_STAT ic0lcuCmdVerbose(
    INOUT egenOBJ*	obj,
    IN    const char*	status,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0lcuCmdStandby(
    INOUT egenOBJ*	obj,
    IN    const char*	function[],	/* max. vltBYTES32[100] */
    IN    vltINT16	functionNum,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0lcuCmdOnline(
    INOUT egenOBJ*	obj,
    IN    const char*	function[],	/* max. vltBYTES32[100] */
    IN    vltINT16	functionNum,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0lcuCmdOff(
    INOUT egenOBJ*	obj,
    IN    const char*	function[],	/* max. vltBYTES32[100] */
    IN    vltINT16	functionNum,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0lcuCmdExit(
    INOUT egenOBJ*	obj,
    IN    const char*	function[],	/* max. vltBYTES32[100] */
    IN    vltINT16	functionNum,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0lcuCmdState(
    INOUT egenOBJ*	obj,
    IN    const char*	function[],	/* max. vltBYTES32[100] */
    IN    vltINT16	functionNum,
    IN    vltLOGICAL	global,
    OUT   char**	state,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0lcuCmdSimulat(
    INOUT egenOBJ*	obj,
    IN    const char*	function[],	/* max. vltBYTES32[100] */
    IN    vltINT16	functionNum,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0lcuCmdStopSim(
    INOUT egenOBJ*	obj,
    IN    const char*	function[],	/* max. vltBYTES32[100] */
    IN    vltINT16	functionNum,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0lcuCmdStatus(
    INOUT egenOBJ*	obj,
    IN    const char*	function[],	/* max. vltBYTES32[999] */
    IN    vltINT16	functionNum,
    IN    vltLOGICAL	flag,
    IN    vltLOGICAL	header,
    IN    vltLOGICAL	conflog,
    IN    vltLOGICAL	opslog,
    IN    vltLOGICAL	condlog,
    OUT   char**	status,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0lcuCmdInit(
    INOUT egenOBJ*	obj,
    IN    const char*	function[],	/* max. vltBYTES32[100] */
    IN    vltINT16	functionNum,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0lcuCmdStop(
    INOUT egenOBJ*	obj,
    IN    const char*	function[],	/* max. vltBYTES32[100] */
    IN    vltINT16	functionNum,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0lcuCmdTest(
    INOUT egenOBJ*	obj,
    IN    const char*	function[],	/* max. vltBYTES32[100] */
    IN    vltINT16	functionNum,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0lcuCmdSelftst(
    INOUT egenOBJ*	obj,
    IN    const char*	function[],	/* max. vltBYTES32[100] */
    IN    vltINT16	functionNum,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0lcuCmdDisable(
    INOUT egenOBJ*	obj,
    IN    const char*	function[],	/* max. vltBYTES32[100] */
    IN    vltINT16	functionNum,
    IN    const char*	access,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0lcuCmdEnable(
    INOUT egenOBJ*	obj,
    IN    const char*	function[],	/* max. vltBYTES32[100] */
    IN    vltINT16	functionNum,
    IN    const char*	access,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0lcuCmdLock(
    INOUT egenOBJ*	obj,
    IN    const char*	function[],	/* max. vltBYTES32[100] */
    IN    vltINT16	functionNum,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0lcuCmdUnlock(
    INOUT egenOBJ*	obj,
    IN    const char*	function[],	/* max. vltBYTES32[100] */
    IN    vltINT16	functionNum,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0lcuCmdHandset(
    INOUT egenOBJ*	obj,
    IN    const char*	function[],	/* max. vltBYTES32[100] */
    IN    vltINT16	functionNum,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0lcuCmdHsetOff(
    INOUT egenOBJ*	obj,
    IN    const char*	function[],	/* max. vltBYTES32[100] */
    IN    vltINT16	functionNum,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0lcuCmdFixPos(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    const char*	position[],	/* max. vltBYTES32[999] */
    IN    vltINT16	positionNum,
    IN    vltLOGICAL	reset,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0lcuCmdMove(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    const char*	position[],	/* max. vltBYTES32[999] */
    IN    vltINT16	positionNum,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0lcuCmdMoveRel(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    const char*	position[],	/* max. vltBYTES32[999] */
    IN    vltINT16	positionNum,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0lcuCmdSet(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    const char*	position[],	/* max. vltBYTES32[999] */
    IN    vltINT16	positionNum,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0lcuCmdCheck(
    INOUT egenOBJ*	obj,
    IN    const char*	function[],	/* max. vltBYTES32[100] */
    IN    vltINT16	functionNum,
    OUT   char**	status,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0lcuCmdWait(
    INOUT egenOBJ*	obj,
    IN    const char*	function[],	/* max. vltBYTES32[100] */
    IN    vltINT16	functionNum,
    IN    vltINT32	timeout,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0lcuCmdSetup(
    INOUT egenOBJ*	obj,
    IN    const char*	function[],	/* max. vltBYTES32[999] */
    IN    vltINT16	functionNum,
    IN    vltLOGICAL	noMove,
    IN    vltLOGICAL	check,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0lcuCmdGetVal(
    INOUT egenOBJ*	obj,
    IN    const char*	function,
    IN    const char*	name[],	/* max. vltBYTES32[2] */
    IN    vltINT16	nameNum,
    OUT   char**	status,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0lcuCmdSetVal(
    INOUT egenOBJ*	obj,
    IN    const char*	function,
    IN    const char*	name[],	/* max. vltBYTES32[2] */
    IN    vltINT16	nameNum,
    IN    const char*	value[],	/* max. vltBYTES32[10] */
    IN    vltINT16	valueNum,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0lcuCmdCfgElem(
    INOUT egenOBJ*	obj,
    IN    const char*	function,
    IN    vltINT32	position,
    IN    const char*	id,
    IN    const char*	values[],	/* max. vltBYTES16[10] */
    IN    vltINT16	valuesNum,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0lcuCmdLogConf(
    INOUT egenOBJ*	obj,
    IN    const char*	function[],	/* max. vltBYTES32[100] */
    IN    vltINT16	functionNum,
    IN    vltLOGICAL	allElements,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0lcuCmdGetConf(
    INOUT egenOBJ*	obj,
    IN    const char*	function[],	/* max. vltBYTES32[100] */
    IN    vltINT16	functionNum,
    IN    vltLOGICAL	allElements,
    OUT   char**	text,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0lcuCmdUsrGetRevision(
    INOUT egenOBJ*	obj,
    OUT   char**	revision,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0lcuCmdInitObj(
    INOUT egenOBJ*	obj,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0lcuCmdExitObj(
    INOUT egenOBJ*	obj,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0lcuCmdFctProcess(
    INOUT egenOBJ*	obj,
    IN    vltINT32	command,
    IN    const char*	function[],	/* max. vltBYTES32[100] */
    IN    vltINT16	functionNum,
    IN    vltINT32	status,
    IN    vltINT32	arg1,
    IN    const char*	arg2,
    IN    vltLOGICAL	arg3,
    OUT   char**	arg4,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0lcuCmdFctIsAll(
    INOUT egenOBJ*	obj,
    IN    const char*	name,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0lcuCmdFctIsDup(
    INOUT egenOBJ*	obj,
    IN    const char*	name,
    OUT   vltLOGICAL*	dup,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0lcuCmdFctGetByName(
    INOUT egenOBJ*	obj,
    IN    const char*	name,
    OUT   ic0lcuCMD_FCT**	fct,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0lcuCmdFctGetByIndex(
    INOUT egenOBJ*	obj,
    IN    vltINT32	index,
    OUT   ic0lcuCMD_FCT**	fct,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0lcuCmdFctGetByStatus(
    INOUT egenOBJ*	obj,
    IN    vltINT32	status,
    OUT   vltLOGICAL	fctFlags[],	/* max. vltLOGICAL[100] */
    OUT   vltINT16*	fctFlagsNum,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0lcuCmdKeyGetByName(
    INOUT egenOBJ*	obj,
    IN    const char*	name,
    OUT   ic0lcuCMD_KEY**	key,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0lcuCmdKeyIsSpecial(
    INOUT egenOBJ*	obj,
    IN    ic0lcuCMD_KEY*	key,
    INOUT char**	value,
    OUT   vltINT32*	keyType,
    OUT   vltINT32*	mode,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0lcuCmdExecMode(
    INOUT egenOBJ*	obj,
    IN    vltINT32	mode,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0lcuCmdExecAction(
    INOUT egenOBJ*	obj,
    IN    vltINT32	index,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0lcuCmdActions(
    INOUT egenOBJ*	obj,
    IN    ic0lcuCMD_ACTION*	action,
    OUT   vltLOGICAL*	end,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0lcuCmdSetState(
    INOUT egenOBJ*	obj,
    OUT   char**	state,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0lcuCmdUsrStatus(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltLOGICAL	flag,
    IN    vltLOGICAL	header,
    IN    vltLOGICAL	conflog,
    IN    vltLOGICAL	opslog,
    IN    vltLOGICAL	condlog,
    OUT   char**	status,
    OUT   ccsERROR*	error);


/*
 * virtual functions
 */
#define ic0lcuCmdVVerbose(obj,status,error) \
	(*((ic0lcuCMD_FCTPTR_VERBOSE)((obj)->fcts[ic0lcuCMD_FCT_VERBOSE]))) \
	 ((obj),(status),(error))
#define ic0lcuCmdVStandby(obj,function,functionNum,error) \
	(*((ic0lcuCMD_FCTPTR_STANDBY)((obj)->fcts[ic0lcuCMD_FCT_STANDBY]))) \
	 ((obj),(function),(functionNum),(error))
#define ic0lcuCmdVOnline(obj,function,functionNum,error) \
	(*((ic0lcuCMD_FCTPTR_ONLINE)((obj)->fcts[ic0lcuCMD_FCT_ONLINE]))) \
	 ((obj),(function),(functionNum),(error))
#define ic0lcuCmdVOff(obj,function,functionNum,error) \
	(*((ic0lcuCMD_FCTPTR_OFF)((obj)->fcts[ic0lcuCMD_FCT_OFF]))) \
	 ((obj),(function),(functionNum),(error))
#define ic0lcuCmdVExit(obj,function,functionNum,error) \
	(*((ic0lcuCMD_FCTPTR_EXIT)((obj)->fcts[ic0lcuCMD_FCT_EXIT]))) \
	 ((obj),(function),(functionNum),(error))
#define ic0lcuCmdVState(obj,function,functionNum,global,state,error) \
	(*((ic0lcuCMD_FCTPTR_STATE)((obj)->fcts[ic0lcuCMD_FCT_STATE]))) \
	 ((obj),(function),(functionNum),(global),(state),(error))
#define ic0lcuCmdVSimulat(obj,function,functionNum,error) \
	(*((ic0lcuCMD_FCTPTR_SIMULAT)((obj)->fcts[ic0lcuCMD_FCT_SIMULAT]))) \
	 ((obj),(function),(functionNum),(error))
#define ic0lcuCmdVStopSim(obj,function,functionNum,error) \
	(*((ic0lcuCMD_FCTPTR_STOP_SIM)((obj)->fcts[ic0lcuCMD_FCT_STOP_SIM]))) \
	 ((obj),(function),(functionNum),(error))
#define ic0lcuCmdVStatus(obj,function,functionNum,flag,header,conflog,opslog,condlog,status,error) \
	(*((ic0lcuCMD_FCTPTR_STATUS)((obj)->fcts[ic0lcuCMD_FCT_STATUS]))) \
	 ((obj),(function),(functionNum),(flag),(header),(conflog),(opslog),(condlog),(status),(error))
#define ic0lcuCmdVInit(obj,function,functionNum,error) \
	(*((ic0lcuCMD_FCTPTR_INIT)((obj)->fcts[ic0lcuCMD_FCT_INIT]))) \
	 ((obj),(function),(functionNum),(error))
#define ic0lcuCmdVStop(obj,function,functionNum,error) \
	(*((ic0lcuCMD_FCTPTR_STOP)((obj)->fcts[ic0lcuCMD_FCT_STOP]))) \
	 ((obj),(function),(functionNum),(error))
#define ic0lcuCmdVTest(obj,function,functionNum,error) \
	(*((ic0lcuCMD_FCTPTR_TEST)((obj)->fcts[ic0lcuCMD_FCT_TEST]))) \
	 ((obj),(function),(functionNum),(error))
#define ic0lcuCmdVSelftst(obj,function,functionNum,error) \
	(*((ic0lcuCMD_FCTPTR_SELFTST)((obj)->fcts[ic0lcuCMD_FCT_SELFTST]))) \
	 ((obj),(function),(functionNum),(error))
#define ic0lcuCmdVDisable(obj,function,functionNum,access,error) \
	(*((ic0lcuCMD_FCTPTR_DISABLE)((obj)->fcts[ic0lcuCMD_FCT_DISABLE]))) \
	 ((obj),(function),(functionNum),(access),(error))
#define ic0lcuCmdVEnable(obj,function,functionNum,access,error) \
	(*((ic0lcuCMD_FCTPTR_ENABLE)((obj)->fcts[ic0lcuCMD_FCT_ENABLE]))) \
	 ((obj),(function),(functionNum),(access),(error))
#define ic0lcuCmdVLock(obj,function,functionNum,error) \
	(*((ic0lcuCMD_FCTPTR_LOCK)((obj)->fcts[ic0lcuCMD_FCT_LOCK]))) \
	 ((obj),(function),(functionNum),(error))
#define ic0lcuCmdVUnlock(obj,function,functionNum,error) \
	(*((ic0lcuCMD_FCTPTR_UNLOCK)((obj)->fcts[ic0lcuCMD_FCT_UNLOCK]))) \
	 ((obj),(function),(functionNum),(error))
#define ic0lcuCmdVHandset(obj,function,functionNum,error) \
	(*((ic0lcuCMD_FCTPTR_HANDSET)((obj)->fcts[ic0lcuCMD_FCT_HANDSET]))) \
	 ((obj),(function),(functionNum),(error))
#define ic0lcuCmdVHsetOff(obj,function,functionNum,error) \
	(*((ic0lcuCMD_FCTPTR_HSET_OFF)((obj)->fcts[ic0lcuCMD_FCT_HSET_OFF]))) \
	 ((obj),(function),(functionNum),(error))
#define ic0lcuCmdVFixPos(obj,devName,position,positionNum,reset,error) \
	(*((ic0lcuCMD_FCTPTR_FIX_POS)((obj)->fcts[ic0lcuCMD_FCT_FIX_POS]))) \
	 ((obj),(devName),(position),(positionNum),(reset),(error))
#define ic0lcuCmdVMove(obj,devName,position,positionNum,error) \
	(*((ic0lcuCMD_FCTPTR_MOVE)((obj)->fcts[ic0lcuCMD_FCT_MOVE]))) \
	 ((obj),(devName),(position),(positionNum),(error))
#define ic0lcuCmdVMoveRel(obj,devName,position,positionNum,error) \
	(*((ic0lcuCMD_FCTPTR_MOVE_REL)((obj)->fcts[ic0lcuCMD_FCT_MOVE_REL]))) \
	 ((obj),(devName),(position),(positionNum),(error))
#define ic0lcuCmdVSet(obj,devName,position,positionNum,error) \
	(*((ic0lcuCMD_FCTPTR_SET)((obj)->fcts[ic0lcuCMD_FCT_SET]))) \
	 ((obj),(devName),(position),(positionNum),(error))
#define ic0lcuCmdVCheck(obj,function,functionNum,status,error) \
	(*((ic0lcuCMD_FCTPTR_CHECK)((obj)->fcts[ic0lcuCMD_FCT_CHECK]))) \
	 ((obj),(function),(functionNum),(status),(error))
#define ic0lcuCmdVWait(obj,function,functionNum,timeout,error) \
	(*((ic0lcuCMD_FCTPTR_WAIT)((obj)->fcts[ic0lcuCMD_FCT_WAIT]))) \
	 ((obj),(function),(functionNum),(timeout),(error))
#define ic0lcuCmdVSetup(obj,function,functionNum,noMove,check,error) \
	(*((ic0lcuCMD_FCTPTR_SETUP)((obj)->fcts[ic0lcuCMD_FCT_SETUP]))) \
	 ((obj),(function),(functionNum),(noMove),(check),(error))
#define ic0lcuCmdVGetVal(obj,function,name,nameNum,status,error) \
	(*((ic0lcuCMD_FCTPTR_GET_VAL)((obj)->fcts[ic0lcuCMD_FCT_GET_VAL]))) \
	 ((obj),(function),(name),(nameNum),(status),(error))
#define ic0lcuCmdVSetVal(obj,function,name,nameNum,value,valueNum,error) \
	(*((ic0lcuCMD_FCTPTR_SET_VAL)((obj)->fcts[ic0lcuCMD_FCT_SET_VAL]))) \
	 ((obj),(function),(name),(nameNum),(value),(valueNum),(error))
#define ic0lcuCmdVCfgElem(obj,function,position,id,values,valuesNum,error) \
	(*((ic0lcuCMD_FCTPTR_CFG_ELEM)((obj)->fcts[ic0lcuCMD_FCT_CFG_ELEM]))) \
	 ((obj),(function),(position),(id),(values),(valuesNum),(error))
#define ic0lcuCmdVLogConf(obj,function,functionNum,allElements,error) \
	(*((ic0lcuCMD_FCTPTR_LOG_CONF)((obj)->fcts[ic0lcuCMD_FCT_LOG_CONF]))) \
	 ((obj),(function),(functionNum),(allElements),(error))
#define ic0lcuCmdVGetConf(obj,function,functionNum,allElements,text,error) \
	(*((ic0lcuCMD_FCTPTR_GET_CONF)((obj)->fcts[ic0lcuCMD_FCT_GET_CONF]))) \
	 ((obj),(function),(functionNum),(allElements),(text),(error))
#define ic0lcuCmdVUsrGetRevision(obj,revision,error) \
	(*((ic0lcuCMD_FCTPTR_USR_GET_REVISION)((obj)->fcts[ic0lcuCMD_FCT_USR_GET_REVISION]))) \
	 ((obj),(revision),(error))
#define ic0lcuCmdVInitObj(obj,error) \
	(*((ic0lcuCMD_FCTPTR_INIT_OBJ)((obj)->fcts[ic0lcuCMD_FCT_INIT_OBJ]))) \
	 ((obj),(error))
#define ic0lcuCmdVExitObj(obj,error) \
	(*((ic0lcuCMD_FCTPTR_EXIT_OBJ)((obj)->fcts[ic0lcuCMD_FCT_EXIT_OBJ]))) \
	 ((obj),(error))
#define ic0lcuCmdVFctProcess(obj,command,function,functionNum,status,arg1,arg2,arg3,arg4,error) \
	(*((ic0lcuCMD_FCTPTR_FCT_PROCESS)((obj)->fcts[ic0lcuCMD_FCT_FCT_PROCESS]))) \
	 ((obj),(command),(function),(functionNum),(status),(arg1),(arg2),(arg3),(arg4),(error))
#define ic0lcuCmdVFctIsAll(obj,name,error) \
	(*((ic0lcuCMD_FCTPTR_FCT_IS_ALL)((obj)->fcts[ic0lcuCMD_FCT_FCT_IS_ALL]))) \
	 ((obj),(name),(error))
#define ic0lcuCmdVFctIsDup(obj,name,dup,error) \
	(*((ic0lcuCMD_FCTPTR_FCT_IS_DUP)((obj)->fcts[ic0lcuCMD_FCT_FCT_IS_DUP]))) \
	 ((obj),(name),(dup),(error))
#define ic0lcuCmdVFctGetByName(obj,name,fct,error) \
	(*((ic0lcuCMD_FCTPTR_FCT_GET_BY_NAME)((obj)->fcts[ic0lcuCMD_FCT_FCT_GET_BY_NAME]))) \
	 ((obj),(name),(fct),(error))
#define ic0lcuCmdVFctGetByIndex(obj,index,fct,error) \
	(*((ic0lcuCMD_FCTPTR_FCT_GET_BY_INDEX)((obj)->fcts[ic0lcuCMD_FCT_FCT_GET_BY_INDEX]))) \
	 ((obj),(index),(fct),(error))
#define ic0lcuCmdVFctGetByStatus(obj,status,fctFlags,fctFlagsNum,error) \
	(*((ic0lcuCMD_FCTPTR_FCT_GET_BY_STATUS)((obj)->fcts[ic0lcuCMD_FCT_FCT_GET_BY_STATUS]))) \
	 ((obj),(status),(fctFlags),(fctFlagsNum),(error))
#define ic0lcuCmdVKeyGetByName(obj,name,key,error) \
	(*((ic0lcuCMD_FCTPTR_KEY_GET_BY_NAME)((obj)->fcts[ic0lcuCMD_FCT_KEY_GET_BY_NAME]))) \
	 ((obj),(name),(key),(error))
#define ic0lcuCmdVKeyIsSpecial(obj,key,value,keyType,mode,error) \
	(*((ic0lcuCMD_FCTPTR_KEY_IS_SPECIAL)((obj)->fcts[ic0lcuCMD_FCT_KEY_IS_SPECIAL]))) \
	 ((obj),(key),(value),(keyType),(mode),(error))
#define ic0lcuCmdVExecMode(obj,mode,error) \
	(*((ic0lcuCMD_FCTPTR_EXEC_MODE)((obj)->fcts[ic0lcuCMD_FCT_EXEC_MODE]))) \
	 ((obj),(mode),(error))
#define ic0lcuCmdVExecAction(obj,index,error) \
	(*((ic0lcuCMD_FCTPTR_EXEC_ACTION)((obj)->fcts[ic0lcuCMD_FCT_EXEC_ACTION]))) \
	 ((obj),(index),(error))
#define ic0lcuCmdVActions(obj,action,end,error) \
	(*((ic0lcuCMD_FCTPTR_ACTIONS)((obj)->fcts[ic0lcuCMD_FCT_ACTIONS]))) \
	 ((obj),(action),(end),(error))
#define ic0lcuCmdVSetState(obj,state,error) \
	(*((ic0lcuCMD_FCTPTR_SET_STATE)((obj)->fcts[ic0lcuCMD_FCT_SET_STATE]))) \
	 ((obj),(state),(error))
#define ic0lcuCmdVUsrStatus(obj,devName,flag,header,conflog,opslog,condlog,status,error) \
	(*((ic0lcuCMD_FCTPTR_USR_STATUS)((obj)->fcts[ic0lcuCMD_FCT_USR_STATUS]))) \
	 ((obj),(devName),(flag),(header),(conflog),(opslog),(condlog),(status),(error))


ccsCOMPL_STAT ic0lcuCmdNewObj(
    IN    dbSYMADDRESS	point,
    IN    egenOBJ*	owner,
    OUT   egenOBJ*	obj,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0lcuCmdDeleteObj(
    INOUT egenOBJ*	obj,
    OUT   ccsERROR*	error);


ccsCOMPL_STAT ic0lcuCmdGetFunctionsUsedSize(
    INOUT egenOBJ*	obj,
    OUT   vltINT16*	num,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0lcuCmdGetKeywordsUsedSize(
    INOUT egenOBJ*	obj,
    OUT   vltINT16*	num,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0lcuCmdGetModesUsedSize(
    INOUT egenOBJ*	obj,
    OUT   vltINT16*	num,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0lcuCmdGetAutoOnline(
    INOUT egenOBJ*	obj,
    OUT   vltLOGICAL*	flag,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0lcuCmdFctGetAutoOnline(
    INOUT egenOBJ*	obj,
    IN    ic0lcuCMD_FCT* fct,
    OUT   vltLOGICAL*	flag,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0lcuCmdStartDevManager(
    INOUT egenOBJ*	obj,
    IN    const char*	manager,
    OUT   ccsERROR*	error);


/*
 * miscellaneous
 */
#define ic0lcuCMD_SENDBUF_SIZE	10
#define ic0lcuCMD_SEM_TIMEOUT	4000

#define ic0lcuKEY_NORMAL	0
#define ic0lcuKEY_ID		1
#define ic0lcuKEY_MODE		2

#define ic0lcuSTATUS_ALL		 0
#define ic0lcuSTATUS_INIT		 1
#define ic0lcuSTATUS_AVAILABLE		 2
#define ic0lcuSTATUS_LOADED_STANDBY	 3
#define ic0lcuSTATUS_ONLINE		 4 
#define ic0lcuSTATUS_STANDBY_ONLINE	 5
#define ic0lcuSTATUS_STATUS		 6
#define ic0lcuSTATUS_READY		 7
#define ic0lcuSTATUS_MANAGERS		 8
#define ic0lcuSTATUS_SIMULATION		 9
#define ic0lcuSTATUS_STOP		10
#define ic0lcuSTATUS_NORMAL		11
#define ic0lcuSTATUS_NORMAL_STANDBY	12
#define ic0lcuSTATUS_AUTO_ONLINE	13

/* The DEVOBJ command originally returned the pointer to a ic0 device.
 * This is not longer possible when the device is managed by a separate
 * server. The DEVOBJ command is now misused to identify how the device
 * is implemented:
 *   > 10: ic0 device pointer
 *     0 : separate server with same CDT as ic0devServer (see xxidev).
 *     1 : separate server with simplified CDT (see icbDevServer.icdt).
 */
#define DEVOBJ_IS_NULL(obj)  ((obj) <= (egenOBJ*) 10)


#endif // !IC0LCU_CMD_H

/************************************************************************/
/* ___oOo___ */
