/******************************************************************************
*  E.S.O. - VLT project
* 
*  "@(#) $Id: ic0motAdc.h,v 1.36 2005/07/14 11:49:40 vltsccm Exp $"
* 
*  who        when      what
*  ---------- --------  ----------------------------------------------
*  rschmutz   16/05/99  value taskWait added.
*  rschmutz   09/02/99  ic0motAdcParamSet added.
*  rschmutz   02/09/97  Created by eccsgen  Revision: 1.20
*
*
*    !!!!!!!!!  CAUTION: THIS FILE IS UPDATED BY ECCSGEN  !!!!!!!!!
*/

/*************************************************************************
*   NAME
*	ic0motAdc - class
*
*   SYNOPSIS
*	#include "ic0motAdc.h"
*
*	ccsCOMPL_STAT ic0motAdcNewObj(
*	    IN    dbSYMADDRESS	point,
*	    IN    egenOBJ*	owner,
*	    OUT   egenOBJ*	obj,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0motAdcDeleteObj(
*	    INOUT egenOBJ*	obj,
*	    OUT   ccsERROR*	error)
*
*	egenOBJ* ic0motAdcGetOwner(
*	    IN const egenOBJ* obj)
*
*	egenOBJ* ic0motAdcLogData(
*	    IN const egenOBJ*	obj,
*	    IN const char*	format,
*	    IN 			...)
*
*	ccsCOMPL_STAT ic0motAdcInitObj(
*	    INOUT egenOBJ*	obj,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0motAdcExitObj(
*	    INOUT egenOBJ*	obj,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0motAdcUsrStandby2Online(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0motAdcUsrOnline2Standby(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0motAdcExecAction(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    ic0devMOT_ACTION*	action,
*	    OUT   vltLOGICAL*	end,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0motAdcUsrStop(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    vltLOGICAL	req,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0motAdcActionAdcRotate(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    ic0devMOT_ACTION*	action,
*	    OUT   vltLOGICAL*	end,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0motAdcUsrStatusCode(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    const char*	text,
*	    IN    vltINT32	flags,
*	    OUT   vltINT32*	code,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0motAdcUsrStatusValue(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    vltINT32	code,
*	    OUT   lcctooVALUE*	value,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0motAdcUsrStatusLast(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    OUT   vltINT16*	last,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0motAdcRead<scalarAttr>(
*	    INOUT egenOBJ*	obj,
*	    OUT   void*		buf,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0motAdcWrite<scalarAttr>(
*	    INOUT egenOBJ*	obj,
*	    IN    void*		buf,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0motAdcRead<vectorAttr>(
*	    INOUT egenOBJ*	obj,
*	    OUT   void*		buf,
*	    IN    vltINT32	first,
*	    IN    vltINT32	last,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0motAdcWrite<vectorAttr>(
*	    INOUT egenOBJ*	obj,
*	    IN    void*		buf,
*	    IN    vltINT32	first,
*	    IN    vltINT32	last,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0motAdcRead<tableAttr>(
*	    INOUT egenOBJ*	obj,
*	    OUT   void*		buf,
*	    IN    vltINT32	firstRec,
*	    IN    vltINT32	lastRec,
*	    IN    vltINT32	firstFld,
*	    IN    vltINT32	lastFld,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0motAdcWrite<tableAttr>(
*	    INOUT egenOBJ*	obj,
*	    IN    void*		buf,
*	    IN    vltINT32	firstRec,
*	    IN    vltINT32	lastRec,
*	    IN    vltINT32	firstFld,
*	    IN    vltINT32	lastFld,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0motErrAdcReadOldb(p1,p2)
*	ccsCOMPL_STAT ic0motErrAdcWriteOldb(p1,p2)
*	ccsCOMPL_STAT ic0motErrAdcTaskStart(p1)
*	ccsCOMPL_STAT ic0motErrAdcTaskStop(p1)
*	ccsCOMPL_STAT ic0motErrAdcTaskWait(p1)
*	ccsCOMPL_STAT ic0motErrAdcWrongValue(p1,p2,p3,p4)
*	ccsCOMPL_STAT ic0motErrAdcGeneral(p1,p2)
*
*   PARENT CLASS
*	public ic0devMOT
*
*   DESCRIPTION
*       The class ic0motADC implements the software device
*       to access an ADC rotate function.
*
*       The ADC rotate uses the following FITS keywords:
*
*       INS.ADC.MODE	OFF, AUTO.
*       INS.ADC.RA	telescope coordinate
*       INS.ADC.DEC	telescope coordinate
*       INS.ADC.POSANG 	start position angle
*       INS.ADC.TEMP 	temperature
*       INS.ADC.SENS1 	atm. pressure
*
*	ic0motAdcNewObj(point,owner,obj,error)
*	    Initialises an instance of the class type ic0motADC.
*
*	    point	<IN>	OLDB point where the owned attributes are
*				located.
*	    owner	<IN>	Pointer to the owner of the new instance.
*	    obj		<OUT>	Handle for the new instance (the handle
*				must be allocated by the caller).
*
*	ic0motAdcDeleteObj(obj,error)
*	    The function lcctooDeleteObj deletes an
*	    instance of the class type ic0motADC
*
*
*	ic0motAdcErr<error>(...)
*	    The macros ic0motAdcErr*() log an error with lcctooLOG_0 and
*	    call errAdd with the corresponding error parameters.
*
*	ic0motAdcRead<attr>(...)
*	ic0motAdcWrite<attr>(...)
*	    The above macros read from/write to the data attributes
*	    of the class.
*	    The attributes are described in ic0motAdcDb(5).
*
*   PROTECTED METHODS
*   PRIVATE METHODS
*	ic0motAdcInitObj(obj,error)
*
*	ic0motAdcExitObj(obj,error)
*
*	ic0motAdcUsrStandby2Online(obj,devName,error)
*	   This function should be overloaded to perform the
*	   actions necessary to change from the STANDBY to the
*	   ONLINE state. The overloaded function should first
*	   call lccdevCmdUsrStandby2Online() or check if the
*	   device is available and enabled before going ONLINE.
*
*	ic0motAdcUsrOnline2Standby(obj,devName,error)
*	   This function should be overloaded to perform the
*	   actions necessary to change from the ONLINE to the
*	   STANDBY state.
*
*	ic0motAdcExecAction(obj,devName,action,end,error)
*	   Executes the action specified by the action entry.
*
*	   action	<IN>	action entry
*	   end	<OUT>	TRUE specifies that the action
*			   sequence should end.
*
*	ic0motAdcUsrStop(obj,devName,req,error)
*	   This function should be overloaded to stop the device.
*	   If req is true, then a command to stop the device MUST
*	   be issued, even if the device is already stopped.
*	   Note: The Stop command is accepted even if the device
*	   is busy performing another command.
*
*	ic0motAdcActionAdcRotate(obj,devName,action,end,error)
*	   Action ic0motMOT_ACTION_ADC_ROTATE:
*
*	   The userValue is used as an index into the
*	   parameters table. The parameter should be
*	   a logical (or a string interpreted as such).
*
*	   If the value is TRUE, then tracking is started.
*
*	   If the value is FALSE, then the motor is
*	   stopped calling ic0devMotActionStop().
*
*	ic0motAdcUsrStatusCode(obj,devName,text,flags,code,error)
*	   This function receives the name of a status value
*	   and returns the corresponding code. This function
*	   should be overloaded if the new class declares new
*	   status values. The overloaded function should check
*	   first if the name corresponds to one of its own
*	   status values. If not, then it should call the
*	   function UsrStatusCode() of its parent class to be
*	   able to retrieve the codes of the parent status
*	   values.
*
*	   text	<IN>	Name of the status value.
*	   flags	<IN>	expected status type (lcctooSTATUS_*).
*	   code	<OUT>	Code of the status value (lccdevGET_*).
*
*	   lccdevGET_DEVICE        "Device"
*	   lccdevGET_STATE         "State"
*	   lccdevGET_TRANSTATE     "TranState"
*	   lccdevGET_ERROR         "Error"
*	   lccdevGET_INITIALISED   "Initialised"
*	   lccdevGET_SIMULATION    "Simulation"
*
*	ic0motAdcUsrStatusValue(obj,devName,code,value,error)
*	   This function receives the code of a status variable
*	   and returns its related value. This function should
*	   be overloaded if the new class declares new status
*	   values. The overloaded function should check first
*	   if the code corresponds to one of its own status
*	   values. If not, then it should call the function
*	   UsrStatusValue() of its parent class to be able to
*	   retrieve the status values of the parent.
*
*	   code	<OUT>	Code of the status value (lccdevGET_*).
*	   value	<OUT>	Handle of the value object
*			   (allocated by the caller).
*
*	ic0motAdcUsrStatusLast(obj,devName,last,error)
*	   This function returns the highest status code that
*	   the class knows. This function should be overloaded
*	   if the new class declares new status values, as new
*	   status codes have to be assigned to the new values.
*
*	   This function is used by the Status command when it
*	   has to return all status values. In this case it
*	   performs a loop from code 1 to the value returned
*	   by this function.
*
*
*   DEFINES
*
*   FILES
*
*   ENVIRONMENT
*
*   RETURN VALUES
*	If the function prototype allows, methods return ccsCOMPL_STAT.
*
*	Methods can generate the following errors:
*	    ic0motERR_ADC_READ_OLDB
*	    ic0motERR_ADC_WRITE_OLDB
*	    ic0motERR_ADC_TASK_START
*	    ic0motERR_ADC_TASK_STOP
*	    ic0motERR_ADC_TASK_WAIT
*	    ic0motERR_ADC_WRONG_VALUE
*	    ic0motERR_ADC_GENERAL
*
*   CAUTIONS
*
*   EXAMPLES
*
*   SEE ALSO
*
*   BUGS
*
* 
*-------------------------------------------------------------------------
*/

#ifndef IC0MOT_ADC_H
#define IC0MOT_ADC_H

#include "egen.h"
#include "ic0motErrors.h"
#include "ic0devMot.h"
#include "ic0motDefines.h"


/*
 * class type identifier
 */
#define ic0motADC_ID	192

/*
 * attribute table
 */
#define ic0motADC_ATTR_STATE	0
#define ic0motADC_ATTR_SUBSTATE	1
#define ic0motADC_ATTR_ERROR	2
#define ic0motADC_ATTR_INITIALISED	3
#define ic0motADC_ATTR_SIMULATION	4
#define ic0motADC_ATTR_DEVICE	5
#define ic0motADC_ATTR_AVAILABLE	6
#define ic0motADC_ATTR_ENABLED	7
#define ic0motADC_ATTR_LOCKED	8
#define ic0motADC_ATTR_HANDSET	9
#define ic0motADC_ATTR_FIXED	10
#define ic0motADC_ATTR_FIX_POS_SET	11
#define ic0motADC_ATTR_FIXED_POSITION	12
#define ic0motADC_ATTR_FIXED_SIMULATION	13
#define ic0motADC_ATTR_FIXED_LOCKED	14
#define ic0motADC_ATTR_PREFIX	15
#define ic0motADC_ATTR_PARAMETERS_SIZE	16
#define ic0motADC_ATTR_PARAMETERS	17
#define ic0motADC_ATTR_STATUS	18
#define ic0motADC_ATTR_STATUS_INDEX	19
#define ic0motADC_ATTR_VALUES_SIZE	20
#define ic0motADC_ATTR_VALUES	21
#define ic0motADC_ATTR_INIT_RESTRICTION	22
#define ic0motADC_ATTR_MOVE_RESTRICTION	23
#define ic0motADC_ATTR_STOP_TIMEOUT	24
#define ic0motADC_ATTR_SET_VAL_FCT	25
#define ic0motADC_ATTR_HELP_TEXT	26
#define ic0motADC_ATTR_PARAM_STEP	27
#define ic0motADC_ATTR_ACTION_COMMAND	28
#define ic0motADC_ATTR_ACTION_STOP_REQ	29
#define ic0motADC_ATTR_ACTION_NO_MOVE	30
#define ic0motADC_ATTR_ACTION_CHECK	31
#define ic0motADC_ATTR_RESET_SETUP_CMD	32
#define ic0motADC_ATTR_MOTORS	33
#define ic0motADC_ATTR_POSITIONS_SIZE	34
#define ic0motADC_ATTR_POSITIONS	35
#define ic0motADC_ATTR_ACTIONS	36
#define ic0motADC_ATTR_USR_ACTIONS	37
#define ic0motADC_ATTR_USER_UNIT_FCT	38
#define ic0motADC_ATTR_USER_UNIT_FCT2	39
#define ic0motADC_ATTR_USER_UNIT_ARGS	40
#define ic0motADC_ATTR_INIT_TIMEOUT	41
#define ic0motADC_ATTR_MOVE_TIMEOUT	42
#define ic0motADC_ATTR_DISCONNECT	43
#define ic0motADC_ATTR_USE_CFG_ELEM	44
#define ic0motADC_ATTR_PARK_ACTION	45
#define ic0motADC_ATTR_TEST_ACTION	46
#define ic0motADC_ATTR_TEST	47
#define ic0motADC_ATTR_INSTALLED	48
#define ic0motADC_ATTR_ATTACHED	49
#define ic0motADC_ATTR_PARKED	50
#define ic0motADC_ATTR_ACTION_STEP	51
#define ic0motADC_ATTR_ACTION_RETRY	52
#define ic0motADC_ATTR_ACTION_MOVE_VALID	53
#define ic0motADC_ATTR_ACTION_MOVE	54
#define ic0motADC_ATTR_PARSE_POS_INDEX	55
#define ic0motADC_ATTR_FIRST_POS_INDEX	56
#define ic0motADC_ATTR_MOVE_MODE	57
#define ic0motADC_ATTR_MODE	58
#define ic0motADC_ATTR_RA	59
#define ic0motADC_ATTR_DEC	60
#define ic0motADC_ATTR_START_POSANG	61
#define ic0motADC_ATTR_POSANG	62
#define ic0motADC_ATTR_DROT_POS	63
#define ic0motADC_ATTR_TEMPERATURE	64
#define ic0motADC_ATTR_PRESSURE	65
#define ic0motADC_ATTR_LATITUDE	66
#define ic0motADC_ATTR_LONGITUDE	67
#define ic0motADC_ATTR_DROT_DEVICE	68

#define ic0motADC_AUTOMATA	0

/*
 * function table
 */
#define ic0motADC_FCT_DELETE_OBJ	0
#define ic0motADC_FCT_STANDBY	1
#define ic0motADC_FCT_ONLINE	2
#define ic0motADC_FCT_OFF	3
#define ic0motADC_FCT_EXIT	4
#define ic0motADC_FCT_STATE	5
#define ic0motADC_FCT_SIMULAT	6
#define ic0motADC_FCT_STOP_SIM	7
#define ic0motADC_FCT_STATUS	8
#define ic0motADC_FCT_INIT	9
#define ic0motADC_FCT_STOP	10
#define ic0motADC_FCT_TEST	11
#define ic0motADC_FCT_SELFTST	12
#define ic0motADC_FCT_AUTO_TBL	13
#define ic0motADC_FCT_AUTO_RST	14
#define ic0motADC_FCT_INIT_OBJ	15
#define ic0motADC_FCT_EXIT_OBJ	16
#define ic0motADC_FCT_LOADED2STBY	17
#define ic0motADC_FCT_ONLINE2STBY	18
#define ic0motADC_FCT_EXIT1	19
#define ic0motADC_FCT_CHECK_DEVICE_NAME	20
#define ic0motADC_FCT_BREAK	21
#define ic0motADC_FCT_USR_INIT	22
#define ic0motADC_FCT_USR_LOADED2STANDBY	23
#define ic0motADC_FCT_USR_STANDBY2ONLINE	24
#define ic0motADC_FCT_USR_ONLINE2STANDBY	25
#define ic0motADC_FCT_USR_STANDBY2LOADED	26
#define ic0motADC_FCT_USR_STOP	27
#define ic0motADC_FCT_USR_SIMULAT	28
#define ic0motADC_FCT_USR_STOP_SIM	29
#define ic0motADC_FCT_USR_STATUS_CODE	30
#define ic0motADC_FCT_USR_STATUS_LAST	31
#define ic0motADC_FCT_USR_STATUS_VALUE	32
#define ic0motADC_FCT_USR_TEST	33
#define ic0motADC_FCT_USR_SELF_TEST	34
#define ic0motADC_FCT_USR_ERROR	35
#define ic0motADC_FCT_AVAIL	36
#define ic0motADC_FCT_UNAVAIL	37
#define ic0motADC_FCT_DISABLE	38
#define ic0motADC_FCT_ENABLE	39
#define ic0motADC_FCT_LOCK	40
#define ic0motADC_FCT_UNLOCK	41
#define ic0motADC_FCT_HANDSET	42
#define ic0motADC_FCT_HSET_OFF	43
#define ic0motADC_FCT_FIX_POS	44
#define ic0motADC_FCT_MOVE	45
#define ic0motADC_FCT_MOVE_REL	46
#define ic0motADC_FCT_SET	47
#define ic0motADC_FCT_CHECK	48
#define ic0motADC_FCT_WAIT	49
#define ic0motADC_FCT_USR_SET_MODE	50
#define ic0motADC_FCT_SETUP	51
#define ic0motADC_FCT_GET_VAL	52
#define ic0motADC_FCT_SET_VAL	53
#define ic0motADC_FCT_CFG_ELEM	54
#define ic0motADC_FCT_LOG_CONF	55
#define ic0motADC_FCT_GET_CONF	56
#define ic0motADC_FCT_RESET_PARAMETERS	57
#define ic0motADC_FCT_PARSE_PARAMETERS	58
#define ic0motADC_FCT_COMPARE_PARAMETERS	59
#define ic0motADC_FCT_COPY_PARAMETERS	60
#define ic0motADC_FCT_EXEC_PARAMETERS	61
#define ic0motADC_FCT_UPDATE_PARAMETERS	62
#define ic0motADC_FCT_GET_PARAM_SET_VALUE	63
#define ic0motADC_FCT_GET_PARAM_STATUS	64
#define ic0motADC_FCT_SET_PARAM	65
#define ic0motADC_FCT_SET_PARAM_STEP	66
#define ic0motADC_FCT_USR_EXEC_ACTION	67
#define ic0motADC_FCT_USR_SET_PARAMETER	68
#define ic0motADC_FCT_GET_VALUE_CODE	69
#define ic0motADC_FCT_GET_VALUE	70
#define ic0motADC_FCT_USR_GET_VALUE	71
#define ic0motADC_FCT_SET_VALUE	72
#define ic0motADC_FCT_USR_SET_VALUE	73
#define ic0motADC_FCT_GET_ARG	74
#define ic0motADC_FCT_MONITOR	75
#define ic0motADC_FCT_USR_MONITOR	76
#define ic0motADC_FCT_LOG_ACTION	77
#define ic0motADC_FCT_LOG_COMMENT	78
#define ic0motADC_FCT_LOG_PARAMETER	79
#define ic0motADC_FCT_LOG_RECOVERY	80
#define ic0motADC_FCT_LOG_TBL_PARAM	81
#define ic0motADC_FCT_LOG_UNFORSEEN	82
#define ic0motADC_FCT_VAR_SET	83
#define ic0motADC_FCT_VAR_WAIT	84
#define ic0motADC_FCT_GET_HANDLES	85
#define ic0motADC_FCT_PARK	86
#define ic0motADC_FCT_GET_ACTION	87
#define ic0motADC_FCT_EXEC_ACTION	88
#define ic0motADC_FCT_ACTION_GET_HANDLES	89
#define ic0motADC_FCT_ACTION_NEW_MOVE	90
#define ic0motADC_FCT_ACTION_IF	91
#define ic0motADC_FCT_ACTION_PARAM	92
#define ic0motADC_FCT_ACTION_ADD_PARAM	93
#define ic0motADC_FCT_ACTION_VALUE	94
#define ic0motADC_FCT_ACTION_ADD_VALUE	95
#define ic0motADC_FCT_ACTION_MOVE	96
#define ic0motADC_FCT_ACTION_SPEED_MOVE	97
#define ic0motADC_FCT_ACTION_WAIT_MOVE	98
#define ic0motADC_FCT_ACTION_CLAMP_BRAKE	99
#define ic0motADC_FCT_ACTION_DISCONNECT	100
#define ic0motADC_FCT_ACTION_STOP	101
#define ic0motADC_FCT_ACTION_USER_FUNCTION	102
#define ic0motADC_FCT_ACTION_RETRY	103
#define ic0motADC_FCT_ACTION_END	104
#define ic0motADC_FCT_ACTION_ERROR	105
#define ic0motADC_FCT_ACTION_SLEEP	106
#define ic0motADC_FCT_ACTION_INCR_VALUE	107
#define ic0motADC_FCT_SET_PAR_LIST_ADDRESS	108
#define ic0motADC_FCT_WLEN2ENC	109
#define ic0motADC_FCT_TEMP2FOCUS	110
#define ic0motADC_FCT_SLIT2ENC1	111
#define ic0motADC_FCT_SLIT2ENC2	112
#define ic0motADC_FCT_SLIT2ENC	113
#define ic0motADC_FCT_WLEN_TETA2ENC	114
#define ic0motADC_FCT_TILT2ENC	115
#define ic0motADC_FCT_ACTION_ADC_ROTATE	116

/*
 * automata states
 */
#define ic0motADC_STATE_NOSTATE	-1
#define ic0motADC_STATE_OFF	0
#define ic0motADC_STATE_LOADED	1
#define ic0motADC_STATE_STANDBY	2
#define ic0motADC_STATE_ONLINE	3

/*
 * automata substates
 */
#define ic0motADC_SUBSTATE_ERROR	0
#define ic0motADC_SUBSTATE_IDLE	1
#define ic0motADC_SUBSTATE_BUSY	2
#define ic0motADC_SUBSTATE_INITIALISING	3
#define ic0motADC_SUBSTATE_SHUTTING_DOWN	4
#define ic0motADC_SUBSTATE_STOPPING	5
#define ic0motADC_SUBSTATE_COLD_STARTING	6
#define ic0motADC_SUBSTATE_STARTING	7
#define ic0motADC_SUBSTATE_STOP	8

/*
 * automata events
 */
#define ic0motADC_EVENT_INIT	0
#define ic0motADC_EVENT_STANDBY	1
#define ic0motADC_EVENT_ONLINE	2
#define ic0motADC_EVENT_STOP	3
#define ic0motADC_EVENT_OFF	4
#define ic0motADC_EVENT_EXIT	5
#define ic0motADC_EVENT_STATE	6
#define ic0motADC_EVENT_STOP_SIM	7
#define ic0motADC_EVENT_STATUS	8
#define ic0motADC_EVENT_SIMULAT	9
#define ic0motADC_EVENT_TEST	10
#define ic0motADC_EVENT_SELFTST	11
#define ic0motADC_EVENT_AUTO_TBL	12
#define ic0motADC_EVENT_AUTO_RST	13
#define ic0motADC_EVENT_DISABLE	14
#define ic0motADC_EVENT_ENABLE	15
#define ic0motADC_EVENT_LOCK	16
#define ic0motADC_EVENT_UNLOCK	17
#define ic0motADC_EVENT_HANDSET	18
#define ic0motADC_EVENT_HSET_OFF	19
#define ic0motADC_EVENT_AVAIL	20
#define ic0motADC_EVENT_UNAVAIL	21
#define ic0motADC_EVENT_MOVE	22
#define ic0motADC_EVENT_MOVE_REL	23
#define ic0motADC_EVENT_SET	24
#define ic0motADC_EVENT_CHECK	25
#define ic0motADC_EVENT_WAIT	26
#define ic0motADC_EVENT_SETUP	27
#define ic0motADC_EVENT_CFG_ELEM	28
#define ic0motADC_EVENT_GET_VAL	29
#define ic0motADC_EVENT_SET_VAL	30
#define ic0motADC_EVENT_LOG_CONF	31
#define ic0motADC_EVENT_GET_CONF	32
#define ic0motADC_EVENT_MONITOR	33


/*
 * user variables
 */
typedef struct
    {
    vltINT32	mode;
    vltDOUBLE	ra;
    vltDOUBLE	dec;
    vltDOUBLE	posang;
    vltLOGICAL	changed;
    ccsTIMEVAL	utc;
    ccsTIMEVAL	utcOffset;
    vltINT32	taskWait;
    vltINT32	reference[ic0motADC_MODE_UNKNOWN];
    vltDOUBLE	ra_r;
    vltDOUBLE	dec_r;
    vltDOUBLE	posang_r;
    vltDOUBLE	circResol_r;
    vltDOUBLE	minSpeed;
    vltDOUBLE	maxSpeed;
    vltDOUBLE	equinox;
    vltDOUBLE	sign1;
    vltDOUBLE	sign2;
    vltDOUBLE	latitude;
    vltDOUBLE	longitude;
    vltDOUBLE	pressure;
    vltDOUBLE   temperature;
    dbSYMADDRESS drotPosPt;
    vltDOUBLE	drotPos;
    vltDOUBLE	temp1;
    vltDOUBLE	temp2;
    vltLOGICAL  test;
    vltINT32    formula;
    vltDOUBLE   minElev_r;
    vltDOUBLE	posOffset_r;
    vltDOUBLE	coffset;
    vltDOUBLE	pslope;
    vltDOUBLE   poffset;
    vltDOUBLE   tslope;
    vltDOUBLE   toffset;
    vltDOUBLE	drotFactor;
    vltDOUBLE	afactor;
    } ic0motADC_PARAM;

typedef struct
    {
    vltINT32	how;
    vltINT32	posenc;
    vltDOUBLE	speed;
    vltLOGICAL	log;
    } ic0motADC_MOTION;

typedef struct
    {
    motHANDLE	motor[3];
    motSTATUS	status;
    vltLOGICAL	simulation;
    motAXIS_TYPE axis;
    vltDOUBLE	circularRange;
    vltINT32	timeout;
    motMOTION	posMotion;
    motMOTION	spdMotion;
    } ic0motADC_MOTOR;

typedef struct
    {
    lcctooTASK	task;
    ic0motADC_PARAM	param;
    ic0motADC_MOTION	motion;
    ic0motADC_MOTOR	motor;
    } ic0motADC_USERDATA;

typedef struct
    {
    SEM_ID	actionSequence;
    SEM_ID	actionSetup;
    ic0devMOT_SYNC_VAR_PARLIST*	syncVarParList[2];
    egenOBJ*	objParList[2];
    ic0motADC_USERDATA* data;
    vltINT32	dummy[3];
    } ic0motADC_USERVAR;


/*
 * function pointer types
 */
typedef ccsCOMPL_STAT (*ic0motADC_FCTPTR_INIT_OBJ)(
    INOUT egenOBJ*	obj,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0motADC_FCTPTR_EXIT_OBJ)(
    INOUT egenOBJ*	obj,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0motADC_FCTPTR_USR_STANDBY2ONLINE)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0motADC_FCTPTR_USR_ONLINE2STANDBY)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0motADC_FCTPTR_EXEC_ACTION)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    ic0devMOT_ACTION*	action,
    OUT   vltLOGICAL*	end,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0motADC_FCTPTR_USR_STOP)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltLOGICAL	req,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0motADC_FCTPTR_ACTION_ADC_ROTATE)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    ic0devMOT_ACTION*	action,
    OUT   vltLOGICAL*	end,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0motADC_FCTPTR_USR_STATUS_CODE)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    const char*	text,
    IN    vltINT32	flags,
    OUT   vltINT32*	code,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0motADC_FCTPTR_USR_STATUS_VALUE)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltINT32	code,
    OUT   lcctooVALUE*	value,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0motADC_FCTPTR_USR_STATUS_LAST)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   vltINT16*	last,
    OUT   ccsERROR*	error);


/*
 * log function
 */
#define ic0motAdcLogData(obj, format, arg...) \
	{ \
	char tmpLogBuf[lcctooTMP_BUFFER_SIZE]; \
	\
	sprintf(tmpLogBuf, (format), ##arg); \
	logData("ic0mot", (obj)->id, tmpLogBuf); \
	}


/*
 * error functions
 */
#define ic0motErrAdcReadOldb(p1,p2) \
	{ \
	lcctooLOG_0("ic0motERR_ADC_READ_OLDB: Device %s: Unable to read %s from OLDB.",(p1),(p2)); \
	errAdd(error,"ic0mot",ic0motERR_ADC_READ_OLDB,__FILE_LINE__,"%s,%s",(p1),(p2)); \
	}
#define ic0motErrAdcWriteOldb(p1,p2) \
	{ \
	lcctooLOG_0("ic0motERR_ADC_WRITE_OLDB: Device %s: Unable to write %s to OLDB.",(p1),(p2)); \
	errAdd(error,"ic0mot",ic0motERR_ADC_WRITE_OLDB,__FILE_LINE__,"%s,%s",(p1),(p2)); \
	}
#define ic0motErrAdcTaskStart(p1) \
	{ \
	lcctooLOG_0("ic0motERR_ADC_TASK_START: Device %s: Error starting the monitor task.",(p1)); \
	errAdd(error,"ic0mot",ic0motERR_ADC_TASK_START,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0motErrAdcTaskStop(p1) \
	{ \
	lcctooLOG_0("ic0motERR_ADC_TASK_STOP: Device %s: Error stopping the monitor task.",(p1)); \
	errAdd(error,"ic0mot",ic0motERR_ADC_TASK_STOP,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0motErrAdcTaskWait(p1) \
	{ \
	lcctooLOG_0("ic0motERR_ADC_TASK_WAIT: Device %s: Semaphore error updating the monitor data.",(p1)); \
	errAdd(error,"ic0mot",ic0motERR_ADC_TASK_WAIT,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0motErrAdcWrongValue(p1,p2,p3,p4) \
	{ \
	lcctooLOG_0("ic0motERR_ADC_WRONG_VALUE: Device %s: Wrong %s value %f (%s).",(p1),(p2),(p3),(p4)); \
	errAdd(error,"ic0mot",ic0motERR_ADC_WRONG_VALUE,__FILE_LINE__,"%s,%s,%f,%s",(p1),(p2),(p3),(p4)); \
	}
#define ic0motErrAdcGeneral(p1,p2) \
	{ \
	lcctooLOG_0("ic0motERR_ADC_GENERAL: Device %s: %s.",(p1),(p2)); \
	errAdd(error,"ic0mot",ic0motERR_ADC_GENERAL,__FILE_LINE__,"%s,%s",(p1),(p2)); \
	}

/*
 * get object owner
 */
#define ic0motAdcGetOwner(obj) ((obj)->owner)


/*
 * attribute access functions
 */
#define ic0motAdcReadState(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motADC_ATTR_STATE,(buf),(error))
#define ic0motAdcWriteState(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motADC_ATTR_STATE,(void*) (buf),(error))
#define ic0motAdcReadSubstate(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motADC_ATTR_SUBSTATE,(buf),(error))
#define ic0motAdcWriteSubstate(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motADC_ATTR_SUBSTATE,(void*) (buf),(error))
#define ic0motAdcReadError(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motADC_ATTR_ERROR,(buf),(error))
#define ic0motAdcWriteError(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motADC_ATTR_ERROR,(void*) (buf),(error))
#define ic0motAdcReadInitialised(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motADC_ATTR_INITIALISED,(buf),(error))
#define ic0motAdcWriteInitialised(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motADC_ATTR_INITIALISED,(void*) (buf),(error))
#define ic0motAdcReadSimulation(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motADC_ATTR_SIMULATION,(buf),(error))
#define ic0motAdcWriteSimulation(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motADC_ATTR_SIMULATION,(void*) (buf),(error))
#define ic0motAdcReadDevice(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motADC_ATTR_DEVICE,(buf),(error))
#define ic0motAdcWriteDevice(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motADC_ATTR_DEVICE,(void*) (buf),(error))
#define ic0motAdcReadAvailable(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motADC_ATTR_AVAILABLE,(buf),(error))
#define ic0motAdcWriteAvailable(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motADC_ATTR_AVAILABLE,(void*) (buf),(error))
#define ic0motAdcReadEnabled(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motADC_ATTR_ENABLED,(buf),(error))
#define ic0motAdcWriteEnabled(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motADC_ATTR_ENABLED,(void*) (buf),(error))
#define ic0motAdcReadLocked(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motADC_ATTR_LOCKED,(buf),(error))
#define ic0motAdcWriteLocked(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motADC_ATTR_LOCKED,(void*) (buf),(error))
#define ic0motAdcReadHandset(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motADC_ATTR_HANDSET,(buf),(error))
#define ic0motAdcWriteHandset(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motADC_ATTR_HANDSET,(void*) (buf),(error))
#define ic0motAdcReadFixed(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motADC_ATTR_FIXED,(buf),(error))
#define ic0motAdcWriteFixed(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motADC_ATTR_FIXED,(void*) (buf),(error))
#define ic0motAdcReadFixPosSet(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motADC_ATTR_FIX_POS_SET,(buf),(error))
#define ic0motAdcWriteFixPosSet(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motADC_ATTR_FIX_POS_SET,(void*) (buf),(error))
#define ic0motAdcReadFixedPosition(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motADC_ATTR_FIXED_POSITION,(buf),(error))
#define ic0motAdcWriteFixedPosition(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motADC_ATTR_FIXED_POSITION,(void*) (buf),(error))
#define ic0motAdcReadFixedSimulation(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motADC_ATTR_FIXED_SIMULATION,(buf),(error))
#define ic0motAdcWriteFixedSimulation(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motADC_ATTR_FIXED_SIMULATION,(void*) (buf),(error))
#define ic0motAdcReadFixedLocked(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motADC_ATTR_FIXED_LOCKED,(buf),(error))
#define ic0motAdcWriteFixedLocked(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motADC_ATTR_FIXED_LOCKED,(void*) (buf),(error))
#define ic0motAdcReadPrefix(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motADC_ATTR_PREFIX,(buf),(error))
#define ic0motAdcWritePrefix(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motADC_ATTR_PREFIX,(void*) (buf),(error))
#define ic0motAdcReadParametersSize(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motADC_ATTR_PARAMETERS_SIZE,(buf),(error))
#define ic0motAdcWriteParametersSize(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motADC_ATTR_PARAMETERS_SIZE,(void*) (buf),(error))
#define ic0motAdcGetParametersSize(obj,num,error) \
	caiGetAttrInfo((obj)->attrs,ic0motADC_ATTR_PARAMETERS,NULL,NULL,(num),NULL, NULL,NULL,(error))
#define ic0motAdcReadParameters(obj,buf,firstRec,lastRec,firstFld,lastFld,error) \
	lcctooCaiRWTable((obj)->attrs,0,ic0motADC_ATTR_PARAMETERS,(buf),(firstRec),(lastRec),(firstFld),(lastFld),(error))
#define ic0motAdcWriteParameters(obj,buf,firstRec,lastRec,firstFld,lastFld,error) \
	lcctooCaiRWTable((obj)->attrs,1,ic0motADC_ATTR_PARAMETERS,(void*) (buf),(firstRec),(lastRec),(firstFld),(lastFld),(error))
#define ic0motAdcGetStatusSize(obj,num,error) \
	caiGetAttrInfo((obj)->attrs,ic0motADC_ATTR_STATUS,NULL,NULL,(num),NULL, NULL,NULL,(error))
#define ic0motAdcReadStatus(obj,buf,firstElt,lastElt,error) \
	caiRWVector((obj)->attrs,0,ic0motADC_ATTR_STATUS,(buf),(firstElt),(lastElt),(error))
#define ic0motAdcWriteStatus(obj,buf,firstElt,lastElt,error) \
	caiRWVector((obj)->attrs,1,ic0motADC_ATTR_STATUS,(void*) (buf),(firstElt),(lastElt),(error))
#define ic0motAdcGetStatusIndexSize(obj,num,error) \
	caiGetAttrInfo((obj)->attrs,ic0motADC_ATTR_STATUS_INDEX,NULL,NULL,(num),NULL, NULL,NULL,(error))
#define ic0motAdcReadStatusIndex(obj,buf,firstElt,lastElt,error) \
	caiRWVector((obj)->attrs,0,ic0motADC_ATTR_STATUS_INDEX,(buf),(firstElt),(lastElt),(error))
#define ic0motAdcWriteStatusIndex(obj,buf,firstElt,lastElt,error) \
	caiRWVector((obj)->attrs,1,ic0motADC_ATTR_STATUS_INDEX,(void*) (buf),(firstElt),(lastElt),(error))
#define ic0motAdcReadValuesSize(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motADC_ATTR_VALUES_SIZE,(buf),(error))
#define ic0motAdcWriteValuesSize(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motADC_ATTR_VALUES_SIZE,(void*) (buf),(error))
#define ic0motAdcGetValuesSize(obj,num,error) \
	caiGetAttrInfo((obj)->attrs,ic0motADC_ATTR_VALUES,NULL,NULL,(num),NULL, NULL,NULL,(error))
#define ic0motAdcReadValues(obj,buf,firstRec,lastRec,firstFld,lastFld,error) \
	lcctooCaiRWTable((obj)->attrs,0,ic0motADC_ATTR_VALUES,(buf),(firstRec),(lastRec),(firstFld),(lastFld),(error))
#define ic0motAdcWriteValues(obj,buf,firstRec,lastRec,firstFld,lastFld,error) \
	lcctooCaiRWTable((obj)->attrs,1,ic0motADC_ATTR_VALUES,(void*) (buf),(firstRec),(lastRec),(firstFld),(lastFld),(error))
#define ic0motAdcReadInitRestriction(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motADC_ATTR_INIT_RESTRICTION,(buf),(error))
#define ic0motAdcWriteInitRestriction(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motADC_ATTR_INIT_RESTRICTION,(void*) (buf),(error))
#define ic0motAdcReadMoveRestriction(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motADC_ATTR_MOVE_RESTRICTION,(buf),(error))
#define ic0motAdcWriteMoveRestriction(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motADC_ATTR_MOVE_RESTRICTION,(void*) (buf),(error))
#define ic0motAdcReadStopTimeout(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motADC_ATTR_STOP_TIMEOUT,(buf),(error))
#define ic0motAdcWriteStopTimeout(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motADC_ATTR_STOP_TIMEOUT,(void*) (buf),(error))
#define ic0motAdcReadSetValFct(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motADC_ATTR_SET_VAL_FCT,(buf),(error))
#define ic0motAdcWriteSetValFct(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motADC_ATTR_SET_VAL_FCT,(void*) (buf),(error))
#define ic0motAdcGetHelpTextSize(obj,num,error) \
	caiGetAttrInfo((obj)->attrs,ic0motADC_ATTR_HELP_TEXT,NULL,NULL,(num),NULL, NULL,NULL,(error))
#define ic0motAdcReadHelpText(obj,buf,firstElt,lastElt,error) \
	caiRWVector((obj)->attrs,0,ic0motADC_ATTR_HELP_TEXT,(buf),(firstElt),(lastElt),(error))
#define ic0motAdcWriteHelpText(obj,buf,firstElt,lastElt,error) \
	caiRWVector((obj)->attrs,1,ic0motADC_ATTR_HELP_TEXT,(void*) (buf),(firstElt),(lastElt),(error))
#define ic0motAdcReadParamStep(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motADC_ATTR_PARAM_STEP,(buf),(error))
#define ic0motAdcWriteParamStep(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motADC_ATTR_PARAM_STEP,(void*) (buf),(error))
#define ic0motAdcReadActionCommand(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motADC_ATTR_ACTION_COMMAND,(buf),(error))
#define ic0motAdcWriteActionCommand(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motADC_ATTR_ACTION_COMMAND,(void*) (buf),(error))
#define ic0motAdcReadActionStopReq(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motADC_ATTR_ACTION_STOP_REQ,(buf),(error))
#define ic0motAdcWriteActionStopReq(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motADC_ATTR_ACTION_STOP_REQ,(void*) (buf),(error))
#define ic0motAdcReadActionNoMove(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motADC_ATTR_ACTION_NO_MOVE,(buf),(error))
#define ic0motAdcWriteActionNoMove(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motADC_ATTR_ACTION_NO_MOVE,(void*) (buf),(error))
#define ic0motAdcReadActionCheck(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motADC_ATTR_ACTION_CHECK,(buf),(error))
#define ic0motAdcWriteActionCheck(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motADC_ATTR_ACTION_CHECK,(void*) (buf),(error))
#define ic0motAdcReadResetSetupCmd(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motADC_ATTR_RESET_SETUP_CMD,(buf),(error))
#define ic0motAdcWriteResetSetupCmd(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motADC_ATTR_RESET_SETUP_CMD,(void*) (buf),(error))
#define ic0motAdcGetMotorsSize(obj,num,error) \
	caiGetAttrInfo((obj)->attrs,ic0motADC_ATTR_MOTORS,NULL,NULL,(num),NULL, NULL,NULL,(error))
#define ic0motAdcReadMotors(obj,buf,firstRec,lastRec,firstFld,lastFld,error) \
	lcctooCaiRWTable((obj)->attrs,0,ic0motADC_ATTR_MOTORS,(buf),(firstRec),(lastRec),(firstFld),(lastFld),(error))
#define ic0motAdcWriteMotors(obj,buf,firstRec,lastRec,firstFld,lastFld,error) \
	lcctooCaiRWTable((obj)->attrs,1,ic0motADC_ATTR_MOTORS,(void*) (buf),(firstRec),(lastRec),(firstFld),(lastFld),(error))
#define ic0motAdcReadPositionsSize(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motADC_ATTR_POSITIONS_SIZE,(buf),(error))
#define ic0motAdcWritePositionsSize(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motADC_ATTR_POSITIONS_SIZE,(void*) (buf),(error))
#define ic0motAdcGetPositionsSize(obj,num,error) \
	caiGetAttrInfo((obj)->attrs,ic0motADC_ATTR_POSITIONS,NULL,NULL,(num),NULL, NULL,NULL,(error))
#define ic0motAdcReadPositions(obj,buf,firstRec,lastRec,firstFld,lastFld,error) \
	lcctooCaiRWTable((obj)->attrs,0,ic0motADC_ATTR_POSITIONS,(buf),(firstRec),(lastRec),(firstFld),(lastFld),(error))
#define ic0motAdcWritePositions(obj,buf,firstRec,lastRec,firstFld,lastFld,error) \
	lcctooCaiRWTable((obj)->attrs,1,ic0motADC_ATTR_POSITIONS,(void*) (buf),(firstRec),(lastRec),(firstFld),(lastFld),(error))
#define ic0motAdcGetActionsSize(obj,num,error) \
	caiGetAttrInfo((obj)->attrs,ic0motADC_ATTR_ACTIONS,NULL,NULL,(num),NULL, NULL,NULL,(error))
#define ic0motAdcReadActions(obj,buf,firstRec,lastRec,firstFld,lastFld,error) \
	lcctooCaiRWTable((obj)->attrs,0,ic0motADC_ATTR_ACTIONS,(buf),(firstRec),(lastRec),(firstFld),(lastFld),(error))
#define ic0motAdcWriteActions(obj,buf,firstRec,lastRec,firstFld,lastFld,error) \
	lcctooCaiRWTable((obj)->attrs,1,ic0motADC_ATTR_ACTIONS,(void*) (buf),(firstRec),(lastRec),(firstFld),(lastFld),(error))
#define ic0motAdcGetUsrActionsSize(obj,num,error) \
	caiGetAttrInfo((obj)->attrs,ic0motADC_ATTR_USR_ACTIONS,NULL,NULL,(num),NULL, NULL,NULL,(error))
#define ic0motAdcReadUsrActions(obj,buf,firstRec,lastRec,firstFld,lastFld,error) \
	lcctooCaiRWTable((obj)->attrs,0,ic0motADC_ATTR_USR_ACTIONS,(buf),(firstRec),(lastRec),(firstFld),(lastFld),(error))
#define ic0motAdcWriteUsrActions(obj,buf,firstRec,lastRec,firstFld,lastFld,error) \
	lcctooCaiRWTable((obj)->attrs,1,ic0motADC_ATTR_USR_ACTIONS,(void*) (buf),(firstRec),(lastRec),(firstFld),(lastFld),(error))
#define ic0motAdcReadUserUnitFct(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motADC_ATTR_USER_UNIT_FCT,(buf),(error))
#define ic0motAdcWriteUserUnitFct(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motADC_ATTR_USER_UNIT_FCT,(void*) (buf),(error))
#define ic0motAdcReadUserUnitFct2(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motADC_ATTR_USER_UNIT_FCT2,(buf),(error))
#define ic0motAdcWriteUserUnitFct2(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motADC_ATTR_USER_UNIT_FCT2,(void*) (buf),(error))
#define ic0motAdcGetUserUnitArgsSize(obj,num,error) \
	caiGetAttrInfo((obj)->attrs,ic0motADC_ATTR_USER_UNIT_ARGS,NULL,NULL,(num),NULL, NULL,NULL,(error))
#define ic0motAdcReadUserUnitArgs(obj,buf,firstElt,lastElt,error) \
	caiRWVector((obj)->attrs,0,ic0motADC_ATTR_USER_UNIT_ARGS,(buf),(firstElt),(lastElt),(error))
#define ic0motAdcWriteUserUnitArgs(obj,buf,firstElt,lastElt,error) \
	caiRWVector((obj)->attrs,1,ic0motADC_ATTR_USER_UNIT_ARGS,(void*) (buf),(firstElt),(lastElt),(error))
#define ic0motAdcReadInitTimeout(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motADC_ATTR_INIT_TIMEOUT,(buf),(error))
#define ic0motAdcWriteInitTimeout(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motADC_ATTR_INIT_TIMEOUT,(void*) (buf),(error))
#define ic0motAdcReadMoveTimeout(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motADC_ATTR_MOVE_TIMEOUT,(buf),(error))
#define ic0motAdcWriteMoveTimeout(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motADC_ATTR_MOVE_TIMEOUT,(void*) (buf),(error))
#define ic0motAdcReadDisconnect(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motADC_ATTR_DISCONNECT,(buf),(error))
#define ic0motAdcWriteDisconnect(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motADC_ATTR_DISCONNECT,(void*) (buf),(error))
#define ic0motAdcReadUseCfgElem(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motADC_ATTR_USE_CFG_ELEM,(buf),(error))
#define ic0motAdcWriteUseCfgElem(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motADC_ATTR_USE_CFG_ELEM,(void*) (buf),(error))
#define ic0motAdcReadParkAction(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motADC_ATTR_PARK_ACTION,(buf),(error))
#define ic0motAdcWriteParkAction(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motADC_ATTR_PARK_ACTION,(void*) (buf),(error))
#define ic0motAdcReadTestAction(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motADC_ATTR_TEST_ACTION,(buf),(error))
#define ic0motAdcWriteTestAction(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motADC_ATTR_TEST_ACTION,(void*) (buf),(error))
#define ic0motAdcReadTest(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motADC_ATTR_TEST,(buf),(error))
#define ic0motAdcWriteTest(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motADC_ATTR_TEST,(void*) (buf),(error))
#define ic0motAdcReadInstalled(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motADC_ATTR_INSTALLED,(buf),(error))
#define ic0motAdcWriteInstalled(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motADC_ATTR_INSTALLED,(void*) (buf),(error))
#define ic0motAdcReadAttached(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motADC_ATTR_ATTACHED,(buf),(error))
#define ic0motAdcWriteAttached(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motADC_ATTR_ATTACHED,(void*) (buf),(error))
#define ic0motAdcReadParked(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motADC_ATTR_PARKED,(buf),(error))
#define ic0motAdcWriteParked(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motADC_ATTR_PARKED,(void*) (buf),(error))
#define ic0motAdcReadActionStep(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motADC_ATTR_ACTION_STEP,(buf),(error))
#define ic0motAdcWriteActionStep(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motADC_ATTR_ACTION_STEP,(void*) (buf),(error))
#define ic0motAdcReadActionRetry(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motADC_ATTR_ACTION_RETRY,(buf),(error))
#define ic0motAdcWriteActionRetry(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motADC_ATTR_ACTION_RETRY,(void*) (buf),(error))
#define ic0motAdcReadActionMoveValid(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motADC_ATTR_ACTION_MOVE_VALID,(buf),(error))
#define ic0motAdcWriteActionMoveValid(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motADC_ATTR_ACTION_MOVE_VALID,(void*) (buf),(error))
#define ic0motAdcGetActionMoveSize(obj,num,error) \
	caiGetAttrInfo((obj)->attrs,ic0motADC_ATTR_ACTION_MOVE,NULL,NULL,(num),NULL, NULL,NULL,(error))
#define ic0motAdcReadActionMove(obj,buf,firstRec,lastRec,firstFld,lastFld,error) \
	lcctooCaiRWTable((obj)->attrs,0,ic0motADC_ATTR_ACTION_MOVE,(buf),(firstRec),(lastRec),(firstFld),(lastFld),(error))
#define ic0motAdcWriteActionMove(obj,buf,firstRec,lastRec,firstFld,lastFld,error) \
	lcctooCaiRWTable((obj)->attrs,1,ic0motADC_ATTR_ACTION_MOVE,(void*) (buf),(firstRec),(lastRec),(firstFld),(lastFld),(error))
#define ic0motAdcReadParsePosIndex(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motADC_ATTR_PARSE_POS_INDEX,(buf),(error))
#define ic0motAdcWriteParsePosIndex(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motADC_ATTR_PARSE_POS_INDEX,(void*) (buf),(error))
#define ic0motAdcReadFirstPosIndex(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motADC_ATTR_FIRST_POS_INDEX,(buf),(error))
#define ic0motAdcWriteFirstPosIndex(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motADC_ATTR_FIRST_POS_INDEX,(void*) (buf),(error))
#define ic0motAdcReadMoveMode(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motADC_ATTR_MOVE_MODE,(buf),(error))
#define ic0motAdcWriteMoveMode(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motADC_ATTR_MOVE_MODE,(void*) (buf),(error))
#define ic0motAdcReadMode(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motADC_ATTR_MODE,(buf),(error))
#define ic0motAdcWriteMode(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motADC_ATTR_MODE,(void*) (buf),(error))
#define ic0motAdcReadRa(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motADC_ATTR_RA,(buf),(error))
#define ic0motAdcWriteRa(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motADC_ATTR_RA,(void*) (buf),(error))
#define ic0motAdcReadDec(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motADC_ATTR_DEC,(buf),(error))
#define ic0motAdcWriteDec(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motADC_ATTR_DEC,(void*) (buf),(error))
#define ic0motAdcReadStartPosang(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motADC_ATTR_START_POSANG,(buf),(error))
#define ic0motAdcWriteStartPosang(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motADC_ATTR_START_POSANG,(void*) (buf),(error))
#define ic0motAdcReadPosang(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motADC_ATTR_POSANG,(buf),(error))
#define ic0motAdcWritePosang(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motADC_ATTR_POSANG,(void*) (buf),(error))
#define ic0motAdcReadDrotPos(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motADC_ATTR_DROT_POS,(buf),(error))
#define ic0motAdcWriteDrotPos(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motADC_ATTR_DROT_POS,(void*) (buf),(error))
#define ic0motAdcReadTemperature(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motADC_ATTR_TEMPERATURE,(buf),(error))
#define ic0motAdcWriteTemperature(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motADC_ATTR_TEMPERATURE,(void*) (buf),(error))
#define ic0motAdcReadPressure(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motADC_ATTR_PRESSURE,(buf),(error))
#define ic0motAdcWritePressure(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motADC_ATTR_PRESSURE,(void*) (buf),(error))
#define ic0motAdcReadLatitude(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motADC_ATTR_LATITUDE,(buf),(error))
#define ic0motAdcWriteLatitude(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motADC_ATTR_LATITUDE,(void*) (buf),(error))
#define ic0motAdcReadLongitude(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motADC_ATTR_LONGITUDE,(buf),(error))
#define ic0motAdcWriteLongitude(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motADC_ATTR_LONGITUDE,(void*) (buf),(error))
#define ic0motAdcReadDrotDevice(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motADC_ATTR_DROT_DEVICE,(buf),(error))
#define ic0motAdcWriteDrotDevice(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motADC_ATTR_DROT_DEVICE,(void*) (buf),(error))
#define ic0motAdcGetAuto(obj,attrPtr,error) \
	SUCCESS; \
	memcpy((attrPtr), &(obj)->objs[ic0motADC_AUTOMATA], sizeof(egenOBJ)); \
	(attrPtr)->ldata = (obj)->ldata;


/*
 * class functions
 */
#define ic0motAdcCheck(obj,devName,status,error) \
	ic0devMotCheck((obj),(devName),(status),(error))
#define ic0motAdcWait(obj,devName,timeout,error) \
	ic0devMotWait((obj),(devName),(timeout),(error))
#define ic0motAdcCfgElem(obj,devName,position,id,values,valuesNum,error) \
	ic0devMotCfgElem((obj),(devName),(position),(id),(values),(valuesNum),(error))
#define ic0motAdcLogConf(obj,devName,allElements,error) \
	ic0devMotLogConf((obj),(devName),(allElements),(error))
#define ic0motAdcGetConf(obj,devName,allElements,text,error) \
	ic0devMotGetConf((obj),(devName),(allElements),(text),(error))
#define ic0motAdcVarSet(obj,error) \
	ic0devMotVarSet((obj),(error))
#define ic0motAdcVarWait(obj,error) \
	ic0devMotVarWait((obj),(error))
#define ic0motAdcUsrInit(obj,devName,error) \
	ic0devMotUsrInit((obj),(devName),(error))
#define ic0motAdcUsrLoaded2Standby(obj,devName,error) \
	ic0devMotUsrLoaded2Standby((obj),(devName),(error))
#define ic0motAdcUsrStandby2Loaded(obj,devName,error) \
	ic0devMotUsrStandby2Loaded((obj),(devName),(error))
#define ic0motAdcUsrSetMode(obj,devName,cmd,available,enabled,simulation,handset,locked,error) \
	ic0devMotUsrSetMode((obj),(devName),(cmd),(available),(enabled),(simulation),(handset),(locked),(error))
#define ic0motAdcUsrSelfTest(obj,devName,error) \
	ic0devMotUsrSelfTest((obj),(devName),(error))
#define ic0motAdcUsrTest(obj,devName,error) \
	ic0devMotUsrTest((obj),(devName),(error))
#define ic0motAdcUsrExecAction(obj,devName,index,error) \
	ic0devMotUsrExecAction((obj),(devName),(index),(error))
#define ic0motAdcUsrSetParameter(obj,devName,cmd,param1,param1SetCode,param2,param2SetCode,value,error) \
	ic0devMotUsrSetParameter((obj),(devName),(cmd),(param1),(param1SetCode),(param2),(param2SetCode),(value),(error))
#define ic0motAdcUsrGetValue(obj,devName,valuesTable,valuesTableNum,code,index,value,valueNum,done,error) \
	ic0devMotUsrGetValue((obj),(devName),(valuesTable),(valuesTableNum),(code),(index),(value),(valueNum),(done),(error))
#define ic0motAdcUsrSetValue(obj,devName,valuesTable,valuesTableNum,code,index,value,valueNum,done,error) \
	ic0devMotUsrSetValue((obj),(devName),(valuesTable),(valuesTableNum),(code),(index),(value),(valueNum),(done),(error))
#define ic0motAdcGetArg(obj,devName,code,index,value,error) \
	ic0devMotGetArg((obj),(devName),(code),(index),(value),(error))
#define ic0motAdcGetHandles(obj,devName,motors,error) \
	ic0devMotGetHandles((obj),(devName),(motors),(error))
#define ic0motAdcPark(obj,devName,error) \
	ic0devMotPark((obj),(devName),(error))
#define ic0motAdcGetAction(obj,devName,actionStep,action,error) \
	ic0devMotGetAction((obj),(devName),(actionStep),(action),(error))
#define ic0motAdcActionGetHandles(obj,devName,index,motors,error) \
	ic0devMotActionGetHandles((obj),(devName),(index),(motors),(error))
#define ic0motAdcActionNewMove(obj,devName,action,end,error) \
	ic0devMotActionNewMove((obj),(devName),(action),(end),(error))
#define ic0motAdcActionIf(obj,devName,action,end,error) \
	ic0devMotActionIf((obj),(devName),(action),(end),(error))
#define ic0motAdcActionParam(obj,devName,action,end,error) \
	ic0devMotActionParam((obj),(devName),(action),(end),(error))
#define ic0motAdcActionAddParam(obj,devName,action,end,error) \
	ic0devMotActionAddParam((obj),(devName),(action),(end),(error))
#define ic0motAdcActionValue(obj,devName,action,end,error) \
	ic0devMotActionValue((obj),(devName),(action),(end),(error))
#define ic0motAdcActionAddValue(obj,devName,action,end,error) \
	ic0devMotActionAddValue((obj),(devName),(action),(end),(error))
#define ic0motAdcActionMove(obj,devName,action,end,error) \
	ic0devMotActionMove((obj),(devName),(action),(end),(error))
#define ic0motAdcActionSpeedMove(obj,devName,action,end,error) \
	ic0devMotActionSpeedMove((obj),(devName),(action),(end),(error))
#define ic0motAdcActionWaitMove(obj,devName,action,end,error) \
	ic0devMotActionWaitMove((obj),(devName),(action),(end),(error))
#define ic0motAdcActionClampBrake(obj,devName,action,end,error) \
	ic0devMotActionClampBrake((obj),(devName),(action),(end),(error))
#define ic0motAdcActionDisconnect(obj,devName,action,end,error) \
	ic0devMotActionDisconnect((obj),(devName),(action),(end),(error))
#define ic0motAdcActionStop(obj,devName,action,end,error) \
	ic0devMotActionStop((obj),(devName),(action),(end),(error))
#define ic0motAdcActionUserFunction(obj,devName,action,end,error) \
	ic0devMotActionUserFunction((obj),(devName),(action),(end),(error))
#define ic0motAdcActionRetry(obj,devName,action,end,error) \
	ic0devMotActionRetry((obj),(devName),(action),(end),(error))
#define ic0motAdcActionEnd(obj,devName,action,end,error) \
	ic0devMotActionEnd((obj),(devName),(action),(end),(error))
#define ic0motAdcActionError(obj,devName,action,end,error) \
	ic0devMotActionError((obj),(devName),(action),(end),(error))
#define ic0motAdcActionSleep(obj,devName,action,end,error) \
	ic0devMotActionSleep((obj),(devName),(action),(end),(error))
#define ic0motAdcActionIncrValue(obj,devName,action,end,error) \
	ic0devMotActionIncrValue((obj),(devName),(action),(end),(error))
#define ic0motAdcSetParListAddress(obj,devName,motor,error) \
	ic0devMotSetParListAddress((obj),(devName),(motor),(error))
#define ic0motAdcWlen2Enc(obj,from,to,parList,error) \
	ic0devMotWlen2Enc((obj),(from),(to),(parList),(error))
#define ic0motAdcTemp2Focus(obj,from,to,parList,error) \
	ic0devMotTemp2Focus((obj),(from),(to),(parList),(error))
#define ic0motAdcSlit2Enc1(obj,from,to,parList,error) \
	ic0devMotSlit2Enc1((obj),(from),(to),(parList),(error))
#define ic0motAdcSlit2Enc2(obj,from,to,parList,error) \
	ic0devMotSlit2Enc2((obj),(from),(to),(parList),(error))
#define ic0motAdcSlit2Enc(obj,motorIndex,from,to,error) \
	ic0devMotSlit2Enc((obj),(motorIndex),(from),(to),(error))
#define ic0motAdcWlenTeta2Enc(obj,from,to,parList,error) \
	ic0devMotWlenTeta2Enc((obj),(from),(to),(parList),(error))
#define ic0motAdcTilt2Enc(obj,from,to,parList,error) \
	ic0devMotTilt2Enc((obj),(from),(to),(parList),(error))
#define ic0motAdcSetup(obj,devName,function,functionNum,noMove,check,error) \
	ic0devSoftSetup((obj),(devName),(function),(functionNum),(noMove),(check),(error))
#define ic0motAdcGetVal(obj,devName,name,nameNum,status,error) \
	ic0devSoftGetVal((obj),(devName),(name),(nameNum),(status),(error))
#define ic0motAdcSetVal(obj,devName,name,nameNum,value,valueNum,error) \
	ic0devSoftSetVal((obj),(devName),(name),(nameNum),(value),(valueNum),(error))
#define ic0motAdcStatus(obj,devName,function,functionNum,flag,header,conflog,opslog,condlog,status,error) \
	ic0devSoftStatus((obj),(devName),(function),(functionNum),(flag),(header),(conflog),(opslog),(condlog),(status),(error))
#define ic0motAdcMove(obj,devName,position,positionNum,error) \
	ic0devSoftMove((obj),(devName),(position),(positionNum),(error))
#define ic0motAdcMoveRel(obj,devName,position,positionNum,error) \
	ic0devSoftMoveRel((obj),(devName),(position),(positionNum),(error))
#define ic0motAdcSet(obj,devName,position,positionNum,error) \
	ic0devSoftSet((obj),(devName),(position),(positionNum),(error))
#define ic0motAdcResetParameters(obj,devName,cmd,error) \
	ic0devSoftResetParameters((obj),(devName),(cmd),(error))
#define ic0motAdcParseParameters(obj,devName,cmd,params,paramsNum,noMove,check,error) \
	ic0devSoftParseParameters((obj),(devName),(cmd),(params),(paramsNum),(noMove),(check),(error))
#define ic0motAdcCompareParameters(obj,devName,cmd,equal,error) \
	ic0devSoftCompareParameters((obj),(devName),(cmd),(equal),(error))
#define ic0motAdcCopyParameters(obj,devName,error) \
	ic0devSoftCopyParameters((obj),(devName),(error))
#define ic0motAdcExecParameters(obj,devName,error) \
	ic0devSoftExecParameters((obj),(devName),(error))
#define ic0motAdcUpdateParameters(obj,devName,cache,error) \
	ic0devSoftUpdateParameters((obj),(devName),(cache),(error))
#define ic0motAdcGetParamSetValue(obj,devName,index,value,setCode,error) \
	ic0devSoftGetParamSetValue((obj),(devName),(index),(value),(setCode),(error))
#define ic0motAdcGetParamStatus(obj,devName,index,flags,status,error) \
	ic0devSoftGetParamStatus((obj),(devName),(index),(flags),(status),(error))
#define ic0motAdcSetParam(obj,devName,index,cmd,value,step,error) \
	ic0devSoftSetParam((obj),(devName),(index),(cmd),(value),(step),(error))
#define ic0motAdcSetParamStep(obj,devName,index,cmd,step,error) \
	ic0devSoftSetParamStep((obj),(devName),(index),(cmd),(step),(error))
#define ic0motAdcGetValueCode(obj,devName,name,code,error) \
	ic0devSoftGetValueCode((obj),(devName),(name),(code),(error))
#define ic0motAdcGetValue(obj,devName,code,index,value,valueNum,error) \
	ic0devSoftGetValue((obj),(devName),(code),(index),(value),(valueNum),(error))
#define ic0motAdcSetValue(obj,devName,code,index,value,valueNum,error) \
	ic0devSoftSetValue((obj),(devName),(code),(index),(value),(valueNum),(error))
#define ic0motAdcMonitor(obj,devName,error) \
	ic0devSoftMonitor((obj),(devName),(error))
#define ic0motAdcUsrMonitor(obj,devName,state,error) \
	ic0devSoftUsrMonitor((obj),(devName),(state),(error))
#define ic0motAdcLogAction(obj,devName,action,comment,error) \
	ic0devSoftLogAction((obj),(devName),(action),(comment),(error))
#define ic0motAdcLogComment(obj,devName,comment,error) \
	ic0devSoftLogComment((obj),(devName),(comment),(error))
#define ic0motAdcLogParameter(obj,devName,parameter,index,value,comment,error) \
	ic0devSoftLogParameter((obj),(devName),(parameter),(index),(value),(comment),(error))
#define ic0motAdcLogRecovery(obj,devName,comment,error) \
	ic0devSoftLogRecovery((obj),(devName),(comment),(error))
#define ic0motAdcLogTblParam(obj,devName,paramIndex,flags,comment,error) \
	ic0devSoftLogTblParam((obj),(devName),(paramIndex),(flags),(comment),(error))
#define ic0motAdcLogUnforseen(obj,devName,comment,error) \
	ic0devSoftLogUnforseen((obj),(devName),(comment),(error))
#define ic0motAdcAvail(obj,devName,error) \
	lccdevCmdAvail((obj),(devName),(error))
#define ic0motAdcUnavail(obj,devName,error) \
	lccdevCmdUnavail((obj),(devName),(error))
#define ic0motAdcDisable(obj,devName,access,error) \
	lccdevCmdDisable((obj),(devName),(access),(error))
#define ic0motAdcEnable(obj,devName,access,error) \
	lccdevCmdEnable((obj),(devName),(access),(error))
#define ic0motAdcLock(obj,devName,error) \
	lccdevCmdLock((obj),(devName),(error))
#define ic0motAdcUnlock(obj,devName,error) \
	lccdevCmdUnlock((obj),(devName),(error))
#define ic0motAdcHandset(obj,devName,error) \
	lccdevCmdHandset((obj),(devName),(error))
#define ic0motAdcHsetOff(obj,devName,error) \
	lccdevCmdHsetOff((obj),(devName),(error))
#define ic0motAdcFixPos(obj,devName,position,positionNum,reset,error) \
	lccdevCmdFixPos((obj),(devName),(position),(positionNum),(reset),(error))
#define ic0motAdcUsrSimulat(obj,devName,error) \
	lccdevCmdUsrSimulat((obj),(devName),(error))
#define ic0motAdcUsrStopSim(obj,devName,error) \
	lccdevCmdUsrStopSim((obj),(devName),(error))
#define ic0motAdcStandby(obj,devName,error) \
	lccdevStdStandby((obj),(devName),(error))
#define ic0motAdcOnline(obj,devName,error) \
	lccdevStdOnline((obj),(devName),(error))
#define ic0motAdcOff(obj,devName,error) \
	lccdevStdOff((obj),(devName),(error))
#define ic0motAdcExit(obj,devName,error) \
	lccdevStdExit((obj),(devName),(error))
#define ic0motAdcState(obj,devName,state,error) \
	lccdevStdState((obj),(devName),(state),(error))
#define ic0motAdcSimulat(obj,devName,error) \
	lccdevStdSimulat((obj),(devName),(error))
#define ic0motAdcStopSim(obj,devName,error) \
	lccdevStdStopSim((obj),(devName),(error))
#define ic0motAdcInit(obj,devName,error) \
	lccdevStdInit((obj),(devName),(error))
#define ic0motAdcStop(obj,devName,error) \
	lccdevStdStop((obj),(devName),(error))
#define ic0motAdcTest(obj,devName,error) \
	lccdevStdTest((obj),(devName),(error))
#define ic0motAdcSelftst(obj,devName,error) \
	lccdevStdSelftst((obj),(devName),(error))
#define ic0motAdcAutoTbl(obj,devName,table,text,error) \
	lccdevStdAutoTbl((obj),(devName),(table),(text),(error))
#define ic0motAdcAutoRst(obj,devName,error) \
	lccdevStdAutoRst((obj),(devName),(error))
#define ic0motAdcLoaded2Stby(obj,devName,error) \
	lccdevStdLoaded2Stby((obj),(devName),(error))
#define ic0motAdcOnline2Stby(obj,devName,error) \
	lccdevStdOnline2Stby((obj),(devName),(error))
#define ic0motAdcExit1(obj,devName,error) \
	lccdevStdExit1((obj),(devName),(error))
#define ic0motAdcCheckDeviceName(obj,devName,error) \
	lccdevStdCheckDeviceName((obj),(devName),(error))
#define ic0motAdcBreak(obj,error) \
	lccdevStdBreak((obj),(error))
#define ic0motAdcUsrError(obj,devName,error) \
	lccdevStdUsrError((obj),(devName),(error))

ccsCOMPL_STAT ic0motAdcInitObj(
    INOUT egenOBJ*	obj,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0motAdcExitObj(
    INOUT egenOBJ*	obj,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0motAdcUsrStandby2Online(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0motAdcUsrOnline2Standby(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0motAdcExecAction(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    ic0devMOT_ACTION*	action,
    OUT   vltLOGICAL*	end,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0motAdcUsrStop(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltLOGICAL	req,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0motAdcActionAdcRotate(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    ic0devMOT_ACTION*	action,
    OUT   vltLOGICAL*	end,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0motAdcUsrStatusCode(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    const char*	text,
    IN    vltINT32	flags,
    OUT   vltINT32*	code,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0motAdcUsrStatusValue(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltINT32	code,
    OUT   lcctooVALUE*	value,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0motAdcUsrStatusLast(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   vltINT16*	last,
    OUT   ccsERROR*	error);


/*
 * virtual functions
 */
#define ic0motAdcVStandby(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_STANDBY)((obj)->fcts[ic0motADC_FCT_STANDBY]))) \
	 ((obj),(devName),(error))
#define ic0motAdcVOnline(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_ONLINE)((obj)->fcts[ic0motADC_FCT_ONLINE]))) \
	 ((obj),(devName),(error))
#define ic0motAdcVOff(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_OFF)((obj)->fcts[ic0motADC_FCT_OFF]))) \
	 ((obj),(devName),(error))
#define ic0motAdcVExit(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_EXIT)((obj)->fcts[ic0motADC_FCT_EXIT]))) \
	 ((obj),(devName),(error))
#define ic0motAdcVState(obj,devName,state,error) \
	(*((lccdevSTD_FCTPTR_STATE)((obj)->fcts[ic0motADC_FCT_STATE]))) \
	 ((obj),(devName),(state),(error))
#define ic0motAdcVSimulat(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_SIMULAT)((obj)->fcts[ic0motADC_FCT_SIMULAT]))) \
	 ((obj),(devName),(error))
#define ic0motAdcVStopSim(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_STOP_SIM)((obj)->fcts[ic0motADC_FCT_STOP_SIM]))) \
	 ((obj),(devName),(error))
#define ic0motAdcVStatus(obj,devName,function,functionNum,flag,header,conflog,opslog,condlog,status,error) \
	(*((ic0devSOFT_FCTPTR_STATUS)((obj)->fcts[ic0motADC_FCT_STATUS]))) \
	 ((obj),(devName),(function),(functionNum),(flag),(header),(conflog),(opslog),(condlog),(status),(error))
#define ic0motAdcVInit(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_INIT)((obj)->fcts[ic0motADC_FCT_INIT]))) \
	 ((obj),(devName),(error))
#define ic0motAdcVStop(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_STOP)((obj)->fcts[ic0motADC_FCT_STOP]))) \
	 ((obj),(devName),(error))
#define ic0motAdcVTest(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_TEST)((obj)->fcts[ic0motADC_FCT_TEST]))) \
	 ((obj),(devName),(error))
#define ic0motAdcVSelftst(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_SELFTST)((obj)->fcts[ic0motADC_FCT_SELFTST]))) \
	 ((obj),(devName),(error))
#define ic0motAdcVAutoTbl(obj,devName,table,text,error) \
	(*((lccdevSTD_FCTPTR_AUTO_TBL)((obj)->fcts[ic0motADC_FCT_AUTO_TBL]))) \
	 ((obj),(devName),(table),(text),(error))
#define ic0motAdcVAutoRst(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_AUTO_RST)((obj)->fcts[ic0motADC_FCT_AUTO_RST]))) \
	 ((obj),(devName),(error))
#define ic0motAdcVInitObj(obj,error) \
	(*((ic0motADC_FCTPTR_INIT_OBJ)((obj)->fcts[ic0motADC_FCT_INIT_OBJ]))) \
	 ((obj),(error))
#define ic0motAdcVExitObj(obj,error) \
	(*((ic0motADC_FCTPTR_EXIT_OBJ)((obj)->fcts[ic0motADC_FCT_EXIT_OBJ]))) \
	 ((obj),(error))
#define ic0motAdcVLoaded2Stby(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_LOADED2STBY)((obj)->fcts[ic0motADC_FCT_LOADED2STBY]))) \
	 ((obj),(devName),(error))
#define ic0motAdcVOnline2Stby(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_ONLINE2STBY)((obj)->fcts[ic0motADC_FCT_ONLINE2STBY]))) \
	 ((obj),(devName),(error))
#define ic0motAdcVExit1(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_EXIT1)((obj)->fcts[ic0motADC_FCT_EXIT1]))) \
	 ((obj),(devName),(error))
#define ic0motAdcVCheckDeviceName(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_CHECK_DEVICE_NAME)((obj)->fcts[ic0motADC_FCT_CHECK_DEVICE_NAME]))) \
	 ((obj),(devName),(error))
#define ic0motAdcVBreak(obj,error) \
	(*((lccdevSTD_FCTPTR_BREAK)((obj)->fcts[ic0motADC_FCT_BREAK]))) \
	 ((obj),(error))
#define ic0motAdcVUsrInit(obj,devName,error) \
	(*((ic0devMOT_FCTPTR_USR_INIT)((obj)->fcts[ic0motADC_FCT_USR_INIT]))) \
	 ((obj),(devName),(error))
#define ic0motAdcVUsrLoaded2Standby(obj,devName,error) \
	(*((ic0devMOT_FCTPTR_USR_LOADED2STANDBY)((obj)->fcts[ic0motADC_FCT_USR_LOADED2STANDBY]))) \
	 ((obj),(devName),(error))
#define ic0motAdcVUsrStandby2Online(obj,devName,error) \
	(*((ic0motADC_FCTPTR_USR_STANDBY2ONLINE)((obj)->fcts[ic0motADC_FCT_USR_STANDBY2ONLINE]))) \
	 ((obj),(devName),(error))
#define ic0motAdcVUsrOnline2Standby(obj,devName,error) \
	(*((ic0motADC_FCTPTR_USR_ONLINE2STANDBY)((obj)->fcts[ic0motADC_FCT_USR_ONLINE2STANDBY]))) \
	 ((obj),(devName),(error))
#define ic0motAdcVUsrStandby2Loaded(obj,devName,error) \
	(*((ic0devMOT_FCTPTR_USR_STANDBY2LOADED)((obj)->fcts[ic0motADC_FCT_USR_STANDBY2LOADED]))) \
	 ((obj),(devName),(error))
#define ic0motAdcVUsrStop(obj,devName,req,error) \
	(*((ic0motADC_FCTPTR_USR_STOP)((obj)->fcts[ic0motADC_FCT_USR_STOP]))) \
	 ((obj),(devName),(req),(error))
#define ic0motAdcVUsrSimulat(obj,devName,error) \
	(*((lccdevCMD_FCTPTR_USR_SIMULAT)((obj)->fcts[ic0motADC_FCT_USR_SIMULAT]))) \
	 ((obj),(devName),(error))
#define ic0motAdcVUsrStopSim(obj,devName,error) \
	(*((lccdevCMD_FCTPTR_USR_STOP_SIM)((obj)->fcts[ic0motADC_FCT_USR_STOP_SIM]))) \
	 ((obj),(devName),(error))
#define ic0motAdcVUsrStatusCode(obj,devName,text,flags,code,error) \
	(*((ic0motADC_FCTPTR_USR_STATUS_CODE)((obj)->fcts[ic0motADC_FCT_USR_STATUS_CODE]))) \
	 ((obj),(devName),(text),(flags),(code),(error))
#define ic0motAdcVUsrStatusLast(obj,devName,last,error) \
	(*((ic0motADC_FCTPTR_USR_STATUS_LAST)((obj)->fcts[ic0motADC_FCT_USR_STATUS_LAST]))) \
	 ((obj),(devName),(last),(error))
#define ic0motAdcVUsrStatusValue(obj,devName,code,value,error) \
	(*((ic0motADC_FCTPTR_USR_STATUS_VALUE)((obj)->fcts[ic0motADC_FCT_USR_STATUS_VALUE]))) \
	 ((obj),(devName),(code),(value),(error))
#define ic0motAdcVUsrTest(obj,devName,error) \
	(*((ic0devMOT_FCTPTR_USR_TEST)((obj)->fcts[ic0motADC_FCT_USR_TEST]))) \
	 ((obj),(devName),(error))
#define ic0motAdcVUsrSelfTest(obj,devName,error) \
	(*((ic0devMOT_FCTPTR_USR_SELF_TEST)((obj)->fcts[ic0motADC_FCT_USR_SELF_TEST]))) \
	 ((obj),(devName),(error))
#define ic0motAdcVUsrError(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_USR_ERROR)((obj)->fcts[ic0motADC_FCT_USR_ERROR]))) \
	 ((obj),(devName),(error))
#define ic0motAdcVAvail(obj,devName,error) \
	(*((lccdevCMD_FCTPTR_AVAIL)((obj)->fcts[ic0motADC_FCT_AVAIL]))) \
	 ((obj),(devName),(error))
#define ic0motAdcVUnavail(obj,devName,error) \
	(*((lccdevCMD_FCTPTR_UNAVAIL)((obj)->fcts[ic0motADC_FCT_UNAVAIL]))) \
	 ((obj),(devName),(error))
#define ic0motAdcVDisable(obj,devName,access,error) \
	(*((lccdevCMD_FCTPTR_DISABLE)((obj)->fcts[ic0motADC_FCT_DISABLE]))) \
	 ((obj),(devName),(access),(error))
#define ic0motAdcVEnable(obj,devName,access,error) \
	(*((lccdevCMD_FCTPTR_ENABLE)((obj)->fcts[ic0motADC_FCT_ENABLE]))) \
	 ((obj),(devName),(access),(error))
#define ic0motAdcVLock(obj,devName,error) \
	(*((lccdevCMD_FCTPTR_LOCK)((obj)->fcts[ic0motADC_FCT_LOCK]))) \
	 ((obj),(devName),(error))
#define ic0motAdcVUnlock(obj,devName,error) \
	(*((lccdevCMD_FCTPTR_UNLOCK)((obj)->fcts[ic0motADC_FCT_UNLOCK]))) \
	 ((obj),(devName),(error))
#define ic0motAdcVHandset(obj,devName,error) \
	(*((lccdevCMD_FCTPTR_HANDSET)((obj)->fcts[ic0motADC_FCT_HANDSET]))) \
	 ((obj),(devName),(error))
#define ic0motAdcVHsetOff(obj,devName,error) \
	(*((lccdevCMD_FCTPTR_HSET_OFF)((obj)->fcts[ic0motADC_FCT_HSET_OFF]))) \
	 ((obj),(devName),(error))
#define ic0motAdcVFixPos(obj,devName,position,positionNum,reset,error) \
	(*((lccdevCMD_FCTPTR_FIX_POS)((obj)->fcts[ic0motADC_FCT_FIX_POS]))) \
	 ((obj),(devName),(position),(positionNum),(reset),(error))
#define ic0motAdcVMove(obj,devName,position,positionNum,error) \
	(*((ic0devSOFT_FCTPTR_MOVE)((obj)->fcts[ic0motADC_FCT_MOVE]))) \
	 ((obj),(devName),(position),(positionNum),(error))
#define ic0motAdcVMoveRel(obj,devName,position,positionNum,error) \
	(*((ic0devSOFT_FCTPTR_MOVE_REL)((obj)->fcts[ic0motADC_FCT_MOVE_REL]))) \
	 ((obj),(devName),(position),(positionNum),(error))
#define ic0motAdcVSet(obj,devName,position,positionNum,error) \
	(*((ic0devSOFT_FCTPTR_SET)((obj)->fcts[ic0motADC_FCT_SET]))) \
	 ((obj),(devName),(position),(positionNum),(error))
#define ic0motAdcVCheck(obj,devName,status,error) \
	(*((ic0devMOT_FCTPTR_CHECK)((obj)->fcts[ic0motADC_FCT_CHECK]))) \
	 ((obj),(devName),(status),(error))
#define ic0motAdcVWait(obj,devName,timeout,error) \
	(*((ic0devMOT_FCTPTR_WAIT)((obj)->fcts[ic0motADC_FCT_WAIT]))) \
	 ((obj),(devName),(timeout),(error))
#define ic0motAdcVUsrSetMode(obj,devName,cmd,available,enabled,simulation,handset,locked,error) \
	(*((ic0devMOT_FCTPTR_USR_SET_MODE)((obj)->fcts[ic0motADC_FCT_USR_SET_MODE]))) \
	 ((obj),(devName),(cmd),(available),(enabled),(simulation),(handset),(locked),(error))
#define ic0motAdcVSetup(obj,devName,function,functionNum,noMove,check,error) \
	(*((ic0devSOFT_FCTPTR_SETUP)((obj)->fcts[ic0motADC_FCT_SETUP]))) \
	 ((obj),(devName),(function),(functionNum),(noMove),(check),(error))
#define ic0motAdcVGetVal(obj,devName,name,nameNum,status,error) \
	(*((ic0devSOFT_FCTPTR_GET_VAL)((obj)->fcts[ic0motADC_FCT_GET_VAL]))) \
	 ((obj),(devName),(name),(nameNum),(status),(error))
#define ic0motAdcVSetVal(obj,devName,name,nameNum,value,valueNum,error) \
	(*((ic0devSOFT_FCTPTR_SET_VAL)((obj)->fcts[ic0motADC_FCT_SET_VAL]))) \
	 ((obj),(devName),(name),(nameNum),(value),(valueNum),(error))
#define ic0motAdcVCfgElem(obj,devName,position,id,values,valuesNum,error) \
	(*((ic0devMOT_FCTPTR_CFG_ELEM)((obj)->fcts[ic0motADC_FCT_CFG_ELEM]))) \
	 ((obj),(devName),(position),(id),(values),(valuesNum),(error))
#define ic0motAdcVLogConf(obj,devName,allElements,error) \
	(*((ic0devMOT_FCTPTR_LOG_CONF)((obj)->fcts[ic0motADC_FCT_LOG_CONF]))) \
	 ((obj),(devName),(allElements),(error))
#define ic0motAdcVGetConf(obj,devName,allElements,text,error) \
	(*((ic0devMOT_FCTPTR_GET_CONF)((obj)->fcts[ic0motADC_FCT_GET_CONF]))) \
	 ((obj),(devName),(allElements),(text),(error))
#define ic0motAdcVResetParameters(obj,devName,cmd,error) \
	(*((ic0devSOFT_FCTPTR_RESET_PARAMETERS)((obj)->fcts[ic0motADC_FCT_RESET_PARAMETERS]))) \
	 ((obj),(devName),(cmd),(error))
#define ic0motAdcVParseParameters(obj,devName,cmd,params,paramsNum,noMove,check,error) \
	(*((ic0devSOFT_FCTPTR_PARSE_PARAMETERS)((obj)->fcts[ic0motADC_FCT_PARSE_PARAMETERS]))) \
	 ((obj),(devName),(cmd),(params),(paramsNum),(noMove),(check),(error))
#define ic0motAdcVCompareParameters(obj,devName,cmd,equal,error) \
	(*((ic0devSOFT_FCTPTR_COMPARE_PARAMETERS)((obj)->fcts[ic0motADC_FCT_COMPARE_PARAMETERS]))) \
	 ((obj),(devName),(cmd),(equal),(error))
#define ic0motAdcVCopyParameters(obj,devName,error) \
	(*((ic0devSOFT_FCTPTR_COPY_PARAMETERS)((obj)->fcts[ic0motADC_FCT_COPY_PARAMETERS]))) \
	 ((obj),(devName),(error))
#define ic0motAdcVExecParameters(obj,devName,error) \
	(*((ic0devSOFT_FCTPTR_EXEC_PARAMETERS)((obj)->fcts[ic0motADC_FCT_EXEC_PARAMETERS]))) \
	 ((obj),(devName),(error))
#define ic0motAdcVUpdateParameters(obj,devName,cache,error) \
	(*((ic0devSOFT_FCTPTR_UPDATE_PARAMETERS)((obj)->fcts[ic0motADC_FCT_UPDATE_PARAMETERS]))) \
	 ((obj),(devName),(cache),(error))
#define ic0motAdcVGetParamSetValue(obj,devName,index,value,setCode,error) \
	(*((ic0devSOFT_FCTPTR_GET_PARAM_SET_VALUE)((obj)->fcts[ic0motADC_FCT_GET_PARAM_SET_VALUE]))) \
	 ((obj),(devName),(index),(value),(setCode),(error))
#define ic0motAdcVGetParamStatus(obj,devName,index,flags,status,error) \
	(*((ic0devSOFT_FCTPTR_GET_PARAM_STATUS)((obj)->fcts[ic0motADC_FCT_GET_PARAM_STATUS]))) \
	 ((obj),(devName),(index),(flags),(status),(error))
#define ic0motAdcVSetParam(obj,devName,index,cmd,value,step,error) \
	(*((ic0devSOFT_FCTPTR_SET_PARAM)((obj)->fcts[ic0motADC_FCT_SET_PARAM]))) \
	 ((obj),(devName),(index),(cmd),(value),(step),(error))
#define ic0motAdcVSetParamStep(obj,devName,index,cmd,step,error) \
	(*((ic0devSOFT_FCTPTR_SET_PARAM_STEP)((obj)->fcts[ic0motADC_FCT_SET_PARAM_STEP]))) \
	 ((obj),(devName),(index),(cmd),(step),(error))
#define ic0motAdcVUsrExecAction(obj,devName,index,error) \
	(*((ic0devMOT_FCTPTR_USR_EXEC_ACTION)((obj)->fcts[ic0motADC_FCT_USR_EXEC_ACTION]))) \
	 ((obj),(devName),(index),(error))
#define ic0motAdcVUsrSetParameter(obj,devName,cmd,param1,param1SetCode,param2,param2SetCode,value,error) \
	(*((ic0devMOT_FCTPTR_USR_SET_PARAMETER)((obj)->fcts[ic0motADC_FCT_USR_SET_PARAMETER]))) \
	 ((obj),(devName),(cmd),(param1),(param1SetCode),(param2),(param2SetCode),(value),(error))
#define ic0motAdcVGetValueCode(obj,devName,name,code,error) \
	(*((ic0devSOFT_FCTPTR_GET_VALUE_CODE)((obj)->fcts[ic0motADC_FCT_GET_VALUE_CODE]))) \
	 ((obj),(devName),(name),(code),(error))
#define ic0motAdcVGetValue(obj,devName,code,index,value,valueNum,error) \
	(*((ic0devSOFT_FCTPTR_GET_VALUE)((obj)->fcts[ic0motADC_FCT_GET_VALUE]))) \
	 ((obj),(devName),(code),(index),(value),(valueNum),(error))
#define ic0motAdcVUsrGetValue(obj,devName,valuesTable,valuesTableNum,code,index,value,valueNum,done,error) \
	(*((ic0devMOT_FCTPTR_USR_GET_VALUE)((obj)->fcts[ic0motADC_FCT_USR_GET_VALUE]))) \
	 ((obj),(devName),(valuesTable),(valuesTableNum),(code),(index),(value),(valueNum),(done),(error))
#define ic0motAdcVSetValue(obj,devName,code,index,value,valueNum,error) \
	(*((ic0devSOFT_FCTPTR_SET_VALUE)((obj)->fcts[ic0motADC_FCT_SET_VALUE]))) \
	 ((obj),(devName),(code),(index),(value),(valueNum),(error))
#define ic0motAdcVUsrSetValue(obj,devName,valuesTable,valuesTableNum,code,index,value,valueNum,done,error) \
	(*((ic0devMOT_FCTPTR_USR_SET_VALUE)((obj)->fcts[ic0motADC_FCT_USR_SET_VALUE]))) \
	 ((obj),(devName),(valuesTable),(valuesTableNum),(code),(index),(value),(valueNum),(done),(error))
#define ic0motAdcVGetArg(obj,devName,code,index,value,error) \
	(*((ic0devMOT_FCTPTR_GET_ARG)((obj)->fcts[ic0motADC_FCT_GET_ARG]))) \
	 ((obj),(devName),(code),(index),(value),(error))
#define ic0motAdcVMonitor(obj,devName,error) \
	(*((ic0devSOFT_FCTPTR_MONITOR)((obj)->fcts[ic0motADC_FCT_MONITOR]))) \
	 ((obj),(devName),(error))
#define ic0motAdcVUsrMonitor(obj,devName,state,error) \
	(*((ic0devSOFT_FCTPTR_USR_MONITOR)((obj)->fcts[ic0motADC_FCT_USR_MONITOR]))) \
	 ((obj),(devName),(state),(error))
#define ic0motAdcVLogAction(obj,devName,action,comment,error) \
	(*((ic0devSOFT_FCTPTR_LOG_ACTION)((obj)->fcts[ic0motADC_FCT_LOG_ACTION]))) \
	 ((obj),(devName),(action),(comment),(error))
#define ic0motAdcVLogComment(obj,devName,comment,error) \
	(*((ic0devSOFT_FCTPTR_LOG_COMMENT)((obj)->fcts[ic0motADC_FCT_LOG_COMMENT]))) \
	 ((obj),(devName),(comment),(error))
#define ic0motAdcVLogParameter(obj,devName,parameter,index,value,comment,error) \
	(*((ic0devSOFT_FCTPTR_LOG_PARAMETER)((obj)->fcts[ic0motADC_FCT_LOG_PARAMETER]))) \
	 ((obj),(devName),(parameter),(index),(value),(comment),(error))
#define ic0motAdcVLogRecovery(obj,devName,comment,error) \
	(*((ic0devSOFT_FCTPTR_LOG_RECOVERY)((obj)->fcts[ic0motADC_FCT_LOG_RECOVERY]))) \
	 ((obj),(devName),(comment),(error))
#define ic0motAdcVLogTblParam(obj,devName,paramIndex,flags,comment,error) \
	(*((ic0devSOFT_FCTPTR_LOG_TBL_PARAM)((obj)->fcts[ic0motADC_FCT_LOG_TBL_PARAM]))) \
	 ((obj),(devName),(paramIndex),(flags),(comment),(error))
#define ic0motAdcVLogUnforseen(obj,devName,comment,error) \
	(*((ic0devSOFT_FCTPTR_LOG_UNFORSEEN)((obj)->fcts[ic0motADC_FCT_LOG_UNFORSEEN]))) \
	 ((obj),(devName),(comment),(error))
#define ic0motAdcVVarSet(obj,error) \
	(*((ic0devMOT_FCTPTR_VAR_SET)((obj)->fcts[ic0motADC_FCT_VAR_SET]))) \
	 ((obj),(error))
#define ic0motAdcVVarWait(obj,error) \
	(*((ic0devMOT_FCTPTR_VAR_WAIT)((obj)->fcts[ic0motADC_FCT_VAR_WAIT]))) \
	 ((obj),(error))
#define ic0motAdcVGetHandles(obj,devName,motors,error) \
	(*((ic0devMOT_FCTPTR_GET_HANDLES)((obj)->fcts[ic0motADC_FCT_GET_HANDLES]))) \
	 ((obj),(devName),(motors),(error))
#define ic0motAdcVPark(obj,devName,error) \
	(*((ic0devMOT_FCTPTR_PARK)((obj)->fcts[ic0motADC_FCT_PARK]))) \
	 ((obj),(devName),(error))
#define ic0motAdcVGetAction(obj,devName,actionStep,action,error) \
	(*((ic0devMOT_FCTPTR_GET_ACTION)((obj)->fcts[ic0motADC_FCT_GET_ACTION]))) \
	 ((obj),(devName),(actionStep),(action),(error))
#define ic0motAdcVExecAction(obj,devName,action,end,error) \
	(*((ic0motADC_FCTPTR_EXEC_ACTION)((obj)->fcts[ic0motADC_FCT_EXEC_ACTION]))) \
	 ((obj),(devName),(action),(end),(error))
#define ic0motAdcVActionGetHandles(obj,devName,index,motors,error) \
	(*((ic0devMOT_FCTPTR_ACTION_GET_HANDLES)((obj)->fcts[ic0motADC_FCT_ACTION_GET_HANDLES]))) \
	 ((obj),(devName),(index),(motors),(error))
#define ic0motAdcVActionNewMove(obj,devName,action,end,error) \
	(*((ic0devMOT_FCTPTR_ACTION_NEW_MOVE)((obj)->fcts[ic0motADC_FCT_ACTION_NEW_MOVE]))) \
	 ((obj),(devName),(action),(end),(error))
#define ic0motAdcVActionIf(obj,devName,action,end,error) \
	(*((ic0devMOT_FCTPTR_ACTION_IF)((obj)->fcts[ic0motADC_FCT_ACTION_IF]))) \
	 ((obj),(devName),(action),(end),(error))
#define ic0motAdcVActionParam(obj,devName,action,end,error) \
	(*((ic0devMOT_FCTPTR_ACTION_PARAM)((obj)->fcts[ic0motADC_FCT_ACTION_PARAM]))) \
	 ((obj),(devName),(action),(end),(error))
#define ic0motAdcVActionAddParam(obj,devName,action,end,error) \
	(*((ic0devMOT_FCTPTR_ACTION_ADD_PARAM)((obj)->fcts[ic0motADC_FCT_ACTION_ADD_PARAM]))) \
	 ((obj),(devName),(action),(end),(error))
#define ic0motAdcVActionValue(obj,devName,action,end,error) \
	(*((ic0devMOT_FCTPTR_ACTION_VALUE)((obj)->fcts[ic0motADC_FCT_ACTION_VALUE]))) \
	 ((obj),(devName),(action),(end),(error))
#define ic0motAdcVActionAddValue(obj,devName,action,end,error) \
	(*((ic0devMOT_FCTPTR_ACTION_ADD_VALUE)((obj)->fcts[ic0motADC_FCT_ACTION_ADD_VALUE]))) \
	 ((obj),(devName),(action),(end),(error))
#define ic0motAdcVActionMove(obj,devName,action,end,error) \
	(*((ic0devMOT_FCTPTR_ACTION_MOVE)((obj)->fcts[ic0motADC_FCT_ACTION_MOVE]))) \
	 ((obj),(devName),(action),(end),(error))
#define ic0motAdcVActionSpeedMove(obj,devName,action,end,error) \
	(*((ic0devMOT_FCTPTR_ACTION_SPEED_MOVE)((obj)->fcts[ic0motADC_FCT_ACTION_SPEED_MOVE]))) \
	 ((obj),(devName),(action),(end),(error))
#define ic0motAdcVActionWaitMove(obj,devName,action,end,error) \
	(*((ic0devMOT_FCTPTR_ACTION_WAIT_MOVE)((obj)->fcts[ic0motADC_FCT_ACTION_WAIT_MOVE]))) \
	 ((obj),(devName),(action),(end),(error))
#define ic0motAdcVActionClampBrake(obj,devName,action,end,error) \
	(*((ic0devMOT_FCTPTR_ACTION_CLAMP_BRAKE)((obj)->fcts[ic0motADC_FCT_ACTION_CLAMP_BRAKE]))) \
	 ((obj),(devName),(action),(end),(error))
#define ic0motAdcVActionDisconnect(obj,devName,action,end,error) \
	(*((ic0devMOT_FCTPTR_ACTION_DISCONNECT)((obj)->fcts[ic0motADC_FCT_ACTION_DISCONNECT]))) \
	 ((obj),(devName),(action),(end),(error))
#define ic0motAdcVActionStop(obj,devName,action,end,error) \
	(*((ic0devMOT_FCTPTR_ACTION_STOP)((obj)->fcts[ic0motADC_FCT_ACTION_STOP]))) \
	 ((obj),(devName),(action),(end),(error))
#define ic0motAdcVActionUserFunction(obj,devName,action,end,error) \
	(*((ic0devMOT_FCTPTR_ACTION_USER_FUNCTION)((obj)->fcts[ic0motADC_FCT_ACTION_USER_FUNCTION]))) \
	 ((obj),(devName),(action),(end),(error))
#define ic0motAdcVActionRetry(obj,devName,action,end,error) \
	(*((ic0devMOT_FCTPTR_ACTION_RETRY)((obj)->fcts[ic0motADC_FCT_ACTION_RETRY]))) \
	 ((obj),(devName),(action),(end),(error))
#define ic0motAdcVActionEnd(obj,devName,action,end,error) \
	(*((ic0devMOT_FCTPTR_ACTION_END)((obj)->fcts[ic0motADC_FCT_ACTION_END]))) \
	 ((obj),(devName),(action),(end),(error))
#define ic0motAdcVActionError(obj,devName,action,end,error) \
	(*((ic0devMOT_FCTPTR_ACTION_ERROR)((obj)->fcts[ic0motADC_FCT_ACTION_ERROR]))) \
	 ((obj),(devName),(action),(end),(error))
#define ic0motAdcVActionSleep(obj,devName,action,end,error) \
	(*((ic0devMOT_FCTPTR_ACTION_SLEEP)((obj)->fcts[ic0motADC_FCT_ACTION_SLEEP]))) \
	 ((obj),(devName),(action),(end),(error))
#define ic0motAdcVActionIncrValue(obj,devName,action,end,error) \
	(*((ic0devMOT_FCTPTR_ACTION_INCR_VALUE)((obj)->fcts[ic0motADC_FCT_ACTION_INCR_VALUE]))) \
	 ((obj),(devName),(action),(end),(error))
#define ic0motAdcVSetParListAddress(obj,devName,motor,error) \
	(*((ic0devMOT_FCTPTR_SET_PAR_LIST_ADDRESS)((obj)->fcts[ic0motADC_FCT_SET_PAR_LIST_ADDRESS]))) \
	 ((obj),(devName),(motor),(error))
#define ic0motAdcVWlen2Enc(obj,from,to,parList,error) \
	(*((ic0devMOT_FCTPTR_WLEN2ENC)((obj)->fcts[ic0motADC_FCT_WLEN2ENC]))) \
	 ((obj),(from),(to),(parList),(error))
#define ic0motAdcVTemp2Focus(obj,from,to,parList,error) \
	(*((ic0devMOT_FCTPTR_TEMP2FOCUS)((obj)->fcts[ic0motADC_FCT_TEMP2FOCUS]))) \
	 ((obj),(from),(to),(parList),(error))
#define ic0motAdcVSlit2Enc1(obj,from,to,parList,error) \
	(*((ic0devMOT_FCTPTR_SLIT2ENC1)((obj)->fcts[ic0motADC_FCT_SLIT2ENC1]))) \
	 ((obj),(from),(to),(parList),(error))
#define ic0motAdcVSlit2Enc2(obj,from,to,parList,error) \
	(*((ic0devMOT_FCTPTR_SLIT2ENC2)((obj)->fcts[ic0motADC_FCT_SLIT2ENC2]))) \
	 ((obj),(from),(to),(parList),(error))
#define ic0motAdcVSlit2Enc(obj,motorIndex,from,to,error) \
	(*((ic0devMOT_FCTPTR_SLIT2ENC)((obj)->fcts[ic0motADC_FCT_SLIT2ENC]))) \
	 ((obj),(motorIndex),(from),(to),(error))
#define ic0motAdcVWlenTeta2Enc(obj,from,to,parList,error) \
	(*((ic0devMOT_FCTPTR_WLEN_TETA2ENC)((obj)->fcts[ic0motADC_FCT_WLEN_TETA2ENC]))) \
	 ((obj),(from),(to),(parList),(error))
#define ic0motAdcVTilt2Enc(obj,from,to,parList,error) \
	(*((ic0devMOT_FCTPTR_TILT2ENC)((obj)->fcts[ic0motADC_FCT_TILT2ENC]))) \
	 ((obj),(from),(to),(parList),(error))
#define ic0motAdcVActionAdcRotate(obj,devName,action,end,error) \
	(*((ic0motADC_FCTPTR_ACTION_ADC_ROTATE)((obj)->fcts[ic0motADC_FCT_ACTION_ADC_ROTATE]))) \
	 ((obj),(devName),(action),(end),(error))


ccsCOMPL_STAT ic0motAdcNewObj(
    IN    dbSYMADDRESS	point,
    IN    egenOBJ*	owner,
    OUT   egenOBJ*	obj,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0motAdcDeleteObj(
    INOUT egenOBJ*	obj,
    OUT   ccsERROR*	error);


void ic0motAdcTask(
    INOUT lcctooTASK*   task);

ccsCOMPL_STAT ic0motAdcParamInit(
    INOUT egenOBJ*	    obj,
    IN    const char*	    devName,
    IN    ic0motADC_PARAM*  p,
    OUT   ccsERROR*	    error);

ccsCOMPL_STAT ic0motAdcParamGet(
    INOUT egenOBJ*	    obj,
    IN    const char*	    devName,
    IN    ic0motADC_PARAM*  p,
    OUT   ccsERROR*	    error);

ccsCOMPL_STAT ic0motAdcParamCalc(
    INOUT egenOBJ*	    obj,
    IN    const char*	    devName,
    IN    ic0motADC_PARAM*  p,
    IN    ic0motADC_MOTOR*  m,
    IN    ic0motADC_MOTION* t,
    OUT   ccsERROR*	    error);

ccsCOMPL_STAT ic0motAdcParamSet(
    INOUT egenOBJ*	    obj,
    IN    const char*	    devName,
    IN    ic0motADC_PARAM*  p,
    IN    ic0motADC_MOTOR*  m,
    OUT   ccsERROR*	    error);

ccsCOMPL_STAT ic0motAdcMotInit(
    INOUT egenOBJ*	    obj,
    IN    const char*	    devName,
    IN    ic0motADC_MOTOR*  m,
    OUT   ccsERROR*	    error);

ccsCOMPL_STAT ic0motAdcMotGetStatus(
    INOUT egenOBJ*	    obj,
    IN    const char*	    devName,
    INOUT ic0motADC_MOTOR*  m,
    OUT   ccsERROR*	    error);

ccsCOMPL_STAT ic0motAdcMotMove(
    INOUT egenOBJ*	    obj,
    IN    const char*	    devName,
    IN    ic0motADC_MOTOR*  m,
    IN    ic0motADC_MOTION* t,
    OUT   ccsERROR*	    error);

ccsCOMPL_STAT ic0motAdcMotStop(
    INOUT egenOBJ*	    obj,
    IN    const char*	    devName,
    IN    ic0motADC_MOTOR*  m,
    OUT   ccsERROR*	    error);


#endif // !IC0MOT_ADC_H

/************************************************************************/
/* ___oOo___ */
