/******************************************************************************
*  E.S.O. - VLT project
* 
*  "@(#) $Id: ic0motDefines.h,v 1.36 2005/07/14 11:49:41 vltsccm Exp $"
* 
*  who      when        what
*  -------- ----------  ----------------------------------------------
*  rschmutz 2005-07-14  SPR VLTSW20050242: ic0mot*_TASK_WAIT=100
*  rschmutz 07/07/99    ACTION codes increased.
*  rschmutz 16/05/99    value taskWait added.
*  rschmutz 05/10/98    *_TASK_ACKTOUT added.
*  rschmutz 02/09/97    Created
*
*/

/*************************************************************************
*    NAME
*	ic0motDefines.h - module header file, define part
* 
* 
*    DESCRIPTION
*	This is a header file of the module ic0mot.
* 
* 
*-------------------------------------------------------------------------
*/

#ifndef IC0MOT_DEFINES_H
#define IC0MOT_DEFINES_H


/*
 * set and get defines
 */
#define ic0motGET_FIRST			1   /* lcctooGET_FIRST		  */

#define ic0motADC_GET_FIRST		120 /* (ic0devMOT_GET_LAST + 1)	  */
#define ic0motADC_GET_MODE		120 /* (ic0devADC_GET_FIRST + 0)  */
#define ic0motADC_GET_RA		121 /* (ic0devADC_GET_FIRST + 1)  */
#define ic0motADC_GET_DEC		122 /* (ic0devADC_GET_FIRST + 2)  */
#define ic0motADC_GET_POSANG		123 /* (ic0devADC_GET_FIRST + 3)  */
#define ic0motADC_GET_TEMP		124 /* (ic0devADC_GET_FIRST + 4)  */
#define ic0motADC_GET_SENS1		125 /* (ic0devADC_GET_FIRST + 5)  */
#define ic0motADC_GET_LAST		125 /* (ic0devADC_GET_FIRST + 5)  */
#define ic0motADC_GET_PARAM_NUM		5   /* SETUP param.: 120..125 	  */

#define ic0motDROT_GET_FIRST		120 /* (ic0devMOT_GET_LAST + 1)	  */
#define ic0motDROT_GET_MODE		120 /* (ic0devDROT_GET_FIRST + 0) */
#define ic0motDROT_GET_RA		121 /* (ic0devDROT_GET_FIRST + 1) */
#define ic0motDROT_GET_DEC		122 /* (ic0devDROT_GET_FIRST + 2) */
#define ic0motDROT_GET_POSANG		123 /* (ic0devDROT_GET_FIRST + 3) */
#define ic0motDROT_GET_STATINDX		124 /* (ic0devDROT_GET_FIRST + 4) */
#define ic0motDROT_GET_POS		125 /* (ic0devDROT_GET_FIRST + 5) */
#define ic0motDROT_GET_LAST		125 /* (ic0devDROT_GET_FIRST + 5) */
#define ic0motDROT_GET_PARAM_NUM	5   /* SETUP param.: 120..124 	  */

#define ic0motADC_SET_MODE		20 
#define ic0motADC_SET_RA		21 
#define ic0motADC_SET_DEC		22 
#define ic0motADC_SET_POSANG		23 
#define ic0motADC_SET_TEMP		24 
#define ic0motADC_SET_SENS1		25 

#define ic0motDROT_SET_MODE		20 
#define ic0motDROT_SET_RA		21 
#define ic0motDROT_SET_DEC		22 
#define ic0motDROT_SET_POSANG		23 
#define ic0motDROT_SET_STATINDX		24 


/*
 * strings
 */
#define ic0motADC_MODE_STRING		"MODE"
#define ic0motADC_RA_STRING		"RA"
#define ic0motADC_DEC_STRING		"DEC"
#define ic0motADC_POSANG_STRING		"POSANG"
#define ic0motADC_TEMP_STRING		"TEMP"
#define ic0motADC_SENS1_STRING		"SENS1"

#define ic0motDROT_MODE_STRING		"MODE"
#define ic0motDROT_RA_STRING		"RA"
#define ic0motDROT_DEC_STRING		"DEC"
#define ic0motDROT_POSANG_STRING	"POSANG"
#define ic0motDROT_STATINDX_STRING	"STATINDX"

/*
 * values
 */
#define ic0motADC_MODE_OFF		0
#define ic0motADC_MODE_AUTO		1
#define ic0motADC_MODE_UNKNOWN		2

#define ic0motADC_MODE_OFF_STRING	"OFF"
#define ic0motADC_MODE_AUTO_STRING	"AUTO"
#define ic0motADC_MODE_UNKNOWN_STRING	"UNKNOWN"

#define ic0motADC_VALUE_TASK_WAIT	4
#define ic0motADC_VALUE_UTC_OFFSET	5
#define ic0motADC_VALUE_MIN_SPEED	6
#define ic0motADC_VALUE_MAX_SPEED	7
#define ic0motADC_VALUE_EQUINOX		8
#define ic0motADC_VALUE_SIGN1		9
#define ic0motADC_VALUE_SIGN2		10
#define ic0motADC_VALUE_REF_OFF		11
#define ic0motADC_VALUE_REF_AUTO	12
#define ic0motADC_VALUE_FORMULA		13
#define ic0motADC_VALUE_MIN_ELEV	14
#define ic0motADC_VALUE_POS_OFFSET	15
#define ic0motADC_VALUE_C0		16
#define ic0motADC_VALUE_PRES_SLOPE	17
#define ic0motADC_VALUE_PRES_OFFSET	18
#define ic0motADC_VALUE_TEMP_SLOPE	19
#define ic0motADC_VALUE_TEMP_OFFSET	20
#define ic0motADC_VALUE_DROT_FACTOR	21
#define ic0motADC_VALUE_A_FACTOR	22
#define ic0motADC_VALUE_LAST		22

#define ic0motDROT_MODE_OFF		0
#define ic0motDROT_MODE_STAT		1
#define ic0motDROT_MODE_SKY		2
#define ic0motDROT_MODE_ELEV		3
#define ic0motDROT_MODE_UNKNOWN		4

#define ic0motDROT_MODE_OFF_STRING	"OFF"
#define ic0motDROT_MODE_STAT_STRING	"STAT"
#define ic0motDROT_MODE_SKY_STRING	"SKY"
#define ic0motDROT_MODE_ELEV_STRING	"ELEV"
#define ic0motDROT_MODE_UNKNOWN_STRING	"UNKNOWN"

#define ic0motDROT_VALUE_TASK_WAIT	4
#define ic0motDROT_VALUE_UTC_OFFSET	5
#define ic0motDROT_VALUE_MIN_SPEED	6
#define ic0motDROT_VALUE_MAX_SPEED	7
#define ic0motDROT_VALUE_EQUINOX	8
#define ic0motDROT_VALUE_SIGN1		9
#define ic0motDROT_VALUE_SIGN2		10
#define ic0motDROT_VALUE_REF_STAT	11
#define ic0motDROT_VALUE_REF_ELEV	13
#define ic0motDROT_VALUE_STAT_POS0	14
#define ic0motDROT_VALUE_STAT_POSN	18
#define ic0motDROT_VALUE_LAST		18
#define ic0motDROT_STAT_POS_NUM		(ic0motDROT_VALUE_STAT_POSN - ic0motDROT_VALUE_STAT_POS0 + 1)

#define ic0motMOT_MOVE_NONE		0
#define ic0motMOT_MOVE_TO_POSENC	1
#define ic0motMOT_TRACK_TO_POSENC	4
#define ic0motMOT_TRACK_BY_SPEED	5

/*
 * actions
 */
#define ic0motMOT_ACTION_TRACKING	21  /* ic0devMOT_ACTION_LASTACTION + 1 */
#define ic0motMOT_ACTION_ADC_ROTATE	22  /* ic0devMOT_ACTION_LASTACTION + 2 */


/*
 * task parameters
 */
#define ic0motADC_TASK_PRIORITY		100
#define ic0motADC_TASK_WAIT		100
#define ic0motADC_TASK_ACKTOUT		90000
#define ic0motDROT_TASK_PRIORITY	100
#define ic0motDROT_TASK_WAIT		100
#define ic0motDROT_TASK_ACKTOUT		90000

/*
 * misc.
 */
#define ic0motVALUE_INVALID		9999


#endif // !IC0MOT_DEFINES_H

/************************************************************************/
/* ___oOo___ */
