/******************************************************************************
*  E.S.O. - VLT project
* 
*  "@(#) $Id: ic0motDrot.h,v 1.36 2005/07/14 11:49:40 vltsccm Exp $"
* 
*  who        when      what
*  ---------- --------  ----------------------------------------------
*  rschmutz   16/05/99  value taskWait added.
*  rschmutz   09/02/99  ic0motDrotParamSet added.
*  rschmutz   22/09/98  test variables added.
*  rschmutz   02/09/97  Created by eccsgen  Revision: 1.20
*
*
*    !!!!!!!!!  CAUTION: THIS FILE IS UPDATED BY ECCSGEN  !!!!!!!!!
*/

/*************************************************************************
*   NAME
*	ic0motDrot - class
*
*   SYNOPSIS
*	#include "ic0motDrot.h"
*
*	ccsCOMPL_STAT ic0motDrotNewObj(
*	    IN    dbSYMADDRESS	point,
*	    IN    egenOBJ*	owner,
*	    OUT   egenOBJ*	obj,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0motDrotDeleteObj(
*	    INOUT egenOBJ*	obj,
*	    OUT   ccsERROR*	error)
*
*	egenOBJ* ic0motDrotGetOwner(
*	    IN const egenOBJ* obj)
*
*	egenOBJ* ic0motDrotLogData(
*	    IN const egenOBJ*	obj,
*	    IN const char*	format,
*	    IN 			...)
*
*	ccsCOMPL_STAT ic0motDrotInitObj(
*	    INOUT egenOBJ*	obj,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0motDrotExitObj(
*	    INOUT egenOBJ*	obj,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0motDrotUsrStandby2Online(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0motDrotUsrOnline2Standby(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0motDrotExecAction(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    ic0devMOT_ACTION*	action,
*	    OUT   vltLOGICAL*	end,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0motDrotUsrStop(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    vltLOGICAL	req,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0motDrotActionTracking(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    ic0devMOT_ACTION*	action,
*	    OUT   vltLOGICAL*	end,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0motDrotUsrStatusCode(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    const char*	text,
*	    IN    vltINT32	flags,
*	    OUT   vltINT32*	code,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0motDrotUsrStatusValue(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    vltINT32	code,
*	    OUT   lcctooVALUE*	value,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0motDrotUsrStatusLast(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    OUT   vltINT16*	last,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0motDrotRead<scalarAttr>(
*	    INOUT egenOBJ*	obj,
*	    OUT   void*		buf,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0motDrotWrite<scalarAttr>(
*	    INOUT egenOBJ*	obj,
*	    IN    void*		buf,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0motDrotRead<vectorAttr>(
*	    INOUT egenOBJ*	obj,
*	    OUT   void*		buf,
*	    IN    vltINT32	first,
*	    IN    vltINT32	last,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0motDrotWrite<vectorAttr>(
*	    INOUT egenOBJ*	obj,
*	    IN    void*		buf,
*	    IN    vltINT32	first,
*	    IN    vltINT32	last,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0motDrotRead<tableAttr>(
*	    INOUT egenOBJ*	obj,
*	    OUT   void*		buf,
*	    IN    vltINT32	firstRec,
*	    IN    vltINT32	lastRec,
*	    IN    vltINT32	firstFld,
*	    IN    vltINT32	lastFld,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0motDrotWrite<tableAttr>(
*	    INOUT egenOBJ*	obj,
*	    IN    void*		buf,
*	    IN    vltINT32	firstRec,
*	    IN    vltINT32	lastRec,
*	    IN    vltINT32	firstFld,
*	    IN    vltINT32	lastFld,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0motErrDrotReadOldb(p1,p2)
*	ccsCOMPL_STAT ic0motErrDrotWriteOldb(p1,p2)
*	ccsCOMPL_STAT ic0motErrDrotTaskStart(p1)
*	ccsCOMPL_STAT ic0motErrDrotTaskStop(p1)
*	ccsCOMPL_STAT ic0motErrDrotTaskWait(p1)
*	ccsCOMPL_STAT ic0motErrDrotWrongValue(p1,p2,p3,p4)
*	ccsCOMPL_STAT ic0motErrDrotGeneral(p1,p2)
*
*   PARENT CLASS
*	public ic0devMOT
*
*   DESCRIPTION
*       The class ic0motDROT implements the software device
*       to access a derotator function.
*
*       The derotator uses the following FITS keywords:
*
*       INS.DROT.MODE	Sky, Vert, Stat
*       INS.DROT.RA	telescope coordinate
*       INS.DROT.DEC	telescope coordinate
*       INS.DROT.POSANG	start position angle
*
*	ic0motDrotNewObj(point,owner,obj,error)
*	    Initialises an instance of the class type ic0motDROT.
*
*	    point	<IN>	OLDB point where the owned attributes are
*				located.
*	    owner	<IN>	Pointer to the owner of the new instance.
*	    obj		<OUT>	Handle for the new instance (the handle
*				must be allocated by the caller).
*
*	ic0motDrotDeleteObj(obj,error)
*	    The function lcctooDeleteObj deletes an
*	    instance of the class type ic0motDROT
*
*
*	ic0motDrotErr<error>(...)
*	    The macros ic0motDrotErr*() log an error with lcctooLOG_0 and
*	    call errAdd with the corresponding error parameters.
*
*	ic0motDrotRead<attr>(...)
*	ic0motDrotWrite<attr>(...)
*	    The above macros read from/write to the data attributes
*	    of the class.
*	    The attributes are described in ic0motDrotDb(5).
*
*   PROTECTED METHODS
*   PRIVATE METHODS
*	ic0motDrotInitObj(obj,error)
*
*	ic0motDrotExitObj(obj,error)
*
*	ic0motDrotUsrStandby2Online(obj,devName,error)
*	   This function should be overloaded to perform the
*	   actions necessary to change from the STANDBY to the
*	   ONLINE state. The overloaded function should first
*	   call lccdevCmdUsrStandby2Online() or check if the
*	   device is available and enabled before going ONLINE.
*
*	ic0motDrotUsrOnline2Standby(obj,devName,error)
*	   This function should be overloaded to perform the
*	   actions necessary to change from the ONLINE to the
*	   STANDBY state.
*
*	ic0motDrotExecAction(obj,devName,action,end,error)
*	   Executes the action specified by the action entry.
*
*	   action	<IN>	action entry
*	   end	<OUT>	TRUE specifies that the action
*			   sequence should end.
*
*	ic0motDrotUsrStop(obj,devName,req,error)
*	   This function should be overloaded to stop the device.
*	   If req is true, then a command to stop the device MUST
*	   be issued, even if the device is already stopped.
*	   Note: The Stop command is accepted even if the device
*	   is busy performing another command.
*
*	ic0motDrotActionTracking(obj,devName,action,end,error)
*	   Action ic0motMOT_ACTION_TRACKING:
*
*	   The userValue is used as an index into the
*	   parameters table. The parameter should be
*	   a logical (or a string interpreted as such).
*
*	   If the value is TRUE, then tracking is started.
*
*	   If the value is FALSE, then the motor is
*	   stopped calling ic0devMotActionStop().
*
*	ic0motDrotUsrStatusCode(obj,devName,text,flags,code,error)
*	   This function receives the name of a status value
*	   and returns the corresponding code. This function
*	   should be overloaded if the new class declares new
*	   status values. The overloaded function should check
*	   first if the name corresponds to one of its own
*	   status values. If not, then it should call the
*	   function UsrStatusCode() of its parent class to be
*	   able to retrieve the codes of the parent status
*	   values.
*
*	   text	<IN>	Name of the status value.
*	   flags	<IN>	expected status type (lcctooSTATUS_*).
*	   code	<OUT>	Code of the status value (lccdevGET_*).
*
*	   lccdevGET_DEVICE        "Device"
*	   lccdevGET_STATE         "State"
*	   lccdevGET_TRANSTATE     "TranState"
*	   lccdevGET_ERROR         "Error"
*	   lccdevGET_INITIALISED   "Initialised"
*	   lccdevGET_SIMULATION    "Simulation"
*
*	ic0motDrotUsrStatusValue(obj,devName,code,value,error)
*	   This function receives the code of a status variable
*	   and returns its related value. This function should
*	   be overloaded if the new class declares new status
*	   values. The overloaded function should check first
*	   if the code corresponds to one of its own status
*	   values. If not, then it should call the function
*	   UsrStatusValue() of its parent class to be able to
*	   retrieve the status values of the parent.
*
*	   code	<OUT>	Code of the status value (lccdevGET_*).
*	   value	<OUT>	Handle of the value object
*			   (allocated by the caller).
*
*	ic0motDrotUsrStatusLast(obj,devName,last,error)
*	   This function returns the highest status code that
*	   the class knows. This function should be overloaded
*	   if the new class declares new status values, as new
*	   status codes have to be assigned to the new values.
*
*	   This function is used by the Status command when it
*	   has to return all status values. In this case it
*	   performs a loop from code 1 to the value returned
*	   by this function.
*
*
*   DEFINES
*
*   FILES
*
*   ENVIRONMENT
*
*   RETURN VALUES
*	If the function prototype allows, methods return ccsCOMPL_STAT.
*
*	Methods can generate the following errors:
*	    ic0motERR_DROT_READ_OLDB
*	    ic0motERR_DROT_WRITE_OLDB
*	    ic0motERR_DROT_TASK_START
*	    ic0motERR_DROT_TASK_STOP
*	    ic0motERR_DROT_TASK_WAIT
*	    ic0motERR_DROT_WRONG_VALUE
*	    ic0motERR_DROT_GENERAL
*
*   CAUTIONS
*
*   EXAMPLES
*
*   SEE ALSO
*
*   BUGS
*
* 
*-------------------------------------------------------------------------
*/

#ifndef IC0MOT_DROT_H
#define IC0MOT_DROT_H

#include "egen.h"
#include "ic0motErrors.h"
#include "ic0devMot.h"
#include "ic0motDefines.h"


/*
 * class type identifier
 */
#define ic0motDROT_ID	191

/*
 * attribute table
 */
#define ic0motDROT_ATTR_STATE	0
#define ic0motDROT_ATTR_SUBSTATE	1
#define ic0motDROT_ATTR_ERROR	2
#define ic0motDROT_ATTR_INITIALISED	3
#define ic0motDROT_ATTR_SIMULATION	4
#define ic0motDROT_ATTR_DEVICE	5
#define ic0motDROT_ATTR_AVAILABLE	6
#define ic0motDROT_ATTR_ENABLED	7
#define ic0motDROT_ATTR_LOCKED	8
#define ic0motDROT_ATTR_HANDSET	9
#define ic0motDROT_ATTR_FIXED	10
#define ic0motDROT_ATTR_FIX_POS_SET	11
#define ic0motDROT_ATTR_FIXED_POSITION	12
#define ic0motDROT_ATTR_FIXED_SIMULATION	13
#define ic0motDROT_ATTR_FIXED_LOCKED	14
#define ic0motDROT_ATTR_PREFIX	15
#define ic0motDROT_ATTR_PARAMETERS_SIZE	16
#define ic0motDROT_ATTR_PARAMETERS	17
#define ic0motDROT_ATTR_STATUS	18
#define ic0motDROT_ATTR_STATUS_INDEX	19
#define ic0motDROT_ATTR_VALUES_SIZE	20
#define ic0motDROT_ATTR_VALUES	21
#define ic0motDROT_ATTR_INIT_RESTRICTION	22
#define ic0motDROT_ATTR_MOVE_RESTRICTION	23
#define ic0motDROT_ATTR_STOP_TIMEOUT	24
#define ic0motDROT_ATTR_SET_VAL_FCT	25
#define ic0motDROT_ATTR_HELP_TEXT	26
#define ic0motDROT_ATTR_PARAM_STEP	27
#define ic0motDROT_ATTR_ACTION_COMMAND	28
#define ic0motDROT_ATTR_ACTION_STOP_REQ	29
#define ic0motDROT_ATTR_ACTION_NO_MOVE	30
#define ic0motDROT_ATTR_ACTION_CHECK	31
#define ic0motDROT_ATTR_RESET_SETUP_CMD	32
#define ic0motDROT_ATTR_MOTORS	33
#define ic0motDROT_ATTR_POSITIONS_SIZE	34
#define ic0motDROT_ATTR_POSITIONS	35
#define ic0motDROT_ATTR_ACTIONS	36
#define ic0motDROT_ATTR_USR_ACTIONS	37
#define ic0motDROT_ATTR_USER_UNIT_FCT	38
#define ic0motDROT_ATTR_USER_UNIT_FCT2	39
#define ic0motDROT_ATTR_USER_UNIT_ARGS	40
#define ic0motDROT_ATTR_INIT_TIMEOUT	41
#define ic0motDROT_ATTR_MOVE_TIMEOUT	42
#define ic0motDROT_ATTR_DISCONNECT	43
#define ic0motDROT_ATTR_USE_CFG_ELEM	44
#define ic0motDROT_ATTR_PARK_ACTION	45
#define ic0motDROT_ATTR_TEST_ACTION	46
#define ic0motDROT_ATTR_TEST	47
#define ic0motDROT_ATTR_INSTALLED	48
#define ic0motDROT_ATTR_ATTACHED	49
#define ic0motDROT_ATTR_PARKED	50
#define ic0motDROT_ATTR_ACTION_STEP	51
#define ic0motDROT_ATTR_ACTION_RETRY	52
#define ic0motDROT_ATTR_ACTION_MOVE_VALID	53
#define ic0motDROT_ATTR_ACTION_MOVE	54
#define ic0motDROT_ATTR_PARSE_POS_INDEX	55
#define ic0motDROT_ATTR_FIRST_POS_INDEX	56
#define ic0motDROT_ATTR_MOVE_MODE	57
#define ic0motDROT_ATTR_MODE	58
#define ic0motDROT_ATTR_RA	59
#define ic0motDROT_ATTR_DEC	60
#define ic0motDROT_ATTR_START_POSANG	61
#define ic0motDROT_ATTR_POSANG	62
#define ic0motDROT_ATTR_STATINDX	63
#define ic0motDROT_ATTR_LATITUDE	64
#define ic0motDROT_ATTR_LONGITUDE	65

#define ic0motDROT_AUTOMATA	0

/*
 * function table
 */
#define ic0motDROT_FCT_DELETE_OBJ	0
#define ic0motDROT_FCT_STANDBY	1
#define ic0motDROT_FCT_ONLINE	2
#define ic0motDROT_FCT_OFF	3
#define ic0motDROT_FCT_EXIT	4
#define ic0motDROT_FCT_STATE	5
#define ic0motDROT_FCT_SIMULAT	6
#define ic0motDROT_FCT_STOP_SIM	7
#define ic0motDROT_FCT_STATUS	8
#define ic0motDROT_FCT_INIT	9
#define ic0motDROT_FCT_STOP	10
#define ic0motDROT_FCT_TEST	11
#define ic0motDROT_FCT_SELFTST	12
#define ic0motDROT_FCT_AUTO_TBL	13
#define ic0motDROT_FCT_AUTO_RST	14
#define ic0motDROT_FCT_INIT_OBJ	15
#define ic0motDROT_FCT_EXIT_OBJ	16
#define ic0motDROT_FCT_LOADED2STBY	17
#define ic0motDROT_FCT_ONLINE2STBY	18
#define ic0motDROT_FCT_EXIT1	19
#define ic0motDROT_FCT_CHECK_DEVICE_NAME	20
#define ic0motDROT_FCT_BREAK	21
#define ic0motDROT_FCT_USR_INIT	22
#define ic0motDROT_FCT_USR_LOADED2STANDBY	23
#define ic0motDROT_FCT_USR_STANDBY2ONLINE	24
#define ic0motDROT_FCT_USR_ONLINE2STANDBY	25
#define ic0motDROT_FCT_USR_STANDBY2LOADED	26
#define ic0motDROT_FCT_USR_STOP	27
#define ic0motDROT_FCT_USR_SIMULAT	28
#define ic0motDROT_FCT_USR_STOP_SIM	29
#define ic0motDROT_FCT_USR_STATUS_CODE	30
#define ic0motDROT_FCT_USR_STATUS_LAST	31
#define ic0motDROT_FCT_USR_STATUS_VALUE	32
#define ic0motDROT_FCT_USR_TEST	33
#define ic0motDROT_FCT_USR_SELF_TEST	34
#define ic0motDROT_FCT_USR_ERROR	35
#define ic0motDROT_FCT_AVAIL	36
#define ic0motDROT_FCT_UNAVAIL	37
#define ic0motDROT_FCT_DISABLE	38
#define ic0motDROT_FCT_ENABLE	39
#define ic0motDROT_FCT_LOCK	40
#define ic0motDROT_FCT_UNLOCK	41
#define ic0motDROT_FCT_HANDSET	42
#define ic0motDROT_FCT_HSET_OFF	43
#define ic0motDROT_FCT_FIX_POS	44
#define ic0motDROT_FCT_MOVE	45
#define ic0motDROT_FCT_MOVE_REL	46
#define ic0motDROT_FCT_SET	47
#define ic0motDROT_FCT_CHECK	48
#define ic0motDROT_FCT_WAIT	49
#define ic0motDROT_FCT_USR_SET_MODE	50
#define ic0motDROT_FCT_SETUP	51
#define ic0motDROT_FCT_GET_VAL	52
#define ic0motDROT_FCT_SET_VAL	53
#define ic0motDROT_FCT_CFG_ELEM	54
#define ic0motDROT_FCT_LOG_CONF	55
#define ic0motDROT_FCT_GET_CONF	56
#define ic0motDROT_FCT_RESET_PARAMETERS	57
#define ic0motDROT_FCT_PARSE_PARAMETERS	58
#define ic0motDROT_FCT_COMPARE_PARAMETERS	59
#define ic0motDROT_FCT_COPY_PARAMETERS	60
#define ic0motDROT_FCT_EXEC_PARAMETERS	61
#define ic0motDROT_FCT_UPDATE_PARAMETERS	62
#define ic0motDROT_FCT_GET_PARAM_SET_VALUE	63
#define ic0motDROT_FCT_GET_PARAM_STATUS	64
#define ic0motDROT_FCT_SET_PARAM	65
#define ic0motDROT_FCT_SET_PARAM_STEP	66
#define ic0motDROT_FCT_USR_EXEC_ACTION	67
#define ic0motDROT_FCT_USR_SET_PARAMETER	68
#define ic0motDROT_FCT_GET_VALUE_CODE	69
#define ic0motDROT_FCT_GET_VALUE	70
#define ic0motDROT_FCT_USR_GET_VALUE	71
#define ic0motDROT_FCT_SET_VALUE	72
#define ic0motDROT_FCT_USR_SET_VALUE	73
#define ic0motDROT_FCT_GET_ARG	74
#define ic0motDROT_FCT_MONITOR	75
#define ic0motDROT_FCT_USR_MONITOR	76
#define ic0motDROT_FCT_LOG_ACTION	77
#define ic0motDROT_FCT_LOG_COMMENT	78
#define ic0motDROT_FCT_LOG_PARAMETER	79
#define ic0motDROT_FCT_LOG_RECOVERY	80
#define ic0motDROT_FCT_LOG_TBL_PARAM	81
#define ic0motDROT_FCT_LOG_UNFORSEEN	82
#define ic0motDROT_FCT_VAR_SET	83
#define ic0motDROT_FCT_VAR_WAIT	84
#define ic0motDROT_FCT_GET_HANDLES	85
#define ic0motDROT_FCT_PARK	86
#define ic0motDROT_FCT_GET_ACTION	87
#define ic0motDROT_FCT_EXEC_ACTION	88
#define ic0motDROT_FCT_ACTION_GET_HANDLES	89
#define ic0motDROT_FCT_ACTION_NEW_MOVE	90
#define ic0motDROT_FCT_ACTION_IF	91
#define ic0motDROT_FCT_ACTION_PARAM	92
#define ic0motDROT_FCT_ACTION_ADD_PARAM	93
#define ic0motDROT_FCT_ACTION_VALUE	94
#define ic0motDROT_FCT_ACTION_ADD_VALUE	95
#define ic0motDROT_FCT_ACTION_MOVE	96
#define ic0motDROT_FCT_ACTION_SPEED_MOVE	97
#define ic0motDROT_FCT_ACTION_WAIT_MOVE	98
#define ic0motDROT_FCT_ACTION_CLAMP_BRAKE	99
#define ic0motDROT_FCT_ACTION_DISCONNECT	100
#define ic0motDROT_FCT_ACTION_STOP	101
#define ic0motDROT_FCT_ACTION_USER_FUNCTION	102
#define ic0motDROT_FCT_ACTION_RETRY	103
#define ic0motDROT_FCT_ACTION_END	104
#define ic0motDROT_FCT_ACTION_ERROR	105
#define ic0motDROT_FCT_ACTION_SLEEP	106
#define ic0motDROT_FCT_ACTION_INCR_VALUE	107
#define ic0motDROT_FCT_SET_PAR_LIST_ADDRESS	108
#define ic0motDROT_FCT_WLEN2ENC	109
#define ic0motDROT_FCT_TEMP2FOCUS	110
#define ic0motDROT_FCT_SLIT2ENC1	111
#define ic0motDROT_FCT_SLIT2ENC2	112
#define ic0motDROT_FCT_SLIT2ENC	113
#define ic0motDROT_FCT_WLEN_TETA2ENC	114
#define ic0motDROT_FCT_TILT2ENC	115
#define ic0motDROT_FCT_ACTION_TRACKING	116

/*
 * automata states
 */
#define ic0motDROT_STATE_NOSTATE	-1
#define ic0motDROT_STATE_OFF	0
#define ic0motDROT_STATE_LOADED	1
#define ic0motDROT_STATE_STANDBY	2
#define ic0motDROT_STATE_ONLINE	3

/*
 * automata substates
 */
#define ic0motDROT_SUBSTATE_ERROR	0
#define ic0motDROT_SUBSTATE_IDLE	1
#define ic0motDROT_SUBSTATE_BUSY	2
#define ic0motDROT_SUBSTATE_INITIALISING	3
#define ic0motDROT_SUBSTATE_SHUTTING_DOWN	4
#define ic0motDROT_SUBSTATE_STOPPING	5
#define ic0motDROT_SUBSTATE_COLD_STARTING	6
#define ic0motDROT_SUBSTATE_STARTING	7
#define ic0motDROT_SUBSTATE_STOP	8

/*
 * automata events
 */
#define ic0motDROT_EVENT_INIT	0
#define ic0motDROT_EVENT_STANDBY	1
#define ic0motDROT_EVENT_ONLINE	2
#define ic0motDROT_EVENT_STOP	3
#define ic0motDROT_EVENT_OFF	4
#define ic0motDROT_EVENT_EXIT	5
#define ic0motDROT_EVENT_STATE	6
#define ic0motDROT_EVENT_STOP_SIM	7
#define ic0motDROT_EVENT_STATUS	8
#define ic0motDROT_EVENT_SIMULAT	9
#define ic0motDROT_EVENT_TEST	10
#define ic0motDROT_EVENT_SELFTST	11
#define ic0motDROT_EVENT_AUTO_TBL	12
#define ic0motDROT_EVENT_AUTO_RST	13
#define ic0motDROT_EVENT_DISABLE	14
#define ic0motDROT_EVENT_ENABLE	15
#define ic0motDROT_EVENT_LOCK	16
#define ic0motDROT_EVENT_UNLOCK	17
#define ic0motDROT_EVENT_HANDSET	18
#define ic0motDROT_EVENT_HSET_OFF	19
#define ic0motDROT_EVENT_AVAIL	20
#define ic0motDROT_EVENT_UNAVAIL	21
#define ic0motDROT_EVENT_MOVE	22
#define ic0motDROT_EVENT_MOVE_REL	23
#define ic0motDROT_EVENT_SET	24
#define ic0motDROT_EVENT_CHECK	25
#define ic0motDROT_EVENT_WAIT	26
#define ic0motDROT_EVENT_SETUP	27
#define ic0motDROT_EVENT_CFG_ELEM	28
#define ic0motDROT_EVENT_GET_VAL	29
#define ic0motDROT_EVENT_SET_VAL	30
#define ic0motDROT_EVENT_LOG_CONF	31
#define ic0motDROT_EVENT_GET_CONF	32
#define ic0motDROT_EVENT_MONITOR	33


/*
 * user variables
 */
typedef struct
    {
    vltINT32	mode;
    vltDOUBLE	ra;
    vltDOUBLE	dec;
    vltDOUBLE	posang;
    vltINT32	statIndex;
    vltLOGICAL	changed;
    ccsTIMEVAL	utc;
    ccsTIMEVAL	utcOffset;
    vltINT32	taskWait;
    vltINT32	reference[ic0motDROT_MODE_UNKNOWN];
    vltINT32	statPos[ic0motDROT_STAT_POS_NUM];
    vltDOUBLE	ra_r;
    vltDOUBLE	dec_r;
    vltDOUBLE	posang_r;
    vltDOUBLE	circResol_r;
    vltDOUBLE	minSpeed;
    vltDOUBLE	maxSpeed;
    vltDOUBLE	equinox;
    vltDOUBLE	sign1;
    vltDOUBLE	sign2;
    vltDOUBLE	latitude;
    vltDOUBLE	longitude;
    vltDOUBLE	temp1;
    vltDOUBLE	temp2;
    vltDOUBLE	temp3;
    vltDOUBLE	temp4;
    vltLOGICAL  test;
    vltDOUBLE   testHourAngle;
    vltDOUBLE   testDec;
    vltDOUBLE   fieldRotation;
    } ic0motDROT_PARAM;

typedef struct
    {
    vltINT32	how;
    vltINT32	posenc;
    vltDOUBLE	speed;
    vltLOGICAL	log;
    } ic0motDROT_MOTION;

typedef struct
    {
    motHANDLE	motor[3];
    motSTATUS	status;
    vltLOGICAL	simulation;
    motAXIS_TYPE axis;
    vltDOUBLE	circularRange;
    vltINT32	timeout;
    motMOTION	posMotion;
    motMOTION	spdMotion;
    } ic0motDROT_MOTOR;

typedef struct
    {
    lcctooTASK	task;
    ic0motDROT_PARAM	param;
    ic0motDROT_MOTION	motion;
    ic0motDROT_MOTOR	motor;
    } ic0motDROT_USERDATA;

typedef struct
    {
    SEM_ID	actionSequence;
    SEM_ID	actionSetup;
    ic0devMOT_SYNC_VAR_PARLIST*	syncVarParList[2];
    egenOBJ*	objParList[2];
    ic0motDROT_USERDATA* data;
    vltINT32	dummy[3];
    } ic0motDROT_USERVAR;

/*
 * function pointer types
 */
typedef ccsCOMPL_STAT (*ic0motDROT_FCTPTR_INIT_OBJ)(
    INOUT egenOBJ*	obj,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0motDROT_FCTPTR_EXIT_OBJ)(
    INOUT egenOBJ*	obj,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0motDROT_FCTPTR_USR_STANDBY2ONLINE)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0motDROT_FCTPTR_USR_ONLINE2STANDBY)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0motDROT_FCTPTR_EXEC_ACTION)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    ic0devMOT_ACTION*	action,
    OUT   vltLOGICAL*	end,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0motDROT_FCTPTR_USR_STOP)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltLOGICAL	req,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0motDROT_FCTPTR_ACTION_TRACKING)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    ic0devMOT_ACTION*	action,
    OUT   vltLOGICAL*	end,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0motDROT_FCTPTR_USR_STATUS_CODE)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    const char*	text,
    IN    vltINT32	flags,
    OUT   vltINT32*	code,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0motDROT_FCTPTR_USR_STATUS_VALUE)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltINT32	code,
    OUT   lcctooVALUE*	value,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0motDROT_FCTPTR_USR_STATUS_LAST)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   vltINT16*	last,
    OUT   ccsERROR*	error);


/*
 * log function
 */
#define ic0motDrotLogData(obj, format, arg...) \
	{ \
	char tmpLogBuf[lcctooTMP_BUFFER_SIZE]; \
	\
	sprintf(tmpLogBuf, (format), ##arg); \
	logData("ic0mot", (obj)->id, tmpLogBuf); \
	}


/*
 * error functions
 */
#define ic0motErrDrotReadOldb(p1,p2) \
	{ \
	lcctooLOG_0("ic0motERR_DROT_READ_OLDB: Device %s: Unable to read %s from OLDB.",(p1),(p2)); \
	errAdd(error,"ic0mot",ic0motERR_DROT_READ_OLDB,__FILE_LINE__,"%s,%s",(p1),(p2)); \
	}
#define ic0motErrDrotWriteOldb(p1,p2) \
	{ \
	lcctooLOG_0("ic0motERR_DROT_WRITE_OLDB: Device %s: Unable to write %s to OLDB.",(p1),(p2)); \
	errAdd(error,"ic0mot",ic0motERR_DROT_WRITE_OLDB,__FILE_LINE__,"%s,%s",(p1),(p2)); \
	}
#define ic0motErrDrotTaskStart(p1) \
	{ \
	lcctooLOG_0("ic0motERR_DROT_TASK_START: Device %s: Error starting the monitor task.",(p1)); \
	errAdd(error,"ic0mot",ic0motERR_DROT_TASK_START,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0motErrDrotTaskStop(p1) \
	{ \
	lcctooLOG_0("ic0motERR_DROT_TASK_STOP: Device %s: Error stopping the monitor task.",(p1)); \
	errAdd(error,"ic0mot",ic0motERR_DROT_TASK_STOP,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0motErrDrotTaskWait(p1) \
	{ \
	lcctooLOG_0("ic0motERR_DROT_TASK_WAIT: Device %s: Semaphore error updating the monitor data.",(p1)); \
	errAdd(error,"ic0mot",ic0motERR_DROT_TASK_WAIT,__FILE_LINE__,"%s",(p1)); \
	}
#define ic0motErrDrotWrongValue(p1,p2,p3,p4) \
	{ \
	lcctooLOG_0("ic0motERR_DROT_WRONG_VALUE: Device %s: Wrong %s value %f (%s).",(p1),(p2),(p3),(p4)); \
	errAdd(error,"ic0mot",ic0motERR_DROT_WRONG_VALUE,__FILE_LINE__,"%s,%s,%f,%s",(p1),(p2),(p3),(p4)); \
	}
#define ic0motErrDrotGeneral(p1,p2) \
	{ \
	lcctooLOG_0("ic0motERR_DROT_GENERAL: Device %s: %s.",(p1),(p2)); \
	errAdd(error,"ic0mot",ic0motERR_DROT_GENERAL,__FILE_LINE__,"%s,%s",(p1),(p2)); \
	}

/*
 * get object owner
 */
#define ic0motDrotGetOwner(obj) ((obj)->owner)


/*
 * attribute access functions
 */
#define ic0motDrotReadState(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motDROT_ATTR_STATE,(buf),(error))
#define ic0motDrotWriteState(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motDROT_ATTR_STATE,(void*) (buf),(error))
#define ic0motDrotReadSubstate(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motDROT_ATTR_SUBSTATE,(buf),(error))
#define ic0motDrotWriteSubstate(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motDROT_ATTR_SUBSTATE,(void*) (buf),(error))
#define ic0motDrotReadError(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motDROT_ATTR_ERROR,(buf),(error))
#define ic0motDrotWriteError(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motDROT_ATTR_ERROR,(void*) (buf),(error))
#define ic0motDrotReadInitialised(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motDROT_ATTR_INITIALISED,(buf),(error))
#define ic0motDrotWriteInitialised(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motDROT_ATTR_INITIALISED,(void*) (buf),(error))
#define ic0motDrotReadSimulation(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motDROT_ATTR_SIMULATION,(buf),(error))
#define ic0motDrotWriteSimulation(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motDROT_ATTR_SIMULATION,(void*) (buf),(error))
#define ic0motDrotReadDevice(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motDROT_ATTR_DEVICE,(buf),(error))
#define ic0motDrotWriteDevice(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motDROT_ATTR_DEVICE,(void*) (buf),(error))
#define ic0motDrotReadAvailable(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motDROT_ATTR_AVAILABLE,(buf),(error))
#define ic0motDrotWriteAvailable(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motDROT_ATTR_AVAILABLE,(void*) (buf),(error))
#define ic0motDrotReadEnabled(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motDROT_ATTR_ENABLED,(buf),(error))
#define ic0motDrotWriteEnabled(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motDROT_ATTR_ENABLED,(void*) (buf),(error))
#define ic0motDrotReadLocked(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motDROT_ATTR_LOCKED,(buf),(error))
#define ic0motDrotWriteLocked(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motDROT_ATTR_LOCKED,(void*) (buf),(error))
#define ic0motDrotReadHandset(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motDROT_ATTR_HANDSET,(buf),(error))
#define ic0motDrotWriteHandset(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motDROT_ATTR_HANDSET,(void*) (buf),(error))
#define ic0motDrotReadFixed(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motDROT_ATTR_FIXED,(buf),(error))
#define ic0motDrotWriteFixed(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motDROT_ATTR_FIXED,(void*) (buf),(error))
#define ic0motDrotReadFixPosSet(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motDROT_ATTR_FIX_POS_SET,(buf),(error))
#define ic0motDrotWriteFixPosSet(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motDROT_ATTR_FIX_POS_SET,(void*) (buf),(error))
#define ic0motDrotReadFixedPosition(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motDROT_ATTR_FIXED_POSITION,(buf),(error))
#define ic0motDrotWriteFixedPosition(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motDROT_ATTR_FIXED_POSITION,(void*) (buf),(error))
#define ic0motDrotReadFixedSimulation(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motDROT_ATTR_FIXED_SIMULATION,(buf),(error))
#define ic0motDrotWriteFixedSimulation(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motDROT_ATTR_FIXED_SIMULATION,(void*) (buf),(error))
#define ic0motDrotReadFixedLocked(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motDROT_ATTR_FIXED_LOCKED,(buf),(error))
#define ic0motDrotWriteFixedLocked(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motDROT_ATTR_FIXED_LOCKED,(void*) (buf),(error))
#define ic0motDrotReadPrefix(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motDROT_ATTR_PREFIX,(buf),(error))
#define ic0motDrotWritePrefix(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motDROT_ATTR_PREFIX,(void*) (buf),(error))
#define ic0motDrotReadParametersSize(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motDROT_ATTR_PARAMETERS_SIZE,(buf),(error))
#define ic0motDrotWriteParametersSize(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motDROT_ATTR_PARAMETERS_SIZE,(void*) (buf),(error))
#define ic0motDrotGetParametersSize(obj,num,error) \
	caiGetAttrInfo((obj)->attrs,ic0motDROT_ATTR_PARAMETERS,NULL,NULL,(num),NULL, NULL,NULL,(error))
#define ic0motDrotReadParameters(obj,buf,firstRec,lastRec,firstFld,lastFld,error) \
	lcctooCaiRWTable((obj)->attrs,0,ic0motDROT_ATTR_PARAMETERS,(buf),(firstRec),(lastRec),(firstFld),(lastFld),(error))
#define ic0motDrotWriteParameters(obj,buf,firstRec,lastRec,firstFld,lastFld,error) \
	lcctooCaiRWTable((obj)->attrs,1,ic0motDROT_ATTR_PARAMETERS,(void*) (buf),(firstRec),(lastRec),(firstFld),(lastFld),(error))
#define ic0motDrotGetStatusSize(obj,num,error) \
	caiGetAttrInfo((obj)->attrs,ic0motDROT_ATTR_STATUS,NULL,NULL,(num),NULL, NULL,NULL,(error))
#define ic0motDrotReadStatus(obj,buf,firstElt,lastElt,error) \
	caiRWVector((obj)->attrs,0,ic0motDROT_ATTR_STATUS,(buf),(firstElt),(lastElt),(error))
#define ic0motDrotWriteStatus(obj,buf,firstElt,lastElt,error) \
	caiRWVector((obj)->attrs,1,ic0motDROT_ATTR_STATUS,(void*) (buf),(firstElt),(lastElt),(error))
#define ic0motDrotGetStatusIndexSize(obj,num,error) \
	caiGetAttrInfo((obj)->attrs,ic0motDROT_ATTR_STATUS_INDEX,NULL,NULL,(num),NULL, NULL,NULL,(error))
#define ic0motDrotReadStatusIndex(obj,buf,firstElt,lastElt,error) \
	caiRWVector((obj)->attrs,0,ic0motDROT_ATTR_STATUS_INDEX,(buf),(firstElt),(lastElt),(error))
#define ic0motDrotWriteStatusIndex(obj,buf,firstElt,lastElt,error) \
	caiRWVector((obj)->attrs,1,ic0motDROT_ATTR_STATUS_INDEX,(void*) (buf),(firstElt),(lastElt),(error))
#define ic0motDrotReadValuesSize(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motDROT_ATTR_VALUES_SIZE,(buf),(error))
#define ic0motDrotWriteValuesSize(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motDROT_ATTR_VALUES_SIZE,(void*) (buf),(error))
#define ic0motDrotGetValuesSize(obj,num,error) \
	caiGetAttrInfo((obj)->attrs,ic0motDROT_ATTR_VALUES,NULL,NULL,(num),NULL, NULL,NULL,(error))
#define ic0motDrotReadValues(obj,buf,firstRec,lastRec,firstFld,lastFld,error) \
	lcctooCaiRWTable((obj)->attrs,0,ic0motDROT_ATTR_VALUES,(buf),(firstRec),(lastRec),(firstFld),(lastFld),(error))
#define ic0motDrotWriteValues(obj,buf,firstRec,lastRec,firstFld,lastFld,error) \
	lcctooCaiRWTable((obj)->attrs,1,ic0motDROT_ATTR_VALUES,(void*) (buf),(firstRec),(lastRec),(firstFld),(lastFld),(error))
#define ic0motDrotReadInitRestriction(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motDROT_ATTR_INIT_RESTRICTION,(buf),(error))
#define ic0motDrotWriteInitRestriction(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motDROT_ATTR_INIT_RESTRICTION,(void*) (buf),(error))
#define ic0motDrotReadMoveRestriction(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motDROT_ATTR_MOVE_RESTRICTION,(buf),(error))
#define ic0motDrotWriteMoveRestriction(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motDROT_ATTR_MOVE_RESTRICTION,(void*) (buf),(error))
#define ic0motDrotReadStopTimeout(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motDROT_ATTR_STOP_TIMEOUT,(buf),(error))
#define ic0motDrotWriteStopTimeout(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motDROT_ATTR_STOP_TIMEOUT,(void*) (buf),(error))
#define ic0motDrotReadSetValFct(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motDROT_ATTR_SET_VAL_FCT,(buf),(error))
#define ic0motDrotWriteSetValFct(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motDROT_ATTR_SET_VAL_FCT,(void*) (buf),(error))
#define ic0motDrotGetHelpTextSize(obj,num,error) \
	caiGetAttrInfo((obj)->attrs,ic0motDROT_ATTR_HELP_TEXT,NULL,NULL,(num),NULL, NULL,NULL,(error))
#define ic0motDrotReadHelpText(obj,buf,firstElt,lastElt,error) \
	caiRWVector((obj)->attrs,0,ic0motDROT_ATTR_HELP_TEXT,(buf),(firstElt),(lastElt),(error))
#define ic0motDrotWriteHelpText(obj,buf,firstElt,lastElt,error) \
	caiRWVector((obj)->attrs,1,ic0motDROT_ATTR_HELP_TEXT,(void*) (buf),(firstElt),(lastElt),(error))
#define ic0motDrotReadParamStep(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motDROT_ATTR_PARAM_STEP,(buf),(error))
#define ic0motDrotWriteParamStep(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motDROT_ATTR_PARAM_STEP,(void*) (buf),(error))
#define ic0motDrotReadActionCommand(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motDROT_ATTR_ACTION_COMMAND,(buf),(error))
#define ic0motDrotWriteActionCommand(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motDROT_ATTR_ACTION_COMMAND,(void*) (buf),(error))
#define ic0motDrotReadActionStopReq(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motDROT_ATTR_ACTION_STOP_REQ,(buf),(error))
#define ic0motDrotWriteActionStopReq(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motDROT_ATTR_ACTION_STOP_REQ,(void*) (buf),(error))
#define ic0motDrotReadActionNoMove(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motDROT_ATTR_ACTION_NO_MOVE,(buf),(error))
#define ic0motDrotWriteActionNoMove(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motDROT_ATTR_ACTION_NO_MOVE,(void*) (buf),(error))
#define ic0motDrotReadActionCheck(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motDROT_ATTR_ACTION_CHECK,(buf),(error))
#define ic0motDrotWriteActionCheck(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motDROT_ATTR_ACTION_CHECK,(void*) (buf),(error))
#define ic0motDrotReadResetSetupCmd(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motDROT_ATTR_RESET_SETUP_CMD,(buf),(error))
#define ic0motDrotWriteResetSetupCmd(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motDROT_ATTR_RESET_SETUP_CMD,(void*) (buf),(error))
#define ic0motDrotGetMotorsSize(obj,num,error) \
	caiGetAttrInfo((obj)->attrs,ic0motDROT_ATTR_MOTORS,NULL,NULL,(num),NULL, NULL,NULL,(error))
#define ic0motDrotReadMotors(obj,buf,firstRec,lastRec,firstFld,lastFld,error) \
	lcctooCaiRWTable((obj)->attrs,0,ic0motDROT_ATTR_MOTORS,(buf),(firstRec),(lastRec),(firstFld),(lastFld),(error))
#define ic0motDrotWriteMotors(obj,buf,firstRec,lastRec,firstFld,lastFld,error) \
	lcctooCaiRWTable((obj)->attrs,1,ic0motDROT_ATTR_MOTORS,(void*) (buf),(firstRec),(lastRec),(firstFld),(lastFld),(error))
#define ic0motDrotReadPositionsSize(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motDROT_ATTR_POSITIONS_SIZE,(buf),(error))
#define ic0motDrotWritePositionsSize(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motDROT_ATTR_POSITIONS_SIZE,(void*) (buf),(error))
#define ic0motDrotGetPositionsSize(obj,num,error) \
	caiGetAttrInfo((obj)->attrs,ic0motDROT_ATTR_POSITIONS,NULL,NULL,(num),NULL, NULL,NULL,(error))
#define ic0motDrotReadPositions(obj,buf,firstRec,lastRec,firstFld,lastFld,error) \
	lcctooCaiRWTable((obj)->attrs,0,ic0motDROT_ATTR_POSITIONS,(buf),(firstRec),(lastRec),(firstFld),(lastFld),(error))
#define ic0motDrotWritePositions(obj,buf,firstRec,lastRec,firstFld,lastFld,error) \
	lcctooCaiRWTable((obj)->attrs,1,ic0motDROT_ATTR_POSITIONS,(void*) (buf),(firstRec),(lastRec),(firstFld),(lastFld),(error))
#define ic0motDrotGetActionsSize(obj,num,error) \
	caiGetAttrInfo((obj)->attrs,ic0motDROT_ATTR_ACTIONS,NULL,NULL,(num),NULL, NULL,NULL,(error))
#define ic0motDrotReadActions(obj,buf,firstRec,lastRec,firstFld,lastFld,error) \
	lcctooCaiRWTable((obj)->attrs,0,ic0motDROT_ATTR_ACTIONS,(buf),(firstRec),(lastRec),(firstFld),(lastFld),(error))
#define ic0motDrotWriteActions(obj,buf,firstRec,lastRec,firstFld,lastFld,error) \
	lcctooCaiRWTable((obj)->attrs,1,ic0motDROT_ATTR_ACTIONS,(void*) (buf),(firstRec),(lastRec),(firstFld),(lastFld),(error))
#define ic0motDrotGetUsrActionsSize(obj,num,error) \
	caiGetAttrInfo((obj)->attrs,ic0motDROT_ATTR_USR_ACTIONS,NULL,NULL,(num),NULL, NULL,NULL,(error))
#define ic0motDrotReadUsrActions(obj,buf,firstRec,lastRec,firstFld,lastFld,error) \
	lcctooCaiRWTable((obj)->attrs,0,ic0motDROT_ATTR_USR_ACTIONS,(buf),(firstRec),(lastRec),(firstFld),(lastFld),(error))
#define ic0motDrotWriteUsrActions(obj,buf,firstRec,lastRec,firstFld,lastFld,error) \
	lcctooCaiRWTable((obj)->attrs,1,ic0motDROT_ATTR_USR_ACTIONS,(void*) (buf),(firstRec),(lastRec),(firstFld),(lastFld),(error))
#define ic0motDrotReadUserUnitFct(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motDROT_ATTR_USER_UNIT_FCT,(buf),(error))
#define ic0motDrotWriteUserUnitFct(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motDROT_ATTR_USER_UNIT_FCT,(void*) (buf),(error))
#define ic0motDrotReadUserUnitFct2(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motDROT_ATTR_USER_UNIT_FCT2,(buf),(error))
#define ic0motDrotWriteUserUnitFct2(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motDROT_ATTR_USER_UNIT_FCT2,(void*) (buf),(error))
#define ic0motDrotGetUserUnitArgsSize(obj,num,error) \
	caiGetAttrInfo((obj)->attrs,ic0motDROT_ATTR_USER_UNIT_ARGS,NULL,NULL,(num),NULL, NULL,NULL,(error))
#define ic0motDrotReadUserUnitArgs(obj,buf,firstElt,lastElt,error) \
	caiRWVector((obj)->attrs,0,ic0motDROT_ATTR_USER_UNIT_ARGS,(buf),(firstElt),(lastElt),(error))
#define ic0motDrotWriteUserUnitArgs(obj,buf,firstElt,lastElt,error) \
	caiRWVector((obj)->attrs,1,ic0motDROT_ATTR_USER_UNIT_ARGS,(void*) (buf),(firstElt),(lastElt),(error))
#define ic0motDrotReadInitTimeout(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motDROT_ATTR_INIT_TIMEOUT,(buf),(error))
#define ic0motDrotWriteInitTimeout(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motDROT_ATTR_INIT_TIMEOUT,(void*) (buf),(error))
#define ic0motDrotReadMoveTimeout(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motDROT_ATTR_MOVE_TIMEOUT,(buf),(error))
#define ic0motDrotWriteMoveTimeout(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motDROT_ATTR_MOVE_TIMEOUT,(void*) (buf),(error))
#define ic0motDrotReadDisconnect(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motDROT_ATTR_DISCONNECT,(buf),(error))
#define ic0motDrotWriteDisconnect(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motDROT_ATTR_DISCONNECT,(void*) (buf),(error))
#define ic0motDrotReadUseCfgElem(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motDROT_ATTR_USE_CFG_ELEM,(buf),(error))
#define ic0motDrotWriteUseCfgElem(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motDROT_ATTR_USE_CFG_ELEM,(void*) (buf),(error))
#define ic0motDrotReadParkAction(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motDROT_ATTR_PARK_ACTION,(buf),(error))
#define ic0motDrotWriteParkAction(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motDROT_ATTR_PARK_ACTION,(void*) (buf),(error))
#define ic0motDrotReadTestAction(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motDROT_ATTR_TEST_ACTION,(buf),(error))
#define ic0motDrotWriteTestAction(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motDROT_ATTR_TEST_ACTION,(void*) (buf),(error))
#define ic0motDrotReadTest(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motDROT_ATTR_TEST,(buf),(error))
#define ic0motDrotWriteTest(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motDROT_ATTR_TEST,(void*) (buf),(error))
#define ic0motDrotReadInstalled(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motDROT_ATTR_INSTALLED,(buf),(error))
#define ic0motDrotWriteInstalled(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motDROT_ATTR_INSTALLED,(void*) (buf),(error))
#define ic0motDrotReadAttached(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motDROT_ATTR_ATTACHED,(buf),(error))
#define ic0motDrotWriteAttached(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motDROT_ATTR_ATTACHED,(void*) (buf),(error))
#define ic0motDrotReadParked(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motDROT_ATTR_PARKED,(buf),(error))
#define ic0motDrotWriteParked(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motDROT_ATTR_PARKED,(void*) (buf),(error))
#define ic0motDrotReadActionStep(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motDROT_ATTR_ACTION_STEP,(buf),(error))
#define ic0motDrotWriteActionStep(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motDROT_ATTR_ACTION_STEP,(void*) (buf),(error))
#define ic0motDrotReadActionRetry(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motDROT_ATTR_ACTION_RETRY,(buf),(error))
#define ic0motDrotWriteActionRetry(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motDROT_ATTR_ACTION_RETRY,(void*) (buf),(error))
#define ic0motDrotReadActionMoveValid(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motDROT_ATTR_ACTION_MOVE_VALID,(buf),(error))
#define ic0motDrotWriteActionMoveValid(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motDROT_ATTR_ACTION_MOVE_VALID,(void*) (buf),(error))
#define ic0motDrotGetActionMoveSize(obj,num,error) \
	caiGetAttrInfo((obj)->attrs,ic0motDROT_ATTR_ACTION_MOVE,NULL,NULL,(num),NULL, NULL,NULL,(error))
#define ic0motDrotReadActionMove(obj,buf,firstRec,lastRec,firstFld,lastFld,error) \
	lcctooCaiRWTable((obj)->attrs,0,ic0motDROT_ATTR_ACTION_MOVE,(buf),(firstRec),(lastRec),(firstFld),(lastFld),(error))
#define ic0motDrotWriteActionMove(obj,buf,firstRec,lastRec,firstFld,lastFld,error) \
	lcctooCaiRWTable((obj)->attrs,1,ic0motDROT_ATTR_ACTION_MOVE,(void*) (buf),(firstRec),(lastRec),(firstFld),(lastFld),(error))
#define ic0motDrotReadParsePosIndex(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motDROT_ATTR_PARSE_POS_INDEX,(buf),(error))
#define ic0motDrotWriteParsePosIndex(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motDROT_ATTR_PARSE_POS_INDEX,(void*) (buf),(error))
#define ic0motDrotReadFirstPosIndex(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motDROT_ATTR_FIRST_POS_INDEX,(buf),(error))
#define ic0motDrotWriteFirstPosIndex(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motDROT_ATTR_FIRST_POS_INDEX,(void*) (buf),(error))
#define ic0motDrotReadMoveMode(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motDROT_ATTR_MOVE_MODE,(buf),(error))
#define ic0motDrotWriteMoveMode(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motDROT_ATTR_MOVE_MODE,(void*) (buf),(error))
#define ic0motDrotReadMode(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motDROT_ATTR_MODE,(buf),(error))
#define ic0motDrotWriteMode(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motDROT_ATTR_MODE,(void*) (buf),(error))
#define ic0motDrotReadRa(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motDROT_ATTR_RA,(buf),(error))
#define ic0motDrotWriteRa(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motDROT_ATTR_RA,(void*) (buf),(error))
#define ic0motDrotReadDec(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motDROT_ATTR_DEC,(buf),(error))
#define ic0motDrotWriteDec(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motDROT_ATTR_DEC,(void*) (buf),(error))
#define ic0motDrotReadStartPosang(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motDROT_ATTR_START_POSANG,(buf),(error))
#define ic0motDrotWriteStartPosang(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motDROT_ATTR_START_POSANG,(void*) (buf),(error))
#define ic0motDrotReadPosang(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motDROT_ATTR_POSANG,(buf),(error))
#define ic0motDrotWritePosang(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motDROT_ATTR_POSANG,(void*) (buf),(error))
#define ic0motDrotReadStatindx(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motDROT_ATTR_STATINDX,(buf),(error))
#define ic0motDrotWriteStatindx(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motDROT_ATTR_STATINDX,(void*) (buf),(error))
#define ic0motDrotReadLatitude(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motDROT_ATTR_LATITUDE,(buf),(error))
#define ic0motDrotWriteLatitude(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motDROT_ATTR_LATITUDE,(void*) (buf),(error))
#define ic0motDrotReadLongitude(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0motDROT_ATTR_LONGITUDE,(buf),(error))
#define ic0motDrotWriteLongitude(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0motDROT_ATTR_LONGITUDE,(void*) (buf),(error))
#define ic0motDrotGetAuto(obj,attrPtr,error) \
	SUCCESS; \
	memcpy((attrPtr), &(obj)->objs[ic0motDROT_AUTOMATA], sizeof(egenOBJ)); \
	(attrPtr)->ldata = (obj)->ldata;


/*
 * class functions
 */
#define ic0motDrotCheck(obj,devName,status,error) \
	ic0devMotCheck((obj),(devName),(status),(error))
#define ic0motDrotWait(obj,devName,timeout,error) \
	ic0devMotWait((obj),(devName),(timeout),(error))
#define ic0motDrotCfgElem(obj,devName,position,id,values,valuesNum,error) \
	ic0devMotCfgElem((obj),(devName),(position),(id),(values),(valuesNum),(error))
#define ic0motDrotLogConf(obj,devName,allElements,error) \
	ic0devMotLogConf((obj),(devName),(allElements),(error))
#define ic0motDrotGetConf(obj,devName,allElements,text,error) \
	ic0devMotGetConf((obj),(devName),(allElements),(text),(error))
#define ic0motDrotVarSet(obj,error) \
	ic0devMotVarSet((obj),(error))
#define ic0motDrotVarWait(obj,error) \
	ic0devMotVarWait((obj),(error))
#define ic0motDrotUsrInit(obj,devName,error) \
	ic0devMotUsrInit((obj),(devName),(error))
#define ic0motDrotUsrLoaded2Standby(obj,devName,error) \
	ic0devMotUsrLoaded2Standby((obj),(devName),(error))
#define ic0motDrotUsrStandby2Loaded(obj,devName,error) \
	ic0devMotUsrStandby2Loaded((obj),(devName),(error))
#define ic0motDrotUsrSetMode(obj,devName,cmd,available,enabled,simulation,handset,locked,error) \
	ic0devMotUsrSetMode((obj),(devName),(cmd),(available),(enabled),(simulation),(handset),(locked),(error))
#define ic0motDrotUsrSelfTest(obj,devName,error) \
	ic0devMotUsrSelfTest((obj),(devName),(error))
#define ic0motDrotUsrTest(obj,devName,error) \
	ic0devMotUsrTest((obj),(devName),(error))
#define ic0motDrotUsrExecAction(obj,devName,index,error) \
	ic0devMotUsrExecAction((obj),(devName),(index),(error))
#define ic0motDrotUsrSetParameter(obj,devName,cmd,param1,param1SetCode,param2,param2SetCode,value,error) \
	ic0devMotUsrSetParameter((obj),(devName),(cmd),(param1),(param1SetCode),(param2),(param2SetCode),(value),(error))
#define ic0motDrotUsrGetValue(obj,devName,valuesTable,valuesTableNum,code,index,value,valueNum,done,error) \
	ic0devMotUsrGetValue((obj),(devName),(valuesTable),(valuesTableNum),(code),(index),(value),(valueNum),(done),(error))
#define ic0motDrotUsrSetValue(obj,devName,valuesTable,valuesTableNum,code,index,value,valueNum,done,error) \
	ic0devMotUsrSetValue((obj),(devName),(valuesTable),(valuesTableNum),(code),(index),(value),(valueNum),(done),(error))
#define ic0motDrotGetArg(obj,devName,code,index,value,error) \
	ic0devMotGetArg((obj),(devName),(code),(index),(value),(error))
#define ic0motDrotGetHandles(obj,devName,motors,error) \
	ic0devMotGetHandles((obj),(devName),(motors),(error))
#define ic0motDrotPark(obj,devName,error) \
	ic0devMotPark((obj),(devName),(error))
#define ic0motDrotGetAction(obj,devName,actionStep,action,error) \
	ic0devMotGetAction((obj),(devName),(actionStep),(action),(error))
#define ic0motDrotActionGetHandles(obj,devName,index,motors,error) \
	ic0devMotActionGetHandles((obj),(devName),(index),(motors),(error))
#define ic0motDrotActionNewMove(obj,devName,action,end,error) \
	ic0devMotActionNewMove((obj),(devName),(action),(end),(error))
#define ic0motDrotActionIf(obj,devName,action,end,error) \
	ic0devMotActionIf((obj),(devName),(action),(end),(error))
#define ic0motDrotActionParam(obj,devName,action,end,error) \
	ic0devMotActionParam((obj),(devName),(action),(end),(error))
#define ic0motDrotActionAddParam(obj,devName,action,end,error) \
	ic0devMotActionAddParam((obj),(devName),(action),(end),(error))
#define ic0motDrotActionValue(obj,devName,action,end,error) \
	ic0devMotActionValue((obj),(devName),(action),(end),(error))
#define ic0motDrotActionAddValue(obj,devName,action,end,error) \
	ic0devMotActionAddValue((obj),(devName),(action),(end),(error))
#define ic0motDrotActionMove(obj,devName,action,end,error) \
	ic0devMotActionMove((obj),(devName),(action),(end),(error))
#define ic0motDrotActionSpeedMove(obj,devName,action,end,error) \
	ic0devMotActionSpeedMove((obj),(devName),(action),(end),(error))
#define ic0motDrotActionWaitMove(obj,devName,action,end,error) \
	ic0devMotActionWaitMove((obj),(devName),(action),(end),(error))
#define ic0motDrotActionClampBrake(obj,devName,action,end,error) \
	ic0devMotActionClampBrake((obj),(devName),(action),(end),(error))
#define ic0motDrotActionDisconnect(obj,devName,action,end,error) \
	ic0devMotActionDisconnect((obj),(devName),(action),(end),(error))
#define ic0motDrotActionStop(obj,devName,action,end,error) \
	ic0devMotActionStop((obj),(devName),(action),(end),(error))
#define ic0motDrotActionUserFunction(obj,devName,action,end,error) \
	ic0devMotActionUserFunction((obj),(devName),(action),(end),(error))
#define ic0motDrotActionRetry(obj,devName,action,end,error) \
	ic0devMotActionRetry((obj),(devName),(action),(end),(error))
#define ic0motDrotActionEnd(obj,devName,action,end,error) \
	ic0devMotActionEnd((obj),(devName),(action),(end),(error))
#define ic0motDrotActionError(obj,devName,action,end,error) \
	ic0devMotActionError((obj),(devName),(action),(end),(error))
#define ic0motDrotActionSleep(obj,devName,action,end,error) \
	ic0devMotActionSleep((obj),(devName),(action),(end),(error))
#define ic0motDrotActionIncrValue(obj,devName,action,end,error) \
	ic0devMotActionIncrValue((obj),(devName),(action),(end),(error))
#define ic0motDrotSetParListAddress(obj,devName,motor,error) \
	ic0devMotSetParListAddress((obj),(devName),(motor),(error))
#define ic0motDrotWlen2Enc(obj,from,to,parList,error) \
	ic0devMotWlen2Enc((obj),(from),(to),(parList),(error))
#define ic0motDrotTemp2Focus(obj,from,to,parList,error) \
	ic0devMotTemp2Focus((obj),(from),(to),(parList),(error))
#define ic0motDrotSlit2Enc1(obj,from,to,parList,error) \
	ic0devMotSlit2Enc1((obj),(from),(to),(parList),(error))
#define ic0motDrotSlit2Enc2(obj,from,to,parList,error) \
	ic0devMotSlit2Enc2((obj),(from),(to),(parList),(error))
#define ic0motDrotSlit2Enc(obj,motorIndex,from,to,error) \
	ic0devMotSlit2Enc((obj),(motorIndex),(from),(to),(error))
#define ic0motDrotWlenTeta2Enc(obj,from,to,parList,error) \
	ic0devMotWlenTeta2Enc((obj),(from),(to),(parList),(error))
#define ic0motDrotTilt2Enc(obj,from,to,parList,error) \
	ic0devMotTilt2Enc((obj),(from),(to),(parList),(error))
#define ic0motDrotSetup(obj,devName,function,functionNum,noMove,check,error) \
	ic0devSoftSetup((obj),(devName),(function),(functionNum),(noMove),(check),(error))
#define ic0motDrotGetVal(obj,devName,name,nameNum,status,error) \
	ic0devSoftGetVal((obj),(devName),(name),(nameNum),(status),(error))
#define ic0motDrotSetVal(obj,devName,name,nameNum,value,valueNum,error) \
	ic0devSoftSetVal((obj),(devName),(name),(nameNum),(value),(valueNum),(error))
#define ic0motDrotStatus(obj,devName,function,functionNum,flag,header,conflog,opslog,condlog,status,error) \
	ic0devSoftStatus((obj),(devName),(function),(functionNum),(flag),(header),(conflog),(opslog),(condlog),(status),(error))
#define ic0motDrotMove(obj,devName,position,positionNum,error) \
	ic0devSoftMove((obj),(devName),(position),(positionNum),(error))
#define ic0motDrotMoveRel(obj,devName,position,positionNum,error) \
	ic0devSoftMoveRel((obj),(devName),(position),(positionNum),(error))
#define ic0motDrotSet(obj,devName,position,positionNum,error) \
	ic0devSoftSet((obj),(devName),(position),(positionNum),(error))
#define ic0motDrotResetParameters(obj,devName,cmd,error) \
	ic0devSoftResetParameters((obj),(devName),(cmd),(error))
#define ic0motDrotParseParameters(obj,devName,cmd,params,paramsNum,noMove,check,error) \
	ic0devSoftParseParameters((obj),(devName),(cmd),(params),(paramsNum),(noMove),(check),(error))
#define ic0motDrotCompareParameters(obj,devName,cmd,equal,error) \
	ic0devSoftCompareParameters((obj),(devName),(cmd),(equal),(error))
#define ic0motDrotCopyParameters(obj,devName,error) \
	ic0devSoftCopyParameters((obj),(devName),(error))
#define ic0motDrotExecParameters(obj,devName,error) \
	ic0devSoftExecParameters((obj),(devName),(error))
#define ic0motDrotUpdateParameters(obj,devName,cache,error) \
	ic0devSoftUpdateParameters((obj),(devName),(cache),(error))
#define ic0motDrotGetParamSetValue(obj,devName,index,value,setCode,error) \
	ic0devSoftGetParamSetValue((obj),(devName),(index),(value),(setCode),(error))
#define ic0motDrotGetParamStatus(obj,devName,index,flags,status,error) \
	ic0devSoftGetParamStatus((obj),(devName),(index),(flags),(status),(error))
#define ic0motDrotSetParam(obj,devName,index,cmd,value,step,error) \
	ic0devSoftSetParam((obj),(devName),(index),(cmd),(value),(step),(error))
#define ic0motDrotSetParamStep(obj,devName,index,cmd,step,error) \
	ic0devSoftSetParamStep((obj),(devName),(index),(cmd),(step),(error))
#define ic0motDrotGetValueCode(obj,devName,name,code,error) \
	ic0devSoftGetValueCode((obj),(devName),(name),(code),(error))
#define ic0motDrotGetValue(obj,devName,code,index,value,valueNum,error) \
	ic0devSoftGetValue((obj),(devName),(code),(index),(value),(valueNum),(error))
#define ic0motDrotSetValue(obj,devName,code,index,value,valueNum,error) \
	ic0devSoftSetValue((obj),(devName),(code),(index),(value),(valueNum),(error))
#define ic0motDrotMonitor(obj,devName,error) \
	ic0devSoftMonitor((obj),(devName),(error))
#define ic0motDrotUsrMonitor(obj,devName,state,error) \
	ic0devSoftUsrMonitor((obj),(devName),(state),(error))
#define ic0motDrotLogAction(obj,devName,action,comment,error) \
	ic0devSoftLogAction((obj),(devName),(action),(comment),(error))
#define ic0motDrotLogComment(obj,devName,comment,error) \
	ic0devSoftLogComment((obj),(devName),(comment),(error))
#define ic0motDrotLogParameter(obj,devName,parameter,index,value,comment,error) \
	ic0devSoftLogParameter((obj),(devName),(parameter),(index),(value),(comment),(error))
#define ic0motDrotLogRecovery(obj,devName,comment,error) \
	ic0devSoftLogRecovery((obj),(devName),(comment),(error))
#define ic0motDrotLogTblParam(obj,devName,paramIndex,flags,comment,error) \
	ic0devSoftLogTblParam((obj),(devName),(paramIndex),(flags),(comment),(error))
#define ic0motDrotLogUnforseen(obj,devName,comment,error) \
	ic0devSoftLogUnforseen((obj),(devName),(comment),(error))
#define ic0motDrotAvail(obj,devName,error) \
	lccdevCmdAvail((obj),(devName),(error))
#define ic0motDrotUnavail(obj,devName,error) \
	lccdevCmdUnavail((obj),(devName),(error))
#define ic0motDrotDisable(obj,devName,access,error) \
	lccdevCmdDisable((obj),(devName),(access),(error))
#define ic0motDrotEnable(obj,devName,access,error) \
	lccdevCmdEnable((obj),(devName),(access),(error))
#define ic0motDrotLock(obj,devName,error) \
	lccdevCmdLock((obj),(devName),(error))
#define ic0motDrotUnlock(obj,devName,error) \
	lccdevCmdUnlock((obj),(devName),(error))
#define ic0motDrotHandset(obj,devName,error) \
	lccdevCmdHandset((obj),(devName),(error))
#define ic0motDrotHsetOff(obj,devName,error) \
	lccdevCmdHsetOff((obj),(devName),(error))
#define ic0motDrotFixPos(obj,devName,position,positionNum,reset,error) \
	lccdevCmdFixPos((obj),(devName),(position),(positionNum),(reset),(error))
#define ic0motDrotUsrSimulat(obj,devName,error) \
	lccdevCmdUsrSimulat((obj),(devName),(error))
#define ic0motDrotUsrStopSim(obj,devName,error) \
	lccdevCmdUsrStopSim((obj),(devName),(error))
#define ic0motDrotStandby(obj,devName,error) \
	lccdevStdStandby((obj),(devName),(error))
#define ic0motDrotOnline(obj,devName,error) \
	lccdevStdOnline((obj),(devName),(error))
#define ic0motDrotOff(obj,devName,error) \
	lccdevStdOff((obj),(devName),(error))
#define ic0motDrotExit(obj,devName,error) \
	lccdevStdExit((obj),(devName),(error))
#define ic0motDrotState(obj,devName,state,error) \
	lccdevStdState((obj),(devName),(state),(error))
#define ic0motDrotSimulat(obj,devName,error) \
	lccdevStdSimulat((obj),(devName),(error))
#define ic0motDrotStopSim(obj,devName,error) \
	lccdevStdStopSim((obj),(devName),(error))
#define ic0motDrotInit(obj,devName,error) \
	lccdevStdInit((obj),(devName),(error))
#define ic0motDrotStop(obj,devName,error) \
	lccdevStdStop((obj),(devName),(error))
#define ic0motDrotTest(obj,devName,error) \
	lccdevStdTest((obj),(devName),(error))
#define ic0motDrotSelftst(obj,devName,error) \
	lccdevStdSelftst((obj),(devName),(error))
#define ic0motDrotAutoTbl(obj,devName,table,text,error) \
	lccdevStdAutoTbl((obj),(devName),(table),(text),(error))
#define ic0motDrotAutoRst(obj,devName,error) \
	lccdevStdAutoRst((obj),(devName),(error))
#define ic0motDrotLoaded2Stby(obj,devName,error) \
	lccdevStdLoaded2Stby((obj),(devName),(error))
#define ic0motDrotOnline2Stby(obj,devName,error) \
	lccdevStdOnline2Stby((obj),(devName),(error))
#define ic0motDrotExit1(obj,devName,error) \
	lccdevStdExit1((obj),(devName),(error))
#define ic0motDrotCheckDeviceName(obj,devName,error) \
	lccdevStdCheckDeviceName((obj),(devName),(error))
#define ic0motDrotBreak(obj,error) \
	lccdevStdBreak((obj),(error))
#define ic0motDrotUsrError(obj,devName,error) \
	lccdevStdUsrError((obj),(devName),(error))

ccsCOMPL_STAT ic0motDrotInitObj(
    INOUT egenOBJ*	obj,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0motDrotExitObj(
    INOUT egenOBJ*	obj,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0motDrotUsrStandby2Online(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0motDrotUsrOnline2Standby(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0motDrotExecAction(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    ic0devMOT_ACTION*	action,
    OUT   vltLOGICAL*	end,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0motDrotUsrStop(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltLOGICAL	req,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0motDrotActionTracking(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    ic0devMOT_ACTION*	action,
    OUT   vltLOGICAL*	end,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0motDrotUsrStatusCode(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    const char*	text,
    IN    vltINT32	flags,
    OUT   vltINT32*	code,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0motDrotUsrStatusValue(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltINT32	code,
    OUT   lcctooVALUE*	value,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0motDrotUsrStatusLast(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   vltINT16*	last,
    OUT   ccsERROR*	error);


/*
 * virtual functions
 */
#define ic0motDrotVStandby(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_STANDBY)((obj)->fcts[ic0motDROT_FCT_STANDBY]))) \
	 ((obj),(devName),(error))
#define ic0motDrotVOnline(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_ONLINE)((obj)->fcts[ic0motDROT_FCT_ONLINE]))) \
	 ((obj),(devName),(error))
#define ic0motDrotVOff(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_OFF)((obj)->fcts[ic0motDROT_FCT_OFF]))) \
	 ((obj),(devName),(error))
#define ic0motDrotVExit(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_EXIT)((obj)->fcts[ic0motDROT_FCT_EXIT]))) \
	 ((obj),(devName),(error))
#define ic0motDrotVState(obj,devName,state,error) \
	(*((lccdevSTD_FCTPTR_STATE)((obj)->fcts[ic0motDROT_FCT_STATE]))) \
	 ((obj),(devName),(state),(error))
#define ic0motDrotVSimulat(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_SIMULAT)((obj)->fcts[ic0motDROT_FCT_SIMULAT]))) \
	 ((obj),(devName),(error))
#define ic0motDrotVStopSim(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_STOP_SIM)((obj)->fcts[ic0motDROT_FCT_STOP_SIM]))) \
	 ((obj),(devName),(error))
#define ic0motDrotVStatus(obj,devName,function,functionNum,flag,header,conflog,opslog,condlog,status,error) \
	(*((ic0devSOFT_FCTPTR_STATUS)((obj)->fcts[ic0motDROT_FCT_STATUS]))) \
	 ((obj),(devName),(function),(functionNum),(flag),(header),(conflog),(opslog),(condlog),(status),(error))
#define ic0motDrotVInit(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_INIT)((obj)->fcts[ic0motDROT_FCT_INIT]))) \
	 ((obj),(devName),(error))
#define ic0motDrotVStop(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_STOP)((obj)->fcts[ic0motDROT_FCT_STOP]))) \
	 ((obj),(devName),(error))
#define ic0motDrotVTest(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_TEST)((obj)->fcts[ic0motDROT_FCT_TEST]))) \
	 ((obj),(devName),(error))
#define ic0motDrotVSelftst(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_SELFTST)((obj)->fcts[ic0motDROT_FCT_SELFTST]))) \
	 ((obj),(devName),(error))
#define ic0motDrotVAutoTbl(obj,devName,table,text,error) \
	(*((lccdevSTD_FCTPTR_AUTO_TBL)((obj)->fcts[ic0motDROT_FCT_AUTO_TBL]))) \
	 ((obj),(devName),(table),(text),(error))
#define ic0motDrotVAutoRst(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_AUTO_RST)((obj)->fcts[ic0motDROT_FCT_AUTO_RST]))) \
	 ((obj),(devName),(error))
#define ic0motDrotVInitObj(obj,error) \
	(*((ic0motDROT_FCTPTR_INIT_OBJ)((obj)->fcts[ic0motDROT_FCT_INIT_OBJ]))) \
	 ((obj),(error))
#define ic0motDrotVExitObj(obj,error) \
	(*((ic0motDROT_FCTPTR_EXIT_OBJ)((obj)->fcts[ic0motDROT_FCT_EXIT_OBJ]))) \
	 ((obj),(error))
#define ic0motDrotVLoaded2Stby(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_LOADED2STBY)((obj)->fcts[ic0motDROT_FCT_LOADED2STBY]))) \
	 ((obj),(devName),(error))
#define ic0motDrotVOnline2Stby(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_ONLINE2STBY)((obj)->fcts[ic0motDROT_FCT_ONLINE2STBY]))) \
	 ((obj),(devName),(error))
#define ic0motDrotVExit1(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_EXIT1)((obj)->fcts[ic0motDROT_FCT_EXIT1]))) \
	 ((obj),(devName),(error))
#define ic0motDrotVCheckDeviceName(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_CHECK_DEVICE_NAME)((obj)->fcts[ic0motDROT_FCT_CHECK_DEVICE_NAME]))) \
	 ((obj),(devName),(error))
#define ic0motDrotVBreak(obj,error) \
	(*((lccdevSTD_FCTPTR_BREAK)((obj)->fcts[ic0motDROT_FCT_BREAK]))) \
	 ((obj),(error))
#define ic0motDrotVUsrInit(obj,devName,error) \
	(*((ic0devMOT_FCTPTR_USR_INIT)((obj)->fcts[ic0motDROT_FCT_USR_INIT]))) \
	 ((obj),(devName),(error))
#define ic0motDrotVUsrLoaded2Standby(obj,devName,error) \
	(*((ic0devMOT_FCTPTR_USR_LOADED2STANDBY)((obj)->fcts[ic0motDROT_FCT_USR_LOADED2STANDBY]))) \
	 ((obj),(devName),(error))
#define ic0motDrotVUsrStandby2Online(obj,devName,error) \
	(*((ic0motDROT_FCTPTR_USR_STANDBY2ONLINE)((obj)->fcts[ic0motDROT_FCT_USR_STANDBY2ONLINE]))) \
	 ((obj),(devName),(error))
#define ic0motDrotVUsrOnline2Standby(obj,devName,error) \
	(*((ic0motDROT_FCTPTR_USR_ONLINE2STANDBY)((obj)->fcts[ic0motDROT_FCT_USR_ONLINE2STANDBY]))) \
	 ((obj),(devName),(error))
#define ic0motDrotVUsrStandby2Loaded(obj,devName,error) \
	(*((ic0devMOT_FCTPTR_USR_STANDBY2LOADED)((obj)->fcts[ic0motDROT_FCT_USR_STANDBY2LOADED]))) \
	 ((obj),(devName),(error))
#define ic0motDrotVUsrStop(obj,devName,req,error) \
	(*((ic0motDROT_FCTPTR_USR_STOP)((obj)->fcts[ic0motDROT_FCT_USR_STOP]))) \
	 ((obj),(devName),(req),(error))
#define ic0motDrotVUsrSimulat(obj,devName,error) \
	(*((lccdevCMD_FCTPTR_USR_SIMULAT)((obj)->fcts[ic0motDROT_FCT_USR_SIMULAT]))) \
	 ((obj),(devName),(error))
#define ic0motDrotVUsrStopSim(obj,devName,error) \
	(*((lccdevCMD_FCTPTR_USR_STOP_SIM)((obj)->fcts[ic0motDROT_FCT_USR_STOP_SIM]))) \
	 ((obj),(devName),(error))
#define ic0motDrotVUsrStatusCode(obj,devName,text,flags,code,error) \
	(*((ic0motDROT_FCTPTR_USR_STATUS_CODE)((obj)->fcts[ic0motDROT_FCT_USR_STATUS_CODE]))) \
	 ((obj),(devName),(text),(flags),(code),(error))
#define ic0motDrotVUsrStatusLast(obj,devName,last,error) \
	(*((ic0motDROT_FCTPTR_USR_STATUS_LAST)((obj)->fcts[ic0motDROT_FCT_USR_STATUS_LAST]))) \
	 ((obj),(devName),(last),(error))
#define ic0motDrotVUsrStatusValue(obj,devName,code,value,error) \
	(*((ic0motDROT_FCTPTR_USR_STATUS_VALUE)((obj)->fcts[ic0motDROT_FCT_USR_STATUS_VALUE]))) \
	 ((obj),(devName),(code),(value),(error))
#define ic0motDrotVUsrTest(obj,devName,error) \
	(*((ic0devMOT_FCTPTR_USR_TEST)((obj)->fcts[ic0motDROT_FCT_USR_TEST]))) \
	 ((obj),(devName),(error))
#define ic0motDrotVUsrSelfTest(obj,devName,error) \
	(*((ic0devMOT_FCTPTR_USR_SELF_TEST)((obj)->fcts[ic0motDROT_FCT_USR_SELF_TEST]))) \
	 ((obj),(devName),(error))
#define ic0motDrotVUsrError(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_USR_ERROR)((obj)->fcts[ic0motDROT_FCT_USR_ERROR]))) \
	 ((obj),(devName),(error))
#define ic0motDrotVAvail(obj,devName,error) \
	(*((lccdevCMD_FCTPTR_AVAIL)((obj)->fcts[ic0motDROT_FCT_AVAIL]))) \
	 ((obj),(devName),(error))
#define ic0motDrotVUnavail(obj,devName,error) \
	(*((lccdevCMD_FCTPTR_UNAVAIL)((obj)->fcts[ic0motDROT_FCT_UNAVAIL]))) \
	 ((obj),(devName),(error))
#define ic0motDrotVDisable(obj,devName,access,error) \
	(*((lccdevCMD_FCTPTR_DISABLE)((obj)->fcts[ic0motDROT_FCT_DISABLE]))) \
	 ((obj),(devName),(access),(error))
#define ic0motDrotVEnable(obj,devName,access,error) \
	(*((lccdevCMD_FCTPTR_ENABLE)((obj)->fcts[ic0motDROT_FCT_ENABLE]))) \
	 ((obj),(devName),(access),(error))
#define ic0motDrotVLock(obj,devName,error) \
	(*((lccdevCMD_FCTPTR_LOCK)((obj)->fcts[ic0motDROT_FCT_LOCK]))) \
	 ((obj),(devName),(error))
#define ic0motDrotVUnlock(obj,devName,error) \
	(*((lccdevCMD_FCTPTR_UNLOCK)((obj)->fcts[ic0motDROT_FCT_UNLOCK]))) \
	 ((obj),(devName),(error))
#define ic0motDrotVHandset(obj,devName,error) \
	(*((lccdevCMD_FCTPTR_HANDSET)((obj)->fcts[ic0motDROT_FCT_HANDSET]))) \
	 ((obj),(devName),(error))
#define ic0motDrotVHsetOff(obj,devName,error) \
	(*((lccdevCMD_FCTPTR_HSET_OFF)((obj)->fcts[ic0motDROT_FCT_HSET_OFF]))) \
	 ((obj),(devName),(error))
#define ic0motDrotVFixPos(obj,devName,position,positionNum,reset,error) \
	(*((lccdevCMD_FCTPTR_FIX_POS)((obj)->fcts[ic0motDROT_FCT_FIX_POS]))) \
	 ((obj),(devName),(position),(positionNum),(reset),(error))
#define ic0motDrotVMove(obj,devName,position,positionNum,error) \
	(*((ic0devSOFT_FCTPTR_MOVE)((obj)->fcts[ic0motDROT_FCT_MOVE]))) \
	 ((obj),(devName),(position),(positionNum),(error))
#define ic0motDrotVMoveRel(obj,devName,position,positionNum,error) \
	(*((ic0devSOFT_FCTPTR_MOVE_REL)((obj)->fcts[ic0motDROT_FCT_MOVE_REL]))) \
	 ((obj),(devName),(position),(positionNum),(error))
#define ic0motDrotVSet(obj,devName,position,positionNum,error) \
	(*((ic0devSOFT_FCTPTR_SET)((obj)->fcts[ic0motDROT_FCT_SET]))) \
	 ((obj),(devName),(position),(positionNum),(error))
#define ic0motDrotVCheck(obj,devName,status,error) \
	(*((ic0devMOT_FCTPTR_CHECK)((obj)->fcts[ic0motDROT_FCT_CHECK]))) \
	 ((obj),(devName),(status),(error))
#define ic0motDrotVWait(obj,devName,timeout,error) \
	(*((ic0devMOT_FCTPTR_WAIT)((obj)->fcts[ic0motDROT_FCT_WAIT]))) \
	 ((obj),(devName),(timeout),(error))
#define ic0motDrotVUsrSetMode(obj,devName,cmd,available,enabled,simulation,handset,locked,error) \
	(*((ic0devMOT_FCTPTR_USR_SET_MODE)((obj)->fcts[ic0motDROT_FCT_USR_SET_MODE]))) \
	 ((obj),(devName),(cmd),(available),(enabled),(simulation),(handset),(locked),(error))
#define ic0motDrotVSetup(obj,devName,function,functionNum,noMove,check,error) \
	(*((ic0devSOFT_FCTPTR_SETUP)((obj)->fcts[ic0motDROT_FCT_SETUP]))) \
	 ((obj),(devName),(function),(functionNum),(noMove),(check),(error))
#define ic0motDrotVGetVal(obj,devName,name,nameNum,status,error) \
	(*((ic0devSOFT_FCTPTR_GET_VAL)((obj)->fcts[ic0motDROT_FCT_GET_VAL]))) \
	 ((obj),(devName),(name),(nameNum),(status),(error))
#define ic0motDrotVSetVal(obj,devName,name,nameNum,value,valueNum,error) \
	(*((ic0devSOFT_FCTPTR_SET_VAL)((obj)->fcts[ic0motDROT_FCT_SET_VAL]))) \
	 ((obj),(devName),(name),(nameNum),(value),(valueNum),(error))
#define ic0motDrotVCfgElem(obj,devName,position,id,values,valuesNum,error) \
	(*((ic0devMOT_FCTPTR_CFG_ELEM)((obj)->fcts[ic0motDROT_FCT_CFG_ELEM]))) \
	 ((obj),(devName),(position),(id),(values),(valuesNum),(error))
#define ic0motDrotVLogConf(obj,devName,allElements,error) \
	(*((ic0devMOT_FCTPTR_LOG_CONF)((obj)->fcts[ic0motDROT_FCT_LOG_CONF]))) \
	 ((obj),(devName),(allElements),(error))
#define ic0motDrotVGetConf(obj,devName,allElements,text,error) \
	(*((ic0devMOT_FCTPTR_GET_CONF)((obj)->fcts[ic0motDROT_FCT_GET_CONF]))) \
	 ((obj),(devName),(allElements),(text),(error))
#define ic0motDrotVResetParameters(obj,devName,cmd,error) \
	(*((ic0devSOFT_FCTPTR_RESET_PARAMETERS)((obj)->fcts[ic0motDROT_FCT_RESET_PARAMETERS]))) \
	 ((obj),(devName),(cmd),(error))
#define ic0motDrotVParseParameters(obj,devName,cmd,params,paramsNum,noMove,check,error) \
	(*((ic0devSOFT_FCTPTR_PARSE_PARAMETERS)((obj)->fcts[ic0motDROT_FCT_PARSE_PARAMETERS]))) \
	 ((obj),(devName),(cmd),(params),(paramsNum),(noMove),(check),(error))
#define ic0motDrotVCompareParameters(obj,devName,cmd,equal,error) \
	(*((ic0devSOFT_FCTPTR_COMPARE_PARAMETERS)((obj)->fcts[ic0motDROT_FCT_COMPARE_PARAMETERS]))) \
	 ((obj),(devName),(cmd),(equal),(error))
#define ic0motDrotVCopyParameters(obj,devName,error) \
	(*((ic0devSOFT_FCTPTR_COPY_PARAMETERS)((obj)->fcts[ic0motDROT_FCT_COPY_PARAMETERS]))) \
	 ((obj),(devName),(error))
#define ic0motDrotVExecParameters(obj,devName,error) \
	(*((ic0devSOFT_FCTPTR_EXEC_PARAMETERS)((obj)->fcts[ic0motDROT_FCT_EXEC_PARAMETERS]))) \
	 ((obj),(devName),(error))
#define ic0motDrotVUpdateParameters(obj,devName,cache,error) \
	(*((ic0devSOFT_FCTPTR_UPDATE_PARAMETERS)((obj)->fcts[ic0motDROT_FCT_UPDATE_PARAMETERS]))) \
	 ((obj),(devName),(cache),(error))
#define ic0motDrotVGetParamSetValue(obj,devName,index,value,setCode,error) \
	(*((ic0devSOFT_FCTPTR_GET_PARAM_SET_VALUE)((obj)->fcts[ic0motDROT_FCT_GET_PARAM_SET_VALUE]))) \
	 ((obj),(devName),(index),(value),(setCode),(error))
#define ic0motDrotVGetParamStatus(obj,devName,index,flags,status,error) \
	(*((ic0devSOFT_FCTPTR_GET_PARAM_STATUS)((obj)->fcts[ic0motDROT_FCT_GET_PARAM_STATUS]))) \
	 ((obj),(devName),(index),(flags),(status),(error))
#define ic0motDrotVSetParam(obj,devName,index,cmd,value,step,error) \
	(*((ic0devSOFT_FCTPTR_SET_PARAM)((obj)->fcts[ic0motDROT_FCT_SET_PARAM]))) \
	 ((obj),(devName),(index),(cmd),(value),(step),(error))
#define ic0motDrotVSetParamStep(obj,devName,index,cmd,step,error) \
	(*((ic0devSOFT_FCTPTR_SET_PARAM_STEP)((obj)->fcts[ic0motDROT_FCT_SET_PARAM_STEP]))) \
	 ((obj),(devName),(index),(cmd),(step),(error))
#define ic0motDrotVUsrExecAction(obj,devName,index,error) \
	(*((ic0devMOT_FCTPTR_USR_EXEC_ACTION)((obj)->fcts[ic0motDROT_FCT_USR_EXEC_ACTION]))) \
	 ((obj),(devName),(index),(error))
#define ic0motDrotVUsrSetParameter(obj,devName,cmd,param1,param1SetCode,param2,param2SetCode,value,error) \
	(*((ic0devMOT_FCTPTR_USR_SET_PARAMETER)((obj)->fcts[ic0motDROT_FCT_USR_SET_PARAMETER]))) \
	 ((obj),(devName),(cmd),(param1),(param1SetCode),(param2),(param2SetCode),(value),(error))
#define ic0motDrotVGetValueCode(obj,devName,name,code,error) \
	(*((ic0devSOFT_FCTPTR_GET_VALUE_CODE)((obj)->fcts[ic0motDROT_FCT_GET_VALUE_CODE]))) \
	 ((obj),(devName),(name),(code),(error))
#define ic0motDrotVGetValue(obj,devName,code,index,value,valueNum,error) \
	(*((ic0devSOFT_FCTPTR_GET_VALUE)((obj)->fcts[ic0motDROT_FCT_GET_VALUE]))) \
	 ((obj),(devName),(code),(index),(value),(valueNum),(error))
#define ic0motDrotVUsrGetValue(obj,devName,valuesTable,valuesTableNum,code,index,value,valueNum,done,error) \
	(*((ic0devMOT_FCTPTR_USR_GET_VALUE)((obj)->fcts[ic0motDROT_FCT_USR_GET_VALUE]))) \
	 ((obj),(devName),(valuesTable),(valuesTableNum),(code),(index),(value),(valueNum),(done),(error))
#define ic0motDrotVSetValue(obj,devName,code,index,value,valueNum,error) \
	(*((ic0devSOFT_FCTPTR_SET_VALUE)((obj)->fcts[ic0motDROT_FCT_SET_VALUE]))) \
	 ((obj),(devName),(code),(index),(value),(valueNum),(error))
#define ic0motDrotVUsrSetValue(obj,devName,valuesTable,valuesTableNum,code,index,value,valueNum,done,error) \
	(*((ic0devMOT_FCTPTR_USR_SET_VALUE)((obj)->fcts[ic0motDROT_FCT_USR_SET_VALUE]))) \
	 ((obj),(devName),(valuesTable),(valuesTableNum),(code),(index),(value),(valueNum),(done),(error))
#define ic0motDrotVGetArg(obj,devName,code,index,value,error) \
	(*((ic0devMOT_FCTPTR_GET_ARG)((obj)->fcts[ic0motDROT_FCT_GET_ARG]))) \
	 ((obj),(devName),(code),(index),(value),(error))
#define ic0motDrotVMonitor(obj,devName,error) \
	(*((ic0devSOFT_FCTPTR_MONITOR)((obj)->fcts[ic0motDROT_FCT_MONITOR]))) \
	 ((obj),(devName),(error))
#define ic0motDrotVUsrMonitor(obj,devName,state,error) \
	(*((ic0devSOFT_FCTPTR_USR_MONITOR)((obj)->fcts[ic0motDROT_FCT_USR_MONITOR]))) \
	 ((obj),(devName),(state),(error))
#define ic0motDrotVLogAction(obj,devName,action,comment,error) \
	(*((ic0devSOFT_FCTPTR_LOG_ACTION)((obj)->fcts[ic0motDROT_FCT_LOG_ACTION]))) \
	 ((obj),(devName),(action),(comment),(error))
#define ic0motDrotVLogComment(obj,devName,comment,error) \
	(*((ic0devSOFT_FCTPTR_LOG_COMMENT)((obj)->fcts[ic0motDROT_FCT_LOG_COMMENT]))) \
	 ((obj),(devName),(comment),(error))
#define ic0motDrotVLogParameter(obj,devName,parameter,index,value,comment,error) \
	(*((ic0devSOFT_FCTPTR_LOG_PARAMETER)((obj)->fcts[ic0motDROT_FCT_LOG_PARAMETER]))) \
	 ((obj),(devName),(parameter),(index),(value),(comment),(error))
#define ic0motDrotVLogRecovery(obj,devName,comment,error) \
	(*((ic0devSOFT_FCTPTR_LOG_RECOVERY)((obj)->fcts[ic0motDROT_FCT_LOG_RECOVERY]))) \
	 ((obj),(devName),(comment),(error))
#define ic0motDrotVLogTblParam(obj,devName,paramIndex,flags,comment,error) \
	(*((ic0devSOFT_FCTPTR_LOG_TBL_PARAM)((obj)->fcts[ic0motDROT_FCT_LOG_TBL_PARAM]))) \
	 ((obj),(devName),(paramIndex),(flags),(comment),(error))
#define ic0motDrotVLogUnforseen(obj,devName,comment,error) \
	(*((ic0devSOFT_FCTPTR_LOG_UNFORSEEN)((obj)->fcts[ic0motDROT_FCT_LOG_UNFORSEEN]))) \
	 ((obj),(devName),(comment),(error))
#define ic0motDrotVVarSet(obj,error) \
	(*((ic0devMOT_FCTPTR_VAR_SET)((obj)->fcts[ic0motDROT_FCT_VAR_SET]))) \
	 ((obj),(error))
#define ic0motDrotVVarWait(obj,error) \
	(*((ic0devMOT_FCTPTR_VAR_WAIT)((obj)->fcts[ic0motDROT_FCT_VAR_WAIT]))) \
	 ((obj),(error))
#define ic0motDrotVGetHandles(obj,devName,motors,error) \
	(*((ic0devMOT_FCTPTR_GET_HANDLES)((obj)->fcts[ic0motDROT_FCT_GET_HANDLES]))) \
	 ((obj),(devName),(motors),(error))
#define ic0motDrotVPark(obj,devName,error) \
	(*((ic0devMOT_FCTPTR_PARK)((obj)->fcts[ic0motDROT_FCT_PARK]))) \
	 ((obj),(devName),(error))
#define ic0motDrotVGetAction(obj,devName,actionStep,action,error) \
	(*((ic0devMOT_FCTPTR_GET_ACTION)((obj)->fcts[ic0motDROT_FCT_GET_ACTION]))) \
	 ((obj),(devName),(actionStep),(action),(error))
#define ic0motDrotVExecAction(obj,devName,action,end,error) \
	(*((ic0motDROT_FCTPTR_EXEC_ACTION)((obj)->fcts[ic0motDROT_FCT_EXEC_ACTION]))) \
	 ((obj),(devName),(action),(end),(error))
#define ic0motDrotVActionGetHandles(obj,devName,index,motors,error) \
	(*((ic0devMOT_FCTPTR_ACTION_GET_HANDLES)((obj)->fcts[ic0motDROT_FCT_ACTION_GET_HANDLES]))) \
	 ((obj),(devName),(index),(motors),(error))
#define ic0motDrotVActionNewMove(obj,devName,action,end,error) \
	(*((ic0devMOT_FCTPTR_ACTION_NEW_MOVE)((obj)->fcts[ic0motDROT_FCT_ACTION_NEW_MOVE]))) \
	 ((obj),(devName),(action),(end),(error))
#define ic0motDrotVActionIf(obj,devName,action,end,error) \
	(*((ic0devMOT_FCTPTR_ACTION_IF)((obj)->fcts[ic0motDROT_FCT_ACTION_IF]))) \
	 ((obj),(devName),(action),(end),(error))
#define ic0motDrotVActionParam(obj,devName,action,end,error) \
	(*((ic0devMOT_FCTPTR_ACTION_PARAM)((obj)->fcts[ic0motDROT_FCT_ACTION_PARAM]))) \
	 ((obj),(devName),(action),(end),(error))
#define ic0motDrotVActionAddParam(obj,devName,action,end,error) \
	(*((ic0devMOT_FCTPTR_ACTION_ADD_PARAM)((obj)->fcts[ic0motDROT_FCT_ACTION_ADD_PARAM]))) \
	 ((obj),(devName),(action),(end),(error))
#define ic0motDrotVActionValue(obj,devName,action,end,error) \
	(*((ic0devMOT_FCTPTR_ACTION_VALUE)((obj)->fcts[ic0motDROT_FCT_ACTION_VALUE]))) \
	 ((obj),(devName),(action),(end),(error))
#define ic0motDrotVActionAddValue(obj,devName,action,end,error) \
	(*((ic0devMOT_FCTPTR_ACTION_ADD_VALUE)((obj)->fcts[ic0motDROT_FCT_ACTION_ADD_VALUE]))) \
	 ((obj),(devName),(action),(end),(error))
#define ic0motDrotVActionMove(obj,devName,action,end,error) \
	(*((ic0devMOT_FCTPTR_ACTION_MOVE)((obj)->fcts[ic0motDROT_FCT_ACTION_MOVE]))) \
	 ((obj),(devName),(action),(end),(error))
#define ic0motDrotVActionSpeedMove(obj,devName,action,end,error) \
	(*((ic0devMOT_FCTPTR_ACTION_SPEED_MOVE)((obj)->fcts[ic0motDROT_FCT_ACTION_SPEED_MOVE]))) \
	 ((obj),(devName),(action),(end),(error))
#define ic0motDrotVActionWaitMove(obj,devName,action,end,error) \
	(*((ic0devMOT_FCTPTR_ACTION_WAIT_MOVE)((obj)->fcts[ic0motDROT_FCT_ACTION_WAIT_MOVE]))) \
	 ((obj),(devName),(action),(end),(error))
#define ic0motDrotVActionClampBrake(obj,devName,action,end,error) \
	(*((ic0devMOT_FCTPTR_ACTION_CLAMP_BRAKE)((obj)->fcts[ic0motDROT_FCT_ACTION_CLAMP_BRAKE]))) \
	 ((obj),(devName),(action),(end),(error))
#define ic0motDrotVActionDisconnect(obj,devName,action,end,error) \
	(*((ic0devMOT_FCTPTR_ACTION_DISCONNECT)((obj)->fcts[ic0motDROT_FCT_ACTION_DISCONNECT]))) \
	 ((obj),(devName),(action),(end),(error))
#define ic0motDrotVActionStop(obj,devName,action,end,error) \
	(*((ic0devMOT_FCTPTR_ACTION_STOP)((obj)->fcts[ic0motDROT_FCT_ACTION_STOP]))) \
	 ((obj),(devName),(action),(end),(error))
#define ic0motDrotVActionUserFunction(obj,devName,action,end,error) \
	(*((ic0devMOT_FCTPTR_ACTION_USER_FUNCTION)((obj)->fcts[ic0motDROT_FCT_ACTION_USER_FUNCTION]))) \
	 ((obj),(devName),(action),(end),(error))
#define ic0motDrotVActionRetry(obj,devName,action,end,error) \
	(*((ic0devMOT_FCTPTR_ACTION_RETRY)((obj)->fcts[ic0motDROT_FCT_ACTION_RETRY]))) \
	 ((obj),(devName),(action),(end),(error))
#define ic0motDrotVActionEnd(obj,devName,action,end,error) \
	(*((ic0devMOT_FCTPTR_ACTION_END)((obj)->fcts[ic0motDROT_FCT_ACTION_END]))) \
	 ((obj),(devName),(action),(end),(error))
#define ic0motDrotVActionError(obj,devName,action,end,error) \
	(*((ic0devMOT_FCTPTR_ACTION_ERROR)((obj)->fcts[ic0motDROT_FCT_ACTION_ERROR]))) \
	 ((obj),(devName),(action),(end),(error))
#define ic0motDrotVActionSleep(obj,devName,action,end,error) \
	(*((ic0devMOT_FCTPTR_ACTION_SLEEP)((obj)->fcts[ic0motDROT_FCT_ACTION_SLEEP]))) \
	 ((obj),(devName),(action),(end),(error))
#define ic0motDrotVActionIncrValue(obj,devName,action,end,error) \
	(*((ic0devMOT_FCTPTR_ACTION_INCR_VALUE)((obj)->fcts[ic0motDROT_FCT_ACTION_INCR_VALUE]))) \
	 ((obj),(devName),(action),(end),(error))
#define ic0motDrotVSetParListAddress(obj,devName,motor,error) \
	(*((ic0devMOT_FCTPTR_SET_PAR_LIST_ADDRESS)((obj)->fcts[ic0motDROT_FCT_SET_PAR_LIST_ADDRESS]))) \
	 ((obj),(devName),(motor),(error))
#define ic0motDrotVWlen2Enc(obj,from,to,parList,error) \
	(*((ic0devMOT_FCTPTR_WLEN2ENC)((obj)->fcts[ic0motDROT_FCT_WLEN2ENC]))) \
	 ((obj),(from),(to),(parList),(error))
#define ic0motDrotVTemp2Focus(obj,from,to,parList,error) \
	(*((ic0devMOT_FCTPTR_TEMP2FOCUS)((obj)->fcts[ic0motDROT_FCT_TEMP2FOCUS]))) \
	 ((obj),(from),(to),(parList),(error))
#define ic0motDrotVSlit2Enc1(obj,from,to,parList,error) \
	(*((ic0devMOT_FCTPTR_SLIT2ENC1)((obj)->fcts[ic0motDROT_FCT_SLIT2ENC1]))) \
	 ((obj),(from),(to),(parList),(error))
#define ic0motDrotVSlit2Enc2(obj,from,to,parList,error) \
	(*((ic0devMOT_FCTPTR_SLIT2ENC2)((obj)->fcts[ic0motDROT_FCT_SLIT2ENC2]))) \
	 ((obj),(from),(to),(parList),(error))
#define ic0motDrotVSlit2Enc(obj,motorIndex,from,to,error) \
	(*((ic0devMOT_FCTPTR_SLIT2ENC)((obj)->fcts[ic0motDROT_FCT_SLIT2ENC]))) \
	 ((obj),(motorIndex),(from),(to),(error))
#define ic0motDrotVWlenTeta2Enc(obj,from,to,parList,error) \
	(*((ic0devMOT_FCTPTR_WLEN_TETA2ENC)((obj)->fcts[ic0motDROT_FCT_WLEN_TETA2ENC]))) \
	 ((obj),(from),(to),(parList),(error))
#define ic0motDrotVTilt2Enc(obj,from,to,parList,error) \
	(*((ic0devMOT_FCTPTR_TILT2ENC)((obj)->fcts[ic0motDROT_FCT_TILT2ENC]))) \
	 ((obj),(from),(to),(parList),(error))
#define ic0motDrotVActionTracking(obj,devName,action,end,error) \
	(*((ic0motDROT_FCTPTR_ACTION_TRACKING)((obj)->fcts[ic0motDROT_FCT_ACTION_TRACKING]))) \
	 ((obj),(devName),(action),(end),(error))


ccsCOMPL_STAT ic0motDrotNewObj(
    IN    dbSYMADDRESS	point,
    IN    egenOBJ*	owner,
    OUT   egenOBJ*	obj,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0motDrotDeleteObj(
    INOUT egenOBJ*	obj,
    OUT   ccsERROR*	error);

void ic0motDrotTask(
    INOUT lcctooTASK*   task);

ccsCOMPL_STAT ic0motDrotParamInit(
    INOUT egenOBJ*	    obj,
    IN    const char*	    devName,
    IN    ic0motDROT_PARAM* p,
    OUT   ccsERROR*	    error);

ccsCOMPL_STAT ic0motDrotParamGet(
    INOUT egenOBJ*	    obj,
    IN    const char*	    devName,
    IN    ic0motDROT_PARAM* p,
    OUT   ccsERROR*	    error);

ccsCOMPL_STAT ic0motDrotParamCalc(
    INOUT egenOBJ*	    obj,
    IN    const char*	    devName,
    IN    ic0motDROT_PARAM* p,
    IN    ic0motDROT_MOTOR* m,
    IN    ic0motDROT_MOTION* t,
    OUT   ccsERROR*	    error);

ccsCOMPL_STAT ic0motDrotParamSet(
    INOUT egenOBJ*	    obj,
    IN    const char*	    devName,
    IN    ic0motDROT_PARAM* p,
    IN    ic0motDROT_MOTOR* m,
    OUT   ccsERROR*	    error);

ccsCOMPL_STAT ic0motDrotMotInit(
    INOUT egenOBJ*	    obj,
    IN    const char*	    devName,
    IN    ic0motDROT_MOTOR* m,
    OUT   ccsERROR*	    error);

ccsCOMPL_STAT ic0motDrotMotGetStatus(
    INOUT egenOBJ*	    obj,
    IN    const char*	    devName,
    INOUT ic0motDROT_MOTOR* m,
    OUT   ccsERROR*	    error);

ccsCOMPL_STAT ic0motDrotMotMove(
    INOUT egenOBJ*	    obj,
    IN    const char*	    devName,
    IN    ic0motDROT_MOTOR* m,
    IN    ic0motDROT_MOTION* t,
    OUT   ccsERROR*	    error);

ccsCOMPL_STAT ic0motDrotMotStop(
    INOUT egenOBJ*	    obj,
    IN    const char*	    devName,
    IN    ic0motDROT_MOTOR* m,
    OUT   ccsERROR*	    error);


#endif // !IC0MOT_DROT_H

/************************************************************************/
/* ___oOo___ */
