/******************************************************************************
*  E.S.O. - VLT project
* 
*  "@(#) $Id: ic0senDefines.h,v 1.51 2005/08/15 13:36:26 vltsccm Exp $"
* 
*  who       when      what
*  --------  --------  ----------------------------------------------
*  rschmutz  03/12/03  ic0senCN77000_* added.
*  rschmutz  25/05/00  ic0senSOFT_FLAG_* added.
*  rschmutz  22/09/99  ic0senTYPE_ANALOG_MEDIANx added.
*  rschmutz  26/04/99  ic0senTYPE_PRESSURE added.
*  rschmutz  19/01/99  illegal value set to 9999 (>0 req. by RTAP plot).
*  rschmutz  03/04/98  Created
*
*/

/*************************************************************************
*    NAME
*	ic0senDefines.h - module header file, define part
* 
* 
*    DESCRIPTION
*	This is a header file of the module ic0sen.
* 
* 
*-------------------------------------------------------------------------
*/

#ifndef IC0SEN_DEFINES_H
#define IC0SEN_DEFINES_H

#include "ic0devDefines.h"


/*
 * parameter get status value
 */
#define ic0senGET_FIRST			1   /* lcctooGET_FIRST	          */
#define ic0senSOFT_GET_FIRST		15  /* (lccdevGET_LAST + 1)	  */


/*
 * ic0sen sensor report types
 */
#define ic0senTYPE_ANALOG		1
#define ic0senTYPE_TRUE_FALSE		2
#define ic0senTYPE_ON_OFF		3
#define ic0senTYPE_OPEN_CLOSED		4
#define ic0senTYPE_OPEN_CLOSED2		5
#define ic0senTYPE_PRESSURE		6
#define ic0senTYPE_ANALOG_MEDIAN1	7
#define ic0senTYPE_ANALOG_MEDIAN2	8
#define ic0senTYPE_ANALOG_MEDIAN3	9
#define ic0senTYPE_ANALOG_MEDIAN4      10

/*
 * cooling system sensor addresses
 */
#define ic0senCOOLING_TEMP_OUTLET	1
#define ic0senCOOLING_TEMP_INLET	2
#define ic0senCOOLING_TEMP_CABINET	3
#define ic0senCOOLING_TEMP_AMBIENT	4
#define ic0senCOOLING_FLOW1		5
#define ic0senCOOLING_FLOW2		6
#define ic0senCOOLING_FLOW3		7
#define ic0senCOOLING_DOOR		8
#define ic0senCOOLING_CSTAT1		9
#define ic0senCOOLING_CSTAT2		10
#define ic0senCOOLING_FEPROM		11
#define ic0senCOOLING_COMM		12

/*
 * CN7700 address and alarm defines
 */
#define ic0senCN77000_ADDR_CURRENT 	  0
#define ic0senCN77000_ADDR_SET     	  1
#define ic0senCN77000_ADDR_ALARM_ENABLED  2
#define ic0senCN77000_ADDR_ALARM_RELATIVE 3
#define ic0senCN77000_ADDR_ALARM_TRIGGER  4
#define ic0senCN77000_ADDR_ALARM_LOW      5
#define ic0senCN77000_ADDR_ALARM_HIGH     6

#define ic0senCN77000_ALARM_TRIGGER_ABOVE 0
#define ic0senCN77000_ALARM_TRIGGER_BELOW 1
#define ic0senCN77000_ALARM_TRIGGER_HILOW 2
#define ic0senCN77000_ALARM_TRIGGER_BAND  3


/*
 * misc. defines
 */
#define ic0senVALUE_ILLEGAL	      9999
#define ic0senANALOG_LAST_MAX		48
#define ic0senSIGNALS_NUM		64

#define ic0senSOFT_HEADER		 1
#define ic0senSOFT_LOG			 2

#define ic0senSOFT_FLAG_PRINTID		 1
#define ic0senSOFT_FLAG_LOGID		 2


#endif // !IC0SEN_DEFINES_H

/************************************************************************/
/* ___oOo___ */
