/******************************************************************************
*  E.S.O. - VLT project
* 
*  "@(#) $Id: ic0senSoft.h,v 1.51 2005/08/15 13:36:26 vltsccm Exp $"
* 
*  who        when      what
*  ---------- --------  ----------------------------------------------
*  rschmutz   22/09/99  name and desc. added to ic0senSOFT_SENSORS_FITS.
*  rschmutz   01/04/98  Created by eccsgen  Revision: 1.20
*
*
*    !!!!!!!!!  CAUTION: THIS FILE IS UPDATED BY ECCSGEN  !!!!!!!!!
*/

/*************************************************************************
*   NAME
*	ic0senSoft - class
*
*   SYNOPSIS
*	#include "ic0senSoft.h"
*
*	ccsCOMPL_STAT ic0senSoftNewObj(
*	    IN    dbSYMADDRESS	point,
*	    IN    egenOBJ*	owner,
*	    OUT   egenOBJ*	obj,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0senSoftDeleteObj(
*	    INOUT egenOBJ*	obj,
*	    OUT   ccsERROR*	error)
*
*	egenOBJ* ic0senSoftGetOwner(
*	    IN const egenOBJ* obj)
*
*	egenOBJ* ic0senSoftLogData(
*	    IN const egenOBJ*	obj,
*	    IN const char*	format,
*	    IN 			...)
*
*	ccsCOMPL_STAT ic0senSoftSetup(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    const char*	function[],	** max. vltBYTES32[999]
*	    IN    vltINT16	functionNum,
*	    IN    vltLOGICAL	noMove,
*	    IN    vltLOGICAL	check,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0senSoftSet(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    const char*	position[],	** max. vltBYTES32[999]
*	    IN    vltINT16	positionNum,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0senSoftMove(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    const char*	position[],	** max. vltBYTES32[999]
*	    IN    vltINT16	positionNum,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0senSoftMoveRel(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    const char*	position[],	** max. vltBYTES32[999]
*	    IN    vltINT16	positionNum,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0senSoftStatus(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    const char*	function[],	** max. vltBYTES32[999]
*	    IN    vltINT16	functionNum,
*	    IN    vltLOGICAL	flag,
*	    IN    vltLOGICAL	header,
*	    IN    vltLOGICAL	conflog,
*	    IN    vltLOGICAL	opslog,
*	    IN    vltLOGICAL	condlog,
*	    OUT   char**	status,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0senSoftGetConf(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    vltLOGICAL	allElements,
*	    OUT   char**	text,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0senSoftLogConf(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    vltLOGICAL	allElements,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0senSoftInitObj(
*	    INOUT egenOBJ*	obj,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0senSoftExitObj(
*	    INOUT egenOBJ*	obj,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0senSoftUsrInit(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0senSoftUsrStandby2Online(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0senSoftUsrOnline2Standby(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0senSoftUsrStandby2Loaded(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0senSoftUsrSetMode(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    vltINT32	cmd,
*	    IN    vltLOGICAL	available,
*	    IN    vltLOGICAL	enabled,
*	    IN    vltLOGICAL	simulation,
*	    IN    vltLOGICAL	handset,
*	    IN    vltLOGICAL	locked,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0senSoftMonitor(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0senSoftUsrTest(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0senSoftUsrStatusCode(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    const char*	text,
*	    IN    vltINT32	flags,
*	    OUT   vltINT32*	code,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0senSoftUsrStatusValue(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    vltINT32	code,
*	    OUT   lcctooVALUE*	value,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0senSoftUsrStatusLast(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    OUT   vltINT16*	last,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0senSoftHwInit(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    lccDEV_MODE	state,
*	    IN    vltLOGICAL	simulation,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0senSoftHwExit(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    lccDEV_MODE	state,
*	    IN    vltLOGICAL	simulation,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0senSoftHwStatus(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    lccDEV_MODE	state,
*	    IN    vltLOGICAL	simulation,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0senSoftHwSetup(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    const char*	function[],	** max. vltBYTES32[999]
*	    IN    vltINT16	functionNum,
*	    IN    vltLOGICAL	noMove,
*	    IN    vltLOGICAL	check,
*	    IN    vltLOGICAL	simulation,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0senSoftHwGetConf(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    OUT   char**	text,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0senSoftHwLogConf(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0senSoftLogStatus(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    vltLOGICAL	all,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0senSoftRead<scalarAttr>(
*	    INOUT egenOBJ*	obj,
*	    OUT   void*		buf,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0senSoftWrite<scalarAttr>(
*	    INOUT egenOBJ*	obj,
*	    IN    void*		buf,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0senSoftRead<vectorAttr>(
*	    INOUT egenOBJ*	obj,
*	    OUT   void*		buf,
*	    IN    vltINT32	first,
*	    IN    vltINT32	last,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0senSoftWrite<vectorAttr>(
*	    INOUT egenOBJ*	obj,
*	    IN    void*		buf,
*	    IN    vltINT32	first,
*	    IN    vltINT32	last,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0senSoftRead<tableAttr>(
*	    INOUT egenOBJ*	obj,
*	    OUT   void*		buf,
*	    IN    vltINT32	firstRec,
*	    IN    vltINT32	lastRec,
*	    IN    vltINT32	firstFld,
*	    IN    vltINT32	lastFld,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0senSoftWrite<tableAttr>(
*	    INOUT egenOBJ*	obj,
*	    IN    void*		buf,
*	    IN    vltINT32	firstRec,
*	    IN    vltINT32	lastRec,
*	    IN    vltINT32	firstFld,
*	    IN    vltINT32	lastFld,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT ic0senErrReadOldb(p1,p2)
*	ccsCOMPL_STAT ic0senErrWriteOldb(p1,p2)
*	ccsCOMPL_STAT ic0senErrSensorConf(p1,p2)
*	ccsCOMPL_STAT ic0senErrGeneral(p1,p2)
*
*   PARENT CLASS
*	public ic0devSOFT
*
*   DESCRIPTION
*       The class ic0senSOFT is the base class for software
*       devices that access sensors.
*
*	ic0senSoftNewObj(point,owner,obj,error)
*	    Initialises an instance of the class type ic0senSOFT.
*
*	    point	<IN>	OLDB point where the owned attributes are
*				located.
*	    owner	<IN>	Pointer to the owner of the new instance.
*	    obj		<OUT>	Handle for the new instance (the handle
*				must be allocated by the caller).
*
*	ic0senSoftDeleteObj(obj,error)
*	    The function lcctooDeleteObj deletes an
*	    instance of the class type ic0senSOFT
*
*	ic0senSoftSetup(obj,devName,function,functionNum,noMove,check,error)
*	   Setups the function. The keys are the last component
*	   of the FITS keywords related with the function.
*	   E.g.:
*	     If the FITS keyword is: INS.OPTI-3.ID #11
*	     then the key is: ID, the value '#11'.
*
*	   If the noMove flag is used, then the setup parameters
*	   are stored, but not executed until a setup command
*	   without the noMove flag is received.
*
*	   If the check flag is used, then only the parameters
*	   are checked. No setup is performed.
*
*	   Aliases are not accepted (The ICS Frontend at the
*	   workstation recognizes the aliases).
*
*	ic0senSoftSet(obj,devName,position,positionNum,error)
*	   Set a hardware device in a specified state
*	   (e.g. set lamp on, set shutter open).
*
*	ic0senSoftMove(obj,devName,position,positionNum,error)
*	   Move the hardware device to a given absolute position.
*
*	ic0senSoftMoveRel(obj,devName,position,positionNum,error)
*	   Move the hardware device to a position relative to
*	   the current position.
*
*	ic0senSoftStatus(obj,devName,function,functionNum,flag,header,conflog,opslog,condlog,status,error)
*	   Updates the complete status in the local database
*	   and returns the relevant status of the software
*	   device.
*
*	   The status is given as lines containing two words
*	   each:
*	     key1  value1,
*	     [key2 value2,
*	     [...]]
*
*	   The value usually begins after the 18th character
*	   of each line. If the flag option is set, then the
*	   values are returned as numbers (by default values
*	   are returned as literals).
*
*	ic0senSoftGetConf(obj,devName,allElements,text,error)
*	   Returns the current configuration of the device.
*
*	   If the allElements flag is given, then the elements
*	   of all wheel positions are reported; otherwise
*	   only the element in the lightpath is described.
*
*	ic0senSoftLogConf(obj,devName,allElements,error)
*	   Sends logs describing the current configuration of
*	   the device.
*
*	   If the allElements flag is given, then the elements
*	   of all wheel positions are reported; otherwise
*	   only the element in the lightpath is described.
*
*
*	ic0senSoftErr<error>(...)
*	    The macros ic0senSoftErr*() log an error with lcctooLOG_0 and
*	    call errAdd with the corresponding error parameters.
*
*	ic0senSoftRead<attr>(...)
*	ic0senSoftWrite<attr>(...)
*	    The above macros read from/write to the data attributes
*	    of the class.
*	    The attributes are described in ic0senSoftDb(5).
*
*   PROTECTED METHODS
*   PRIVATE METHODS
*	ic0senSoftInitObj(obj,error)
*
*	ic0senSoftExitObj(obj,error)
*
*	ic0senSoftUsrInit(obj,devName,error)
*	   This function should be overloaded to perform the
*	   device initialisation (without hardware movements).
*
*	ic0senSoftUsrStandby2Online(obj,devName,error)
*	   This function should be overloaded to perform the
*	   actions necessary to change from the STANDBY to the
*	   ONLINE state. The overloaded function should first
*	   call lccdevCmdUsrStandby2Online() or check if the
*	   device is available and enabled before going ONLINE.
*
*	ic0senSoftUsrOnline2Standby(obj,devName,error)
*	   This function should be overloaded to perform the
*	   actions necessary to change from the ONLINE to the
*	   STANDBY state.
*
*	ic0senSoftUsrStandby2Loaded(obj,devName,error)
*	   This function should be overloaded to perform the
*	   actions necessary to change from the STANDBY to the
*	   LOADED state.
*
*	ic0senSoftUsrSetMode(obj,devName,cmd,available,enabled,simulation,handset,locked,error)
*	   This function should be overloaded to perform the
*	   actions necessary to change the mode of the hardware
*	   device.
*
*	   cmd	<IN>	code indicating the command that
*			   calls UsrSetMode() (lccdevCMD_*).
*	   logical	<IN>	state of the available, enabled,
*			   simulation, handset and locked
*			   modes.
*
*	ic0senSoftMonitor(obj,devName,error)
*	   This function is periodically called by the device
*	   manager. It updates the status if the device is in
*	   the Standby or Online state. It calls the UsrMonitor.
*
*	ic0senSoftUsrTest(obj,devName,error)
*	   This function should be overloaded to perform the
*	   actions necessary to test the software device
*	   (eventually with hardware movements).
*
*	ic0senSoftUsrStatusCode(obj,devName,text,flags,code,error)
*	   This function receives the name of a status value
*	   and returns the corresponding code. This function
*	   should be overloaded if the new class declares new
*	   status values. The overloaded function should check
*	   first if the name corresponds to one of its own
*	   status values. If not, then it should call the
*	   function UsrStatusCode() of its parent class to be
*	   able to retrieve the codes of the parent status
*	   values.
*
*	   text	<IN>	Name of the status value.
*	   flags	<IN>	expected status type (lcctooSTATUS_*).
*	   code	<OUT>	Code of the status value (lccdevGET_*).
*
*	   lccdevGET_DEVICE        "Device"
*	   lccdevGET_STATE         "State"
*	   lccdevGET_TRANSTATE     "TranState"
*	   lccdevGET_ERROR         "Error"
*	   lccdevGET_INITIALISED   "Initialised"
*	   lccdevGET_SIMULATION    "Simulation"
*
*	ic0senSoftUsrStatusValue(obj,devName,code,value,error)
*	   This function receives the code of a status variable
*	   and returns its related value. This function should
*	   be overloaded if the new class declares new status
*	   values. The overloaded function should check first
*	   if the code corresponds to one of its own status
*	   values. If not, then it should call the function
*	   UsrStatusValue() of its parent class to be able to
*	   retrieve the status values of the parent.
*
*	   code	<OUT>	Code of the status value (lccdevGET_*).
*	   value	<OUT>	Handle of the value object
*			   (allocated by the caller).
*
*	ic0senSoftUsrStatusLast(obj,devName,last,error)
*	   This function returns the highest status code that
*	   the class knows. This function should be overloaded
*	   if the new class declares new status values, as new
*	   status codes have to be assigned to the new values.
*
*	   This function is used by the Status command when it
*	   has to return all status values. In this case it
*	   performs a loop from code 1 to the value returned
*	   by this function.
*
*	ic0senSoftHwInit(obj,devName,state,simulation,error)
*	   HwInit is called when the software device enters
*	   the STANDBY or ONLINE state.
*
*	ic0senSoftHwExit(obj,devName,state,simulation,error)
*	   HwInit is called when the software device leaves
*	   the STANDBY or ONLINE state.
*
*	ic0senSoftHwStatus(obj,devName,state,simulation,error)
*	   HwStatus is called periodically to update the
*	   status vector of the software device.
*
*	ic0senSoftHwSetup(obj,devName,function,functionNum,noMove,check,simulation,error)
*	   HwSetup is called when the SETUP command is
*	   issued in the ONLINE state.
*
*	ic0senSoftHwGetConf(obj,devName,text,error)
*	   Returns the current configuration of the
*	   software device.
*
*	ic0senSoftHwLogConf(obj,devName,error)
*	   Logs the current configuration of the
*	   software device.
*
*	ic0senSoftLogStatus(obj,devName,all,error)
*	   Logs the current sensor values of the
*	   software device.
*
*
*   DEFINES
*
*   FILES
*
*   ENVIRONMENT
*
*   RETURN VALUES
*	If the function prototype allows, methods return ccsCOMPL_STAT.
*
*	Methods can generate the following errors:
*	    ic0senERR_READ_OLDB
*	    ic0senERR_WRITE_OLDB
*	    ic0senERR_SENSOR_CONF
*	    ic0senERR_GENERAL
*
*   CAUTIONS
*
*   EXAMPLES
*
*   SEE ALSO
*
*   BUGS
*
* 
*-------------------------------------------------------------------------
*/

#ifndef IC0SEN_SOFT_H
#define IC0SEN_SOFT_H

#include "egen.h"
#include "ic0senErrors.h"
#include "ic0senDefines.h"
#include "ic0devSoft.h"

/*
 * class type identifier
 */
#define ic0senSOFT_ID	185

/*
 * attribute table
 */
#define ic0senSOFT_ATTR_STATE	0
#define ic0senSOFT_ATTR_SUBSTATE	1
#define ic0senSOFT_ATTR_ERROR	2
#define ic0senSOFT_ATTR_INITIALISED	3
#define ic0senSOFT_ATTR_SIMULATION	4
#define ic0senSOFT_ATTR_DEVICE	5
#define ic0senSOFT_ATTR_AVAILABLE	6
#define ic0senSOFT_ATTR_ENABLED	7
#define ic0senSOFT_ATTR_LOCKED	8
#define ic0senSOFT_ATTR_HANDSET	9
#define ic0senSOFT_ATTR_FIXED	10
#define ic0senSOFT_ATTR_FIX_POS_SET	11
#define ic0senSOFT_ATTR_FIXED_POSITION	12
#define ic0senSOFT_ATTR_FIXED_SIMULATION	13
#define ic0senSOFT_ATTR_FIXED_LOCKED	14
#define ic0senSOFT_ATTR_PREFIX	15
#define ic0senSOFT_ATTR_PARAMETERS_SIZE	16
#define ic0senSOFT_ATTR_PARAMETERS	17
#define ic0senSOFT_ATTR_STATUS	18
#define ic0senSOFT_ATTR_STATUS_INDEX	19
#define ic0senSOFT_ATTR_VALUES_SIZE	20
#define ic0senSOFT_ATTR_VALUES	21
#define ic0senSOFT_ATTR_INIT_RESTRICTION	22
#define ic0senSOFT_ATTR_MOVE_RESTRICTION	23
#define ic0senSOFT_ATTR_STOP_TIMEOUT	24
#define ic0senSOFT_ATTR_SET_VAL_FCT	25
#define ic0senSOFT_ATTR_HELP_TEXT	26
#define ic0senSOFT_ATTR_PARAM_STEP	27
#define ic0senSOFT_ATTR_ACTION_COMMAND	28
#define ic0senSOFT_ATTR_ACTION_STOP_REQ	29
#define ic0senSOFT_ATTR_ACTION_NO_MOVE	30
#define ic0senSOFT_ATTR_ACTION_CHECK	31
#define ic0senSOFT_ATTR_RESET_SETUP_CMD	32
#define ic0senSOFT_ATTR_SENSORS_PREFIX	33
#define ic0senSOFT_ATTR_SENSORS_SIZE	34
#define ic0senSOFT_ATTR_SENSORS	35
#define ic0senSOFT_ATTR_HW_ACCESS	36
#define ic0senSOFT_ATTR_LAST	37
#define ic0senSOFT_ATTR_LAST_ACCESS	38
#define ic0senSOFT_ATTR_MIN_ACCESS	39
#define ic0senSOFT_ATTR_IC0SENFLAG	40

#define ic0senSOFT_AUTOMATA	0

/*
 * function table
 */
#define ic0senSOFT_FCT_DELETE_OBJ	0
#define ic0senSOFT_FCT_STANDBY	1
#define ic0senSOFT_FCT_ONLINE	2
#define ic0senSOFT_FCT_OFF	3
#define ic0senSOFT_FCT_EXIT	4
#define ic0senSOFT_FCT_STATE	5
#define ic0senSOFT_FCT_SIMULAT	6
#define ic0senSOFT_FCT_STOP_SIM	7
#define ic0senSOFT_FCT_STATUS	8
#define ic0senSOFT_FCT_INIT	9
#define ic0senSOFT_FCT_STOP	10
#define ic0senSOFT_FCT_TEST	11
#define ic0senSOFT_FCT_SELFTST	12
#define ic0senSOFT_FCT_AUTO_TBL	13
#define ic0senSOFT_FCT_AUTO_RST	14
#define ic0senSOFT_FCT_INIT_OBJ	15
#define ic0senSOFT_FCT_EXIT_OBJ	16
#define ic0senSOFT_FCT_LOADED2STBY	17
#define ic0senSOFT_FCT_ONLINE2STBY	18
#define ic0senSOFT_FCT_EXIT1	19
#define ic0senSOFT_FCT_CHECK_DEVICE_NAME	20
#define ic0senSOFT_FCT_BREAK	21
#define ic0senSOFT_FCT_USR_INIT	22
#define ic0senSOFT_FCT_USR_LOADED2STANDBY	23
#define ic0senSOFT_FCT_USR_STANDBY2ONLINE	24
#define ic0senSOFT_FCT_USR_ONLINE2STANDBY	25
#define ic0senSOFT_FCT_USR_STANDBY2LOADED	26
#define ic0senSOFT_FCT_USR_STOP	27
#define ic0senSOFT_FCT_USR_SIMULAT	28
#define ic0senSOFT_FCT_USR_STOP_SIM	29
#define ic0senSOFT_FCT_USR_STATUS_CODE	30
#define ic0senSOFT_FCT_USR_STATUS_LAST	31
#define ic0senSOFT_FCT_USR_STATUS_VALUE	32
#define ic0senSOFT_FCT_USR_TEST	33
#define ic0senSOFT_FCT_USR_SELF_TEST	34
#define ic0senSOFT_FCT_USR_ERROR	35
#define ic0senSOFT_FCT_AVAIL	36
#define ic0senSOFT_FCT_UNAVAIL	37
#define ic0senSOFT_FCT_DISABLE	38
#define ic0senSOFT_FCT_ENABLE	39
#define ic0senSOFT_FCT_LOCK	40
#define ic0senSOFT_FCT_UNLOCK	41
#define ic0senSOFT_FCT_HANDSET	42
#define ic0senSOFT_FCT_HSET_OFF	43
#define ic0senSOFT_FCT_FIX_POS	44
#define ic0senSOFT_FCT_MOVE	45
#define ic0senSOFT_FCT_MOVE_REL	46
#define ic0senSOFT_FCT_SET	47
#define ic0senSOFT_FCT_CHECK	48
#define ic0senSOFT_FCT_WAIT	49
#define ic0senSOFT_FCT_USR_SET_MODE	50
#define ic0senSOFT_FCT_SETUP	51
#define ic0senSOFT_FCT_GET_VAL	52
#define ic0senSOFT_FCT_SET_VAL	53
#define ic0senSOFT_FCT_CFG_ELEM	54
#define ic0senSOFT_FCT_LOG_CONF	55
#define ic0senSOFT_FCT_GET_CONF	56
#define ic0senSOFT_FCT_RESET_PARAMETERS	57
#define ic0senSOFT_FCT_PARSE_PARAMETERS	58
#define ic0senSOFT_FCT_COMPARE_PARAMETERS	59
#define ic0senSOFT_FCT_COPY_PARAMETERS	60
#define ic0senSOFT_FCT_EXEC_PARAMETERS	61
#define ic0senSOFT_FCT_UPDATE_PARAMETERS	62
#define ic0senSOFT_FCT_GET_PARAM_SET_VALUE	63
#define ic0senSOFT_FCT_GET_PARAM_STATUS	64
#define ic0senSOFT_FCT_SET_PARAM	65
#define ic0senSOFT_FCT_SET_PARAM_STEP	66
#define ic0senSOFT_FCT_USR_EXEC_ACTION	67
#define ic0senSOFT_FCT_USR_SET_PARAMETER	68
#define ic0senSOFT_FCT_GET_VALUE_CODE	69
#define ic0senSOFT_FCT_GET_VALUE	70
#define ic0senSOFT_FCT_USR_GET_VALUE	71
#define ic0senSOFT_FCT_SET_VALUE	72
#define ic0senSOFT_FCT_USR_SET_VALUE	73
#define ic0senSOFT_FCT_GET_ARG	74
#define ic0senSOFT_FCT_MONITOR	75
#define ic0senSOFT_FCT_USR_MONITOR	76
#define ic0senSOFT_FCT_LOG_ACTION	77
#define ic0senSOFT_FCT_LOG_COMMENT	78
#define ic0senSOFT_FCT_LOG_PARAMETER	79
#define ic0senSOFT_FCT_LOG_RECOVERY	80
#define ic0senSOFT_FCT_LOG_TBL_PARAM	81
#define ic0senSOFT_FCT_LOG_UNFORSEEN	82
#define ic0senSOFT_FCT_HW_INIT	83
#define ic0senSOFT_FCT_HW_EXIT	84
#define ic0senSOFT_FCT_HW_STATUS	85
#define ic0senSOFT_FCT_HW_SETUP	86
#define ic0senSOFT_FCT_HW_GET_CONF	87
#define ic0senSOFT_FCT_HW_LOG_CONF	88
#define ic0senSOFT_FCT_LOG_STATUS	89

/*
 * automata states
 */
#define ic0senSOFT_STATE_NOSTATE	-1
#define ic0senSOFT_STATE_OFF	0
#define ic0senSOFT_STATE_LOADED	1
#define ic0senSOFT_STATE_STANDBY	2
#define ic0senSOFT_STATE_ONLINE	3

/*
 * automata substates
 */
#define ic0senSOFT_SUBSTATE_ERROR	0
#define ic0senSOFT_SUBSTATE_IDLE	1
#define ic0senSOFT_SUBSTATE_BUSY	2
#define ic0senSOFT_SUBSTATE_INITIALISING	3
#define ic0senSOFT_SUBSTATE_SHUTTING_DOWN	4
#define ic0senSOFT_SUBSTATE_STOPPING	5
#define ic0senSOFT_SUBSTATE_COLD_STARTING	6
#define ic0senSOFT_SUBSTATE_STARTING	7
#define ic0senSOFT_SUBSTATE_STOP	8

/*
 * automata events
 */
#define ic0senSOFT_EVENT_INIT	0
#define ic0senSOFT_EVENT_STANDBY	1
#define ic0senSOFT_EVENT_ONLINE	2
#define ic0senSOFT_EVENT_STOP	3
#define ic0senSOFT_EVENT_OFF	4
#define ic0senSOFT_EVENT_EXIT	5
#define ic0senSOFT_EVENT_STATE	6
#define ic0senSOFT_EVENT_STOP_SIM	7
#define ic0senSOFT_EVENT_STATUS	8
#define ic0senSOFT_EVENT_SIMULAT	9
#define ic0senSOFT_EVENT_TEST	10
#define ic0senSOFT_EVENT_SELFTST	11
#define ic0senSOFT_EVENT_AUTO_TBL	12
#define ic0senSOFT_EVENT_AUTO_RST	13
#define ic0senSOFT_EVENT_DISABLE	14
#define ic0senSOFT_EVENT_ENABLE	15
#define ic0senSOFT_EVENT_LOCK	16
#define ic0senSOFT_EVENT_UNLOCK	17
#define ic0senSOFT_EVENT_HANDSET	18
#define ic0senSOFT_EVENT_HSET_OFF	19
#define ic0senSOFT_EVENT_AVAIL	20
#define ic0senSOFT_EVENT_UNAVAIL	21
#define ic0senSOFT_EVENT_MOVE	22
#define ic0senSOFT_EVENT_MOVE_REL	23
#define ic0senSOFT_EVENT_SET	24
#define ic0senSOFT_EVENT_CHECK	25
#define ic0senSOFT_EVENT_WAIT	26
#define ic0senSOFT_EVENT_SETUP	27
#define ic0senSOFT_EVENT_CFG_ELEM	28
#define ic0senSOFT_EVENT_GET_VAL	29
#define ic0senSOFT_EVENT_SET_VAL	30
#define ic0senSOFT_EVENT_LOG_CONF	31
#define ic0senSOFT_EVENT_GET_CONF	32
#define ic0senSOFT_EVENT_MONITOR	33


/*
 * user variables
 */
typedef struct
    {
    vltBYTES16	name;
    vltBYTES32	description;
    vltINT32	flags;
    vltBYTES32	fits;
    } ic0senSOFT_SENSORS_FITS;

typedef struct
    {
    SEM_ID	 actionSequence;  /* used to guard hw. access */
    SEM_ID	 actionSetup;	  /* not used */
    vltINT16     lastGetCode;
    vltINT16     sensorsTblNum;
    ic0senSOFT_SENSORS_FITS* sensorsTbl;
    const char** sensorsNames;
    vltBYTES16*  sensorsPrefix;
    vltBYTES20*	 status;
    vltINT16	 statusNum;
    vltINT16	 flags;
    void*	 hwData;
    vltINT32	 logIdTime;
    } ic0senSOFT_USERVAR;


/*
 * function pointer types
 */
typedef ccsCOMPL_STAT (*ic0senSOFT_FCTPTR_SETUP)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    const char*	function[],	/* max. vltBYTES32[999] */
    IN    vltINT16	functionNum,
    IN    vltLOGICAL	noMove,
    IN    vltLOGICAL	check,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0senSOFT_FCTPTR_SET)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    const char*	position[],	/* max. vltBYTES32[999] */
    IN    vltINT16	positionNum,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0senSOFT_FCTPTR_MOVE)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    const char*	position[],	/* max. vltBYTES32[999] */
    IN    vltINT16	positionNum,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0senSOFT_FCTPTR_MOVE_REL)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    const char*	position[],	/* max. vltBYTES32[999] */
    IN    vltINT16	positionNum,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0senSOFT_FCTPTR_STATUS)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    const char*	function[],	/* max. vltBYTES32[999] */
    IN    vltINT16	functionNum,
    IN    vltLOGICAL	flag,
    IN    vltLOGICAL	header,
    IN    vltLOGICAL	conflog,
    IN    vltLOGICAL	opslog,
    IN    vltLOGICAL	condlog,
    OUT   char**	status,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0senSOFT_FCTPTR_GET_CONF)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltLOGICAL	allElements,
    OUT   char**	text,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0senSOFT_FCTPTR_LOG_CONF)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltLOGICAL	allElements,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0senSOFT_FCTPTR_INIT_OBJ)(
    INOUT egenOBJ*	obj,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0senSOFT_FCTPTR_EXIT_OBJ)(
    INOUT egenOBJ*	obj,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0senSOFT_FCTPTR_USR_INIT)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0senSOFT_FCTPTR_USR_STANDBY2ONLINE)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0senSOFT_FCTPTR_USR_ONLINE2STANDBY)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0senSOFT_FCTPTR_USR_STANDBY2LOADED)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0senSOFT_FCTPTR_USR_SET_MODE)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltINT32	cmd,
    IN    vltLOGICAL	available,
    IN    vltLOGICAL	enabled,
    IN    vltLOGICAL	simulation,
    IN    vltLOGICAL	handset,
    IN    vltLOGICAL	locked,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0senSOFT_FCTPTR_MONITOR)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0senSOFT_FCTPTR_USR_TEST)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0senSOFT_FCTPTR_USR_STATUS_CODE)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    const char*	text,
    IN    vltINT32	flags,
    OUT   vltINT32*	code,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0senSOFT_FCTPTR_USR_STATUS_VALUE)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltINT32	code,
    OUT   lcctooVALUE*	value,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0senSOFT_FCTPTR_USR_STATUS_LAST)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   vltINT16*	last,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0senSOFT_FCTPTR_HW_INIT)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    lccDEV_MODE	state,
    IN    vltLOGICAL	simulation,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0senSOFT_FCTPTR_HW_EXIT)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    lccDEV_MODE	state,
    IN    vltLOGICAL	simulation,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0senSOFT_FCTPTR_HW_STATUS)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    lccDEV_MODE	state,
    IN    vltLOGICAL	simulation,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0senSOFT_FCTPTR_HW_SETUP)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    const char*	function[],	/* max. vltBYTES32[999] */
    IN    vltINT16	functionNum,
    IN    vltLOGICAL	noMove,
    IN    vltLOGICAL	check,
    IN    vltLOGICAL	simulation,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0senSOFT_FCTPTR_HW_GET_CONF)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   char**	text,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0senSOFT_FCTPTR_HW_LOG_CONF)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*ic0senSOFT_FCTPTR_LOG_STATUS)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltLOGICAL	all,
    OUT   ccsERROR*	error);


/*
 * log function
 */
#define ic0senSoftLogData(obj, format, arg...) \
	{ \
	char tmpLogBuf[lcctooTMP_BUFFER_SIZE]; \
	\
	sprintf(tmpLogBuf, (format), ##arg); \
	logData("ic0sen", (obj)->id, tmpLogBuf); \
	}


/*
 * error functions
 */
#define ic0senErrReadOldb(p1,p2) \
	{ \
	lcctooLOG_0("ic0senERR_READ_OLDB: Device %s: Unable to read %s from OLDB.",(p1),(p2)); \
	errAdd(error,"ic0sen",ic0senERR_READ_OLDB,__FILE_LINE__,"%s,%s",(p1),(p2)); \
	}
#define ic0senErrWriteOldb(p1,p2) \
	{ \
	lcctooLOG_0("ic0senERR_WRITE_OLDB: Device %s: Unable to write %s to OLDB.",(p1),(p2)); \
	errAdd(error,"ic0sen",ic0senERR_WRITE_OLDB,__FILE_LINE__,"%s,%s",(p1),(p2)); \
	}
#define ic0senErrSensorConf(p1,p2) \
	{ \
	lcctooLOG_0("ic0senERR_SENSOR_CONF: Device %s: Invalid signal configuration (%s).",(p1),(p2)); \
	errAdd(error,"ic0sen",ic0senERR_SENSOR_CONF,__FILE_LINE__,"%s,%s",(p1),(p2)); \
	}
#define ic0senErrGeneral(p1,p2) \
	{ \
	lcctooLOG_0("ic0senERR_GENERAL: Device %s: %s.",(p1),(p2)); \
	errAdd(error,"ic0sen",ic0senERR_GENERAL,__FILE_LINE__,"%s,%s",(p1),(p2)); \
	}

/*
 * get object owner
 */
#define ic0senSoftGetOwner(obj) ((obj)->owner)


/*
 * attribute access functions
 */
#define ic0senSoftReadState(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0senSOFT_ATTR_STATE,(buf),(error))
#define ic0senSoftWriteState(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0senSOFT_ATTR_STATE,(void*) (buf),(error))
#define ic0senSoftReadSubstate(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0senSOFT_ATTR_SUBSTATE,(buf),(error))
#define ic0senSoftWriteSubstate(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0senSOFT_ATTR_SUBSTATE,(void*) (buf),(error))
#define ic0senSoftReadError(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0senSOFT_ATTR_ERROR,(buf),(error))
#define ic0senSoftWriteError(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0senSOFT_ATTR_ERROR,(void*) (buf),(error))
#define ic0senSoftReadInitialised(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0senSOFT_ATTR_INITIALISED,(buf),(error))
#define ic0senSoftWriteInitialised(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0senSOFT_ATTR_INITIALISED,(void*) (buf),(error))
#define ic0senSoftReadSimulation(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0senSOFT_ATTR_SIMULATION,(buf),(error))
#define ic0senSoftWriteSimulation(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0senSOFT_ATTR_SIMULATION,(void*) (buf),(error))
#define ic0senSoftReadDevice(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0senSOFT_ATTR_DEVICE,(buf),(error))
#define ic0senSoftWriteDevice(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0senSOFT_ATTR_DEVICE,(void*) (buf),(error))
#define ic0senSoftReadAvailable(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0senSOFT_ATTR_AVAILABLE,(buf),(error))
#define ic0senSoftWriteAvailable(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0senSOFT_ATTR_AVAILABLE,(void*) (buf),(error))
#define ic0senSoftReadEnabled(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0senSOFT_ATTR_ENABLED,(buf),(error))
#define ic0senSoftWriteEnabled(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0senSOFT_ATTR_ENABLED,(void*) (buf),(error))
#define ic0senSoftReadLocked(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0senSOFT_ATTR_LOCKED,(buf),(error))
#define ic0senSoftWriteLocked(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0senSOFT_ATTR_LOCKED,(void*) (buf),(error))
#define ic0senSoftReadHandset(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0senSOFT_ATTR_HANDSET,(buf),(error))
#define ic0senSoftWriteHandset(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0senSOFT_ATTR_HANDSET,(void*) (buf),(error))
#define ic0senSoftReadFixed(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0senSOFT_ATTR_FIXED,(buf),(error))
#define ic0senSoftWriteFixed(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0senSOFT_ATTR_FIXED,(void*) (buf),(error))
#define ic0senSoftReadFixPosSet(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0senSOFT_ATTR_FIX_POS_SET,(buf),(error))
#define ic0senSoftWriteFixPosSet(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0senSOFT_ATTR_FIX_POS_SET,(void*) (buf),(error))
#define ic0senSoftReadFixedPosition(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0senSOFT_ATTR_FIXED_POSITION,(buf),(error))
#define ic0senSoftWriteFixedPosition(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0senSOFT_ATTR_FIXED_POSITION,(void*) (buf),(error))
#define ic0senSoftReadFixedSimulation(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0senSOFT_ATTR_FIXED_SIMULATION,(buf),(error))
#define ic0senSoftWriteFixedSimulation(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0senSOFT_ATTR_FIXED_SIMULATION,(void*) (buf),(error))
#define ic0senSoftReadFixedLocked(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0senSOFT_ATTR_FIXED_LOCKED,(buf),(error))
#define ic0senSoftWriteFixedLocked(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0senSOFT_ATTR_FIXED_LOCKED,(void*) (buf),(error))
#define ic0senSoftReadPrefix(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0senSOFT_ATTR_PREFIX,(buf),(error))
#define ic0senSoftWritePrefix(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0senSOFT_ATTR_PREFIX,(void*) (buf),(error))
#define ic0senSoftReadParametersSize(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0senSOFT_ATTR_PARAMETERS_SIZE,(buf),(error))
#define ic0senSoftWriteParametersSize(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0senSOFT_ATTR_PARAMETERS_SIZE,(void*) (buf),(error))
#define ic0senSoftGetParametersSize(obj,num,error) \
	caiGetAttrInfo((obj)->attrs,ic0senSOFT_ATTR_PARAMETERS,NULL,NULL,(num),NULL, NULL,NULL,(error))
#define ic0senSoftReadParameters(obj,buf,firstRec,lastRec,firstFld,lastFld,error) \
	lcctooCaiRWTable((obj)->attrs,0,ic0senSOFT_ATTR_PARAMETERS,(buf),(firstRec),(lastRec),(firstFld),(lastFld),(error))
#define ic0senSoftWriteParameters(obj,buf,firstRec,lastRec,firstFld,lastFld,error) \
	lcctooCaiRWTable((obj)->attrs,1,ic0senSOFT_ATTR_PARAMETERS,(void*) (buf),(firstRec),(lastRec),(firstFld),(lastFld),(error))
#define ic0senSoftGetStatusSize(obj,num,error) \
	caiGetAttrInfo((obj)->attrs,ic0senSOFT_ATTR_STATUS,NULL,NULL,(num),NULL, NULL,NULL,(error))
#define ic0senSoftReadStatus(obj,buf,firstElt,lastElt,error) \
	caiRWVector((obj)->attrs,0,ic0senSOFT_ATTR_STATUS,(buf),(firstElt),(lastElt),(error))
#define ic0senSoftWriteStatus(obj,buf,firstElt,lastElt,error) \
	caiRWVector((obj)->attrs,1,ic0senSOFT_ATTR_STATUS,(void*) (buf),(firstElt),(lastElt),(error))
#define ic0senSoftGetStatusIndexSize(obj,num,error) \
	caiGetAttrInfo((obj)->attrs,ic0senSOFT_ATTR_STATUS_INDEX,NULL,NULL,(num),NULL, NULL,NULL,(error))
#define ic0senSoftReadStatusIndex(obj,buf,firstElt,lastElt,error) \
	caiRWVector((obj)->attrs,0,ic0senSOFT_ATTR_STATUS_INDEX,(buf),(firstElt),(lastElt),(error))
#define ic0senSoftWriteStatusIndex(obj,buf,firstElt,lastElt,error) \
	caiRWVector((obj)->attrs,1,ic0senSOFT_ATTR_STATUS_INDEX,(void*) (buf),(firstElt),(lastElt),(error))
#define ic0senSoftReadValuesSize(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0senSOFT_ATTR_VALUES_SIZE,(buf),(error))
#define ic0senSoftWriteValuesSize(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0senSOFT_ATTR_VALUES_SIZE,(void*) (buf),(error))
#define ic0senSoftGetValuesSize(obj,num,error) \
	caiGetAttrInfo((obj)->attrs,ic0senSOFT_ATTR_VALUES,NULL,NULL,(num),NULL, NULL,NULL,(error))
#define ic0senSoftReadValues(obj,buf,firstRec,lastRec,firstFld,lastFld,error) \
	lcctooCaiRWTable((obj)->attrs,0,ic0senSOFT_ATTR_VALUES,(buf),(firstRec),(lastRec),(firstFld),(lastFld),(error))
#define ic0senSoftWriteValues(obj,buf,firstRec,lastRec,firstFld,lastFld,error) \
	lcctooCaiRWTable((obj)->attrs,1,ic0senSOFT_ATTR_VALUES,(void*) (buf),(firstRec),(lastRec),(firstFld),(lastFld),(error))
#define ic0senSoftReadInitRestriction(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0senSOFT_ATTR_INIT_RESTRICTION,(buf),(error))
#define ic0senSoftWriteInitRestriction(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0senSOFT_ATTR_INIT_RESTRICTION,(void*) (buf),(error))
#define ic0senSoftReadMoveRestriction(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0senSOFT_ATTR_MOVE_RESTRICTION,(buf),(error))
#define ic0senSoftWriteMoveRestriction(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0senSOFT_ATTR_MOVE_RESTRICTION,(void*) (buf),(error))
#define ic0senSoftReadStopTimeout(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0senSOFT_ATTR_STOP_TIMEOUT,(buf),(error))
#define ic0senSoftWriteStopTimeout(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0senSOFT_ATTR_STOP_TIMEOUT,(void*) (buf),(error))
#define ic0senSoftReadSetValFct(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0senSOFT_ATTR_SET_VAL_FCT,(buf),(error))
#define ic0senSoftWriteSetValFct(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0senSOFT_ATTR_SET_VAL_FCT,(void*) (buf),(error))
#define ic0senSoftGetHelpTextSize(obj,num,error) \
	caiGetAttrInfo((obj)->attrs,ic0senSOFT_ATTR_HELP_TEXT,NULL,NULL,(num),NULL, NULL,NULL,(error))
#define ic0senSoftReadHelpText(obj,buf,firstElt,lastElt,error) \
	caiRWVector((obj)->attrs,0,ic0senSOFT_ATTR_HELP_TEXT,(buf),(firstElt),(lastElt),(error))
#define ic0senSoftWriteHelpText(obj,buf,firstElt,lastElt,error) \
	caiRWVector((obj)->attrs,1,ic0senSOFT_ATTR_HELP_TEXT,(void*) (buf),(firstElt),(lastElt),(error))
#define ic0senSoftReadParamStep(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0senSOFT_ATTR_PARAM_STEP,(buf),(error))
#define ic0senSoftWriteParamStep(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0senSOFT_ATTR_PARAM_STEP,(void*) (buf),(error))
#define ic0senSoftReadActionCommand(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0senSOFT_ATTR_ACTION_COMMAND,(buf),(error))
#define ic0senSoftWriteActionCommand(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0senSOFT_ATTR_ACTION_COMMAND,(void*) (buf),(error))
#define ic0senSoftReadActionStopReq(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0senSOFT_ATTR_ACTION_STOP_REQ,(buf),(error))
#define ic0senSoftWriteActionStopReq(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0senSOFT_ATTR_ACTION_STOP_REQ,(void*) (buf),(error))
#define ic0senSoftReadActionNoMove(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0senSOFT_ATTR_ACTION_NO_MOVE,(buf),(error))
#define ic0senSoftWriteActionNoMove(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0senSOFT_ATTR_ACTION_NO_MOVE,(void*) (buf),(error))
#define ic0senSoftReadActionCheck(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0senSOFT_ATTR_ACTION_CHECK,(buf),(error))
#define ic0senSoftWriteActionCheck(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0senSOFT_ATTR_ACTION_CHECK,(void*) (buf),(error))
#define ic0senSoftReadResetSetupCmd(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0senSOFT_ATTR_RESET_SETUP_CMD,(buf),(error))
#define ic0senSoftWriteResetSetupCmd(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0senSOFT_ATTR_RESET_SETUP_CMD,(void*) (buf),(error))
#define ic0senSoftReadSensorsPrefix(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0senSOFT_ATTR_SENSORS_PREFIX,(buf),(error))
#define ic0senSoftWriteSensorsPrefix(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0senSOFT_ATTR_SENSORS_PREFIX,(void*) (buf),(error))
#define ic0senSoftReadSensorsSize(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0senSOFT_ATTR_SENSORS_SIZE,(buf),(error))
#define ic0senSoftWriteSensorsSize(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0senSOFT_ATTR_SENSORS_SIZE,(void*) (buf),(error))
#define ic0senSoftGetSensorsSize(obj,num,error) \
	caiGetAttrInfo((obj)->attrs,ic0senSOFT_ATTR_SENSORS,NULL,NULL,(num),NULL, NULL,NULL,(error))
#define ic0senSoftReadSensors(obj,buf,firstRec,lastRec,firstFld,lastFld,error) \
	lcctooCaiRWTable((obj)->attrs,0,ic0senSOFT_ATTR_SENSORS,(buf),(firstRec),(lastRec),(firstFld),(lastFld),(error))
#define ic0senSoftWriteSensors(obj,buf,firstRec,lastRec,firstFld,lastFld,error) \
	lcctooCaiRWTable((obj)->attrs,1,ic0senSOFT_ATTR_SENSORS,(void*) (buf),(firstRec),(lastRec),(firstFld),(lastFld),(error))
#define ic0senSoftReadHwAccess(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0senSOFT_ATTR_HW_ACCESS,(buf),(error))
#define ic0senSoftWriteHwAccess(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0senSOFT_ATTR_HW_ACCESS,(void*) (buf),(error))
#define ic0senSoftGetLastSize(obj,num,error) \
	caiGetAttrInfo((obj)->attrs,ic0senSOFT_ATTR_LAST,NULL,NULL,(num),NULL, NULL,NULL,(error))
#define ic0senSoftReadLast(obj,buf,firstElt,lastElt,error) \
	caiRWVector((obj)->attrs,0,ic0senSOFT_ATTR_LAST,(buf),(firstElt),(lastElt),(error))
#define ic0senSoftWriteLast(obj,buf,firstElt,lastElt,error) \
	caiRWVector((obj)->attrs,1,ic0senSOFT_ATTR_LAST,(void*) (buf),(firstElt),(lastElt),(error))
#define ic0senSoftReadLastAccess(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0senSOFT_ATTR_LAST_ACCESS,(buf),(error))
#define ic0senSoftWriteLastAccess(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0senSOFT_ATTR_LAST_ACCESS,(void*) (buf),(error))
#define ic0senSoftReadMinAccess(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0senSOFT_ATTR_MIN_ACCESS,(buf),(error))
#define ic0senSoftWriteMinAccess(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0senSOFT_ATTR_MIN_ACCESS,(void*) (buf),(error))
#define ic0senSoftReadIc0senflag(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,ic0senSOFT_ATTR_IC0SENFLAG,(buf),(error))
#define ic0senSoftWriteIc0senflag(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,ic0senSOFT_ATTR_IC0SENFLAG,(void*) (buf),(error))
#define ic0senSoftGetAuto(obj,attrPtr,error) \
	SUCCESS; \
	memcpy((attrPtr), &(obj)->objs[ic0senSOFT_AUTOMATA], sizeof(egenOBJ)); \
	(attrPtr)->ldata = (obj)->ldata;


/*
 * class functions
 */
#define ic0senSoftGetVal(obj,devName,name,nameNum,status,error) \
	ic0devSoftGetVal((obj),(devName),(name),(nameNum),(status),(error))
#define ic0senSoftSetVal(obj,devName,name,nameNum,value,valueNum,error) \
	ic0devSoftSetVal((obj),(devName),(name),(nameNum),(value),(valueNum),(error))
#define ic0senSoftCfgElem(obj,devName,position,id,values,valuesNum,error) \
	ic0devSoftCfgElem((obj),(devName),(position),(id),(values),(valuesNum),(error))
#define ic0senSoftResetParameters(obj,devName,cmd,error) \
	ic0devSoftResetParameters((obj),(devName),(cmd),(error))
#define ic0senSoftParseParameters(obj,devName,cmd,params,paramsNum,noMove,check,error) \
	ic0devSoftParseParameters((obj),(devName),(cmd),(params),(paramsNum),(noMove),(check),(error))
#define ic0senSoftCompareParameters(obj,devName,cmd,equal,error) \
	ic0devSoftCompareParameters((obj),(devName),(cmd),(equal),(error))
#define ic0senSoftCopyParameters(obj,devName,error) \
	ic0devSoftCopyParameters((obj),(devName),(error))
#define ic0senSoftExecParameters(obj,devName,error) \
	ic0devSoftExecParameters((obj),(devName),(error))
#define ic0senSoftUpdateParameters(obj,devName,cache,error) \
	ic0devSoftUpdateParameters((obj),(devName),(cache),(error))
#define ic0senSoftGetParamSetValue(obj,devName,index,value,setCode,error) \
	ic0devSoftGetParamSetValue((obj),(devName),(index),(value),(setCode),(error))
#define ic0senSoftGetParamStatus(obj,devName,index,flags,status,error) \
	ic0devSoftGetParamStatus((obj),(devName),(index),(flags),(status),(error))
#define ic0senSoftSetParam(obj,devName,index,cmd,value,step,error) \
	ic0devSoftSetParam((obj),(devName),(index),(cmd),(value),(step),(error))
#define ic0senSoftSetParamStep(obj,devName,index,cmd,step,error) \
	ic0devSoftSetParamStep((obj),(devName),(index),(cmd),(step),(error))
#define ic0senSoftUsrExecAction(obj,devName,index,error) \
	ic0devSoftUsrExecAction((obj),(devName),(index),(error))
#define ic0senSoftUsrSetParameter(obj,devName,cmd,param1,param1SetCode,param2,param2SetCode,value,error) \
	ic0devSoftUsrSetParameter((obj),(devName),(cmd),(param1),(param1SetCode),(param2),(param2SetCode),(value),(error))
#define ic0senSoftGetValueCode(obj,devName,name,code,error) \
	ic0devSoftGetValueCode((obj),(devName),(name),(code),(error))
#define ic0senSoftGetValue(obj,devName,code,index,value,valueNum,error) \
	ic0devSoftGetValue((obj),(devName),(code),(index),(value),(valueNum),(error))
#define ic0senSoftUsrGetValue(obj,devName,valuesTable,valuesTableNum,code,index,value,valueNum,done,error) \
	ic0devSoftUsrGetValue((obj),(devName),(valuesTable),(valuesTableNum),(code),(index),(value),(valueNum),(done),(error))
#define ic0senSoftSetValue(obj,devName,code,index,value,valueNum,error) \
	ic0devSoftSetValue((obj),(devName),(code),(index),(value),(valueNum),(error))
#define ic0senSoftUsrSetValue(obj,devName,valuesTable,valuesTableNum,code,index,value,valueNum,done,error) \
	ic0devSoftUsrSetValue((obj),(devName),(valuesTable),(valuesTableNum),(code),(index),(value),(valueNum),(done),(error))
#define ic0senSoftGetArg(obj,devName,code,index,value,error) \
	ic0devSoftGetArg((obj),(devName),(code),(index),(value),(error))
#define ic0senSoftUsrMonitor(obj,devName,state,error) \
	ic0devSoftUsrMonitor((obj),(devName),(state),(error))
#define ic0senSoftLogAction(obj,devName,action,comment,error) \
	ic0devSoftLogAction((obj),(devName),(action),(comment),(error))
#define ic0senSoftLogComment(obj,devName,comment,error) \
	ic0devSoftLogComment((obj),(devName),(comment),(error))
#define ic0senSoftLogParameter(obj,devName,parameter,index,value,comment,error) \
	ic0devSoftLogParameter((obj),(devName),(parameter),(index),(value),(comment),(error))
#define ic0senSoftLogRecovery(obj,devName,comment,error) \
	ic0devSoftLogRecovery((obj),(devName),(comment),(error))
#define ic0senSoftLogTblParam(obj,devName,paramIndex,flags,comment,error) \
	ic0devSoftLogTblParam((obj),(devName),(paramIndex),(flags),(comment),(error))
#define ic0senSoftLogUnforseen(obj,devName,comment,error) \
	ic0devSoftLogUnforseen((obj),(devName),(comment),(error))
#define ic0senSoftUsrStop(obj,devName,req,error) \
	ic0devSoftUsrStop((obj),(devName),(req),(error))
#define ic0senSoftAvail(obj,devName,error) \
	lccdevCmdAvail((obj),(devName),(error))
#define ic0senSoftUnavail(obj,devName,error) \
	lccdevCmdUnavail((obj),(devName),(error))
#define ic0senSoftDisable(obj,devName,access,error) \
	lccdevCmdDisable((obj),(devName),(access),(error))
#define ic0senSoftEnable(obj,devName,access,error) \
	lccdevCmdEnable((obj),(devName),(access),(error))
#define ic0senSoftLock(obj,devName,error) \
	lccdevCmdLock((obj),(devName),(error))
#define ic0senSoftUnlock(obj,devName,error) \
	lccdevCmdUnlock((obj),(devName),(error))
#define ic0senSoftHandset(obj,devName,error) \
	lccdevCmdHandset((obj),(devName),(error))
#define ic0senSoftHsetOff(obj,devName,error) \
	lccdevCmdHsetOff((obj),(devName),(error))
#define ic0senSoftFixPos(obj,devName,position,positionNum,reset,error) \
	lccdevCmdFixPos((obj),(devName),(position),(positionNum),(reset),(error))
#define ic0senSoftCheck(obj,devName,status,error) \
	lccdevCmdCheck((obj),(devName),(status),(error))
#define ic0senSoftWait(obj,devName,timeout,error) \
	lccdevCmdWait((obj),(devName),(timeout),(error))
#define ic0senSoftUsrSimulat(obj,devName,error) \
	lccdevCmdUsrSimulat((obj),(devName),(error))
#define ic0senSoftUsrStopSim(obj,devName,error) \
	lccdevCmdUsrStopSim((obj),(devName),(error))
#define ic0senSoftUsrLoaded2Standby(obj,devName,error) \
	lccdevCmdUsrLoaded2Standby((obj),(devName),(error))
#define ic0senSoftStandby(obj,devName,error) \
	lccdevStdStandby((obj),(devName),(error))
#define ic0senSoftOnline(obj,devName,error) \
	lccdevStdOnline((obj),(devName),(error))
#define ic0senSoftOff(obj,devName,error) \
	lccdevStdOff((obj),(devName),(error))
#define ic0senSoftExit(obj,devName,error) \
	lccdevStdExit((obj),(devName),(error))
#define ic0senSoftState(obj,devName,state,error) \
	lccdevStdState((obj),(devName),(state),(error))
#define ic0senSoftSimulat(obj,devName,error) \
	lccdevStdSimulat((obj),(devName),(error))
#define ic0senSoftStopSim(obj,devName,error) \
	lccdevStdStopSim((obj),(devName),(error))
#define ic0senSoftInit(obj,devName,error) \
	lccdevStdInit((obj),(devName),(error))
#define ic0senSoftStop(obj,devName,error) \
	lccdevStdStop((obj),(devName),(error))
#define ic0senSoftTest(obj,devName,error) \
	lccdevStdTest((obj),(devName),(error))
#define ic0senSoftSelftst(obj,devName,error) \
	lccdevStdSelftst((obj),(devName),(error))
#define ic0senSoftAutoTbl(obj,devName,table,text,error) \
	lccdevStdAutoTbl((obj),(devName),(table),(text),(error))
#define ic0senSoftAutoRst(obj,devName,error) \
	lccdevStdAutoRst((obj),(devName),(error))
#define ic0senSoftLoaded2Stby(obj,devName,error) \
	lccdevStdLoaded2Stby((obj),(devName),(error))
#define ic0senSoftOnline2Stby(obj,devName,error) \
	lccdevStdOnline2Stby((obj),(devName),(error))
#define ic0senSoftExit1(obj,devName,error) \
	lccdevStdExit1((obj),(devName),(error))
#define ic0senSoftCheckDeviceName(obj,devName,error) \
	lccdevStdCheckDeviceName((obj),(devName),(error))
#define ic0senSoftBreak(obj,error) \
	lccdevStdBreak((obj),(error))
#define ic0senSoftUsrSelfTest(obj,devName,error) \
	lccdevStdUsrSelfTest((obj),(devName),(error))
#define ic0senSoftUsrError(obj,devName,error) \
	lccdevStdUsrError((obj),(devName),(error))

ccsCOMPL_STAT ic0senSoftSetup(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    const char*	function[],	/* max. vltBYTES32[999] */
    IN    vltINT16	functionNum,
    IN    vltLOGICAL	noMove,
    IN    vltLOGICAL	check,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0senSoftSet(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    const char*	position[],	/* max. vltBYTES32[999] */
    IN    vltINT16	positionNum,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0senSoftMove(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    const char*	position[],	/* max. vltBYTES32[999] */
    IN    vltINT16	positionNum,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0senSoftMoveRel(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    const char*	position[],	/* max. vltBYTES32[999] */
    IN    vltINT16	positionNum,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0senSoftStatus(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    const char*	function[],	/* max. vltBYTES32[999] */
    IN    vltINT16	functionNum,
    IN    vltLOGICAL	flag,
    IN    vltLOGICAL	header,
    IN    vltLOGICAL	conflog,
    IN    vltLOGICAL	opslog,
    IN    vltLOGICAL	condlog,
    OUT   char**	status,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0senSoftGetConf(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltLOGICAL	allElements,
    OUT   char**	text,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0senSoftLogConf(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltLOGICAL	allElements,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0senSoftInitObj(
    INOUT egenOBJ*	obj,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0senSoftExitObj(
    INOUT egenOBJ*	obj,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0senSoftUsrInit(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0senSoftUsrStandby2Online(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0senSoftUsrOnline2Standby(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0senSoftUsrStandby2Loaded(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0senSoftUsrSetMode(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltINT32	cmd,
    IN    vltLOGICAL	available,
    IN    vltLOGICAL	enabled,
    IN    vltLOGICAL	simulation,
    IN    vltLOGICAL	handset,
    IN    vltLOGICAL	locked,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0senSoftMonitor(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0senSoftUsrTest(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0senSoftUsrStatusCode(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    const char*	text,
    IN    vltINT32	flags,
    OUT   vltINT32*	code,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0senSoftUsrStatusValue(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltINT32	code,
    OUT   lcctooVALUE*	value,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0senSoftUsrStatusLast(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   vltINT16*	last,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0senSoftHwInit(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    lccDEV_MODE	state,
    IN    vltLOGICAL	simulation,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0senSoftHwExit(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    lccDEV_MODE	state,
    IN    vltLOGICAL	simulation,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0senSoftHwStatus(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    lccDEV_MODE	state,
    IN    vltLOGICAL	simulation,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0senSoftHwSetup(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    const char*	function[],	/* max. vltBYTES32[999] */
    IN    vltINT16	functionNum,
    IN    vltLOGICAL	noMove,
    IN    vltLOGICAL	check,
    IN    vltLOGICAL	simulation,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0senSoftHwGetConf(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   char**	text,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0senSoftHwLogConf(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0senSoftLogStatus(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltLOGICAL	all,
    OUT   ccsERROR*	error);


/*
 * virtual functions
 */
#define ic0senSoftVStandby(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_STANDBY)((obj)->fcts[ic0senSOFT_FCT_STANDBY]))) \
	 ((obj),(devName),(error))
#define ic0senSoftVOnline(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_ONLINE)((obj)->fcts[ic0senSOFT_FCT_ONLINE]))) \
	 ((obj),(devName),(error))
#define ic0senSoftVOff(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_OFF)((obj)->fcts[ic0senSOFT_FCT_OFF]))) \
	 ((obj),(devName),(error))
#define ic0senSoftVExit(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_EXIT)((obj)->fcts[ic0senSOFT_FCT_EXIT]))) \
	 ((obj),(devName),(error))
#define ic0senSoftVState(obj,devName,state,error) \
	(*((lccdevSTD_FCTPTR_STATE)((obj)->fcts[ic0senSOFT_FCT_STATE]))) \
	 ((obj),(devName),(state),(error))
#define ic0senSoftVSimulat(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_SIMULAT)((obj)->fcts[ic0senSOFT_FCT_SIMULAT]))) \
	 ((obj),(devName),(error))
#define ic0senSoftVStopSim(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_STOP_SIM)((obj)->fcts[ic0senSOFT_FCT_STOP_SIM]))) \
	 ((obj),(devName),(error))
#define ic0senSoftVStatus(obj,devName,function,functionNum,flag,header,conflog,opslog,condlog,status,error) \
	(*((ic0senSOFT_FCTPTR_STATUS)((obj)->fcts[ic0senSOFT_FCT_STATUS]))) \
	 ((obj),(devName),(function),(functionNum),(flag),(header),(conflog),(opslog),(condlog),(status),(error))
#define ic0senSoftVInit(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_INIT)((obj)->fcts[ic0senSOFT_FCT_INIT]))) \
	 ((obj),(devName),(error))
#define ic0senSoftVStop(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_STOP)((obj)->fcts[ic0senSOFT_FCT_STOP]))) \
	 ((obj),(devName),(error))
#define ic0senSoftVTest(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_TEST)((obj)->fcts[ic0senSOFT_FCT_TEST]))) \
	 ((obj),(devName),(error))
#define ic0senSoftVSelftst(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_SELFTST)((obj)->fcts[ic0senSOFT_FCT_SELFTST]))) \
	 ((obj),(devName),(error))
#define ic0senSoftVAutoTbl(obj,devName,table,text,error) \
	(*((lccdevSTD_FCTPTR_AUTO_TBL)((obj)->fcts[ic0senSOFT_FCT_AUTO_TBL]))) \
	 ((obj),(devName),(table),(text),(error))
#define ic0senSoftVAutoRst(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_AUTO_RST)((obj)->fcts[ic0senSOFT_FCT_AUTO_RST]))) \
	 ((obj),(devName),(error))
#define ic0senSoftVInitObj(obj,error) \
	(*((ic0senSOFT_FCTPTR_INIT_OBJ)((obj)->fcts[ic0senSOFT_FCT_INIT_OBJ]))) \
	 ((obj),(error))
#define ic0senSoftVExitObj(obj,error) \
	(*((ic0senSOFT_FCTPTR_EXIT_OBJ)((obj)->fcts[ic0senSOFT_FCT_EXIT_OBJ]))) \
	 ((obj),(error))
#define ic0senSoftVLoaded2Stby(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_LOADED2STBY)((obj)->fcts[ic0senSOFT_FCT_LOADED2STBY]))) \
	 ((obj),(devName),(error))
#define ic0senSoftVOnline2Stby(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_ONLINE2STBY)((obj)->fcts[ic0senSOFT_FCT_ONLINE2STBY]))) \
	 ((obj),(devName),(error))
#define ic0senSoftVExit1(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_EXIT1)((obj)->fcts[ic0senSOFT_FCT_EXIT1]))) \
	 ((obj),(devName),(error))
#define ic0senSoftVCheckDeviceName(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_CHECK_DEVICE_NAME)((obj)->fcts[ic0senSOFT_FCT_CHECK_DEVICE_NAME]))) \
	 ((obj),(devName),(error))
#define ic0senSoftVBreak(obj,error) \
	(*((lccdevSTD_FCTPTR_BREAK)((obj)->fcts[ic0senSOFT_FCT_BREAK]))) \
	 ((obj),(error))
#define ic0senSoftVUsrInit(obj,devName,error) \
	(*((ic0senSOFT_FCTPTR_USR_INIT)((obj)->fcts[ic0senSOFT_FCT_USR_INIT]))) \
	 ((obj),(devName),(error))
#define ic0senSoftVUsrLoaded2Standby(obj,devName,error) \
	(*((lccdevCMD_FCTPTR_USR_LOADED2STANDBY)((obj)->fcts[ic0senSOFT_FCT_USR_LOADED2STANDBY]))) \
	 ((obj),(devName),(error))
#define ic0senSoftVUsrStandby2Online(obj,devName,error) \
	(*((ic0senSOFT_FCTPTR_USR_STANDBY2ONLINE)((obj)->fcts[ic0senSOFT_FCT_USR_STANDBY2ONLINE]))) \
	 ((obj),(devName),(error))
#define ic0senSoftVUsrOnline2Standby(obj,devName,error) \
	(*((ic0senSOFT_FCTPTR_USR_ONLINE2STANDBY)((obj)->fcts[ic0senSOFT_FCT_USR_ONLINE2STANDBY]))) \
	 ((obj),(devName),(error))
#define ic0senSoftVUsrStandby2Loaded(obj,devName,error) \
	(*((ic0senSOFT_FCTPTR_USR_STANDBY2LOADED)((obj)->fcts[ic0senSOFT_FCT_USR_STANDBY2LOADED]))) \
	 ((obj),(devName),(error))
#define ic0senSoftVUsrStop(obj,devName,req,error) \
	(*((ic0devSOFT_FCTPTR_USR_STOP)((obj)->fcts[ic0senSOFT_FCT_USR_STOP]))) \
	 ((obj),(devName),(req),(error))
#define ic0senSoftVUsrSimulat(obj,devName,error) \
	(*((lccdevCMD_FCTPTR_USR_SIMULAT)((obj)->fcts[ic0senSOFT_FCT_USR_SIMULAT]))) \
	 ((obj),(devName),(error))
#define ic0senSoftVUsrStopSim(obj,devName,error) \
	(*((lccdevCMD_FCTPTR_USR_STOP_SIM)((obj)->fcts[ic0senSOFT_FCT_USR_STOP_SIM]))) \
	 ((obj),(devName),(error))
#define ic0senSoftVUsrStatusCode(obj,devName,text,flags,code,error) \
	(*((ic0senSOFT_FCTPTR_USR_STATUS_CODE)((obj)->fcts[ic0senSOFT_FCT_USR_STATUS_CODE]))) \
	 ((obj),(devName),(text),(flags),(code),(error))
#define ic0senSoftVUsrStatusLast(obj,devName,last,error) \
	(*((ic0senSOFT_FCTPTR_USR_STATUS_LAST)((obj)->fcts[ic0senSOFT_FCT_USR_STATUS_LAST]))) \
	 ((obj),(devName),(last),(error))
#define ic0senSoftVUsrStatusValue(obj,devName,code,value,error) \
	(*((ic0senSOFT_FCTPTR_USR_STATUS_VALUE)((obj)->fcts[ic0senSOFT_FCT_USR_STATUS_VALUE]))) \
	 ((obj),(devName),(code),(value),(error))
#define ic0senSoftVUsrTest(obj,devName,error) \
	(*((ic0senSOFT_FCTPTR_USR_TEST)((obj)->fcts[ic0senSOFT_FCT_USR_TEST]))) \
	 ((obj),(devName),(error))
#define ic0senSoftVUsrSelfTest(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_USR_SELF_TEST)((obj)->fcts[ic0senSOFT_FCT_USR_SELF_TEST]))) \
	 ((obj),(devName),(error))
#define ic0senSoftVUsrError(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_USR_ERROR)((obj)->fcts[ic0senSOFT_FCT_USR_ERROR]))) \
	 ((obj),(devName),(error))
#define ic0senSoftVAvail(obj,devName,error) \
	(*((lccdevCMD_FCTPTR_AVAIL)((obj)->fcts[ic0senSOFT_FCT_AVAIL]))) \
	 ((obj),(devName),(error))
#define ic0senSoftVUnavail(obj,devName,error) \
	(*((lccdevCMD_FCTPTR_UNAVAIL)((obj)->fcts[ic0senSOFT_FCT_UNAVAIL]))) \
	 ((obj),(devName),(error))
#define ic0senSoftVDisable(obj,devName,access,error) \
	(*((lccdevCMD_FCTPTR_DISABLE)((obj)->fcts[ic0senSOFT_FCT_DISABLE]))) \
	 ((obj),(devName),(access),(error))
#define ic0senSoftVEnable(obj,devName,access,error) \
	(*((lccdevCMD_FCTPTR_ENABLE)((obj)->fcts[ic0senSOFT_FCT_ENABLE]))) \
	 ((obj),(devName),(access),(error))
#define ic0senSoftVLock(obj,devName,error) \
	(*((lccdevCMD_FCTPTR_LOCK)((obj)->fcts[ic0senSOFT_FCT_LOCK]))) \
	 ((obj),(devName),(error))
#define ic0senSoftVUnlock(obj,devName,error) \
	(*((lccdevCMD_FCTPTR_UNLOCK)((obj)->fcts[ic0senSOFT_FCT_UNLOCK]))) \
	 ((obj),(devName),(error))
#define ic0senSoftVHandset(obj,devName,error) \
	(*((lccdevCMD_FCTPTR_HANDSET)((obj)->fcts[ic0senSOFT_FCT_HANDSET]))) \
	 ((obj),(devName),(error))
#define ic0senSoftVHsetOff(obj,devName,error) \
	(*((lccdevCMD_FCTPTR_HSET_OFF)((obj)->fcts[ic0senSOFT_FCT_HSET_OFF]))) \
	 ((obj),(devName),(error))
#define ic0senSoftVFixPos(obj,devName,position,positionNum,reset,error) \
	(*((lccdevCMD_FCTPTR_FIX_POS)((obj)->fcts[ic0senSOFT_FCT_FIX_POS]))) \
	 ((obj),(devName),(position),(positionNum),(reset),(error))
#define ic0senSoftVMove(obj,devName,position,positionNum,error) \
	(*((ic0senSOFT_FCTPTR_MOVE)((obj)->fcts[ic0senSOFT_FCT_MOVE]))) \
	 ((obj),(devName),(position),(positionNum),(error))
#define ic0senSoftVMoveRel(obj,devName,position,positionNum,error) \
	(*((ic0senSOFT_FCTPTR_MOVE_REL)((obj)->fcts[ic0senSOFT_FCT_MOVE_REL]))) \
	 ((obj),(devName),(position),(positionNum),(error))
#define ic0senSoftVSet(obj,devName,position,positionNum,error) \
	(*((ic0senSOFT_FCTPTR_SET)((obj)->fcts[ic0senSOFT_FCT_SET]))) \
	 ((obj),(devName),(position),(positionNum),(error))
#define ic0senSoftVCheck(obj,devName,status,error) \
	(*((lccdevCMD_FCTPTR_CHECK)((obj)->fcts[ic0senSOFT_FCT_CHECK]))) \
	 ((obj),(devName),(status),(error))
#define ic0senSoftVWait(obj,devName,timeout,error) \
	(*((lccdevCMD_FCTPTR_WAIT)((obj)->fcts[ic0senSOFT_FCT_WAIT]))) \
	 ((obj),(devName),(timeout),(error))
#define ic0senSoftVUsrSetMode(obj,devName,cmd,available,enabled,simulation,handset,locked,error) \
	(*((ic0senSOFT_FCTPTR_USR_SET_MODE)((obj)->fcts[ic0senSOFT_FCT_USR_SET_MODE]))) \
	 ((obj),(devName),(cmd),(available),(enabled),(simulation),(handset),(locked),(error))
#define ic0senSoftVSetup(obj,devName,function,functionNum,noMove,check,error) \
	(*((ic0senSOFT_FCTPTR_SETUP)((obj)->fcts[ic0senSOFT_FCT_SETUP]))) \
	 ((obj),(devName),(function),(functionNum),(noMove),(check),(error))
#define ic0senSoftVGetVal(obj,devName,name,nameNum,status,error) \
	(*((ic0devSOFT_FCTPTR_GET_VAL)((obj)->fcts[ic0senSOFT_FCT_GET_VAL]))) \
	 ((obj),(devName),(name),(nameNum),(status),(error))
#define ic0senSoftVSetVal(obj,devName,name,nameNum,value,valueNum,error) \
	(*((ic0devSOFT_FCTPTR_SET_VAL)((obj)->fcts[ic0senSOFT_FCT_SET_VAL]))) \
	 ((obj),(devName),(name),(nameNum),(value),(valueNum),(error))
#define ic0senSoftVCfgElem(obj,devName,position,id,values,valuesNum,error) \
	(*((ic0devSOFT_FCTPTR_CFG_ELEM)((obj)->fcts[ic0senSOFT_FCT_CFG_ELEM]))) \
	 ((obj),(devName),(position),(id),(values),(valuesNum),(error))
#define ic0senSoftVLogConf(obj,devName,allElements,error) \
	(*((ic0senSOFT_FCTPTR_LOG_CONF)((obj)->fcts[ic0senSOFT_FCT_LOG_CONF]))) \
	 ((obj),(devName),(allElements),(error))
#define ic0senSoftVGetConf(obj,devName,allElements,text,error) \
	(*((ic0senSOFT_FCTPTR_GET_CONF)((obj)->fcts[ic0senSOFT_FCT_GET_CONF]))) \
	 ((obj),(devName),(allElements),(text),(error))
#define ic0senSoftVResetParameters(obj,devName,cmd,error) \
	(*((ic0devSOFT_FCTPTR_RESET_PARAMETERS)((obj)->fcts[ic0senSOFT_FCT_RESET_PARAMETERS]))) \
	 ((obj),(devName),(cmd),(error))
#define ic0senSoftVParseParameters(obj,devName,cmd,params,paramsNum,noMove,check,error) \
	(*((ic0devSOFT_FCTPTR_PARSE_PARAMETERS)((obj)->fcts[ic0senSOFT_FCT_PARSE_PARAMETERS]))) \
	 ((obj),(devName),(cmd),(params),(paramsNum),(noMove),(check),(error))
#define ic0senSoftVCompareParameters(obj,devName,cmd,equal,error) \
	(*((ic0devSOFT_FCTPTR_COMPARE_PARAMETERS)((obj)->fcts[ic0senSOFT_FCT_COMPARE_PARAMETERS]))) \
	 ((obj),(devName),(cmd),(equal),(error))
#define ic0senSoftVCopyParameters(obj,devName,error) \
	(*((ic0devSOFT_FCTPTR_COPY_PARAMETERS)((obj)->fcts[ic0senSOFT_FCT_COPY_PARAMETERS]))) \
	 ((obj),(devName),(error))
#define ic0senSoftVExecParameters(obj,devName,error) \
	(*((ic0devSOFT_FCTPTR_EXEC_PARAMETERS)((obj)->fcts[ic0senSOFT_FCT_EXEC_PARAMETERS]))) \
	 ((obj),(devName),(error))
#define ic0senSoftVUpdateParameters(obj,devName,cache,error) \
	(*((ic0devSOFT_FCTPTR_UPDATE_PARAMETERS)((obj)->fcts[ic0senSOFT_FCT_UPDATE_PARAMETERS]))) \
	 ((obj),(devName),(cache),(error))
#define ic0senSoftVGetParamSetValue(obj,devName,index,value,setCode,error) \
	(*((ic0devSOFT_FCTPTR_GET_PARAM_SET_VALUE)((obj)->fcts[ic0senSOFT_FCT_GET_PARAM_SET_VALUE]))) \
	 ((obj),(devName),(index),(value),(setCode),(error))
#define ic0senSoftVGetParamStatus(obj,devName,index,flags,status,error) \
	(*((ic0devSOFT_FCTPTR_GET_PARAM_STATUS)((obj)->fcts[ic0senSOFT_FCT_GET_PARAM_STATUS]))) \
	 ((obj),(devName),(index),(flags),(status),(error))
#define ic0senSoftVSetParam(obj,devName,index,cmd,value,step,error) \
	(*((ic0devSOFT_FCTPTR_SET_PARAM)((obj)->fcts[ic0senSOFT_FCT_SET_PARAM]))) \
	 ((obj),(devName),(index),(cmd),(value),(step),(error))
#define ic0senSoftVSetParamStep(obj,devName,index,cmd,step,error) \
	(*((ic0devSOFT_FCTPTR_SET_PARAM_STEP)((obj)->fcts[ic0senSOFT_FCT_SET_PARAM_STEP]))) \
	 ((obj),(devName),(index),(cmd),(step),(error))
#define ic0senSoftVUsrExecAction(obj,devName,index,error) \
	(*((ic0devSOFT_FCTPTR_USR_EXEC_ACTION)((obj)->fcts[ic0senSOFT_FCT_USR_EXEC_ACTION]))) \
	 ((obj),(devName),(index),(error))
#define ic0senSoftVUsrSetParameter(obj,devName,cmd,param1,param1SetCode,param2,param2SetCode,value,error) \
	(*((ic0devSOFT_FCTPTR_USR_SET_PARAMETER)((obj)->fcts[ic0senSOFT_FCT_USR_SET_PARAMETER]))) \
	 ((obj),(devName),(cmd),(param1),(param1SetCode),(param2),(param2SetCode),(value),(error))
#define ic0senSoftVGetValueCode(obj,devName,name,code,error) \
	(*((ic0devSOFT_FCTPTR_GET_VALUE_CODE)((obj)->fcts[ic0senSOFT_FCT_GET_VALUE_CODE]))) \
	 ((obj),(devName),(name),(code),(error))
#define ic0senSoftVGetValue(obj,devName,code,index,value,valueNum,error) \
	(*((ic0devSOFT_FCTPTR_GET_VALUE)((obj)->fcts[ic0senSOFT_FCT_GET_VALUE]))) \
	 ((obj),(devName),(code),(index),(value),(valueNum),(error))
#define ic0senSoftVUsrGetValue(obj,devName,valuesTable,valuesTableNum,code,index,value,valueNum,done,error) \
	(*((ic0devSOFT_FCTPTR_USR_GET_VALUE)((obj)->fcts[ic0senSOFT_FCT_USR_GET_VALUE]))) \
	 ((obj),(devName),(valuesTable),(valuesTableNum),(code),(index),(value),(valueNum),(done),(error))
#define ic0senSoftVSetValue(obj,devName,code,index,value,valueNum,error) \
	(*((ic0devSOFT_FCTPTR_SET_VALUE)((obj)->fcts[ic0senSOFT_FCT_SET_VALUE]))) \
	 ((obj),(devName),(code),(index),(value),(valueNum),(error))
#define ic0senSoftVUsrSetValue(obj,devName,valuesTable,valuesTableNum,code,index,value,valueNum,done,error) \
	(*((ic0devSOFT_FCTPTR_USR_SET_VALUE)((obj)->fcts[ic0senSOFT_FCT_USR_SET_VALUE]))) \
	 ((obj),(devName),(valuesTable),(valuesTableNum),(code),(index),(value),(valueNum),(done),(error))
#define ic0senSoftVGetArg(obj,devName,code,index,value,error) \
	(*((ic0devSOFT_FCTPTR_GET_ARG)((obj)->fcts[ic0senSOFT_FCT_GET_ARG]))) \
	 ((obj),(devName),(code),(index),(value),(error))
#define ic0senSoftVMonitor(obj,devName,error) \
	(*((ic0senSOFT_FCTPTR_MONITOR)((obj)->fcts[ic0senSOFT_FCT_MONITOR]))) \
	 ((obj),(devName),(error))
#define ic0senSoftVUsrMonitor(obj,devName,state,error) \
	(*((ic0devSOFT_FCTPTR_USR_MONITOR)((obj)->fcts[ic0senSOFT_FCT_USR_MONITOR]))) \
	 ((obj),(devName),(state),(error))
#define ic0senSoftVLogAction(obj,devName,action,comment,error) \
	(*((ic0devSOFT_FCTPTR_LOG_ACTION)((obj)->fcts[ic0senSOFT_FCT_LOG_ACTION]))) \
	 ((obj),(devName),(action),(comment),(error))
#define ic0senSoftVLogComment(obj,devName,comment,error) \
	(*((ic0devSOFT_FCTPTR_LOG_COMMENT)((obj)->fcts[ic0senSOFT_FCT_LOG_COMMENT]))) \
	 ((obj),(devName),(comment),(error))
#define ic0senSoftVLogParameter(obj,devName,parameter,index,value,comment,error) \
	(*((ic0devSOFT_FCTPTR_LOG_PARAMETER)((obj)->fcts[ic0senSOFT_FCT_LOG_PARAMETER]))) \
	 ((obj),(devName),(parameter),(index),(value),(comment),(error))
#define ic0senSoftVLogRecovery(obj,devName,comment,error) \
	(*((ic0devSOFT_FCTPTR_LOG_RECOVERY)((obj)->fcts[ic0senSOFT_FCT_LOG_RECOVERY]))) \
	 ((obj),(devName),(comment),(error))
#define ic0senSoftVLogTblParam(obj,devName,paramIndex,flags,comment,error) \
	(*((ic0devSOFT_FCTPTR_LOG_TBL_PARAM)((obj)->fcts[ic0senSOFT_FCT_LOG_TBL_PARAM]))) \
	 ((obj),(devName),(paramIndex),(flags),(comment),(error))
#define ic0senSoftVLogUnforseen(obj,devName,comment,error) \
	(*((ic0devSOFT_FCTPTR_LOG_UNFORSEEN)((obj)->fcts[ic0senSOFT_FCT_LOG_UNFORSEEN]))) \
	 ((obj),(devName),(comment),(error))
#define ic0senSoftVHwInit(obj,devName,state,simulation,error) \
	(*((ic0senSOFT_FCTPTR_HW_INIT)((obj)->fcts[ic0senSOFT_FCT_HW_INIT]))) \
	 ((obj),(devName),(state),(simulation),(error))
#define ic0senSoftVHwExit(obj,devName,state,simulation,error) \
	(*((ic0senSOFT_FCTPTR_HW_EXIT)((obj)->fcts[ic0senSOFT_FCT_HW_EXIT]))) \
	 ((obj),(devName),(state),(simulation),(error))
#define ic0senSoftVHwStatus(obj,devName,state,simulation,error) \
	(*((ic0senSOFT_FCTPTR_HW_STATUS)((obj)->fcts[ic0senSOFT_FCT_HW_STATUS]))) \
	 ((obj),(devName),(state),(simulation),(error))
#define ic0senSoftVHwSetup(obj,devName,function,functionNum,noMove,check,simulation,error) \
	(*((ic0senSOFT_FCTPTR_HW_SETUP)((obj)->fcts[ic0senSOFT_FCT_HW_SETUP]))) \
	 ((obj),(devName),(function),(functionNum),(noMove),(check),(simulation),(error))
#define ic0senSoftVHwGetConf(obj,devName,text,error) \
	(*((ic0senSOFT_FCTPTR_HW_GET_CONF)((obj)->fcts[ic0senSOFT_FCT_HW_GET_CONF]))) \
	 ((obj),(devName),(text),(error))
#define ic0senSoftVHwLogConf(obj,devName,error) \
	(*((ic0senSOFT_FCTPTR_HW_LOG_CONF)((obj)->fcts[ic0senSOFT_FCT_HW_LOG_CONF]))) \
	 ((obj),(devName),(error))
#define ic0senSoftVLogStatus(obj,devName,all,error) \
	(*((ic0senSOFT_FCTPTR_LOG_STATUS)((obj)->fcts[ic0senSOFT_FCT_LOG_STATUS]))) \
	 ((obj),(devName),(all),(error))


ccsCOMPL_STAT ic0senSoftNewObj(
    IN    dbSYMADDRESS	point,
    IN    egenOBJ*	owner,
    OUT   egenOBJ*	obj,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT ic0senSoftDeleteObj(
    INOUT egenOBJ*	obj,
    OUT   ccsERROR*	error);


ccsCOMPL_STAT ic0senSoftGetSensorsUsedSize(
    INOUT egenOBJ*	obj,
    OUT   vltINT16*	num,
    OUT   ccsERROR*	error);


#endif // !IC0SEN_SOFT_H

/************************************************************************/
/* ___oOo___ */
