#ifndef IKON_H
#define IKON_H
/******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: ikon.h,v 2.5 2003/07/24 13:22:48 vltsccm Exp $" 
*
* ikon.h - Public header of IKON driver
*
* who        when       what
* ---------- ---------- ----------------------------------------------
* S.Sandrock 06.03.1995 created
* S.Sandrock 06.03.1996 extended for firmware "246 118 02"
*/


#include "lcudrvPublic.h"
#include "ikonCommands.h"
#include "ikonErrors.h"

/*
 * IKON driver provided functions
 */
extern int ikonDrv(int nDevices, 
		   int nChannels, 
		   int timeout);

extern int ikonDevCreate(const char *devName, 
			 void       *baseAddrA24, 
			 void       *baseAddrA16,
			 int        intrNumber,
			 int        intrLevel,
			 int        initialP30,
			 int        versionHW,
			 const char *versionSW,
			 const char *coreFile);

/*
 * IKON tools
 */
extern int ikonVersion(void);
#if 0
int ikonDevShow(const char* devName); /* this declaration only for lcudrvTk */
#endif
extern int ikonDevShow(const char* devName, int more, int reset);
extern int ikonPosShow(const char* devName);
extern int ikonDataShow(const char* devName);
extern int ikonParamShow(const char* devName);

/*
 * IKON support functions
 */
extern int ikonCoreSave(const char *devName, const char *fileName);
extern int ikonCoreSaveX1(const char *devName, const char *fileName);
extern int ikonCoreSaveX2(const char *devName, const char *fileName);
extern int ikonCoreLoad(const char *devName, const char *fileName);
extern int ikonCoreSaveFd(int devFd, int fileFd, int what);
extern int ikonCoreLoadFd(int devFd, int fileFd, int dummy);

#endif /* !IKON_H */
