#ifndef IKON_ERRORS_H
#define IKON_ERRORS_H
/******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: ikonErrors.h,v 2.5 2003/07/24 13:22:49 vltsccm Exp $" 
*
* ikonErrors.h - error literals of IKON driver
*
* who        when       what
* ---------- ---------- ----------------------------------------------
* S.Sandrock 06.03.1995 created
* S.Sandrock 06.03.1996 extended for firmware "246 118 02"
*/

/*
 * Initialization Errors:
 */
#define ikonERROR_POST_FAILED		-100
#define ikonERROR_REF_MOVE_IN_PROGRESS	-110
#define ikonERROR_REF_MOVE_FAILED	-111

/*
 * Parameters Errors:
 */
#define ikonERROR_INV_PARAM_SPEC	-200
#define ikonERROR_INV_PARAM_VALUE	-201


/*
 * Position Errors:
 */
#define ikonERROR_POS_NOT_AVAILABLE	-300
#define ikonERROR_POS_STATUS		-301
#define ikonERROR_POS_CONVERSION	-302
/* Position Warnings due to asynchronous error-interrupts:	*/
/* Note that the returned position may be valid although!	*/
#define ikonERROR_POS_STATUS_WARNING	-303

/*
 * Correction Table Operations Errors:
 */
#define ikonERROR_CORR_IN_PROGRESS	-500
#define ikonERROR_CORR_NO_REF		-501
#define ikonERROR_CORR_INV_SPEED	-502
#define ikonERROR_CORR_INV_POSITION	-503
#define ikonERROR_CORR_INV_DIRECTION	-504
#define ikonERROR_CORR_MEASURE_FAILED	-505
#define ikonERROR_CORR_CALC_FAILED	-506
#define ikonERROR_CORR_INTERNAL_MEM	-507
#define ikonERROR_CORR_INTERNAL_CTR	-508

#define ikonERROR_CORR_CALC_IN_PROGRESS	-510
#define ikonERROR_CORR_BCC		-511
#define ikonERROR_CORR_RECORD_NUMBER	-512
#define ikonERROR_CORR_NO_DATA		-513
#define ikonERROR_CORR_CHANNEL		-514
#define ikonERROR_CORR_UNKNOWN		-599

/*
 * Driver Commands Errors:
 */
#define ikonERROR_NOT_EXCLUSIVE		-904

/*
 * Device Layer Errors:
 */
#define ikonERROR_DEVICE_DEAD		-1000
#define ikonERROR_COMMAND_TIMEOUT	-1001
#define ikonERROR_INTERNAL		-1002

#endif /* !IKON_ERRORS_H */
