#ifndef INMOS_H
#define INMOS_H
/*************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: inmos.h,v 1.14 2005/06/22 12:40:13 vltsccm Exp $"
*
* inmos.h
*
* who        when      what
* --------   --------  ----------------------------------------------
* INMOS Ltd. XX/XX/88  created for Unix
* J.Ayasse   13/08/93  VxWorks Version
* C.Cumani   04/08/94  function prototypes added
* C.Cumani   07/10/94  standard header added
* C.Cumani   19/12/94  inmosVERSION = 1.1.2
* C.Cumani   26/09/95  - made compatible with CMM
*                      - inmosVERSION_DATE, inmosMOD_NAME, inmosMOD_DESC
*                        definitions added
*                      - inmosVersion() function prototype added
* C.Cumani   03/03/96  - inmosVERSION_DATE set to "FEB96"
* C.Cumani   26/08/97  - inmosVERSION_DATE set to "NOV97"
*
*/

/*************************************************************************
*  This file contains the definitions of the inmos module.
*************************************************************************/

#include "ccs.h"

#ifndef BYTE
#define BYTE unsigned char
#endif
#define BOOL int

#ifdef MSC
#define INT32 long
#else
#define INT32 int
#endif

#ifdef sun3
#define BIG_ENDIAN
#else
#ifdef sun4
#define BIG_ENDIAN
#else
#ifdef VXWORKS
#define BIG_ENDIAN
#else
#define LITTLE_ENDIAN
#endif
#endif
#endif

#ifndef TRUE 
#define TRUE 1
#endif
#ifndef FALSE 
#define FALSE 0
#endif

#ifndef PUBLIC
#define PUBLIC
#endif
#ifndef PRIVATE
#define PRIVATE static
#endif
#define VOID void
#define EXTERN extern

#define LINK int

#define inmosVERSION        "$Revision: 1.14 $"
#define inmosVERSION_DATE   "NOV97"
#define inmosMOD_NAME       "inmos"
#define inmosMOD_DESC       "VxWorks Inmos occam2 package module"

/*
static char Copyright[] = "Copyright (c) INMOS Ltd, 1988.  All Rights Reserved.\n";
 */

/*
 * Function prototypes
 */

int inmosCheck (char *arg1, char *arg2, char *arg3, char *arg4, char *arg5,
                char *arg6, char *arg7, char *arg8, char *arg9, char *arg10);

int inmosLoad  (char *arg1, char *arg2, char *arg3, char *arg4, char *arg5,
                char *arg6, char *arg7, char *arg8, char *arg9, char *arg10);

int inmosMtest (char *arg1, char *arg2, char *arg3, char *arg4, char *arg5,
                char *arg6, char *arg7, char *arg8, char *arg9, char *arg10);

void inmosF    (char *arg1, char *arg2, char *arg3, char *arg4, char *arg5,
                char *arg6, char *arg7, char *arg8, char *arg9, char *arg10);

void idebug    (char *arg1, char *arg2, char *arg3, char *arg4, char *arg5,
                char *arg6, char *arg7, char *arg8, char *arg9, char *arg10);

void idump     (char *arg1, char *arg2, char *arg3, char *arg4, char *arg5,
                char *arg6, char *arg7, char *arg8, char *arg9, char *arg10);
            
void iskip     (char *arg1, char *arg2, char *arg3, char *arg4, char *arg5,
                char *arg6, char *arg7, char *arg8, char *arg9, char *arg10);

int iserver    (char *arg1, char *arg2, char *arg3, char *arg4, char *arg5,
                char *arg6, char *arg7, char *arg8, char *arg9, char *arg10);

int iserver2   (char *arg1, char *arg2, char *arg3, char *arg4, char *arg5,
                char *arg6, char *arg7, char *arg8, char *arg9, char *arg10);

int iserver3   (char *arg1, char *arg2, char *arg3, char *arg4, char *arg5,
                char *arg6, char *arg7, char *arg8, char *arg9, char *arg10);

ccsCOMPL_STAT inmosVersion ( vltBYTES80 version );

#endif /*!INMOS_H*/
