#ifndef IRVME_H
#define IRVME_H
/******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: irvme.h,v 1.7 2005/09/12 08:08:38 vltsccm Exp $" 
*
* irvme.h  - This is the interface file for the IRACE VME-BUS device driver. 
*            It contains the declarations user available constants, data 
*            types and variables as well as the
*            function prototypes.
*
* who        when       what
* ---------  ---------- ----------------------------------------------
* jstegmei   14/11/00   created
*/

#include "iosLib.h"
#include "lcudrvPublic.h"      /* Include common driver literals */
#include "irvmeCommands.h"     /* Include irvme command definitions */
#include "irvmeErrors.h"       /* Include irvme error codes and literals */

/*
 * Driver version
 */
#define irvmeVERSION "@(#) irvme $Revision: 1.7 $"

#ifdef __cplusplus
extern "C" {
#endif

/*
 * IRVME driver provided functions
 */
int irvmeDrv(int devices, int channels, int timeout);
int irvmeDrvRemove(void);
int irvmeDevCreate(char *name, int addrSpace, int dmaWidth, void *baseAddr, 
		   int intrNumber, int intrLevel);
int irvmeDevDelete(int unit);

/*
 * IRVME tool functions
 */
void irvmeVersion(void);
void irvmeDevShow(void);
u_long irvmeBlockSize(u_long dataSize, u_long fifoSize, u_short bpw);
const char *irvmeTransferStat2Str(u_long transferStatus);
const char *irvmeErrorGet(int status);
void *irvmeMalloc(unsigned int size);

#ifdef __cplusplus
}
#endif

#endif /* !IRVME_H */

/* __oOo__ */
