#ifndef IRVME_CAPTURE_H
#define IRVME_CAPTURE_H
/******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: irvmeCapture.h,v 1.7 2005/09/12 08:08:38 vltsccm Exp $" 
*
* irvmeCapture.h - Data capture routines for irvme interface
*
* who        when       what
* ---------  ---------- ----------------------------------------------
* jstegmei   14/11/00   created
*/

#include "irvme.h"  

#ifdef __cplusplus
extern "C" {
#endif

/*
 * IRVME data capture functions
 */
int irvmeInit(const char *devName, char *erms);
int irvmeReset(int channel, int hdr, char *erms);
int irvmeConfig(int channel, void **buffer, int size, char *erms);
SEM_ID irvmeStart(int channel, irvmeUSR_ISR userISR, void *userArg,
		  char *erms);
int irvmeStop(int channel, char *erms);
int irvmeWait(int channel, SEM_ID semISR, int timeout, char *erms);
int irvmeAck(int channel, char *erms);
int irvmeRelease(int channel, char *erms);

#ifdef __cplusplus
}
#endif

#endif /* !IRVME_CAPTURE_H */

/* __oOo__ */
