#ifndef IRVME_SOCK_H
#define IRVME_SOCK_H

/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: irvmeSock.h,v 1.7 2005/09/12 08:08:39 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* jstegmei  20/12/00  created
*/

/************************************************************************
 *
 *  irvmeSock.h  - socket interface
 *
 *----------------------------------------------------------------------
 */


/*
 * Default timeouts in seconds
 */
#define irvmeSOCK_DEFAULT_TIMEOUT  5  
#define irvmeSOCK_CONNECT_TIMEOUT -1  /* no timeout */

/*
 * Buffer sizes
 */
#define irvmeSOCK_MAX_PKTLEN     (1024 * 32)

/*
 * Maximum number of client sockets
 */
#define irvmeSOCK_MAX_CLIENT     4

#ifdef __cplusplus
extern "C" {
#endif

/*
 * Prototypes
 */
int  irvmeSockSrvOpen(int portNum, char *erms);
int  irvmeSockSrvConnect(int sock, char *erms);
int  irvmeSockClientOpen(char *srvName, char *erms);
int  irvmeSockClose(int sock);
int  irvmeSockRead(int sock, char *buffer, int size, char *erms);
int  irvmeSockWrite(int sock, const char *buffer, int size, char *erms);
int  irvmeSockWait(int sock, int timeout, char *erms);
int  irvmeSockPort(int sock);
BOOL irvmeSockCheck(int sock);

#ifdef __cplusplus
}
#endif

#endif /*!IRVME_SOCK_H*/
