#ifndef LCC_MEMORY_TRACE_H
#define LCC_MEMORY_TRACE_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: lccMemoryTrace.h,v 4.97.1.1 2005/10/24 13:55:53 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* bgustafs  05/07/99  made include file C++ compliant
* P.Duhoux  11/03/97  created
* P.Duhoux  11/06/97  Added functions calloc and realloc
*/

#ifdef __cplusplus
extern "C" {
#endif

#ifndef __FILE_LINE__
#define _lccMemoryTrace_tostr(a) #a
#define _lccMemoryTrace_tostr_pass2(a) _lccMemoryTrace_tostr(a)

#define __FILE_LINE__  __FILE__ ":" _lccMemoryTrace_tostr_pass2(__LINE__)
#endif

/************************************************************************
 * Include for LCU memory usage trace
 *----------------------------------------------------------------------
 */
void    lccPrintMemory(void);
void   *lccRealloc(char *fn, void   *p, size_t n);
void   *lccCalloc (char *fn, size_t  n, size_t s);
void   *lccMalloc (char *fn, size_t  n);
void    lccFree   (char *fn, void   *p);

#define realloc(p,n) lccRealloc(__FILE_LINE__,(p),(n))
#define calloc(n,s)  lccCalloc(__FILE_LINE__,(n),(s))
#define malloc(n)    lccMalloc(__FILE_LINE__,(n))
#define free(p)      lccFree(__FILE_LINE__,(p))

#ifdef __cplusplus
}
#endif

#endif /*!LCC_MEMORY_TRACE_H*/
