/******************************************************************************
*  E.S.O. - VLT project
* 
*  "@(#) $Id: lccdevStd.h,v 1.18 2003/12/05 12:07:46 vltsccm Exp $"
* 
*  who        when      what
*  ---------- --------  ----------------------------------------------
*  rschmutzer 02/09/95  Created by eccsgen V0.45 (September 1995)
*
*
*    !!!!!!!!!  CAUTION: THIS FILE IS UPDATED BY ECCSGEN  !!!!!!!!!
*/

/*************************************************************************
*   NAME
*	lccdevStd - LCC Software Device
*
*   SYNOPSIS
*	#include "lccdevStd.h"
*
*	ccsCOMPL_STAT lccdevStdNewObj(
*	    IN    dbSYMADDRESS	point,
*	    IN    egenOBJ*	owner,
*	    OUT   egenOBJ*	obj,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT lccdevStdDeleteObj(
*	    INOUT egenOBJ*	obj,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT lccdevStdStandby(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT lccdevStdOnline(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT lccdevStdOff(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT lccdevStdExit(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT lccdevStdState(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    OUT   char**	state,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT lccdevStdSimulat(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT lccdevStdStopSim(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT lccdevStdStatus(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    const char*	function[],	** max. vltBYTES32[999]
*	    IN    vltINT16	functionNum,
*	    IN    vltLOGICAL	flag,
*	    IN    vltLOGICAL	header,
*	    IN    vltLOGICAL	conflog,
*	    IN    vltLOGICAL	opslog,
*	    IN    vltLOGICAL	condlog,
*	    OUT   char**	status,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT lccdevStdInit(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT lccdevStdStop(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT lccdevStdTest(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT lccdevStdSelftst(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT lccdevStdAutoTbl(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    const char*	table,
*	    OUT   char**	text,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT lccdevStdAutoRst(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT lccdevStdInitObj(
*	    INOUT egenOBJ*	obj,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT lccdevStdExitObj(
*	    INOUT egenOBJ*	obj,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT lccdevStdLoaded2Stby(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT lccdevStdOnline2Stby(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT lccdevStdExit1(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT lccdevStdCheckDeviceName(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT lccdevStdBreak(
*	    INOUT egenOBJ*	obj,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT lccdevStdUsrInit(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT lccdevStdUsrLoaded2Standby(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT lccdevStdUsrStandby2Online(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT lccdevStdUsrOnline2Standby(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT lccdevStdUsrStandby2Loaded(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT lccdevStdUsrStop(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    vltLOGICAL	req,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT lccdevStdUsrSimulat(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT lccdevStdUsrStopSim(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT lccdevStdUsrStatusCode(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    const char*	text,
*	    IN    vltINT32	flags,
*	    OUT   vltINT32*	code,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT lccdevStdUsrStatusLast(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    OUT   vltINT16*	last,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT lccdevStdUsrStatusValue(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    vltINT32	code,
*	    OUT   lcctooVALUE*	value,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT lccdevStdUsrTest(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT lccdevStdUsrSelfTest(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT lccdevStdUsrError(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT lccdevStdRead<scalarAttr>(
*	    INOUT egenOBJ*	obj,
*	    OUT   void*		buf,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT lccdevStdWrite<scalarAttr>(
*	    INOUT egenOBJ*	obj,
*	    IN    void*		buf,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT lccdevStdErr<error>(...)
*
*   PARENT CLASS
*	-
*
*   DESCRIPTION
*       The class lccdevSTD implements the standard commands
*       and the basic state machine of a LCC Software Device.
*
*       The class implements the following standard commands:
*
*	.   	STANDBY ONLINE OFF EXIT STATE
*	.   	SIMULAT STOPSIM STATUS
*	.   	INIT STOP TEST
*	.   	SELFTST
*
*       Note that the commands VERSION VERBOSE DEBUG GETDEBU
*       BREAK and KILL are implemented in the lcctoo class
*       (A process may handle several software devices. In
*       this case separate commands are needed for each command
*       implemented in this class. The commands VERSION VERBOSE
*       DEBUG GETDEBUG BREAK and KILL are common to all devices,
*       i.e. they belong to the process).
*
*       The state machine is implemented as follows:
*
*
*	                    --->-->-->--Online-->-->-->--
*	                   /  COLD_STARTING + STARTING   \
*	                  /                               \
*	   ->-exec.->-   -->--Standby-->---   ->-Online-->-\
*	  /           \ /  COLD_STARTING   \ /   STARTING   \
*	.OFF        LOADED               STANDBY          ONLINE
*	  \           / \  SHUTTING_DOWN   / \   STOPPING   /
*	   -<-Exit-<--   \--<--Off--<--<---   -<-Standby--<-
*	                  \    Init                       /
*	                   \                             /
*	                    \  SHUTTING_DOWN + STOPPING /
*	                     ---<--<--<--Off--<--<--<---
*	                                 Init
*	  
*       The state machine of the device has four main states:
*       OFF, LOADED, STANDBY and ONLINE. The current state of the
*       device is stored in the 'state' attribute.
*
*       The 'initialised' attribute indicates if the device is
*       initialised (i.e. if it has received the INIT command).
*       The attribute is reset when the device returns to the
*       LOADED state (with the Off command).
*
*       When the device changes state, the 'substate' attribute
*       changes from substate IDLE to another substate to indicate
*       that the device is busy. The substates are:
*       BUSY, COLD_STARTING, STARTING, STOPPING and SHUTTING_DOWN.
*       The substate may be also seen as a 'transient state'.
*
*       Only the commands STOP, EXIT, STATE and STATUS are accepted
*       while a device is busy. Other commands are rejected (e.g.
*       the command OFF is rejected, if the device is executing
*       the command MOVE; first a STOP command has to given to
*       properly stop the movement).
*
*       By default, no actions are performed when the software device
*       changes state. Classes derived from lccdevSTD may override the
*       functions described below as protected methods.
*
*   PUBLIC METHODS
*	lccdevStdNewObj(point,owner,obj,error)
*	    Initialises an instance of the class type lccdevSTD.
*
*	    point	<IN>	OLDB point where the owned attributes are
*				located.
*	    owner	<IN>	Pointer to the owner of the new instance.
*	    obj		<OUT>	Handle for the new instance (the handle
*				must be allocated by the caller).
*
*	lccdevStdDeleteObj(obj,error)
*	    The function lcctooDeleteObj deletes an
*	    instance of the class type lccdevSTD
*
*	lccdevStdStandby(obj,devName,error)
*	   Switches the software device to state STANDBY.
*	   Eventually the device is moved to a predefined
*	   secure position, brakes are engaged, etc.
*
*	lccdevStdOnline(obj,devName,error)
*	   Switches the software device to state ONLINE.
*	   The device goes through the state STANDBY if
*	   this command is issued from state LOADED.
*
*	lccdevStdOff(obj,devName,error)
*	   Switches the software device to state LOADED.
*	   The device goes through the state STANDBY if
*	   this command is issued from state ONLINE.
*
*	lccdevStdExit(obj,devName,error)
*	   Terminates the process.
*
*	lccdevStdState(obj,devName,state,error)
*	   Returns the software device state.
*
*	   OFF: 	 the software device is not operational.
*
*	   LOADED:  the software is loaded and initialised,
*		    the hardware is ready to be initialised.
*
*	   STANDBY: the software is loaded and initialised,
*		    the hardware is initialised, but in
*		    standby (applicable parts switched off,
*		    brakes clamped, etc.)
*
*	   ONLINE:  the software is loaded and initialised,
*		    the hardware is initialised and fully
*		    operational.
*
*	lccdevStdSimulat(obj,devName,error)
*	   Places the device in state LOADED and enters
*	   simulation mode. Then the device is brought
*	   back to the original state in simulation mode.
*
*	lccdevStdStopSim(obj,devName,error)
*	   Disables simulation mode of the hardware device.
*	   The software device is placed in state LOADED.
*
*	lccdevStdStatus(obj,devName,function,functionNum,flag,
*			header,conflog,opslog,condlog,status,error)
*	   Updates the complete status in the local database
*	   and returns the relevant status of the software
*	   device.
*
*	   The status is given as lines containing two words
*	   each:
*	     key1  value1,
*	     [key2 value2,
*	     [...]]
*
*	   The value usually begins after the 18th character
*	   of each line. If the flag option is set, then the
*	   values are returned as numbers (by default values
*	   are returned as literals).
*
*	lccdevStdInit(obj,devName,error)
*	   INIT initialises the software device.
*
*	lccdevStdStop(obj,devName,error)
*	   Stops the current action performed by the software
*	   device. This command should stop all mechanical
*	   movements of the related hardware device.
*
*	lccdevStdTest(obj,devName,error)
*	   Performs a test of the software device.
*	   The device is moved mechanically to perform the
*	   test. The reply is either OK or FAILURE.
*
*	lccdevStdSelftst(obj,devName,error)
*	   Performs a selftest of the software device.
*	   No mechanical movements are performed by the test.
*
*	lccdevStdAutoTbl(obj,devName,table,text,error)
*	   This command returns the tables of the state machine.
*	   The following arguments are accepted:
*
*	   States	- State table
*	   Substates	- Substate table
*	   Actions	- Actions table
*	   Subactions	- Subactions table
*
*	lccdevStdAutoRst(obj,devName,error)
*	   This command resets the substate of the state machine
*	   to IDLE. This command should ONLY be used, if the
*	   state machine gets locked in another substate due
*	   to an error.
*
*   PUBLIC DATA MEMBERS
*	The following data members are defined in the file lccdevStd.class:
*
*	vltBYTES20	device
*	vltBYTES20	description
*	vltINT32	state
*	vltINT32	substate
*	vltINT32	error
*	vltLOGICAL	initialised
*	vltLOGICAL	simulation
*
*   PROTECTED METHODS
*	lccdevStdUsrInit(obj,devName,error)
*	   This function should be overloaded to perform the
*	   device initialisation (without hardware movements).
*	   The function is called by the command INIT.
*
*	lccdevStdUsrLoaded2Standby(obj,devName,error)
*	   This function should be overloaded to perform the
*	   actions necessary to change from the LOADED to the
*	   ONLINE state. The function is called by the commands:
*	   STANDBY and ONLINE.
*
*	lccdevStdUsrStandby2Online(obj,devName,error)
*	   This function should be overloaded to perform the
*	   actions necessary to change from the STANDBY to the
*	   ONLINE state. The function is called by the command
*	   ONLINE.
*
*	lccdevStdUsrOnline2Standby(obj,devName,error)
*	   This function should be overloaded to perform the
*	   actions necessary to change from the ONLINE to the
*	   STANDBY state. The function is called by the
*	   commands: STANDBY, OFF, EXIT, INIT and SIMSTOP.
*
*	lccdevStdUsrStandby2Loaded(obj,devName,error)
*	   This function should be overloaded to perform the
*	   actions necessary to change from the STANDBY to the
*	   LOADED state. The function is called by the commands:
*	   OFF, EXIT, INIT and SIMSTOP.
*
*	lccdevStdUsrStop(obj,devName,req,error)
*	   This function should be overloaded to stop the device.
*	   If req is true, then a command to stop the device MUST
*	   be issued, even if the device is already stopped.
*	   Note: The STOP command is accepted even if the device
*	   is busy performing another command.
*
*	lccdevStdUsrSimulat(obj,devName,error)
*	   This function should be overloaded to perform the
*	   actions necessary to enter simulation mode.
*	   Called by the command SIMULAT.
*
*	lccdevStdUsrStopSim(obj,devName,error)
*	   This function should be overloaded to perform the
*	   actions necessary to leave simulation mode.
*	   Called by the command STOPSIM.
*
*	lccdevStdUsrStatusCode(obj,devName,text,flags,code,error)
*	   This function receives the name of a status value
*	   and returns the corresponding code. This function
*	   should be overloaded if the new class declares new
*	   status values. The overloaded function should check
*	   first if the name corresponds to one of its own
*	   status values. If not, then it should call the
*	   function UsrStatusCode() of its parent class to be
*	   able to retrieve the codes of the parent status
*	   values. Called by the command STATUS.
*
*	   text		<IN>	Name of the status value.
*	   flags	<IN>	expected status type (lcctooSTATUS_*).
*	   code		<OUT>	Code of the status value (lccdevGET_*).
*
*	   lccdevGET_DEVICE        "Device"
*	   lccdevGET_STATE         "State"
*	   lccdevGET_TRANSTATE     "TranState"
*	   lccdevGET_ERROR         "Error"
*	   lccdevGET_INITIALISED   "Initialised"
*	   lccdevGET_SIMULATION    "Simulation"
*
*	lccdevStdUsrStatusLast(obj,devName,last,error)
*	   This function returns the highest status code that
*	   the class knows. This function should be overloaded
*	   if the new class declares new status values, as new
*	   status codes have to be assigned to the new values.
*
*	   This function is used by the STATUS command when it
*	   has to return all status values. In this case it
*	   performs a loop from code 1 to the value returned
*	   by this function.
*
*	lccdevStdUsrStatusValue(obj,devName,code,value,error)
*	   This function receives the code of a status variable
*	   and returns its related value. This function should
*	   be overloaded if the new class declares new status
*	   values. The overloaded function should check first
*	   if the code corresponds to one of its own status
*	   values. If not, then it should call the function
*	   UsrStatusValue() of its parent class to be able to
*	   retrieve the status values of the parent.
*
*	   code		<OUT>	Code of the status value (lccdevGET_*).
*	   value	<OUT>	Handle of the value object
*			   	(allocated by the caller).
*
*	lccdevStdUsrTest(obj,devName,error)
*	   This function should be overloaded to perform the
*	   actions necessary to test the software device
*	   (eventually with hardware movements).
*	   Called by the command TEST.
*
*	lccdevStdUsrSelfTest(obj,devName,error)
*	   This function should be overloaded to perform a
*	   selftest of the device.  No movements are allowed
*	   (it must be possible to execute this function in
*	   the state LOADED). Called by the command SELFTST.
*
*	lccdevStdUsrError(obj,devName,error)
*	   This function may be used when a command is not
*	   applicable for the device.
*
*	lccdevStdErr<error>(...)
*	    The macros lccdevStdErr*() log an error with lcctooLOG_0 and
*	    call errAdd with the corresponding error parameters.
*
*	lccdevStdRead<attr>(...)
*	lccdevStdWrite<attr>(...)
*	    The above macros read from/write to the data attributes
*	    of the class described below.
*
*   PRIVATE METHODS
*	lccdevStdInitObj(obj,error)
*	   This function is called when the object is created.
*	   If the Break handler is not installed, then a Break
*	   handler that executes the Stop command is installed.
*
*	lccdevStdExitObj(obj,error)
*	   This function is called when the object is deleted.
*	   It executes the EXIT command (see below).
*
*	lccdevStdLoaded2Stby(obj,devName,error)
*	   This function is called from the STANDBY command,
*	   when the device is in state LOADED. It calls the
*	   user function UsrLoaded2Standby().
*
*	lccdevStdOnline2Stby(obj,devName,error)
*	   This function is called from the STANDBY command,
*	   when the device is in state ONLINE. It calls the
*	   user function UsrOnline2Standby().
*
*	lccdevStdExit1(obj,devName,error)
*	   When the command EXIT is received by the Command
*	   Interpreter (CI), the CI terminates the application
*	   after the command has been processed. Therefore not
*	   only this device must be deleted, _all_ objects managed
*	   by the application must be deleted. This should be done
*	   by the Break Handler that the application registers.
*	   The Break Handler should call the DeleteObj function
*	   of each object of the application (see <process>.c
*	   generated by the eccsgen utility).
*	   
*	   In case of lccdevSTD objects, DeleteObj calls the user
*	   delete function ExitObj (see file lccdevStdNewObj.c).
*	   ExitObj in turn calls Exit1(), placing the device in
*	   the OFF state.
*
*	lccdevStdCheckDeviceName(obj,devName,error)
*	   This function returns an error if the device name
*	   does not correspond to the one registered in the
*	   data attribute 'device'.
*
*	lccdevStdBreak(obj,error)
*	   This is the break handler registered by InitObj().
*	   It stops the device (i.e. calls Stop()).
*
*   RETURN VALUES
*	If the function prototype allows, methods return ccsCOMPL_STAT.
*
*	The names of the defined errors begin as follows:
*	lccdevERR_<error>
*
*   SEE ALSO
*	lccdevCmd(3) auto(3) lcctoo(3) egen(3)
*
*-------------------------------------------------------------------------
*/

#ifndef LCCDEV_STD_H
#define LCCDEV_STD_H

#include "egen.h"
#include "lccdevDefines.h"
#include "lccdevErrors.h"

/*
 * class type identifier
 */
#define lccdevSTD_ID	115

/*
 * attribute table
 */
#define lccdevSTD_ATTR_STATE	0
#define lccdevSTD_ATTR_SUBSTATE	1
#define lccdevSTD_ATTR_ERROR	2
#define lccdevSTD_ATTR_INITIALISED	3
#define lccdevSTD_ATTR_SIMULATION	4
#define lccdevSTD_ATTR_DEVICE	5

#define lccdevSTD_AUTOMATA	0

/*
 * function table
 */
#define lccdevSTD_FCT_DELETE_OBJ	0
#define lccdevSTD_FCT_STANDBY	1
#define lccdevSTD_FCT_ONLINE	2
#define lccdevSTD_FCT_OFF	3
#define lccdevSTD_FCT_EXIT	4
#define lccdevSTD_FCT_STATE	5
#define lccdevSTD_FCT_SIMULAT	6
#define lccdevSTD_FCT_STOP_SIM	7
#define lccdevSTD_FCT_STATUS	8
#define lccdevSTD_FCT_INIT	9
#define lccdevSTD_FCT_STOP	10
#define lccdevSTD_FCT_TEST	11
#define lccdevSTD_FCT_SELFTST	12
#define lccdevSTD_FCT_AUTO_TBL	13
#define lccdevSTD_FCT_AUTO_RST	14
#define lccdevSTD_FCT_INIT_OBJ	15
#define lccdevSTD_FCT_EXIT_OBJ	16
#define lccdevSTD_FCT_LOADED2STBY	17
#define lccdevSTD_FCT_ONLINE2STBY	18
#define lccdevSTD_FCT_EXIT1	19
#define lccdevSTD_FCT_CHECK_DEVICE_NAME	20
#define lccdevSTD_FCT_BREAK	21
#define lccdevSTD_FCT_USR_INIT	22
#define lccdevSTD_FCT_USR_LOADED2STANDBY	23
#define lccdevSTD_FCT_USR_STANDBY2ONLINE	24
#define lccdevSTD_FCT_USR_ONLINE2STANDBY	25
#define lccdevSTD_FCT_USR_STANDBY2LOADED	26
#define lccdevSTD_FCT_USR_STOP	27
#define lccdevSTD_FCT_USR_SIMULAT	28
#define lccdevSTD_FCT_USR_STOP_SIM	29
#define lccdevSTD_FCT_USR_STATUS_CODE	30
#define lccdevSTD_FCT_USR_STATUS_LAST	31
#define lccdevSTD_FCT_USR_STATUS_VALUE	32
#define lccdevSTD_FCT_USR_TEST	33
#define lccdevSTD_FCT_USR_SELF_TEST	34
#define lccdevSTD_FCT_USR_ERROR	35

/*
 * automata states
 */
#define lccdevSTD_STATE_NOSTATE	-1
#define lccdevSTD_STATE_OFF	0
#define lccdevSTD_STATE_LOADED	1
#define lccdevSTD_STATE_STANDBY	2
#define lccdevSTD_STATE_ONLINE	3

/*
 * automata substates
 */
#define lccdevSTD_SUBSTATE_ERROR	0
#define lccdevSTD_SUBSTATE_IDLE	1
#define lccdevSTD_SUBSTATE_BUSY	2
#define lccdevSTD_SUBSTATE_INITIALISING	3
#define lccdevSTD_SUBSTATE_SHUTTING_DOWN	4
#define lccdevSTD_SUBSTATE_STOPPING	5
#define lccdevSTD_SUBSTATE_COLD_STARTING	6
#define lccdevSTD_SUBSTATE_STARTING	7
#define lccdevSTD_SUBSTATE_STOP	8

/*
 * automata events
 */
#define lccdevSTD_EVENT_INIT	0
#define lccdevSTD_EVENT_STANDBY	1
#define lccdevSTD_EVENT_ONLINE	2
#define lccdevSTD_EVENT_STOP	3
#define lccdevSTD_EVENT_OFF	4
#define lccdevSTD_EVENT_EXIT	5
#define lccdevSTD_EVENT_STATE	6
#define lccdevSTD_EVENT_STOP_SIM	7
#define lccdevSTD_EVENT_STATUS	8
#define lccdevSTD_EVENT_SIMULAT	9
#define lccdevSTD_EVENT_TEST	10
#define lccdevSTD_EVENT_SELFTST	11
#define lccdevSTD_EVENT_AUTO_TBL	12
#define lccdevSTD_EVENT_AUTO_RST	13


/*
 * function pointer types
 */
typedef ccsCOMPL_STAT (*lccdevSTD_FCTPTR_STANDBY)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*lccdevSTD_FCTPTR_ONLINE)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*lccdevSTD_FCTPTR_OFF)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*lccdevSTD_FCTPTR_EXIT)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*lccdevSTD_FCTPTR_STATE)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   char**	state,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*lccdevSTD_FCTPTR_SIMULAT)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*lccdevSTD_FCTPTR_STOP_SIM)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*lccdevSTD_FCTPTR_STATUS)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    const char*	function[],	/* max. vltBYTES32[999] */
    IN    vltINT16	functionNum,
    IN    vltLOGICAL	flag,
    IN    vltLOGICAL	header,
    IN    vltLOGICAL	conflog,
    IN    vltLOGICAL	opslog,
    IN    vltLOGICAL	condlog,
    OUT   char**	status,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*lccdevSTD_FCTPTR_INIT)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*lccdevSTD_FCTPTR_STOP)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*lccdevSTD_FCTPTR_TEST)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*lccdevSTD_FCTPTR_SELFTST)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*lccdevSTD_FCTPTR_AUTO_TBL)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    const char*	table,
    OUT   char**	text,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*lccdevSTD_FCTPTR_AUTO_RST)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*lccdevSTD_FCTPTR_INIT_OBJ)(
    INOUT egenOBJ*	obj,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*lccdevSTD_FCTPTR_EXIT_OBJ)(
    INOUT egenOBJ*	obj,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*lccdevSTD_FCTPTR_LOADED2STBY)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*lccdevSTD_FCTPTR_ONLINE2STBY)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*lccdevSTD_FCTPTR_EXIT1)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*lccdevSTD_FCTPTR_CHECK_DEVICE_NAME)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*lccdevSTD_FCTPTR_BREAK)(
    INOUT egenOBJ*	obj,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*lccdevSTD_FCTPTR_USR_INIT)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*lccdevSTD_FCTPTR_USR_LOADED2STANDBY)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*lccdevSTD_FCTPTR_USR_STANDBY2ONLINE)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*lccdevSTD_FCTPTR_USR_ONLINE2STANDBY)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*lccdevSTD_FCTPTR_USR_STANDBY2LOADED)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*lccdevSTD_FCTPTR_USR_STOP)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltLOGICAL	req,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*lccdevSTD_FCTPTR_USR_SIMULAT)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*lccdevSTD_FCTPTR_USR_STOP_SIM)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*lccdevSTD_FCTPTR_USR_STATUS_CODE)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    const char*	text,
    IN    vltINT32	flags,
    OUT   vltINT32*	code,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*lccdevSTD_FCTPTR_USR_STATUS_LAST)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   vltINT16*	last,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*lccdevSTD_FCTPTR_USR_STATUS_VALUE)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltINT32	code,
    OUT   lcctooVALUE*	value,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*lccdevSTD_FCTPTR_USR_TEST)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*lccdevSTD_FCTPTR_USR_SELF_TEST)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*lccdevSTD_FCTPTR_USR_ERROR)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);


/*
 * log function
 */
#define lccdevStdLogData(obj, format, arg...) \
	{ \
	char tmpLogBuf[lcctooTMP_BUFFER_SIZE]; \
	\
	sprintf(tmpLogBuf, (format), ##arg); \
	logData("lccdev", (obj)->id, tmpLogBuf); \
	}


/*
 * error functions
 */
#define lccdevErrErrorFlag(p1,p2) \
	{ \
	lcctooLOG_0("lccdevERR_ERROR_FLAG: Device %s: Error flag set (%d). Unable to proceed.",(p1),(p2)); \
	errAdd(error,"lccdev",lccdevERR_ERROR_FLAG,__FILE_LINE__,"%s,%d",(p1),(p2)); \
	}
#define lccdevErrReadDevice() \
	{ \
	lcctooLOG_0("lccdevERR_READ_DEVICE: Unable to read to attr. device."); \
	errAdd(error,"lccdev",lccdevERR_READ_DEVICE,__FILE_LINE__,""); \
	}
#define lccdevErrReadInitialised(p1) \
	{ \
	lcctooLOG_0("lccdevERR_READ_INITIALISED: Device %s: Unable to read from attr. initialised.",(p1)); \
	errAdd(error,"lccdev",lccdevERR_READ_INITIALISED,__FILE_LINE__,"%s",(p1)); \
	}
#define lccdevErrWriteInitialised(p1,p2) \
	{ \
	lcctooLOG_0("lccdevERR_WRITE_INITIALISED: Device %s: Unable to write to attr. initialised (value %d).",(p1),(p2)); \
	errAdd(error,"lccdev",lccdevERR_WRITE_INITIALISED,__FILE_LINE__,"%s,%d",(p1),(p2)); \
	}
#define lccdevErrReadError(p1) \
	{ \
	lcctooLOG_0("lccdevERR_READ_ERROR: Device %s: Unable to read from attr. error.",(p1)); \
	errAdd(error,"lccdev",lccdevERR_READ_ERROR,__FILE_LINE__,"%s",(p1)); \
	}
#define lccdevErrWriteError(p1,p2) \
	{ \
	lcctooLOG_0("lccdevERR_WRITE_ERROR: Device %s: Unable to write to attr. error (value %d).",(p1),(p2)); \
	errAdd(error,"lccdev",lccdevERR_WRITE_ERROR,__FILE_LINE__,"%s,%d",(p1),(p2)); \
	}
#define lccdevErrReadSimulation(p1) \
	{ \
	lcctooLOG_0("lccdevERR_READ_SIMULATION: Device %s: Unable to read from attr. simulation.",(p1)); \
	errAdd(error,"lccdev",lccdevERR_READ_SIMULATION,__FILE_LINE__,"%s",(p1)); \
	}
#define lccdevErrWriteSimulation(p1,p2) \
	{ \
	lcctooLOG_0("lccdevERR_WRITE_SIMULATION: Device %s: Unable to write to attr. simulation (value %d).",(p1),(p2)); \
	errAdd(error,"lccdev",lccdevERR_WRITE_SIMULATION,__FILE_LINE__,"%s,%d",(p1),(p2)); \
	}
#define lccdevErrCmdNotApplicable(p1) \
	{ \
	lcctooLOG_0("lccdevERR_CMD_NOT_APPLICABLE: Device %s: Command not available.",(p1)); \
	errAdd(error,"lccdev",lccdevERR_CMD_NOT_APPLICABLE,__FILE_LINE__,"%s",(p1)); \
	}
#define lccdevErrDeviceName(p1) \
	{ \
	lcctooLOG_0("lccdevERR_DEVICE_NAME: Wrong device name %s",(p1)); \
	errAdd(error,"lccdev",lccdevERR_DEVICE_NAME,__FILE_LINE__,"%s",(p1)); \
	}
#define lccdevErrDevEnterSim(p1) \
	{ \
	lcctooLOG_0("lccdevERR_DEV_ENTER_SIM: Device %s: Unable to go into simulation mode.",(p1)); \
	errAdd(error,"lccdev",lccdevERR_DEV_ENTER_SIM,__FILE_LINE__,"%s",(p1)); \
	}
#define lccdevErrDevExitSim(p1) \
	{ \
	lcctooLOG_0("lccdevERR_DEV_EXIT_SIM: Device %s: Unable to exit the simulation mode.",(p1)); \
	errAdd(error,"lccdev",lccdevERR_DEV_EXIT_SIM,__FILE_LINE__,"%s",(p1)); \
	}
#define lccdevErrGetState(p1) \
	{ \
	lcctooLOG_0("lccdevERR_GET_STATE: Device %s: Unable to obtain the state.",(p1)); \
	errAdd(error,"lccdev",lccdevERR_GET_STATE,__FILE_LINE__,"%s",(p1)); \
	}
#define lccdevErrGetSubState(p1) \
	{ \
	lcctooLOG_0("lccdevERR_GET_SUB_STATE: Device %s: Unable to obtain the substate.",(p1)); \
	errAdd(error,"lccdev",lccdevERR_GET_SUB_STATE,__FILE_LINE__,"%s",(p1)); \
	}
#define lccdevErrInitialised(p1) \
	{ \
	lcctooLOG_0("lccdevERR_INITIALISED: Device %s is initialised, but not in the STANDBY state.",(p1)); \
	errAdd(error,"lccdev",lccdevERR_INITIALISED,__FILE_LINE__,"%s",(p1)); \
	}
#define lccdevErrNotInitialised(p1) \
	{ \
	lcctooLOG_0("lccdevERR_NOT_INITIALISED: Device %s not initialised.",(p1)); \
	errAdd(error,"lccdev",lccdevERR_NOT_INITIALISED,__FILE_LINE__,"%s",(p1)); \
	}
#define lccdevErrNotInSimulation(p1) \
	{ \
	lcctooLOG_0("lccdevERR_NOT_IN_SIMULATION: Device %s is not in simulation mode.",(p1)); \
	errAdd(error,"lccdev",lccdevERR_NOT_IN_SIMULATION,__FILE_LINE__,"%s",(p1)); \
	}
#define lccdevErrSetState(p1) \
	{ \
	lcctooLOG_0("lccdevERR_SET_STATE: Device %s: Unable to set the state.",(p1)); \
	errAdd(error,"lccdev",lccdevERR_SET_STATE,__FILE_LINE__,"%s",(p1)); \
	}
#define lccdevErrSetSubState(p1) \
	{ \
	lcctooLOG_0("lccdevERR_SET_SUB_STATE: Device %s: Unable to set the substate.",(p1)); \
	errAdd(error,"lccdev",lccdevERR_SET_SUB_STATE,__FILE_LINE__,"%s",(p1)); \
	}
#define lccdevErrStdExit(p1) \
	{ \
	lcctooLOG_0("lccdevERR_STD_EXIT: Device %s: Error going to the OFF state.",(p1)); \
	errAdd(error,"lccdev",lccdevERR_STD_EXIT,__FILE_LINE__,"%s",(p1)); \
	}
#define lccdevErrStdStop(p1) \
	{ \
	lcctooLOG_0("lccdevERR_STD_STOP: Device %s: Error stopping the device.",(p1)); \
	errAdd(error,"lccdev",lccdevERR_STD_STOP,__FILE_LINE__,"%s",(p1)); \
	}
#define lccdevErrUsrInit(p1) \
	{ \
	lcctooLOG_0("lccdevERR_USR_INIT: Device %s: Error performing the initialisation of the device.",(p1)); \
	errAdd(error,"lccdev",lccdevERR_USR_INIT,__FILE_LINE__,"%s",(p1)); \
	}
#define lccdevErrUsrLoaded2Standby(p1) \
	{ \
	lcctooLOG_0("lccdevERR_USR_LOADED2STANDBY: Device %s: Error changing from state LOADED to STANDBY.",(p1)); \
	errAdd(error,"lccdev",lccdevERR_USR_LOADED2STANDBY,__FILE_LINE__,"%s",(p1)); \
	}
#define lccdevErrUsrOnline2Standby(p1) \
	{ \
	lcctooLOG_0("lccdevERR_USR_ONLINE2STANDBY: Device %s: Error changing from state ONLINE to STANDBY.",(p1)); \
	errAdd(error,"lccdev",lccdevERR_USR_ONLINE2STANDBY,__FILE_LINE__,"%s",(p1)); \
	}
#define lccdevErrUsrSelfTest(p1) \
	{ \
	lcctooLOG_0("lccdevERR_USR_SELF_TEST: Device %s: Error in selftest.",(p1)); \
	errAdd(error,"lccdev",lccdevERR_USR_SELF_TEST,__FILE_LINE__,"%s",(p1)); \
	}
#define lccdevErrUsrSimulat(p1) \
	{ \
	lcctooLOG_0("lccdevERR_USR_SIMULAT: Device %s: Unable to set the device in simulation mode.",(p1)); \
	errAdd(error,"lccdev",lccdevERR_USR_SIMULAT,__FILE_LINE__,"%s",(p1)); \
	}
#define lccdevErrUsrStandby2Loaded(p1) \
	{ \
	lcctooLOG_0("lccdevERR_USR_STANDBY2LOADED: Device %s: Error changing from state STANDBY to LOADED.",(p1)); \
	errAdd(error,"lccdev",lccdevERR_USR_STANDBY2LOADED,__FILE_LINE__,"%s",(p1)); \
	}
#define lccdevErrUsrStandby2Online(p1) \
	{ \
	lcctooLOG_0("lccdevERR_USR_STANDBY2ONLINE: Device %s: Error changing from state STANDBY to ONLINE.",(p1)); \
	errAdd(error,"lccdev",lccdevERR_USR_STANDBY2ONLINE,__FILE_LINE__,"%s",(p1)); \
	}
#define lccdevErrUsrStatus(p1) \
	{ \
	lcctooLOG_0("lccdevERR_USR_STATUS: Device %s: Unable to return the status.",(p1)); \
	errAdd(error,"lccdev",lccdevERR_USR_STATUS,__FILE_LINE__,"%s",(p1)); \
	}
#define lccdevErrUsrStop(p1) \
	{ \
	lcctooLOG_0("lccdevERR_USR_STOP: Device %s: Error stopping the device.",(p1)); \
	errAdd(error,"lccdev",lccdevERR_USR_STOP,__FILE_LINE__,"%s",(p1)); \
	}
#define lccdevErrUsrStopSim(p1) \
	{ \
	lcctooLOG_0("lccdevERR_USR_STOP_SIM: Device %s: Unable to leave simulation mode.",(p1)); \
	errAdd(error,"lccdev",lccdevERR_USR_STOP_SIM,__FILE_LINE__,"%s",(p1)); \
	}
#define lccdevErrUsrTest(p1) \
	{ \
	lcctooLOG_0("lccdevERR_USR_TEST: Device %s: Error in the automatic test of the device.",(p1)); \
	errAdd(error,"lccdev",lccdevERR_USR_TEST,__FILE_LINE__,"%s",(p1)); \
	}
#define lccdevErrSendReplyText(p1) \
	{ \
	lcctooLOG_0("lccdevERR_SEND_REPLY_TEXT: Device %s: Error sending a reply message.",(p1)); \
	errAdd(error,"lccdev",lccdevERR_SEND_REPLY_TEXT,__FILE_LINE__,"%s",(p1)); \
	}

/*
 * get object owner
 */
#define lccdevStdGetOwner(obj) ((obj)->owner)


/*
 * attribute access functions
 */
#define lccdevStdReadState(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,lccdevSTD_ATTR_STATE,(buf),(error))
#define lccdevStdWriteState(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,lccdevSTD_ATTR_STATE,(void*) (buf),(error))
#define lccdevStdReadSubstate(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,lccdevSTD_ATTR_SUBSTATE,(buf),(error))
#define lccdevStdWriteSubstate(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,lccdevSTD_ATTR_SUBSTATE,(void*) (buf),(error))
#define lccdevStdReadError(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,lccdevSTD_ATTR_ERROR,(buf),(error))
#define lccdevStdWriteError(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,lccdevSTD_ATTR_ERROR,(void*) (buf),(error))
#define lccdevStdReadInitialised(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,lccdevSTD_ATTR_INITIALISED,(buf),(error))
#define lccdevStdWriteInitialised(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,lccdevSTD_ATTR_INITIALISED,(void*) (buf),(error))
#define lccdevStdReadSimulation(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,lccdevSTD_ATTR_SIMULATION,(buf),(error))
#define lccdevStdWriteSimulation(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,lccdevSTD_ATTR_SIMULATION,(void*) (buf),(error))
#define lccdevStdReadDevice(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,lccdevSTD_ATTR_DEVICE,(buf),(error))
#define lccdevStdWriteDevice(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,lccdevSTD_ATTR_DEVICE,(void*) (buf),(error))
#define lccdevStdGetAuto(obj,attrPtr,error) \
	SUCCESS; \
	memcpy((attrPtr), &(obj)->objs[lccdevSTD_AUTOMATA], sizeof(egenOBJ)); \
	(attrPtr)->ldata = (obj)->ldata;


/*
 * class functions
 */

ccsCOMPL_STAT lccdevStdStandby(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT lccdevStdOnline(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT lccdevStdOff(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT lccdevStdExit(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT lccdevStdState(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   char**	state,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT lccdevStdSimulat(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT lccdevStdStopSim(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT lccdevStdStatus(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    const char*	function[],	/* max. vltBYTES32[999] */
    IN    vltINT16	functionNum,
    IN    vltLOGICAL	flag,
    IN    vltLOGICAL	header,
    IN    vltLOGICAL	conflog,
    IN    vltLOGICAL	opslog,
    IN    vltLOGICAL	condlog,
    OUT   char**	status,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT lccdevStdInit(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT lccdevStdStop(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT lccdevStdTest(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT lccdevStdSelftst(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT lccdevStdAutoTbl(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    const char*	table,
    OUT   char**	text,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT lccdevStdAutoRst(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT lccdevStdInitObj(
    INOUT egenOBJ*	obj,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT lccdevStdExitObj(
    INOUT egenOBJ*	obj,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT lccdevStdLoaded2Stby(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT lccdevStdOnline2Stby(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT lccdevStdExit1(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT lccdevStdCheckDeviceName(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT lccdevStdBreak(
    OUT   ccsERROR*	error);

ccsCOMPL_STAT lccdevStdUsrInit(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT lccdevStdUsrLoaded2Standby(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT lccdevStdUsrStandby2Online(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT lccdevStdUsrOnline2Standby(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT lccdevStdUsrStandby2Loaded(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT lccdevStdUsrStop(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltLOGICAL	req,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT lccdevStdUsrSimulat(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT lccdevStdUsrStopSim(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT lccdevStdUsrStatusCode(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    const char*	text,
    IN    vltINT32	flags,
    OUT   vltINT32*	code,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT lccdevStdUsrStatusLast(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   vltINT16*	last,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT lccdevStdUsrStatusValue(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltINT32	code,
    OUT   lcctooVALUE*	value,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT lccdevStdUsrTest(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT lccdevStdUsrSelfTest(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT lccdevStdUsrError(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);


/*
 * virtual functions
 */
#define lccdevStdVStandby(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_STANDBY)((obj)->fcts[lccdevSTD_FCT_STANDBY]))) \
	 ((obj),(devName),(error))
#define lccdevStdVOnline(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_ONLINE)((obj)->fcts[lccdevSTD_FCT_ONLINE]))) \
	 ((obj),(devName),(error))
#define lccdevStdVOff(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_OFF)((obj)->fcts[lccdevSTD_FCT_OFF]))) \
	 ((obj),(devName),(error))
#define lccdevStdVExit(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_EXIT)((obj)->fcts[lccdevSTD_FCT_EXIT]))) \
	 ((obj),(devName),(error))
#define lccdevStdVState(obj,devName,state,error) \
	(*((lccdevSTD_FCTPTR_STATE)((obj)->fcts[lccdevSTD_FCT_STATE]))) \
	 ((obj),(devName),(state),(error))
#define lccdevStdVSimulat(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_SIMULAT)((obj)->fcts[lccdevSTD_FCT_SIMULAT]))) \
	 ((obj),(devName),(error))
#define lccdevStdVStopSim(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_STOP_SIM)((obj)->fcts[lccdevSTD_FCT_STOP_SIM]))) \
	 ((obj),(devName),(error))
#define lccdevStdVStatus(obj,devName,function,functionNum,flag,header,conflog,opslog,condlog,status,error) \
	(*((lccdevSTD_FCTPTR_STATUS)((obj)->fcts[lccdevSTD_FCT_STATUS]))) \
	 ((obj),(devName),(function),(functionNum),(flag),(header),(conflog),(opslog),(condlog),(status),(error))
#define lccdevStdVInit(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_INIT)((obj)->fcts[lccdevSTD_FCT_INIT]))) \
	 ((obj),(devName),(error))
#define lccdevStdVStop(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_STOP)((obj)->fcts[lccdevSTD_FCT_STOP]))) \
	 ((obj),(devName),(error))
#define lccdevStdVTest(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_TEST)((obj)->fcts[lccdevSTD_FCT_TEST]))) \
	 ((obj),(devName),(error))
#define lccdevStdVSelftst(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_SELFTST)((obj)->fcts[lccdevSTD_FCT_SELFTST]))) \
	 ((obj),(devName),(error))
#define lccdevStdVAutoTbl(obj,devName,table,text,error) \
	(*((lccdevSTD_FCTPTR_AUTO_TBL)((obj)->fcts[lccdevSTD_FCT_AUTO_TBL]))) \
	 ((obj),(devName),(table),(text),(error))
#define lccdevStdVAutoRst(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_AUTO_RST)((obj)->fcts[lccdevSTD_FCT_AUTO_RST]))) \
	 ((obj),(devName),(error))
#define lccdevStdVInitObj(obj,error) \
	(*((lccdevSTD_FCTPTR_INIT_OBJ)((obj)->fcts[lccdevSTD_FCT_INIT_OBJ]))) \
	 ((obj),(error))
#define lccdevStdVExitObj(obj,error) \
	(*((lccdevSTD_FCTPTR_EXIT_OBJ)((obj)->fcts[lccdevSTD_FCT_EXIT_OBJ]))) \
	 ((obj),(error))
#define lccdevStdVLoaded2Stby(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_LOADED2STBY)((obj)->fcts[lccdevSTD_FCT_LOADED2STBY]))) \
	 ((obj),(devName),(error))
#define lccdevStdVOnline2Stby(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_ONLINE2STBY)((obj)->fcts[lccdevSTD_FCT_ONLINE2STBY]))) \
	 ((obj),(devName),(error))
#define lccdevStdVExit1(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_EXIT1)((obj)->fcts[lccdevSTD_FCT_EXIT1]))) \
	 ((obj),(devName),(error))
#define lccdevStdVCheckDeviceName(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_CHECK_DEVICE_NAME)((obj)->fcts[lccdevSTD_FCT_CHECK_DEVICE_NAME]))) \
	 ((obj),(devName),(error))
#define lccdevStdVBreak(obj,error) \
	(*((lccdevSTD_FCTPTR_BREAK)((obj)->fcts[lccdevSTD_FCT_BREAK]))) \
	 ((obj),(error))
#define lccdevStdVUsrInit(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_USR_INIT)((obj)->fcts[lccdevSTD_FCT_USR_INIT]))) \
	 ((obj),(devName),(error))
#define lccdevStdVUsrLoaded2Standby(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_USR_LOADED2STANDBY)((obj)->fcts[lccdevSTD_FCT_USR_LOADED2STANDBY]))) \
	 ((obj),(devName),(error))
#define lccdevStdVUsrStandby2Online(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_USR_STANDBY2ONLINE)((obj)->fcts[lccdevSTD_FCT_USR_STANDBY2ONLINE]))) \
	 ((obj),(devName),(error))
#define lccdevStdVUsrOnline2Standby(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_USR_ONLINE2STANDBY)((obj)->fcts[lccdevSTD_FCT_USR_ONLINE2STANDBY]))) \
	 ((obj),(devName),(error))
#define lccdevStdVUsrStandby2Loaded(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_USR_STANDBY2LOADED)((obj)->fcts[lccdevSTD_FCT_USR_STANDBY2LOADED]))) \
	 ((obj),(devName),(error))
#define lccdevStdVUsrStop(obj,devName,req,error) \
	(*((lccdevSTD_FCTPTR_USR_STOP)((obj)->fcts[lccdevSTD_FCT_USR_STOP]))) \
	 ((obj),(devName),(req),(error))
#define lccdevStdVUsrSimulat(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_USR_SIMULAT)((obj)->fcts[lccdevSTD_FCT_USR_SIMULAT]))) \
	 ((obj),(devName),(error))
#define lccdevStdVUsrStopSim(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_USR_STOP_SIM)((obj)->fcts[lccdevSTD_FCT_USR_STOP_SIM]))) \
	 ((obj),(devName),(error))
#define lccdevStdVUsrStatusCode(obj,devName,text,flags,code,error) \
	(*((lccdevSTD_FCTPTR_USR_STATUS_CODE)((obj)->fcts[lccdevSTD_FCT_USR_STATUS_CODE]))) \
	 ((obj),(devName),(text),(flags),(code),(error))
#define lccdevStdVUsrStatusLast(obj,devName,last,error) \
	(*((lccdevSTD_FCTPTR_USR_STATUS_LAST)((obj)->fcts[lccdevSTD_FCT_USR_STATUS_LAST]))) \
	 ((obj),(devName),(last),(error))
#define lccdevStdVUsrStatusValue(obj,devName,code,value,error) \
	(*((lccdevSTD_FCTPTR_USR_STATUS_VALUE)((obj)->fcts[lccdevSTD_FCT_USR_STATUS_VALUE]))) \
	 ((obj),(devName),(code),(value),(error))
#define lccdevStdVUsrTest(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_USR_TEST)((obj)->fcts[lccdevSTD_FCT_USR_TEST]))) \
	 ((obj),(devName),(error))
#define lccdevStdVUsrSelfTest(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_USR_SELF_TEST)((obj)->fcts[lccdevSTD_FCT_USR_SELF_TEST]))) \
	 ((obj),(devName),(error))
#define lccdevStdVUsrError(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_USR_ERROR)((obj)->fcts[lccdevSTD_FCT_USR_ERROR]))) \
	 ((obj),(devName),(error))


ccsCOMPL_STAT lccdevStdNewObj(
    IN    dbSYMADDRESS	point,
    IN    egenOBJ*	owner,
    OUT   egenOBJ*	obj,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT lccdevStdDeleteObj(
    INOUT egenOBJ*	obj,
    OUT   ccsERROR*	error);


#endif // !LCCDEV_STD_H

/************************************************************************/
/* ___oOo___ */
