/******************************************************************************
*  E.S.O. - VLT project
* 
*  "@(#) $Id: lcctooDefines.h,v 1.30 2005/05/09 15:25:52 vltsccm Exp $"
* 
*  who       when      what
*  --------  --------  ----------------------------------------------
*  rschmutz  01/07/97  added #define lcctooVALUE_TOLERANCE
*  rschmutz  30/10/95  Created
*
*/

#ifndef LCCTOO_DEFINES_H
#define LCCTOO_DEFINES_H


/*
 * Class lcctooVALUE defines
 */
#define lcctooVALUE_TYPE	7
#define lcctooVALUE_ANY		0
#define lcctooVALUE_LOGICAL	1
#define lcctooVALUE_FLAG	2
#define lcctooVALUE_INTEGER	3
#define lcctooVALUE_DOUBLE	4
#define lcctooVALUE_STRING	5
#define lcctooVALUE_TIME	6

#define lcctooVALUE_NO_UNIT	 32	/* do not parse unit */
#define lcctooVALUE_COMPARE	 64	/* not used by lcctoo */
#define lcctooVALUE_NAME	128	/* display name */
#define lcctooVALUE_UNIT	256	/* display unit */
#define lcctooVALUE_NUMERIC	512	/* display in numeric format */
#define lcctooVALUE_FIRST      1024	/* not used by lcctoo */
#define lcctooVALUE_NEXTPOS    2048	/* not used by lcctoo */
#define lcctooVALUE_NOCASE     4096	/* case insensitive compare */
#define lcctooVALUE_RESET      8192	/* not used by lcctoo */
#define lcctooVALUE_CACHE     16384	/* not used by lcctoo */
#define lcctooVALUE_TOLERANCE 32768     /* not used by lcctoo */

#define lcctooVALUE_NAME_LEN	32
#define lcctooVALUE_STRING_LEN	20
#define lcctooVALUE_UNIT_LEN	 8
#define lcctooVALUE_FORMAT_LEN	 8

#define lcctooVALUE_NAME_FMT	"%-16s "
#define lcctooVALUE_LOGICAL_FMT	"%s"
#define lcctooVALUE_INTEGER_FMT "%d"
#define lcctooVALUE_DOUBLE_FMT	"%g"
#define lcctooVALUE_STRING_FMT	"%s"
#define lcctooVALUE_TIME_FMT	"%d.%06d"
#define lcctooVALUE_UNIT_FMT	"%s"

#define lcctooVALUE_EMPTY_STRING "\"\""
#define lcctooVALUE_NUMBER_NAME	"NUMBER"
#define lcctooVALUE_STRING_NAME "STRING"
#define lcctooVALUE_TIME_NAME	"TIME"
#define lcctooVALUE_TIME_UNIT	"sec"


/*
 * Status types
 */
#define lcctooCLASS_TYPE	31
#define lcctooCLASS_NORMAL	 1
#define lcctooCLASS_HEADER	 2
#define lcctooCLASS_CONF_LOG	 4
#define lcctooCLASS_OPS_LOG	 8
#define lcctooCLASS_COND_LOG	16

#define lcctooSTATUS_SEP	", \n"
#define lcctooSTATUS_LAST_SEP	""


/*
 * Status options (lcctooGetDebugValue)
 */
#define lcctooGET_FIRST		1
#define lcctooGET_DEBUG		1
#define lcctooGET_LOG		2
#define lcctooGET_VERBOSE	3
#define lcctooGET_TIMEOUT	4
#define lcctooGET_LAST		4

#define lcctooGET_DEBUG_STRING	 "DebugLevel"
#define lcctooGET_LOG_STRING	 "Log"
#define lcctooGET_VERBOSE_STRING "Verbose"
#define lcctooGET_TIMEOUT_STRING "Timeout"


/*
 * Reply types
 */
#define lcctooREPLY_NONE	0
#define lcctooREPLY_NORMAL	1
#define lcctooREPLY_VERBOSE	2
#define lcctooREPLY_ALL		3
#define lcctooREPLY_LAST	4


#endif // !LCCTOO_DEFINES_H

/************************************************************************/
/* ___oOo___ */
