#ifndef LQS_H
#define LQS_H
/******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: lqs.h,v 2.23 2005/10/11 16:20:36 vltsccm Exp $" 
*
* lqs.h
*
* who        when       what
* ---------- ---------- ----------------------------------------------
* ---v2.1---
* S.Sandrock 06.10.1994 New comment header,
*			removed include of "lqsObituary.h" (not public)
*	     14.10.1994 Added dummy-declarations of tool-functions.
*	     16.10.1994 Added declarations of public functions from 'lqs.c'.
* ---v2.2--- 31.10.1994 ---RELEASED---
*/

/************************************************************************
* Copyright (c) 1992	European  Southern  Observatory			*
*									*
*									*
*			Very Large Telescope Software			*
*			*****************************			*
*									*
*	Subsystem   :	Local Control Unit				*
*									*
*	Module      :	Q Server - lqs					*
*									*
*	Component   :	lqsLib.h					*
*									*
*	Produced by :	ESO						*
*									*
*	Author      :	A Wallander					*
*									*
*	Description :	Includes all include files required to use the	*
*			lqs interface. This should be the only include	*
*   			file included by the message system.		*
*									*
*	Change history :						*
*									*
*	Author	Date	Version		Description of change		*
*									*
*	AWA	10Mar93	  1.2		First version			*
*       AWA     18Nov93   1.3           (SBI-LQS-02) public prototypes  *
*       Phan    20Jan94   2.1   	Add RTAP 6.30 changes:		*
*					Acknowledge with sequence nbr	*
*					and ping request/response	*
*					VLT Programming Standard 	*
*					Suppress lqsVarious.h		*
*									*
*************************************************************************/

#include "lqsMain.h"
#include "lqsError.h"
#include "lqsLocalIo.h"
#include "lqsLocalTbl.h"
#include "lqsPipe.h"
#include "lqsTools.h"
#include "lqsLog.h"


extern void     lqsVersion(void);

#if 0 /* The following are dummy-declarations for lcudrvTk */
/*
 * These tool-functions are included in the Tools-menu of lcudrvTk
 */
void lqsPrintEnvTbl(void);
void lqsPrintLocalTbl(void);
void lqsWatch();
void lqsWatchEnable(void);
void lqsWatchDisable(void);
void lqsPrintSizeof(void);
void lqsObi(void);
void lqsPing(void);
void lqsTrace(void);
void lqsDebug(void);
#endif /* 0 */

extern void     lqs(void);
extern STATUS   lqsInit(int ackTimeout);
extern STATUS   lqsCloseAllSockets(void);
extern void     lqsReboot(void);

#endif /* !LQS_H */
