#ifndef LQS_ACK_H
#define LQS_ACK_H
/******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: lqsAck.h,v 2.23 2005/10/11 16:20:36 vltsccm Exp $" 
*
* lqsAck.h
*
* who        when       what
* ---------- ---------- ----------------------------------------------
* ---v2.1---
* S.Sandrock 06.10.1994 New comment header, revised Prototypes
* ---v2.2--- 31.10.1994 ---RELEASED---
*/

/************************************************************************
* Copyright (c) 1992	European  Southern  Observatory			*
*									*
*									*
*			Very Large Telescope Software			*
*			*****************************			*
*									*
*	Subsystem   :	Local Control Unit				*
*									*
*	Module      :	Q Server					*
*									*
*	Component   :	lqsAck.h					*
*									*
*	Produced by :	SpaceBel Informatique s.a.			*
*									*
*	Author      :	T. Phan Duc					*
*									*
*	Description :	Prototypes of ACK message timeout 		*
*									*
*	Change history :						*
*									*
*	Author	Date	Version		Description of change		*
*									*
*       Phan   20Jan94    2.1           First version according		*
*					to RTAP 6.30 			*
*									*
*************************************************************************/

void	lqsDecrementAckCtr(void);

void	lqsSetAckCtr(int		proc_num,
		     unsigned int 	msgSeqNum,
		     int 		fd,
		     rtMsgHeader *	msgHeaderPtr);

void	lqsResetAckCtr(int proc_num);

STATUS	lqsGetAckError(int procNum);

STATUS	lqsCheckAckCtr(void);

BOOL	lqsWaitAckCtr(int fd);

#endif /* !LQS_ACK_H */
