#ifndef LQS_ENVTBL_H
#define LQS_ENVTBL_H
/******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: lqsEnvTbl.h,v 2.23 2005/10/11 16:20:37 vltsccm Exp $" 
*
* lqsEnvTbl.h
*
* who        when       what
* ---------- ---------- ----------------------------------------------
* ---v2.1---
* S.Sandrock 06.10.1994 New comment header, revised Prototypes
*	     27.10.1994 Added member `netSuffix' in type `qsemuENV',
*			changed decl. of `lqsAddEnvTbl' accordingly.
* ---v2.2--- 31.10.1994 ---RELEASED---
* S.Sandrock 22.09.1995 Rtap 6.6: added `protocolVersion' in env-table.
* T.Ebert    08.11.2003 Added disconnectTime
*/

/************************************************************************
* Copyright (c) 1992	European  Southern  Observatory			*
*									*
*									*
*			Very Large Telescope Software			*
*			*****************************			*
*									*
*	Subsystem   :	Local Control Unit				*
*									*
*	Module      :	Q Server					*
*									*
*	Component   :	lqsEnvTbl.h					*
*									*
*	Produced by :	SpaceBel Informatique s.a.			*
*									*
*	Author      :	T. Phan Duc					*
*									*
*	Description :	Structures and Prototypes of functions to  	*
*			manage the environments table.			*
*									*
*									*
*	Change history :						*
*									*
*	Author	Date	Version		Description of change		*
*									*
*	Phan  	9Jun92	  0.0		First version			*
*	AWA    12Mar93    1.1		Partly VLT Programming Standard	*
*       Phan     Jan94    2.1           Add RTAP 6.30 changes:		*
*					Acknowledge with sequence nbr	*
*					and ping request/response	*
*					VLT Programming Standard 	*
*									*
*************************************************************************/

#define lqsENV_TBL_SIZE			20	/* max 20 environments */
	
typedef struct
	{
	rtProcessEnv	env;
	char		host [20];
	int		tcpPort;
	char		netSuffix[8];
	int		fd;
	int		protocolVersion;
	int	        pingCtr;
        unsigned int    disconnectTime;
	BOOL		waitPingResponse;
	} lqsENV;

typedef	lqsENV *	lqsENVP;

typedef	lqsENV		lqsENV_TBL [lqsENV_TBL_SIZE];

typedef	lqsENV_TBL *	lqsENV_TBLP;

 
STATUS	lqsInitEnvTbl(void);

STATUS	lqsAddEnvTbl(char *	envPtr,
		     char *	hostNamepPr,
		     char *	hostIpAddrPtr,
		     int	tcpPort,
		     char *	netSuffixPtr);

STATUS	lqsDeleteEnvTblSocket(int fd);

int	lqsGetEnvTblSocket(char * envPtr);

char *	lqsGetEnvTblEnv(int fd);

STATUS	lqsVerifyEnvTbl(char *envPtr);

lqsENV * lqsGetEnvTblPtr(const char * envPtr);


BOOL lqsWaitPingResponse(char *envPtr);

void lqsDecrementPingCtr(void);

void lqsSetPingCtr(char *envPtr);

void lqsResetPingCtr(char *envPtr);

STATUS lqsCheckPingCtr(void);

#endif /* !LQS_ENVTBL_H */
