#ifndef LQS_LOCALIO_H
#define LQS_LOCALIO_H
/******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: lqsLocalIo.h,v 2.23 2005/10/11 16:20:37 vltsccm Exp $" 
*
* lqsLocalIo.h
*
* who        when       what
* ---------- ---------- ----------------------------------------------
* ---v2.1---
* S.Sandrock 06.10.1994 New comment header, revised Prototypes
* ---v2.2--- 31.10.1994 ---RELEASED---
*/

/************************************************************************
* Copyright (c) 1992	European  Southern  Observatory			*
*									*
*									*
*			Very Large Telescope Software			*
*			*****************************			*
*									*
*	Subsystem   :	Local Control Unit				*
*									*
*	Module      :	Q Server					*
*									*
*	Component   :	lqsLocalIo.h					*
*									*
*	Produced by :	SpaceBel Informatique s.a.			*
*									*
*	Author      :	T. Phan Duc					*
*									*
*	Description :	Prototypes of functions to manage the		*
*			communication FROM QServer TO a local process.	*
*									*
*			Currently this one_way communication is based	*
*			on the VxWorks msg Q functions.			*
*									*
*		Functions are :						*
*		- lqsOpenLocal :					*
*			Used by the local process to create the msg Q.	*
*			Return ERROR or the msg Q id (integer).		*
*		- lqsCloseLocal :					*
*			Used by the local process to delete the msg Q.	*
*			Return OK or ERROR.				*
*		- lqsReadLocal :					*
*			Used by the local process to read incoming data.*
*			Return OK or errors.				*
*		- lqsWriteLocal :					*
*			Used by the Q Server to send data received from	*
*			the network to local process.			*
*			Return OK or errors.				*
*									*
*	Change history :						*
*									*
*	Author	Date	Version		Description of change		*
*									*
*	Phan  	5Jun92	  0.0		First version			*
*       AWA    12Mar93    1.1           Partly VLT Programming Standard *
*       AWA     6Dec93    1.3           SBI-LQS-07 lqsReadLocal         *
*									*
*************************************************************************/

int	lqsOpenLocal(int maxMsgs);

int	lqsCloseLocal(int communicationId);

int	lqsReadLocal(int	communicationId,
		     char **	msg_ptr,
		     int	timeout);

int	lqsWriteLocal(int	communicationId,
		      char *	msgPtr,
		      int	NBytes,
		      int	timeout);

#endif /* !LQS_LOCALIO_H */
