#ifndef LQS_MAIN_H
#define LQS_MAIN_H
/******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: lqsMain.h,v 2.23 2005/10/11 16:20:38 vltsccm Exp $" 
*
* lqsMain.h
*
* who        when       what
* ---------- ---------- ----------------------------------------------
* ---v2.1---
* S.Sandrock 06.10.1994 New comment header, revised Prototypes,
*			removed declaration of 'lqsRequestConnectionToRemote'
* ---v2.2--- 31.10.1994 ---RELEASED---
* S.Sandrock 10.11.1994 Added and updated `lqsVERSION_STRING'.
* --v2.2.1-- 11.11.1994 ---RELEASED---
* S.Sandrock 02.01.1995 Updated `lqsVERSION_STRING'.
* --v2.2.2-- 02.01.1995 ---RELEASED---
* S.Sandrock 30.01.1995 Updated `lqsVERSION_STRING'.
* --v2.2.3-- 03.02.1995
* S.Sandrock 03.02.1995 Updated `lqsVERSION_STRING'.
* ---v2.3--- 06.02.1995 ---RELEASED---
* S.Sandrock 22.09.1995 Rtap 6.6 compatibility: changed `lqsNET_PACKET_ID'.
*/

#define lqsVERSION_STRING \
	"LCU Q-Server lqs $Revision: 2.23 $ $Date: 2005/10/11 16:20:38 $"

/************************************************************************
* Copyright (c) 1992	European  Southern  Observatory			*
*									*
*									*
*			Very Large Telescope Software			*
*			*****************************			*
*									*
*	Subsystem   :	Local Control Unit				*
*									*
*	Module      :	Q Server					*
*									*
*	Component   :	lqsMain.h					*
*									*
*	Produced by :	SpaceBel Informatique s.a.			*
*									*
*	Author      :	T. Phan Duc					*
*									*
*	Description :	Structures used by the LCU Q Server.		*
*									*
*	Change history :						*
*									*
*	Author	Date	Version		Description of change		*
*									*
*	Phan  	9Jun92	  0.0		First version			*
*       AWA    12Mar93    1.1           Partly VLT Programming Standard *  
*       Phan   20Jan94    2.1           Add RTAP 6.30 changes:		*  
*					Acknowledge with sequence nbr	*
*					and ping request/response	*
*					VLT Programming Standard 	*
*									*
*************************************************************************/

#include "lqsRtap.h" /* Rtap compatibility header */


/*
 * lqs definitions and defaults:
 */
#define lqsPROTOCOL_VERSION		3   /* default lqs protocolVersion */
#define lqsPROTOCOL_VERSION_RTAP_6_6	3   /* identifies Rtap rev. >= 6.6 */
#define lqsPROC_NUM			3   /* default lqs process-number  */
#define lqsMAX_PROC_NUM			255 /* max. number of processes    */


/*
 * Rtap defined msg-types (Q-Server internal):
 */
#define	rtREMOTE_QUERY_PROCNUM		11
#define	rtREMOTE_QUERY_PROCNAME		12
#define	rtREMOTE_PROCNUM		13
#define	rtREMOTE_PROCNAME		14

#define	rtQ_SERVER_PING_REQUEST		37
#define	rtQ_SERVER_PING_RESPONSE	38
#define	rtQ_SERVER_ACKNOWLEDGE		39


#define	qsAnyProcNum_C			0
#define	qsAnyEnvironment_C	(char*) 0


/* used by local processes */

typedef struct
	{
	rtMsgHeader	msgHeader;
	union
		{
		char		str [rtMSGSIZE - sizeof (rtMsgHeader)];
		rtAcknowledge	ack;
		rtObituary	obi;
		int		param [1];
		} body;
	}	lqsMSG;

typedef lqsMSG *		lqsMSGP;


/* used by network */

typedef struct
	{
	rtInt32		netPacketSize;
	char		userName [9];
	rtUInt8		reserved;
	rtUInt16	msgSeqNum;
	}	lqsNET_HEADER;

typedef struct
	{
	lqsNET_HEADER		netHeader;
	lqsMSG			msg;
	}	lqsNET_PACKET;

typedef	lqsNET_PACKET *		lqsNET_PACKETP;


typedef struct
	{
	rtProcessId	procId;
	rtUInt8		protocolVersion;
	}	lqsHELLO_MSG;

typedef struct
	{
	lqsNET_HEADER	netHeader;
	lqsHELLO_MSG	helloMsg;
	}	lqsNET_PACKET_ID;


char *	lqsGetLocalEnv(void);
STATUS	lqsCheckLocalEnv(const char *env);
STATUS	lqsFillLocalEnv(char *localEnv, const char *destEnv);

int     lqsCheckDead(void);

int     lqsGetAckTimeout(void);

STATUS  lqsExitTask(WIND_TCB *tcbPtr);

#endif /* !LQS_MAIN_H */
