#ifndef LQS_OBITUARY_H
#define LQS_OBITUARY_H
/******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: lqsObituary.h,v 2.23 2005/10/11 16:20:38 vltsccm Exp $" 
*
* lqsObituary.h
*
* who        when       what
* ---------- ---------- ----------------------------------------------
* ---v2.1---
* S.Sandrock 06.10.1994 New comment header, revised Prototypes
* ---v2.2--- 31.10.1994 ---RELEASED---
*/

/************************************************************************
* Copyright (c) 1992	European  Southern  Observatory			*
*									*
*									*
*			Very Large Telescope Software			*
*			*****************************			*
*									*
*	Subsystem   :	Local Control Unit				*
*									*
*	Module      :	Q Server					*
*									*
*	Component   :	lqsObituary.h					*
*									*
*	Produced by :	SpaceBel Informatique s.a.			*
*									*
*	Author      :	T. Phan Duc					*
*									*
*	Description :	Prototypes of obituary functions.		*
*									*
*	Change history :						*
*									*
*	Author	Date	Version		Description of change		*
*									*
*	Phan  	3Nov92	  0.0		First version			*
*       Phan   20Jan94    2.1   	Add RTAP 6.30 changes:		*
*					Acknowledge with sequence nbr	*
*					and ping request/response	*
*					VLT Programming Standard 	*
*									*
*************************************************************************/

int	lqsFillObituaryMsg(lqsMSGP	msgPtr, 
			   int		obiProcNum,
			   char *	obiEnvPtr);
		
STATUS	lqsObituarySendToAllLocalProcess(lqsNET_PACKETP netMsgPtr);

STATUS	lqsObituarySendToAllRemoteEnv(lqsNET_PACKETP netMsgPtr);

STATUS	lqsObituaryEnvironment(int fd);

STATUS	lqsObituaryCleanup(int qsProcNum);
		
#endif /* !LQS_OBITUARY_H */
