#ifndef LQS_PIPE_H
#define LQS_PIPE_H
/******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: lqsPipe.h,v 2.23 2005/10/11 16:20:38 vltsccm Exp $" 
*
* lqsPipe.h
*
* who        when       what
* ---------- ---------- ----------------------------------------------
* ---v2.1---
* S.Sandrock 06.10.1994 New comment header, revised Prototypes
* ---v2.2--- 31.10.1994 ---RELEASED---
*/

/************************************************************************
* Copyright (c) 1992	European  Southern  Observatory			*
*									*
*									*
*			Very Large Telescope Software			*
*			*****************************			*
*									*
*	Subsystem   :	Local Control Unit				*
*									*
*	Module      :	Q Server					*
*									*
*	Component   :	lqsPipe.h					*
*									*
*	Produced by :	SpaceBel Informatique s.a.			*
*									*
*	Author      :	T. Phan Duc					*
*									*
*	Description :	Prototypes of functions to manage the		*
*			communication TO QServer FROM a local process.	*
*									*
*			Currently this one_way communication is based	*
*			on the VxWorks pipe.				*
*									*
*		Functions are :						*
*		- lqsCreatePipe :					*
*			Create a pipe.					*
*			Return OK or ERROR.				*
*		- lqsOpenPipe :						*
*			Return ERROR or the file descriptor.		*
*		- lqsClosePipe :					*
*			Return OK or ERROR.				*
*		- lqsReadPipe :						*
*			Used by the QServer to read incoming data.	*
*			Return OK or the number of bytes received.	*
*		- lqsWritePipe :					*
*			Used by the local processes to send data. 	*
*			Return OK or ERROR.				*
*	Change history :						*
*									*
*	Author	Date	Version		Description of change		*
*									*
*	Phan  	Dec92	  0.0		First version			*
*       AWA    12Mar93    1.1           Partly VLT Programming Standard *
*       Phan    Jan94     2.1   	Add RTAP 6.30 changes:		*
*					Acknowledge with sequence nbr	*
*					and ping request/response	*
*					VLT Programming Standard 	*
*					lqsCreatePipe: Fixed pipe size	*
*					lqsReadPipe and lqsWritePipe:	*
*					Change of message passing mode 	*
*									*
*************************************************************************/


STATUS	lqsCreatePipe(void);

int	lqsOpenPipe(void);

int	lqsClosePipe(int fd);

int	lqsReadPipe(int	commId, 
		    char **msgPtr);

int	lqsWritePipe(int commId,
		     char *msgPtr,
		     int bytes);

#endif /* !LQS_PIPE_H */
