#ifndef LQS_TOOLS_H
#define LQS_TOOLS_H
/******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: lqsTools.h,v 2.23 2005/10/11 16:20:39 vltsccm Exp $" 
*
* lqsTools.h
*
* who        when       what
* ---------- ---------- ----------------------------------------------
* ---v2.1---
* S.Sandrock 06.10.1994 New comment header, revised Prototypes
* ---v2.2--- 31.10.1994 ---RELEASED---
*/

/************************************************************************
* Copyright (c) 1992	European  Southern  Observatory			*
*									*
*									*
*			Very Large Telescope Software			*
*			*****************************			*
*									*
*	Subsystem   :	Local Control Unit				*
*									*
*	Module      :	LCU Q Server					*
*									*
*	Component   :	lqsTools.h					*
*									*
*	Produced by :	SpaceBel Informatique s.a.			*
*									*
*	Author      :	T. Phan Duc					*
*									*
*	Description :	Prototypes of functions used for debugging	*
*			purpose, to display message contents, such as	*
*			headers, body...				*
*									*
*	Change history :						*
*									*
*	Author	Date	Version		Description of change		*
*									*
*	Phan  	Jul92	  0.0		First version			*
*       AWA     9Mar93    1.2           Partly VLT Programming Standard *
*									*
*************************************************************************/

void	lqsPrintNetheader(lqsNET_HEADER *netHeader_ptr);

void	lqsPrintMsgheader(rtMsgHeader *msgHeader_ptr);

void	lqsPrintMsgbody(char *str);

void	lqsPrintNack(rtAcknowledge *ack_ptr);

const char * lqsGetMsgTypeStr(rtUInt8 msgType);
const char * lqsGetMsgFlagStr(rtUInt8 responseFlag);
const char * lqsGetErrorStr(int error);

#endif /* !LQS_TOOLS_H */
