#ifndef LSF_CONTROL_H
#define LSF_CONTROL_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: lsfControl.h,v 1.121 2005/09/14 07:02:58 vltsccm Exp $"
*
* who       when        what
* --------  ----------  ----------------------------------------------
* pduhoux   2000-05-02  created
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */
#include "lsfDefines.h"
#include "lsfDevice.h"

typedef struct
{
    vltBYTES20 name;
    vltINT32   type;
    vltINT32   startPhase;
    vltINT32   stopPhase;
    vltLOGICAL simulation;
    vltLOGICAL ignored;
} lsfCONTROL_ENTRY;

typedef struct
{
    void             *ctrlData;
    void             *srvrData;
    int               numDevices[lsfDEVICE_NUM_TYPES+1];
    lsfCONTROL_ENTRY *deviceTable;
    lsfDEVICE_DATA   *deviceData[lsfDEVICE_NUM_TYPES+1];
    char             *attrTable;
} lsfCONTROL_DATA;

ccsCOMPL_STAT lsfControlConstructor ( IN  const char      *swdName, 
				      IN  lsfDEVICE_DATA  *serverData, 
				      OUT ccsERROR        *error );
void          lsfControlDestructor  ( IN  lsfDEVICE_DATA  *serverData );

void         *lsfControlGetDevData  ( IN  lsfCONTROL_DATA *controlData,
				      IN  int              devType );
int           lsfControlGetDevType  ( IN  lsfCONTROL_DATA *controlData,
				      IN  const char      *devName );
int           lsfControlGetDevNamesOfType  ( IN  lsfCONTROL_DATA *controlData,
					     IN  int              devType,
					     IN  const char      *devNames[] );
const char   *lsfControlGetSwdName  ( IN  void       *pData );

ccsCOMPL_STAT lsfControlOff       ( IN  lsfCONTROL_DATA *controlData, 
				    IN  const char      *devName,
				    OUT ccsERROR        *error );
ccsCOMPL_STAT lsfControlStop      ( IN  lsfCONTROL_DATA *controlData, 
				    IN  const char      *devName,
				    OUT ccsERROR        *error );
ccsCOMPL_STAT lsfControlInit      ( IN  lsfCONTROL_DATA *controlData,
				    IN  const char      *devName,
				    OUT ccsERROR        *error );
ccsCOMPL_STAT lsfControlOnline    ( IN  lsfCONTROL_DATA *controlData, 
				    IN  const char      *devName,
				    OUT ccsERROR        *error );
ccsCOMPL_STAT lsfControlStandby   ( IN  lsfCONTROL_DATA *controlData, 
				    IN  const char      *devName,
				    OUT ccsERROR        *error );
ccsCOMPL_STAT lsfControlExit      ( IN  lsfCONTROL_DATA *controlData, 
				    IN  const char      *devName,
				    OUT ccsERROR        *error );
ccsCOMPL_STAT lsfControlSimulat   ( IN  lsfCONTROL_DATA *controlData, 
				    IN  const char      *devName,
				    OUT ccsERROR        *error );
ccsCOMPL_STAT lsfControlStopsim   ( IN  lsfCONTROL_DATA *controlData, 
				    IN  const char      *devName,
				    OUT ccsERROR        *error );
ccsCOMPL_STAT lsfControlSelftest  ( IN  lsfCONTROL_DATA *controlData, 
				    IN  const char      *devName,
				    OUT ccsERROR        *error );
ccsCOMPL_STAT lsfControlTest      ( IN  lsfCONTROL_DATA *controlData, 
				    IN  const char      *devName,
				    OUT ccsERROR        *error );

#endif /*!LSF_CONTROL_H*/
