#ifndef LSF_DEFINES_H
#define LSF_DEFINES_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: lsfDefines.h,v 1.121 2005/09/14 07:02:55 vltsccm Exp $"
*
* who       when        what
* --------  ----------  ----------------------------------------------
* pduhoux   2000-04-10  created
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */

/*
 * Constants
 */
#define lsfVERSION      "$Revision: 1.121 $"
#define lsfVERSION_DATE "APR2004"

#ifndef __FILE_LINE__
#define _lsf_tostr(a) #a
#define _lsf_tostr_pass2(a) _lsf_tostr(a)

#define __FILE_LINE__  __FILE__ ":" _lsf_tostr_pass2(__LINE__)
#endif

#define lsfMODULE_ID    "lsf"	/* module name */
#define lsfMODULE_NAME   lsfMODULE_ID
#define lsfMODULE_TITLE  "LCU Server Framework"
#define lsfLOG_ID 	 100

#define lsfMAX_DEVICES         512
#define lsfMAX_MOTORS           24

#define lsfMAX_PLC_CFGRDDATA    32
#define lsfMAX_PLC_CFGWRDATA    16
#define lsfMAX_PLC_RUNRDDATA    32
#define lsfMAX_PLC_RUNWRDATA    16

/*
 * Default timeout for devices in seconds
 */
#define lsfDEVICE_TIMEOUT      120

/*
 * Default task options for taskSpawn()
 */
#define lsfTASK_OPTIONS        VX_FP_TASK

/*
 * Database
 */   
#define lsfDB_CONTROL_POINT    ":control"
#define lsfDB_CONFIG_POINT     ":config"
#define lsfDB_DATA_POINT       ":data"

#define lsfDB_SIGNAL_POINT     ":signal"
#define lsfDB_MOTOR_POINT      ":motor"
#define lsfDB_SERIAL_POINT     ":serial"
#define lsfDB_ENCODER_POINT    ":encoder"
#define lsfDB_NETWORK_POINT    ":network"
#define lsfDB_SOFTDEV_POINT    ":softdev"
#define lsfDB_TASKDEV_POINT    ":taskdev"
#define lsfDB_MISCDEV_POINT    ":miscdev"

#define lsfALL_DEVICES         "all"

#define lsfDEVTYPE_SIGNAL_STR     "signal"
#define   lsfDEVTYPE_ANALOG_STR   "analog"
#define   lsfDEVTYPE_DIGITAL_STR  "digital"
#define lsfDEVTYPE_MOTOR_STR      "motor"
#define lsfDEVTYPE_SERIAL_STR     "serial"
#define   lsfDEVTYPE_TYCO_STR     "tyCo"
#define   lsfDEVTYPE_RS232_STR    "rs232"
#define   lsfDEVTYPE_RS422_STR    "rs422"
#define   lsfDEVTYPE_RS485_STR    "rs485"
#define   lsfDEVTYPE_PLC_STR      "plc"
#define   lsfDEVTYPE_STEP5_STR    "step5"
#define   lsfDEVTYPE_STEP7_STR    "step7"
#define   lsfDEVTYPE_EY2400_STR   "ey2400"
#define lsfDEVTYPE_ENCODER_STR    "encoder"
#define   lsfDEVTYPE_IK320_STR    "ik320"
#define lsfDEVTYPE_NETWORK_STR    "network"
#define   lsfDEVTYPE_ETHERNET_STR "ethernet"
#define   lsfDEVTYPE_NET01_STR    "net01"
#define   lsfDEVTYPE_ATM_STR      "atm"
#define lsfDEVTYPE_SOFTDEV_STR    "softdev"
#define lsfDEVTYPE_TASKDEV_STR    "taskdev"
#define lsfDEVTYPE_MISCDEV_STR    "miscdev"
#define   lsfDEVTYPE_TAC_STR      "tac"

#define lsfDEVICE_NUM_TYPES 8
#define lsfDEVICE_SIGNAL    1
#define lsfDEVICE_MOTOR     2
#define lsfDEVICE_SERIAL    3
#define lsfDEVICE_ENCODER   4
#define lsfDEVICE_NETWORK   5
#define lsfDEVICE_SOFTDEV   6
#define lsfDEVICE_TASKDEV   7
#define lsfDEVICE_MISCDEV   8

/* lsfDEVTYPE_<device> = (0x100 << (lsfDEVICE_<type>-1)) + <kind> */
#define lsfDEVTYPE_MASK       0xFF00
#define lsfDEVTYPE_UNKNOWN    0
#define lsfDEVTYPE_SIGNAL     0x0100
#define   lsfDEVTYPE_ANALOG   0x0101      /* = lsfDEVTYPE_SIGNAL | ioANALOG  */
#define   lsfDEVTYPE_DIGITAL  0x0102      /* = lsfDEVTYPE_SIGNAL | ioDIGITAL */
#define lsfDEVTYPE_MOTOR      0x0200
#define lsfDEVTYPE_SERIAL     0x0400
#define   lsfDEVTYPE_RS232    0x0401
#define   lsfDEVTYPE_RS422    0x0402
#define   lsfDEVTYPE_RS485    0x0404
#define   lsfDEVTYPE_PLC      0x0411      /* = lsfDEVTYPE_RS232 | 0x10 */
#define lsfDEVTYPE_ENCODER    0x0800
#define   lsfDEVTYPE_IK320    0x0801
#define lsfDEVTYPE_NETWORK    0x1000
#define   lsfDEVTYPE_ETHERNET 0x1001
#define   lsfDEVTYPE_NET01    0x1002
#define   lsfDEVTYPE_ATM      0x1004
#define lsfDEVTYPE_SOFTDEV    0x2000
#define lsfDEVTYPE_TASKDEV    0x4000
#define lsfDEVTYPE_MISCDEV    0x8000

#define lsfSTATE_OFF     1
#define lsfSTATE_LOADED  2
#define lsfSTATE_STANDBY 3
#define lsfSTATE_ONLINE  4

#define lsfUNCHANGED -99

#define lsfSUBSTATE_UNKNOWN     -1
#define lsfSUBSTATE_IDLE         0
#define lsfSUBSTATE_ERROR        1
#define lsfSUBSTATE_TIMEOUT      2
#define lsfSUBSTATE_INITIALIZING 3
#define lsfSUBSTATE_ACTIVE       4
#define lsfSUBSTATE_MONITORING   5
#define lsfSUBSTATE_MOVING       6
#define lsfSUBSTATE_WAITING      7
#define lsfSUBSTATE_READY        8

#define lsfATTR_NAMES \
    "state","substate","simulation","initialized","timeout"

#define lsfDB_STATE          0
#define lsfDB_SUBSTATE       1
#define lsfDB_SIMULATION     2
#define lsfDB_INITIALIZED    3
#define lsfDB_TIMEOUT        4
#define lsfDB_LAST           5 

#define lsfPLC_NONE   0
#define lsfPLC_EY2400 1
#define lsfPLC_RK512  2
#define lsfPLC_LAST   3

#define lsfPLC_EY2400_STR "EY2400"
#define lsfPLC_RK512_STR  "RK512"

#endif /*!LSF_DEFINES_H*/
