#ifndef LSF_INTERFACE_H
#define LSF_INTERFACE_H
/************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: lsfInterface.h,v 1.121 2005/09/14 07:02:55 vltsccm Exp $"
*
* who       when        what
* --------  ----------  ----------------------------------------------
* pduhoux   2000-02-23  created
*/

/************************************************************************/

#ifdef __cplusplus
extern "C" {
#endif

#define lsfACI_FUNCTION(mod,fct) \
ccsCOMPL_STAT I ## mod ## fct ( \
    IN  const char   *parameters,       /* Formatted input parameters   */ \
    IN  msgMSG       *msg,              /* Message body used for reply  */ \
    OUT char         **replyBuffer,     /* Output buffer                */ \
    OUT msgLENGTH    *replyBufferSize,  /* Output buffer size           */ \
    OUT ccsERROR     *error )           /* Returned error structure     */

#define lsfACI_PARAMS  \
    parameters,msg,replyBuffer,replyBufferSize,error

#define lsfVERBOSE_CMD_RECV(cmd) \
    if (lcuVerbose(msg,cmd ## ": Command received",error) != SUCCESS) \
        return FAILURE
#define lsfVERBOSE_CMD_DONE(cmd) \
    if (lcuVerbose(msg,cmd ## ": Command executed",error) != SUCCESS) \
        return FAILURE

#define lsfSTD_COMMAND(mod,fct,cmd) \
    lsfACI_FUNCTION(mod,Std ## fct) \
    { \
    ccsCOMPL_STAT status;                           \
    lsfVERBOSE_CMD_RECV(cmd);                       \
    status = mod ## Std ## fct (parameters,error);  \
    lsfVERBOSE_CMD_DONE(cmd);                       \
    lsfSTD_REPLY;                                   \
    }

#define lsfSTD_REPLY \
    if (status == SUCCESS)                      \
        {                                       \
        sprintf(msg->body,"OK");                \
        *replyBuffer=(char *)&msg->body;        \
        *replyBufferSize=strlen(msg->body) + 1; \
        }                                       \
    return (status)

#define lsfREPLY_OK(status,msg,buffer,size) \
    if (status == SUCCESS)                      \
        {                                       \
        sprintf(msg->body,"OK");                \
        *buffer=(char *)&msg->body;             \
        *size=strlen(msg->body) + 1;            \
        }

#define lsfTASK_REGISTER(mod,id) \
  {                                           \
  ccsPROCNAME ccsProcName;                    \
  sprintf(ccsProcName,"%.8s%.4s%04X",mod,id,(taskIdSelf() & 0x0000FFFF));  \
  if (ccsInit(ccsProcName,0,NULL,NULL,error) != SUCCESS)               \
      return FAILURE;                                                  \
  }

#ifdef __cplusplus
}
#endif

#endif /*!LSF_INTERFACE_H*/
