#ifndef LSF_MISCDEV_H
#define LSF_MISCDEV_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: lsfMiscDev.h,v 1.121 2005/09/14 07:03:00 vltsccm Exp $"
*
* who       when        what
* --------  ----------  ----------------------------------------------
* pduhoux   2000-04-05  created
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */
#include "lsfControl.h"

typedef struct
{
    lsfSTATE    state;
    lsfSUBSTATE subState;
    vltLOGICAL  init;
    vltLOGICAL  simulation;
    vltINT32    timeout;
} lsfMISCDEV_ENTRY;

typedef struct
{
    void              *ctrlData;
    void              *userData;
    lsfSTATE           state;
    lsfSUBSTATE        subState;
    vltLOGICAL         init;
    vltLOGICAL         simulation;
    vltINT32           timeout;      /* Timeout in milli-seconds    */
    vltINT32           numMiscDevs;

    vltBYTES20        *miscDevNames;
    char              *attrTable[lsfMAX_DEVICES+1];
    lsfMISCDEV_ENTRY  *miscDevTable[lsfMAX_DEVICES];
} lsfMISCDEV_DATA;

typedef ccsCOMPL_STAT lsfMISCDEV_HOOK ( IN  lsfMISCDEV_DATA *miscDevData, 
				        IN  const char      *miscDevName, 
				        OUT ccsERROR        *error);

#define lsfMiscDevGetData(ptr) \
    (lsfMISCDEV_DATA *)lsfControlGetDevData((lsfCONTROL_DATA *)(((lsfCONTROL_DATA *)ptr)->ctrlData),lsfDEVICE_MISCDEV)
#define lsfMiscDevGetUserData(ptr) \
    (lsfMiscDevGetData(ptr))->userData

ccsCOMPL_STAT lsfMiscDevConstructor ( IN  const char      *swdName, 
				      IN  lsfCONTROL_DATA *controlData,
				      IN  const char      *miscDevNames[],
				      OUT ccsERROR        *error );
void          lsfMiscDevDestructor  ( IN  lsfCONTROL_DATA *controlData );

ccsCOMPL_STAT lsfMiscDevInit      ( IN  lsfMISCDEV_DATA *miscDevData, 
				    IN  const char      *miscDevName, 
				    OUT ccsERROR        *error );
ccsCOMPL_STAT lsfMiscDevStandby   ( IN  lsfMISCDEV_DATA *miscDevData, 
				    IN  const char      *miscDevName, 
				    OUT ccsERROR        *error );
ccsCOMPL_STAT lsfMiscDevOnline    ( IN  lsfMISCDEV_DATA *miscDevData, 
				    IN  const char      *miscDevName, 
				    OUT ccsERROR        *error );
ccsCOMPL_STAT lsfMiscDevStop      ( IN  lsfMISCDEV_DATA *miscDevData, 
				    IN  const char      *miscDevName, 
				    OUT ccsERROR        *error );
ccsCOMPL_STAT lsfMiscDevOff       ( IN  lsfMISCDEV_DATA *miscDevData, 
				    IN  const char      *miscDevName, 
				    OUT ccsERROR        *error );
ccsCOMPL_STAT lsfMiscDevExit      ( IN  lsfMISCDEV_DATA *miscDevData, 
				    IN  const char      *miscDevName, 
				    OUT ccsERROR        *error );
ccsCOMPL_STAT lsfMiscDevSimulat   ( IN  lsfMISCDEV_DATA *miscDevData, 
				    IN  const char      *miscDevName, 
				    OUT ccsERROR        *error );
ccsCOMPL_STAT lsfMiscDevStopsim   ( IN  lsfMISCDEV_DATA *miscDevData, 
				    IN  const char      *miscDevName, 
				    OUT ccsERROR        *error );
ccsCOMPL_STAT lsfMiscDevSelftest  ( IN  lsfMISCDEV_DATA *miscDevData, 
				    IN  const char      *miscDevName, 
				    OUT ccsERROR        *error );
ccsCOMPL_STAT lsfMiscDevTest      ( IN  lsfMISCDEV_DATA *miscDevData, 
				    IN  const char      *miscDevName, 
				    OUT ccsERROR        *error );

#endif /*!LSF_MISCDEV_H*/

