#ifndef LSF_SOFTDEV_H
#define LSF_SOFTDEV_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: lsfSoftDev.h,v 1.121 2005/09/14 07:02:59 vltsccm Exp $"
*
* who       when        what
* --------  ----------  ----------------------------------------------
* pduhoux   2000-04-05  created
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */
#include "lsfControl.h"

typedef struct
{
    lsfSTATE    state;
    lsfSUBSTATE subState;
    vltLOGICAL  init;
    vltLOGICAL  simulation;
    vltINT32    timeout;            /* Timeout in milli-seconds    */

    vltBYTES20  serverName;
} lsfSOFTDEV_ENTRY;

typedef struct
{
    void              *ctrlData;
    void              *userData;
    lsfSTATE           state;
    lsfSUBSTATE        subState;
    vltLOGICAL         init;
    vltLOGICAL         simulation;
    vltINT32           timeout;            /* Timeout in milli-seconds    */
    vltINT32           numSoftDevs;

    vltBYTES20        *softDevNames;
    char              *attrTable[lsfMAX_DEVICES+1];
    lsfSOFTDEV_ENTRY  *softDevTable[lsfMAX_DEVICES];
} lsfSOFTDEV_DATA;

#define lsfSoftDevGetData(ptr) \
    (lsfSOFTDEV_DATA *)lsfControlGetDevData((lsfCONTROL_DATA *)(((lsfCONTROL_DATA *)ptr)->ctrlData),lsfDEVICE_SOFTDEV)
#define lsfSoftDevGetUserData(ptr) \
    (lsfSoftDevGetData(ptr))->userData

ccsCOMPL_STAT lsfSoftDevConstructor ( IN  const char      *swdName, 
				      IN  lsfCONTROL_DATA *controlData,
				      IN  const char      *softDevNames[],
				      OUT ccsERROR        *error );
void          lsfSoftDevDestructor  ( IN  lsfCONTROL_DATA *controlData );

ccsCOMPL_STAT lsfSoftDevInit      ( IN  lsfSOFTDEV_DATA *softDevData, 
				    IN  const char      *softDevName, 
				    OUT ccsERROR        *error );
ccsCOMPL_STAT lsfSoftDevStandby   ( IN  lsfSOFTDEV_DATA *softDevData, 
				    IN  const char      *softDevName, 
				    OUT ccsERROR        *error );
ccsCOMPL_STAT lsfSoftDevOnline    ( IN  lsfSOFTDEV_DATA *softDevData, 
				    IN  const char      *softDevName, 
				    OUT ccsERROR        *error );
ccsCOMPL_STAT lsfSoftDevStop      ( IN  lsfSOFTDEV_DATA *softDevData, 
				    IN  const char      *softDevName, 
				    OUT ccsERROR        *error );
ccsCOMPL_STAT lsfSoftDevOff       ( IN  lsfSOFTDEV_DATA *softDevData, 
				    IN  const char      *softDevName, 
				    OUT ccsERROR        *error );
ccsCOMPL_STAT lsfSoftDevExit      ( IN  lsfSOFTDEV_DATA *softDevData, 
				    IN  const char      *softDevName, 
				    OUT ccsERROR        *error );
ccsCOMPL_STAT lsfSoftDevSimulat   ( IN  lsfSOFTDEV_DATA *softDevData, 
				    IN  const char      *softDevName, 
				    OUT ccsERROR        *error );
ccsCOMPL_STAT lsfSoftDevStopsim   ( IN  lsfSOFTDEV_DATA *softDevData, 
				    IN  const char      *softDevName, 
				    OUT ccsERROR        *error );
ccsCOMPL_STAT lsfSoftDevSelftest  ( IN  lsfSOFTDEV_DATA *softDevData, 
				    IN  const char      *softDevName, 
				    OUT ccsERROR        *error );
ccsCOMPL_STAT lsfSoftDevTest      ( IN  lsfSOFTDEV_DATA *softDevData, 
				    IN  const char      *softDevName, 
				    OUT ccsERROR        *error );

ccsCOMPL_STAT lsfForwardCommand   ( IN  lsfSOFTDEV_DATA *softDevData, 
				    IN  const char      *devName,
				    IN  const char      *command,
				    IN  const char      *param,
				    OUT char            *reply,
				    OUT ccsERROR        *error);

#endif /*!LSF_SOFTDEV_H*/

