#ifndef MCON_H
#define MCON_H
/******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: mcon.h,v 2.35 2003/11/11 13:40:39 vltsccm Exp $" 
*
* mcon.h - This is the interface file for the LCU MACCON device driver which
*          forms a module of the VLT software. It contains the declarations
*          user available constants, data types and variables as well as the
*          function prototypes
*
* who        when       what
* ---------  ---------- ----------------------------------------------
* ?             ?       First version
* S.Sandrock 21.06.1994 Modifications:
*			- Declaration for 'mconDevCreate()' updated
* S.Sandrock 22.08.1994 Included "lcudrvPublic.h"
*	     02.09.1994 mconVer --> mconVersion
*	     07.09.1994 added mconParMode
* ---v2.0--- 08.02.1995 ---RELEASED---
* bgustafs   2/12/96   added mconLog prototype
*---------------------------------------------------------------------------
*/


#include "lcudrvPublic.h"	/* include public common driver literals */
#include "mconCommands.h"	/* include MCON command definitions      */
#include "mconErrors.h"         /* include MCON error codes and literals */


/*
 * MCON driver provided functions
 */
extern int mconDrv ( int devices, int channels, int timeout);
extern int mconDevCreate (char *devName, 
			  void *baseAddr, 
			  int devNumber, 
			  int backplaneAddr,
			  u_char vectorOutputNbr,
			  u_char vectorNbrDriveFault,
			  u_char vectorNbrMotionEnd, 
			  u_char vectorNbrEmergencyStop, 
			  int intrLevel,
			  int mac4Version);
		   
/*
 * MCON tools
 */
extern void mconVersion (int axis);
extern void mconDevShow (void);
extern void mconSt (int axis);
extern void mconSSt (int axis);
extern void mconCSt (int axis);
extern void mconStAll ( void );
extern void mconPos (int axis);
extern void mconPar (int axis);
extern void mconParMode (int axis);
extern void mconParDC (int axis);
extern void mconParSSI (int axis);
extern void mconParStep (int axis);
extern void mconParAux (int axis);
extern void mconSetSP ( int axis, int sp );
extern void mconSizeofPrint ( void );
extern void mconErrorPrint (int err);
extern STATUS mconProbe (int device);
extern void mconLog (int level);
extern void mconShowQ (int device);

#endif /* !MCON_H */
