#ifndef MCON_ERROR_H
#define MCON_ERROR_H
/******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: mconErrors.h,v 2.35 2003/11/11 13:40:40 vltsccm Exp $"
*
* mconErrors.h - Contains literals for all MACCON driver error codes,
*                returned from the ioctl calls
*
* who        when       what
* ---------- ---------- ----------------------------------------------
* ?          ?          First version
* S.Sandrock 20.07.1994 Updated error codes
* S.Sandrock 08.12.1994 Added `mconERROR_STATUS_DRIVE_FAULT'.
* ---v2.0--- 08.02.1995 ---RELEASED---
* S.Sandrock 22.05.1995 Added/changed `mconERROR_STATUS...' macros for new HW.
* bgustafs   06/11/95   Added error code mconERROR_INT_CONFIG
*---------------------------------------------------------------------------
*/


/*
 *	Set Maccon driver error definitions
 */

/* Register Status Errors */
#define mconERROR_STATUS_UNKNOWN		-300
#define mconERROR_STATUS_INVALID_AXIS		-301
#define mconERROR_STATUS_SYNTAX			-302
#define mconERROR_STATUS_PARAM_RANGE		-303
#define mconERROR_STATUS_UNEXP_COMMAND		-304
#define mconERROR_STATUS_FOLLOWING_ERROR	-305
#define mconERROR_STATUS_ENCODER_FAULT		-306
#define mconERROR_STATUS_DRIVE_FAULT		-307
#define mconERROR_STATUS_WATCHDOG		-308
#define mconERROR_STATUS_HW_STOP		-309

/* Queue Errors */
#define mconERROR_QUEUE_FULL                    -311
#define mconERROR_NO_REPLY                      -312
#define mconERROR_WRONG_REPLY                   -313

/* Timing Errors */
#define mconERROR_SYNC_TIMEOUT			-321
#define mconERROR_COMMAND_TIMEOUT		-322
#define mconERROR_START_TIMER			-323
#define mconERROR_STOP_TIMER			-324

/* Others */
#define mconERROR_NO_EXCLUSIVE			-331
#define mconERROR_INT_CONFIG                    -332

#endif /* !MCON_ERROR_H */
