#ifndef MENDRV_H
#define MENDRV_H
/******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id"
*
* mendrv.h  -  This is the interface file for the LCU MENDRV device driver which
*              forms a module of the VLT software. It contains the declarations
*              user available constants, data types and variables as well as the
*              function prototypes.
*
* who        when       what
* ---------  ---------- ----------------------------------------------
* vltcan     2005-04-04 created
*/

#include "mendrvTyps.h"     /* men specific type definitions */
#include "lcudrv.h"         /*  Include common driver literals */
#include "mendrvErrors.h"   /* Include MENDRV error codes and literals */

/*
 * Version number
 */
#define mendrvVERSION   "@(#) men $Revision: 1.5 $"

/*
 * MEN driver provided functions
 */
int mendrvDrv      (int devices, int channels, int aioeout);
int mendrvDevCreate(char *name, void *baseAddr, int irNumber, int irLevel, int par);

/*
 * MEN driver tool functions
 */
int mendrvVersion     ( void );
int mendrvDevShow     ( void );
int mendrvPrintRegs   ( int unit );
int mendrvPrintDevice ( int unit );
int mendrvPrintChannel( int fd );
int mendrvPrintError  ( int errorCode );
int mendrvPrintCmd    ( int cmdCode );

#endif /* !MENDRV_H */
