/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: msgLCC.h,v 4.97.1.1 2005/10/24 13:55:47 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* bgustafs  28/04/00  suppressed const for errmsg in msgReplyWithId, 
*                     SPR20000001
* gfilippi  27/09/95  created from $VLTSCCM/VLTSW/LCC/2.2.4/lcc
* bgustafs  08/03/96  modified for lcc 3.1
*
*/

/*-----------------------------------------------------------------------------
*  ESO VLT              LCU Common Software              SPACEBEL Informatique
*------------------------------------------------------------------------------
*  Version      Date            Author          Comment
*------------------------------------------------------------------------------
*  1.1          18/12/93        lccteam         First version
*  1.2          17/01/94        P.Rochez        Change according to Acceptance
*               18/02/94        P.Rochez        SPR940012 Added prototpye for
*                                                 msgSendAnyMsg()
*  2.1          31/01/95        P.Rochez
*       Added msgSetFilter(), msgCheckProcess() and msgGetProcesses()
*           functions
*       Added message types corresponding to RTAP types (in particular
*           for events and alarms)
*       Added msgBODYMAXLEN and used it in definition of msgMSG data type
*       Created LCC specific include file
*  3.1          15/02/96        P.Creten        Added msgPing() function.
*------------------------------------------------------------------------------
*  SCCS Id:  msgLCC.h  3.1  05 Mar 1996
*----------------------------------------------------------------------------*/

/*
 * <msgLCC.h> - LCU / MESSAGE SYSTEM Interface File
 */

/************************************************************************
 *                      LCU Specific Definitions                        *
 ************************************************************************/

/* 
 * Data types
 */

/* 
 * Functions prototypes 
 */

ccsCOMPL_STAT msgCheckProcess(      /* Check if a process is registered */
    const ccsPROCNAME  procName,    /* Process name                     */
    vltLOGICAL         *result,     /* Returned registration status     */
    ccsPROCNUM         *procNum,    /* Returned procnum (valid only     */
                                    /* when result is TRUE)             */
    ccsERROR           *error       /* Returned error structure         */
    );


ccsCOMPL_STAT msgGetProcesses(      /* Get the list of all registered   */
                                    /* processes                        */
    vltUINT8           *number,     /* Number of processes              */
    ccsPROCNAME        **procName,  /* Array of process names           */
    ccsPROCNUM         **procNum,   /* Array of process numbers         */
    ccsERROR           *error       /* Returned error structure         */
    );


ccsCOMPL_STAT msgReplyWithId(       /* Identical to msgSendReply, but   */
                                    /* source processId is given. Used  */
                                    /* by commands spawned by a Command */
                                    /* Interpreter to send replies with */
                                    /* sourceId = Command Interpreter   */
    const msgPROCESSID *sourceId,   /* ProcessId to be used as source of*/
                                    /* the processId                    */
    const msgPROCESSID *destId,     /* Destination of the reply, as     */
                                    /* found in the origin field of the */
                                    /* command                          */
    msgCMDID           commandId,   /* As found in the command          */
    const msgCMD       command,     /* As found in the command          */
    const char         *buffer,     /* Buffer containing the reply      */
    msgLENGTH          buflen,      /* Buffer length. Max len = 8kB.    */
    vltLOGICAL         lastReply,   /* Flag to indicate if another      */
                                    /* reply follows                    */
    ccsERROR           *errmsg,     /* Error structure returned in msg  */
    ccsERROR           *error       /* Returned error structure         */
    );


ccsCOMPL_STAT msgSendAnyMsg(        /* Send a message without checking  */
                                    /* for CCS compliance               */
    char             *message,      /* pointer to already formatted msg */
    msgLENGTH        msgSize,       /* length in bytes, max=8kB         */
    ccsERROR         *error         /* Returned error structure         */
    );


ccsCOMPL_STAT msgPing  (
    ccsENVNAME   envName,    /* environment name           */
    ccsPROCNAME  procName,   /* process name               */
    vltLOGICAL   reply,      /* reply flag                 */
    ccsERROR    *error       /* Returned error structure   */
    );
