/*
 *            Copyright (c) 2000 - 2005 by electronic system design gmbh
 *
 *  This software is copyrighted by and is the sole property of 
 *  esd gmbh.  All rights, title, ownership, or other interests
 *  in the software remain the property of esd gmbh. This
 *  software may only be used in accordance with the corresponding
 *  license agreement.  Any unauthorized use, duplication, transmission,  
 *  distribution, or disclosure of this software is expressly forbidden.
 *
 *  This Copyright notice may not be removed or modified without prior
 *  written consent of esd gmbh.
 *
 *  esd gmbh, reserves the right to modify this software without notice.
 *
 *  electronic system design gmbh          Tel. +49-511-37298-0
 *  Vahrenwalder Str 207                   Fax. +49-511-37298-68 
 *  30165 Hannover                         http://www.esd-electronics.com
 *  Germany                                sales@esd-electronics.com
 *
 *************************************************************************
 *
 *     Module Name: psysvx.h
 *         Version: 1.00
 *   Original Date:  27-Jan-2005
 *     Host system: N/A
 *   Target system: N/A
 *          Author: Oliver Thimm
 *        Language: ANSI C
 * Compile Options: 
 * Compile defines:
 *
 * Description.
 * =======================================================================
 *  VxWorks specific part of Portable SYStem interface
 */
#ifndef _PSYSVX_H_
#define _PSYSVX_H_

#ifndef _PSYS_H_
# error "Header must be included from PSYS header"
#endif

#ifndef VXWORKS
# error "Wrong system header for target platform"
#endif

#if !defined(VW54) && !defined(VW55)
# error "You must define either VW54 to select VxWorks version 5.4 and" \
          "earlier or define VW55 for VxWorks version 5.5 and later."
#endif
  	 
#include <vxWorks.h>
#include <sysLib.h>
#include <taskLib.h>
#include <semLib.h>
#include <msgQLib.h>
#include <wdLib.h>
#include <tickLib.h>
#include <vxLib.h>
#include <string.h>
#include <stdio.h>
#include <ctype.h>
#include <unistd.h>

#include <sysSymTbl.h>

#include <timers.h>
#include <sockLib.h>
#include <inetLib.h>
#include <sys/socket.h>
#include <netinet/in.h>

  /*
   * Macros to define INT64/UINT64 constants according to ISO C99
   * missing in VxWorks
   */
#ifndef UINT64_C
# define UINT64_C(c) (c ## ULL)
#endif

#ifndef INT64_C
# define INT64_C(c)  (c ## LL)
#endif
  
  /*
   * Macros for printing 64 bit format specifiers according to ISO C99
   * missing in VxWorks
   */
#ifndef __PRI64_PREFIX
# define __PRI64_PREFIX  "ll"
# define PRId64           __PRI64_PREFIX "d"
# define PRIi64           __PRI64_PREFIX "i"
# define PRIu64           __PRI64_PREFIX "u"
# define PRIx64           __PRI64_PREFIX "x" 
# define PRIX64           __PRI64_PREFIX "X"
#endif

#if (_BYTE_ORDER ==_BIG_ENDIAN)
    #define PSYS_BYTE_ORDER PSYS_ENDIAN_BIG
#endif

#if (_BYTE_ORDER ==_LITTLE_ENDIAN)
    #define PSYS_BYTE_ORDER PSYS_ENDIAN_LITTLE
#endif

  /* TODO: Adapt to correct CPU */
#define PSYS_REG_SIZE 32

  /* These come from <vxTypesOld.h> under all 5.X versions.
  typedef   signed   char      INT8;
  typedef   unsigned char      UINT8;
  typedef   signed   short     INT16;
  typedef   unsigned short     UINT16;
  typedef   signed   long      INT32;
  typedef   unsigned long      UINT32;
  */

#ifdef VW54
  /* These are missing in <vxTypesOld.h> in VxWorks 5.4 and older. */
  typedef   signed   long long INT64;
  typedef   unsigned long long UINT64;
#endif

  typedef   int            THREAD;

  typedef   SEM_ID         MUTEX;
  typedef   SEM_ID         COND;

#endif /* of _PSYSVX_H_ */
