#ifndef RMN_H
#define RMN_H
/******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: rmn.h,v 1.12 2002/04/29 08:36:02 vltsccm Exp $" 
*
* rmn.h - Public header of RMN driver
*
* who      when      what
* -------- --------  ----------------------------------------------
* mverola  01/08/97  created
*---------------------------------------------------------------------------
*/

#include "lcudrvPublic.h"
#include "rmnCommands.h"
#include "rmnErrors.h"

#if (CPU==PPC604)
#define rmnVME_A32_BASE_ADDRESS 0x12000000
#else
#if (CPU==MC68040)
#define rmnVME_A32_BASE_ADDRESS 0x09000000
#else
#error Unknown CPU
#endif
#endif

#define rmnBOARD_ID             0x18 /* board identification code (ID)      */

/* VMIVME-5576 memory option mnemonic codes */
#define  rmnMEM_256KB  256
#define  rmnMEM_512KB  512
#define  rmnMEM_1MB   1024

/* VMIVME-5576 VME address space configuration */
#define  rmnVME_ADD_A24  24
#define  rmnVME_ADD_A32  32

/*
 * RMN driver provided functions
 */
extern int rmnDrv(int devices, int channels, int timeout);
extern int rmnDevCreate(char *devName, int addrSpace, void *baseAddr, 
			int memOption, int intrNumber, int intrLevel);
		   
/*
 * RMN tools
 */
extern void rmnVersion(void);
extern int  rmnDevShow(void);
extern int  rmnDevDump(char *name);
extern int  rmnMemDump(char *name);
extern int  rmnDevDescrDump(char *name);
extern int  rmnTestBoard(char *name);
extern int  rmnDevDelete(char *name);
extern int  rmnDevDeleteAll(void);
extern int  rmnDrvRemove(void);
extern int  rmnPrintError(int errCode);
extern int  rmnPrintCommand(int errCode);
#endif /* !RMN_H */
