/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: sampLCC.h,v 4.97.1.1 2005/10/24 13:55:47 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* gfilippi  27/09/95  created from $VLTSCCM/VLTSW/LCC/2.2.4/lcc
*
*/

/*-----------------------------------------------------------------------------
*  ESO VLT              LCU Common Software              SPACEBEL Informatique
*------------------------------------------------------------------------------
*  Version      Date            Author          Comment
*------------------------------------------------------------------------------
*  1.1          18/12/93        lccteam         First version
*  2.1          31/01/95        P.Rochez        Added headerSize field in
*                                               sample reply message
*                                               Changed to ESO header structure
*------------------------------------------------------------------------------
*  SCCS Id:  sampLCC.h  2.1  03 Feb 1995
*----------------------------------------------------------------------------*/

/*
 * <sampLCC.h> - LCU / SAMPLING Interface File
 */

/************************************************************************
 *                      LCU Specific Definitions                        *
 ************************************************************************/


/*
 * Header files
 */

#include "db.h"
#include "ccs.h"
#include "msg.h"


/*
 * Constants
 */

/* None */


/*
 * Data types
 */

typedef enum {                      /* List of sampling start/stop modes*/
    sampNOW = 1,                    /* Start immediately, stop when     */
                                    /* sampStop is called               */
    sampON_EVENT                    /* Start or stop on event           */
} sampMODE;


/*
 * Functions
 */

ccsCOMPL_STAT sampStartSampling(    /* Start sampling                   */
    vltUINT32          number,      /* Number of items to sample        */
    dbSYMADDRESS       *list,       /* List of items to sample          */
    sampMODE           startMode,   /* Start mode                       */
    const dbEVENT      *startEvent, /* Start event                      */
    sampMODE           stopMode,    /* Stop mode                        */
    const dbEVENT      *stopEvent,  /* Stop event                       */
    vltFLOAT           sampleRate,  /* Sample rate (# of samples/second)*/
    vltUINT32          reportRate,  /* Report rate (# of seconds        */
                                    /* between two reports)             */
    msgCMDID           cmdId,
    msgCMD             cmdName,
    ccsERROR           *error       /* Returned error structure         */
    );


ccsCOMPL_STAT sampStopSampling(     /* Stop the current sampling        */
    ccsERROR           *error       /* Returned error structure         */
    );

