/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: tacAnalogTFBlock.h,v 1.49 2005/08/08 21:53:07 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* bbauvir   21/03/01  created
*/

#ifndef TAC_ANALOGTFBLOCK_H
#define TAC_ANALOGTFBLOCK_H

/************************************************************************
 *  tacAnalogTFBlock.h - This file provides the interface to the Analog 
 *                       Transfer function block class. Any specification 
 *                       of this class must include this header file.
 *
 *----------------------------------------------------------------------
 */

/* 
 * System Headers
 */

/* 
 * Local Headers
 */

#include "tacStdBlock.h"
#include "tacDigitalTFBlock.h"

/*
 * Constants
 */

#define tacANALOGTF_1ST_ORDER_EXPECTED_PARAM  4
#define tacANALOGTF_2ND_ORDER_EXPECTED_PARAM  6
#define tacANALOGTF_3RD_ORDER_EXPECTED_PARAM  8
#define tacANALOGTF_4TH_ORDER_EXPECTED_PARAM 10

typedef enum {
  tacANALOGTF_1ST_ORDER_NUMERATOR1 = 0,
  tacANALOGTF_1ST_ORDER_NUMERATOR0,
  tacANALOGTF_1ST_ORDER_DENOMINATOR1,
  tacANALOGTF_1ST_ORDER_DENOMINATOR0,
  tacANALOGTF_1ST_ORDER_PARAMETER_NUMBER,
}tacANALOGTF_1ST_ORDER_PARAMETER_INDEX;

typedef enum {
  tacANALOGTF_2ND_ORDER_NUMERATOR2 = 0,
  tacANALOGTF_2ND_ORDER_NUMERATOR1,
  tacANALOGTF_2ND_ORDER_NUMERATOR0,
  tacANALOGTF_2ND_ORDER_DENOMINATOR2,
  tacANALOGTF_2ND_ORDER_DENOMINATOR1,
  tacANALOGTF_2ND_ORDER_DENOMINATOR0,
  tacANALOGTF_2ND_ORDER_PARAMETER_NUMBER,
}tacANALOGTF_2ND_ORDER_PARAMETER_INDEX;

typedef enum {
  tacANALOGTF_3RD_ORDER_NUMERATOR3 = 0,
  tacANALOGTF_3RD_ORDER_NUMERATOR2,
  tacANALOGTF_3RD_ORDER_NUMERATOR1,
  tacANALOGTF_3RD_ORDER_NUMERATOR0,
  tacANALOGTF_3RD_ORDER_DENOMINATOR3,
  tacANALOGTF_3RD_ORDER_DENOMINATOR2,
  tacANALOGTF_3RD_ORDER_DENOMINATOR1,
  tacANALOGTF_3RD_ORDER_DENOMINATOR0,
  tacANALOGTF_3RD_ORDER_PARAMETER_NUMBER,
}tacANALOGTF_3RD_ORDER_PARAMETER_INDEX;

typedef enum {
  tacANALOGTF_4TH_ORDER_NUMERATOR4 = 0,
  tacANALOGTF_4TH_ORDER_NUMERATOR3,
  tacANALOGTF_4TH_ORDER_NUMERATOR2,
  tacANALOGTF_4TH_ORDER_NUMERATOR1,
  tacANALOGTF_4TH_ORDER_NUMERATOR0,
  tacANALOGTF_4TH_ORDER_DENOMINATOR4,
  tacANALOGTF_4TH_ORDER_DENOMINATOR3,
  tacANALOGTF_4TH_ORDER_DENOMINATOR2,
  tacANALOGTF_4TH_ORDER_DENOMINATOR1,
  tacANALOGTF_4TH_ORDER_DENOMINATOR0,
  tacANALOGTF_4TH_ORDER_PARAMETER_NUMBER,
}tacANALOGTF_4TH_ORDER_PARAMETER_INDEX;

/* 
 * Types
 */

/*
 * Macros
 */

/*
 * Global variables
 */

/*
 * Functions
 */

STATUS tacAnalogTFBlockConstructor(tacSTDBLOCK* pSelf,
                                   tacSTDBLOCK_PARAM* parameter,
                                   tacERROR* error);
STATUS tacAnalogTFBlockSetParameter(tacSTDBLOCK* pSelf,
                                    tacSTDBLOCK_PARAM* parameter,
                                    tacERROR* error);
void tacAnalogTFBlockReset(tacSTDBLOCK* pSelf);
void tacAnalogTFBlockDestructor(tacSTDBLOCK* pSelf);

void tacAnalogTFBlockShow(tacSTDBLOCK* pSelf);

#endif /*!TAC_ANALOGTFBLOCK_H*/






