/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: tacDefines.h,v 1.55 2005/10/03 17:38:05 vltsccm Exp $"
*
* who       when        what
* --------  ----------  ----------------------------------------------
* pduhoux   2000-02-24  created
* bbauvir   2001-07-23  automatic creation for module 'tac'
*/

#ifndef TAC_DEFINES_H
#define TAC_DEFINES_H

/************************************************************************
 *  tacDefines.h - This file provides the definition of all constants 
 *                 related to the tac module.
 *
 *----------------------------------------------------------------------
 */

/* 
 * System Headers
 */

/* 
 * Local Headers
 */

#include "lsfDefines.h"
#include "slamac.h"    /* VLTSW20010698 */

/*
 * LSF Constants
 */

#define tacVERSION      "$Revision: 1.55 $"
#define tacVERSION_DATE "APR2004"

#define tacMODULE_ID    "tac"
#define tacMODULE_NAME   tacMODULE_ID
#define tacMODULE_TITLE "Tools for Advanced Control"
#define tacLOG_ID 	 101		

/*
 * Constants
 */

#undef tacDEBUG    /* Debug information */
#undef tacDEBUG_LOG_TIME_STAMP

#define tacSYNCHRO_NO_SYNC_CONTEXT   "NO_SYNC"
#define tacSYNCHRO_AUX_CLK_CONTEXT   "AUX_CLK"
#define tacSYNCHRO_SEMAPHORE_CONTEXT "TASK"
#define tacSYNCHRO_INT_CONTEXT       "INT"

#define tacIO_BASE_ADDR 0xfbff0000

#define tacMAX_NAME_SIZE    48
#define tacMAX_DATA_NUMBER  10

#if 0 /* VLTSW20020037 */
#define tacMAX_PARAM_NUMBER 5
#else
#define tacMAX_PARAM_NUMBER 10
#endif

#define tacMAX_PARAM_SIZE tacMAX_PARAM_NUMBER*sizeof(double)

#define tacMAX_BLOCK_NUMBER     256
#define tacMAX_LINK_NUMBER      256
#define tacMAX_BLOCK_TYPE_NUMBER 80

#if 0 /* VLTSW20010698 */
#define tacPI 3.14159265358979
#else
#define tacPI DPI    /* Keep tacPI constant for backward compatibility */
#endif

/* VLTSW20030076 - Support PCI interrupts */
#define tacINT_VME_BUS 0
#define tacINT_PCI_BUS 1
#define tacINT_MASK 0xff

#define tacTIME_NOW_SECONDS  0x0
#define tacTIME_NOW_MICROSEC 0x0
#define tacTIME_NOW_STRING   "now"

#define tacTIME_NEVER_SECONDS  0xffffffff 
#define tacTIME_NEVER_MICROSEC 0xffffffff
#define tacTIME_NEVER_STRING   "never"

/* 
 * Types
 */

/*
 * Macros
 */

#define tacRTC_ERR(errNumber,string)        \
  {                                         \
    error->errNum = errNumber;              \
    strcpy(error->location, __FILE_LINE__); \
    sprintf(error->param, "%.40s",string);  \
  }                                         \

#define tacRTC_ERR_ADD(tacError) \
  {                                                                                 \
    errAdd(error,tacMODULE_ID,tacError.errNum,tacError.location,"",tacError.param); \
  }                                                                                 \

/* VLTSW20030076 - Support PCI interrupts */
#define tacRtcDefineInterrupt(synchro, busType, intLevel, intVector)      \
  {                                                                       \
    (synchro).type = tacSYNCHRO_INTERRUPT;                                \
    (synchro).interrupt.level = (busType * (tacINT_MASK + 1)) + intLevel; \
    (synchro).interrupt.vector = intVector;                               \
  }

#define tacRtcIsPCIInterrupt(synchro) (synchro.interrupt.level > tacINT_MASK)
#define tacRtcIsVMEInterrupt(synchro) (synchro.interrupt.level <= tacINT_MASK)
#define tacRtcGetInterruptLevel(synchro) (synchro.interrupt.level & tacINT_MASK)

#define tacRtcDefineSemaphore(synchro, semaphore, taskLevel) \
  {                                                          \
    (synchro).type = tacSYNCHRO_SEMAPHORE;                   \
    (synchro).task.semId = semaphore;                        \
    (synchro).task.priority = taskLevel;                     \
  }

/*
 * Global variables
 */

/*
 * Functions
 */

#endif /*!TAC_DEFINES_H*/




