/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: tacDigitalTFBlock.h,v 1.49 2005/08/08 21:53:07 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* bbauvir   21/03/01  created
*/

#ifndef TAC_DIGITALTFBLOCK_H
#define TAC_DIGITALTFBLOCK_H

/************************************************************************
 *  tacDigitalTFBlock.h - This file provides the interface to the Digital 
 *                       Transfer function block class. Any specification 
 *                       of this class must include this header file.
 *
 *----------------------------------------------------------------------
 */

/* 
 * System Headers
 */

/* 
 * Local Headers
 */

#include "tacStdBlock.h"

/*
 * Constants
 */

#define tacDIGITALTF_1ST_ORDER_EXPECTED_PARAM 3
#define tacDIGITALTF_2ND_ORDER_EXPECTED_PARAM 5
#define tacDIGITALTF_3RD_ORDER_EXPECTED_PARAM 7
#define tacDIGITALTF_4TH_ORDER_EXPECTED_PARAM 9

typedef enum {
  tacDIGITALTF_1ST_ORDER_GAIN = 0,
  tacDIGITALTF_1ST_ORDER_NUMERATOR1,
  tacDIGITALTF_1ST_ORDER_DENOMINATOR1,
  tacDIGITALTF_1ST_ORDER_PARAMETER_NUMBER,
}tacDIGITALTF_1ST_ORDER_PARAMETER_INDEX;

typedef enum {
  tacDIGITALTF_2ND_ORDER_GAIN = 0,
  tacDIGITALTF_2ND_ORDER_NUMERATOR1,
  tacDIGITALTF_2ND_ORDER_NUMERATOR2,
  tacDIGITALTF_2ND_ORDER_DENOMINATOR1,
  tacDIGITALTF_2ND_ORDER_DENOMINATOR2,
  tacDIGITALTF_2ND_ORDER_PARAMETER_NUMBER,
}tacDIGITALTF_2ND_ORDER_PARAMETER_INDEX;

typedef enum {
  tacDIGITALTF_3RD_ORDER_GAIN = 0,
  tacDIGITALTF_3RD_ORDER_NUMERATOR1,
  tacDIGITALTF_3RD_ORDER_NUMERATOR2,
  tacDIGITALTF_3RD_ORDER_NUMERATOR3,
  tacDIGITALTF_3RD_ORDER_DENOMINATOR1,
  tacDIGITALTF_3RD_ORDER_DENOMINATOR2,
  tacDIGITALTF_3RD_ORDER_DENOMINATOR3,
  tacDIGITALTF_3RD_ORDER_PARAMETER_NUMBER,
}tacDIGITALTF_3RD_ORDER_PARAMETER_INDEX;

typedef enum {
  tacDIGITALTF_4TH_ORDER_GAIN = 0,
  tacDIGITALTF_4TH_ORDER_NUMERATOR1,
  tacDIGITALTF_4TH_ORDER_NUMERATOR2,
  tacDIGITALTF_4TH_ORDER_NUMERATOR3,
  tacDIGITALTF_4TH_ORDER_NUMERATOR4,
  tacDIGITALTF_4TH_ORDER_DENOMINATOR1,
  tacDIGITALTF_4TH_ORDER_DENOMINATOR2,
  tacDIGITALTF_4TH_ORDER_DENOMINATOR3,
  tacDIGITALTF_4TH_ORDER_DENOMINATOR4,
  tacDIGITALTF_4TH_ORDER_PARAMETER_NUMBER,
}tacDIGITALTF_4TH_ORDER_PARAMETER_INDEX;

/* 
 * Types
 */

/*
 * Macros
 */

/*
 * Global variables
 */

/*
 * Functions
 */

STATUS tacDigitalTFBlockConstructor(tacSTDBLOCK* pSelf,
                                    tacSTDBLOCK_PARAM* parameter,
                                    tacERROR* error);
STATUS tacDigitalTFBlockSetParameter(tacSTDBLOCK* pSelf,
                                     tacSTDBLOCK_PARAM* parameter,
                                     tacERROR* error);
void tacDigitalTFBlock1stOrderAlgorithm(tacSTDBLOCK* pSelf);
void tacDigitalTFBlock2ndOrderAlgorithm(tacSTDBLOCK* pSelf);
void tacDigitalTFBlock3rdOrderAlgorithm(tacSTDBLOCK* pSelf);
void tacDigitalTFBlock4thOrderAlgorithm(tacSTDBLOCK* pSelf);
void tacDigitalTFBlockReset(tacSTDBLOCK* pSelf);
void tacDigitalTFBlockDestructor(tacSTDBLOCK* pSelf);

void tacDigitalTFBlockShow(tacSTDBLOCK* pSelf);

#endif /*!TAC_DIGITALTFBLOCK_H*/






