/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: tacRMNBlock.h,v 1.49 2005/08/08 21:53:08 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* bbauvir   21/03/01  created
*/

#ifndef TAC_RMNBLOCK_H
#define TAC_RMNBLOCK_H

/************************************************************************
 *  tacRMNBlock.h - This file provides the interface to the Reflective 
 *                  Memory board abstract class. Any specification of 
 *                  this class must include this header file.
 *
 *----------------------------------------------------------------------
 */

/* 
 * System Headers
 */

/* 
 * Local Headers
 */

#include "rmacPublic.h"
#include "tacStdBlock.h"

/*
 * Constants
 */

/* 
 * Types
 */

/*
 * Macros
 */

#define tacRMN_VMETRO_MARK(m) \
    if (tacRmnVmetroMarkerEnable) tacRmnVmetroMark(m)

/*
 * Global variables
 */

extern int tacRmnVmetroMarkerEnable;

/*
 * Functions
 */

STATUS tacRMNBlockConstructor(tacSTDBLOCK* pSelf, tacSTDBLOCK_PARAM* parameter, tacERROR* error);
void tacRMNBlockDestructor(tacSTDBLOCK* pSelf);

void tacRmnEnableVmetroMarker();
void tacRmnDisableVmetroMarker();
void tacRmnVmetroMark(int m);

/*
 * Note: Routines called from within the algorithm must be declared with
 *       static __inline__ <prototype>
 */

#endif /*!TAC_RMNBLOCK_H*/






