/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: tacServer.h,v 1.55 2005/10/03 17:38:05 vltsccm Exp $"
*
* who       when     what
* --------  -------  ----------------------------------------------
* bbauvir  13/06/02  Add SIMULAT/STOPSIM support
* pduhoux  04/05/00  created
*/

#ifndef TAC_SERVER_H
#define TAC_SERVER_H

/* 
 * System Headers
 */

/* 
 * Local Headers
 */

#include "ccs.h"
#include "tacTypes.h"

/*
 * Constants
 */

typedef enum {
  tacDATA_MONITOR_CALLBACK = 0,
  tacDATA_PROBE_CALLBACK,
}tacDATA_CALLBACK_TYPE;

/* 
 * Types
 */

/*
 * Global variables
 */

/*
 * Functions
 */

ccsCOMPL_STAT tacServerConfigRTC(ccsERROR *error);
ccsCOMPL_STAT tacServerConfig(char *fileName, ccsERROR *error);
ccsCOMPL_STAT tacServerReport(char *fileName, ccsERROR *error);
ccsCOMPL_STAT tacServerResetAlgorithm(ccsERROR *error);
ccsCOMPL_STAT tacServerStopAlgorithm(ccsERROR *error);
ccsCOMPL_STAT tacServerRecord(char *fileName, char *blockName, vltUINT32 sample, ccsERROR *error);
ccsCOMPL_STAT tacServerStopRecord(ccsERROR *error);
ccsCOMPL_STAT tacServerAddBlock(char *type, char *name, tacPARAM *parameter, ccsERROR *error);
ccsCOMPL_STAT tacServerDeleteBlock(char *name, ccsERROR *error);
ccsCOMPL_STAT tacServerModifyBlock(char *name, tacPARAM *parameter, vltINT32 reply, ccsERROR *error);
ccsCOMPL_STAT tacServerReportBlock(char *name, tacPARAM *parameter, ccsERROR *error);

ccsCOMPL_STAT tacServerAddLink(char *name, 
                               char *srcName, vltUINT32 srcPort, 
                               char *dstName, vltUINT32 dstPort, 
			       ccsERROR *error);
ccsCOMPL_STAT tacServerDeleteLink(char *name, ccsERROR *error);
ccsCOMPL_STAT tacServerClearAlgorithm(ccsERROR *error);

ccsCOMPL_STAT tacServerGetCurrentTime(ccsTIMEVAL *time, ccsERROR *error);
ccsCOMPL_STAT tacServerReadMonitorValue(char* name, vltDOUBLE* data, vltINT32 dataId, ccsERROR* error);
vltINT32 tacServerGetSubState(void);

ccsCOMPL_STAT tacServerInstallDataCallback(vltUINT32 callbackType, 
					   char* name,
                                           void (* theCallback)(), 
					   void* usrParam,
                                           ccsERROR *error);
ccsCOMPL_STAT tacServerRemoveDataCallback(vltUINT32 callbackType, char* name, ccsERROR *error);

ccsCOMPL_STAT tacServerSimulate(ccsERROR *error);
ccsCOMPL_STAT tacServerStopSim(ccsERROR *error);

ccsCOMPL_STAT tacStopRecord(ccsERROR* error);
ccsCOMPL_STAT tacRecordToFile(char* fileName, char *blockName, unsigned long dataSample, tacVOIDFCTPTR dumpFctPtr, ccsERROR* error);

#endif /*!TAC_SERVER_H*/
