#ifndef tcsLogFits_H
#define tcsLogFits_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: tcsLogFits.h,v 1.153 2005/08/02 12:52:36 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* gchiozzi  03/04/98  created
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */

#include "log.h"

ccsCOMPL_STAT tcsLogFitsSetModule(const ccsMODULEID module);
const char   *tcsLogFitsGetModule();

ccsCOMPL_STAT tcsLogFitsSetDict(const logDICTIONARY mask);
const char   *tcsLogFitsGetDict();

ccsCOMPL_STAT tcsLogFitsSetLevel(vltINT32 level);
vltINT32      tcsLogFitsGetLevel();

ccsCOMPL_STAT tcsLogFitsSetMask(const logMASK mask);
const char   *tcsLogFitsGetMask();

ccsCOMPL_STAT tcsLogFitsComment (const char *who,
				 const char *text,
				 vltINT32    level);
ccsCOMPL_STAT tcsLogFitsEvent(logFITS_TYPE  fitsType,
			      const char   *text,
			      vltINT32      level);
ccsCOMPL_STAT tcsLogFitsAction(const logCATEGORY fitsCat,
			       const logFITS_KEY fitsSys,
			       const logACTION   fitsAction,
			       vltINT32          level);

ccsCOMPL_STAT tcsLogFitsParLogical(const logCATEGORY fitsCat,
				   const logFITS_KEY fitsSys,
				   const logFITS_KEY fitsParam,
				   const vltLOGICAL  value,
				   vltINT32          level);
ccsCOMPL_STAT tcsLogFitsParInt32(const logCATEGORY fitsCat,   
				 const logFITS_KEY fitsSys,   
				 const logFITS_KEY fitsParam, 
				 const vltINT32    value,     
				 vltINT32          level);
ccsCOMPL_STAT tcsLogFitsParDouble(const logCATEGORY fitsCat,   
				  const logFITS_KEY fitsSys,   
				  const logFITS_KEY fitsParam, 
				  const vltDOUBLE   value,     
				  vltINT32          level);
ccsCOMPL_STAT tcsLogFitsParChar(const logCATEGORY fitsCat,   
				const logFITS_KEY fitsSys,   
				const logFITS_KEY fitsParam, 
				const char       *value,     
				vltINT32          level);

ccsCOMPL_STAT tcsLogFitsParUChar(const logCATEGORY    fitsCat,   
				 const logFITS_KEY    fitsSys,   
				 const logFITS_KEY    fitsParam, 
				 const unsigned char *value,     
				 vltINT32             level);

#if 0
ccsCOMPL_STAT tcsLogFitsParArray(const logCATEGORY fitsCat,
				 const logFITS_KEY fitsSys,
				 const logFITS_KEY fitsParam,
				 vltINT16          numbElem,
				 vltINT16          elemSize,
				 const void       *array,
				 vltINT32          level);
#endif

#endif /*!tcsLogFits_H*/
