#ifndef TIM_ERROR_H
#define TIM_ERROR_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: timErrors.h,v 3.12 2005/07/26 08:51:42 vltsccm Exp $" 
*
* timError.h  -  Contains literals for all TIM driver error codes, 
*                returned from ioctl calls.
*
* who       when      what
* --------  --------  ----------------------------------------------
* ssandroc  02/08/94  Modified for version 1.3
*/

#define timOK			 	 0
#define timERROR_NOT_CONFIGURED		-200
#define timERROR_EXTERNAL_GATED		-210
#define timERROR_NOT_INTERRUPTED	-220
#define timERROR_NOT_PERIODIC		-230
#define timERROR_NO_TRS			-240
#define timERROR_NOT_FREE		-250
#define timERROR_TICK_MISSED		-260
#define timERROR_NOT_LOCAL		-270
#define timERROR_INVALID_TIME		-275
#define timERROR_INVALID_TIMEOUT	-280
#define timERROR_INVALID_MODE		-290
#define timERROR_INVALID_TIMER		-291
#define timERROR_INVALID_COUNT		-292
#define timERROR_INVALID_RATE		-293
#define timERROR_INVALID_IR_LEVEL	-294
#define timERROR_INVALID_IR_NUMBER	-295
#define timERROR_NO_EXCLUSIVE		-299

/* New for version 1.3: */
#define timERROR_SYSCLK_NOT_INSTALLED		-297
#define timERROR_SYSCLK_ALREADY_INSTALLED	-298

/* Checking of interrupt level */
#define timERROR_WRONG_INTR_LEVEL               -205

#endif /* !TIM_ERROR_H */
