/******************************************************************************
*  E.S.O. - VLT project
* 
*  "@(#) $Id: uvisenExpm.h,v 1.22 2003/12/03 18:29:31 vltsccm Exp $"
* 
*  who        when      what
*  ---------- --------  ----------------------------------------------
*  rschmutz   06/04/98  Created by eccsgen  Revision: 1.20
*
*
*    !!!!!!!!!  CAUTION: THIS FILE IS UPDATED BY ECCSGEN  !!!!!!!!!
*/

/*************************************************************************
*   NAME
*	uvisenExpm - class
*
*   SYNOPSIS
*	#include "uvisenExpm.h"
*
*	ccsCOMPL_STAT uvisenExpmNewObj(
*	    IN    dbSYMADDRESS	point,
*	    IN    egenOBJ*	owner,
*	    OUT   egenOBJ*	obj,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT uvisenExpmDeleteObj(
*	    INOUT egenOBJ*	obj,
*	    OUT   ccsERROR*	error)
*
*	egenOBJ* uvisenExpmGetOwner(
*	    IN const egenOBJ* obj)
*
*	egenOBJ* uvisenExpmLogData(
*	    IN const egenOBJ*	obj,
*	    IN const char*	format,
*	    IN 			...)
*
*	ccsCOMPL_STAT uvisenExpmSetup(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    const char*	function[],	** max. vltBYTES32[999]
*	    IN    vltINT16	functionNum,
*	    IN    vltLOGICAL	noMove,
*	    IN    vltLOGICAL	check,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT uvisenExpmInitObj(
*	    INOUT egenOBJ*	obj,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT uvisenExpmExitObj(
*	    INOUT egenOBJ*	obj,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT uvisenExpmUsrInit(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT uvisenExpmUsrStandby2Online(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT uvisenExpmUsrOnline2Standby(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT uvisenExpmUsrStandby2Loaded(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT uvisenExpmUsrSetMode(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    vltINT32	cmd,
*	    IN    vltLOGICAL	available,
*	    IN    vltLOGICAL	enabled,
*	    IN    vltLOGICAL	simulation,
*	    IN    vltLOGICAL	handset,
*	    IN    vltLOGICAL	locked,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT uvisenExpmUsrStatusCode(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    const char*	text,
*	    IN    vltINT32	flags,
*	    OUT   vltINT32*	code,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT uvisenExpmUsrStatusValue(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    vltINT32	code,
*	    OUT   lcctooVALUE*	value,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT uvisenExpmUsrStatusLast(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    OUT   vltINT16*	last,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT uvisenExpmHwInit(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    lccDEV_MODE	state,
*	    IN    vltLOGICAL	simulation,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT uvisenExpmHwExit(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    lccDEV_MODE	state,
*	    IN    vltLOGICAL	simulation,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT uvisenExpmHwSetup(
*	    INOUT egenOBJ*	obj,
*	    IN    const char*	devName,
*	    IN    const char*	function[],	** max. vltBYTES32[999]
*	    IN    vltINT16	functionNum,
*	    IN    vltLOGICAL	noMove,
*	    IN    vltLOGICAL	check,
*	    IN    vltLOGICAL	simulation,
*	    OUT   ccsERROR*	error)
*
*	void uvisenExpmHwMonitor(
*	    INOUT lcctooTASK*	task)
*
*	ccsCOMPL_STAT uvisenExpmRead<scalarAttr>(
*	    INOUT egenOBJ*	obj,
*	    OUT   void*		buf,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT uvisenExpmWrite<scalarAttr>(
*	    INOUT egenOBJ*	obj,
*	    IN    void*		buf,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT uvisenExpmRead<vectorAttr>(
*	    INOUT egenOBJ*	obj,
*	    OUT   void*		buf,
*	    IN    vltINT32	first,
*	    IN    vltINT32	last,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT uvisenExpmWrite<vectorAttr>(
*	    INOUT egenOBJ*	obj,
*	    IN    void*		buf,
*	    IN    vltINT32	first,
*	    IN    vltINT32	last,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT uvisenExpmRead<tableAttr>(
*	    INOUT egenOBJ*	obj,
*	    OUT   void*		buf,
*	    IN    vltINT32	firstRec,
*	    IN    vltINT32	lastRec,
*	    IN    vltINT32	firstFld,
*	    IN    vltINT32	lastFld,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT uvisenExpmWrite<tableAttr>(
*	    INOUT egenOBJ*	obj,
*	    IN    void*		buf,
*	    IN    vltINT32	firstRec,
*	    IN    vltINT32	lastRec,
*	    IN    vltINT32	firstFld,
*	    IN    vltINT32	lastFld,
*	    OUT   ccsERROR*	error)
*
*	ccsCOMPL_STAT uvisenExpmErr<error>(...)
*
*   PARENT CLASS
*	public ic0devSOFT
*
*   DESCRIPTION
*       The class uvisenEXPM implements the software device to access
*       the UVES exposure meters.
*
*       The count of the exposure meter is continously monitored making
*       exposures with the integration time specified by the corresponding
*       configuration value.
*       The count values are stored in a vector (ctValues, see below)
*       from where they can be retrieved from the workstation.
*       The accumulated value is stored in status(1). If no special
*       exposure is running, then the last count is stored in status(0).
*
*       It is possible to make special exposures with the SETUP command.
*       The count of these exposures are stored in status(0).
*
*       All counts are adjusted with the dark and sky offset values
*       according to the exposure integration time.
*  
*       The following FITS keywords are used:
*	 INS.DETi.UIT          integration time
*	 INS.DETi.CTLAST       last exposure meter count
*	 INS.DETi.CTTOT        accumulated exposure meter count
*	 INS.DETi.OFFDRK       dark offset per sec.
*	 INS.DETi.OFFSKY       sky offset per sec.
*
*	uvisenExpmNewObj(point,owner,obj,error)
*	    Initialises an instance of the class type uvisenEXPM.
*
*	    point	<IN>	OLDB point where the owned attributes are
*				located.
*	    owner	<IN>	Pointer to the owner of the new instance.
*	    obj		<OUT>	Handle for the new instance (the handle
*				must be allocated by the caller).
*
*	uvisenExpmDeleteObj(obj,error)
*	    The function lcctooDeleteObj deletes an
*	    instance of the class type uvisenEXPM
*
*	uvisenExpmSetup(obj,devName,function,functionNum,noMove,check,error)
*	   Setups the function. The keys are the last component
*	   of the FITS keywords related with the function.
*	   E.g.:
*	     If the FITS keyword is: INS.OPTI-3.ID #11
*	     then the key is: ID, the value '#11'.
*
*	   If the noMove flag is used, then the setup parameters
*	   are stored, but not executed until a setup command
*	   without the noMove flag is received.
*
*	   If the check flag is used, then only the parameters
*	   are checked. No setup is performed.
*
*	   Aliases are not accepted (The ICS Frontend at the
*	   workstation recognizes the aliases).
*
*
*	uvisenExpmErr<error>(...)
*	    The macros uvisenExpmErr*() log an error with lcctooLOG_0 and
*	    call errAdd with the corresponding error parameters.
*
*	uvisenExpmRead<attr>(...)
*	uvisenExpmWrite<attr>(...)
*	    The above macros read from/write to the data attributes
*	    of the class.
*	    The attributes are described in uvisenExpmDb(5).
*
*   PROTECTED METHODS
*   PRIVATE METHODS
*	uvisenExpmInitObj(obj,error)
*
*	uvisenExpmExitObj(obj,error)
*
*	uvisenExpmUsrInit(obj,devName,error)
*	   This function should be overloaded to perform the
*	   device initialisation (without hardware movements).
*
*	uvisenExpmUsrStandby2Online(obj,devName,error)
*	   This function should be overloaded to perform the
*	   actions necessary to change from the STANDBY to the
*	   ONLINE state. The overloaded function should first
*	   call lccdevCmdUsrStandby2Online() or check if the
*	   device is available and enabled before going ONLINE.
*
*	uvisenExpmUsrOnline2Standby(obj,devName,error)
*	   This function should be overloaded to perform the
*	   actions necessary to change from the ONLINE to the
*	   STANDBY state.
*
*	uvisenExpmUsrStandby2Loaded(obj,devName,error)
*	   This function should be overloaded to perform the
*	   actions necessary to change from the STANDBY to the
*	   LOADED state.
*
*	uvisenExpmUsrSetMode(obj,devName,cmd,available,enabled,simulation,handset,locked,error)
*	   This function should be overloaded to perform the
*	   actions necessary to change the mode of the hardware
*	   device.
*
*	   cmd	<IN>	code indicating the command that
*			   calls UsrSetMode() (lccdevCMD_*).
*	   logical	<IN>	state of the available, enabled,
*			   simulation, handset and locked
*			   modes.
*
*	uvisenExpmUsrStatusCode(obj,devName,text,flags,code,error)
*	   This function receives the name of a status value
*	   and returns the corresponding code. This function
*	   should be overloaded if the new class declares new
*	   status values. The overloaded function should check
*	   first if the name corresponds to one of its own
*	   status values. If not, then it should call the
*	   function UsrStatusCode() of its parent class to be
*	   able to retrieve the codes of the parent status
*	   values.
*
*	   text	<IN>	Name of the status value.
*	   flags	<IN>	expected status type (lcctooSTATUS_*).
*	   code	<OUT>	Code of the status value (lccdevGET_*).
*
*	   lccdevGET_DEVICE        "Device"
*	   lccdevGET_STATE         "State"
*	   lccdevGET_TRANSTATE     "TranState"
*	   lccdevGET_ERROR         "Error"
*	   lccdevGET_INITIALISED   "Initialised"
*	   lccdevGET_SIMULATION    "Simulation"
*
*	uvisenExpmUsrStatusValue(obj,devName,code,value,error)
*	   This function receives the code of a status variable
*	   and returns its related value. This function should
*	   be overloaded if the new class declares new status
*	   values. The overloaded function should check first
*	   if the code corresponds to one of its own status
*	   values. If not, then it should call the function
*	   UsrStatusValue() of its parent class to be able to
*	   retrieve the status values of the parent.
*
*	   code	<OUT>	Code of the status value (lccdevGET_*).
*	   value	<OUT>	Handle of the value object
*			   (allocated by the caller).
*
*	uvisenExpmUsrStatusLast(obj,devName,last,error)
*	   This function returns the highest status code that
*	   the class knows. This function should be overloaded
*	   if the new class declares new status values, as new
*	   status codes have to be assigned to the new values.
*
*	   This function is used by the Status command when it
*	   has to return all status values. In this case it
*	   performs a loop from code 1 to the value returned
*	   by this function.
*
*	uvisenExpmHwInit(obj,devName,state,simulation,error)
*	   HwInit is called when the software device enters
*	   the STANDBY or ONLINE state.
*
*	uvisenExpmHwExit(obj,devName,state,simulation,error)
*	   HwInit is called when the software device leaves
*	   the STANDBY or ONLINE state.
*
*	uvisenExpmHwSetup(obj,devName,function,functionNum,noMove,check,simulation,error)
*	   HwSetup is called when the SETUP command is
*	   issued in the ONLINE state.
*
*	uvisenExpmHwMonitor(task)
*	   HwMonitor reads continuesly the exposure meter
*	   and updates the status.
*
*
*   DEFINES
*
*   FILES
*
*   ENVIRONMENT
*
*   RETURN VALUES
*	If the function prototype allows, methods return ccsCOMPL_STAT.
*
*	The names of the defined errors begin as follows:
*	uvisenERR_<error>
*
*   CAUTIONS
*
*   EXAMPLES
*
*   SEE ALSO
*
*   BUGS
*
* 
*-------------------------------------------------------------------------
*/

#ifndef UVISEN_EXPM_H
#define UVISEN_EXPM_H

#include "egen.h"
#include "uvisenErrors.h"
#include "uvisenDefines.h"
#include "ic0devSoft.h"
#include "lcctooTask.h"

/*
 * class type identifier
 */
#define uvisenEXPM_ID	711

/*
 * attribute table
 */
#define uvisenEXPM_ATTR_STATE	0
#define uvisenEXPM_ATTR_SUBSTATE	1
#define uvisenEXPM_ATTR_ERROR	2
#define uvisenEXPM_ATTR_INITIALISED	3
#define uvisenEXPM_ATTR_SIMULATION	4
#define uvisenEXPM_ATTR_DEVICE	5
#define uvisenEXPM_ATTR_AVAILABLE	6
#define uvisenEXPM_ATTR_ENABLED	7
#define uvisenEXPM_ATTR_LOCKED	8
#define uvisenEXPM_ATTR_HANDSET	9
#define uvisenEXPM_ATTR_FIXED	10
#define uvisenEXPM_ATTR_FIX_POS_SET	11
#define uvisenEXPM_ATTR_FIXED_POSITION	12
#define uvisenEXPM_ATTR_FIXED_SIMULATION	13
#define uvisenEXPM_ATTR_FIXED_LOCKED	14
#define uvisenEXPM_ATTR_PREFIX	15
#define uvisenEXPM_ATTR_PARAMETERS_SIZE	16
#define uvisenEXPM_ATTR_PARAMETERS	17
#define uvisenEXPM_ATTR_STATUS	18
#define uvisenEXPM_ATTR_STATUS_INDEX	19
#define uvisenEXPM_ATTR_VALUES_SIZE	20
#define uvisenEXPM_ATTR_VALUES	21
#define uvisenEXPM_ATTR_INIT_RESTRICTION	22
#define uvisenEXPM_ATTR_MOVE_RESTRICTION	23
#define uvisenEXPM_ATTR_STOP_TIMEOUT	24
#define uvisenEXPM_ATTR_SET_VAL_FCT	25
#define uvisenEXPM_ATTR_HELP_TEXT	26
#define uvisenEXPM_ATTR_PARAM_STEP	27
#define uvisenEXPM_ATTR_ACTION_COMMAND	28
#define uvisenEXPM_ATTR_ACTION_STOP_REQ	29
#define uvisenEXPM_ATTR_ACTION_NO_MOVE	30
#define uvisenEXPM_ATTR_ACTION_CHECK	31
#define uvisenEXPM_ATTR_RESET_SETUP_CMD	32
#define uvisenEXPM_ATTR_COM_DEVICE	33
#define uvisenEXPM_ATTR_GPIB_ADDR	34
#define uvisenEXPM_ATTR_CTLAST	35
#define uvisenEXPM_ATTR_CTTOT	36
#define uvisenEXPM_ATTR_UIT	37
#define uvisenEXPM_ATTR_REP	38
#define uvisenEXPM_ATTR_OFFDRK	39
#define uvisenEXPM_ATTR_OFFSKY	40
#define uvisenEXPM_ATTR_SETUP_ACTIVE	41
#define uvisenEXPM_ATTR_FITS_LOG_UIT	42
#define uvisenEXPM_ATTR_CT_MIN_LOG	43
#define uvisenEXPM_ATTR_CT_NUMBER	44
#define uvisenEXPM_ATTR_CT_VALUES	45
#define uvisenEXPM_ATTR_HW_ACCESS	46
#define uvisenEXPM_ATTR_HW_FD	47
#define uvisenEXPM_ATTR_CURR_TIMEOUT	48
#define uvisenEXPM_ATTR_CURR_POLL_RATE	49

#define uvisenEXPM_AUTOMATA	0

/*
 * function table
 */
#define uvisenEXPM_FCT_DELETE_OBJ	0
#define uvisenEXPM_FCT_STANDBY	1
#define uvisenEXPM_FCT_ONLINE	2
#define uvisenEXPM_FCT_OFF	3
#define uvisenEXPM_FCT_EXIT	4
#define uvisenEXPM_FCT_STATE	5
#define uvisenEXPM_FCT_SIMULAT	6
#define uvisenEXPM_FCT_STOP_SIM	7
#define uvisenEXPM_FCT_STATUS	8
#define uvisenEXPM_FCT_INIT	9
#define uvisenEXPM_FCT_STOP	10
#define uvisenEXPM_FCT_TEST	11
#define uvisenEXPM_FCT_SELFTST	12
#define uvisenEXPM_FCT_AUTO_TBL	13
#define uvisenEXPM_FCT_AUTO_RST	14
#define uvisenEXPM_FCT_INIT_OBJ	15
#define uvisenEXPM_FCT_EXIT_OBJ	16
#define uvisenEXPM_FCT_LOADED2STBY	17
#define uvisenEXPM_FCT_ONLINE2STBY	18
#define uvisenEXPM_FCT_EXIT1	19
#define uvisenEXPM_FCT_CHECK_DEVICE_NAME	20
#define uvisenEXPM_FCT_BREAK	21
#define uvisenEXPM_FCT_USR_INIT	22
#define uvisenEXPM_FCT_USR_LOADED2STANDBY	23
#define uvisenEXPM_FCT_USR_STANDBY2ONLINE	24
#define uvisenEXPM_FCT_USR_ONLINE2STANDBY	25
#define uvisenEXPM_FCT_USR_STANDBY2LOADED	26
#define uvisenEXPM_FCT_USR_STOP	27
#define uvisenEXPM_FCT_USR_SIMULAT	28
#define uvisenEXPM_FCT_USR_STOP_SIM	29
#define uvisenEXPM_FCT_USR_STATUS_CODE	30
#define uvisenEXPM_FCT_USR_STATUS_LAST	31
#define uvisenEXPM_FCT_USR_STATUS_VALUE	32
#define uvisenEXPM_FCT_USR_TEST	33
#define uvisenEXPM_FCT_USR_SELF_TEST	34
#define uvisenEXPM_FCT_USR_ERROR	35
#define uvisenEXPM_FCT_AVAIL	36
#define uvisenEXPM_FCT_UNAVAIL	37
#define uvisenEXPM_FCT_DISABLE	38
#define uvisenEXPM_FCT_ENABLE	39
#define uvisenEXPM_FCT_LOCK	40
#define uvisenEXPM_FCT_UNLOCK	41
#define uvisenEXPM_FCT_HANDSET	42
#define uvisenEXPM_FCT_HSET_OFF	43
#define uvisenEXPM_FCT_FIX_POS	44
#define uvisenEXPM_FCT_MOVE	45
#define uvisenEXPM_FCT_MOVE_REL	46
#define uvisenEXPM_FCT_SET	47
#define uvisenEXPM_FCT_CHECK	48
#define uvisenEXPM_FCT_WAIT	49
#define uvisenEXPM_FCT_USR_SET_MODE	50
#define uvisenEXPM_FCT_SETUP	51
#define uvisenEXPM_FCT_GET_VAL	52
#define uvisenEXPM_FCT_SET_VAL	53
#define uvisenEXPM_FCT_CFG_ELEM	54
#define uvisenEXPM_FCT_LOG_CONF	55
#define uvisenEXPM_FCT_GET_CONF	56
#define uvisenEXPM_FCT_RESET_PARAMETERS	57
#define uvisenEXPM_FCT_PARSE_PARAMETERS	58
#define uvisenEXPM_FCT_COMPARE_PARAMETERS	59
#define uvisenEXPM_FCT_COPY_PARAMETERS	60
#define uvisenEXPM_FCT_EXEC_PARAMETERS	61
#define uvisenEXPM_FCT_UPDATE_PARAMETERS	62
#define uvisenEXPM_FCT_GET_PARAM_SET_VALUE	63
#define uvisenEXPM_FCT_GET_PARAM_STATUS	64
#define uvisenEXPM_FCT_SET_PARAM	65
#define uvisenEXPM_FCT_SET_PARAM_STEP	66
#define uvisenEXPM_FCT_USR_EXEC_ACTION	67
#define uvisenEXPM_FCT_USR_SET_PARAMETER	68
#define uvisenEXPM_FCT_GET_VALUE_CODE	69
#define uvisenEXPM_FCT_GET_VALUE	70
#define uvisenEXPM_FCT_USR_GET_VALUE	71
#define uvisenEXPM_FCT_SET_VALUE	72
#define uvisenEXPM_FCT_USR_SET_VALUE	73
#define uvisenEXPM_FCT_GET_ARG	74
#define uvisenEXPM_FCT_MONITOR	75
#define uvisenEXPM_FCT_USR_MONITOR	76
#define uvisenEXPM_FCT_LOG_ACTION	77
#define uvisenEXPM_FCT_LOG_COMMENT	78
#define uvisenEXPM_FCT_LOG_PARAMETER	79
#define uvisenEXPM_FCT_LOG_RECOVERY	80
#define uvisenEXPM_FCT_LOG_TBL_PARAM	81
#define uvisenEXPM_FCT_LOG_UNFORSEEN	82
#define uvisenEXPM_FCT_HW_INIT	83
#define uvisenEXPM_FCT_HW_EXIT	84
#define uvisenEXPM_FCT_HW_SETUP	85

/*
 * automata states
 */
#define uvisenEXPM_STATE_NOSTATE	-1
#define uvisenEXPM_STATE_OFF	0
#define uvisenEXPM_STATE_LOADED	1
#define uvisenEXPM_STATE_STANDBY	2
#define uvisenEXPM_STATE_ONLINE	3

/*
 * automata substates
 */
#define uvisenEXPM_SUBSTATE_ERROR	0
#define uvisenEXPM_SUBSTATE_IDLE	1
#define uvisenEXPM_SUBSTATE_BUSY	2
#define uvisenEXPM_SUBSTATE_INITIALISING	3
#define uvisenEXPM_SUBSTATE_SHUTTING_DOWN	4
#define uvisenEXPM_SUBSTATE_STOPPING	5
#define uvisenEXPM_SUBSTATE_COLD_STARTING	6
#define uvisenEXPM_SUBSTATE_STARTING	7
#define uvisenEXPM_SUBSTATE_STOP	8

/*
 * automata events
 */
#define uvisenEXPM_EVENT_INIT	0
#define uvisenEXPM_EVENT_STANDBY	1
#define uvisenEXPM_EVENT_ONLINE	2
#define uvisenEXPM_EVENT_STOP	3
#define uvisenEXPM_EVENT_OFF	4
#define uvisenEXPM_EVENT_EXIT	5
#define uvisenEXPM_EVENT_STATE	6
#define uvisenEXPM_EVENT_STOP_SIM	7
#define uvisenEXPM_EVENT_STATUS	8
#define uvisenEXPM_EVENT_SIMULAT	9
#define uvisenEXPM_EVENT_TEST	10
#define uvisenEXPM_EVENT_SELFTST	11
#define uvisenEXPM_EVENT_AUTO_TBL	12
#define uvisenEXPM_EVENT_AUTO_RST	13
#define uvisenEXPM_EVENT_DISABLE	14
#define uvisenEXPM_EVENT_ENABLE	15
#define uvisenEXPM_EVENT_LOCK	16
#define uvisenEXPM_EVENT_UNLOCK	17
#define uvisenEXPM_EVENT_HANDSET	18
#define uvisenEXPM_EVENT_HSET_OFF	19
#define uvisenEXPM_EVENT_AVAIL	20
#define uvisenEXPM_EVENT_UNAVAIL	21
#define uvisenEXPM_EVENT_MOVE	22
#define uvisenEXPM_EVENT_MOVE_REL	23
#define uvisenEXPM_EVENT_SET	24
#define uvisenEXPM_EVENT_CHECK	25
#define uvisenEXPM_EVENT_WAIT	26
#define uvisenEXPM_EVENT_SETUP	27
#define uvisenEXPM_EVENT_CFG_ELEM	28
#define uvisenEXPM_EVENT_GET_VAL	29
#define uvisenEXPM_EVENT_SET_VAL	30
#define uvisenEXPM_EVENT_LOG_CONF	31
#define uvisenEXPM_EVENT_GET_CONF	32
#define uvisenEXPM_EVENT_MONITOR	33


/*
 * user variables
 */
typedef struct
    {
    SEM_ID	actionSequence;
    SEM_ID	actionSetup;
    lcctooTASK*	task;
    vltINT32	dummy[7];
    } uvisenEXPM_USERVAR;


/*
 * function pointer types
 */
typedef ccsCOMPL_STAT (*uvisenEXPM_FCTPTR_SETUP)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    const char*	function[],	/* max. vltBYTES32[999] */
    IN    vltINT16	functionNum,
    IN    vltLOGICAL	noMove,
    IN    vltLOGICAL	check,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*uvisenEXPM_FCTPTR_INIT_OBJ)(
    INOUT egenOBJ*	obj,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*uvisenEXPM_FCTPTR_EXIT_OBJ)(
    INOUT egenOBJ*	obj,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*uvisenEXPM_FCTPTR_USR_INIT)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*uvisenEXPM_FCTPTR_USR_STANDBY2ONLINE)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*uvisenEXPM_FCTPTR_USR_ONLINE2STANDBY)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*uvisenEXPM_FCTPTR_USR_STANDBY2LOADED)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*uvisenEXPM_FCTPTR_USR_SET_MODE)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltINT32	cmd,
    IN    vltLOGICAL	available,
    IN    vltLOGICAL	enabled,
    IN    vltLOGICAL	simulation,
    IN    vltLOGICAL	handset,
    IN    vltLOGICAL	locked,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*uvisenEXPM_FCTPTR_USR_STATUS_CODE)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    const char*	text,
    IN    vltINT32	flags,
    OUT   vltINT32*	code,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*uvisenEXPM_FCTPTR_USR_STATUS_VALUE)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltINT32	code,
    OUT   lcctooVALUE*	value,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*uvisenEXPM_FCTPTR_USR_STATUS_LAST)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   vltINT16*	last,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*uvisenEXPM_FCTPTR_HW_INIT)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    lccDEV_MODE	state,
    IN    vltLOGICAL	simulation,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*uvisenEXPM_FCTPTR_HW_EXIT)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    lccDEV_MODE	state,
    IN    vltLOGICAL	simulation,
    OUT   ccsERROR*	error);

typedef ccsCOMPL_STAT (*uvisenEXPM_FCTPTR_HW_SETUP)(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    const char*	function[],	/* max. vltBYTES32[999] */
    IN    vltINT16	functionNum,
    IN    vltLOGICAL	noMove,
    IN    vltLOGICAL	check,
    IN    vltLOGICAL	simulation,
    OUT   ccsERROR*	error);


/*
 * log function
 */
#define uvisenExpmLogData(obj, format, arg...) \
	{ \
	char tmpLogBuf[lcctooTMP_BUFFER_SIZE]; \
	\
	sprintf(tmpLogBuf, (format), ##arg); \
	logData("uvisen", (obj)->id, tmpLogBuf); \
	}


/*
 * error functions
 */
#define uvisenErrReadOldb(p1,p2) \
	{ \
	lcctooLOG_0("uvisenERR_READ_OLDB: Device %s: Unable to read %s from OLDB.",(p1),(p2)); \
	errAdd(error,"uvisen",uvisenERR_READ_OLDB,__FILE_LINE__,"%s,%s",(p1),(p2)); \
	}
#define uvisenErrWriteOldb(p1,p2) \
	{ \
	lcctooLOG_0("uvisenERR_WRITE_OLDB: Device %s: Unable to write %s to OLDB.",(p1),(p2)); \
	errAdd(error,"uvisen",uvisenERR_WRITE_OLDB,__FILE_LINE__,"%s,%s",(p1),(p2)); \
	}
#define uvisenErrExpmIfTimeout(p1,p2) \
	{ \
	lcctooLOG_0("uvisenERR_EXPM_IF_TIMEOUT: Device %s: Timeout on read after %f sec.",(p1),(p2)); \
	errAdd(error,"uvisen",uvisenERR_EXPM_IF_TIMEOUT,__FILE_LINE__,"%s,%f",(p1),(p2)); \
	}
#define uvisenErrExpmIfRead(p1) \
	{ \
	lcctooLOG_0("uvisenERR_EXPM_IF_READ: Device %s: No data available from serial port.",(p1)); \
	errAdd(error,"uvisen",uvisenERR_EXPM_IF_READ,__FILE_LINE__,"%s",(p1)); \
	}
#define uvisenErrExpmIfWrite(p1) \
	{ \
	lcctooLOG_0("uvisenERR_EXPM_IF_WRITE: Device %s: Problem writting data to the serial port.",(p1)); \
	errAdd(error,"uvisen",uvisenERR_EXPM_IF_WRITE,__FILE_LINE__,"%s",(p1)); \
	}
#define uvisenErrExpmCheckGpib(p1) \
	{ \
	lcctooLOG_0("uvisenERR_EXPM_CHECK_GPIB: Device %s: Check if GPIB-232CT-A and HP Counter are powered on.",(p1)); \
	errAdd(error,"uvisen",uvisenERR_EXPM_CHECK_GPIB,__FILE_LINE__,"%s",(p1)); \
	}
#define uvisenErrExpmCheckCounter(p1) \
	{ \
	lcctooLOG_0("uvisenERR_EXPM_CHECK_COUNTER: Device %s: No answer from HP counter: Check if it is powered on.",(p1)); \
	errAdd(error,"uvisen",uvisenERR_EXPM_CHECK_COUNTER,__FILE_LINE__,"%s",(p1)); \
	}
#define uvisenErrExpmComOpen(p1) \
	{ \
	lcctooLOG_0("uvisenERR_EXPM_COM_OPEN: Device %s: Error opening the serial port.",(p1)); \
	errAdd(error,"uvisen",uvisenERR_EXPM_COM_OPEN,__FILE_LINE__,"%s",(p1)); \
	}
#define uvisenErrExpmComOpenParam(p1) \
	{ \
	lcctooLOG_0("uvisenERR_EXPM_COM_OPEN_PARAM: Device %s: Error retrieving the port parameters.",(p1)); \
	errAdd(error,"uvisen",uvisenERR_EXPM_COM_OPEN_PARAM,__FILE_LINE__,"%s",(p1)); \
	}
#define uvisenErrExpmComClose(p1) \
	{ \
	lcctooLOG_0("uvisenERR_EXPM_COM_CLOSE: Device %s: Error closeing the serial port.",(p1)); \
	errAdd(error,"uvisen",uvisenERR_EXPM_COM_CLOSE,__FILE_LINE__,"%s",(p1)); \
	}
#define uvisenErrExpmComStart(p1) \
	{ \
	lcctooLOG_0("uvisenERR_EXPM_COM_START: Device %s: Error starting the counter.",(p1)); \
	errAdd(error,"uvisen",uvisenERR_EXPM_COM_START,__FILE_LINE__,"%s",(p1)); \
	}
#define uvisenErrExpmTaskStart(p1) \
	{ \
	lcctooLOG_0("uvisenERR_EXPM_TASK_START: Device %s: Error starting the monitor task.",(p1)); \
	errAdd(error,"uvisen",uvisenERR_EXPM_TASK_START,__FILE_LINE__,"%s",(p1)); \
	}
#define uvisenErrExpmTaskStop(p1) \
	{ \
	lcctooLOG_0("uvisenERR_EXPM_TASK_STOP: Device %s: Error stopping the monitor task.",(p1)); \
	errAdd(error,"uvisen",uvisenERR_EXPM_TASK_STOP,__FILE_LINE__,"%s",(p1)); \
	}
#define uvisenErrExpmTaskWait(p1) \
	{ \
	lcctooLOG_0("uvisenERR_EXPM_TASK_WAIT: Device %s: Semaphore error updating the monitor data.",(p1)); \
	errAdd(error,"uvisen",uvisenERR_EXPM_TASK_WAIT,__FILE_LINE__,"%s",(p1)); \
	}

/*
 * get object owner
 */
#define uvisenExpmGetOwner(obj) ((obj)->owner)


/*
 * attribute access functions
 */
#define uvisenExpmReadState(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,uvisenEXPM_ATTR_STATE,(buf),(error))
#define uvisenExpmWriteState(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,uvisenEXPM_ATTR_STATE,(void*) (buf),(error))
#define uvisenExpmReadSubstate(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,uvisenEXPM_ATTR_SUBSTATE,(buf),(error))
#define uvisenExpmWriteSubstate(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,uvisenEXPM_ATTR_SUBSTATE,(void*) (buf),(error))
#define uvisenExpmReadError(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,uvisenEXPM_ATTR_ERROR,(buf),(error))
#define uvisenExpmWriteError(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,uvisenEXPM_ATTR_ERROR,(void*) (buf),(error))
#define uvisenExpmReadInitialised(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,uvisenEXPM_ATTR_INITIALISED,(buf),(error))
#define uvisenExpmWriteInitialised(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,uvisenEXPM_ATTR_INITIALISED,(void*) (buf),(error))
#define uvisenExpmReadSimulation(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,uvisenEXPM_ATTR_SIMULATION,(buf),(error))
#define uvisenExpmWriteSimulation(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,uvisenEXPM_ATTR_SIMULATION,(void*) (buf),(error))
#define uvisenExpmReadDevice(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,uvisenEXPM_ATTR_DEVICE,(buf),(error))
#define uvisenExpmWriteDevice(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,uvisenEXPM_ATTR_DEVICE,(void*) (buf),(error))
#define uvisenExpmReadAvailable(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,uvisenEXPM_ATTR_AVAILABLE,(buf),(error))
#define uvisenExpmWriteAvailable(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,uvisenEXPM_ATTR_AVAILABLE,(void*) (buf),(error))
#define uvisenExpmReadEnabled(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,uvisenEXPM_ATTR_ENABLED,(buf),(error))
#define uvisenExpmWriteEnabled(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,uvisenEXPM_ATTR_ENABLED,(void*) (buf),(error))
#define uvisenExpmReadLocked(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,uvisenEXPM_ATTR_LOCKED,(buf),(error))
#define uvisenExpmWriteLocked(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,uvisenEXPM_ATTR_LOCKED,(void*) (buf),(error))
#define uvisenExpmReadHandset(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,uvisenEXPM_ATTR_HANDSET,(buf),(error))
#define uvisenExpmWriteHandset(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,uvisenEXPM_ATTR_HANDSET,(void*) (buf),(error))
#define uvisenExpmReadFixed(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,uvisenEXPM_ATTR_FIXED,(buf),(error))
#define uvisenExpmWriteFixed(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,uvisenEXPM_ATTR_FIXED,(void*) (buf),(error))
#define uvisenExpmReadFixPosSet(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,uvisenEXPM_ATTR_FIX_POS_SET,(buf),(error))
#define uvisenExpmWriteFixPosSet(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,uvisenEXPM_ATTR_FIX_POS_SET,(void*) (buf),(error))
#define uvisenExpmReadFixedPosition(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,uvisenEXPM_ATTR_FIXED_POSITION,(buf),(error))
#define uvisenExpmWriteFixedPosition(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,uvisenEXPM_ATTR_FIXED_POSITION,(void*) (buf),(error))
#define uvisenExpmReadFixedSimulation(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,uvisenEXPM_ATTR_FIXED_SIMULATION,(buf),(error))
#define uvisenExpmWriteFixedSimulation(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,uvisenEXPM_ATTR_FIXED_SIMULATION,(void*) (buf),(error))
#define uvisenExpmReadFixedLocked(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,uvisenEXPM_ATTR_FIXED_LOCKED,(buf),(error))
#define uvisenExpmWriteFixedLocked(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,uvisenEXPM_ATTR_FIXED_LOCKED,(void*) (buf),(error))
#define uvisenExpmReadPrefix(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,uvisenEXPM_ATTR_PREFIX,(buf),(error))
#define uvisenExpmWritePrefix(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,uvisenEXPM_ATTR_PREFIX,(void*) (buf),(error))
#define uvisenExpmReadParametersSize(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,uvisenEXPM_ATTR_PARAMETERS_SIZE,(buf),(error))
#define uvisenExpmWriteParametersSize(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,uvisenEXPM_ATTR_PARAMETERS_SIZE,(void*) (buf),(error))
#define uvisenExpmGetParametersSize(obj,num,error) \
	caiGetAttrInfo((obj)->attrs,uvisenEXPM_ATTR_PARAMETERS,NULL,NULL,(num),NULL, NULL,NULL,(error))
#define uvisenExpmReadParameters(obj,buf,firstRec,lastRec,firstFld,lastFld,error) \
	lcctooCaiRWTable((obj)->attrs,0,uvisenEXPM_ATTR_PARAMETERS,(buf),(firstRec),(lastRec),(firstFld),(lastFld),(error))
#define uvisenExpmWriteParameters(obj,buf,firstRec,lastRec,firstFld,lastFld,error) \
	lcctooCaiRWTable((obj)->attrs,1,uvisenEXPM_ATTR_PARAMETERS,(void*) (buf),(firstRec),(lastRec),(firstFld),(lastFld),(error))
#define uvisenExpmGetStatusSize(obj,num,error) \
	caiGetAttrInfo((obj)->attrs,uvisenEXPM_ATTR_STATUS,NULL,NULL,(num),NULL, NULL,NULL,(error))
#define uvisenExpmReadStatus(obj,buf,firstElt,lastElt,error) \
	caiRWVector((obj)->attrs,0,uvisenEXPM_ATTR_STATUS,(buf),(firstElt),(lastElt),(error))
#define uvisenExpmWriteStatus(obj,buf,firstElt,lastElt,error) \
	caiRWVector((obj)->attrs,1,uvisenEXPM_ATTR_STATUS,(void*) (buf),(firstElt),(lastElt),(error))
#define uvisenExpmGetStatusIndexSize(obj,num,error) \
	caiGetAttrInfo((obj)->attrs,uvisenEXPM_ATTR_STATUS_INDEX,NULL,NULL,(num),NULL, NULL,NULL,(error))
#define uvisenExpmReadStatusIndex(obj,buf,firstElt,lastElt,error) \
	caiRWVector((obj)->attrs,0,uvisenEXPM_ATTR_STATUS_INDEX,(buf),(firstElt),(lastElt),(error))
#define uvisenExpmWriteStatusIndex(obj,buf,firstElt,lastElt,error) \
	caiRWVector((obj)->attrs,1,uvisenEXPM_ATTR_STATUS_INDEX,(void*) (buf),(firstElt),(lastElt),(error))
#define uvisenExpmReadValuesSize(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,uvisenEXPM_ATTR_VALUES_SIZE,(buf),(error))
#define uvisenExpmWriteValuesSize(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,uvisenEXPM_ATTR_VALUES_SIZE,(void*) (buf),(error))
#define uvisenExpmGetValuesSize(obj,num,error) \
	caiGetAttrInfo((obj)->attrs,uvisenEXPM_ATTR_VALUES,NULL,NULL,(num),NULL, NULL,NULL,(error))
#define uvisenExpmReadValues(obj,buf,firstRec,lastRec,firstFld,lastFld,error) \
	lcctooCaiRWTable((obj)->attrs,0,uvisenEXPM_ATTR_VALUES,(buf),(firstRec),(lastRec),(firstFld),(lastFld),(error))
#define uvisenExpmWriteValues(obj,buf,firstRec,lastRec,firstFld,lastFld,error) \
	lcctooCaiRWTable((obj)->attrs,1,uvisenEXPM_ATTR_VALUES,(void*) (buf),(firstRec),(lastRec),(firstFld),(lastFld),(error))
#define uvisenExpmReadInitRestriction(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,uvisenEXPM_ATTR_INIT_RESTRICTION,(buf),(error))
#define uvisenExpmWriteInitRestriction(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,uvisenEXPM_ATTR_INIT_RESTRICTION,(void*) (buf),(error))
#define uvisenExpmReadMoveRestriction(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,uvisenEXPM_ATTR_MOVE_RESTRICTION,(buf),(error))
#define uvisenExpmWriteMoveRestriction(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,uvisenEXPM_ATTR_MOVE_RESTRICTION,(void*) (buf),(error))
#define uvisenExpmReadStopTimeout(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,uvisenEXPM_ATTR_STOP_TIMEOUT,(buf),(error))
#define uvisenExpmWriteStopTimeout(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,uvisenEXPM_ATTR_STOP_TIMEOUT,(void*) (buf),(error))
#define uvisenExpmReadSetValFct(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,uvisenEXPM_ATTR_SET_VAL_FCT,(buf),(error))
#define uvisenExpmWriteSetValFct(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,uvisenEXPM_ATTR_SET_VAL_FCT,(void*) (buf),(error))
#define uvisenExpmGetHelpTextSize(obj,num,error) \
	caiGetAttrInfo((obj)->attrs,uvisenEXPM_ATTR_HELP_TEXT,NULL,NULL,(num),NULL, NULL,NULL,(error))
#define uvisenExpmReadHelpText(obj,buf,firstElt,lastElt,error) \
	caiRWVector((obj)->attrs,0,uvisenEXPM_ATTR_HELP_TEXT,(buf),(firstElt),(lastElt),(error))
#define uvisenExpmWriteHelpText(obj,buf,firstElt,lastElt,error) \
	caiRWVector((obj)->attrs,1,uvisenEXPM_ATTR_HELP_TEXT,(void*) (buf),(firstElt),(lastElt),(error))
#define uvisenExpmReadParamStep(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,uvisenEXPM_ATTR_PARAM_STEP,(buf),(error))
#define uvisenExpmWriteParamStep(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,uvisenEXPM_ATTR_PARAM_STEP,(void*) (buf),(error))
#define uvisenExpmReadActionCommand(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,uvisenEXPM_ATTR_ACTION_COMMAND,(buf),(error))
#define uvisenExpmWriteActionCommand(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,uvisenEXPM_ATTR_ACTION_COMMAND,(void*) (buf),(error))
#define uvisenExpmReadActionStopReq(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,uvisenEXPM_ATTR_ACTION_STOP_REQ,(buf),(error))
#define uvisenExpmWriteActionStopReq(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,uvisenEXPM_ATTR_ACTION_STOP_REQ,(void*) (buf),(error))
#define uvisenExpmReadActionNoMove(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,uvisenEXPM_ATTR_ACTION_NO_MOVE,(buf),(error))
#define uvisenExpmWriteActionNoMove(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,uvisenEXPM_ATTR_ACTION_NO_MOVE,(void*) (buf),(error))
#define uvisenExpmReadActionCheck(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,uvisenEXPM_ATTR_ACTION_CHECK,(buf),(error))
#define uvisenExpmWriteActionCheck(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,uvisenEXPM_ATTR_ACTION_CHECK,(void*) (buf),(error))
#define uvisenExpmReadResetSetupCmd(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,uvisenEXPM_ATTR_RESET_SETUP_CMD,(buf),(error))
#define uvisenExpmWriteResetSetupCmd(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,uvisenEXPM_ATTR_RESET_SETUP_CMD,(void*) (buf),(error))
#define uvisenExpmReadComDevice(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,uvisenEXPM_ATTR_COM_DEVICE,(buf),(error))
#define uvisenExpmWriteComDevice(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,uvisenEXPM_ATTR_COM_DEVICE,(void*) (buf),(error))
#define uvisenExpmReadGpibAddr(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,uvisenEXPM_ATTR_GPIB_ADDR,(buf),(error))
#define uvisenExpmWriteGpibAddr(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,uvisenEXPM_ATTR_GPIB_ADDR,(void*) (buf),(error))
#define uvisenExpmReadCtlast(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,uvisenEXPM_ATTR_CTLAST,(buf),(error))
#define uvisenExpmWriteCtlast(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,uvisenEXPM_ATTR_CTLAST,(void*) (buf),(error))
#define uvisenExpmReadCttot(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,uvisenEXPM_ATTR_CTTOT,(buf),(error))
#define uvisenExpmWriteCttot(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,uvisenEXPM_ATTR_CTTOT,(void*) (buf),(error))
#define uvisenExpmReadUit(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,uvisenEXPM_ATTR_UIT,(buf),(error))
#define uvisenExpmWriteUit(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,uvisenEXPM_ATTR_UIT,(void*) (buf),(error))
#define uvisenExpmReadRep(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,uvisenEXPM_ATTR_REP,(buf),(error))
#define uvisenExpmWriteRep(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,uvisenEXPM_ATTR_REP,(void*) (buf),(error))
#define uvisenExpmReadOffdrk(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,uvisenEXPM_ATTR_OFFDRK,(buf),(error))
#define uvisenExpmWriteOffdrk(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,uvisenEXPM_ATTR_OFFDRK,(void*) (buf),(error))
#define uvisenExpmReadOffsky(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,uvisenEXPM_ATTR_OFFSKY,(buf),(error))
#define uvisenExpmWriteOffsky(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,uvisenEXPM_ATTR_OFFSKY,(void*) (buf),(error))
#define uvisenExpmReadSetupActive(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,uvisenEXPM_ATTR_SETUP_ACTIVE,(buf),(error))
#define uvisenExpmWriteSetupActive(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,uvisenEXPM_ATTR_SETUP_ACTIVE,(void*) (buf),(error))
#define uvisenExpmReadFitsLogUit(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,uvisenEXPM_ATTR_FITS_LOG_UIT,(buf),(error))
#define uvisenExpmWriteFitsLogUit(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,uvisenEXPM_ATTR_FITS_LOG_UIT,(void*) (buf),(error))
#define uvisenExpmReadCtMinLog(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,uvisenEXPM_ATTR_CT_MIN_LOG,(buf),(error))
#define uvisenExpmWriteCtMinLog(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,uvisenEXPM_ATTR_CT_MIN_LOG,(void*) (buf),(error))
#define uvisenExpmReadCtNumber(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,uvisenEXPM_ATTR_CT_NUMBER,(buf),(error))
#define uvisenExpmWriteCtNumber(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,uvisenEXPM_ATTR_CT_NUMBER,(void*) (buf),(error))
#define uvisenExpmGetCtValuesSize(obj,num,error) \
	caiGetAttrInfo((obj)->attrs,uvisenEXPM_ATTR_CT_VALUES,NULL,NULL,(num),NULL, NULL,NULL,(error))
#define uvisenExpmReadCtValues(obj,buf,firstElt,lastElt,error) \
	caiRWVector((obj)->attrs,0,uvisenEXPM_ATTR_CT_VALUES,(buf),(firstElt),(lastElt),(error))
#define uvisenExpmWriteCtValues(obj,buf,firstElt,lastElt,error) \
	caiRWVector((obj)->attrs,1,uvisenEXPM_ATTR_CT_VALUES,(void*) (buf),(firstElt),(lastElt),(error))
#define uvisenExpmReadHwAccess(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,uvisenEXPM_ATTR_HW_ACCESS,(buf),(error))
#define uvisenExpmWriteHwAccess(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,uvisenEXPM_ATTR_HW_ACCESS,(void*) (buf),(error))
#define uvisenExpmReadHwFd(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,uvisenEXPM_ATTR_HW_FD,(buf),(error))
#define uvisenExpmWriteHwFd(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,uvisenEXPM_ATTR_HW_FD,(void*) (buf),(error))
#define uvisenExpmReadCurrTimeout(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,uvisenEXPM_ATTR_CURR_TIMEOUT,(buf),(error))
#define uvisenExpmWriteCurrTimeout(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,uvisenEXPM_ATTR_CURR_TIMEOUT,(void*) (buf),(error))
#define uvisenExpmReadCurrPollRate(obj,buf,error) \
	caiRWAttribute((obj)->attrs,0,uvisenEXPM_ATTR_CURR_POLL_RATE,(buf),(error))
#define uvisenExpmWriteCurrPollRate(obj,buf,error) \
	caiRWAttribute((obj)->attrs,1,uvisenEXPM_ATTR_CURR_POLL_RATE,(void*) (buf),(error))
#define uvisenExpmGetAuto(obj,attrPtr,error) \
	SUCCESS; \
	memcpy((attrPtr), &(obj)->objs[uvisenEXPM_AUTOMATA], sizeof(egenOBJ)); \
	(attrPtr)->ldata = (obj)->ldata;


/*
 * class functions
 */
#define uvisenExpmGetVal(obj,devName,name,nameNum,status,error) \
	ic0devSoftGetVal((obj),(devName),(name),(nameNum),(status),(error))
#define uvisenExpmSetVal(obj,devName,name,nameNum,value,valueNum,error) \
	ic0devSoftSetVal((obj),(devName),(name),(nameNum),(value),(valueNum),(error))
#define uvisenExpmCfgElem(obj,devName,position,id,values,valuesNum,error) \
	ic0devSoftCfgElem((obj),(devName),(position),(id),(values),(valuesNum),(error))
#define uvisenExpmLogConf(obj,devName,allElements,error) \
	ic0devSoftLogConf((obj),(devName),(allElements),(error))
#define uvisenExpmGetConf(obj,devName,allElements,text,error) \
	ic0devSoftGetConf((obj),(devName),(allElements),(text),(error))
#define uvisenExpmStatus(obj,devName,function,functionNum,flag,header,conflog,opslog,condlog,status,error) \
	ic0devSoftStatus((obj),(devName),(function),(functionNum),(flag),(header),(conflog),(opslog),(condlog),(status),(error))
#define uvisenExpmMove(obj,devName,position,positionNum,error) \
	ic0devSoftMove((obj),(devName),(position),(positionNum),(error))
#define uvisenExpmMoveRel(obj,devName,position,positionNum,error) \
	ic0devSoftMoveRel((obj),(devName),(position),(positionNum),(error))
#define uvisenExpmSet(obj,devName,position,positionNum,error) \
	ic0devSoftSet((obj),(devName),(position),(positionNum),(error))
#define uvisenExpmResetParameters(obj,devName,cmd,error) \
	ic0devSoftResetParameters((obj),(devName),(cmd),(error))
#define uvisenExpmParseParameters(obj,devName,cmd,params,paramsNum,noMove,check,error) \
	ic0devSoftParseParameters((obj),(devName),(cmd),(params),(paramsNum),(noMove),(check),(error))
#define uvisenExpmCompareParameters(obj,devName,cmd,equal,error) \
	ic0devSoftCompareParameters((obj),(devName),(cmd),(equal),(error))
#define uvisenExpmCopyParameters(obj,devName,error) \
	ic0devSoftCopyParameters((obj),(devName),(error))
#define uvisenExpmExecParameters(obj,devName,error) \
	ic0devSoftExecParameters((obj),(devName),(error))
#define uvisenExpmUpdateParameters(obj,devName,cache,error) \
	ic0devSoftUpdateParameters((obj),(devName),(cache),(error))
#define uvisenExpmGetParamSetValue(obj,devName,index,value,setCode,error) \
	ic0devSoftGetParamSetValue((obj),(devName),(index),(value),(setCode),(error))
#define uvisenExpmGetParamStatus(obj,devName,index,flags,status,error) \
	ic0devSoftGetParamStatus((obj),(devName),(index),(flags),(status),(error))
#define uvisenExpmSetParam(obj,devName,index,cmd,value,step,error) \
	ic0devSoftSetParam((obj),(devName),(index),(cmd),(value),(step),(error))
#define uvisenExpmSetParamStep(obj,devName,index,cmd,step,error) \
	ic0devSoftSetParamStep((obj),(devName),(index),(cmd),(step),(error))
#define uvisenExpmUsrExecAction(obj,devName,index,error) \
	ic0devSoftUsrExecAction((obj),(devName),(index),(error))
#define uvisenExpmUsrSetParameter(obj,devName,cmd,param1,param1SetCode,param2,param2SetCode,value,error) \
	ic0devSoftUsrSetParameter((obj),(devName),(cmd),(param1),(param1SetCode),(param2),(param2SetCode),(value),(error))
#define uvisenExpmGetValueCode(obj,devName,name,code,error) \
	ic0devSoftGetValueCode((obj),(devName),(name),(code),(error))
#define uvisenExpmGetValue(obj,devName,code,index,value,valueNum,error) \
	ic0devSoftGetValue((obj),(devName),(code),(index),(value),(valueNum),(error))
#define uvisenExpmUsrGetValue(obj,devName,valuesTable,valuesTableNum,code,index,value,valueNum,done,error) \
	ic0devSoftUsrGetValue((obj),(devName),(valuesTable),(valuesTableNum),(code),(index),(value),(valueNum),(done),(error))
#define uvisenExpmSetValue(obj,devName,code,index,value,valueNum,error) \
	ic0devSoftSetValue((obj),(devName),(code),(index),(value),(valueNum),(error))
#define uvisenExpmUsrSetValue(obj,devName,valuesTable,valuesTableNum,code,index,value,valueNum,done,error) \
	ic0devSoftUsrSetValue((obj),(devName),(valuesTable),(valuesTableNum),(code),(index),(value),(valueNum),(done),(error))
#define uvisenExpmGetArg(obj,devName,code,index,value,error) \
	ic0devSoftGetArg((obj),(devName),(code),(index),(value),(error))
#define uvisenExpmMonitor(obj,devName,error) \
	ic0devSoftMonitor((obj),(devName),(error))
#define uvisenExpmUsrMonitor(obj,devName,state,error) \
	ic0devSoftUsrMonitor((obj),(devName),(state),(error))
#define uvisenExpmLogAction(obj,devName,action,comment,error) \
	ic0devSoftLogAction((obj),(devName),(action),(comment),(error))
#define uvisenExpmLogComment(obj,devName,comment,error) \
	ic0devSoftLogComment((obj),(devName),(comment),(error))
#define uvisenExpmLogParameter(obj,devName,parameter,index,value,comment,error) \
	ic0devSoftLogParameter((obj),(devName),(parameter),(index),(value),(comment),(error))
#define uvisenExpmLogRecovery(obj,devName,comment,error) \
	ic0devSoftLogRecovery((obj),(devName),(comment),(error))
#define uvisenExpmLogTblParam(obj,devName,paramIndex,flags,comment,error) \
	ic0devSoftLogTblParam((obj),(devName),(paramIndex),(flags),(comment),(error))
#define uvisenExpmLogUnforseen(obj,devName,comment,error) \
	ic0devSoftLogUnforseen((obj),(devName),(comment),(error))
#define uvisenExpmUsrStop(obj,devName,req,error) \
	ic0devSoftUsrStop((obj),(devName),(req),(error))
#define uvisenExpmAvail(obj,devName,error) \
	lccdevCmdAvail((obj),(devName),(error))
#define uvisenExpmUnavail(obj,devName,error) \
	lccdevCmdUnavail((obj),(devName),(error))
#define uvisenExpmDisable(obj,devName,access,error) \
	lccdevCmdDisable((obj),(devName),(access),(error))
#define uvisenExpmEnable(obj,devName,access,error) \
	lccdevCmdEnable((obj),(devName),(access),(error))
#define uvisenExpmLock(obj,devName,error) \
	lccdevCmdLock((obj),(devName),(error))
#define uvisenExpmUnlock(obj,devName,error) \
	lccdevCmdUnlock((obj),(devName),(error))
#define uvisenExpmHandset(obj,devName,error) \
	lccdevCmdHandset((obj),(devName),(error))
#define uvisenExpmHsetOff(obj,devName,error) \
	lccdevCmdHsetOff((obj),(devName),(error))
#define uvisenExpmFixPos(obj,devName,position,positionNum,reset,error) \
	lccdevCmdFixPos((obj),(devName),(position),(positionNum),(reset),(error))
#define uvisenExpmCheck(obj,devName,status,error) \
	lccdevCmdCheck((obj),(devName),(status),(error))
#define uvisenExpmWait(obj,devName,timeout,error) \
	lccdevCmdWait((obj),(devName),(timeout),(error))
#define uvisenExpmUsrSimulat(obj,devName,error) \
	lccdevCmdUsrSimulat((obj),(devName),(error))
#define uvisenExpmUsrStopSim(obj,devName,error) \
	lccdevCmdUsrStopSim((obj),(devName),(error))
#define uvisenExpmUsrLoaded2Standby(obj,devName,error) \
	lccdevCmdUsrLoaded2Standby((obj),(devName),(error))
#define uvisenExpmStandby(obj,devName,error) \
	lccdevStdStandby((obj),(devName),(error))
#define uvisenExpmOnline(obj,devName,error) \
	lccdevStdOnline((obj),(devName),(error))
#define uvisenExpmOff(obj,devName,error) \
	lccdevStdOff((obj),(devName),(error))
#define uvisenExpmExit(obj,devName,error) \
	lccdevStdExit((obj),(devName),(error))
#define uvisenExpmState(obj,devName,state,error) \
	lccdevStdState((obj),(devName),(state),(error))
#define uvisenExpmSimulat(obj,devName,error) \
	lccdevStdSimulat((obj),(devName),(error))
#define uvisenExpmStopSim(obj,devName,error) \
	lccdevStdStopSim((obj),(devName),(error))
#define uvisenExpmInit(obj,devName,error) \
	lccdevStdInit((obj),(devName),(error))
#define uvisenExpmStop(obj,devName,error) \
	lccdevStdStop((obj),(devName),(error))
#define uvisenExpmTest(obj,devName,error) \
	lccdevStdTest((obj),(devName),(error))
#define uvisenExpmSelftst(obj,devName,error) \
	lccdevStdSelftst((obj),(devName),(error))
#define uvisenExpmAutoTbl(obj,devName,table,text,error) \
	lccdevStdAutoTbl((obj),(devName),(table),(text),(error))
#define uvisenExpmAutoRst(obj,devName,error) \
	lccdevStdAutoRst((obj),(devName),(error))
#define uvisenExpmLoaded2Stby(obj,devName,error) \
	lccdevStdLoaded2Stby((obj),(devName),(error))
#define uvisenExpmOnline2Stby(obj,devName,error) \
	lccdevStdOnline2Stby((obj),(devName),(error))
#define uvisenExpmExit1(obj,devName,error) \
	lccdevStdExit1((obj),(devName),(error))
#define uvisenExpmCheckDeviceName(obj,devName,error) \
	lccdevStdCheckDeviceName((obj),(devName),(error))
#define uvisenExpmBreak(obj,error) \
	lccdevStdBreak((obj),(error))
#define uvisenExpmUsrTest(obj,devName,error) \
	lccdevStdUsrTest((obj),(devName),(error))
#define uvisenExpmUsrSelfTest(obj,devName,error) \
	lccdevStdUsrSelfTest((obj),(devName),(error))
#define uvisenExpmUsrError(obj,devName,error) \
	lccdevStdUsrError((obj),(devName),(error))

ccsCOMPL_STAT uvisenExpmSetup(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    const char*	function[],	/* max. vltBYTES32[999] */
    IN    vltINT16	functionNum,
    IN    vltLOGICAL	noMove,
    IN    vltLOGICAL	check,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT uvisenExpmInitObj(
    INOUT egenOBJ*	obj,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT uvisenExpmExitObj(
    INOUT egenOBJ*	obj,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT uvisenExpmUsrInit(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT uvisenExpmUsrStandby2Online(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT uvisenExpmUsrOnline2Standby(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT uvisenExpmUsrStandby2Loaded(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT uvisenExpmUsrSetMode(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltINT32	cmd,
    IN    vltLOGICAL	available,
    IN    vltLOGICAL	enabled,
    IN    vltLOGICAL	simulation,
    IN    vltLOGICAL	handset,
    IN    vltLOGICAL	locked,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT uvisenExpmUsrStatusCode(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    const char*	text,
    IN    vltINT32	flags,
    OUT   vltINT32*	code,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT uvisenExpmUsrStatusValue(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltINT32	code,
    OUT   lcctooVALUE*	value,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT uvisenExpmUsrStatusLast(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   vltINT16*	last,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT uvisenExpmHwInit(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    lccDEV_MODE	state,
    IN    vltLOGICAL	simulation,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT uvisenExpmHwExit(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    lccDEV_MODE	state,
    IN    vltLOGICAL	simulation,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT uvisenExpmHwSetup(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    const char*	function[],	/* max. vltBYTES32[999] */
    IN    vltINT16	functionNum,
    IN    vltLOGICAL	noMove,
    IN    vltLOGICAL	check,
    IN    vltLOGICAL	simulation,
    OUT   ccsERROR*	error);

void uvisenExpmHwMonitor(
    INOUT lcctooTASK*	task);


/*
 * virtual functions
 */
#define uvisenExpmVStandby(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_STANDBY)((obj)->fcts[uvisenEXPM_FCT_STANDBY]))) \
	 ((obj),(devName),(error))
#define uvisenExpmVOnline(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_ONLINE)((obj)->fcts[uvisenEXPM_FCT_ONLINE]))) \
	 ((obj),(devName),(error))
#define uvisenExpmVOff(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_OFF)((obj)->fcts[uvisenEXPM_FCT_OFF]))) \
	 ((obj),(devName),(error))
#define uvisenExpmVExit(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_EXIT)((obj)->fcts[uvisenEXPM_FCT_EXIT]))) \
	 ((obj),(devName),(error))
#define uvisenExpmVState(obj,devName,state,error) \
	(*((lccdevSTD_FCTPTR_STATE)((obj)->fcts[uvisenEXPM_FCT_STATE]))) \
	 ((obj),(devName),(state),(error))
#define uvisenExpmVSimulat(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_SIMULAT)((obj)->fcts[uvisenEXPM_FCT_SIMULAT]))) \
	 ((obj),(devName),(error))
#define uvisenExpmVStopSim(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_STOP_SIM)((obj)->fcts[uvisenEXPM_FCT_STOP_SIM]))) \
	 ((obj),(devName),(error))
#define uvisenExpmVStatus(obj,devName,function,functionNum,flag,header,conflog,opslog,condlog,status,error) \
	(*((ic0devSOFT_FCTPTR_STATUS)((obj)->fcts[uvisenEXPM_FCT_STATUS]))) \
	 ((obj),(devName),(function),(functionNum),(flag),(header),(conflog),(opslog),(condlog),(status),(error))
#define uvisenExpmVInit(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_INIT)((obj)->fcts[uvisenEXPM_FCT_INIT]))) \
	 ((obj),(devName),(error))
#define uvisenExpmVStop(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_STOP)((obj)->fcts[uvisenEXPM_FCT_STOP]))) \
	 ((obj),(devName),(error))
#define uvisenExpmVTest(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_TEST)((obj)->fcts[uvisenEXPM_FCT_TEST]))) \
	 ((obj),(devName),(error))
#define uvisenExpmVSelftst(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_SELFTST)((obj)->fcts[uvisenEXPM_FCT_SELFTST]))) \
	 ((obj),(devName),(error))
#define uvisenExpmVAutoTbl(obj,devName,table,text,error) \
	(*((lccdevSTD_FCTPTR_AUTO_TBL)((obj)->fcts[uvisenEXPM_FCT_AUTO_TBL]))) \
	 ((obj),(devName),(table),(text),(error))
#define uvisenExpmVAutoRst(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_AUTO_RST)((obj)->fcts[uvisenEXPM_FCT_AUTO_RST]))) \
	 ((obj),(devName),(error))
#define uvisenExpmVInitObj(obj,error) \
	(*((uvisenEXPM_FCTPTR_INIT_OBJ)((obj)->fcts[uvisenEXPM_FCT_INIT_OBJ]))) \
	 ((obj),(error))
#define uvisenExpmVExitObj(obj,error) \
	(*((uvisenEXPM_FCTPTR_EXIT_OBJ)((obj)->fcts[uvisenEXPM_FCT_EXIT_OBJ]))) \
	 ((obj),(error))
#define uvisenExpmVLoaded2Stby(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_LOADED2STBY)((obj)->fcts[uvisenEXPM_FCT_LOADED2STBY]))) \
	 ((obj),(devName),(error))
#define uvisenExpmVOnline2Stby(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_ONLINE2STBY)((obj)->fcts[uvisenEXPM_FCT_ONLINE2STBY]))) \
	 ((obj),(devName),(error))
#define uvisenExpmVExit1(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_EXIT1)((obj)->fcts[uvisenEXPM_FCT_EXIT1]))) \
	 ((obj),(devName),(error))
#define uvisenExpmVCheckDeviceName(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_CHECK_DEVICE_NAME)((obj)->fcts[uvisenEXPM_FCT_CHECK_DEVICE_NAME]))) \
	 ((obj),(devName),(error))
#define uvisenExpmVBreak(obj,error) \
	(*((lccdevSTD_FCTPTR_BREAK)((obj)->fcts[uvisenEXPM_FCT_BREAK]))) \
	 ((obj),(error))
#define uvisenExpmVUsrInit(obj,devName,error) \
	(*((uvisenEXPM_FCTPTR_USR_INIT)((obj)->fcts[uvisenEXPM_FCT_USR_INIT]))) \
	 ((obj),(devName),(error))
#define uvisenExpmVUsrLoaded2Standby(obj,devName,error) \
	(*((lccdevCMD_FCTPTR_USR_LOADED2STANDBY)((obj)->fcts[uvisenEXPM_FCT_USR_LOADED2STANDBY]))) \
	 ((obj),(devName),(error))
#define uvisenExpmVUsrStandby2Online(obj,devName,error) \
	(*((uvisenEXPM_FCTPTR_USR_STANDBY2ONLINE)((obj)->fcts[uvisenEXPM_FCT_USR_STANDBY2ONLINE]))) \
	 ((obj),(devName),(error))
#define uvisenExpmVUsrOnline2Standby(obj,devName,error) \
	(*((uvisenEXPM_FCTPTR_USR_ONLINE2STANDBY)((obj)->fcts[uvisenEXPM_FCT_USR_ONLINE2STANDBY]))) \
	 ((obj),(devName),(error))
#define uvisenExpmVUsrStandby2Loaded(obj,devName,error) \
	(*((uvisenEXPM_FCTPTR_USR_STANDBY2LOADED)((obj)->fcts[uvisenEXPM_FCT_USR_STANDBY2LOADED]))) \
	 ((obj),(devName),(error))
#define uvisenExpmVUsrStop(obj,devName,req,error) \
	(*((ic0devSOFT_FCTPTR_USR_STOP)((obj)->fcts[uvisenEXPM_FCT_USR_STOP]))) \
	 ((obj),(devName),(req),(error))
#define uvisenExpmVUsrSimulat(obj,devName,error) \
	(*((lccdevCMD_FCTPTR_USR_SIMULAT)((obj)->fcts[uvisenEXPM_FCT_USR_SIMULAT]))) \
	 ((obj),(devName),(error))
#define uvisenExpmVUsrStopSim(obj,devName,error) \
	(*((lccdevCMD_FCTPTR_USR_STOP_SIM)((obj)->fcts[uvisenEXPM_FCT_USR_STOP_SIM]))) \
	 ((obj),(devName),(error))
#define uvisenExpmVUsrStatusCode(obj,devName,text,flags,code,error) \
	(*((uvisenEXPM_FCTPTR_USR_STATUS_CODE)((obj)->fcts[uvisenEXPM_FCT_USR_STATUS_CODE]))) \
	 ((obj),(devName),(text),(flags),(code),(error))
#define uvisenExpmVUsrStatusLast(obj,devName,last,error) \
	(*((uvisenEXPM_FCTPTR_USR_STATUS_LAST)((obj)->fcts[uvisenEXPM_FCT_USR_STATUS_LAST]))) \
	 ((obj),(devName),(last),(error))
#define uvisenExpmVUsrStatusValue(obj,devName,code,value,error) \
	(*((uvisenEXPM_FCTPTR_USR_STATUS_VALUE)((obj)->fcts[uvisenEXPM_FCT_USR_STATUS_VALUE]))) \
	 ((obj),(devName),(code),(value),(error))
#define uvisenExpmVUsrTest(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_USR_TEST)((obj)->fcts[uvisenEXPM_FCT_USR_TEST]))) \
	 ((obj),(devName),(error))
#define uvisenExpmVUsrSelfTest(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_USR_SELF_TEST)((obj)->fcts[uvisenEXPM_FCT_USR_SELF_TEST]))) \
	 ((obj),(devName),(error))
#define uvisenExpmVUsrError(obj,devName,error) \
	(*((lccdevSTD_FCTPTR_USR_ERROR)((obj)->fcts[uvisenEXPM_FCT_USR_ERROR]))) \
	 ((obj),(devName),(error))
#define uvisenExpmVAvail(obj,devName,error) \
	(*((lccdevCMD_FCTPTR_AVAIL)((obj)->fcts[uvisenEXPM_FCT_AVAIL]))) \
	 ((obj),(devName),(error))
#define uvisenExpmVUnavail(obj,devName,error) \
	(*((lccdevCMD_FCTPTR_UNAVAIL)((obj)->fcts[uvisenEXPM_FCT_UNAVAIL]))) \
	 ((obj),(devName),(error))
#define uvisenExpmVDisable(obj,devName,access,error) \
	(*((lccdevCMD_FCTPTR_DISABLE)((obj)->fcts[uvisenEXPM_FCT_DISABLE]))) \
	 ((obj),(devName),(access),(error))
#define uvisenExpmVEnable(obj,devName,access,error) \
	(*((lccdevCMD_FCTPTR_ENABLE)((obj)->fcts[uvisenEXPM_FCT_ENABLE]))) \
	 ((obj),(devName),(access),(error))
#define uvisenExpmVLock(obj,devName,error) \
	(*((lccdevCMD_FCTPTR_LOCK)((obj)->fcts[uvisenEXPM_FCT_LOCK]))) \
	 ((obj),(devName),(error))
#define uvisenExpmVUnlock(obj,devName,error) \
	(*((lccdevCMD_FCTPTR_UNLOCK)((obj)->fcts[uvisenEXPM_FCT_UNLOCK]))) \
	 ((obj),(devName),(error))
#define uvisenExpmVHandset(obj,devName,error) \
	(*((lccdevCMD_FCTPTR_HANDSET)((obj)->fcts[uvisenEXPM_FCT_HANDSET]))) \
	 ((obj),(devName),(error))
#define uvisenExpmVHsetOff(obj,devName,error) \
	(*((lccdevCMD_FCTPTR_HSET_OFF)((obj)->fcts[uvisenEXPM_FCT_HSET_OFF]))) \
	 ((obj),(devName),(error))
#define uvisenExpmVFixPos(obj,devName,position,positionNum,reset,error) \
	(*((lccdevCMD_FCTPTR_FIX_POS)((obj)->fcts[uvisenEXPM_FCT_FIX_POS]))) \
	 ((obj),(devName),(position),(positionNum),(reset),(error))
#define uvisenExpmVMove(obj,devName,position,positionNum,error) \
	(*((ic0devSOFT_FCTPTR_MOVE)((obj)->fcts[uvisenEXPM_FCT_MOVE]))) \
	 ((obj),(devName),(position),(positionNum),(error))
#define uvisenExpmVMoveRel(obj,devName,position,positionNum,error) \
	(*((ic0devSOFT_FCTPTR_MOVE_REL)((obj)->fcts[uvisenEXPM_FCT_MOVE_REL]))) \
	 ((obj),(devName),(position),(positionNum),(error))
#define uvisenExpmVSet(obj,devName,position,positionNum,error) \
	(*((ic0devSOFT_FCTPTR_SET)((obj)->fcts[uvisenEXPM_FCT_SET]))) \
	 ((obj),(devName),(position),(positionNum),(error))
#define uvisenExpmVCheck(obj,devName,status,error) \
	(*((lccdevCMD_FCTPTR_CHECK)((obj)->fcts[uvisenEXPM_FCT_CHECK]))) \
	 ((obj),(devName),(status),(error))
#define uvisenExpmVWait(obj,devName,timeout,error) \
	(*((lccdevCMD_FCTPTR_WAIT)((obj)->fcts[uvisenEXPM_FCT_WAIT]))) \
	 ((obj),(devName),(timeout),(error))
#define uvisenExpmVUsrSetMode(obj,devName,cmd,available,enabled,simulation,handset,locked,error) \
	(*((uvisenEXPM_FCTPTR_USR_SET_MODE)((obj)->fcts[uvisenEXPM_FCT_USR_SET_MODE]))) \
	 ((obj),(devName),(cmd),(available),(enabled),(simulation),(handset),(locked),(error))
#define uvisenExpmVSetup(obj,devName,function,functionNum,noMove,check,error) \
	(*((uvisenEXPM_FCTPTR_SETUP)((obj)->fcts[uvisenEXPM_FCT_SETUP]))) \
	 ((obj),(devName),(function),(functionNum),(noMove),(check),(error))
#define uvisenExpmVGetVal(obj,devName,name,nameNum,status,error) \
	(*((ic0devSOFT_FCTPTR_GET_VAL)((obj)->fcts[uvisenEXPM_FCT_GET_VAL]))) \
	 ((obj),(devName),(name),(nameNum),(status),(error))
#define uvisenExpmVSetVal(obj,devName,name,nameNum,value,valueNum,error) \
	(*((ic0devSOFT_FCTPTR_SET_VAL)((obj)->fcts[uvisenEXPM_FCT_SET_VAL]))) \
	 ((obj),(devName),(name),(nameNum),(value),(valueNum),(error))
#define uvisenExpmVCfgElem(obj,devName,position,id,values,valuesNum,error) \
	(*((ic0devSOFT_FCTPTR_CFG_ELEM)((obj)->fcts[uvisenEXPM_FCT_CFG_ELEM]))) \
	 ((obj),(devName),(position),(id),(values),(valuesNum),(error))
#define uvisenExpmVLogConf(obj,devName,allElements,error) \
	(*((ic0devSOFT_FCTPTR_LOG_CONF)((obj)->fcts[uvisenEXPM_FCT_LOG_CONF]))) \
	 ((obj),(devName),(allElements),(error))
#define uvisenExpmVGetConf(obj,devName,allElements,text,error) \
	(*((ic0devSOFT_FCTPTR_GET_CONF)((obj)->fcts[uvisenEXPM_FCT_GET_CONF]))) \
	 ((obj),(devName),(allElements),(text),(error))
#define uvisenExpmVResetParameters(obj,devName,cmd,error) \
	(*((ic0devSOFT_FCTPTR_RESET_PARAMETERS)((obj)->fcts[uvisenEXPM_FCT_RESET_PARAMETERS]))) \
	 ((obj),(devName),(cmd),(error))
#define uvisenExpmVParseParameters(obj,devName,cmd,params,paramsNum,noMove,check,error) \
	(*((ic0devSOFT_FCTPTR_PARSE_PARAMETERS)((obj)->fcts[uvisenEXPM_FCT_PARSE_PARAMETERS]))) \
	 ((obj),(devName),(cmd),(params),(paramsNum),(noMove),(check),(error))
#define uvisenExpmVCompareParameters(obj,devName,cmd,equal,error) \
	(*((ic0devSOFT_FCTPTR_COMPARE_PARAMETERS)((obj)->fcts[uvisenEXPM_FCT_COMPARE_PARAMETERS]))) \
	 ((obj),(devName),(cmd),(equal),(error))
#define uvisenExpmVCopyParameters(obj,devName,error) \
	(*((ic0devSOFT_FCTPTR_COPY_PARAMETERS)((obj)->fcts[uvisenEXPM_FCT_COPY_PARAMETERS]))) \
	 ((obj),(devName),(error))
#define uvisenExpmVExecParameters(obj,devName,error) \
	(*((ic0devSOFT_FCTPTR_EXEC_PARAMETERS)((obj)->fcts[uvisenEXPM_FCT_EXEC_PARAMETERS]))) \
	 ((obj),(devName),(error))
#define uvisenExpmVUpdateParameters(obj,devName,cache,error) \
	(*((ic0devSOFT_FCTPTR_UPDATE_PARAMETERS)((obj)->fcts[uvisenEXPM_FCT_UPDATE_PARAMETERS]))) \
	 ((obj),(devName),(cache),(error))
#define uvisenExpmVGetParamSetValue(obj,devName,index,value,setCode,error) \
	(*((ic0devSOFT_FCTPTR_GET_PARAM_SET_VALUE)((obj)->fcts[uvisenEXPM_FCT_GET_PARAM_SET_VALUE]))) \
	 ((obj),(devName),(index),(value),(setCode),(error))
#define uvisenExpmVGetParamStatus(obj,devName,index,flags,status,error) \
	(*((ic0devSOFT_FCTPTR_GET_PARAM_STATUS)((obj)->fcts[uvisenEXPM_FCT_GET_PARAM_STATUS]))) \
	 ((obj),(devName),(index),(flags),(status),(error))
#define uvisenExpmVSetParam(obj,devName,index,cmd,value,step,error) \
	(*((ic0devSOFT_FCTPTR_SET_PARAM)((obj)->fcts[uvisenEXPM_FCT_SET_PARAM]))) \
	 ((obj),(devName),(index),(cmd),(value),(step),(error))
#define uvisenExpmVSetParamStep(obj,devName,index,cmd,step,error) \
	(*((ic0devSOFT_FCTPTR_SET_PARAM_STEP)((obj)->fcts[uvisenEXPM_FCT_SET_PARAM_STEP]))) \
	 ((obj),(devName),(index),(cmd),(step),(error))
#define uvisenExpmVUsrExecAction(obj,devName,index,error) \
	(*((ic0devSOFT_FCTPTR_USR_EXEC_ACTION)((obj)->fcts[uvisenEXPM_FCT_USR_EXEC_ACTION]))) \
	 ((obj),(devName),(index),(error))
#define uvisenExpmVUsrSetParameter(obj,devName,cmd,param1,param1SetCode,param2,param2SetCode,value,error) \
	(*((ic0devSOFT_FCTPTR_USR_SET_PARAMETER)((obj)->fcts[uvisenEXPM_FCT_USR_SET_PARAMETER]))) \
	 ((obj),(devName),(cmd),(param1),(param1SetCode),(param2),(param2SetCode),(value),(error))
#define uvisenExpmVGetValueCode(obj,devName,name,code,error) \
	(*((ic0devSOFT_FCTPTR_GET_VALUE_CODE)((obj)->fcts[uvisenEXPM_FCT_GET_VALUE_CODE]))) \
	 ((obj),(devName),(name),(code),(error))
#define uvisenExpmVGetValue(obj,devName,code,index,value,valueNum,error) \
	(*((ic0devSOFT_FCTPTR_GET_VALUE)((obj)->fcts[uvisenEXPM_FCT_GET_VALUE]))) \
	 ((obj),(devName),(code),(index),(value),(valueNum),(error))
#define uvisenExpmVUsrGetValue(obj,devName,valuesTable,valuesTableNum,code,index,value,valueNum,done,error) \
	(*((ic0devSOFT_FCTPTR_USR_GET_VALUE)((obj)->fcts[uvisenEXPM_FCT_USR_GET_VALUE]))) \
	 ((obj),(devName),(valuesTable),(valuesTableNum),(code),(index),(value),(valueNum),(done),(error))
#define uvisenExpmVSetValue(obj,devName,code,index,value,valueNum,error) \
	(*((ic0devSOFT_FCTPTR_SET_VALUE)((obj)->fcts[uvisenEXPM_FCT_SET_VALUE]))) \
	 ((obj),(devName),(code),(index),(value),(valueNum),(error))
#define uvisenExpmVUsrSetValue(obj,devName,valuesTable,valuesTableNum,code,index,value,valueNum,done,error) \
	(*((ic0devSOFT_FCTPTR_USR_SET_VALUE)((obj)->fcts[uvisenEXPM_FCT_USR_SET_VALUE]))) \
	 ((obj),(devName),(valuesTable),(valuesTableNum),(code),(index),(value),(valueNum),(done),(error))
#define uvisenExpmVGetArg(obj,devName,code,index,value,error) \
	(*((ic0devSOFT_FCTPTR_GET_ARG)((obj)->fcts[uvisenEXPM_FCT_GET_ARG]))) \
	 ((obj),(devName),(code),(index),(value),(error))
#define uvisenExpmVMonitor(obj,devName,error) \
	(*((ic0devSOFT_FCTPTR_MONITOR)((obj)->fcts[uvisenEXPM_FCT_MONITOR]))) \
	 ((obj),(devName),(error))
#define uvisenExpmVUsrMonitor(obj,devName,state,error) \
	(*((ic0devSOFT_FCTPTR_USR_MONITOR)((obj)->fcts[uvisenEXPM_FCT_USR_MONITOR]))) \
	 ((obj),(devName),(state),(error))
#define uvisenExpmVLogAction(obj,devName,action,comment,error) \
	(*((ic0devSOFT_FCTPTR_LOG_ACTION)((obj)->fcts[uvisenEXPM_FCT_LOG_ACTION]))) \
	 ((obj),(devName),(action),(comment),(error))
#define uvisenExpmVLogComment(obj,devName,comment,error) \
	(*((ic0devSOFT_FCTPTR_LOG_COMMENT)((obj)->fcts[uvisenEXPM_FCT_LOG_COMMENT]))) \
	 ((obj),(devName),(comment),(error))
#define uvisenExpmVLogParameter(obj,devName,parameter,index,value,comment,error) \
	(*((ic0devSOFT_FCTPTR_LOG_PARAMETER)((obj)->fcts[uvisenEXPM_FCT_LOG_PARAMETER]))) \
	 ((obj),(devName),(parameter),(index),(value),(comment),(error))
#define uvisenExpmVLogRecovery(obj,devName,comment,error) \
	(*((ic0devSOFT_FCTPTR_LOG_RECOVERY)((obj)->fcts[uvisenEXPM_FCT_LOG_RECOVERY]))) \
	 ((obj),(devName),(comment),(error))
#define uvisenExpmVLogTblParam(obj,devName,paramIndex,flags,comment,error) \
	(*((ic0devSOFT_FCTPTR_LOG_TBL_PARAM)((obj)->fcts[uvisenEXPM_FCT_LOG_TBL_PARAM]))) \
	 ((obj),(devName),(paramIndex),(flags),(comment),(error))
#define uvisenExpmVLogUnforseen(obj,devName,comment,error) \
	(*((ic0devSOFT_FCTPTR_LOG_UNFORSEEN)((obj)->fcts[uvisenEXPM_FCT_LOG_UNFORSEEN]))) \
	 ((obj),(devName),(comment),(error))
#define uvisenExpmVHwInit(obj,devName,state,simulation,error) \
	(*((uvisenEXPM_FCTPTR_HW_INIT)((obj)->fcts[uvisenEXPM_FCT_HW_INIT]))) \
	 ((obj),(devName),(state),(simulation),(error))
#define uvisenExpmVHwExit(obj,devName,state,simulation,error) \
	(*((uvisenEXPM_FCTPTR_HW_EXIT)((obj)->fcts[uvisenEXPM_FCT_HW_EXIT]))) \
	 ((obj),(devName),(state),(simulation),(error))
#define uvisenExpmVHwSetup(obj,devName,function,functionNum,noMove,check,simulation,error) \
	(*((uvisenEXPM_FCTPTR_HW_SETUP)((obj)->fcts[uvisenEXPM_FCT_HW_SETUP]))) \
	 ((obj),(devName),(function),(functionNum),(noMove),(check),(simulation),(error))


ccsCOMPL_STAT uvisenExpmNewObj(
    IN    dbSYMADDRESS	point,
    IN    egenOBJ*	owner,
    OUT   egenOBJ*	obj,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT uvisenExpmDeleteObj(
    INOUT egenOBJ*	obj,
    OUT   ccsERROR*	error);


ccsCOMPL_STAT uvisenExpmComOpen(
    INOUT egenOBJ*	     obj,
    IN    const char*	     devName,
    OUT   ccsERROR*	     error);

ccsCOMPL_STAT uvisenExpmComClose(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT uvisenExpmComStart(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT uvisenExpmComRead(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    OUT   char*		data,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT uvisenExpmComConfig(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN    vltDOUBLE	uit,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT uvisenExpmCtInit(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN	  vltDOUBLE*	ctValues,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT uvisenExpmCtStart(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN	  vltDOUBLE*	ctValues,
    IN	  vltDOUBLE	uit,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT uvisenExpmCtWrite(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN	  vltDOUBLE*	ctValues,
    IN    vltINT32	rep,
    IN	  vltDOUBLE	ctlast,
    OUT   ccsERROR*	error);

ccsCOMPL_STAT uvisenExpmCtUpdate(
    INOUT egenOBJ*	obj,
    IN    const char*	devName,
    IN	  vltDOUBLE*	ctValues,
    OUT   ccsERROR*	error);


#endif // !UVISEN_EXPM_H

/************************************************************************/
/* ___oOo___ */
