/******************************************************************************
*
* E.S.O. - VLT project
*
* "@(#) $Id: vme4sa.h,v 2.4 2005/06/21 14:57:41 vltsccm Exp $" 
*
* who       when      what
* --------  --------  ----------------------------------------------
* CAM GmbH  --/05/94  Created  for Release 1.1
* P.Duhoux  --/07/94  Modified for Release 1.2
* P.Duhoux  09/09/94  Renamed vme4saVERSION_NUMBER to vme4saVERSION
*                     and changed its definition
* P.Duhoux  21/12/94  motInternal.h now includes motDatabase.h
* P.Duhoux  09/06/95  Modified for CMM Archive
* P.Duhoux  13/09/95  Added include motPublic.h (not anymore in sdlPublic.h)
* P.Duhoux  29/11/95  Added function vme4saDeinstall
* P.Duhoux  25/03/96  Modified interface of vme4saConnectIsr
*                     - Changed parameter order                     
* P.Duhoux  11/11/96  Modified interface to vme4saMove/LowLim/UpLim for
*                     MCON compatibility
*/

#ifndef VME4SA_H
#define VME4SA_H

/******************************************************************************
 * vme4sa.h - Servo Amplifier single device library interface file
 *---------------------------------------------------------------------------*/

#ifdef __cplusplus
extern "C" {
#endif
 
/* MCM Common Public include file */
#include "motPublic.h"

/* SDL Common Public include file */
#include "sdlPublic.h"

/* VME4SA include files */
#include "vme4saDefines.h"
#include "vme4saErrors.h"

/* servo amplifier module name */
#define vme4saMODULE         "vme4sa"
#define vme4saMODULE_NAME    "Servo Amplifier SDL"

/* servo amplifier module version */
#define vme4saVERSION        "$Revision: 2.4 $"
#define vme4saVERSION_DATE   "OCT99"

/*
 * function prototypes
 */
ccsCOMPL_STAT vme4saInstall     (motDESCRIPTION *motDesc, ccsERROR *error);
ccsCOMPL_STAT vme4saDeinstall   (motDESCRIPTION *motDesc, ccsERROR *error);

ccsCOMPL_STAT vme4saCheckError  (motDESCRIPTION *motDesc, vltBYTES256 errMsg, 
				 ccsERROR *error);
ccsCOMPL_STAT vme4saConnectIsr  (motDESCRIPTION *motDesc, vltINT32 type, 
				 vltBYTES32 function, vltINT32 argument, 
				 ccsERROR *error);
ccsCOMPL_STAT vme4saConnect     (motDESCRIPTION *motDesc, motCONNECTION relay, 
				 ccsERROR *error);
ccsCOMPL_STAT vme4saDisconnect  (motDESCRIPTION *motDesc, motCONNECTION relay, 
				 ccsERROR *error);
ccsCOMPL_STAT vme4saGetStatus   (motDESCRIPTION *motDesc, motSTATUS *motStatus,
				 ccsERROR *error);
ccsCOMPL_STAT vme4saInitHw      (motDESCRIPTION *motDesc, vltINT32 initCode,
				 vltINT32 velocity, ccsERROR *error);
ccsCOMPL_STAT vme4saInitSw      (motDESCRIPTION *motDesc, ccsERROR *error);
ccsCOMPL_STAT vme4saLoadPar     (motDESCRIPTION *motDesc, motPARAMETER *parBuf,
				 vltUINT32 *number, vltLOGICAL all, 
				 ccsERROR *error);
ccsCOMPL_STAT vme4saRetrievePar (motDESCRIPTION *motDesc, motPARAMETER *parBuf,
				 vltUINT32 *number, vltLOGICAL all, 
				 ccsERROR *error);
ccsCOMPL_STAT vme4saMove        (motDESCRIPTION *motDesc, vltDOUBLE velRef,
				 ccsERROR *error);
ccsCOMPL_STAT vme4saMoveUpLim   (motDESCRIPTION *motDesc, vltDOUBLE velRef,
				 ccsERROR *error);
ccsCOMPL_STAT vme4saMoveLowLim  (motDESCRIPTION *motDesc, vltDOUBLE velRef,
				 ccsERROR *error);
ccsCOMPL_STAT vme4saResetAxis   (motDESCRIPTION *motDesc, ccsERROR *error);
ccsCOMPL_STAT vme4saResetBoard  (motDESCRIPTION *motDesc, ccsERROR *error);
ccsCOMPL_STAT vme4saSetMode     (motDESCRIPTION *motDesc, motMOTIONMODE mode, 
				 ccsERROR *error);
ccsCOMPL_STAT vme4saSetOpMode   (motDESCRIPTION *motDesc, motOPMODE mode,
				 ccsERROR *error);
ccsCOMPL_STAT vme4saSetTimeout  (motDESCRIPTION *motDesc, vltUINT32 timeout, 
				 ccsERROR *error);
ccsCOMPL_STAT vme4saStop        (motDESCRIPTION *motDesc, ccsERROR *error);

void          vme4saVersion     (vltBYTES80 version);

#ifdef __cplusplus
}
#endif

#endif /* !VME4SA_H */

/*****************************************************************************/

/*___oOo___*/
