#ifndef LSFTPL_PRIVATE_H
#define LSFTPL_PRIVATE_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: lsftplPrivate.h,v 1.15 2003/09/10 12:41:48 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* rkarban  29/07/97  created
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */
/*
 * System includes
 */
#include "vxWorks.h"

#include "stdio.h"
#include "string.h"
#include "types.h"
#include "time.h"
#include "math.h"

#include "sysLib.h"
#include "tickLib.h"
#include "msgQLib.h"
#include "memLib.h"
#include "lstLib.h"
#include "semLib.h"
#include "wdLib.h"
#include "taskLib.h"
#include "rebootLib.h"
#include "usrLib.h"
#include "errnoLib.h"
#include "taskVarLib.h"
#include "vxLib.h"

/*
 * Required LCC Interface
 */
#include "CCS.h"
#include "cai.h"

#include "too.h"
#include "tooErrors.h"

/*
 * Required LSF Interface
 */
#include "lsfServer.h"
#include "lsfControl.h"

/*
 * Local headers
 */
#include "lsftpl.h"

/*
 * Globals
 */
extern lsfSERVER_DATA *lsftplGlobalData;
extern int lsftplPrintEnable;

/*
 * Constants
 */
#define lccMODULE_ID lsftplMODULE_ID

/*
 * Error handling macros
 */
#define lsftplERR_ADD(errNum,params...) \
    {                                                               \
    lcuDebug("ERROR_ADD %s(Line: %d)",__FILE__,__LINE__);           \
    errAdd(error,lsftplMODULE_ID,errNum,__FILE_LINE__,"",##params); \
    }                                                             

#define lsftplERR_RETURN(errNum,params...) \
    {                                                               \
    lcuDebug("ERROR_RETURN %s(Line: %d)",__FILE__,__LINE__);        \
    errAdd(error,lsftplMODULE_ID,errNum,__FILE_LINE__,"",##params); \
    return FAILURE;                                                 \
    }                                                             

/*
 * Debugging macros
 */
extern int lsftplPrintEnable;
#define lsftplPrintf \
    if (lsftplPrintEnable) printf

#endif /*!LSFTPL_PRIVATE_H*/
