/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: lsftplMiscDev.c,v 1.15 2003/09/10 12:41:55 vltsccm Exp $"
*
* who       when        what
* --------  ----------  ----------------------------------------------
* pduhoux   2000-04-05  created
*/

/************************************************************************
*   NAME
*     lsftplMiscDev - Handling of miscellaneous devices
*
*   SYNOPSIS
*     #include "lsftplMiscDev.h"
*   DESCRIPTION
*     This module .... 
*   METHODS
*   PUBLIC
*     
*   DATABASE
*     lsftpl:control:miscdev
*   FILES
*
*   ENVIRONMENT
*
*   COMMANDS
*
*   RETURN VALUES
*
*   CAUTIONS 
*
*   EXAMPLES
*
*   SEE ALSO
*
*   BUGS   
* 
*------------------------------------------------------------------------
*/

#define _POSIX_SOURCE 1
#include "vltPort.h"

static char *rcsId="@(#) $Id: lsftplMiscDev.c,v 1.15 2003/09/10 12:41:55 vltsccm Exp $"; 
static void *use_rcsId = ((void)&use_rcsId,(void *) &rcsId);

#include "lsftplPrivate.h"
#include "lsftplMiscDev.h"

ccsCOMPL_STAT lsftplMiscDevCommand ( IN  const char *devName, 
				     OUT ccsERROR   *error )
{
    lsfMISCDEV_DATA *miscDevData = lsfMiscDevGetData(lsftplGlobalData);

    lsftplPrintf("lsftplMiscDevCommand(%s)\n",devName);
    if (lsfServerGetState(lsftplGlobalData) != lsfSTATE_ONLINE)
	{
        lsftplERR_ADD(lsftplERR_STATE,error,lcuStateString[lsfSTATE_ONLINE]);
	return FAILURE;
	}

    printf("lsftplMiscDevCommand: miscDevData->state=%d\n",miscDevData->state);

    return SUCCESS;
}

/*___oOo___*/
