/************************************************************************
* E.S.O. - VLT project
#
# "@(#) $Id: lsftplMotorInterface.c,v 1.15 2003/09/10 12:41:51 vltsccm Exp $" 
*
* who       when        what
* --------  ----------  ----------------------------------------------
* pduhoux   2000-07-18  created
*------------------------------------------------------------------------
*/

#define _POSIX_SOURCE 1
#include "vltPort.h"

static char *rcsId = "@(#) $Id: lsftplMotorInterface.c,v 1.15 2003/09/10 12:41:51 vltsccm Exp $";
static void *use_rcsId = ((void)&use_rcsId,(void *) &rcsId);

#include "lsftplPrivate.h"
#include "lsftplMotor.h"
#include "lsftplMotorInterface.h"

lsfACI_FUNCTION(lsftpl,MotorMoveAbs)
{
    char          *parPtr = (char *)parameters;
    vltBYTES20     motor;
    vltINT32       n,m;
    vltDOUBLE      target[lsfNUM_MOTOR];
    char          *names[lsfNUM_MOTOR+1];
    vltDOUBLE      pos[lsfNUM_MOTOR];
    char          *units[lsfNUM_MOTOR];
    ccsCOMPL_STAT  status;

    lsfTASK_REGISTER(lsftplMODULE_ID,"MOVE");

    lsfVERBOSE_CMD_DONE("MOVEA");
    
    n = (int)*(parPtr+1);
    if (n > lsfNUM_MOTOR) n = lsfNUM_MOTOR;
    parPtr += 2;
    strncpy (motor,parPtr,sizeof(vltBYTES20)); 
    parPtr += strlen(motor)+1;
    memcpy(target,parPtr,n*sizeof(vltINT32)); 

    if (strcmp(motor,lsfALL_DEVICES) == 0)
	{
	if (n < lsfNUM_MOTOR)
	    {
	    for (m=n;m<lsfNUM_MOTOR;m++)
		target[m] = target[n-1];
	    }
	}

    status = lsftplMotorMoveAbs(motor,target,NULL,ccsFALSE,error);
    if (status == SUCCESS)
	{
	ccsERROR   errorReply;
	errResetStack(&errorReply);
	strcpy((char *)&msg->body,"OK");
	if (msgReplyWithId(&msg->msgHeader.dest,&msg->msgHeader.source,
			   msg->msgHeader.msgId,msg->type.command.command,
			   msg->body,strlen(msg->body)+1,ccsFALSE,&errorReply,
			   error) == FAILURE)
	    {
	    errCloseStack(&errorReply);
	    status = FAILURE;
	    goto exit;
	    }
	}
    else goto exit;

    status = lsftplMotorWaitMove(motor,names,pos,units,error);
    if (status == SUCCESS)
	{
	ccsERROR   errorReply;
	errResetStack(&errorReply);

	for (m=0;m<lsfNUM_MOTOR;m++)
	    {
	    sprintf ((char *)&msg->body,"%s: %f %s",names[m],pos[m],units[m]);
	    if (names[m+1] == NULL) break;

	    if (msgReplyWithId(&msg->msgHeader.dest,&msg->msgHeader.source,
			       msg->msgHeader.msgId,msg->type.command.command,
			       msg->body,strlen(msg->body)+1,ccsFALSE,
			       &errorReply,error) == FAILURE)
		{
		errCloseStack(&errorReply);
		return FAILURE;
		}
	    }
	*replyBuffer = (char *)&msg->body;
	*replyBufferSize = strlen(msg->body) + 1;
	}

exit:
    lsfVERBOSE_CMD_DONE("MOVEA");
    
    return status;
}

