/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: lsftplSerial.c,v 1.15 2003/09/10 12:41:52 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* rkarban  14/09/99  created
*/

/************************************************************************
*   NAME
*     lsftplSerial - Handling of Serial devices
*
*   SYNOPSIS
*     #include "lsftplSerial.h"
*   DESCRIPTION
*     This module gives a very primitive template of LCC serial usage
*   METHODS
*   PUBLIC
*     ccsCOMPL_STAT lsftplSerialConfigIo(ccsERROR *error)
*       Configures one analog ad one digital example serial
*     ccsCOMPL_STAT lsftplSerialReadDigital (vltUINT32 *value, ccsERROR *error)
*       Reads the configured analog serial
*     ccsCOMPL_STAT lsftplSerialWriteDigital (vltUINT32 value, ccsERROR *error)
*       Writes the configured digital serial
*     ccsCOMPL_STAT lsftplSerialReadAnalog (vltFLOAT *value, ccsERROR *error)
*       Reads the configured analog serial
*     ccsCOMPL_STAT lsftplSerialWriteAnalog (vltFLOAT value, ccsERROR *error)
*       Writes the configured analog serial
*   DATABASE
*     lsftpl:control:serial
*   FILES
*
*   ENVIRONMENT
*
*   COMMANDS
*
*   RETURN VALUES
*
*   CAUTIONS 
*
*   EXAMPLES
*
*   SEE ALSO
*
*   BUGS   
* 
*------------------------------------------------------------------------
*/

#define _POSIX_SOURCE 1
#include "vltPort.h"

static char *rcsId="@(#) $Id: lsftplSerial.c,v 1.15 2003/09/10 12:41:52 vltsccm Exp $"; 
static void *use_rcsId = ((void)&use_rcsId,(void *) &rcsId);

#include "lsftplPrivate.h"
#include "lsftplSerial.h"

ccsCOMPL_STAT lsftplSerialRead (IN  const char *serialName,
			       OUT char       *names[], 
			       OUT char       *buffer[],
			       OUT ccsERROR   *error )
{
    lsfSERIAL_DATA *serialData = lsfSerialGetData(lsftplGlobalData);

    lsftplPrintf("lsftplSerialRead(serialName=%s,...)\n",serialName);
    return lsfSerialRead(serialData,serialName,names,buffer,error);
}

ccsCOMPL_STAT lsftplSerialWrite ( IN  const char *serialName,
				 IN  char       *buffer[],
				 OUT ccsERROR   *error )
{
    lsfSERIAL_DATA *serialData = lsfSerialGetData(lsftplGlobalData);

    lsftplPrintf("lsftplSerialWrite(serialName=%s,...)\n",serialName);
    return lsfSerialWrite(serialData,serialName,buffer,error);
}

/*___oOo___*/
