/************************************************************************
* E.S.O. - VLT project
#
# "@(#) $Id: lsftplSerialInterface.c,v 1.15 2003/09/10 12:41:53 vltsccm Exp $" 
*
* who       when        what
* --------  ----------  ----------------------------------------------
* pduhoux   2000-07-18  created
*------------------------------------------------------------------------
*/
#define _POSIX_SOURCE 1
#include "vltPort.h"

static char *rcsId="@(#) $Id: lsftplSerialInterface.c,v 1.15 2003/09/10 12:41:53 vltsccm Exp $";
static void *use_rcsId = ((void)&use_rcsId,(void *) &rcsId);

#include "lsftplPrivate.h"
#include "lsftplSerial.h"
#include "lsftplSerialInterface.h"

typedef char   vltBYTES1024[1024];
typedef char   vltBYTES512[512];

lsfACI_FUNCTION(lsftpl,SerialRead)
{
    int            s;
    vltBYTES512    buf512[lsfNUM_SERIAL];
    char          *buffer[lsfNUM_SERIAL];
    char          *names[lsfNUM_SERIAL+1];
    ccsCOMPL_STAT  status;

    lsfTASK_REGISTER(lsftplMODULE_ID,"READ");

    lsfVERBOSE_CMD_RECV("RSCOM");
    
    for (s=0;s<lsfNUM_SERIAL;s++) buffer[s]=buf512[s];
    status = lsftplSerialRead(parameters,names,(char **)buffer,error);
    if (status == SUCCESS)
	{
	ccsERROR   errorReply;
	errResetStack(&errorReply);

	for (s=0;s<lsfNUM_SERIAL;s++)
	    {
	    sprintf ((char *)&msg->body,"%s: %s",names[s],buffer[s]);
	    if (names[s+1] == NULL) break;

	    if (msgReplyWithId(&msg->msgHeader.dest,&msg->msgHeader.source,
			       msg->msgHeader.msgId,msg->type.command.command,
			       msg->body,strlen(msg->body)+1,ccsFALSE,
			       &errorReply,error) == FAILURE)
		{
		errCloseStack(&errorReply);
		return FAILURE;
		}
	    }
	*replyBuffer = (char *)&msg->body;
	*replyBufferSize = strlen(msg->body) + 1;
	}

    lsfVERBOSE_CMD_DONE("RSCOM");
    
    return status;
}

lsfACI_FUNCTION(lsftpl,SerialWrite)
{
    char          *parPtr = (char *)parameters;
    vltBYTES20     serial;
    vltINT32       n,i;
    char          *buffer[lsfNUM_SERIAL];
    ccsCOMPL_STAT  status;

    lsfVERBOSE_CMD_RECV("WSCOM");

    n = (int)*(parPtr+1);
    if (n > lsfNUM_SERIAL) n = lsfNUM_SERIAL;
    parPtr += 2;
    strncpy(serial,parPtr,sizeof(vltBYTES20)); 
    parPtr += strlen(serial)+1;

    for (i=0;i<n;i++) 
	{
	buffer[i] = parPtr;
	parPtr += strlen(parPtr)+1;
	}
    if (strcmp(serial,lsfALL_DEVICES) == 0)
	{
	if (n < lsfNUM_SERIAL)
	    {
	    for (i=n;i<lsfNUM_SERIAL;i++)
		buffer[i] = buffer[n-1];
	    }
	}

    status = lsftplSerialWrite(serial,buffer,error);
    if (status == SUCCESS)
	{
	strcpy ((char *)&msg->body, "OK");
	*replyBuffer = (char *)&msg->body;
	*replyBufferSize = strlen(msg->body) + 1;	
	}

    lsfVERBOSE_CMD_DONE("WSCOM");
        
    return status;
}

