/************************************************************************
* E.S.O. - VLT project
#
# "@(#) $Id: lsftplSignalInterface.c,v 1.15 2003/09/10 12:41:52 vltsccm Exp $" 
*
* who       when        what
* --------  ----------  ----------------------------------------------
* pduhoux   2000-07-18  created
*------------------------------------------------------------------------
*/
#define _POSIX_SOURCE 1
#include "vltPort.h"

static char *rcsId="@(#) $Id: lsftplSignalInterface.c,v 1.15 2003/09/10 12:41:52 vltsccm Exp $";
static void *use_rcsId = ((void)&use_rcsId,(void *) &rcsId);

#include "lsftplPrivate.h"
#include "lsftplSignal.h"
#include "lsftplSignalInterface.h"


lsfACI_FUNCTION(lsftpl,SignalReadAnalog)
{
    int            i;
    vltFLOAT       value[lsfNUM_SIGNAL];
    char          *names[lsfNUM_SIGNAL+1];
    ccsCOMPL_STAT  status;

    lsfVERBOSE_CMD_RECV("RASIG");
    
    status = lsftplSignalReadAnalog(parameters,names,value,error);
    if (status == SUCCESS)
	{
	ccsERROR   errorReply;
	errResetStack(&errorReply);

	for (i=0;i<lsfNUM_SIGNAL;i++)
	    {
	    sprintf ((char *)&msg->body,"%s: %f",names[i],value[i]);
	    if (names[i+1] == NULL) break;

	    if (msgReplyWithId(&msg->msgHeader.dest,&msg->msgHeader.source,
			       msg->msgHeader.msgId,msg->type.command.command,
			       msg->body,strlen(msg->body)+1,ccsFALSE,
			       &errorReply,error) == FAILURE)
		{
		errCloseStack(&errorReply);
		return FAILURE;
		}
	    }
	*replyBuffer = (char *)&msg->body;
	*replyBufferSize = strlen(msg->body) + 1;	
	}

    lsfVERBOSE_CMD_DONE("RASIG");
    
    return status;
}

lsfACI_FUNCTION(lsftpl,SignalWriteAnalog)
{
    char          *parPtr = (char *)parameters;
    vltBYTES20     signal;
    vltINT32       n,i;
    vltFLOAT       value[lsfNUM_SIGNAL];
    vltDOUBLE      dblValue[lsfNUM_SIGNAL];
    ccsCOMPL_STAT  status;

    lsfVERBOSE_CMD_RECV("WASIG");

    n = (int)*(parPtr+1);
    if (n > lsfNUM_SIGNAL) n = lsfNUM_SIGNAL;
    parPtr += 2;
    strncpy (signal,parPtr,sizeof(vltBYTES20)); 
    parPtr += strlen(signal)+1;
    memcpy(dblValue,parPtr,n*sizeof(vltDOUBLE)); 
    for (i=0;i<n;i++) value[i] = (vltFLOAT)dblValue[i];

    if (strcmp(signal,lsfALL_DEVICES) == 0)
	{
	if (n < lsfNUM_SIGNAL)
	    {
	    for (i=n;i<lsfNUM_SIGNAL;i++)
		value[i] = value[n-1];
	    }
	}

    status = lsftplSignalWriteAnalog(signal,value,error);
    if (status == SUCCESS)
	{
	strcpy ((char *)&msg->body, "OK");
	*replyBuffer = (char *)&msg->body;
	*replyBufferSize = strlen(msg->body) + 1;	
	}

    lsfVERBOSE_CMD_DONE("WASIG");
        
    return status;
}

lsfACI_FUNCTION(lsftpl,SignalReadDigital)
{
    int            i;
    vltUINT32      value[lsfNUM_SIGNAL];
    char          *names[lsfNUM_SIGNAL+1];
    ccsCOMPL_STAT  status;

    lsfVERBOSE_CMD_RECV("RDSIG");
    
    status = lsftplSignalReadDigital(parameters,names,value,error);
    if (status == SUCCESS)
	{
	ccsERROR   errorReply;
	errResetStack(&errorReply);

	for (i=0;i<lsfNUM_SIGNAL;i++)
	    {
	    sprintf ((char *)&msg->body,"%s: %X",names[i],value[i]);
	    if (names[i+1] == NULL) break;

	    if (msgReplyWithId(&msg->msgHeader.dest,&msg->msgHeader.source,
			       msg->msgHeader.msgId,msg->type.command.command,
			       msg->body,strlen(msg->body)+1,ccsFALSE,
			       &errorReply,error) == FAILURE)
		{
		errCloseStack(&errorReply);
		return FAILURE;
		}
	    }
	*replyBuffer = (char *)&msg->body;
	*replyBufferSize = strlen(msg->body) + 1;
	}

    lsfVERBOSE_CMD_DONE("RDSIG");
    
    return status;
}

lsfACI_FUNCTION(lsftpl,SignalWriteDigital)
{
    char          *parPtr = (char *)parameters;
    vltBYTES20     signal;
    vltINT32       n,i;
    vltUINT32      value[lsfNUM_SIGNAL];
    ccsCOMPL_STAT  status;

    lsfVERBOSE_CMD_RECV("WDSIG");

    n = (int)*(parPtr+1);
    if (n > lsfNUM_SIGNAL) n = lsfNUM_SIGNAL;
    parPtr += 2;
    strncpy (signal,parPtr,sizeof(vltBYTES20)); 
    parPtr += strlen(signal)+1;
    memcpy(value,parPtr,n*sizeof(vltUINT32)); 

    if (strcmp(signal,lsfALL_DEVICES) == 0)
	{
	if (n < lsfNUM_SIGNAL)
	    {
	    for (i=n;i<lsfNUM_SIGNAL;i++)
		value[i] = value[n-1];
	    }
	}

    status = lsftplSignalWriteDigital(signal,value,error);
    if (status == SUCCESS)
	{
	strcpy ((char *)&msg->body, "OK");
	*replyBuffer = (char *)&msg->body;
	*replyBufferSize = strlen(msg->body) + 1;	
	}

    lsfVERBOSE_CMD_DONE("WDSIG");
    
    return status;
}

