/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: lsftplSoftDev.c,v 1.15 2003/09/10 12:41:52 vltsccm Exp $"
*
* who       when        what
* --------  ----------  ----------------------------------------------
* pduhoux   2000-04-05  created
*/

/************************************************************************
*   NAME
*     lsftplSoftDev - Handling of sub-SW devices
*
*   SYNOPSIS
*     #include "lsftplSignal.h"
*   DESCRIPTION
*     This module .... 
*   METHODS
*   PUBLIC
*     
*   DATABASE
*     lsftpl:control:softdev
*   FILES
*
*   ENVIRONMENT
*
*   COMMANDS
*
*   RETURN VALUES
*
*   CAUTIONS 
*
*   EXAMPLES
*
*   SEE ALSO
*
*   BUGS   
* 
*------------------------------------------------------------------------
*/

#define _POSIX_SOURCE 1
#include "vltPort.h"

static char *rcsId="@(#) $Id: lsftplSoftDev.c,v 1.15 2003/09/10 12:41:52 vltsccm Exp $"; 
static void *use_rcsId = ((void)&use_rcsId,(void *) &rcsId);

#include "lsftplPrivate.h"
#include "lsftplSoftDev.h"
#include "swd2tstServer.h"

ccsCOMPL_STAT lsftplSoftDevSoft ( IN  const char *devName, 
				 OUT char       *str, 
				 OUT ccsERROR   *error )
{
    ccsCOMPL_STAT status = SUCCESS;

    lsfSOFTDEV_DATA *softDevData = lsfSoftDevGetData(lsftplGlobalData);

    lsftplPrintf("lsftplSoftDevSoft(devName=%s,str=0x%08X)\n",devName,(int)str);
    if (lsfServerGetState(lsftplGlobalData) != lsfSTATE_ONLINE)
	{
        lsftplERR_ADD(lsftplERR_STATE,error,lcuStateString[lsfSTATE_ONLINE]);
	return FAILURE;
	}

    lsftplPrintf("lsftplSoftDevSoft: call lsfForwardCommand(SOFTCMD,%s)\n",devName);
    status = lsfForwardCommand(softDevData,devName,"SOFTCMD",NULL,str,error);

    return status;
}

ccsCOMPL_STAT lsftplSoftDevSwd ( IN  const char *devName, 
				OUT char       *str, 
				OUT ccsERROR   *error )
{
    lsftplPrintf("lsftplSoftDevSwd(devName=%s,str=0x%08X)\n",devName,(int)str);
    if (strcmp(devName,lsfALL_DEVICES) && strcmp(devName,"swd"))
	{
	vltBYTES32 errMsg;
	sprintf(errMsg,"%s - Unsupported Command",devName);
	lsftplERR_ADD(lsftplERR_PARAMETER,error,errMsg);
	return FAILURE;
	}

    if (lsfServerGetState(lsftplGlobalData) < lsfSTATE_STANDBY)
	{
	vltBYTES32 errMsg;
	sprintf(errMsg,"%s or %s",lcuStateString[lsfSTATE_STANDBY],
		lcuStateString[lsfSTATE_ONLINE]);
        lsftplERR_ADD(lsftplERR_STATE,error,errMsg);
	return FAILURE;
	}

    lsftplPrintf("lsftplSoftDevSwd: call swd2tstServerSwdCommand()\n");
    return swd2tstServerSwdCommand(str,error);
}

/*___oOo___*/
