/************************************************************************
* E.S.O. - VLT project
#
# "@(#) $Id: lsftplStandard.c,v 1.15 2003/09/10 12:41:52 vltsccm Exp $" 
*
* who       when      what
* --------  --------  ----------------------------------------------
* rkarban  06/11/99  don't save taskid in server class
* rkarban  06/12/96  created
*------------------------------------------------------------------------
*/

#define _POSIX_SOURCE 1
#include "vltPort.h"

static char *rcsId="@(#) $Id: lsftplStandard.c,v 1.15 2003/09/10 12:41:52 vltsccm Exp $";
static void *use_rcsId = ((void)&use_rcsId,(void *) &rcsId);

#include "lsftplPrivate.h"
#include "lsfStandard.h"
#include "lsftplStandard.h"

#define checkModuleId \
    if (strcmp(moduleId,lsftplMODULE_ID) != 0) \
        ERROR_RETURN(lsftplERR_MODULE_ID,__FILE__,"",moduleId)

/************************************************************************
*   NAME
*       lsftplStandard - lsftpl API for Standard LCC Commands
* 
*   SYNOPSIS
*       ccsCOMPL_STAT lsftplStd<Command>( IN  const char   *moduleId,
*                                        OUT ccsERROR     *error );
*
*   COMMAND
*       <COMMAND> <device>
*       lsftplStd<Command> <device>
*
*   DESCRIPTION
*       lsftplStd<Command>() is the wrapper to the LSF Standard Command API
*       lsfStd<Command>().
*       This function is required by the command interpreter as it must 
*       be declared in the global symbol table.
*
*   FILES
*       None
*
*   ENVIRONMENT
*       None
*
*   SIGNALS
*       None
*
*   DATABASE
*
*   RETURN VALUES
*       SUCCESS if everything ok
*       FAILURE, the error structure is updated with:
*           lsftplERR_MODULE_ID if module names mismatched
*
*   SEE ALSO
*       lsfStandard(3)
*
*------------------------------------------------------------------------
*/

ccsCOMPL_STAT lsftplStdExit ( IN  const char *moduleId,
			     OUT ccsERROR   *error )
{
    return lsfStdExit(lsftplGlobalData,moduleId,error);
}


ccsCOMPL_STAT lsftplStdGetInit( OUT vltLOGICAL *init,
			       OUT ccsERROR   *error )
{
    return lsfStdGetInit(lsftplGlobalData,init,error);
}

ccsCOMPL_STAT lsftplStdGetSimulation( OUT vltLOGICAL  *simulation,
				     OUT ccsERROR    *error )
{
    return lsfStdGetSimulation(lsftplGlobalData,simulation,error);
}

ccsCOMPL_STAT lsftplStdGetVersion ( OUT char     *version,
				   OUT ccsERROR *error ) 
{
    lsftplVersion(version);
    return SUCCESS; 
}

ccsCOMPL_STAT lsftplStdInit ( IN  const char *moduleId,
			     OUT ccsERROR   *error )
{
    return lsfStdInit(lsftplGlobalData,moduleId,error);
}

ccsCOMPL_STAT lsftplStdOff ( IN  const char *moduleId,
			    OUT ccsERROR   *error )
{
    return lsfStdOff(lsftplGlobalData,moduleId,error);
}

ccsCOMPL_STAT lsftplStdOnline ( IN  const char *moduleId,
			       OUT ccsERROR   *error )
{
    return lsfStdOnline(lsftplGlobalData,moduleId,error);
}

ccsCOMPL_STAT lsftplStdSelfTest ( IN  const char *moduleId,
				 OUT ccsERROR   *error )
{  
    return lsfStdSelfTest(lsftplGlobalData,moduleId,error);
}

ccsCOMPL_STAT lsftplStdStandby ( IN  const char *moduleId,
				OUT ccsERROR   *error )
{
    return lsfStdStandby(lsftplGlobalData,moduleId,error);
}

ccsCOMPL_STAT lsftplStdStartSim ( IN  const char *moduleId,
				 OUT ccsERROR   *error )
{   
    return lsfStdStartSim(lsftplGlobalData,moduleId,error);
}

ccsCOMPL_STAT lsftplStdStop ( IN  const char *moduleId,
			     OUT ccsERROR   *error )
{
    return lsfStdStop(lsftplGlobalData,moduleId,error);
}

ccsCOMPL_STAT lsftplStdStopSim ( IN  const char *moduleId,
				OUT ccsERROR   *error )
{ 
    return lsfStdStopSim(lsftplGlobalData,moduleId,error);
}

ccsCOMPL_STAT lsftplStdTest ( IN  const char *moduleId,
			     OUT ccsERROR   *error )
{
    return lsfStdTest(lsftplGlobalData,moduleId,error);
}

/*************************************************************************/
/* ___oOo___ */
