#*****************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: lsftplTest1.tcl,v 1.15 2003/09/10 12:41:59 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# tphan    14/05/97   created from trk module
#

#************************************************************************
#   NAME
# 
#   SYNOPSIS
# 
#   DESCRIPTION
#
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#
#   SEE ALSO
#
#   BUGS     
#
#------------------------------------------------------------------------
#


####################
# Initialyze CCS   #
####################
seq_ccsInit seq_$env(USER)
seq_ccsAsyncInput open

#    global my_ccsEnvName
############################
# Here starts actual test  #
############################
if {[catch {set ws_ccsEnvName  $env(wsTat)}]} {
    printLog "Environment variable wsTat is undefined. Exiting..."
    exit
    }

if {[catch {set lcu_ccsEnvName  $env(lcuTat)}]} {
    printLog "Environment variable lcuTat is undefined. Exiting..."
    exit
    }

printLog "%%%Starting test - Standard cmds"

# Wait that the process under test is ready and reactive

#
#
set currentTest "---"
label .currentTest -textvariable currentTest 
pack .currentTest  -padx 2m -pady 2m

testMultiCommand "Set verbose Off" 	  { lsftplServer  VERBOSE "Off" } 
testMultiCommand "Set debug   Off" 	  { lsftplServer  DEBUG "Off" } 
#---------------------------------------------------------------------
testMultiCommand "Test ping" 	          { lsftplServer  PING } 
testMultiCommand "Get version" 	          { lsftplServer  VERSION } 
#---------------------------------------------------------------------
testMultiCommand "Set simulation On" 	  { lsftplServer  SIMULAT }
testDbValueLCU lsftpl.simulation
testDbAttrLCU lsftpl simulation 1
testMultiCommand "Get simulation flag" 	  { lsftplServer  GETSIM }
#---------------------------------------------------------------------
testMultiCommand "Initialize"  	          { lsftplServer  INIT } 
testDbValueLCU lsftpl.state
sleep 2
testDbValueWS  Appl_data:lsftpl.state
testDbValueLCU lsftpl.initialized
testMultiCommand "Get state" 	          { lsftplServer  STATE }
testMultiCommand "Get initialization flag" { lsftplServer GETINIT } 

testDbAttrLCU lsftpl state 2
testDbAttrLCU lsftpl substate 0
testDbAttrLCU lsftpl initialized 1

#---------------------------------------------------------------------
testMultiCommand "Set online" 	          { lsftplServer  ONLINE } 
testDbAttrLCU lsftpl state 4
testDbValueLCU lsftpl.substate
sleep 2
testDbValueWS  Appl_data:lsftpl.state
testDbValueWS  Appl_data:lsftpl.substate
testDbValueLCU lsftpl:control:taskdev:bgTask.state
testDbValueLCU lsftpl:control:taskdev:bgTask.substate
sleep 2
testMultiCommand "Get state" 	          { lsftplServer  STATE }
testMultiCommand "Get general status" 	  { lsftplServer  STATUS }
testMultiCommand "Get general status" 	  { lsftplServer  STATUS }
testMultiCommand "Set online" 	          { lsftplServer  ONLINE }
testMultiCommand "Get general status" 	  { lsftplServer  STATUS }
testMultiCommand "Set in Standby" 	  { lsftplServer  STANDBY } 
testMultiCommand "Get general status" 	  { lsftplServer  STATUS }
testMultiCommand "Get general status" 	  { lsftplServer  STATUS }

#---------------------------------------------------------------------
testMultiCommand "Set in Standby" 	  { lsftplServer  STANDBY } 
testMultiCommand "Get general status" 	  { lsftplServer  STATUS }
testDbValueLCU lsftpl.state
testDbAttrLCU  lsftpl state 3
sleep 2
testDbValueWS  Appl_data:lsftpl.state
testMultiCommand "Get state" 	          { lsftplServer  STATE }
#---------------------------------------------------------------------
seq_dbWriteSymbolic @$lcu_ccsEnvName:lsftpl:control:taskdev:bgTask.position 0.0
sleep 2
testDbValueWS  Appl_data:lsftpl:control:taskdev:bgTask.position
testMultiCommand "Set online" 	          { lsftplServer  ONLINE } 
testDbAttrLCU lsftpl state 4
testDbValueLCU lsftpl.state
testDbValueLCU lsftpl.substate
testDbValueLCU lsftpl:control:taskdev.substate
testDbValueLCU lsftpl:control:taskdev:bgTask.substate
sleep 5
testMultiCommand "Stop" 	          { lsftplServer  STOP } 
testDbAttrLCU lsftpl state 4
testDbValueLCU lsftpl.state
testDbValueLCU lsftpl.substate
testDbValueLCU lsftpl:control:taskdev.substate
testDbValueLCU lsftpl:control:taskdev:bgTask.substate
testDbValueWS  Appl_data:lsftpl:control:taskdev:bgTask.position
testDbValueWS  Appl_data:lsftpl.state
set position [seq_dbReadSymbolic @$ws_ccsEnvName:Appl_data:lsftpl:control:taskdev:bgTask.position]
if { $position == 0.0 } {
    puts "====================> Error: position not updated"
}
set time [seq_dbReadSymbolic @$lcu_ccsEnvName:lsftpl:data.dataValues(1:1)]
set nber [seq_dbReadSymbolic @$lcu_ccsEnvName:lsftpl:data.dataValues(2:2)]
sleep 3
set time1 [seq_dbReadSymbolic @$lcu_ccsEnvName:lsftpl:data.dataValues(1:1)]
set nber1 [seq_dbReadSymbolic @$lcu_ccsEnvName:lsftpl:data.dataValues(2:2)]
if { [expr $nber1 - $nber] != 1 || [expr $time1 - $time] != 300 } {
    puts "====================> Error: data not updated"
}
set time [seq_dbReadSymbolic @$ws_ccsEnvName:Appl_data:lsftpl:data.dataValues(1:1)]
set nber [seq_dbReadSymbolic @$ws_ccsEnvName:Appl_data:lsftpl:data.dataValues(2:2)]
sleep 3
set time1 [seq_dbReadSymbolic @$ws_ccsEnvName:Appl_data:lsftpl:data.dataValues(1:1)]
set nber1 [seq_dbReadSymbolic @$ws_ccsEnvName:Appl_data:lsftpl:data.dataValues(2:2)]
if { [expr $nber1 - $nber] != 1 || [expr $time1 - $time] != 300 } {
    puts "====================> Error: scanned data not updated"
}

testMultiCommand "Get state" 	          { lsftplServer STATE }
#---------------------------------------------------------------------
testMultiCommand "Read Digital signals"   { lsftplServer RDSIG } 
testDbValueLCU lsftpl:control:signal:DI2.simValue
testDbValueLCU lsftpl:control:signal:DI3.simValue
testMultiCommand "Read Digital signals" { lsftplServer RDSIG "DI3" } 
#---------------------------------------------------------------------
testMultiCommand "Read Analog signals" 	{ lsftplServer RASIG } 
testDbValueLCU lsftpl:control:signal:AI1.simValue
testDbValueLCU lsftpl:control:signal:AI8.simValue
testMultiCommand "Read Analog signals" 	{ lsftplServer RASIG "AI1" } 
#---------------------------------------------------------------------
testMultiCommand "Move motor" 	{ lsftplServer MOVEA "M1,10000" }
testDbValueLCU lsftpl:control:motor:M1:motor:STATUS.motionStatus
testDbValueLCU lsftpl:control:motor:M1:motor:STATUS.inPos
testDbValueLCU lsftpl:control:motor:M1:motor:STATUS.posEnc
#---------------------------------------------------------------------
testMultiCommand "Read serial communication links" { lsftplServer RSCOM }
#---------------------------------------------------------------------
testMultiCommand "Set in Standby" 	{ lsftplServer STANDBY } 
testDbAttrLCU lsftpl state 3
testDbAttrLCU lsftpl substate 0
sleep 2
testDbValueWS  Appl_data:lsftpl.state
testMultiCommand "Set in Standby (again)" { lsftplServer STANDBY } 
testMultiCommand "Get state" 	        { lsftplServer STATE }
#---------------------------------------------------------------------
testMultiCommand "Set off"    	        { lsftplServer OFF } 
testDbAttrLCU lsftpl state 2
testDbAttrLCU lsftpl substate 0
testDbAttrLCU lsftpl initialized 0
sleep 2
testDbValueWS  Appl_data:lsftpl.state
testMultiCommand "Get state" 	        { lsftplServer STATE }
testMultiCommand "Set off (again)"    	{ lsftplServer OFF } 
testDbAttrLCU lsftpl state 2
testDbAttrLCU lsftpl substate 0
testDbAttrLCU lsftpl initialized 0
#---------------------------------------------------------------------
testMultiCommand "Initialize"   	{ lsftplServer INIT } 
testDbValueLCU lsftpl.state
sleep 2
testDbValueWS  Appl_data:lsftpl.state
testDbAttrLCU lsftpl state 2
testDbAttrLCU lsftpl substate 0
testDbAttrLCU lsftpl initialized 1
testMultiCommand "Get state" 	        { lsftplServer STATE }
testMultiCommand "Get general status"   { lsftplServer STATUS } 
#---------------------------------------------------------------------
testMultiCommand "Stop" 	        { lsftplServer STOP }
testMultiCommand "Get state" 	        { lsftplServer STATE }
#---------------------------------------------------------------------
testMultiCommand "Set online" 	        { lsftplServer ONLINE }
testDbValueLCU lsftpl.state
sleep 2
testDbValueWS  Appl_data:lsftpl.state
testMultiCommand "Get state" 	        { lsftplServer STATE }
testMultiCommand "Get general status"   { lsftplServer STATUS }
#---------------------------------------------------------------------
# going STANDBY before switching off simulation 

testMultiCommand "Set in Standby" 	{ lsftplServer STANDBY }
testDbValueLCU lsftpl.state
sleep 2
testDbValueWS  Appl_data:lsftpl.state
testMultiCommand "Reset simulation"  	{ lsftplServer STOPSIM }
testDbAttrLCU lsftpl state 2
testDbAttrLCU lsftpl substate 0
testDbAttrLCU lsftpl initialized 0
testDbAttrLCU lsftpl simulation 0
sleep 2
testDbValueWS  Appl_data:lsftpl.state
testMultiCommand "Reset simulation"  	{ lsftplServer STOPSIM }
testMultiCommand "Get general status"   { lsftplServer STATUS } 
#---------------------------------------------------------------------
#---------------------------------------------------------------------
# Tracing commands 

testMultiCommand "verbose On" 	{ lsftplServer VERBOSE "On" } 
testMultiCommand "get verbose" 	{ lsftplServer GETVERB } 
testMultiCommand "verbose Off" 	{ lsftplServer VERBOSE "Off" } 
testMultiCommand "get verbose" 	{ lsftplServer GETVERB } 

testMultiCommand "trace On" 	{ lsftplServer TRACE "On" } 
testMultiCommand "get trace" 	{ lsftplServer GETTRA } 
testMultiCommand "trace Off" 	{ lsftplServer TRACE "Off" } 
testMultiCommand "get trace" 	{ lsftplServer GETTRA } 

testMultiCommand "debug On" 	{ lsftplServer DEBUG "On" } 
testMultiCommand "get debug" 	{ lsftplServer GETDEBU } 
testMultiCommand "debug Off" 	{ lsftplServer DEBUG "Off" } 
testMultiCommand "get debug" 	{ lsftplServer GETDEBU } 

#---------------------------------------------------------------------
#
# Waits a couple of seconds before exiting,
#
sleep 2
printLog "Test completed !!!"
exit 0
#
# ___oOo___
