!
! "@(#) $Id: CCDtype.prg,v 2.83 2005/09/30 08:26:42 vltsccm Exp $"
!
! CCDtype.prg
! Program to recognize the CCD -type of a given image *.bdf
!+ 
! resulting in the sensitive area, pixel size and exposure type
!+
! S. Deiries 10.09.98 Version 16 (vlttc- vlt fits headers)
!+
! Parameter:
!+
! npix = number of pixel (x)
! nline = number of lines (y)
! xstart = number of first pixel
! ystart = number of first line
! detector = Manufacturer and Serial number of CCD
! exposure = exposure information of frame
! xstep = binning in x
! ystep = binning in y
! pix = pixel size in micron
! xprescan = number of prescan pixels
! xspix = number of sensitive pixels
! yprescan = number of prescan lines
! ysline = number of sensitive lines
! extype = abbreviation of exposure type
! ccd_type = CCD detector type name
! image = file-name of used image
!+
! Program:
!+
define/par p1 ? ima "Enter name of input image frame:"
write/key image/c/1/20 {p1}
!
write/key npix/i/1/1 {{p1},npix(1)}
write/key nline/i/1/1 {{p1},npix(2)}
write/key xstart/i/1/1 {{p1},start(1)}
write/key ystart/i/1/1 {{p1},start(2)}
write/key npix/i/1/1 {{p1},npix(1)}
define/local indx/i/1/5 0,0
compute/key indx(1) = M$EXISTD(p1,"detname")
if indx(1) .eq. 0 then
 compute/key indx(3) = M$EXISTD(p1,"eso.det.chip1.id")
 if indx(3) .eq. 0 then
  compute/key indx(1) = M$EXISTD(p1,"o_com")
  if indx(1) .eq. 0 then
     write/out "No keyword <detname> or <o_com> available"
     define/par p2 ? ima "Enter detname e.g.: <DJS>,<DJL>,<TKA> etc."
     write/key detector/c/1/20 "{p2}"
  else
     write/key detector/c/1/20 "{{p1},o_com(220:237)}"
  endif 
 else
    write/key detector/c/1/20 "{{p1},eso.det.chip1.id(1:16)}"  
 endif
else
  write/key detector/c/1/20 "{{p1},detname}"
endif
!
! write/out "Do you agree with this detector-name: {detector}   ?"
!
! SD FOR OLAF ONLY   define/par p3 ? ima "Enter <yes> or <no>"
!
! if p3 .eq. "no" then
!   define/par p2 ? ima "Enter desired detname e.g.: TKA, TKB  etc."
!   write/key detector/c/1/20 "{p2}"
! endif  
!
write/key exposure/c/1/20 "{{p1},ident}"

compute/key indx(2) = M$EXISTD(p1,"exptype")
if indx(2) .eq. 0 then
  compute/key indx(4) = M$EXISTD(p1,"eso.det.exp.type")
  if indx(4) .eq. 0 then
     write/key exptype/c/1/2 "{{p1},ident(1:2)}"
  else
     write/key subject/c/1/4 "{{p1},eso.det.exp.type(1:4)}"
     if subject(1:1) .eq. "d" then
       write/key exptype/c/1/2 "DK"
     else
       write/key exptype/c/1/2 "RE"
     endif
  endif
else
  write/key exptype/c/1/2 "{{p1},exptyp(1:2)}"
endif
!
compute/key indx(5) = M$EXISTD(p1,"o_time")
if indx(5) .eq. 0 then
!
else
  write/key time/r/1/1 {{p1},o_time(7)}
  if time .ne. 0.00 then
     write/out   -------   Exposure Time = {time}
  endif
  if time .lt. 60 then
     write/key nn/i/1/1 {time}
     write/key ttype/c/1/1 "S"
  elseif time .lt. 3600 then
    time = time / 60
    write/key nn/i/1/1 {time}
    write/key ttype/c/1/1 "M"
  else 
    time = time / 3600
    write/key nn/i/1/1 {time}
    write/key ttype/c/1/1 "H"
  endif
 if time .ne. 0.00 then  
   write/key tval/c/1/4 "{nn}"
   write/key ident/c/1/20 "{exptype}/{tval(3:4)}{ttype}"
   write/out {ident}  
   write/key exposure/c/1/20 "{ident}"
 endif
endif
!
!
write/key xstep/i/1/1 {{p1},step(1)}
write/key ystep/i/1/1 {{p1},step(2)}
write/key pix/r/1/1 27.0
write/key xprescan/i/1/1 50
write/key xspix/i/1/1 512
write/key yprescan/i/1/1 0
write/key ysline/i/1/1 512
!
write/key ccd_type/c/1/23 "unidentified type      "
define/local unbinx/i/1/1 0
define/local unbiny/i/1/1 0
define/local binprod/r/1/1 0.0
!
if npix .eq. 331 ccd_type = "RCA SID 501 EX  "
if npix .eq. 337 ccd_type = "RCA SID 501 EX  "
if npix .eq. 410 ccd_type = "GEC P 8603      "
if npix .eq. 411 ccd_type = "GEC P 8603      "
if npix .eq. 570 ccd_type = "Tektronix TK512 "
if npix .eq. 571 ccd_type = "Tektronix TK512 "
if npix .eq. 651 ccd_type = "RCA SID 006 EX  "
if npix .eq. 661 ccd_type = "RCA SID 006 EX  "
if npix .eq. 337 ccd_type = "RCA SID 501 EX  "
if npix .eq. 337 ccd_type = "RCA SID 501 EX  "
if npix .eq. 337 ccd_type = "RCA SID 501 EX  "
!if npix .eq. 1041 ccd_type = "Ford Aerospace  FA2048L"
if npix .eq. 1061 ccd_type = "Thomson THX31156"
if npix .eq. 1801 ccd_type = "Loral Geary 2048a"
!if nline .eq. 1030 ccd_type = "Ford Aerospace FA2048L"
if nline .eq. 1035 ccd_type = "Loral Geary 2048a"
!if nline .eq. 1050 ccd_type = "Ford Aerospace FA2048L"
if nline .eq. 1060 ccd_type = "Thomson THX31156"
if nline .eq. 1100 ccd_type = "Tektronix TK1024"
!
        unbinx = npix * xstep
        unbiny = nline * ystep
        binprod = xstep * ystep 
        binprod = M$SQRT(binprod)
!
!
branch ccd_type(1:2) RCA,GEC,TK,For,Tho,Lor RC,GE,TK,Ford,Th,Loral
!
	write/out Unknown detector, but wait, I' am thinking harder !
  goto next
!
  RC:
!
	if npix .le. 500 then 
!
!				 RCALR
		xprescan = 1
		xspix = 320
		ysline = 515
		pix = 30
!
	else
!
! 				RCAHR
		xprescan = 1
		xspix = 640
		ysline = 1030
		pix = 15
	endif
  goto next
!
  GE:
	xprescan = 11
	xspix = 385
	ysline = 576
	pix = 22
  goto next
!
  TK:
!

	if unbinx .le. 700 then
!
! 				TK512
		xprescan = 50 / xstep
		xspix = 512 / xstep
		ysline = 512 / ystep                
		pix = 27 * binprod
!
	elseif unbinx .le. 1101 then
!
! 				TK1024
		xprescan = 52 / xstep
		xspix = 1024 / xstep
		ysline = 1024 / ystep
		pix = 24 * binprod
!
        else
!
! 				TK2048:
		xprescan = 19 / xstep
		xspix = 2048 / xstep
		ysline = 2046 / ystep   !statt 2047 wie vorher !!
		pix = 24 * binprod
!
	endif
  goto next
!
  Ford:
!
! 				Ford2K:
	xprescan = 16 / xstep
	xspix = 2048 / xstep
	ysline = 2048 / ystep
	pix = 15 * binprod
  goto next
!
  TH:
!
	if unbinx .ge. 1000 then
!
! 				Th1k:
		xprescan = 2 / xstep ! ?????
		xspix = 1024 / xstep
		ysline = 1024 / ystep
		pix = 19 * binprod
!
	else
!
! 				Thbutt:
		xprescan = 1 ! ?????
		xspix = 400 ! ????
		ysline = 579 ! ????
		pix = 23
!
	endif
  goto next
!
  Loral:
!
! Loral2k:
	if unbinx .le. 1200 then
		xprescan = 16 / xstep
		xspix = 2048 / xstep
		ysline = 2048 / ystep
		pix = 15 * binprod
	else
		xprescan = 4
		xspix = 1776 !?????
		ysline = 1780 !?????
		pix = 15
	endif
!
  next:
!
if ccd_type(1:12) .eq. "unidentified" then
!
  ccd_type = detector
!
  branch ccd_type(1:3) ML2,GEC,TK5,TK1,TK2,EEA,EEB,JG2,JGT,Lor,THX,TKA,TKC,TKB,TKD,DJS,DJL,EEV,vlt ML2,GEC,T5,T1,T2,EEA,EEB,JG2,JGT,LO,THX,TKA,TKC,TKB,TKD,DJS,DJL,EEV,VLT 
!
     write/out unidentified CCD-type, I'am sorry !!!!
    return
!
     ML2:
	xprescan = 0
	xspix = 2048
	ysline = 2048
	pix = 15
	ccd_type = "ml2k3b = LES2k3b"
      goto enough
!
     GEC:
	xprescan = 11
	xspix = 385
	ysline = 576
	pix = 22
	ccd_type = "GEC P 8603      "
      goto enough
!
     T5:
	xprescan = 50 / xstep
	xspix = 512 / xstep
	ysline = 512 / ystep
	pix = 27 * binprod
	ccd_type = "Tektronix TK512 "
      goto enough
!
     T1:
	xprescan = 52 / xstep
	xspix = 1024 / xstep
	ysline = 1024 / ystep
	pix = 24 * binprod
	ccd_type = "Tektronix TK1024"
     goto enough
!
     T2:
	xprescan = 19 / xstep
	xspix = 2048 / xstep
	ysline = 2046 / ystep  ! statt 2047
	pix = 24 * binprod
	ccd_type = "Tektronix TK2048"
       goto enough
!
     EEA:
	xprescan = 50 / xstep
	xspix = 1024 / xstep
	ysline = 512 / ystep
	pix = 15 * binprod
	ccd_type = "EEV-CCD44-Ampleft,W"
       goto enough
!
     EEB:
	xprescan = 1074
	xspix = 1024
	ysline = 512
	pix = 15
	ccd_type = "EEV-CCD44-Ampright,W"
       goto enough
!
     JG2:
	xprescan = 16 / xstep
	xspix = 2688 / xstep
	ysline = 511 / ystep
	pix = 15 * binprod
	ccd_type = "Loral JG2605ST   "
       goto enough
!
     JGT:
	xprescan = 43 / xstep
	xspix = 2640 / xstep
        yprescan = 2 /ystep
	ysline = 499 / ystep
	pix = 15 * binprod
	ccd_type = "Loral JG2605STNWAX"
       goto enough
!
     LO:
	xprescan = 16 / xstep
	xspix = 2048 / xstep
	ysline = 2048 / ystep
	pix = 15 * binprod
	ccd_type = "Loral Geary 2048a"
       goto enough
!
     THX:
	xprescan = 13 / xstep
	xspix = 2048 / xstep
	ysline = 2048 / ystep
	pix = 15 * binprod
	ccd_type = "THX7397M"
       goto enough
!
     TKA:
	xprescan = 20 / xstep
	yprescan = 0 / ystep
	xspix = 1004 / xstep
	ysline = 1024 / ystep
	pix = 24 * binprod
	ccd_type = "Tektronix TK2048_A"
     goto enough
!
     TKC:   ! before field of TKB
	xprescan = 20 / xstep
	yprescan = 1024 / ystep
	xspix = 1004 / xstep
	ysline = 1024 / ystep
	pix = 24 * binprod
	ccd_type = "Tektronix TK2048_C"
     goto enough
!
     TKB:   ! before field of TKC
        xprescan = 1024 / xstep
	yprescan = 0 / ystep
	xspix = 1004 / xstep
	ysline = 1024 / ystep
	pix = 24 * binprod
	ccd_type = "Tektronix TK2048_B"
     goto enough
!
     TKD:
	xprescan = 1024 / xstep
	yprescan = 1024 / ystep
	xspix = 1004 / xstep
	ysline = 1024 / ystep
	pix = 24 * binprod
	ccd_type = "Tektronix TK2048_D"
!
     goto enough
!
     DJS:
	xprescan = 8 / xstep
	yprescan = 0 / ystep
	xspix = 386 / xstep  !386
	ysline = 290 / ystep
	pix = 22 * binprod
	ccd_type = "DJOsmall"
!
     goto enough
!

     DJL:
	xprescan = 8 / xstep
	yprescan = 0 / ystep
	xspix = 578 / xstep  !386
	ysline = 578 / ystep
	pix = 22 * binprod
	ccd_type = "DJOlarge"
!
     goto enough
!
     EEV:
	xprescan = 50 / xstep
	yprescan = 0 / ystep
	xspix = 2048 / xstep  !386
	ysline = 4100 / ystep
	pix = 13.5 * binprod
	ccd_type = "EEV-CCD-42"
!
    goto enough	
!
     VLT:
	xprescan = 0 / xstep
	yprescan = 0 / ystep
	xspix = 2048 / xstep  !386
	ysline = 2048 / ystep
	pix = 24 * binprod
	ccd_type = "VLTTC"
!
    enough:
!
endif
!
write/out Date = 
$date
! write/key Imagefile/c/1/20 "{{p1},frame}"
write/out Image-File-Name = {p1}
write/out Detector Type = {ccd_type}
write/out Serial Number = {detector}
write/out "  "
write/out Exposure = {exposure}
write/out Exposure Type = {exptype}
write/out "  "
write/out Number of prescan pixels in x = {xprescan}
write/out Number of prescan lines in y = {yprescan}
write/out Number of sensitive pixels = {xspix}
write/out Number of sensitive lines = {ysline}
set/format f3.1
write/out Pixelsize in micron = {pix}
!
! end



