!
! "@(#) $Id: Linplot.prg,v 2.83 2005/09/30 08:26:44 vltsccm Exp $"
!
! Linplot.prg
! Program to convert a Linearity protocol into a Linearity plot
!+ 
! resulting in a print-out and in a ps-file for the LATEX document
!+
! S. Deiries 30.11.95 Version 3
!+
! Parameter:
!+
! image = file-name of used protocol
!+
! Program:
!+
define/par p1 ? ima "Enter file-name of Linearity protocol:"
write/key image/c/1/20 {p1}
write/key copy/c/1/20 cp{p1}
write/key lcount/i/1/1 0
write/key textold/c/1/80

!$cp {p1} {copy}
!del/grap

open/file {p1} ? outputi
open/file {copy} write inputi

LOOP:

lcount = lcount + 1

if lcount .gt. 100 then 
   goto ENDLOOP
endif

write/key text/c/1/80 " "

read/file {outputi(1)} text 80

if text(36:39) .eq. "Type" then
   write/key type/c/1/20 {text(58:77)}
endif

if text(5:7) .eq. "ADU" then
   write/key eadu/c/1/20 {text(22:27)}
endif

if text(36:39) .eq. "Used" then
   write/key usedout/c/1/20 {text(62:62)}
endif

if text(36:39) .eq. "Subp" then
   write/key pattern/c/1/20 {text(62:62)}
endif

if text(1:6) .eq. "System" then
   write/key gain/c/1/20 {text(27:27)}
endif

if text(1:4) .eq. "Misc" then
   write/key sernr/c/1/20 {text(23:34)}
endif

if text(1:4) .eq. "Misc" then
   write/key rest/c/1/20 {text(35:46)}
endif

if text(1:10) .eq. "Linearity=" then
   goto ENDLOOP
endif

if text(6:7) .eq. "00" then
   if text .eq. textold then
      goto ENDLOOP
   endif
   write/file {inputi(1)} {text(1:79)}   
endif

textold = text

goto LOOP

ENDLOOP:

close/file {inputi(1)}
close/file {outputi(1)}

open/file linear.fmt write inputi
write/file {inputi(1)} "!    -   Linearity format file"
write/file {inputi(1)} define/field  1  5 R F8.2 :TIME "sec"
write/file {inputi(1)} define/field 10 16 R F8.2 :TEMP "K"
write/file {inputi(1)} define/field 23 27 R F8.2 :DENS "log"
write/file {inputi(1)} define/filed 30 38 R F8.2 :MEAN "ADU"
write/file {inputi(1)} define/field 41 49 R F8.2 :RMS "ADU"
write/file {inputi(1)} define/field 51 59 R E10.3 :PHOTONFLUX "Phot/cm2"
write/file {inputi(1)} define/filed 62 70 R F8.2 :ERROR "%"
close/file {inputi(1)}

!$cp /users/sdeiries/tex/CCD/Documentation/lin.fmt linear.fmt

crea/tab lin{copy} ? ? {copy} linear
del/grap
crea/grap
set/grap
set/grap LTYPE=1 STYPE=0 XAXIS=+0,5,+1,-1 XFORM=P YAXIS=-4,4 

plot/tab lin{copy} :MEAN :ERROR
set/grap LTYPE=0 STYPE=1
over/tab lin{copy} :MEAN :ERROR 1
label/grap "Type = {type}" 10,20,mm 0 1 1
label/grap "Sernr = {sernr} {rest}" 10,15,mm 0 1 1
label/grap "Used-out={usedout} Subpatt={pattern} gain={gain} " 10,10,mm 0 1 1 
label/grap "e- per ADU = {eadu}" 10,5,mm 0 1 1 


!ass/grap ps0to0 NOSPOOL
copy/grap ps0to0
$cancel ps0to0
wait 1
$cancel ps0to0
wait 
$cancel ps0to0

open/file ps_change.sh  write inputi
write/file {inputi(1)} "#! /bin/sh"
!write/file {inputi(1)} sleep 10
write/file {inputi(1)} sed -e 's/570 810/810 570/' \
write/file {inputi(1)} -e 's/19.0 cm /% 19.0cm/' \
write/file {inputi(1)} -e 's/90 rotate/% 90rotate/' \
write/file {inputi(1)} ps0to0.ps > lin{copy}.ps
close/file {inputi(1)}

$sh ps_change.sh

set/format f3.1

$rm lin{copy}*.tbl
!$rm lin*.plt
$rm ps_change.sh
$rm {copy}
$rm ps0to0.ps
$chmod 777 lin{copy}.ps
!$rm graph_wnd099.plt
!$rm ps0to099.plt

write/out Linplot is ready
!
! end






