!
! "@(#) $Id: Qeplot_mult.prg,v 2.83 2005/09/30 08:26:45 vltsccm Exp $"
!
! Qeplot.prg
! Program to convert a Sensitivity (QE) protocol into a Qe-plot
!+ 
! resulting in a print-out and in a ps-file for the LATEX document
!+
! S. Deiries 22.01.96 Version 1
!+
! Parameter:
!+
! image = file-name of used protocol
!+
! Program:
!+
define/par p1 ? ima "Enter file-name of Sensitivity protocol:"
write/key image/c/1/20 {p1}
write/key lcount/i/1/1 0
write/key textold/c/1/80
write/key gcount/i/1/1 1
write/key height/i/1/1 0
write/key next/c/1/20 "no"
write/key m/i/1/1 1

del/grap
crea/grap

MORE:

lcount = 0
write/key copy/c/1/20 cp{image}
open/file {image} ? outputi
open/file {copy} write inputi

LOOP:

lcount = lcount + 1

if lcount .gt. 100 then 
   goto ENDLOOP
endif

write/key text/c/1/80 " "

read/file {outputi(1)} text 80

if text(36:39) .eq. "Type" then
   write/key type/c/1/20 {text(58:77)}
endif

if text(5:7) .eq. "ADU" then
   write/key eadu/c/1/20 {text(22:27)}
endif

if text(36:39) .eq. "Used" then
   write/key usedout/c/1/20 {text(62:62)}
endif

if text(36:39) .eq. "Subp" then
   write/key pattern/c/1/20 {text(62:62)}
endif

if text(1:6) .eq. "System" then
   write/key gain/c/1/20 {text(27:27)}
endif

if text(1:4) .eq. "Misc" then
   write/key sernr/c/1/20 {text(23:34)}
endif

if text(1:4) .eq. "Misc" then
   write/key rest/c/1/20 {text(35:46)}
endif

if text(1:17) .eq. "Calibration_error" then
   goto ENDLOOP
endif

if text(6:6) .eq. "0" then
   if text .eq. textold then
      goto ENDLOOP
   endif
   if text(3:3) .eq. " " THEN
      text(3:3) = "0"
   endif
   write/file {inputi(1)} {text(3:79)}   
endif

textold = text

goto LOOP

ENDLOOP:

close/file {inputi(1)}
close/file {outputi(1)}

open/file qe.fmt write inputi
write/file {inputi(1)} "!    -   qe format file"
write/file {inputi(1)} define/field 1 4 I :LAMBDA "nm"
write/file {inputi(1)} define/field 8 10 I :TIME "sec"
write/file {inputi(1)} define/field 13 15 R F8.1 :DENS "log"
write/file {inputi(1)} define/field 18 22 R F8.1 :TEMP "K"
write/file {inputi(1)} define/filed 24 28 I :COUNTS "ADU"
write/file {inputi(1)} define/field 30 34 R F8.2 :RQE "%"
write/file {inputi(1)} define/field 36 40 R F8.2 :RQE_ERROR "%"
write/file {inputi(1)} define/field 44 53 R E10.3 :SENSITIVITY "W/cm2"
write/file {inputi(1)} define/field 56 65 R E10.3 :PHOTONFLUX "Phot/cm2"
write/file {inputi(1)} define/filed 68 77 R E10.3 :IRRADIANCE "W/cm2"
close/file {inputi(1)}

crea/tab qe{copy} 10 ? {copy} qe
set/grap
set/grap LTYPE=1 STYPE=0 XAXIS=300,1100 YAXIS=0,100 COLOUR={gcount}
if gcount .eq. 1 then
   plot/tab qe{copy} :LAMBDA :RQE
else
   over/tab qe{copy} :LAMBDA :RQE
endif
!if gcount .ne. 2 then
over/err qe{copy} :LAMBDA :RQE :RQE_ERROR
!endif
set/grap LTYPE=0 STYPE=1
over/tab qe{copy} :LAMBDA :RQE 
over/tab qe{copy} :LAMBDA :RQE 2

height = gcount * 5

label/grap "{type}" 123,{height},mm 0 1 1


if gcount .eq. 1 then
!
define/par p2 ? ima "Enter next file-name of Sensitivity protocol or say no"
write/key image/c/1/20 {p2}
!
endif
if gcount .eq. 2 then
!
define/par p3 ? ima "Enter next file-name of Sensitivity protocol or say no"
write/key image/c/1/20 {p3}
!
endif
if gcount .eq. 3 then
!
define/par p4 ? ima "Enter next file-name of Sensitivity protocol or say no"
write/key image/c/1/20 {p4}
!
endif
if gcount .eq. 4 then
!
define/par p5 ? ima "Enter next file-name of Sensitivity protocol or say no"
write/key image/c/1/20 {p5}
!
endif
if gcount .eq. 5 then
!
define/par p6 ? ima "Enter next file-name of Sensitivity protocol or say no"
write/key image/c/1/20 {p6}
!
endif
if gcount .eq. 6 then
!
define/par p7 ? ima "Enter next file-name of Sensitivity protocol or say no"
write/key image/c/1/20 {p7}
!
endif
if gcount .eq. 7 then
!
define/par p8 ? ima "Enter next file-name of Sensitivity protocol or say no"
write/key image/c/1/20 {p8}
!
endif

if image(1:2) .ne. "no" then
   gcount = gcount + 1   
!   $rm {copy}
   goto MORE
endif

!ass/grap ps0to0 NOSPOOL
copy/grap ps0to0
$cancel ps0to0
wait 1
$cancel ps0to0
wait 
$cancel ps0to0

open/file ps_change.sh  write inputi
write/file {inputi(1)} "#! /bin/sh"
!write/file {inputi(1)} sleep 10
write/file {inputi(1)} sed -e 's/570 810/810 570/' \
write/file {inputi(1)} -e 's/19.0 cm /% 19.0cm/' \
write/file {inputi(1)} -e 's/90 rotate/% 90rotate/' \
write/file {inputi(1)} ps0to0.ps > qe{copy}.ps
close/file {inputi(1)}

$sh ps_change.sh

set/format f3.1

!$rm qe{copy}*.tbl
!$rm qe*.plt
!$rm {copy}
$rm ps0to0.ps
$rm ps_change.sh
$chmod 777 qe{copy}.ps

write/out Qeplot is ready
!
! end






