!
! "@(#) $Id: cosmic_1q.prg,v 2.83 2005/09/30 08:26:47 vltsccm Exp $"
!
! cosmic.prg
! Program to count the cosmic ray event on an ccd dark image
! given as *.bdf
!+ 
! resulting in the rate per cm*cm sensitive area and minute of time
!+
! S. Deiries 13.10.1995 Version 3 (special) only for ml2k3b
!+
! Parameter:
!+
! npix = number of pixel (x)
! nline = number of lines (y)
! xstart = number of first pixel
! ystart = number of first line
! detector = Manufacturer and Serial number of CCD
! exposure = exposure information of frame
! xstep = binning in x
! ystep = binning in y
! pix = pixel size in micron
! xprescan = number of prescan pixels
! xspix = number of sensitive pixels
! ysline = number of sensitive lines
! extype = abbreviation of exposure type
! ccd_type = CCD detector type name
! image = file-name of used image
!+
! Program:
!+
define/local level/r/1/1 0.0
define/local ccdarea/r/1/1 10000.0
define/local factor/r/1/1 60.0
define/local rate/r/1/1 0.0
define/local xcanfang/i/1/1 0
define/local xcende/i/1/1 0
define/local ycanfang/i/1/1 0
define/local ycende/i/1/1 0
define/local grmean/r/1/1 0.0
define/local grrms/r/1/1 100000.0
!
define/par p1 ? ima "Enter name of input dark exposure:   "
!
@@ CCDtype {p1} 
!
xspix = 1024   !SD
ysline = 1024   !SD
!
xcanfang = xstart  + xprescan + ( xspix * 0.2 )
xcende   = xcanfang + ( xspix  * 0.6 )
ycanfang = ystart  + ( ysline * 0.2 )
ycende   = ycanfang + ( ysline * 0.6 )
!
@@ ground {p1} {xcanfang} {ycanfang} {xcende} {ycende} 0.2
grmean = {q1}
grrms = {q2}
!
level = grmean + (5 * grrms)
compute/ima back = ( MAX( {p1},{level} ) - {level} )
filter/digital back filtered 1,1,1,1,1,1,1,1,1
set/context invent
!set/midas_system keywords=1400,60000
search/invent filtered cosmic
show/tab cosmic
!
define/local objects/i/1/1 {outputi(2)}
!
ccdarea = xspix * ysline * pix * pix / 100000000.0
!
define/local time/i/1/1 {exposure(4:5)}
define/local unit/c/1/1 "{exposure(6:6)}"
!
if unit .eq. "H" factor = 60
if unit .eq. "M" factor = 1
if unit .eq. "S" factor = 0.01666667
!
rate = (((( objects ) / factor ) / time ) / ccdarea )
!
set/format f5.2
write/out Number of cosmic objects : {objects}
write/out CCD-area in cm*cm : {ccdarea}
write/out Exposuretime: {time} {unit}
write/out Cosmic-ray rate in events per squarecm and minutes: {rate}
!
set/format
open/file cosmic.result write OUTPUTI
write/file {OUTPUTI(1)} {rate} {objects} {ccdarea} {time} {unit}
close/file {OUTPUTI(1)}
return {rate} {objects}
! end




