!
! "@(#) $Id: ground.prg,v 2.83 2005/09/30 08:26:49 vltsccm Exp $"
!
!+
!  ground.prg
!  Midas procedure to calculate the undisturbed background of a CCD
!  Version 2 	18.3.1993 	S. Deiries
!+
! xstart = number of first pixel
! ystart = number of first line
! xprescan = number of prescan pixels
! xspix = number of sensitive pixels
! ysline = number of sensitive lines
! image = file-name of used image
! xanfang = startx of the used window
! yanfang = starty of the used window
! xende = endx of the used window
! yende = endy of the used window
!+
! smean = Mean value of a quarter of the window with lowest RMS 
! srms =  lowest RMS Value of a quarter of the window
! xa = startx of the quarter with the lowest RMS
! xe = endx of the quarter with the lowest RMS
! ya = starty of the quarter with the lowest RMS
! ya = endy of the quarter with the lowest RMS
! grmean = Mean value of cleaned background
! grrmd = RMS value of cleaned background
!+
define/par p1 ? ima "Enter name for input frame:  "
define/par p2 ? num "Enter number of first pixel: "
define/par p3 ? num "Enter number of first line:  "
define/par p4 ? num "Enter number of last pixel:  "
define/par p5 ? num "Enter number of last line:   "
define/par p6 ? num "Enter tolerance value in percentage / 100: "
!
define/local xanfang/i/1/1 {p2}
define/local yanfang/i/1/1 {p3}
define/local xende/i/1/1 {p4}
define/local yende/i/1/1 {p5}
define/local tol/r/1/1 {p6}
define/local grrms/r/1/1 100000
define/local grmean/r/1/1 0.0
define/local deltarms/r/1/1 1000.0
define/local quoti/r/1/1 0.0
!
define/local iteratio/i/1/1 0
!
LOOP:
!
	iteratio = iteratio + 1
	if iteratio .ge. 8 goto ENDLOOP
	if iteratio .gt. 1 then 
		grrms  = srms
		grmean = smean
	endif
!
	@@ lowqua {p1} {xanfang} {yanfang} {xende} {yende}
!
	xanfang = xa
	xende   = xe
	yanfang = ya
	yende   = ye
!
	if iteratio .gt. 1 then
		deltarms = grrms - srms
		quoti = M$ABS(deltarms) /grrms
		if quoti .ge. tol goto LOOP
	else
		goto LOOP	
	endif
!
ENDLOOP:
!
set/format f5.2
write/out Image background:  Mean: {grmean} and RMS: {grrms}
!
return {grmean} {grrms}
!
! end













