!
! "@(#) $Id: homogen.prg,v 2.83 2005/09/30 08:26:49 vltsccm Exp $"
!
! homogen.prg
! Program to calculate the homogeneity of a CCD frame
! given as image:       *.bdf
!+ 
! resulting in the percentage of homogeneity and exposure type
!+
! S. Deiries 16.3.1998 Version 0 + 1 (Fits)
!+
! Parameter:
!+
! npix = number of pixel (x)
! nline = number of lines (y)
! xstart = number of first pixel
! ystart = number of first line
! detector = Manufacturer and Serial number of CCD
! exposure = exposure information of frame
! xstep = binning in x
! ystep = binning in y
! pix = pixel size in micron
! xprescan = number of prescan pixels
! xspix = number of sensitive pixels
! ysline = number of sensitive lines
! extype = abbreviation of exposure type
! ccd_type = CCD detector type name
! image = name of used frame
!+
! Program:
!+
define/par p1 ? ima "Enter name of input image frame:"
!
@@ test_fits {p1}
@@ CCDtype {p1}
!
write/key xbegin/i/1/1 0
write/key xend/i/1/1 0
write/key ybegin/i/1/1 0
write/key yend/i/1/1 0
! write/key hmean/r/1/1 0.0
! write/key hrms/r/1/1 1.0
write/key flatness/r/1/1 0.0
create/tab homogen1 7 1 null
!
xbegin = xstart + xprescan
xend = xbegin + xspix - 1
ybegin = 1
yend = ysline
!
crea/tab homogen2 4 1 null
crea/col homogen2 :xstart
crea/col homogen2 :ystart
crea/col homogen2 :xend
crea/col homogen2 :yend
		write/tab homogen2 :xstart @1 {xbegin}
		write/tab homogen2 :ystart @1 {ybegin}
		write/tab homogen2 :xend   @1 {xend}
		write/tab homogen2 :yend   @1 {yend}
stat/ima {image} homogen2 option=rn outtab=homogen1
! read/tab homogen1 @1 
write/key hmean/r/1/1 {homogen1,:MEAN,1}
write/key hrms/r/1/1  {homogen1,:STD,1}
flatness = 100 * hrms / hmean 
set/format f3.2
write/out Homogeneity of frame {image} = {flatness} %
!
! end



