!
! "@(#) $Id: lowqua.prg,v 2.83 2005/09/30 08:26:50 vltsccm Exp $"
!
! lowqua.prg
!+
! Program to quarter a given image window calculating Mean and RMS 
! and give the window with the lowest RMS including Mean and RMS
!+
! window of frame *.bdf given with xbegin, ybegin, xend, yend 
!+ 
! resulting in the values   Mean   and   RMS
!+
! S. Deiries 15.3.1993 Version 0.1
!+
! Parameter:
!+
! P1 = image frame
! P2 = first pixel
! P3 = first line
! P4 = last pixel
! P5 = last line
! lmean = Mean value
! lrms = Rms Value
! smean = Mean value of square with lowest RMS
! srms = RMS with square with lowest RMS
! number = number of square with lowest RMS
! xa = first pixel of lowest square
! ya = first line of lowest square
! xe = last pixel of lowest square
! ye = last line of lowest square
!+
! Program:
!+
!
define/par p1 ? ima "Enter name of input frame:  "
define/par p2 ? num "Enter number of first pixel:  "
define/par p3 ? num "Enter number of first line:  "
define/par p4 ? num "Enter number of last pixel:  "
define/par p5 ? num "Enter number of last line:  "
!
write/key srms/r/1/1 100000
write/key smean/r/1/1 0
write/key xa/i/1/1 0
write/key ya/i/1/1 0
write/key xe/i/1/1 0
write/key ye/i/1/1 0
!
define/local lmean/r/1/4 0 all
define/local lrms/r/1/4 0 all
define/local number/i/1/1 0
!
@@ divide_in_squares {p2} {p3} {p4} {p5} 2
!
define/local n/i/1/1 0
define/local k/i/1/1 0
define/local l/i/1/1 0
!
do n = 1 4
	k = (n * 2) - 1
	l = n * 2
	xa = xcoord({k})
	ya = ycoord({k})
	xe = xcoord({l})
	ye = ycoord({l})
	@@ sample {p1} {xa} {ya} {xe} {ye}
	lmean({n}) = {q1}
	lrms({n}) = {q2}	
	if lrms({n}) .le. srms then
		srms = lrms({n})
		number = n
	endif
enddo
!
write/out Square number = {number}
l = number * 2
k = l - 1
xa = xcoord({k})
ya = ycoord({k})
xe = xcoord({l})
ye = ycoord({l})
!
write/out xa = {xa}  ya = {ya}  xe = {xe}   ye = {ye} 
set/format f5.2
smean = lmean({number})
write/out Mean = {smean}  Rms = {srms}
!
return
!
! end



